(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["Events`Events`",
{"Global`",
"SpinDynamica`",
"General`UserLevel`",
(*"General`ModifyBuiltIn`",*)
"General`Matrices`",
"General`Miscellaneous`",
"QM`Hilbert`",
"QM`SpinOperators`",
"QM`Liouville`",
"SD`Generators`",
"Rotations`Wigner`",
"Units`",
"General`PhysicalConstants`"}];


(* ::Input::Initialization:: *)
EventSpecifications::usage="EventSpecifications[events] converts events into standard form. The list of events has the syntax {event1,event2...} where each event may either have the form {HamiltonianOperator,duration}  or be a single superoperator, for example a RotationSuperoperator or a CoherenceOrderFiltrationSuperoperator.  EventSpecifications converts the list of events into standard form, including the imposition of right-to-left chronology. 
Each event may also carry its internal options. Two examples are as follows: 
 {opI[\"x\"],1,Basis\[Rule]ZeemanBasis[]}, and {RotationSuperoperator[{\[Pi]/2,\"x\"},OperatorBasis\[Rule]CartesianProductOperatorBasis[]}. These local options are carried into the subsequent spin dynamical computations. 
Options may also be imposed on entire blocks of events, using syntax of the form {event1,{event2,event3,c\[Rule]d},a\[Rule]b}. In this case the option a\[Rule]b applies to event1, while both a\[Rule]b and c\[Rule]d apply to event2 and event3. Such constructions may be nested indefinitely. 
.";


(* ::Input::Initialization:: *)
ValidEventSpecificationQ::usage="ValidEventSpecificationQ[evspec] returns True if evspec is a valid specification for a spin dynamical event, and False otherwise."; 


(* ::Input::Initialization:: *)
StandardizedEventSpecificationQ::usage="StandardizedEventSpecificationQ[evspec] returns True if evspec is a standardized specification for a spin dynamical event, and False otherwise."; 


(* ::Input::Initialization:: *)
StandardizeEventSpecification::usage="StandardizeEventSpecification[evspec] converts an EventSpecification into standard form."; 


(* ::Input::Initialization:: *)
SingleTimeIndependentEventPattern::usage="SingleTimeIndependentEventPattern is the pattern for a single time-independent event. It is used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
RepeatedTimeIndependentEventSeqPattern::usage="RepeatedTimeIndependentEventSeqPattern is the pattern for a repeated sequence of time-independent events. It is used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
PiecewiseTimeIndependentEventSeqPattern::usage="PiecewiseTimeIndependentEventSeqPattern is the pattern for a sequence of piecewise time-independent events. It is used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
DivideEventSpecifications::usage="DivideEventSpecifications[evspecs,{..,\[Tau]2,\[Tau]1}] divides up a list of event specifications using intervals {..,\[Tau]2,\[Tau]1} (reading from right to left). DivideEventSpecifications[evspecs,n] divides the list of event specifications into n sets of equal duration. If the option IncludeRepetitionNumbers\[Rule]True is used, the output contains information on the number of repetitions of identical event sequences.";


(* ::Input::Initialization:: *)
IncludeRepetitionNumbers::usage="IncludeRepetitionNumbers is an option for DivideEventSpecifications. It is used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
FurtherEventSpecificationPatterns::usage="FurtherEventSpecificationPatterns is a set of patterns for valid event specifications, which are passed from other packages to the Events package. This routine is used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
Event::usage="Event is the internal format for spin-dynamical events. It is used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
PropagatorCalculationProcedure::usage="PropagatorCalculationProcedure is an event property used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
PropagatorCalculationProceduresDetermined::usage="PropagatorCalculationProceduresDetermined is an event property used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
InstantaneousTransformation::usage="InstantaneousTransformation is a value for PropagatorCalculationProcedure used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
IntegrateEvolutionOverTime::usage="IntegrateEvolutionOverTime is a value for PropagatorCalculationProcedure used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
RepeatPropagator::usage="RepeatPropagator is a value for PropagatorCalculationProcedure used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
UsePrecalculatedPropagator::usage="UsePrecalculatedPropagator is a value for PropagatorCalculationProcedure used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
PropagationMethod::usage="PropagationMethod is an option for individual events. Possible PropagationMethods are Automatic and Adiabatic. Automatic employs standard numerical methods to solve the Schroedinger equation. Adiabatic on the other hand assumes adiabaticity along the whole event to solve the Schrodinger equation leading to speed improvements in most cases. The default option for PropagationMethod is: ProapgationMethod \[Rule] Automatic.";


(* ::Input::Initialization:: *)
Adiabatic::usage="Adiabatic is a possible PropagationMethod for a single event. SpinDynamica then assumes adiabaticity for the specified event. A set of correlated adiabatic eigenstates may then be calculated along the time-trajectory of the event, which may then be used to determine the final state of the system.
Using the Adiabatic PropagationMethod requires the additional input: EventSampling.";


(* ::Input::Initialization:: *)
EventSampling::usage="EventSampling may be used to specify the time-sampling of an adiabatic event. EventSampling may be of the following forms:
Using an integer, N:
- EventSampling \[Rule] {N}
SpinDynamica will then uniformly distribute the overall duration of the event into N pieces.
Using a specific timegrid:
- EventSampling \[Rule] {\!\(\*SubscriptBox[\(t\), \(1\)]\), \!\(\*SubscriptBox[\(t\), \(2\)]\), ..., T}
SpinDynamica will make use of the specified timegrid to calculate the adiabatic eigenstates.
";


(* ::Input::Initialization:: *)
DeleteCoherences::usage="DeleteCoherences may be used to specify whether SpinDynamica should also propagate coherences during an adiabatic event or not. By default SpinDynamica assumes DeleteCoherences \[Rule] True. Coherences will then not be propagated and neglected and removed from the initial density operator. If DeleteCoherences \[Rule] False is chosen SpinDynamica will also propagate coherences. During an adiabatic event coherences will aquire an additional phase, \[Phi]. Generally \[Phi] may have two contributions, a dynamic phase \!\(\*SubscriptBox[\(\[Phi]\), \(dyn\)]\) and a geometric phase \!\(\*SubscriptBox[\(\[Phi]\), \(geo\)]\). SpinDynamica will attempt to calculate both of these contributions.";


(* ::Input::Initialization:: *)
EventList::usage="EventList is the internal format for a list of time-ordered spin-dynamical events. It is used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
MixedHilbertSpaceCompatibility::usage="MixedHilbertSpaceCompatibility is an event property used internally by SpinDynamica. The HilbertSpaceCompatibility of an EventList takes the value MixedHilbertSpaceCompatibility if some, but not all, of the contained events are Hilbert-space compatible.";


(* ::Input::Initialization:: *)
EventDuration::usage="EventDuration[event] returns the time duration of an event or list of events.";


(* ::Input::Initialization:: *)
If[$VersionNumber<11,
Duration::usage="The SpinDynamica routine Duration has been superseded by EventDuration."
];


(* ::Input::Initialization:: *)
InitialTimePoint::usage="InitialTimePoint is an option for various SpinDynamics functions, specifying the time coordinate for the start of a sequence of events.";


(* ::Input::Initialization:: *)
FinalTimePoint::usage="FinalTimePoint is an option for various SpinDynamics functions, specifying the time coordinate for the end of a sequence of events.";


(* ::Input::Initialization:: *)
TotalEventTimeInterval::usage="TotalEventTimeInterval[event] returns the {end,start} time points of an Event or EventList.";


(* ::Input::Initialization:: *)
EventTimeIntervals::usage="EventTimeIntervals[eventlist] returns the set of time pairs {{end,start}..} defining the elements of an EventList.";


(* ::Input::Initialization:: *)
PermittedTimeShift::usage="PermittedTimeShift is an event property used internally by SpinDynamica. It specifies the time shift through which an event may be translated while still retaining the same propagator. It may have the values None, All, or take a numerical value. ";


(* ::Input::Initialization:: *)
StandardizedInterval::usage="StandardizedInterval is an event property used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
Repeat::usage="Repeat[events,n,options] specifies the n-fold repetition of an event or set of events. The output of Repeat is presented in condensed form, unless Expand is applied.";


(* ::Input::Initialization:: *)
ExpandRepeatedEvents::usage="ExpandRepeatedEvents\[Rule]True is an option for EventSpecifications which forces the expansion of any Repeat objects into a list of consecutive events. The option ExpandRepeatedEvents\[Rule]Automatic induces an expansion depending on the context of the repeated event (including the BackgroundGenerator). 
";


(* ::Input::Initialization:: *)
RepeatEvent::usage="RepeatEvent has been replaced by Repeat";


(* ::Input::Initialization:: *)
BackgroundGenerator::usage="BackgroundGenerator is an option for Event, NPropagate, Trajectory, TransformationAmplitude and other spin dynamical routines. BackgroundGenerator may be an operator, a superoperator, a time-dependent operator function, or a time-dependent superoperator function. The value of BackgroundGenerator is combined with the specified sequence of events to create the complete Liouvillian for the dynamic evolution of the system. Often BackgroundGenerator is used specify the internal Hamiltonian and/or relaxation superoperator, while the sequence of events is used to specify the applied pulse sequence, or similar.";


(* ::Input::Initialization:: *)
EvolutionBackground::usage="EvolutionBackground has been replaced by BackgroundGenerator.";


(* ::Input::Initialization:: *)
BackgroundGeneratorImplemented::usage="BackgroundGeneratorImplemented is a property of an Event, used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
ImplementBackgroundGenerator::usage="ImplementBackgroundGenerator is an instruction for Event, used internally by SpinDynamica.";


UnassignedSymbols::usage="UnassignedSymbols[expr,options] detects any symbols in expr which do not have assigned values. The options may contain a PermittedSymbols->symbols directive.";


PermittedSymbols::usage="PermittedSymbols is an option for UnassignedSymbols specifying a set of permitted symbols that are exempted from the test."; 


NumericalComputationReadyQ::usage="NumericalComputationReadyQ[expr] determines whether events is ready for numerical computation.";


(* ::Input::Initialization:: *)
ReportSuspectSymbols::usage="A reporting function used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
PrecalculatedEvent::usage="PrecalculatedEvent is an object containing a precalculated propagator that may be used as part of a sequence of events. It is generated by applying Precalculate to a single event, or list of events.";


(* ::Input::Initialization:: *)
$Chronology="LeftToRight";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
TimePointPattern=
_?NumericQ|_Symbol|_?(MatchQ[#,Except[_List]]&&FreeQ[#,_?OperatorQ|_?SuperoperatorQ]&);


(* ::Input::Initialization:: *)
DurationPattern=TimePointPattern;


(* ::Input::Initialization:: *)
IntervalPattern=DurationPattern|{TimePointPattern,TimePointPattern};


(* ::Input::Initialization:: *)
RepeatNumberPattern=_Integer|_Symbol|_?(MatchQ[#,Except[_List]]&&FreeQ[#,_?OperatorQ|_?SuperoperatorQ]&);


(* ::Input::Initialization:: *)
StandardEventSpecificationPattern:={_?SuperoperatorQ,___Rule}|{_?ValidGeneratorQ,DurationPattern,___Rule}|{_Repeat,___Rule}|{_PrecalculatedEvent,___Rule}|StandardNullEventSpecificationPattern


(* ::Input::Initialization:: *)
NonStandardNullEventSpecificationPattern:=None|{None,___Rule}|UnitySuperoperator[___]|{___Rule}|{None|_?OperatorQ|_?SuperoperatorQ|_Function|_PeriodicFunction|_ShapeFunction,0,___Rule}|{None|_?OperatorQ|_?SuperoperatorQ|_Function|_PeriodicFunction|_ShapeFunction,\[Tau]_?((Chop@N[#]==0)&),___Rule};


(* ::Input::Initialization:: *)
StandardNullEventSpecificationPattern={UnitySuperoperator[___Rule],___Rule};


(* ::Input::Initialization:: *)
NullEventSpecificationPattern=NonStandardNullEventSpecificationPattern|StandardNullEventSpecificationPattern;


(* ::Input::Initialization:: *)
NonStandardEventSpecificationPattern:=_?SuperoperatorQ|_Repeat|_PrecalculatedEvent|NonStandardNullEventSpecificationPattern


(* ::Input::Initialization:: *)
EventSpecificationPattern:=StandardEventSpecificationPattern|NonStandardEventSpecificationPattern


(* ::Input::Initialization:: *)
SingleTimeIndependentEventPattern={NullGeneratorPattern|_?OperatorQ|_?SuperoperatorQ,DurationPattern}|{{NullGeneratorPattern|_?OperatorQ|_?SuperoperatorQ,DurationPattern}};


(* ::Input::Initialization:: *)
RepeatedTimeIndependentEventSeqPattern=
RepeatedEvent[
EventSpecifications[{{NullGeneratorPattern|_?OperatorQ|_?SuperoperatorQ,DurationPattern}..},___Rule],
RepeatNumberPattern
];


(* ::Input::Initialization:: *)
PiecewiseTimeIndependentEventSeqPattern=
SingleTimeIndependentEventPattern|
{(SingleTimeIndependentEventPattern|
RepeatedTimeIndependentEventSeqPattern)...};


(* ::Input::Initialization:: *)
ValidEventSpecificationQ[evspec_?StandardizedEventSpecificationQ,___Rule]:=True;


(* ::Input::Initialization:: *)
ValidEventSpecificationQ[evspec:EventSpecificationPattern,___Rule]:=True;


(* ::Input::Initialization:: *)
ValidEventSpecificationQ[evspec_,___Rule]:=False;


(* ::Input::Initialization:: *)
Options[StandardizedEventSpecificationQ]={};


(* ::Input::Initialization:: *)
StandardizedEventSpecificationQ[StandardEventSpecificationPattern,___Rule]=True;


(* ::Input::Initialization:: *)
StandardizedEventSpecificationQ[Except[StandardEventSpecificationPattern],___Rule]=False;


(* ::Input::Initialization:: *)
StandardizeEventSpecification[ev_?StandardizedEventSpecificationQ,___Rule]:=ev;


(* ::Input::Initialization:: *)
StandardizeEventSpecification[ev:(_?SuperoperatorQ|_Repeat|_PrecalculatedEvent),opts___Rule]:=StandardizeEventSpecification[{ev},opts];


(* ::Input::Initialization:: *)
StandardizeEventSpecification[{sop_?SuperoperatorQ,evopts___Rule},opts__Rule]:=StandardizeEventSpecification[{sop,SimplifyRules[evopts,opts]}];


(* ::Input::Initialization:: *)
StandardizeEventSpecification[{repev_Repeat,evopts___Rule},opts__Rule]:=StandardizeEventSpecification[{repev,SimplifyRules[evopts,opts]}];


(* ::Input::Initialization:: *)
StandardizeEventSpecification[{precalev_PrecalculatedEvent,evopts___Rule},opts__Rule]:=
StandardizeEventSpecification[{precalev,SimplifyRules[evopts,opts]}];


(* ::Input::Initialization:: *)
StandardizeEventSpecification[{evgen_?ValidGeneratorQ,dur:DurationPattern, evopts___Rule},opts__Rule]:=
StandardizeEventSpecification[{evgen,dur,SimplifyRules[evopts,opts]}
];


(* ::Input::Initialization:: *)
StandardizeEventSpecification[{evgen_?ValidGeneratorQ,dur:DurationPattern, evopts___Rule}]:=Module[{test,stdevg},(
StandardizeEventSpecification[{stdevg,dur,evopts}]
)/;(
stdevg=StandardizeGenerator[evgen];
!MatchQ[stdevg,evgen]
)];


(* ::Input::Initialization:: *)
StandardizeEventSpecification[NonStandardNullEventSpecificationPattern,opts___Rule]:=StandardNullEventSpecification;


(* ::Input::Initialization:: *)
StandardizeEventSpecification[
evsp:EventSpecifications[status:True|{chronstatus_,{_,True}|True,morestatus___},evspecs_,evspecopts___Rule
],
opts___Rule
]:=EventSpecifications[status,evspecs,SimplifyRules[evspecopts,opts]];


(* ::Input::Initialization:: *)
StandardizeEventSpecification[
EventSpecifications[{chronstatus_,{_,False}|False,morestatus___},evspecs_,evspecopts___Rule
],
opts___Rule
]:=
EventSpecifications[{chronstatus,{True,False},morestatus},evspecs,SimplifyRules[evspecopts,opts]];


(* ::Input::Initialization:: *)
StandardizeEventSpecification[evspec_,opts___Rule]/;!TrueQ[StandardizedEventSpecificationQ[evspec]]&&!MatchQ[evspec,Alternatives@@(FurtherEventSpecificationPatterns/.{opts}/.Options[EventSpecifications])]:=(Message[StandardizeEventSpecification::badevspec,evspec];$Failed);


(* ::Input::Initialization:: *)
StandardizeEventSpecification::badevspec="The event specification <`1`> cannot be interpreted.";


(* ::Input::Initialization:: *)
StandardNullEventSpecification:={UnitySuperoperator[]};


(* ::Input::Initialization:: *)
Options[EventSpecifications]={Chronology:>$Chronology,ExpandRepeatedEvents->False,Verbose->False,FurtherEventSpecificationPatterns->{}};


(* ::Input::Initialization:: *)
EventSpecifications[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
StatusDimension[EventSpecifications]=5;


(* ::Input::Initialization:: *)
EventSpecifications[evspecs_,evspecsopts___Rule]:=
EventSpecifications[False,evspecs,evspecsopts];


(* ::Input::Initialization:: *)
EventSpecifications[False,evspecs_,evspecsopts___Rule]:=EventSpecifications[Table[False,{StatusDimension[EventSpecifications]}],evspecs,evspecsopts];


(* ::Input::Initialization:: *)
EventSpecifications[{True..},evspecs_,opts___Rule]:=EventSpecifications[True,evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[arg:Except[_List],opts___Rule]:=EventSpecifications[{arg},opts];


(* ::Input::Initialization:: *)
EventSpecifications[
{checkstatus_,chronstatus_,nestliststatus_,False,morestatus___},evspecs_,opts___Rule]:=
EventSpecifications[{checkstatus,chronstatus,nestliststatus,Table[False,{5}],morestatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[
{checkstatus_,chronstatus_,nestliststatus_,{True..},morestatus___},evspecs_,opts___Rule]:=
EventSpecifications[{checkstatus,chronstatus,nestliststatus,True,morestatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[
{checkstatus_,chronstatus_,nestliststatus_,{False,___},morestatus___},evspecs_,opts___Rule]:=
EventSpecifications[{checkstatus,chronstatus,nestliststatus,
{True,False,False,False,False},morestatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[
status:{checkstatus_,chronstatus_,nestliststatus_,{True,True,True,True,False},morestatus___},
evspecs:{_Except[Rule]..},opts___Rule
]/;And@@(StandardizedEventSpecificationQ/@evspecs):=
EventSpecifications[
{checkstatus,chronstatus,nestliststatus,{True,True,True,True,True},morestatus},
evspecs,opts
];


(* ::Input::Initialization:: *)
EventSpecifications[
status:{checkstatus_,chronstatus_,nestliststatus_,{True,__},morestatus___},
evspec:EventSpecificationPattern,opts___Rule
]:=EventSpecifications[status,{evspec},opts];


(* ::Input::Initialization:: *)
EventSpecifications[
status_,
{evspec:EventSpecifications[True,evspecargs:Except[_Rule]...,evspecopts___Rule],moreevspecsopts___Rule},
opts___Rule
]:=EventSpecifications[True,evspecargs,
SimplifyRules[evspecopts,moreevspecsopts,opts]];


(* ::Input::Initialization:: *)
EventSpecifications[
status:{checkstatus_,chronstatus_,nestliststatus_,{True,False,morestandstatus___},morestatus___},
evspecs:{rawevspecs___,evspecsopts___Rule},
opts___Rule
]:=
If[
(Count[{rawevspecs},NullEventSpecificationPattern,1]>=1)&&(Count[{rawevspecs},Except[NullEventSpecificationPattern],1]>=1),
(If[Verbose/.{opts}/.Options[EventSpecifications],
Print["EventSpecifications: stripping out null events."]];
EventSpecifications[{checkstatus,chronstatus,nestliststatus,{True,True,morestandstatus},morestatus},
Replace[
evspecs,
{nullevspec:NullEventSpecificationPattern:>Sequence[]},
1
],
opts
]
),
EventSpecifications[{checkstatus,chronstatus,nestliststatus,{True,True,morestandstatus},morestatus},
evspecs,opts]
];


(* ::Input::Initialization:: *)
EventSpecifications[
status:{checkstatus_,chronstatus_,nestliststatus_,{True,True,False,stnoopevs_,True},morestatus___},
evspecs:{evspecseq:Except[_Rule]..,evspecopts___Rule},opts___Rule
]:=(
If[Verbose/.{opts}/.Options[EventSpecifications],
Print["EventSpecifications: incorporating options: ", Expand[evspecs]/.s_ShapeFunction:>s[[{4}]]]];
EventSpecifications[
{checkstatus,chronstatus,nestliststatus,{True,True,True,stnoopevs,True},morestatus},
Replace[
{evspecseq},
{{sop_?SuperoperatorQ,evopts___Rule}:>
{sop,allowedeventopts[evopts,evspecopts,opts]},
{evgen_?ValidGeneratorQ,dur:DurationPattern, evopts___Rule}:>{evgen,dur,allowedeventopts[evopts,evspecopts,opts]},
{repev_Repeat,evopts___Rule}:>{repev,allowedeventopts[Repeat,evopts,evspecopts,opts]},
{precalev_PrecalculatedEvent,evopts___Rule}:>{precalev,allowedeventopts[evopts,evspecopts,opts]}
},
1
],
opts
]);


(* ::Input::Initialization:: *)
allowedeventopts[opts___Rule]:=Sequence@@SimplifyRules[FilterRules[{opts},Join[Options[Event],Options[EventList],Options[NDSolve]]]];


(* ::Input::Initialization:: *)
allowedeventopts[Repeat,opts___Rule]:=Sequence@@SimplifyRules[FilterRules[{opts},Join[{ExpandRepeatedEvents},Options[Event],Options[EventList],Options[NDSolve]]]];


(* ::Input::Initialization:: *)
EventSpecifications[
status:{checkstatus_,chronstatus_,nestliststatus_,{True,stemp_,stop_,False,morestandstatus___},morestatus___},
evspecs_List,
opts___Rule
]/;FreeQ[evspecs,_EventSpecifications]:=EventSpecifications[{checkstatus,chronstatus,nestliststatus,
{True,stemp,stop,True,morestandstatus},morestatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[
status:{checkstatus_,True,nestliststatus_,{True,stemp_,stop_,False,morestandstatus___},morestatus___},
evspecs_List,
opts___Rule
]/;(Count[evspecs,EventSpecifications[True,___],{1}]>=1)&&FreeQ[evspecs,EventSpecifications[{_,False,___},___]]:=
Module[{newstatus},(
newstatus={checkstatus,True,nestliststatus,
{True,stemp,stop,True,morestandstatus},morestatus};
(
If[Verbose/.{opts}/.Options[EventSpecifications],
Print["EventSpecifications: absorbing EventSpecifications arguments with no change in Chronology: ",Expand[evspecs]/.s_ShapeFunction:>s[[{4}]]]];
EventSpecifications[
newstatus,
Replace[
evspecs,
EventSpecifications[True,args:Except[_Rule]...,___Rule]:>Sequence@@args,
1
],
opts
]
)
)];


(* ::Input::Initialization:: *)
EventSpecifications[
status:{checkstatus_,False,nestliststatus_,{True,morestandstatus___},morestatus___},
evspecs_List,
opts___Rule
]/;(Count[evspecs,EventSpecifications[True|{_,True,___},___],{1}]>=1):=
Module[{newstatus},(
newstatus={checkstatus,False,nestliststatus,
{True,morestandstatus},morestatus};
(
If[Verbose/.{opts}/.Options[EventSpecifications],
Print["EventSpecifications: absorbing EventSpecifications arguments with reversed chronology (case 1): ",Expand[evspecs]/.s_ShapeFunction:>s[[{4}]]]];
EventSpecifications[
status,
Replace[
evspecs,
EventSpecifications[True|{_,True,___},args:Except[_Rule]...,___Rule]:>Sequence@@Reverse[args],
1
],
SimplifyRules[
Chronology->"LeftToRight",
opts
]
]
)
)];


(* ::Input::Initialization:: *)
EventSpecifications[
status:{checkstatus_,True,nestliststatus_,{True,morestandstatus___},morestatus___},
evspecs_List,
opts___Rule
]/;(Count[evspecs,EventSpecifications[{_,False,___},___],{1}]>=1):=
Module[{newstatus},(
newstatus={checkstatus,True,nestliststatus,
{True,morestandstatus},morestatus};
(
If[Verbose/.{opts}/.Options[EventSpecifications],
Print["EventSpecifications: absorbing EventSpecifications arguments with reversed chronology (case 2): ",Expand[evspecs]/.s_ShapeFunction:>s[[{4}]]]];
EventSpecifications[
status,
Replace[
evspecs,
EventSpecifications[{_,False,___},args:Except[_Rule]...,___Rule]:>Sequence@@Reverse[args],
1
],
SimplifyRules[
Chronology->"RightToLeft",
opts
]
]
)
)];


(* ::Input::Initialization:: *)
EventSpecifications[
status:{checkstatus_,chronstatus_,nestliststatus_,{True,stemp_,stop_,ststr_,False},morestatus___},
{evspecs__,evspecsopts___Rule},opts___Rule
]:=
Module[{stdevspecs,newstandstatus,fevspecpatts},(
If[Verbose/.{opts}/.Options[EventSpecifications],
Print["EventSpecifications: standardizing event specifications: ",Expand@{evspecs,evspecsopts}/.s_ShapeFunction:>s[[{4}]]]
];
fevspecpatts=Alternatives@@(FurtherEventSpecificationPatterns/.{opts}/.Options[EventSpecifications]);
stdevspecs=Sequence@@(Function[evspec,
Switch[evspec,
_?StandardizedEventSpecificationQ,evspec,
fevspecpatts,
	StandardizeEventSpecification[evspec,opts],
NonStandardEventSpecificationPattern,
	StandardizeEventSpecification[evspec,opts],
EventSpecifications[True,___]|EventSpecifications[{_,_,_,True,___},___],
	evspec,
_List,EventSpecifications[False,evspec,SimplifyRules[evspecsopts,opts]],
_Event,evspec/.Event[_,_,spec:Except[_Rule],___Rule]:>spec,
_EventList,evspec/.EventList[_,_,specs_List,___Rule]:>
If[chronstatus,EventSpecifications/@specs,EventSpecifications/@Reverse[specs]],
_,(Message[EventSpecifications::inval,evspec];$Failed)
]
]/@{evspecs});
newstandstatus=If[MemberQ[{stdevspecs},EventSpecifications[Except[True],___]],False,True];
EventSpecifications[
{checkstatus,chronstatus,nestliststatus,
{True,False,False,False,newstandstatus},
morestatus},
{stdevspecs,SimplifyRules[evspecsopts,opts]},
opts
]
)
];


(* ::Input::Initialization:: *)
EventSpecifications[{check_,False,otherstatus___},evspecs_,opts___Rule]:=EventSpecifications[{check,{False,False},otherstatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[{check_,{True,True},otherstatus___},evspecs_,opts___Rule]:=EventSpecifications[{check,True,otherstatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[{check_,chron:{False,chrondone_},otherstatus___},evspecs_,opts___Rule]:=EventSpecifications[{check,{True,False},otherstatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[{check_,chron:{True,False},otherstatus___},evspecs:{(_?StandardizedEventSpecificationQ|_EventSpecifications)...},opts___Rule]:=
(If[Verbose/.{opts}/.Options[EventSpecifications],
Print["EventSpecifications: implementing RtoL Chronology:", {chron,evspecs}/.s_ShapeFunction:>s[[{4}]]]];
EventSpecifications[
{check,True,otherstatus},
Switch[
Chronology/.{opts}/.Options[EventSpecifications],
"RightToLeft",evspecs,
"LeftToRight",Reverse[evspecs],
_,(Message[EventSpecifications::invchron];$Failed)
],
SimplifyRules[Chronology->"RightToLeft",opts]
]);


(* ::Input::Initialization:: *)
EventSpecifications[
{checkstatus_,chronstatus_,False,morestatus___},evspecs_,opts___Rule]:=
EventSpecifications[{checkstatus,chronstatus,{False,False},morestatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[
{checkstatus_,chronstatus_,{True,True},morestatus___},evspecs_,opts___Rule]:=
EventSpecifications[{checkstatus,chronstatus,True,morestatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[
{checkstatus_,chronstatus_,{False,_},morestatus___},evspecs_,opts___Rule]:=
EventSpecifications[{checkstatus,chronstatus,{True,False},morestatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[
status:{checkstatus_,chronstatus_,{True,False},morestatus___},
evspecs:{_?StandardizedEventSpecificationQ..},opts___Rule
]:=
(If[Verbose/.{opts}/.Options[EventSpecifications],
(Print["EventSpecifications: no internal list detected."];
Print[status,Expand@evspecs/.s_ShapeFunction:>s[[{4}]]])
];
EventSpecifications[{checkstatus,chronstatus,True,morestatus},evspecs,opts]
);


(* ::Input::Initialization:: *)
EventSpecifications[
{checkstatus_,chronstatus_,{True,False},morestatus___},evspecs_,opts___Rule]/;FreeQ[{evspecs},_EventSpecifications,1]:=EventSpecifications[{checkstatus,chronstatus,{True,True},morestatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[
{checkstatus_,chronstatus_,{True,False},morestatus___},evspecs_,opts___Rule]/;FreeQ[{evspecs},EventSpecifications[{_,_,False|{_,False},___},___],1]:=EventSpecifications[{checkstatus,chronstatus,{True,True},morestatus},evspecs,opts];


(* ::Input::Initialization:: *)
HoldPattern@EventSpecifications[status_List,{a___,{Repeat[repevs_,0,___Rule],repevopts___Rule},b___},opts___Rule]:=EventSpecifications[False,{a,b},opts];


(* ::Input::Initialization:: *)
HoldPattern@EventSpecifications[status_List,{a___,{Repeat[repevs_,1,___Rule],repevopts___Rule},b___},opts___Rule]:=EventSpecifications[False,{a,{repevs,repevopts},b},opts];


(* ::Input::Initialization:: *)
EventSpecifications[{checkstatus_,chronstatus_,nestliststatus_,standstatus_,False,otherstatus___},evspecs_,opts___Rule]:=EventSpecifications[{checkstatus,chronstatus,nestliststatus,standstatus,{False,False},otherstatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[{checkstatus_,chronstatus_,nestliststatus_,standstatus_,{True,True},otherstatus___},evspecs_,opts___Rule]:=EventSpecifications[{checkstatus,chronstatus,nestliststatus,standstatus,True,otherstatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[{checkstatus_,chronstatus_,nestliststatus_,standstatus_,{False,False}|False,otherstatus___},evspecs_,opts___Rule]:=
EventSpecifications[
{checkstatus,chronstatus,nestliststatus,standstatus,{True,False},otherstatus},
evspecs,opts
];


(* ::Input::Initialization:: *)
EventSpecifications[
evspecst:{checkstatus_,chronstatus_,nestliststatus_,standstatus_,{True,False},otherstatus___},
evspecs_List,
opts___Rule]:=
(
If[Verbose/.{opts}/.Options[EventSpecifications],
Print["EventSpecifications: handling Repeat: ",Expand@{evspecst,evspecs}/.s_ShapeFunction:>s[[{4}]]]];
EventSpecifications[
{False,chronstatus,False,False,True,otherstatus},
evspecs/.{evsa___,Repeat[EventList[_,_,events:{_Event..},evlistopts___Rule],n_Integer,repevopts___Rule],evsb___,evsopts___Rule}/;TrueQ[ExpandRepeatedEvents/.{repevopts,evsopts}/.Options[EventSpecifications]]:>
{evsa,
{Sequence@@If[chronstatus,Table[events,{n}],Table[Reverse@events,{n}]],
Sequence@@Cases[{evlistopts,repevopts},Except@HoldPattern[ExpandRepeatedEvents->_]]
},
evsb,
Sequence@@Cases[{evsopts},Except@HoldPattern[ExpandRepeatedEvents->_]]
},
Sequence@@Cases[{opts},Except@HoldPattern[ExpandRepeatedEvents->_]]
]);


(* ::Input::Initialization:: *)
EventSpecifications[{False,otherstatus___},evspecs_,opts___Rule]:=EventSpecifications[{{False,False},otherstatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[{{True,True},otherstatus___},evspecs_,opts___Rule]:=EventSpecifications[{True,otherstatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[{{False,False},otherstatus___},evspecs_,opts___Rule]:=EventSpecifications[{{True,False},otherstatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications[{{True,False},otherstatus:True...},evspecs_,opts___Rule]:=EventSpecifications[{{True,True},otherstatus},evspecs,opts];


(* ::Input::Initialization:: *)
EventSpecifications::inval="The event specification <`1`> is invalid.";


(* ::Input::Initialization:: *)
EventSpecifications::invchron="Invalid value for Chronology.";


(* ::Input::Initialization:: *)
EventSpecifications::chronconflict="An inconsistency has arisen between the chronological ordering of two or more EventSpecifications objects contained within another EventSpecifications object.";


(* ::Input::Initialization:: *)
Options[DivideEventSpecifications]={IncludeRepetitionNumbers->False};


(* ::Input::Initialization:: *)
DivideEventSpecifications[source:Except[_EventSpecifications],more:Except[_Rule]...,opts___Rule]:=DivideEventSpecifications[
EventSpecifications[source,SimplifyRules[ExpandRepeatedEvents->True,opts]],
more,
opts];


(* ::Input::Initialization:: *)
DivideEventSpecifications[evspecs_EventSpecifications,more:Except[_Rule]...,opts___Rule]/;!FreeQ[evspecs,_Repeat]:=
DivideEventSpecifications[
EventSpecifications[evspecs,SimplifyRules[ExpandRepeatedEvents->True,opts]],
more,
opts]


(* ::Input::Initialization:: *)
DivideEventSpecifications[EventSpecifications[{Except[True],morestatus___},evspecs_List,evspeclistopts___Rule],
more:Except[_Rule]...,opts___Rule]:=DivideEventSpecifications[EventSpecifications[{{True,False},morestatus},evspecs,evspeclistopts],
more,opts];


(* ::Input::Initialization:: *)
DivideEventSpecifications[evspeclist_EventSpecifications,
more:Except[_Rule]...,opts___Rule]/;!NumericQ[EventDuration[evspeclist]]:=(Message[DivideEventSpecifications::notnumdur];$Failed);


(* ::Input::Initialization:: *)
DivideEventSpecifications[evspeclist_EventSpecifications
\[Tau]vals_List,opts___Rule]/;Chop[Plus@@\[Tau]vals-EventDuration[evspeclist,Check->False]]!=0:=(Message[DivideEventSpecifications::invaltimes];$Failed);


(* ::Input::Initialization:: *)
DivideEventSpecifications[_EventSpecifications
n_Integer,opts___Rule]/;n<=0:=
(Message[DivideEventSpecifications::baddiv];$Failed)


(* ::Input::Initialization:: *)
DivideEventSpecifications[_EventSpecifications
n:Except[_Integer|_List],opts___Rule]:=
(Message[DivideEventSpecifications::baddiv];$Failed);


(* ::Input::Initialization:: *)
DivideEventSpecifications[evspeclist_EventSpecifications,
n_Integer,opts___Rule]:=
DivideEventSpecifications[evspeclist,Table[EventDuration[evspeclist,Check->False]/n,{n}],
opts
];


(* ::Input::Initialization:: *)
DivideEventSpecifications[
evspeclist_EventSpecifications,
\[Tau]vals:{_?NumericQ..},opts___Rule]/;(IncludeRepetitionNumbers/.{opts}/.Options[DivideEventSpecifications]):=
AddRepetitionIndices@DivideEventSpecifications[evspeclist,\[Tau]vals,
SimplifyRules[
IncludeRepetitionNumbers->False,opts
]
];


(* ::Input::Initialization:: *)
DivideEventSpecifications[EventSpecifications[status:True|{True,___},evspecs_List,evspeclistopts___Rule],
\[Tau]vals:{_?NumericQ..},opts___Rule]/;!(IncludeRepetitionNumbers/.{opts}/.Options[DivideEventSpecifications]):=
(EventSpecifications[status,#,evspeclistopts]&/@DivideRawEventList[evspecs,\[Tau]vals]);


(* ::Input::Initialization:: *)
DivideEventSpecifications::notnumdur="The duration of the events to be divided must be numeric.";


(* ::Input::Initialization:: *)
DivideEventSpecifications::baddiv="The division specification must be a positive definite integer or a list of timing intervals.";


(* ::Input::Initialization:: *)
DivideEventSpecifications::invaltimes="The division intervals must add up to the total duration of the event sequence.";


(* ::Input::Initialization:: *)
AddRepetitionIndices[eventlists:{_EventSpecifications..}]:=
Module[{groupedlists},(
groupedlists=SplitBy[MapAt[(
Replace[Rationalize[#],{notdur_,dur_}:>{notdur, N[dur]}])&,eventlists,{All,2}]/.{{None,0}-> Nothing,{None,0.}-> Nothing}];
MapThread[List,{Length/@groupedlists,First/@groupedlists},1]
)];


(* ::Input::Initialization:: *)
DivideRawEventList[source_List,\[Delta]tvals_List]/;!MatchQ[Last@source,{}|{{}}]:=
DivideRawEventList[source,{},\[Delta]tvals];


(* ::Input::Initialization:: *)
DivideRawEventList[source_List,{},\[Delta]tvals_List]:=DivideRawEventList[source,{{}},\[Delta]tvals];


(* ::Input::Initialization:: *)
DivideRawEventList[{},divlists:{_List...},\[Delta]tvals_List]:=divlists/.{{}->Sequence[]};


(* ::Input::Initialization:: *)
DivideRawEventList[source_,{{},prevlists___List},\[Delta]tvals_List]:=
Module[{newsource,newlist},(
{newsource,newlist}=TransferElement[source,{},Last[\[Delta]tvals]];
DivideRawEventList[newsource,{{},newlist,prevlists},Most[\[Delta]tvals]]
)/;(
EventDuration[source,Check->False]>=Last[\[Delta]tvals]
)
];


(* ::Input::Initialization:: *)
TransferElement[{},target_List,\[Delta]t_]:={{},target};


(* ::Input::Initialization:: *)
TransferElement[source_List,target_List,\[Delta]t_]/;(Chop[\[Delta]t]==0)&&(EventDuration[source,Check->False]>0):={source,target}


(* ::Input::Initialization:: *)
TransferElement[source_List,target_List,\[Delta]t_]:=
Module[{firstel,first\[Tau]},(
TransferElement[Most@source,Join[{Last@source},target],\[Delta]t]
)/;( 
(Length[source]>=1)&&(Chop[EventDuration[Last@source,Check->False]]==0)
)];


(* ::Input::Initialization:: *)
TransferElement[source_List,target_List,\[Delta]t_]:=
Module[{firstel,first\[Tau]},(
TransferElement[Most@source,Join[{Last@source},target],\[Delta]t-first\[Tau]]
)/;( 
(Length[source]>=1)&&(
firstel=Last@source;
first\[Tau]=EventDuration[firstel,Check->False];
(first\[Tau]<=\[Delta]t)&&Chop[first\[Tau]]!=0
)
)];


(* ::Input::Initialization:: *)
TransferElement[source_List,target_List,\[Delta]t_]:=
Module[{firstel,evgen,\[Tau],splitel1,splitel2},(
{splitel2,splitel1}=SplitElement[firstel,\[Delta]t];
TransferElement[Join[Most[source],{splitel2}],
Join[{splitel1},target],0]
)/;(
(\[Delta]t>0)&&Length[source]>0&&(
firstel=Last@source;
MatchQ[firstel,{evgen_,\[Tau]_,___Rule}]&&
EventDuration[firstel,Check->False]>\[Delta]t)
)
];


(* ::Input::Initialization:: *)
SplitElement[{evgen:(None|_?OperatorQ|_?SuperoperatorQ),\[Tau]_,opts___Rule},\[Delta]t_]:={{evgen,Chop[\[Tau]-\[Delta]t],opts},{evgen,Chop[\[Delta]t],opts}};


(* ::Input::Initialization:: *)
SplitElement[{evgen:ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,func_],\[Tau]_,opts___Rule},\[Delta]t_]:=Module[{\[Tau]vals,xvals,xvals1,xvals2,\[Tau]xpairs1,\[Tau]xpairs2},(
{\[Tau]vals,xvals}=Transpose[\[Tau]xpairs];
xvals1=(# \[Tau]/\[Delta]t)&/@xvals;
xvals2=((# \[Tau]-\[Delta]t)/(\[Tau]-\[Delta]t))&/@xvals;
\[Tau]xpairs1=Transpose[{\[Tau]vals,xvals1}];
\[Tau]xpairs2=Transpose[{\[Tau]vals,xvals2}];
{{ShapeFunction[t,Evaluate@\[Tau]xpairs2,T,func],Chop[\[Tau]-\[Delta]t],opts},
{ShapeFunction[t,Evaluate@\[Tau]xpairs1,T,func],Chop[\[Delta]t],opts}
}
)];


(* ::Input::Initialization:: *)
Options[Event]=
{
InitialTimePoint->Automatic,
FinalTimePoint->Automatic,
BackgroundGenerator->Undefined,
PropagatorCalculationProcedure->Automatic,
PropagationMethod-> Automatic,
EventSampling->None,
DeleteCoherences-> True,
OperatorBasis->Automatic,
Basis->Automatic,
ExpandRepeatedEvents->Automatic,
Verbose->False
};


(* ::Input::Initialization:: *)
Event[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
Event[evspec:Except[_Rule],opts___Rule]:=Event[False,evspec,opts];


(* ::Input::Initialization:: *)
Event[False,more:(Except[_Rule]...),opts___Rule]:=Event[{False,False},more,opts];


(* ::Input::Initialization:: *)
CharacteristicsDimension[Event]=6;


(* ::Input::Initialization:: *)
Event[{False,False},evspec:Except[_Rule],opts___Rule]:=Event[{False,False},Undefined,evspec,opts];


(* ::Input::Initialization:: *)
Event[{False,False},Undefined,evspec:Except[_Rule],opts___Rule]:=
Event[{False,False},Table[Undefined,{CharacteristicsDimension[Event]}],evspec,opts];


(* ::Input::Initialization:: *)
Event[status_,
{Undefined,charsb___},
evspec:Except[_Rule],opts___Rule]:=
Event[status,
{{Undefined,Undefined,Undefined,Undefined},charsb},
evspec,opts];


(* ::Input::Initialization:: *)
Event[status_,
{charsa_,Undefined,charsb___},
evspec:Except[_Rule],opts___Rule]:=
Event[status,
{charsa,{Undefined,Undefined, Undefined},charsb},
evspec,opts];


(* ::Input::Initialization:: *)
Event[{False,False},chars_List,more:(Except[_Rule]..),opts___Rule]/;FreeQ[{chars,more},Undefined]&&MatchQ[chars,{_,{__,True},_,_,True|{__,True},___,True|{__,True}}]:=Event[{True,False},chars,more,
Sequence@@FilterRules[{opts},Except[(BackgroundGenerator|ExpandRepeatedEvents)->_]
]
];


(* ::Input::Initialization:: *)
Event[{True,False},chars_List,more:(Except[_Rule]..),opts___Rule]/;MatchQ[UnassignedSymbols[{more},opts],{}]:=Event[{True,True},chars,more,opts];


(* ::Input::Initialization:: *)
NumericalComputationReadyQ[Event[{False,num_},more:(Except[_Rule]...),opts___Rule],___Rule]:=False;


(* ::Input::Initialization:: *)
NumericalComputationReadyQ[Event[{True,num_},more:(Except[_Rule]...),opts___Rule],___Rule]:=num;


(* ::Input::Initialization:: *)
Event[{False,numst_},{chars:Repeated[_,{4}],Undefined,morech___},evspec_,opts___Rule]:=
Event[{False,numst},{chars,{ExpandRepeatedEvents/.{opts}/.Options[Event],True,False},morech},evspec,opts];


(* ::Input::Initialization:: *)
ExpandRepeatedEvents[
Event[{False,numst_},{chars:Repeated[_,{4}],Undefined|{Undefined,__},morech___},evspec_,opts___Rule],
exprepevopts___Rule
]:=
Event[{False,numst},
{chars,
{ExpandRepeatedEvents/.{exprepevopts,opts}/.Options[Event],True,False},morech},evspec,
Sequence@@FilterRules[{opts},Except[ExpandRepeatedEvents]]
];


(* ::Input::Initialization:: *)
ExpandRepeatedEvents[
Event[{False,numst_},{chars:Repeated[_,{4}],{expreptype_,__},morech___},evspec_,opts___Rule],
exprepevopts___Rule
]:=
Event[{False,numst},
{chars,
{ExpandRepeatedEvents/.{exprepevopts,opts,ExpandRepeatedEvents->expreptype}/.Options[Event],True,False},morech},evspec,
Sequence@@FilterRules[{opts},Except[ExpandRepeatedEvents]]
];


(* ::Input::Initialization:: *)
ExpandRepeatedEvents[
ev:Event[st_,{chars:Repeated[_,{4}],True|{True..}|{__,True},morech___},evspec_,opts___Rule],
exprepevopts___Rule
]:=ev;


(* ::Input::Initialization:: *)
Event[{False,numst_},{chars:Repeated[_,{4}],{type_,True,False},morech___},evspec_,opts___Rule]/;FreeQ[evspec,_Repeat]:=
Event[{False,numst},{chars,{type,True,True},morech},evspec,
Sequence@@FilterRules[{opts},Except[ExpandRepeatedEvents]]
];


(* ::Input::Initialization:: *)
Event[{False,numst_},{chars:Repeated[_,{4}],{type_,True,True},morech___},evspec_,opts___Rule]:=
Event[{False,numst},{chars,True,morech},evspec,opts];


(* ::Input::Initialization:: *)
Event[{False,numst_},chars_List,{evgen_?ValidGeneratorQ,\[Tau]:DurationPattern,evspecopts__Rule},opts___Rule]:=
Event[{False,numst},chars,{evgen,\[Tau]},
SimplifyRules[evspecopts,opts]
];


(* ::Input::Initialization:: *)
Event[{False,numst_},chars_List,{sop_?SuperoperatorQ,evspecopts__Rule},opts___Rule]:=
Event[{False,numst},chars,{sop},
SimplifyRules[evspecopts,opts]
];


(* ::Input::Initialization:: *)
Event[{False,numst_},chars_List,ev:NonStandardNullEventSpecificationPattern,opts___Rule]:=
Event[{False,numst},chars,StandardNullEventSpecification,opts];


(* ::Input::Initialization:: *)
Event[{False,numst_},chars_List,EventSpecifications[True,{evspec_?StandardizedEventSpecificationQ},evspecopts___Rule],opts___Rule]:=
Event[{False,numst},chars,evspec,
SimplifyRules[evspecopts,opts]
];


(* ::Input::Initialization:: *)
Event[st_,chars_,{repevs_Repeat,opts1___Rule},opts2___Rule]:=Event[st,chars,repevs,SimplifyRules[opts1,opts2]];


(* ::Input::Initialization:: *)
Event[st_,chars_,{precalev_PrecalculatedEvent,opts1___Rule},opts2___Rule]:=Event[st,chars,precalev,SimplifyRules[opts1,opts2]];


(* ::Input::Initialization:: *)
Event[{False,numst_},{tch2_,evbackgch2:{evbackg2_,evbackgimplreq2_,evbackgimpl2_},morech2__},
ev:Event[stat1_,
{tch1_,evbackgch1:{evbackg1_,evbackgimplreq1_,evbackgimpl1_},morech1__},evspec_,evopts1___Rule],
evopts2___Rule
]:=
Module[{evbackg},(
If[Verbose/.{evopts2,evopts1}/.Options[Event],Print["applying Event to another Event"]];
Event[{False,numst},
{tch2,
Switch[
{evbackgch2,evbackgch1},
	{{Undefined,__},{Undefined,__}},{Undefined,Undefined,Undefined},
	{{Undefined,__},Except[{Undefined,__}]},evbackgch1,
	{Except[{Undefined,__}],{Undefined,__}},evbackgch2,
	{{evbackg_,___},{evbackg_,___}},evbackgch1,
	_,(Message[Event::backgconf];$Failed)
],
Undefined,Undefined,Undefined,Undefined
},
evspec,
SimplifyRules[
evopts1,evopts2
]
]
)];


(* ::Input::Initialization:: *)
Event[evst_,evchs_,evlist_EventList,evopts___Rule]:=evlist;


(* ::Input::Initialization:: *)
Event[{False,numst_},{{Undefined,moretimingch___},morech___},evspec_,opts___Rule]:=
Module[{dur},(
dur=EventDuration[evspec];
If[Verbose/.{opts}/.Options[Event],Print["inserting duration"]];
If[
TrueQ[Chop@N@dur<0],
	(Message[Event::negdur];$Failed),
Event[{False,numst},{{dur,moretimingch},morech},evspec,opts]
]
)];


(* ::Input::Initialization:: *)
EventDuration[Event[status_,{{dur_,moretimingch___},morech___},evspec_,opts___Rule]]:=dur;


(* ::Input::Initialization:: *)
Event[{False,numst_},{{dur_,{tb_,ta_},moretimingch___},morech___},evspec_,opts___Rule]:=
Module[{newtb,newta,newsttb,newstta},(
Message[Event::tconflict];$Failed
)/;(
{newtb,newta}={FinalTimePoint,InitialTimePoint}/.{opts}/.Options[Event];
TrueQ[Chop[newtb-tb]!=0]||TrueQ[Chop[newta-ta]!=0]
)
];


(* ::Input::Initialization:: *)
Event[{ready_,numst_},{{dur:Except[Undefined],Undefined,moretimingch___},morech___},evspec_,opts___Rule]:=
Module[{ta,tb},(
If[Verbose/.{opts}/.Options[Event],Print["inserting {tb,ta}"]];
Event[{ready,numst},{
{dur,
Switch[{tb,ta},
{Except[Automatic|Undefined],Automatic|Undefined},
	{tb,tb-dur},
{Automatic|Undefined,Except[Automatic|Undefined]},
	{ta+dur,ta},
_,(Message[Event::badtimepts];$Failed)
],
moretimingch},morech},
evspec,Sequence@@Cases[{opts},Except[(FinalTimePoint|InitialTimePoint)->_]]]
)/;(
{tb,ta}={FinalTimePoint,InitialTimePoint}/.{opts}/.Options[Event];
!MatchQ[{tb,ta},{Automatic|Undefined,Automatic|Undefined}]
)];


(* ::Input::Initialization:: *)
HoldPattern@Event[{False,numst_},
{{dur_,{tb_,ta_},moretimingch___},{backg:Except[Undefined],False,False},hilbch_,pcpch_,exprepch:True|{exptype_,expreq_,True}},
Repeat[
EventList[evliststatus_,evlistch:{evlisttimech:{evlistdur_,Undefined,moreevlisttimech__},evlistbackgch_,moreevlistch___},events_List,
evlistopts___Rule
],
nrep_,
repevopts___Rule
],
opts___Rule]:=
Event[{False,numst},{{dur,{tb,ta},moretimingch},{backg,True,False},hilbch,pcpch,exprepch},
Repeat[
EventList[evliststatus,evlistch,
events,
SimplifyRules[
InitialTimePoint->ta,
FinalTimePoint->Automatic,
evlistopts
]
],
nrep,
repevopts
],
opts
];


(* ::Input::Initialization:: *)
InitialTimePoint[Event[status_,{{dur_,Undefined,moretimingch___},morech___},evspec_,opts___Rule],___Rule]:=Undefined;


(* ::Input::Initialization:: *)
InitialTimePoint[Event[status_,{{dur_,{tb_,ta_},moretimingch___},morech___},evspec_,opts___Rule],___Rule]:=ta;


(* ::Input::Initialization:: *)
FinalTimePoint[Event[status_,{{dur_,Undefined,moretimingch___},morech___},evspec_,opts___Rule],___Rule]:=Undefined;


(* ::Input::Initialization:: *)
FinalTimePoint[Event[status_,{{dur_,{tb_,ta_},moretimingch___},morech___},evspec_,opts___Rule],___Rule]:=tb;


(* ::Input::Initialization:: *)
Event[{False,numst_},{{dur_,timepts_,Undefined,moretimingch___},backgch:{backg:Except[Undefined],_,_},morech___},evspec_,opts___Rule]:=
Module[{pts},(
If[Verbose/.{opts}/.Options[Event],Print["inserting PermittedTimeShift"]];
Event[{False,numst},{{dur,timepts,pts,moretimingch},backgch,morech},evspec,opts]
)/;(
pts=PermittedTimeShift[evspec,BackgroundGenerator->backg];
!MatchQ[pts,Undefined]
)]; 


(* ::Input::Initialization:: *)
PermittedTimeShift[Event[status_,{{dur_,timepts_,pts_,moretimingch___},morech___},evspec_,opts___Rule],___Rule]:=pts;


(* ::Input::Initialization:: *)
Event[{False,numst_},{{dur_,{tb_,ta_},pts:Except[Undefined],Undefined},morech___},evspec_,opts___Rule]:=
(If[Verbose/.{opts}/.Options[Event],Print["inserting StandardizedInterval"]];
Event[{False,numst},
{{dur,{tb,ta},pts,StandardizedInterval[{tb,ta},pts]},morech},
evspec,opts]);


(* ::Input::Initialization:: *)
StandardizedInterval[Event[status_,{{dur_,timepts_,pts_,standintv_,moretimingch___},morech___},evspec_,opts___Rule],___Rule]:=standintv;


(* ::Input::Initialization:: *)
StandardizedInterval[{tb_,ta_},None]:={tb,ta};


(* ::Input::Initialization:: *)
StandardizedInterval[{tb_,ta_},All]:={0,ta-tb};


(* ::Input::Initialization:: *)
StandardizedInterval[{tb_,ta_},T_?NumericQ]/;(Chop[T]!=0):=
Module[{\[CapitalDelta]},(\[CapitalDelta]=T*Floor[tb/T];{tb-\[CapitalDelta],ta-\[CapitalDelta]})];


(* ::Input::Initialization:: *)
StandardizedInterval[{tb_,ta_},T_?NumericQ]/;(Chop[T]==0):=StandardizedInterval[{tb,ta},All];


(* ::Input::Initialization:: *)
StandardizedInterval[{tb_,ta_},T:DurationPattern]:=
Module[{\[CapitalDelta]},(\[CapitalDelta]=T*Floor[tb/T];{tb-\[CapitalDelta],ta-\[CapitalDelta]})];


(* ::Input::Initialization:: *)
StandardizedInterval[{tb_,ta_},_]:={tb,ta};


(* ::Input::Initialization:: *)
HoldPattern@Event[evstatus:{False,numst_},
evch:{{evT_,{tb_,ta:Except[Undefined]},moreevtch__},moreevch__,True|{__,True}},
Repeat[
evlist:EventList[
evliststatus_,
evlistchars:{{evlistT_,Undefined,moreevlisttch__},moreevlistch__},
events:{_Event..},
evlistopts___Rule],
nrep_,
repevopts___Rule
],
evopts___Rule
]:=
(If[Verbose/.{evopts}/.Options[Event],Print["passing down timing to EventList inside Repeat"]];
Event[evstatus,evch,
Repeat[
EventList[
evliststatus,evlistchars,
events/.Event[ievst_,{ievttch_,moreievch__},ievspecs_,ievopts___Rule]:>Event[ievst,{Undefined,moreievch},ievspecs,ievopts],
SimplifyRules[
InitialTimePoint->ta,
evlistopts
]
],
nrep,
repevopts
],
evopts
]);


(* ::Input::Initialization:: *)
Event[{False,numst_},{timingch_,{Undefined,backgimp__},morech___},evspec_,opts___Rule]:=
Module[{evbackg},(
If[Verbose/.{opts}/.Options[Event],Print["inserting BackgroundGenerator: ", Expand[evbackg]]];
Event[{False,numst},{timingch,{evbackg,backgimp},morech},evspec,opts]
)/;(
evbackg=BackgroundGenerator/.{opts}/.Options[Event];
!MatchQ[evbackg,Undefined]
)];


(* ::Input::Initialization:: *)
Event[{False,numst_},{timingch_,{evbackg1:Except[Undefined|False],backgimp__},morech___},evspec_,opts___Rule]:=Module[{evbackg2},(
(Message[Event::backgconflict];$Failed)
)/;(
evbackg2=BackgroundGenerator/.{opts}/.Options[Event];
!MatchQ[evbackg2,Undefined]&&
!GeneratorMatchQ[evbackg1,evbackg2]
)];


(* ::Input::Initialization:: *)
Event[{False,numst_},
{{dur_,moretimingch___},{backg:Except[Undefined],False|Undefined,False|Undefined},morech___},evspec_,opts___Rule]/;TrueQ[Chop[dur]==0]:=
Event[{False,numst},{{dur,moretimingch},{backg,True,False},morech},evspec,
Sequence@@FilterRules[{opts},Except[BackgroundGenerator]]
];


(* ::Input::Initialization:: *)
Event[{False,numst_},
{{dur_,moretimingch___},{backg:Except[Undefined],True,False|Undefined},morech___},evspec_,opts___Rule]/;TrueQ[Chop[dur]==0]:=
Event[{False,numst},{{dur,moretimingch},{backg,True,True},morech},evspec,opts
];


(* ::Input::Initialization:: *)
Event[{False,numst_},
{{dur_,moretimingch___},{backg:Except[Undefined],False|Undefined,False|Undefined},morech___},{evgen_,\[Tau]_},opts___Rule]/;!TrueQ[Chop[dur]==0]:=
Event[{False,numst},{{dur,moretimingch},{backg,True,False},morech},{evgen,\[Tau]},Sequence@@FilterRules[{opts},Except[BackgroundGenerator]]
];


(* ::Input::Initialization:: *)
Event[{False,numst_},
{{dur_,moretimingch___},{backg:Except[Undefined],True,False|Undefined},morech___},{evgen_,\[Tau]_},opts___Rule]/;!TrueQ[Chop[dur]==0]:=
Module[{},(
If[Verbose/.{opts}/.Options[Event],Print["implementing BackgroundGenerator in finite-duration Event: ", {backg,evgen}/.s_ShapeFunction:>s[[{4}]]]
];
Event[{False,numst},{{dur,moretimingch},{backg,True,True},morech},{CombineGenerators[evgen,backg],\[Tau]},opts
]
)];


(* ::Input::Initialization:: *)
HoldPattern@Event[{False,numst_},
{{dur_,moretimingch___},{backg:Except[Undefined],_,_},morech___},repevs:Repeat[EventList[evliststatus_,{evlisttiming_,{evlistbackg:Undefined,evlistbackgreqimpl_,evlistbackgimpl_},moreevlistch___},events_List,evlistopts___Rule],nrep_,repevopts___Rule],
opts___Rule]:=
Module[{},(
If[Verbose/.{opts}/.Options[Event],Print["inserting BackgroundGenerator into Repeat: ", Expand[backg]]];
Event[{False,numst},{{dur,moretimingch},{backg,False,False},morech},Repeat[EventList[evliststatus,{evlisttiming,{backg,False,False},moreevlistch},events,evlistopts],nrep,repevopts],Sequence@@FilterRules[{opts},Except[BackgroundGenerator]]
]
)];


(* ::Input::Initialization:: *)
Event[{False,numst_},
{{dur_,moretimingch___},{backg:Except[Undefined],False,False},hilbch_,pcpch_,exprepch:True|{exptype_,expreq_,True},morech___},
repevs_Repeat,
opts___Rule]:=
Module[{},(
If[Verbose/.{opts}/.Options[Event],Print["requesting BackgroundGenerator implementation for Repeat: ", Expand[backg]]];
Event[{False,numst},{{dur,moretimingch},{backg,True,False},hilbch,pcpch,exprepch,morech},
repevs,
Sequence@@FilterRules[{opts},Except[BackgroundGenerator]]
]
)];


(* ::Input::Initialization:: *)
HoldPattern@Event[{False,numst_},
{{dur_,moretimingch___},{backg:Except[Undefined],True,False},morech___},repevs:Repeat[EventList[evliststatus_,{evlisttiming_,{backg_,False|Undefined,False|Undefined},moreevlistch___},events_List,evlistopts___Rule],nrep_,repevopts___Rule],
opts___Rule]:=
Module[{},(
If[Verbose/.{opts}/.Options[Event],Print["passing BackgroundGenerator implementation request into Repeat: ",Expand[backg]]
];
Event[{False,numst},{{dur,moretimingch},{backg,True,False},morech},
Repeat[EventList[evliststatus,{evlisttiming,{backg,True,False},moreevlistch},events,evlistopts],nrep,repevopts],
Sequence@@FilterRules[{opts},Except[BackgroundGenerator]]
]
)];


(* ::Input::Initialization:: *)
HoldPattern@Event[{False,numst_},
{{dur_,moretimingch___},{backg:Except[Undefined],True,False},morech___},repevs:Repeat[EventList[evliststatus_,{evlisttiming_,{backg_,_,True},moreevlistch___},events_List,evlistopts___Rule],nrep_,repevopts___Rule],
opts___Rule]:=
Module[{},(
If[Verbose/.{opts}/.Options[Event],Print["passing BackgroundGenerator implementation status from Repeat upwards to enclosing Event: ",Expand@backg ]
];
Event[{False,numst},{{dur,moretimingch},{backg,True,True},morech},
Repeat[EventList[evliststatus,{evlisttiming,{backg,True,True},moreevlistch},events,evlistopts],nrep,repevopts],
Sequence@@FilterRules[{opts},Except[BackgroundGenerator]]
]
)];


(* ::Input::Initialization:: *)
BackgroundGenerator[Event[status_,{timingch_,{backg_,__},morech___},evspec_,opts___Rule],___]:=backg;


(* ::Input::Initialization:: *)
BackgroundGeneratorImplemented[Event[status_,{timingch_,{backg_,reqbackgimp_,backgimp_},morech___},evspec_,opts___Rule],___]:=backgimp;


(* ::Input::Initialization:: *)
Event[{False,numst_},{timingch_,backgch:{backg:Except[Undefined],__},Undefined,morech___},evspec_,opts___Rule]:=
Module[{hilbcomp},(
If[Verbose/.{opts}/.Options[Event],Print["inserting HilbertSpaceCompatibility into Event: ",hilbcomp]];
Event[{False,numst},{timingch,backgch,hilbcomp,morech},evspec,opts]
)/;(
hilbcomp=If[MatchQ[(PropagationMethod/.{opts}),Adiabatic],False,HilbertSpaceCompatibility[evspec,BackgroundGenerator->backg]];
!MatchQ[hilbcomp,Undefined]
)
];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[Event[status_,{timingch_,backgch_,hilbcompat_,morech___},evspec_,opts___Rule],___]:=hilbcompat;


(* ::Input::Initialization:: *)
Options[HilbertSpaceCompatibility]={BackgroundGenerator->Undefined};


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[args:Except[_Rule]..]/;(
Or@@(MatchQ[#,Undefined]&/@{args})):=Undefined;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[args:Except[_Rule]...,optsa___Rule,BackgroundGenerator->(backg:Undefined),optsb___Rule]:=Undefined;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[args:Except[_Rule]..,opts__Rule]:=HilbertSpaceCompatibility[args]/;FreeQ[{opts},BackgroundGenerator];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[
args:Repeated[Except[_Rule],{2,Infinity}],
opts___Rule]/;(
Or@@(MatchQ[HilbertSpaceCompatibility[#,opts],Undefined]&/@{args})):=Undefined;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[a_,b:Except[_Rule]..,opts___Rule]:=
And@@(TrueQ[HilbertSpaceCompatibility[#,opts]]&/@{a,b});


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[Undefined]=Undefined;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[None]:=True;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[_?OperatorQ]:=True;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[(Function|PeriodicFunction|ShapeFunction)[__,_?OperatorQ|_CommutationSuperoperator]]:=True;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[_RotationSuperoperator|_UnitySuperoperator|_CommutationSuperoperator]:=True;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[HoldPattern@Dot[_RotationSuperoperator..]]:=True;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[{evgen_?ValidGeneratorQ,\[Tau]_},opts___Rule]/;!TrueQ[Chop[\[Tau]]==0]:=
HilbertSpaceCompatibility[evgen,BackgroundGenerator/.{opts}/.Options[HilbertSpaceCompatibility]
];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[{evgen_?ValidGeneratorQ,\[Tau]_},opts___Rule]/;TrueQ[Chop[\[Tau]]==0]:=
HilbertSpaceCompatibility[evgen];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[evgen_?ValidGeneratorQ,opts__Rule]:=HilbertSpaceCompatibility[evgen];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[{sop_?SuperoperatorQ,___},opts___Rule]:=HilbertSpaceCompatibility[sop];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[_RotationSuperoperator|_UnitySuperoperator|_NullSuperoperator,opts___Rule]=True;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[_?SuperoperatorQ,opts___Rule]:=False;


(* ::Input::Initialization:: *)
HoldPattern@HilbertSpaceCompatibility[Repeat[evs_,n_Integer,Except[_Rule]...,repevopts___Rule],opts___Rule]:=
TrueQ[HilbertSpaceCompatibility[evs,repevopts,opts]];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[PrecalculatedEvent[{tch_,evgench_,hilb_,___},___],opts___Rule]:=
hilb;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[
Event[evstatus_,evch:{evtch_,{evbackg_,morevbackgch__},
hilbcomp:Except[Undefined],moreevch__},
evspecs_,
evopts___Rule
],
opts___Rule
]:=hilbcomp;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[
Event[evstatus_,evch:{evtch_,{evbackg:Undefined,morevbackgch__},
hilbcomp_,moreevch__},
evspecs_,
evopts___Rule
],
opts___Rule
]/;MatchQ[BackgroundGenerator/.{opts}/.Options[HilbertSpaceCompatibility],Undefined]:=Undefined;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[
Event[evstatus_,evch:{evtch_,{evbackg:Undefined,morevbackgch__},
hilbcomp:Undefined,moreevch__},
evspecs_,
evopts___Rule
],
opts___Rule
]:=Module[{extbackg},(
HilbertSpaceCompatibility[evspecs,opts]
)/;(
extbackg=BackgroundGenerator/.{opts}/.Options[HilbertSpaceCompatibility];
!MatchQ[extbackg,Undefined]
)];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[
EventList[evlstatus_,evlch:{evltch_,{evlbackg_,morevlbackgch__},
hilbcomp:Except[Undefined],moreevlch__},
events_List,
evlopts___Rule
],
opts___Rule
]:=hilbcomp;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[
EventList[evlstatus_,evlch:{evltch_,{evlbackg:Undefined,morevlbackgch__},
hilbcomp:Except[Undefined],moreevlch__},
events_List,
evlopts___Rule
],
opts___Rule
]/;MatchQ[BackgroundGenerator/.{opts}/.Options[HilbertSpaceCompatibility],Undefined]:=Undefined;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[
EventList[evlstatus_,evlch:{evltch_,{evlbackg:Undefined,morevlbackgch__},
hilbcomp:Undefined,moreevlch__},
events_List,
evlopts___Rule
],
opts___Rule
]:=Module[{extbackg},(
And@@(HilbertSpaceCompatibility[#,opts]&/@events)
)/;(
extbackg=BackgroundGenerator/.{opts}/.Options[HilbertSpaceCompatibility];
!MatchQ[extbackg,Undefined]
)];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[spec_,opts___Rule]/;MatchQ[spec,Except[_?ValidGeneratorQ|_EventSpecifications|_Event|_?(StandardizedEventSpecificationQ[#,opts]&)|_EventList|{_Event..}]
]:=HilbertSpaceCompatibility[EventSpecifications[spec,opts],opts];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[EventSpecifications[True,evspecs_,___Rule],opts___Rule]:=And@@(HilbertSpaceCompatibility[#,opts]&/@evspecs);


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[evlist_EventList,opts___Rule]:=HilbertSpaceCompatibility[First[evlist],opts];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[evs:{_Event..},opts___Rule]:=And@@(HilbertSpaceCompatibility[#,opts]&/@evs);


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[ev_Event,opts___Rule]:=HilbertSpaceCompatibility[First[ev],opts];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[___]:=False;


(* ::Input::Initialization:: *)
Event[{False,numst_},{timingch_,backgch:{backg:Except[Undefined],_,True},hilbch_,Undefined,morech___},evspec_,opts___Rule]:=
Event[{False,numst},
{timingch,backgch,hilbch,
PropagatorCalculationProcedure[evspec],
morech},
evspec,opts];


(* ::Input::Initialization:: *)
PropagatorCalculationProcedure[Event[status_,{timingch_,backgch_,hilbcompat_,pcproc_,morech___},evspec_,opts___Rule],___]:=pcproc;


(* ::Input::Initialization:: *)
PropagatorCalculationProcedure[NullEventSpecificationPattern,convopts___Rule]:=None


(* ::Input::Initialization:: *)
PropagatorCalculationProcedure[{None|op_?OperatorQ,timing:{tb_?NumericQ,ta_?NumericQ}|\[Tau]_?NumericQ,opts___Rule},convopts___Rule]:=IntegrateEvolutionOverTime;


(* ::Input::Initialization:: *)
PropagatorCalculationProcedure[{func:(_Function|_PeriodicFunction|_ShapeFunction),timing:{tb_?NumericQ,ta_?NumericQ}|\[Tau]_?NumericQ,opts___Rule},convopts___Rule]:=IntegrateEvolutionOverTime;


(* ::Input::Initialization:: *)
PropagatorCalculationProcedure[{sop_?SuperoperatorQ,timing:{tb_?NumericQ,ta_?NumericQ}|\[Tau]_?NumericQ,opts___Rule},convopts___Rule]:=IntegrateEvolutionOverTime;


(* ::Input::Initialization:: *)
PropagatorCalculationProcedure[
_?SuperoperatorQ,convopts___Rule]:=InstantaneousTransformation;


(* ::Input::Initialization:: *)
PropagatorCalculationProcedure[
{_?SuperoperatorQ,___Rule},convopts___Rule]:=InstantaneousTransformation;


(* ::Input::Initialization:: *)
PropagatorCalculationProcedure[_Repeat,convopts___Rule]:=RepeatPropagator;


(* ::Input::Initialization:: *)
PropagatorCalculationProcedure[_PrecalculatedEvent,convopts___Rule]:=UsePrecalculatedPropagator;


(* ::Input::Initialization:: *)
PropagatorCalculationProcedure[Event[Except[_Rule]..,evopts___Rule],convopts___Rule]:=PropagatorCalculationProcedure/.{evopts}/.Options[Event];


(* ::Input::Initialization:: *)
HoldPattern@Event[evstatus:{False,numst_},
evch:{timingch:{dur_,timeptch_,moretimingch__},{evbackg_,_,_},hilbch_,propcalcprocchar_,{All|True,True,False},morech___},
repev:Repeat[
evlist:EventList[evliststatus_,evlistchars_,events:{_Event..},evlistopts___Rule],
nrep_,
repevopts___Rule
],
evopts___Rule
]/;NumericQ[nrep]&&(nrep>=0):=
Module[{newevents,firstnewevent,laternewevents},(
(
If[Verbose/.{evopts}/.Options[Event],Print["implementing complete expansion of Repeat"]];
newevents=Flatten[Table[events,{nrep}],1];
Sequence@@If[nrep>0,
Join[
Drop[newevents,-1]/.
Event[evstatus$_,{{dur$_,moretch$___},backgch$_,hilbch$_,pcp$_,exprep$_,precalchk$_,morech$___},evspecs$_,evopts$___Rule]:>Event[{False,False},{Undefined,backgch$,Undefined,Undefined,{True,True,False},False,morech$},evspecs$,evopts$],
{Last[newevents]}/.
Event[evstatus$_,{{dur$_,moretch$___},backgch$_,hilbch$_,pcp$_,exprep$_,precalchk$_,morech$___},evspecs$_,evopts$___Rule]:>Event[{False,False},{Undefined,backgch$,Undefined,Undefined,{True,True,False},False,morech$},evspecs$,
SimplifyRules[
Switch[timeptch,
{_,Except[Undefined|Automatic]},InitialTimePoint->Last[timeptch],
{Except[Undefined|Automatic],_},FinalTimePoint->First[timeptch],
_,InitialTimePoint->Undefined
],
evopts$
]
]
],
{}
]
)
)];


(* ::Input::Initialization:: *)
HoldPattern@Event[evstatus:{False,numst_},
{timingch_,backgch_,hilbch_,pcpch_,{Automatic,True,False},morech___},
repevs:Repeat[
evlist:EventList[evliststatus_,evlistchars_,events:{_Event..},evlistopts___Rule],
nrep_,
repevopts___Rule
],
evopts___Rule
]/;(PermittedTimeShift[evlist]==None):=
Module[{},(
If[Verbose/.{evopts}/.Options[Event],Print["case of PermittedTimeShift \[Equal] None"]];
Event[evstatus,{timingch,backgch,hilbch,pcpch,{True,True,False},morech},repevs,evopts]
)];


(* ::Input::Initialization:: *)
HoldPattern@Event[evstatus:{False,numst_},
{timingch_,backgch_,hilbch_,pcpch_,{Automatic,True,False},morech___},
repevs:Repeat[
evlist:EventList[evliststatus_,evlistchars_,events:{_Event..},evlistopts___Rule],
nrep_,
repevopts___Rule
],
evopts___Rule
]/;(PermittedTimeShift[evlist]==All):=
Module[{},(
If[Verbose/.{evopts}/.Options[Event],Print["case of PermittedTimeShift \[Equal] All"]];
Event[evstatus,{timingch,backgch,hilbch,pcpch,{False,True,False},morech},repevs,evopts]
)];


(* ::Input::Initialization:: *)
HoldPattern@Event[evstatus:{False,numst_},
{timingch_,backgch_,hilbch_,pcpch_,{Automatic,True,False},morech___},
repevs:Repeat[
evlist:EventList[
evliststatus_,
evlistchars:{{T_,_,pts_,__},{__,True},___},
events:{_Event..},
evlistopts___Rule],
nrep_,
repevopts___Rule
],
evopts___Rule
]:=Module[{Nperiod,nperiod},(
If[Verbose/.{evopts}/.Options[Event],Print["implementing no repeat event expansion"]];
Event[evstatus,{timingch,backgch,hilbch,pcpch,{False,True,False},morech},repevs,evopts]
)/;(
Nperiod=T/pts;
nperiod=Round[Nperiod];
TrueQ[Chop@N[nperiod-Nperiod]==0]&&
nperiod>=1
)];


(* ::Input::Initialization:: *)
HoldPattern@Event[evstatus:{False,numst_},
{timingch:{dur_,timeptch_,moretimingch__},backgch_,hilbch_,pcpch_,{Automatic,True,False},morech___},
repevs:Repeat[
evlist:EventList[
evliststatus_,
evlistchars:{evlisttchars:{T_,_,pts_,__},evlistbckgch:{evbackg:Except[Undefined],_,True},moreevlistchars___},
events:{_Event..},
evlistopts___Rule],
nrep_,
repevopts___Rule
],
evopts___Rule
]:=Module[{nrepinperiod,nperiod,nrem,remevents,expandedevents},(
remevents=Flatten[Table[events,{nrem}],1];
expandedevents=Join[
If[nrem>0,
{First[remevents]/.
Event[evstatus$_,{tch$_,backgch$_,hilbch$_,pcp$_,exprep$_,precalchk$_,morech$___},evspecs$_,evopts$___Rule]:>
Event[{False,False},{Undefined,backgch$,Undefined,Undefined,{True,True,False},False,morech$},evspecs$,
SimplifyRules[
Switch[timeptch,
{Except[Undefined],_},FinalTimePoint->First[timeptch],
_,FinalTimePoint->Undefined
],
evopts$
]],
Sequence@@(
Drop[remevents,1]/.
Event[evstatus$_,{tch$_,backgch$_,hilbch$_,pcp$_,exprep$_,precalchk$_,morech$___},evspecs$_,evopts$___Rule]:>
Event[{False,False},{Undefined,backgch$,Undefined,Undefined,{True,True,False},False,morech$},evspecs$,
SimplifyRules[
Switch[{timeptch,nperiod},
{{_,Except[Undefined]},0},InitialTimePoint->Last[timeptch],
_,InitialTimePoint->Undefined
],
evopts$
]
]
)
},
{}
],
If[nperiod>0,
{Event[
{False,False},
{Undefined,backgch,Undefined,Undefined,{Automatic,True,True},morech},
Repeat[
EventList[{False,False},
{Undefined,evlistbckgch,moreevlistchars},
Flatten[Table[
events/.Event[evstatus$_,{tch$_,backgch$_,hilbch$_,pcp$_,exprep$_,precalchk$_,morech$___},evspecs$_,evopts$___Rule]:>
Event[{False,False},{Undefined,backgch$,Undefined,Undefined,{True,True,False},False,morech$},evspecs$,evopts$],
{nrepinperiod}],
1],
evlistopts
],
nperiod,
repevopts
],
SimplifyRules[
ReleaseHold@Switch[{nrem,timeptch},
{_,{_,Except[Undefined]}},InitialTimePoint->Last[timeptch],
{0,{Except[Undefined],_}},FinalTimePoint->First[timeptch],
_,Hold[FinalTimePoint->Undefined,InitialTimePoint->Undefined]
],
evopts
]
]},
{}
]
];
If[Verbose/.{evopts}/.Options[Event],Print["partial repeat event expansion: ",{nrepinperiod,nperiod,nrem}];
Print["leading to : ",expandedevents/.s_ShapeFunction:>s[[{4}]]]
];
Sequence@@expandedevents
)/;(
nrepinperiod=Numerator[pts/T];
nperiod=Floor[nrep/nrepinperiod];
nrem=nrep-nrepinperiod*nperiod;
IntegerQ[nrepinperiod]&&NumericQ[pts]&&NumericQ[T]
)];


(* ::Input::Initialization:: *)
HoldPattern@Event[evstatus:{False,numst_},
ch:{timingch_,backgch_,hilbch_,pcpch_,{Automatic,True,False},precalchk_,morech___},
repevs:Repeat[
evlist:EventList[
evliststatus_,
evlistchars:{evlisttchars:{T_,_,pts_,__},evlistbckgch:{evbackg:Except[Undefined],_,True},evlisthilbch_,_},
events:{_Event..},
evlistopts___Rule],
nrep_,
repevopts___Rule
],
evopts___Rule
]:=
Module[{nrepinperiod,nperiod,nrem},(
If[Verbose/.{evopts}/.Options[Event],Print["full repeat event expansion: ",{nrepinperiod,nperiod,nrem}]];
Event[evstatus,
{timingch,backgch,hilbch,pcpch,{All,True,False},False,morech},
repevs,evopts
])/;(
nrepinperiod=Numerator[pts/T];
nperiod=Floor[nrep/nrepinperiod];
nrem=nrep-nrepinperiod*nperiod;
!(IntegerQ[nrepinperiod]&&NumericQ[pts]&&NumericQ[T])
)
];


(* ::Input::Initialization:: *)
HoldPattern@Event[evstatus:{False,numst_},
{timingch_,backgch:{evbackg:Except[Undefined],_,_},hilbch_,propcalcprocchar_,{False,True,False},morech___},
repevs:Repeat[
evlist:EventList[evliststatus_,
{
evlisttimech:{T:Except[Undefined],_,pts:Except[Undefined],_},
moreevlistch__},
events:{_Event..},
evlistopts___Rule
],
nrep_Integer,
repevopts___Rule
],
evopts___Rule
]:=
(
If[Verbose/.{evopts}/.Options[Event],Print["forced no Repeat expansion"]];
Which[
(MatchQ[pts,All]||
TrueQ[Chop@N[(T/pts)-Round[T/pts]]==0]),
	Event[evstatus,{timingch,backgch,hilbch,propcalcprocchar,{False,True,True},morech},repevs,evopts],
MatchQ[pts,None],
	(Message[Event::notperiodicrepev];$Failed),
!TrueQ[Chop@N[(T/pts)-Round[T/pts]]==0],
	(Message[Event::incompptsrepev,T,pts];$Failed),
True,$Failed
]
);


(* ::Input::Initialization:: *)
Event[st:{False,_},{firstch:Repeated[_,{5}],Undefined|False,morech___},precalev_PrecalculatedEvent,opts___Rule]:=
Event[st,{firstch,{True,False,False,False},morech},precalev,opts];


(* ::Input::Initialization:: *)
Event[st:{False,_},{firstch:Repeated[_,{5}],Except[True|{True..}],morech___},evspec:Except[_PrecalculatedEvent],opts___Rule]:=
Event[st,{firstch,True,morech},evspec,opts];


(* ::Input::Initialization:: *)
Event[evstatus:{False,numst_},
{evtiming_,backgch:{evbackg:Except[Undefined],_,_},hilbch_,pcp_,exprep_,{True,False,False,False},evmorech___},
precalev_PrecalculatedEvent,
evopts___Rule
]:=
If[
GeneratorMatchQ[evbackg,BackgroundGenerator[precalev]],
	Event[evstatus,
	{evtiming,backgch,hilbch,pcp,exprep,{True,True,False,False},evmorech},
	precalev,evopts],
	(Message[PrecalculatedEvent::precalbackgconflict];$Failed)
];


(* ::Input::Initialization:: *)
Event[evstatus:{False,numst_},
{evtch:{_,_,_,evstandintv:Except[Undefined]},evbgch_,evhilbch_,evpcp_,evexprep_,{True,True,False,False},evmorech___},
precalev_PrecalculatedEvent,
evopts___Rule
]:=
If[
MatchQ[evstandintv,StandardizedInterval@precalev],
	Event[evstatus,
	{evtch,evbgch,evhilbch,evpcp,evexprep,{True,True,True,False},evmorech},
	precalev,evopts],
	(Message[PrecalculatedEvent::precaltimingconflict];$Failed)
];


(* ::Input::Initialization:: *)
Event[evstatus:{False,numst_},
{evtch_,evbgch_,evhilbch_,evpcp_,evexprep_,{True,True,True,False},evmorech___},
precalev:PrecalculatedEvent[
{precalevtch_,precalevbgch_,precalhilbch_,precalevexprep_,precalmorech___},
propagator_,precalevopts___Rule],
evopts___Rule
]:=
Event[evstatus,
{evtch,precalevbgch,precalhilbch,evpcp,precalevexprep,{True,True,True,True},evmorech},
precalev,
SimplifyRules[precalevopts,evopts,evopts]
];


(* ::Input::Initialization:: *)
Event[st_,{firstch:Repeated[_,{5}],{True..},morech___},evspec_,opts___Rule]:=
Event[st,{firstch,True,morech},evspec,opts];


(* ::Input::Initialization:: *)
Event[{False,_},chars_List,more___]/;Length[chars]!=CharacteristicsDimension[Event]:=
(Message[Event::badcharlen];$Failed);


(* ::Input::Initialization:: *)
Event::badtimepts="Unable to assign initial or final time points of an event.";


(* ::Input::Initialization:: *)
Event::tconflict="A timing conflict has been generated.";


(* ::Input::Initialization:: *)
Event::negdur="A negative event duration has been encountered.";


(* ::Input::Initialization:: *)
Event::backgconflict="A conflict in evolution backgrounds has been encountered.";


(* ::Input::Initialization:: *)
Event::repevbackgconflict="The evolution background in the Repeat object differs from that in the enclosing Event.";


(* ::Input::Initialization:: *)
Event::notperiodicrepev="The Repeat cannot be implemented without expansion, since the event itself or the BackgroundGenerator are not invariant to time-translation.";


(* ::Input::Initialization:: *)
Event::incompptsrepev="The Repeat cannot be implemented without expansion, since the duration `1` of the repeating event is incompatible with the allowed time-translation interval `2` of the event, taking into account the BackgroundGenerator.";


(* ::Input::Initialization:: *)
Event::badcharlen="The Event characteristics do not have the correct length.";


(* ::Input::Initialization:: *)
Options[EventList]=
{
InitialTimePoint->Automatic,
FinalTimePoint->Automatic,
BackgroundGenerator->Undefined,
ExpandRepeatedEvents->Automatic,
Verbose->False
};


(* ::Input::Initialization:: *)
EventList[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
EventList[events:Except[_Rule],opts___Rule]:=EventList[False,events,opts];


(* ::Input::Initialization:: *)
EventList[False,more:(Except[_Rule]...),opts___Rule]:=EventList[{False,False},more,opts];


(* ::Input::Initialization:: *)
CharacteristicsDimension[EventList]=4;


(* ::Input::Initialization:: *)
EventList[{False,False},events:Except[_Rule],opts___Rule]:=EventList[{False,False},Undefined,events,opts]


(* ::Input::Initialization:: *)
EventList[{False,False},Undefined,events:Except[_Rule],opts___Rule]:=
EventList[{False,False},Table[Undefined,{CharacteristicsDimension[EventList]}],events,opts];


(* ::Input::Initialization:: *)
EventList[status_,
{Undefined,charsb___},
events:Except[_Rule],opts___Rule]:=
EventList[status,
{{Undefined,Undefined,Undefined,Undefined},charsb},
events,opts];


(* ::Input::Initialization:: *)
EventList[status_,
{charsa_,Undefined,charsb___},
events:Except[_Rule],opts___Rule]:=
EventList[status,
{charsa,{Undefined,Undefined,Undefined},charsb},
events,opts]


(* ::Input::Initialization:: *)
EventList[status_,
{charsa:Repeated[_,{3}],Undefined,charsb___},
events:Except[_Rule],opts___Rule]:=
EventList[status,
{charsa,{Undefined, Undefined,Undefined},charsb},
events,opts]


(* ::Input::Initialization:: *)
EventList[{False,False},chars_List,more:(Except[_Rule]...),opts___Rule]/;FreeQ[{chars,more},Undefined]&&MatchQ[chars,{_,{__,True},_,{__,True},___}]:=EventList[{True,False},chars,more,Sequence@@FilterRules[{opts},Except[(BackgroundGenerator|ExpandRepeatedEvents)->_]
]
];


(* ::Input::Initialization:: *)
EventList[{True,False},chars_List,events_List,opts___Rule]/;
TrueQ[And@@(NumericalComputationReadyQ/@events)]:=
EventList[{True,True},chars,events,opts];


(* ::Input::Initialization:: *)
NumericalComputationReadyQ[EventList[{False,num_},more:(Except[_Rule]...),opts___Rule],___Rule]:=False;


(* ::Input::Initialization:: *)
NumericalComputationReadyQ[EventList[{True,num_},more:(Except[_Rule]...),opts___Rule],___Rule]:=num;


(* ::Input::Initialization:: *)
EventList[{False,False},chars_,arg:Except[_EventSpecifications|{(_Event|_EventList)..}],opts___Rule]:=
(If[Verbose/.{opts}/.Options[EventList],Print["applying EventList to raw argument: ",Expand[arg]/.s_ShapeFunction:>s[[{4}]]]];
EventList[{False,False},chars,
EventSpecifications[arg,
SimplifyRules[
Sequence@@Cases[{opts},Except[(InitialTimePoint|FinalTimePoint|BackgroundGenerator|Chronology)->_]
]
]],
opts
]);


(* ::Input::Initialization:: *)
EventList[{False,False},chars_,EventSpecifications[True,evspecs_List,evspecopts___Rule],opts___Rule]:=
(
EventList[{False,False},
chars,
Event[#,
SimplifyRules[
Sequence@@Cases[{evspecopts,opts},Except[(InitialTimePoint|FinalTimePoint|BackgroundGenerator|Chronology)->_]
]
]]&/@evspecs,
SimplifyRules[
Sequence@@Cases[{evspecopts,opts},Except[Chronology->_]
]
]
]);


(* ::Input::Initialization:: *)
EventList[evlistst_,evlistch:{evlisttch_,evlistbackgch:{backg_,backgimplreq_,backgimpl_},morech___},args:{___,_EventList,___},evlistopts___Rule]:=
Module[{eventlists},(
If[Verbose/.{evlistopts}/.Options[EventList],Print["absorbing EventList contained in another EventList (case of uniform implemented BackgroundGenerator): ",Expand[{backg,backgimplreq,backgimpl}/.s_ShapeFunction:>s[[{4}]]]]];
EventList[evlistst,{evlisttch,{backg,True,True},morech},
Replace[args,
EventList[_,_,evs:{_Event..},___]:>Sequence@@evs,
1
],
evlistopts
]
)/;(
eventlists=Cases[args,_EventList];
And@@(MatchQ[#,EventList[_,{_,{backg,_,True},__,True|{__,True}},___]]&/@eventlists)
)
];


(* ::Input::Initialization:: *)
EventList[evlistst_,evlistch_,{eventlist_EventList,___Rule},evlistopts___Rule]:=
(If[Verbose/.{evlistopts}/.Options[EventList],Print["absorbing a single EventList into another: ",Expand[{{evlistch,eventlist}}/.s_ShapeFunction:>s[[{4}]]]]];
eventlist
);


(* ::Input::Initialization:: *)
EventList[evlistst_,evlistch:{evlisttch_,evlistbackgch:{backg_,backgimplreq_,backgimpl_},morech___},args:{___,_EventList,___},evlistopts___Rule]:=
Module[{eventlists},(
If[Verbose/.{evlistopts}/.Options[EventList],Print["absorbing EventList contained in another EventList (case of non-implemented BackgroundGenerator): ", Expand[{backg,backgimplreq,backgimpl}/.s_ShapeFunction:>s[[{4}]]]]];
EventList[evlistst,{evlisttch,evlistbackgch,morech},
Replace[args,
EventList[_,_,evs:{_Event..},___]:>Sequence@@evs,
1
],
evlistopts
]
)/;(
eventlists=Cases[args,_EventList];
And@@(MatchQ[#,EventList[_,{_,{_,_,False|Undefined},__,True|{__,True}},___]]&/@eventlists)
)
];


(* ::Input::Initialization:: *)
EventList[status_,chars_,{},opts___Rule]:=EventList[status,chars,{None,0},opts];


(* ::Input::Initialization:: *)
EventList[{False,numst_},{{Undefined,moretimingch___},morech___},events_List,opts___Rule]:=
(EventList[{False,numst},{{Plus@@(EventDuration/@events),moretimingch},morech},events,opts]);


(* ::Input::Initialization:: *)
EventDuration[EventList[status_,{{dur_,moretimingch___},morech___},evspec_,opts___Rule]]:=dur;


(* ::Input::Initialization:: *)
EventList[{False,numst_},{{dur_,Undefined,moretimingch___},morech___},events:{_Event...},opts___Rule]:=
Module[{ta,tb,tavals,modevents},(
tavals=Most[FoldList[(#1+#2)&,ta,EventDuration/@Reverse@events]];
modevents=Reverse@MapThread[(#1/.Event[evspecs:(Except[_Rule]..),evspecopts___Rule]:>Event[evspecs,SimplifyRules[InitialTimePoint->#2,FinalTimePoint->Automatic,evspecopts]]
)&,
{Reverse@events,tavals}
];
EventList[{False,numst},{
{dur,{FinalTimePoint[First@modevents],ta},moretimingch},morech},
modevents,Sequence@@Cases[{opts},Except[(FinalTimePoint|InitialTimePoint)->_]]]
)/;(
{tb,ta}={FinalTimePoint,InitialTimePoint}/.{opts}/.Options[EventList];
MatchQ[{tb,ta},{Automatic|Undefined,Except[Automatic|Undefined]}]
)];


(* ::Input::Initialization:: *)
InitialTimePoint[EventList[status_,{{dur_,Undefined,moretimingch___},morech___},events_List,opts___Rule],___Rule]:=Undefined;


(* ::Input::Initialization:: *)
InitialTimePoint[EventList[status_,{{dur_,{tb_,ta_},moretimingch___},morech___},events_List,opts___Rule],___Rule]:=ta;


(* ::Input::Initialization:: *)
EventList[{False,numst_},{{dur_,Undefined,moretimingch___},morech___},events:{_Event...},opts___Rule]:=
Module[{ta,tb,tbvals,modevents},(
tbvals=Most[FoldList[(#1-#2)&,tb,EventDuration/@events]];
modevents=MapThread[(#1/.Event[evspecs:(Except[_Rule]..),evspecopts___Rule]:>Event[evspecs,SimplifyRules[FinalTimePoint->#2,InitialTimePoint->Automatic,evspecopts]]
)&,
{events,tbvals}
];
EventList[{False,numst},{
{dur,{tb,InitialTimePoint[Last@modevents]},moretimingch},morech},
modevents,Sequence@@Cases[{opts},Except[(FinalTimePoint|InitialTimePoint)->_]]]
)/;(
{tb,ta}={FinalTimePoint,InitialTimePoint}/.{opts}/.Options[EventList];
MatchQ[{tb,ta},{Except[Automatic|Undefined],Automatic|Undefined}]
)];


(* ::Input::Initialization:: *)
FinalTimePoint[EventList[status_,{{dur_,Undefined,moretimingch___},morech___},events_List,opts___Rule],___Rule]:=Undefined;


(* ::Input::Initialization:: *)
FinalTimePoint[EventList[status_,{{dur_,{tb_,ta_},moretimingch___},morech___},events_List,opts___Rule],___Rule]:=tb;


(* ::Input::Initialization:: *)
EventList[{False,numst_},{{dur_,{tb_,ta_},moretimingch___},morech___},events_,opts___Rule]:=
Module[{newtb,newta},(
Message[EventList::tconflict];$Failed
)/;(
{newtb,newta}={FinalTimePoint,InitialTimePoint}/.{opts}/.Options[EventList];
TrueQ[Chop[newtb-tb]!=0]||TrueQ[Chop[newta-ta]!=0]
)
];


(* ::Input::Initialization:: *)
EventList[{False,numst_},{{dur_,timepts_,Undefined,moretimingch___},backgch:{Except[Undefined],_,True},morech___},events_,opts___Rule]:=
Module[{pts},(
pts=PermittedTimeShift[Sequence@@events];
EventList[{False,numst},{{dur,timepts,pts,moretimingch},backgch,morech},events,opts]
)];


(* ::Input::Initialization:: *)
PermittedTimeShift[EventList[status_,{{dur_,timepts_,pts_,moretimingch___},morech___},events_,opts___Rule],___Rule]:=pts;


(* ::Input::Initialization:: *)
EventList[st:{False,numst_},ch:{{dur_,{tb_,ta_},pts:Except[Undefined],Undefined},morech___},events_,opts___Rule]:=
EventList[{False,numst},
{{dur,{tb,ta},pts,StandardizedInterval[{tb,ta},pts]},morech},
events,opts];


(* ::Input::Initialization:: *)
StandardizedInterval[EventList[status_,{{dur_,timepts_,pts_,standintv_,moretimingch___},morech___},events_,opts___Rule],___Rule]:=standintv;


(* ::Input::Initialization:: *)
EventList[st:{False,numst_},ch:{{dur_,{tb_,ta:Except[Undefined]},moretch___},morech___},events:{_Event..},opts___Rule]/;MemberQ[Join[InitialTimePoint/@events,FinalTimePoint/@events],Undefined]:=
Module[{newevlist},(
EventList[st,
{{dur,Undefined,moretch},morech},
events,
SimplifyRules[
InitialTimePoint->ta,
FinalTimePoint->Automatic,
opts
]
]
)];


(* ::Input::Initialization:: *)
EventList[st:{False,numst_},ch:{{dur_,{tb:Except[Undefined],ta_},moretch___},morech___},events:{_Event..},opts___Rule]/;MemberQ[Join[InitialTimePoint/@events,FinalTimePoint/@events],Undefined]:=
Module[{newevlist},(
EventList[st,
{{dur,Undefined,moretch},morech},
events,
SimplifyRules[
InitialTimePoint->Automatic,
FinalTimePoint->tb,
opts
]
]
)];


(* ::Input::Initialization:: *)
EventList[{False,numst_},{timingch_,{Undefined,_,_},morech___},events:{_Event...},opts___Rule]:=
Module[{evbackg},(
EventList[{False,numst},{timingch,{evbackg,False,False},morech},
events,
Sequence@@Cases[{opts},Except[BackgroundGenerator->_]]
]
)/;(
evbackg=BackgroundGenerator/.{opts}/.Options[EventList];
!MatchQ[evbackg,Undefined]
)]; 


(* ::Input::Initialization:: *)
EventList[{False,numst_},{timingch_,{evbackg:Except[Undefined],False|Undefined,_},hilb_,repevexpch:True|{__,True},morech___},
events:{_Event...},opts___Rule]:=
(
EventList[{False,numst},{timingch,{evbackg,True,False},hilb,repevexpch,morech},
events,
Sequence@@Cases[{opts},Except[BackgroundGenerator->_]]
]
);


(* ::Input::Initialization:: *)
EventList[st:{False,_},{timingch_,{backg:Except[Undefined],backgimplreq_,False},morech___},events:{_Event...},opts___Rule]:=
(
If[Verbose/.{opts}/.Options[EventList],Print["passing BackgroundGenerator down to events inside EventList: ",{{backg,backgimplreq,False},Expand@events}/.s_ShapeFunction:>s[[{4}]]]];
EventList[st,{timingch,{backg,backgimplreq,False},morech},
Replace[
events,
{Event[evst_,evch:{evtimingch_,evbackgch:Except[{__,True}],evmorech___},
evspecs_,evopts___Rule]:>Event[evst,{evtimingch,{backg,backgimplreq,False},evmorech},evspecs,evopts]},
1
],
opts]
)/;Or@@(
MatchQ[#,
HoldPattern@Event[evst_,evch:{_,{_,False|Undefined,_},___},___]
]&/@events);


(* ::Input::Initialization:: *)
EventList[{False,numst_},{timingch_,{evlistbackg:Undefined,_,_},morech___},events:{_Event...},opts___Rule]:=
Module[{backgs},(
If[
(GeneratorMatchQ@@backgs),
EventList[{False,numst},{timingch,{First@backgs,False,False},morech},
events,opts
],
(Message[EventList::backgmismatch];$Failed)
]
)/;(
backgs=BackgroundGenerator/@events;
Or@@(!MatchQ[#,Undefined]&/@backgs)
)];


(* ::Input::Initialization:: *)
EventList[{False,numst_},{timingch_,{evlistbackg:Except[Undefined],_,False|Undefined},morech___},events:{_Event...},opts___Rule]:=
Module[{evbackgs},(
EventList[{False,numst},{timingch,{evlistbackg,True,True},morech},
events,opts
]
)/;(
evbackgs=BackgroundGenerator/@events;
FreeQ[evbackgs,Undefined]&&
GeneratorMatchQ@@Join[evbackgs,{evlistbackg}]
)
];


(* ::Input::Initialization:: *)
BackgroundGenerator[EventList[status_,{timingch_,{backg_,__},morech___},events_,opts___Rule],___]:=backg;


(* ::Input::Initialization:: *)
BackgroundGeneratorImplemented[EventList[status_,{timingch_,{backg_,requbackgimp_,backgimp_},morech___},events_,opts___Rule],___]:=TrueQ[backgimp];


(* ::Input::Initialization:: *)
EventList[{False,numst_},{timingch_,backgch:{backg_,backgimpreq_,backgimp_},Undefined,morech___},events_List,opts___Rule]/;MatchQ[{backg,backgimp},{Except[Undefined],True}]:=
Module[{hilbcomp},(
hilbcomp=Switch[HilbertSpaceCompatibility/@events,
{True..},True,
{False..},False,
{(True|False)..},MixedHilbertSpaceCompatibility,
_,$Failed
];
EventList[{False,numst},
{timingch,backgch,hilbcomp,morech},
events,opts]
)];


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[EventList[status_,{timingch_,backgch_,hilbcompat_,morech___},events_,opts___Rule],___]:=hilbcompat;


(* ::Input::Initialization:: *)
EventList[{False,numst_},{chars:Repeated[_,{3}],Undefined|{Undefined,morerepevch__},morech___},events:{_Event...},opts___Rule]:=
(
EventList[{False,numst},{chars,{ExpandRepeatedEvents/.{opts}/.Options[EventList],False,False},morech},events,opts]
);


(* ::Input::Initialization:: *)
ExpandRepeatedEvents[
EventList[{False,numst_},{chars:Repeated[_,{3}],Undefined|{Undefined..},morech___},events:{_Event...},opts___Rule],
exprepevopts___Rule
]:=
EventList[{False,numst},
{chars,
{ExpandRepeatedEvents/.{exprepevopts,opts}/.Options[EventList],True,False},morech},
events,
Sequence@@FilterRules[{opts},Except[ExpandRepeatedEvents]]
];


(* ::Input::Initialization:: *)
ExpandRepeatedEvents[
EventList[{False,numst_},{chars:Repeated[_,{3}],{expreptype_,_,False},morech___},events:{_Event...},opts___Rule],
exprepevopts___Rule
]:=
EventList[{False,numst},
{chars,
{ExpandRepeatedEvents/.{exprepevopts,opts,ExpandRepeatedEvents->expreptype}/.Options[EventList],True,False},morech},
events,
Sequence@@FilterRules[{opts},Except[ExpandRepeatedEvents]]
];


(* ::Input::Initialization:: *)
ExpandRepeatedEvents[
evlist:EventList[{False,numst_},{chars:Repeated[_,{3}],True,morech___},events:{_Event...},opts___Rule],
exprepevopts___Rule
]:=evlist;


(* ::Input::Initialization:: *)
EventList[st:{False,numst_},{chars:Repeated[_,{3}],{expreptype:Except[Undefined],False,_},morech___},events:{_Event...},opts___Rule]:=
(
EventList[st,{chars,{expreptype,True,False},morech},events,opts]
);


(* ::Input::Initialization:: *)
EventList[{False,numst_},{cha:Repeated[_,{3}],{expreptype:Except[Undefined],True,False},morech___},events:{_Event...},opts___Rule]:=
(
EventList[{False,numst},{cha,{True,True},morech},
ExpandRepeatedEvents[#,
SimplifyRules[opts,ExpandRepeatedEvents->expreptype]
]&/@events,
opts
]); 


(* ::Input::Initialization:: *)
EventList[{False,numst_},{cha:Repeated[_,{3}],{expreptype_,True,False},morech___},events:{_Event...},opts___Rule]/;And@@(MatchQ[#,
Event[_,{Repeated[_,{4}],True|{_,True,True},___},_,___Rule]]&/@events):=EventList[{False,numst},{cha,{expreptype,True,True},morech},events,opts];


(* ::Input::Initialization:: *)
EventList[{False,_},chars_List,more___]/;Length[chars]!=CharacteristicsDimension[EventList]:=
(Message[EventList::badcharlen];$Failed);


(* ::Input::Initialization:: *)
EventList::badtimepts="Unable to assign initial or final time points of an event list.";


(* ::Input::Initialization:: *)
EventList::tconflict="A timing conflict has been generated.";


(* ::Input::Initialization:: *)
EventList::backgmismatch="An EventList contains events with different values for BackgroundGenerator.";


(* ::Input::Initialization:: *)
EventList::cantabsorb="A mismatch has arisen when trying to absorb an EventList by a containing EventList.";


(* ::Input::Initialization:: *)
EventList::badcharlen="The EventList characteristics do not have the correct length.";


(* ::Input::Initialization:: *)
RepeatEvent[args___]:=(Message[RepeatEvent::usage];$Failed);


(* ::Input::Initialization:: *)
Options[Repeat]=
{Chronology:>$Chronology,
ExpandRepeatedEvents->Automatic,
Expand->False
};


(* ::Input::Initialization:: *)
Format[HoldPattern@Repeat[evspecs_,n_,repopts___Rule]/;!(Expand/.{repopts}/.Options[Repeat])]:=
RowBox[{
"Repeat[<<..>>,"<>ToString[n]<>"]"
}]//DisplayForm;


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Expand,Infinity,
Expand[a_]/;!FreeQ[a,_Repeat]:=a/.{repev_Repeat:>Expand[repev]}
];


(* ::Input::Initialization:: *)
Repeat/:Expand[HoldPattern@Repeat[args___,opts___Rule]]:=Repeat[args,Evaluate@SimplifyRules[Expand->True,opts]];


(* ::Input::Initialization:: *)
Repeat/:ExpandAll[HoldPattern@Repeat[args___,opts___Rule]]:=Repeat[args,Evaluate@SimplifyRules[Expand->True,opts]];


(* ::Input::Initialization:: *)
Repeat[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
Repeat[evspecs_,repopts___Rule]:=Repeat[evspecs,Automatic,repopts];


(* ::Input::Initialization:: *)
Repeat[evspecs_,n_,repopts___Rule]/;TrueQ[n<0]:=
(Message[Repeat::negn];$Failed);


(* ::Input::Initialization:: *)
Repeat[evspecs_,n_,repopts___Rule]/;TrueQ[!Element[n,Integers]]:=
(Message[Repeat::nonintegn];$Failed);


(* ::Input::Initialization:: *)
Repeat[evspecs_,n_,repopts___Rule]/;TrueQ[!Element[n,Integers]]:=
(Message[Repeat::nonintegn];$Failed);


(* ::Input::Initialization:: *)
Repeat[evspecs:EventSpecificationPattern,1,repopts___Rule]:=Event[evspecs,repopts];


(* ::Input::Initialization:: *)
Repeat[evspecs:{EventSpecificationPattern...},1,repopts___Rule]:=Event[#,repopts]&/@evspecs;


(* ::Input::Initialization:: *)
Repeat[evspecs_,0,repopts___Rule]:=Event[{None,0},repopts];


(* ::Input::Initialization:: *)
Repeat[evspecs:Except[_EventList],n:Except[Automatic],repopts___Rule]:=
Repeat[
EventList[evspecs,repopts],
n,
repopts
];


(* ::Input::Initialization:: *)
HoldPattern@EventDuration[Repeat[evlist_EventList,nrep_,repevopts___Rule],opts___Rule]:=
nrep*EventDuration[evlist,opts];


(* ::Input::Initialization:: *)
HoldPattern@PermittedTimeShift[Repeat[evlist_EventList,nrep_,repevopts___Rule],ptsopts___Rule]:=
PermittedTimeShift[evlist];


(* ::Input::Initialization:: *)
HoldPattern@BackgroundGenerator[Repeat[evlist_EventList,nrep_,repevopts___Rule],opts___Rule]:=
BackgroundGenerator[evlist];


(* ::Input::Initialization:: *)
Repeat::negn="The repeat number cannot be negative.";


(* ::Input::Initialization:: *)
Repeat::nonintegn="The repeat number must be an integer.";


(* ::Input::Initialization:: *)
Repeat::experr="Error in expanding Repeat object.";


(* ::Input::Initialization:: *)
Repeat::badargs="Inappropriate arguments for Repeat.";


(* ::Input::Initialization:: *)
Options[PrecalculatedEvent]={Expand->False};


(* ::Input::Initialization:: *)
Format[precalev:PrecalculatedEvent[Except[_Rule]..,precalopts___Rule]/;!(Expand/.{precalopts}/.Options[PrecalculatedEvent])]:=
RowBox[{"PrecalculatedEvent[",ToBoxes[{InitialTimePoint[precalev],FinalTimePoint[precalev]}],
", <<..>>]"
}]//DisplayForm;


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[Expand,Infinity,
Expand[a_]/;!FreeQ[a,_PrecalculatedEvent]:=a/.{precalev_PrecalculatedEvent:>Expand[precalev]}
];


(* ::Input::Initialization:: *)
(*UserLevelDependentDefinition[Expand,Infinity,Expand[HoldPattern@PrecalculatedEvent[args:(Except[_Rule]..),opts___Rule]]:=PrecalculatedEvent[args,Evaluate@SimplifyRules[Expand\[Rule]True,opts]]
]*)


(* ::Input::Initialization:: *)
(*UserLevelDependentDefinition[ExpandAll,Infinity,ExpandAll[HoldPattern@PrecalculatedEvent[args:(Except[_Rule]..),opts___Rule]]:=PrecalculatedEvent[args,Evaluate@SimplifyRules[Expand\[Rule]True,opts]]
];*)


(* ::Input::Initialization:: *)
PrecalculatedEvent[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
EventDuration[PrecalculatedEvent[{{dur_,___},___},___],___Rule]:=dur;


(* ::Input::Initialization:: *)
InitialTimePoint[PrecalculatedEvent[{{_,{_,ta_},___},___},___],___Rule]:=ta;


(* ::Input::Initialization:: *)
FinalTimePoint[PrecalculatedEvent[{{_,{tb_,_},___},___},___],___Rule]:=tb;


(* ::Input::Initialization:: *)
PermittedTimeShift[PrecalculatedEvent[{{_,_,pts_,___},___},___],___Rule]:=pts;


(* ::Input::Initialization:: *)
StandardizedInterval[PrecalculatedEvent[{{_,_,_,stdintv_,___},___},___],___Rule]:=stdintv;


(* ::Input::Initialization:: *)
BackgroundGenerator[PrecalculatedEvent[{tch_,{backg_,__},___},___],___Rule]:=backg;


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility[PrecalculatedEvent[{tch_,backgch_,hilbch_,___},___],___Rule]:=hilbch;


(* ::Input::Initialization:: *)
PrecalculatedEvent::precalbackgconflict="A PrecalculatedEvent may only be deployed with the same BackgroundGenerator as when it was generated.";


(* ::Input::Initialization:: *)
PrecalculatedEvent::precaltimingconflict="The timing of the PrecalculatedEvent is incompatible with its current use.";


(* ::Input::Initialization:: *)
Options[UnassignedSymbols]={PermittedSymbols->{}};


(* ::Input::Initialization:: *)
UnassignedSymbols[x:Except[_List],more___,opts___Rule]:=UnassignedSymbols[{x},more,opts];


(* ::Input::Initialization:: *)
UnassignedSymbols[arg_,permittedsymbols_List,opts___Rule]:=
Module[{symbols1,suspectsymbols1,suspectsymbols2},(
symbols1=Union@Cases[Cases[ReleaseHold[arg/.{sa_SparseArray:>Normal[sa]}],_Symbol,Infinity],_Symbol];
(* the curious syntax above ensures that held symbols which have set numerical arguments are not selected *)
suspectsymbols1=Select[symbols1,MatchQ[Context[#],"Global`"]&];
suspectsymbols2=Select[
FixedPoint[Head,#]&/@Union@Cases[
ReleaseHold[arg/.{sa_SparseArray:>Normal[sa]}],
_?(!MatchQ[Head[#],Symbol|Integer|Real|String]&),
Infinity
],
MatchQ[Context@#,"Global`"]&
];
Union@Select[Flatten[{suspectsymbols1,suspectsymbols2}],!MemberQ[permittedsymbols,#]&]
)]


(* ::Input::Initialization:: *)
UnassignedSymbols[arg_,opts___Rule]:=
Module[{permsymb},(
UnassignedSymbols[arg,
SimplifyRules[
PermittedSymbols->{permsymb},
opts
]
]
)/;(
permsymb=PermittedSymbols/.{opts}/.Options[UnassignedSymbols];
!MatchQ[permsymb,_List]
)];


(* ::Input::Initialization:: *)
UnassignedSymbols[arg_,opts___Rule]:=
Module[{permsymb},(
UnassignedSymbols[
arg,
Join[LocalGeneratorSymbols[arg],permsymb]
]/;(
permsymb=PermittedSymbols/.{opts}/.Options[UnassignedSymbols];
MatchQ[permsymb,_List]
)
)];


(* ::Input::Initialization:: *)
ReportSuspectSymbols[args_,opts___Rule]:=
Module[{suspsymbols},(
suspsymbols=UnassignedSymbols[args];
Switch[
suspsymbols,
{},Message[ReportSuspectSymbols::nosuspsymbol],
{_},Message[ReportSuspectSymbols::suspsymbol,First@suspsymbols],
{__},Message[ReportSuspectSymbols::suspsymbols,suspsymbols],
_,Null];
)];


ReportSuspectSymbols::nosuspsymbol="A non-numeric symbol has not been detected.";


ReportSuspectSymbols::suspsymbol="The following symbol does not have a numerical value: `1`";


ReportSuspectSymbols::suspsymbols="The following symbols do not have a numerical value: `1`";


(* ::Input::Initialization:: *)
Options[EventDuration]={Check->True};


(* ::Input::Initialization:: *)
EventDuration[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
EventDuration[ev:Except[_Event|_EventList|_EventSpecifications|_?StandardizedEventSpecificationQ],opts___Rule]:=EventDuration[EventSpecifications[ev],opts];


(* ::Input::Initialization:: *)
EventDuration[
EventSpecifications[status_,eventspecs_List,___Rule],
opts___Rule]:=
Plus@@(
EventDuration[#,
Sequence@@If[MatchQ[status,True|{True,__}],
SimplifyRules[{Check->False,opts}],
{opts}
]
]&/@eventspecs
);


(* ::Input::Initialization:: *)
EventDuration[{ev_?StandardizedEventSpecificationQ,___Rule},opts___Rule]:=EventDuration[ev,opts];


(* ::Input::Initialization:: *)
EventDuration[{_?SuperoperatorQ,___Rule},opts___Rule]=0;


(* ::Input::Initialization:: *)
EventDuration[{_?ValidGeneratorQ,\[Tau]:DurationPattern,___Rule},opts___Rule]:=\[Tau];


(* ::Input::Initialization:: *)
EventDuration[{_?ValidGeneratorQ,{tb:TimePointPattern,ta:TimePointPattern},___Rule},opts___Rule]:=Abs[tb-ta];


(* ::Input::Initialization:: *)
EventDuration[{Repeat[events_,nrep:RepeatNumberPattern,___Rule],___Rule},opts___Rule]:=EventDuration[events]*nrep;


(* ::Input::Initialization:: *)
EventDuration[{PrecalculatedEvent[{{T_,___},___},___],___Rule},opts___Rule]:=T;


(* ::Input::Initialization:: *)
HoldPattern@EventDuration[
EventList[
status_,{{dur_,moretiming__},___},more__,
evlistopts___Rule],
opts___Rule
]:=dur;


(* ::Input::Initialization:: *)
HoldPattern@EventDuration[
Event[
status_,{{dur_,moretiming__},___},more__,
evopts___Rule],
opts___Rule
]:=dur;


(* ::Input::Initialization:: *)
HoldPattern@EventDuration[events:{_Event..},opts___Rule]:=Plus@@(EventDuration[Evaluate[#],opts]&/@events);


(* ::Input::Initialization:: *)
If[$VersionNumber<11,
Duration[args___]:=(Message[Duration::usage];$Failed)
];


(* ::Input::Initialization:: *)
Options[PermittedTimeShift]={BackgroundGenerator->None};


(* ::Input::Initialization:: *)
PermittedTimeShift[evgen:(_?SuperoperatorQ|{_?SuperoperatorQ,___opts}),opts__Rule]:=PermittedTimeShift[evgen];


(* ::Input::Initialization:: *)
PermittedTimeShift[evgen_?ValidGeneratorQ,opts__Rule]:=PermittedTimeShift[evgen,BackgroundGenerator/.{opts}/.Options[PermittedTimeShift]];


(* ::Input::Initialization:: *)
PermittedTimeShift[evspec_?StandardizedEventSpecificationQ,opts__Rule]:=PermittedTimeShift[evspec,BackgroundGenerator/.{opts}/.Options[PermittedTimeShift]];


(* ::Input::Initialization:: *)
PermittedTimeShift[None]=All;


(* ::Input::Initialization:: *)
PermittedTimeShift[0]=All;


(* ::Input::Initialization:: *)
PermittedTimeShift[op_?OperatorQ]=All;


(* ::Input::Initialization:: *)
PermittedTimeShift[sop_?SuperoperatorQ]=All;


(* ::Input::Initialization:: *)
PermittedTimeShift[{sop_?SuperoperatorQ,evspecopts___Rule}]=All;


(* ::Input::Initialization:: *)
PermittedTimeShift[{evgen:(None|_?OperatorQ|_?SuperoperatorQ),timing___,evspecopts___Rule}]=All;


(* ::Input::Initialization:: *)
PermittedTimeShift[{evgen:ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,func_],timing___,evspecopts___Rule}]:=T;


(* ::Input::Initialization:: *)
PermittedTimeShift[{_PrecalculatedPropagator,timing___,evspecopts___Rule}]=None;


(* ::Input::Initialization:: *)
PermittedTimeShift[ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,func_]]:=T;


(* ::Input::Initialization:: *)
PermittedTimeShift[evgen:(_Function|_PeriodicFunction)]:=PermittedTimeShift[StandardizeGenerator[evgen,ImplementMatrixRepresentation->False]];


(* ::Input::Initialization:: *)
PermittedTimeShift[{evgen:(_Function|_PeriodicFunction),timing___,evspecopts___Rule}]:=PermittedTimeShift[StandardizeGenerator[evgen,ImplementMatrixRepresentation->False]];


(* ::Input::Initialization:: *)
HoldPattern@PermittedTimeShift[
Repeat[evlist_EventList,nrep_,repopts___Rule],
opts___Rule
]:=PermittedTimeShift[evlist,SimplifyRules[repopts,opts]];


(* ::Input::Initialization:: *)
PermittedTimeShift[
PrecalculatedEvent[{{_,_,pts_,_},___},___],
opts___Rule
]:=pts;


(* ::Input::Initialization:: *)
PermittedTimeShift[HoldPattern@EventSpecifications[status_,evspecs_List,evspecsopts___Rule],opts___Rule]:=
PermittedTimeShift[Sequence@@evspecs,opts];


(* ::Input::Initialization:: *)
PermittedTimeShift[
Event[status_,{{dur_,_,pts:Except[Undefined],___},___},{evbackg_,_,True},evopts___Rule],opts___Rule
]:=pts;


(* ::Input::Initialization:: *)
PermittedTimeShift[
Event[status_,{{dur_,_,pts_,___},___},{evbackg:Except[Undefined],_,False},evopts___Rule],opts___Rule
]:=PermittedTimeShift[pts,PermittedTimeShift[evbackg]];


(* ::Input::Initialization:: *)
PermittedTimeShift[
Event[status_,{{dur_,_,pts_,___},___},Undefined|{Undefined,___},evopts___Rule],opts___Rule
]:=PermittedTimeShift[pts,opts];


(* ::Input::Initialization:: *)
PermittedTimeShift[evlist:{_Event..},opts___Rule]:=
CommonPeriod@@(PermittedTimeShift[#,opts]&/@evlist);


(* ::Input::Initialization:: *)
PermittedTimeShift[
HoldPattern@EventList[events:{_Event...},timing_,evlistopts___Rule],
opts___Rule
]:=PermittedTimeShift[Sequence@@events,evlistopts,opts];


(* ::Input::Initialization:: *)
PermittedTimeShift[evgen1_,evgen2:Except[_Rule],opts___Rule]:=
Module[{pts1,pts2},(
pts1=PermittedTimeShift[evgen1,opts];
pts2=PermittedTimeShift[evgen2,opts];
If[
MatchQ[pts1,All|None|DurationPattern&&MatchQ[pts2,All|None|DurationPattern]],
CommonPeriod[pts1,pts2],
None
]
)];


(* ::Input::Initialization:: *)
PermittedTimeShift[evgen1_,evgen2_,evgens3:Except[_Rule]..,opts___Rule]:=
CommonPeriod[
PermittedTimeShift[evgen1,evgen2,opts],
PermittedTimeShift[evgens3,opts]
];


(* ::Input::Initialization:: *)
EventTimeIntervals[{}]={0,0};


(* ::Input::Initialization:: *)
EventTimeIntervals[EventList[st_,ch_,events:{_Event..},___]]:=EventTimeIntervals[events];


(* ::Input::Initialization:: *)
EventTimeIntervals[events:{_Event...}]:=Join@@(EventTimeIntervals/@events);


(* ::Input::Initialization:: *)
EventTimeIntervals[Event[st_,{{_,{tb_,ta_},__},__},___]]:={{tb,ta}};


(* ::Input::Initialization:: *)
EventTimeIntervals[Event[st_,{{_,Undefined,__},__},___]]:=Undefined;


(* ::Input::Initialization:: *)
TotalEventTimeInterval[events:Except[_EventList|{_Event..}|_Event],opts___Rule]:=
TotalEventTimeInterval[EventList[events,ExpandRepeatedEvents->False,ImplementBackgroundGenerator->False,opts],opts];


(* ::Input::Initialization:: *)
TotalEventTimeInterval[EventList[st_,{{_,{tb_,ta_},__},__},___],opts___Rule]:={tb,ta};


(* ::Input::Initialization:: *)
TotalEventTimeInterval[EventList[st_,{{_,Undefined,__},__},___],opts___Rule]:=Undefined;


(* ::Input::Initialization:: *)
TotalEventTimeInterval[Event[st_,{{_,{tb_,ta_},__},__},___],opts___Rule]:={tb,ta};


(* ::Input::Initialization:: *)
TotalEventTimeInterval[Event[st_,{{_,Undefined,__},__},___],opts___Rule]:=Undefined;


(* ::Input::Initialization:: *)
StandardizeInterval[{tb_,ta_},None]:={tb,ta};


(* ::Input::Initialization:: *)
StandardizeInterval[{tb_,ta_},All]:={0,ta-tb};


(* ::Input::Initialization:: *)
StandardizeInterval[{tb_,ta_},T_?NumericQ]/;(Chop[T]!=0):=
Module[{\[CapitalDelta]},(\[CapitalDelta]=T*Floor[tb/T];{tb-\[CapitalDelta],ta-\[CapitalDelta]})];


(* ::Input::Initialization:: *)
StandardizeInterval[{tb_,ta_},T_?NumericQ]/;(Chop[T]==0):=StandardizeInterval[{tb,ta},All];


(* ::Input::Initialization:: *)
StandardizeInterval[{tb_,ta_},T:DurationPattern]:=
Module[{\[CapitalDelta]},(\[CapitalDelta]=T*Floor[tb/T];{tb-\[CapitalDelta],ta-\[CapitalDelta]})];


(* ::Input::Initialization:: *)
StandardizeInterval[{tb_,ta_},_]:={tb,ta};


(* ::Input::Initialization:: *)
StandardizeInterval[ev:Event[st_,{{_,{tb_,ta_},pts_,{tbs_,tas_},___},__},___]]:=ev;


(* ::Input::Initialization:: *)
StandardizeInterval[ev:Event[st_,{{_,{tb_,ta_},pts:Except[Undefined],Undefined,___},__},___]]:=StandardizeInterval[{tb,ta},pts];


(* ::Input::Initialization:: *)
StandardizeInterval[ev:Event[st_,{{_,_,Undefined,___},__},___]]:=(Message[StandardizeInterval::undefptshft];$Failed);


(* ::Input::Initialization:: *)
StandardizeInterval::undefptshft="cannot standardize interval if PermittedTimeShift is Undefined";


(* ::Input::Initialization:: *)
HoldPattern@EventStartTimePoint[events_]:=Last@Flatten@EventTimeIntervals[events];


(* ::Input::Initialization:: *)
HoldPattern@EventEndTimePoint[events_]:=First@Flatten@EventTimeIntervals[events];


(* ::Input::Initialization:: *)
EvolutionBackground:=(Message[EvolutionBackground::usage];BackgroundGenerator);


(* ::Input::Initialization:: *)
End[];
EndPackage[];



