(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["General`General3D`",
{"Global`",
"SpinDynamica`",
"General`UserLevel`",
(*"General`ModifyBuiltIn`",*)
"General`Miscellaneous`"
}];


(* ::Input::Initialization:: *)
Origin::"usage"="point {0,0,0}";


(* ::Input::Initialization:: *)
ex::"usage"="unit vector {1,0,0}";


(* ::Input::Initialization:: *)
ey::"usage"="unit vector {0,1,0}";


(* ::Input::Initialization:: *)
ez::"usage"="unit vector {0,0,1}";


(* ::Input::Initialization:: *)
AxisSystem::"usage"="AxisSystem[vz] generates a normalized right-handed axis system with three orthogonal axes, the last one parallel to vz. The first axis is in (ex,vz) plane.   
AxisSystem[vx,vz] generates a normalized right-handed axis system with first axis in {vx,vz} plane and third axis parallel to vz.   
AxisSystem[vx,vy,vz] generates a normalized right-handed axis system if the input vectors are already orthogonal. 
AxisSystem[] defaults to {ex,ey,ez}.
AxisSystem[{vx,vy,vz}] has the same meaning as AxisSystem[vx,vy,vz]";


(* ::Input::Initialization:: *)
PolarToVector::"usage"="  PolarToVector[r,{th,ph}] generates a vector from the origin with radius r and polar angles {th,ph}. ";


(* ::Input::Initialization:: *)
VectorToPolar::"usage"="  VectorToPolar[vec] derives the radius and polar angles of the tip of a vector with respect to the origin, presented in the form {r,{th,ph}}. ";


(* ::Input::Initialization:: *)
SolidAngle::"usage"="SolidAngle[{v1,v2,v3}] determines the solid angle subtended at the centre of the unit sphere by the triangle with vertices {v1,v2,v3}.\n SolidAngle[{v1,v2,v3,v4}] sums the solid angles of the triangles {v1,v2,v3} and {v1,v4,v3}";


(* ::Input::Initialization:: *)
SubtendedAngle::"usage"="SubtendedAngle[v1,v2,v3,v4] determines the angle subtended by the v1-v2 and v3-v4 vectors. SubtendedAngle[v1,v2,v3] determines the angle subtended by the v1-v2 and v2-v3 vectors. \n
    SubtendedAngle[v1,v2] determines the angle subtended by the 0-v1 and 0-v2 vectors.";


(* ::Input::Initialization:: *)
BondAngle::"usage"="BondAngle[v1,v2,v3] determines the angle subtended by the v1-v2 and v2-v3 vectors.";


(* ::Input::Initialization:: *)
TorsionAngle::"usage"="TorsionAngle[v1,v2,v3,v4] determines the torsion angle v1-v2-v3-v4. The convention is chosen that if the far bond has to be rotated anticlockwise so as to eclipse the near bond, then the torsion angle is positive";


(* ::Input::Initialization:: *)
Distance::"usage"="Distance[v1,v2] determines the distance between two points";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
ex={1,0,0};ey={0,1,0};ez={0,0,1};


(* ::Input::Initialization:: *)
Origin={0,0,0};


(* ::Input::Initialization:: *)
SubtendedAngle[v1_,v2_,v3_,v4_]:=Module[{vec1,vec2},
vec1=Normalize[v1-v2];
vec2=Normalize[v4-v3];
ArcCos[vec1.vec2]
]


(* ::Input::Initialization:: *)
SubtendedAngle[v1_,v2_,v3_]:=SubtendedAngle[v1,v2,v2,v3]


(* ::Input::Initialization:: *)
SubtendedAngle[v1_,v2_]:=SubtendedAngle[v1,Origin,Origin,v2]


(* ::Input::Initialization:: *)
BondAngle[v1_,v2_,v3_]:=SubtendedAngle[v1,v2,v3];


(* ::Input::Initialization:: *)
TorsionAngle[v1_,v2_,v3_,v4_]:=Module[{n123,n234},n123=Normalize[(v2-v1)\[Cross](v2-v3)];n234=Normalize[(v3-v2)\[Cross](v3-v4)];N[ArcTan[n123.n234,n123\[Cross]n234.Normalize[v3-v2]]]]


(* ::Input::Initialization:: *)
Distance[v1_,v2_]:=Norm[v1-v2];


(* ::Input::Initialization:: *)
AxisSystem[axes_?MatrixQ]:=AxisSystem@@axes;


(* ::Input::Initialization:: *)
AxisSystem[]:=AxisSystem[ez];


(* ::Input::Initialization:: *)
AxisSystem[vz_List]:=AxisSystem[ez]/;vz==Origin


(* ::Input::Initialization:: *)
AxisSystem[vx_List,vz_List]:=AxisSystem[vz]/;vx==Origin


(* ::Input::Initialization:: *)
AxisSystem[vz_List]:=
Module[{vzN},(
vzN=Simplify@PowerExpand@ComplexExpand@Normalize[vz];
Which[
TrueQ[vzN==ex],AxisSystem[-ez,vzN],
TrueQ[vzN==-ex],AxisSystem[ez,vzN],
True,AxisSystem[ex,vzN]
]
)];


(* ::Input::Initialization:: *)
AxisSystem[vx_List,vz_List]:=
Module[{vxN,vyN,vzN},(
{vxN,vzN}=Simplify@PowerExpand@ComplexExpand[Normalize/@{vx,vz}];
		If[TrueQ[vxN==vzN||vxN==-vzN],AxisSystem[vzN],(vyN=Simplify@PowerExpand@ComplexExpand@Normalize[vzN\[Cross]vxN];vxN=Simplify@PowerExpand@ComplexExpand@Normalize[vyN\[Cross]vzN]);{vxN,vyN,vzN}]
)];


(* ::Input::Initialization:: *)
AxisSystem[vx_List,vy_List,vz_List]:=Module[{vxN,vyN,vzN},({vxN,vyN,vzN}=Simplify@PowerExpand@ComplexExpand[Normalize/@{vx,vy,vz}];
		If[TrueQ[Simplify@Chop@N[vzN-vxN\[Cross]vyN]=={0,0,0}],{vxN,vyN,vzN},Message[AxisSystem::"notRHOrthog"]
		]
)];


(* ::Input::Initialization:: *)
AxisSystem::"notRHOrthog"="input vectors are not proved to be a right-handed orthogonal set";


(* ::Input::Initialization:: *)
AxisSystem::"failed"="cannot construct orthonormal axes";


(* ::Input::Initialization:: *)
PolarToVector[r_,{th_,ph_}]:=N[r {Sin[th] Cos[ph],Sin[th] Sin[ph],Cos[th]}];


(* ::Input::Initialization:: *)
VectorToPolar[vec:{x_?NumericQ,y_?NumericQ,z_?NumericQ}]:=Module[{r,v,th,ph},r=Norm[vec];v=Normalize[vec];th=ArcCos[v[[3]]];ph=If[Chop[N[Abs[v[[3]]]-1]]==0,0,ArcTan[v[[1]],v[[2]]]];{r,{th,ph}}];


(* ::Input::Initialization:: *)
SolidAngle[{v1_,v2_,v3_}]:=0/;v1==v2||v2==v3||v3==v1;


(* ::Input::Initialization:: *)
SolidAngle[{v1_,v2_,v3_}]:=Module[{a,b,c,A,B,C,d,nv1,nv2,nv3},{nv1,nv2,nv3}=Normalize/@{v1,v2,v3};c=ArcCos[v1.v2];a=ArcCos[v2.v3];b=ArcCos[v3.v1];A=ArcCos[(Cos[a]-Cos[b] Cos[c])/(Sin[b] Sin[c])];B=ArcCos[(Cos[b] Sin[c]-Cos[A] Cos[c] Sin[b])/Sin[a]];C=ArcCos[(Cos[c] Sin[b]-Cos[A] Cos[b] Sin[c])/Sin[a]];A+B+C-\[Pi]];


(* ::Input::Initialization:: *)
SolidAngle[{v1_,v2_,v3_,v4_}]:=SolidAngle[{v1,v2,v3}]+SolidAngle[{v1,v4,v3}];


(* ::Input::Initialization:: *)
End[];
EndPackage[];
