(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["General`PhysicalConstants`",{"Global`","SpinDynamica`","Units`","General`Miscellaneous`"}];


(* ::Input::Initialization:: *)
PhysicalConstantValues::usage="\!\(\*
StyleBox[\"PhysicalConstantValues\",\nFontSlant->\"Italic\"]\) provides the substitution rules for the SI numerical values of selected physical constants \!\(\*
StyleBox[\"c\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"h\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[HBar]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\[Mu]0\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\[Epsilon]0\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)kB\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)Nav\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"e\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)me\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)mp\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)mn";


(* ::Input::Initialization:: *)
c::usage="c is the speed of light. Obtain numerical value in SI units by c/.PhysicalConstantValues";


(* ::Input::Initialization:: *)
h::usage="h is the Planck constant. Obtain numerical value in SI units by h/.PhysicalConstantValues";


(* ::Input::Initialization:: *)
hbar::usage="hbar is a synonym for \[HBar]";


(* ::Input::Initialization:: *)
\[HBar]::usage="\[HBar] is the Planck constant divided by 2\[Pi]. Obtain numerical value in SI units by \[HBar]/.PhysicalConstantValues";


(* ::Input::Initialization:: *)
\[Mu]0::usage="Magnetic Constant. Obtain numerical value in SI units by \[Mu]0/.PhysicalConstantValues";


(* ::Input::Initialization:: *)
\[Epsilon]0::usage="Electric constant. Obtain numerical value in SI units by \[Epsilon]0/.PhysicalConstantValues";


(* ::Input::Initialization:: *)
kB::usage="Boltzmann constant. Obtain numerical value in SI units by kB/.PhysicalConstantValues";


(* ::Input::Initialization:: *)
Nav::usage="Avogadro constant. Obtain numerical value by Nav/.PhysicalConstantValues";


(* ::Input::Initialization:: *)
e::usage="e is the proton charge. Obtain numerical value in SI units by e/.PhysicalConstantValues";


(* ::Input::Initialization:: *)
me::usage="Electron mass. Obtain numerical value in SI units by me/.PhysicalConstantValues";


(* ::Input::Initialization:: *)
mp::usage="Proton mass. Obtain numerical value in SI units by mp/.PhysicalConstantValues";


(* ::Input::Initialization:: *)
mn::usage="Neutron mass. Obtain numerical value in SI units by mn/.PhysicalConstantValues";


(* ::Input::Initialization:: *)
If[$VersionNumber<9,
(Needs["PhysicalConstants`"];
PhysicalConstantValues={
c -> PhysicalConstants`SpeedOfLight/(Meter/Second),
h ->PhysicalConstants`PlanckConstant/(Joule Second),
\[HBar] -> PhysicalConstants`PlanckConstantReduced/(Joule Second),
\[Mu]0->PhysicalConstants`VacuumPermeability/(Second Volt/(Meter Ampere)),
\[Epsilon]0->PhysicalConstants`VacuumPermittivity/(Ampere Second/(Meter Volt)),kB -> PhysicalConstants`BoltzmannConstant/(Joule/Kelvin),
Nav -> PhysicalConstants`AvogadroConstant/(1/Mole),
e->PhysicalConstants`ElectronCharge/Coulomb,
me->PhysicalConstants`ElectronMass/Kilogram,
mp->PhysicalConstants`ProtonMass/Kilogram,
mn->PhysicalConstants`NeutronMass/Kilogram
})
];


(* ::Input::Initialization:: *)
If[$VersionNumber>=9,
PhysicalConstantValues={
c -> 299792458,
h -> 6.6260695699999995915614325125943122898228578`7.057827997854494*^-34,
\[HBar] -> 1.0545717259999999496487072925965924455989191`7.049948269732947*^-34,
\[Mu]0->\[Pi]/2500000,
\[Epsilon]0->625000/(22468879468420441 \[Pi]),kB -> 1.3806488000000000456839657751372779`5.725109871795768*^-23,
Nav -> 6.02214128999999968641024`7.047357180783781*^23,
e->1.60217656500000003606379190082454356534`7.359612335017222*^-19,
me->9.10938291707429769542081766`7.0617630921243855*^-31,
mp->1.672621776498276672145209052493`7.053283984852396*^-27,
mn->1.674927351890068511848978152322`7.053586622862399*^-27
}
];


(* ::Input::Initialization:: *)
Protect/@(First/@PhysicalConstantValues);


(* ::Input::Initialization:: *)
EndPackage[];
