(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage[ "Graphics`Visualization`",	
	{	"Global`",
		"SpinDynamica`",
		"General`General3D`",
		"Rotations`Euler`",
		"General`Miscellaneous`"
	}	
];


(* ::Input::Initialization:: *)
Axes3D::"usage"="Axes3D[{x,y,z}, pt, opts] draws a set of arrowed axes centred at pt, along the vectors specified by {x,y,z}.If pt is absent, the origin is assumed.
An incomplete axes specification may be given, i.e. Axes3D[{x,z}, pt, opts] or Axes3D[{z}, pt, opts],as in AxisSystem.
The axis orientations may also be specified using Euler angles, as in Axes3D[{\[Alpha],\[Beta],\[Gamma]},pt,opts] (orientation relative to the default coordinate system), or Axes3D[{\[Alpha],\[Beta],\[Gamma]},{x,y,z},pt,ops] (orientation relative to the coordinate system {x,y,z})";


(* ::Input::Initialization:: *)
Axes3DLength::"usage"="length of arrows to use for the axes.\n ";


(* ::Input::Initialization:: *)
Arrow3D::usage=
	"Arrow3D[begin, end, opts] generates graphics primitives for an arrow in 3D space. Arrow3D[end, opts] draws from the origin. Arrow3D now uses the inbuilt functionality of Arrow in Mathematica 7 to specify the arrow head. The option Tube -> True can be used to specify that the arrow and heads are drawn as tubes. If a numeric value is used for the Tube option, that value is used as the tube radius.";


(* ::Input::Initialization:: *)
HeadSize::"usage"="Size of Arrow Head";


(* ::Input::Initialization:: *)
Annotation::"usage"="string for annotation. Suppresses if Annotation->None ";


(* ::Input::Initialization:: *)
AnnotationPosition::"usage"="fractional distance from begin to end for the label. ";


(* ::Input::Initialization:: *)
AnnotationFont::"usage"="font to use for the annotation. ";


(* ::Input::Initialization:: *)
AnnotationRadius::"usage"="Radial distance to use for the annotation.\n ";


(* ::Input::Initialization:: *)
Clockwise::usage="An option for computing annotations and rotation arrows";


(* ::Input::Initialization:: *)
VisualizeEuler::usage =
	"VisualizeEuler[{\[Alpha]PL,\[Beta]PL,\[Gamma]PL}] draws two axis systems, the lab axis system (thin lines), and an axis system P related to it by the Euler angles {\[Alpha]PL,\[Beta]PL,\[Gamma]PL} (thick lines)";


(* ::Input::Initialization:: *)
LShapeDimensions::usage="Dimensions of LShape";


(* ::Input::Initialization:: *)
LShapeLineStyle::usage="line style for LShape";


(* ::Input::Initialization:: *)
LShape::usage="LShape[opts] generates graphics primitives for a LShape, useful for illustrating rotations. Example: Show[LShape[]]";


(* ::Input::Initialization:: *)
RotorDimensions::usage="An option for Rotor. Example: Rotor[RotorDimensions\[Rule]{radius,length}]";


(* ::Input::Initialization:: *)
Rotor::usage="Rotor[opts] generates graphics primitives for a sample rotor. Options may included RotorDimensions\[Rule]{radius,length} and PlotPoints\[Rule]n";


(* ::Input::Initialization:: *)
SphereAndAxes::usage="SphereAndAxes[] generates the Graphics3D object for a transparent sphere of unit radius with labelled Cartesian axes, suitable for trajectory diagrams. At present (v2.5.5) there are no options available";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
Options[Axes3D]={
Axes3DLength->1.0,
Annotation->{"x","y","z"},
AnnotationPosition->{0.8,0.8,0.8},AnnotationRadius->Table[0.05,{3}],
Clockwise->Table[False,{3}],
FormatType->StandardForm,
FontFamily->"Helvetica",
FontSize->14,
Directive->{}
};


(* ::Input::Initialization:: *)
Axes3D[opts___Rule]:=Axes3D[{0,0,0},opts];


(* ::Input::Initialization:: *)
Axes3D[{\[Alpha]:Except[_List],\[Beta]:Except[_List],\[Gamma]:Except[_List]},opts___Rule]:=Axes3D[{\[Alpha],\[Beta],\[Gamma]},Origin,opts];


(* ::Input::Initialization:: *)
Axes3D[{\[Alpha]:Except[_List],\[Beta]:Except[_List],\[Gamma]:Except[_List]},origin:{Except[_List],Except[_List],Except[_List]},opts___Rule]:=Axes3D[{\[Alpha],\[Beta],\[Gamma]},AxisSystem[ez],origin,opts];


(* ::Input::Initialization:: *)
Axes3D[{\[Alpha]:Except[_List],\[Beta]:Except[_List],\[Gamma]:Except[_List]},axes_?MatrixQ,opts___Rule]:=Axes3D[{\[Alpha],\[Beta],\[Gamma]},axes,Origin,opts];


(* ::Input::Initialization:: *)
Axes3D[{\[Alpha]:Except[_List],\[Beta]:Except[_List],\[Gamma]:Except[_List]},axes_?MatrixQ,
origin:{Except[_List],Except[_List],Except[_List]},opts___Rule]:=Axes3D[RotateEuler[AxisSystem[axes],{\[Alpha],\[Beta],\[Gamma]}],origin,opts];


(* ::Input::Initialization:: *)
Axes3D[axes_?MatrixQ,opts___Rule]:=Axes3D[axes,Origin,opts];


(* ::Input::Initialization:: *)
Axes3D[axes_?MatrixQ,origin:{Except[_List],Except[_List],Except[_List]},opts___Rule]:=
Module[{len,ann,annpos,annrad,clock,dir},{len,ann,annpos,annrad,clock}={Axes3DLength,Annotation,AnnotationPosition,AnnotationRadius,Clockwise}/. {opts}/. Options[Axes3D];
If [Length[ann]==0,ann=Table[ann,{3}]];
If [Length[annpos]==0,annpos=Table[annpos,{3}]];
If [Length[annrad]==0,annrad=Table[annrad,{3}]];
If [Length[clock]==0,clock=Table[clock,{3}]];
Graphics3D@MapThread[
First@Arrow3D[#1,#2,#3,#4,#5,#6,opts,Sequence@@Options[Axes3D]]&,
{
{origin,origin,origin},
{origin,origin,origin}+len*AxisSystem[axes],
(Annotation->#)&/@ann,
(AnnotationPosition->#)&/@annpos,
(AnnotationRadius->#)&/@annrad,
(Clockwise->#)&/@clock
}
]
];


(* ::Input::Initialization:: *)
Options[Arrow3D]={PlotStyle->Thin,HeadSize->Medium,Annotation->None,AnnotationPosition->0.8,AnnotationRadius->0.07,Clockwise->False,Tube->True,Directive->None};


(* ::Input::Initialization:: *)
Arrow3D[end_List,opts___Rule]:=Arrow3D[Origin,end,opts];


(* ::Input::Initialization:: *)
Arrow3D[begin_List,end_List,opts___Rule]:=Module[{headSize,ann,tube,dir},({headSize,tube,dir}={HeadSize,Tube,Directive}/.{opts}/.Join[Options[Graphics3D],Options[Arrow3D]];
Graphics3D[
Flatten@{
If[MatchQ[dir,None|False|{}],{},dir],
Arrowheads[headSize],
Switch[tube,
_?NumericQ,Arrow[Tube[{begin,end},tube]],
True,Arrow[Tube[{begin,end}]],
_,Arrow[{begin,end}]
],
If[MatchQ[ann,None|False],{},AnnotateArrow[begin,end,opts,Sequence@@Options[Arrow3D]]
]
}]
)];


(* ::Input::Initialization:: *)
AnnotateArrow[end_List,opts___Rule]:=AnnotateArrow[Origin,end,opts];


(* ::Input::Initialization:: *)
AnnotateArrow[begin_List,end_List,opts___Rule]:=Module[{ann,annpos,annfont,annrad,clockwise,vpc,x,y,z,l,pos},({vpc,ann,annpos,annfont,annrad,clockwise}={ViewPoint,Annotation,AnnotationPosition,AnnotationFont,AnnotationRadius,Clockwise}/.{opts}/.Options[Graphics3D];
(
l=Norm[end-begin];
{x,y,z}=AxisSystem[vpc,end-begin];
pos=begin+annpos*l*z+l*annrad*If[clockwise,-y,y];
Flatten@{
If[TrueQ[ann==None],{},
Text[
Style[ann,
Sequence@@FilterRules[{opts},Options[Style]]
],
pos,
Sequence@@FilterRules[{opts},Options[Text]]
]
]
}
)
)];



(* ::Input::Initialization:: *)
VisualizeEuler[\[CapitalOmega]:{_,_,_},opts___]:=Show[{Axes3D[],Axes3D[RotateEuler[#,-Reverse[\[CapitalOmega]]]&/@{ex,ey,ez},PlotStyle->Thick]}]


(* ::Input::Initialization:: *)
Options[LShape]=
	{	LShapeDimensions->{0.5, 0.8, 0.2, 0.2, 0.2},
		LShapeLineStyle->Thin
  };


(* ::Input::Initialization:: *)
LShape[opts___]:=
	Module[
	{	linestyle,	
		a,b,c,d,e,	
		v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,
		v13, v14, v15, v16,
		avec, bvec, cvec, dvec, evec,
		face1a, face1b, face1c,
		face2, face3, face4, face5, face6, 
		face7a, face7b, face7c,
		face8,
		edge1, edge7
	},(
		{a,b,c,d,e} = LShapeDimensions/.{opts}/.Options[LShape];
		linestyle = LShapeLineStyle/.{opts}/.Options[LShape];
		avec = {a,0,0};
		bvec = {0,0,b};
		cvec = {c,0,0};
		dvec = {0,d,0};
		evec = {0,0,e};
		v1 = dvec + avec;
		v2 = dvec;
		v3 = v2 + bvec;
		v4 = v3 + cvec;
		v5 = v4 - bvec + evec;
		v6 = v1 + evec;
		v7 = v1 - dvec;
		v8 = v2 - dvec;
		v9 = v3 - dvec;
		v10 = v4 - dvec;
		v11 = v5 - dvec;
		v12 = v6 - dvec;
		v13 = v2 + cvec;
		v14 = v2 + evec;
		v15 = v8 + cvec;
		v16 = v8 + evec;
		face1a = { v1, v13, v5, v6 };
		face1b = { v13, v2, v14, v5 };
		face1c = { v14, v3, v4, v5 };
		face2 = { v1, v2, v8, v7 };
		face3 = { v2, v3, v9, v8 };
		face4 = { v4, v3, v9, v10 };
		face5 = { v11, v5, v4, v10 };
		face6 = { v6, v5, v11, v12};
		face7a = { v7, v15, v11, v12};
		face7b = { v15, v8, v16, v11 };
		face7c = {v16, v9, v10, v11 };
		face8 = { v1, v6, v12, v7 };
		edge1 = { v1, v2, v3, v4, v5, v6, v1 };
		edge7 = { v7, v8, v9, v10, v11, v12, v7 };
		Graphics3D[
		Flatten[{
			Map[{EdgeForm[],FaceForm[White],Polygon[#]}&,
				{ face1a, face1b, face1c,
					face7a, face7b, face7c
				}
			],
			Map[Polygon,
				{	
					face2, face3, face4, 
					face5, face6,  face8
				}
			],
			linestyle,
			Map[Line,
				{ edge1, edge7 }
			]
		}]]
	)];		
		


(* ::Input::Initialization:: *)
Options[Rotor]={RotorDimensions->{0.3,1.0},PlotPoints->100};


(* ::Input::Initialization:: *)
Rotor[opts___Rule]:=
Module[{r,h,n,toppointsw,toppointsb,botpointsw,botpointsb},(
{r,h,n}=Flatten[{RotorDimensions,PlotPoints}/.{opts}/.Options[Rotor]];
toppointsb=Table[{r Cos[ph],r Sin[ph],h/2},{ph,\[Pi]/n,\[Pi]+\[Pi]/n,\[Pi]/(n/2)}];
botpointsb=Table[{r Cos[ph],r Sin[ph],-(h/2)},{ph,\[Pi]/n,\[Pi]+\[Pi]/n,\[Pi]/(n/2)}];
toppointsw=Table[{r Cos[ph],r Sin[ph],h/2},{ph,\[Pi]+\[Pi]/n,2\[Pi]+\[Pi]/n,\[Pi]/(n/2)}];
botpointsw=Table[{r Cos[ph],r Sin[ph],-(h/2)},{ph,\[Pi]+\[Pi]/n,2\[Pi]+\[Pi]/n,\[Pi]/(n/2)}];
Graphics3D@{EdgeForm[],
{Darker@Gray,Polygon[toppointsb],Polygon[botpointsb],
MapThread[Polygon[Join[#1,Reverse[#2]]]&,
{Partition[toppointsb,2,1],Partition[botpointsb,2,1]}
]
},
{White,Polygon[toppointsw],Polygon[botpointsw],
MapThread[Polygon[Join[#1,Reverse[#2]]]&,
{Partition[toppointsw,2,1],Partition[botpointsw,2,1]}
]
}
}
)];


(* ::Input::Initialization:: *)
SphereAndAxes[]:=
Graphics3D[
{Opacity[0.1],EdgeForm[],
Polygon[{0,Cos[#],Sin[#]}&/@Range[0,2\[Pi],2\[Pi]/100]],
Polygon[{Cos[#],Sin[#],0}&/@Range[0,2\[Pi],2\[Pi]/100]],
Polygon[{Cos[#],0,Sin[#]}&/@Range[0,2\[Pi],2\[Pi]/100]],
Sphere[{0,0,0},1],
Opacity[1],
Arrow[Tube[{{0,0,0},{1,0,0}}]],
Arrow[Tube[{{0,0,0},{0,1,0}}]],
Arrow[Tube[{{0,0,0},{0,0,1}}]],
Text[Style["x",Large],{1.1,0,0}],
Text[Style["y",Large],{0,1.1,0}],
Text[Style["z",Large],{0,0,1.1}]
}
]


(* ::Input::Initialization:: *)
End[];


(* ::Input::Initialization:: *)
EndPackage[];
