(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["Interactions`Interactions`",
{"Global`",
"SpinDynamica`",
"General`Miscellaneous`",
"General`PhysicalConstants`"
}
];


(* ::Input::Initialization:: *)
Isotope::usage = "Isotope[A] finds the isotope with mass number A. A warning is issued if there are duplicate mass numbers.";


(* ::Input::Initialization:: *)
NuclearSpinQuantumNumber::usage = "NuclearSpinQuantumNumber[isotope] gives the ground-state nuclear spin quantum number of the given isotope, specified using either its mass number, or as an abbreviation, for example \"13C\".";


(* ::Input::Initialization:: *)
MagnetogyricRatio::usage = "MagnetogyricRatio[isotope] gives the magnetogyric ratio of the specified isotope, in units of rad\[NonBreakingSpace]\!\(\*SuperscriptBox[\(s\), \(-1\)]\)\[NonBreakingSpace]\!\(\*SuperscriptBox[\(T\), \(-1\)]\). The isotope is specified either by its mass number, or as an abbreviation, for example \"13C\".";


(* ::Input::Initialization:: *)
NaturalAbundance::usage = "NaturalAbundance[isotope] gives the natural abundance of the specified isotope. The isotope is specified either by its mass number, or as an abbreviation, for example \"13C\".";


(* ::Input::Initialization:: *)
GyromagneticRatio::usage = "same as MagnetogyricRatio";


(* ::Input::Initialization:: *)
LarmorFrequency::usage = "LarmorFrequency[isotope,\!\(\*SubscriptBox[\(B\), \(0\)]\)] gives the Larmor frequency of the specified isotope in the field \!\(\*SubscriptBox[\(B\), \(0\)]\) [specified in Tesla], in units of rad\[NonBreakingSpace]\!\(\*SuperscriptBox[\(s\), \(-1\)]\). The isotope is specified either by its mass number, or as an abbreviation, for example \"13C\".";


(* ::Input::Initialization:: *)
DirectDipolarCoupling::usage = "DirectDipolarCoupling[{isotope1,isotope2},r] gives the dipolar coupling (in rad\[NonBreakingSpace]\!\(\*SuperscriptBox[\(s\), \(-1\)]\)) between the nuclei of two isotopes separated by r (in meters). DirectDipolarCoupling[isotope1,r] assumes two identical isotopes. Each isotope is specified either by its mass number, or as an abbreviation, for example \"13C\".";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
IsotopicData=
{#[[1]],#[[2]],#[[3]]*10^7,#[[4]],#[[5]]/100}&/@
{{1,"1H",26.7522128,1/2,99.9885},
{2,"2H",4.10662791,1,0.0115},
{3,"3H",28.5349779,1/2,0},
{3,"3He",-20.3801587,1/2,0.000137},
{6,"6Li",3.9371709,1,7.59},
{7,"7Li",10.3977013,3/2,92.41},
{9,"9Be",-3.759666,3/2,100},
{10,"10B",2.8746786,3,19.9},
{11,"11B",8.5847044,3/2,80.1},
{13,"13C",6.728284,1/2,1.07},
{14,"14N",1.9337792,1,99.632},
{15,"15N",-2.71261804,1/2,0.368},
{17,"17O",-3.62808,5/2,0.038},
{19,"19F",25.18148,1/2,100},
{21,"21Ne",-2.11308,3/2,0.27},
{23,"23Na",7.0808493,3/2,100},
{25,"25Mg",-1.63887,5/2,10.00},
{27,"27Al",6.9762715,5/2,100},
{29,"29Si",-5.3190,1/2,4.6832},
{31,"31P",10.8394,1/2,100},
{33,"33S",2.055685,3/2,0.76},
{35,"35Cl",2.624198,3/2,75.77},
{37,"37Cl",2.184368,3/2,24.23},
{39,"39K",1.2500608,3/2,93.2581},
{40,"40K",-1.5542854,4,0.0117},
{41,"41K",0.68606808,3/2,6.7302},
{43,"43Ca",-1.803069,7/2,0.135},
{45,"45Sc",6.5087973,7/2,100},
{47,"47Ti",-1.5105,5/2,7.44},
{49,"49Ti",-1.51095,7/2,5.41},
{50,"50V",2.6706490,6,0.250},
{51,"51V",7.0455117,7/2,99.750},
{53,"53Cr",-1.5152,3/2,9.501},
{55,"55Mn",6.6452546,5/2,100},
{57,"57Fe",0.8680624,1/2,2.2},
{59,"59Co",6.332,7/2,100},
{61,"61Ni",-2.3948,3/2,1.140},
{63,"63Cu",7.1117890,3/2,69.17},
{65,"65Cu",7.60435,3/2,30.83},
{67,"67Zn",1.676688,5/2,4.1},
{69,"69Ga",6.438855,3/2,60.108},
{71,"71Ga",8.181171,3/2,39.892},
{73,"73Ge",-0.9360303,9/2,7.73},
{75,"75As",4.596163,3/2,100},
{77,"77Se",5.1253857,1/2,7.63},
{79,"79Br",6.725616,3/2,50.69},
{81,"81Br",7.249776,3/2,49.31},
{83,"83Kr",-1.03310,9/2,11.5},
{85,"85Rb",2.5927050,5/2,72.165},
{87,"87Rb",8.786400,3/2,27.835},
{87,"87Sr",-1.1639376,9/2,7.00},
{89,"89Y",-1.3162791,1/2,100},
{91,"91Zr",-2.49743,5/2,11.22},
{93,"93Nb",6.5674,9/2,100},
{95,"95Mo",-1.751,5/2,15.92},
{97,"97Mo",-1.788,5/2,9.55},
{99,"99Tc",6.046,9/2,0},
{99,"99Ru",-1.229,5/2,12.7},
{101,"101Ru",-1.377,5/2,17},
{103,"103Rh",-0.8468,1/2,100},
{105,"105Pd",-1.23,5/2,22.33},
{107,"107Ag",-1.0889181,1/2,51.839},
{109,"109Ag",-1.2518634,1/2,48.161},
{111,"111Cd",-5.6983131,1/2,12.8},
{113,"113Cd",-5.9609153,1/2,12.22},
{113,"113In", 5.8845,9/2,4.3},
{115,"115In",5.8972,9/2,95.7},
{115,"115Sn",-8.8013,1/2,0.34},
{117,"117Sn",-9.58879,1/2,7.68},
{119,"119Sn",-10.0317,1/2,8.59},
{121,"121Sb",6.4435,5/2,57.36},
{123,"123Sb",3.4892,7/2,42.64},
{123,"123Te",-7.059098,1/2,0.908},
{125,"125Te",-8.5108404,1/2,7.139},
{127,"127I",5.389573,5/2,100},
{129,"129Xe",-7.452103,1/2,26.4},
{131,"131Xe",2.209076,3/2,21.2},
{133,"133Cs",3.5332539,7/2,100},
{135,"135Ba",2.65750,3/2,6.592},
{137,"137Ba",2.99295,3/2,11.23},
{138,"138La",3.557239,5,0.0902},
{139,"139La",3.8083318,7/2,99.9098},
{141,"141Pr",8.1907,5/2,100},
{143,"143Nd",-1.457,7/2,12.18},
{145,"145Nd",-0.898,7/2,8.30},
{147,"147Pm",3.613,7/2,0},
{147,"147Sm",-1.115,7/2,15.0},
{149,"149Sm",-0.9192,7/2,13.8},
{151,"151Eu",6.6510,5/2,47.8},
{153,"153Eu",2.9369,5/2,52.2},
{155,"155Gd",-0.82132,3/2,14.8},
{157,"157Gd",-1.0769,3/2,15.65},
{159,"159Tb",6.431,3/2,100},
{161,"161Dy",-0.9201,5/2,18.9},
{163,"163Dy",1.289,5/2,24.9},
{165,"165Ho",5.710,7/2,100},
{167,"167Er",-0.77157,7/2,22.95},
{169,"169Tm",-2.218,1/2,100},
{171,"171Yb",4.7288,1/2,14.3},
{173,"173Yb",-1.3025,5/2,16.12},
{175,"175Lu",3.0552,7/2,97.41},
{176,"176Lu",2.1684,7,2.59},
{177,"177Hf",1.086,7/2,18.606},
{179,"179Hf",-0.6821,9/2,13.629},
{181,"181Ta",3.2438,7/2,99.988},
{183,"183W",1.1282403,1/2,14.3},
{185,"185Re",6.1057,5/2,37.40},
{187,"187Re",6.1682,5/2,62.60},
{187,"187Os",0.6192895,1/2,1.6},
{189,"189Os",2.10713,3/2,16.1},
{191,"191Ir",0.4812,3/2,37.3},
{193,"193Ir",0.5227,3/2,62.7},
{195,"195Pt",5.8385,1/2,33.8},
{197,"197Au",0.473060,3/2,100},
{199,"199Hg",4.8457916,1/2,16.87},
{201,"201Hg",-1.788769,3/2,13.18},
{203,"203Tl",15.5393338,1/2,29.524},
{205,"205Tl",15.6921808,1/2,70.476},
{207,"207Pb",5.58046,1/2,22.1},
{209,"209Bi",4.3750,9/2,100},
{209,"209Po",7.4,1/2,0},
{227,"227Ac",3.5,3/2,0},
{229,"229Th",0.40,5/2,100},
{231,"231Pa",3.21,3/2,100},
{235,"235U",-0.52,7/2,0.7200},
{237,"237Np",3.1,5/2,0},
{239,"239Pu",0.972,1/2,0},
{241,"241Am",1.54,5/2,0},
{243,"243Am",1.54,5/2,0},
{247,"247Cm",0.20,9/2,0}
};


(* ::Input::Initialization:: *)
Isotope[A_Integer]:=
Module[{candidates},(
candidates=Cases[IsotopicData,{A,___}];
Switch[Length[candidates],
0,
(Message[Isotope::none,A];$Failed),
1,candidates[[1,2]],
_,
(Message[Isotope::dup,A,("\""<>#[[2]]<>"\"")&/@candidates];Part[#,2]&/@candidates)
]
)];


(* ::Input::Initialization:: *)
Isotope[isotope_String]:=isotope;


(* ::Input::Initialization:: *)
Isotope::none="No isotope found with mass number `1`";


(* ::Input::Initialization:: *)
Isotope::dup="The mass number `1` is ambiguous. Specify one the following isotopes explicitly: `2`";


(* ::Input::Initialization:: *)
GyromagneticRatio[$Failed|_List]=$Failed;


(* ::Input::Initialization:: *)
GyromagneticRatio[A_Integer]:=GyromagneticRatio[Isotope[A]];


(* ::Input::Initialization:: *)
GyromagneticRatio[isotope_String]:=(
GyromagneticRatio[isotope]=Cases[IsotopicData,{_,isotope,___}][[1,3]]
);


(* ::Input::Initialization:: *)
MagnetogyricRatio[n___]:=GyromagneticRatio[n]


(* ::Input::Initialization:: *)
NuclearSpinQuantumNumber[$Failed|_List]=$Failed;


(* ::Input::Initialization:: *)
NuclearSpinQuantumNumber[A_Integer]:=NuclearSpinQuantumNumber[Isotope[A]];


(* ::Input::Initialization:: *)
NuclearSpinQuantumNumber[isotope_String]:=(
NuclearSpinQuantumNumber[isotope]=Cases[IsotopicData,{_,isotope,___}][[1,4]]
);


(* ::Input::Initialization:: *)
NaturalAbundance[$Failed|_List]=$Failed;


(* ::Input::Initialization:: *)
NaturalAbundance[A_Integer]:=NaturalAbundance[Isotope[A]];


(* ::Input::Initialization:: *)
NaturalAbundance[isotope_String]:=(
NaturalAbundance[isotope]=Cases[IsotopicData,{_,isotope,___}][[1,5]]
);


(* ::Input::Initialization:: *)
LarmorFrequency[$Failed|_List,___]:=$Failed;


(* ::Input::Initialization:: *)
LarmorFrequency[A_Integer,Bzero_]:=
LarmorFrequency[Isotope[A],Bzero];


(* ::Input::Initialization:: *)
LarmorFrequency[isotope_String,Bzero_]:=
-MagnetogyricRatio[isotope]*Bzero;


(* ::Input::Initialization:: *)
DirectDipolarCoupling[{$Failed|_List,_},___]:=$Failed;


(* ::Input::Initialization:: *)
DirectDipolarCoupling[{_,$Failed|_List},___]:=$Failed;


(* ::Input::Initialization:: *)
DirectDipolarCoupling[iso1:Except[_List],r_] :=DirectDipolarCoupling[{iso1,iso1},r];


(* ::Input::Initialization:: *)
DirectDipolarCoupling[iso1_,iso2_,r_] :=DirectDipolarCoupling[{iso1,iso2},r];


(* ::Input::Initialization:: *)
DirectDipolarCoupling[{A1_Integer,iso2_},r_] :=DirectDipolarCoupling[{Isotope[A1],iso2},r];


(* ::Input::Initialization:: *)
DirectDipolarCoupling[{iso1_,A2_Integer},r_] :=DirectDipolarCoupling[{iso1,Isotope[A2]},r];


(* ::Input::Initialization:: *)
DirectDipolarCoupling[{iso1_String,iso2_String},r_] :=N[-(\[Mu]0/(4\[Pi]))*((MagnetogyricRatio[iso1]*MagnetogyricRatio[iso2]*\[HBar])/(r^3))]/.PhysicalConstantValues;


(* ::Input::Initialization:: *)
End[];
EndPackage[];
