(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["Interactions`Relaxation`",
{"Global`",
"SpinDynamica`",
"General`UserLevel`",
(*"General`ModifyBuiltIn`",*)
"General`Matrices`",
"General`Miscellaneous`",
"QM`Hilbert`",
"QM`SpinOperators`",
"QM`Liouville`",
"SD`Generators`",
"SD`Approximations`",
"Rotations`Wigner`",
"Units`",
"General`PhysicalConstants`"}];


(* ::Input::Initialization:: *)
PhenomenologicalRelaxationSuperoperator::usage=
"\!\(\*
StyleBox[\"PhenomenologicalRelaxationSuperoperator\",\nFontSlant->\"Italic\"]\) generates a relaxation superoperator according to a simple phenomenological relaxation model in which the uncorrelated relaxations of individual spins are characterised by relaxation time constants \!\(\*
StyleBox[\"T1\",\nFontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"T2\",\nFontSlant->\"Italic\"]\). \!\(\*
StyleBox[\"PhenomenologicalRelaxationSuperoperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"T\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)uses the same relaxation time constant \!\(\*
StyleBox[\"T\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)for all spins, with \!\(\*
StyleBox[\"T1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"=\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"T2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"=\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"T\",\nFontSlant->\"Italic\"]\). \!\(\*
StyleBox[\"PhenomenologicalRelaxationSuperoperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"T1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"T2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)uses the same relaxation time constants \!\(\*
StyleBox[\"T1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"and\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"T2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)for all spins. The syntax \!\(\*
StyleBox[\"PhenomenologicalRelaxationSuperoperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Tj\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Tk\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)specifies an individual relaxation time constant \!\(\*
StyleBox[\"T1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"=\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"T2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"=\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Tj\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)for spin \!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)and similar for spin \!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\), etc. \!\(\*
StyleBox[\"PhenomenologicalRelaxationSuperoperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"T1j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"T2j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"T1k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"T2k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)specifies individual relaxation time constants \!\(\*
StyleBox[\"T1j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)and \!\(\*
StyleBox[\"T2j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)for spin \!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)and similar for spin \!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\), etc.";


(* ::Input::Initialization:: *)
$Chronology="LeftToRight";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
PhenomenologicalRelaxationSuperoperator[args___]/;!FreeQ[{args},$Failed]:=$Failed


(* ::Input::Initialization:: *)
PhenomenologicalRelaxationSuperoperator[T:Except[_List],opts___Rule]:=PhenomenologicalRelaxationSuperoperator[T,T,opts];


(* ::Input::Initialization:: *)
PhenomenologicalRelaxationSuperoperator[T1:Except[_List],T2:Except[_List],opts___Rule]:=PhenomenologicalRelaxationSuperoperator[{#,T1,T2}&/@(First/@SpinSystem[]),opts];


(* ::Input::Initialization:: *)
PhenomenologicalRelaxationSuperoperator[jTspec:{Except[_List]..},opts___Rule]:=PhenomenologicalRelaxationSuperoperator[{jTspec}, opts];


(* ::Input::Initialization:: *)
PhenomenologicalRelaxationSuperoperator[jTspec:{a___,{j:Except[_List],T:Except[_List]},b___},opts___Rule]:=PhenomenologicalRelaxationSuperoperator[{a,{j,T,T},b},opts];


(* ::Input::Initialization:: *)
PhenomenologicalRelaxationSuperoperator[jT1T2list:{{_,_,_}..},opts___Rule]/;!ValidSpinQ[First/@jT1T2list,SpinSystem[]]:=(Message[PhenomenologicalRelaxationSuperoperator::invalspin];$Failed);


(* ::Input::Initialization:: *)
PhenomenologicalRelaxationSuperoperator[jT1T2list:{{_,_,_}..},opts___Rule]:=(Message[PhenomenologicalRelaxationSuperoperator::invalT2];$Failed)/;Or@@(TrueQ[Part[#,3]>2Part[#,2]]&/@jT1T2list);


(* ::Input::Initialization:: *)
PhenomenologicalRelaxationSuperoperator[jT1T2list:{{_,_,_}..},opts___Rule]:=
Module[{bops,counts,spins,spinsmissing,jT1T2list$,R1,R2,diagels},(
bops=BasisOperators[ShiftAndZOperatorBasis[]];
spins=First/@SpinSystem[];
spinsmissing=Complement[spins,jT1T2list[[All,1]]];
jT1T2list$=Join[jT1T2list,{#,\[Infinity],\[Infinity]}&/@spinsmissing];
counts=Function[op,
{#,{"z",Count[{op},HoldPattern@opI[#,"z",___],Infinity]},{"+",Count[{op},HoldPattern@opI[#,"+",___],Infinity]},
{"-",Count[{op},HoldPattern@opI[#,"-",___],Infinity]}}&/@
spins
]/@bops;
R1[j_]:=1/Cases[jT1T2list$,{j,_,_}][[1,2]];
R2[j_]:=1/Cases[jT1T2list$,{j,_,_}][[1,3]];
diagels=-Apply[
Plus,
counts/.{j_,{"z",nz_},{"+",np_},{"-",nm_}}:>nz*R1[j]+np*R2[j]+nm*R2[j],
{1}
];
Superoperator[SparseArray[DiagonalMatrix[diagels]],ShiftAndZOperatorBasis[]]
)];


(* ::Input::Initialization:: *)
PhenomenologicalRelaxationSuperoperator::invalspin="One or more spins is not valid in the current \!\(\*
StyleBox[\"SpinSystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)";


(* ::Input::Initialization:: *)
PhenomenologicalRelaxationSuperoperator::invalT2="The T2 for a particular spin cannot exceed 2\[Times]T1";


(* ::Input::Initialization:: *)
End[];
EndPackage[];



