(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["Rotations`Wigner`",
{"Global`",
"General`UserLevel`",
(*"General`ModifyBuiltIn`",*)
"SpinDynamica`",
"General`Miscellaneous`"}];


(* ::Input::Initialization:: *)
(*ModifyBuiltIn[WignerD,
(
Off[WignerD::list];
Off[WignerD::argbu];
SyntaxInformation[WignerD]={"ArgumentsPattern"\[Rule]{_,_.,_.,_.}};
)
];*)


(* ::Input::Initialization:: *)
UserLevelDependentDefinition[WignerD,Infinity,
(
Unprotect[WignerD];
Off[WignerD::list];
Off[WignerD::argbu];
SyntaxInformation[WignerD]={"ArgumentsPattern"->{_,_.,_.,_.}};
Protect[WignerD];
)];


(* ::Input::Initialization:: *)
Unprotect[WignerD];


(* ::Input::Initialization:: *)
Wignerd::usage=
	"Wignerd[J][\[Beta]] is the reduced Wigner matrix (J integral or half-integral). Wignerd[J,{m2,m1}][\[Beta]] is the reduced Wigner function (element of the reduced Wigner matrix). Wignerd[J,{m}][\[Beta]] is the mth row of the reduced Wigner matrix; Wignerd[J,{{m}}][\[Beta]] is the mth column of the reduced Wigner matrix. In all cases the row and column indices run from +J to -J in descending order.";


(* ::Input::Initialization:: *)
WignerD::usage=
"WignerD is a built-in function in Mathematica 2.0 but has been given enhanced functionality in SpinDynamica, in order to maintain compatibility with previous code. The SpinDynamica definitions are as follows:
WignerD[J][{\[Alpha],\[Beta],\[Gamma]}] is the three-angle Wigner matrix for integral or half-integral J. WignerD[J]{{\[Alpha]2,\[Beta]2,\[Gamma]2},{\[Alpha]1,\[Beta]1,\[Gamma]1}..}] is the Wigner matrix for the overall rotation corresponding to the specified sequence of Euler rotations. WignerD[J,{m2,m1}][{\[Alpha],\[Beta],\[Gamma]}] is a three-angle Wigner function (Wigner matrix element). WignerD[J,{m}][{\[Alpha],\[Beta],\[Gamma]}] is the mth row of the Wigner matrix; WignerD[J,{{m}}][{\[Alpha],\[Beta],\[Gamma]}] is the mth column of the Wigner matrix. In all cases the row and column indices run from +J to -J in descending order.";


(* ::Input::Initialization:: *)
TensorElement::usage=
	"TensorElement[\[Lambda], \[Mu]][tensor] accesses the component \[Mu] of the rank \[Lambda] tensor (written as a list of length 2\[Lambda]+1).";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
FirstCallToWignerD=True;


(* ::Input::Initialization:: *)
WignerD[args___]/;TrueQ[FirstCallToWignerD]&&($KernelID==0):=
(
Message[WignerD::mod];
Print[Button["For ?WignerD click <here>",Print[Style[WignerD::usage,"Usage"]]]//DisplayForm];
FirstCallToWignerD=False;
WignerD[args]
);


(* ::Input::Initialization:: *)
HoldPattern@WignerD[\[Lambda]_Integer,{\[Mu]2_Integer,\[Mu]1_Integer}][{\[Alpha]:Except[_List],\[Beta]:Except[_List],\[Gamma]:Except[_List]}]:=0/;(Abs[\[Mu]2]>\[Lambda])||(Abs[\[Mu]1]>\[Lambda]);


(* ::Input::Initialization:: *)
HoldPattern@WignerD[\[Lambda]_,{\[Mu]2_,\[Mu]1_}][{\[Alpha]:Except[_List],\[Beta]:Except[_List],\[Gamma]:Except[_List]}]:=0/;IntegerQ[2\[Lambda]]&&IntegerQ[2\[Mu]2]&&IntegerQ[2\[Mu]1]&&((Abs[\[Mu]2]>\[Lambda])||(Abs[\[Mu]1]>\[Lambda]));


(* ::Input::Initialization:: *)
HoldPattern@WignerD[\[Lambda]_,{\[Mu]2_,\[Mu]1_}][{\[Alpha]:Except[_List],\[Beta]:Except[_List],\[Gamma]:Except[_List]}]:=TrigExpand@WignerD[{\[Lambda],-\[Mu]2,-\[Mu]1},\[Alpha],\[Beta],\[Gamma]];


(* ::Input::Initialization:: *)
HoldPattern@WignerD[\[Lambda]_][{\[Alpha]:Except[_List],\[Beta]:Except[_List],\[Gamma]:Except[_List]}]:=Table[WignerD[\[Lambda],{\[Mu]2,\[Mu]1}][{\[Alpha],\[Beta],\[Gamma]}],{\[Mu]2,+\[Lambda],-\[Lambda],-1},{\[Mu]1,+\[Lambda],-\[Lambda],-1}]


(* ::Input::Initialization:: *)
HoldPattern@WignerD[\[Lambda]_,{\[Mu]2_}][\[CapitalOmega]_]:=Table[WignerD[\[Lambda],{\[Mu]2,\[Mu]1}][\[CapitalOmega]],{\[Mu]1,+\[Lambda],-\[Lambda],-1}];


(* ::Input::Initialization:: *)
HoldPattern@WignerD[\[Lambda]_,{{\[Mu]1_}}][\[CapitalOmega]_]:=Table[WignerD[\[Lambda],{\[Mu]2,\[Mu]1}][\[CapitalOmega]],{\[Mu]2,+\[Lambda],-\[Lambda],-1}];


(* ::Input::Initialization:: *)
HoldPattern@WignerD[J_][rot:{{Except[_List],Except[_List],Except[_List]}}]:=WignerD[J][First@rot];


(* ::Input::Initialization:: *)
HoldPattern@WignerD[J_][{rots:{Except[_List],Except[_List],Except[_List]}..,rot1:{Except[_List],Except[_List],Except[_List]}}]:=WignerD[J][{rots}].WignerD[J][rot1];


(* ::Input::Initialization:: *)
HoldPattern@WignerD[J_,{m2_,m1_}][rot:{{Except[_List],Except[_List],Except[_List]}}]:=WignerD[J,{m2,m1}][First@rot];


(* ::Input::Initialization:: *)
HoldPattern@WignerD[J_,{m2_,m1_}][{rots:{Except[_List],Except[_List],Except[_List]}..,rot1:{Except[_List],Except[_List],Except[_List]}}]:=Sum[WignerD[J,{m2,m21}][{rots}]*WignerD[J,{m21,m1}][rot1],{m21,-J,+J}];


(* ::Input::Initialization:: *)
WignerD::mod="The built-in function WignerD has been given extra functionality in SpinDynamica. Execute ?WignerD for more information.";


(* ::Input::Initialization:: *)
Protect[WignerD];


(* ::Input::Initialization:: *)
Wignerd[\[Lambda]_Integer,{\[Mu]2_Integer,\[Mu]1_Integer}][\[Beta]_]:=0/;(Abs[\[Mu]2]>\[Lambda])||(Abs[\[Mu]1]>\[Lambda]);


(* ::Input::Initialization:: *)
Wignerd[\[Lambda]_,{\[Mu]2_,\[Mu]1_}][\[Beta]_]:=0/;IntegerQ[2\[Lambda]]&&IntegerQ[2\[Mu]2]&&IntegerQ[2\[Mu]1]&&((Abs[\[Mu]2]>\[Lambda])||(Abs[\[Mu]1]>\[Lambda]));


(* ::Input::Initialization:: *)
Wignerd[\[Lambda]_,{\[Mu]2_,\[Mu]1_}][\[Beta]_]:=TrigExpand@WignerD[{\[Lambda],-\[Mu]2,-\[Mu]1},0,\[Beta],0];


(* ::Input::Initialization:: *)
HoldPattern@Wignerd[\[Lambda]_][\[Beta]:Except[_List]]:=Table[Wignerd[\[Lambda],{\[Mu]2,\[Mu]1}][\[Beta]],{\[Mu]2,+\[Lambda],-\[Lambda],-1},{\[Mu]1,+\[Lambda],-\[Lambda],-1}]


(* ::Input::Initialization:: *)
Wignerd[J_,{m2_?NumericQ}][\[Beta]_]/; (-J<=m2<=J):= 
Table[Wignerd[J,{m2,m1}][\[Beta]],{m1,+J,-J,-1}];


(* ::Input::Initialization:: *)
Wignerd[J_,{{m1_?NumericQ}}][\[Beta]_]/; (-J<=m1<=J):= 
Table[Wignerd[J,{m2,m1}][\[Beta]],{m2,+J,-J,-1}];


(* ::Input::Initialization:: *)
TensorElement[\[Lambda]_, \[Mu]_][tensor_List]:=tensor[[ \[Lambda]+1-\[Mu]]] /;( Dimensions[tensor]=={2\[Lambda]+1})&&(-\[Lambda]<=\[Mu]<=\[Lambda]);


(* ::Input::Initialization:: *)
End[];
EndPackage[];
