(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["SD`Generators`",
{"Global`",
"SpinDynamica`",
"General`UserLevel`",
(*"General`ModifyBuiltIn`",*)
"General`Matrices`",
"General`Miscellaneous`",
"QM`Hilbert`",
"QM`SpinOperators`",
"QM`Liouville`",
"Interactions`Interactions`",
"Interactions`Hamiltonians`",
"Interactions`Relaxation`",
"Rotations`Wigner`",
"Units`",
"General`PhysicalConstants`"}];


(* ::Input::Initialization:: *)
CombineGenerators::usage="CombineGenerators[a, b, ..] combines Hamiltonians, Liouvillians, time-dependent Hamiltonian functions, and so on, to generate a single evolution generator.";


(* ::Input::Initialization:: *)
CombineEvolutionGenerators::usage="CombineEvolutionGenerators has been replaced by CombineGenerators.";


(* ::Input::Initialization:: *)
ValidGeneratorQ::usage="ValidGeneratorQ[gen] returns True if gen is a valid generator.";


(* ::Input::Initialization:: *)
ValidEvolutionGeneratorQ::usage="ValidEvolutionGeneratorQ has been replaced by ValidGeneratorQ.";


(* ::Input::Initialization:: *)
StandardizeGenerator::usage="StandardizeGenerator[gen] puts the generator gen in a standard form.";


(* ::Input::Initialization:: *)
StandardizeEvolutionGenerator::usage="StandardizeEvolutionGenerator has been replaced by StandardizeGenerator.";


(* ::Input::Initialization:: *)
GeneratorMatchQ::usage="GeneratorMatchQ[gen1,gen2..] returns True if the generators match.";


(* ::Input::Initialization:: *)
EvolutionGeneratorMatchQ::usage="EvolutionGeneratorMatchQ has been replaced by GeneratorMatchQ.";


(* ::Input::Initialization:: *)
NonStandardNullGeneratorPattern::usage="NonStandardNullGeneratorPattern is a pattern variable used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
NullGeneratorPattern::usage="NullGeneratorPattern is a pattern variable used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
HeldGeneratorSymbol::usage="HeldGeneratorSymbol is used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
ImplementMatrixRepresentation::usage="ImplementMatrixRepresentation is used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
PermittedTimeShift::usage="PermittedTimeShift is a property of an evolution generator, used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
HilbertSpaceCompatibility::usage="HilbertSpaceCompatibility is a property of an evolution generator, used internally by SpinDynamica.";


(* ::Input::Initialization:: *)
CommonPeriod::usage="CommonPeriod calculates the common period of several periodic or aperiodic evolution generators.";


(* ::Input::Initialization:: *)
LocalGeneratorSymbols::usage="\!\(\*
StyleBox[\"LocalGeneratorSymbols\",\nFontSlant->\"Italic\"]\) extracts the symbols which define local variables from a generator object. It is used internally by \!\(\*
StyleBox[\"SpinDynamica\",\nFontSlant->\"Italic\"]\).";


(* ::Input::Initialization:: *)
PeriodicFunction::usage="PeriodicFunction[t,T,expression] defines a periodic Hamiltonian or Liouvillian with period T. The term expression is a function of the time variable t. A periodic function which has been defined through func=PeriodicFunction[t,T,expression] may be applied using the syntax func[t] to generate the expression as a function of time. The period argument T determines when derived propagators may be reused.";


(* ::Input::Initialization:: *)
ShapeFunction::usage="ShapeFunction[t,{\[Tau],x},T,expression] defines a time-dependent Hamiltonian or Liouvillian which depends on an absolute time variable t and also a relative time variable \[Tau] which is taken relative to the event in which the ShapeFunction is used. The variable x is used to specify the time origin of the relative time variable \[Tau]. For example x=0 specifies that the time origin is the start of the event; x=1 indicates a time origin at the end of the event, and x=1/2 indicates a time origin at the middle of the event.  The period argument T determines when derived propagators may be reused. A ShapeFunction defined through func=ShapeFunction[t,{\[Tau],x},T,expression] may be evaluated at any time during an event that starts at time point ta and ends at time point tb using the syntax func[t,ta,tb]. A ShapeFunction may employ multiple relative time variables by using the syntax ShapeFunction[t,{{\[Tau]1,x1},{\[Tau]2,x2}..},T,expression].
";


(* ::Input::Initialization:: *)
Liouvillian::usage="Liouvillian[generators..] converts an evolution generator, or a list of evolution generators, into a Liouvillian superoperator.";


(* ::Input::Initialization:: *)
$Chronology="LeftToRight";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
SetAttributes[PeriodicFunction,HoldAll];


(* ::Input::Initialization:: *)
PeriodicFunction[t_,T_,contents_]/;!MatchQ[t,_Symbol|_Pattern|_Blank|{(_Symbol|_Pattern|_Blank)..}]:=(Message[PeriodicFunction::badt];Abort[]);


(* ::Input::Initialization:: *)
PeriodicFunction/:Expand[PeriodicFunction[t_,T_,contents_]]:=Module[{\[Tau]},ShapeFunction[t,Evaluate@{\[Tau],None},Evaluate@T,contents]];


(* ::Input::Initialization:: *)
PeriodicFunction[t_,T_,contents_][tval_]:=contents/.{t->tval};


(* ::Input::Initialization:: *)
PeriodicFunction::badt="The time variable of PeriodicFunction cannot have an assigned value";


(* ::Input::Initialization:: *)
SetAttributes[ShapeFunction,HoldAll];


(* ::Input::Initialization:: *)
Options[ShapeFunction]={Expand->False};


(* ::Input::Initialization:: *)
Format[ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,arg_,opts___Rule]/;!(Expand/.{opts}/.Options[ShapeFunction])]:=
RowBox[{
"ShapeFunction[<<..>>]"
}]//DisplayForm; 


(* ::Input::Initialization:: *)
(*UserLevelDependentDefinition[Expand,Infinity,
Expand[a_]/;!FreeQ[a,_ShapeFunction]:=a/.{shf_ShapeFunction:>Expand[shf]}
];*)


(* ::Input::Initialization:: *)
ShapeFunction/:(Expand|ExpandAll)[ShapeFunction[args___,opts___Rule]]:=ShapeFunction[args,Evaluate@SimplifyRules[Expand->True,opts]];


(* ::Input::Initialization:: *)
ShapeFunction[{\[Tau]_,x_},contents_,opts___Rule]:=ShapeFunction[{\[Tau],x},All,Evaluate@StandardizeGenerator@contents];


(* ::Input::Initialization:: *)
ShapeFunction[t_,{\[Tau]_,x_},contents_,opts___Rule]:=ShapeFunction[t,{\[Tau],x},None,Evaluate@StandardizeGenerator@contents];


(* ::Input::Initialization:: *)
ShapeFunction[{\[Tau]_,x_},T_,contents_,opts___Rule]:=Module[{t},ShapeFunction[t,{\[Tau],x},T,Evaluate@StandardizeGenerator@contents]];


(* ::Input::Initialization:: *)
ShapeFunction[t_,{\[Tau]:Except[_List],x:Except[_List]},T_,contents_,opts___Rule]:=ShapeFunction[t,{{\[Tau],x}},T,Evaluate@StandardizeGenerator@contents];


(* ::Input::Initialization:: *)
ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,num_?NumericQ,opts___Rule]:=Function[Evaluate@StandardizeGenerator@num];


(* ::Input::Initialization:: *)
ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,___]/;!MatchQ[t,_Symbol|_Pattern|_Blank]:=(Message[ShapeFunction::badt];Abort[]);


(* ::Input::Initialization:: *)
ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,contents_,opts___Rule][tval_]/;And@@(FreeQ[contents,First[#]]&/@\[Tau]xpairs):=
ReleaseHold@ReplaceEverywhere[Hold[contents],{HoldPattern[t]->tval}];


(* ::Input::Initialization:: *)
ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,contents_,opts___Rule][\[Tau]val_]/;!And@@(FreeQ[contents,First[#]]&/@\[Tau]xpairs):=(Message[ShapeFunction::misst];$Failed);


(* ::Input::Initialization:: *)
ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,contents_,opts___Rule][tval_,t0_]/;
(And@@((Chop[Last[#]-(1/2)]==0)&/@\[Tau]xpairs)):=
Module[{rules},(
rules=Sequence[HoldPattern[t]->tval,Sequence@@((First[#]->tval-t0)&/@\[Tau]xpairs)];
ReleaseHold@ReplaceEverywhere[Hold[contents],rules]
)];


(* ::Input::Initialization:: *)
ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,contents_,opts___Rule][tval_,t0_]/;
(Or@@((Chop[Last[#]-(1/2)]!=0)&/@\[Tau]xpairs)):=(Message[ShapeFunction::misstatb];$Failed);


(* ::Input::Initialization:: *)
ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,contents_,opts___Rule][tval_,ta_,tb_]:=
Module[{tloc,rules},(
rules=Sequence[
HoldPattern[t]->tval,Sequence@@((First[#]->tval-(ta+Last[#]*(tb-ta)))&/@\[Tau]xpairs)];
ReleaseHold@ReplaceEverywhere[Hold[contents],rules]
)];


(* ::Input::Initialization:: *)
ShapeFunction::misstatb="missing start and end time points.";


(* ::Input::Initialization:: *)
ShapeFunction::misst="missing time variable.";


(* ::Input::Initialization:: *)
ShapeFunction::badt="The time variable of ShapeFunction cannot have an assigned value";


(* ::Input::Initialization:: *)
ValidEvolutionGeneratorQ[args___]:=(Message[ValidEvolutionGeneratorQ::usage];ValidGeneratorQ[args]);


(* ::Input::Initialization:: *)
ValidGeneratorQ[Hold[symb_]]:=ValidGeneratorQ[symb];


(* ::Input::Initialization:: *)
ValidGeneratorQ[None]=True;


(* ::Input::Initialization:: *)
ValidGeneratorQ[num_?NumericQ]:=True;


(* ::Input::Initialization:: *)
ValidGeneratorQ[op_?OperatorQ]:=True;


(* ::Input::Initialization:: *)
ValidGeneratorQ[sop_?SuperoperatorQ]:=True;


(* ::Input::Initialization:: *)
ValidGeneratorQ[_PrecalculatedPropagator]:=True;


(* ::Input::Initialization:: *)
ValidGeneratorQ[
HoldPattern@Function[___,arg_]]:=
Switch[arg,
_?(!FreeQ[{#},$Failed]&),$Failed,
_?NumericQ|_?OperatorQ|_?SuperoperatorQ,True,
_,False];


(* ::Input::Initialization:: *)
ValidGeneratorQ[
HoldPattern@PeriodicFunction[___,arg_]]:=
Switch[arg,
_?(!FreeQ[{#},$Failed]&),$Failed,
_?NumericQ|_?OperatorQ|_?SuperoperatorQ,True,
_,False];


(* ::Input::Initialization:: *)
ValidGeneratorQ[
HoldPattern@ShapeFunction[___,arg_]]:=
Switch[arg,
_?(!FreeQ[{#},$Failed]&),$Failed,
_?NumericQ|_?OperatorQ|_?SuperoperatorQ,True,
_,False];


(* ::Input::Initialization:: *)
ValidGeneratorQ[evgen_]:=Module[{chopevgen},(ValidGeneratorQ[chopevgen])/;(
chopevgen=Chop[evgen];
!MatchQ[chopevgen,evgen]
)];


(* ::Input::Initialization:: *)
ValidGeneratorQ[_]:=False;


(* ::Input::Initialization:: *)
StandardizeEvolutionGenerator[args___]:=(Message[StandardizeEvolutionGenerator::usage];StandardizeGenerator[args]);


(* ::Input::Initialization:: *)
Options[StandardizeGenerator]={};


(* ::Input::Initialization:: *)
StandardizeGenerator[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
StandardizeGenerator[Hold[args___]]:=StandardizeGenerator[args];


(* ::Input::Initialization:: *)
NonStandardNullGeneratorPattern=None|0|n_?((MatchQ[#,_?NumericQ]&&Chop[#]==0)&)|NullSuperoperator[]|HoldPattern@Function[___,0|n_?((MatchQ[#,_?NumericQ]&&Chop[#]==0)&)|None|NullOperator[]|NullSuperoperator[]]|HoldPattern@ShapeFunction[___,0|n_?((MatchQ[#,_?NumericQ]&&Chop[#]==0)&)|None|NullOperator[]|NullSuperoperator[]];


(* ::Input::Initialization:: *)
NullGeneratorPattern=NullOperator[]|NonStandardNullGeneratorPattern;


(* ::Input::Initialization:: *)
StandardizeGenerator[NonStandardNullGeneratorPattern,opts___Rule]=NullOperator[];


(* ::Input::Initialization:: *)
StandardizeGenerator[evgen_]:=
Module[{chopevgen},(
StandardizeGenerator[chopevgen]
)/;(chopevgen=Chop[evgen];
!MatchQ[chopevgen,evgen])
];


(* ::Input::Initialization:: *)
StandardizeGenerator[HoldPattern@Function[args_],opts___Rule]:=StandardizeGenerator[args,opts];


(* ::Input::Initialization:: *)
StandardizeGenerator[
HoldPattern@Function[t_,args_],opts___Rule]:=
Module[{tloc,\[Tau],x},
StandardizeGenerator[
ShapeFunction[tloc,{\[Tau],x},None,
Evaluate@ReleaseHold@ReplaceEverywhere[
Hold[args],{HoldPattern[t]->tloc}
]
],
opts
]
];


(* ::Input::Initialization:: *)
StandardizeGenerator[
HoldPattern@Function[{t_,t0_},args_],opts___Rule]:=
Module[{tloc,\[Tau]},
StandardizeGenerator[ShapeFunction[tloc,{\[Tau],1/2},None,Evaluate@ReleaseHold@ReplaceEverywhere[
Hold[args],{HoldPattern[t]->tloc,HoldPattern[t0]->tloc-\[Tau]}
]
],
opts]
];


(* ::Input::Initialization:: *)
StandardizeGenerator[
HoldPattern@Function[{t_,ta_,tb_},args_],opts___Rule]:=
Module[{tloc,\[Tau]},
StandardizeGenerator[ShapeFunction[tloc,{\[Tau],0},None,
Evaluate@ReleaseHold@ReplaceEverywhere[
Hold[args],{HoldPattern[t]->tloc,HoldPattern[ta]->tloc-\[Tau]}
]
],
opts]
];


(* ::Input::Initialization:: *)
StandardizeGenerator[PeriodicFunction[t_,T_,args_],opts___Rule]:=Module[{tloc,\[Tau],x},
StandardizeGenerator[
ShapeFunction[tloc,{\[Tau],x},T,
Evaluate@ReleaseHold@ReplaceEverywhere[
Hold[args],{HoldPattern[t]->tloc}
]
],
opts
]
];


(* ::Input::Initialization:: *)
StandardizeGenerator[PeriodicFunction[{t_,t0_},T_,args_],opts___Rule]:=
Module[{tloc,\[Tau]},
StandardizeGenerator[
ShapeFunction[tloc,{\[Tau],1/2},T,
Evaluate@ReleaseHold@ReplaceEverywhere[
Hold[args],{HoldPattern[t]->tloc,\[Tau]->tloc-t0}
]
],
opts
]
];


(* ::Input::Initialization:: *)
StandardizeGenerator[PeriodicFunction[{t_,ta_,tb_},T_,args_],opts___Rule]:=
Module[{tloc,\[Tau]},
StandardizeGenerator[ShapeFunction[tloc,{\[Tau],0},T,
Evaluate@ReleaseHold@ReplaceEverywhere[
Hold[args],{HoldPattern[t]->tloc,\[Tau]->t-ta}
]
],
opts
]
];


(* ::Input::Initialization:: *)
StandardizeGenerator[HoldPattern@Function[t:Except[_Rule],NonStandardNullGeneratorPattern,___Rule],opts___Rule]:=NullOperator[];


(* ::Input::Initialization:: *)
StandardizeGenerator[HoldPattern@PeriodicFunction[t:Except[_Rule],T:Except[_Rule],NonStandardNullGeneratorPattern,___Rule],opts___Rule]:=NullOperator[];


(* ::Input::Initialization:: *)
StandardizeGenerator[HoldPattern@ShapeFunction[t:Except[_Rule],\[Tau]xpairs_?MatrixQ,T:Except[_Rule],NonStandardNullGeneratorPattern,___Rule],opts___Rule]:=NullOperator[];


(* ::Input::Initialization:: *)
StandardizeGenerator[HoldPattern@ShapeFunction[args___],opts___Rule]/;!FreeQ[{args},$Failed]=$Failed;


(* ::Input::Initialization:: *)
StandardizeGenerator[HoldPattern@ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,expr_],opts___Rule]:=Module[{\[Tau]vars,\[Tau]loc,\[Tau]locvars,tloc},(
\[Tau]vars=First/@\[Tau]xpairs;
\[Tau]locvars=Array[\[Tau]loc,Length[\[Tau]vars]];
ShapeFunction[tloc,
Evaluate@Transpose[{\[Tau]locvars,Last/@\[Tau]xpairs}],
T,
Evaluate@StandardizeGenerator[
ReleaseHold@ReplaceEverywhere[Hold[expr],Join[
MapThread[Rule,{\[Tau]vars,\[Tau]locvars}],{HoldPattern[t]->tloc}]],
Evaluate@SimplifyRules[
CheckOperatorType->False,
CheckSuperoperatorType->False,
opts]
]
]
)];


(* ::Input::Initialization:: *)
StandardizeGenerator[BackgroundGenerator-> SO_]:=BackgroundGenerator-> StandardizeGenerator[SO]


(* ::Input::Initialization:: *)
StandardizeGenerator[ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,op_?SuperoperatorQ]]:=ShapeFunction[t,\[Tau]xpairs,T,StandardizeGenerator[op]];


(* ::Input::Initialization:: *)
StandardizeGenerator[SO:{___}]:=StandardizeGenerator/@SO;


(* ::Input::Initialization:: *)
StandardizeGenerator[SO_]:=SO/.{CommutationSuperoperator[Op___]:>CommutationSuperoperator[Total[StandardizeGenerator[(List@@ExpandAll[Op+"dummy"]/.{"dummy"-> Nothing}),"2"]]]}


(* ::Input::Initialization:: *)
StandardizeGenerator[SO:{___},"2"]:=1.*SO/.{\[Alpha]_?NumericQ Op_:>(N[\[Alpha]]/.{Complex[a_,b_]:>I* Sign[b]Abs[b],a_:> -I*Sign[a]Abs[a]})Op,\[Alpha]_?NumericQ Op_:> (N[\[Alpha]]/.{Complex[a_,0]:> -I*a})Op}


(* ::Input::Initialization:: *)
StandardizeGenerator[n1_?NumericQ,opts___Rule]/;MatchQ[n1,Except[0]]:=StandardizeGenerator[n1*UnityOperator[],opts];


(* ::Input::Initialization:: *)
StandardizeGenerator[evgen_?ValidGeneratorQ,opts___Rule]:=evgen;


(* ::Input::Initialization:: *)
StandardizeGenerator[StandardizeGenerator[evgen_,opts1___Rule],opts2___Rule]:=StandardizeGenerator[evgen,
SimplifyRules[opts1,opts2]
];


(* ::Input::Initialization:: *)
EvolutionGeneratorMatchQ[args___]:=(Message[EvolutionGeneratorMatchQ::usage];GeneratorMatchQ[args]);


(* ::Input::Initialization:: *)
GeneratorMatchQ[a_]=True;


(* ::Input::Initialization:: *)
GeneratorMatchQ[Hold[a_],Hold[a_]]:=True;


(* ::Input::Initialization:: *)
GeneratorMatchQ[Hold[a_],b_]:=GeneratorMatchQ[ReleaseHold[a],b];


(* ::Input::Initialization:: *)
GeneratorMatchQ[a_,Hold[b_]]:=ReleaseHold@GeneratorMatchQ[a,ReleaseHold[b]];


(* ::Input::Initialization:: *)
GeneratorMatchQ[op1_?OperatorQ,op2_?OperatorQ]:=MatchQ[op1,op2]||MatchQ[N@MatrixRepresentation[op1],N@MatrixRepresentation[op2]];


(* ::Input::Initialization:: *)
GeneratorMatchQ[sop1_?SuperoperatorQ,sop2_?SuperoperatorQ]:=MatchQ[sop1,sop2]||MatchQ[N@SuperoperatorMatrixRepresentation[sop1],N@SuperoperatorMatrixRepresentation[sop2]];


(* ::Input::Initialization:: *)
GeneratorMatchQ[a_,b:(_Function|_PeriodicFunction)]:=GeneratorMatchQ[a,StandardizeGenerator[b,ImplementMatrixRepresentation->False,CheckOperatorType->False,CheckSuperoperatorType->False]
];


(* ::Input::Initialization:: *)
GeneratorMatchQ[a:(_Function|_PeriodicFunction),b_]:=GeneratorMatchQ[StandardizeGenerator[a,ImplementMatrixRepresentation->False,CheckOperatorType->False,CheckSuperoperatorType->False],
b
];


(* ::Input::Initialization:: *)
GeneratorMatchQ[Except[_ShapeFunction],_ShapeFunction]:=False;


(* ::Input::Initialization:: *)
GeneratorMatchQ[_ShapeFunction,Except[_ShapeFunction]]:=False;


(* ::Input::Initialization:: *)
GeneratorMatchQ[a:Except[_ShapeFunction],b:Except[_ShapeFunction]]:=
MatchQ[
StandardizeGenerator[a,ImplementMatrixRepresentation->False,CheckOperatorType->False,CheckSuperoperatorType->False],StandardizeGenerator[b,ImplementMatrixRepresentation->False,CheckOperatorType->False,CheckSuperoperatorType->False]
];


(* ::Input::Initialization:: *)
GeneratorMatchQ[
shfunc1:ShapeFunction[t1_,\[Tau]xpairs1_?MatrixQ,T1_,func1_],
shfunc2:ShapeFunction[t2_,\[Tau]xpairs2_?MatrixQ,T2_,func2_]
]:=Module[{t,ta,tb},(
TrueQ[shfunc1[t,ta,tb]==shfunc2[t,ta,tb]]
)];


(* ::Input::Initialization:: *)
GeneratorMatchQ[evgen1_,evgen2_,evgens__,opts___Rule]:=
GeneratorMatchQ[evgen1,evgen2,opts]&&GeneratorMatchQ[evgen2,Sequence@@Rest[{evgens}],opts];


(* ::Input::Initialization:: *)
Options[HeldGeneratorSymbol]={ImplementMatrixRepresentation->True,CheckOperatorType->False,CheckSuperoperatorType->False};


(* ::Input::Initialization:: *)
HeldGeneratorSymbol[gen_?ValidGeneratorQ,opts___Rule]:=
Module[{evgensymbol,evgen,standevgen},(
standevgen=
StandardizeGenerator[gen,Evaluate@SimplifyRules[opts,Sequence@@Options[HeldGeneratorSymbol]]
];
evgensymbol=standevgen;
PermittedTimeShift[Hold@evgensymbol]=PermittedTimeShift[standevgen];
HilbertSpaceCompatibility[Hold@evgensymbol]=HilbertSpaceCompatibility[standevgen];
Hold@evgensymbol
)];


(* ::Input::Initialization:: *)
HeldGeneratorSymbol[gen_?(!ValidGeneratorQ[#])&,opts___Rule]:=
(Message[HeldGeneratorSymbol::inval];$Failed);


(* ::Input::Initialization:: *)
HeldGeneratorSymbol::inval="invalid evolution generator";


(* ::Input::Initialization:: *)
CombineEvolutionGenerators[args___]:=(Message[CombineEvolutionGenerators::usage];CombineGenerators[args]);


(* ::Input::Initialization:: *)
Options[CombineGenerators]={GeneratorsStandardized->False};


(* ::Input::Initialization:: *)
CombineGenerators[gens_List,opts___Rule]:=CombineGenerators[Sequence@@gens,opts];


(* ::Input::Initialization:: *)
CombineGenerators[a:Except[_Hold|_Rule]...,b_Hold,c:Except[_Hold|Rule]...,opts___Rule]:=CombineGenerators[a,ReleaseHold[b],c,opts];


(* ::Input::Initialization:: *)
CombineGenerators[items:Except[_Rule]..,opts___Rule]/;!(GeneratorsStandardized/.{opts}/.Options[CombineGenerators]):=
CombineGenerators[
Sequence@@(StandardizeGenerator/@{items}),
SimplifyRules[
GeneratorsStandardized->True,
opts
]
];


(* ::Input::Initialization:: *)
CombineGenerators[a:Except[_List],opts___Rule]:=StandardizeGenerator[a,
SimplifyRules[opts,Sequence@@Options[CombineGenerators]]
];


(* ::Input::Initialization:: *)
CombineGenerators[a:Except[_Rule],b:Except[_Rule],c:Except[_Rule]..,opts___Rule]:=CombineGenerators[CombineGenerators[a,b,opts],c,opts];


(* ::Input::Initialization:: *)
CombineGenerators[NullGeneratorPattern,item2_,opts___Rule]:=StandardizeGenerator[item2,SimplifyRules[opts,Sequence@@Options[CombineGenerators]]];


(* ::Input::Initialization:: *)
CombineGenerators[item1_,NullGeneratorPattern,opts___Rule]:=StandardizeGenerator[item1,SimplifyRules[opts,Sequence@@Options[CombineGenerators]]];


(* ::Input::Initialization:: *)
CombineGenerators[NullGeneratorPattern,NullGeneratorPattern,opts___Rule]:=NullOperator[];


(* ::Input::Initialization:: *)
CombineGenerators[op1_?OperatorQ,op2_?OperatorQ,opts___Rule]:=StandardizeGenerator[op1+op2,
SimplifyRules[opts,Sequence@@Options[CombineGenerators]]
];


(* ::Input::Initialization:: *)
CombineGenerators[op1_?OperatorQ,sop2_?SuperoperatorQ,opts___Rule]:=StandardizeGenerator[-I CommutationSuperoperator[op1]+sop2,
SimplifyRules[opts,Sequence@@Options[CombineGenerators]]
];


(* ::Input::Initialization:: *)
CombineGenerators[op1_?OperatorQ,f:(_Function|_PeriodicFunction),
opts___Rule]:=
CombineGenerators[op1,StandardizeGenerator[f,SimplifyRules[opts,Sequence@@Options[CombineGenerators]]]
];


(* ::Input::Initialization:: *)
CombineGenerators[op1_?OperatorQ,HoldPattern@ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,args2_],
opts___Rule]:=
ShapeFunction[t,\[Tau]xpairs,T,
Evaluate@CombineGenerators[op1,args2,opts]
];


(* ::Input::Initialization:: *)
CombineGenerators[sop1_?SuperoperatorQ,op2_?OperatorQ,opts___Rule]:=StandardizeGenerator[sop1-I CommutationSuperoperator[op2],SimplifyRules[opts,Sequence@@Options[CombineGenerators]]];


(* ::Input::Initialization:: *)
CombineGenerators[sop1_?SuperoperatorQ,sop2_?SuperoperatorQ,opts___Rule]:=StandardizeGenerator[sop1+sop2,SimplifyRules[opts,Sequence@@Options[CombineGenerators]]];


(* ::Input::Initialization:: *)
CombineGenerators[sop1_?SuperoperatorQ,f:(_Function|_PeriodicFunction),
opts___Rule]:=CombineGenerators[sop1,StandardizeGenerator[f,SimplifyRules[opts,Sequence@@Options[CombineGenerators]]]];


(* ::Input::Initialization:: *)
CombineGenerators[sop1_?SuperoperatorQ,HoldPattern@ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,args2_],opts___Rule]:=
ShapeFunction[t,\[Tau]xpairs,T,Evaluate@CombineGenerators[sop1,args2,opts]
];


(* ::Input::Initialization:: *)
CombineGenerators[
evgen1:(_Function|_PeriodicFunction),
evgen2_,
opts___Rule
]:=
CombineGenerators[
StandardizeGenerator[evgen1,SimplifyRules[opts,Sequence@@Options[CombineGenerators]]
],
evgen2,
opts
];


(* ::Input::Initialization:: *)
CombineGenerators[
evgen1:HoldPattern@ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,expr_],
evgen2:(_Function|_PeriodicFunction),
opts___Rule
]:=
CombineGenerators[
evgen1,
StandardizeGenerator[evgen2,SimplifyRules[opts,Sequence@@Options[CombineGenerators]]],
opts
];


(* ::Input::Initialization:: *)
CombineGenerators[
HoldPattern@ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,expr_],
evgen:Except[_ShapeFunction],
opts___Rule
]:=
ShapeFunction[
t,\[Tau]xpairs,T,
Evaluate@CombineGenerators[expr,evgen,opts]
];


(* ::Input::Initialization:: *)
CombineGenerators[
func1:HoldPattern@ShapeFunction[t1_,\[Tau]xpairs1_?MatrixQ,T1_,args1_],
func2:HoldPattern@ShapeFunction[t2_,\[Tau]xpairs2_?MatrixQ,T2_,args2_],
opts___Rule
]:=
Module[{t3,\[Tau]vars1,\[Tau]loc1,\[Tau]locvars1,\[Tau]vars2,\[Tau]loc2,\[Tau]locvars2},(
\[Tau]vars1=First/@\[Tau]xpairs1;
\[Tau]locvars1=Array[\[Tau]loc1,Length[\[Tau]vars1]];
\[Tau]vars2=First/@\[Tau]xpairs2;
\[Tau]locvars2=Array[\[Tau]loc2,Length[\[Tau]vars2]];
ShapeFunction[t3,
Evaluate@Join[
Transpose[{\[Tau]locvars1,Last/@\[Tau]xpairs1}],
Transpose[{\[Tau]locvars2,Last/@\[Tau]xpairs2}]
],
Evaluate@CommonPeriod[T1,T2],
Evaluate@
CombineGenerators[
ReleaseHold@ReplaceEverywhere[Hold[args1],Join[{HoldPattern[t1]->t3},MapThread[Rule,{\[Tau]vars1,\[Tau]locvars1}]]],
ReleaseHold@ReplaceEverywhere[Hold[args2],Join[{HoldPattern[t2]->t3},MapThread[Rule,{\[Tau]vars2,\[Tau]locvars2}]]],
opts
]
]
)];


(* ::Input::Initialization:: *)
CommonPeriod[a_,opts___Rule]:=a


(* ::Input::Initialization:: *)
CommonPeriod[a_,All,opts___Rule]:=a


(* ::Input::Initialization:: *)
CommonPeriod[All,a_,opts___Rule]:=a


(* ::Input::Initialization:: *)
CommonPeriod[a_,None,opts___Rule]:=None


(* ::Input::Initialization:: *)
CommonPeriod[None,a_,opts___Rule]:=None


(* ::Input::Initialization:: *)
CommonPeriod[a_,a_,opts___Rule]:=a;


(* ::Input::Initialization:: *)
CommonPeriod[a_?NumericQ,b_?NumericQ,opts___Rule]:=
Module[{ratio},(
ratio=Rationalize[a/b];
Denominator[ratio]*a
)];


(* ::Input::Initialization:: *)
CommonPeriod[a_,b_,c__,opts___Rule]:=
CommonPeriod[CommonPeriod[a,b,opts],c,opts];


(* ::Input::Initialization:: *)
HoldPattern@CommonPeriod[a_,CommonPeriod[b_,c_,opts1___Rule],opts2___Rule]:=
Module[{union},(
CommonPeriod[Sequence@@union,SimplifyRules[opts1,opts2]]
)/;(
union=Union[{a,b,c}];
TrueQ[Length[union]<3]
)];


(* ::Input::Initialization:: *)
HoldPattern@CommonPeriod[CommonPeriod[a_,b_,opts1___Rule],c_,opts2___Rule]:=
Module[{union},(
CommonPeriod[Sequence@@union,SimplifyRules[opts1,opts2]]
)/;(
union=Union[{a,b,c}];
TrueQ[Length[union]<3]
)];


(* ::Input::Initialization:: *)
Options[LocalGeneratorSymbols]={TargetFunctions->{_Function,_PeriodicFunction,_ShapeFunction}};


(* ::Input::Initialization:: *)
LocalGeneratorSymbols[opts___Rule]={};


(* ::Input::Initialization:: *)
LocalGeneratorSymbols[arg_,opts___Rule]:=
Module[{targetpattern},(
targetpattern=Alternatives@@(TargetFunctions/.{opts}/.Options[LocalGeneratorSymbols]);
Union@Flatten[
LocalGeneratorSymbols/@Cases[{arg},targetpattern,Infinity]
]
)/;(
targetpattern=Alternatives@@(TargetFunctions/.{opts}/.Options[LocalGeneratorSymbols]);
!MatchQ[arg,targetpattern]
)
];


(* ::Input::Initialization:: *)
LocalGeneratorSymbols[HoldPattern@Function[arg_,___Rule],___Rule]:={};


(* ::Input::Initialization:: *)
LocalGeneratorSymbols[HoldPattern@Function[t_,more:Except[_Rule]..,___Rule],___Rule]:={t};


(* ::Input::Initialization:: *)
LocalGeneratorSymbols[f_PeriodicFunction,___Rule]:={First[f]};


(* ::Input::Initialization:: *)
LocalGeneratorSymbols[f_ShapeFunction,___Rule]:=Union@Flatten@({#[[1]],First/@(#[[2]])}&@f);


(* ::Input::Initialization:: *)
Options[Liouvillian]={CheckOperatorType->False,CheckSuperoperatorType->False};


(* ::Input::Initialization:: *)
Liouvillian[a_,b:Except[_Rule]..,opts___Rule]:=Liouvillian[{a,b},opts];


(* ::Input::Initialization:: *)
Liouvillian[evgens_List,opts___Rule]:=
Liouvillian[
CombineGenerators[evgens,
SimplifyRules[opts,Sequence@@Options[Liouvillian]]
],
SimplifyRules[opts,Sequence@@Options[Liouvillian]]
];


(* ::Input::Initialization:: *)
Liouvillian[NullGeneratorPattern,opts___Rule]:=Superoperator[NullSuperoperator[]];


(* ::Input::Initialization:: *)
Liouvillian[ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,evgen_?ValidGeneratorQ],opts___Rule]:=ShapeFunction[t,\[Tau]xpairs,T,Evaluate@Liouvillian[evgen,CheckSuperoperatorType->False,opts]];


(* ::Input::Initialization:: *)
Liouvillian[op_?OperatorQ,opts___Rule]/;!MatchQ[op,_Operator]:=
Liouvillian[
Operator[op,
Sequence@@FilterRules[
Join[{opts},Options[Liouvillian]],
Options[Operator]
],
opts
],
opts
];


(* ::Input::Initialization:: *)
Liouvillian[op_Operator,opts___Rule]/;(CheckOperatorType/.{opts}/.Options[Liouvillian])&&!MatchQ[OperatorType[op],"Hermitian"]:=
(Message[Liouvillian::notherm];
Liouvillian[op,
SimplifyRules[
CheckOperatorType->False,
opts
]
]);


(* ::Input::Initialization:: *)
Liouvillian[O:Operator[{X_?MatrixQ,evals_List,Xinv_?MatrixQ},basis_,opopts___Rule],opts___Rule]:=
CommutationSuperoperator[Operator[{X,-I*evals,Xinv},basis,SimplifyRules[OperatorType->"AntiHermitian",opopts]],Assumptions->{OperatorType->"AntiHermitian"}];


(* ::Input::Initialization:: *)
Liouvillian[op_Operator,opts___Rule]:=
CommutationSuperoperator[-I op,Assumptions->{OperatorType->"AntiHermitian"}];


(* ::Input::Initialization:: *)
Liouvillian[sop_?SuperoperatorQ,opts___Rule]:=
Superoperator[sop,
SimplifyRules[
opts,
Sequence@@Options[Liouvillian]
]
];


(* ::Input::Initialization:: *)
Liouvillian[evgen:Except[_?ValidGeneratorQ],opts___Rule]:=(Message[Liouvillian::inval,evgen];$Failed);


(* ::Input::Initialization:: *)
Liouvillian::inval="Invalid generator: `1`";


(* ::Input::Initialization:: *)
Liouvillian::notherm="A non-Hermitian operator has been detected during the construction of the Liouvillian. Continuing anyway.";


(* ::Input::Initialization:: *)
End[];
EndPackage[];



