(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["SD`Propagation`",
{"Global`",
"SpinDynamica`",
"General`UserLevel`",
(*"General`ModifyBuiltIn`",*)
"General`Matrices`",
"General`Miscellaneous`",
"QM`Hilbert`",
"QM`SpinOperators`",
"QM`Liouville`",
"SD`Generators`",
"SD`Approximations`",
"SD`Propagation`",
"Events`Events`",
"Events`PulseSequence`",
"Interactions`Interactions`",
"Interactions`Hamiltonians`",
"Interactions`Relaxation`",
"Signals`Signal`",
"Rotations`Wigner`",
"Units`",
"General`PhysicalConstants`"}];


(* ::Input::Initialization:: *)
Continuous::usage="The option Continuous\[Rule]True may be used in NPropagate or NPropagationOperator to provide an interpolation function which may be evaluated at any time point within the propagation interval.";


(* ::Input::Initialization:: *)
NPropagate::usage="NPropagate[EventsAndTimings, opts][\[Rho]ini] propagates an initial density operator \[Rho]ini under a consecutive sequence of events, returning the final density operator. If \[Rho]ini is a vector representation, the output is also a vector representation. If \[Rho]ini is a symbolic operator, the output is also a symbolic operator. If opts contains Continuous\[Rule]True, the output is a OperatorTrajectoryFunction which may be evaluated at any time point within the timing range of the propagation. The options InitialTimePoint\[Rule]tini or FinalTimePoint\[Rule]tfin may be given to specify the time origin of the event sequence. 

	The item EventsAndTimings is a list of events. The possible formats for each event are:
(i) a single superoperator, assumed to act instantaneously;
(ii) have the form {Hop,\[Tau]} where Hop is a time-independent Hamiltonian operator, acting over the interval \[Tau];
(iii) have the form {Lsop,\[Tau]}, where Lsop is a time-independent Liouvillian superoperator, acting over the interval \[Tau];
(iv) the form {Function[t,f[t]],\[Tau]} where f[t] is an operator or superoperator expression dependent on the time variable t. The time-dependent operator or superoperator acts over the interval \[Tau];
(v) the form {PeriodicFunction[t,T,f[t]],\[Tau]} where f[t] is a periodic operator or superoperator expression with period T.  The periodic time-dependent operator or superoperator acts over the interval \[Tau];
(vi) the form {ShapeFunction[..],\[Tau]} where the ShapeFunction object allows specification of a time-dependent Hamiltonian or Liouvillian dependent on either a global or local time variable, or both. 

	The call to NPropagate may include options for the NDSolve routine, used in cases (iv) and (v). The operator basis used in the calculation may be specified if desired using the OperatorBasis option.
	
	The option BackgroundGenerator\[Rule]background may be used in NPropagate. The term background may be an operator, a superoperator, an operator function, and so on (the format is the same as any of the individual events). When this option is used, the term background is combined with all of the items in the sequence of events. 

	The two options UseMatrixExpWhenPossible, UseHilbertSpaceWhenPossible and UseDiagonalizationWhenPossible may be used to control the propagation strategy. These options take the values True or False.

	The output of NPropagate is an operator, for the case Continuous\[Rule]False, or an OperatorTrajectoryFunction, for the case Continuous\[Rule]True.
";


(* ::Input::Initialization:: *)
UseMatrixExpWhenPossible::usage="UseMatrixExpWhenPossible is an option for NPropagate and associated routines. When set to True, propagation will use the matrix exponential to calculate the propagator under a time-independent event, rather than using a numerical solution of the time-dependent Schr\[ODoubleDot]dinger equation.";


(* ::Input::Initialization:: *)
UseDiagonalizationWhenPossible::usage="UseDiagonalizationWhenPossible is an option for NPropagate and associated routines.  When set to True, propagation will diagonalize the Liouvillian or Hamiltonian for a time-independent event, rather than using a numerical solution of the time-dependent Schr\[ODoubleDot]dinger equation.";


(* ::Input::Initialization:: *)
UseHilbertSpaceWhenPossible::usage="UseHilbertSpaceWhenPossible is an option for NPropagate and associated routines.  When set to True, propagation under Hamiltonian events will be calculated in Hilbert space, rather than in Liouville space, whenever possible.";


(* ::Input::Initialization:: *)
NPropagationOperator::usage="NPropagationOperator[events, opts] generates the unitary Operator for propagation under the specified events. The options opts may include a specification for Basis and options to be passed into NDSolve.

The output of NPropagate is an operator, for the case Continuous\[Rule]False, or an OperatorTrajectoryFunction, for the case Continuous\[Rule]True.
";


(* ::Input::Initialization:: *)
NPropagationSuperoperator::usage="NPropagationSuperoperator[EventSpecifications, opts] generates the Superoperator for propagation under the specified EventSpecifications. The options opts may include a specification for OperatorBasis, Basis and options to be passed into NDSolve.";


(* ::Input::Initialization:: *)
CorrelatedEigensystems::usage="Correlated Eigensystem allows the calculation of the correlated eigenvalues and eigenvectors of a parameter-dependent Hamiltonian, H(x)= \!\(\*SubscriptBox[\(H\), \(0\)]\) + \!\(\*SubscriptBox[\(H\), \(1\)]\)(x). 
	The syntax of CorrelatedEigensystems is given by: CorrelatedEigensystems[\!\(\*SubscriptBox[\(H\), \(1\)]\)(x), range, opts].
	The range specifications could be of the type {x, \!\(\*SubscriptBox[\(x\), \(a\)]\), \!\(\*SubscriptBox[\(x\), \(b\)]\), \[Delta]x} or {x, {\!\(\*SubscriptBox[\(x\), \(1\)]\), \!\(\*SubscriptBox[\(x\), \(2\)]\), ..., \!\(\*SubscriptBox[\(x\), \(N\)]\)}}.
	CorrelatedEigensystems returns a two-element list: {correvals,correvecs}. 
	The correlated eigenvalues take the form:{{{\!\(\*SubscriptBox[\(x\), \(1\)]\), \!\(\*SubscriptBox[\(\[Lambda]\), \(1\)]\)}, {\!\(\*SubscriptBox[\(x\), \(2\)]\), \!\(\*SubscriptBox[\(\[Lambda]\), \(1\)]\)}, ...}, {{\!\(\*SubscriptBox[\(x\), \(1\)]\), \!\(\*SubscriptBox[\(\[Lambda]\), \(2\)]\)}, {\!\(\*SubscriptBox[\(x\), \(2\)]\), \!\(\*SubscriptBox[\(\[Lambda]\), \(2\)]\)}, ...} ...} and may readily be plotted using ListPlot. The correlated eigenvectors take the form: {{\!\(\*SubscriptBox[\(x\), \(1\)]\), {\!\(\*SubscriptBox[\(v\), \(1\)]\), \!\(\*SubscriptBox[\(v\), \(2\)]\),..., \!\(\*SubscriptBox[\(v\), \(N\)]\)}}, {\!\(\*SubscriptBox[\(x\), \(2\)]\), {\!\(\*SubscriptBox[\(v\), \(1\)]\), \!\(\*SubscriptBox[\(v\), \(2\)]\),..., \!\(\*SubscriptBox[\(v\), \(N\)]\)}}, ...}.
	The options include {BackgroundGenerator, Basis} to specify a constant Hamiltonian acting in the background and to define a starting Basis if desired.";


(* ::Input::Initialization:: *)
ReturnKets::usage="Internal SpinDynamica option for CorrelatedEigensystems";


(* ::Input::Initialization:: *)
AdiabaticPropagation::usage="Internal SpinDynamica function responsible for adiabatic propagation.";


(* ::Input::Initialization:: *)
dynamicphase::usage="Internal SpinDynamica function responsible for calculation of dynamic phase factors during an adiabatic process.";


(* ::Input::Initialization:: *)
geometricphase::usage="Internal SpinDynamica function responsible for calculation of geometric phase factors during an adiabatic process.";


(* ::Input::Initialization:: *)
phasesmoothing::usage="Internal SpinDynamica function related to the calculation of geometric phase factors during an adiabatic process.";


(* ::Input::Initialization:: *)
OperatorTrajectoryFunction::usage="OperatorTrajectoryFunction[timerange,trajectory] is a function which provides an operator when evaluated at any time point within timerange. It is provided as the output of a NPropagate or NPropagationOperator evaluation with option Continuous\[Rule]True.";


(* ::Input::Initialization:: *)
Precalculate::usage="Precalculate[events, options] calculates the propagator for a set of events and stores it as a PrecalculatedEvent object for future use. The output is a PrecalculatedEvent object. This may save calculation time in some cases. The options may contain a rule of the form BackgroundGenerator\[Rule]<backgen>. This uses the specified background generator <backgen> when calculating the propagator for the event. A PrecalculatedEvent may only be used in a context for which the BackgroundGenerator is the same as that applying when the PrecalculatedEvent was constructed. 
The option Precalculate\[Rule]True or Precalculate\[Rule]False is also used as an option for some propagation routines to indicate whether an attempt is made to detect and precalculate common events, in order to reduce computation time.";


(* ::Input::Initialization:: *)
$Chronology="LeftToRight";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
SortVectorSpaceCompatibility[ev:EventList[st_,chars_,events:{_Event..},evlistopts___Rule],opts___Rule]:=Module[{eventsig,splitevents},
splitevents=SplitBy[events,HilbertSpaceCompatibility[#,opts]&];
eventsig=(HilbertSpaceCompatibility[#]&/@splitevents);
SortVectorSpaceCompatibility[(Transpose@{eventsig,splitevents})]
]

SortVectorSpaceCompatibility[{A:{__},B:{__}..}]:=Join[SortVectorSpaceCompatibility[A],SortVectorSpaceCompatibility[{B}]];
SortVectorSpaceCompatibility[{stat_,ev:{__}}]:={stat,#}&/@ev;
SortVectorSpaceCompatibility[{{stat_,ev:{__}}}]:={stat,#}&/@ev;


(* ::Input::Initialization:: *)
HilbPropToLiouvProp[k_.*A:(_Operator|_RotationOperator|_OperatorProduct),basis_,opts___Rule]:=Module[{Ufw,Ubw},
Ufw=MatrixRepresentation[k*A,ZeemanBasis[]];
Ubw=If[UnitaryMatrixQ[Ufw]==True,ConjugateTranspose@Ufw,Inverse@Ufw];
Superoperator[KroneckerProduct[Ufw,Transpose@Ubw],ZeemanKetBraOperatorBasis[],basis,
Sequence@@FilterRules[Join[{opts},{CheckOperatorType-> False},Options[NPropagationSuperoperator]],Options[Superoperator]]]
];

HilbPropToLiouvProp[A:(_Superoperator),basis_,opts___Rule]:=A;


(* ::Input::Initialization:: *)
Options[NPropagate]={
OperatorBasis:>ZeemanKetBraOperatorBasis[],
Basis:>ZeemanBasis[],
Continuous->False,
UseMatrixExpWhenPossible->True,
UseDiagonalizationWhenPossible->Automatic,
UseHilbertSpaceWhenPossible->True,
BackgroundGenerator->None,
ExpandRepeatedEvents->Automatic,
PropagatorCalculationProcedure->None,
InitialTimePoint->0,
Method->Automatic,
AccuracyGoal->Automatic,
PrecisionGoal->Automatic,
MaxStepSize->Automatic,
MaxSteps->Automatic,
Chronology:>$Chronology
};


(* ::Input::Initialization:: *)
NPropagate[arg1:Except[_?BooleanQ|{_?BooleanQ..}],args2___,opts___Rule][\[Rho]_]:=
NPropagate[False,arg1,args2,opts][\[Rho]];


(* ::Input::Initialization:: *)
CheckFlagDimension[NPropagate]=6;


(* ::Input::Initialization:: *)
NPropagate[False,args___][\[Rho]_]:=NPropagate[Table[False,{CheckFlagDimension[NPropagate]}],args][\[Rho]];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,{True..},args___]:=NPropagate[\[Rho],True,args];


(* ::Input::Initialization:: *)
NPropagate[{False,morestatus___},arg1:Except[_?BooleanQ],args2:Except[_Rule]...,opts___Rule][\[Rho]_]:=NPropagate[\[Rho],{OperatorQ[\[Rho]],morestatus},arg1,args2,opts];

NPropagate[\[Rho]_,{False,morestatus___},events_,opts___Rule]:=Message[NPropagate::bad\[Rho]];$Failed;


(* ::Input::Initialization:: *)
NPropagate[arg1:Except[True],args___]/;!FreeQ[{arg1,args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,status:{_?BooleanQ..},events_,opts___Rule]:=NPropagate[\[Rho],status,
Continuous/.{opts}/.Options[NPropagate],
events,
Sequence@@FilterRules[{opts},Except[Continuous->_]]];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,status:{_?BooleanQ..},cont_?BooleanQ,({}|UnityOperator[]|UnitySuperoperator[]),opts___Rule]:=\[Rho];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,status:{_?BooleanQ..},cont_?BooleanQ,events_,opts___Rule]:=
NPropagate[\[Rho],status,cont,events,OperatorBasis/.{opts}/.Options[NPropagate],Basis/.{opts}/.Options[NPropagate],opts];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,status:{_?BooleanQ..},cont_?BooleanQ,events_,opbasis_,basis_,opts___Rule]/;(SpinSystem[]==SpinSystemUnknown):=(Message[SpinSystem::notready];$Failed);


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,status:{_?BooleanQ..},cont_?BooleanQ,events_,opbasis_,basis_,opts___Rule]/;!DefinedOperatorBasisQ[opbasis]:=
(
Message[NPropagate::undefopbasis,opbasis];
NPropagate[\[Rho],status,cont,events,OperatorBasis[],basis,opts]
);


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,status:{_?BooleanQ..},cont_?BooleanQ,events_,opbasis_,basis_,opts___Rule]/;!DefinedBasisQ[basis]:=
(
Message[NPropagate::undefbasis,basis];
NPropagate[\[Rho],status,cont,events,opbasis,Basis[],opts]
);


(* ::Input::Initialization:: *)
HoldPattern@NPropagate[\[Rho]_,status:{True,False,morestatus___},cont_?BooleanQ,events_,opbasis_,basis_,opts___Rule]:=
Module[{evbackg,evbackgstd},(
evbackg=BackgroundGenerator/.{opts}/.Options[NPropagate];
evbackg=If[MatchQ[evbackg,_[{_?MatrixQ,_?VectorQ,_?MatrixQ},___]],NDiagonalize[evbackg],evbackg];
evbackgstd=StandardizeGenerator[evbackg];
NPropagate[\[Rho],{True,True,morestatus},cont,events, opbasis,basis,
Evaluate@SimplifyRules[
BackgroundGenerator->Switch[evbackgstd,
Except[_Hold|NullGeneratorPattern],
	HeldGeneratorSymbol[evbackgstd],
	_,evbackgstd
],Parallel-> False,
opts
]
]
)];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,status:{True,True,False,morestatus___},cont_?BooleanQ,events:Except[_PulseSequence],more:(Except[_Rule]...),opts___Rule]/;PulseSequenceQ[events]:=NPropagate[\[Rho],status,cont,PulseSequence[events,opts],more,opts];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,status:{True,True,False,morestatus___},cont_?BooleanQ,events:Except[EventList[True|{True,_},___]],more:(Except[_Rule]...),opts___Rule]:=NPropagate[\[Rho],
{True,True,False,morestatus},cont,
EventList[events,
SimplifyRules[
Chronology->(Chronology/.{opts}/.Options[NPropagate]),
ImplementBackgroundGenerator->True,
ExpandRepeatedEvents->If[cont,True,
ExpandRepeatedEvents/.{opts}/.Options[NPropagate]
],
Sequence@@FilterRules[
Join[{opts},Options[NPropagate]],
Join[Options[EventList],Options[NDSolve]]
]
]
],
more,opts
];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,status:{True,True,False,morestatus___},cont_?BooleanQ,eventlist:EventList[True|{True,_},___],more:(Except[_Rule]...),opts___Rule]:=
NPropagate[\[Rho],{True,True,True,morestatus},cont,eventlist,more,opts];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,status:{True,True,True,False,morestatus___},cont_?BooleanQ,
eventlist_EventList,opbasis_,basis_,opts___Rule]:=NPropagate[\[Rho],{True,True,True,True,morestatus},cont,HilbertSpaceCompatibility[eventlist],
eventlist,opbasis,basis,opts];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,checkflags:{_,_,_,_,False,morecheckflags__},args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,checkflags:{True,True,True,True,False,morecheckflags__},args___]/;FreeQ[{args},$Failed]:=NPropagate[\[Rho],{True,True,True,True,True,morecheckflags},args];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,status:{True,True,True,True,True,False,morestatus___},cont_?BooleanQ,Hstat_,eventlist:EventList[Except[True|{True..}],___],more___,opts___Rule]:=
Module[{suspsymbols},(
Message[NPropagate::argnotready];
ReportSuspectSymbols[{eventlist,more}];
$Failed
)];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,status:{True,True,True,True,True,False,morestatus___},cont_?BooleanQ,Hstat_,eventlist:EventList[True|{True,True},___],more___]:=NPropagate[\[Rho],{True,True,True,True,True,True,morestatus},cont,Hstat,eventlist,more];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,False,True,EventList[st_,chars_,events:{_Event..},evlistopts___Rule],opbasis_,basis_,opts___Rule]:=Module[{zbmatreps,\[Rho]matrep,Ufw,Ubw},(
\[Rho]matrep=MatrixRepresentation[\[Rho],basis];
zbmatreps=MatrixRepresentation[NPropagate[True,False,True,#,opbasis,basis,opts],basis]&/@events;
Ufw=If[Length[zbmatreps]==1,First@zbmatreps,Fold[Dot,First@zbmatreps,Drop[zbmatreps,1]]];
Ubw=If[UnitaryMatrixQ[Ufw]==True,ConjugateTranspose@Ufw,SparseArray@Inverse@Ufw];
Operator[Chop@Dot[Ufw,\[Rho]matrep,Ubw],basis,Sequence@@FilterRules[{opts},Options[Operator]]]
)];



(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,False,(MixedHilbertSpaceCompatibility|False),ev:EventList[st_,chars_,events:{_Event..},evlistopts___Rule],opbasis_,
basis_,opts___Rule]:=Module[{\[Rho]final,sortedevents,zbmatreps},(
sortedevents=Reverse[SortVectorSpaceCompatibility[ev]];
\[Rho]final=Fold[NPropagate[#1,#2,opbasis,basis,opts]&,\[Rho],sortedevents]
)];

NPropagate[\[Rho]_,{True,event:_Event},opbasis_,basis_,opts___Rule]:=Module[{\[Rho]mat,Ufw,Ubw},(
\[Rho]mat=MatrixRepresentation[\[Rho],basis];
Ufw=MatrixRepresentation[NPropagate[True,False,True,event,opbasis,basis,opts],basis];
Ubw=If[UnitaryMatrixQ[Ufw]==True,ConjugateTranspose@Ufw,Inverse@Ufw];
Operator[SparseArray@Chop@N@Dot[Ufw,\[Rho]mat,Ubw],basis,Sequence@@FilterRules[{opts},Options[Operator]]
]
)];

NPropagate[\[Rho]_,{False,event:_Event},opbasis_,basis_,opts___Rule]:=NPropagate[\[Rho],True,False,False,event,opbasis,basis,opts]


(* ::Input::Initialization:: *)
NPropagate[True,False,True,Event[True|{True,True},{_,_,True,None,__},_,___Rule],opbasis_,basis_,opts___Rule]:=UnityOperator[];


(* ::Input::Initialization:: *)
NPropagate[True,False,True,Event[True|{True,True},{{T_,__},_,True,IntegrateEvolutionOverTime,__},
{_,_},___Rule],opbasis_,basis_,opts___Rule]/;(Chop[T]==0):=UnityOperator[];


(* ::Input::Initialization:: *)
NPropagate[True,False,True,Event[True|{True,True},{{T_,__},_,_,IntegrateEvolutionOverTime,__},{ShapeFunction[___, NullGeneratorPattern],_},___Rule],opbasis_,basis_,opts___Rule]:=UnityOperator[];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,False,False,Event[True|{True,True},{_,_,True,None,__},_,___Rule],opbasis_,basis_,opts___Rule]:=\[Rho];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,False,False,Event[True|{True,True},{{T_,__},_,True,IntegrateEvolutionOverTime,__},
{_,_},___Rule],opbasis_,basis_,opts___Rule]/;(Chop[T]==0):=\[Rho];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,False,False,Event[True|{True,True},{{T_,__},_,_,IntegrateEvolutionOverTime,__},{ShapeFunction[___, NullGeneratorPattern],_},___Rule],opbasis_,basis_,opts___Rule]:=\[Rho];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,False,False,Event[True|{True,True},{_,_,_,InstantaneousTransformation,__},{UnitySuperoperator[___],___},___Rule],opbasis_,basis_,opts___Rule]:=\[Rho];


(* ::Input::Initialization:: *)
NPropagate[True,False,True,Event[st:(True|{True,True}),ch:{_,_,_,IntegrateEvolutionOverTime,__},{CommutationSuperoperator[op_,___Rule],\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]:=
NPropagate[True,False,True,Event[st,ch,{op/.{Complex[a_,b_]:>(a-b)},\[Tau]},evopts],opbasis,basis,opts];


(* ::Input::Initialization:: *)
(*NPropagate[True,False,True,Event[st:(True|{True,True}),ch:{_,_,_,IntegrateEvolutionOverTime,__},{Hop:HoldPattern@Operator[{_?MatrixQ,_List,_?MatrixQ},basis1_,opts1___Rule],\[Tau]_},evopts___Rule],opbasis_,basis2_,opts___Rule]:=
Module[{X,evals,Xinv},(
Hop=If[basis1==basis2,Hop,NDiagonalize[Hop,basis2,opts1]];
{X,evals,Xinv}=First@Hop;
Operator[
SparseArray@Chop[X.DiagonalMatrix[Exp[-I*\[Tau]*#]&/@evals].Xinv],
basis2,
Sequence@@FilterRules[
Join[{opts},Options[NPropagate]],
Options[Operator]
]
]
)];*)


(* ::Input::Initialization:: *)
NPropagate[True,False,True,Event[st:(True|{True,True}),ch:{_,_,_,IntegrateEvolutionOverTime,__},{Hop_?OperatorQ,\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]/;(UseMatrixExpWhenPossible/.{opts}/.Options[NPropagate]):=
Module[{matrep},(
matrep=(-I MatrixRepresentation[Hop,basis]* \[Tau])/.{evopts,opts};
Operator[
SparseArray@Chop@N@MatrixExp[N@matrep],
basis,
Sequence@@FilterRules[
Join[{opts},Options[NPropagate]],
Options[Operator]
]
]
)];


(* ::Input::Initialization:: *)
NPropagate[True,False,True,Event[st:(True|{True,True}),ch:{T_,_,_,IntegrateEvolutionOverTime,__},{Hop_?OperatorQ,\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]/;(!UseMatrixExpWhenPossible/.{opts}/.Options[NPropagate]):=
NPropagate[True,False,True,Event[st,ch,{StandardizeGenerator[Function[t,Evaluate[Hop]],Basis->basis],\[Tau]},evopts],opbasis,basis,opts];


(* ::Input::Initialization:: *)
NPropagate[True,False,True,ev:Event[
st:(True|{True,True}),ch_,
{Lfunc:ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,CommutationSuperoperator[op_,___Rule]],\[Tau]_},
evopts___Rule],opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]&&BackgroundGeneratorImplemented[ev]:=
NPropagate[True,False,True,Event[st,ch,{ShapeFunction[t,\[Tau]xpairs,T,op/.{Complex[a_,b_]:>(a-b)}],\[Tau]},evopts],opbasis,basis,opts];


(* ::Input::Initialization:: *)
NPropagate[True,False,True,ev:Event[st:(True|{True,True}),ch:{{_,{tb_,ta_},moretch___},__},{Hfunc:ShapeFunction[args__,op_?OperatorQ],\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]&&BackgroundGeneratorImplemented[ev]:=Module[{Hmatfunc,NDSolveopts,n,u,uvec,uvecplain,uvecflat,umat,h,hvec,hmat,t$,sol},(
Hmatfunc=
Function[tinternal,
Evaluate[
Normal@MatrixRepresentation[Hfunc[tinternal,ta,tb]/.{evopts,opts},basis]
]
];
NDSolveopts=Sequence@@FilterRules[SimplifyRules[{evopts,opts}],Options[NDSolve]];
n=BasisDimension[basis];
uvec[t$_]:=Evaluate[Array[u[#1,#2][t$]&,{n,n}]];
uvecflat[t$_]:=Evaluate[Flatten[Array[u[#1,#2][t$]&,{n,n}]]];
uvecplain=Evaluate[Array[u[#1,#2]&,{n,n}]];
sol=NDSolveValue[{D[uvecflat[t$],t$]==-I (Flatten[Hmatfunc[t$].uvec[t$]]),uvecflat[ta]==Flatten[IdentityMatrix[n]]},uvecplain,{t$,ta,tb},NDSolveopts];
Operator[SparseArray[Chop[N[Through[#[tb]]&/@sol]]],basis,Sequence@@FilterRules[
Join[{opts},Options[NPropagate]],
Options[Operator]
]
])
]


(* ::Input::Initialization:: *)
NPropagate[
True,False,True,
Event[True|{True,True},
{_,_,_,InstantaneousTransformation,__},
{RotationSuperoperator[args___],___},___Rule],opbasis_,
basis_,opts___Rule]:=RotationOperator[args]


(* ::Input::Initialization:: *)
NPropagate[
True,False,True,
Event[True|{True,True},
{_,_,_,InstantaneousTransformation,__},
{R:Dot[RotationSuperoperator[___],RotationSuperoperator[___]..],___},___Rule],opbasis_,
basis_,opts___Rule]:=R/.{RotationSuperoperator-> RotationOperator}


(* ::Input::Initialization:: *)
HoldPattern@NPropagate[True,False,True,ev:Event[st:(True|{True,True}),ch_,Repeat[EventList[st_,chars_,events:{_Event..},evlistopts___Rule],n_Integer,evtropts___Rule],
evopts___Rule],opbasis_,basis_,opts___Rule]/;
MatchQ[PropagatorCalculationProcedure[ev],RepeatPropagator]&&BackgroundGeneratorImplemented[ev]:=
Module[{zbmatreps,singleprop},(
zbmatreps=MatrixRepresentation[NPropagate[True,False,True,#,opbasis,basis,opts],basis]&/@events;
singleprop=If[Length[zbmatreps]==1,First@zbmatreps,Fold[Dot,First@zbmatreps,Drop[zbmatreps,1]]];
Operator[MatrixPower[singleprop,n],basis,
Sequence@@FilterRules[
Join[{opts},Options[NPropagate]],
Options[Operator]
]
]
)];


(* ::Input::Initialization:: *)
NPropagate[True,False,True,ev:Event[st:(True|{True,True}),ch_,PrecalculatedEvent[precalch_,op_Operator,precalevopts___Rule],
evopts___Rule],opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],UsePrecalculatedPropagator]:=op;


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,False,False,Event[True|{True,True},{_,_,_,InstantaneousTransformation,__},{InstaOp_,___},___Rule],opbasis_,
basis_,opts___Rule]:=InstaOp[\[Rho]];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,False,False,Event[st:(True|{True,True}),ch:{_,_,_,IntegrateEvolutionOverTime,__},{Lsop:HoldPattern@Superoperator[{_?MatrixQ,_List,_?MatrixQ},opbasis1_,basis1_,___Rule],\[Tau]_},evopts___Rule],opbasis2_,basis2_,opts___Rule]:=
Module[{\[Rho]vec,X,evals,Xinv},(
Lsop=If[opbasis1===opbasis2,Lsop,NDiagonalize[Lsop,opbasis2]];
\[Rho]vec=OperatorVectorRepresentation[\[Rho],opbasis2,basis2]
{X,evals,Xinv}=First@Lsop;
Operator[
SparseArray@Fold[Chop[Dot[#2,#1]]&,{\[Rho]vec,Xinv,SparseArray[DiagonalMatrix[Exp[\[Tau]*#]&/@evals]],X}],
opbasis2,basis2,Sequence@@FilterRules[{opts},Options[Operator]]
]
)
];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,False,False,Event[st:(True|{True,True}),ch:{_,_,_,IntegrateEvolutionOverTime,__},{Lsop_?SuperoperatorQ,\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]/;(UseMatrixExpWhenPossible/.{opts}/.Options[NPropagate]):=Module[{\[Rho]vec,matrep},(
matrep=SuperoperatorMatrixRepresentation[StandardizeGenerator[Lsop]* \[Tau]/.{evopts,opts},opbasis];
\[Rho]vec=OperatorVectorRepresentation[\[Rho],opbasis,basis];
Operator[SparseArray@Chop@MatrixExp[SparseArray@Chop@N@matrep,\[Rho]vec],opbasis,basis,Sequence@@FilterRules[{opts},Options[Operator]]]
)
];


(* ::Input::Initialization:: *)
NPropagate[True,False,False,ev:Event[st:(True|{True,True}),ch:{{_,{tb_,ta_},moretch___},__},{Lfunc:ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,op_?SuperoperatorQ],\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]&&BackgroundGeneratorImplemented[ev]:=Module[{nL,uvec,uvecflat,u,uvecplain,NDSolveopts,sol,Uini,Lmatfunc},
nL=BasisDimension [basis]^2;
NDSolveopts=Sequence@@FilterRules[SimplifyRules[{evopts,opts}],Options[NDSolve]];
Lmatfunc=Function[t$,Evaluate@N[SuperoperatorMatrixRepresentation[StandardizeGenerator[Lfunc[t$,ta,tb]/.{evopts,opts}],opbasis]]];
uvec[t$_]:=Evaluate[Array[u[#1,#2][t$]&,{nL,nL}]];
uvecflat[t$_]:=Evaluate[Flatten[Array[u[#1,#2][t$]&,{nL,nL}]]];
uvecplain=Evaluate[Array[u[#1,#2]&,{nL,nL}]];
Uini=IdentityMatrix[BasisDimension[]*BasisDimension[]];
sol=NDSolveValue[{D[uvecflat[t$],t$]==(Flatten[Lmatfunc[t$].uvec[t$]]),uvecflat[ta]==Flatten[Uini]},uvecplain,{t$,ta,tb},NDSolveopts];
Superoperator[SparseArray[Chop[N[Through[#[tb]]&/@sol]]],
opbasis,
Sequence@@FilterRules[
Join[{opts},Options[NPropagate]],
Options[Operator]
]
]
];


(* ::Input::Initialization:: *)
OperatorPattern=_Operator|
_opI|_opT|_opR|
_ProjectionOperator|_ShiftOperator|
_SpinExchangeOperator|_SpinPermutationOperator|
_UnityOperator|_NullOperator|
HoldPattern@Dot[___,_Ket,_Bra,___]|(
ifunc_InterpolatingFunction[_]/;
(Depth[ifunc]>=3)&&
MatchQ[ifunc[ifunc[[1,1,1]]],_?OperatorQ]);


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,False,False,ev:Event[st:(True|{True,True}),ch:{{_,{tb_,ta_},moretch___},__},{Hfunc:ShapeFunction[args__,op_?OperatorQ],\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]/;(MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]&&BackgroundGeneratorImplemented[ev]&&MatchQ[(PropagationMethod/.{evopts}/.Options[Event]),Adiabatic]):=Module[{Hlist,Ht,\[Lambda]$,tloc,parametergrid,timegrid,evals,evecs,H\[Lambda],adiabaticparts,nonadiabaticparts,adiabaticfactor,adiabaticparameter,spinsys},(
spinsys=SpinSystem[basis];
timegrid=(Which[
MatchQ[#,{_Integer}],ta+(tb-ta)/#[[1]]*Range[0,#[[1]]],
MatchQ[#,{_?NumericQ..}],#,
MatchQ[#,None],(Message[NPropagate::noevsampling];Abort[])]&@(EventSampling/.{evopts}/.Options[Event])
);
Ht=Hfunc[tloc,ta,tb];
Hlist=Rest[List@@("dummy"+ExpandAll[Ht])];
adiabaticparts=Total@Select[Hlist,!FreeQ[#,tloc]&];
adiabaticparts=Together[Collect[adiabaticparts,tloc]];
nonadiabaticparts=Expand[Total@Select[Hlist,FreeQ[#,tloc]&],OperatorPattern];
adiabaticfactor=First[Rest[List@@("dummy"+adiabaticparts)]]/.{k_. tloc*_?OperatorQ:> k tloc};
adiabaticparameter=First@Cases[Flatten@{adiabaticfactor},tloc*___,\[Infinity]];
H\[Lambda]=nonadiabaticparts+(adiabaticparts/.{adiabaticparameter-> \[Lambda]$});
parametergrid=Map[adiabaticparameter/.{tloc-> #}&,timegrid];
{evals,evecs}=CorrelatedEigensystems[H\[Lambda],Join[{\[Lambda]$},{parametergrid}],ReturnKets-> False,Basis-> ZeemanBasis[spinsys],{"1","4"}];
AdiabaticPropagation[\[Rho],Transpose[evals],evecs,parametergrid,timegrid,spinsys,evopts]
)
]


(* ::Input::Initialization:: *)
AdiabaticPropagation[\[Rho]_,evals_,evecs_,parametergrid_,timegrid_,spinsys_,opts___Rule]:=Module[{\[Rho]mat,\[Rho]ini,coherencestatus,vini,vfinal,nnzoffdiag,adiabaticstate,dim,len,\[Phi]evecs,evalfuncs,evecfuncs,dynamic\[Phi],geometric\[Phi],\[Phi]mat},
\[Rho]mat=MatrixRepresentation[\[Rho], ZeemanBasis[spinsys]];
DisableBuiltInModifications[Dot];
coherencestatus=DeleteCoherences/.{opts}/.Options[Event];
vini=First[evecs];
vfinal=Last[evecs];
\[Rho]ini=Chop[vini.\[Rho]mat.ConjugateTranspose[vini]];
dim=Length[vfinal];
If[coherencestatus,(
adiabaticstate=SparseArray@Fold[Chop[Dot[#2,#1]]&,{Flatten[\[Rho]ini],DiagonalMatrix[Flatten@IdentityMatrix[dim,SparseArray]],ConjugateTranspose[KroneckerProduct[Conjugate[vfinal],vfinal]]}];
ReenableBuiltInModifications[Dot];
Operator[ArrayReshape[adiabaticstate,{dim,dim}],ZeemanBasis[spinsys],CheckOperatorType->False,CheckMatrixDimensions->False]
),
(
nnzoffdiag=Union@@(SparseArray[Chop@UpperTriangularize[\[Rho]ini,1]]["NonzeroPositions"]);
If[nnzoffdiag=={},(
adiabaticstate=SparseArray@Fold[Chop[Dot[#2,#1]]&,{Flatten[\[Rho]ini],DiagonalMatrix[Flatten@IdentityMatrix[dim,SparseArray]],ConjugateTranspose[KroneckerProduct[Conjugate[vfinal],vfinal]]}];
ReenableBuiltInModifications[Dot];
Operator[ArrayReshape[adiabaticstate,{dim,dim}],ZeemanBasis[spinsys],CheckOperatorType->False,CheckMatrixDimensions->False]
)
,(
\[Phi]evecs=phasesmoothing[SparseArray/@#,0]&/@Transpose[evecs];
vini=SparseArray[Chop[\[Phi]evecs[[All,1]]]];
vfinal=SparseArray[Chop[\[Phi]evecs[[All,-1]]]];
evalfuncs=Interpolation[Transpose[{timegrid,#}]]&/@(evals[[nnzoffdiag]]);
len=Length[nnzoffdiag];
dynamic\[Phi]=dynamicphase[evalfuncs,len,{First[timegrid],Last[timegrid]}];
\[Phi]mat=Chop@SparseArray[Join[Thread[nnzoffdiag->dynamic\[Phi]],Thread[Complement[Range[dim],nnzoffdiag]-> ConstantArray[1,dim-len]]]];
If[Union[Internal`RealValuedNumericQ[Chop@#]&/@Flatten@Normal[\[Phi]evecs]]=={True},(
adiabaticstate=SparseArray[#.\[Rho]mat.ConjugateTranspose[#]&@(Chop[Transpose[vfinal].DiagonalMatrix[\[Phi]mat].Conjugate[vini]])];
ReenableBuiltInModifications[Dot];
Operator[adiabaticstate,ZeemanBasis[spinsys],CheckOperatorType->False,CheckMatrixDimensions->False]
),(
evecfuncs=Interpolation[Transpose[{parametergrid,#}]]&/@\[Phi]evecs;
geometric\[Phi]=geometricphase[evecfuncs,len,parametergrid];
\[Phi]mat=Chop@SparseArray[Join[Thread[Flatten[Outer[{#1,#2}&,nnzoffdiag,nnzoffdiag],1]-> Flatten[Outer[#1*Conjugate[#2]&,geometric\[Phi]*dynamic\[Phi],geometric\[Phi]*dynamic\[Phi]]]],Thread[Transpose[({#,#}&@Complement[Range[dim],nnzoffdiag])]-> ConstantArray[1,dim-len]]],{dim,dim}];
adiabaticstate=SparseArray@ArrayReshape[Fold[Chop[Dot[#2,#1]]&,{Flatten[\[Rho]mat],KroneckerProduct[Conjugate[vini],vini],DiagonalMatrix@Flatten[\[Phi]mat],ConjugateTranspose[KroneckerProduct[Conjugate[vfinal],vfinal]]}],{dim,dim}];
ReenableBuiltInModifications[Dot];
Operator[adiabaticstate,ZeemanBasis[spinsys],CheckOperatorType->False,CheckMatrixDimensions->False]
)
]
)
]
)
]
]


(* ::Input::Initialization:: *)
phasesmoothing[set_,X_]:=Module[{len,\[Delta]\[Phi]},
FoldList[Exp[-I*Arg[Chop[Conjugate[#1].#2]]]*#2&,First[set],Rest[set]]
]


(* ::Input::Initialization:: *)
dynamicphase[funcs_,len_,{ta_,tb_}]:=Module[{\[Phi],\[Phi]dyn,\[Phi]dynplain,\[Phi]dynini,sol},
\[Phi]dyn[t$_]:=Evaluate[Array[\[Phi][#][t$]&,len]];
\[Phi]dynplain=Evaluate[Array[\[Phi][#]&,len]];
\[Phi]dynini=ConstantArray[0,len];
sol=Through[NDSolveValue[{D[\[Phi]dyn[t$],t$]==Through[funcs[t$]],\[Phi]dyn[ta]==\[Phi]dynini},\[Phi]dynplain,{t$,ta,tb}][tb]];
Exp[-I*Re@Chop[sol]]
]


(* ::Input::Initialization:: *)
geometricphase[funcs_,len_,\[Lambda]vals_]:=Module[{\[Lambda]a,\[Lambda]b,scalarfuncs,\[Phi],\[Phi]geo,\[Phi]geoplain,\[Phi]geoini,sol},
{\[Lambda]a,\[Lambda]b}={First[\[Lambda]vals],Last[\[Lambda]vals]};
scalarfuncs=Table[Interpolation[Transpose[{\[Lambda]vals,Chop[Im[Conjugate[funcs[[j]][#]].funcs[[j]]'[#]]&/@\[Lambda]vals]}]],{j,Range[len]}];
\[Phi]geo[\[Lambda]$_]:=Evaluate[Array[\[Phi][#][\[Lambda]$]&,len]];
\[Phi]geoplain=Evaluate[Array[\[Phi][#]&,len]];
\[Phi]geoini=ConstantArray[0,len];
sol=Through[NDSolveValue[{D[\[Phi]geo[\[Lambda]$],\[Lambda]$]==Through[scalarfuncs[\[Lambda]$]],\[Phi]geo[\[Lambda]a]==\[Phi]geoini},\[Phi]geoplain,{\[Lambda]$,\[Lambda]a,\[Lambda]b}][\[Lambda]b]];
Exp[-I*Re@Chop[sol]]
]


(* ::Input::Initialization:: *)
HoldPattern@NPropagate[\[Rho]_,True,False,False,ev:Event[st:(True|{True,True}),ch_,Repeat[EventList[st_,chars_,events:{_Event..},evlistopts___Rule],n_Integer,evtropts___Rule],
evopts___Rule],opbasis_,basis_,opts___Rule]/;
MatchQ[PropagatorCalculationProcedure[ev],RepeatPropagator]&&BackgroundGeneratorImplemented[ev]:=
Module[{matreps,singleprop,\[Rho]vec},(
\[Rho]vec=OperatorVectorRepresentation[\[Rho],opbasis,basis];
matreps=SuperoperatorMatrixRepresentation[NPropagationSuperoperator[True,HilbertSpaceCompatibility[#],#,opts],opbasis,basis,opts]&/@events;
singleprop=If[Length[matreps]==1,First@matreps,Fold[Dot,First@matreps,Drop[matreps,1]]];
Operator[SparseArray[Chop[MatrixPower[singleprop,n,\[Rho]vec]]],opbasis,basis,Sequence@@FilterRules[{opts},Options[Operator]]]
)];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,False,False,ev:Event[st:(True|{True,True}),ch_,PrecalculatedEvent[precalch_,Sop_Superoperator,precalevopts___Rule],
evopts___Rule],opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],UsePrecalculatedPropagator]:=Sop[\[Rho]];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,True,Hstat_,eventlist_EventList,opbasis_,basis_,opts___Rule]:=NPropagate[\[Rho],True,{True,1},eventlist,opbasis,basis,opts];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,
True,{True,1},eventlist_EventList,opbasis_,basis_,opts___Rule]:=
Module[{opfunc,timeinterval},(
timeinterval=TotalEventTimeInterval[eventlist];
opfunc=
NPropagate[\[Rho],True,{True,2},
eventlist,opbasis,basis,opts];
OperatorTrajectoryFunction[{timeinterval},opfunc,opbasis,basis,Sequence@@FilterRules[Join[{opts},Options[NPropagate]],Options[OperatorTrajectoryFunction]]]
)];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,{True,2},
eventlist_EventList,opbasis_,basis_,opts___Rule]:=
Which[
Chop[EventDuration[eventlist]]<=0,
	(Message[NPropagate::contzerodur];$Failed),
!FreeQ[eventlist,_PrecalculatedEvent],
	(Message[NPropagate::contnoprecalev];$Failed),
True,
	NPropagate[\[Rho],True,{True,3},eventlist,opbasis,basis,opts]
];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,{True,3},
eventlist:EventList[st_,ch_,events:{_Event..},evlistopts___Rule],opbasis_,basis_,opts___Rule]:=Module[{sortedevents,zbasis,funcsLtoR,timeintervalsLtoR,intervals,funcs,lasttimepoint},(
timeintervalsLtoR=Reverse[Reverse/@EventTimeIntervals[eventlist]];
sortedevents=Reverse[SortVectorSpaceCompatibility[eventlist]];
funcsLtoR=Drop[#,1]&@FoldList[NPropagate[#1[InitialTimePoint[#2[[2]]]],True,{True,4},#2,opbasis,basis,opts]&,Function[\[Rho]],sortedevents];
{intervals,funcs}=Transpose@Cases[Transpose[{timeintervalsLtoR,funcsLtoR}],{{_,_},_InterpolatingFunction|_Function}];
If[
FreeQ[{timeintervalsLtoR,funcsLtoR},$Failed],
({intervals,funcs}=Transpose@Cases[Transpose[{timeintervalsLtoR,funcsLtoR}],{{_,_},_InterpolatingFunction|_Function}];
Function[t,
Evaluate@Chop[
N@Piecewise[
MapThread[{#1[t],#2}&,
{funcs,
Join[
(#[[1]]<=t<#[[2]])&/@Most[intervals],
(#[[1]]<=t<=#[[2]])&/@{Last[intervals]}
]
}
],
Undefined
]
]
]
),
$Failed
]
)];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,{True,4},
{True,ev:Event[st:True|{True..},ch_,{CommutationSuperoperator[op_,___Rule],\[Tau]_},evopts___Rule]},opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]:=NPropagate[\[Rho],True,{True,4},{True,Event[st,ch,{op/.{Complex[a_,b_]:>(a-b)},\[Tau]},evopts]},opbasis,basis,opts];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,{True,4},
{True,ev:Event[st:True|{True..},ch_,{Hop_?OperatorQ,\[Tau]_},evopts___Rule]},opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]:=Module[{tb,ta,\[Rho]matrep,t,evals,evecs,X,Xinv},(
\[Rho]matrep=MatrixRepresentation[\[Rho],basis];
{tb,ta}={FinalTimePoint[ev],InitialTimePoint[ev]};
Function[t,
Evaluate@Operator[
{X,evals,Xinv}=First@NDiagonalize[Hop,basis,opts];
SparseArray@Chop@N@ExpToTrig@Normal[Dot[#,\[Rho]matrep,ConjugateTranspose@#]&@
(MultiplyMatricesAndMatrixInterpolationFunctions[
X,
DiagonalMatrix[Exp[-I*#*(t-ta)]&/@evals],
Xinv
])
],
basis,CheckOperatorType->False
]
]
)];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,{True,4},{True,ev:Event[st:(True|{True,True}),ch_,
{ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,CommutationSuperoperator[op_,___Rule]],\[Tau]_},
evopts___Rule]},opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]&&BackgroundGeneratorImplemented[ev]:=
NPropagate[\[Rho],True,{True,4},{True,Event[st,ch,
{ShapeFunction[t,\[Tau]xpairs,T,op/.{Complex[a_,b_]:>(a-b)}],\[Tau]},evopts]},opbasis,basis,opts];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,{True,4},{True,ev:Event[st:True|{True..},ch_,{Hfunc:ShapeFunction[args__,op_?OperatorQ],\[Tau]_},evopts___Rule]},opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]:=
Module[{dim,tb,ta,Hmatfunc,NDSolveopts,\[Rho]vec,\[Rho]vecflat,\[Rho]vecplain,\[Rho]ini,\[Rho]$,sol},(
dim=BasisDimension[basis];
{tb,ta}={FinalTimePoint[ev],InitialTimePoint[ev]};
Hmatfunc=Function[t$,Evaluate[N@Normal@MatrixRepresentation[Hfunc[t$,ta,tb]/.{evopts,opts},ZeemanBasis[]]]];
NDSolveopts=Sequence@@FilterRules[{evopts,opts},Options[NDSolve]];
\[Rho]vec[t$_]:=Evaluate[Array[\[Rho]$[#1,#2][t$]&,{dim,dim}]];
\[Rho]vecflat[t$_]:=Evaluate[Flatten[Array[\[Rho]$[#1,#2][t$]&,{dim,dim}]]];
\[Rho]vecplain=Evaluate[Array[\[Rho]$[#1,#2]&,{dim,dim}]];
\[Rho]ini=MatrixRepresentation[\[Rho],basis];
sol=NDSolveValue[{D[\[Rho]vecflat[t$],t$]==-I Flatten@(Hmatfunc[t$].\[Rho]vec[t$]-\[Rho]vec[t$].Hmatfunc[t$]),\[Rho]vecflat[ta]==Flatten[Normal@\[Rho]ini]},Flatten@\[Rho]vecplain,{t$,ta,tb},NDSolveopts];
Function[t,Evaluate@Operator[SparseArray[Chop[N[Through[sol[t]]]]],ZeemanKetBraOperatorBasis[],ZeemanBasis[],Sequence@@FilterRules[
Join[{opts},Options[NPropagate]],
Options[Operator]
]]]
)];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,{True,4},{True,ev:Event[True|{True,True},
{_,_,_,InstantaneousTransformation,__},
{RotationSuperoperator[args___],___},___Rule]},opbasis_,
basis_,opts___Rule]:=
Module[{Ufw,\[Rho]matrep},(
\[Rho]matrep=MatrixRepresentation[\[Rho],basis];
Ufw=MatrixRepresentation[RotationOperator[args],basis];
Function[t,
Evaluate@Operator[
Dot[Ufw,\[Rho]matrep,ConjugateTranspose@Ufw],basis,Sequence@@FilterRules[Join[{opts},Options[NPropagate]],Options[Operator]]]
]
)];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,{True,4},{False,Event[True|{True,True},{_,_,_,InstantaneousTransformation,__},{InstaOp_,___},___Rule]},opbasis_,basis_,opts___Rule]:=Module[{Ufw,\[Rho]vec},(
\[Rho]vec=OperatorVectorRepresentation[\[Rho],opbasis];
Ufw=SuperoperatorMatrixRepresentation[InstaOp,opbasis];
Function[t,
Evaluate@Operator[
Dot[Ufw,\[Rho]vec],opbasis,basis,Sequence@@FilterRules[Join[{opts},Options[NPropagate]],Options[Operator]]]
]
)];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,{True,4},{False,ev:Event[st:(True|{True,True}),ch:{_,_,_,IntegrateEvolutionOverTime,__},{Lsop_?SuperoperatorQ,\[Tau]_},evopts___Rule]},opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]:=Module[{\[Rho]vec,ta,tb,t,evals,X,Xinv},(
\[Rho]vec=OperatorVectorRepresentation[\[Rho],opbasis];
{tb,ta}={FinalTimePoint[ev],InitialTimePoint[ev]};
Function[t,
Evaluate@Operator[
{X,evals,Xinv}=First@NDiagonalize[StandardizeGenerator[Lsop],opbasis,opts];
SparseArray@Chop@N@ExpToTrig@Normal[Dot[(MultiplyMatricesAndMatrixInterpolationFunctions[X,DiagonalMatrix[Exp[#*(t-ta)]&/@evals],Xinv]),\[Rho]vec]],opbasis,basis,CheckOperatorType->False]]
)];


(* ::Input::Initialization:: *)
NPropagate[\[Rho]_,True,{True,4},{False,ev:Event[st:True|{True..},ch:{{_,{tb_,ta_},moretch___},__},{Lfunc:ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,op_?SuperoperatorQ],\[Tau]_},evopts___Rule]},opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]&&BackgroundGeneratorImplemented[ev]:=Module[{dim,NDSolveopts,\[Rho]vecflat,\[Rho]vecplain,\[Rho]ini,\[Rho]$,t$,sol,Lmatfunc},
dim=BasisDimension[basis];
Lmatfunc=Function[t$,Evaluate@N[SuperoperatorMatrixRepresentation[StandardizeGenerator[Lfunc[t$,ta,tb]/.{evopts,opts}],opbasis]]];
NDSolveopts=Sequence@@FilterRules[{evopts,opts},Options[NDSolve]];
\[Rho]vecflat[t$_]:=Evaluate[Flatten[Array[\[Rho]$[#1,#2][t$]&,{dim,dim}]]];
\[Rho]vecplain=Evaluate[Array[\[Rho]$[#1,#2]&,{dim,dim}]];
\[Rho]ini=OperatorVectorRepresentation[\[Rho],opbasis];
sol=NDSolveValue[{D[\[Rho]vecflat[t$],t$]==Flatten@(Lmatfunc[t$].\[Rho]vecflat[t$]),\[Rho]vecflat[ta]==Flatten[Normal@\[Rho]ini]},Flatten@\[Rho]vecplain,{t$,ta,tb},NDSolveopts];
Function[t$,Evaluate@Operator[SparseArray[Chop[N[Through[sol[t$]]]]],opbasis,basis,Sequence@@FilterRules[
Join[{opts},Options[NPropagate]],
Options[Operator]
]]]
];


(* ::Input::Initialization:: *)
NPropagate::argnotready="The argument of NPropagate is not ready for numerical computation.";


(* ::Input::Initialization:: *)
NPropagate::undefbasis="The Basis `1` is not defined. Calculation will proceed using the default Basis.";


(* ::Input::Initialization:: *)
NPropagate::undefopbasis="The OperatorBasis `1` is not defined. Calculation will proceed using the default OperatorBasis.";


(* ::Input::Initialization:: *)
NPropagate::nonnumeric="A non-numeric matrix was detected. The requested context does not permit operators with symbolic coefficients.";


(* ::Input::Initialization:: *)
NPropagate::contzerodur="NPropagate with the option setting Continuous\[Rule]True requires an event duration greater than 0.";


(* ::Input::Initialization:: *)
NPropagate::contnoprecalev="Precalculated events are not allowed for NPropagate with the option setting Continuous\[Rule]True.";


(* ::Input::Initialization:: *)
NPropagate::bad\[Rho]="NPropagate was applied to an expression that is not an operator.";


(* ::Input::Initialization:: *)
NPropagate::noevsampling="For adiabatic proapgation schemes a valid EventSampling has to be provided.";


(* ::Input::Initialization:: *)
Options[NPropagationOperator]={
OperatorBasis:>ZeemanKetBraOperatorBasis[],
Basis:>ZeemanBasis[],
Continuous-> False,
UseMatrixExpWhenPossible->True,
BackgroundGenerator->None,
ExpandRepeatedEvents->Automatic,
PropagatorCalculationProcedure->None,
InitialTimePoint->0,
Chronology:>$Chronology,
Method->Automatic,
AccuracyGoal->Automatic,
PrecisionGoal->Automatic,
MaxStepSize->Automatic,
MaxSteps->Automatic,
Assumptions->{OperatorType->"Unitary"},
CheckOperatorType->False
};


(* ::Input::Initialization:: *)
NPropagationOperator[arg1:Except[_?BooleanQ|{_?BooleanQ..}],args2___,opts___Rule]:=
NPropagationOperator[False,arg1,args2,opts];


(* ::Input::Initialization:: *)
CheckFlagDimension[NPropagationOperator]=5;


(* ::Input::Initialization:: *)
NPropagationOperator[False,args___]:=
NPropagationOperator[Table[False,{CheckFlagDimension[NPropagationOperator]}],args];


(* ::Input::Initialization:: *)
NPropagationOperator[{True..},args___]:=
NPropagationOperator[True,args];


(* ::Input::Initialization:: *)
NPropagationOperator[arg1:Except[True],args___]/;!FreeQ[{arg1,args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
NPropagationOperator[False|{_?BooleanQ..},arg1:Except[_?BooleanQ],args2:Except[_Rule]...,opts___Rule]:=
NPropagationOperator[False,
Continuous/.{opts}/.Options[NPropagationOperator],
arg1,args2,
Sequence@@FilterRules[{opts},Except[Continuous->_]]
];


(* ::Input::Initialization:: *)
NPropagationOperator[status:{_?BooleanQ..},cont_?BooleanQ,({}|UnityOperator[]),basis_,opts___Rule]:=UnityOperator[];


(* ::Input::Initialization:: *)
NPropagationOperator[status:{_?BooleanQ..},cont_?BooleanQ,events_,opts___Rule]:=
NPropagationOperator[status,cont,events,Basis/.{opts}/.Options[NPropagationOperator],opts];


(* ::Input::Initialization:: *)
NPropagationOperator[status:{_?BooleanQ..},cont_?BooleanQ,events_,basis_,opts___Rule]/;(SpinSystem[]==SpinSystemUnknown):=(Message[SpinSystem::notready];$Failed);


(* ::Input::Initialization:: *)
NPropagationOperator[status:{_?BooleanQ..},cont_?BooleanQ,events_,BasisUnknown,opts___Rule]:=
(
Message[Basis::unknown];
Message[Basis::default];
SetBasis[ZeemanBasis[SpinSystem[]],CheckBasis->False];
NPropagationOperator[status,cont,events,opts]
);


(* ::Input::Initialization:: *)
NPropagationOperator[status:{_?BooleanQ..},cont_?BooleanQ,events_,basis_,opts___Rule]/;!DefinedBasisQ[basis]:=
(
Message[NPropagationOperator::undefbasis,basis];
NPropagationOperator[status,cont,events,Basis[],opts]
);


(* ::Input::Initialization:: *)
HoldPattern@NPropagationOperator[status:{False,morestatus___},cont_?BooleanQ,events_,basis_,opts___Rule]:=
Module[{evbackg},(
evbackg=StandardizeGenerator[BackgroundGenerator/.{opts}/.Options[NPropagationOperator]];
NPropagationOperator[{True,morestatus},cont,events, basis,
Evaluate@SimplifyRules[
BackgroundGenerator->
Switch[evbackg,
Except[_Hold|NullGeneratorPattern],
	HeldGeneratorSymbol[evbackg],
	_,evbackg
],
opts
]
]
)];


(* ::Input::Initialization:: *)
NPropagationOperator[status:{True,False,morestatus___},cont_?BooleanQ,events:Except[_PulseSequence],more:(Except[_Rule]...),opts___Rule]/;PulseSequenceQ[events]:=NPropagationOperator[status,cont,PulseSequence[events,opts],more,opts];


(* ::Input::Initialization:: *)
NPropagationOperator[status:{True,False,morestatus___},cont_?BooleanQ,events:Except[_EventList],more:(Except[_Rule]...),opts___Rule]:=
NPropagationOperator[
{True,False,morestatus},cont,
EventList[events,
SimplifyRules[
Chronology->(Chronology/.{opts}/.Options[NPropagationOperator]),
ImplementBackgroundGenerator->True,
ExpandRepeatedEvents->If[cont,True,
ExpandRepeatedEvents/.{opts}/.Options[NPropagationOperator]
],
Sequence@@FilterRules[
Join[{opts},Options[NPropagationOperator]],
Join[Options[EventList],Options[NDSolve]]
]
]
],
more,opts
];


(* ::Input::Initialization:: *)
NPropagationOperator[status:{True,False,morestatus___},cont_?BooleanQ,eventlist:EventList[True|{True,_},___],more:(Except[_Rule]...),opts___Rule]:=
NPropagationOperator[{True,True,morestatus},cont,eventlist,more,opts];


(* ::Input::Initialization:: *)
NPropagationOperator[status:{True,True,False,morestatus___},cont_?BooleanQ,
eventlist_EventList,basis_,opts___Rule]/;(!TrueQ[HilbertSpaceCompatibility[eventlist,opts]]):=
(Message[NPropagationOperator::hilbincompat];$Failed);


(* ::Input::Initialization:: *)
NPropagationOperator[status:{True,True,False,morestatus___},cont_?BooleanQ,
eventlist_EventList,basis_,opts___Rule]/;(TrueQ[HilbertSpaceCompatibility[eventlist,opts]]):=
NPropagationOperator[{True,True,True,morestatus},cont,
eventlist,basis,opts];


(* ::Input::Initialization:: *)
NPropagationOperator[checkflags:{_,_,_,False,morecheckflags__},args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
NPropagationOperator[checkflags:{True,True,True,False,morecheckflags__},args___]/;FreeQ[{args},$Failed]:=NPropagationOperator[{True,True,True,True,morecheckflags},args];


(* ::Input::Initialization:: *)
NPropagationOperator[status:{True,True,True,True,False,morestatus___},cont_?BooleanQ,eventlist:EventList[Except[True|{True..}],___],more___,opts___Rule]:=
Module[{suspsymbols},(
Message[NPropagationOperator::argnotready];
ReportSuspectSymbols[{eventlist,more}];
$Failed
)];


(* ::Input::Initialization:: *)
NPropagationOperator[status:{True,True,True,True,False,morestatus___},cont_?BooleanQ,eventlist:EventList[True|{True,True},___],more___]:=NPropagationOperator[{True,True,True,True,True,morestatus},cont,eventlist,more];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
EventList[st_,chars_,events:{_Event..},evlistopts___Rule],
basis_,opts___Rule]:=
Module[{zbmatreps,zbasis},(
zbasis=ZeemanBasis[SpinSystem[basis]];
zbmatreps=
MatrixRepresentation[NPropagationOperator[True,False,#,zbasis,opts],zbasis]&/@events;
Operator[
If[Length[zbmatreps]==1,First@zbmatreps,Fold[Dot,First@zbmatreps,Drop[zbmatreps,1]]],
zbasis,
Sequence@@FilterRules[
Join[{opts},Options[NPropagationOperator]],
Options[Operator]
]
]
)];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
Event[True|{True,True},
{_,_,True,None,__},
_,___Rule],
basis_,
opts___Rule
]:=UnityOperator[];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
Event[True|{True,True},
{{T_,__},_,True,IntegrateEvolutionOverTime,__},
{_,_},___Rule],
basis_,
opts___Rule
]/;(Chop[T]==0):=UnityOperator[];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
Event[True|{True,True},
{{T_,__},_,_,IntegrateEvolutionOverTime,__},
{ShapeFunction[___, NullGeneratorPattern],_},___Rule],
basis_,
opts___Rule
]:=UnityOperator[];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
Event[True|{True,True},
{_,_,_,InstantaneousTransformation,__},
{UnitySuperoperator[___],___},___Rule],
basis_,
opts___Rule
]:=UnityOperator[];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
Event[True|{True,True},
{_,_,_,InstantaneousTransformation,__},
{R:Dot[RotationSuperoperator[___],RotationSuperoperator[___]..],___},___Rule],
basis_,opts___Rule]:=R/.{RotationSuperoperator-> RotationOperator}


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
Event[True|{True,True},
{_,_,_,InstantaneousTransformation,__},
{RotationSuperoperator[args___],___},___Rule],
basis_,opts___Rule]:=RotationOperator[args];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
Event[st:(True|{True,True}),
ch:{_,_,_,IntegrateEvolutionOverTime,__},
{CommutationSuperoperator[minusIop_,___Rule],\[Tau]_},evopts___Rule],
basis_,opts___Rule]:=
NPropagationOperator[
True,False,
Event[st,ch,{minusIop/.{Complex[a_,b_]:>(a-b)},\[Tau]},evopts],basis,opts];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
Event[st:(True|{True,True}),
ch:{_,_,_,IntegrateEvolutionOverTime,__},
{Hop:HoldPattern@Operator[{_?MatrixQ,_List,_?MatrixQ},basis1_,___Rule],\[Tau]_},evopts___Rule],
basis_,
opts___Rule]:=
Module[{X,evals,Xinv},(
{X,evals,Xinv}=First@NDiagonalize[Hop,basis];
Operator[
SparseArray@Chop[X.DiagonalMatrix[Exp[-I*\[Tau]*evals]].Xinv],
basis,
Sequence@@FilterRules[
Join[{opts},Options[NPropagationOperator]],
Options[Operator]
]
]
)];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
Event[st:(True|{True,True}),
ch:{_,_,_,IntegrateEvolutionOverTime,__},
{Hop_?OperatorQ,\[Tau]_},evopts___Rule],
basis_,
opts___Rule]/;(UseMatrixExpWhenPossible/.{opts}/.Options[NPropagationOperator]):=
Module[{matrep,zbasis},(
zbasis=ZeemanBasis[SpinSystem[basis]];
matrep=MatrixRepresentation[(-I Hop* \[Tau]/.{evopts,opts}),zbasis];
Operator[
SparseArray@N@Chop@MatrixExp[N@matrep],
zbasis,
Sequence@@FilterRules[
Join[{opts},Options[NPropagationOperator]],
Options[Operator]
]
]
)];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
Event[st:(True|{True,True}),
ch:{T_,_,_,IntegrateEvolutionOverTime,__},
{Hop_?OperatorQ,\[Tau]_},evopts___Rule],
basis_,opts___Rule]/;(!UseMatrixExpWhenPossible/.{opts}/.Options[NPropagationOperator]):=
NPropagationOperator[
True,False,
Event[
st,ch,
{StandardizeGenerator[
Function[t,Evaluate[Hop]],
Basis->basis
],
\[Tau]},
evopts
],
basis,
opts];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
ev:Event[
st:(True|{True,True}),ch_,
{ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,CommutationSuperoperator[op_,___Rule]],\[Tau]_},
evopts___Rule],
basis_,
opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]&&BackgroundGeneratorImplemented[ev]:=
NPropagationOperator[
True,False,
Event[
st,ch,
{ShapeFunction[t,\[Tau]xpairs,T,op/.{Complex[a_,b_]:>(a-b)}],\[Tau]},evopts],
basis,
opts];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
ev:Event[
st:(True|{True,True}),
ch:{{_,{tb_,ta_},moretch___},__},
{Hfunc:ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,op_?OperatorQ],\[Tau]_},
evopts___Rule
],
basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]&&BackgroundGeneratorImplemented[ev]:=
Module[{n,u,uvec,umat,h,hvec,hmat,t$,maineqns,initialconds,Hmatfunc,NDSolveopts},(NDSolveopts=Sequence@@FilterRules[SimplifyRules[Join[{evopts,opts},Options[NPropagationOperator]]],Options[NDSolveValue]];
Hmatfunc=
Function[t$,
Evaluate[
Normal@MatrixRepresentation[Hfunc[t$,ta,tb]/.{evopts,opts},basis]
]
];
n=BasisDimension[basis];
uvec[t$_]=Through[Flatten[Array[u,{n,n}]][t$]];
hmat[t$_]=Partition[Through[Flatten[Array[h,{n,n}]][t$]],n];
umat[t$_]=Partition[uvec[t$],n];
maineqns=Inner[(#1==#2)&,D[uvec[t$],t$],Flatten[-I (hmat[t$].umat[t$])],List];
initialconds=Flatten[umat[ta]/.{u[r_,r_][_]:>u[r,r][ta]==1,u[r_,s_][_]:>u[r,s][ta]==0}];
Operator[
Partition[
NDSolveValue[
Join[
maineqns/.h[r_,s_][t$_]:>Hmatfunc[t$][[r,s]],
initialconds
],
uvec[t$],
{t$,ta,tb},NDSolveopts
]/.t$->tb,
n
],
Sequence@@FilterRules[
Join[{opts},Options[NPropagationOperator]],
Options[Operator]
]
]
)];


(* ::Input::Initialization:: *)
HoldPattern@NPropagationOperator[
True,False,
ev:Event[
st:(True|{True,True}),ch_,
Repeat[evlist_EventList,n_Integer,evtropts___Rule],
evopts___Rule
],
basis_,
opts___Rule
]/;
MatchQ[PropagatorCalculationProcedure[ev],RepeatPropagator]&&BackgroundGeneratorImplemented[ev]:=
Module[{zbasis},(
zbasis=ZeemanBasis[SpinSystem[basis]];
Operator[
MatrixPower[
MatrixRepresentation[NPropagationOperator[True,False,evlist,zbasis,opts],zbasis],
n
],
zbasis,
Sequence@@FilterRules[
Join[{opts},Options[NPropagationOperator]],
Options[Operator]
]
]
)];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,False,
ev:Event[
st:(True|{True,True}),ch_,
PrecalculatedEvent[precalch_,op_Operator,precalevopts___Rule],
evopts___Rule
],
basis_,
opts___Rule
]/;MatchQ[PropagatorCalculationProcedure[ev],UsePrecalculatedPropagator]:=
op;


(* ::Input::Initialization:: *)
NPropagationOperator[status:{_?BooleanQ..},False,
eventlists:{_EventList..},basis_,opts___Rule]:=
Operator[
Apply[Dot,
MatrixRepresentation[
NPropagationOperator[status,False,#,basis,opts],
basis
]&/@eventlists
],
basis,
Sequence@@FilterRules[Join[{opts},Options[NPropagationOperator]],Options[Operator]]
];


(* ::Input::Initialization:: *)
NPropagationOperator[True,True,eventlist_EventList,basis_,opts___Rule]:=NPropagationOperator[True,{True,1},eventlist,basis,opts];


(* ::Input::Initialization:: *)
NPropagationOperator[
True,{True,1},eventlist_EventList,basis_,opts___Rule]:=
Module[{opfunc,timeinterval,opbasis},(
opbasis=OperatorBasis/.{opts}/.Options[NPropagationOperator];
timeinterval=TotalEventTimeInterval[eventlist];
opfunc=
NPropagationOperator[True,{True,2},
eventlist,opbasis,basis,opts
];
OperatorTrajectoryFunction[{timeinterval},opfunc,opbasis,basis,Sequence@@FilterRules[Join[{opts},Options[NPropagationOperator]],Options[OperatorTrajectoryFunction]]]
)];


(* ::Input::Initialization:: *)
NPropagationOperator[True,{True,2},
eventlist_EventList,opbasis_,basis_,opts___Rule]:=
Which[
Chop[EventDuration[eventlist]]<=0,
	(Message[NPropagationOperator::contzerodur];$Failed),
!TrueQ[HilbertSpaceCompatibility[eventlist,opts]],
	(Message[NPropagationOperator::hilbincompat];$Failed),
!FreeQ[eventlist,_PrecalculatedEvent],
	(Message[NPropagationOperator::contnoprecalev];$Failed),
True,
	NPropagationOperator[True,{True,3},eventlist,opbasis,basis,opts]
];


(* ::Input::Initialization:: *)
HoldPattern@NPropagationOperator[True,{True,3},
eventlist:EventList[st_,ch_,events:{_Event..},evlistopts___Rule],opbasis_,basis_,opts___Rule]:=Module[{funcsLtoR,timeintervalsLtoR,intervals,funcs,lasttimepoint,InitialPropagator},(
timeintervalsLtoR=Reverse[Reverse/@EventTimeIntervals[eventlist]];
funcsLtoR=Drop[#,1]&@
FoldList[
NPropagationOperator[True,{True,4},#1[InitialTimePoint[#2]],#2,opbasis,basis,opts]&,
Function[UnityOperator[]],
Reverse@events
];
{intervals,funcs}=Transpose@Cases[Transpose[{timeintervalsLtoR,funcsLtoR}],{{_,_},_InterpolatingFunction|_Function}];
If[
FreeQ[{timeintervalsLtoR,funcsLtoR},$Failed],
({intervals,funcs}=Transpose@Cases[Transpose[{timeintervalsLtoR,funcsLtoR}],{{_,_},_InterpolatingFunction|_Function}];
Function[t,
Evaluate@Chop[
N@Piecewise[
MapThread[{#1[t],#2}&,
{funcs,
Join[
(#[[1]]<=t<#[[2]])&/@Most[intervals],
(#[[1]]<=t<=#[[2]])&/@{Last[intervals]}
]
}
],
Undefined
]
]
]
),
$Failed
]
)];


(* ::Input::Initialization:: *)
NPropagationOperator[True,{True,4},InitialPropagator_,
ev:Event[st:True|{True..},ch_,
{Hop_?OperatorQ,\[Tau]_},evopts___Rule],
opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]:=Module[{tb,ta,Umatini,t,evals,evecs,X,Xinv},(
{tb,ta}={FinalTimePoint[ev],InitialTimePoint[ev]};
Umatini=MatrixRepresentation[InitialPropagator,basis];
Function[t,
Evaluate@Operator[
{X,evals,Xinv}=First@NDiagonalize[Hop,basis,opts];
SparseArray@Chop@N@ExpToTrig@Normal[
MultiplyMatricesAndMatrixInterpolationFunctions[
X,
DiagonalMatrix[Exp[-I*#*(t-ta)]&/@evals],
Xinv,
Umatini
]
],
basis,CheckOperatorType->False
]
]
)];


(* ::Input::Initialization:: *)
NPropagationOperator[True,{True,4},InitialPropagator_,
ev:Event[st:True|{True..},ch_,
{Hfunc:ShapeFunction[args__,op_?OperatorQ],\[Tau]_},evopts___Rule
],
opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]:=
Module[{tb,ta,Hmatfunc,NDSolveopts,n,u,uvec,uvecplain,uvecflat,umat,h,hvec,hmat,t$,sol,Ufunc},(
{tb,ta}={FinalTimePoint[ev],InitialTimePoint[ev]};
Hmatfunc=
Function[tinternal,
Evaluate[
Normal@MatrixRepresentation[Hfunc[tinternal,ta,tb]/.{evopts,opts},basis]
]
];
NDSolveopts=Sequence@@FilterRules[SimplifyRules[{evopts,opts}],Options[NDSolve]];
n=BasisDimension[Basis[]];
uvec[t$_]:=Evaluate[Array[u[#1,#2][t$]&,{n,n}]];
uvecflat[t$_]:=Evaluate[Flatten[Array[u[#1,#2][t$]&,{n,n}]]];
uvecplain=Evaluate[Array[u[#1,#2]&,{n,n}]];
sol=NDSolveValue[{D[uvecflat[t$],t$]==-I (Flatten[Hmatfunc[t$].uvec[t$]]),uvecflat[ta]==Flatten[Normal@MatrixRepresentation[InitialPropagator,basis]]},uvecplain,{t$,ta,tb},NDSolveopts];
Ufunc=Function[t,Evaluate[Operator[SparseArray[Through[#[t]]&/@sol],basis,CheckOperatorType-> False]]]
)];


(* ::Input::Initialization:: *)
NPropagationOperator[True,{True,4},InitialPropagator_,ev:Event[st:True|{True..},ch_,evspec_,evopts___Rule],
opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],InstantaneousTransformation]:=
Module[{matrep,Umatini},(
Umatini=MatrixRepresentation[InitialPropagator,basis];
matrep=MatrixRepresentation[
NPropagationOperator[evspec,Continuous->False],basis];
Function[
Operator[
Dot[matrep,Umatini],Sequence@@FilterRules[Join[{opts},Options[NPropagationOperator]],Options[Operator]]]
]
)];


(* ::Input::Initialization:: *)
NPropagationOperator::argnotready="The argument of NPropagationOperator is not ready for numerical computation.";


(* ::Input::Initialization:: *)
NPropagationOperator::undefbasis="The basis `1` is not defined. Calculation will proceed using the default basis.";


(* ::Input::Initialization:: *)
NPropagationOperator::hilbincompat="Cannot calculate the propagation operator of a Hilbert-space-incompatible event.";


(* ::Input::Initialization:: *)
NPropagationOperator::nonnumeric="A non-numeric matrix was detected. The requested context does not permit operators with symbolic coefficients.";


(* ::Input::Initialization:: *)
NPropagationOperator::contzerodur="NPropagationOperator with the option setting Continuous\[Rule]True requires an event duration greater than 0.";


(* ::Input::Initialization:: *)
NPropagationOperator::contnoprecalev="Precalculated events are not allowed for NPropagationOperator with the option setting Continuous\[Rule]True.";


(* ::Input::Initialization:: *)
Options[NPropagationSuperoperator]={
OperatorBasis:>ZeemanKetBraOperatorBasis[],
Basis:>ZeemanBasis[],
UseHilbertSpaceWhenPossible->True,
UseMatrixExpWhenPossible->True,
BackgroundGenerator->None,
ExpandRepeatedEvents->Automatic,
PropagatorCalculationProcedure->None,
InitialTimePoint->0,
Chronology:>$Chronology,
Assumptions->{},
Method->Automatic,
AccuracyGoal->Automatic,
PrecisionGoal->Automatic,
MaxStepSize->Automatic,
MaxSteps->Automatic,
CheckSuperoperatorType->False
};


(* ::Input::Initialization:: *)
NPropagationSuperoperator[arg1:Except[_?BooleanQ|{_?BooleanQ..}],args2___,opts___Rule]:=
NPropagationSuperoperator[False,arg1,args2,opts];


(* ::Input::Initialization:: *)
CheckFlagDimension[NPropagationSuperoperator]=5;


(* ::Input::Initialization:: *)
NPropagationSuperoperator[False,args___]:=NPropagationSuperoperator[Table[False,{CheckFlagDimension[NPropagationSuperoperator]}],args];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[{True..},args___]:=NPropagationSuperoperator[True,args];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[arg1:Except[True],args___]/;!FreeQ[{arg1,args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
NPropagationSuperoperator[status:{_?BooleanQ..},({}|UnityOperator[]|UnitySuperoperator[]),opbasis_,basis_,opts___Rule]:=UnitySuperoperator[];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[status:{_?BooleanQ..},events_,opts___Rule]:=NPropagationSuperoperator[status,events,OperatorBasis/.{opts}/.Options[NPropagationSuperoperator],Basis/.{opts}/.Options[NPropagationSuperoperator],opts];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[status:{_?BooleanQ..},events_,opbasis_,basis_,opts___Rule]/;(SpinSystem[]==SpinSystemUnknown):=(Message[SpinSystem::notready];$Failed);


(* ::Input::Initialization:: *)
NPropagationSuperoperator[status:{_?BooleanQ..},events_,opbasis_,basis_,opts___Rule]/;!DefinedOperatorBasisQ[opbasis]:=
(
Message[NPropagationSuperoperator::undefopbasis,opbasis];
NPropagationSuperoperator[status,events,OperatorBasis[],Basis[],opts]
);


(* ::Input::Initialization:: *)
NPropagationSuperoperator[status:{_?BooleanQ..},events_,opbasis_,basis_,opts___Rule]/;!DefinedBasisQ[basis]:=
(
Message[NPropagationSuperoperator::undefbasis,basis];
NPropagationSuperoperator[status,events,opbasis,Basis[],opts]
);


(* ::Input::Initialization:: *)
HoldPattern@NPropagationSuperoperator[status:{False,morestatus___},events_,opbasis_,basis_,opts___Rule]:=
Module[{evbackg},(
evbackg=StandardizeGenerator[BackgroundGenerator/.{opts}/.Options[NPropagationSuperoperator]];
NPropagationSuperoperator[{True,morestatus},events,opbasis, basis,
Evaluate@SimplifyRules[
BackgroundGenerator->
Switch[evbackg,
Except[_Hold|NullGeneratorPattern],
	HeldGeneratorSymbol[evbackg],
	_,evbackg
],
opts
]
]
)];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[status:{True,False,morestatus___},events:Except[_PulseSequence],more:(Except[_Rule]...),opts___Rule]/;PulseSequenceQ[events]:=NPropagationSuperoperator[status,PulseSequence[events,opts],more,opts];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[status:{True,False,morestatus___},events:Except[_EventList],more:(Except[_Rule]...),opts___Rule]:=NPropagationSuperoperator[
{True,False,morestatus},
EventList[events,
SimplifyRules[
Chronology->(Chronology/.{opts}/.Options[NPropagationSuperoperator]),
ImplementBackgroundGenerator->True,
Sequence@@FilterRules[
Join[{opts},Options[NPropagationSuperoperator]],
Join[Options[EventList],Options[NDSolve]]
]
]
],
more,opts
];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[status:{True,False,morestatus___},eventlist:EventList[True|{True,_},___],more:(Except[_Rule]...),opts___Rule]:=
NPropagationSuperoperator[{True,True,morestatus},eventlist,more,opts];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[status:{True,True,False,morestatus___},
eventlist_EventList,opbasis_,basis_,opts___Rule]:=
NPropagationSuperoperator[{True,True,True,morestatus},HilbertSpaceCompatibility[eventlist],eventlist,opbasis,basis,opts];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[checkflags:{_,_,_,False,morecheckflags__},args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
NPropagationSuperoperator[checkflags:{True,True,True,False,morecheckflags__},args___]/;FreeQ[{args},$Failed]:=
NPropagationSuperoperator[{True,True,True,True,morecheckflags},args];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[status:{True,True,True,True,False,morestatus___},Hstat_,eventlist:EventList[Except[True|{True..}],___],more___,opts___Rule]:=
Module[{suspsymbols},(
Message[NPropagationSuperoperator::argnotready];
ReportSuspectSymbols[{eventlist,more}];
$Failed
)];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[status:{True,True,True,True,False,morestatus___},Hstat_,eventlist:EventList[True|{True,True},___],more___]:=
NPropagationSuperoperator[{True,True,True,True,True,morestatus},Hstat,eventlist,more];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,EventList[st_,chars_,events:{_Event..},evlistopts___Rule],opbasis_,basis_,opts___Rule]:=Module[{Hfunc,matreps,Ufw,Ubw},(
matreps=
MatrixRepresentation[NPropagationSuperoperator[True,True,#,opbasis,basis,opts],basis]&/@events;
Ufw=If[Length[matreps]==1,First@matreps,Fold[Dot,First@matreps,Drop[matreps,1]]];
Ubw=If[UnitaryMatrixQ[Ufw]==True,ConjugateTranspose@Ufw,Inverse@Ufw];
Superoperator[KroneckerProduct[Ufw,Transpose@Ubw],ZeemanKetBraOperatorBasis[],basis,
Sequence@@FilterRules[Join[{opts},{CheckOperatorType-> False},Options[NPropagationSuperoperator]],Options[Superoperator]]]
)];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,(False|MixedHilbertSpaceCompatibility),ev:EventList[st_,chars_,events:{_Event..},evlistopts___Rule],opbasis_,
basis_,opts___Rule]:=Module[{U,Umatreps,sortedevents},(
sortedevents=SortVectorSpaceCompatibility[ev];
Umatreps=(SuperoperatorMatrixRepresentation[HilbPropToLiouvProp[NPropagationSuperoperator[True,Sequence@@#,opbasis,basis,opts],basis,opts],opbasis]&/@sortedevents);
U=If[Length[Umatreps]==1,First@Umatreps,Fold[Dot,First@Umatreps,Drop[Umatreps,1]]];
Superoperator[U,opbasis,basis,
Sequence@@FilterRules[Join[{opts},{CheckOperatorType-> False},Options[NPropagationSuperoperator]],Options[Superoperator]]]
)];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,Event[True|{True,True},{_,_,True,None,__},_,___Rule],opbasis_,basis_,opts___Rule]:=UnityOperator[];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,Event[True|{True,True},{{T_,__},_,True,IntegrateEvolutionOverTime,__},
{_,_},___Rule],opbasis_,basis_,opts___Rule]/;(Chop[T]==0):=UnityOperator[];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,Event[True|{True,True},
{{T_,__},_,_,IntegrateEvolutionOverTime,__},{ShapeFunction[___, NullGeneratorPattern],_},___Rule],opbasis_,basis_,opts___Rule]:=UnityOperator[];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,Event[True|{True,True},{_,_,_,InstantaneousTransformation,__},{UnityOperator[___],___},___Rule],opbasis_,basis_,opts___Rule]:=UnityOperator[];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,False,Event[True|{True,True},{_,_,True,None,__},_,___Rule],opbasis_,basis_,opts___Rule]:=Superoperator[UnitySuperoperator[],opbasis,CheckOperatorType-> False];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,False,Event[True|{True,True},{{T_,__},_,True,IntegrateEvolutionOverTime,__},
{_,_},___Rule],opbasis_,basis_,opts___Rule]/;(Chop[T]==0):=Superoperator[UnitySuperoperator[],opbasis,CheckOperatorType-> False];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,False,Event[True|{True,True},
{{T_,__},_,_,IntegrateEvolutionOverTime,__},{ShapeFunction[___, NullGeneratorPattern],_},___Rule],opbasis_,basis_,opts___Rule]:=Superoperator[UnitySuperoperator[],opbasis,CheckOperatorType-> False];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,False,False,Event[True|{True,True},{_,_,_,InstantaneousTransformation,__},{UnitySuperoperator[___],___},___Rule],opbasis_,basis_,opts___Rule]:=Superoperator[UnitySuperoperator[],opbasis,CheckOperatorType-> False];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,Event[st:(True|{True,True}),ch:{_,_,_,IntegrateEvolutionOverTime,__},{CommutationSuperoperator[op_,___Rule],\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]:=
NPropagationSuperoperator[True,True,Event[st,ch,{op/.{Complex[a_,b_]:>(a-b)},\[Tau]},evopts],opbasis,basis,opts];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,Event[st:(True|{True,True}),ch:{_,_,_,IntegrateEvolutionOverTime,__},{Hop:HoldPattern@Operator[{_?MatrixQ,_List,_?MatrixQ},basis1_,___Rule],\[Tau]_},evopts___Rule],opbasis_,basis2_,opts___Rule]:=
Module[{X,evals,Xinv},(
Hop=If[basis1==basis2,Hop,NDiagonalize[Hop,basis2]];
{X,evals,Xinv}=First@Hop;
Operator[SparseArray@Chop@N[X.DiagonalMatrix[Exp[-I*\[Tau]*#]&/@evals].Xinv],basis2,
Sequence@@FilterRules[
Join[{opts},Options[NPropagationSuperoperator]],
Options[Operator]
]
]
)];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,Event[st:(True|{True,True}),ch:{_,_,_,IntegrateEvolutionOverTime,__},{Hop_?OperatorQ,\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]/;(UseMatrixExpWhenPossible/.{opts}/.Options[NPropagationSuperoperator]):=
Module[{matrep},(
matrep=MatrixRepresentation[-I Hop* \[Tau]/.{evopts,opts},basis];
Operator[SparseArray@Chop@N@MatrixExp[N@matrep],
Sequence@@FilterRules[
Join[{opts},Options[NPropagationSuperoperator]],
Options[Operator]
]
]
)];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,Event[st:(True|{True,True}),ch:{T_,_,_,IntegrateEvolutionOverTime,__},{Hop_?OperatorQ,\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]/;(!UseMatrixExpWhenPossible/.{opts}/.Options[NPropagationSuperoperator]):=
NPropagationSuperoperator[True,True,Event[st,ch,{StandardizeGenerator[Function[t,Evaluate[Hop]],Basis->basis],\[Tau]},evopts],opbasis,basis,opts];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,ev:Event[st:(True|{True,True}),ch_,{ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,CommutationSuperoperator[op_,___Rule]],\[Tau]_},
evopts___Rule],opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]&&BackgroundGeneratorImplemented[ev]:=
NPropagationSuperoperator[True,True,Event[st,ch,{ShapeFunction[t,\[Tau]xpairs,T,op/.{Complex[a_,b_]:>(a-b)}],\[Tau]},evopts],opbasis,basis,opts];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,ev:Event[st:(True|{True,True}),ch:{{_,{tb_,ta_},moretch___},__},{Hfunc:ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,op_?OperatorQ],\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]&&BackgroundGeneratorImplemented[ev]:=Module[{n,NDSolveopts,u,uvec,uvecflat,sol,uvecplain,Uini,Ufunc,Hmatfunc,U},
NDSolveopts=Sequence@@FilterRules[SimplifyRules[{evopts,opts}],Options[NDSolve]];
n=BasisDimension[basis];
Hmatfunc=
Function[t$,
Evaluate[
Normal@MatrixRepresentation[Hfunc[t$,ta,tb]/.{evopts,opts},basis]
]
];
uvec[t$_]:=Evaluate[Array[u[#1,#2][t$]&,{n,n}]];
uvecflat[t$_]:=Evaluate[Flatten[Array[u[#1,#2][t$]&,{n,n}]]];
uvecplain=Evaluate[Array[u[#1,#2]&,{n,n}]];
Uini=IdentityMatrix[BasisDimension[]];
sol=NDSolveValue[{D[uvecflat[t$],t$]==-I (Flatten[Hmatfunc[t$].uvec[t$]]),uvecflat[ta]==Flatten[Uini]},uvecplain,{t$,ta,tb},NDSolveopts];
Operator[SparseArray[Chop[N[Through[#[tb]]&/@sol]]],basis,Sequence@@FilterRules[
Join[{opts},Options[NPropagationSuperoperator]],
Options[Operator]
]
]
];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,Event[True|{True,True},{_,_,_,InstantaneousTransformation,__},{RotationSuperoperator[args___],___},___Rule],opbasis_,basis_,opts___Rule]:=RotationOperator[args]


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,Event[True|{True,True},
{_,_,_,InstantaneousTransformation,__},
{R:Dot[RotationSuperoperator[___],RotationSuperoperator[___]..],___},___Rule],opbasis_,
basis_,opts___Rule]:=R/.{RotationSuperoperator-> RotationOperator}


(* ::Input::Initialization:: *)
HoldPattern@NPropagationSuperoperator[True,True,ev:Event[st:(True|{True,True}),ch_,Repeat[EventList[st_,chars_,events:{_Event..},evlistopts___Rule],n_Integer,evtropts___Rule],
evopts___Rule],opbasis_,basis_,opts___Rule]/;
MatchQ[PropagatorCalculationProcedure[ev],RepeatPropagator]&&BackgroundGeneratorImplemented[ev]:=
Module[{zbmatreps,singleprop},(
zbmatreps=MatrixRepresentation[NPropagationSuperoperator[True,True,#,opbasis,basis,opts],basis]&/@events;
singleprop=If[Length[zbmatreps]==1,First@zbmatreps,Fold[Dot,First@zbmatreps,Drop[zbmatreps,1]]];
Operator[MatrixPower[singleprop,n],basis,
Sequence@@FilterRules[
Join[{opts},Options[NPropagationSuperoperator]],
Options[Operator]
]
]
)];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,True,ev:Event[st:(True|{True,True}),ch_,PrecalculatedEvent[precalch_,op_Operator,precalevopts___Rule],
evopts___Rule],opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],UsePrecalculatedPropagator]:=op;


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,False,Event[True|{True,True},{_,_,_,InstantaneousTransformation,__},{InstaOp_,___},___Rule],opbasis_,basis_,opts___Rule]:=Superoperator[InstaOp,opbasis,CheckOperatorBasis-> False];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,False,Event[st:(True|{True,True}),ch:{_,_,_,IntegrateEvolutionOverTime,__},{Lsop:HoldPattern@Superoperator[{_?MatrixQ,_List,_?MatrixQ},opbasis1_,basis1_,___Rule],\[Tau]_},evopts___Rule],opbasis2_,basis2_,opts___Rule]:=
Module[{X,evals,Xinv},(
Lsop=If[opbasis1===opbasis2,Lsop,NDiagonalize[StandardizeGenerator[Lsop],opbasis2]];
{X,evals,Xinv}=First@Lsop;
Superoperator[
SparseArray@Chop[X.DiagonalMatrix[Exp[\[Tau]*#]&/@evals].Xinv],
opbasis2,
Sequence@@FilterRules[
Join[{opts},Options[NPropagationSuperoperator]],
Options[Operator]
]
]
)];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,False,Event[st:(True|{True,True}),ch:{_,_,_,IntegrateEvolutionOverTime,__},{Lsop_?SuperoperatorQ,\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]/;(UseMatrixExpWhenPossible/.{opts}/.Options[NPropagationSuperoperator]):=Module[{matrep},(
matrep=SuperoperatorMatrixRepresentation[StandardizeGenerator[Lsop]/.{evopts,opts},opbasis];
Superoperator[
SparseArray@Chop@N@MatrixExp[\[Tau] *N@matrep],
opbasis,
Sequence@@FilterRules[
Join[{opts},Options[NPropagationSuperoperator]],
Options[Operator]
]
]
)
];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,False,ev:Event[st:(True|{True,True}),ch:{{_,{tb_,ta_},moretch___},__},{Lfunc:ShapeFunction[t_,\[Tau]xpairs_?MatrixQ,T_,op_?SuperoperatorQ],\[Tau]_},evopts___Rule],opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],IntegrateEvolutionOverTime]&&BackgroundGeneratorImplemented[ev]:=Module[{nL,u,uvecflat,uvec,uvecplain,NDSolveopts,Uini,Lmatfunc,sol},
NDSolveopts=Sequence@@FilterRules[SimplifyRules[{evopts,opts}],Options[NDSolve]];
nL=BasisDimension[]^2;
Lmatfunc=Function[t$,Evaluate@N[SuperoperatorMatrixRepresentation[StandardizeGenerator[Lfunc[t$,ta,tb]/.{evopts,opts}],opbasis]]];
uvec[t$_]:=Evaluate[Array[u[#1,#2][t$]&,{nL,nL}]];
uvecflat[t$_]:=Evaluate[Flatten[Array[u[#1,#2][t$]&,{nL,nL}]]];
uvecplain=Evaluate[Array[u[#1,#2]&,{nL,nL}]];
Uini=IdentityMatrix[nL];
sol=NDSolveValue[{D[uvecflat[t$],t$]==(Flatten[Lmatfunc[t$].uvec[t$]]),uvecflat[ta]==Flatten[Uini]},uvecplain,{t$,ta,tb},NDSolveopts];
Superoperator[SparseArray[Chop[N[Through[#[tb]]&/@sol]]],
opbasis,
Sequence@@FilterRules[
Join[{opts},Options[NPropagationSuperoperator]],
Options[Operator]
]
]
];


(* ::Input::Initialization:: *)
HoldPattern@NPropagationSuperoperator[True,False,ev:Event[st:(True|{True,True}),ch_,Repeat[EventList[st_,chars_,events:{_Event..},evlistopts___Rule],n_Integer,evtropts___Rule],
evopts___Rule],opbasis_,basis_,opts___Rule]/;
MatchQ[PropagatorCalculationProcedure[ev],RepeatPropagator]&&BackgroundGeneratorImplemented[ev]:=
Module[{matreps,singleprop},(
matreps=SuperoperatorMatrixRepresentation[HilbPropToLiouvProp[NPropagationSuperoperator[True,HilbertSpaceCompatibility[#],#,opbasis,basis,opts],basis,opts],opbasis]&/@events;
singleprop=If[Length[matreps]==1,First@matreps,Fold[Dot,First@matreps,Drop[matreps,1]]];
Superoperator[MatrixPower[singleprop,n],opbasis,
Sequence@@FilterRules[
Join[{opts},Options[NPropagationSuperoperator]],
Options[Operator]
]
]
)];


(* ::Input::Initialization:: *)
NPropagationSuperoperator[True,False,ev:Event[st:(True|{True,True}),ch_,PrecalculatedEvent[precalch_,Sop_Superoperator,precalevopts___Rule],evopts___Rule],opbasis_,basis_,opts___Rule]/;MatchQ[PropagatorCalculationProcedure[ev],UsePrecalculatedPropagator]:=Sop;


(* ::Input::Initialization:: *)
NPropagationSuperoperator::argnotready="The argument of NPropagationSuperoperator is not ready for numerical computation.";


(* ::Input::Initialization:: *)
NPropagationSuperoperator::undefopbasis="The OperatorBasis `1` is not defined. Calculation will proceed using the default OperatorBasis.";


(* ::Input::Initialization:: *)
NPropagationSuperoperator::undefbasis="The basis `1` is not defined. Calculation will proceed using the default basis.";


(* ::Input::Initialization:: *)
Options[CorrelatedEigensystems]={BackgroundGenerator:> NullOperator[],Basis:>Basis[],ReturnKets-> True};


(* ::Input::Initialization:: *)
CorrelatedEigensystems[args___]:=CorrelatedEigensystems[args,{"1","0"}];


(* ::Input::Initialization:: *)
CorrelatedEigensystems[args___,{"1","0"}]:=If[MatchQ[{args},{ _,_?ListQ,___Rule}],CorrelatedEigensystems[args,{"1","1"}],Message[CorrelatedEigensystems::badargs];Abort[]]


(* ::Input::Initialization:: *)
CorrelatedEigensystems[adH_,\[Lambda]specs_,more___,{"1","1"}]:=If[OperatorQ[adH],CorrelatedEigensystems[adH,\[Lambda]specs,more,{"1","2"}],Message[CorrelatedEigensystems::HnoOp];Abort[]]


(* ::Input::Initialization:: *)
CorrelatedEigensystems[adH_,specs:{par_,more___},opts___Rule,{"1","2"}]:=If[(MatchQ[specs,{_,_List}]&&Length[more]>0)\[Or]MatchQ[specs,{_,_,_,_}],CorrelatedEigensystems[adH,specs,opts,{"1","3"}],Message[CorrelatedEigensystems::specstruc];Abort[]]


(* ::Input::Initialization:: *)
CorrelatedEigensystems[adH_,specs:{par_,more___},opts___Rule,{"1","3"}]:=If[Length[UnassignedSymbols[par,opts]]==1,CorrelatedEigensystems[adH,specs,opts,{"1","4"}],Message[CorrelatedEigensystems::parAssigned];Abort[]]


(* ::Input::Initialization:: *)
CorrelatedEigensystems[adH_,specs:{par_,vals_?ListQ},opts___Rule,{"1","4"}]:=If[VectorQ[vals,NumericQ],CorrelatedEigensystems[adH,specs,opts,{"1","5"}],Message[CorrelatedEigensystems::numpar];Abort[]]


(* ::Input::Initialization:: *)
CorrelatedEigensystems[adH_,specs:{par_,xa_,xb_,\[Delta]x_},opts___Rule,{"1","4"}]:=If[VectorQ[{xa,xb,\[Delta]x},NumericQ],CorrelatedEigensystems[adH,{par,xa,xb,\[Delta]x},opts,{"1","5"}],Message[CorrelatedEigensystems::numpar];Abort[]]


(* ::Input::Initialization:: *)
CorrelatedEigensystems[adH_,specs:{par_,vals_?ListQ},opts___Rule,{"1","5"}]:=CorrelatedEigensystems[adH,specs,opts,{"1","6"}]


(* ::Input::Initialization:: *)
CorrelatedEigensystems[adH_,specs:{par_,xa_,xb_,\[Delta]x_},opts___Rule,{"1","5"}]:=Module[{new\[Delta]x,Napprox,NapproxIP},
Napprox=N[(xb-xa)/\[Delta]x];
NapproxIP=N[IntegerPart[Napprox]];
If[NapproxIP==Napprox,
CorrelatedEigensystems[adH,{par,Range[xa,xb,\[Delta]x]},opts,{"1","6"}],
new\[Delta]x=(xb-xa)/(NapproxIP+1);
Message[CorrelatedEigensystems::\[Delta]xadj,new\[Delta]x//EngineeringForm];
CorrelatedEigensystems[adH,{par,Range[xa,xb,new\[Delta]x]},opts,{"1","6"}]
]
]


(* ::Input::Initialization:: *)
CorrelatedEigensystems[adH_,specs:{par_,vals_},opts___Rule,{"1","6"}]:=Module[{basis,adHmat,adHmatnum},
basis=Basis/.{opts}/.Options[CorrelatedEigensystems];
adHmat=MatrixRepresentation[adH,basis];
adHmatnum=ReplaceEverywhere[adHmat,{par-> First[vals]}];
If[MatrixQ[adHmatnum,NumericQ],CorrelatedEigensystems[adHmat,specs,opts,{"2","1"}],Message[CorrelatedEigensystems::HnonNum],Abort[]]]


(* ::Input::Initialization:: *)
CorrelatedEigensystems::badargs="The argument structure of the input is not correct.";


(* ::Input::Initialization:: *)
CorrelatedEigensystems::HnoOp="The specified Hamiltonian is not a valid Operator object.";


(* ::Input::Initialization:: *)
CorrelatedEigensystems::specstruc="The parameter specifications should be either of the form {x,\!\(\*SubscriptBox[\(x\), \(a\)]\),\!\(\*SubscriptBox[\(x\), \(b\)]\),\[Delta]x} or {x,{\!\(\*SubscriptBox[\(x\), \(1\)]\), \!\(\*SubscriptBox[\(x\), \(2\)]\), ..., \!\(\*SubscriptBox[\(x\), \(N\)]\)}}";


(* ::Input::Initialization:: *)
CorrelatedEigensystems::parAssigned="The parameter should be an unassigned symbol.";


(* ::Input::Initialization:: *)
CorrelatedEigensystems::numpar="The parameter speficiations should all have numeric values.";


(* ::Input::Initialization:: *)
CorrelatedEigensystems::HnonNum="The Hamiltonian is not numeric after parameter replacement.";


(* ::Input::Initialization:: *)
CorrelatedEigensystems::\[Delta]xadj="The parameter stepsize (\[Delta]x) has been adjusted to `1`, so that the output starts with H(\!\(\*SubscriptBox[\(x\), \(a\)]\)) and ends with H(\!\(\*SubscriptBox[\(x\), \(b\)]\)).";


(* ::Input::Initialization:: *)
CorrelatedEigensystems::ambcorr="Ambiguous correlation encountered. Assignment attempted using OptimalBipartiteGraphMatching Algorithm.";


(* ::Input::Initialization:: *)
CorrelatedEigensystems[adHmat_,specs:{par_,vals_},opts___Rule,{"2","1"}]:=Module[{sol,\[Phi],dummykets,ketrules,dim,len,range,basis,Hmat,Hgrid,eigensystems,correlations,evals,evecs,ambstatus,auxfunc,correlatedevals,correlatedevecs,temp},
DisableBuiltInModifications[Dot];
len=Length[vals];
range=Range[len-1];
basis=Basis/.{opts}/.Options[CorrelatedEigensystems];
dim=BasisDimension[basis];
dummykets=Array[\[Phi],dim];
ketrules=Thread[dummykets-> BasisKets[basis]];
Hmat=MatrixRepresentation[BackgroundGenerator/.{opts}/.Options[CorrelatedEigensystems],basis];
Hgrid=(Chop@N@ReplaceEverywhere[adHmat+Hmat,{par-> #}]&/@vals);
eigensystems=Chop[Eigensystem/@Hgrid];
evals=eigensystems[[All,1]];
evecs=SparseArray/@(eigensystems[[All,2]]);
ambstatus=False;
correlatedevals={First[evals]};
correlatedevecs={First[evecs]};
auxfunc=Function[{overlap,pos},
temp=Flatten[Position[#,Max[#]]&/@overlap];
If[DuplicateFreeQ[temp],
correlatedevals=Append[correlatedevals ,evals[[pos+1]][[temp]]];
correlatedevecs=Append[correlatedevecs ,evecs[[pos+1]][[temp]]],
ambstatus=True;
temp=OptimalBipartiteGraphMatching[1-overlap];
correlatedevals=Append[correlatedevals ,evals[[pos+1]][[temp]]];
correlatedevecs=Append[correlatedevecs ,evecs[[pos+1]][[temp]]]
]
];
Map[auxfunc[Abs[Chop@Normal[correlatedevecs[[#]].ConjugateTranspose[evecs[[#+1]]]]],#]&,range];
If[ambstatus,Message[CorrelatedEigensystems::ambcorr]];
sol=If[Evaluate@(ReturnKets/.{opts}/.Options[CorrelatedEigensystems]),{Map[Transpose[{vals,correlatedevals[[All,#]]}]&,Range[dim]],Transpose[{vals,(Map[Conjugate[#1].dummykets&,correlatedevecs])/.ketrules}]},{correlatedevals,correlatedevecs}
];
ReenableBuiltInModifications[Dot];
sol
]


(* ::Input::Initialization:: *)
Options[Precalculate]=
{
InitialTimePoint->0,
FinalTimePoint->Automatic,
BackgroundGenerator->Undefined,
PropagatorCalculationProcedure->Automatic,
ExpandRepeatedEvents->Automatic,
Verbose->False
};


(* ::Input::Initialization:: *)
Precalculate[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
Precalculate[events:Except[_EventList],opts___Rule]:=
Precalculate[
EventList[events,
SimplifyRules[
opts,
Sequence@@Options[Precalculate]
]
],
opts
];


(* ::Input::Initialization:: *)
Precalculate[evlist:EventList[False|{False,_},___],opts___Rule]/;MatchQ[BackgroundGenerator[evlist],Undefined]:=
(Message[Precalculate::nobackg];$Failed);


(* ::Input::Initialization:: *)
Precalculate[evlist:EventList[False|{False,_},___],opts___Rule]/;MatchQ[InitialTimePoint[evlist],Undefined]:=
(Message[Precalculate::nota];$Failed);


(* ::Input::Initialization:: *)
Precalculate[evlist:EventList[False|{False,_},___],opts___Rule]/;MatchQ[FinalTimePoint[evlist],Undefined]:=
(Message[Precalculate::notb];$Failed);


(* ::Input::Initialization:: *)
Precalculate[evlist:EventList[
True|{True,__},
{{dur_,{tb_,ta_},pts_,{tb0_,ta0_}},
morech___},
more___],
opts___Rule]:=
Module[{},(
PrecalculatedEvent[
{{dur,{tb0,ta0},pts,{tb0,ta0}},morech},
If[HilbertSpaceCompatibility[evlist],
NPropagationOperator[evlist,
SimplifyRules[Continuous->False,opts]
],
NPropagationSuperoperator[evlist,
SimplifyRules[Continuous->False,opts]
]
],
Sequence@@FilterRules[{opts},Options[PrecalculatedEvent]]
]
)];


(* ::Input::Initialization:: *)
Precalculate::nobackg="Precalculate requires a defined BackgroundGenerator.";


(* ::Input::Initialization:: *)
Precalculate::nota="Precalculate requires a defined InitialTimePoint.";


(* ::Input::Initialization:: *)
Precalculate::nota="Precalculate requires a defined FinalTimePoint.";


(* ::Input::Initialization:: *)
Options[OperatorTrajectoryFunction]={};


(* ::Input::Initialization:: *)
OperatorTrajectoryFunction[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
OperatorTrajectoryFunction[range:{{tb_?NumericQ,ta_?NumericQ}},opfunc_,opts___Rule]:=OperatorTrajectoryFunction[range,opfunc,OperatorBasis[],opts];


(* ::Input::Initialization:: *)
OperatorTrajectoryFunction[range:{{tb_?NumericQ,ta_?NumericQ}},opfunc_,opbasis_,opts___Rule]:=OperatorTrajectoryFunction[range,opfunc,opbasis,Basis[],opts];


(* ::Input::Initialization:: *)
Format[OperatorTrajectoryFunction[range:{{tb_?NumericQ,ta_?NumericQ}},opfunc_,opbasis_,basis_,opts___Rule]]:=
RowBox[{
"OperatorTrajectoryFunction[",
ToBoxes[EngineeringForm@Chop[N@(Reverse/@range)]
],
ToBoxes[", <>]"]
}]//DisplayForm;


(* ::Input::Initialization:: *)
OperatorTrajectoryFunction[{{tb_?NumericQ,ta_?NumericQ}},opfunc:Except[_String],opbasis_,basis_,opts___Rule][t_?NumericQ]/;(Chop@N[t-ta]<0)||(Chop@N[t-tb]>0):=
(
Message[
OperatorTrajectoryFunction::outofrange,
EngineeringForm[N@t],EngineeringForm[N@ta],EngineeringForm[N@tb]
];
0);


(* ::Input::Initialization:: *)
OperatorTrajectoryFunction[{{tb_?NumericQ,ta_?NumericQ}},opfunc:Except[_String],opbasis_,basis_,opts___Rule][t_?NumericQ]:=Chop@ExpressOperator[opfunc[t],opbasis];


(* ::Input::Initialization:: *)
InitialTimePoint[OperatorTrajectoryFunction[{{tb_?NumericQ,ta_?NumericQ}},___]]:=ta;


(* ::Input::Initialization:: *)
FinalTimePoint[OperatorTrajectoryFunction[{{tb_?NumericQ,ta_?NumericQ}},___]]:=tb;


(* ::Input::Initialization:: *)
OperatorTrajectoryFunction::outofrange="time point `1` does not lie in the interval between `2` and `3`";


(* ::Input::Initialization:: *)
End[];
EndPackage[];



