(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["Signals`Lineshapes`",{"Global`","SpinDynamica`","General`Miscellaneous`"}];


(* ::Input::Initialization:: *)
Gaussian::"usage"=" Gaussian[w,{amp,w0,width}] generates a Gaussian function of w with integral amp, centre freq w0, and hwhh = width;
\n\n 
Gaussian[w,{w0,width}] assumes unit amplitude;\n\n 
Gaussian[w,{{_,_,_}...}] generates a superposition of Gaussians.";


(* ::Input::Initialization:: *)
Lorentzian::"usage"=" Lorentzian[w,{amp,w0,lam}] generates a complex Lorentzian function of w with complex amplitude amp, centre freq w0, and hwhh = lam;\n\n 
Lorentzian[w,{w0,lam}] assumes unit amplitude;\n\n 
Lorentzian[w,{{_,_,_}...}] generates a superposition of Lorentzians.";


(* ::Input::Initialization:: *)
Absorption::"usage"=" Absorption[w,{amp,w0,lam}] generates a Absorption  Lorentzian function of w with amplitude amp, centre freq w0, and hwhh = lam;\n\n 
Absorption[w,{w0,lam}] assumes unit amplitude;\n\n 
Absorption[w,{{_,_,_}...}] generates a superposition of such Absorption Lorentzians";


(* ::Input::Initialization:: *)
Dispersion::"usage"=" Dispersion[w,{amp,w0,lam}] generates a Dispersion Lorentzian function of w with amplitude amp, centre freq w0, and fwhh = lam;\n\n 
Dispersion[w,{w0,lam}] assumes unit amplitude;\n\n
Dispersion[w,{{_,_,_}...}] generates a superposition of such Dispersion Lorentzians";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
Gaussian[w_,line:{amp_,w0_,width_}/;TrueQ[Im[amp]==0&&Im[w0]==0&&Im[width]==0]]=
amp*Exp[-Log[2](w-w0)^2/width^2]/(width*Sqrt[Pi/Log[2]]);


(* ::Input::Initialization:: *)
Gaussian[w_,lines_?MatrixQ]:=Plus@@(Gaussian[w,#1]&)/@lines;


(* ::Input::Initialization:: *)
Gaussian[w_,{w0_,lam_}]:=Gaussian[w,{1,w0,lam}]


(* ::Input::Initialization:: *)
Lorentzian[w_,line:{amp_,w0_,lam_}/;TrueQ[Im[w0]==0&&Im[lam]==0]]=ComplexExpand[amp/(lam+I (w-w0)),{amp}];


(* ::Input::Initialization:: *)
Lorentzian[w_,lines_?MatrixQ]:=Plus@@(Lorentzian[w,#1]&)/@lines;


(* ::Input::Initialization:: *)
Lorentzian[w_,{w0_,lam_}]:=Lorentzian[w,{1,w0,lam}]


(* ::Input::Initialization:: *)
Absorption[w_,{amp_,w0_,lam_}/;TrueQ[Im[amp]==0&&Im[w0]==0&&Im[lam]==0]]=(amp lam)/(lam^2+(w-w0)^2);


(* ::Input::Initialization:: *)
Absorption[w_,lines_?MatrixQ]:=Plus@@(Absorption[w,#1]&)/@lines;


(* ::Input::Initialization:: *)
Absorption[w_,line:{w0_,lam_}]:=Absorption[w,{1,w0,lam}];


(* ::Input::Initialization:: *)
Dispersion[w_,line:{amp_,w0_,lam_}/;TrueQ[Im[amp]==0&&Im[w0]==0&&Im[lam]==0]]=(amp (w-w0))/(lam^2+(w-w0)^2);


(* ::Input::Initialization:: *)
Dispersion[w_,lines_?MatrixQ]:=Plus@@(Dispersion[w,#1]&)/@lines;


(* ::Input::Initialization:: *)
Dispersion[w_,line:{w0_,lam_}]:=Dispersion[w,{1,w0,lam}];


(* ::Input::Initialization:: *)
End[]
EndPackage[];
