(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["Signals`Signal`",
{"Global`",
"SpinDynamica`",
"General`UserLevel`",
"General`Miscellaneous`"}
];


(* ::Input::Initialization:: *)
Signal::usage="Signal[{tmin,tmax,\[Delta]t},data,opts] describes a time-domain signal spanning the interval between tmin and tmax with sampling interval \[Delta]t. The symbol data may either be a list of numeric signal amplitudes, or a peak specification of the form {type,{{a,\[Omega],\[Lambda]},...}} where type must currently be equal to \"Lorentzian\" and each peak is specified by a complex amplitude a, a frequency \[Omega] (in rad \!\(\*SuperscriptBox[\(s\), \(-1\)]\)), and a time-domain decay parameter \[Lambda] (corresponding to the half-width-at-half-height in rad \!\(\*SuperscriptBox[\(s\), \(-1\)]\)). 
Signal may be converted to a table of {time,amplitude} pairs by using Expand[Signal[...]]. This expansion is done implicitly when applying FT or ListPlot to Signal. The operations Re and Im may be applied to Signal and apply to the expanded signal amplitudes, not to the time coordinates.
The options opts determine what happend when Expand is applied. If EmbedCoordinates\[Rule]True, explicit time coordinates are generated. The option LineBroadening\[Rule]fwhh applies an extra linebroadening on expansion, where fwhh is the full-width-at-half-height in rad \!\(\*SuperscriptBox[\(s\), \(-1\)]\). The default LineBroadening\[Rule]Automatic applies Lorentzian linebroadening that brings the signal amplitude down to 1% at the end of the signal. The option DigitalFrequencyResolution allows a compromise to be made between computation speed and computational accuracy. 
";


(* ::Input::Initialization:: *)
LineBroadening::usage="LineBroadening is an option for Signal. LineBroadening->fwhh gives the acquired signal an exponential decay corresponding to a Lorentzian linebroadening in the frequency domain with full-width-at-half-height fwhh (in rad \!\(\*SuperscriptBox[\(s\), \(-1\)]\)). The same result is obtained with the option LineBroadening->{\"Lorentzian\",fwhh}. Future implementations will allow different types of LineBroadening functions. The default setting is Automatic, which sets the Lorentzian LineBroadening such that the signal envelope decays to the 1% level at the end of the signal. ";


(* ::Input::Initialization:: *)
DigitalFrequencyResolution::usage="DigitalFrequencyResolution is an option for Signal. DigitalFrequencyResolution\[Rule]Automatic shifts each peak frequency to the nearest digitized point in the frequency domain, taking into account the setting for ZeroFill. This degrades accuracy slightly but allows faster computation, especially when combining data from a large ensemble. Setting DigitalFrequencyResolution\[Rule]False disables this peak shift at the expense of processing speed."


(* ::Input::Initialization:: *)
SnapPeaksToFrequencyGrid::usage="SnapPeaksToFrequencyGrid is obsolete and has been superseded by DigitalFrequencyResolution.";


(* ::Input::Initialization:: *)
ApplyLineBroadening::usage=
"ApplyLineBroadening[signal,opts] applies line broadening to a Signal object, using the option LineBroadening\[Rule]{type,fwhh}, where fwhh is the full-width-at-half-height in rad \!\(\*SuperscriptBox[\(s\), \(-1\)]\). Currently type must be equal to \"Lorentzian\". The default setting is Automatic, which sets the Lorentzian LineBroadening such that the signal envelope decays to the 1% level at the end of the signal.";


(* ::Input::Initialization:: *)
CombineData::"usage"="CombineData[{data1,data2..},{w1,w2..}] makes a linear combination of time or frequency-domain data using the specified weights. The mean of the data is used if the list of weights is omitted. The data sets {data1,data2..} may each have the form Signal[..], or may be arrays of data with any set of dimensions. In the latter case, the option EmbedCoordinates may be used to specify whether the data sets have embedded time and frequency coordinates. If EmbedCoordinates->True, the innermost level of each data set is assumed to have the form {x1,x2..value}, where {x1,x2..} are time or frequency coordinates. In this case, all coordinates must be the same for the combined data sets. If EmbedCoordinates->False, the data is assumed to have no embedded coordinates. If EmbedCoordinates->Automatic, the routine attempts to guess whether coordinates are embedded or not.";


(* ::Input::Initialization:: *)
FT::usage="FT generates a Fourier transform of 1D or 2D time-domain data, correcting the arrangement of the data as generated by the FFT algorithm and adding frequency coordinates, if required. If the option EmbedCoordinates\[Rule]False is used, the input data is either a 1D list or a 2D matrix of signal values, and the output has the same form. If the option EmbedCoordinates\[Rule]True is used, the input data is a list of the type {{0,s1},{\[Delta]t,s2},{2\[Delta]t,s3}..} for 1D data and {{0,0,s1},{0,\[Delta]t2,s2},{0,2\[Delta]t2,s3}..{\[Delta]t1,0,s2}..} for 2D data. The output is of the same form, but with frequency coordinates instead of time coordinates.";


(* ::Input::Initialization:: *)
SampleFrequency::"usage"="Sampling Frequency in FT routine (specified in Hz).";


(* ::Input::Initialization:: *)
SampleInterval::"usage"="Sampling Interval in FT routine";


(* ::Input::Initialization:: *)
EmbedCoordinates::"usage"="EmbedCoordinates is an option for FT. Used to specify the form of the data input and the data output. If EmbedCoordinates\[Rule]True is used, the time and frequency coordinates are embedded in the individual data points (default). The embedded time coordinates are used to calculate the frequency coordinates are the FT. If EmbedCoordinates\[Rule]False is used, the input and output data lack time or frequency coordinates, in which case the time or frequency range of the data must be specified afterwards when the data are processed.";


(* ::Input::Initialization:: *)
FirstPointMultiplicationFactor::"usage"="FirstPointMultiplicationFactor is an option for FT. The default is 0.5, which states that the first point of the time-domain data is divided by 2 before application of the FFT algorithm. This prevents a spurious baseline shift generated by the discrete FT, in the case that the signal decays to zero before the end of the time-domain data. The spurious baseline shift is inversely proportional to the number of points. If FT is applied to non-decaying signals, an option FirstPointMultiplicationFactor->1 should be given. For 2D data, options such as FirstPointMultiplicationFactor\[Rule]{0.5,1.0} may be used to specify different factors for the two dimensions, in the order {direct, indirect}.";


(* ::Input::Initialization:: *)
ZeroFill::"usage"="ZeroFill is an option for FT. ZeroFill\[Rule]n causes (n-1)*m zeroes to be appended to the data prior to FT, where m is the number of data points. ZeroFill\[Rule]True is equivalent to ZeroFill\[Rule]2.   ZeroFill->False is equivalent to ZeroFill\[Rule]1. Options such as ZeroFill\[Rule]{True,False} may be specified for 2D data to indicate different zero-filling in the two dimensions, in the order {direct, indirect}.";


(* ::Input::Initialization:: *)
ReflectSpectrum::"usage"="ReflectSpectrum[spectrum] reflects spectrum about the zero-frequency axis. When applied to a 2D spectrum, the reflection is around the frequency axis of the indirect dimension. 
";


(* ::Input::Initialization:: *)
CombineComplementarySpectra::"usage"="CombineComplementarySpectra[{spec1,spec2}] reflects spec2 about the \!\(\*SubscriptBox[\(\[Omega]\), \(1\)]\)=0 axis and adds it to spec1. The result is divided by 2. This generates a pure absorption 2D spectrum if all peaks in the individual spectra have opposite \!\(\*SubscriptBox[\(\[Omega]\), \(1\)]\) frequencies and identical real amplitudes.
";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
Options[Signal]=
{EmbedCoordinates->True,
LineBroadening->Automatic,
DigitalFrequencyResolution->Automatic,
ZeroFill->Automatic,
DefinedPeakTypes->{"Lorentzian"},
PeakReductionImplemented->False,
PeaksSnappedToFrequencyGrid->False,
SnapPeaksToFrequencyGrid->False
};


(* ::Input::Initialization:: *)
Signal/:Format[Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,peakspecs_List},opts___Rule]]:=
RowBox[{
"Signal[",
ToBoxes[EngineeringForm@Chop@N@times],
ToBoxes[", {"],
ToBoxes[type],
ToBoxes[",<<"],
ToBoxes[Length[peakspecs]],
ToBoxes[">>}]"]
}]//DisplayForm;


(* ::Input::Initialization:: *)
Signal/:Format[Signal[times:{tmin_,tmax_,\[Delta]t_},data:{_?NumericQ...},opts___Rule]]:=
RowBox[{
"Signal[",
ToBoxes[EngineeringForm@Chop@N@times],
ToBoxes[", <<"],ToBoxes[Length[data]],
ToBoxes[">>]"]
}]//DisplayForm;


(* ::Input::Initialization:: *)
Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,{}},opts___Rule]:=Signal[times,{type,{{0,0,0}}},opts];


(* ::Input::Initialization:: *)
Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,peak:{Except[_List]..}},opts___Rule]:=Signal[times,{type,{peak}},opts];


(* ::Input::Initialization:: *)
Signal[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,peaks_List},opts___Rule]/;!MemberQ[DefinedPeakTypes/.Options[Signal],type]:=(Message[Signal::typeunkn];$Failed);


(* ::Input::Initialization:: *)
Signal[times:{tmin_,tmax_,\[Delta]t_},data:{_?NumericQ..},opts___Rule]/;!(Length[data]==1+Round[Abs[(tmax-tmin)/\[Delta]t]]):=(Message[Signal::badtimes];$Failed);


(* ::Input::Initialization:: *)
Signal[times:{tmin_,tmax_,\[Delta]t_},data_,opts___Rule]/;!MatchQ[LineBroadening/.{opts}/.Options[Signal],None|0|False]:=
ApplyLineBroadening[
Signal[times,data,
Evaluate@SimplifyRules[
LineBroadening->None,
opts,
Sequence@@Options[Signal]
]
],
LineBroadening->(LineBroadening/.{opts}/.Options[Signal])
];


(* ::Input::Initialization:: *)
Signal[times:{tmin_,tmax_,\[Delta]t_},data_,opts___Rule]/;MatchQ[ZeroFill/.{opts}/.Options[Signal],True|Automatic]:=
Signal[times,data,
Evaluate@SimplifyRules[
ZeroFill->2,
opts,
Sequence@@Options[Signal]
]
];


(* ::Input::Initialization:: *)
Signal[times:{tmin_,tmax_,\[Delta]t_},data_,opts___Rule]/;MatchQ[ZeroFill/.{opts}/.Options[Signal],None|False]:=
Signal[times,data,
Evaluate@SimplifyRules[
ZeroFill->1,
opts,
Sequence@@Options[Signal]
]
];


(* ::Input::Initialization:: *)
Signal[args:Except[_Rule]..,opts___Rule]/;MatchQ[SnapPeaksToFrequencyGrid/.{opts},True|Automatic]:=
(Message[Signal::obssnap];
Signal[args,
Evaluate@SimplifyRules[
DigitalFrequencyResolution->Automatic,
SnapPeaksToFrequencyGrid->False,
opts,
Sequence@@Options[Signal]
]
]);


(* ::Input::Initialization:: *)
Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,peaks_List},opts___Rule]/;MatchQ[DigitalFrequencyResolution/.{opts}/.Options[Signal],None|Infinity|(_?(Chop@N[#]==0)&)
]:=
Signal[times,{type,peaks},
Evaluate@SimplifyRules[
DigitalFrequencyResolution->False,
opts,
Sequence@@Options[Signal]
]
];


(* ::Input::Initialization:: *)
Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,peaks_List},opts___Rule]/;MatchQ[{DigitalFrequencyResolution,ZeroFill}/.{opts}/.Options[Signal],{True|Automatic,_?NumericQ}]:=
Module[{ZF,nZF,T,n,\[Delta]\[Omega]},(
ZF=ZeroFill/.{opts}/.Options[Signal];
T=tmax-tmin;
n=Round[Abs[T/\[Delta]t]]+1;
nZF=ZF*n;
\[Delta]\[Omega]=Abs[2\[Pi]/\[Delta]t]/nZF;
Signal[times,{type,peaks},
Evaluate@SimplifyRules[
DigitalFrequencyResolution->\[Delta]\[Omega],
opts,
Sequence@@Options[Signal]
]
]
)];


(* ::Input::Initialization:: *)
Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,peaks_List},opts___Rule]/;!(PeakReductionImplemented/.{opts}/.Options[Signal]):=
Module[{avals,\[Omega]vals,\[Lambda]vals,reduced\[Omega]vals,T,n,ZF,nZF,\[Delta]\[Omega],\[Omega]min,\[Omega]max,reducedpeaks,snapped},(
{ZF,\[Delta]\[Omega]}={ZeroFill,DigitalFrequencyResolution}/.{opts}/.Options[Signal];
{avals,\[Omega]vals,\[Lambda]vals}=
Transpose[
If[MatchQ[#,{}],{{0,0,0}},#]&@
Select[peaks,(Chop@N@First[#]!=0)&]
];
{reduced\[Omega]vals,snapped}=If[
NumericQ[\[Delta]\[Omega]]&&(Chop[\[Delta]\[Omega]]>0),
	(T=tmax-tmin;
	n=Round[Abs[T/\[Delta]t]]+1;
	nZF=ZF*n;
	\[Delta]\[Omega]=Abs[2\[Pi]/\[Delta]t]/nZF;
	{\[Omega]min,\[Omega]max}={-(nZF/2)+1,nZF/2}*\[Delta]\[Omega];
	{Mod[\[Delta]\[Omega]*Round[#/\[Delta]\[Omega]],nZF \[Delta]\[Omega],\[Omega]min]&/@\[Omega]vals,True}
),
	{\[Omega]vals,False}
];
reducedpeaks={Apply[Plus,First[Transpose[#]]],#[[1,2]],#[[1,3]]}&/@
GatherBy[Transpose[{avals,reduced\[Omega]vals,\[Lambda]vals}],Rest];
Signal[times,
{type,N@reducedpeaks},
Evaluate@SimplifyRules[
PeakReductionImplemented->True,
PeaksSnappedToFrequencyGrid->snapped,
opts
]
]
)];


(* ::Input::Initialization:: *)
Signal/:Expand[Signal[times:{tmin_,tmax_,\[Delta]t_},data_,opts___Rule]]/;(EmbedCoordinates/.{opts}/.Options[Signal]):=
Module[{n},(
n=Round[Abs[(tmax-tmin)/\[Delta]t]]+1;
Transpose[
{
Table[tmin+i \[Delta]t,{i,0,n-1}],
Expand@Signal[times,data,
SimplifyRules[EmbedCoordinates->False,opts]
]
}
]
)];


(* ::Input::Initialization:: *)
Signal/:Expand[Signal[times:{tmin_,tmax_,\[Delta]t_},data:{_?NumericQ..},opts___Rule]]/;(!EmbedCoordinates/.{opts}/.Options[Signal])&&MatchQ[LineBroadening/.{opts}/.Options[Signal],None|False]:=data;


(* ::Input::Initialization:: *)
Signal/:Expand[Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,peaks_List},opts___Rule]]/;
MatchQ[{PeaksSnappedToFrequencyGrid,PeakReductionImplemented,EmbedCoordinates,LineBroadening,ZeroFill}/.{opts}/.Options[Signal],{True,True,False|None,False|None|0,_?NumericQ}]&&
MatchQ[Chop[Last/@peaks],{0...}]:=
Module[{avals,\[Omega]vals,\[Lambda]vals,ivals,\[Delta]\[Omega],n,ZF,nZF,\[Omega]min,\[Omega]max,spec},(
ZF=ZeroFill/.{opts}/.Options[Signal];
n=Round[Abs[(tmax-tmin)/\[Delta]t]]+1;
nZF=ZF*n;
\[Delta]\[Omega]=Abs[2\[Pi]/\[Delta]t]/nZF;
{avals,\[Omega]vals,\[Lambda]vals}=Transpose[peaks];
ivals=(Mod[Round[#/\[Delta]\[Omega]],nZF]+1)&/@\[Omega]vals;
Chop@Fourier[SparseArray[ivals->avals,{nZF}],FourierParameters->{1,1}][[Range[1,n]]]
)];


(* ::Input::Initialization:: *)
Signal/:Expand[Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,peaks:{{_,_,\[Lambda]_}..}},opts___Rule]]/;
MatchQ[{PeaksSnappedToFrequencyGrid,PeakReductionImplemented,EmbedCoordinates,LineBroadening}/.{opts}/.Options[Signal],{True,True,False|None,False|None|0}]&&(Chop[\[Lambda]]!=0):=
Module[{n,nZF,tvals,avals,\[Omega]vals,\[Lambda]vals},(
n=Round[Abs[(tmax-tmin)/\[Delta]t]]+1;
tvals=Table[tmin+i \[Delta]t,{i,0,n-1}];
{avals,\[Omega]vals,\[Lambda]vals}=Transpose[peaks];
MapThread[
Times[TimeDomainDecayFunction[type,2\[Lambda],tmin][#1],#2]&,
{tvals,
Expand[
Signal[times,
{type,
Transpose[{avals,\[Omega]vals,Table[0,{Length[peaks]}]}]
},
SimplifyRules[
EmbedCoordinates->False,
LineBroadening->None,
opts
]
]]
}
]
)];


(* ::Input::Initialization:: *)
Signal/:Expand[Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,peaks:{{_,_,_}..}},opts___Rule]]/;MatchQ[{PeaksSnappedToFrequencyGrid,PeakReductionImplemented,EmbedCoordinates,LineBroadening}/.{opts}/.Options[Signal],{True,True,False|None,False|None|0}]:=
Apply[Plus,
Expand[Signal[times,{type,#},opts]]&/@GatherBy[peaks,Last]
];


(* ::Input::Initialization:: *)
Signal/:Expand[Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,peaks:{{_,_,_}..}},opts___Rule]]/;
MatchQ[{PeaksSnappedToFrequencyGrid,PeakReductionImplemented,EmbedCoordinates,LineBroadening}/.{opts}/.Options[Signal],{False,True,False,False|None|0}]:=
Module[{n,tvals,avals,\[Omega]vals,\[Lambda]vals},(
n=Round[Abs[(tmax-tmin)/\[Delta]t]]+1;
tvals=Table[tmin+i \[Delta]t,{i,0,n-1}];
{avals,\[Omega]vals,\[Lambda]vals}=Transpose[peaks];
Map[
Function[t,
Evaluate[
Plus@@MapThread[
((#1)*Exp[I*(#2)*t]*
TimeDomainDecayFunction[type,2 (#3),tmin][t]
)&,
{avals,\[Omega]vals,\[Lambda]vals}
]
]
],
tvals
]
)];


(* ::Input::Initialization:: *)
Signal/:ExpandAll[Signal[args___]]:=Expand[Signal[args]];


(* ::Input::Initialization:: *)
Signal/:Re[Signal[times:{tmin_,tmax_,\[Delta]t_},data_,opts___Rule]]/;!(EmbedCoordinates/.{opts}/.Options[Signal]):=Re[Expand[Signal[times,data,opts]]];


(* ::Input::Initialization:: *)
Signal/:Re[Signal[times:{tmin_,tmax_,\[Delta]t_},data_,opts___Rule]]/;(EmbedCoordinates/.{opts}/.Options[Signal]):={First[#],Re@Last[#]}&/@Expand[Signal[times,data,opts]];


(* ::Input::Initialization:: *)
Signal/:Im[Signal[times:{tmin_,tmax_,\[Delta]t_},data_,opts___Rule]]/;!(EmbedCoordinates/.{opts}/.Options[Signal]):=Im[Expand[Signal[times,data,opts]]];


(* ::Input::Initialization:: *)
Signal/:Im[Signal[times:{tmin_,tmax_,\[Delta]t_},data_,opts___Rule]]/;(EmbedCoordinates/.{opts}/.Options[Signal]):={First[#],Im@Last[#]}&/@Expand[Signal[times,data,opts]];


(* ::Input::Initialization:: *)
Signal/:Abs[Signal[times:{tmin_,tmax_,\[Delta]t_},data_,opts___Rule]]/;!(EmbedCoordinates/.{opts}/.Options[Signal]):=Abs[Expand[Signal[times,data,opts]]];


(* ::Input::Initialization:: *)
Signal/:Abs[Signal[times:{tmin_,tmax_,\[Delta]t_},data_,opts___Rule]]/;(EmbedCoordinates/.{opts}/.Options[Signal]):={First[#],Abs@Last[#]}&/@Expand[Signal[times,data,opts]];


(* ::Input::Initialization:: *)
Signal/:HoldPattern@Times[a___,Signal[times:{tmin_,tmax_,\[Delta]t_},data:{_?NumericQ..},opts___Rule],b___]:=
Signal[times,Times[{1,Times[a,b]},#]&/@data,opts];


(* ::Input::Initialization:: *)
Signal/:HoldPattern@Times[a___,Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,peaks_List},opts___Rule],b___]:=
Signal[times,
{type,Times[{Times[a,b],1,1},#]&/@peaks},
opts];


(* ::Input::Initialization:: *)
Signal/:FT[Signal[args:Except[Rule]..,sigopts___Rule],FTopts___Rule]:=
FT[
Expand[Signal[args,sigopts]],
Evaluate@SimplifyRules[
FTopts,
sigopts
]
];


(* ::Input::Initialization:: *)
Signal/:ListPlot[Signal[args___],more___]:=ListPlot[Expand[Signal[args]],more];


(* ::Input::Initialization:: *)
Signal::typeunkn="Unknown peak type";


(* ::Input::Initialization:: *)
Signal::badtimes="Incompatible timing specifications";


(* ::Input::Initialization:: *)
Signal::obssnap="The option SnapPeaksToFrequencyGrid is obsolete. Proceeding using DigitalFrequencyResolution\[Rule]Automatic.";


(* ::Input::Initialization:: *)
Options[ApplyLineBroadening]={LineBroadening->Automatic,DefinedPeakTypes->{"Lorentzian"}};


(* ::Input::Initialization:: *)
ApplyLineBroadening[sig_,opts___Rule]/;MatchQ[LineBroadening/.{opts}/.Options[Signal],None|False]:=sig;


(* ::Input::Initialization:: *)
ApplyLineBroadening[sig_,opts___Rule]/;(!MatchQ[LineBroadening/.{opts}/.Options[Signal],Automatic|None|_?NumericQ|{_?(MemberQ[DefinedPeakTypes/.Options[ApplyLineBroadening],#]&),_?NumericQ}
]):=(Message[ApplyLineBroadening::unrecoglb];$Failed);


(* ::Input::Initialization:: *)
ApplyLineBroadening[sig_,opts___Rule]/;MatchQ[LineBroadening/.{opts}/.Options[ApplyLineBroadening],_?NumericQ]:=
ApplyLineBroadening[sig,
SimplifyRules[
LineBroadening->{"Lorentzian",LineBroadening/.{opts}/.Options[ApplyLineBroadening]},
opts
]
];


(* ::Input::Initialization:: *)
ApplyLineBroadening[Signal[times:{tmin_,tmax_,\[Delta]t_},data_,sigopts___Rule],opts___Rule]/;MatchQ[LineBroadening/.{opts}/.Options[ApplyLineBroadening],None|0]:=
Signal[times,data,sigopts];


(* ::Input::Initialization:: *)
ApplyLineBroadening[sig:Signal[times:{tmin_,tmax_,\[Delta]t_},more___],
opts___Rule]/;MatchQ[LineBroadening/.{opts}/.Options[ApplyLineBroadening],Automatic]:=
Module[{fwhh},(
fwhh=N[4 Log[10]/(Abs[tmax-tmin])];
Message[ApplyLineBroadening::autolb,EngineeringForm@N[fwhh/(2\[Pi])]];
ApplyLineBroadening[
sig,
SimplifyRules[LineBroadening->{"Lorentzian",fwhh},opts]
]
)];


(* ::Input::Initialization:: *)
ApplyLineBroadening[Signal[times:{tmin_,tmax_,\[Delta]t_},{type_String,peaks_List},sigopts___Rule],opts___Rule]/;
MatchQ[LineBroadening/.{opts}/.Options[ApplyLineBroadening],{type,Except[0|None]}]:=
Module[{lb},(
lb=Last[LineBroadening/.{opts}/.Options[Signal]];
Signal[times,
{type,Plus[{0,0,lb/2},#]&/@peaks},
SimplifyRules[
LineBroadening->None,
sigopts,
Sequence@@Options[Signal]
]
]
)];


(* ::Input::Initialization:: *)
ApplyLineBroadening[Signal[times:{tmin_,tmax_,\[Delta]t_},data:{_?NumericQ...},sigopts___Rule],opts___Rule]/;MatchQ[LineBroadening/.{opts}/.Options[Signal],{_String,Except[0|None]}]&&MatchQ[LineBroadening/.{sigopts}/.Options[ApplyLineBroadening],None]:=
Module[{n,tvals,lb,lbtype},(
{lbtype,lb}=LineBroadening/.{opts}/.Options[Signal];
n=Round[Abs[(tmax-tmin)/\[Delta]t]]+1;
tvals=Table[tmin+i \[Delta]t,{i,0,n-1}];
Signal[times,
MapThread[
Times[TimeDomainDecayFunction[lbtype,lb,tmin][#1],#2]&,
{tvals,data}
],
SimplifyRules[
LineBroadening->None,
sigopts,
Sequence@@Options[Signal]
]
]
)];


(* ::Input::Initialization:: *)
ApplyLineBroadening[data:{{_?NumericQ,_?NumericQ}...},opts___Rule]/;MatchQ[LineBroadening/.{opts}/.Options[Signal],None]:=data;


(* ::Input::Initialization:: *)
ApplyLineBroadening[data:{{_?NumericQ,_?NumericQ}...},opts___Rule]/;MatchQ[LineBroadening/.{opts}/.Options[Signal],{_String,Except[0|None]}]:=
Module[{tvals,tmin,svals,lb,lbtype},(
{lbtype,lb}=LineBroadening/.{opts}/.Options[Signal];
{tvals,svals}=Transpose[data];
tmin=First@tvals;
Inner[
{#1,Times[TimeDomainDecayFunction[lbtype,lb,tmin][#1],#2]}&,
tvals,svals,
List
]
)];


(* ::Input::Initialization:: *)
TimeDomainDecayFunction["Lorentzian",fwhh_,tmin_]:=(Exp[-(fwhh/2)*(#-tmin)])&;


(* ::Input::Initialization:: *)
ApplyLineBroadening::unrecoglb="Unrecognized line-broadening specification.";


(* ::Input::Initialization:: *)
ApplyLineBroadening::autolb="Using LineBroadening \[Rule] 2\[Pi] \[Times] `1` rad \!\(\*SuperscriptBox[\(s\), \(-1\)]\).";


(* ::Input::Initialization:: *)
Options[FT]={EmbedCoordinates->True,SampleFrequency->Automatic,SampleInterval->Automatic,FirstPointMultiplicationFactor->0.5,ZeroFill->True,LineBroadening->None};


(* ::Input::Initialization:: *)
FT[sig:Except[_Rule],opts___Rule]/;
(!MatchQ[LineBroadening/.{opts}/.Options[FT],None|False]):=
FT[
ApplyLineBroadening[sig,LineBroadening->(LineBroadening/.{opts}/.Options[FT])],
SimplifyRules[
LineBroadening->None,
opts
]
];


(* ::Input::Initialization:: *)
FT[sig:Except[_Rule],opts___Rule]/;MatchQ[ZeroFill/.{opts}/.Options[FT],True|Automatic]:=
Signal[sig,
Evaluate@SimplifyRules[
ZeroFill->2,
opts,
Sequence@@Options[FT]
]
];


(* ::Input::Initialization:: *)
FT[sig:Except[_Rule],opts___Rule]/;MatchQ[ZeroFill/.{opts}/.Options[FT],None|False]:=
Signal[sig,
Evaluate@SimplifyRules[
ZeroFill->1,
opts,
Sequence@@Options[FT]
]
];


(* ::Input::Initialization:: *)
FT[sig1D_?MatrixQ,opts___Rule]/;(MatchQ[Dimensions[sig1D],{_,2}]&&(EmbedCoordinates/.{opts}/.Options[FT])&&
MatchQ[SampleInterval/.{opts}/.Options[FT],Automatic]&&
MatchQ[LineBroadening/.{opts}/.Options[FT],None|False]
):=
Module[{tcoords,n,\[Delta]t},(
tcoords=First/@sig1D;
\[Delta]t=tcoords[[2]]-tcoords[[1]];
n=Length[tcoords];
If[
Chop@N[Table[i*\[Delta]t,{i,0,n-1}]-tcoords]==Table[0,{n}],
FT[Last/@sig1D,EmbedCoordinates->True,SampleInterval->\[Delta]t,opts],
(Message[FT::badtcoords];$Failed)
]
)];


(* ::Input::Initialization:: *)
FT[sig1D:{Except[_List]..},opts___Rule]/;(
(EmbedCoordinates/.{opts}/.Options[FT])&&
((!MatchQ[SampleInterval/.{opts}/.Options[FT],Automatic])||(!MatchQ[SampleFrequency/.{opts}/.Options[FT],Automatic])
)&&(MatchQ[LineBroadening/.{opts}/.Options[FT],None|False])
):=
AddFrequencyCoordinates[
FT[sig1D,EmbedCoordinates->False,opts],opts
];


(* ::Input::Initialization:: *)
FT[sig1D:{Except[_List]..},opts___Rule]/;(
(EmbedCoordinates/.{opts}/.Options[FT])&&
MatchQ[SampleInterval/.{opts}/.Options[FT],Automatic]&&
MatchQ[SampleFrequency/.{opts}/.Options[FT],Automatic]&&(MatchQ[LineBroadening/.{opts}/.Options[FT],None|False])
):=(Message[FT::no\[Delta]t];$Failed);


(* ::Input::Initialization:: *)
FT[sig2D_?MatrixQ,opts___Rule]/;(MatchQ[Dimensions[sig2D],{_,3}]&&(EmbedCoordinates/.{opts}/.Options[FT])&&
MatchQ[SampleInterval/.{opts}/.Options[FT],Automatic]&&(MatchQ[LineBroadening/.{opts}/.Options[FT],None|False])
):=
Module[{t1vals,t2vals,sigvals,n1,n2,\[Delta]t1,\[Delta]t2},(
{t1vals,t2vals,sigvals}=Transpose[sig2D];
\[Delta]t1=(#[[2]]-#[[1]])&@Union[t1vals];
\[Delta]t2=(#[[2]]-#[[1]])&@Union[t2vals];
{n1,n2}=Length[Union[#]]&/@{t1vals,t2vals};
If[
Chop@N[
Flatten[
Table[{i1*\[Delta]t1,i2*\[Delta]t2},{i1,0,n1-1},{i2,0,n2-1}],
1]-Transpose[{t1vals,t2vals}]==Table[{0,0},{n1*n2}]
],
FT[
Partition[sigvals,n2],
EmbedCoordinates->True,SampleInterval->{\[Delta]t1,\[Delta]t2},opts],
(Message[FT::badtcoords];$Failed)
]
)];


(* ::Input::Initialization:: *)
FT[sig2D:{{Except[_List]..}..},opts___Rule]/;
(
(EmbedCoordinates/.{opts}/.Options[FT])&&
(MatchQ[SampleInterval/.{opts}/.Options[FT],{_,_}]||MatchQ[SampleFrequency/.{opts}/.Options[FT],{_,_}]
)&&(MatchQ[LineBroadening/.{opts}/.Options[FT],None|False])
):=
AddFrequencyCoordinates[
FT[sig2D,EmbedCoordinates->False,opts],opts
];


(* ::Input::Initialization:: *)
FT[sig2D:{{Except[_List]..}..},opts___Rule]/;
(
(EmbedCoordinates/.{opts}/.Options[FT])&&
MatchQ[SampleInterval/.{opts}/.Options[FT],Automatic]&&
MatchQ[SampleFrequency/.{opts}/.Options[FT],Automatic]&&(MatchQ[LineBroadening/.{opts}/.Options[FT],None|False])
):=(Message[FT::no\[Delta]t];$Failed);


(* ::Input::Initialization:: *)
FT[sig1D:{Except[_List]..},opts___Rule]/;!(EmbedCoordinates/.{opts}/.Options[FT])&&(MatchQ[LineBroadening/.{opts}/.Options[FT],None|False]):=
(
RotateRight[#,Floor[Length[#]/2]-1]&@
Fourier[
ZeroFill[
CorrectFirstPoint[sig1D,opts],
opts
],
FourierParameters->{1,-1}
]/Length[sig1D]
);


(* ::Input::Initialization:: *)
FT[sig2D:{{Except[_List]..}..},opts___Rule]/;MatchQ[FirstPointMultiplicationFactor/.{opts}/.Options[FT],Except[_List]]&&!(EmbedCoordinates/.{opts}/.Options[FT])&&(MatchQ[LineBroadening/.{opts}/.Options[FT],None|False]):=
FT[sig2D,FirstPointMultiplicationFactor->Table[FirstPointMultiplicationFactor/.{opts}/.Options[FT],{2}],opts];


(* ::Input::Initialization:: *)
FT[sig2D:{{Except[_List]..}..},opts___Rule]/;MatchQ[ZeroFill/.{opts}/.Options[FT],Except[_List]]&&!(EmbedCoordinates/.{opts}/.Options[FT])&&(MatchQ[LineBroadening/.{opts}/.Options[FT],None|False]):=
FT[sig2D,ZeroFill->Table[ZeroFill/.{opts}/.Options[FT],{2}],opts];


(* ::Input::Initialization:: *)
FT[sig2D:{{Except[_List]..}..},opts___Rule]/;!(EmbedCoordinates/.{opts}/.Options[FT])&&(MatchQ[LineBroadening/.{opts}/.Options[FT],None|False]):=
Module[{zfdir,zfindir,fpmfdir,fpmfindir},(
{zfdir,zfindir}=ZeroFill/.{opts}/.Options[FT];
{fpmfdir,fpmfindir}=FirstPointMultiplicationFactor/.{opts}/.Options[FT];
Transpose[
FT[#,EmbedCoordinates->False,ZeroFill-> zfindir,FirstPointMultiplicationFactor->fpmfindir,opts]&/@Transpose[FT[#,EmbedCoordinates->False,ZeroFill-> zfdir,FirstPointMultiplicationFactor->fpmfdir, opts]&/@sig2D]
]
)];


(* ::Input::Initialization:: *)
ZeroFill[fdata:{Except[_List]..},opts___Rule]/;MatchQ[ZeroFill/.{opts}/.Options[FT],False|None|1]:=fdata;


(* ::Input::Initialization:: *)
ZeroFill[fdata:{Except[_List]..},opts___Rule]/;MatchQ[ZeroFill/.{opts}/.Options[FT],Automatic|True]:=
ZeroFill[fdata,
SimplifyRules[
ZeroFill->2,
opts
]
];


(* ::Input::Initialization:: *)
ZeroFill[fdata:{Except[_List]..},opts___Rule]:=
Module[{zf},(
If[zf<2,
(Message[ZeroFill::inval,zf];$Failed),
Join[fdata,Table[0,{Length[fdata]*(zf-1)}]]
]
)/;(
zf=ZeroFill/.{opts}/.Options[FT];
IntegerQ[zf]
)
];


(* ::Input::Initialization:: *)
ZeroFill::inval="Option `1` is invalid for ZeroFill.";


(* ::Input::Initialization:: *)
CorrectFirstPoint[fdata:{Except[_List]..},opts___Rule]:=Module[{fpmf},(
fpmf=FirstPointMultiplicationFactor/.{opts}/.Options[FT];
ReplacePart[fdata,1->fpmf*First@fdata]
)];


(* ::Input::Initialization:: *)
AddFrequencyCoordinates[fdata:{Except[_List]..},opts___Rule]:=Module[{\[Delta]t,sw,n},(
\[Delta]t=SampleInterval/.{opts}/.Options[FT];
AddFrequencyCoordinates[fdata,SampleFrequency->1/\[Delta]t,opts]
)]/;(!MatchQ[SampleInterval/.{opts}/.Options[FT],Automatic])&&MatchQ[SampleFrequency/.{opts}/.Options[FT],Automatic];


(* ::Input::Initialization:: *)
AddFrequencyCoordinates[fdata:{Except[_List]..},opts___Rule]:=Module[{sw,n},(
n=Length[fdata];
sw=SampleFrequency/.{opts}/.Options[FT];
If[EvenQ[n],
Transpose[{Range[-(n/2)+1,(n/2)]*sw/n,fdata}],
Transpose[{Range[-Floor[n/2],Floor[n/2]]*sw/n,fdata}]
]
)]/;(MatchQ[SampleFrequency/.{opts}/.Options[FT],Except[_List]])&&
!MatchQ[SampleFrequency/.{opts}/.Options[FT],Automatic];


(* ::Input::Initialization:: *)
AddFrequencyCoordinates[S2D_?MatrixQ,opts___Rule]:=Module[{\[Delta]t1,\[Delta]t2,sw,n},(
{\[Delta]t1,\[Delta]t2}=SampleInterval/.{opts}/.Options[FT];
AddFrequencyCoordinates[S2D,SampleFrequency->{1/\[Delta]t1,1/\[Delta]t2},opts]
)]/;(MatchQ[SampleInterval/.{opts}/.Options[FT],{_,_}])&&MatchQ[SampleFrequency/.{opts}/.Options[FT],Automatic];


(* ::Input::Initialization:: *)
AddFrequencyCoordinates[S2D_?MatrixQ,opts___Rule]:=
Module[{sw1,sw2,n1,n2,freqs},(
{n1,n2}=Dimensions[S2D];
{sw1,sw2}=SampleFrequency/.{opts}/.Options[FT];
freqs=Flatten[
Outer[List,
Range[-(n1/2)+1,(n1/2)]*sw1/n1,Range[-(n2/2)+1,(n2/2)]*sw2/n2
]
,1];
Flatten/@Transpose[{freqs/(sw1*sw2),Flatten[S2D]}]
)]/;(MatchQ[SampleFrequency/.{opts}/.Options[FT],{_,_}]);


(* ::Input::Initialization:: *)
FT::no\[Delta]t="SampleFrequency or SampleInterval must be specified in the case that EmbedCoordinates\[Rule]True";


(* ::Input::Initialization:: *)
FT::badtcoords="The time coordinates are not an equally spaced list of numbers.";


(* ::Input::Initialization:: *)
Options[CombineData]={EmbedCoordinates->Automatic};


(* ::Input::Initialization:: *)
CombineData[datasets:{(_?NumericQ|_List|Signal[___])..},opts___Rule]:=
CombineData[datasets,Table[1/Length[datasets],{Length[datasets]},opts]
];


(* ::Input::Initialization:: *)
CombineData[datasets_List,weights_List,opts___Rule]:=(Message[CombineData::incompw];$Failed)/;Length[datasets]!=Length[weights];


(* ::Input::Initialization:: *)
CombineData[datasets_List,weights_List,opts___Rule]:=(Message[CombineData::incompdim];$Failed)/;!Equal@@(Dimensions/@datasets);


(* ::Input::Initialization:: *)
CombineSignalOptions[
sigs:{Signal[times_,{type_String,_?MatrixQ},___Rule]..}
]:=Module[{sigoptset,snappeaks,peakreds},(
sigoptset=(List@@#[[3;;-1]])&/@sigs;
snappeaks=Flatten[SnapPeaksToFrequencyGrid/.{sigoptset}/.Options[Signal]];
peakreds=Flatten[PeakReductionImplemented/.{sigoptset}/.Options[Signal]];
{
PeakReductionImplemented->!And@@peakreds
}
)];


(* ::Input::Initialization:: *)
CombineData[
sigs:{Signal[times_,{type_String,_?MatrixQ},___Rule]..},weights_List,opts___Rule]/;(Length[sigs]==Length[weights]):=
Module[{peakset,weightedcombinedpeaks,temp,sig},(
temp=PrintTemporary["combining signals.."];
peakset=Part[#,2,2]&/@sigs;
weightedcombinedpeaks=
SortBy[Join@@MapThread[
Function[{w,pks},({w,1,1}*#)&/@pks],
{weights,peakset},1],Rest];
sig=Signal[
times,
{type,weightedcombinedpeaks},
SimplifyRules[
LineBroadening->None,
Sequence@@CombineSignalOptions[sigs],
Sequence@@Options[Signal]
]
];
NotebookDelete[temp];
sig
)];


(* ::Input::Initialization:: *)
CombineData[
sigs:{Signal[times_,{_?NumericQ...},___Rule]..},weights_List,opts___Rule]/;(Length[sigs]==Length[weights]):=
Module[{datasets,totalopts,temp,sig},(
temp=PrintTemporary["combining signals.."];
datasets=sigs/.Signal[_,data:{_?NumericQ...},___Rule]:>data;
sig=Signal[
times,
Plus@@MapThread[Times,{weights,datasets}],
SimplifyRules[
LineBroadening->None,
Sequence@@Options[Signal]
]
];
NotebookDelete[temp];
sig
)];


(* ::Input::Initialization:: *)
CombineData[datasets:{Except[Signal[___]]..},weights_List,opts___Rule]/;Module[{dims},(
dims=Dimensions[First[datasets]];
MatchQ[EmbedCoordinates/.{opts}/.Options[CombineData],Automatic]&&(
(!(Length[dims]>2))||
(First[dims]!=2)||
(!Equal@@(First/@Transpose/@datasets))
)
)]:=CombineData[datasets,weights,SimplifyRules[EmbedCoordinates->False,opts]
];


(* ::Input::Initialization:: *)
CombineData[datasets:{Except[Signal[___]]..},weights_List,opts___Rule]/;MatchQ[EmbedCoordinates/.{opts}/.Options[CombineData],Automatic]&&(Equal@@(First/@Transpose/@datasets))&&(First@Dimensions[First[datasets]]==2):=
(Message[CombineData::ambig];
CombineData[datasets,weights,SimplifyRules[EmbedCoordinates->True,opts]
]);


(* ::Input::Initialization:: *)
CombineData[datasets:{Except[Signal[___]]..},weights_List,opts___Rule]/;MatchQ[EmbedCoordinates/.{opts}/.Options[CombineData],Automatic]:=
CombineData[datasets,weights,SimplifyRules[EmbedCoordinates->False,opts]
];


(* ::Input::Initialization:: *)
CombineData[datasets:{Except[Signal[___]]..},weights_List,opts___Rule]/;!(EmbedCoordinates/.{opts}/.Options[CombineData]):=Plus@@MapThread[Times,{datasets,weights}];


(* ::Input::Initialization:: *)
CombineData[datasets:{Except[Signal[___]|TrajectoryFunction[___]]..},weights_List,opts___Rule]/;(EmbedCoordinates/.{opts}/.Options[CombineData])&&(First@Dimensions[First[datasets]]!=2):=(Message[CombineData::embcoordbaddim];$Failed);


(* ::Input::Initialization:: *)
CombineData[datasets:{Except[Signal[___]|TrajectoryFunction[___]]..},weights_List,opts___Rule]/;(EmbedCoordinates/.{opts}/.Options[CombineData])&&!(Equal@@(First/@Transpose/@datasets)):=(Message[CombineData::embcoordincompat];$Failed);


(* ::Input::Initialization:: *)
CombineData[datasets:{Except[Signal[___]]..},weights_List,opts___Rule]/;(EmbedCoordinates/.{opts}/.Options[CombineData]):=
Module[{coords,vals},(
coords=Most/@First[datasets];
vals=Map[(Last/@#)&,datasets];
MapThread[Append,{coords,CombineData[vals,weights,EmbedCoordinates->False]}]
)];


(* ::Input::Initialization:: *)
CombineData::incompdim="The data have incompatible dimensions and cannot be combined.";


(* ::Input::Initialization:: *)
CombineData::incompw="number of weights must be equal to the number of data sets.";


(* ::Input::Initialization:: *)
CombineData::embcoordbaddim="The data may only have 2 levels if EmbedCoordinates\[Rule]True.";


(* ::Input::Initialization:: *)
CombineData::embcoordincompat="Embedded time or frequency coordinates must be identical in all data sets.";


(* ::Input::Initialization:: *)
CombineData::ambig="The data is ambiguous. Assuming EmbedCoordinates\[Rule]True.";


(* ::Input::Initialization:: *)
ReflectSpectrum[S1D:{Except[_List]..},opts___Rule]/;EvenQ[Length[S1D]]:=RotateLeft[Reverse[S1D],1]


(* ::Input::Initialization:: *)
ReflectSpectrum[S2D:{{Except[_List]..}..},opts___Rule]/;(Apply[And,EvenQ/@Dimensions[S2D]]&&Last[Dimensions[S2D]]>3):=
Transpose[ReflectSpectrum/@Transpose[S2D]];


(* ::Input::Initialization:: *)
ReflectSpectrum[S1D_?MatrixQ,opts___Rule]/;(MatchQ[Dimensions[S1D],{_?EvenQ,2}]
):=
Module[{tcoords,amplitudes},(
{tcoords,amplitudes}=Transpose[S1D];
Transpose[{tcoords,ReflectSpectrum[amplitudes]}]
)];


(* ::Input::Initialization:: *)
ReflectSpectrum[S2D_?MatrixQ,opts___Rule]/;MatchQ[Dimensions[S2D],{_?EvenQ,3}]:=
Module[{\[Omega]1vals,\[Omega]2vals,amplitudes,n1,n2},(
{\[Omega]1vals,\[Omega]2vals,amplitudes}=Transpose[S2D];
{n1,n2}=Length[Union[#]]&/@{\[Omega]1vals,\[Omega]2vals};
Transpose[{\[Omega]1vals,\[Omega]2vals,Flatten[ReflectSpectrum[Partition[amplitudes,n2]]]
}]
)];


(* ::Input::Initialization:: *)
CombineComplementarySpectra[spec1_?MatrixQ,spec2_?MatrixQ,opts___Rule]:=CombineData[{spec1,ReflectSpectrum[spec2]},{1/2,1/2}];


(* ::Input::Initialization:: *)
End[];
EndPackage[];



