(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["Simulations`Polarization`",
{"Global`",
"SpinDynamica`",
"General`UserLevel`",
"QM`Hilbert`",
"QM`SpinOperators`",
"QM`Liouville`"
}];


(* ::Input::Initialization:: *)
PolarizedDensityOperator::usage=
"\!\(\*
StyleBox[\"PolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"<\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"args\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\">\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) sets up a density operator in which one, or several spins, are polarized along an arbitrary axis. In general the polarization levels and polarization directions may be defined individually for each spin. 
One special case of the syntax is \!\(\*
StyleBox[\"PolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\"\!\(\*
StyleBox[\"z\",\nFontSlant->\"Italic\"]\)\"\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) which generates a density operator with polarization level p along the z-axis for all spins in the current \!\(\*
StyleBox[\"SpinSystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\). Similarly, \!\(\*
StyleBox[\"PolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"l\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\"\!\(\*
StyleBox[\"z\",\nFontSlant->\"Italic\"]\)\"\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)generates a density operator with polarization level \!\(\*
StyleBox[\"p\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)along the z-axis for spins \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"l\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\). 
The most general syntax is \!\(\*
StyleBox[\"PolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"polj\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"axisj\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"polk\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"axisk\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spinsystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) which constructs a density operator for \!\(\*
StyleBox[\"spinsystem\",\nFontSlant->\"Italic\"]\), corresponding to polarization \!\(\*
StyleBox[\"polj\",\nFontSlant->\"Italic\"]\) for spins \!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\) along the axis \!\(\*
StyleBox[\"axisj\",\nFontSlant->\"Italic\"]\), and similarly for spins \!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\), etc. The polarizations \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"polj\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"polk\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\) are in the range -1 to +1, with -1 indicating complete negative polarization, and +1 indicating complete positive polarization. If a polarization argument is omitted, a value of +1 is assumed.
If \!\(\*
StyleBox[\"spinsystem\",\nFontSlant->\"Italic\"]\) is omitted, the current \!\(\*
StyleBox[\"SpinSystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) is assumed. 
The spin labels \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\) must be members of \!\(\*
StyleBox[\"spinsystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)and cannot be duplicated.
The axis arguments may take values \"x\",\"y\", \"z\", or a number \[Phi], or a pair of polar angles {\[Theta],\[Phi]}. The phase \[Phi] denotes an axis in the transverse plane. The polar angles {\[Theta],\[Phi]} may be used to define an arbitrary direction. If an axis argument is omitted, the axis \"z\" is assumed. 
The syntax \!\(\*
StyleBox[\"PolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"pol\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"axis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spinsystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) assumes all spins \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\) have polarization level \!\(\*
StyleBox[\"pol\",\nFontSlant->\"Italic\"]\) along \!\(\*
StyleBox[\"axis\",\nFontSlant->\"Italic\"]\). 
The syntax \!\(\*
StyleBox[\"PolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"pol\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spinsystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)assumes all spins \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\) have polarization level \!\(\*
StyleBox[\"pol\",\nFontSlant->\"Italic\"]\) along the z-axis.
The syntax \!\(\*
StyleBox[\"PolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"pol\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spinsystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) assumes all spins in the \!\(\*
StyleBox[\"spinsystem\",\nFontSlant->\"Italic\"]\) have polarization level \!\(\*
StyleBox[\"pol\",\nFontSlant->\"Italic\"]\) along the \!\(\*
StyleBox[\"z\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"-\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"axis\",\nFontSlant->\"Italic\"]\).
The syntax \!\(\*
StyleBox[\"PolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"axis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spinsystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) assumes all spins in the \!\(\*
StyleBox[\"spinsystem\",\nFontSlant->\"Italic\"]\) have polarization level +1 along \!\(\*
StyleBox[\"axis\",\nFontSlant->\"Italic\"]\).
";


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator::usage=
"\!\(\*
StyleBox[\"SingletPolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"<\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"args\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\">\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) sets up a density operator in which one spin pair, or several spin pairs, exhibit singlet polarization. In general the polarization levels and polarization directions may be defined individually for each spin pair.
In the case where the current \!\(\*
StyleBox[\"SpinSystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) is a spin-1/2 pair, \!\(\*
StyleBox[\"SingletPolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) generates a density operator with singlet polarization \!\(\*
StyleBox[\"p\",\nFontSlant->\"Italic\"]\). 
If the current \!\(\*
StyleBox[\"SpinSystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) contains more than two spins-1/2, the syntax \!\(\*
StyleBox[\"SingletPolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) generates a density operator with singlet polarization \!\(\*
StyleBox[\"p\",\nFontSlant->\"Italic\"]\) for the spin pair \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\), and the syntax \!\(\*
StyleBox[\"SingletPolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"l\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"m\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"p\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) generates a density operator with singlet polarization \!\(\*
StyleBox[\"p\",\nFontSlant->\"Italic\"]\) for the spin pairs \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)and \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"l\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"m\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\). 
The most general syntax is \!\(\*
StyleBox[\"SingletPolarizedDensityOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"pjk\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"l\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"m\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"plm\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spinsystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) which allows individual singlet polarization levels for distinct spin pairs. If \!\(\*
StyleBox[\"spinsystem\",\nFontSlant->\"Italic\"]\) is omitted, the current \!\(\*
StyleBox[\"SpinSystem\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) is assumed.
";


(* ::Input::Initialization:: *)
PolarizationLevelOperator::usage=
"\!\(\*
StyleBox[\"PolarizationLevelOperator\",\nFontSlant->\"Italic\"]\) is an operator for the polarization level of the spin system. For example \!\(\*
StyleBox[\"OperatorAmplitude\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\[Rho]\[Rule]\!\(\*
StyleBox[\"PolarizationLevelOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\"z\"]] extracts the mean polarization level of spins 1 and 2 along the z-axis, for the density operator \[Rho].
\!\(\*
StyleBox[\"PolarizationLevelOperator\",\nFontSlant->\"Italic\"]\)[\"z\"] is the operator for the mean level of polarization along the z-axis. 
\!\(\*
StyleBox[\"PolarizationLevelOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\"z\"\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)is the operator for the the mean level of polarization of spins 1 and 2 along the z-axis. 
The general syntax is \!\(\*
StyleBox[\"PolarizationLevelOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"...\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"axis\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) where \!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\) is the set of spins to be analyzed and \!\(\*
StyleBox[\"axis\",\nFontSlant->\"Italic\"]\) defines the direction of the polarization. 
\!\(\*
StyleBox[\"PolarizationLevelOperator\",\nFontSlant->\"Italic\"]\) may be used as an observable in simulation routines (\!\(\*
StyleBox[\"Trajectory\",\nFontSlant->\"Italic\"]\), \!\(\*
StyleBox[\"TransformationAmplitude\",\nFontSlant->\"Italic\"]\), etc.) in order to simulate the polarization level of the spin system. 
The operator \!\(\*
StyleBox[\"PolarizationLevelOperator\",\nFontSlant->\"Italic\"]\) is distinct from the \"polarization operator\" used by Ernst and co-workers, which refers to the projection operator onto the Zeeman eigenstates of a spin-1/2, and whose functionality is covered in \!\(\*
StyleBox[\"SpinDynamica\",\nFontSlant->\"Italic\"]\) by the syntax o\!\(\*
StyleBox[\"pI\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\"\[Alpha]\"\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"opI\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\"\[Beta]\"\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\).
";


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator::usage=
"\!\(\*
StyleBox[\"SingletPolarizationLevelOperator\",\nFontSlant->\"Italic\"]\) is an operator for the polarization level of the spin system. For example \!\(\*
StyleBox[\"OperatorAmplitude\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\[Rho]\[Rule]\!\(\*
StyleBox[\"SingletPolarizationLevelOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)]] extracts the mean singlet polarization level of spins 1 and 2, for the density operator \[Rho].
\!\(\*
StyleBox[\"SingletPolarizationLevelOperator\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"j2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"k2\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) is the operator for the mean level of singlet polarization for the specified spin pairs.
\!\(\*
StyleBox[\"SingletPolarizationLevelOperator\",\nFontSlant->\"Italic\"]\) may be used as an observable in simulation routines (\!\(\*
StyleBox[\"Trajectory\",\nFontSlant->\"Italic\"]\), \!\(\*
StyleBox[\"TransformationAmplitude\",\nFontSlant->\"Italic\"]\), etc.) in order to simulate the singlet polarization level of the spin system. 
";


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[args___]:=(Message[SpinSystem::notready];Abort[])/;MatchQ[SpinSystem/.Options[SpinSystem],Undefined];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
PolarizedDensityOperator[]:=PolarizedDensityOperator[All];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[arg_]:=PolarizedDensityOperator[arg,SpinSystem[]];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[args__]/;!MatrixQ[Last@{args}]:=PolarizedDensityOperator[args,SpinSystem[]];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[All,spinsys_?MatrixQ]:=PolarizedDensityOperator[First/@spinsys,spinsys];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[pol:Except[_List|_String|All],spinsys_?MatrixQ]:=PolarizedDensityOperator[First/@spinsys,pol,spinsys];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[spins:{Except[_List]..},spinsys_?MatrixQ]/;ValidSpinQ[spins,spinsys]:=PolarizedDensityOperator[spins,{1,"z"},spinsys];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[axis_?ValidAxisSpecificationQ,spinsys_?MatrixQ]:=PolarizedDensityOperator[First/@spinsys,{1,axis},spinsys];


(* ::Input::Initialization:: *)
 PolarizedDensityOperator[{pol:(_?NumericQ|_Symbol),axis_?ValidAxisSpecificationQ},spinsys_?MatrixQ]:=
PolarizedDensityOperator[First/@spinsys,{pol,axis},spinsys]; 


(* ::Input::Initialization:: *)
PolarizedDensityOperator[j:Except[_List],axis_?ValidAxisSpecificationQ,spinsys_?MatrixQ]/;ValidSpinQ[j,spinsys]:=PolarizedDensityOperator[j,{1,axis},spinsys];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[j:Except[_List],{pol_,axis_?ValidAxisSpecificationQ},spinsys_?MatrixQ]/;ValidSpinQ[j,spinsys]:=PolarizedDensityOperator[{j},{pol,axis},spinsys];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[spins:{Except[_List]..},pol:(_?NumericQ|_Symbol),spinsys_?MatrixQ]:=PolarizedDensityOperator[spins,{pol,"z"},spinsys];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[spins:{Except[_List]..},axis_?ValidAxisSpecificationQ,spinsys_?MatrixQ]:=PolarizedDensityOperator[spins,{1,axis},spinsys];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[spins:{Except[_List]..},{pol_,axis_?ValidAxisSpecificationQ},spinsys_?MatrixQ]:=PolarizedDensityOperator[{#,{pol,axis}}&/@spins,spinsys];


(* ::Input::Initialization:: *)
PolarizedDensityOperator[polspecs:{{_,{_,_}}..},spinsys_?MatrixQ]:=
If[
FreeQ[#,$Failed],
(*PolarizedDensityOperator[polspecs,spinsys]=*)Simplify@Expand[#],
$Failed]&@
Module[{dim},(
dim=BasisDimension[ZeemanBasis[spinsys]];
dim^(Length[polspecs]-1)*
Apply[Dot,SingleSpinPolarizedDensityOperator[#,spinsys]&/@polspecs]
)];


(* ::Input::Initialization:: *)
SingleSpinPolarizedDensityOperator[{j:Except[_List],{pol_,axis_}},spinsys_]/;!ValidAxisSpecificationQ[axis]:=
(Message[PolarizedDensityOperator::badaxis];$Failed);


(* ::Input::Initialization:: *)
SingleSpinPolarizedDensityOperator[{j:Except[_List],{pol_,axis_}},spinsys_]/;TrueQ[pol>1]:=(Message[PolarizedDensityOperator::polgt1];$Failed);


(* ::Input::Initialization:: *)
SingleSpinPolarizedDensityOperator[{j:Except[_List],{pol_,axis_}},spinsys_]/;TrueQ[pol<-1]:=(Message[PolarizedDensityOperator::polltneg1];$Failed);


(* ::Input::Initialization:: *)
SingleSpinPolarizedDensityOperator[{j:Except[_List],{pol_,axis_}},spinsys_]/;!ValidSpinQ[j,spinsys]:=(Message[SpinSystem::invspin,j];$Failed);


(* ::Input::Initialization:: *)
SingleSpinPolarizedDensityOperator[{j_,{pol_,axis_}},spinsys_?MatrixQ]:=
Module[{dim},(
dim=BasisDimension[ZeemanBasis[spinsys]];
(*SingleSpinPolarizedDensityOperator[{j,pol,axis},spinsys]=*)dim^-1(UnityOperator[]+2 pol opI[j,axis])
)];


(* ::Input::Initialization:: *)
PolarizedDensityOperator::badaxis="Cannot interpret polarization axis specification.";


(* ::Input::Initialization:: *)
PolarizedDensityOperator::polgt1="The polarization level cannot be greater than 1.";


(* ::Input::Initialization:: *)
PolarizedDensityOperator::polltneg1="The polarization level cannot be less than -1.";


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[args___]:=(Message[SpinSystem::notready];Abort[])/;MatchQ[SpinSystem/.Options[SpinSystem],Undefined];


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[]:=
Module[{spinsys},(
spinsys=SpinSystem[];
If[MatchQ[spinsys,{{_,1/2},{_,1/2}}],SingletPolarizedDensityOperator[First/@spinsys],
(Message[SingletPolarizedDensityOperator::notspinpair];$Failed)
]
)];


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[args_]:=SingletPolarizedDensityOperator[args,SpinSystem[]];


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[args__]/;!MatrixQ[Last@{args}]:=SingletPolarizedDensityOperator[args,SpinSystem[]];


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[{{j:Except[_List],k:Except[_List]}},pol:Except[_List]]:=SingletPolarizedDensityOperator[{{j,k}},pol,SpinSystem[]];


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[spinpairs:({Except[_List],Except[_List]}|{{Except[_List],Except[_List]}..}),spinsys_?MatrixQ]:=SingletPolarizedDensityOperator[spinpairs,1,spinsys];


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[pol:Except[_List],spinsys_?MatrixQ]/;MatchQ[spinsys,{{_,1/2},{_,1/2}}]:=SingletPolarizedDensityOperator[First/@spinsys,pol,spinsys];


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[{j:Except[_List],k:Except[_List]},pol:Except[_List],spinsys_?MatrixQ]:=SingletPolarizedDensityOperator[{{j,k},pol},spinsys];


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[spinpairs:{{_,_}..},pol:Except[_List],spinsys_?MatrixQ]:=
SingletPolarizedDensityOperator[{#,pol}&/@spinpairs,spinsys];


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[polpairs:{{{Except[_List],Except[_List]},Except[_List]}..},spinsys_]:=
Module[{spinpairs},(
Message[SingletPolarizedDensityOperator::sharedspins];
$Failed
)/;(
spinpairs=First/@polpairs;
(Length[spinpairs]>1)&&(!Intersection[Sequence@@spinpairs]=={})
)
];


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[polpairs:{{{Except[_List],Except[_List]},_}..},spinsys_?MatrixQ]:=
If[
FreeQ[#,$Failed],
SingletPolarizedDensityOperator[polpairs,spinsys]=Simplify@Expand[#],
$Failed]&@
Module[{dim},(
dim=BasisDimension[ZeemanBasis[spinsys]];
SingletPolarizedDensityOperator[polpairs,spinsys]=Simplify[dim^(Length[polpairs]-1)*
Apply[Dot,SingletPolarizedDensityOperator[#,spinsys]&/@polpairs]
]
)];


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[{{j:Except[_List],k:Except[_List]},pol:Except[_List]},spinsys_]/;!ValidSpinQ[j,spinsys]:=(Message[SpinSystem::invspin,j];$Failed);


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[{{j:Except[_List],k:Except[_List]},pol:Except[_List]},spinsys_]/;!ValidSpinQ[k,spinsys]:=(Message[SpinSystem::invspin,k];$Failed);


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[{{j:Except[_List],k:Except[_List]},pol:Except[_List]},spinsys_]/;(SpinQuantumNumber[j,spinsys]!=1/2):=(Message[SingletPolarizedDensityOperator::notspinhf,j];$Failed);


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[{{j:Except[_List],k:Except[_List]},pol:Except[_List]},spinsys_]/;(SpinQuantumNumber[k,spinsys]!=1/2):=(Message[SingletPolarizedDensityOperator::notspinhf,k];$Failed);


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[{{j_,j_},pol:Except[_List]},spinsys_]:=(Message[SingletPolarizedDensityOperator::invalpair,{j,j}];$Failed);


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[{{j:Except[_List],k:Except[_List]},pol:Except[_List]},spinsys_]/;(pol>1):=(Message[SingletPolarizedDensityOperator::toobigpol];$Failed)


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[{{j:Except[_List],k:Except[_List]},pol:Except[_List]},spinsys_]/;(pol<-1/3):=(Message[SingletPolarizedDensityOperator::toonegpol];$Failed)


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator[{{j:Except[_List],k:Except[_List]},pol:Except[_List]},spinsys_?MatrixQ]:=
Module[{dim},(
dim=BasisDimension[ZeemanBasis[spinsys]];
SingletPolarizedDensityOperator[{{j,k},pol},spinsys]=Simplify[(4/dim)((1/4)UnityOperator[]- pol opI[j].opI[k])]
)];


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator::notspinhf="Spin `1` is not spin-1/2.";


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator::invalpair="The spin pair `1` is invalid.";


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator::toobigpol="The singlet polarization cannot be larger than 1.";


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator::toonegpol="The singlet polarization cannot be less than -1/3.";


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator::sharedspins="Spins may not be shared between different pairs.";


(* ::Input::Initialization:: *)
SingletPolarizedDensityOperator::notspinpair="The current SpinSystem[] is not a spin-1/2 pair. The singlet spin pair must be specified explicitly.";


(* ::Input::Initialization:: *)
PolarizationLevelOperator[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
PolarizationLevelOperator[args___]:=(Message[SpinSystem::notready];Abort[])/;TrueQ[(SpinSystem/.Options[SpinSystem])==Undefined];


(* ::Input::Initialization:: *)
PolarizationLevelOperator[]:=PolarizationLevelOperator[All];


(* ::Input::Initialization:: *)
PolarizationLevelOperator[args__]/;!MatrixQ@Last[{args}]:=PolarizationLevelOperator[args,SpinSystem[]];


(* ::Input::Initialization:: *)
PolarizationLevelOperator[j:Except[_List],spinsys_?MatrixQ]/;ValidSpinQ[j,spinsys]:=PolarizationLevelOperator[j,"z",spinsys];


(* ::Input::Initialization:: *)
PolarizationLevelOperator[All,spinsys_?MatrixQ]:=PolarizationLevelOperator[First/@spinsys,spinsys];


(* ::Input::Initialization:: *)
PolarizationLevelOperator[spins_List,spinsys_?MatrixQ]/;And@@(ValidSpinQ[#,spinsys]&/@spins):=PolarizationLevelOperator[spins,"z",spinsys];


(* ::Input::Initialization:: *)
PolarizationLevelOperator[axis_?ValidAxisSpecificationQ,spinsys_?MatrixQ]:=PolarizationLevelOperator[All,axis,spinsys];


(* ::Input::Initialization:: *)
PolarizationLevelOperator[All,axis_,spinsys_?MatrixQ]:=PolarizationLevelOperator[First/@spinsys,axis,spinsys];


(* ::Input::Initialization:: *)
PolarizationLevelOperator[spins_,axis_,spinsys_?MatrixQ]/;!ValidAxisSpecificationQ[axis]:=
(Message[PolarizationLevelOperator::badaxis];$Failed);


(* ::Input::Initialization:: *)
PolarizationLevelOperator[spins_List]/;!DuplicateFreeQ[spins]:=(Message[PolarizationLevelOperator::dupspins,spins];$Failed);


(* ::Input::Initialization:: *)
PolarizationLevelOperator[spins_List,axis_,spinsys_]:=
If[FreeQ[#,$Failed],
PolarizationLevelOperator[axis,spins,spinsys]=Simplify[#],
$Failed
]&@
Apply[Plus,PolarizationLevelOperator[#,axis,spinsys]&/@spins];


(* ::Input::Initialization:: *)
PolarizationLevelOperator[j:Except[_List],axis_,spinsys_]/;!ValidSpinQ[j,spinsys]:=(Message[SpinSystem::invspin,j];$Failed);


(* ::Input::Initialization:: *)
PolarizationLevelOperator[j:Except[_List],axis_?ValidAxisSpecificationQ,spinsys_]:=
(PolarizationLevelOperator[axis,j,spinsys]=
Module[{Ij,dim},(
Ij=SpinQuantumNumber[j,spinsys];
dim=BasisDimension[ZeemanBasis[spinsys]];
Simplify[3/((Ij+1)*dim)*opI[j,axis]]
)]
);


(* ::Input::Initialization:: *)
PolarizationLevelOperator::dupspins="The specified list of spins `1` should not contain duplicates.";


(* ::Input::Initialization:: *)
PolarizationLevelOperator::badaxis="Cannot interpret polarization axis specification.";


(* ::Input::Initialization:: *)
PolarizationLevelOperator::inval\[Rho]="\!\(\*
StyleBox[\"PolarizationLevelOperator\",\nFontSlant->\"Italic\"]\) has been used with a non-rigorous density operator (trace not equal to 1). Polarization levels are unreliable in this case.";


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator[args___]/;!FreeQ[{args},$Failed]:=$Failed;


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator[args___]:=(Message[SpinSystem::notready];Abort[])/;MatchQ[SpinSystem/.Options[SpinSystem],Undefined];


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator[]:=
Module[{spinsys},(
spinsys=SpinSystem[];
If[MatchQ[spinsys,{{_,1/2},{_,1/2}}],SingletPolarizationLevelOperator[First/@spinsys],
(Message[SingletPolarizationLevelOperator::notspinpair];$Failed)
]
)];


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator[args_]:=SingletPolarizationLevelOperator[args,SpinSystem[]];


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator[spinpairs:{{_,_}..},spinsys_]:=
Module[{},(
Message[SingletPolarizationLevelOperator::sharedspins];
$Failed
)/;(
(Length[spinpairs]>1)&&And@@Apply[DisjointQ, Subsets[spinpairs,{2}],{1}]
)
];


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator[spinpairs:{{_,_}..},spinsys_]:=
If[FreeQ[#,$Failed],
SingletPolarizationLevelOperator[spinpairs,spinsys]=#,
$Failed
]&@
Simplify[Plus@@(SingletPolarizationLevelOperator[#,spinsys]&/@spinpairs)];


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator[{j:Except[_List],k:Except[_List]},spinsys_]/;!ValidSpinQ[j,spinsys]:=(Message[SpinSystem::invspin,j];$Failed);


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator[{j:Except[_List],k:Except[_List]},spinsys_]/;!ValidSpinQ[k,spinsys]:=(Message[SpinSystem::invspin,k];$Failed);


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator[{j:Except[_List],k:Except[_List]},spinsys_]/;(SpinQuantumNumber[j,spinsys]!=1/2):=(Message[SingletPolarizationLevelOperator::notspinhf,j];$Failed);


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator[{j:Except[_List],k:Except[_List]},spinsys_]/;(SpinQuantumNumber[k,spinsys]!=1/2):=(Message[SingletPolarizationLevelOperator::notspinhf,k];$Failed);


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator[{j_,j_},spinsys_]:=(Message[SingletPolarizationLevelOperator::invalpair,{j,j}];$Failed);


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator[{j_,k_},spinsys_]:=
SingletPolarizationLevelOperator[{j,k},spinsys]=-(4/BasisDimension[ZeemanBasis[spinsys]])opI[j].opI[k];


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator::notspinhf="Spin `1` is not spin-1/2.";


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator::invalpair="The spin pair `1` is invalid.";


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator::sharedspins="Spins may not be shared between different pairs.";  


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator::notspinpair="The current SpinSystem[] is not a spin-1/2 pair. The singlet spin pair must be specified explicitly.";


(* ::Input::Initialization:: *)
SingletPolarizationLevelOperator::inval\[Rho]="\!\(\*
StyleBox[\"SingletPolarizationLevelOperator\",\nFontSlant->\"Italic\"]\) has been used with a non-rigorous density operator (trace not equal to 1). Polarization levels are unreliable in this case.";


(* ::Input::Initialization:: *)
End[];
EndPackage[];



