(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
BeginPackage["SpinDynamica`",{"Global`","SubKernels`"}];


(* ::Input::Initialization:: *)
Chronology::usage="Chronology is an option for many routines in SpinDynamica, which controls the temporal order of events in all event sequences used by the routines. The value of Chronology must be \"LeftToRight\" or \"RightToLeft\". The default value is set by $Chronology.";


(* ::Input::Initialization:: *)
$Chronology::usage="$Chronology is the default setting for Chronology. The value of $Chronology must be \"LeftToRight\" or \"RightToLeft\".";


(* ::Input::Initialization:: *)
$SpinDynamicaVersion::usage="$SpinDynamicaVersion is the active version of SpinDynamica";


(* ::Input::Initialization:: *)
MinimumMathematicaVersionNumber::usage="MinimumMathematicaVersionNumber is the minimum version of Mathematica which is compatible with the current version of SpinDynamica.";


(* ::Input::Initialization:: *)
Sorted::usage="\!\(\*
StyleBox[\"Sorted\",\nFontSlant->\"Italic\"]\) is an option for various routines in \!\(\*
StyleBox[\"SpinDynamica\",\nFontSlant->\"Italic\"]\), which indicates whether the arguments to a function have been placed in canonical order or not.";


(* ::Input::Initialization:: *)
Checked::usage="\!\(\*
StyleBox[\"Checked\",\nFontSlant->\"Italic\"]\) is an option for various routines in SpinDynamica, which indicates whether the arguments to a function have been checked for validity or not.";


(* ::Input::Initialization:: *)
SpinDynamicaSymbols::usage="\!\(\*
StyleBox[\"SpinDynamicaSymbols\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",\nFontSlant->\"Italic\"]\) generates a clickable list of all \!\(\*
StyleBox[\"SpinDynamica\",\nFontSlant->\"Italic\"]\) symbols.";


(* ::Input::Initialization:: *)
SubKernels`Protected`stdargs=" -subkernel"


(* ::Input::Initialization:: *)
Begin["`Private`"];


(* ::Input::Initialization:: *)
$SpinDynamicaVersion:=First@ReadList["VersionInfo.txt",String];


(* ::Input::Initialization:: *)
MinimumMathematicaVersionNumber=8.0;


(* ::Input::Initialization:: *)
If[
$KernelID==0,
Print[
FrameBox@ToBoxes[$SpinDynamicaVersion<>" loaded"]//DisplayForm
];
];


(* ::Input::Initialization:: *)
If[
($KernelID==0)&&
($VersionNumber<MinimumMathematicaVersionNumber),
(StylePrint[
DisplayForm@ButtonBox[
"Warning: This version of SpinDynamica requires Mathematica version "<>ToString[MinimumMathematicaVersionNumber]<>" or higher. Problems may be encountered."
]
]
)
];


(* ::Input::Initialization:: *)
If[
($KernelID==0)&&
($VersionNumber<9),
Needs["PhysicalConstants`"]
];


(* ::Input::Initialization:: *)
SpinDynamicaSymbols[opts___Rule]:=(
Information["SpinDynamica`*"];
Information["SD`Propagation`*"];
Information["SD`Approximations`*"];
Information["Signals`Signal`*"];
Information["QM`Hilbert`*"];
Information["QM`Liouville`*"];
Information["QM`SpinOperators`*"];
Information["Graphics`Visualization`*"];Information["General`Matrices`*"];
Information["Rotations`Euler`*"];
Information["Rotations`Wigner`*"];
Information["Ensemble`OrientationalSampling`*"];
Information["Interactions`Interactions`*"];
Information["SD`Generators`*"];
Information["Events`Events`*"];
Information["General`PhysicalConstants`*"];
Information["General`ModifyBuiltIn`*"];
Information["General`Miscellaneous`*"];
Information["Rotations`Polar`*"];
Information["Rotations`Quaternion`*"];
Information["Signals`Lineshapes`*"];
)


(* ::Input::Initialization:: *)
End[];
EndPackage[];


(* ::Input::Initialization:: *)
DeclarePackage[
"Ensemble`OrientationalSampling`",
{"OrientationalSamplingScheme",
"DefineOrientationalSamplingScheme",
"Orientations",
"OrientationsAndWeights",
"OrientationWeights"
}
];


(* ::Input::Initialization:: *)
Needs/@ {
"General`UserLevel`",
"QM`Hilbert`",
"QM`SpinOperators`",
"QM`Liouville`",
"SD`Generators`",
"SD`Approximations`",
"SD`Propagation`",
"Events`Events`",
"Events`PulseSequence`",
"Interactions`Interactions`",
"Interactions`Hamiltonians`",
"Interactions`Relaxation`",
"Simulations`Polarization`",
"Simulations`Simulations`",
"Signals`Signal`",
"Signals`Lineshapes`",
"Graphics`Visualization`",
"Rotations`Polar`",
"Rotations`Quaternion`",
"Tensors`CG`",
"Tensors`IST`"
};


(* ::Input::Initialization:: *)
$Chronology="LeftToRight";


(* ::Input::Initialization:: *)
$RecursionLimit=1000;


(* ::Input::Initialization:: *)
If[$KernelID==0,Message[SetUserLevel::ini,2,MaximumUserLevel]];
SetUserLevel[2];


(* ::Input::Initialization:: *)
SetOptions[Plot, LabelStyle->Directive[FontFamily->"Helvetica",FontSize->14],Frame->True,Axes->None];


(* ::Input::Initialization:: *)
SetOptions[ListPlot, LabelStyle->Directive[FontFamily->"Helvetica",FontSize->14],Frame->True,Joined->True,PlotRange->All,Axes->None]; 


(* ::Input::Initialization:: *)
SetOptions[ParametricPlot3D, LabelStyle->Directive[FontFamily->"Helvetica",FontSize->14]]; 


(* ::Input::Initialization:: *)
SetOptions[Graphics, LabelStyle->Directive[FontFamily->"Helvetica",FontSize->14]]; 


(* ::Input::Initialization:: *)
SetOptions[Graphics3D, LabelStyle->Directive[FontFamily->"Helvetica",FontSize->14]];



