(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     38832,       1196]
NotebookOptionsPosition[     27816,        931]
NotebookOutlinePosition[     28621,        959]
CellTagsIndexPosition[     28578,        956]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["General`General3D`", "Title",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"5a69af4d-105b-42ac-9092-ec9a05971408"],

Cell[CellGroupData[{

Cell["BeginPackage", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9, 3.683109016913093*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"115105de-7746-4acb-8de0-8fe8e733aac2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<General`General3D`\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Global`\>\"", ",", "\[IndentingNewLine]", "\"\<SpinDynamica`\>\"", 
      ",", "\[IndentingNewLine]", "\"\<General`UserLevel`\>\"", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"\"\<General`ModifyBuiltIn`\>\"", ","}], "*)"}], 
      "\[IndentingNewLine]", "\"\<General`Miscellaneous`\>\""}], 
     "\[IndentingNewLine]", "}"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.409319796270381*^9, {3.4093201105632973`*^9, 3.409320117721262*^9}, {
   3.409322873612007*^9, 3.40932287413334*^9}, {3.409826221996408*^9, 
   3.409826244587482*^9}, {3.409826564655456*^9, 3.409826572825223*^9}, {
   3.409827278160428*^9, 3.409827285922904*^9}, {3.409828816256514*^9, 
   3.409828820439386*^9}, 3.4098294673169413`*^9, 3.448289089283012*^9, {
   3.51508347931888*^9, 3.515083479747661*^9}, {3.5645981155459423`*^9, 
   3.5645981158216543`*^9}, {3.564598932284286*^9, 3.564598933990444*^9}, 
   3.745397159006221*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"f9df6ddc-9519-4d93-912b-c01f81d87d82"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exports", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"04954688-8614-46bd-9a7e-e113dd59288e"],

Cell[CellGroupData[{

Cell["origin", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Origin", "::", "\"\<usage\>\""}], "=", "\"\<point {0,0,0}\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["unit vectors", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ex", "::", "\"\<usage\>\""}], "=", 
   "\"\<unit vector {1,0,0}\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ey", "::", "\"\<usage\>\""}], "=", 
   "\"\<unit vector {0,1,0}\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ez", "::", "\"\<usage\>\""}], "=", 
   "\"\<unit vector {0,0,1}\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["AxisSystem", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxisSystem", "::", "\"\<usage\>\""}], "=", 
   "\"\<AxisSystem[vz] generates a normalized right-handed axis system with \
three orthogonal axes, the last one parallel to vz. The first axis is in \
(ex,vz) plane.   \nAxisSystem[vx,vz] generates a normalized right-handed axis \
system with first axis in {vx,vz} plane and third axis parallel to vz.   \n\
AxisSystem[vx,vy,vz] generates a normalized right-handed axis system if the \
input vectors are already orthogonal. \nAxisSystem[] defaults to {ex,ey,ez}.\n\
AxisSystem[{vx,vy,vz}] has the same meaning as AxisSystem[vx,vy,vz]\>\""}], 
  ";"}]], "Input",
 PageWidth->PaperWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409814877736721*^9, 3.409814950707582*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["PolarToVector", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PolarToVector", "::", "\"\<usage\>\""}], "=", 
   "\"\<  PolarToVector[r,{th,ph}] generates a vector from the origin with \
radius r and polar angles {th,ph}. \>\""}], ";"}]], "Input",
 PageWidth->PaperWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["VectorToPolar", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VectorToPolar", "::", "\"\<usage\>\""}], "=", 
   "\"\<  VectorToPolar[vec] derives the radius and polar angles of the tip \
of a vector with respect to the origin, presented in the form {r,{th,ph}}. \>\
\""}], ";"}]], "Input",
 PageWidth->PaperWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SolidAngle", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SolidAngle", "::", "\"\<usage\>\""}], "=", 
   "\"\<SolidAngle[{v1,v2,v3}] determines the solid angle subtended at the \
centre of the unit sphere by the triangle with vertices {v1,v2,v3}.\\n \
SolidAngle[{v1,v2,v3,v4}] sums the solid angles of the triangles {v1,v2,v3} \
and {v1,v4,v3}\>\""}], ";"}]], "Input",
 PageWidth->PaperWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SubtendedAngle", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SubtendedAngle", "::", "\"\<usage\>\""}], "=", 
   "\"\<SubtendedAngle[v1,v2,v3,v4] determines the angle subtended by the \
v1-v2 and v3-v4 vectors. SubtendedAngle[v1,v2,v3] determines the angle \
subtended by the v1-v2 and v2-v3 vectors. \\n\n    SubtendedAngle[v1,v2] \
determines the angle subtended by the 0-v1 and 0-v2 vectors.\>\""}], 
  ";"}]], "Input",
 PageWidth->PaperWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409650317251943*^9, 3.409650320327465*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["BondAngle", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BondAngle", "::", "\"\<usage\>\""}], "=", 
   "\"\<BondAngle[v1,v2,v3] determines the angle subtended by the v1-v2 and \
v2-v3 vectors.\>\""}], ";"}]], "Input",
 PageWidth->PaperWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409650468718659*^9, 3.4096505004232388`*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["TorsionAngle", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TorsionAngle", "::", "\"\<usage\>\""}], "=", 
   "\"\<TorsionAngle[v1,v2,v3,v4] determines the torsion angle v1-v2-v3-v4. \
The convention is chosen that if the far bond has to be rotated anticlockwise \
so as to eclipse the near bond, then the torsion angle is positive\>\""}], 
  ";"}]], "Input",
 PageWidth->PaperWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Distance", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Distance", "::", "\"\<usage\>\""}], "=", 
   "\"\<Distance[v1,v2] determines the distance between two points\>\""}], 
  ";"}]], "Input",
 PageWidth->PaperWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["package", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"05241b46-4d62-4b4a-8ffd-ef7dc023ca01"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["unit vectors", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ex", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], ";", 
  RowBox[{"ey", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], ";", 
  RowBox[{"ez", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Origin", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SubtendedAngle", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SubtendedAngle", "[", 
   RowBox[{"v1_", ",", "v2_", ",", "v3_", ",", "v4_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"vec1", ",", "vec2"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"vec1", "=", 
      RowBox[{"Normalize", "[", 
       RowBox[{"v1", "-", "v2"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"vec2", "=", 
      RowBox[{"Normalize", "[", 
       RowBox[{"v4", "-", "v3"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ArcCos", "[", 
      RowBox[{"vec1", ".", "vec2"}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409320040689994*^9, 3.4093200417915773`*^9}, {
  3.409650249914032*^9, 3.409650252312055*^9}, {3.409650283465102*^9, 
  3.409650292343841*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SubtendedAngle", "[", 
   RowBox[{"v1_", ",", "v2_", ",", "v3_"}], "]"}], ":=", 
  RowBox[{"SubtendedAngle", "[", 
   RowBox[{"v1", ",", "v2", ",", "v2", ",", "v3"}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SubtendedAngle", "[", 
   RowBox[{"v1_", ",", "v2_"}], "]"}], ":=", 
  RowBox[{"SubtendedAngle", "[", 
   RowBox[{"v1", ",", "Origin", ",", "Origin", ",", "v2"}], "]"}]}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["BondAngle", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BondAngle", "[", 
    RowBox[{"v1_", ",", "v2_", ",", "v3_"}], "]"}], ":=", 
   RowBox[{"SubtendedAngle", "[", 
    RowBox[{"v1", ",", "v2", ",", "v3"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409650443730212*^9, 3.4096504577630863`*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["TorsionAngle", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"TorsionAngle", "[", 
   RowBox[{"v1_", ",", "v2_", ",", "v3_", ",", "v4_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"n123", ",", "n234"}], "}"}], ",", 
    RowBox[{
     RowBox[{"n123", "=", 
      RowBox[{"Normalize", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"v2", "-", "v1"}], ")"}], "\[Cross]", 
        RowBox[{"(", 
         RowBox[{"v2", "-", "v3"}], ")"}]}], "]"}]}], ";", 
     RowBox[{"n234", "=", 
      RowBox[{"Normalize", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"v3", "-", "v2"}], ")"}], "\[Cross]", 
        RowBox[{"(", 
         RowBox[{"v3", "-", "v4"}], ")"}]}], "]"}]}], ";", 
     RowBox[{"N", "[", 
      RowBox[{"ArcTan", "[", 
       RowBox[{
        RowBox[{"n123", ".", "n234"}], ",", 
        RowBox[{
         RowBox[{"n123", "\[Cross]", "n234"}], ".", 
         RowBox[{"Normalize", "[", 
          RowBox[{"v3", "-", "v2"}], "]"}]}]}], "]"}], "]"}]}]}], 
   "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409320042808227*^9, 3.409320044669883*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Distance", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Distance", "[", 
    RowBox[{"v1_", ",", "v2_"}], "]"}], ":=", 
   RowBox[{"Norm", "[", 
    RowBox[{"v1", "-", "v2"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.409649813326187*^9, {3.409650585621544*^9, 3.409650588370173*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["AxisSystem", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxisSystem", "[", 
    RowBox[{"axes_", "?", "MatrixQ"}], "]"}], ":=", 
   RowBox[{"AxisSystem", "@@", "axes"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4098149660708933`*^9, 3.4098149983475323`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxisSystem", "[", "]"}], ":=", 
   RowBox[{"AxisSystem", "[", "ez", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AxisSystem", "[", "vz_List", "]"}], ":=", 
  RowBox[{
   RowBox[{"AxisSystem", "[", "ez", "]"}], "/;", 
   RowBox[{"vz", "==", "Origin"}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AxisSystem", "[", 
   RowBox[{"vx_List", ",", "vz_List"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"AxisSystem", "[", "vz", "]"}], "/;", 
   RowBox[{"vx", "==", "Origin"}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxisSystem", "[", "vz_List", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "vzN", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vzN", "=", 
        RowBox[{"Simplify", "@", 
         RowBox[{"PowerExpand", "@", 
          RowBox[{"ComplexExpand", "@", 
           RowBox[{"Normalize", "[", "vz", "]"}]}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{"vzN", "==", "ex"}], "]"}], ",", 
         RowBox[{"AxisSystem", "[", 
          RowBox[{
           RowBox[{"-", "ez"}], ",", "vzN"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TrueQ", "[", 
          RowBox[{"vzN", "==", 
           RowBox[{"-", "ex"}]}], "]"}], ",", 
         RowBox[{"AxisSystem", "[", 
          RowBox[{"ez", ",", "vzN"}], "]"}], ",", "\[IndentingNewLine]", 
         "True", ",", 
         RowBox[{"AxisSystem", "[", 
          RowBox[{"ex", ",", "vzN"}], "]"}]}], "\[IndentingNewLine]", "]"}]}],
       "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.409320046018423*^9, {3.6739458634636383`*^9, 3.6739458692882633`*^9}, {
   3.673945971302079*^9, 3.6739460098530293`*^9}, {3.6739463004358997`*^9, 
   3.673946325317503*^9}, {3.673946768431917*^9, 3.673946778444886*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxisSystem", "[", 
    RowBox[{"vx_List", ",", "vz_List"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vxN", ",", "vyN", ",", "vzN"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vxN", ",", "vzN"}], "}"}], "=", 
        RowBox[{"Simplify", "@", 
         RowBox[{"PowerExpand", "@", 
          RowBox[{"ComplexExpand", "[", 
           RowBox[{"Normalize", "/@", 
            RowBox[{"{", 
             RowBox[{"vx", ",", "vz"}], "}"}]}], "]"}]}]}]}], ";", "\n", 
       "\t\t", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"vxN", "==", "vzN"}], "||", 
           RowBox[{"vxN", "==", 
            RowBox[{"-", "vzN"}]}]}], "]"}], ",", 
         RowBox[{"AxisSystem", "[", "vzN", "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"vyN", "=", 
             RowBox[{"Simplify", "@", 
              RowBox[{"PowerExpand", "@", 
               RowBox[{"ComplexExpand", "@", 
                RowBox[{"Normalize", "[", 
                 RowBox[{"vzN", "\[Cross]", "vxN"}], "]"}]}]}]}]}], ";", 
            RowBox[{"vxN", "=", 
             RowBox[{"Simplify", "@", 
              RowBox[{"PowerExpand", "@", 
               RowBox[{"ComplexExpand", "@", 
                RowBox[{"Normalize", "[", 
                 RowBox[{"vyN", "\[Cross]", "vzN"}], "]"}]}]}]}]}]}], ")"}], 
          ";", 
          RowBox[{"{", 
           RowBox[{"vxN", ",", "vyN", ",", "vzN"}], "}"}]}]}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409320047016789*^9, 3.409320048965996*^9}, {
  3.673945987169156*^9, 3.673946049700118*^9}, {3.673946093419495*^9, 
  3.67394610055999*^9}, {3.673946333498695*^9, 3.673946367897895*^9}, {
  3.673946787074984*^9, 3.673946801058214*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxisSystem", "[", 
    RowBox[{"vx_List", ",", "vy_List", ",", "vz_List"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vxN", ",", "vyN", ",", "vzN"}], "}"}], ",", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vxN", ",", "vyN", ",", "vzN"}], "}"}], "=", 
        RowBox[{"Simplify", "@", 
         RowBox[{"PowerExpand", "@", 
          RowBox[{"ComplexExpand", "[", 
           RowBox[{"Normalize", "/@", 
            RowBox[{"{", 
             RowBox[{"vx", ",", "vy", ",", "vz"}], "}"}]}], "]"}]}]}]}], ";", 
       "\n", "\t\t", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"Simplify", "@", 
            RowBox[{"Chop", "@", 
             RowBox[{"N", "[", 
              RowBox[{"vzN", "-", 
               RowBox[{"vxN", "\[Cross]", "vyN"}]}], "]"}]}]}], "==", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"vxN", ",", "vyN", ",", "vzN"}], "}"}], ",", 
         RowBox[{"Message", "[", 
          RowBox[{"AxisSystem", "::", "\"\<notRHOrthog\>\""}], "]"}]}], "\n", 
        "\t\t", "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.409320049977559*^9, {3.6416590166017647`*^9, 3.641659052358828*^9}, {
   3.673946062562537*^9, 3.673946107032051*^9}, {3.673946374505332*^9, 
   3.6739463789234657`*^9}, 3.673946803544359*^9, 3.6739488401593113`*^9},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxisSystem", "::", "\"\<notRHOrthog\>\""}], "=", 
   "\"\<input vectors are not proved to be a right-handed orthogonal \
set\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.6739461241750097`*^9, 3.673946154208599*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AxisSystem", "::", "\"\<failed\>\""}], "=", 
   "\"\<cannot construct orthonormal axes\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["PolarToVector", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PolarToVector", "[", 
    RowBox[{"r_", ",", 
     RowBox[{"{", 
      RowBox[{"th_", ",", "ph_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"N", "[", 
    RowBox[{"r", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Sin", "[", "th", "]"}], " ", 
        RowBox[{"Cos", "[", "ph", "]"}]}], ",", 
       RowBox[{
        RowBox[{"Sin", "[", "th", "]"}], " ", 
        RowBox[{"Sin", "[", "ph", "]"}]}], ",", 
       RowBox[{"Cos", "[", "th", "]"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["VectorToPolar", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VectorToPolar", "[", 
    RowBox[{"vec", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x_", "?", "NumericQ"}], ",", 
       RowBox[{"y_", "?", "NumericQ"}], ",", 
       RowBox[{"z_", "?", "NumericQ"}]}], "}"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", "v", ",", "th", ",", "ph"}], "}"}], ",", 
     RowBox[{
      RowBox[{"r", "=", 
       RowBox[{"Norm", "[", "vec", "]"}]}], ";", 
      RowBox[{"v", "=", 
       RowBox[{"Normalize", "[", "vec", "]"}]}], ";", 
      RowBox[{"th", "=", 
       RowBox[{"ArcCos", "[", 
        RowBox[{"v", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
        "]"}]}], ";", 
      RowBox[{"ph", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Chop", "[", 
           RowBox[{"N", "[", 
            RowBox[{
             RowBox[{"Abs", "[", 
              RowBox[{
              "v", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}], 
              "]"}], "-", "1"}], "]"}], "]"}], "==", "0"}], ",", "0", ",", 
         RowBox[{"ArcTan", "[", 
          RowBox[{
           RowBox[{
           "v", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
           RowBox[{
           "v", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
          "]"}]}], "]"}]}], ";", 
      RowBox[{"{", 
       RowBox[{"r", ",", 
        RowBox[{"{", 
         RowBox[{"th", ",", "ph"}], "}"}]}], "}"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.409320051339212*^9, 3.409649814891385*^9},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SolidAngle", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell["see Bronshtein p.227", "Text",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SolidAngle", "[", 
    RowBox[{"{", 
     RowBox[{"v1_", ",", "v2_", ",", "v3_"}], "}"}], "]"}], ":=", 
   RowBox[{"0", "/;", 
    RowBox[{
     RowBox[{"v1", "==", "v2"}], "||", 
     RowBox[{"v2", "==", "v3"}], "||", 
     RowBox[{"v3", "==", "v1"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SolidAngle", "[", 
    RowBox[{"{", 
     RowBox[{"v1_", ",", "v2_", ",", "v3_"}], "}"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "a", ",", "b", ",", "c", ",", "A", ",", "B", ",", "C", ",", "d", ",", 
       "nv1", ",", "nv2", ",", "nv3"}], "}"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"nv1", ",", "nv2", ",", "nv3"}], "}"}], "=", 
       RowBox[{"Normalize", "/@", 
        RowBox[{"{", 
         RowBox[{"v1", ",", "v2", ",", "v3"}], "}"}]}]}], ";", 
      RowBox[{"c", "=", 
       RowBox[{"ArcCos", "[", 
        RowBox[{"v1", ".", "v2"}], "]"}]}], ";", 
      RowBox[{"a", "=", 
       RowBox[{"ArcCos", "[", 
        RowBox[{"v2", ".", "v3"}], "]"}]}], ";", 
      RowBox[{"b", "=", 
       RowBox[{"ArcCos", "[", 
        RowBox[{"v3", ".", "v1"}], "]"}]}], ";", 
      RowBox[{"A", "=", 
       RowBox[{"ArcCos", "[", 
        FractionBox[
         RowBox[{
          RowBox[{"Cos", "[", "a", "]"}], "-", 
          RowBox[{
           RowBox[{"Cos", "[", "b", "]"}], " ", 
           RowBox[{"Cos", "[", "c", "]"}]}]}], 
         RowBox[{
          RowBox[{"Sin", "[", "b", "]"}], " ", 
          RowBox[{"Sin", "[", "c", "]"}]}]], "]"}]}], ";", 
      RowBox[{"B", "=", 
       RowBox[{"ArcCos", "[", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", "b", "]"}], " ", 
           RowBox[{"Sin", "[", "c", "]"}]}], "-", 
          RowBox[{
           RowBox[{"Cos", "[", "A", "]"}], " ", 
           RowBox[{"Cos", "[", "c", "]"}], " ", 
           RowBox[{"Sin", "[", "b", "]"}]}]}], 
         RowBox[{"Sin", "[", "a", "]"}]], "]"}]}], ";", 
      RowBox[{"C", "=", 
       RowBox[{"ArcCos", "[", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"Cos", "[", "c", "]"}], " ", 
           RowBox[{"Sin", "[", "b", "]"}]}], "-", 
          RowBox[{
           RowBox[{"Cos", "[", "A", "]"}], " ", 
           RowBox[{"Cos", "[", "b", "]"}], " ", 
           RowBox[{"Sin", "[", "c", "]"}]}]}], 
         RowBox[{"Sin", "[", "a", "]"}]], "]"}]}], ";", 
      RowBox[{"A", "+", "B", "+", "C", "-", "\[Pi]"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4093200523423967`*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SolidAngle", "[", 
    RowBox[{"{", 
     RowBox[{"v1_", ",", "v2_", ",", "v3_", ",", "v4_"}], "}"}], "]"}], ":=", 
   
   RowBox[{
    RowBox[{"SolidAngle", "[", 
     RowBox[{"{", 
      RowBox[{"v1", ",", "v2", ",", "v3"}], "}"}], "]"}], "+", 
    RowBox[{"SolidAngle", "[", 
     RowBox[{"{", 
      RowBox[{"v1", ",", "v4", ",", "v3"}], "}"}], "]"}]}]}], ";"}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"d8a2a385-6c9a-4be3-9799-f8f4e152ce13"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]}], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"da92703f-72e9-4db8-9207-adabdd82b33d"]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{682, 838},
WindowMargins->{{Automatic, 84}, {Automatic, 41}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
ShowCellLabel->True,
ShowCellTags->False,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 209, 5, 114, "Title",ExpressionUUID->"5a69af4d-105b-42ac-9092-ec9a05971408",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[801, 31, 337, 8, 44, "Section",ExpressionUUID->"115105de-7746-4acb-8de0-8fe8e733aac2",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1141, 41, 1245, 25, 173, "Input",ExpressionUUID->"f9df6ddc-9519-4d93-912b-c01f81d87d82",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[2423, 71, 164, 4, 36, "Section",ExpressionUUID->"04954688-8614-46bd-9a7e-e113dd59288e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[2612, 79, 108, 3, 34, "Subsection",ExpressionUUID->"bbab5a54-cbf8-4f38-a4bb-bb9261ce680e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[2723, 84, 212, 7, 27, "Input",ExpressionUUID->"bd547e36-0769-497e-a481-01e2b7e632b1",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2972, 96, 114, 3, 26, "Subsection",ExpressionUUID->"d461cf90-6381-4484-8c57-442f0ef32d86",
 InitializationCell->True,
 InitializationGroup->True],
Cell[3089, 101, 215, 7, 27, "Input",ExpressionUUID->"2473c437-f31d-48fa-afd9-4b95c20b83d6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[3307, 110, 215, 7, 27, "Input",ExpressionUUID->"8bccaf88-3027-49a1-8504-3ac3749d4bb8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[3525, 119, 215, 7, 27, "Input",ExpressionUUID->"53eb96c0-cbc3-4e53-9a49-48ddd6538bad",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[3777, 131, 112, 3, 26, "Subsection",ExpressionUUID->"620be9f2-7512-4a66-b6f4-71705e48eb0f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[3892, 136, 824, 16, 223, "Input",ExpressionUUID->"6e42cfb7-e304-4c14-9505-e91e744c4be3",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[4753, 157, 115, 3, 26, "Subsection",ExpressionUUID->"b4cb24ab-6708-45f9-b2db-083fffb4dca6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[4871, 162, 335, 9, 73, "Input",ExpressionUUID->"56f36c53-cb77-4e7b-a393-728820aa3ba5",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5243, 176, 115, 3, 26, "Subsection",ExpressionUUID->"c2be48a5-c155-4ec5-b391-447c0d3ca4cd",
 InitializationCell->True,
 InitializationGroup->True],
Cell[5361, 181, 378, 10, 88, "Input",ExpressionUUID->"8d5c1715-c164-4181-af83-5400cd514336",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5776, 196, 112, 3, 26, "Subsection",ExpressionUUID->"1a0ec4a6-a4d9-4b18-86b4-ff4300dbd351",
 InitializationCell->True,
 InitializationGroup->True],
Cell[5891, 201, 462, 11, 118, "Input",ExpressionUUID->"d2b3786b-bccd-4374-a639-bdfbc534ebdf",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6390, 217, 116, 3, 26, "Subsection",ExpressionUUID->"db5e269d-a418-4483-aad2-28d5d8fa5a66",
 InitializationCell->True,
 InitializationGroup->True],
Cell[6509, 222, 577, 13, 133, "Input",ExpressionUUID->"fd10ab68-f646-479b-a86b-a29615eccd2f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[7123, 240, 111, 3, 26, "Subsection",ExpressionUUID->"b9669d0e-2b53-4d67-9f41-23d8e96e910a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[7237, 245, 379, 10, 58, "Input",ExpressionUUID->"f249d736-b534-4565-97d3-338759568316",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[7653, 260, 114, 3, 26, "Subsection",ExpressionUUID->"5a05d268-a59a-4d69-af9c-70138e6f423a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[7770, 265, 449, 11, 85, "Input",ExpressionUUID->"3021f1de-9af2-4c8f-b506-1e1ec59bc442",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8256, 281, 110, 3, 26, "Subsection",ExpressionUUID->"2e0db93c-a3a4-439a-9299-5fd3cff6fc3d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[8369, 286, 287, 9, 58, "Input",ExpressionUUID->"857ec599-e58e-4ed7-a75d-9761f5e4895e",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[8705, 301, 164, 4, 36, "Section",ExpressionUUID->"05241b46-4d62-4b4a-8ffd-ef7dc023ca01",
 InitializationCell->True,
 InitializationGroup->True],
Cell[8872, 307, 172, 5, 48, "Input",ExpressionUUID->"bc9c7ddc-f78f-48a6-b2e0-2ed0c5afca77",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[9069, 316, 114, 3, 44, "Subsection",ExpressionUUID->"9f09fce0-a931-4a6b-97de-a93a0b13e24e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[9186, 321, 393, 13, 27, "Input",ExpressionUUID->"e83374eb-46d1-45fe-809d-e483b5032f0e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[9582, 336, 211, 7, 27, "Input",ExpressionUUID->"59218aa5-a8be-4216-b076-2c52fed63d78",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9830, 348, 116, 3, 36, "Subsection",ExpressionUUID->"d1c16f10-1383-4544-b037-6fb185d29492",
 InitializationCell->True,
 InitializationGroup->True],
Cell[9949, 353, 901, 23, 103, "Input",ExpressionUUID->"7aa3b909-c473-4156-bdd3-f5abd1450c56",
 InitializationCell->True,
 InitializationGroup->True],
Cell[10853, 378, 300, 8, 43, "Input",ExpressionUUID->"34f22428-c58f-4662-8cb0-0fe2539d8b78",
 InitializationCell->True,
 InitializationGroup->True],
Cell[11156, 388, 298, 9, 43, "Input",ExpressionUUID->"a4c1165f-f75a-45b6-a9c5-eb080effd30f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[11491, 402, 111, 3, 36, "Subsection",ExpressionUUID->"cc61f7b7-b51a-4c44-b784-ef65be0318e4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[11605, 407, 374, 10, 27, "Input",ExpressionUUID->"66589328-6cf6-477e-97cf-72540876434b",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[12016, 422, 114, 3, 36, "Subsection",ExpressionUUID->"ed6f460d-4cfe-452c-892e-54132b065a02",
 InitializationCell->True,
 InitializationGroup->True],
Cell[12133, 427, 1171, 35, 70, "Input",ExpressionUUID->"f3a280fe-fc8f-4085-be5e-4dafa79ca8cc",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[13341, 467, 110, 3, 36, "Subsection",ExpressionUUID->"42dfcb89-8b5a-4f7d-a89b-fe290c6c23ab",
 InitializationCell->True,
 InitializationGroup->True],
Cell[13454, 472, 363, 11, 27, "Input",ExpressionUUID->"835e5ff0-d974-400b-8028-a3d754e7af3e",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[13854, 488, 112, 3, 36, "Subsection",ExpressionUUID->"e75b327b-e32f-48be-9f44-a8f125fec32e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[13969, 493, 303, 8, 48, "Input",ExpressionUUID->"81a57995-0ae6-48ec-b4f7-13d7148499fe",
 InitializationCell->True,
 InitializationGroup->True],
Cell[14275, 503, 220, 7, 48, "Input",ExpressionUUID->"c60ffb93-ae8d-4f6f-8680-1002a9e38a70",
 InitializationCell->True,
 InitializationGroup->True],
Cell[14498, 512, 267, 8, 48, "Input",ExpressionUUID->"9575f42d-2f1f-4464-957e-5c123df21eaa",
 InitializationCell->True,
 InitializationGroup->True],
Cell[14768, 522, 297, 9, 48, "Input",ExpressionUUID->"f93b2054-eb62-489f-b70a-b7e2d374100b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[15068, 533, 1536, 38, 217, "Input",ExpressionUUID->"5a56d8dd-37e9-48a4-b1fd-a9c691d57365",
 InitializationCell->True,
 InitializationGroup->True],
Cell[16607, 573, 2096, 54, 217, "Input",ExpressionUUID->"6f6dd0d5-ad78-4341-a4fb-13a88914d4d6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[18706, 629, 1674, 44, 196, "Input",ExpressionUUID->"07824d9d-ec05-4a59-aa3f-eace6d2bf52e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[20405, 677, 113, 3, 35, "Subsubsection",ExpressionUUID->"b01b6778-bf3d-4c2d-8dcb-b93da4ad550a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[20521, 682, 344, 9, 91, "Input",ExpressionUUID->"1943b580-a3da-46b8-a2f2-cde81f379edf",
 InitializationCell->True,
 InitializationGroup->True],
Cell[20868, 693, 238, 7, 48, "Input",ExpressionUUID->"a7137a23-7576-4557-8fd3-36d4e74562c8",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[21155, 706, 115, 3, 44, "Subsection",ExpressionUUID->"661c9180-35d9-431b-aff2-79553f7b94f3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[21273, 711, 629, 20, 43, "Input",ExpressionUUID->"ae361712-cee6-4dc2-ba2d-949a0f8c670b",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[21939, 736, 115, 3, 36, "Subsection",ExpressionUUID->"02718806-33d9-4ce3-93f9-e467ff5375b4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[22057, 741, 1692, 49, 103, "Input",ExpressionUUID->"daa4c857-93b2-4529-950e-6ea4d2d1527d",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[23786, 795, 112, 3, 36, "Subsection",ExpressionUUID->"95fd0979-e908-4956-9b79-5298b9c4bc25",
 InitializationCell->True,
 InitializationGroup->True],
Cell[23901, 800, 116, 3, 28, "Text",ExpressionUUID->"1fdff7f0-dfa2-445f-9a60-3c4207ef7748",
 InitializationCell->True,
 InitializationGroup->True],
Cell[24020, 805, 402, 13, 24, "Input",ExpressionUUID->"4e42186b-ea23-431b-88b1-81afa1a05e9d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[24425, 820, 2374, 68, 193, "Input",ExpressionUUID->"ff5610ee-0ecd-4e59-bd75-80a6e8bc4d73",
 InitializationCell->True,
 InitializationGroup->True],
Cell[26802, 890, 505, 17, 40, "Input",ExpressionUUID->"ed81cd39-30b5-49ae-8f7b-9b1b3d724524",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[27356, 913, 160, 4, 36, "Section",ExpressionUUID->"d8a2a385-6c9a-4be3-9799-f8f4e152ce13",
 InitializationCell->True,
 InitializationGroup->True],
Cell[27519, 919, 269, 8, 68, "Input",ExpressionUUID->"da92703f-72e9-4db8-9207-adabdd82b33d",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]]
}, Open  ]]
}
]
*)

