(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    140624,       3735]
NotebookOptionsPosition[    118476,       3271]
NotebookOutlinePosition[    119281,       3299]
CellTagsIndexPosition[    119238,       3296]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["General`Matrices`", "Subtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"c84b313e-1e5b-4efc-8aac-63e358cd01f8"],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsubtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.7453971090495253`*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"17966ccc-b9ed-47d2-ab63-9b6f8f0d4674"],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", 
  RowBox[{"\"\<General`Matrices`\>\"", ",", "\n", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Global`\>\"", ",", "\n", "\"\<SpinDynamica`\>\"", ",", "\n", 
     "\"\<General`UserLevel`\>\"", ",", "\n", 
     RowBox[{"(*", 
      RowBox[{"\"\<General`ModifyBuiltIn`\>\"", ","}], "*)"}], "\n", 
     "\"\<General`General3D`\>\"", ",", "\n", 
     "\"\<General`Miscellaneous`\>\""}], "}"}]}], "\n", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.745397127514616*^9, 
  3.745397127516123*^9}},ExpressionUUID->"7a127078-49bb-44c9-ad9c-\
7fb014a4ba1c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exports", "Subsubtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->
  True,ExpressionUUID->"7a5a3558-9690-4e14-a517-fe4f63951c5e"],

Cell[CellGroupData[{

Cell["DiagonalElements", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->
  True,ExpressionUUID->"5988bde4-31d7-494a-817b-3cec77250b6d"],

Cell["\<\
DiagonalElements::usage=
\t\"DiagonalElements[mat] has been superseded by Diagonal\";\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.409670620215569*^9, 3.409670625865086*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["DirectProduct", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->
  True,ExpressionUUID->"32ac9548-22c8-47a5-814b-fee26f8dd5a3"],

Cell["\<\
DirectProduct::usage=
\t\"DirectProduct[m1,m2] generates direct product of
\tmatrices m1 \\!\\(\[CircleTimes]\\) m2.\\n
\tDirectProduct[v1,m2] generates direct product of row vector v1 and matrix \
m2.\\n
\t\tDirectProduct[m1,v2] generates direct product of matrix m1 and row vector \
v2.\\n
\t\tDirectProduct[v1,v2] generates direct product of row vector v1 and row \
vector v2.\\n
\t\tDirectProduct[a,b,c..] takes many pairwise direct products in sequence, \
i.e. a \\!\\(\[CircleTimes]\\) b \\!\\(\[CircleTimes]\\) c\";\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Adjoint", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->
  True,ExpressionUUID->"02d38f78-42d7-4758-a502-a23473ddc1a4"],

Cell["\<\
Adjoint::usage=
\t\"Adjoint[m] generates the adjoint of m.\";\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["DyadicProduct", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->
  True,ExpressionUUID->"4ec6652f-7664-4cfc-b395-697f588a2916"],

Cell["\<\
DyadicProduct::usage=
\t\"DyadicProduct[v1,v2] generates dyadic product of two vectors\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["NDiagonalize", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.586070650573553*^9, 
  3.5860706527635736`*^9}},ExpressionUUID->"23ff2fdf-217e-480d-a749-\
37cdd3f25731"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"NDiagonalize\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"mat\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"opts\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) returns the form \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"X\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"evals\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Xinv\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\) where \!\(\*
StyleBox[\"X\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)is the matrix whose columns are the normalized \
eigenvectors of \!\(\*
StyleBox[\"mat\",
FontSlant->\"Italic\"]\), and \!\(\*
StyleBox[\"Xinv\",
FontSlant->\"Italic\"]\) is the inverse of \!\(\*
StyleBox[\"X\",
FontSlant->\"Italic\"]\). The option \!\(\*
StyleBox[\"Assumptions\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"OrthogonalEigenvectors\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\) may be used to allow the use of \!\(\*
StyleBox[\"ConjugateTranspose\",
FontSlant->\"Italic\"]\) to invert \!\(\*
StyleBox[\"X\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5860708268975153`*^9, 3.586070845276064*^9}, {
  3.586080044487323*^9, 3.586080055604177*^9}, {3.586089145784408*^9, 
  3.586089167847836*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrthogonalEigenvectors", "::", "usage"}], "=", 
   "\"\<An assumption of the form \!\(\*
StyleBox[\"Assumptions\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"OrthogonalEigenvectors\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\) may be used in \!\(\*
StyleBox[\"NDiagonalize\",
FontSlant->\"Italic\"]\) to allow the use of \!\(\*
StyleBox[\"ConjugateTranspose\",
FontSlant->\"Italic\"]\) to invert the eigenvector matrix.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586070819537876*^9, 3.586070905038425*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["HermitianQ", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->
  True,ExpressionUUID->"72fe8efd-f81d-4dff-b3b8-6b5ce678efcc"],

Cell["\<\
HermitianQ::usage=
\t\"HermitianQ[mat] tests whether a matrix is Hermitian.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["AntiHermitianQ", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.562904148178501*^9, 
  3.5629041489049053`*^9}},ExpressionUUID->"615595ac-719f-4c4b-97e5-\
afb0b3d37566"],

Cell["\<\
AntiHermitianQ::usage=
\t\"AntiHermitianQ[mat] tests whether a matrix is AntiHermitian.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.5629041524294558`*^9, 3.562904156545055*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["NormalQ", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{
  3.505026309983615*^9},ExpressionUUID->"605f52cf-d6cc-4f33-b080-\
c4ce707fe892"],

Cell[TextData[{
 "NormalQ::usage=\n\t\"",
 StyleBox["NormalQ[mat]",
  FontSlant->"Italic"],
 " tests whether a matrix is Hermitian.\";\n\t"
}], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.5050262804077797`*^9, 3.505026287184105*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["UnitaryQ", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{
  3.505026309983615*^9, {3.5318311181449003`*^9, 
   3.531831119725911*^9}},ExpressionUUID->"68b70933-62b6-4fd0-8cba-\
262fbb45cfee"],

Cell[TextData[{
 "UnitaryQ::usage=\n\t\"",
 StyleBox["UnitaryQ[mat]",
  FontSlant->"Italic"],
 " tests whether a matrix is Unitary.\";\n\t"
}], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.5050262804077797`*^9, 3.505026287184105*^9}, {
  3.531831123019384*^9, 3.531831127854189*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["OrthogonalQ", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->
  True,ExpressionUUID->"f5f1276d-f853-420d-b22e-cfa6f4d6d5a6"],

Cell["\<\
OrthogonalQ::usage=
\t\"OrthogonalQ[mat] tests whether a matrix has orthogonal rows and columns.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["OrthonormalQ", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->
  True,ExpressionUUID->"a1597a92-dfa7-4c79-932c-6bfb5a0f94d8"],

Cell["\<\
OrthonormalQ::usage=
\t\"OrthonormalQ[mat] tests whether a matrix has orthonormal rows and \
columns.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["EigensystemQ", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->
  True,ExpressionUUID->"ab58de80-b539-478d-9c74-e1f0bc5d98fb"],

Cell["\<\
EigensystemQ::usage=
\t\"EigensystemQ[{evals,evecs},mat] tests whether a set of eigenvalues and \
evectors really are an appropriate set for the given matrix.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["CommuteQ", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->
  True,ExpressionUUID->"36a545e5-fcd7-444c-b629-2259634ba1ff"],

Cell["\<\
CommuteQ::usage=
\t\"CommuteQ[mat1,mat2] tests whether two matrices commute.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["DiagonalQ", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->
  True,ExpressionUUID->"75059f67-e782-43c2-be20-8b24766a4b44"],

Cell["\<\
DiagonalQ::usage=
\t\"DiagonalQ[mat1] tests whether a matrix is diagonal.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["NumericMatrixQ", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{
  3.5645664298871107`*^9},ExpressionUUID->"61635e43-8387-4399-bf03-\
4b997352c6b3"],

Cell["\<\
NumericMatrixQ::usage=
\t\"NumericMatrixQ[mat] returns True if mat is a matrix with numerical \
elements, and False otherwise.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.564566431260633*^9, 3.564566455114056*^9}, {
   3.564568030435405*^9, 3.5645681000647793`*^9}, 3.564568277952297*^9},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["BlockDiagonalMatrix", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->
  True,ExpressionUUID->"c8748328-2e1f-4847-9577-19315f3cd6cb"],

Cell["\<\
BlockDiagonalMatrix::usage=
\t\"BlockDiagonalMatrix[{mat1,mat2..}] or BlockDiagonalMatrix[mat1,mat2..] \
constructs a block-diagonal square matrix out of the given square blocks.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.409664233707582*^9, 3.409664245245743*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SetOffDiagonalElementsToZero", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4304525161812763`*^9, 3.430452516650445*^9}, {
  3.4304527423882313`*^9, 
  3.4304527541304283`*^9}},ExpressionUUID->"a0d10cd8-a4bc-4191-9496-\
649b2529fbf0"],

Cell["\<\
SetOffDiagonalElementsToZero::usage=
\t\"SetOffDiagonalElementsToZero[mat,func] sets off-diagonal elements of the \
square matrix mat to zero, in the case that func[r,c] yields True, where r \
and c are the row and column indices. The diagonal elements are left \
untouched.\\n
\tSetOffDiagonalElementsToZero[mat] sets all off-diagonal elements to \
zero.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.409664233707582*^9, 3.409664245245743*^9}, {
  3.4304525234553757`*^9, 3.430452632283009*^9}, {3.4304527593678017`*^9, 
  3.4304527604315567`*^9}, {3.43045308948318*^9, 3.430453091552456*^9}, {
  3.430453792537098*^9, 3.430453812301825*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["MultiplyMatricesAndMatrixInterpolationFunctions", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4304525161812763`*^9, 3.430452516650445*^9}, {
  3.4304527423882313`*^9, 3.4304527541304283`*^9}, {3.6215335561502037`*^9, 
  3.621533572063485*^9}},ExpressionUUID->"50fcae96-e27d-4a18-b4f9-\
18033bdbb3ed"],

Cell["\<\
MultiplyMatricesAndMatrixInterpolationFunctions::usage=
\t\"MultiplyMatricesAndMatrixInterpolationFunctions[mat1,mat2..] multiplies \
compatible matrices together. Any argument may also be an \
InterpolationFunction which evaluates to a matrix.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.409664233707582*^9, 3.409664245245743*^9}, {
  3.4304525234553757`*^9, 3.430452632283009*^9}, {3.4304527593678017`*^9, 
  3.4304527604315567`*^9}, {3.43045308948318*^9, 3.430453091552456*^9}, {
  3.430453792537098*^9, 3.430453812301825*^9}, {3.62153357667563*^9, 
  3.621533645348847*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SumMatricesAndMatrixInterpolationFunctions", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4304525161812763`*^9, 3.430452516650445*^9}, {
  3.4304527423882313`*^9, 3.4304527541304283`*^9}, {3.6215335561502037`*^9, 
  3.621533572063485*^9}, {3.6215336543748093`*^9, 
  3.6215336548755407`*^9}},ExpressionUUID->"ee6334cc-2f67-497d-b64b-\
0c924e12d46a"],

Cell["\<\
SumMatricesAndMatrixInterpolationFunctions::usage=
\t\"SumMatricesAndMatrixInterpolationFunctions[mat1,mat2..] adds compatible \
matrices together. Any argument may also be an InterpolationFunction which \
evaluates to a matrix.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.409664233707582*^9, 3.409664245245743*^9}, {
  3.4304525234553757`*^9, 3.430452632283009*^9}, {3.4304527593678017`*^9, 
  3.4304527604315567`*^9}, {3.43045308948318*^9, 3.430453091552456*^9}, {
  3.430453792537098*^9, 3.430453812301825*^9}, {3.62153357667563*^9, 
  3.62153366513536*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["MultiplyMatricesAndVectorInterpolationFunctions", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4304525161812763`*^9, 3.430452516650445*^9}, {
   3.4304527423882313`*^9, 3.4304527541304283`*^9}, {3.6215335561502037`*^9, 
   3.621533572063485*^9}, {3.6233288112415524`*^9, 3.623328812599122*^9}, 
   3.6233288895042257`*^9},ExpressionUUID->"55946f6b-1ee3-483a-b98b-\
4067ae2af24a"],

Cell["\<\
MultiplyMatricesAndVectorInterpolationFunctions::usage=
\t\"MultiplyMatricesAndVectorInterpolationFunctions[mat1,mat2,..vec] \
multiplies compatible matrices and a vector together. Intelligent ordering of \
products is used to achieve numerical efficiency. Any argument may also be an \
InterpolationFunction which evaluates to a matrix or a vector.\";
\t\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.409664233707582*^9, 3.409664245245743*^9}, {
  3.4304525234553757`*^9, 3.430452632283009*^9}, {3.4304527593678017`*^9, 
  3.4304527604315567`*^9}, {3.43045308948318*^9, 3.430453091552456*^9}, {
  3.430453792537098*^9, 3.430453812301825*^9}, {3.62153357667563*^9, 
  3.621533645348847*^9}, {3.623328816090743*^9, 3.623328903067882*^9}, {
  3.6233298051951523`*^9, 3.62332980637129*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"00e26637-9439-4e12-916e-1d68c906be37"]
}, Open  ]],

Cell[CellGroupData[{

Cell["OptimalBipartiteGraphMatching", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4304525161812763`*^9, 3.430452516650445*^9}, {
   3.4304527423882313`*^9, 3.4304527541304283`*^9}, {3.6215335561502037`*^9, 
   3.621533572063485*^9}, {3.6233288112415524`*^9, 3.623328812599122*^9}, 
   3.6233288895042257`*^9, {3.7195743495498996`*^9, 3.7195743523012877`*^9}, 
   3.726068021125506*^9},ExpressionUUID->"b45eb750-ea32-4883-90a2-\
aeb45d000587"],

Cell["\<\
OptimalBipartiteGraphMatching::usage=
\t\"OptimalBipartiteGraphMatching is SpinDynamica's implementation of the \
Hungarian Algorithm for optimal assignment problems on a bipartite graph. 
Consider the following practical problem: Workers W1, W2, W3 and W4, etc. \
together have to fulfill jobs A, B, C and D, etc. 
Eacher worker ranks his preference with regard to which job he would like to \
perform. 
What is the best assignment of jobs as to maximize the satisfaction of each \
worker? For such cases the Hungarian Algorithm provides an optimal solution. 

In general given a complete weighted Bipartite Graph K(n,n), the Hungarian \
Algorithm provides an optimal solution. 
OptimalBipartiteGraphMatching assumes the Bipartite Graph K(n,n) to be \
arranged into a M(n,n) matrix, 
where columns represent the vertices of the set U and rows the vertices of \
the set V. The matrix-element M_{i,j} is the edge-weight connecting vertices \
i and j.
OptimalBipartiteGraphMatching returns a permutation sequence. Application of \
the permutation sequence to the columns of M leads to a minimization of the \
Trace, 
which is equivalent to an optimal assignment.\";\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQBGIQ3bzETDY7/aWjwt3lciC6YFLeUsH+l46ZfJybQTTH
0deHQHTAed7DINqsTP8NiN6xthBMv9AXdBEC0r0rOt1A9OF5oh/bfr9yPKi5
+ieIjnvO1Pb53ytHcZ1HE0D0BrtljF+A9JyHp8F0zJsrWW3bXjty1a7MB9Fa
RnxzQLTswmww/SNpAdPLQ68dz8q/ZAfRIetU1EF0VROXNpiee9YeRJttNnQG
0VsObHMH0YcCC/1A9NrbKUEg2mm7aAZYnNO2BkTH3TKrBdHL9rU1gehJ35va
QPQUvTU9INq1r3EiiO5qbZ4Ooi06lm0F0SLLFxwC0Sp7D58C0f9++J8H0bOV
rC+A6AJLg6sg+rTErlsgWrb1wn0QzSDP+QhEs00++wxEc3y88gVE86z7+QPs
jgeT+F4BaQDn6+f6
  "],
 AspectRatioFixed->
  True,ExpressionUUID->"02f21540-580e-4187-8d99-15cb6e66ee01"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["main", "Subsubtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->
  True,ExpressionUUID->"3888d19d-4be8-417d-bab5-396d3c79f5da"],

Cell["Begin[\"`Private`\"];", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["DirectProduct", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell["\<\
DirectProduct[matA_?MatrixQ,matB_?MatrixQ]:=
\tFlatten[#,1]& @
\t\tMap[
\t\t\tFunction[arow,
\t\t\t\tMap[
\t\t\t\t\tFunction[brow,
\t\t\t\t\t\tFlatten[#,2]&@{ 
\t\t\t\t\t\t\tMap[
\t\t\t\t\t\t\t\tFunction[acol,\t\t
\t\t\t\t\t\t\t\t\tacol*brow
\t\t\t\t\t\t\t\t],
\t\t\t\t\t\t\t\tarow
\t\t\t\t\t\t\t] 
\t\t\t\t\t\t}
\t\t\t\t\t],
\t\t\t\t\tmatB
\t\t\t\t]
\t\t\t],
\t\t\tmatA
\t\t]\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell["\<\
DirectProduct[matA_?MatrixQ,vecB_List]:=
\tDirectProduct[matA,{vecB}]\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell["\<\
DirectProduct[vecA_List,matB_?MatrixQ]:=
\tDirectProduct[{vecA},matB]\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell["\<\
DirectProduct[vecA_List,vecB_List]:=
\tFlatten[#,1]& @DirectProduct[{vecA},{vecB}]\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DirectProduct", "[", "a_", "]"}], ":=", "a"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DirectProduct", "[", 
   RowBox[{"a_", ",", " ", "b_", ",", " ", "c__"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Fold", "[", 
   RowBox[{"DirectProduct", ",", "a", ",", 
    RowBox[{"{", 
     RowBox[{"b", ",", "c"}], "}"}]}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Adjoint", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", 
    RowBox[{"a_", "+", "b__"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Adjoint", "[", "a", "]"}], "+", 
    RowBox[{"Adjoint", "[", 
     RowBox[{"Plus", "[", "b", "]"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.430900298947371*^9, 3.430900319010696*^9}, {
  3.430900629733593*^9, 3.430900631601954*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", 
    RowBox[{"Times", "[", 
     RowBox[{"a_", ",", "b__"}], "]"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Adjoint", "[", "a", "]"}], "*", 
    RowBox[{"Adjoint", "[", 
     RowBox[{"Times", "[", "b", "]"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.430900322502603*^9, 3.430900344384946*^9}, {
  3.43090116218864*^9, 3.4309011655286083`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Adjoint", "[", "sa_SparseArray", "]"}], "/;", 
    RowBox[{"MatrixQ", "[", "sa", "]"}]}], ":=", "\n", "\t", 
   RowBox[{"Transpose", "@", 
    RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"ArrayRules", "[", "sa", "]"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a_", "\[Rule]", "b_"}], ")"}], "\[RuleDelayed]", 
          RowBox[{"(", 
           RowBox[{"a", "\[Rule]", 
            RowBox[{"ComplexExpand", "@", 
             RowBox[{"Conjugate", "[", "b", "]"}]}]}], ")"}]}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"a_", ":>", "b_"}], ")"}], "\[RuleDelayed]", 
          RowBox[{"(", 
           RowBox[{"a", ":>", 
            RowBox[{"ComplexExpand", "@", 
             RowBox[{"Conjugate", "[", "b", "]"}]}]}], ")"}]}]}], "}"}]}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"Dimensions", "[", "sa", "]"}]}], "\[IndentingNewLine]", 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.659524963822628*^9, 3.6595249638234453`*^9}, {
  3.659525231678803*^9, 3.659525238309455*^9}, {3.6595252749660273`*^9, 
  3.659525281836863*^9}, {3.6595253460436983`*^9, 3.659525401227255*^9}, {
  3.6595254974121227`*^9, 3.6595255010736856`*^9}, {3.659535436602166*^9, 
  3.659535438440632*^9}, {3.6595355839837303`*^9, 3.659535602301647*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Adjoint", "[", "sa_SparseArray", "]"}], "/;", 
    RowBox[{"VectorQ", "[", "sa", "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"ArrayRules", "[", "sa", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a_", "\[Rule]", "b_"}], ")"}], "\[RuleDelayed]", 
         RowBox[{"(", 
          RowBox[{"a", "\[Rule]", 
           RowBox[{"ComplexExpand", "@", 
            RowBox[{"Conjugate", "[", "b", "]"}]}]}], ")"}]}], ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a_", ":>", "b_"}], ")"}], "\[RuleDelayed]", 
         RowBox[{"(", 
          RowBox[{"a", ":>", 
           RowBox[{"ComplexExpand", "@", 
            RowBox[{"Conjugate", "[", "b", "]"}]}]}], ")"}]}]}], "}"}]}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"Dimensions", "[", "sa", "]"}]}], "\[IndentingNewLine]", "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.659535715399235*^9, 3.65953576470112*^9}, {
  3.659535885015482*^9, 3.659535943622115*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", 
    RowBox[{"m_", "?", "MatrixQ"}], "]"}], ":=", "\n", "\t", 
   RowBox[{"ComplexExpand", "@", 
    RowBox[{"Conjugate", "[", 
     RowBox[{"Transpose", "[", "m", "]"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.659524973453516*^9, 3.659524973454392*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", 
    RowBox[{"m_", "?", "NumericQ"}], "]"}], ":=", "\n", "\t", 
   RowBox[{"ComplexExpand", "@", 
    RowBox[{"Conjugate", "[", "m", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.659524982350663*^9, 3.659524982351582*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", "v_List", "]"}], ":=", "\n", "\t", 
   RowBox[{"ComplexExpand", "@", 
    RowBox[{"Conjugate", "[", "v", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.65952499128645*^9, 3.6595249912875223`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"f", ":", 
       RowBox[{"(", 
        RowBox[{"Cos", "|", "Sin", "|", "Tan"}], ")"}]}], ")"}], "[", "x__", 
     "]"}], "]"}], ":=", 
   RowBox[{"ComplexExpand", "@", 
    RowBox[{"Conjugate", "[", 
     RowBox[{"f", "[", "x", "]"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593009798769155*^9, 3.593009879395075*^9}, {
   3.6571051883201323`*^9, 3.657105191228936*^9}, 3.659524905204121*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", 
    RowBox[{"num_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"ComplexExpand", "@", 
    RowBox[{"Conjugate", "[", "num", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4502887965299*^9, 3.450288858748598*^9}, {
   3.569523037275894*^9, 3.569523057801008*^9}, {3.570104812906722*^9, 
   3.570104819142477*^9}, 3.6595249070778913`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", "symbol_Symbol", "]"}], ":=", 
   RowBox[{"ComplexExpand", "@", 
    RowBox[{"Conjugate", "[", "symbol", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4502887965299*^9, 3.450288858748598*^9}, {
   3.569523037275894*^9, 3.569523057801008*^9}, {3.570104812906722*^9, 
   3.570104836599957*^9}, 3.659524909517746*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", 
    RowBox[{"Conjugate", "[", "symbol_Symbol", "]"}], "]"}], ":=", 
   RowBox[{"ComplexExpand", "@", "symbol"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.657104614263034*^9, 3.657104623011056*^9}, 
   3.6595249126696043`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", 
    RowBox[{"Conjugate", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"f", ":", 
        RowBox[{"Sin", "|", "Cos", "|", "Tan"}]}], ")"}], "[", 
      "symbol_Symbol", "]"}], "]"}], "]"}], ":=", 
   RowBox[{"f", "[", "symbol", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.657104614263034*^9, 3.657104623011056*^9}, {
  3.6571052831123323`*^9, 3.65710530417312*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Adjoint", "[", 
    RowBox[{"Exp", "[", "op_", "]"}], "]"}], ":=", 
   RowBox[{"Exp", "[", 
    RowBox[{"Adjoint", "[", "op", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Adjoint", "[", 
   RowBox[{"Power", "[", 
    RowBox[{"E", ",", "op_"}], "]"}], "]"}], ":=", 
  RowBox[{"Exp", "[", 
   RowBox[{"Adjoint", "[", "op", "]"}], "]"}]}]}], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4395139086100073`*^9, 3.4395139354945927`*^9}, 
   3.439514360937415*^9, {3.589263171728022*^9, 3.589263207919682*^9}, {
   3.589479887280684*^9, 3.589479899483118*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["DyadicProduct", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell["\<\
DyadicProduct[v1_List,v2_List]:=
\tDirectProduct[Map[List,v1],v2];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["NDiagonalize", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{3.586071042433832*^9},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5868618772045517`*^9, 3.586861898059215*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "NDiagonalize", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Assumptions", "\[Rule]", "Automatic"}], "}"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.5860711295104313`*^9, 3.5860711426440983`*^9}, {
  3.586084382165196*^9, 3.586084383865512*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["numeric matrix", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5868618772045517`*^9, 3.586861898059215*^9}, {
  3.586861932032152*^9, 3.58686194825243*^9}}],

Cell["\<\
In the case of Assumptions\[Rule]{OrthogonalEigenvectors\[Rule]True}, \
orthogonalization is applied individually to all eigenvector subspaces \
belonging to degenerate eigenvalue sets. The degenerate subspaces are treated \
independently, for the sake of numerical efficiency. The inverse of the X \
matrix may then be calculated by normalizing the eigenvectors and using \
ConjugateTranspose. Surprisingly, in tests, this does not lead to \
computational advantages over just using the Inverse, even for large \
matrices, mainly because of the cost of the Tally operation for large \
vectors. Nevertheless I have kept the code in. Assumptions\[Rule]False may be \
used to force use of the Inverse.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586078389076832*^9, 3.586078428036951*^9}, {
  3.586078605140266*^9, 3.586078620824727*^9}, {3.586085037635858*^9, 
  3.586085115476633*^9}, {3.586088423688616*^9, 3.586088429590706*^9}, {
  3.586088523392727*^9, 3.5860885510380793`*^9}, {3.586088582593645*^9, 
  3.586088650115561*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"mat_", "?", "NumericMatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "evals", ",", "evecs", ",", "X", ",", "Xinv", ",", "ass", ",", 
       "orthogevecs", ",", "degevals", ",", "degevalpositions"}], "}"}], ",", 
     
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ass", "=", 
        RowBox[{
         RowBox[{"Assumptions", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "NDiagonalize", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"orthogevecs", "=", "\[IndentingNewLine]", 
        RowBox[{"Switch", "[", 
         RowBox[{"ass", ",", "\[IndentingNewLine]", 
          RowBox[{"None", "|", "False", "|", "Automatic"}], ",", "False", ",",
           "\[IndentingNewLine]", 
          RowBox[{"_Rule", "|", 
           RowBox[{"{", 
            RowBox[{"_Rule", "..."}], "}"}]}], ",", "\[IndentingNewLine]", 
          "\t", 
          RowBox[{"OrthogonalEigenvectors", "/.", 
           RowBox[{"Flatten", "[", 
            RowBox[{"{", 
             RowBox[{"ass", ",", 
              RowBox[{"OrthogonalEigenvectors", "\[Rule]", "False"}]}], "}"}],
             "]"}]}], ",", "\[IndentingNewLine]", "_", ",", "False"}], 
         "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"evals", ",", "evecs"}], "}"}], "=", 
        RowBox[{"Eigensystem", "[", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "mat", "]"}], "\[GreaterEqual]", "256"}], 
           ",", 
           RowBox[{"N", "@", 
            RowBox[{"Normal", "@", "mat"}]}], ",", 
           RowBox[{"N", "@", "mat"}]}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"orthogevecs", ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"degevals", "=", 
            RowBox[{"First", "/@", 
             RowBox[{"Select", "[", 
              RowBox[{
               RowBox[{"Tally", "[", 
                RowBox[{"evals", ",", "Equal"}], "]"}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Last", "[", "#", "]"}], ">", "1"}], ")"}], "&"}]}],
               "]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"degevalpositions", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"Flatten", "[", 
               RowBox[{"Position", "[", 
                RowBox[{"evals", ",", "#"}], "]"}], "]"}], "&"}], "/@", 
             "degevals"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"evecs", "=", 
            RowBox[{"ReplacePart", "[", 
             RowBox[{"evecs", ",", 
              RowBox[{"Flatten", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"MapThread", "[", 
                  RowBox[{"Rule", ",", 
                   RowBox[{"{", 
                    RowBox[{"#", ",", 
                    RowBox[{"Orthogonalize", "[", 
                    RowBox[{
                    "evecs", "\[LeftDoubleBracket]", "#", 
                    "\[RightDoubleBracket]"}], "]"}]}], "}"}]}], "]"}], "&"}],
                 "/@", "degevalpositions"}], "]"}]}], "]"}]}]}], 
          "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"X", "=", 
        RowBox[{"SparseArray", "@", 
         RowBox[{"Chop", "@", 
          RowBox[{"Transpose", "[", 
           RowBox[{"Normalize", "/@", "evecs"}], "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Xinv", "=", 
        RowBox[{"If", "[", 
         RowBox[{"orthogevecs", ",", 
          RowBox[{"ConjugateTranspose", "[", "X", "]"}], ",", 
          RowBox[{"Chop", "@", 
           RowBox[{"Inverse", "[", "X", "]"}]}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Switch", "[", 
        RowBox[{"Xinv", ",", "\[IndentingNewLine]", "_Inverse", ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"NDiagonalize", "::", "fail"}], "]"}], ";", "$Failed"}], 
          ")"}], ",", "\[IndentingNewLine]", "_", ",", 
         RowBox[{"{", 
          RowBox[{"X", ",", "evals", ",", 
           RowBox[{"SparseArray", "@", "Xinv"}]}], "}"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQAWIQ/Xb2O4fH2185dp2VDwXRc45WR4Lolkff4sA0n2Yy
iL7wl7cLRIudWTMdREuZPZ4BooVeiVwA0TUfLtwB0daXO3+B6NfJxSxPgPSB
t04SILqocoUkmD+t5+JTIO39dc5VEH1qlsO9Z0B6QXLsaxDtt2KFz3MgzVR2
C0zfrdxz5CWQbjrNfBREG4VoC/PueOX4lemVOIjmK11dnLrzlaOsPHcpiC6I
LtoHovf83r0fRHufP61bPe21Y0d0oT6Ivr60xBhEJ+hqWYDo1yYv3EG0xZ1E
DxCdv/h9IIiu8foOpq0Y63ecPvTakWHlIzDN8/DKMRDNMuUWmAYA0lG68w==

  "]]
}, Closed]],

Cell[CellGroupData[{

Cell["failure", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5868618772045517`*^9, 3.5868618855392447`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"mat_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"NDiagonalize", "::", "notnummat"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586331643311863*^9, 3.5863316722947187`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5868618772045517`*^9, 3.586861878699669*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "::", "fail"}], "=", 
   "\"\<Cannot invert the matrix of eigenvectors, possibly because the matrix \
is singular.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5860722996354856`*^9, 3.5860723188434*^9}, 
   3.586072405035383*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "::", "notnummat"}], "=", 
   "\"\<NDiagonalize cannot be applied to a non-numeric matrix. Check that \
all symbols have numeric values.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5860722996354856`*^9, 3.5860723188434*^9}, 
   3.586072405035383*^9, {3.586331681992073*^9, 3.586331705126358*^9}, {
   3.5863318905517807`*^9, 3.586331896973156*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["HermitianQ", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"HermitianQ", "[", 
   RowBox[{"X_", "?", "MatrixQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Chop", "@", 
    RowBox[{"ComplexExpand", "@", 
     RowBox[{"N", "@", 
      RowBox[{"Normal", "[", 
       RowBox[{
        RowBox[{"Adjoint", "[", "X", "]"}], "-", "X"}], "]"}]}]}]}], 
   "\[Equal]", 
   RowBox[{"DiagonalMatrix", "[", 
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"Length", "[", "X", "]"}], "}"}]}], "]"}], " ", 
    "]"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.541356442466282*^9, 3.5413564453353853`*^9}, {
  3.54135671229758*^9, 3.5413567672772818`*^9}, {3.54135686124443*^9, 
  3.54135686773216*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["AntiHermitianQ", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.562904128235589*^9, 3.56290412896938*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"AntiHermitianQ", "[", 
   RowBox[{"X_", "?", "MatrixQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Chop", "@", 
    RowBox[{"ComplexExpand", "@", 
     RowBox[{"N", "@", 
      RowBox[{"Normal", "[", 
       RowBox[{
        RowBox[{"Adjoint", "[", "X", "]"}], "+", "X"}], "]"}]}]}]}], 
   "\[Equal]", 
   RowBox[{"DiagonalMatrix", "[", 
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"Length", "[", "X", "]"}], "}"}]}], "]"}], " ", 
    "]"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.541356442466282*^9, 3.5413564453353853`*^9}, {
  3.54135671229758*^9, 3.5413567672772818`*^9}, {3.54135686124443*^9, 
  3.54135686773216*^9}, {3.56290413379023*^9, 3.562904137367815*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["UnitaryQ", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.531831155320922*^9, 3.531831156301428*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"UnitaryQ", "[", 
   RowBox[{"X_", "?", "MatrixQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Chop", "@", 
    RowBox[{"ComplexExpand", "@", 
     RowBox[{"N", "@", 
      RowBox[{"Normal", "[", 
       RowBox[{
        RowBox[{"Adjoint", "[", "X", "]"}], ".", "X"}], "]"}]}]}]}], 
   "\[Equal]", 
   RowBox[{"Chop", "@", 
    RowBox[{"ComplexExpand", "@", 
     RowBox[{"N", "@", 
      RowBox[{"Normal", "[", 
       RowBox[{"X", ".", 
        RowBox[{"Adjoint", "[", "X", "]"}]}], "]"}]}]}]}], "==", 
   RowBox[{"DiagonalMatrix", "[", 
    RowBox[{"Table", "[", 
     RowBox[{"1", ",", 
      RowBox[{"{", 
       RowBox[{"Length", "[", "X", "]"}], "}"}]}], "]"}], " ", 
    "]"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.531831160083158*^9, 3.53183119297233*^9}, 
   3.5318313576233397`*^9, {3.531832285635756*^9, 3.531832288822775*^9}, {
   3.5413565099882803`*^9, 3.5413565206789227`*^9}, {3.541356728549407*^9, 
   3.541356738805183*^9}, {3.5413567718246326`*^9, 3.541356778581077*^9}, {
   3.541356882767269*^9, 3.541356886413136*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["NormalQ", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.505026327228353*^9, 3.505026329482765*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NormalQ", "[", 
     RowBox[{"X_", "?", "MatrixQ"}], "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Union", "@", 
        RowBox[{"Flatten", "@", 
         RowBox[{"Chop", "@", 
          RowBox[{"ComplexExpand", "@", 
           RowBox[{"N", "@", 
            RowBox[{"Normal", "[", 
             RowBox[{"X", "+", 
              RowBox[{"ConjugateTranspose", "@", "X"}]}], "]"}]}]}]}]}]}], 
       "\[Equal]", 
       RowBox[{"{", "0", "}"}]}], ")"}], "||", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Union", "@", 
        RowBox[{"Flatten", "@", 
         RowBox[{"Chop", "@", 
          RowBox[{"ComplexExpand", "@", 
           RowBox[{"N", "@", 
            RowBox[{"Normal", "[", 
             RowBox[{"X", "-", 
              RowBox[{"ConjugateTranspose", "@", "X"}]}], "]"}]}]}]}]}]}], 
       "\[Equal]", 
       RowBox[{"{", "0", "}"}]}], ")"}], "||", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Chop", "@", 
        RowBox[{"ComplexExpand", "@", 
         RowBox[{"N", "[", 
          RowBox[{
           RowBox[{"Plus", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Abs", "[", "#", "]"}], "^", "2"}], ")"}], "&"}], "/@", 
              RowBox[{"Eigenvalues", "[", "X", "]"}]}], ")"}]}], "-", 
           RowBox[{"Plus", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Abs", "[", "#", "]"}], "^", "2"}], ")"}], "&"}], "/@", 
              RowBox[{"Flatten", "[", "X", "]"}]}], ")"}]}]}], "]"}]}]}], 
       "\[Equal]", "0"}], ")"}]}]}], ";"}], "\[IndentingNewLine]"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.5050263367457027`*^9, 3.505026396312476*^9}, {
  3.541356531852491*^9, 3.541356558713029*^9}, {3.541356894897418*^9, 
  3.541356912719486*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["OrthogonalQ", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"OrthogonalQ", "[", 
   RowBox[{"X_", "?", "MatrixQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "mat", "}"}], ",", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"mat", "=", 
       RowBox[{"Chop", "@", 
        RowBox[{"Outer", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Conjugate", "[", "#1", "]"}], ".", "#2"}], ")"}], "&"}],
           ",", "X", ",", "X", ",", "1"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{"mat", "\[Equal]", " ", 
        RowBox[{"DiagonalMatrix", "[", 
         RowBox[{"Diagonal", "[", "mat", "]"}], "]"}]}], ")"}]}], 
     "\[IndentingNewLine]", ")"}]}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4096707378688097`*^9, 3.409670760437592*^9}, {
  3.5629040649300613`*^9, 3.562904070412744*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["OrthonormalQ", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrthonormalQ", "[", 
    RowBox[{"X_", "?", "MatrixQ"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Chop", "@", 
     RowBox[{"Outer", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Conjugate", "[", "#1", "]"}], ".", "#2"}], ")"}], "&"}], 
       ",", "X", ",", "X", ",", "1"}], "]"}]}], "\[Equal]", " ", 
    RowBox[{"DiagonalMatrix", "[", 
     RowBox[{"Table", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"Length", "[", "X", "]"}], "}"}]}], "]"}], "]"}]}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{
  3.5629040935388517`*^9, {3.562904684917346*^9, 3.5629046986076603`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["EigensystemQ", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"EigensystemQ", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"evals_List", ",", 
      RowBox[{"evecs_", "?", "MatrixQ"}]}], "}"}], ",", 
    RowBox[{"mat_", "?", "MatrixQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"X", ",", "L"}], "}"}], ",", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"X", "=", 
       RowBox[{"Transpose", "@", "evecs"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"L", "=", 
       RowBox[{"DiagonalMatrix", "[", "evals", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Chop", "[", 
        RowBox[{"N", "[", 
         RowBox[{
          RowBox[{"mat", ".", "X"}], " ", "-", " ", 
          RowBox[{"X", ".", "L"}]}], "]"}], "]"}], "\[Equal]", 
       RowBox[{"DiagonalMatrix", "[", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"Length", "[", "evals", "]"}], "}"}]}], "]"}], " ", 
        "]"}]}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["CommuteQ", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"CommuteQ", "[", 
   RowBox[{
    RowBox[{"m1_", "?", "MatrixQ"}], ",", 
    RowBox[{"m2_", "?", "MatrixQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Chop", "[", 
        RowBox[{"N", "[", 
         RowBox[{
          RowBox[{"m1", ".", "m2"}], "-", 
          RowBox[{"m2", ".", "m1"}]}], "]"}], "]"}], "\[Equal]", " ", 
       RowBox[{"DiagonalMatrix", "[", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", 
           RowBox[{"Length", "[", "m1", "]"}], "}"}]}], "]"}], "]"}]}], ")"}],
      "\[IndentingNewLine]", ")"}]}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["DiagonalQ", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DiagonalQ", "[", 
   RowBox[{"mat_", "?", "MatrixQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", ",", "n"}], "}"}], ",", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"m", ",", "n"}], "}"}], "=", 
       RowBox[{"Dimensions", "[", "mat", "]"}]}], ";", "\[IndentingNewLine]", 
      
      RowBox[{
       RowBox[{"(", 
        RowBox[{"m", "\[Equal]", "n"}], ")"}], "&&", "\[IndentingNewLine]", 
       RowBox[{"And", "@@", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Chop", "[", "#", "]"}], "==", "0"}], ")"}], "&"}], "/@", 
          RowBox[{"Flatten", "@", 
           RowBox[{"Table", "[", " ", 
            RowBox[{
             RowBox[{"Drop", "[", 
              RowBox[{
               RowBox[{"mat", "[", 
                RowBox[{"[", "r", "]"}], "]"}], ",", 
               RowBox[{"{", "r", "}"}]}], "]"}], ",", " ", 
             RowBox[{"{", 
              RowBox[{"r", ",", "1", ",", 
               RowBox[{"Length", "[", "mat", "]"}]}], "}"}]}], "]"}]}]}], 
         "\[IndentingNewLine]", ")"}]}]}]}], "\[IndentingNewLine]", ")"}]}], 
   "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["NumericMatrixQ", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{3.564566474700713*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NumericMatrixQ", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ".."}], "}"}], ".."}], "}"}], "]"}], 
   "=", "True"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5645662382821627`*^9, 3.564566308414949*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NumericMatrixQ", "[", "sa_SparseArray", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"Last", "/@", 
       RowBox[{"ArrayRules", "@", "sa"}]}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ".."}], "}"}]}], "]"}]}], "=", 
   "True"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.564566317215365*^9, 3.564566340800194*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumericMatrixQ", "[", "_", "]"}], ":=", "False"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.564566345502575*^9, 3.564566350165349*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BlockDiagonalMatrix", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"BlockDiagonalMatrix", "[", 
   RowBox[{"mat1_", ",", "mats__"}], "]"}], ":=", 
  RowBox[{"BlockDiagonalMatrix", "[", 
   RowBox[{"{", 
    RowBox[{"mat1", ",", "mats"}], "}"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.409664138935763*^9, 3.409664191086877*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BlockDiagonalMatrix", "[", 
   RowBox[{"blocks", ":", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"_", "?", "MatrixQ"}], ".."}], "}"}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "blockdims", ",", "starts", ",", "ends", ",", "blockranges", ",", 
       "blockindex", ",", "positioninblock"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"blockdims", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"First", "[", 
           RowBox[{"Dimensions", "[", "#", "]"}], "]"}], "&"}], "/@", 
         "blocks"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"starts", "=", 
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{"FoldList", "[", 
           RowBox[{"Plus", ",", "1", ",", "blockdims"}], "]"}], ",", 
          RowBox[{"-", "1"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ends", "=", 
        RowBox[{"starts", "+", "blockdims", "-", "1"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"blockranges", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"starts", ",", "ends"}], "}"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"blockindex", "[", "i_", "]"}], ":=", 
        RowBox[{"First", "@", 
         RowBox[{"Flatten", "@", 
          RowBox[{"Position", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"MemberQ", "[", 
               RowBox[{
                RowBox[{"Range", "@@", 
                 RowBox[{"(", "#", ")"}]}], ",", "i"}], "]"}], "&"}], "/@", 
             "blockranges"}], ",", "True"}], "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"positioninblock", "[", "i_", "]"}], ":=", 
        RowBox[{"i", "-", 
         RowBox[{"starts", "\[LeftDoubleBracket]", 
          RowBox[{"blockindex", "[", "i", "]"}], "\[RightDoubleBracket]"}], 
         "+", "1"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"blockindex", "[", "i", "]"}], "\[Equal]", 
             RowBox[{"blockindex", "[", "j", "]"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"blocks", "\[LeftDoubleBracket]", 
             RowBox[{
              RowBox[{"blockindex", "[", "i", "]"}], ",", 
              RowBox[{"positioninblock", "[", "i", "]"}], ",", 
              RowBox[{"positioninblock", "[", "j", "]"}]}], 
             "\[RightDoubleBracket]"}], ",", "\[IndentingNewLine]", "0"}], 
           "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Plus", "@@", "blockdims"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "1", ",", 
           RowBox[{"Plus", "@@", "blockdims"}]}], "}"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"Equal", "@@", 
         RowBox[{"Dimensions", "[", "#", "]"}]}], ")"}], "&"}], "/@", 
      "blocks"}], ")"}]}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SetOffDiagonalElementsToZero", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{3.430452769281374*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOffDiagonalElementsToZero", "[", 
   RowBox[{"mat_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"SetOffDiagonalElementsToZero", "[", 
    RowBox[{"mat", ",", 
     RowBox[{"True", "&"}]}], "]"}], "/;", 
   RowBox[{"Equal", "@@", 
    RowBox[{"Dimensions", "[", "mat", "]"}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.43045382927347*^9, 3.430453890804462*^9}, 
   3.4304540263722486`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetOffDiagonalElementsToZero", "[", 
    RowBox[{
     RowBox[{"mat_", "?", "MatrixQ"}], ",", "func_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "n", "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"n", "=", 
         RowBox[{"First", "@", 
          RowBox[{"Dimensions", "[", "mat", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ReplacePart", "[", 
         RowBox[{"mat", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"DeleteCases", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Position", "[", 
              RowBox[{
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"func", "[", 
                  RowBox[{"r", ",", "c"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"r", ",", "1", ",", "n"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"c", ",", "1", ",", "n"}], "}"}]}], "]"}], ",", 
               "True"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"r_", ",", "r_"}], "}"}]}], "\[IndentingNewLine]", 
            "]"}], "\[Rule]", "0"}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", ")"}]}], "]"}], "/;", 
    RowBox[{"Equal", "@@", 
     RowBox[{"Dimensions", "[", "mat", "]"}]}]}]}], 
  "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.409664138935763*^9, 3.409664191086877*^9}, {
  3.430452665062142*^9, 3.430452726525506*^9}, {3.4304527720709743`*^9, 
  3.430452790116661*^9}, {3.430452824191351*^9, 3.4304528361515923`*^9}, {
  3.430453101034411*^9, 3.430453118087002*^9}, {3.430453163709519*^9, 
  3.4304531915388117`*^9}, {3.4304534116136208`*^9, 3.430453499620863*^9}, {
  3.430453686186276*^9, 3.430453687263865*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["MultiplyMatricesAndMatrixInterpolationFunctions", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{3.430452769281374*^9, 3.621533691545862*^9},
 AspectRatioFixed->True],

Cell["\<\
multiplies matrix representations together. This routine handles the case \
when one or more of the operands is an InterpolatingFunction for generating a \
matrix. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.62125033717229*^9, 3.621250374827387*^9}, {
  3.62125042669479*^9, 3.621250428234219*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
   "MultiplyMatricesAndMatrixInterpolationFunctions", "[", "mat1_", "]"}], ":=",
    "mat1"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621161175119286*^9, 3.621161188517819*^9}, 
   3.621161223648713*^9, 3.621161489113659*^9, 3.621250396098237*^9, 
   3.621250433323427*^9, 3.621533716959853*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
    RowBox[{"matrices", ":", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"_", "?", "MatrixQ"}], ".."}], ")"}]}], "]"}], ":=", 
   RowBox[{"Dot", "[", "matrices", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6314397438651533`*^9, 3.631439776376986*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
    RowBox[{"mat1_", ",", "mat2_", ",", "more__"}], "]"}], ":=", 
   RowBox[{"MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
    RowBox[{
     RowBox[{"MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
      RowBox[{"mat1", ",", "mat2"}], "]"}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6211611347295723`*^9, 3.621161170179515*^9}, {
  3.621161224926882*^9, 3.6211612271470947`*^9}, {3.621161490756505*^9, 
  3.62116149280414*^9}, {3.621250397524008*^9, 3.6212503996095552`*^9}, {
  3.6212504346392384`*^9, 3.621250437125608*^9}, {3.621533718807754*^9, 
  3.6215337226146097`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
    RowBox[{
     RowBox[{"mat1_", "?", "MatrixQ"}], ",", 
     RowBox[{"mat2_", "?", "MatrixQ"}]}], "]"}], ":=", 
   RowBox[{"SparseArray", "[", 
    RowBox[{"mat1", ".", "mat2"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621161196364728*^9, 3.621161228834638*^9}, 
   3.621161494289155*^9, 3.62116192105905*^9, 3.621250400856679*^9, {
   3.621250442896059*^9, 3.6212504456660423`*^9}, {3.621251628295556*^9, 
   3.6212516339303303`*^9}, 3.621533726838621*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
     RowBox[{
      RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
      RowBox[{"mat_", "?", "MatrixQ"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{"ifunc", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"m_", "?", "MatrixQ"}], "\[RuleDelayed]", 
        RowBox[{"SparseArray", "@", 
         RowBox[{"Simplify", "[", 
          RowBox[{"m", ".", "mat"}], "]"}]}]}], "}"}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.621161231681098*^9, {3.62116126441649*^9, 3.6211613681913443`*^9}, 
   3.621161498395927*^9, {3.6211624660165167`*^9, 3.6211624669937067`*^9}, 
   3.621250404940707*^9, {3.621250458378385*^9, 3.6212504679178*^9}, {
   3.621251333720931*^9, 3.621251338905498*^9}, {3.6212517339507847`*^9, 
   3.621251737583247*^9}, 3.621533730235482*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
     RowBox[{
      RowBox[{"mat_", "?", "MatrixQ"}], ",", 
      RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}]}], "]"}], "/;", 
    
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{"ifunc", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"m_", "?", "MatrixQ"}], "\[RuleDelayed]", 
        RowBox[{"SparseArray", "[", 
         RowBox[{"mat", ".", "m"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.621161231681098*^9, {3.62116126441649*^9, 3.6211613681913443`*^9}, 
   3.621161498395927*^9, {3.6211624660165167`*^9, 3.6211624669937067`*^9}, 
   3.621250404940707*^9, {3.621250458378385*^9, 3.621250491283547*^9}, {
   3.621251326781913*^9, 3.621251329781361*^9}, 3.621533733385378*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
     RowBox[{
      RowBox[{"ifunc1_InterpolatingFunction", "[", "t_", "]"}], ",", 
      RowBox[{"ifunc2_InterpolatingFunction", "[", "t_", "]"}]}], "]"}], "/;",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc1", "]"}], "\[GreaterEqual]", "3"}], ")"}],
      "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc1", "[", 
        RowBox[{"ifunc1", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}], "&&", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc2", "]"}], "\[GreaterEqual]", "3"}], ")"}],
      "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc2", "[", 
        RowBox[{"ifunc2", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}], "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"First", "@", "ifunc1"}], ",", 
       RowBox[{"First", "@", "ifunc2"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "interptimes", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"interptimes", "=", 
        RowBox[{"Sort", "@", 
         RowBox[{"Union", "[", 
          RowBox[{
           RowBox[{"ifunc1", "\[LeftDoubleBracket]", 
            RowBox[{"3", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
           RowBox[{"ifunc1", "\[LeftDoubleBracket]", 
            RowBox[{"3", ",", "2"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Interpolation", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"SparseArray", "[", 
            RowBox[{
             RowBox[{"ifunc1", "[", "#", "]"}], ".", 
             RowBox[{"ifunc2", "[", "#", "]"}]}], "]"}], "&"}], "/@", 
          "interptimes"}], "]"}], "[", "t", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.621161231681098*^9, {3.62116126441649*^9, 3.62116145577761*^9}, 
   3.621161500668488*^9, {3.62116160430916*^9, 3.621161722810411*^9}, 
   3.62125040696611*^9, {3.621250499285955*^9, 3.621250506597664*^9}, {
   3.621251312243587*^9, 3.621251318275893*^9}, {3.62125147450102*^9, 
   3.621251507869431*^9}, 3.6215337423296633`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["SumMatricesAndMatrixInterpolationFunctions", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{
  3.430452769281374*^9, 3.621533691545862*^9, {3.621533779100169*^9, 
   3.6215337796498537`*^9}},
 AspectRatioFixed->True],

Cell["\<\
sums matrix representations together. This routine handles the case when one \
or more of the operands is an InterpolatingFunction for generating a matrix. \
\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.62125033717229*^9, 3.621250374827387*^9}, {
  3.62125042669479*^9, 3.621250428234219*^9}, {3.621533785136264*^9, 
  3.621533785901223*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SumMatricesAndMatrixInterpolationFunctions", "[", "mat1_", "]"}], 
   ":=", "mat1"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621161175119286*^9, 3.621161188517819*^9}, 
   3.621161223648713*^9, 3.621161489113659*^9, 3.621250396098237*^9, 
   3.621250433323427*^9, 3.621533716959853*^9, 3.621533790920869*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SumMatricesAndMatrixInterpolationFunctions", "[", 
    RowBox[{"matrices", ":", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"_", "?", "MatrixQ"}], ".."}], ")"}]}], "]"}], ":=", 
   RowBox[{"Plus", "[", "matrices", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6314397438651533`*^9, 3.631439805934681*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SumMatricesAndMatrixInterpolationFunctions", "[", 
    RowBox[{"mat1_", ",", "mat2_", ",", "more__"}], "]"}], ":=", 
   RowBox[{"SumMatricesAndMatrixInterpolationFunctions", "[", 
    RowBox[{
     RowBox[{"SumMatricesAndMatrixInterpolationFunctions", "[", 
      RowBox[{"mat1", ",", "mat2"}], "]"}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6211611347295723`*^9, 3.621161170179515*^9}, {
  3.621161224926882*^9, 3.6211612271470947`*^9}, {3.621161490756505*^9, 
  3.62116149280414*^9}, {3.621250397524008*^9, 3.6212503996095552`*^9}, {
  3.6212504346392384`*^9, 3.621250437125608*^9}, {3.621533718807754*^9, 
  3.6215337226146097`*^9}, {3.621533792972804*^9, 3.621533796562701*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SumMatricesAndMatrixInterpolationFunctions", "[", 
    RowBox[{
     RowBox[{"mat1_", "?", "MatrixQ"}], ",", 
     RowBox[{"mat2_", "?", "MatrixQ"}]}], "]"}], ":=", 
   RowBox[{"SparseArray", "[", 
    RowBox[{"mat1", "+", "mat2"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621161196364728*^9, 3.621161228834638*^9}, 
   3.621161494289155*^9, 3.62116192105905*^9, 3.621250400856679*^9, {
   3.621250442896059*^9, 3.6212504456660423`*^9}, {3.621251628295556*^9, 
   3.6212516339303303`*^9}, 3.621533726838621*^9, {3.621533799121542*^9, 
   3.621533802705872*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SumMatricesAndMatrixInterpolationFunctions", "[", 
     RowBox[{
      RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
      RowBox[{"mat_", "?", "MatrixQ"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{"ifunc", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"m_", "?", "MatrixQ"}], "\[RuleDelayed]", 
        RowBox[{"SparseArray", "@", 
         RowBox[{"Simplify", "[", 
          RowBox[{"m", "+", "mat"}], "]"}]}]}], "}"}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.621161231681098*^9, {3.62116126441649*^9, 3.6211613681913443`*^9}, 
   3.621161498395927*^9, {3.6211624660165167`*^9, 3.6211624669937067`*^9}, 
   3.621250404940707*^9, {3.621250458378385*^9, 3.6212504679178*^9}, {
   3.621251333720931*^9, 3.621251338905498*^9}, {3.6212517339507847`*^9, 
   3.621251737583247*^9}, 3.621533730235482*^9, {3.621533807810367*^9, 
   3.6215338137355328`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SumMatricesAndMatrixInterpolationFunctions", "[", 
   RowBox[{
    RowBox[{"mat_", "?", "MatrixQ"}], ",", 
    RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}]}], "]"}], ":=", 
  RowBox[{"SumMatricesAndMatrixInterpolationFunctions", "[", 
   RowBox[{
    RowBox[{"ifunc", "[", "t", "]"}], ",", "mat"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.621161231681098*^9, {3.62116126441649*^9, 3.6211613681913443`*^9}, 
   3.621161498395927*^9, {3.6211624660165167`*^9, 3.6211624669937067`*^9}, 
   3.621250404940707*^9, {3.621250458378385*^9, 3.621250491283547*^9}, {
   3.621251326781913*^9, 3.621251329781361*^9}, 3.621533733385378*^9, {
   3.621533822216942*^9, 3.6215338627792053`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SumMatricesAndMatrixInterpolationFunctions", "[", 
     RowBox[{
      RowBox[{"ifunc1_InterpolatingFunction", "[", "t_", "]"}], ",", 
      RowBox[{"ifunc2_InterpolatingFunction", "[", "t_", "]"}]}], "]"}], "/;",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc1", "]"}], "\[GreaterEqual]", "3"}], ")"}],
      "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc1", "[", 
        RowBox[{"ifunc1", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}], "&&", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc2", "]"}], "\[GreaterEqual]", "3"}], ")"}],
      "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc2", "[", 
        RowBox[{"ifunc2", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}], "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"First", "@", "ifunc1"}], ",", 
       RowBox[{"First", "@", "ifunc2"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "interptimes", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"interptimes", "=", 
        RowBox[{"Sort", "@", 
         RowBox[{"Union", "[", 
          RowBox[{
           RowBox[{"ifunc1", "\[LeftDoubleBracket]", 
            RowBox[{"3", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
           RowBox[{"ifunc1", "\[LeftDoubleBracket]", 
            RowBox[{"3", ",", "2"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Interpolation", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"SparseArray", "[", 
            RowBox[{
             RowBox[{"ifunc1", "[", "#", "]"}], "+", 
             RowBox[{"ifunc2", "[", "#", "]"}]}], "]"}], "&"}], "/@", 
          "interptimes"}], "]"}], "[", "t", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.621161231681098*^9, {3.62116126441649*^9, 3.62116145577761*^9}, 
   3.621161500668488*^9, {3.62116160430916*^9, 3.621161722810411*^9}, 
   3.62125040696611*^9, {3.621250499285955*^9, 3.621250506597664*^9}, {
   3.621251312243587*^9, 3.621251318275893*^9}, {3.62125147450102*^9, 
   3.621251507869431*^9}, 3.6215337423296633`*^9, {3.621533875684113*^9, 
   3.6215338849220667`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["MultiplyMatricesAndVectorInterpolationFunctions", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{3.430452769281374*^9, 3.621533691545862*^9, 
  3.623328922751421*^9},
 AspectRatioFixed->True],

Cell["\<\
multiplies matrix representations into a vector using intelligent ordering. \
The last operand may be a vector or an interpolation function yielding a \
vector. The other operands may be a matrix or an interpolation function \
yielding a matrix. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.62125033717229*^9, 3.621250374827387*^9}, {
  3.62125042669479*^9, 3.621250428234219*^9}, {3.6233289493584957`*^9, 
  3.623328959162881*^9}, {3.623329277372075*^9, 3.623329336377501*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
   "MultiplyMatricesAndVectorInterpolationFunctions", "[", "vec_", "]"}], ":=",
    "vec"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621161175119286*^9, 3.621161188517819*^9}, 
   3.621161223648713*^9, 3.621161489113659*^9, 3.621250396098237*^9, 
   3.621250433323427*^9, 3.621533716959853*^9, 3.6233289352757998`*^9, {
   3.623328968632779*^9, 3.6233289732133923`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MultiplyMatricesAndVectorInterpolationFunctions", "[", 
    RowBox[{"mats1__", ",", "mat2_", ",", "vec_"}], "]"}], ":=", 
   RowBox[{"MultiplyMatricesAndVectorInterpolationFunctions", "[", 
    RowBox[{"mats1", ",", "\[IndentingNewLine]", 
     RowBox[{"MultiplyMatricesAndVectorInterpolationFunctions", "[", 
      RowBox[{"mat2", ",", "vec"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6211611347295723`*^9, 3.621161170179515*^9}, {
  3.621161224926882*^9, 3.6211612271470947`*^9}, {3.621161490756505*^9, 
  3.62116149280414*^9}, {3.621250397524008*^9, 3.6212503996095552`*^9}, {
  3.6212504346392384`*^9, 3.621250437125608*^9}, {3.621533718807754*^9, 
  3.6215337226146097`*^9}, {3.6233290203005*^9, 3.623329059113309*^9}, {
  3.623329098262352*^9, 3.623329145468726*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MultiplyMatricesAndVectorInterpolationFunctions", "[", 
    RowBox[{
     RowBox[{"mat_", "?", "MatrixQ"}], ",", 
     RowBox[{"vec_", "?", "VectorQ"}]}], "]"}], ":=", 
   RowBox[{"SparseArray", "[", 
    RowBox[{"mat", ".", "vec"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621161196364728*^9, 3.621161228834638*^9}, 
   3.621161494289155*^9, 3.62116192105905*^9, 3.621250400856679*^9, {
   3.621250442896059*^9, 3.6212504456660423`*^9}, {3.621251628295556*^9, 
   3.6212516339303303`*^9}, 3.621533726838621*^9, {3.623329158246097*^9, 
   3.623329173206607*^9}, 3.623329242898696*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MultiplyMatricesAndVectorInterpolationFunctions", "[", 
     RowBox[{
      RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
      RowBox[{"vec_", "?", "VectorQ"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{"ifunc", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"m_", "?", "MatrixQ"}], "\[RuleDelayed]", 
        RowBox[{"SparseArray", "@", 
         RowBox[{"Simplify", "[", 
          RowBox[{"m", ".", "vec"}], "]"}]}]}], "}"}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.621161231681098*^9, {3.62116126441649*^9, 3.6211613681913443`*^9}, 
   3.621161498395927*^9, {3.6211624660165167`*^9, 3.6211624669937067`*^9}, 
   3.621250404940707*^9, {3.621250458378385*^9, 3.6212504679178*^9}, {
   3.621251333720931*^9, 3.621251338905498*^9}, {3.6212517339507847`*^9, 
   3.621251737583247*^9}, 3.621533730235482*^9, {3.623329190858472*^9, 
   3.623329201729177*^9}, 3.623329244737751*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MultiplyMatricesAndVectorInterpolationFunctions", "[", 
     RowBox[{
      RowBox[{"mat_", "?", "MatrixQ"}], ",", 
      RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}]}], "]"}], "/;", 
    
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "VectorQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{"ifunc", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"v_", "?", "VectorQ"}], "\[RuleDelayed]", 
        RowBox[{"SparseArray", "[", 
         RowBox[{"mat", ".", "v"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.621161231681098*^9, {3.62116126441649*^9, 3.6211613681913443`*^9}, 
   3.621161498395927*^9, {3.6211624660165167`*^9, 3.6211624669937067`*^9}, 
   3.621250404940707*^9, {3.621250458378385*^9, 3.621250491283547*^9}, {
   3.621251326781913*^9, 3.621251329781361*^9}, 3.621533733385378*^9, {
   3.623329219287713*^9, 3.623329247106051*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MultiplyMatricesAndVectorInterpolationFunctions", "[", 
     RowBox[{
      RowBox[{"ifunc1_InterpolatingFunction", "[", "t_", "]"}], ",", 
      RowBox[{"ifunc2_InterpolatingFunction", "[", "t_", "]"}]}], "]"}], "/;",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc1", "]"}], "\[GreaterEqual]", "3"}], ")"}],
      "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc1", "[", 
        RowBox[{"ifunc1", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}], "&&", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc2", "]"}], "\[GreaterEqual]", "3"}], ")"}],
      "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc2", "[", 
        RowBox[{"ifunc2", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "VectorQ"}]}], "]"}], "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"First", "@", "ifunc1"}], ",", 
       RowBox[{"First", "@", "ifunc2"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "interptimes", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"interptimes", "=", 
        RowBox[{"Sort", "@", 
         RowBox[{"Union", "[", 
          RowBox[{
           RowBox[{"ifunc1", "\[LeftDoubleBracket]", 
            RowBox[{"3", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
           RowBox[{"ifunc1", "\[LeftDoubleBracket]", 
            RowBox[{"3", ",", "2"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Interpolation", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"SparseArray", "[", 
            RowBox[{
             RowBox[{"ifunc1", "[", "#", "]"}], ".", 
             RowBox[{"ifunc2", "[", "#", "]"}]}], "]"}], "&"}], "/@", 
          "interptimes"}], "]"}], "[", "t", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.621161231681098*^9, {3.62116126441649*^9, 3.62116145577761*^9}, 
   3.621161500668488*^9, {3.62116160430916*^9, 3.621161722810411*^9}, 
   3.62125040696611*^9, {3.621250499285955*^9, 3.621250506597664*^9}, {
   3.621251312243587*^9, 3.621251318275893*^9}, {3.62125147450102*^9, 
   3.621251507869431*^9}, 3.6215337423296633`*^9, {3.62332924961709*^9, 
   3.623329261770009*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["OptimalBipartiteGraphMatching", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.430452769281374*^9, 3.621533691545862*^9, 3.623328922751421*^9, {
   3.7195743339338284`*^9, 3.71957433779737*^9}, 3.7260677436773386`*^9},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["step1", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7179179561076403`*^9, 3.7179179565295506`*^9}, {
  3.7179285086638436`*^9, 3.7179285093033037`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OptimalBipartiteGraphMatching", "[", "A_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "A$", ",", "M$", ",", "RC$", ",", "CC$", ",", "result", ",", "dimR", 
       ",", "dimC"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"dimR", ",", "dimC"}], "}"}], "=", 
       RowBox[{"Dimensions", "[", "A", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"A$", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "-", 
           RowBox[{"Min", "[", "#", "]"}]}], "&"}], "/@", 
         RowBox[{"Transpose", "[", "A", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"A$", ",", "M$", ",", "RC$", ",", "CC$"}], "}"}], "=", 
       RowBox[{"OptimalBipartiteGraphMatching", "[", 
        RowBox[{
         RowBox[{"Chop", "[", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"#", "-", 
              RowBox[{"Min", "[", "#", "]"}]}], "&"}], "/@", "A$"}], ")"}], 
          "]"}], ",", 
         RowBox[{"ConstantArray", "[", 
          RowBox[{"0", ",", 
           RowBox[{"{", 
            RowBox[{"dimR", ",", "dimC"}], "}"}]}], "]"}], ",", 
         RowBox[{"ConstantArray", "[", 
          RowBox[{"0", ",", "dimR"}], "]"}], ",", 
         RowBox[{"ConstantArray", "[", 
          RowBox[{"0", ",", "dimC"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"dimR", ",", "dimC"}], "}"}], ",", "\"\<step2\>\""}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"OptimalBipartiteGraphMatching", "[", 
       RowBox[{"M$", ",", "dimR", ",", "\"\<assignment\>\""}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.717837409066432*^9, 3.717837499531946*^9}, {
   3.7178375996834164`*^9, 3.7178376027610807`*^9}, {3.7178383040460987`*^9, 
   3.7178383665750213`*^9}, {3.7179180229243836`*^9, 3.717918040776406*^9}, {
   3.7179182570790153`*^9, 3.7179182576415663`*^9}, {3.717923209303504*^9, 
   3.7179232976247835`*^9}, {3.7179262524778204`*^9, 
   3.7179262650088167`*^9}, {3.717927678858453*^9, 3.71792767957752*^9}, {
   3.718025906565547*^9, 3.718025952923791*^9}, {3.718026530325819*^9, 
   3.7180265306383505`*^9}, {3.718089105282522*^9, 3.718089105282522*^9}, {
   3.718089158647568*^9, 3.71808916293878*^9}, {3.7180912761194773`*^9, 
   3.7180913038427644`*^9}, {3.718091504922413*^9, 3.71809150518807*^9}, {
   3.7180961570608954`*^9, 3.718096158267841*^9}, {3.7181046574037886`*^9, 
   3.7181046601359196`*^9}, {3.718104738302147*^9, 3.718104738427165*^9}, {
   3.7181061330246024`*^9, 3.718106140322219*^9}, 3.7181852734229407`*^9, {
   3.718185550901286*^9, 3.7181855560453405`*^9}, {3.7181903515289154`*^9, 
   3.718190383826705*^9}, {3.718190455406892*^9, 3.7181904628449135`*^9}, {
   3.718192133149256*^9, 3.7181921436028194`*^9}, {3.718192182162927*^9, 
   3.7181921944141693`*^9}, {3.718193136455409*^9, 3.7181931399884267`*^9}, {
   3.7183595840255947`*^9, 3.7183595862169504`*^9}, {3.7183597409884696`*^9, 
   3.7183597451101007`*^9}, {3.7183598002786474`*^9, 3.718359800377274*^9}, {
   3.7183616923823757`*^9, 3.718361699081154*^9}, {3.718361733061307*^9, 
   3.7183617601817827`*^9}, {3.718361967185762*^9, 3.718361967301179*^9}, {
   3.7183625741725917`*^9, 3.7183625787167797`*^9}, {3.718362733666589*^9, 
   3.718362733766481*^9}, {3.7183637112338853`*^9, 3.7183637158775997`*^9}, {
   3.7183685532341137`*^9, 3.718368553312811*^9}, {3.718372115728833*^9, 
   3.7183721187160115`*^9}, {3.718372272681945*^9, 3.7183722980588465`*^9}, {
   3.7183725226640453`*^9, 3.7183725240395017`*^9}, {3.7183726908435197`*^9, 
   3.718372693276651*^9}, {3.7195744496459913`*^9, 3.7195744768321157`*^9}, {
   3.71957452213659*^9, 3.719574530866486*^9}, {3.719574612665165*^9, 
   3.719574616353444*^9}, {3.726067733023587*^9, 3.72606773302759*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"OptimalBipartiteGraphMatching", "[", 
   RowBox[{"W_", ",", "dim_", ",", "\"\<assignment\>\""}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "aux1", ",", "aux2", ",", "range", ",", "oneset", ",", "assigned", ",", 
      "set$", ",", "setA", ",", "setB"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"aux1", "[", "A_", "]"}], ":=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "A", "]"}], "\[Equal]", "1"}], ",", "A", ",", 
        "Nothing"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"aux2", "[", "A_", "]"}], ":=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Length", "[", "A", "]"}], "\[Equal]", "1"}], ")"}]}], ",",
         "A", ",", "Nothing"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"range", "=", 
      RowBox[{"Range", "[", "dim", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"oneset", "=", 
      RowBox[{"Position", "[", 
       RowBox[{"W", ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"assigned", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"set$", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Cases", "[", 
           RowBox[{"oneset", ",", 
            RowBox[{"{", 
             RowBox[{"_", ",", "#"}], "}"}]}], "]"}], "&"}], "/@", "range"}], 
        ")"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "}"}], "\[Rule]", " ", "Nothing"}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "assigned", "]"}], "\[NotEqual]", " ", "dim"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"setA", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{"aux1", "/@", "set$"}], ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "[", "setA", "]"}], "\[NotEqual]", " ", "0"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"assigned", "=", 
            RowBox[{"Join", "[", 
             RowBox[{"assigned", ",", "setA"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"set$", "=", 
            RowBox[{"aux2", "/@", "set$"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"oneset", "=", 
            RowBox[{"DeleteCases", "[", 
             RowBox[{"oneset", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Alternatives", "@@", 
                 RowBox[{"setA", "\[LeftDoubleBracket]", 
                  RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}]}], ",",
                 "_"}], "}"}]}], "]"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"setB", "=", 
            RowBox[{"First", "@", 
             RowBox[{"First", "[", "set$", "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"set$", "=", 
            RowBox[{"Rest", "@", "set$"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"assigned", "=", 
            RowBox[{"Join", "[", 
             RowBox[{"assigned", ",", 
              RowBox[{"{", "setB", "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"oneset", "=", 
            RowBox[{"DeleteCases", "[", 
             RowBox[{"oneset", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                "setB", "\[LeftDoubleBracket]", "1", 
                 "\[RightDoubleBracket]"}], ",", "_"}], "}"}]}], "]"}]}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"oneset", "=", 
            RowBox[{"DeleteCases", "[", 
             RowBox[{"oneset", ",", 
              RowBox[{"{", 
               RowBox[{"_", ",", 
                RowBox[{
                "setB", "\[LeftDoubleBracket]", "2", 
                 "\[RightDoubleBracket]"}]}], "}"}]}], "]"}]}]}]}], 
         "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"Flatten", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Cases", "[", 
         RowBox[{"assigned", ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"#", ",", "j_"}], "}"}], "\[RuleDelayed]", "j"}]}], " ", 
         "]"}], "&"}], "/@", "range"}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.718090678369104*^9, 3.71809072924162*^9}, {
   3.718090759790747*^9, 3.7180908087055*^9}, {3.718090839493373*^9, 
   3.7180908972872105`*^9}, {3.718091061450386*^9, 3.718091079164873*^9}, {
   3.718091183122839*^9, 3.7180911836697683`*^9}, {3.7180912541407423`*^9, 
   3.7180912585373263`*^9}, {3.7180915018498397`*^9, 
   3.7180915021154857`*^9}, {3.7181046356262836`*^9, 
   3.7181046383702044`*^9}, {3.718104798578848*^9, 3.718104836846485*^9}, {
   3.7181048704434924`*^9, 3.71810489219059*^9}, {3.71810492439113*^9, 
   3.718105015718091*^9}, {3.7181050562336855`*^9, 3.718105059604353*^9}, {
   3.718105115077699*^9, 3.7181051801589327`*^9}, {3.718105321079916*^9, 
   3.7181053240319414`*^9}, {3.718105362719968*^9, 3.718105363975898*^9}, {
   3.718105643949644*^9, 3.718105770190363*^9}, {3.718105921683739*^9, 
   3.718105942490631*^9}, {3.7181060830036135`*^9, 3.7181060968274326`*^9}, {
   3.7181061506982646`*^9, 3.718106155384968*^9}, {3.7183601353434057`*^9, 
   3.7183601396517158`*^9}, {3.718360343692521*^9, 3.718360343745783*^9}, {
   3.718372101541966*^9, 3.718372103076311*^9}, {3.718372188757537*^9, 
   3.7183721898097363`*^9}, {3.7183726019942317`*^9, 3.7183726299543147`*^9}, 
   3.719574480856784*^9, {3.719574619374892*^9, 3.7195746233557496`*^9}, 
   3.7260677330330935`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["step2", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7179181016250134`*^9, 3.7179181028127184`*^9}, 
   3.7181852735792065`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"OptimalBipartiteGraphMatching", "[", 
   RowBox[{"A_", ",", "M_", ",", "RCover_", ",", "CCover_", ",", 
    RowBox[{"{", 
     RowBox[{"dimR_", ",", "dimC_"}], "}"}], ",", "\"\<step2\>\""}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "M$", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"M$", "=", 
      RowBox[{"Normal", "[", 
       RowBox[{"SparseArray", "[", 
        RowBox[{
         RowBox[{"Thread", "[", 
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{"Chop", "[", "A", "]"}], ",", 
             RowBox[{"0", "|", "0."}]}], "]"}], "\[Rule]", " ", "1"}], "]"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"dimR", ",", "dimC"}], "}"}]}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"OptimalBipartiteGraphMatching", "[", 
      RowBox[{"A", ",", "M$", ",", "RCover", ",", "CCover", ",", 
       RowBox[{"{", 
        RowBox[{"dimR", ",", "dimC"}], "}"}], ",", "\"\<step3\>\""}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7179181081256695`*^9, 3.7179181822576885`*^9}, {
   3.7179182231120834`*^9, 3.71791824381071*^9}, 3.717918282494729*^9, {
   3.7179183453700523`*^9, 3.717918353853958*^9}, {3.7179185032933292`*^9, 
   3.7179185035590143`*^9}, {3.717923092128153*^9, 3.7179231092910705`*^9}, {
   3.7179233122166862`*^9, 3.7179233190815015`*^9}, {3.717923349115344*^9, 
   3.717923384409213*^9}, {3.717923450090152*^9, 3.717923504804036*^9}, {
   3.7179236529810715`*^9, 3.717923655403195*^9}, {3.7179262697889957`*^9, 
   3.7179262730490613`*^9}, {3.7179285232253385`*^9, 3.717928531754158*^9}, {
   3.718014906943475*^9, 3.7180149207885246`*^9}, 3.718014965526787*^9, {
   3.7180150791186843`*^9, 3.7180150817131915`*^9}, {3.7180152207121906`*^9, 
   3.718015226700918*^9}, {3.718015385330998*^9, 3.7180153909509645`*^9}, {
   3.718015472241967*^9, 3.7180154768181705`*^9}, {3.718015530659566*^9, 
   3.718015553420554*^9}, {3.7180158532380314`*^9, 3.7180158710785465`*^9}, {
   3.718016071007216*^9, 3.7180160780367613`*^9}, {3.7180168235848875`*^9, 
   3.7180168535437727`*^9}, {3.718017541793358*^9, 3.7180175596511393`*^9}, {
   3.7180206029816065`*^9, 3.718020620476275*^9}, {3.7180207183353395`*^9, 
   3.7180207570334454`*^9}, {3.718089105298149*^9, 3.718089105298149*^9}, {
   3.7180891586631727`*^9, 3.7180891629544063`*^9}, 3.71818527361046*^9, {
   3.7181855617314057`*^9, 3.718185618879428*^9}, 3.7181904284754314`*^9, {
   3.7181904766601987`*^9, 3.7181904771289935`*^9}, {3.719574509262077*^9, 
   3.7195745424817705`*^9}, {3.7260677330410986`*^9, 3.7260677330431085`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["step3", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7179181016250134`*^9, 3.7179181028127184`*^9}, {
  3.717918252891093*^9, 3.717918252984852*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"OptimalBipartiteGraphMatching", "[", 
   RowBox[{"A_", ",", "M_", ",", "RCover_", ",", "CCover_", ",", 
    RowBox[{"{", 
     RowBox[{"dimR_", ",", "dimC_"}], "}"}], ",", "\"\<step3\>\""}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"colcount", ",", "A$", ",", "M$", ",", "RC$", ",", "CC$"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"A$", "=", "A"}], ";", "\[IndentingNewLine]", 
     RowBox[{"M$", "=", "M"}], ";", "\[IndentingNewLine]", 
     RowBox[{"RC$", "=", "RCover"}], ";", "\[IndentingNewLine]", 
     RowBox[{"CC$", "=", 
      RowBox[{"Normal", "[", 
       RowBox[{"SparseArray", "[", 
        RowBox[{
         RowBox[{"Thread", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Position", "[", 
             RowBox[{"M$", ",", "1"}], "]"}], "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "\[Rule]", 
           " ", "1"}], "]"}], ",", "dimC"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"colcount", "=", 
      RowBox[{"Count", "[", 
       RowBox[{"CC$", ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"colcount", "\[GreaterEqual]", " ", "dimC"}], "||", 
         RowBox[{"colcount", "\[GreaterEqual]", " ", "dimR"}]}], ")"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"A$", ",", "M$", ",", "RC$", ",", "CC$"}], "}"}], ",", 
       RowBox[{"OptimalBipartiteGraphMatching", "[", 
        RowBox[{"A$", ",", "M$", ",", "RC$", ",", "CC$", ",", 
         RowBox[{"{", 
          RowBox[{"dimR", ",", "dimC"}], "}"}], ",", "\"\<step4\>\""}], 
        "]"}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->CompressedData["
1:eJwlxVtIU2EAB/DNStSlpQ8x1xwTvLSTaY4Ue8g6YDcbFcla2ERXKAnq5q1k
UGSWRM0ch1CCgTScZkVMXXomBVKzQKuVaD4oXsamxjQVL7WQ7Pt/Pfz4xV7R
XygMEggEDIGXbNrRvG4/27ulnsTz3jQfDtmyzGFhcPkKFofO0bOlkQkF5L+J
tUn4oqioBDe0Zxqw/n2gS0ee5bXd2LMeF36V3LZrOAormqXRWHjfFIMlgW+x
eCiuNAXbtn12mshV+dffYluwahBLLb1fsWDNMYJbFtfHsa/wtheXRFn9OLOa
W8HPZNZVHHmzNbSBbBzrE+EjlSm7sWjTKcap8nQ5dt+op8ublMnYcf4jvfzk
zFl8IkdzCbe7crX4mvEF/fFEdRH2BNL1WPnSV4OXd8Ybca7ZXIc/7PtzD4tD
sjrwJ0W8A5vVBh7vYGro1kXDG8zVvurHQy6v5BG54JR+L2YyRAy28DI6M3Ag
GUewdYewKavvKN4+4KL3cGO/Gsky+63f+Hv/MamZrNI9jMGGBwplJ7kpjKHb
+dEMrAnLP4xPJ2pcU+Qpdwf9y5mynGlyeESxGrud+y/jTedB+uAelvOQRyST
9Mrjumb8cyPvCa4SqhyYe23ncdJz7Z36Hj873HjuLk6Yfhr0452frVj4/z/k
G29v
  "]]
}, Closed]],

Cell[CellGroupData[{

Cell["step4", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7179185409819164`*^9, 3.717918542263296*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"OptimalBipartiteGraphMatching", "[", 
   RowBox[{"A_", ",", "M_", ",", "RCover_", ",", "CCover_", ",", 
    RowBox[{"{", 
     RowBox[{"dimR_", ",", "dimC_"}], "}"}], ",", "\"\<step4\>\""}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "col", ",", "row", ",", "status", ",", "A$", ",", "M$", ",", "RC$", ",", 
      "CC$", ",", "starset", ",", "starrowset"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"A$", "=", "A"}], ";", "\[IndentingNewLine]", 
     RowBox[{"M$", "=", "M"}], ";", "\[IndentingNewLine]", 
     RowBox[{"RC$", "=", "RCover"}], ";", "\[IndentingNewLine]", 
     RowBox[{"CC$", "=", "CCover"}], ";", "\[IndentingNewLine]", 
     RowBox[{"status", "=", "False"}], ";", "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{"status", "\[Equal]", "False"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"row", ",", "col"}], "}"}], "=", 
         RowBox[{"OptimalBipartiteGraphMatching", "[", 
          RowBox[{
          "A$", ",", "M$", ",", "RC$", ",", "CC$", ",", 
           "\"\<findunczero\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"row", "\[Equal]", 
           RowBox[{"-", "1"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"status", "=", "True"}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"A$", ",", "M$", ",", "RC$", ",", "CC$"}], "}"}], "=", 
            RowBox[{"OptimalBipartiteGraphMatching", "[", 
             RowBox[{"A$", ",", "M$", ",", "RC$", ",", "CC$", ",", 
              RowBox[{"{", 
               RowBox[{"dimR", ",", "dimC"}], "}"}], ",", "\"\<step6\>\""}], 
             "]"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"M$", "\[LeftDoubleBracket]", 
             RowBox[{"row", ",", "col"}], "\[RightDoubleBracket]"}], "=", 
            "2"}], ";", "\[IndentingNewLine]", 
           RowBox[{"starset", "=", 
            RowBox[{"Position", "[", 
             RowBox[{"M$", ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"starrowset", "=", 
            RowBox[{"Cases", "[", 
             RowBox[{"starset", ",", 
              RowBox[{"{", 
               RowBox[{"row", ",", "_"}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"(", 
               RowBox[{"starrowset", "\[Equal]", 
                RowBox[{"{", "}"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"col", "=", 
               RowBox[{
                RowBox[{"First", "[", "starrowset", "]"}], 
                "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], ";",
               "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
               "RC$", "\[LeftDoubleBracket]", "row", 
                "\[RightDoubleBracket]"}], "=", "1"}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
               "CC$", "\[LeftDoubleBracket]", "col", 
                "\[RightDoubleBracket]"}], "=", "0"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"status", "=", "True"}], ";", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"A$", ",", "M$", ",", "RC$", ",", "CC$"}], "}"}], "=", 
               RowBox[{"OptimalBipartiteGraphMatching", "[", 
                RowBox[{
                "A$", ",", "M$", ",", "RC$", ",", "CC$", ",", "starset", ",", 
                 
                 RowBox[{"{", 
                  RowBox[{"row", ",", "col"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"dimR", ",", "dimC"}], "}"}], ",", 
                 "\"\<step5\>\""}], "]"}]}]}]}], "\[IndentingNewLine]", "]"}],
            ";"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"A$", ",", "M$", ",", "RC$", ",", "CC$"}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7179252748421416`*^9, 3.717925313852249*^9}, {
   3.7179253450998063`*^9, 3.7179254596597624`*^9}, {3.717925543475108*^9, 
   3.717925603355097*^9}, {3.717925646852452*^9, 3.717925647920212*^9}, {
   3.7179257240579844`*^9, 3.717925741637488*^9}, {3.717925898625358*^9, 
   3.7179259007950983`*^9}, {3.7179259732771254`*^9, 
   3.7179259734757423`*^9}, {3.7179262222697344`*^9, 
   3.7179262255310946`*^9}, {3.7179263289305944`*^9, 3.717926386187204*^9}, {
   3.717926768831811*^9, 3.7179268344501257`*^9}, {3.717926878248811*^9, 
   3.7179269227467923`*^9}, {3.7179269630937557`*^9, 3.717926963577508*^9}, {
   3.7179270116223183`*^9, 3.7179270144640455`*^9}, {3.7179272243235483`*^9, 
   3.717927226257991*^9}, {3.7179272654327087`*^9, 3.717927271991715*^9}, {
   3.7179273453072586`*^9, 3.717927494656646*^9}, {3.717927531931465*^9, 
   3.717927532068762*^9}, {3.7179275649631414`*^9, 3.717927571799955*^9}, {
   3.717928616870723*^9, 3.7179286223624425`*^9}, {3.7179292154226418`*^9, 
   3.7179292155522842`*^9}, {3.7180114136257687`*^9, 
   3.7180115002636013`*^9}, {3.718012625487076*^9, 3.7180126608091707`*^9}, {
   3.7180141700685825`*^9, 3.718014192818448*^9}, {3.718014286897355*^9, 
   3.718014296727173*^9}, {3.718015255871589*^9, 3.718015260331723*^9}, 
   3.718016966558485*^9, {3.718017091264183*^9, 3.7180170924362297`*^9}, {
   3.718017137147051*^9, 3.718017138334735*^9}, 3.71801719489542*^9, {
   3.718017517461813*^9, 3.718017517868104*^9}, {3.7180175623027277`*^9, 
   3.7180175623964877`*^9}, {3.7180229818149805`*^9, 
   3.7180229911145387`*^9}, {3.718023053412723*^9, 3.718023053553362*^9}, {
   3.718023104333948*^9, 3.718023112607888*^9}, {3.718023426473323*^9, 
   3.718023438016468*^9}, {3.7180235534945445`*^9, 3.7180235643014107`*^9}, {
   3.7180240473219433`*^9, 3.718024086793486*^9}, 3.718024123670312*^9, {
   3.7180257744871354`*^9, 3.7180258018371515`*^9}, {3.718089105313792*^9, 
   3.7180891053450317`*^9}, {3.718089158678795*^9, 3.71808916293878*^9}, {
   3.7181845757684755`*^9, 3.7181845768330407`*^9}, {3.7181847201443367`*^9, 
   3.718184734907301*^9}, {3.7181848268945303`*^9, 3.7181848281134043`*^9}, {
   3.7181848972416143`*^9, 3.7181848974138894`*^9}, {3.718184941288175*^9, 
   3.718184950734533*^9}, {3.718185054122555*^9, 3.718185122772135*^9}, {
   3.7181851905360203`*^9, 3.718185195552162*^9}, {3.7181852414697027`*^9, 
   3.718185251252795*^9}, {3.7181856450497866`*^9, 3.7181856670137434`*^9}, {
   3.7181884331691213`*^9, 3.7181884350656867`*^9}, {3.718190149395054*^9, 
   3.718190152176591*^9}, {3.718190706722084*^9, 3.7181907229908457`*^9}, {
   3.7181912120202703`*^9, 3.7181912136453714`*^9}, {3.7181918250841703`*^9, 
   3.7181918440185957`*^9}, {3.7181918976939573`*^9, 
   3.7181918979283495`*^9}, {3.718191931784292*^9, 3.71819196868322*^9}, {
   3.7181921013094177`*^9, 3.718192113312884*^9}, {3.718192249937289*^9, 
   3.7181922521199694`*^9}, {3.7195745694227304`*^9, 
   3.7195745960260096`*^9}, {3.7195746297357216`*^9, 3.719574633755948*^9}, {
   3.7260677330741224`*^9, 3.7260677330806265`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"OptimalBipartiteGraphMatching", "[", 
   RowBox[{
   "A_", ",", "M_", ",", "RCover_", ",", "CCover_", ",", 
    "\"\<findunczero\>\""}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "set", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"set", "=", 
      RowBox[{"DeleteCases", "[", 
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"A", ",", 
          RowBox[{"0", "|", "0."}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"_", ",", 
          RowBox[{"Alternatives", "@@", 
           RowBox[{"Flatten", "@", 
            RowBox[{"Position", "[", 
             RowBox[{"CCover", ",", "1"}], "]"}]}]}]}], "}"}]}], "]"}]}], ";",
      "\[IndentingNewLine]", 
     RowBox[{"set", "=", 
      RowBox[{"DeleteCases", "[", 
       RowBox[{"set", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Alternatives", "@@", 
           RowBox[{"Flatten", "@", 
            RowBox[{"Position", "[", 
             RowBox[{"RCover", ",", "1"}], "]"}]}]}], ",", "_"}], "}"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"set", "\[Equal]", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"First", "[", "set", "]"}]}], "]"}]}]}], "\[IndentingNewLine]",
    "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.718022971181259*^9, {3.7180230111639376`*^9, 3.7180230172096567`*^9}, {
   3.718023098661474*^9, 3.718023100724181*^9}, {3.7180231590724707`*^9, 
   3.7180231705580034`*^9}, {3.7180232655687923`*^9, 
   3.7180232890213814`*^9}, {3.7180233385168924`*^9, 
   3.7180233676563253`*^9}, {3.7180234769112387`*^9, 
   3.7180235672392063`*^9}, {3.7181845725006423`*^9, 
   3.7181845727198954`*^9}, {3.7181857249714622`*^9, 
   3.7181857259871883`*^9}, {3.718190669368326*^9, 3.718190680277463*^9}, {
   3.718190733000213*^9, 3.7181907345628705`*^9}, {3.719574637270125*^9, 
   3.7195746416753316`*^9}, 3.726067733093137*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["step5", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.717929352789896*^9, 3.717929353940665*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"OptimalBipartiteGraphMatching", "[", 
   RowBox[{
   "A_", ",", "M_", ",", "RCover_", ",", "CCover_", ",", "starset_", ",", 
    "pathstart_", ",", 
    RowBox[{"{", 
     RowBox[{"dimR_", ",", "dimC_"}], "}"}], ",", "\"\<step5\>\""}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "path", ",", "status", ",", "starrow", ",", "M$", ",", "coltmp", ",", 
      "rowtmp", ",", "subs"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"path", "=", 
      RowBox[{"Append", "[", 
       RowBox[{
        RowBox[{"{", "}"}], ",", "pathstart"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"M$", "=", "M"}], ";", "\[IndentingNewLine]", 
     RowBox[{"status", "=", "False"}], ";", "\[IndentingNewLine]", 
     RowBox[{"While", "[", 
      RowBox[{
       RowBox[{"status", "\[Equal]", "False"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"coltmp", "=", 
         RowBox[{
          RowBox[{"Last", "[", "path", "]"}], "\[LeftDoubleBracket]", "2", 
          "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"starrow", "=", 
         RowBox[{"Cases", "[", 
          RowBox[{"starset", ",", 
           RowBox[{"{", 
            RowBox[{"_", ",", "coltmp"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"(", 
            RowBox[{"starrow", "\[Equal]", 
             RowBox[{"{", "}"}]}], ")"}]}], ",", 
          RowBox[{"path", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"path", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"First", "[", "starrow", "]"}], 
                "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
               "coltmp"}], "}"}]}], "]"}]}], ",", 
          RowBox[{"status", "=", "True"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"rowtmp", "=", 
         RowBox[{
          RowBox[{"Last", "[", "path", "]"}], "\[LeftDoubleBracket]", "1", 
          "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"status", "\[Equal]", "False"}], ",", 
          RowBox[{"path", "=", 
           RowBox[{"Append", "[", 
            RowBox[{"path", ",", 
             RowBox[{"{", 
              RowBox[{"rowtmp", ",", 
               RowBox[{"OptimalBipartiteGraphMatching", "[", 
                RowBox[{
                "M$", ",", "rowtmp", ",", "dimC", ",", 
                 "\"\<findprimeinrow\>\""}], "]"}]}], "}"}]}], "]"}]}]}], 
         "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     
     RowBox[{"subs", "=", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"#", "\[Rule]", " ", 
           RowBox[{"OddQ", "@", 
            RowBox[{"Position", "[", 
             RowBox[{"path", ",", "#", ",", "1"}], "]"}]}]}], ")"}], "&"}], "/@",
         "path"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", "True", "}"}], "}"}], "\[Rule]", " ", "1"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", "False", "}"}], "}"}], "\[Rule]", " ", "2"}]}], 
        "}"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"M$", "=", 
         RowBox[{"ReplacePart", "[", 
          RowBox[{"M$", ",", "#"}], "]"}]}], ")"}], "&"}], "/@", "subs"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"M$", "=", 
      RowBox[{"M$", "/.", 
       RowBox[{"{", 
        RowBox[{"2", "\[Rule]", " ", "0"}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"OptimalBipartiteGraphMatching", "[", 
      RowBox[{"A", ",", "M$", ",", 
       RowBox[{"ConstantArray", "[", 
        RowBox[{"0", ",", "dimR"}], "]"}], ",", 
       RowBox[{"ConstantArray", "[", 
        RowBox[{"0", ",", "dimC"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"dimR", ",", "dimC"}], "}"}], ",", "\"\<step3\>\""}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.718011358851407*^9, 3.718011359314927*^9}, {
   3.71801145039351*^9, 3.7180114510939474`*^9}, {3.718011503143861*^9, 
   3.7180115130337906`*^9}, {3.7180117418555107`*^9, 3.718011776082214*^9}, {
   3.7180118199265714`*^9, 3.7180120137613153`*^9}, {3.718012204356895*^9, 
   3.71801231244637*^9}, {3.718012352982013*^9, 3.71801236143953*^9}, {
   3.7180124319396143`*^9, 3.7180125255790744`*^9}, {3.7180127088038282`*^9, 
   3.718012776096837*^9}, {3.718013165284031*^9, 3.7180132230649633`*^9}, {
   3.7180139746105337`*^9, 3.718014052439207*^9}, {3.7180141022988205`*^9, 
   3.71801411287729*^9}, {3.7180142226775227`*^9, 3.718014224866676*^9}, {
   3.718014347267485*^9, 3.718014350546666*^9}, {3.7180144629040227`*^9, 
   3.718014465206808*^9}, {3.71801456618579*^9, 3.7180145663362565`*^9}, {
   3.718015264307476*^9, 3.7180152683654985`*^9}, {3.718016540343004*^9, 
   3.718016560338176*^9}, 3.7180171052788353`*^9, {3.718017565960658*^9, 
   3.7180175660857067`*^9}, {3.7181884443129168`*^9, 
   3.7181884599855185`*^9}, {3.718189555345308*^9, 3.7181895713889894`*^9}, {
   3.718189610079586*^9, 3.7181896198435307`*^9}, {3.7181896565804634`*^9, 
   3.718189671243991*^9}, {3.718190156921378*^9, 3.718190171242349*^9}, {
   3.718190573152525*^9, 3.718190576411848*^9}, 3.7181906079899235`*^9, {
   3.7181906472190275`*^9, 3.7181906613999825`*^9}, {3.719574651975561*^9, 
   3.719574675561534*^9}, {3.726067733108155*^9, 3.7260677331121497`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"OptimalBipartiteGraphMatching", "[", 
   RowBox[{"M_", ",", "row_", ",", "dimC_", ",", "\"\<findprimeinrow\>\""}], 
   "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"col", ",", "ccount"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"col", "=", 
      RowBox[{"-", "1"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"For", "[", 
      RowBox[{
       RowBox[{"ccount", "=", "1"}], ",", 
       RowBox[{"ccount", "\[LessEqual]", "dimC"}], ",", 
       RowBox[{"ccount", "++"}], ",", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"M", "\[LeftDoubleBracket]", 
           RowBox[{"row", ",", "ccount"}], "\[RightDoubleBracket]"}], 
          "\[Equal]", "2"}], ",", 
         RowBox[{"col", "=", "ccount"}]}], "]"}]}], "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", "col"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.718012171359108*^9, 3.71801217802999*^9}, {
   3.7195746786771083`*^9, 3.719574683812413*^9}, 3.7260677331250935`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["step6", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7179229654752855`*^9, 3.7179229661003833`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"OptimalBipartiteGraphMatching", "[", 
   RowBox[{"A_", ",", "M_", ",", "RCover_", ",", "CCover_", ",", 
    RowBox[{"{", 
     RowBox[{"dimR_", ",", "dimC_"}], "}"}], ",", "\"\<step6\>\""}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "minval", ",", "rcount", ",", "ccount", ",", "A$", ",", "minmat"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"A$", "=", "A"}], ";", "\[IndentingNewLine]", 
     RowBox[{"minval", "=", 
      RowBox[{"Min", "[", 
       RowBox[{"A", "\[LeftDoubleBracket]", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Range", "[", "dimR", "]"}], "*", 
           RowBox[{"(", 
            RowBox[{"RCover", "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0", "\[Rule]", " ", "1"}], ",", 
               RowBox[{"1", "\[Rule]", " ", "0"}]}], "}"}]}], ")"}]}], "/.", 
          RowBox[{"{", 
           RowBox[{"0", "\[Rule]", " ", "Nothing"}], "}"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Range", "[", "dimC", "]"}], "*", 
           RowBox[{"(", 
            RowBox[{"CCover", "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"0", "\[Rule]", " ", "1"}], ",", 
               RowBox[{"1", "\[Rule]", " ", "0"}]}], "}"}]}], ")"}]}], "/.", 
          RowBox[{"{", 
           RowBox[{"0", "\[Rule]", " ", "Nothing"}], "}"}]}]}], 
        "\[RightDoubleBracket]"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"minmat", "=", 
      RowBox[{
       RowBox[{"Outer", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"#1", "+", "#2"}], "&"}], ",", "RCover", ",", "CCover"}], 
        "]"}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"0", "\[Rule]", " ", 
          RowBox[{"-", "minval"}]}], ",", 
         RowBox[{"1", "\[Rule]", " ", "0"}], ",", 
         RowBox[{"2", "\[Rule]", "minval"}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"A$", "=", 
      RowBox[{"Chop", "[", 
       RowBox[{"minmat", "+", "A$"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"OptimalBipartiteGraphMatching", "[", 
      RowBox[{"A$", ",", "M", ",", "RCover", ",", "CCover", ",", 
       RowBox[{"{", 
        RowBox[{"dimR", ",", "dimC"}], "}"}], ",", "\"\<step4\>\""}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.717922991693613*^9, 3.717923063061083*^9}, {
  3.7179238447301397`*^9, 3.7179238451563025`*^9}, {3.71792549966582*^9, 
  3.717925531057561*^9}, {3.7179256225835886`*^9, 3.7179256231826906`*^9}, {
  3.7179256767627687`*^9, 3.7179257094887314`*^9}, {3.717926028341705*^9, 
  3.7179260971810246`*^9}, {3.7180152778589287`*^9, 3.7180152816209564`*^9}, {
  3.71801752855412*^9, 3.718017528679134*^9}, {3.718185739997384*^9, 
  3.7181857796787605`*^9}, {3.7181858477026987`*^9, 3.7181858515632973`*^9}, {
  3.718187399400589*^9, 3.7181874622220106`*^9}, {3.7181879258289404`*^9, 
  3.7181879595698752`*^9}, {3.7181883788576193`*^9, 3.718188383951896*^9}, {
  3.7181903891173277`*^9, 3.7181903916488285`*^9}, {3.719574690467883*^9, 
  3.719574703176359*^9}, {3.726067733138586*^9, 3.726067733140588*^9}}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Subsubtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->
  True,ExpressionUUID->"a337be80-5099-4b81-a402-44f13de5cf03"],

Cell["\<\
End[];
EndPackage[];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 AspectRatioFixed->
  True,ExpressionUUID->"68534a7e-ab28-4437-bf6f-7bb1ca640db7"]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{808, 715},
WindowMargins->{{Automatic, 171}, {1, Automatic}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
ShowCellLabel->True,
ShowCellTags->False,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 208, 5, 69, "Subtitle",ExpressionUUID->"c84b313e-1e5b-4efc-8aac-63e358cd01f8",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[800, 31, 297, 7, 57, "Subsubtitle",ExpressionUUID->"17966ccc-b9ed-47d2-ab63-9b6f8f0d4674",
 InitializationCell->True],
Cell[1100, 40, 606, 14, 194, "Input",ExpressionUUID->"7a127078-49bb-44c9-ad9c-7fb014a4ba1c",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1743, 59, 165, 4, 41, "Subsubtitle",ExpressionUUID->"7a5a3558-9690-4e14-a517-fe4f63951c5e",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1933, 67, 148, 3, 54, "Subsection",ExpressionUUID->"5988bde4-31d7-494a-817b-3cec77250b6d",
 InitializationCell->True],
Cell[2084, 72, 253, 7, 40, "Input",ExpressionUUID->"ab4975f8-cadc-4694-ad37-0a156070dfd3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2374, 84, 145, 3, 38, "Subsection",ExpressionUUID->"32ac9548-22c8-47a5-814b-fee26f8dd5a3",
 InitializationCell->True],
Cell[2522, 89, 624, 15, 144, "Input",ExpressionUUID->"a100134c-3dd4-4c64-84e6-4a8ffcfe6b62",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[3183, 109, 139, 3, 38, "Subsection",ExpressionUUID->"02d38f78-42d7-4758-a502-a23473ddc1a4",
 InitializationCell->True],
Cell[3325, 114, 163, 6, 36, "Input",ExpressionUUID->"cfef89c0-f8fb-4607-b2fa-bff6b6aa8045",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[3525, 125, 145, 3, 38, "Subsection",ExpressionUUID->"4ec6652f-7664-4cfc-b395-697f588a2916",
 InitializationCell->True],
Cell[3673, 130, 194, 7, 53, "Input",ExpressionUUID->"28431013-ef6b-4e76-a02b-cef27c9cd4a0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[3904, 142, 214, 5, 38, "Subsection",ExpressionUUID->"23ff2fdf-217e-480d-a749-37cdd3f25731",
 InitializationCell->True],
Cell[4121, 149, 1840, 62, 85, "Input",ExpressionUUID->"52c445e3-cf89-4cbb-97d6-ba9675c1c321",
 InitializationCell->True],
Cell[5964, 213, 818, 25, 66, "Input",ExpressionUUID->"7c7e5fc4-ba51-4344-8896-b8dffb4f92c6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6819, 243, 142, 3, 38, "Subsection",ExpressionUUID->"72fe8efd-f81d-4dff-b3b8-6b5ce678efcc",
 InitializationCell->True],
Cell[6964, 248, 183, 7, 78, "Input",ExpressionUUID->"45523ef6-7f14-41d1-ac17-90552808c75f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[7184, 260, 216, 5, 38, "Subsection",ExpressionUUID->"615595ac-719f-4c4b-97e5-afb0b3d37566",
 InitializationCell->True],
Cell[7403, 267, 263, 8, 53, "Input",ExpressionUUID->"984c30e7-bbc4-467b-a815-d7ad944f470e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[7703, 280, 183, 5, 38, "Subsection",ExpressionUUID->"605f52cf-d6cc-4f33-b080-c4ce707fe892",
 InitializationCell->True],
Cell[7889, 287, 297, 9, 53, "Input",ExpressionUUID->"678c4553-79eb-46c7-afe1-43089d571c2c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8223, 301, 236, 6, 38, "Subsection",ExpressionUUID->"68b70933-62b6-4fd0-8cba-262fbb45cfee",
 InitializationCell->True],
Cell[8462, 309, 346, 10, 53, "Input",ExpressionUUID->"cfa1a3ae-c04b-4b3d-9cd5-35609e64b7b5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8845, 324, 143, 3, 38, "Subsection",ExpressionUUID->"f5f1276d-f853-420d-b22e-cfa6f4d6d5a6",
 InitializationCell->True],
Cell[8991, 329, 204, 7, 60, "Input",ExpressionUUID->"61bd3aa4-1676-4ff0-b461-bb9861b1c702",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9232, 341, 144, 3, 38, "Subsection",ExpressionUUID->"a1597a92-dfa7-4c79-932c-6bfb5a0f94d8",
 InitializationCell->True],
Cell[9379, 346, 209, 8, 60, "Input",ExpressionUUID->"1a1bebc4-9b60-45e6-adbf-1a5da3524469",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9625, 359, 144, 3, 38, "Subsection",ExpressionUUID->"ab58de80-b539-478d-9c74-e1f0bc5d98fb",
 InitializationCell->True],
Cell[9772, 364, 266, 8, 60, "Input",ExpressionUUID->"c07e6d8f-c173-42c6-9071-47428aa595ab",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10075, 377, 140, 3, 38, "Subsection",ExpressionUUID->"36a545e5-fcd7-444c-b629-2259634ba1ff",
 InitializationCell->True],
Cell[10218, 382, 184, 7, 48, "Input",ExpressionUUID->"0be3467e-dc45-406b-bf9f-0730f3413c1a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10439, 394, 141, 3, 38, "Subsection",ExpressionUUID->"75059f67-e782-43c2-be20-8b24766a4b44",
 InitializationCell->True],
Cell[10583, 399, 181, 7, 48, "Input",ExpressionUUID->"eb0888fe-9c6c-4ca1-a445-ba948d570184",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10801, 411, 192, 5, 38, "Subsection",ExpressionUUID->"61635e43-8387-4399-bf03-4b997352c6b3",
 InitializationCell->True],
Cell[10996, 418, 374, 10, 66, "Input",ExpressionUUID->"eb3b846a-e283-44b7-bf8d-53c17fee2ec1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[11407, 433, 151, 3, 38, "Subsection",ExpressionUUID->"c8748328-2e1f-4847-9577-19315f3cd6cb",
 InitializationCell->True],
Cell[11561, 438, 352, 9, 79, "Input",ExpressionUUID->"95387138-a571-491c-8f7b-b52946334bc2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[11950, 452, 283, 6, 38, "Subsection",ExpressionUUID->"a0d10cd8-a4bc-4191-9496-649b2529fbf0",
 InitializationCell->True],
Cell[12236, 460, 727, 16, 134, "Input",ExpressionUUID->"1317a610-1472-468e-b470-920445d065c9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[13000, 481, 350, 6, 38, "Subsection",ExpressionUUID->"50fcae96-e27d-4a18-b4f9-18033bdbb3ed",
 InitializationCell->True],
Cell[13353, 489, 664, 14, 89, "Input",ExpressionUUID->"4dfd75a5-716f-4975-aab4-3d84bcaa3cad",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[14054, 508, 398, 7, 38, "Subsection",ExpressionUUID->"ee6334cc-2f67-497d-b64b-0c924e12d46a",
 InitializationCell->True],
Cell[14455, 517, 647, 14, 89, "Input",ExpressionUUID->"0e2e6ebd-4ed9-494a-835e-57a6fd2fa590",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[15139, 536, 428, 7, 38, "Subsection",ExpressionUUID->"55946f6b-1ee3-483a-b98b-4067ae2af24a",
 InitializationCell->True],
Cell[15570, 545, 923, 17, 136, "Input",ExpressionUUID->"00e26637-9439-4e12-916e-1d68c906be37",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[16530, 567, 486, 8, 54, "Subsection",ExpressionUUID->"b45eb750-ea32-4883-90a2-aeb45d000587",
 InitializationCell->True],
Cell[17019, 577, 1810, 36, 370, "Input",ExpressionUUID->"02f21540-580e-4187-8d99-15cb6e66ee01",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[18878, 619, 162, 4, 41, "Subsubtitle",ExpressionUUID->"3888d19d-4be8-417d-bab5-396d3c79f5da",
 InitializationCell->True],
Cell[19043, 625, 115, 3, 46, "Input",ExpressionUUID->"21705a87-2316-4fa4-b351-d47b296794c7",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[19183, 632, 109, 3, 33, "Section",ExpressionUUID->"e5cc89cb-bd4c-4a62-a928-635752012145",
 InitializationCell->True],
Cell[19295, 637, 478, 24, 274, "Input",ExpressionUUID->"d38990e5-001b-490b-b04e-b8492badce5a",
 InitializationCell->True],
Cell[19776, 663, 171, 6, 40, "Input",ExpressionUUID->"1af18857-cc31-4735-9a79-c68f1eb4b6ae",
 InitializationCell->True],
Cell[19950, 671, 171, 6, 40, "Input",ExpressionUUID->"96faa65e-1dfe-413e-ae45-737815fd6266",
 InitializationCell->True],
Cell[20124, 679, 184, 6, 40, "Input",ExpressionUUID->"2343882b-1d23-4c82-8fc6-fed24e4336be",
 InitializationCell->True],
Cell[20311, 687, 162, 5, 27, "Input",ExpressionUUID->"60e6b83b-ce20-4a01-b129-4147b4c41e38",
 InitializationCell->True],
Cell[20476, 694, 344, 10, 43, "Input",ExpressionUUID->"c34fe26d-996e-48d7-8f5e-770d4c7bb442",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20857, 709, 103, 3, 33, "Section",ExpressionUUID->"6d6a5512-dcec-4415-a8c4-014d8f4d7ba1",
 InitializationCell->True],
Cell[20963, 714, 403, 11, 48, "Input",ExpressionUUID->"ffac90bb-9741-48b5-b180-924c6cd700d7",
 InitializationCell->True],
Cell[21369, 727, 440, 12, 48, "Input",ExpressionUUID->"0de3b2a1-670f-4a19-8cb5-6c9078255220",
 InitializationCell->True],
Cell[21812, 741, 1474, 35, 154, "Input",ExpressionUUID->"bb7c9054-211c-4a4b-97a2-f554f2e9c4f9",
 InitializationCell->True],
Cell[23289, 778, 1176, 31, 154, "Input",ExpressionUUID->"4dc957c9-21c7-425f-92e2-8d5b8689999c",
 InitializationCell->True],
Cell[24468, 811, 353, 9, 70, "Input",ExpressionUUID->"447f59ae-d905-490a-97f2-2e344bbd338f",
 InitializationCell->True],
Cell[24824, 822, 315, 8, 70, "Input",ExpressionUUID->"d97ac6ca-88bc-4b4a-abe3-eee681cdca03",
 InitializationCell->True],
Cell[25142, 832, 288, 7, 70, "Input",ExpressionUUID->"80b6de35-d6f7-494f-aec6-8b61aa5a8c4b",
 InitializationCell->True],
Cell[25433, 841, 539, 15, 31, "Input",ExpressionUUID->"f8d73074-b611-43cf-901b-86162628c56b",
 InitializationCell->True],
Cell[25975, 858, 429, 10, 28, "Input",ExpressionUUID->"d24aafd0-e1ff-429e-aaa3-589baadf3ee5",
 InitializationCell->True],
Cell[26407, 870, 407, 9, 28, "Input",ExpressionUUID->"ae6cf277-2a0c-4fd0-8b16-e6e1b9aed599",
 InitializationCell->True],
Cell[26817, 881, 315, 8, 28, "Input",ExpressionUUID->"42f60838-d9ce-4cca-b180-eea35287759d",
 InitializationCell->True],
Cell[27135, 891, 468, 13, 31, "Input",ExpressionUUID->"1a53ad96-31fc-4037-a2c4-43d0399b655e",
 InitializationCell->True],
Cell[27606, 906, 668, 18, 46, "Input",ExpressionUUID->"eb43f2a7-5503-4ac3-9801-285b4b6f9d29",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[28311, 929, 109, 3, 33, "Section",ExpressionUUID->"3e1bb7ee-bc9a-4574-821f-342f7fa76450",
 InitializationCell->True],
Cell[28423, 934, 168, 6, 40, "Input",ExpressionUUID->"b76bbc3c-c469-4a69-85c6-b052f3c5626d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[28628, 945, 150, 4, 33, "Section",ExpressionUUID->"9f52d3a1-022d-4aa4-b66c-0f1f66dc1048",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[28803, 953, 124, 2, 43, "Subsection",ExpressionUUID->"50d43fbf-660c-4cb3-889c-2f849ba3cde2",
 InitializationCell->True],
Cell[28930, 957, 334, 9, 46, "Input",ExpressionUUID->"f1ad1d33-f4f1-49f1-8f18-99210415c907",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[29301, 971, 179, 3, 35, "Subsection",ExpressionUUID->"caff4a70-b622-4096-9d98-826de191c54c",
 InitializationCell->True],
Cell[29483, 976, 1060, 17, 144, "Text",ExpressionUUID->"bb0865da-3808-4e9f-91a4-ff4e28dfad2b",
 InitializationCell->True],
Cell[30546, 995, 5041, 123, 505, "Input",ExpressionUUID->"1036d5b4-024e-4b2b-a530-f886c55d3c6b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[35624, 1123, 126, 2, 35, "Subsection",ExpressionUUID->"1339b150-ba3d-4bcf-8090-4b8d247a3d4a",
 InitializationCell->True],
Cell[35753, 1127, 417, 12, 66, "Input",ExpressionUUID->"f9718ac0-689b-49fd-8c76-29975207c80a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[36207, 1144, 125, 2, 35, "Subsection",ExpressionUUID->"deeec032-730b-4ab6-9dc7-cc285cb9b8c6",
 InitializationCell->True],
Cell[36335, 1148, 320, 8, 66, "Input",ExpressionUUID->"d541570f-b3cd-4657-893f-39f4cc0c5746",
 InitializationCell->True],
Cell[36658, 1158, 440, 9, 85, "Input",ExpressionUUID->"48246c06-e5f9-452a-bb7f-49829f4fb464",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[37147, 1173, 106, 3, 33, "Section",ExpressionUUID->"c65f97ef-e652-473c-add4-0427f9b0a68c",
 InitializationCell->True],
Cell[37256, 1178, 764, 22, 58, "Input",ExpressionUUID->"a91bbe7f-013c-45b7-b119-0a2769c2d5a3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[38057, 1205, 175, 4, 33, "Section",ExpressionUUID->"4c2971cc-3cac-4890-99a3-116025d43121",
 InitializationCell->True],
Cell[38235, 1211, 813, 22, 58, "Input",ExpressionUUID->"9d9883d9-652b-499a-814a-5657ab20b186",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[39085, 1238, 170, 4, 33, "Section",ExpressionUUID->"1c7c00f5-62a1-4a80-adbd-dd88ea19e0b1",
 InitializationCell->True],
Cell[39258, 1244, 1144, 30, 73, "Input",ExpressionUUID->"5497e118-cb1e-42ad-a24e-98fa6b8df845",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[40439, 1279, 169, 4, 33, "Section",ExpressionUUID->"a87196c4-a7cd-4ba6-8d21-4b7520935123",
 InitializationCell->True],
Cell[40611, 1285, 2106, 59, 178, "Input",ExpressionUUID->"fe268e84-fb2c-4fe7-afec-a13941b0f097",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[42754, 1349, 107, 3, 33, "Section",ExpressionUUID->"130271ed-25d2-4d50-9395-e26219a1028b",
 InitializationCell->True],
Cell[42864, 1354, 989, 27, 88, "Input",ExpressionUUID->"fa6de942-9b53-4e95-9e9b-c4910e13dba2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[43890, 1386, 108, 3, 33, "Section",ExpressionUUID->"6f55f4b5-a79d-4c77-8d42-f75bf6519e86",
 InitializationCell->True],
Cell[44001, 1391, 767, 23, 58, "Input",ExpressionUUID->"e46aae16-54de-47c0-b604-9276dd4c9ea3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[44805, 1419, 108, 3, 33, "Section",ExpressionUUID->"8c910df2-13e5-48cd-97a6-20040c32678d",
 InitializationCell->True],
Cell[44916, 1424, 1145, 32, 103, "Input",ExpressionUUID->"82b28d16-9474-49b8-8304-757b867497b2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[46098, 1461, 104, 3, 33, "Section",ExpressionUUID->"bfda4430-bf24-4588-b154-cfe7656c5988",
 InitializationCell->True],
Cell[46205, 1466, 823, 24, 73, "Input",ExpressionUUID->"4b52d769-b1b0-44ee-b6fe-3d2c0f67cabc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[47065, 1495, 105, 3, 33, "Section",ExpressionUUID->"29175fec-89b1-4564-8384-3644c199a2c3",
 InitializationCell->True],
Cell[47173, 1500, 1398, 39, 148, "Input",ExpressionUUID->"500b6c34-a074-4b52-a09c-f6e738ebff61",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[48608, 1544, 152, 4, 33, "Section",ExpressionUUID->"61e308ef-4f59-47ef-a1da-900ef263879a",
 InitializationCell->True],
Cell[48763, 1550, 345, 11, 27, "Input",ExpressionUUID->"f2688211-c694-4c57-b34b-8cf4a9399bc9",
 InitializationCell->True],
Cell[49111, 1563, 465, 14, 43, "Input",ExpressionUUID->"d06b1484-a67b-4876-82d9-972a4b92f2c1",
 InitializationCell->True],
Cell[49579, 1579, 188, 4, 27, "Input",ExpressionUUID->"e49a8442-447e-4b40-9f8a-4a6647659bfd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[49804, 1588, 115, 3, 33, "Section",ExpressionUUID->"9d2e82e9-c348-4cc7-9485-0bea4f9bc498",
 InitializationCell->True],
Cell[49922, 1593, 323, 8, 27, "Input",ExpressionUUID->"35adeba7-a3e4-4047-afe8-5d1caf5ebcdf",
 InitializationCell->True],
Cell[50248, 1603, 3490, 90, 298, "Input",ExpressionUUID->"7b600bcc-ca89-4b7d-8a2d-56ae8a7e05d7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[53775, 1698, 166, 4, 33, "Section",ExpressionUUID->"7fe6a6b9-8ed5-4e8e-9964-6cb25dbc2d12",
 InitializationCell->True],
Cell[53944, 1704, 459, 12, 43, "Input",ExpressionUUID->"83f39455-8dfd-4129-be1b-fdb311c58a3c",
 InitializationCell->True],
Cell[54406, 1718, 1953, 46, 178, "Input",ExpressionUUID->"9cf743c6-3b38-4eaf-b4e6-b54d4fe611de",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[56396, 1769, 207, 4, 33, "Section",ExpressionUUID->"29e4a452-c595-45fa-8dfd-3feb7085ca16",
 InitializationCell->True],
Cell[56606, 1775, 328, 7, 49, "Text",ExpressionUUID->"48b560ff-f3e2-48d8-b4d4-84a883605692",
 InitializationCell->True],
Cell[56937, 1784, 369, 9, 48, "Input",ExpressionUUID->"8d068681-6573-4c3b-bd03-edd23d4f16b7",
 InitializationCell->True],
Cell[57309, 1795, 391, 10, 70, "Input",ExpressionUUID->"35e08e03-1b20-4eb3-8d32-8adcc816e027",
 InitializationCell->True],
Cell[57703, 1807, 751, 15, 91, "Input",ExpressionUUID->"a553dc1d-73b9-46df-a374-8e666c73fcd7",
 InitializationCell->True],
Cell[58457, 1824, 598, 13, 70, "Input",ExpressionUUID->"a63484fa-b63a-45ce-a49f-09a822b25038",
 InitializationCell->True],
Cell[59058, 1839, 1478, 37, 112, "Input",ExpressionUUID->"0fda5ce7-631c-4cbf-bd0e-b3150cccee7c",
 InitializationCell->True],
Cell[60539, 1878, 1395, 36, 112, "Input",ExpressionUUID->"284e9e31-bd4c-4d4a-acfd-91eab600772f",
 InitializationCell->True],
Cell[61937, 1916, 2716, 67, 259, "Input",ExpressionUUID->"c08d3f9c-b3ac-4918-b5a6-24a5a7f590c3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[64690, 1988, 257, 6, 33, "Section",ExpressionUUID->"1e309448-040a-4788-ac0c-f197ca056b65",
 InitializationCell->True],
Cell[64950, 1996, 371, 8, 49, "Text",ExpressionUUID->"c33cd136-f5f1-45c2-9013-9d5e9f50364d",
 InitializationCell->True],
Cell[65324, 2006, 382, 8, 28, "Input",ExpressionUUID->"a3ec42ec-2ced-4733-8d8f-e386e049243a",
 InitializationCell->True],
Cell[65709, 2016, 387, 10, 46, "Input",ExpressionUUID->"19d895cf-f38c-4a9d-9dcf-8284201fd878",
 InitializationCell->True],
Cell[66099, 2028, 782, 15, 63, "Input",ExpressionUUID->"f66cd89d-69c4-40ee-b8c5-0fd8b73053f2",
 InitializationCell->True],
Cell[66884, 2045, 643, 14, 46, "Input",ExpressionUUID->"f791aecd-4df8-46b4-909b-c4c53be968e4",
 InitializationCell->True],
Cell[67530, 2061, 1525, 38, 114, "Input",ExpressionUUID->"e6e5ce7a-2def-4af5-a026-ab76397f85c6",
 InitializationCell->True],
Cell[69058, 2101, 754, 15, 63, "Input",ExpressionUUID->"6e5e29c9-0312-431b-b2c0-03e4407108f0",
 InitializationCell->True],
Cell[69815, 2118, 2763, 68, 233, "Input",ExpressionUUID->"1f85a8b9-5725-4f9b-a490-7523b5a0d2c3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[72615, 2191, 232, 5, 33, "Section",ExpressionUUID->"b40239b6-75aa-4307-ad01-231f92a1a373",
 InitializationCell->True],
Cell[72850, 2198, 507, 9, 68, "Text",ExpressionUUID->"225dd968-7dd8-423b-a2ca-aee90571ffb8",
 InitializationCell->True],
Cell[73360, 2209, 443, 10, 28, "Input",ExpressionUUID->"c25d5b29-0f74-42e3-b244-9b32264ac32a",
 InitializationCell->True],
Cell[73806, 2221, 890, 16, 80, "Input",ExpressionUUID->"776e7aa3-7cf7-4886-8e39-a17f48bae4bb",
 InitializationCell->True],
Cell[74699, 2239, 666, 14, 46, "Input",ExpressionUUID->"3d7f08c0-f3a5-4616-bfaa-be02d162631c",
 InitializationCell->True],
Cell[75368, 2255, 1550, 38, 97, "Input",ExpressionUUID->"8a56d37b-cd77-4662-8374-6c436851a666",
 InitializationCell->True],
Cell[76921, 2295, 1445, 37, 80, "Input",ExpressionUUID->"4872716a-cbc6-439c-89c0-6a4b17e4b630",
 InitializationCell->True],
Cell[78369, 2334, 2765, 68, 233, "Input",ExpressionUUID->"777c0ae1-4548-4a7a-b115-8bb989d4fde4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[81171, 2407, 317, 7, 33, "Section",ExpressionUUID->"811b8b6b-cd7f-4268-a9ed-303c1d9c2425",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[81513, 2418, 205, 4, 43, "Subsection",ExpressionUUID->"5bd48b0a-2752-4a1e-8d0b-8658a68cf9ab",
 InitializationCell->True,
 InitializationGroup->True],
Cell[81721, 2424, 4060, 79, 180, "Input",ExpressionUUID->"d4035ff7-b41a-490b-a2bb-a8abaefa1990",
 InitializationCell->True,
 InitializationGroup->True],
Cell[85784, 2505, 6002, 141, 465, "Input",ExpressionUUID->"b9d3d07e-523f-4ce1-848d-208e07aedbd6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[91823, 2651, 180, 4, 35, "Subsection",ExpressionUUID->"111989a6-1e69-4dba-8488-ec6549adaae2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[92006, 2657, 2755, 51, 114, "Input",ExpressionUUID->"647de8af-0aee-4f8b-bee7-be04229ea6c8",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[94798, 2713, 201, 4, 35, "Subsection",ExpressionUUID->"3b07f8e9-3878-45ee-9365-b42aa3f7195a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[95002, 2719, 2639, 60, 256, "Input",ExpressionUUID->"b4e3c7cd-9e77-4d34-9235-b233ecce3837",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[97678, 2784, 150, 3, 35, "Subsection",ExpressionUUID->"c31aecbc-1524-483d-b582-a01eb4aa09c9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[97831, 2789, 7475, 143, 577, "Input",ExpressionUUID->"c93bc35d-1777-4cf4-ac90-98b34aa5cd6d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[105309, 2934, 2151, 55, 124, "Input",ExpressionUUID->"5c007f80-6943-4e45-b174-2ed00a24cf7b",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[107497, 2994, 148, 3, 35, "Subsection",ExpressionUUID->"ee4a9b36-7c0e-4b9e-b303-d3cec4a01ba7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[107648, 2999, 5729, 132, 389, "Input",ExpressionUUID->"de41c484-16bf-4058-8bc5-a3d193bc116a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[113380, 3133, 1181, 29, 161, "Input",ExpressionUUID->"17e71dcd-0041-4223-9d73-67d0c54891d5",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[114598, 3167, 152, 3, 35, "Subsection",ExpressionUUID->"5639d1c2-a762-47d3-9f15-306c3b68f53b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[114753, 3172, 3290, 75, 209, "Input",ExpressionUUID->"4f41130f-f054-4e39-8abb-3b2de948fad1",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[118104, 3254, 161, 4, 41, "Subsubtitle",ExpressionUUID->"a337be80-5099-4b81-a402-44f13de5cf03",
 InitializationCell->True],
Cell[118268, 3260, 180, 7, 40, "Input",ExpressionUUID->"68534a7e-ab28-4437-bf6f-7bb1ca640db7",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}
]
*)

