(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     24190,        827]
NotebookOptionsPosition[     18338,        615]
NotebookOutlinePosition[     19032,        640]
CellTagsIndexPosition[     18989,        637]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["General`Miscellaneous`", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448288485512178*^9, 3.448288487611507*^9}},
 AspectRatioFixed->True],

Cell["Some simple general purpose routines", "Text",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4409362054119377`*^9, {3.4482889666096888`*^9, 3.448288980949339*^9}, 
   3.448289030822792*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<General`Miscellaneous`\>\"", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<Global`\>\"", ",", "\"\<SpinDynamica`\>\""}], "}"}]}], 
   "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409651192774447*^9, 3.409651196073245*^9}, {
  3.409651264334598*^9, 3.409651271003416*^9}, {3.409652209086062*^9, 
  3.409652214855588*^9}, {3.4482885612431307`*^9, 3.448288566815598*^9}, {
  3.564598142211006*^9, 3.5645981424439774`*^9}, {3.564598964202496*^9, 
  3.564598965928616*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["exports", "Subtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["RToD", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RToD", "::", "\"\<usage\>\""}], "=", 
   "\"\<RToD[rad] converts radians to degrees\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["DToR", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DToR", "::", "\"\<usage\>\""}], "=", 
   "\"\<DToR[deg] converts degrees to radians\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["DeclareAsReal", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.440936859670583*^9, 3.440936866707868*^9}, 
   3.448288590467355*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DeclareAsReal", "::", "\"\<usage\>\""}], "=", 
   "\"\<DeclareAsReal[x] declares x to be a real variable. \
DeclareAsReal[x,y...] declares many variables at the same time\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4409368780691433`*^9, 3.440936892829461*^9}, {
  3.440937895258524*^9, 3.440937906730548*^9}, {3.4482885917212048`*^9, 
  3.448288635517098*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["SimplifyRules", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.440936859670583*^9, 3.440936866707868*^9}, 
   3.448288590467355*^9, {3.4642549713647423`*^9, 3.464254981755418*^9}, {
   3.4642550447074842`*^9, 3.464255053803872*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SimplifyRules", "::", "usage"}], "=", 
   "\"\<SimplifyRules[a\[Rule]b,c\[Rule]d..] returns a list of options in \
which all redundant rules have been stripped out.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4642549887737627`*^9, 3.4642551029931707`*^9}, {
  3.4642554391933317`*^9, 3.4642554422922688`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ReplaceEverywhere", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.440936859670583*^9, 3.440936866707868*^9}, 
   3.448288590467355*^9, {3.4642549713647423`*^9, 3.464254981755418*^9}, {
   3.4642550447074842`*^9, 3.464255053803872*^9}, {3.533202556222485*^9, 
   3.533202560611165*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ReplaceEverywhere", "::", "usage"}], "=", 
   "\"\<ReplaceEverywhere[a, b->c..] is the same as ReplaceAll (/.) but works \
inside SparseArrays, which ReplaceAll does not.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4642549887737627`*^9, 3.4642551029931707`*^9}, {
  3.4642554391933317`*^9, 3.4642554422922688`*^9}, {3.5332025638117657`*^9, 
  3.533202624219545*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["CurrentOptionsToPassDown", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.440936859670583*^9, 3.440936866707868*^9}, 
   3.448288590467355*^9, {3.4642549713647423`*^9, 3.464254981755418*^9}, {
   3.4642550447074842`*^9, 3.464255053803872*^9}, {3.54273291834048*^9, 
   3.542732923162018*^9}, 3.542733034266386*^9, 3.5427331056018476`*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CurrentOptionsToPassDown", "::", "usage"}], "=", 
   "\"\<CurrentOptionsToPassDown[f,g] returns a list of options from function \
f that are suitable for passing down to g. This augments the FilterRules \
routine by updating any delayed options (\\\":>\\\").\>\""}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.4642549887737627`*^9, 3.4642551029931707`*^9}, {
  3.4642554391933317`*^9, 3.4642554422922688`*^9}, {3.5427329328872633`*^9, 
  3.542733017267185*^9}, {3.542733088887761*^9, 3.542733096505122*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ChopThreshold, DefaultChopThreshold", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.440936859670583*^9, 3.440936866707868*^9}, 
   3.448288590467355*^9, {3.4642549713647423`*^9, 3.464254981755418*^9}, {
   3.4642550447074842`*^9, 3.464255053803872*^9}, {3.54273291834048*^9, 
   3.542732923162018*^9}, 3.542733034266386*^9, 3.5427331056018476`*^9, {
   3.5435148174381943`*^9, 3.5435148204049873`*^9}, {3.54351551101298*^9, 
   3.543515518250139*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ChopThreshold", "::", "usage"}], "=", 
   "\"\<ChopThreshold is an option for several routines setting the threshold \
for implementations of Chop.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5435148237643414`*^9, 3.543514929462248*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefaultChopThreshold", "::", "usage"}], "=", 
   "\"\<Default value of ChopThreshold\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.543515521921115*^9, 3.543515536866641*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Validity", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.440936859670583*^9, 3.440936866707868*^9}, 
   3.448288590467355*^9, {3.4642549713647423`*^9, 3.464254981755418*^9}, {
   3.4642550447074842`*^9, 3.464255053803872*^9}, {3.54273291834048*^9, 
   3.542732923162018*^9}, 3.542733034266386*^9, 3.5427331056018476`*^9, {
   3.5435148174381943`*^9, 3.5435148204049873`*^9}, {3.54351551101298*^9, 
   3.543515518250139*^9}, {3.547530066511307*^9, 3.547530067620919*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Validity", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"Validity\",
FontSlant->\"Italic\"]\) is an option for several routines. If \!\(\*
StyleBox[\(V\*
StyleBox[\"alidity\",
FontSlant->\"Italic\"]\)]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\), the arguments have passed validity checks.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5435148237643414`*^9, 3.543514929462248*^9}, {
  3.54753007122919*^9, 3.547530105769546*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["main", "Subtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["RToD", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"RToD", ",", "Listable"}], "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RToD", "[", "rad_", "]"}], ":=", 
   RowBox[{"N", "[", 
    FractionBox[
     RowBox[{"rad", " ", "*", "180"}], "\[Pi]"], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["DToR", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"DToR", ",", "Listable"}], "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DToR", "[", "deg_", "]"}], ":=", 
   FractionBox[
    RowBox[{"deg", "*", " ", "\[Pi]"}], "180"]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409651037330494*^9, 3.409651040396517*^9}},
 AspectRatioFixed->True],

Cell["Extensions of Convert", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.409652668111833*^9, 3.4096528057843*^9, {3.44093618524859*^9, 
   3.4409361992220917`*^9}},
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["DeclareAsReal", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.448288657530002*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"DeclareAsReal", ",", "Listable"}], "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.448288674322549*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DeclareAsReal", "[", 
    RowBox[{"x_", ",", "y__"}], "]"}], ":=", 
   RowBox[{"DeclareAsReal", "[", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.409651037330494*^9, 3.409651040396517*^9}, {
  3.4482886825687103`*^9, 3.448288726300888*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DeclareAsReal", "[", "x_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Re", "[", "x", "]"}], "^=", "x"}], ";", 
     RowBox[{
      RowBox[{"Im", "[", "x", "]"}], "^=", "0"}], ";", 
     RowBox[{
      RowBox[{"Conjugate", "[", "x", "]"}], "^=", "x"}], ";", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"DeclareAsReal", "::", "dec"}], ",", "x"}], "]"}]}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4482887293421297`*^9, 3.448288759356278*^9}, {
  3.4482887918567247`*^9, 3.4482887930947104`*^9}, {3.4482896904645987`*^9, 
  3.44828972209437*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DeclareAsReal", "::", "dec"}], "=", 
   "\"\<The symbol `1` has been declared as real.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448289743227498*^9, 3.4482897811985207`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SimplifyRules", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.448288657530002*^9, 3.464255159216711*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SimplifyRules", "[", 
    RowBox[{"rules", ":", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_Rule", "|", "_RuleDelayed"}], ")"}], "..."}], ")"}]}], 
    "]"}], ":=", 
   RowBox[{"Sequence", "@@", 
    RowBox[{"First", "/@", 
     RowBox[{"GatherBy", "[", 
      RowBox[{
       RowBox[{"{", "rules", "}"}], ",", "First"}], "]"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4642551642918987`*^9, 3.464255220879669*^9}, {
  3.4642553524811974`*^9, 3.464255354037271*^9}, {3.4642554085695972`*^9, 
  3.46425541468734*^9}, {3.5067756555736847`*^9, 3.506775697935026*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SimplifyRules", "[", 
    RowBox[{"{", 
     RowBox[{"rules", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_Rule", "|", "_RuleDelayed"}], ")"}], "..."}], ")"}]}], 
     "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"SimplifyRules", "[", "rules", "]"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4642554512383213`*^9, 3.464255475969902*^9}, 
   3.506775683245035*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["CurrentOptionsToPassDown", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.448288657530002*^9, 3.464255159216711*^9, 
  3.542733041228483*^9, 3.5427331083515368`*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CurrentOptionsToPassDown", "[", 
    RowBox[{"f_", ",", "g_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FilterRules", "[", 
     RowBox[{
      RowBox[{"Options", "[", "f", "]"}], ",", 
      RowBox[{"Options", "[", "g", "]"}]}], "]"}], "/.", 
    RowBox[{
     RowBox[{"RuleDelayed", "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], ":>", 
     RowBox[{"Rule", "[", 
      RowBox[{"x", ",", "y"}], "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4642551642918987`*^9, 3.464255220879669*^9}, {
  3.4642553524811974`*^9, 3.464255354037271*^9}, {3.4642554085695972`*^9, 
  3.46425541468734*^9}, {3.5067756555736847`*^9, 3.506775697935026*^9}, {
  3.542733045209766*^9, 3.5427330641712227`*^9}, {3.5427331108693857`*^9, 
  3.542733126946015*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ReplaceEverywhere", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.448288657530002*^9, 3.464255159216711*^9, 
  3.533202637191145*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ReplaceEverywhere", "[", 
    RowBox[{"a_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"ReplaceEverywhere", "[", 
    RowBox[{"a", ",", 
     RowBox[{"{", "opts", "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4642551642918987`*^9, 3.464255220879669*^9}, {
  3.4642553524811974`*^9, 3.464255354037271*^9}, {3.4642554085695972`*^9, 
  3.46425541468734*^9}, {3.5067756555736847`*^9, 3.506775697935026*^9}, {
  3.533202639056829*^9, 3.53320266062803*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ReplaceEverywhere", "[", 
    RowBox[{"a_", ",", 
     RowBox[{"rules", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_Rule", "|", "_RuleDelayed"}], ")"}], "..."}], "}"}]}]}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"a", "/.", "rules"}], "/.", 
    RowBox[{"(", 
     RowBox[{"sa_SparseArray", "\[RuleDelayed]", 
      RowBox[{"SparseArray", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"ArrayRules", "[", "sa", "]"}], "/.", "rules"}], ",", 
        RowBox[{"Dimensions", "[", "sa", "]"}]}], "]"}]}], ")"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4642551642918987`*^9, 3.464255220879669*^9}, {
  3.4642553524811974`*^9, 3.464255354037271*^9}, {3.4642554085695972`*^9, 
  3.46425541468734*^9}, {3.5067756555736847`*^9, 3.506775697935026*^9}, {
  3.533202639056829*^9, 3.533202733917327*^9}, {3.533211756580923*^9, 
  3.533211776937154*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ChopThreshold, DefaultChopThreshold", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.448288657530002*^9, 3.464255159216711*^9, 
  3.533202637191145*^9, 3.543515552678534*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefaultChopThreshold", "=", 
   RowBox[{"10", "^", 
    RowBox[{"-", "10"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.543515555677578*^9, 3.543515559809657*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Subtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{692, 708},
WindowMargins->{{299, Automatic}, {Automatic, 0}},
ShowCellLabel->True,
ShowCellTags->False,
FrontEndVersion->"11.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (July 28, \
2016)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 231, 6, 92, "Title",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[801, 30, 299, 8, 30, "Text",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1103, 40, 642, 15, 48, "Input",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1770, 59, 153, 5, 67, "Subtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1948, 68, 152, 5, 44, "Subsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[2103, 75, 260, 8, 27, "Input",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2400, 88, 152, 5, 36, "Subsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[2555, 95, 260, 8, 27, "Input",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[2852, 108, 253, 7, 36, "Subsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[3108, 117, 518, 13, 73, "Input",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[3663, 135, 353, 8, 36, "Subsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[4019, 145, 386, 8, 58, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[4442, 158, 407, 9, 36, "Subsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[4852, 169, 443, 9, 58, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[5332, 183, 459, 9, 36, "Subsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[5794, 194, 579, 11, 88, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6410, 210, 573, 11, 36, "Subsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[6986, 223, 314, 7, 58, "Input",
 InitializationCell->True],
Cell[7303, 232, 249, 6, 27, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[7589, 243, 592, 11, 36, "Subsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[8184, 256, 567, 16, 91, "Input",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[8800, 278, 150, 5, 67, "Subtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[8953, 285, 197, 6, 27, "Input",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[9175, 295, 153, 5, 28, "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[9331, 302, 223, 7, 27, "Input",
 InitializationCell->True,
 InitializationGroup->True],
Cell[9557, 311, 299, 10, 47, "Input",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9893, 326, 153, 5, 28, "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[10049, 333, 223, 7, 27, "Input",
 InitializationCell->True,
 InitializationGroup->True],
Cell[10275, 342, 334, 10, 47, "Input",
 InitializationCell->True,
 InitializationGroup->True],
Cell[10612, 354, 282, 8, 26, "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10931, 367, 204, 6, 28, "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[11138, 375, 274, 8, 27, "Input",
 InitializationCell->True,
 InitializationGroup->True],
Cell[11415, 385, 451, 13, 27, "Input",
 InitializationCell->True,
 InitializationGroup->True],
Cell[11869, 400, 702, 20, 43, "Input",
 InitializationCell->True,
 InitializationGroup->True],
Cell[12574, 422, 253, 6, 43, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[12864, 433, 226, 6, 28, "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[13093, 441, 675, 19, 44, "Input",
 InitializationCell->True],
Cell[13771, 462, 487, 15, 29, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[14295, 482, 286, 7, 28, "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[14584, 491, 817, 20, 43, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[15438, 516, 255, 7, 28, "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[15696, 525, 540, 12, 27, "Input",
 InitializationCell->True],
Cell[16239, 539, 970, 26, 59, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[17246, 570, 295, 7, 28, "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[17544, 579, 225, 6, 27, "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[17818, 591, 149, 5, 67, "Subtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[17970, 598, 174, 6, 48, "Input",
 InitializationCell->True,
 InitializationGroup->True],
Cell[18147, 606, 163, 5, 48, "Input",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]]
}, Open  ]]
}
]
*)

