(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    368375,      10176]
NotebookOptionsPosition[    294152,       8559]
NotebookOutlinePosition[    294825,       8583]
CellTagsIndexPosition[    294782,       8580]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["QM`Hilbert`", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.682593577765571*^9, {3.6825938406739693`*^9, 3.6825938408792667`*^9}, 
   3.682596590313637*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"62281054-fef9-4cfe-9522-59664e1ed568"],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9, 3.683109016913093*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"8e6fa999-345c-4591-b206-08fc80d80f5d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<QM`Hilbert`\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Global`\>\"", ",", "\[IndentingNewLine]", "\"\<SpinDynamica`\>\"", 
      ",", "\[IndentingNewLine]", "\"\<General`UserLevel`\>\"", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"\"\<General`ModifyBuiltIn`\>\"", ","}], "*)"}], 
      "\[IndentingNewLine]", "\"\<General`Matrices`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<General`Miscellaneous`\>\""}], 
     "\[IndentingNewLine]", "}"}]}], "\n", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.745396946517459*^9, 
  3.745396985931005*^9}},ExpressionUUID->"3a3103db-1ce2-40c5-b968-\
6bd0db40df15"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exports", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"09376711-def3-4766-b8ac-eca59bab4ab1"],

Cell[CellGroupData[{

Cell["spin systems", "Section",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.682596691217362*^9, 
   3.682596695008479*^9}},ExpressionUUID->"9dac0249-d574-4d8c-a45d-\
cdce0efb99f1"],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"f272bfab-bcef-48a6-a9f2-0882745ce9e1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "::", "usage"}], "=", 
   "\"\<SpinSystem[] provides the setting for the current spin system.\>\""}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470250809519997`*^9, 3.5470250971988*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SetSpinSystem", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"03f3aa24-7f55-478e-bab5-b99e5247d6c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetSpinSystem", "::", "usage"}], "=", 
   "\"\<\!\(\*StyleBox[\"SetSpinSystem\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"[\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"{\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"j\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"Ij\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"{\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"k\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"Ik\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"..\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"]\",FontSlant->\"Italic\"]\) sets a spin system with labels \
\!\(\*StyleBox[\"j\",FontSlant->\"Italic\"]\) and \
\!\(\*StyleBox[\"k\",FontSlant->\"Italic\"]\) and spin quantum numbers \
\!\(\*StyleBox[\"Ij\",FontSlant->\"Italic\"]\) and \
\!\(\*StyleBox[\"Ik\",FontSlant->\"Italic\"]\). For example, \
\!\(\*StyleBox[\"SetSpinSystem\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"[\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"1\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"1\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"/\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"2\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"{\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"2\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"1\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"}\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"]\",FontSlant->\"Italic\"]\) defines \
two spins, with labels 1 and 2 and spin quantum numbers 1/2 and 1 \
respectively. Shortcuts are available, for example: \
S\!\(\*StyleBox[\"etSpinSystem\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"[\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"3\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"]\",FontSlant->\"Italic\"]\) sets up a set of 3 spins-1/2 with \
default labels 1, 2 and 3.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438873111535149*^9, 3.438873248583531*^9}, {
  3.6825939584855547`*^9, 
  3.682593972689973*^9}},ExpressionUUID->"b3b25869-658c-49fb-be72-\
cdd18246aae6"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinQuantumNumber", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"af4f0b1f-19a2-4ac2-bda2-30a5dadcf3ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinQuantumNumber", "::", "usage"}], " ", "=", "\"\<\!\(\*
StyleBox[\"SpinQuantumNumber\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"label\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)determines the angular momentum quantum number of the \
spin with the given \!\(\*
StyleBox[\"label\",
FontSlant->\"Italic\"]\), in the current spin system.\>\""}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.5470253678117743`*^9, 3.547025377782058*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ValidSpinQ", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456163307931814*^9, 3.456163309680984*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"53598af3-1095-40ae-b4e5-d20643fce2fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidSpinQ", "::", "usage"}], " ", "=", " ", "\"\<\!\(\*
StyleBox[\"ValidSpinQ\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"label\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) returns \!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\) if the spin label is valid for the current spin \
system.\n\!\(\*
StyleBox[\"ValidSpinQ\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"label1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"label2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) returns \!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\) if all spin labels are valid.\n\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470253852711678`*^9, 3.5470253923271027`*^9}, {
  3.6811104637106237`*^9, 3.6811105118819723`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinsOrderedQ", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456163307931814*^9, 3.456163309680984*^9}, {
  3.46755582023454*^9, 3.467555823465253*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"9827d57b-20a3-4e12-ab27-b45fb2a93080"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinsOrderedQ", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"SpinsOrderedQ\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"label1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"label2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) determines whether the spin labels are ordered, \
according to the current \!\(\*
StyleBox[\"SpinSystem\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470253993679323`*^9, 3.54702541587711*^9}, {
  3.547025912001553*^9, 3.547025913711926*^9}, {3.682594011411623*^9, 
  3.682594011578066*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["general basis operations", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"889c079e-460e-4f7d-abfc-cb4df54f6f9c"],

Cell[CellGroupData[{

Cell["Basis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Basis", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"Basis\",
FontSlant->\"Italic\"]\) is an option for \!\(\*
StyleBox[\"MatrixRepresentation\",
FontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"VectorRepresentation\",
FontSlant->\"Italic\"]\), specifying the Hilbert-space basis for these \
representations\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547024664103837*^9, 3.547024702374998*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisLabels", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486386306202651*^9, 3.486386308457654*^9}, {
  3.4863866143423157`*^9, 3.486386614963355*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisLabels", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"BasisLabels\",
FontSlant->\"Italic\"]\) is an option for the Hilbert space bases. If \!\(\*
StyleBox[\"BasisLabels\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Automatic\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)(default), the Kets and Bras may be referred to using \
integers running from 1 to the basis dimension. The option \!\(\*
StyleBox[\"BasisLabels\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"a\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"b\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"c\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\) allows the integers or strings \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"a\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"b\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"c\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\) to be used to refer to the Kets and Bras. The \
operation \!\(\*
StyleBox[\"BasisLabels\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) may also be used to obtain the set of state labels \
defined for a particular basis.\>\""}], ";"}], "   "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4863863135328617`*^9, 3.486386452254155*^9}, {
  3.486386618171278*^9, 3.486386671012261*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisDimension", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4388523178700323`*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisDimension", "::", "usage"}], " ", "=", " ", "\"\<\!\(\*
StyleBox[\"BasisDimension\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)returns the dimension of a basis. Example: \!\(\*
StyleBox[\"BasisDimension\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"ZeemanBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\). \!\(\*
StyleBox[\"BasisDimension\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) refers to the current basis.\>\""}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.5470254253113422`*^9, 3.5470254343542547`*^9}, {
  3.682594085121269*^9, 3.6825940884632893`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["DefineBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388524571721783`*^9, 3.438852465651808*^9}, 
   3.4483571957211647`*^9, {3.683189603033992*^9, 3.6831896121894083`*^9}, 
   3.68318965988424*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineBasis", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"DefineBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"newbasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"ket1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"ket2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"opts\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) defines a state basis which may be used for operator \
matrix representations. The option \!\(\*
StyleBox[\"CheckBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\) may be used to check its suitability. \nThe syntax \
\!\(\*
StyleBox[\"DefineBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"newbasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"existingbasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\), where basis is the name of an already defined \
basis, sets the basis kets of \!\(\*
StyleBox[\"newbasis\",
FontSlant->\"Italic\"]\) to be equal to the basis kets of \!\(\*
StyleBox[\"existingbasis\",
FontSlant->\"Italic\"]\).\n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438852469414063*^9, 3.43885250300457*^9}, {
   3.473172448897842*^9, 3.473172451434535*^9}, 3.547024928259735*^9, {
   3.561355398347836*^9, 3.5613554162341423`*^9}, {3.6749909461327677`*^9, 
   3.674991007906126*^9}, 3.6749910413802977`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["DefinedBasisQ", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388524571721783`*^9, 3.438852465651808*^9}, 
   3.4483571957211647`*^9, {3.683189603033992*^9, 3.6831896121894083`*^9}, 
   3.683189649195649*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedBasisQ", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"DefinedBasisQ\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) returns \!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\) if \!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\) has been defined as a Hilbert basis.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683189558256678*^9, 3.683189608854768*^9}, {
  3.683189651642703*^9, 3.683189655489723*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["UndefineBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438852521076331*^9, 3.438852532612158*^9}, 
   3.448357198118917*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UndefineBasis", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"UndefineBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) removes the definitions for \!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\) so that the same symbol may be used for a different \
basis, if desired. \>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388525259727983`*^9, 3.438852539515896*^9}, 
   3.473172472476625*^9, 3.547025677861869*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["CheckBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438852552980576*^9, 3.4388525571975117`*^9}, 
   3.448357200958729*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"CheckBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) checks a state basis for orthogonality and \
normalization\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438852573057229*^9, 3.438852581515723*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SetBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetBasis", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"SetBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) sets the state basis of Hilbert space.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483570997181797`*^9, 3.448357147088831*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisKets", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisKets", "::", "usage"}], " ", "=", " ", "\"\<\!\(\*
StyleBox[\"BasisKets\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) returns a list of kets for the specified \
basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470254433608294`*^9, 3.5470254508166857`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisBras", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisBras", "::", "usage"}], " ", "=", " ", "\"\<\!\(\*
StyleBox[\"BasisBras\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) returns a list of bras for the specified \
basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547025457143488*^9, 3.5470254653314257`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisTransformationMatrix", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.429871849689171*^9, {3.439427868111414*^9, 3.439427877573254*^9}, 
   3.486386289810934*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "::", "usage"}], "=", 
   "\[IndentingNewLine]", "\"\<\!\(\*
StyleBox[\"BasisTransformationMatrix\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) is the matrix that transforms the kets of \!\(\*
StyleBox[\"basis1\",
FontSlant->\"Italic\"]\) into the kets of \!\(\*
StyleBox[\"basis2\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429683398117825*^9, 3.429683483589595*^9}, 
   3.429683518165381*^9, {3.429809497054675*^9, 3.429809543990481*^9}, {
   3.429871868857893*^9, 3.429871893075202*^9}, {3.429872033658004*^9, 
   3.429872035487479*^9}, {3.429872143058139*^9, 3.4298721704471617`*^9}, {
   3.439427884064005*^9, 3.439427910528206*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["bases", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.502016044168977*^9},ExpressionUUID->"65de7e1f-c642-4352-805f-\
459b858e3672"],

Cell[CellGroupData[{

Cell["predefined bases", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.502016049543847*^9, 3.5020160508158293`*^9}}],

Cell[CellGroupData[{

Cell["ZeemanBasis", "Subsubsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ZeemanBasis", "::", "usage"}], " ", "=", " ", "\"\<\!\(\*
StyleBox[\"ZeemanBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"/\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"/\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"3\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) defines a Zeeman product basis for spins with \
indices 1, 2 and 3 and spins 1/2, 1/2, 1 respectively. The list of spins must \
be ordered. \!\(\*
StyleBox[\"ZeemanBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)defines a Zeeman product basis for the current spin \
system.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547025474335778*^9, 3.5470254876691837`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SingletTripletBasis", "Subsubsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletBasis", "::", "usage"}], " ", "=", " ", "\"\<\!\(\*
StyleBox[\"SingletTripletBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) defines a singlet-triplet basis for spins with \
indices 1 and 2. This is currently available only for 2-spin-1/2 \
systems.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.54702549531077*^9, 3.5470255035126123`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["TransformedBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.42968234673812*^9, 3.429682350151795*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformedBasis", "::", "usage"}], " ", "=", "\"\<\!\(\*
StyleBox[\"TransformedBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) defines a basis in which the kets are composed by \
applying the operator \!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\) to the kets of \!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\). \!\(\*
StyleBox[\"TransformedBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) generates a transformation of the current \
basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470255141898823`*^9, 3.5470255216753683`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Eigenbasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.42968234673812*^9, 3.429682350151795*^9}, {
  3.502016119081449*^9, 3.502016122695365*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Eigenbasis", "::", "usage"}], " ", "=", " ", "\"\<\!\(\*
StyleBox[\"Eigenbasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) defines a basis of eigenkets for the operator \!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547025529277066*^9, 3.547025539852783*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ProductBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.42968234673812*^9, 3.429682350151795*^9}, {
  3.502016119081449*^9, 3.502016122695365*^9}, {3.623913665335273*^9, 
  3.6239136683253403`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductBasis", "::", "usage"}], " ", "=", " ", "\"\<\!\(\*
StyleBox[\"ProductBasis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) defines a basis of product kets constructed from the \
kets of the argument bases. The kets of the product basis is ordered so that \
the kets of \!\(\*
StyleBox[\"basis1\",
FontSlant->\"Italic\"]\) form the innermost loop.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547025529277066*^9, 3.547025539852783*^9}, {
  3.623913671463773*^9, 3.623913743165023*^9}, {3.6239174617585773`*^9, 
  3.623917494042832*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["kets and bras", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.589974179721093*^9, 
  3.5899741824071827`*^9}},ExpressionUUID->"d1071941-e66a-498f-8b0f-\
ff13e24d6810"],

Cell[CellGroupData[{

Cell["Ket", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<Ket[specification,spinsystem] defines a Ket in the specified \
spinsystem.\nIf spinsystem is omitted, the current SpinSystem[] is used. \
Otherwise, spinsystem has the syntax {{j,Ij},{k,Ik}..} where {j,k..} are spin \
labels and {Ij,Ik..} are spin quantum numbers. \nspecification may be:\n* a \
single symbol, which indicates a state label in the current Basis[]. For \
example, if the default ZeemanBasis[] is used, the value of specification may \
be an integer {1,2..}, numbering the kets in the current basis;\n* a string \
of the form \\\"\[Alpha]\[Alpha]..\[Beta]\\\" indicating magnetic quantum \
numbers \[PlusMinus]1/2, in the case of spins-1/2;\n* a list of the form \
{{j,Mj},{k,Mk}..} where {j,k..} are spin labels and {Mj,Mk..} are magnetic \
quantum numbers. The spin labels must correspond to those specified in the \
spinsystem argument.\n\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.674285083180787*^9, 3.67428556185474*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["KetQ", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}, {
  3.448347634351637*^9, 3.448347634812874*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KetQ", "::", "usage"}], "=", 
   "\"\<determines whether an expression has the form of a ket state\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291333690934*^9, 3.448291357780293*^9}, {
  3.448347658322262*^9, 3.4483476668491297`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Bra", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<Bra[specification,spinsystem] defines a Bra in the specified \
spinsystem.\nIf spinsystem is omitted, the current SpinSystem[] is used. \
Otherwise, spinsystem has the syntax {{j,Ij},{k,Ik}..} where {j,k..} are spin \
labels and {Ij,Ik..} are spin quantum numbers. \nspecification may be:\n* a \
single symbol, which indicates a state label in the current Basis[]. For \
example, if the default ZeemanBasis[] is used, the value of specification may \
be an integer {1,2..}, numbering the bras in the current basis;\n* a string \
of the form \\\"\[Alpha]\[Alpha]..\[Beta]\\\" indicating magnetic quantum \
numbers \[PlusMinus]1/2, in the case of spins-1/2;\n* a list of the form \
{{j,Mj},{k,Mk}..} where {j,k..} are spin labels and {Mj,Mk..} are magnetic \
quantum numbers. The spin labels must correspond to those specified in the \
spinsystem argument.\n\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.674285083180787*^9, 3.6742856002279797`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BraQ", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}, {
  3.448347634351637*^9, 3.448347634812874*^9}, {3.4483476747349358`*^9, 
  3.448347675220845*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BraQ", "::", "usage"}], "=", 
   "\"\<determines whether an expression has the form of a ket state\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291333690934*^9, 3.448291357780293*^9}, {
  3.448347658322262*^9, 3.4483476782076807`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ProductKet", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.5902341249735622`*^9, {3.623912559778561*^9, 3.623912561751794*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductKet", "::", "usage"}], "=", 
   "\"\<ProductKet[ket1, ket2, ...] returns the direct product of the \
argument kets. Each of the argument kets must involve a different set of \
spins. If possible, the spins in the output ket are arranged according to \
their order in the current SpinSystem[]. \>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291333690934*^9, 3.448291357780293*^9}, {
  3.448347658322262*^9, 3.4483476782076807`*^9}, {3.589974193838787*^9, 
  3.589974251459923*^9}, {3.589975389354529*^9, 3.5899755660428*^9}, {
  3.590234064779139*^9, 3.590234106864098*^9}, {3.623912575807365*^9, 
  3.623912641109812*^9}, {3.625928185760757*^9, 3.625928216135645*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ProductBra", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.5902341249735622`*^9, {3.623912559778561*^9, 3.623912561751794*^9}, {
   3.623912804520379*^9, 3.62391280496524*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductBra", "::", "usage"}], "=", 
   "\"\<ProductBra[bra1, bra2, ...] returns the direct product of the \
argument bras. Each of the argument bras must involve a different set of \
spins. If possible, the spins in the output bra are arranged according to \
their order in the current SpinSystem[].\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291333690934*^9, 3.448291357780293*^9}, {
  3.448347658322262*^9, 3.4483476782076807`*^9}, {3.589974193838787*^9, 
  3.589974251459923*^9}, {3.589975389354529*^9, 3.5899755660428*^9}, {
  3.590234064779139*^9, 3.590234106864098*^9}, {3.623912575807365*^9, 
  3.623912641109812*^9}, {3.6239128081623983`*^9, 3.623912822974349*^9}, {
  3.6259282266280107`*^9, 3.625928241520032*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["MagneticQuantumNumber", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{3.5902341249735622`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "::", "usage"}], "=", 
   "\"\<MagneticQuantumNumber[ket,spins] returns the magnetic quantum number \
(M-value) for the specified set of spins. If spins is omitted, all spins are \
taken. \nThe syntax MagneticQuantumNumber[ket,{spins1, spins2..}] returns the \
sets of magnetic quantum numbers for each specified set of spins, and returns \
a list of the results.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291333690934*^9, 3.448291357780293*^9}, {
   3.448347658322262*^9, 3.4483476782076807`*^9}, {3.589974193838787*^9, 
   3.589974251459923*^9}, {3.589975389354529*^9, 3.5899755660428*^9}, {
   3.590234064779139*^9, 3.590234106864098*^9}, {3.630581339912466*^9, 
   3.63058134098391*^9}, 3.674285690848422*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["VectorRepresentation", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.682597676003251*^9, 
   3.6825976805832787`*^9}},ExpressionUUID->"c8560aa5-778e-451e-81d0-\
c36f0627a8ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VectorRepresentation", "::", "usage"}], " ", "=", "\"\<\!\(\*
StyleBox[\(V\*
StyleBox[\"ectorRepresentation\",
FontSlant->\"Italic\"]\)]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"state\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) provides the vector representation for a state in a \
given basis. The output is a \!\(\*
StyleBox[\"SparseArray\",
FontSlant->\"Italic\"]\) and may be viewed by applying \!\(\*
StyleBox[\"MatrixForm\",
FontSlant->\"Italic\"]\) or \!\(\*
StyleBox[\"MatrixPlot\",
FontSlant->\"Italic\"]\). The current basis is used if \!\(\*
StyleBox[\"basis\",
FontSlant->\"Italic\"]\) is omitted.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547025588867415*^9, 3.547025598201891*^9}, {
  3.682594227567628*^9, 3.6825942741206512`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["start", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"026d6511-ed0a-445e-8c15-a04baf983a5f"],

Cell["Begin[\"`Private`\"];", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["spin system operations", "Subsubtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"49a988ab-695f-49c0-aa9d-366c7d7f4c19"],

Cell[CellGroupData[{

Cell["SpinSystem", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"5d1e5cc0-9c71-4350-aa68-0c9c3327386c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SpinSystem", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"SpinSystem", "\[Rule]", "Undefined"}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448355239917651*^9, 3.4483552410841427`*^9}, {
   3.448355325117587*^9, 3.4483553260194902`*^9}, 
   3.5470251523440657`*^9},ExpressionUUID->"966176fd-acc9-4555-a3f8-\
08c5bd9edae0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{
    RowBox[{"SpinSystem", "/.", 
     RowBox[{"{", "opts", "}"}]}], "/.", 
    RowBox[{"Options", "[", "SpinSystem", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456162275161253*^9, 
  3.45616229059741*^9}},ExpressionUUID->"4df412d3-45cc-4103-b20d-\
c41cad102da0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SpinSystem", "[", 
     RowBox[{"Plus", "[", 
      RowBox[{"a_", ",", "b__"}], "]"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "spinsystems", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"spinsystems", "=", 
        RowBox[{"SpinSystem", "/@", 
         RowBox[{"{", 
          RowBox[{"a", ",", "b"}], "}"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"spinsystems", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"spinsystem_", "?", "MatrixQ"}], ".."}], "}"}]}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"First", "@", "spinsystems"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"SpinSystem", "::", "inconsist"}], "]"}], ";", 
           "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502067517629562*^9, 3.502067569175872*^9}, {
  3.502067635407127*^9, 3.502067637976651*^9}, {3.502067696202178*^9, 
  3.502067709216003*^9}, {3.5020677500119667`*^9, 3.502067937102977*^9}, {
  3.50206799955958*^9, 3.5020680098862047`*^9}, {3.5020680804671707`*^9, 
  3.5020680821360903`*^9}},ExpressionUUID->"9c0e57d7-f09d-4f0c-a67f-\
5ed0383f4c02"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SpinSystem", "[", 
     RowBox[{"Times", "[", 
      RowBox[{
       RowBox[{"___", "?", "NumericQ"}], ",", "a_", ",", 
       RowBox[{"___", "?", "NumericQ"}]}], "]"}], "]"}]}], ":=", 
   RowBox[{"SpinSystem", "[", "a", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502067517629562*^9, 3.502067569175872*^9}, {
  3.502067635407127*^9, 3.502067637976651*^9}, {3.502068035261837*^9, 
  3.502068039235791*^9}},ExpressionUUID->"cecf1919-1044-4c9d-a257-\
286ebb92e89f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", 
    RowBox[{"basis_", "?", "DefinedBasisQ"}], "]"}], ":=", 
   RowBox[{"First", "[", "basis", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531931372600628*^9, 
  3.531931410225419*^9}},ExpressionUUID->"76083e2f-dd9f-44bf-86a8-\
da18fd62f2e3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "::", "notready"}], "=", 
   "\"\<The spin system must be set by using SetSpinSystem or \
SetBasis.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433526587886537*^9, 3.433526689110347*^9}, 
   3.43893714308392*^9, {3.448355717402543*^9, 3.448355755926491*^9}, {
   3.4606485110793953`*^9, 
   3.460648518980689*^9}},ExpressionUUID->"80861a63-45ff-4566-8a09-\
ceb90442f32a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SpinSystem", "::", "invspin"}], "=", 
    "\"\<spin index `1` is not in current spin system. Use SetSpinSystem or \
SetBasis to set up spin system.\>\""}], ";"}], " "}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.502068015102234*^9, 3.502068165975911*^9, {3.530465437171726*^9, 
   3.53046543866648*^9}},ExpressionUUID->"0a082ed7-1e58-441a-b861-\
e7d384b48481"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "::", "inconsist"}], "=", 
   "\"\<the spin systems are inconsistent.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502068106175138*^9, 3.502068118390267*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SetSpinSystem", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetSpinSystem", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.6831310258354063`*^9, 3.6831310419298067`*^9}, 
   3.683131079226157*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetSpinSystem", "[", "nspin_Integer", "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"SetSpinSystem", "[", 
   RowBox[{"Range", "[", 
    RowBox[{"1", ",", "nspin"}], "]"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetSpinSystem", "[", 
   RowBox[{"labels", ":", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"SetSpinSystem", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"#", ",", 
       RowBox[{"1", "/", "2"}]}], "}"}], "&"}], "/@", "labels"}], 
   "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438939848443688*^9, 3.438939866241064*^9}, {
  3.7136989659851246`*^9, 3.713698978536298*^9}, {3.7136990098533897`*^9, 
  3.713699016354633*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetSpinSystem", "[", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"Ij", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], "}"}], "}"}], "]"}], ":=", 
   RowBox[{"SetSpinSystem", "[", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"1", ",", "Ij"}], "}"}], "}"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.640696940961191*^9, 3.640696991985265*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetSpinSystem", "[", 
    RowBox[{"Ijvals", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "_", "}"}], ".."}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "n", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "Ijvals", "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"SetSpinSystem", "[", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{"1", ",", "n"}], "]"}], ",", 
           RowBox[{"Flatten", "@", "Ijvals"}]}], "}"}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6406972255940323`*^9, 3.640697257926276*^9}, {
   3.6406972968217077`*^9, 3.6406973413848667`*^9}, 3.652866231815321*^9, {
   3.7136990283739443`*^9, 3.7136990306722746`*^9}, {3.713699089503971*^9, 
   3.713699089647211*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetSpinSystem", "[", 
    RowBox[{"Ij", ":", 
     RowBox[{"Rational", "[", 
      RowBox[{"_", ",", "2"}], "]"}]}], "]"}], ":=", 
   RowBox[{"SetSpinSystem", "[", 
    RowBox[{"{", 
     RowBox[{"{", "Ij", "}"}], "}"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.64069702217802*^9, 3.6406970507022533`*^9}, {
  3.640697086280675*^9, 3.6406971485939693`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetSpinSystem", "[", 
     RowBox[{"spinsys_", "?", "MatrixQ"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"Sort", "[", 
       RowBox[{"First", "/@", "spinsys"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"___", ",", "lab_", ",", "lab_", ",", "___"}], "}"}]}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SetSpinSystem", "::", "dupspins"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.652866298778428*^9, 3.6528664158603163`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetSpinSystem", "[", 
    RowBox[{"spinsys_", "?", "MatrixQ"}], "]"}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prevspinsys", ",", "prevbasis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"prevspinsys", "=", 
        RowBox[{"SpinSystem", "[", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"prevbasis", "=", 
        RowBox[{"Basis", "[", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"SetOptions", "[", 
        RowBox[{"SpinSystem", ",", 
         RowBox[{"SpinSystem", "->", "spinsys"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"SetSpinSystem", "::", "set"}], ",", "spinsys"}], "]"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{
            RowBox[{"Basis", "[", "]"}], ",", "Undefined"}], "]"}], "||", 
          RowBox[{"!", 
           RowBox[{"MatchQ", "[", 
            RowBox[{"prevspinsys", ",", "spinsys"}], "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SetBasis", "[", 
          RowBox[{"ZeemanBasis", "[", "spinsys", "]"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438938168611176*^9, 3.438938232164309*^9}, {
   3.438938265020599*^9, 3.438938289048616*^9}, 3.438939538514349*^9, 
   3.438939622586421*^9, 3.4483534887190742`*^9, {3.448353647290016*^9, 
   3.448353651919012*^9}, {3.448353693852518*^9, 3.4483537122365723`*^9}, {
   3.448353751844482*^9, 3.448353780780786*^9}, {3.451396941794655*^9, 
   3.451396944231148*^9}, {3.456162692176491*^9, 3.4561626945187473`*^9}, {
   3.456206027040824*^9, 3.456206072925954*^9}, {3.456212500468904*^9, 
   3.4562126554030724`*^9}, 3.547025229129086*^9, {3.68034189791733*^9, 
   3.680341959252433*^9}, {3.680342601415901*^9, 3.680342634558296*^9}, {
   3.7136987755834208`*^9, 3.7136988301455307`*^9}, {3.7136988645533657`*^9, 
   3.713698864752775*^9}, {3.7136989136355333`*^9, 3.713698942432656*^9}, {
   3.7136990999139104`*^9, 3.7136991147337265`*^9}, {3.71369915813361*^9, 
   3.7136991900097*^9}, {3.7136992235351686`*^9, 3.7136992640460415`*^9}, 
   3.7136993384523177`*^9, {3.71370000870863*^9, 3.713700019668805*^9}, {
   3.713700283517004*^9, 3.713700284455838*^9}, {3.713700332031884*^9, 
   3.7137003321663356`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetSpinSystem", "::", "set"}], "=", 
   "\"\<the spin system has been set to `1`\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetSpinSystem", "::", "noord"}], "=", 
   "\"\<the spin system labels must be ordered.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.652866423838768*^9, 3.652866429803694*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"SetSpinSystem", "::", "dupspins"}], "=", 
  "\"\<the spin labels must all be different.\>\""}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.65286643827949*^9, 3.6528664671060266`*^9}}],

Cell[BoxData["\<\"the spin labels must all be different.\"\>"], "Output",
 InitializationCell->True,
 CellChangeTimes->{
  3.653577804692181*^9, 3.653577837575597*^9, {3.657727334159046*^9, 
   3.65772734827246*^9}, {3.67402457186032*^9, 3.674024582891182*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinQuantumNumber", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinQuantumNumber", "[", "i_", "]"}], ":=", 
   RowBox[{"SpinQuantumNumber", "[", 
    RowBox[{"i", ",", 
     RowBox[{"SpinSystem", "[", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4561624844893084`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinQuantumNumber", "[", 
    RowBox[{"i_", ",", "Undefined"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.448355790030466*^9, 3.456164467690854*^9, 
  3.547025159571191*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinQuantumNumber", "[", 
    RowBox[{"i_", ",", 
     RowBox[{"spins_", "?", "MatrixQ"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"SpinSystem", "::", "invspin"}], ",", " ", "i"}], "]"}], ";", 
      "$Failed"}], ")"}], "/;", 
    RowBox[{"!", 
     RowBox[{"ValidSpinQ", "[", 
      RowBox[{"i", ",", "spins"}], "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456163471889215*^9, 3.4561634802692347`*^9}, 
   3.456163776320569*^9, 3.456164468641548*^9, {3.503104713915086*^9, 
   3.503104715896152*^9}, {3.530465445406776*^9, 3.530465445915316*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SpinQuantumNumber", "[", 
   RowBox[{"i_", ",", 
    RowBox[{"spins_", "?", "MatrixQ"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Cases", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "_"}], "}"}]}], "]"}], "\[LeftDoubleBracket]", 
   RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.45616351958663*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["ValidSpinQ", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.456590147668189*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidSpinQ", "[", 
    RowBox[{
    "\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<-x\>\"", "|", "\"\<-y\>\""}], 
    "]"}], "=", "False"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.616677275776037*^9, 3.6166772914276648`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidSpinQ", "[", "i_", "]"}], ":=", 
   RowBox[{"ValidSpinQ", "[", 
    RowBox[{"i", ",", 
     RowBox[{"SpinSystem", "[", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4561624844893084`*^9, {3.456163353210182*^9, 3.456163360930299*^9}, {
   3.6811105303101683`*^9, 3.6811105405920067`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidSpinQ", "[", 
    RowBox[{"i_", ",", "Undefined"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.448355790030466*^9, 3.456163367755082*^9, 3.456164470057225*^9, {
   3.456590152519681*^9, 3.4565901555798893`*^9}, {3.5021623193139553`*^9, 
   3.502162321599489*^9}, 3.547025163522018*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidSpinQ", "[", 
    RowBox[{
     RowBox[{"i", ":", 
      RowBox[{"Except", "[", "_List", "]"}]}], ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"ValidSpinQ", "[", 
     RowBox[{"i", ",", "spinsys"}], "]"}], "=", 
    RowBox[{"MemberQ", "[", 
     RowBox[{
      RowBox[{"First", "/@", "spinsys"}], ",", "i"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4561634095169277`*^9, 3.456163429523982*^9}, {
  3.616676927302614*^9, 3.6166769484461937`*^9}, {3.681110549538163*^9, 
  3.681110553124742*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ValidSpinQ", "[", 
    RowBox[{"labels_List", ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}]}], "]"}], ":=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"ValidSpinQ", "[", 
        RowBox[{"#", ",", "spinsys"}], "]"}], "&"}], "/@", "labels"}], 
     ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4561634095169277`*^9, 3.456163429523982*^9}, {
  3.616676927302614*^9, 3.6166769484461937`*^9}, {3.681110549538163*^9, 
  3.68111058946278*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinsOrderedQ", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.456590147668189*^9, {3.46755589007862*^9, 3.467555893709231*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinsOrderedQ", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Repeated", "[", "label_", "]"}], "}"}], ",", "___"}], "]"}], 
   "=", "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4561624844893084`*^9, {3.456163353210182*^9, 3.456163360930299*^9}, {
   3.467555897914514*^9, 3.46755589920195*^9}, {3.467555983924624*^9, 
   3.467556000573872*^9}, {3.467556836368823*^9, 3.467556842942815*^9}, {
   3.616674604915217*^9, 3.616674637351616*^9}, {3.620983755396783*^9, 
   3.620983786299951*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinsOrderedQ", "[", "labels_List", "]"}], ":=", 
   RowBox[{"SpinsOrderedQ", "[", 
    RowBox[{"labels", ",", 
     RowBox[{"SpinSystem", "[", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4561624844893084`*^9, {3.456163353210182*^9, 3.456163360930299*^9}, {
   3.467555897914514*^9, 3.46755589920195*^9}, {3.467555983924624*^9, 
   3.467556000573872*^9}, {3.467556836368823*^9, 3.467556842942815*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinsOrderedQ", "[", 
    RowBox[{"labels_List", ",", "Undefined"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.448355790030466*^9, 3.456163367755082*^9, 3.456164470057225*^9, {
   3.456590152519681*^9, 3.4565901555798893`*^9}, {3.4675559024828176`*^9, 
   3.467555915713087*^9}, 3.467556007934987*^9, 3.467556851369927*^9, 
   3.547025167201701*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinsOrderedQ", "[", 
    RowBox[{"labels_List", ",", 
     RowBox[{"spins_", "?", "MatrixQ"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"SpinsOrderedQ", "[", 
     RowBox[{"labels", ",", "spins"}], "]"}], "=", 
    RowBox[{"SpinsOrderedQ", "[", 
     RowBox[{"labels", ",", 
      RowBox[{"First", "/@", "spins"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4561634095169277`*^9, 3.456163429523982*^9}, {
  3.46755592088459*^9, 3.4675559502505903`*^9}, {3.467556011480369*^9, 
  3.467556016976684*^9}, {3.467556856826675*^9, 3.4675568618102703`*^9}, {
  3.616677083157188*^9, 3.616677092460011*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinsOrderedQ", "[", 
    RowBox[{"labels_List", ",", 
     RowBox[{"spinsyslabels", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], "..."}], "}"}]}]}], "]"}], ":=", 
   RowBox[{"OrderedQ", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Position", "[", 
       RowBox[{"spinsyslabels", ",", "#"}], "]"}], "&"}], "/@", "labels"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4561634095169277`*^9, 3.456163429523982*^9}, {
  3.46755592088459*^9, 3.467555969851157*^9}, {3.46755602252882*^9, 
  3.467556115957777*^9}, {3.4675568934790087`*^9, 3.467556965579*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["bases and basis operations", "Subsubtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.502070527186632*^9, 
  3.502070528848119*^9}},ExpressionUUID->"1054dfa7-786e-46b9-a200-\
e7a1e199da62"],

Cell[CellGroupData[{

Cell["General basis operations", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[CellGroupData[{

Cell["Basis", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Basis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Basis", "\[Rule]", "Undefined"}], ",", 
     RowBox[{"BasisLabels", "\[Rule]", "Automatic"}]}], "}"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448353538025895*^9, 3.448353539232689*^9}, {
   3.4863879169944363`*^9, 3.4863879257948217`*^9}, 3.547025232531987*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BasisUndefined", ":=", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"Basis", "/.", 
      RowBox[{"Options", "[", "Basis", "]"}]}], ",", "Undefined"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.618475450555242*^9, 3.6184754785117807`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Basis", "[", "opts___Rule", "]"}], ":=", 
  RowBox[{
   RowBox[{"Basis", "/.", 
    RowBox[{"{", "opts", "}"}]}], "/.", 
   RowBox[{"Options", "[", "Basis", "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.456162794822988*^9, 3.456162816869891*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Basis", "::", "unknown"}], "=", 
   "\"\<State basis is undefined.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433526524792596*^9, 3.433526570684641*^9}, {
  3.4335267173847313`*^9, 3.433526742654161*^9}, {3.44835359230692*^9, 
  3.448353600961087*^9}, {3.448353874907015*^9, 3.448353887265395*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Basis", "::", "default"}], "=", 
   "\"\<Changing to default Zeeman basis..\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433526524792596*^9, 3.433526570684641*^9}, {
  3.4335267173847313`*^9, 3.433526742654161*^9}, {3.44835359230692*^9, 
  3.448353600961087*^9}, {3.448353874907015*^9, 3.448353887265395*^9}, {
  3.448353953526429*^9, 3.448354001223502*^9}, {3.448354070055814*^9, 
  3.44835409288188*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Basis", "::", "notON"}], "=", 
   "\"\<basis functions are not orthonormal.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],

Cell[CellGroupData[{

Cell["CheckBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853403708282*^9, 3.438853408390069*^9}, 
   3.4388549071203003`*^9, 3.439287640177064*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "[", 
    RowBox[{"Basis", "\[Rule]", "basis_List"}], "]"}], ":=", 
   RowBox[{"CheckBasis", "[", "basis", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853484277184*^9, 3.438853516729755*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{"CheckBasis", "[", 
    RowBox[{
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430895773079342*^9, 3.4308957972363787`*^9}, {
   3.4388535614301777`*^9, 3.4388535692429867`*^9}, 3.4561628669057617`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CheckBasis", "[", 
     RowBox[{
      RowBox[{"basis", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"CheckedBasisQ", "[", "basis", "]"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CheckBasis", "::", "alreadychkd"}], "]"}], ";", "True"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502071727258346*^9, 3.502071789707267*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CheckBasis", "[", 
     RowBox[{
      RowBox[{"basis", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Length", "[", 
      RowBox[{"BasisLabels", "[", "basis", "]"}], "]"}], "\[NotEqual]", 
     RowBox[{"Length", "[", 
      RowBox[{"BasisKets", "[", "basis", "]"}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"CheckBasis", "::", "inapplabels"}], "]"}], ";", "False"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486388470492908*^9, 3.486388576530945*^9}, {
  3.48638862431253*^9, 3.486388624933261*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "[", 
    RowBox[{
     RowBox[{"basis", ":", 
      RowBox[{"Except", "[", "_List", "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CheckBasis", "[", 
    RowBox[{
     RowBox[{"BasisKets", "[", "basis", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4392877655844727`*^9, 3.4392878140907383`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "[", 
    RowBox[{"basiskets_List", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CheckBasis", "[", 
    RowBox[{"basiskets", ",", 
     RowBox[{"Adjoint", "/@", "basiskets"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439287678184429*^9, 3.439287723227458*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "[", 
    RowBox[{"basiskets_List", ",", "basisbras_List", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vecs", ",", "mat", ",", "topleft"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vecs", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"VectorRepresentation", "[", 
           RowBox[{"#", ",", 
            RowBox[{"ZeemanBasis", "[", 
             RowBox[{"SpinSystem", "[", "]"}], "]"}]}], "]"}], "&"}], "/@", 
         "basiskets"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "basiskets", "]"}], "\[NotEqual]", 
          RowBox[{"(", 
           RowBox[{"Times", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"2", "*", 
                  RowBox[{"SpinQuantumNumber", "[", "#", "]"}]}], "+", "1"}], 
                ")"}], "&"}], "/@", 
              RowBox[{"(", 
               RowBox[{"First", "/@", 
                RowBox[{"SpinSystem", "[", "]"}]}], ")"}]}], ")"}]}], ")"}]}],
          ",", "\[IndentingNewLine]", 
         RowBox[{"Message", "[", 
          RowBox[{"CheckBasis", "::", "incomplete"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"mat", "=", 
        RowBox[{"Chop", "@", 
         RowBox[{"N", "@", 
          RowBox[{"Outer", "[", 
           RowBox[{"Dot", ",", 
            RowBox[{"Conjugate", "[", "vecs", "]"}], ",", "vecs", ",", "1"}], 
           "]"}]}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"topleft", "=", 
        RowBox[{"mat", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"OrthonormalQ", "[", "mat", "]"}], ",", 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"CheckBasis", "::", "orthonormal"}], "]"}], ";", "True"}],
           ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"DiagonalQ", "[", "mat", "]"}], "&&", 
          RowBox[{"(", 
           RowBox[{"And", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"#", "==", "topleft"}], ")"}], "&"}], "/@", 
              RowBox[{"Diagonal", "[", "mat", "]"}]}], ")"}]}], ")"}]}], ",", 
         "    ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"CheckBasis", "::", "orthogonalsamenorm"}], ",", 
             "topleft"}], "]"}], ";", "False"}], ")"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"DiagonalQ", "[", "mat", "]"}], ",", "\[IndentingNewLine]", 
         "\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"CheckBasis", "::", "orthogonaldiffnorm"}], ",", 
             RowBox[{"Diagonal", "[", "mat", "]"}]}], "]"}], ";", "False"}], 
          ")"}], ",", "\[IndentingNewLine]", "True", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"CheckBasis", "::", "notorthogonal"}], "]"}], ";", 
           "False"}], ")"}]}], "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430567581108365*^9, 3.430567588815233*^9}, {
   3.430567660266232*^9, 3.430567713048575*^9}, {3.434516920456045*^9, 
   3.434516921318618*^9}, {3.438853575498447*^9, 3.438853647011606*^9}, {
   3.438853726078535*^9, 3.4388537715880957`*^9}, {3.438855154639895*^9, 
   3.438855167283934*^9}, {3.438855306880831*^9, 3.438855310852129*^9}, {
   3.439287736377761*^9, 3.43928774855005*^9}, {3.4392878264427156`*^9, 
   3.439287829230424*^9}, {3.439287885807123*^9, 3.439287888139593*^9}, 
   3.456162343710332*^9, 3.502074160612706*^9, {3.505019570342911*^9, 
   3.505019572508398*^9}, {3.640513419661263*^9, 3.640513421261835*^9}, {
   3.7187995608313727`*^9, 3.718799590840201*^9}, {3.7187996242472706`*^9, 
   3.718799632516*^9}}],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5010430768785763`*^9, 3.50104307806927*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "::", "orthonormal"}], "=", 
   "\"\<State basis is orthonormal.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853426647867*^9, 3.438853430187441*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "::", "orthogonalsamenorm"}], "=", 
   "\"\<State basis is orthogonal but not orthonormal. All kets have the same \
norm =`1`.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853685806014*^9, 3.438853697794941*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "::", "orthogonaldiffnorm"}], "=", 
   "\"\<State basis is orthogonal but not orthonormal. The operators have \
different norms: `1`\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388536873103*^9, 3.438853711246471*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "::", "notorthogonal"}], "=", 
   "\"\<Operator basis is not orthogonal.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4388536896462812`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "::", "incomplete"}], "=", 
   "\"\<There are not enough kets for the specified spin system. Matrix \
representations may be unreliable.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853447052013*^9, 3.4388534654522533`*^9}, {
  3.4392878498188877`*^9, 3.439287857758835*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "::", "inapplabels"}], "=", 
   "\"\<The set of state labels is inappropriate for the given basis. The \
number of labels might be incorrect.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853447052013*^9, 3.4388534654522533`*^9}, {
  3.4392878498188877`*^9, 3.439287857758835*^9}, {3.486388410770298*^9, 
  3.486388442681184*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckBasis", "::", "alreadychkd"}], "=", 
   "\"\<no need to check this predefined basis\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502071807907291*^9, 3.502071817075061*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CheckedBasisQ", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388527785807457`*^9, 3.438852780778096*^9}, {
   3.438853162062491*^9, 3.438853168194075*^9}, 3.438854379436735*^9, 
   3.438854801078199*^9, 3.438854897397311*^9, 3.439287649244726*^9, {
   3.502071633047389*^9, 3.5020716354619226`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckedBasisQ", "[", 
    RowBox[{
     RowBox[{"ZeemanBasis", "[", "___", "]"}], "|", 
     RowBox[{"SingletTripletBasis", "[", "___", "]"}]}], "]"}], ":=", 
   "True"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502072145684132*^9, 3.5020721523709517`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckedBasisQ", "[", 
    RowBox[{"basis", ":", 
     RowBox[{"Except", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", "___", "]"}], "|", 
       RowBox[{"SingletTripletBasis", "[", "___", "]"}]}], "]"}]}], "]"}], ":=",
    "False"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853110014647*^9, 3.438853112083522*^9}, {
  3.5010411380696297`*^9, 3.501041148685639*^9}, {3.501041248049582*^9, 
  3.501041264416102*^9}, {3.502015914530384*^9, 3.5020159427709827`*^9}, {
  3.5020716399484653`*^9, 3.502071676648374*^9}, {3.5020721205084753`*^9, 
  3.502072122850396*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["DefineBasis", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388527785807457`*^9, 3.438852780778096*^9}, {
   3.438853162062491*^9, 3.438853168194075*^9}, {3.4388548887196712`*^9, 
   3.4388548916823893`*^9}, 3.43928760754463*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefineBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"CheckBasis", "->", "True"}], ",", " ", 
     RowBox[{"BasisLabels", "\[Rule]", "Automatic"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438852807089439*^9, 3.438852810765882*^9}, {
  3.4863865017769814`*^9, 3.486386507799055*^9}, {3.4863867084054947`*^9, 
  3.486386708978726*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineBasis", "[", 
    RowBox[{"basis_", ",", 
     RowBox[{"existingbasis_", "?", "DefinedBasisQ"}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"DefineBasis", "[", 
    RowBox[{"basis", ",", 
     RowBox[{"BasisKets", "[", "existingbasis", "]"}], ",", "opts"}], "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6749910980203447`*^9, 3.674991137564011*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefineBasis", "[", 
     RowBox[{"basis_", ",", "existingbasis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{"existingbasis", ",", 
       RowBox[{"Except", "[", "_List", "]"}]}], "]"}], "&&", 
     RowBox[{"!", 
      RowBox[{"DefinedBasisQ", "[", "existingbasis", "]"}]}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"DefineBasis", "::", "undefbasis"}], ",", "basis", ",", 
       "existingbasis"}], "]"}], ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.674991160650182*^9, 3.674991233316341*^9}, {
  3.674991297284833*^9, 3.6749912979127693`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefineBasis", "[", 
     RowBox[{"basis_", ",", "kets_List", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"BasisLabels", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "DefineBasis", "]"}]}], ",", "Automatic"}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"DefineBasis", "[", 
    RowBox[{"basis", ",", "kets", ",", 
     RowBox[{"BasisLabels", "->", 
      RowBox[{"Range", "[", 
       RowBox[{"1", ",", 
        RowBox[{"Length", "[", "kets", "]"}]}], "]"}]}], ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4863868708781*^9, 3.486386961220276*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefineBasis", "[", 
     RowBox[{"basis_", ",", "kets_List", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Length", "[", 
      RowBox[{
       RowBox[{"BasisLabels", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "DefineBasis", "]"}]}], "]"}], "\[NotEqual]", 
     RowBox[{"Length", "[", "kets", "]"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"DefineBasis", "::", "inapplabels"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4863869902939653`*^9, 3.4863870424797773`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefineBasis", "[", 
     RowBox[{"basis_", ",", "kets_List", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"DefinedBasisQ", "[", "basis", "]"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"DefineBasis", "::", "alreadydef"}], ",", "basis"}], "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"UndefineBasis", "[", "basis", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"DefineBasis", "[", 
      RowBox[{"basis", ",", "kets", ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.657299289247642*^9, 3.6572993540339746`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineBasis", "[", 
    RowBox[{"basis_", ",", "kets_List", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"check", ",", "basislabels"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"check", "=", 
        RowBox[{
         RowBox[{"CheckBasis", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "DefineBasis", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"basislabels", "=", 
        RowBox[{
         RowBox[{"BasisLabels", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "DefineBasis", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisKets", "[", "basis", "]"}], "=", "kets"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisBras", "[", "basis", "]"}], "=", 
        RowBox[{"Adjoint", "/@", "kets"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisDimension", "[", "basis", "]"}], "=", 
        RowBox[{"Length", "[", "kets", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisLabels", "[", "basis", "]"}], "=", "basislabels"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"check", "&&", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"CheckedBasisQ", "[", "basis", "]"}], "||", 
            RowBox[{"CheckBasis", "[", "basis", "]"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefineBasis", "::", "defined"}], ",", "basis"}], "]"}], 
           ";", "\[IndentingNewLine]", "\t", 
           RowBox[{
            RowBox[{"DefinedBasisQ", "[", "basis", "]"}], "=", "True"}], ";", 
           "\[IndentingNewLine]", "\t", 
           RowBox[{
            RowBox[{"CheckedBasisQ", "[", "basis", "]"}], "=", "True"}], ";", 
           "\[IndentingNewLine]", "\t", 
           RowBox[{
            RowBox[{"SpinSystem", "[", "basis", "]"}], "^=", 
            RowBox[{"SpinSystem", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
          "\t", ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{"check", "&&", 
          RowBox[{"!", 
           RowBox[{"CheckedBasisQ", "[", "basis", "]"}]}], "&&", 
          RowBox[{"!", 
           RowBox[{"CheckBasis", "[", "basis", "]"}]}]}], ",", 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefineBasis", "::", "notdefined"}], ",", "basis"}], 
            "]"}], ";", "\[IndentingNewLine]", "\t", 
           RowBox[{"UndefineBasis", "[", "basis", "]"}], ";", 
           "\[IndentingNewLine]", "\t", 
           RowBox[{
            RowBox[{"DefinedBasisQ", "[", "basis", "]"}], "=", "False"}], ";",
            "\[IndentingNewLine]", "\t", "$Failed"}], "\[IndentingNewLine]", 
          "\t", ")"}], ",", "\[IndentingNewLine]", "True", ",", 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefineBasis", "::", "nocheck"}], ",", "basis"}], "]"}], 
           ";", "\[IndentingNewLine]", "\t", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefineBasis", "::", "defined"}], ",", "basis"}], "]"}], 
           ";", "\[IndentingNewLine]", "\t", 
           RowBox[{
            RowBox[{"DefinedBasisQ", "[", "basis", "]"}], "=", "True"}], ";", 
           "\[IndentingNewLine]", "\t", 
           RowBox[{
            RowBox[{"CheckedBasisQ", "[", "basis", "]"}], "=", "False"}], ";", 
           RowBox[{
            RowBox[{"SpinSystem", "[", "basis", "]"}], "^=", 
            RowBox[{"SpinSystem", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
          "\t", ")"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.43885283050099*^9, 3.4388528821828737`*^9}, {
   3.4388530399474373`*^9, 3.438853075966858*^9}, {3.4388720778121853`*^9, 
   3.438872120191215*^9}, {3.438872154704297*^9, 3.4388722214945507`*^9}, {
   3.438872257942667*^9, 3.43887237301164*^9}, {3.4388724760022306`*^9, 
   3.438872535335445*^9}, {3.438872585212392*^9, 3.4388725862125483`*^9}, {
   3.4388726864714003`*^9, 3.4388727791425257`*^9}, {3.438872836850781*^9, 
   3.438872844950885*^9}, {3.438873986946745*^9, 3.43887403542763*^9}, {
   3.438874111921815*^9, 3.438874123229286*^9}, 3.45616447377005*^9, {
   3.4825714678877087`*^9, 3.482571481788485*^9}, {3.486386715069599*^9, 
   3.486386846438259*^9}, {3.486387097983469*^9, 3.486387153144472*^9}, {
   3.48638722454939*^9, 3.486387235565549*^9}, {3.5020718725442333`*^9, 
   3.502071879990118*^9}, {3.502071993941366*^9, 3.502072000347377*^9}, {
   3.657299104255012*^9, 3.657299111905864*^9}, {3.657299175400619*^9, 
   3.657299217315008*^9}, {3.657299435600018*^9, 3.6572994933478413`*^9}, {
   3.6572995634074497`*^9, 3.657299868644848*^9}, {3.657299914337508*^9, 
   3.657299992683178*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineBasis", "::", "defined"}], "=", 
   "\"\<The state basis `1` has been defined. To use this basis, execute \
SetBasis[`1`].\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388531171513653`*^9, 3.438853120315407*^9}, 
   3.4388543682095757`*^9, 3.438854416341448*^9, {3.4388729477392397`*^9, 
   3.438872970934195*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineBasis", "::", "notdefined"}], "=", 
   "\"\<The state basis `1` is defective and has not been defined.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388531171513653`*^9, 3.438853120315407*^9}, 
   3.4388543682095757`*^9, 3.438854416341448*^9, {3.43887223130092*^9, 
   3.438872240749669*^9}, {3.438872273122801*^9, 3.43887227435468*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineBasis", "::", "nocheck"}], "=", 
   "\"\<The basis `1` has not been checked for completeness and \
orthonormality.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853128175951*^9, 3.4388531431723013`*^9}, {
  3.438872304811009*^9, 3.438872307075637*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineBasis", "::", "inapplabels"}], "=", 
   "\"\<The value of BasisLabels is inappropriate.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4863870524563828`*^9, 3.4863870863721046`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineBasis", "::", "alreadydef"}], "=", 
   "\"\<The basis `1` is already defined. It is now being redefined.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.65729936785036*^9, 3.65729939379109*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineBasis", "::", "undefbasis"}], "=", 
   "\"\<The basis `2` does not exist. The new basis `1` has not been defined.\
\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.674991248907948*^9, 3.6749912879452047`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["DefinedBasisQ", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388527785807457`*^9, 3.438852780778096*^9}, {
   3.438853162062491*^9, 3.438853168194075*^9}, 3.438854379436735*^9, 
   3.438854801078199*^9, 3.438854897397311*^9, 3.439287649244726*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedBasisQ", "[", 
    RowBox[{"Except", "[", 
     RowBox[{
     "_ZeemanBasis", "|", "_SingletTripletBasis", "|", "_Eigenbasis", "|", 
      "_TransformedBasis", "|", "_ProductBasis"}], "]"}], "]"}], ":=", 
   "False"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853110014647*^9, 3.438853112083522*^9}, {
  3.5010411380696297`*^9, 3.501041148685639*^9}, {3.501041248049582*^9, 
  3.501041264416102*^9}, {3.502015914530384*^9, 3.5020159427709827`*^9}, {
  3.623923240302607*^9, 3.623923296549242*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["UndefineBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388532058284903`*^9, 3.438853209765585*^9}, 
   3.438854899245728*^9, 3.439287646412785*^9},
 AspectRatioFixed->True],

Cell["\<\
includes clearing of any BasisTransformationMatrix settings that include this \
basis.\
\>", "Text",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4394344493670177`*^9, 3.439434470028729*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UndefineBasis", "[", "basis_", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "btmdefs", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"BasisKets", "[", "basis", "]"}], "=."}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisBras", "[", "basis", "]"}], "=."}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisDimension", "[", "basis", "]"}], "=."}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisLabels", "[", "basis", "]"}], "=."}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"btmdefs", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"DownValues", "[", "BasisTransformationMatrix", "]"}], ",", 
          
          RowBox[{
           RowBox[{"FreeQ", "[", 
            RowBox[{"#", ",", "basis"}], "]"}], "&"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Clear", "[", "BasisTransformationMatrix", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DownValues", "[", "BasisTransformationMatrix", "]"}], "=", 
        "btmdefs"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DefinedBasisQ", "[", "basis", "]"}], "=", "False"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CheckedBasisQ", "[", "basis", "]"}], "=", "False"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ClearAll", "[", "basis", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"UndefineBasis", "::", "undefined"}], ",", "basis"}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"DefinedBasisQ", "[", 
           RowBox[{"Basis", "[", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"UndefineBasis", "::", "reset"}], "]"}], ";", 
           RowBox[{"SetBasis", "[", 
            RowBox[{"ZeemanBasis", "[", "]"}], "]"}]}], ")"}]}], 
        "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853221686697*^9, 3.4388532548768263`*^9}, {
   3.438874076779736*^9, 3.4388740898868847`*^9}, {3.439434360579378*^9, 
   3.439434440081942*^9}, 3.439434482421692*^9, {3.439435733869897*^9, 
   3.439435752817718*^9}, {3.4394357990494328`*^9, 3.439435881853661*^9}, {
   3.4394359497080307`*^9, 3.439435959153882*^9}, 3.456162868892796*^9, {
   3.4863871759094553`*^9, 3.4863871920958433`*^9}, {3.502073091923975*^9, 
   3.5020730969600983`*^9}, {3.547019854912477*^9, 3.5470198600835943`*^9}, {
   3.547019947057235*^9, 3.547019968427332*^9}, 3.5470200361391*^9, {
   3.547020248296769*^9, 3.547020259424371*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UndefineBasis", "::", "undefined"}], "=", 
   "\"\<The state basis `1` has been undefined, and associated basis \
transformation matrices removed.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853275163869*^9, 3.438853278243451*^9}, {
  3.439434649053713*^9, 3.439434653318637*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UndefineBasis", "::", "reset"}], "=", 
   "\"\<resetting current basis to Zeeman basis..\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439435894655632*^9, 3.439435905925852*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SetBasis", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853352456051*^9, 3.438853355402343*^9}, {
   3.4388538267578087`*^9, 3.438853829281473*^9}, 3.438854901077818*^9, 
   3.438871661369275*^9, {3.438941684064148*^9, 3.438941689314937*^9}, 
   3.439287642924676*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SetBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"CheckBasis", "\[Rule]", "True"}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853855565796*^9, 3.4388538621951437`*^9}, {
   3.438938881754055*^9, 3.438938888181924*^9}, {3.438938987248849*^9, 
   3.4389390168300962`*^9}, {3.448356167466611*^9, 3.4483561774307756`*^9}, 
   3.448356976646196*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetBasis", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.6831310258354063`*^9, 3.6831310419298067`*^9}, 
   3.683131100767377*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetBasis", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{"SetBasis", "[", 
    RowBox[{
     RowBox[{"ZeemanBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.451396702475831*^9, 3.451396736354693*^9}, {
  3.456203549895397*^9, 3.456203550198102*^9}, {3.50207292727118*^9, 
  3.502072927647705*^9}, {3.7137003903866725`*^9, 3.713700398746521*^9}, {
  3.7259997886123524`*^9, 3.725999792988575*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetBasis", "[", 
    RowBox[{
     RowBox[{"_", "[", 
      RowBox[{"Undefined", ",", "___"}], "]"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SetBasis", "::", "spinsysunk"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438938562702832*^9, 3.438938614080345*^9}, {
   3.4389390809222603`*^9, 3.4389391128622828`*^9}, 3.456164480687593*^9, {
   3.45620392702597*^9, 3.4562039337142487`*^9}, 3.456203973172719*^9, 
   3.5470251723487873`*^9, {3.6184755409061127`*^9, 3.618475541975315*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetBasis", "[", 
     RowBox[{"basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"DefinedBasisQ", "[", "basis", "]"}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"SetBasis", "::", "undefined"}], ",", "basis"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388540102517567`*^9, 3.438854021331098*^9}, {
   3.438939171359144*^9, 3.438939177225296*^9}, 3.45616448155906*^9, {
   3.50104173363*^9, 3.501041737843272*^9}, {3.501041864164021*^9, 
   3.5010418675851307`*^9}, {3.5010419757394333`*^9, 3.501042012649906*^9}, {
   3.501042260633236*^9, 3.501042263854265*^9}, {3.517848639360969*^9, 
   3.517848640896689*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetBasis", "[", 
     RowBox[{"basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"Basis", "[", "]"}], ",", "basis"}], "]"}]}], ":=", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"SetBasis", "::", "alreadyset"}], ",", "basis"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.61847236899547*^9, 3.6184724243053617`*^9}, {
   3.62058078027844*^9, 3.620580795291716*^9}, 3.620581320105637*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetBasis", "[", 
     RowBox[{
      RowBox[{"basisname_", "[", 
       RowBox[{
        RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "basisopts___Rule"}], 
       "]"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"!", 
      RowBox[{"TrueQ", "[", 
       RowBox[{"spinsys", "\[Equal]", 
        RowBox[{"SpinSystem", "[", "]"}]}], "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "basis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"basis", "=", 
        RowBox[{"basisname", "[", 
         RowBox[{"spinsys", ",", "basisopts"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetOptions", "[", 
        RowBox[{"SpinSystem", ",", 
         RowBox[{"SpinSystem", "\[Rule]", "spinsys"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{
            RowBox[{"Basis", "[", "]"}], ",", "basis"}], "]"}]}], ",", 
         RowBox[{"SetBasis", "[", 
          RowBox[{"basis", ",", "opts"}], "]"}]}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4389384684309607`*^9, 3.438938497044159*^9}, {
   3.4389386952167397`*^9, 3.438938749348257*^9}, {3.4389390563027353`*^9, 
   3.438939095598721*^9}, {3.43894000325774*^9, 3.4389400469656353`*^9}, {
   3.438940587240964*^9, 3.4389405974938917`*^9}, {3.438940751946364*^9, 
   3.438940754710593*^9}, {3.438940884781701*^9, 3.438940893896954*^9}, {
   3.438940939923792*^9, 3.438940943313365*^9}, {3.438940990182252*^9, 
   3.438941046158743*^9}, 3.438941110170247*^9, {3.438941437764842*^9, 
   3.438941446599493*^9}, {3.456203689417553*^9, 3.456203730440482*^9}, 
   3.456203824338887*^9, {3.456204229722039*^9, 3.456204249296723*^9}, {
   3.5010419522614517`*^9, 3.5010419653381042`*^9}, 3.501042328649622*^9, 
   3.517848542495039*^9, {3.517848720252516*^9, 3.517848813969523*^9}, {
   3.517848906676436*^9, 3.517848907777544*^9}, {3.7136993536025486`*^9, 
   3.7136993555430355`*^9}, {3.7136994999421816`*^9, 3.713699529757569*^9}, {
   3.7136995807806635`*^9, 3.7136996468510222`*^9}, {3.713699708830161*^9, 
   3.7136997451960506`*^9}, {3.7136997848417435`*^9, 
   3.7136997904299836`*^9}, {3.7136998530897803`*^9, 
   3.7136998535482025`*^9}, {3.7136998910917444`*^9, 
   3.7136999374515157`*^9}, {3.713700353752824*^9, 3.7137003539669065`*^9}, {
   3.713700407045844*^9, 3.713700409560511*^9}, {3.7137011686617503`*^9, 
   3.713701172301716*^9}, 3.7137013478227406`*^9, {3.7137013968664174`*^9, 
   3.7137013971258693`*^9}, {3.7137014278961706`*^9, 
   3.7137014312362766`*^9}, {3.7137015277682486`*^9, 
   3.7137015388358903`*^9}, {3.713701763698366*^9, 3.7137017669955697`*^9}, {
   3.7137019219174323`*^9, 3.713701923464468*^9}, {3.7137019573116293`*^9, 
   3.713701973719527*^9}, {3.7137020293970194`*^9, 3.7137020347569375`*^9}, {
   3.713702095622444*^9, 3.7137021010448666`*^9}, {3.713768391708779*^9, 
   3.7137684523649306`*^9}, {3.7137686138790207`*^9, 
   3.7137686176149497`*^9}, {3.7137687328601065`*^9, 3.713768736219713*^9}, {
   3.713768767565812*^9, 3.7137687775964704`*^9}, {3.71376899402391*^9, 
   3.7137689953535967`*^9}, {3.7137690706752434`*^9, 
   3.7137690717864013`*^9}, {3.71376911265559*^9, 3.7137691257938128`*^9}, {
   3.713769405720727*^9, 3.713769406408284*^9}, {3.7137703930719233`*^9, 
   3.7137703934937506`*^9}, {3.7137704925884104`*^9, 
   3.7137704940870175`*^9}, {3.713770532713205*^9, 3.713770532963229*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetBasis", "[", 
     RowBox[{"basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"CheckedBasisQ", "[", "basis", "]"}], "||", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"!", "CheckBasis"}], "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "SetBasis", "]"}]}], ")"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SetOptions", "[", 
      RowBox[{"Basis", ",", 
       RowBox[{"Basis", "\[Rule]", "basis"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"SetBasis", "::", "set"}], ",", "basis"}], "]"}], ";"}], " ", 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5020723178955317`*^9, 3.502072366871603*^9}, {
   3.502072482900752*^9, 3.502072486388658*^9}, {3.5051190669318933`*^9, 
   3.5051190854030952`*^9}, {3.713700420576004*^9, 3.7137004264866076`*^9}, {
   3.7137702512939043`*^9, 3.713770253575405*^9}, 3.7137704462022653`*^9, {
   3.71377053466076*^9, 3.7137705357195477`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetBasis", "[", 
     RowBox[{"basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"CheckBasis", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "SetBasis", "]"}]}], ")"}], "&&", 
      RowBox[{"CheckBasis", "[", "basis", "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SetOptions", "[", 
      RowBox[{"Basis", ",", 
       RowBox[{"Basis", "\[Rule]", "basis"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"SetBasis", "::", "set"}], ",", "basis"}], "]"}], ";"}], " ", 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5020723178955317`*^9, 3.502072366871603*^9}, {
  3.502072482900752*^9, 3.502072486388658*^9}, {3.502072558855989*^9, 
  3.5020725687826138`*^9}, {3.7137004309268827`*^9, 3.7137004423461833`*^9}, {
  3.713770538227564*^9, 3.7137705433722763`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetBasis", "[", 
     RowBox[{"basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"CheckBasis", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "SetBasis", "]"}]}], ")"}], "&&", 
      RowBox[{"(", 
       RowBox[{"!", 
        RowBox[{"CheckBasis", "[", "basis", "]"}]}], ")"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SetBasis", "::", "unsuitable"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502072436336616*^9, 3.502072455908551*^9}, {
   3.502072505362319*^9, 3.5020725319943657`*^9}, {3.505118831238387*^9, 
   3.505118881647069*^9}, 3.505118952374165*^9, {3.5051192853846416`*^9, 
   3.5051193168239117`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetBasis", "[", 
     RowBox[{"basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"CheckBasis", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "SetBasis", "]"}]}], ")"}], "&&", 
      RowBox[{"(", 
       RowBox[{"!", 
        RowBox[{"TrueQ", "[", 
         RowBox[{"CheckBasis", "[", "basis", "]"}], "]"}]}], ")"}]}], ")"}]}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SetBasis", "::", "possunsuitable"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{"basis", ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}], ",", "opts"}], "]"}]}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502072436336616*^9, 3.502072455908551*^9}, {
   3.502072505362319*^9, 3.5020725319943657`*^9}, {3.505118831238387*^9, 
   3.505118881647069*^9}, 3.505118952374165*^9}],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.501041524520939*^9, 3.501041525727335*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetBasis", "::", "unsuitable"}], "=", 
   "\"\<the state basis is unsuitable.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853867150202*^9, 3.4388538746659517`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetBasis", "::", "set"}], "=", 
   "\"\<the state basis has been set to `1`.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388538770946283`*^9, 3.438853879594825*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetBasis", "::", "nocheck"}], "=", 
   "\"\<the state basis has not been checked for completeness or \
orthonormality. Execute CheckBasis[] to check completeness and \
orthonormality.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434526840673403*^9, 3.434526849207477*^9}, {
  3.438853883670847*^9, 3.438853893195694*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetBasis", "::", "undefined"}], "=", 
   "\"\<The state basis `1` is undefined. It must be defined first using \
DefineBasis[kets].\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853900230575*^9, 3.438853910538793*^9}, 
   3.5010409048351183`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetBasis", "::", "spinsysunk"}], "=", 
   "\"\<SetSpinSystem must be used before defining basis.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4389386320978413`*^9, 3.438938659791746*^9}, 
   3.438939265248999*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetBasis", "::", "possunsuitable"}], "=", 
   "\"\<The suitability of the basis cannot be determined unambiguously. \
Proceeding anyway.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505118895415209*^9, 3.505118917849031*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetBasis", "::", "alreadyset"}], "=", "\[IndentingNewLine]", 
   "\"\<The basis is already set to `1`. No action has been taken.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.61847243681205*^9, 3.618472472208544*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Basis Dimension", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"BasisDimension", "[", "]"}], ":=", " ", 
  RowBox[{"BasisDimension", "[", 
   RowBox[{"Basis", "[", "]"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.456162870814488*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisDimension", "[", "Undefined", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.456164482828516*^9, 3.547025235663719*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisKets", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"BasisKets", "[", "]"}], ":=", " ", 
  RowBox[{"BasisKets", "[", 
   RowBox[{"Basis", "[", "]"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.456162873802148*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisKets", "[", 
     RowBox[{"Undefined", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, 
   3.456162346206533*^9, 3.456164484811524*^9, 3.547025176422535*^9, 
   3.547025238214806*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisKets", "[", 
    RowBox[{"Undefined", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "default"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{"SpinSystem", "[", "]"}], "]"}], ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"BasisKets", "[", "opts", "]"}]}], "\[IndentingNewLine]", 
    ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448352996365299*^9, 3.4483530373305273`*^9}, 
   3.448353271146612*^9, {3.4483540167855062`*^9, 3.448354027026896*^9}, 
   3.448354099021682*^9, {3.448355090943782*^9, 3.448355104215683*^9}, 
   3.4483551842477407`*^9, 3.448355597404213*^9, {3.448356357397586*^9, 
   3.4483563612172003`*^9}, 3.448357012050106*^9, 3.456162347356441*^9, 
   3.547025239355689*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisBras", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"BasisBras", "[", "]"}], ":=", " ", 
  RowBox[{"BasisBras", "[", 
   RowBox[{"Basis", "[", "]"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.456162874784974*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisBras", "[", 
     RowBox[{"Undefined", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355417134337*^9}, 3.448355808394209*^9, 
   3.4561623504923267`*^9, 3.456164485773666*^9, 3.547025181634644*^9, 
   3.547025240456263*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisBras", "[", 
    RowBox[{"Undefined", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "default"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{"SpinSystem", "[", "]"}], "]"}], ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"BasisBras", "[", "opts", "]"}]}], "\[IndentingNewLine]", 
    ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448352996365299*^9, 3.4483530373305273`*^9}, 
   3.448353271146612*^9, {3.4483540167855062`*^9, 3.448354027026896*^9}, 
   3.448354099021682*^9, {3.448355090943782*^9, 3.448355129708845*^9}, 
   3.4483551879041767`*^9, 3.448355605429779*^9, 3.448356369303214*^9, 
   3.448357020192367*^9, 3.4561623516032953`*^9, 3.5470252414454203`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisLabels", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486387821844768*^9, 3.486387822571076*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BasisLabels", "[", "]"}], ":=", " ", 
  RowBox[{"BasisLabels", "[", 
   RowBox[{"Basis", "[", "]"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.456162874784974*^9, {3.486387833960845*^9, 3.4863878602150917`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisLabels", "[", 
     RowBox[{
      RowBox[{"basis", ":", 
       RowBox[{"type_", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], ".."}], ",", 
         "basisopts___Rule"}], "]"}]}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"BasisLabels", "/.", 
        RowBox[{"{", 
         RowBox[{"basisopts", ",", "opts"}], "}"}]}], "/.", 
       RowBox[{"Options", "[", "Basis", "]"}]}], ",", "Automatic"}], "]"}]}], 
   ":=", "\[IndentingNewLine]", 
   RowBox[{"Range", "[", 
    RowBox[{"1", ",", 
     RowBox[{"BasisDimension", "[", 
      RowBox[{"basis", ",", "opts"}], "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502023598199395*^9, 3.502023686544981*^9}, {
  3.5020243189349613`*^9, 3.502024322761402*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisLabels", "[", 
     RowBox[{
      RowBox[{"basis", ":", 
       RowBox[{"type_", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], ".."}], ",", 
         "basisopts___Rule"}], "]"}]}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"BasisLabels", "/.", 
         RowBox[{"{", 
          RowBox[{"basisopts", ",", "opts"}], "}"}]}], "/.", 
        RowBox[{"Options", "[", "Basis", "]"}]}], ",", "Automatic"}], 
      "]"}]}]}], ":=", 
   RowBox[{
    RowBox[{"BasisLabels", "/.", 
     RowBox[{"{", 
      RowBox[{"basisopts", ",", "opts"}], "}"}]}], "/.", 
    RowBox[{"Options", "[", "Basis", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502944100386079*^9, 3.502944122825119*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisLabels", "[", 
    RowBox[{"basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"BasisLabels", "/.", 
     RowBox[{"{", "opts", "}"}]}], "/.", 
    RowBox[{"Options", "[", "Basis", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486387992906413*^9, 3.486387998811019*^9}, {
  3.501043585815104*^9, 3.501043590299921*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["predefined bases", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.502017949187397*^9, 3.502017950441843*^9}}],

Cell[CellGroupData[{

Cell["Zeeman Basis", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"ZeemanBasis", ",", "NHoldFirst"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.5320142816604567`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ZeemanBasis", "[", 
   RowBox[{"labels_List", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ZeemanBasis", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#", ",", 
         RowBox[{"1", "/", "2"}]}], "}"}], "&"}], "/@", "labels"}], ",", 
     "opts"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"!", 
      RowBox[{"MatrixQ", "[", "labels", "]"}]}], ")"}], "&&", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"labels", ",", 
       RowBox[{"{", "}"}]}], "]"}]}]}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.43496998227287*^9, 3.434970003133623*^9}, {
  3.486387693256557*^9, 3.486387699623499*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ZeemanBasis", "[", 
   RowBox[{"nspin_Integer", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"ZeemanBasis", "[", 
   RowBox[{
    RowBox[{"Range", "[", 
     RowBox[{"1", ",", "nspin"}], "]"}], ",", "opts"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486387704415118*^9, 3.486387710487081*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ZeemanBasis", "[", "Undefined", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", "Undefined"}], 
    ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.448355829257028*^9, {3.547025185339319*^9, 3.5470251993246727`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ZeemanBasis", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{"ZeemanBasis", "[", 
    RowBox[{
     RowBox[{"SpinSystem", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.435242131488824*^9, 3.456162352605176*^9, {3.486387713785145*^9, 
   3.486387722262595*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ZeemanBasis", "[", 
    RowBox[{"spinsys_", "?", "MatrixQ"}], "]"}], ":=", 
   RowBox[{"ZeemanBasis", "[", 
    RowBox[{"spinsys", ",", 
     RowBox[{"BasisLabels", "\[Rule]", "Automatic"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486387321522032*^9, 3.486387361306889*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedBasisQ", "[", 
    RowBox[{"ZeemanBasis", "[", 
     RowBox[{
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], "=", "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438854563203662*^9, 3.43885460225706*^9}, 
   3.438854641085773*^9, {3.486387364444646*^9, 3.4863873674181013`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisDimension", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisDimension", "[", 
    RowBox[{"ZeemanBasis", "[", 
     RowBox[{
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], ":=", 
   RowBox[{"Times", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "*", "#"}], "+", "1"}], ")"}], "&"}], "/@", 
      RowBox[{"Last", "[", " ", 
       RowBox[{"Transpose", "[", "spinsys", "]"}], "]"}]}], ")"}]}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.486387380957283*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisKets", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisKets", "[", 
    RowBox[{"ZeemanBasis", "[", 
     RowBox[{
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "states", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"states", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"First", "[", "#", "]"}], ",", "m"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"m", ",", 
              RowBox[{"Last", "[", "#", "]"}], ",", 
              RowBox[{"-", 
               RowBox[{"Last", "[", "#", "]"}]}], ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "]"}], "&"}], "/@", 
         "spinsys"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Ket", "[", 
          RowBox[{
           RowBox[{"Reverse", "[", "#", "]"}], ",", "spinsys", ",", 
           RowBox[{"Check", "\[Rule]", "False"}]}], "]"}], "&"}], "/@", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Outer", "[", 
           RowBox[{"List", ",", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"Reverse", "[", "states", "]"}]}], ",", "1"}], "]"}], 
          ",", 
          RowBox[{
           RowBox[{"Length", "[", "spinsys", "]"}], "-", "1"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4389274313552227`*^9, 3.4389274367876062`*^9}, {
   3.438937885176935*^9, 3.438937925144215*^9}, {3.438938075135476*^9, 
   3.438938082617691*^9}, 3.4863873856146927`*^9, {3.535369750694541*^9, 
   3.535369764987452*^9}, {3.5472285216840763`*^9, 3.5472285251051207`*^9}, 
   3.5474798513775263`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisBras", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisBras", "[", 
    RowBox[{"ZeemanBasis", "[", 
     RowBox[{
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Adjoint", "/@", 
    RowBox[{"BasisKets", "[", 
     RowBox[{"ZeemanBasis", "[", 
      RowBox[{"spinsys", ",", "opts"}], "]"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4389274313552227`*^9, 3.438927490521316*^9}, {
  3.48638739247666*^9, 3.486387399340385*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 3.468059115613844*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", 
    RowBox[{"ZeemanBasis", "[", 
     RowBox[{
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], "^:=", "spinsys"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468059125578073*^9, 3.4680591405217257`*^9}, {
  3.482571334646247*^9, 3.482571338869853*^9}, {3.486387411312503*^9, 
  3.486387419101542*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SingletTripletBasis", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"SingletTripletBasis", ",", "NHoldFirst"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5320142816604567`*^9, 3.5320142996911488`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SingletTripletBasis", "[", 
   RowBox[{"labels_List", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SingletTripletBasis", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#", ",", 
         RowBox[{"1", "/", "2"}]}], "}"}], "&"}], "/@", "labels"}], ",", 
     "opts"}], "]"}], "/;", 
   RowBox[{"!", 
    RowBox[{"MatrixQ", "[", "labels", "]"}]}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438941835199871*^9, 3.4389418464292517`*^9}, {
  3.486388719189558*^9, 3.4863887218999577`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SingletTripletBasis", "[", 
   RowBox[{"nspin_Integer", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"SingletTripletBasis", "[", 
   RowBox[{
    RowBox[{"Range", "[", 
     RowBox[{"1", ",", "nspin"}], "]"}], ",", "opts"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486388727456069*^9, 3.4863887315710983`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletBasis", "[", "Undefined", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", "Undefined"}], 
    ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.448355831308378*^9, 3.547025201321056*^9, 
  3.5472286062392197`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletBasis", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{"SingletTripletBasis", "[", 
    RowBox[{
     RowBox[{"SpinSystem", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.435242133278305*^9, 3.456162353649251*^9, {3.486389866217664*^9, 
   3.486389880838994*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SingletTripletBasis", "[", 
   RowBox[{
    RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SingletTripletBasis", "::", "notspinhf"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}], "/;", 
   RowBox[{"!", 
    RowBox[{"(", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"Last", "/@", "spinsystem"}], ",", 
       RowBox[{"{", 
        RowBox[{"Repeated", "[", 
         RowBox[{"1", "/", "2"}], "]"}], "}"}]}], "]"}], ")"}]}]}]}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.456164487477077*^9, 3.486388748112834*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SingletTripletBasis", "[", 
   RowBox[{
    RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SingletTripletBasis", "::", "morethantwospins"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}], "/;", 
   RowBox[{
    RowBox[{"Length", "[", "spinsystem", "]"}], "!=", "2"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.456164488307888*^9, 3.4863887537374487`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletBasis", "[", 
    RowBox[{"spinsys_", "?", "MatrixQ"}], "]"}], ":=", 
   RowBox[{"SingletTripletBasis", "[", 
    RowBox[{"spinsys", ",", 
     RowBox[{"BasisLabels", "\[Rule]", "Automatic"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486387321522032*^9, 3.486387361306889*^9}, {
  3.4863887830181303`*^9, 3.486388784618042*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefinedBasisQ", "[", 
     RowBox[{"SingletTripletBasis", "[", 
      RowBox[{
       RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
     "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"Last", "/@", "spinsystem"}], ",", 
       RowBox[{"{", 
        RowBox[{"Repeated", "[", 
         RowBox[{"1", "/", "2"}], "]"}], "}"}]}], "]"}], ")"}]}], "=", 
   "True"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388557110243*^9, 3.438855784299089*^9}, {
  3.4388565507042637`*^9, 3.438856565461182*^9}, {3.486388762992909*^9, 
  3.486388766886183*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisDimension", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"BasisDimension", "[", 
   RowBox[{"SingletTripletBasis", "[", 
    RowBox[{
     RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "]"}],
   ":=", 
  RowBox[{"4", "/;", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Length", "[", "spinsys", "]"}], "==", "2"}], ")"}]}]}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.486389611000272*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisKets", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisKets", "[", 
    RowBox[{"SingletTripletBasis", "[", 
     RowBox[{
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"2", "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "/", "2"}], ")"}]}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Ket", "[", 
         RowBox[{"\"\<\[Alpha]\[Beta]\>\"", ",", "spinsys", ",", 
          RowBox[{"Check", "\[Rule]", "False"}]}], "]"}], "-", 
        RowBox[{"Ket", "[", 
         RowBox[{"\"\<\[Beta]\[Alpha]\>\"", ",", "spinsys", ",", 
          RowBox[{"Check", "\[Rule]", "False"}]}], "]"}]}], ")"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Ket", "[", 
      RowBox[{"\"\<\[Alpha]\[Alpha]\>\"", ",", "spinsys", ",", 
       RowBox[{"Check", "\[Rule]", "False"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"2", "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "/", "2"}], ")"}]}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Ket", "[", 
         RowBox[{"\"\<\[Alpha]\[Beta]\>\"", ",", "spinsys", ",", 
          RowBox[{"Check", "\[Rule]", "False"}]}], "]"}], "+", 
        RowBox[{"Ket", "[", 
         RowBox[{"\"\<\[Beta]\[Alpha]\>\"", ",", "spinsys", ",", 
          RowBox[{"Check", "\[Rule]", "False"}]}], "]"}]}], ")"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Ket", "[", 
      RowBox[{"\"\<\[Beta]\[Beta]\>\"", ",", "spinsys", ",", 
       RowBox[{"Check", "\[Rule]", "False"}]}], "]"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.486389629461298*^9, {3.547228545815194*^9, 3.547228563457119*^9}, {
   3.54747985250976*^9, 3.5474798571124077`*^9}, {3.623922437655476*^9, 
   3.623922459423567*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisBras", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisBras", "[", 
    RowBox[{"SingletTripletBasis", "[", "args___", "]"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Adjoint", "/@", 
    RowBox[{"BasisKets", "[", 
     RowBox[{"SingletTripletBasis", "[", "args", "]"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.486389636988752*^9, {3.6239224788741713`*^9, 3.623922503539173*^9}, {
   3.623922577016006*^9, 3.623922597821405*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 3.468059115613844*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", 
    RowBox[{"SingletTripletBasis", "[", 
     RowBox[{
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], "^:=", "spinsys"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468059125578073*^9, 3.4680591405217257`*^9}, {
   3.482571334646247*^9, 3.482571356228991*^9}, 3.486389643003372*^9, {
   3.623922510373179*^9, 3.6239225123384542`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["error messages", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletBasis", "::", "notspinhf"}], "=", 
   "\"\<singlet-triplet basis is only available for spins-1/2\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletBasis", "::", "morethantwospins"}], "=", 
   "\"\<singlet-triplet basis is only available for two spins-1/2\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["derived bases", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.502017952073842*^9, 3.502017952913645*^9}}],

Cell[CellGroupData[{

Cell["TransformedBasis", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4296825159619217`*^9, 3.429682520655286*^9}}],

Cell["TransformedBasis code is in QM`SpinOperators", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.6831879051536913`*^9, 3.6831879163864317`*^9}, 
   3.683188056670576*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Eigenbasis", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4296825159619217`*^9, 3.429682520655286*^9}, {
  3.5020163674684753`*^9, 3.502016371474929*^9}}],

Cell["Eigenbasis code is in QM`SpinOperators", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.6831879051536913`*^9, 3.6831879163864317`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ProductBasis", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4296825159619217`*^9, 3.429682520655286*^9}, {
  3.5020163674684753`*^9, 3.502016371474929*^9}, {3.623913839434927*^9, 
  3.623913841760942*^9}}],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439436493671139*^9, 3.439436494484573*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ProductBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"BasisLabels", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"Validity", "\[Rule]", "Undefined"}]}], "}"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.501043345831255*^9, 3.501043359724909*^9}, 
   3.502016378967168*^9, 3.623913850456718*^9, {3.6239164752222233`*^9, 
   3.62391648359881*^9}, {3.623916539552281*^9, 3.623916572794866*^9}, {
   3.623916659620882*^9, 3.623916660928782*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductBasis", "[", 
    RowBox[{
     RowBox[{"bases", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"_", "?", "DefinedBasisQ"}], ".."}], ")"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", 
         RowBox[{"_", "?", "DefinedBasisQ"}], "]"}], "..."}], ")"}]}]}], 
    "]"}], ":=", 
   RowBox[{"ProductBasis", "[", 
    RowBox[{
     RowBox[{"{", "bases", "}"}], ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.623918766725698*^9, 3.623918805636787*^9}, {
  3.62391887992367*^9, 3.623918897978994*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductBasis", "[", 
    RowBox[{"bases_List", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"ProductBasis", "[", 
    RowBox[{"bases", ",", "\[IndentingNewLine]", 
     RowBox[{"Join", "@@", 
      RowBox[{"(", 
       RowBox[{"SpinSystem", "/@", "bases"}], ")"}]}], ",", 
     "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.501044223437993*^9, 3.501044384788707*^9}, {
  3.501044431270719*^9, 3.501044451332543*^9}, {3.501044504691627*^9, 
  3.501044515897071*^9}, {3.50104524010634*^9, 3.501045251679199*^9}, {
  3.501045445540399*^9, 3.501045448315486*^9}, {3.501045523382839*^9, 
  3.501045524738613*^9}, {3.50201834027234*^9, 3.502018417195421*^9}, {
  3.623913907449016*^9, 3.623913974121895*^9}, {3.623914043402964*^9, 
  3.623914074568308*^9}, {3.6239141076923532`*^9, 3.623914107954021*^9}, {
  3.6239176275212393`*^9, 3.623917635415001*^9}, {3.623918255360209*^9, 
  3.623918323221958*^9}, {3.623918427932675*^9, 3.623918439373486*^9}}],

Cell["\<\
check validity of bases and spin system specifications and set \
Validity\[Rule]True if all OK. This will disable further checks.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.623919482352317*^9, 3.623919523734522*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProductBasis", "[", 
     RowBox[{"bases_List", ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;",
     "\[IndentingNewLine]", 
    RowBox[{"(", 
     RowBox[{"!", 
      RowBox[{"TrueQ", "[", 
       RowBox[{
        RowBox[{"Validity", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "ProductBasis", "]"}]}], "]"}]}], ")"}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spinsystems", ",", "spins", ",", "comspins", ",", "totspins"}],
       "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"spinsystems", "=", 
        RowBox[{"SpinSystem", "/@", "bases"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"spins", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"First", "[", 
           RowBox[{"Transpose", "[", "#", "]"}], "]"}], "&"}], "/@", 
         "spinsystems"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"comspins", "=", 
        RowBox[{"Intersection", "@@", "spins"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"totspins", "=", 
        RowBox[{"Union", "@@", "spins"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"comspins", ",", 
            RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", "\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"ProductBasis", "::", "sharedspins"}], ",", "comspins"}],
             "]"}], ";", "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"And", "@@", 
           RowBox[{"(", 
            RowBox[{"DefinedBasisQ", "/@", "bases"}], ")"}]}]}], ",", 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"ProductBasis", "::", "undef"}], ",", 
             RowBox[{"Select", "[", 
              RowBox[{"bases", ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"!", 
                  RowBox[{"DefinedBasisQ", "[", "#", "]"}]}], ")"}], "&"}]}], 
              "]"}]}], "]"}], ";", "$Failed"}], ")"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{
            RowBox[{"Join", "@@", "spinsystems"}], ",", "spinsys"}], "]"}]}], 
         ",", "\[IndentingNewLine]", "\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"ProductBasis", "::", "invalspins"}], "]"}], ";", 
           "$Failed"}], ")"}], ",", "\[IndentingNewLine]", "True", ",", 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"ProductBasis", "[", "\[IndentingNewLine]", "\t\t", 
          RowBox[{"bases", ",", "spinsys", ",", "\[IndentingNewLine]", "\t\t", 
           RowBox[{"Sequence", "@@", 
            RowBox[{"FilterRules", "[", "\[IndentingNewLine]", "\t\t", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Validity", "\[Rule]", "True"}], ",", "opts"}], "}"}],
               ",", "\[IndentingNewLine]", "\t", 
              RowBox[{"Options", "[", "ProductBasis", "]"}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.501044223437993*^9, 3.501044384788707*^9}, {
   3.501044431270719*^9, 3.501044451332543*^9}, {3.501044504691627*^9, 
   3.501044515897071*^9}, {3.50104524010634*^9, 3.501045251679199*^9}, {
   3.501045445540399*^9, 3.501045448315486*^9}, {3.501045523382839*^9, 
   3.501045524738613*^9}, {3.50201834027234*^9, 3.502018417195421*^9}, {
   3.623913907449016*^9, 3.623913974121895*^9}, {3.623914043402964*^9, 
   3.623914074568308*^9}, {3.6239141076923532`*^9, 3.623914107954021*^9}, {
   3.623916170746133*^9, 3.623916230572507*^9}, {3.623916359259798*^9, 
   3.623916418403557*^9}, {3.623916589904561*^9, 3.623916593043943*^9}, {
   3.623916627432185*^9, 3.623916678724077*^9}, {3.6239167093842573`*^9, 
   3.62391686514113*^9}, {3.623916905583611*^9, 3.623916978075768*^9}, {
   3.623917011656692*^9, 3.623917098019342*^9}, {3.623917164327878*^9, 
   3.623917223556108*^9}, {3.6239173344219513`*^9, 3.623917387229475*^9}, {
   3.623917430854767*^9, 3.623917436487698*^9}, {3.623917818733852*^9, 
   3.623917929442971*^9}, {3.623918081119884*^9, 3.623918163627222*^9}, {
   3.623918334450643*^9, 3.6239183448136883`*^9}, {3.623918453734109*^9, 
   3.623918585077259*^9}, 3.623919459422944*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["DefinedBasisQ", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439436493671139*^9, 3.439436494484573*^9}, 
   3.501044929734041*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedBasisQ", "[", 
    RowBox[{"ProductBasis", "[", 
     RowBox[{"bases_List", ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], ":=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{"DefinedBasisQ", "/@", "bases"}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429810906571207*^9, 3.4298109624411077`*^9}, {
   3.438853086487935*^9, 3.4388531040278177`*^9}, 3.501043981041954*^9, {
   3.502016460266349*^9, 3.502016475016206*^9}, {3.502017506761675*^9, 
   3.5020175187617826`*^9}, 3.62391417218775*^9, 3.623914230924602*^9, {
   3.623923085953395*^9, 3.6239230881838093`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisDimension", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisDimension", "[", 
    RowBox[{"ProductBasis", "[", 
     RowBox[{"bases_List", ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], ":=", 
   RowBox[{"Times", "@@", 
    RowBox[{"(", 
     RowBox[{"BasisDimension", "/@", "bases"}], ")"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429682561209777*^9, 3.429682583824851*^9}, 
   3.429684938095209*^9, {3.501043276599259*^9, 3.5010432795488777`*^9}, {
   3.5020164834354*^9, 3.502016494906588*^9}, {3.502017526986478*^9, 
   3.5020175289285517`*^9}, {3.502020236344823*^9, 3.502020240605795*^9}, {
   3.6239143676083593`*^9, 3.62391439505471*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisKets", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisKets", "[", 
    RowBox[{"ProductBasis", "[", 
     RowBox[{"bases_List", ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BasisKets", "[", 
     RowBox[{"ProductBasis", "[", 
      RowBox[{"bases", ",", "spinsys", ",", "___Rule"}], "]"}], "]"}], "=", 
    RowBox[{"Simplify", "@", 
     RowBox[{"Expand", "@", 
      RowBox[{"Flatten", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{
          RowBox[{"Outer", "[", 
           RowBox[{"ProductKet", ",", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"(", 
              RowBox[{"BasisKets", "/@", "bases"}], ")"}]}]}], "]"}], ",", 
          RowBox[{"Reverse", "@", 
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", "bases", "]"}], "]"}]}]}], "]"}], ",", 
        RowBox[{
         RowBox[{"Length", "[", "bases", "]"}], "-", "1"}]}], "]"}]}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.623914439444087*^9, 3.62391445826005*^9}, {
   3.623914493554824*^9, 3.623914517004323*^9}, {3.623915197929685*^9, 
   3.6239152297921953`*^9}, {3.623916042892314*^9, 3.62391609632547*^9}, {
   3.623918721938427*^9, 3.623918745436445*^9}, 3.623919077162258*^9, {
   3.623922745595949*^9, 3.623922781841505*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisBras", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisBras", "[", "prodbasis_ProductBasis", "]"}], ":=", 
   RowBox[{"Adjoint", "/@", 
    RowBox[{"BasisKets", "[", "prodbasis", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4296837804177017`*^9, 3.4296838218469677`*^9}, {
   3.429685439711335*^9, 3.429685440287122*^9}, {3.429685491399211*^9, 
   3.429685503728818*^9}, {3.439437840101775*^9, 3.439437857935*^9}, {
   3.5010413357609043`*^9, 3.501041353032669*^9}, {3.50104332500014*^9, 
   3.501043334333499*^9}, 3.501045607881752*^9, {3.5020172566426573`*^9, 
   3.502017276336644*^9}, {3.502017611902952*^9, 3.5020176186119757`*^9}, {
   3.502018241746413*^9, 3.502018245230214*^9}, {3.623915248834736*^9, 
   3.623915294552524*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 3.468059115613844*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", 
    RowBox[{"ProductBasis", "[", 
     RowBox[{"bases_List", ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
    "]"}], "^:=", "spinsys"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468059125578073*^9, 3.4680591405217257`*^9}, {
   3.482571334646247*^9, 3.48257138911128*^9}, {3.502017288323278*^9, 
   3.5020173054797573`*^9}, {3.50201763140621*^9, 3.5020176443074713`*^9}, 
   3.623914482900103*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.623910519048006*^9, 3.623910542425253*^9}, {
   3.623910868913475*^9, 3.623910869879321*^9}, {3.623912023205567*^9, 
   3.623912024428597*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductBasis", "::", "undef"}], "=", 
   "\"\<The following argument of ProductBasis is not a defined Basis: \
`1`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.623912149843783*^9, 3.623912182527576*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductBasis", "::", "sharedspins"}], "=", 
   "\"\<Spins may not be shared between the component bases of a \
ProductBasis. The following spins are shared: `1`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.623917112363982*^9, 3.62391715644055*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductBasis", "::", "invalspins"}], "=", 
   "\"\<The set of spins comprising the bases of the ProductBasis does not \
conform to the requested spin system of the ProductBasis.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.623917112363982*^9, 3.62391715644055*^9}, {
  3.623917235333829*^9, 3.623917327232708*^9}}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisTransformationMatrix", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.431059892057632*^9, 3.439427968279667*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{"basis2_", "?", "DefinedBasisQ"}], "]"}], ":=", 
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{"basis2", ",", 
     RowBox[{"Basis", "[", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310688402972383`*^9, 3.431068870287149*^9}, {
   3.43942797740836*^9, 3.43942799966306*^9}, 3.456162879413439*^9, {
   3.623923850079403*^9, 3.623923853380308*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"basis2_", "?", "DefinedBasisQ"}], ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}]}], "]"}], ":=", 
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"basis2", ",", 
       RowBox[{"Basis", "[", "]"}]}], "}"}], ",", "spinsys"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310688402972383`*^9, 3.431068870287149*^9}, {
   3.43942797740836*^9, 3.43942799966306*^9}, 3.456162879413439*^9, {
   3.623923850079403*^9, 3.623923853380308*^9}, {3.6239239590722103`*^9, 
   3.623923969831029*^9}, {3.623947429783634*^9, 3.623947432182954*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"basis2_", "?", "DefinedBasisQ"}], ",", 
     RowBox[{"basis1_", "?", "DefinedBasisQ"}]}], "]"}], ":=", 
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{"{", 
     RowBox[{"basis2", ",", "basis1"}], "}"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310688402972383`*^9, 3.431068870287149*^9}, {
   3.43942797740836*^9, 3.43942799966306*^9}, 3.456162879413439*^9, {
   3.623923850079403*^9, 3.623923896093541*^9}, {3.623923983147084*^9, 
   3.623924048472353*^9}, {3.623946350240926*^9, 3.623946386386039*^9}, {
   3.623946459054899*^9, 3.623946461387969*^9}, 3.657302306390135*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"basis2_", "?", "DefinedBasisQ"}], ",", 
      RowBox[{"basis1_", "?", "DefinedBasisQ"}]}], "}"}], "]"}], ":=", 
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"basis2", ",", "basis1"}], "}"}], ",", 
     RowBox[{"SpinSystem", "[", "basis2", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.657302286784586*^9, 3.657302299759719*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisTransformationMatrix", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"basis2_", ",", "basis1_"}], "}"}], ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}]}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"SameQ", "[", 
      RowBox[{
       RowBox[{"SpinSystem", "[", "basis2", "]"}], ",", 
       RowBox[{"SpinSystem", "[", "basis1", "]"}], ",", "spinsys"}], 
      "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"BasisTransformationMatrix", "::", "incompspinsys"}], "]"}], 
     ";", "\[IndentingNewLine]", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6239240569384327`*^9, 3.623924115611685*^9}, {
   3.623924207731543*^9, 3.623924214790473*^9}, {3.64052179554058*^9, 
   3.6405218143496304`*^9}, {3.6405225076729527`*^9, 3.640522517911166*^9}, 
   3.640598378007406*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"basis_", ",", "basis_"}], "}"}], ",", "spinsys_"}], "]"}], ":=", 
   RowBox[{"SparseArray", "[", 
    RowBox[{
     RowBox[{"Band", "[", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], "]"}], "\[Rule]", 
     RowBox[{"Table", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"BasisDimension", "[", "basis", "]"}], "}"}]}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502069032878415*^9, 3.5020690856374207`*^9}, {
   3.623924125408381*^9, 3.623924136476975*^9}, {3.6239242210517406`*^9, 
   3.623924223240108*^9}, 3.683190461968013*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"basis2_", ",", "basis1_"}], "}"}], ",", "spinsys_"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"SparseArray", "@", 
    RowBox[{"Outer", "[", 
     RowBox[{"Dot", ",", 
      RowBox[{"BasisBras", "[", "basis2", "]"}], ",", 
      RowBox[{"BasisKets", "[", "basis1", "]"}]}], "]"}]}]}], ";"}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431060507531653*^9, 3.4310605243448067`*^9}, {
   3.4310605573642673`*^9, 3.431060656344018*^9}, {3.431068723362863*^9, 
   3.4310687254902067`*^9}, {3.431068809114211*^9, 3.43106882252243*^9}, 
   3.435381118675346*^9, {3.439428042918405*^9, 3.4394282238018837`*^9}, {
   3.5010461085207167`*^9, 3.5010461116670027`*^9}, {3.501046565073094*^9, 
   3.5010465675660763`*^9}, {3.6239241433442707`*^9, 3.623924150205113*^9}, {
   3.623924226963258*^9, 3.623924234992362*^9}, 3.657302052528763*^9, 
   3.6573021210366383`*^9, {3.657302188296178*^9, 3.657302251665419*^9}, 
   3.657302332005475*^9, {3.657303008220611*^9, 3.65730301134578*^9}, {
   3.6831904192705107`*^9, 3.6831904272620153`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisTransformationMatrix", "::", "incompspinsys"}], "=", 
   "\"\<The spin systems for the bases are inconsistent.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6239239085748167`*^9, 3.623923935533703*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Kets and Bras", "Subsubtitle",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"271e5a03-9c1c-41b5-91b8-c055b107b35a"],

Cell[CellGroupData[{

Cell["Ket", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.5470169136012373`*^9, 3.5703431586623163`*^9}],

Cell[CellGroupData[{

Cell["properties", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456165698465754*^9, 3.456165702536334*^9}, {
   3.460366510406715*^9, 3.460366512373371*^9}, {3.460366553134673*^9, 
   3.460366553649557*^9}, {3.502166412932279*^9, 3.502166415362692*^9}, {
   3.530617644510482*^9, 3.530617646155493*^9}, {3.547015193191354*^9, 
   3.547015194620152*^9}, 3.570343158662703*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Ket", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Validity", "\[Rule]", "Undefined"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547015195991577*^9, 3.547015215062867*^9}, 
   3.5474798354375963`*^9, {3.54753015727983*^9, 3.5475301627646112`*^9}, 
   3.570343158663248*^9}],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Ket", ",", "NHoldAll"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.530617652915752*^9, 3.530617681579221*^9}, {
   3.53269165405834*^9, 3.532691654568581*^9}, {3.532691981791937*^9, 
   3.53269198604044*^9}, 3.570343158670879*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["generalities", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.547013633187716*^9, 3.5470136348584747`*^9}, 
   3.5703431586763287`*^9}],

Cell[CellGroupData[{

Cell["default to current spin system", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.5703431586765623`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "[", 
    RowBox[{"id_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Ket", "[", 
    RowBox[{"id", ",", 
     RowBox[{"SpinSystem", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.456162354482678*^9, {3.4864509197927723`*^9, 3.486450929773013*^9}, 
   3.5703431586768923`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "[", 
    RowBox[{"id_", ",", "Undefined", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438927343640579*^9, 3.438927372092021*^9}, 
   3.448355861478483*^9, 3.456164492527885*^9, 3.4864509375678463`*^9, 
   3.5472286101736107`*^9, 3.570343158682405*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["eliminate any dot products involving zero", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431092174992111*^9, 3.431092176181019*^9}, {
   3.460642489525651*^9, 3.460642526180264*^9}, {3.4826800325166817`*^9, 
   3.482680048202726*^9}, {3.48653746245815*^9, 3.486537464423171*^9}, {
   3.486537496160138*^9, 3.486537503582787*^9}, 3.570343158699059*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Ket", "/:", 
   RowBox[{"HoldPattern", "[", 
    RowBox[{"Dot", "[", 
     RowBox[{"___", ",", 
      RowBox[{"Ket", "[", "___", "]"}], ",", "0", ",", "___"}], "]"}], "]"}], 
   "=", "0"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486537515139436*^9, 3.4865375329378853`*^9}, 
   3.570343158699341*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["check input validity", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
   3.486452077545096*^9, 3.4864521531961813`*^9}, {3.5470135609391937`*^9, 
   3.5470135648101883`*^9}, 3.570343158704631*^9}],

Cell[CellGroupData[{

Cell["\<\
if the identifier is a string of \[Alpha] and \[Beta]'s , check for validity \
and translate\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
   3.486452077545096*^9, 3.4864521531961813`*^9}, 3.570343158704895*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Ket", "[", 
      RowBox[{"id_String", ",", 
       RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}]}], "/;",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"Validity", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Ket", "]"}]}], "]"}]}], ")"}], "&&", 
     "\[IndentingNewLine]", 
     RowBox[{"StringMatchQ", "[", 
      RowBox[{"id", ",", 
       RowBox[{"Repeated", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\"\<\[Alpha]\>\"", "|", "\"\<\[Beta]\>\""}], ")"}], ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "spinsys", "]"}], "}"}]}], "]"}]}], "]"}], "&&",
      "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"Last", "/@", "spinsys"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", "2"}], ".."}], "}"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Ket", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MapThread", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"#1", ",", 
          RowBox[{"Switch", "[", 
           RowBox[{"#2", ",", "\"\<\[Alpha]\>\"", ",", 
            RowBox[{"1", "/", "2"}], ",", "\"\<\[Beta]\>\"", ",", 
            RowBox[{
             RowBox[{"-", "1"}], "/", "2"}]}], "]"}]}], "}"}], "&"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"First", "/@", "spinsys"}], ",", 
         RowBox[{"Characters", "[", "id", "]"}]}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "spinsys", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Validity", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
       "opts"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486452120596053*^9, 3.486452169710497*^9}, {
   3.486452269447176*^9, 3.486452294183125*^9}, {3.486452330546908*^9, 
   3.486452397486413*^9}, {3.486452539002718*^9, 3.4864525591368504`*^9}, {
   3.4864527330306053`*^9, 3.486452744860353*^9}, {3.547015246676133*^9, 
   3.547015347485002*^9}, {3.547479836541873*^9, 3.54747983789174*^9}, {
   3.5475301935540047`*^9, 3.547530214085843*^9}, {3.547530409748961*^9, 
   3.5475304210270767`*^9}, {3.570271956428969*^9, 3.570271958736946*^9}, {
   3.570343066550168*^9, 3.570343069344429*^9}, 3.57034315870539*^9, {
   3.5714218151278477`*^9, 3.571421818100276*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
if the identifier is not a list, use it as a label of a defined state basis.\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
   3.502023996117338*^9, 3.502023996369627*^9}, {3.502024396129133*^9, 
   3.502024400837843*^9}, 3.570343158705586*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "[", 
    RowBox[{
     RowBox[{"id", ":", 
      RowBox[{"Except", "[", "_List", "]"}]}], ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   
   RowBox[{"Ket", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"id", ",", 
       RowBox[{"Basis", "[", "]"}]}], "}"}], ",", "spinsys", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486451016723567*^9, 3.4864510747264643`*^9}, 
   3.570343158705966*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"id", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", "Undefined"}], "}"}], 
     ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486451088088696*^9, 3.486451093663088*^9}, {
   3.486451123890458*^9, 3.486451142866674*^9}, 3.547025203271402*^9, 
   3.570343158711632*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Ket", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"id", ":", 
         RowBox[{"Except", "[", "_List", "]"}]}], ",", 
        RowBox[{"basis_", "?", "DefinedBasisQ"}]}], "}"}], ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MemberQ", "[", 
     RowBox[{
      RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "id"}], "]"}]}], ":=", 
   
   RowBox[{"First", "@", 
    RowBox[{"Extract", "[", 
     RowBox[{
      RowBox[{"BasisKets", "[", "basis", "]"}], ",", 
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "id"}], "]"}]}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486389009042329*^9, 3.486389161349902*^9}, {
   3.4863893449866047`*^9, 3.4863893650423803`*^9}, {3.486451187456595*^9, 
   3.486451208247272*^9}, {3.486451745825087*^9, 3.486451764680912*^9}, {
   3.502024113358232*^9, 3.502024135156452*^9}, {3.5020695951306133`*^9, 
   3.5020695998307877`*^9}, 3.50207027024127*^9, {3.547019298208593*^9, 
   3.547019306344761*^9}, 3.5703431587134113`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Ket", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"id", ":", 
         RowBox[{"Except", "[", "_List", "]"}]}], ",", 
        RowBox[{"basis_", "?", "DefinedBasisQ"}]}], "}"}], ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"MemberQ", "[", 
       RowBox[{
        RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "id"}], "]"}], 
      "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Ket", "::", "inappbl"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486451427173036*^9, 3.486451448933189*^9}, 
   3.486451771635577*^9, 3.5020241532778177`*^9, 3.502069621828886*^9, 
   3.50207027328684*^9, {3.5470179494257793`*^9, 3.547017949897129*^9}, 
   3.5470193778696404`*^9, 3.547019417919765*^9, 3.5703431587148046`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["check validity of all spins", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
   3.502023996117338*^9, 3.502023996369627*^9}, {3.502024396129133*^9, 
   3.502024400837843*^9}, {3.5470137311280107`*^9, 3.547013737295046*^9}, {
   3.547014348884225*^9, 3.5470143509551573`*^9}, 3.5703431587160263`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Ket", "[", 
     RowBox[{
      RowBox[{"kets_", "?", "MatrixQ"}], ",", 
      RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"Validity", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Ket", "]"}]}], "]"}]}], ")"}], "&&", 
     RowBox[{"!", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Length", "[", "kets", "]"}], "\[Equal]", 
        RowBox[{"Length", "[", "spinsystem", "]"}]}], ")"}]}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Ket", "::", "invalidnum"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470137540859337`*^9, 3.54701385891964*^9}, {
   3.547013891635468*^9, 3.547013902990355*^9}, {3.5470143780855713`*^9, 
   3.547014402736335*^9}, 3.547014443652863*^9, {3.547015406685961*^9, 
   3.5470154096435833`*^9}, 3.547479838675273*^9, 3.54753023082697*^9, 
   3.547530428403953*^9, 3.570343158716546*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Ket", "[", 
     RowBox[{
      RowBox[{"kets_", "?", "MatrixQ"}], ",", 
      RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"Validity", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Ket", "]"}]}], "]"}]}], ")"}], "&&", 
     RowBox[{"!", 
      RowBox[{"And", "@@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"MemberQ", "[", 
           RowBox[{
            RowBox[{"First", "/@", "spinsystem"}], ",", 
            RowBox[{"First", "[", "#", "]"}]}], "]"}], "&"}], "/@", "kets"}], 
        ")"}]}]}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "invalspins", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"invalspins", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"First", "/@", "kets"}], ",", 
          RowBox[{
           RowBox[{"!", 
            RowBox[{"MemberQ", "[", 
             RowBox[{
              RowBox[{"First", "/@", "spinsystem"}], ",", "#"}], "]"}]}], 
           "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"Ket", "::", "invalidspins"}], ",", "invalspins"}], "]"}], 
       ";", "\[IndentingNewLine]", "$Failed"}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470137540859337`*^9, 3.54701385891964*^9}, {
   3.547013891635468*^9, 3.547013902990355*^9}, 3.5470154152223167`*^9, 
   3.5474798393856153`*^9, {3.5474801572143717`*^9, 3.5474802641996803`*^9}, 
   3.5474807460504513`*^9, 3.54753024499543*^9, 3.547530431260914*^9, 
   3.5703431587181597`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["reorder spins if needed", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
   3.502023996117338*^9, 3.502023996369627*^9}, {3.502024396129133*^9, 
   3.502024400837843*^9}, {3.5470137311280107`*^9, 3.547013737295046*^9}, {
   3.547014348884225*^9, 3.5470143509551573`*^9}, 3.5703431587160263`*^9, {
   3.695466312307742*^9, 3.695466316634486*^9}}],

Cell["\<\
this happens if the set of spin labels used for the kets is the same as in \
spinsystem, but in the wrong order.  \
\>", "Text",
 CellChangeTimes->{{3.6954675162699747`*^9, 3.695467574755065*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "[", 
    RowBox[{
     RowBox[{"kets_", "?", "MatrixQ"}], ",", 
     RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spinlabels", ",", "ketspinlabels", ",", "perm"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"perm", "=", 
         RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
          RowBox[{"Inner", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"List", "[", 
                RowBox[{"#1", ",", "#2"}], "]"}], "\[Rule]", "1"}], ")"}], 
             "&"}], ",", 
            RowBox[{"Ordering", "[", "spinlabels", "]"}], ",", 
            RowBox[{"Ordering", "[", "ketspinlabels", "]"}], ",", "List"}], 
           "]"}], "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"Ket", "[", 
         RowBox[{
          RowBox[{"perm", ".", "kets"}], ",", "spinsystem", ",", "opts"}], 
         "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"!", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"Validity", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Ket", "]"}]}], "]"}]}], ")"}], "&&", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"spinlabels", "=", 
           RowBox[{"First", "/@", "spinsystem"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"ketspinlabels", "=", 
           RowBox[{"First", "/@", "kets"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"spinlabels", "\[NotEqual]", "ketspinlabels"}], ")"}], "&&",
            "\[IndentingNewLine]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Sort", "[", "spinlabels", "]"}], "\[Equal]", 
             RowBox[{"Sort", "[", "ketspinlabels", "]"}]}], ")"}]}]}], 
         "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470137540859337`*^9, 3.54701385891964*^9}, {
   3.547013891635468*^9, 3.547013902990355*^9}, 3.5470154152223167`*^9, 
   3.5474798393856153`*^9, {3.5474801572143717`*^9, 3.5474802641996803`*^9}, 
   3.5474807460504513`*^9, 3.54753024499543*^9, 3.547530431260914*^9, 
   3.5703431587181597`*^9, {3.695466330851245*^9, 3.695466513735317*^9}, {
   3.6954666420562773`*^9, 3.6954666649332933`*^9}, {3.6954674442631083`*^9, 
   3.695467534590068*^9}, {3.695467940143546*^9, 3.695467976804677*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["check validity of spin quantum numbers", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
   3.502023996117338*^9, 3.502023996369627*^9}, {3.502024396129133*^9, 
   3.502024400837843*^9}, {3.5470137311280107`*^9, 3.547013737295046*^9}, {
   3.54701398063899*^9, 3.547013983083658*^9}, 3.570343158719351*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Ket", "[", 
     RowBox[{
      RowBox[{"kets_", "?", "MatrixQ"}], ",", 
      RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"Validity", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Ket", "]"}]}], "]"}]}], ")"}], "&&", 
     RowBox[{"!", 
      RowBox[{"Inner", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"-", "#2"}], ",", "#2", ",", "1"}], "]"}], ",", "#1"}], 
          "]"}], "&"}], ",", 
        RowBox[{"Last", "/@", "kets"}], ",", 
        RowBox[{"Last", "/@", "spinsystem"}], ",", "And"}], "]"}]}]}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "invalIjMjpairs", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"invalIjMjpairs", "=", 
        RowBox[{"Select", "[", 
         RowBox[{"kets", ",", 
          RowBox[{
           RowBox[{"!", 
            RowBox[{"MemberQ", "[", 
             RowBox[{
              RowBox[{"Range", "[", 
               RowBox[{
                RowBox[{"-", 
                 RowBox[{"SpinQuantumNumber", "[", 
                  RowBox[{
                   RowBox[{"First", "[", "#", "]"}], ",", "spinsystem"}], 
                  "]"}]}], ",", 
                RowBox[{"SpinQuantumNumber", "[", 
                 RowBox[{
                  RowBox[{"First", "[", "#", "]"}], ",", "spinsystem"}], 
                 "]"}], ",", "1"}], "]"}], ",", 
              RowBox[{"Last", "[", "#", "]"}]}], "]"}]}], "&"}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"Ket", "::", "invalidm"}], ",", "invalIjMjpairs"}], "]"}], 
       ";", "\[IndentingNewLine]", "$Failed"}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470137540859337`*^9, 3.54701385891964*^9}, {
   3.547013891635468*^9, 3.547013902990355*^9}, {3.5470140021300898`*^9, 
   3.547014016561652*^9}, {3.547014294420295*^9, 3.5470143427121983`*^9}, {
   3.547014467235573*^9, 3.5470145168849707`*^9}, {3.547015027246422*^9, 
   3.547015072670374*^9}, 3.547015425907599*^9, 3.5474798401859837`*^9, {
   3.547480361398184*^9, 3.547480391659873*^9}, {3.547480429242442*^9, 
   3.547480606283288*^9}, 3.547480742932478*^9, {3.547480824026526*^9, 
   3.547480857117519*^9}, 3.547530268624489*^9, 3.5475304339191628`*^9, 
   3.570343158720208*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["if all validity checks are passed, suppress further checks", \
"Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
   3.502023996117338*^9, 3.502023996369627*^9}, {3.502024396129133*^9, 
   3.502024400837843*^9}, {3.5470137311280107`*^9, 3.547013737295046*^9}, {
   3.54701398063899*^9, 3.547013983083658*^9}, {3.547015435823205*^9, 
   3.547015447445345*^9}, 3.570343158721426*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Ket", "[", 
     RowBox[{
      RowBox[{"kets_", "?", "MatrixQ"}], ",", 
      RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"!", 
      RowBox[{"TrueQ", "[", 
       RowBox[{
        RowBox[{"Validity", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Ket", "]"}]}], "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Ket", "[", 
    RowBox[{"kets", ",", "spinsystem", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Validity", "\[Rule]", "True"}], ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547015459496625*^9, 3.547015494249064*^9}, {
   3.5474798411546993`*^9, 3.547479841839082*^9}, {3.547480131352581*^9, 
   3.547480136041061*^9}, {3.547480715600648*^9, 3.5474807170304823`*^9}, {
   3.54753027969693*^9, 3.547530287509933*^9}, 3.547530436891252*^9, 
   3.570343158721898*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["output format", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
   3.486452077545096*^9, 3.4864521531961813`*^9}, {3.5470135609391937`*^9, 
   3.547013593106125*^9}, 3.5703431587230787`*^9}],

Cell[CellGroupData[{

Cell["\[Alpha]\[Beta] output notation for spins-1/2", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.57034315872335*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Format", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"kets_", "?", "MatrixQ"}], ",", 
       RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
     "]"}], "/;", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"First", "/@", "kets"}], "==", 
        RowBox[{"First", "/@", "spinsystem"}]}], ")"}], "&&", 
      "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"Last", "/@", "spinsystem"}], ",", 
        RowBox[{"{", 
         RowBox[{"Repeated", "[", 
          RowBox[{"1", "/", "2"}], "]"}], "}"}]}], "]"}]}], 
     "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}], "^:=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "mvals", "}"}], ",", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"mvals", "=", 
       RowBox[{"Last", "/@", "kets"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\"\<\[LeftBracketingBar]\>\"", "<>", 
       RowBox[{"StringJoin", "@@", 
        RowBox[{"(", 
         RowBox[{"mvals", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"-", "1"}], "/", "2"}], "->", "\"\<\[Beta]\>\""}], ",", 
            
            RowBox[{
             RowBox[{"1", "/", "2"}], "->", "\"\<\[Alpha]\>\""}]}], "}"}]}], 
         ")"}]}], "<>", "\"\<\[RightAngleBracket]\>\""}]}], 
     "\[IndentingNewLine]", ")"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527309134687*^9, {3.433529673039196*^9, 3.433529679168274*^9}, {
   3.43352999216604*^9, 3.4335300099391823`*^9}, {3.433530597072773*^9, 
   3.433530617840526*^9}, {3.433530959631031*^9, 3.433530994310092*^9}, 
   3.438937296104188*^9, {3.438937339720722*^9, 3.438937343243238*^9}, 
   3.4389374579398537`*^9, 3.570343158724043*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["notation for general spins", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433527267081368*^9, 3.433527275606921*^9}, 
   3.570343158725288*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Format", "[", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Ket", "[", 
      RowBox[{
       RowBox[{"kets_", "?", "MatrixQ"}], ",", 
       RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
     "]"}], "/;", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"First", "/@", "kets"}], "==", 
        RowBox[{"First", "/@", "spinsystem"}]}], ")"}], "&&", 
      "\[IndentingNewLine]", 
      RowBox[{"!", 
       RowBox[{"MatchQ", "[", 
        RowBox[{
         RowBox[{"Last", "/@", "spinsystem"}], ",", 
         RowBox[{"{", 
          RowBox[{"Repeated", "[", 
           RowBox[{"1", "/", "2"}], "]"}], "}"}]}], "]"}]}]}], 
     "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}], "^:=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Ivals", ",", "mvals"}], "}"}], ",", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Ivals", "=", 
       RowBox[{"Last", "/@", "spinsystem"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"mvals", "=", 
       RowBox[{"Last", "/@", "kets"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"RowBox", "[", "\[IndentingNewLine]", 
        RowBox[{"Flatten", "@", 
         RowBox[{"{", 
          RowBox[{
          "\"\<\[LeftBracketingBar]\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Inner", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"DisplayForm", "@", 
                  RowBox[{"StyleBox", "[", "#1", "]"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"#2", ">", "0"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"DisplayForm", "@", 
                    RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<+\>\"", ",", 
                    RowBox[{"StyleBox", "[", "#2", "]"}]}], "}"}], "]"}]}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"DisplayForm", "@", 
                    RowBox[{"StyleBox", "[", "#2", "]"}]}]}], 
                  "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                "}"}], "&"}], ",", "\[IndentingNewLine]", "Ivals", ",", 
              "\[IndentingNewLine]", "mvals", ",", "\[IndentingNewLine]", 
              "List"}], "]"}], "//.", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"a___", ",", "b_List", ",", "c__List"}], "}"}], 
             "\[RuleDelayed]", 
             RowBox[{"{", 
              RowBox[{"a", ",", "b", ",", "\"\<,\>\"", ",", "c"}], "}"}]}]}], 
           ",", "\[IndentingNewLine]", "\"\<\[RightAngleBracket]\>\""}], 
          "}"}]}], "\[IndentingNewLine]", "]"}], "//", "DisplayForm"}]}], 
     "\[IndentingNewLine]", ")"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527307174115*^9, {3.4335273546606283`*^9, 3.433527375102069*^9}, {
   3.433527646730826*^9, 3.433527665412752*^9}, {3.4335278142235603`*^9, 
   3.433527828066536*^9}, {3.43352886218329*^9, 3.4335288651888103`*^9}, {
   3.433529076549699*^9, 3.433529096799673*^9}, {3.433529452478706*^9, 
   3.433529477797674*^9}, {3.433530215689196*^9, 3.433530250356915*^9}, 
   3.4335304675056047`*^9, {3.433531058452547*^9, 3.433531103929535*^9}, 
   3.433531253116337*^9, {3.433570150270357*^9, 3.433570151101845*^9}, 
   3.433570513550333*^9, {3.438937268901223*^9, 3.438937276193701*^9}, {
   3.438937352170002*^9, 3.438937355991117*^9}, 3.438937462301223*^9, 
   3.5703431587263403`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Adjoint", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431092174992111*^9, 3.431092176181019*^9}, 
   3.570343158727796*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Adjoint", "[", 
     RowBox[{"Ket", "[", "a___", "]"}], "]"}]}], "^:=", 
   RowBox[{"Bra", "[", "a", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310921778748827`*^9, 3.431092189070763*^9}, {
   3.431092299506341*^9, 3.431092302615196*^9}, 3.570343158728115*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Adjoint", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Adjoint", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"n1___", ",", 
       RowBox[{"Ket", "[", "a___", "]"}], ",", "n2___"}], "]"}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"ComplexExpand", "@", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"n1", "*", "n2"}], "]"}]}], "*", 
    RowBox[{"Bra", "[", "a", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310921778748827`*^9, 3.431092201974896*^9}, 
   3.4310923129713182`*^9, {3.4388529457982903`*^9, 3.438853016352058*^9}, {
   3.438854099104802*^9, 3.438854103639477*^9}, 3.438854206380229*^9, {
   3.448290960645425*^9, 3.448290964011812*^9}, 3.5703431587294817`*^9, {
   3.657821195926923*^9, 3.65782119677285*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431092174992111*^9, 3.431092176181019*^9}, {
   3.460642489525651*^9, 3.460642526180264*^9}, {3.4826800325166817`*^9, 
   3.482680048202726*^9}, {3.48653746245815*^9, 3.486537464423171*^9}, 
   3.502068618011084*^9, 3.5470136797154922`*^9, 3.5703431587306767`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SpinSystem", "[", 
   RowBox[{"Ket", "[", 
    RowBox[{"id_", ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "]"}],
   ":=", "spinsys"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4826800496033573`*^9, 3.482680092861084*^9}, {
   3.502068507629322*^9, 3.502068533210311*^9}, 3.570343158730991*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["KetQ", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}, {
   3.4483476122476683`*^9, 3.4483476127491083`*^9}, 3.570343158732218*^9},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KetQ", "[", "$Failed", "]"}], "=", "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448307746358148*^9, 3.448307754710662*^9}, 
   3.448347693291162*^9, 3.570343158732505*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"KetQ", "[", 
     RowBox[{"Times", "[", "x__", "]"}], "]"}]}], ":=", 
   RowBox[{"Or", "@@", 
    RowBox[{"(", 
     RowBox[{"KetQ", "/@", 
      RowBox[{"{", "x", "}"}]}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291401492332*^9, 3.448291511758871*^9}, {
   3.448291659933428*^9, 3.448291688974347*^9}, {3.448291749856472*^9, 
   3.448291832272952*^9}, {3.4482921316857443`*^9, 3.448292134260504*^9}, {
   3.44834770635611*^9, 3.448347708611017*^9}, 3.570343158733741*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"KetQ", "[", 
     RowBox[{"Plus", "[", "x__", "]"}], "]"}]}], ":=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{"KetQ", "/@", 
      RowBox[{"{", "x", "}"}]}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291401492332*^9, 3.448291511758871*^9}, {
   3.448291659933428*^9, 3.448291688974347*^9}, {3.448291749856472*^9, 
   3.448291832272952*^9}, {3.4482921316857443`*^9, 3.448292134260504*^9}, {
   3.448346879187158*^9, 3.448346879984984*^9}, {3.448347713291296*^9, 
   3.448347734711936*^9}, 3.570343158734981*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"KetQ", "[", 
     RowBox[{"Ket", "[", "___", "]"}], "]"}]}], ":=", "True"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291585748311*^9, 3.448291603371173*^9}, 
   3.4482916532125387`*^9, {3.4482919449213467`*^9, 3.448291948948346*^9}, {
   3.4483073628982487`*^9, 3.44830737590583*^9}, {3.448347768617799*^9, 
   3.4483477771483803`*^9}, 3.5703431587361794`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"KetQ", "[", "x_", "]"}], ":=", "False"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291844442856*^9, 3.448291854862982*^9}, 
   3.4483074348827744`*^9, {3.4483076873582897`*^9, 3.448307690050252*^9}, {
   3.4483079087170343`*^9, 3.448307910856666*^9}, 3.448347781457934*^9, 
   3.5703431587373457`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Messages", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.547014009842368*^9, 3.570343158738551*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "::", "invalid\[Alpha]\[Beta]"}], "=", 
   "\"\<state indices \[Alpha] and \[Beta] may only be used with \
spins-1/2\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.570343158738847*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "::", "invalidab"}], "=", 
   "\"\<indices a and b have been superseded by \[Alpha] and \[Beta]\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.570343158740007*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "::", "invalidnum"}], "=", 
   "\"\<the number of spins in the Ket and in the spin system do not match.\>\
\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.547013874598929*^9, 3.5470138820397043`*^9}, {
   3.5470144290393476`*^9, 3.547014438249095*^9}, {3.547480303200651*^9, 
   3.547480347803083*^9}, 3.5703431587412357`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "::", "invalidspins"}], "=", 
   "\"\<The following spins do not belong to the requested spin system: `1`\>\
\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.547013874598929*^9, 3.5470138820397043`*^9}, {
   3.547480112149914*^9, 3.547480119719061*^9}, {3.547480262263797*^9, 
   3.547480284804515*^9}, 3.570343158742426*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "::", "invalidm"}], "=", 
   "\"\<the following pairs of spins and magnetic quantum numbers are \
invalid: `1`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.54701631199524*^9, 3.547016329883703*^9}, {
   3.5474806152070713`*^9, 3.5474806305980797`*^9}, 3.547481001990192*^9, 
   3.570343158743614*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "::", "dupspins"}], "=", 
   "\"\<product ket must be unique for each spin\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.570343158744816*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "::", "inappid"}], "=", 
   "\"\<inappropriate identifier\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4863904887084837`*^9, 3.486390511331934*^9}, 
   3.570343158745989*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Ket", "::", "inappbl"}], "=", 
   "\"\<inappropriate basis label\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4863904887084837`*^9, 3.486390511331934*^9}, {
   3.5470179642166967`*^9, 3.5470179675955973`*^9}, 3.570343158747178*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Bra", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.547016732145212*^9, 3.547016732725533*^9}, 
   3.547016915655939*^9}],

Cell[CellGroupData[{

Cell["properties", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456165698465754*^9, 3.456165702536334*^9}, {
  3.460366510406715*^9, 3.460366512373371*^9}, {3.460366553134673*^9, 
  3.460366553649557*^9}, {3.502166412932279*^9, 3.502166415362692*^9}, {
  3.530617644510482*^9, 3.530617646155493*^9}, {3.547015193191354*^9, 
  3.547015194620152*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Bra", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Validity", "\[Rule]", "Undefined"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547015195991577*^9, 3.547015215062867*^9}, 
   3.547016742524148*^9, 3.5474798429888268`*^9, {3.5475302996421957`*^9, 
   3.547530303252842*^9}}],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Bra", ",", "NHoldAll"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.530617652915752*^9, 3.530617681579221*^9}, {
   3.53269165405834*^9, 3.532691654568581*^9}, {3.532691981791937*^9, 
   3.53269198604044*^9}, 3.547016743765354*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["generalities", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.547013633187716*^9, 3.5470136348584747`*^9}}],

Cell[CellGroupData[{

Cell["default to current spin system", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "[", 
    RowBox[{"id_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Bra", "[", 
    RowBox[{"id", ",", 
     RowBox[{"SpinSystem", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.456162354482678*^9, {3.4864509197927723`*^9, 3.486450929773013*^9}, {
   3.54701674551602*^9, 3.547016746181054*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "[", 
    RowBox[{"id_", ",", "Undefined", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438927343640579*^9, 3.438927372092021*^9}, 
   3.448355861478483*^9, 3.456164492527885*^9, 3.4864509375678463`*^9, 
   3.547016746877742*^9, 3.547228611216648*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["eliminate any dot products involving zero", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431092174992111*^9, 3.431092176181019*^9}, {
  3.460642489525651*^9, 3.460642526180264*^9}, {3.4826800325166817`*^9, 
  3.482680048202726*^9}, {3.48653746245815*^9, 3.486537464423171*^9}, {
  3.486537496160138*^9, 3.486537503582787*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Bra", "/:", 
   RowBox[{"HoldPattern", "[", 
    RowBox[{"Dot", "[", 
     RowBox[{"___", ",", 
      RowBox[{"Bra", "[", "___", "]"}], ",", "0", ",", "___"}], "]"}], "]"}], 
   "=", "0"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486537515139436*^9, 3.4865375329378853`*^9}, {
  3.547016749470229*^9, 3.5470167502451982`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["check input validity", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
  3.486452077545096*^9, 3.4864521531961813`*^9}, {3.5470135609391937`*^9, 
  3.5470135648101883`*^9}}],

Cell[CellGroupData[{

Cell["\<\
if the identifier is a string of \[Alpha] and \[Beta]'s , check for validity \
and translate\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
  3.486452077545096*^9, 3.4864521531961813`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bra", "[", 
     RowBox[{"id_String", ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"Validity", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Bra", "]"}]}], "]"}]}], ")"}], "&&", 
     "\[IndentingNewLine]", 
     RowBox[{"StringMatchQ", "[", 
      RowBox[{"id", ",", 
       RowBox[{"Repeated", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\"\<\[Alpha]\>\"", "|", "\"\<\[Beta]\>\""}], ")"}], ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "spinsys", "]"}], "}"}]}], "]"}]}], "]"}], "&&",
      "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"Last", "/@", "spinsys"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"1", "/", "2"}], ".."}], "}"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Bra", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MapThread", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"#1", ",", 
          RowBox[{"Switch", "[", 
           RowBox[{"#2", ",", "\"\<\[Alpha]\>\"", ",", 
            RowBox[{"1", "/", "2"}], ",", "\"\<\[Beta]\>\"", ",", 
            RowBox[{
             RowBox[{"-", "1"}], "/", "2"}]}], "]"}]}], "}"}], "&"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"First", "/@", "spinsys"}], ",", 
         RowBox[{"Characters", "[", "id", "]"}]}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "spinsys", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Validity", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
       "opts"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486452120596053*^9, 3.486452169710497*^9}, {
  3.486452269447176*^9, 3.486452294183125*^9}, {3.486452330546908*^9, 
  3.486452397486413*^9}, {3.486452539002718*^9, 3.4864525591368504`*^9}, {
  3.4864527330306053`*^9, 3.486452744860353*^9}, {3.547015246676133*^9, 
  3.547015347485002*^9}, {3.547479836541873*^9, 3.54747983789174*^9}, {
  3.54748110684379*^9, 3.547481108781993*^9}, {3.54753032100172*^9, 
  3.547530337956895*^9}, {3.5475304481756077`*^9, 3.547530451695966*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
if the identifier is not a list, use it as a label of a defined state basis.\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
  3.502023996117338*^9, 3.502023996369627*^9}, {3.502024396129133*^9, 
  3.502024400837843*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "[", 
    RowBox[{
     RowBox[{"id", ":", 
      RowBox[{"Except", "[", "_List", "]"}]}], ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   
   RowBox[{"Bra", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"id", ",", 
       RowBox[{"Basis", "[", "]"}]}], "}"}], ",", "spinsys", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486451016723567*^9, 3.4864510747264643`*^9}, {
  3.5474811101063013`*^9, 3.547481110845788*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"id", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", "Undefined"}], "}"}], 
     ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486451088088696*^9, 3.486451093663088*^9}, {
   3.486451123890458*^9, 3.486451142866674*^9}, 3.547025203271402*^9, 
   3.547481111809506*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bra", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"id", ":", 
         RowBox[{"Except", "[", "_List", "]"}]}], ",", 
        RowBox[{"basis_", "?", "DefinedBasisQ"}]}], "}"}], ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MemberQ", "[", 
     RowBox[{
      RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "id"}], "]"}]}], ":=", 
   
   RowBox[{"First", "@", 
    RowBox[{"Extract", "[", 
     RowBox[{
      RowBox[{"BasisBras", "[", "basis", "]"}], ",", 
      RowBox[{"Position", "[", 
       RowBox[{
        RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "id"}], "]"}]}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486389009042329*^9, 3.486389161349902*^9}, {
   3.4863893449866047`*^9, 3.4863893650423803`*^9}, {3.486451187456595*^9, 
   3.486451208247272*^9}, {3.486451745825087*^9, 3.486451764680912*^9}, {
   3.502024113358232*^9, 3.502024135156452*^9}, {3.5020695951306133`*^9, 
   3.5020695998307877`*^9}, 3.50207027024127*^9, {3.547019298208593*^9, 
   3.547019306344761*^9}, 3.547481112610408*^9, {3.5519394570917683`*^9, 
   3.5519394591602287`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bra", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"id", ":", 
         RowBox[{"Except", "[", "_List", "]"}]}], ",", 
        RowBox[{"basis_", "?", "DefinedBasisQ"}]}], "}"}], ",", 
      RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"TrueQ", "[", 
      RowBox[{"MemberQ", "[", 
       RowBox[{
        RowBox[{"BasisLabels", "[", "basis", "]"}], ",", "id"}], "]"}], 
      "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Bra", "::", "inappbl"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486451427173036*^9, 3.486451448933189*^9}, 
   3.486451771635577*^9, 3.5020241532778177`*^9, 3.502069621828886*^9, 
   3.50207027328684*^9, {3.5470179494257793`*^9, 3.547017949897129*^9}, 
   3.5470193778696404`*^9, 3.547019417919765*^9, {3.547481113628357*^9, 
   3.547481114766233*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["check validity of all spins", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
  3.502023996117338*^9, 3.502023996369627*^9}, {3.502024396129133*^9, 
  3.502024400837843*^9}, {3.5470137311280107`*^9, 3.547013737295046*^9}, {
  3.547014348884225*^9, 3.5470143509551573`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bra", "[", 
     RowBox[{
      RowBox[{"bras_", "?", "MatrixQ"}], ",", 
      RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"Validity", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Bra", "]"}]}], "]"}]}], ")"}], "&&", 
     RowBox[{"!", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Length", "[", "bras", "]"}], "\[Equal]", 
        RowBox[{"Length", "[", "spinsystem", "]"}]}], ")"}]}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Bra", "::", "invalidnum"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470137540859337`*^9, 3.54701385891964*^9}, {
   3.547013891635468*^9, 3.547013902990355*^9}, {3.5470143780855713`*^9, 
   3.547014402736335*^9}, 3.547014443652863*^9, {3.547015406685961*^9, 
   3.5470154096435833`*^9}, 3.547479838675273*^9, {3.547481115816525*^9, 
   3.547481117523978*^9}, {3.547481165800358*^9, 3.5474811673536787`*^9}, 
   3.547530350558239*^9, 3.547530462228406*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bra", "[", 
     RowBox[{
      RowBox[{"bras_", "?", "MatrixQ"}], ",", 
      RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"Validity", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Bra", "]"}]}], "]"}]}], ")"}], "&&", 
     RowBox[{"!", 
      RowBox[{"And", "@@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"MemberQ", "[", 
           RowBox[{
            RowBox[{"First", "/@", "spinsystem"}], ",", 
            RowBox[{"First", "[", "#", "]"}]}], "]"}], "&"}], "/@", "bras"}], 
        ")"}]}]}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "invalspins", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"invalspins", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"First", "/@", "bras"}], ",", 
          RowBox[{
           RowBox[{"!", 
            RowBox[{"MemberQ", "[", 
             RowBox[{
              RowBox[{"First", "/@", "spinsystem"}], ",", "#"}], "]"}]}], 
           "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"Bra", "::", "invalidspins"}], ",", "invalspins"}], "]"}], 
       ";", "\[IndentingNewLine]", "$Failed"}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470137540859337`*^9, 3.54701385891964*^9}, {
   3.547013891635468*^9, 3.547013902990355*^9}, 3.5470154152223167`*^9, 
   3.5474798393856153`*^9, {3.5474801572143717`*^9, 3.5474802641996803`*^9}, 
   3.5474807460504513`*^9, {3.547481118327032*^9, 3.547481120226515*^9}, {
   3.547481168185363*^9, 3.547481169772537*^9}, 3.547530356306225*^9, 
   3.547530468711019*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["reorder spins if needed", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
   3.502023996117338*^9, 3.502023996369627*^9}, {3.502024396129133*^9, 
   3.502024400837843*^9}, {3.5470137311280107`*^9, 3.547013737295046*^9}, {
   3.547014348884225*^9, 3.5470143509551573`*^9}, 3.5703431587160263`*^9, {
   3.695466312307742*^9, 3.695466316634486*^9}}],

Cell["\<\
this happens if the set of spin labels used for the bras is the same as in \
spinsystem, but in the wrong order.  \
\>", "Text",
 CellChangeTimes->{{3.6954675162699747`*^9, 3.695467574755065*^9}, {
  3.695468869829382*^9, 3.6954688705313168`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "[", 
    RowBox[{
     RowBox[{"bras_", "?", "MatrixQ"}], ",", 
     RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spinlabels", ",", "braspinlabels", ",", "perm"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"perm", "=", 
         RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
          RowBox[{"Inner", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"List", "[", 
                RowBox[{"#1", ",", "#2"}], "]"}], "\[Rule]", "1"}], ")"}], 
             "&"}], ",", 
            RowBox[{"Ordering", "[", "spinlabels", "]"}], ",", 
            RowBox[{"Ordering", "[", "braspinlabels", "]"}], ",", "List"}], 
           "]"}], "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"Bra", "[", 
         RowBox[{
          RowBox[{"perm", ".", "bras"}], ",", "spinsystem", ",", "opts"}], 
         "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"!", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"Validity", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Bra", "]"}]}], "]"}]}], ")"}], "&&", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"spinlabels", "=", 
           RowBox[{"First", "/@", "spinsystem"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"braspinlabels", "=", 
           RowBox[{"First", "/@", "bras"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"spinlabels", "\[NotEqual]", "braspinlabels"}], ")"}], "&&",
            "\[IndentingNewLine]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Sort", "[", "spinlabels", "]"}], "\[Equal]", 
             RowBox[{"Sort", "[", "braspinlabels", "]"}]}], ")"}]}]}], 
         "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470137540859337`*^9, 3.54701385891964*^9}, {
   3.547013891635468*^9, 3.547013902990355*^9}, 3.5470154152223167`*^9, 
   3.5474798393856153`*^9, {3.5474801572143717`*^9, 3.5474802641996803`*^9}, 
   3.5474807460504513`*^9, 3.54753024499543*^9, 3.547530431260914*^9, 
   3.5703431587181597`*^9, {3.695466330851245*^9, 3.695466513735317*^9}, {
   3.6954666420562773`*^9, 3.6954666649332933`*^9}, {3.6954674442631083`*^9, 
   3.695467534590068*^9}, {3.695467940143546*^9, 3.695467976804677*^9}, {
   3.695468731297689*^9, 3.695468734952787*^9}, {3.69546880741505*^9, 
   3.695468827839682*^9}, 3.695468865327989*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["check validity of spin quantum numbers", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
  3.502023996117338*^9, 3.502023996369627*^9}, {3.502024396129133*^9, 
  3.502024400837843*^9}, {3.5470137311280107`*^9, 3.547013737295046*^9}, {
  3.54701398063899*^9, 3.547013983083658*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bra", "[", 
     RowBox[{
      RowBox[{"bras_", "?", "MatrixQ"}], ",", 
      RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"TrueQ", "[", 
        RowBox[{
         RowBox[{"Validity", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Bra", "]"}]}], "]"}]}], ")"}], "&&", 
     RowBox[{"!", 
      RowBox[{"Inner", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"-", "#2"}], ",", "#2", ",", "1"}], "]"}], ",", "#1"}], 
          "]"}], "&"}], ",", 
        RowBox[{"Last", "/@", "bras"}], ",", 
        RowBox[{"Last", "/@", "spinsystem"}], ",", "And"}], "]"}]}]}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "invalIjMjpairs", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"invalIjMjpairs", "=", 
        RowBox[{"Select", "[", 
         RowBox[{"bras", ",", 
          RowBox[{
           RowBox[{"!", 
            RowBox[{"MemberQ", "[", 
             RowBox[{
              RowBox[{"Range", "[", 
               RowBox[{
                RowBox[{"-", 
                 RowBox[{"SpinQuantumNumber", "[", 
                  RowBox[{
                   RowBox[{"First", "[", "#", "]"}], ",", "spinsystem"}], 
                  "]"}]}], ",", 
                RowBox[{"SpinQuantumNumber", "[", 
                 RowBox[{
                  RowBox[{"First", "[", "#", "]"}], ",", "spinsystem"}], 
                 "]"}], ",", "1"}], "]"}], ",", 
              RowBox[{"Last", "[", "#", "]"}]}], "]"}]}], "&"}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"Bra", "::", "invalidm"}], ",", "invalIjMjpairs"}], "]"}], 
       ";", "\[IndentingNewLine]", "$Failed"}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5470137540859337`*^9, 3.54701385891964*^9}, {
   3.547013891635468*^9, 3.547013902990355*^9}, {3.5470140021300898`*^9, 
   3.547014016561652*^9}, {3.547014294420295*^9, 3.5470143427121983`*^9}, {
   3.547014467235573*^9, 3.5470145168849707`*^9}, {3.547015027246422*^9, 
   3.547015072670374*^9}, 3.547015425907599*^9, 3.5474798401859837`*^9, {
   3.547480361398184*^9, 3.547480391659873*^9}, {3.547480429242442*^9, 
   3.547480606283288*^9}, 3.547480742932478*^9, {3.547480824026526*^9, 
   3.547480857117519*^9}, {3.547481121347077*^9, 3.5474811232714157`*^9}, {
   3.547481170831525*^9, 3.54748117292737*^9}, 3.547530360916472*^9, 
   3.547530473673263*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["if all validity checks are passed, suppress further checks", \
"Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
  3.502023996117338*^9, 3.502023996369627*^9}, {3.502024396129133*^9, 
  3.502024400837843*^9}, {3.5470137311280107`*^9, 3.547013737295046*^9}, {
  3.54701398063899*^9, 3.547013983083658*^9}, {3.547015435823205*^9, 
  3.547015447445345*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Bra", "[", 
     RowBox[{
      RowBox[{"bras_", "?", "MatrixQ"}], ",", 
      RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"!", 
      RowBox[{"TrueQ", "[", 
       RowBox[{
        RowBox[{"Validity", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Bra", "]"}]}], "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Bra", "[", 
    RowBox[{"bras", ",", "spinsystem", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Validity", "\[Rule]", "True"}], ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.547015459496625*^9, 3.547015494249064*^9}, {
   3.5474798411546993`*^9, 3.547479841839082*^9}, {3.547480131352581*^9, 
   3.547480136041061*^9}, {3.547480715600648*^9, 3.5474807170304823`*^9}, {
   3.547481124799241*^9, 3.5474811284224977`*^9}, {3.547481174229228*^9, 
   3.5474811752339287`*^9}, {3.547530376970826*^9, 3.547530383220038*^9}, 
   3.54753047865348*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["output format", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486450968759159*^9, 3.486451001016008*^9}, {
  3.486452077545096*^9, 3.4864521531961813`*^9}, {3.5470135609391937`*^9, 
  3.547013593106125*^9}}],

Cell[CellGroupData[{

Cell["\[Alpha]\[Beta] output notation for spins-1/2", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Format", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"bras_", "?", "MatrixQ"}], ",", 
       RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
     "]"}], "/;", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"First", "/@", "bras"}], "==", 
        RowBox[{"First", "/@", "spinsystem"}]}], ")"}], "&&", 
      "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"Last", "/@", "spinsystem"}], ",", 
        RowBox[{"{", 
         RowBox[{"Repeated", "[", 
          RowBox[{"1", "/", "2"}], "]"}], "}"}]}], "]"}]}], 
     "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}], "^:=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "mvals", "}"}], ",", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"mvals", "=", 
       RowBox[{"Last", "/@", "bras"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\"\<<\>\"", "<>", 
       RowBox[{"StringJoin", "@@", 
        RowBox[{"(", 
         RowBox[{"mvals", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"-", "1"}], "/", "2"}], "->", "\"\<\[Beta]\>\""}], ",", 
            
            RowBox[{
             RowBox[{"1", "/", "2"}], "->", "\"\<\[Alpha]\>\""}]}], "}"}]}], 
         ")"}]}], "<>", "\"\<|\>\""}]}], "\[IndentingNewLine]", ")"}]}], 
   "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527309134687*^9, {3.433529673039196*^9, 3.433529679168274*^9}, {
   3.43352999216604*^9, 3.4335300099391823`*^9}, {3.433530597072773*^9, 
   3.433530617840526*^9}, {3.433530959631031*^9, 3.433530994310092*^9}, 
   3.438937296104188*^9, {3.438937339720722*^9, 3.438937343243238*^9}, 
   3.4389374579398537`*^9, 3.547016773499071*^9, {3.547016840451538*^9, 
   3.547016842346196*^9}, {3.547016964568886*^9, 3.547016970613193*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["notation for general spins", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433527267081368*^9, 3.433527275606921*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Format", "[", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Bra", "[", 
      RowBox[{
       RowBox[{"bras_", "?", "MatrixQ"}], ",", 
       RowBox[{"spinsystem_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], 
     "]"}], "/;", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"First", "/@", "bras"}], "==", 
        RowBox[{"First", "/@", "spinsystem"}]}], ")"}], "&&", 
      "\[IndentingNewLine]", 
      RowBox[{"!", 
       RowBox[{"MatchQ", "[", 
        RowBox[{
         RowBox[{"Last", "/@", "spinsystem"}], ",", 
         RowBox[{"{", 
          RowBox[{"Repeated", "[", 
           RowBox[{"1", "/", "2"}], "]"}], "}"}]}], "]"}]}]}], 
     "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}], "^:=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Ivals", ",", "mvals"}], "}"}], ",", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Ivals", "=", 
       RowBox[{"Last", "/@", "spinsystem"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"mvals", "=", 
       RowBox[{"Last", "/@", "bras"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"RowBox", "[", "\[IndentingNewLine]", 
        RowBox[{"Flatten", "@", 
         RowBox[{"{", 
          RowBox[{"\"\<<\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Inner", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"DisplayForm", "@", 
                  RowBox[{"StyleBox", "[", "#1", "]"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"#2", ">", "0"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"DisplayForm", "@", 
                    RowBox[{"RowBox", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<+\>\"", ",", 
                    RowBox[{"StyleBox", "[", "#2", "]"}]}], "}"}], "]"}]}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"DisplayForm", "@", 
                    RowBox[{"StyleBox", "[", "#2", "]"}]}]}], 
                  "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                "}"}], "&"}], ",", "\[IndentingNewLine]", "Ivals", ",", 
              "\[IndentingNewLine]", "mvals", ",", "\[IndentingNewLine]", 
              "List"}], "]"}], "//.", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"a___", ",", "b_List", ",", "c__List"}], "}"}], 
             "\[RuleDelayed]", 
             RowBox[{"{", 
              RowBox[{"a", ",", "b", ",", "\"\<,\>\"", ",", "c"}], "}"}]}]}], 
           ",", "\[IndentingNewLine]", "\"\<|\>\""}], "}"}]}], 
        "\[IndentingNewLine]", "]"}], "//", "DisplayForm"}]}], 
     "\[IndentingNewLine]", ")"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527307174115*^9, {3.4335273546606283`*^9, 3.433527375102069*^9}, {
   3.433527646730826*^9, 3.433527665412752*^9}, {3.4335278142235603`*^9, 
   3.433527828066536*^9}, {3.43352886218329*^9, 3.4335288651888103`*^9}, {
   3.433529076549699*^9, 3.433529096799673*^9}, {3.433529452478706*^9, 
   3.433529477797674*^9}, {3.433530215689196*^9, 3.433530250356915*^9}, 
   3.4335304675056047`*^9, {3.433531058452547*^9, 3.433531103929535*^9}, 
   3.433531253116337*^9, {3.433570150270357*^9, 3.433570151101845*^9}, 
   3.433570513550333*^9, {3.438937268901223*^9, 3.438937276193701*^9}, {
   3.438937352170002*^9, 3.438937355991117*^9}, 3.438937462301223*^9, 
   3.547016775213526*^9, {3.5470168434209137`*^9, 3.547016845289077*^9}, {
   3.5470169756711807`*^9, 3.5470169791283417`*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Adjoint", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431092174992111*^9, 3.431092176181019*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Adjoint", "[", 
     RowBox[{"Bra", "[", "a___", "]"}], "]"}]}], "^:=", 
   RowBox[{"Ket", "[", "a", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310921778748827`*^9, 3.431092189070763*^9}, {
   3.431092299506341*^9, 3.431092302615196*^9}, 3.547016776428224*^9, {
   3.54701698830956*^9, 3.547016988759384*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Adjoint", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Adjoint", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"n1___", ",", 
       RowBox[{"Bra", "[", "a___", "]"}], ",", "n2___"}], "]"}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"ComplexExpand", "@", 
     RowBox[{"Conjugate", "[", 
      RowBox[{"n1", "*", "n2"}], "]"}]}], "*", 
    RowBox[{"Ket", "[", "a", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310921778748827`*^9, 3.431092201974896*^9}, 
   3.4310923129713182`*^9, {3.4388529457982903`*^9, 3.438853016352058*^9}, {
   3.438854099104802*^9, 3.438854103639477*^9}, 3.438854206380229*^9, {
   3.448290960645425*^9, 3.448290964011812*^9}, 3.5470167774666643`*^9, {
   3.54701699340545*^9, 3.5470169939695187`*^9}, {3.657821202117484*^9, 
   3.657821203164516*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431092174992111*^9, 3.431092176181019*^9}, {
   3.460642489525651*^9, 3.460642526180264*^9}, {3.4826800325166817`*^9, 
   3.482680048202726*^9}, {3.48653746245815*^9, 3.486537464423171*^9}, 
   3.502068618011084*^9, 3.5470136797154922`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SpinSystem", "[", 
   RowBox[{"Bra", "[", 
    RowBox[{"id_", ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "]"}],
   ":=", "spinsys"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4826800496033573`*^9, 3.482680092861084*^9}, {
   3.502068507629322*^9, 3.502068533210311*^9}, 3.547016779985538*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["BraQ", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}, {
  3.4483476122476683`*^9, 3.4483476127491083`*^9}, {3.5470168747466707`*^9, 
  3.5470168964291563`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BraQ", "[", "$Failed", "]"}], "=", "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448307746358148*^9, 3.448307754710662*^9}, 
   3.448347693291162*^9, 3.547016897195221*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"BraQ", "[", 
     RowBox[{"Times", "[", "x__", "]"}], "]"}]}], ":=", 
   RowBox[{"Or", "@@", 
    RowBox[{"(", 
     RowBox[{"BraQ", "/@", 
      RowBox[{"{", "x", "}"}]}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291401492332*^9, 3.448291511758871*^9}, {
  3.448291659933428*^9, 3.448291688974347*^9}, {3.448291749856472*^9, 
  3.448291832272952*^9}, {3.4482921316857443`*^9, 3.448292134260504*^9}, {
  3.44834770635611*^9, 3.448347708611017*^9}, {3.547016898797964*^9, 
  3.547016899310134*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"BraQ", "[", 
     RowBox[{"Plus", "[", "x__", "]"}], "]"}]}], ":=", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{"BraQ", "/@", 
      RowBox[{"{", "x", "}"}]}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291401492332*^9, 3.448291511758871*^9}, {
  3.448291659933428*^9, 3.448291688974347*^9}, {3.448291749856472*^9, 
  3.448291832272952*^9}, {3.4482921316857443`*^9, 3.448292134260504*^9}, {
  3.448346879187158*^9, 3.448346879984984*^9}, {3.448347713291296*^9, 
  3.448347734711936*^9}, {3.5470168999642467`*^9, 3.547016900501696*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"BraQ", "[", 
     RowBox[{"Bra", "[", "___", "]"}], "]"}]}], ":=", "True"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291585748311*^9, 3.448291603371173*^9}, 
   3.4482916532125387`*^9, {3.4482919449213467`*^9, 3.448291948948346*^9}, {
   3.4483073628982487`*^9, 3.44830737590583*^9}, {3.448347768617799*^9, 
   3.4483477771483803`*^9}, 3.54701678381647*^9, 3.5470169013139257`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BraQ", "[", "x_", "]"}], ":=", "False"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291844442856*^9, 3.448291854862982*^9}, 
   3.4483074348827744`*^9, {3.4483076873582897`*^9, 3.448307690050252*^9}, {
   3.4483079087170343`*^9, 3.448307910856666*^9}, 3.448347781457934*^9, 
   3.547016902313455*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Messages", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.547014009842368*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "::", "invalid\[Alpha]\[Beta]"}], "=", 
   "\"\<state indices \[Alpha] and \[Beta] may only be used with \
spins-1/2\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.547481214253669*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "::", "invalidab"}], "=", 
   "\"\<indices a and b have been superseded by \[Alpha] and \[Beta]\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.547481214770603*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "::", "invalidnum"}], "=", 
   "\"\<the number of spins in the Bra and in the spin system do not match.\>\
\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.547013874598929*^9, 3.5470138820397043`*^9}, {
  3.5470144290393476`*^9, 3.547014438249095*^9}, {3.547480303200651*^9, 
  3.547480347803083*^9}, {3.54748121560393*^9, 3.547481216692973*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "::", "invalidspins"}], "=", 
   "\"\<The following spins do not belong to the requested spin system: `1`\>\
\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.547013874598929*^9, 3.5470138820397043`*^9}, {
   3.547480112149914*^9, 3.547480119719061*^9}, {3.547480262263797*^9, 
   3.547480284804515*^9}, 3.5474812173935223`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "::", "invalidm"}], "=", 
   "\"\<the following pairs of spins and magnetic quantum numbers are \
invalid: `1`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.54701631199524*^9, 3.547016329883703*^9}, {
   3.5474806152070713`*^9, 3.5474806305980797`*^9}, 3.547481001990192*^9, 
   3.547481217959519*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "::", "dupspins"}], "=", 
   "\"\<product ket must be unique for each spin\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.547481218711605*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "::", "inappid"}], "=", 
   "\"\<inappropriate identifier\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4863904887084837`*^9, 3.486390511331934*^9}, 
   3.547481219230893*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bra", "::", "inappbl"}], "=", 
   "\"\<inappropriate basis label\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4863904887084837`*^9, 3.486390511331934*^9}, {
   3.5470179642166967`*^9, 3.5470179675955973`*^9}, 3.547481220799711*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Bra-Kets", "Section",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Bra", "/:", 
   RowBox[{"HoldPattern", "[", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"Bra", "[", 
       RowBox[{"states_", ",", "spins_", ",", "___Rule"}], "]"}], ",", 
      RowBox[{"Ket", "[", 
       RowBox[{"states_", ",", "spins_", ",", "___Rule"}], "]"}]}], "]"}], 
    "]"}], "=", "1"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4335273072687473`*^9, {3.547017084858756*^9, 
   3.5470170946196003`*^9}},ExpressionUUID->"be15ae0e-1eea-4567-beae-\
fbec64b0e70f"],

Cell[BoxData[
 RowBox[{"Bra", "/:", 
  RowBox[{"HoldPattern", "[", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"Bra", "[", 
      RowBox[{"bra_", ",", "spins_", ",", "___Rule"}], "]"}], ",", 
     RowBox[{"Ket", "[", 
      RowBox[{"ket_", ",", "spins_", ",", "___Rule"}], "]"}]}], "]"}], "]"}], 
  ":=", 
  RowBox[{"0", "/;", 
   RowBox[{"bra", "!=", "ket"}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433527307318677*^9, {3.547017104301849*^9, 3.547017107844352*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Bra", "/:", 
   RowBox[{"HoldPattern", "[", 
    RowBox[{"Dot", "[", 
     RowBox[{
      RowBox[{"Bra", "[", "___", "]"}], ",", "0", ",", 
      RowBox[{"Ket", "[", "___", "]"}]}], "]"}], "]"}], "=", "0"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.433527307369026*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "[", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"bra_", "?", "BraQ"}], ",", 
        RowBox[{"ket_", "?", "KetQ"}]}], "]"}], "]"}], ":=", 
     "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "spinsys", "}"}], ",", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"spinsys", "=", 
          RowBox[{"SpinSystem", "[", "ket", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Dot", "[", 
          RowBox[{
           RowBox[{"VectorRepresentation", "[", 
            RowBox[{"bra", ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "]"}], ",", 
           RowBox[{"VectorRepresentation", "[", 
            RowBox[{"ket", ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "]"}]}], "]"}]}],
         "\[IndentingNewLine]", ")"}]}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, {
  3.683119993176091*^9, 3.683120006752449*^9}, {3.745399564558066*^9, 
  3.745399569754775*^9}},ExpressionUUID->"d9463118-cc27-422a-9c28-\
1cdaba402e0a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Ket-Bra", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.616755752943087*^9, 3.616755754292186*^9}}],

Cell[CellGroupData[{

Cell["expand general Ket.Bra products", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.616757753855721*^9, 3.61675776848033*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"Times", "[", 
         RowBox[{"n1__", ",", 
          RowBox[{"ket_", "?", "KetQ"}], ",", "n2___"}], "]"}], ",", 
        RowBox[{"bra_", "?", "BraQ"}]}], "]"}]}], ":=", 
     RowBox[{"Times", "[", 
      RowBox[{"n1", ",", "n2", ",", 
       RowBox[{"Dot", "[", 
        RowBox[{"ket", ",", "bra"}], "]"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683192830253633*^9, 3.683192966968565*^9}, {
   3.683193057790988*^9, 3.6831930611817102`*^9}, 3.683193608820951*^9, {
   3.745399580013645*^9, 
   3.745399599509503*^9}},ExpressionUUID->"ad5ef632-d63c-4138-b8e8-\
a3dc5abbf8f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"Times", "[", 
         RowBox[{"n1___", ",", 
          RowBox[{"ket_", "?", "KetQ"}], ",", "n2__"}], "]"}], ",", 
        RowBox[{"bra_", "?", "BraQ"}]}], "]"}]}], ":=", 
     RowBox[{"Times", "[", 
      RowBox[{"n1", ",", "n2", ",", 
       RowBox[{"Dot", "[", 
        RowBox[{"ket", ",", "bra"}], "]"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683192830253633*^9, 3.683192966968565*^9}, {
  3.683193057790988*^9, 3.6831930611817102`*^9}, {3.683193608820951*^9, 
  3.683193621547187*^9}, {3.745399584212364*^9, 
  3.745399602068954*^9}},ExpressionUUID->"70305424-02b1-4fdd-9f4b-\
e82cdadc8fdf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"ket_", "?", "KetQ"}], ",", 
        RowBox[{"Times", "[", 
         RowBox[{"n1__", ",", 
          RowBox[{"bra_", "?", "BraQ"}], ",", "n2___"}], "]"}]}], "]"}]}], ":=", 
     RowBox[{"Times", "[", 
      RowBox[{"n1", ",", "n2", ",", 
       RowBox[{"Dot", "[", 
        RowBox[{"ket", ",", "bra"}], "]"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683192830253633*^9, 3.68319293313859*^9}, {
   3.6831929736991243`*^9, 3.683192987581005*^9}, {3.683193041199108*^9, 
   3.6831930488711243`*^9}, 3.683193628531314*^9, {3.7453995891158323`*^9, 
   3.745399592050756*^9}},ExpressionUUID->"c171632e-b7f7-400d-98df-\
7e040ac8f526"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"ket_", "?", "KetQ"}], ",", 
        RowBox[{"Times", "[", 
         RowBox[{"n1___", ",", 
          RowBox[{"bra_", "?", "BraQ"}], ",", "n2__"}], "]"}]}], "]"}]}], ":=", 
     RowBox[{"Times", "[", 
      RowBox[{"n1", ",", "n2", ",", 
       RowBox[{"Dot", "[", 
        RowBox[{"ket", ",", "bra"}], "]"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683192830253633*^9, 3.68319293313859*^9}, {
   3.6831929736991243`*^9, 3.683192987581005*^9}, {3.683193041199108*^9, 
   3.6831930488711243`*^9}, 3.683193630691141*^9, 
   3.745399612002776*^9},ExpressionUUID->"9d1d13f5-be88-4ec8-99bf-\
fb076100e402"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"Plus", "[", 
         RowBox[{"kets__", "?", "KetQ"}], "]"}], ",", 
        RowBox[{"bra_", "?", "BraQ"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
     RowBox[{"Plus", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Dot", "[", 
          RowBox[{"#", ",", "bra"}], "]"}], "&"}], "/@", 
        RowBox[{"{", "kets", "}"}]}], ")"}]}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683192830253633*^9, 3.68319293313859*^9}, {
   3.6831929736991243`*^9, 3.683193032550158*^9}, {3.683193072417038*^9, 
   3.683193115965087*^9}, 
   3.745399617372085*^9},ExpressionUUID->"5ebd5fbc-298c-40b2-810e-\
7e9cd588a165"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"ket_", "?", "KetQ"}], ",", 
        RowBox[{"Plus", "[", 
         RowBox[{"bras__", "?", "BraQ"}], "]"}]}], "]"}]}], ":=", 
     "\[IndentingNewLine]", 
     RowBox[{"Plus", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Dot", "[", 
          RowBox[{"ket", ",", "#"}], "]"}], "&"}], "/@", 
        RowBox[{"{", "bras", "}"}]}], ")"}]}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683192830253633*^9, 3.68319293313859*^9}, {
   3.6831929736991243`*^9, 3.683193032550158*^9}, {3.683193072417038*^9, 
   3.68319317125101*^9}, 
   3.745399622461384*^9},ExpressionUUID->"62f62783-8bda-45b5-bc2a-\
a2d805b882cd"]
}, Open  ]],

Cell[CellGroupData[{

Cell["apply Ket.Bra to a ket", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.616757753855721*^9, 3.61675776848033*^9}, {
  3.674990438512289*^9, 3.6749904481075277`*^9}}],

Cell[BoxData[
 RowBox[{"UserLevelDependentDefinition", "[", 
  RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
   RowBox[{"Dot", "/:", 
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"ket1_", "?", "KetQ"}], ",", 
        RowBox[{"bra2_", "?", "BraQ"}]}], "]"}], "[", 
      RowBox[{"ket3_", "?", "KetQ"}], "]"}], "]"}], ":=", 
    RowBox[{"Dot", "[", 
     RowBox[{"ket1", ",", 
      RowBox[{"Dot", "[", 
       RowBox[{"bra2", ",", "ket3"}], "]"}]}], "]"}]}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.683120041060684*^9, 
  3.7453996276704807`*^9},ExpressionUUID->"78d8a5ca-92fe-4834-a6e0-\
9a28f94690bf"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ProductKet", "Section",
 InitializationCell->True,
 CellChangeTimes->{3.589974082346613*^9, 3.5902341344519176`*^9, 
  3.623912671621937*^9}],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.623910519048006*^9, 3.623910542425253*^9}, {
   3.623910868913475*^9, 3.623910869879321*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProductKet", "[", "args__", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.623910874674595*^9, 3.6239109018743668`*^9}, 
   3.623911359584261*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductKet", "[", 
    RowBox[{"kets__", "?", "KetQ"}], "]"}], ":=", 
   RowBox[{"ProductKet", "[", 
    RowBox[{"{", "kets", "}"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.632938609013384*^9, 3.6329386459788923`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductKet", "[", 
    RowBox[{
     RowBox[{"kets__", "?", "KetQ"}], ",", 
     RowBox[{"spinsys", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_", "?", "KetQ"}], "]"}]}]}], "]"}], ":=", 
   RowBox[{"ProductKet", "[", 
    RowBox[{
     RowBox[{"{", "kets", "}"}], ",", "spinsys"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.632938609013384*^9, 3.6329386869538307`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductKet", "[", 
    RowBox[{"kets", ":", 
     RowBox[{"{", 
      RowBox[{"__", "?", "KetQ"}], "}"}]}], "]"}], ":=", 
   RowBox[{"ProductKet", "[", 
    RowBox[{"kets", ",", 
     RowBox[{"SpinSystem", "[", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.632938709988784*^9, 3.632938745761599*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductKet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ket1_", "?", "KetQ"}], ",", 
       RowBox[{"ket2_", "?", "KetQ"}], ",", 
       RowBox[{"kets3__", "?", "KetQ"}]}], "}"}], ",", "spinsys_"}], "]"}], ":=", 
   RowBox[{"ProductKet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ProductKet", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"ket1", ",", "ket2"}], "}"}], ",", "spinsys"}], "]"}], ",", 
       "kets3"}], "}"}], ",", "spinsys"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.62391111142216*^9, 3.623911175592925*^9}, {
  3.6239113602184877`*^9, 3.623911361300156*^9}, {3.632938762458733*^9, 
  3.6329387712566347`*^9}, {3.632938803715612*^9, 3.632938819068224*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["general ProductKet (including sums and numerical factors)", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.623910519048006*^9, 3.623910551381616*^9}, 
   3.623911801109294*^9, {3.632939430801867*^9, 3.632939437725876*^9}}],

Cell["\<\
This coding is sufficient to handle sums and numerical factors\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.6239127412530537`*^9, 3.623912764169888*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProductKet", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ket1", ":", 
         RowBox[{"Except", "[", "_Ket", "]"}]}], ",", 
        RowBox[{"ket2_", "?", "KetQ"}]}], "}"}], ",", "spinsys_"}], "]"}], "/;", 
    RowBox[{"KetQ", "[", "ket1", "]"}]}], ":=", 
   RowBox[{"ket1", "/.", 
    RowBox[{"ket_Ket", "\[RuleDelayed]", 
     RowBox[{"ProductKet", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket", ",", "ket2"}], "}"}], ",", "spinsys"}], "]"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6239101901825542`*^9, 3.623910205949758*^9}, {
  3.623910276183774*^9, 3.623910343117465*^9}, {3.623911363154051*^9, 
  3.623911363741111*^9}, {3.63293929496004*^9, 3.632939326840867*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProductKet", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ket1_", "?", "KetQ"}], ",", 
        RowBox[{"ket2", ":", 
         RowBox[{"Except", "[", "_Ket", "]"}]}]}], "}"}], ",", "spinsys_"}], 
     "]"}], "/;", 
    RowBox[{"KetQ", "[", "ket2", "]"}]}], ":=", 
   RowBox[{"ket2", "/.", 
    RowBox[{"ket_Ket", "\[RuleDelayed]", 
     RowBox[{"ProductKet", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ket1", ",", "ket"}], "}"}], ",", "spinsys"}], "]"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6239101901825542`*^9, 3.623910205949758*^9}, {
  3.623910276183774*^9, 3.623910386238179*^9}, {3.623911364242696*^9, 
  3.623911364766758*^9}, {3.6329393324813766`*^9, 3.632939347080858*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["elementary ProductKet (without sums or numerical factors)", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.623910519048006*^9, 3.623910542425253*^9}, 
   3.623911798280623*^9, {3.632935740479425*^9, 3.6329357501799*^9}, {
   3.632939443386034*^9, 3.6329394442780027`*^9}}],

Cell["\<\
rearrange Mvals and spinsystem according to ordering in current SpinSystem\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.625911791656616*^9, 3.625911826150445*^9}, {
   3.625918964329218*^9, 3.625918972225142*^9}, 3.6329397774703074`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductKet", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ket1_Ket", ",", "ket2_Ket"}], "}"}], ",", "spinsys_"}], "]"}], 
   ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ssys1", ",", "ssys2", ",", "comspins", ",", "Mvals", ",", "ssys12", 
       ",", "invalspins"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ssys1", "=", 
        RowBox[{
        "ket1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"ssys2", "=", 
        RowBox[{
        "ket2", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"comspins", "=", 
        RowBox[{"Intersection", "[", 
         RowBox[{
          RowBox[{"First", "/@", "ssys1"}], ",", 
          RowBox[{"First", "/@", "ssys2"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Mvals", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
          "ket1", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
          RowBox[{
          "ket2", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ssys12", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{
          "ket1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], ",", 
          RowBox[{
          "ket2", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"invalspins", "=", 
        RowBox[{"Complement", "[", 
         RowBox[{
          RowBox[{"First", "/@", "ssys12"}], ",", 
          RowBox[{"First", "/@", "spinsys"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"comspins", ",", 
            RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", "\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"ProductKet", "::", "comspins"}], ",", "comspins"}], 
            "]"}], ";", "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"invalspins", ",", 
            RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", "\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"ProductKet", "::", "invalspins"}], ",", "invalspins", 
             ",", "spinsys"}], "]"}], ";", "$Failed"}], ")"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"ssys12", ",", "spinsys"}], "]"}], ",", 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"Ket", "[", 
          RowBox[{"Mvals", ",", "ssys12"}], "]"}], ",", "\[IndentingNewLine]",
          "True", ",", "\[IndentingNewLine]", "\t", 
         RowBox[{"Ket", "[", 
          RowBox[{
           RowBox[{"SortBy", "[", 
            RowBox[{"Mvals", ",", 
             RowBox[{
              RowBox[{"Position", "[", 
               RowBox[{
                RowBox[{"First", "/@", "spinsys"}], ",", 
                RowBox[{"First", "[", "#", "]"}]}], "]"}], "&"}]}], "]"}], 
           ",", 
           RowBox[{"SortBy", "[", 
            RowBox[{"ssys12", ",", 
             RowBox[{
              RowBox[{"Position", "[", 
               RowBox[{
                RowBox[{"First", "/@", "spinsys"}], ",", 
                RowBox[{"First", "[", "#", "]"}]}], "]"}], "&"}]}], "]"}]}], 
          "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.623432545897689*^9, 3.6234326025604067`*^9}, {
   3.623432635081326*^9, 3.6234326590943203`*^9}, {3.623432721067717*^9, 
   3.623432781808301*^9}, {3.623910558550976*^9, 3.6239106235798683`*^9}, {
   3.623910654036623*^9, 3.623910776476622*^9}, {3.623910812874585*^9, 
   3.623910858385572*^9}, 3.623911257034464*^9, {3.62391136198685*^9, 
   3.623911362553681*^9}, {3.625911829335518*^9, 3.625911868195174*^9}, {
   3.6259184709674377`*^9, 3.625918783184773*^9}, {3.625928008095697*^9, 
   3.625928058507782*^9}, {3.6259281470931892`*^9, 3.625928158972868*^9}, {
   3.632938844699367*^9, 3.632939226428994*^9}, {3.632939368750246*^9, 
   3.632939371690021*^9}, {3.632940037593093*^9, 3.632940044631793*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.623910519048006*^9, 3.623910551381616*^9}, {
   3.623910911554031*^9, 3.623910919032425*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProductKet", "::", "comspins"}], "=", 
    "\"\<Spins may not be shared between the arguments of ProductKet. The \
following shared spins have been detected: `1`\>\""}], ";"}], " "}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.623910923646888*^9, 3.623910985155714*^9}, {
  3.623911365562028*^9, 3.623911366412546*^9}, {3.623912118692905*^9, 
  3.623912131825795*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProductKet", "::", "invalspins"}], "=", 
    "\"\<Spins `1` are not members of the spin system `2` of the \
ProductKet.\>\""}], ";"}], " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.623910923646888*^9, 3.623910985155714*^9}, {
  3.623911365562028*^9, 3.623911366412546*^9}, {3.623912118692905*^9, 
  3.623912131825795*^9}, {3.632939242848206*^9, 3.632939284202816*^9}, {
  3.632939996173999*^9, 3.632939996621421*^9}, {3.632940049625585*^9, 
  3.632940050997959*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ProductBra", "Section",
 InitializationCell->True,
 CellChangeTimes->{
  3.589974082346613*^9, 3.5902341344519176`*^9, 3.623912671621937*^9, {
   3.623913072410331*^9, 3.623913072871706*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProductBra", "[", "args__", "]"}], ":=", 
   RowBox[{"Adjoint", "@", 
    RowBox[{"ProductKet", "[", 
     RowBox[{"Sequence", "@@", 
      RowBox[{"(", 
       RowBox[{"Adjoint", "/@", 
        RowBox[{"{", "args", "}"}]}], ")"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6329394800355797`*^9, 3.632939495224247*^9}, {
  3.639224528580234*^9, 3.639224547199111*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["MagneticQuantumNumber", "Section",
 InitializationCell->True,
 CellChangeTimes->{3.589974082346613*^9, 3.5902341344519176`*^9}],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.59023579348326*^9, 3.590235808610156*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{
     RowBox[{"bra_", "?", "BraQ"}], ",", "args___"}], "]"}], ":=", 
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{
     RowBox[{"Adjoint", "[", "bra", "]"}], ",", "args"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.589974878357438*^9, 3.589974900393577*^9}, {
  3.590234141475276*^9, 3.590234143081629*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{"ket_", "?", "KetQ"}], "]"}], ":=", 
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{"ket", ",", 
     RowBox[{"First", "/@", 
      RowBox[{"SpinSystem", "[", "ket", "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5899746049657*^9, 3.589974647524126*^9}, {
  3.590234151418014*^9, 3.590234153026173*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{
     RowBox[{"ket_", "?", "KetQ"}], ",", 
     RowBox[{"spin", ":", 
      RowBox[{"Except", "[", "_List", "]"}]}]}], "]"}], ":=", 
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{"ket", ",", 
     RowBox[{"{", "spin", "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.589974957308818*^9, 3.589974973929969*^9}, {
   3.5899750141453*^9, 3.589975015074728*^9}, {3.590234156857205*^9, 
   3.590234159193277*^9}, {3.590234301037053*^9, 3.590234301700452*^9}, 
   3.590235849734704*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{
     RowBox[{"ket_", "?", "KetQ"}], ",", 
     RowBox[{"spinsets", ":", 
      RowBox[{"{", 
       RowBox[{"_List", ".."}], "}"}]}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"MagneticQuantumNumber", "[", 
      RowBox[{"ket", ",", "#"}], "]"}], "&"}], "/@", "spinsets"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.589975134903968*^9, 3.589975179713234*^9}, {
  3.5902343115521727`*^9, 3.590234313454883*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{
     RowBox[{"Except", "[", 
      RowBox[{"_", "?", "KetQ"}], "]"}], ",", "___"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"MagneticQuantumNumber", "::", "inval"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.589974090877286*^9, 3.589974142982876*^9}, {
   3.589974261004925*^9, 3.589974262675785*^9}, {3.5899745417169533`*^9, 
   3.589974543831359*^9}, {3.589975324274494*^9, 3.589975325801852*^9}, {
   3.590234145921743*^9, 3.5902341487295856`*^9}, 3.59023589067236*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to single Zeeman-basis Ket", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.59023579348326*^9, 3.590235821667235*^9}, {
  3.590237288097747*^9, 3.5902372914285717`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MagneticQuantumNumber", "[", 
     RowBox[{"ket_Ket", ",", 
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}]}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"ValidSpinQ", "[", 
      RowBox[{"spins", ",", 
       RowBox[{"SpinSystem", "[", "ket", "]"}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"MagneticQuantumNumber", "::", "invalspins"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5899742802163897`*^9, 3.589974303303499*^9}, {
   3.589974346417694*^9, 3.589974465770938*^9}, {3.590234162003693*^9, 
   3.590234167731175*^9}, 3.590234287995028*^9, {3.682577596703456*^9, 
   3.682577625079878*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{"ket_Ket", ",", 
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}]}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ketspins", ",", "Mvals"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ketspins", ",", "Mvals"}], "}"}], "=", 
        RowBox[{"Transpose", "@", 
         RowBox[{"First", "@", "ket"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Plus", "@@", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Pick", "[", 
            RowBox[{"Mvals", ",", "ketspins", ",", "#"}], "]"}], "&"}], "/@", 
          "spins"}], "]"}]}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5899746689991302`*^9, 3.589974670069777*^9}, {
   3.589974744802473*^9, 3.58997485234245*^9}, {3.589974987321986*^9, 
   3.589974991530768*^9}, {3.590234179900364*^9, 3.590234214040506*^9}, {
   3.59023425745284*^9, 3.590234274122079*^9}, 3.590234518622732*^9, 
   3.590236485448702*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to composite Ket", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.59023579348326*^9, 3.590235821667235*^9}, {
  3.590235910554614*^9, 3.590235914160749*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Times", "[", 
       RowBox[{
        RowBox[{"n1", ":", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_", "?", "KetQ"}], "]"}], "..."}]}], ",", 
        RowBox[{"ket_", "?", "KetQ"}], ",", 
        RowBox[{"n2", ":", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_", "?", "KetQ"}], "]"}], ".."}]}]}], "]"}]}], ",", 
     "spins_"}], "]"}], ":=", 
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{"ket", ",", "spins"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590235928198881*^9, 3.59023598168207*^9}, {
   3.590236681534829*^9, 3.590236682691216*^9}, {3.590236743482777*^9, 
   3.590236752423559*^9}, 3.590236855124093*^9, {3.5902370796335917`*^9, 
   3.590237093848342*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Times", "[", 
       RowBox[{
        RowBox[{"n1", ":", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_", "?", "KetQ"}], "]"}], ".."}]}], ",", 
        RowBox[{"ket_", "?", "KetQ"}], ",", 
        RowBox[{"n2", ":", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_", "?", "KetQ"}], "]"}], "..."}]}]}], "]"}]}], ",", 
     "spins_"}], "]"}], ":=", 
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{"ket", ",", "spins"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590235928198881*^9, 3.59023598168207*^9}, {
   3.590236681534829*^9, 3.590236682691216*^9}, {3.590236743482777*^9, 
   3.590236752423559*^9}, 3.590236855124093*^9, {3.5902370796335917`*^9, 
   3.590237104022614*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{
     RowBox[{"ket", ":", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"Plus", "[", 
        RowBox[{"kets__", "?", "KetQ"}], "]"}]}]}], ",", 
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}]}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Mvals", ",", "x"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Mvals", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"MagneticQuantumNumber", "[", 
           RowBox[{"#", ",", "spins"}], "]"}], "&"}], "/@", 
         RowBox[{"{", "kets", "}"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Switch", "[", 
        RowBox[{"Mvals", ",", 
         RowBox[{"{", 
          RowBox[{"Repeated", "[", "x_", "]"}], "}"}], ",", 
         RowBox[{"First", "@", "Mvals"}], ",", "_", ",", 
         RowBox[{"Union", "[", "Mvals", "]"}]}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5902359911629047`*^9, 3.590236210399851*^9}, {
  3.590236344172352*^9, 3.5902363832349863`*^9}, {3.5902365785871153`*^9, 
  3.590236580438837*^9}, {3.590237225961705*^9, 3.590237226238039*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "[", 
    RowBox[{
     RowBox[{"ket", ":", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"Plus", "[", 
        RowBox[{"kets__", "?", "KetQ"}], "]"}]}]}], ",", 
     RowBox[{"spinsets", ":", 
      RowBox[{"{", 
       RowBox[{"_List", ".."}], "}"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MagneticQuantumNumber", "[", 
      RowBox[{"#", ",", "spinsets"}], "]"}], "&"}], "/@", "kets"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5902359911629047`*^9, 3.590236284926778*^9}, {
  3.590237215040954*^9, 3.59023721668552*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.59023579348326*^9, 3.590235821667235*^9}, {
  3.590235876288445*^9, 3.590235877494555*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "::", "inval"}], "=", 
   "\"\<MagneticQuantumNumber may only be applied to a ket or a bra.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.589974150447557*^9, 3.5899741651778717`*^9}, {
  3.589975304267405*^9, 3.5899753159152107`*^9}, {3.5899755836852713`*^9, 
  3.589975590385994*^9}, {3.59023431543836*^9, 3.5902343192152*^9}, {
  3.5902358958059063`*^9, 3.590235896178331*^9}, {3.590237259672728*^9, 
  3.590237260989275*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MagneticQuantumNumber", "::", "invalspins"}], "=", 
   "\"\<At least one of the specified spins is not valid for the specified \
ket.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.589974150447557*^9, 3.5899741651778717`*^9}, {
  3.589974475170697*^9, 3.589974499678306*^9}, {3.589975051296036*^9, 
  3.589975058503196*^9}, {3.590234323711565*^9, 3.590234337027755*^9}}]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["VectorRepresentation", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"d78bbb7b-24ad-4cfc-8ff8-aa83421cc9f0"],

Cell[CellGroupData[{

Cell["general", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "VectorRepresentation", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Method", "\[Rule]", "Automatic"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439428413360384*^9, 3.439428435600795*^9}, 
   3.439430465209126*^9, 3.43995078797649*^9}],

Cell[CellGroupData[{

Cell["$Failed trap", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VectorRepresentation", "[", 
    RowBox[{"$Failed", ",", "___"}], "]"}], ":=", "$Failed"}], ";"}]], "Input",\

 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
pass basis specifications into function, including trap for unknown basis\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.683189786228153*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VectorRepresentation", "[", 
    RowBox[{"state_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"VectorRepresentation", "[", 
    RowBox[{"state", ",", 
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.456162881610156*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{"state_", ",", "Undefined", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355417134337*^9}, {3.4483554535025663`*^9, 
   3.4483554835690393`*^9}, 3.4483558340741863`*^9, 3.456162359771184*^9, 
   3.456164416466517*^9, 3.547025210681012*^9, 3.5472286159741163`*^9, {
   3.618473285260065*^9, 3.6184732859939537`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VectorRepresentation", "[", 
    RowBox[{"state_", ",", "Undefined", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "default"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{"SpinSystem", "[", "]"}], "]"}], ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"VectorRepresentation", "[", 
      RowBox[{"state", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", ")"}]}],
   ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448353134740058*^9, 3.4483531456559687`*^9}, 
   3.448353277679308*^9, 3.448354037415494*^9, 3.4483541025992613`*^9, 
   3.448355591065969*^9, {3.44835634567667*^9, 3.448356347824398*^9}, 
   3.448357031231312*^9, 3.456162360582917*^9, 3.5470252116499243`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{"state_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"DefinedQ", "[", "basis", "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6831899593078423`*^9, 3.683189988950148*^9}, 
   3.6831900259186153`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["fix or trap inappropriate arguments", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.5319297444260406`*^9, 3.531929753780078*^9}, {
   3.531929909532097*^9, 3.531929915726618*^9}, {3.6267782290119667`*^9, 
   3.6267782413631763`*^9}, 3.626778309724236*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ElementaryVectorRepresentationArgumentPattern", "=", 
   RowBox[{"HoldPattern", "[", 
    RowBox[{
     RowBox[{"_", "?", "NumericQ"}], "|", 
     RowBox[{"_", "?", "KetQ"}], "|", 
     RowBox[{"_", "?", "BraQ"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.626777853074462*^9, 3.626777868575357*^9}, {
   3.626777913870387*^9, 3.6267779194763813`*^9}, {3.626778262584475*^9, 
   3.626778264731461*^9}, {3.6267792643516207`*^9, 3.626779286108348*^9}, {
   3.626779738317361*^9, 3.626779786401582*^9}, {3.626779823629963*^9, 
   3.626779827173409*^9}, 3.626779979108779*^9, {3.6831894043681717`*^9, 
   3.683189415654335*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"PermissibleVectorRepresentationArgumentPattern", "=", 
   RowBox[{"ElementaryVectorRepresentationArgumentPattern", "|", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Plus", "[", 
      RowBox[{"ElementaryVectorRepresentationArgumentPattern", ".."}], 
      "]"}]}], "|", "\[IndentingNewLine]", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Times", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], "..."}], ",", 
       "ElementaryVectorRepresentationArgumentPattern", ",", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], "..."}]}], "]"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.626779788628785*^9, 3.6267798834382*^9}, 
   3.6267799440574303`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VectorRepresentation", "[", 
    RowBox[{
     RowBox[{"arg", ":", 
      RowBox[{
      "Except", "[", "PermissibleVectorRepresentationArgumentPattern", 
       "]"}]}], ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "fixedarg", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"VectorRepresentation", "[", 
        RowBox[{"fixedarg", ",", "basis", ",", "opts"}], "]"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"fixedarg", "=", 
         RowBox[{"Chop", "[", "arg", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{
         "fixedarg", ",", "PermissibleVectorRepresentationArgumentPattern"}], 
         "]"}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.626777618316545*^9, 3.626777675617124*^9}, {
   3.626777761009489*^9, 3.6267778371984663`*^9}, {3.626777874160409*^9, 
   3.6267779072933683`*^9}, {3.626778270452571*^9, 3.626778272282688*^9}, {
   3.626780110353464*^9, 3.626780119702527*^9}, {3.626780163287224*^9, 
   3.62678018585387*^9}, {3.626780241021612*^9, 3.62678026069547*^9}, 
   3.6267804146880608`*^9, 3.640513908583173*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VectorRepresentation", "[", 
    RowBox[{
     RowBox[{"arg", ":", 
      RowBox[{
      "Except", "[", "PermissibleVectorRepresentationArgumentPattern", 
       "]"}]}], ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"VectorRepresentation", "::", "badarg"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929684468029*^9, 3.531929722331521*^9}, {
   3.531929756418811*^9, 3.531929789325817*^9}, {3.5319298388168793`*^9, 
   3.5319298734439783`*^9}, {3.531930063726522*^9, 3.5319300867107153`*^9}, {
   3.53193033230785*^9, 3.531930374757971*^9}, {3.532171820635771*^9, 
   3.532171832215679*^9}, 3.5703425336772327`*^9, {3.626777927935762*^9, 
   3.626777944324647*^9}, {3.6267782739853573`*^9, 3.626778278305336*^9}, 
   3.626780556735364*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ZeemanBasis", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.435138455176607*^9}, {
   3.4351385782893333`*^9, 3.435138578864519*^9}, {3.439428354758057*^9, 
   3.4394283669204197`*^9}, {3.439951929172604*^9, 3.439951931815658*^9}, {
   3.558598456710265*^9, 3.558598458604494*^9}, {3.57026869700731*^9, 
   3.570268702221177*^9}, 3.683190058267489*^9}],

Cell[CellGroupData[{

Cell["kets", "Subsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[CellGroupData[{

Cell["single spin", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570268769396137*^9, 3.570268770851289*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{
      RowBox[{"Ket", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j_", ",", "Mj_"}], "}"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", "___Rule"}], "]"}], 
      ",", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", "___Rule"}], "]"}], 
      ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SparseArray", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "+", "Ij", "-", "Mj"}], "\[Rule]", "1"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"2", "Ij"}], "+", "1"}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570268735851305*^9, 3.5702688155995283`*^9}, {
  3.5702688689584427`*^9, 3.570268871485486*^9}, {3.570268916203123*^9, 
  3.570268917157318*^9}, {3.570269424382745*^9, 3.570269427145556*^9}, {
  3.570270009175034*^9, 3.570270011133791*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["many spins", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570268769396137*^9, 3.570268770851289*^9}, {
  3.570270021012323*^9, 3.570270023193321*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"VectorRepresentation", "[", 
      RowBox[{
       RowBox[{"Ket", "[", 
        RowBox[{
         RowBox[{"jMjvals", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
         RowBox[{"jIjvals", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
         "___Rule"}], "]"}], ",", 
       RowBox[{"basis", ":", 
        RowBox[{"ZeemanBasis", "[", 
         RowBox[{"jIjvals_", ",", "___Rule"}], "]"}]}], ",", "opts___Rule"}], 
      "]"}]}], "/;", 
    RowBox[{
     RowBox[{"Length", "[", "jIjvals", "]"}], ">", "1"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
    RowBox[{"KroneckerProduct", "@@", 
     RowBox[{"Reverse", "[", "\[IndentingNewLine]", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"VectorRepresentation", "[", 
          RowBox[{
           RowBox[{"Ket", "[", 
            RowBox[{
             RowBox[{"{", "#1", "}"}], ",", 
             RowBox[{"{", "#2", "}"}]}], "]"}], ",", 
           RowBox[{"ZeemanBasis", "[", 
            RowBox[{"{", "#2", "}"}], "]"}]}], "]"}], "&"}], ",", 
        RowBox[{"{", 
         RowBox[{"jMjvals", ",", "jIjvals"}], "}"}]}], "]"}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQAWIQ/T58/5T8ma8cK+YsWweiDTRPXQfRSVMSboPo0pL6
JyD63dQ2MD3n/dGPIFqgddNXEP1sV6V0AZA+8qBIGUTbTXJc3guk417OA9Of
pqnu2gekE9oP7QPRYdc4QvcD6SafvHAQ7XE1MwZEzzgknA2ik+9fKgDRV0IW
F4LoDXs7SkG0w1v9MhA99ejSdhB9Wf9SF4h2TVFaCaKNTVaB6TMrrQ6C6LoI
DzCdtFH9OIgWuKZ5Akx/yroAov+lWV4G0fe7eR+B6AdPQsB03QO/ZyB6j/9h
MP1OaOLkA0A6ZqLdVBD9idvi1yMgnf6+DkwDAO4tvJA=
  "]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["bras", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.570270099270917*^9, 3.570270099836899*^9}}],

Cell[CellGroupData[{

Cell["single spin", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570268769396137*^9, 3.570268770851289*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{
      RowBox[{"Bra", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j_", ",", "Mj_"}], "}"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", "___Rule"}], "]"}], 
      ",", 
      RowBox[{"ZeemanBasis", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", "___Rule"}], "]"}], 
      ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SparseArray", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "+", "Ij", "-", "Mj"}], "\[Rule]", "1"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"2", "Ij"}], "+", "1"}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570268735851305*^9, 3.5702688155995283`*^9}, {
  3.5702688689584427`*^9, 3.570268871485486*^9}, {3.570268916203123*^9, 
  3.570268917157318*^9}, {3.570269424382745*^9, 3.570269427145556*^9}, {
  3.570270009175034*^9, 3.570270011133791*^9}, {3.570270108670179*^9, 
  3.570270109121821*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["many spins", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.570268769396137*^9, 3.570268770851289*^9}, {
  3.570270021012323*^9, 3.570270023193321*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"VectorRepresentation", "[", 
      RowBox[{
       RowBox[{"Bra", "[", 
        RowBox[{
         RowBox[{"jMjvals", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
         RowBox[{"jIjvals", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
         "___Rule"}], "]"}], ",", 
       RowBox[{"basis", ":", 
        RowBox[{"ZeemanBasis", "[", 
         RowBox[{"jIjvals_", ",", "___Rule"}], "]"}]}], ",", "opts___Rule"}], 
      "]"}]}], "/;", 
    RowBox[{
     RowBox[{"Length", "[", "jIjvals", "]"}], ">", "1"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
    RowBox[{"KroneckerProduct", "@@", 
     RowBox[{"Reverse", "[", "\[IndentingNewLine]", 
      RowBox[{"MapThread", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"VectorRepresentation", "[", 
          RowBox[{
           RowBox[{"Bra", "[", 
            RowBox[{
             RowBox[{"{", "#1", "}"}], ",", 
             RowBox[{"{", "#2", "}"}]}], "]"}], ",", 
           RowBox[{"ZeemanBasis", "[", 
            RowBox[{"{", "#2", "}"}], "]"}]}], "]"}], "&"}], ",", 
        RowBox[{"{", 
         RowBox[{"jMjvals", ",", "jIjvals"}], "}"}]}], "]"}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQBmIQ/T58/5T8ma8cK+YsWweiDTRPXQfRSVMSboPo0pL6
JyD63dQ2MD3n/dGPIFqgddNXEP1sV6V0AZA+8qBIGUTbTXJc3guk417OA9Of
pqnu2gekE9oP7QPRYdc4QvcD6SafvHAQ7XE1MwZEzzgknA2ik+9fKgDRV0IW
F4LoDXs7SkG0w1v9MhA99ejSdhB9Wf9SF4h2TVFaCaKNTVaB6TMrrQ6C6LoI
DzCdtFH9OIgWuKZ5Akx/yroAov+lWV4G0fe7eR+B6AdPQsB03QO/ZyB6j/9h
MH3nhehXEG0zrRtMAwB/H7OA
  "]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
arbitrary basis using Method\[Rule]Automatic (involves transformation from \
ZeemanBasis)\
\>", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.435138455176607*^9}, {
  3.4351385782893333`*^9, 3.435138578864519*^9}, {3.439428354758057*^9, 
  3.4394283669204197`*^9}, {3.439428555610299*^9, 3.439428558911394*^9}, {
  3.439951941263769*^9, 3.439951966665169*^9}, {3.6831900681454782`*^9, 
  3.683190072238949*^9}}],

Cell[CellGroupData[{

Cell["kets", "Subsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{
      RowBox[{"ket_", "?", "KetQ"}], ",", 
      RowBox[{"basis_", "?", "DefinedBasisQ"}], ",", "opts___Rule"}], "]"}]}],
    ":=", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "ibasis", "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ibasis", "=", 
         RowBox[{"ZeemanBasis", "[", 
          RowBox[{"SpinSystem", "[", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"BasisTransformationMatrix", "[", 
          RowBox[{"basis", ",", "ibasis"}], "]"}], ".", 
         RowBox[{"VectorRepresentation", "[", 
          RowBox[{"ket", ",", "ibasis"}], "]"}]}]}], "\[IndentingNewLine]", 
       ")"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Method", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "VectorRepresentation", "]"}]}], ",", 
       "Automatic"}], "]"}], "&&", 
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{"basis", ",", 
        RowBox[{"ZeemanBasis", "[", "___", "]"}]}], "]"}]}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310748617559023`*^9, 3.431074866287414*^9}, {
   3.439428445081674*^9, 3.4394285143709707`*^9}, {3.43942856466698*^9, 
   3.439428567090693*^9}, {3.439428623967114*^9, 3.439428759095665*^9}, {
   3.439431131396223*^9, 3.439431173168355*^9}, {3.439431445213122*^9, 
   3.439431456928738*^9}, {3.43943187158153*^9, 3.439431877213736*^9}, {
   3.439432093540332*^9, 3.4394321138643637`*^9}, {3.439437400501769*^9, 
   3.4394374118579683`*^9}, {3.439951050067746*^9, 3.4399510710727787`*^9}, {
   3.4399515618698874`*^9, 3.4399515649005327`*^9}, 3.456162361407626*^9, {
   3.683190157609599*^9, 3.683190159494565*^9}, {3.683190285633628*^9, 
   3.6831902887707033`*^9}, 3.683190360467548*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["bras", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439951275795327*^9, 3.439951276337084*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{
      RowBox[{"bra_", "?", "BraQ"}], ",", 
      RowBox[{"basis_", "?", "DefinedBasisQ"}], ",", "opts___Rule"}], "]"}]}],
    ":=", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "ibasis", "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ibasis", "=", 
         RowBox[{"ZeemanBasis", "[", 
          RowBox[{"SpinSystem", "[", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"VectorRepresentation", "[", 
          RowBox[{"bra", ",", "ibasis"}], "]"}], ".", 
         RowBox[{"BasisTransformationMatrix", "[", 
          RowBox[{"ibasis", ",", "basis"}], "]"}]}]}], "\[IndentingNewLine]", 
       ")"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Method", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "VectorRepresentation", "]"}]}], ",", 
       "Automatic"}], "]"}], "&&", 
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{"basis", ",", 
        RowBox[{"ZeemanBasis", "[", "___", "]"}]}], "]"}]}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310748617559023`*^9, 3.431074866287414*^9}, {
   3.439428445081674*^9, 3.4394285143709707`*^9}, {3.43942856466698*^9, 
   3.439428567090693*^9}, {3.439428623967114*^9, 3.439428759095665*^9}, {
   3.439431131396223*^9, 3.439431173168355*^9}, {3.439431445213122*^9, 
   3.439431456928738*^9}, {3.43943187158153*^9, 3.439431877213736*^9}, {
   3.439432093540332*^9, 3.4394321138643637`*^9}, {3.439437400501769*^9, 
   3.4394374118579683`*^9}, {3.439951050067746*^9, 3.4399510710727787`*^9}, {
   3.439951279606246*^9, 3.439951322590191*^9}, {3.43995156987654*^9, 
   3.439951572786757*^9}, 3.456162362207871*^9, {3.6831902039269867`*^9, 
   3.683190206516148*^9}, 3.683190295892561*^9, 3.683190363039501*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["calculation using Method\[Rule]\[CloseCurlyDoubleQuote]Direct\
\[CloseCurlyDoubleQuote]", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.435138455176607*^9}, {
  3.4351385782893333`*^9, 3.435138578864519*^9}, {3.439428354758057*^9, 
  3.4394283669204197`*^9}, {3.439951929172604*^9, 3.439951931815658*^9}, {
  3.558598456710265*^9, 3.558598458604494*^9}}],

Cell[CellGroupData[{

Cell["kets", "Subsection",
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"VectorRepresentation", "[", 
    RowBox[{
     RowBox[{"ket", ":", 
      RowBox[{"Ket", "[", "___", "]"}]}], ",", 
     RowBox[{"basis_", "?", "DefinedBasisQ"}], ",", "opts___Rule"}], "]"}]}], 
  ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"#", ".", "ket"}], ")"}], "&"}], ",", 
       RowBox[{"BasisBras", "[", "basis", "]"}]}], "]"}], "/.", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"HoldPattern", "[", 
         RowBox[{"Dot", "[", 
          RowBox[{"___", ",", "0", ",", "___"}], "]"}], "]"}], 
        "\[RuleDelayed]", "0"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"HoldPattern", "[", 
         RowBox[{"Dot", "[", 
          RowBox[{"a__", ",", "1", ",", "b___"}], "]"}], "]"}], 
        "\[RuleDelayed]", 
        RowBox[{"Dot", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"HoldPattern", "[", 
         RowBox[{"Dot", "[", 
          RowBox[{"a___", ",", "1", ",", "b__"}], "]"}], "]"}], 
        "\[RuleDelayed]", 
        RowBox[{"Dot", "[", 
         RowBox[{"a", ",", "b"}], "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
    "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Method", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "VectorRepresentation", "]"}]}], ",", 
      "\"\<Direct\>\""}], "]"}], "||", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"basis", ",", 
      RowBox[{"ZeemanBasis", "[", "___", "]"}]}], "]"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310748617559023`*^9, 3.431074866287414*^9}, {
   3.439428445081674*^9, 3.4394285143709707`*^9}, {3.4399508789757423`*^9, 
   3.439950933817395*^9}, {3.4399515138279123`*^9, 3.439951521459077*^9}, {
   3.4864625028326178`*^9, 3.486462514136891*^9}, 3.5470255707761*^9, 
   3.683190300929908*^9, 3.683190385161948*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["bras", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439950958044537*^9, 3.4399509586657457`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{
      RowBox[{"bra", ":", 
       RowBox[{"Bra", "[", "___", "]"}]}], ",", 
      RowBox[{"basis_", "?", "DefinedBasisQ"}], ",", "opts___Rule"}], "]"}]}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"bra", ".", "#"}], ")"}], "&"}], ",", 
        RowBox[{"BasisKets", "[", "basis", "]"}]}], "]"}], "/.", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{"Dot", "[", 
           RowBox[{"___", ",", "0", ",", "___"}], "]"}], "]"}], 
         "\[RuleDelayed]", "0"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{"Dot", "[", 
           RowBox[{"a__", ",", "1", ",", "b___"}], "]"}], "]"}], 
         "\[RuleDelayed]", 
         RowBox[{"Dot", "[", 
          RowBox[{"a", ",", "b"}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"HoldPattern", "[", 
          RowBox[{"Dot", "[", 
           RowBox[{"a___", ",", "1", ",", "b__"}], "]"}], "]"}], 
         "\[RuleDelayed]", 
         RowBox[{"Dot", "[", 
          RowBox[{"a", ",", "b"}], "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
     "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Method", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "VectorRepresentation", "]"}]}], ",", 
       "\"\<Direct\>\""}], "]"}], "||", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"basis", ",", 
       RowBox[{"ZeemanBasis", "[", "___", "]"}]}], "]"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310748617559023`*^9, 3.431074866287414*^9}, {
   3.439428445081674*^9, 3.4394285143709707`*^9}, {3.4399508789757423`*^9, 
   3.439950933817395*^9}, {3.439950969481256*^9, 3.439950987684978*^9}, 
   3.439951541989438*^9, {3.48646252164955*^9, 3.4864625434506617`*^9}, 
   3.547025572584433*^9, 3.683190326948929*^9, 3.683190391729803*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["sums and numerical factors", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.435138455176607*^9}, {
  3.435138565931657*^9, 3.4351385693764677`*^9}, {3.4394288285217752`*^9, 
  3.439428830117169*^9}, {3.439430729574646*^9, 3.439430744819829*^9}, {
  3.4394307789742527`*^9, 3.439430797443653*^9}, {3.4399513911453533`*^9, 
  3.439951396087367*^9}}],

Cell[CellGroupData[{

Cell["handling of sums", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{
      RowBox[{"Plus", "[", "states___", "]"}], ",", "basis_", ",", 
      "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Map", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"VectorRepresentation", "[", 
       RowBox[{"#", ",", "basis", ",", "opts"}], "]"}], "&"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Plus", "[", "states", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.457268971978846*^9, 3.457268997734482*^9}, {
  3.457269363539052*^9, 3.457269366486373*^9}, {3.457272011140717*^9, 
  3.457272027630496*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["handling of numerical factors", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{
      RowBox[{"num_", "?", "NumericQ"}], ",", "___"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", "num", "]"}], "\[Equal]", "0"}], ")"}]}], ":=", 
   RowBox[{"SparseArray", "@", 
    RowBox[{"Table", "[", 
     RowBox[{"0", ",", 
      RowBox[{"{", 
       RowBox[{"BasisDimension", "[", "]"}], "}"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468758014607855*^9, 3.4687580193265553`*^9}, {
  3.468758058009684*^9, 3.468758078218605*^9}, {3.4687581155264997`*^9, 
  3.468758145239079*^9}, {3.657355143927394*^9, 3.657355152185108*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{
      RowBox[{"Times", "[", 
       RowBox[{
        RowBox[{"num1", ":", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{
            RowBox[{"_", "?", "KetQ"}], "|", 
            RowBox[{"_", "?", "BraQ"}]}], "]"}], ".."}]}], ",", "state_"}], 
       "]"}], ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Times", "[", 
    RowBox[{"num1", ",", 
     RowBox[{"VectorRepresentation", "[", 
      RowBox[{"state", ",", "basis", ",", "opts"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435162429133709*^9, 3.435162467849051*^9}, {
   3.448291159826447*^9, 3.448291163083337*^9}, {3.448292282946432*^9, 
   3.448292287759934*^9}, {3.44829318107003*^9, 3.448293184857436*^9}, {
   3.4482932409215183`*^9, 3.448293250975316*^9}, {3.448308249969927*^9, 
   3.4483082541593313`*^9}, {3.448345390344214*^9, 3.448345416971203*^9}, {
   3.4483456543308277`*^9, 3.448345685330309*^9}, {3.448345872714571*^9, 
   3.4483458915487843`*^9}, {3.448345957560493*^9, 3.448345960820505*^9}, {
   3.4502868116542587`*^9, 3.4502868532847233`*^9}, 3.450286967687614*^9, {
   3.61847383550935*^9, 3.6184738363228197`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"VectorRepresentation", "[", 
     RowBox[{
      RowBox[{"Times", "[", 
       RowBox[{"state_", ",", 
        RowBox[{"num1", ":", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{
            RowBox[{"_", "?", "KetQ"}], "|", 
            RowBox[{"_", "?", "BraQ"}]}], "]"}], ".."}]}]}], "]"}], ",", 
      "basis_", ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Times", "[", 
    RowBox[{"num1", ",", 
     RowBox[{"VectorRepresentation", "[", 
      RowBox[{"state", ",", "basis", ",", "opts"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435162429133709*^9, 3.435162467849051*^9}, {
   3.448291159826447*^9, 3.448291163083337*^9}, {3.448292282946432*^9, 
   3.448292287759934*^9}, {3.44829318107003*^9, 3.448293184857436*^9}, {
   3.4482932409215183`*^9, 3.448293250975316*^9}, {3.448308249969927*^9, 
   3.4483082541593313`*^9}, {3.448345390344214*^9, 3.448345416971203*^9}, {
   3.4483456543308277`*^9, 3.448345685330309*^9}, {3.448345872714571*^9, 
   3.4483458915487843`*^9}, {3.448345957560493*^9, 3.448345960820505*^9}, {
   3.4502868116542587`*^9, 3.4502868532847233`*^9}, {3.450286885022665*^9, 
   3.450286893108201*^9}, 3.450286971033537*^9, {3.618473843474907*^9, 
   3.618473844131962*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439556134936461*^9, 3.4395561699887114`*^9}, {
   3.439556231249998*^9, 3.439556232460958*^9}, 3.460869867383815*^9, 
   3.4610005801119423`*^9, {3.531930388871133*^9, 3.531930390059944*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VectorRepresentation", "::", "badarg"}], "=", 
   "\"\<VectorRepresentation may only be applied to a Ket or a Bra.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5319303977523413`*^9, 3.5319304432399893`*^9}, {
   3.531930893004917*^9, 3.5319308936026573`*^9}, {3.626777966502247*^9, 
   3.6267779756841717`*^9}, 3.626778285445784*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Subsubtitle",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"1d7ae850-817f-4758-8d96-ebf8e41bc785"],

Cell["\<\
End[];
EndPackage[];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{808, 751},
WindowMargins->{{Automatic, 62}, {Automatic, 20}},
ShowCellLabel->True,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 369, 10, 114, "Title",ExpressionUUID->"62281054-fef9-4cfe-9522-59664e1ed568",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[961, 36, 341, 8, 57, "Subsubtitle",ExpressionUUID->"8e6fa999-345c-4591-b206-08fc80d80f5d",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1305, 46, 764, 17, 215, "Input",ExpressionUUID->"3a3103db-1ce2-40c5-b968-6bd0db40df15",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[2106, 68, 214, 6, 41, "Subsubtitle",ExpressionUUID->"09376711-def3-4766-b8ac-eca59bab4ab1",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[2345, 78, 210, 5, 36, "Section",ExpressionUUID->"9dac0249-d574-4d8c-a45d-cdce0efb99f1",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[2580, 87, 216, 6, 54, "Subsection",ExpressionUUID->"f272bfab-bcef-48a6-a9f2-0882745ce9e1",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[2799, 95, 274, 7, 48, "Input",ExpressionUUID->"a09a9cc4-baaa-451e-bfb8-95b125b128cd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[3110, 107, 219, 6, 38, "Subsection",ExpressionUUID->"03f3aa24-7f55-478e-bab5-b99e5247d6c1",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[3332, 115, 2685, 42, 173, "Input",ExpressionUUID->"b3b25869-658c-49fb-be72-cdd18246aae6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6054, 162, 223, 6, 38, "Subsection",ExpressionUUID->"af4f0b1f-19a2-4ac2-bda2-30a5dadcf3ba",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[6280, 170, 632, 19, 91, "Input",ExpressionUUID->"a2147afe-c269-438d-8926-01b7e6f33e58",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6949, 194, 282, 7, 38, "Subsection",ExpressionUUID->"53598af3-1095-40ae-b4e5-d20643fce2fe",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[7234, 203, 1129, 38, 133, "Input",ExpressionUUID->"4f4ab136-a24e-49d6-8260-85c119802089",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8400, 246, 333, 8, 38, "Subsection",ExpressionUUID->"9827d57b-20a3-4e12-ab27-b45fb2a93080",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[8736, 256, 980, 32, 91, "Input",ExpressionUUID->"35f87c06-2a3c-4667-b9a1-8d25211fc17e",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[9765, 294, 181, 4, 36, "Section",ExpressionUUID->"889c079e-460e-4f7d-abfc-cb4df54f6f9c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[9971, 302, 153, 5, 44, "Subsection",ExpressionUUID->"b889a8f4-0b0c-4081-8edc-8a7757ba57dc",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[10127, 309, 470, 12, 91, "Input",ExpressionUUID->"fe40a235-7dc0-437e-8a62-9c8342226fd9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10634, 326, 276, 7, 36, "Subsection",ExpressionUUID->"9df41f75-9277-41ec-b226-68aeebd6f949",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[10913, 335, 1951, 64, 175, "Input",ExpressionUUID->"295a98bb-318f-4443-a459-30de6d4f5b40",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[12901, 404, 206, 6, 36, "Subsection",ExpressionUUID->"ccf313b6-09d4-44b8-a278-f4f8351a97af",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[13110, 412, 1061, 35, 91, "Input",ExpressionUUID->"6f993d6b-86de-4eea-9369-7fa4147ccd7e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[14208, 452, 328, 8, 36, "Subsection",ExpressionUUID->"2131595a-3fc2-42b3-9804-dd454ba5d9aa",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[14539, 462, 1988, 63, 196, "Input",ExpressionUUID->"5fd77777-0837-48b5-a7e7-a2d7c014c270",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[16564, 530, 331, 8, 36, "Subsection",ExpressionUUID->"1b435902-8e12-455e-9b8e-7b1bda811de6",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[16898, 540, 615, 19, 91, "Input",ExpressionUUID->"f8eac79f-7023-4aed-b79e-9513044bb7b3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[17550, 564, 253, 7, 36, "Subsection",ExpressionUUID->"7f1bdefc-3144-409d-b4f0-acc02360e815",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[17806, 573, 669, 19, 91, "Input",ExpressionUUID->"a8f4036e-1af3-49c7-b093-cfcdf9d24afb",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[18512, 597, 252, 7, 36, "Subsection",ExpressionUUID->"e21748cc-f1a5-4728-a9de-ee1c5a67c4ec",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[18767, 606, 518, 16, 70, "Input",ExpressionUUID->"81895b0c-7fb3-4af8-891f-6525719c7c14",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[19322, 627, 156, 5, 36, "Subsection",ExpressionUUID->"7b5bb1cf-1b96-4b54-afb7-09fe54f480e8",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[19481, 634, 499, 16, 48, "Input",ExpressionUUID->"210cd5b0-a1cd-4548-9f02-802edebcc5e2",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20017, 655, 157, 5, 36, "Subsection",ExpressionUUID->"0936860f-8bd9-4f27-9aba-b10630ffb61e",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[20177, 662, 468, 14, 70, "Input",ExpressionUUID->"fc1d9da8-041c-4819-a987-91a666aa4f80",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20682, 681, 157, 5, 36, "Subsection",ExpressionUUID->"bbe0d99e-dfda-4dd6-b995-490cec9b1073",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[20842, 688, 466, 14, 70, "Input",ExpressionUUID->"91b470e1-7996-452a-b883-85c3b79483d8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[21345, 707, 290, 8, 36, "Subsection",ExpressionUUID->"eabbfa38-4433-4efa-9218-18b5c7895959",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[21638, 717, 1027, 27, 91, "Input",ExpressionUUID->"27492f1a-2efe-4f27-acb4-fc7697fa85e4",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[22714, 750, 206, 6, 36, "Section",ExpressionUUID->"65de7e1f-c642-4352-805f-459b858e3672",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[22945, 760, 186, 4, 44, "Subsection",ExpressionUUID->"752af502-23e6-40bf-a05e-e25d33812ac0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[23156, 768, 162, 5, 35, "Subsubsection",ExpressionUUID->"a58413b0-3130-43e1-9ca8-6804853aae4a",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[23321, 775, 1850, 68, 133, "Input",ExpressionUUID->"3ee6aa57-04ce-4a4f-824a-9ce59df61d7e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[25208, 848, 170, 5, 29, "Subsubsection",ExpressionUUID->"23c66396-d020-42c6-86ab-9a0092bddf77",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[25381, 855, 744, 23, 112, "Input",ExpressionUUID->"fcec8e17-0959-4dda-98f5-7dcd92c8850c",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[26174, 884, 229, 6, 36, "Subsection",ExpressionUUID->"092e7c3c-13d4-45c1-af49-85831bbf052a",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[26406, 892, 969, 31, 112, "Input",ExpressionUUID->"f530534b-1eae-41b3-b9e3-10b4d0a18f33",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[27412, 928, 272, 7, 36, "Subsection",ExpressionUUID->"bc26d777-6b80-4474-8bc5-95c1b468e3a8",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[27687, 937, 509, 15, 70, "Input",ExpressionUUID->"9768ce95-2a8c-4117-bc8e-6dcf13f78bc0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[28233, 957, 325, 8, 44, "Subsection",ExpressionUUID->"656d8810-841d-47dc-912e-b03ca7920126",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[28561, 967, 892, 25, 112, "Input",ExpressionUUID->"9769dfdf-b465-418f-800b-0a20e8192f72",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[29502, 998, 240, 6, 36, "Section",ExpressionUUID->"d1071941-e66a-498f-8b0f-ff13e24d6810",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[29767, 1008, 151, 5, 44, "Subsection",ExpressionUUID->"d8dc3794-d5a9-4eef-832f-3880224d15cd",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[29921, 1015, 1080, 17, 364, "Input",ExpressionUUID->"458260ed-bc12-4866-b28a-1ebca5c5f260",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[31038, 1037, 267, 7, 44, "Subsection",ExpressionUUID->"5b2aa196-00de-451d-ba8d-af473c6614d2",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[31308, 1046, 370, 10, 48, "Input",ExpressionUUID->"5aff9cd1-acf7-4b6a-8161-62c0b597d164",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[31715, 1061, 151, 5, 44, "Subsection",ExpressionUUID->"54e8f2e5-77d0-4093-888f-471220a66e10",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[31869, 1068, 1083, 17, 364, "Input",ExpressionUUID->"ecb02c63-a21d-442e-867f-3b3f63a74de0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[32989, 1090, 318, 8, 44, "Subsection",ExpressionUUID->"a92247b1-52fa-407d-9b30-e53dd862185f",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[33310, 1100, 370, 10, 39, "Input",ExpressionUUID->"3b312645-3d47-4df2-adc3-0254852efdb9",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[33717, 1115, 152, 3, 36, "Subsection",ExpressionUUID->"9956f14c-f6e1-411e-a0cb-49b70389e6da",
 InitializationCell->True],
Cell[33872, 1120, 806, 15, 97, "Input",ExpressionUUID->"f870fc0b-f093-40c6-a572-cceb5298206b",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[34715, 1140, 201, 4, 36, "Subsection",ExpressionUUID->"f7f479bb-9a33-45d9-823f-d0ee330f493c",
 InitializationCell->True],
Cell[34919, 1146, 858, 16, 97, "Input",ExpressionUUID->"ee5850b0-8171-48e8-9399-8e4ff723b49c",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[35814, 1167, 114, 2, 36, "Subsection",ExpressionUUID->"bd58839a-8458-400b-9773-0249c0803c45",
 InitializationCell->True],
Cell[35931, 1171, 872, 16, 131, "Input",ExpressionUUID->"7ea8c574-07b7-46e7-af64-7beb1ee9b7d4",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[36852, 1193, 273, 7, 36, "Section",ExpressionUUID->"c8560aa5-778e-451e-81d0-c36f0627a8ad",
 InitializationCell->True,
 InitializationGroup->True],
Cell[37128, 1202, 979, 28, 133, "Input",ExpressionUUID->"e99a9ac0-b858-4345-8b44-9697013050b6",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[38156, 1236, 212, 6, 41, "Subsubtitle",ExpressionUUID->"026d6511-ed0a-445e-8c15-a04baf983a5f",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[38371, 1244, 143, 4, 46, "Input",ExpressionUUID->"21ff19a7-a193-46c2-8735-69c204993144",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[38551, 1253, 183, 4, 41, "Subsubtitle",ExpressionUUID->"49a988ab-695f-49c0-aa9d-366c7d7f4c19",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[38759, 1261, 167, 4, 36, "Section",ExpressionUUID->"5d1e5cc0-9c71-4350-aa68-0c9c3327386c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[38929, 1267, 468, 12, 46, "Input",ExpressionUUID->"966176fd-acc9-4555-a3f8-08c5bd9edae0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[39400, 1281, 430, 12, 46, "Input",ExpressionUUID->"4df412d3-45cc-4103-b20d-c41cad102da0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[39833, 1295, 1550, 37, 194, "Input",ExpressionUUID->"9c0e57d7-f09d-4f0c-a67f-5ed0383f4c02",
 InitializationCell->True],
Cell[41386, 1334, 574, 14, 46, "Input",ExpressionUUID->"cecf1919-1044-4c9d-a257-286ebb92e89f",
 InitializationCell->True],
Cell[41963, 1350, 338, 9, 46, "Input",ExpressionUUID->"76083e2f-dd9f-44bf-86a8-da18fd62f2e3",
 InitializationCell->True],
Cell[42304, 1361, 514, 13, 68, "Input",ExpressionUUID->"80861a63-45ff-4566-8a09-ceb90442f32a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[42821, 1376, 467, 12, 89, "Input",ExpressionUUID->"0a082ed7-1e58-441a-b861-e7d384b48481",
 InitializationCell->True,
 InitializationGroup->True],
Cell[43291, 1390, 247, 6, 46, "Input",ExpressionUUID->"f2ac70b7-5c94-41f0-8f9f-fd205c3ef3d2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[43575, 1401, 112, 3, 33, "Section",ExpressionUUID->"b4b8efb8-610e-4761-8160-ffe7a7726444",
 InitializationCell->True,
 InitializationGroup->True],
Cell[43690, 1406, 446, 14, 46, "Input",ExpressionUUID->"35a7c3e6-8bfd-496b-81f2-2da723358278",
 InitializationCell->True,
 InitializationGroup->True],
Cell[44139, 1422, 310, 9, 66, "Input",ExpressionUUID->"a297ae86-2dab-43c7-af1c-dcdcbad7101c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[44452, 1433, 656, 20, 66, "Input",ExpressionUUID->"0b4f723c-8d7e-4b4f-8f19-017f222543d2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[45111, 1455, 443, 13, 46, "Input",ExpressionUUID->"b9856bc6-dad3-4596-81e2-41c1569aa0bd",
 InitializationCell->True],
Cell[45557, 1470, 1077, 29, 123, "Input",ExpressionUUID->"dec37533-786f-4256-9a25-f2383f7e95c0",
 InitializationCell->True],
Cell[46637, 1501, 438, 12, 46, "Input",ExpressionUUID->"e704f843-5282-48f4-bd47-50ceff306f3a",
 InitializationCell->True],
Cell[47078, 1515, 662, 19, 85, "Input",ExpressionUUID->"60af7986-989e-4b71-8db7-72f35dca2030",
 InitializationCell->True],
Cell[47743, 1536, 2683, 56, 256, "Input",ExpressionUUID->"3e1ce27c-de20-4a2d-99f9-c3e7bb2973d4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[50429, 1594, 232, 7, 46, "Input",ExpressionUUID->"5ee1c450-5962-416c-b6cf-0ac9b193e2ea",
 InitializationCell->True,
 InitializationGroup->True],
Cell[50664, 1603, 304, 8, 46, "Input",ExpressionUUID->"0b0868db-2c50-47ec-b5ee-c965560e0b57",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[50993, 1615, 234, 5, 46, "Input",ExpressionUUID->"cdbea09a-32c7-4a08-9819-704668bafecc",
 InitializationCell->True],
Cell[51230, 1622, 261, 4, 32, "Output",ExpressionUUID->"53064d03-06eb-41d7-9bd7-deaa6b23cf56",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[51540, 1632, 116, 3, 33, "Section",ExpressionUUID->"78125e86-0fcb-4a8e-bb92-0250479786b5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[51659, 1637, 318, 9, 48, "Input",ExpressionUUID->"a64fd114-b0ed-4527-8820-8d54917fc070",
 InitializationCell->True,
 InitializationGroup->True],
Cell[51980, 1648, 451, 13, 70, "Input",ExpressionUUID->"73078347-6863-4c0f-a50e-c0cbdfe450b9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[52434, 1663, 739, 20, 70, "Input",ExpressionUUID->"a1f85093-f1b4-4374-81bf-83a1efe0b721",
 InitializationCell->True,
 InitializationGroup->True],
Cell[53176, 1685, 457, 13, 48, "Input",ExpressionUUID->"eb09d363-2889-47fc-880b-533ce93b23c8",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[53670, 1703, 151, 4, 33, "Section",ExpressionUUID->"54d53c26-6651-4607-bbc1-1b0a28f8650b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[53824, 1709, 293, 8, 50, "Input",ExpressionUUID->"d1d52da3-dfd3-4ca6-941e-28f078e9d633",
 InitializationCell->True],
Cell[54120, 1719, 407, 11, 48, "Input",ExpressionUUID->"e85d4018-bc47-4ab2-a891-3717e7ce7ae5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[54530, 1732, 570, 15, 48, "Input",ExpressionUUID->"542d5313-6c34-4e8c-b84b-a9b63610ce4a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[55103, 1749, 630, 18, 70, "Input",ExpressionUUID->"b91f1463-937d-4552-8ecc-e26018e5f06a",
 InitializationCell->True],
Cell[55736, 1769, 563, 16, 48, "Input",ExpressionUUID->"b08a7150-1fc0-4136-bae0-8f5a8e3d6c0e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[56336, 1790, 202, 5, 33, "Section",ExpressionUUID->"4b305ffb-e634-4012-8f49-4064519dc265",
 InitializationCell->True,
 InitializationGroup->True],
Cell[56541, 1797, 605, 15, 126, "Input",ExpressionUUID->"8cafda37-6ded-4ecf-a107-30d14f7f6791",
 InitializationCell->True,
 InitializationGroup->True],
Cell[57149, 1814, 518, 12, 126, "Input",ExpressionUUID->"76a4f193-e017-4d2a-857f-937286a104fe",
 InitializationCell->True,
 InitializationGroup->True],
Cell[57670, 1828, 630, 16, 213, "Input",ExpressionUUID->"54eb6570-0334-4f62-b8d2-a458dc7e2dac",
 InitializationCell->True,
 InitializationGroup->True],
Cell[58303, 1846, 682, 16, 213, "Input",ExpressionUUID->"f1654de0-8867-42f7-8a1b-76a6221397e7",
 InitializationCell->True],
Cell[58988, 1864, 685, 18, 213, "Input",ExpressionUUID->"710a8f8a-6c75-4805-99d7-fafe4be350fc",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[59722, 1888, 255, 6, 41, "Subsubtitle",ExpressionUUID->"1054dfa7-786e-46b9-a200-e7a1e199da62",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[60002, 1898, 123, 3, 33, "Section",ExpressionUUID->"09ace50d-602a-4eff-a918-d2f4fd44b32e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[60150, 1905, 107, 3, 43, "Subsection",ExpressionUUID->"7c1acced-1263-4e7a-9e3f-d05f6b9b2ae6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[60260, 1910, 474, 13, 48, "Input",ExpressionUUID->"c8e216e3-84f7-4c98-903f-475ba445ec9f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[60737, 1925, 319, 9, 48, "Input",ExpressionUUID->"0ac1c1a8-fffc-4d1d-a12d-2d33715411cf",
 InitializationCell->True],
Cell[61059, 1936, 305, 8, 48, "Input",ExpressionUUID->"d0d48fb7-88cf-49cf-acf1-93a656325091",
 InitializationCell->True],
Cell[61367, 1946, 429, 10, 48, "Input",ExpressionUUID->"882d0746-d1fd-4bdb-8a3d-489ccfabfec8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[61799, 1958, 535, 12, 48, "Input",ExpressionUUID->"5ac0a82f-fac5-4a4e-a380-9973b41728ef",
 InitializationCell->True,
 InitializationGroup->True],
Cell[62337, 1972, 227, 7, 48, "Input",ExpressionUUID->"7016bdb0-79f4-4a83-896f-86ae400d925d",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[62601, 1984, 274, 7, 35, "Subsection",ExpressionUUID->"69e7512d-e078-4a66-94e6-3f5a06e0c58f",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[62878, 1993, 338, 9, 46, "Input",ExpressionUUID->"5ae61306-6da9-4ad6-9193-091cc4be57ce",
 InitializationCell->True,
 InitializationGroup->True],
Cell[63219, 2004, 413, 10, 46, "Input",ExpressionUUID->"2a8433a3-c3ee-4f9a-b287-97eea9a91a52",
 InitializationCell->True,
 InitializationGroup->True],
Cell[63635, 2016, 521, 15, 85, "Input",ExpressionUUID->"8c577790-0944-491c-b8c7-dd49b11012ec",
 InitializationCell->True],
Cell[64159, 2033, 721, 20, 104, "Input",ExpressionUUID->"bc4d066f-d9ab-4e28-985a-1c0f86473d4d",
 InitializationCell->True],
Cell[64883, 2055, 449, 13, 46, "Input",ExpressionUUID->"b67c1119-bf7c-41f3-9f94-c3ec8a7b0407",
 InitializationCell->True,
 InitializationGroup->True],
Cell[65335, 2070, 403, 11, 46, "Input",ExpressionUUID->"db57fe79-4101-4e28-991d-1d243a233ec6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[65741, 2083, 4534, 108, 408, "Input",ExpressionUUID->"b40b05cb-04d4-47a9-a56a-68c266a091ee",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[70300, 2195, 127, 2, 34, "Subsubsection",ExpressionUUID->"b34508e5-d2d9-4144-a89c-3556382a8c5c",
 InitializationCell->True],
Cell[70430, 2199, 295, 8, 126, "Input",ExpressionUUID->"e1653bf5-6ac9-498a-8342-53c9a52ab4a8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[70728, 2209, 357, 9, 296, "Input",ExpressionUUID->"125ef394-33a6-44ae-b82b-5e1f49e1ef91",
 InitializationCell->True,
 InitializationGroup->True],
Cell[71088, 2220, 361, 9, 296, "Input",ExpressionUUID->"81f3df85-0058-47c4-8c78-9fddf0700f2b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[71452, 2231, 281, 8, 126, "Input",ExpressionUUID->"7e3b967c-4ab1-44d4-a086-3767127c1b7d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[71736, 2241, 420, 10, 296, "Input",ExpressionUUID->"e2b6c031-aacf-4479-83e6-d00923612ace",
 InitializationCell->True,
 InitializationGroup->True],
Cell[72159, 2253, 474, 11, 296, "Input",ExpressionUUID->"d95b4ba3-91c3-4c00-885b-9c1d1d76edfa",
 InitializationCell->True,
 InitializationGroup->True],
Cell[72636, 2266, 253, 6, 126, "Input",ExpressionUUID->"713add15-9cfe-4745-8174-7fcd159cffef",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[72938, 2278, 377, 7, 43, "Subsection",ExpressionUUID->"5f0f41c2-c6cf-4e4f-bef5-169623fa11c7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[73318, 2287, 330, 9, 146, "Input",ExpressionUUID->"bb43000d-df2b-4e6e-bc98-21138c6791d9",
 InitializationCell->True],
Cell[73651, 2298, 678, 16, 222, "Input",ExpressionUUID->"25d18c35-7e56-47a3-87ed-29d9e9b39579",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[74366, 2319, 306, 6, 35, "Subsection",ExpressionUUID->"afb29d67-c985-42d0-bff2-d8a265379984",
 InitializationCell->True,
 InitializationGroup->True],
Cell[74675, 2327, 481, 13, 28, "Input",ExpressionUUID->"0ebdae05-5295-4521-b1e2-15186d735a56",
 InitializationCell->True,
 InitializationGroup->True],
Cell[75159, 2342, 443, 12, 62, "Input",ExpressionUUID->"fdc04dd4-1681-43b3-9402-b42e811730d3",
 InitializationCell->True],
Cell[75605, 2356, 762, 20, 96, "Input",ExpressionUUID->"0281d71b-3d12-43fc-b624-334fda1b00ac",
 InitializationCell->True],
Cell[76370, 2378, 771, 21, 63, "Input",ExpressionUUID->"8bedf25c-5b68-4c69-8215-88c798b76cdc",
 InitializationCell->True],
Cell[77144, 2401, 715, 19, 80, "Input",ExpressionUUID->"96e978e9-b38a-4726-a0ad-7f20aba95cb2",
 InitializationCell->True],
Cell[77862, 2422, 723, 18, 97, "Input",ExpressionUUID->"263d26f2-657a-4c87-8842-7d7d60142b17",
 InitializationCell->True],
Cell[78588, 2442, 5371, 116, 505, "Input",ExpressionUUID->"77c7a2ca-71e9-4e6e-bda7-bff29a532d91",
 InitializationCell->True,
 InitializationGroup->True],
Cell[83962, 2560, 425, 10, 46, "Input",ExpressionUUID->"4b2300c4-8172-4b10-9cb3-2488571f3a9a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[84390, 2572, 450, 10, 28, "Input",ExpressionUUID->"7d156b95-d4cf-4163-84d1-e5368cb6d592",
 InitializationCell->True,
 InitializationGroup->True],
Cell[84843, 2584, 389, 10, 46, "Input",ExpressionUUID->"7687c6c6-dc61-45a2-b5e3-1e90e5d1cc73",
 InitializationCell->True,
 InitializationGroup->True],
Cell[85235, 2596, 262, 6, 28, "Input",ExpressionUUID->"83aec186-1121-46fd-9fca-7e036d3dd9e6",
 InitializationCell->True],
Cell[85500, 2604, 276, 7, 46, "Input",ExpressionUUID->"f32541ec-daf4-422f-96e7-8c4d09798317",
 InitializationCell->True],
Cell[85779, 2613, 288, 7, 62, "Input",ExpressionUUID->"26bacec8-7fad-4838-a2f1-aab732520f26",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[86104, 2625, 325, 6, 35, "Subsection",ExpressionUUID->"3d7ce96b-7174-4095-a33b-d44354cb7ddc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[86432, 2633, 607, 14, 312, "Input",ExpressionUUID->"0b6aef4b-7fe8-43ed-81dd-cae5eab319c7",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[87076, 2652, 277, 7, 35, "Subsection",ExpressionUUID->"a7467ae9-7bda-4b93-9783-7584164b4463",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[87356, 2661, 233, 6, 141, "Text",ExpressionUUID->"28d676ab-af7e-40d7-a84b-6aa5dd79f53b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[87592, 2669, 2999, 69, 1449, "Input",ExpressionUUID->"8df4a5e8-27fd-49d1-b6bd-fd76de65d67a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[90594, 2740, 388, 9, 296, "Input",ExpressionUUID->"f2fe2983-5c0f-49d4-872a-1efa6026bb41",
 InitializationCell->True,
 InitializationGroup->True],
Cell[90985, 2751, 281, 7, 126, "Input",ExpressionUUID->"604d4ec9-6452-4226-ba80-3fad0d39a30f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[91303, 2763, 348, 7, 35, "Subsection",ExpressionUUID->"cd828685-6ed7-4019-8e0c-4507a1b3c1e4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[91654, 2772, 500, 12, 46, "Input",ExpressionUUID->"d908946a-a6e7-4f64-806d-06621138fc76",
 InitializationCell->True,
 InitializationGroup->True],
Cell[92157, 2786, 441, 14, 46, "Input",ExpressionUUID->"6cb57c53-9264-4bf8-aa9a-531ca9e35ea8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[92601, 2802, 506, 12, 46, "Input",ExpressionUUID->"34fa6787-6a58-49ad-8fff-91141e174e39",
 InitializationCell->True],
Cell[93110, 2816, 713, 17, 66, "Input",ExpressionUUID->"9edb44f7-eaf3-489a-89d4-39109f615603",
 InitializationCell->True,
 InitializationGroup->True],
Cell[93826, 2835, 887, 22, 85, "Input",ExpressionUUID->"2ae7636f-1f11-477d-b2d0-586a8b613fee",
 InitializationCell->True,
 InitializationGroup->True],
Cell[94716, 2859, 542, 15, 66, "Input",ExpressionUUID->"d40423e9-f227-4c2b-a009-a45f478a104f",
 InitializationCell->True],
Cell[95261, 2876, 3718, 73, 161, "Input",ExpressionUUID->"5cb87cbc-b746-4ae5-92de-006237c29351",
 InitializationCell->True,
 InitializationGroup->True],
Cell[98982, 2951, 1230, 31, 142, "Input",ExpressionUUID->"90e7d8e7-f963-4cd4-96cd-317e2e89594f",
 InitializationCell->True],
Cell[100215, 2984, 1124, 29, 142, "Input",ExpressionUUID->"233970b6-51ef-44b7-a17e-5f91432ad228",
 InitializationCell->True],
Cell[101342, 3015, 982, 27, 104, "Input",ExpressionUUID->"f6b36193-25a9-4cbe-a659-5d85678664b5",
 InitializationCell->True],
Cell[102327, 3044, 1075, 30, 104, "Input",ExpressionUUID->"aaa67b4b-02c9-484d-aa36-9fa6168a710d",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[103427, 3078, 126, 2, 34, "Subsubsection",ExpressionUUID->"4bed9dbb-28b0-4ea2-8f43-0275cf7954ed",
 InitializationCell->True],
Cell[103556, 3082, 297, 8, 46, "Input",ExpressionUUID->"04951c86-a7d7-4888-aac9-7db86b1a0a5a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[103856, 3092, 296, 8, 46, "Input",ExpressionUUID->"c1055161-bd8d-485a-9493-834c975ee5eb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[104155, 3102, 450, 11, 85, "Input",ExpressionUUID->"939afc2b-a6a3-4490-9e19-147739e31913",
 InitializationCell->True,
 InitializationGroup->True],
Cell[104608, 3115, 352, 9, 66, "Input",ExpressionUUID->"9ed5930c-cbeb-43be-924d-eedd4e228978",
 InitializationCell->True,
 InitializationGroup->True],
Cell[104963, 3126, 320, 9, 46, "Input",ExpressionUUID->"489931d0-8783-4758-985c-9a1ece9fbf86",
 InitializationCell->True,
 InitializationGroup->True],
Cell[105286, 3137, 301, 7, 66, "Input",ExpressionUUID->"5f01915d-489d-45e2-8b81-4d8256b962f1",
 InitializationCell->True],
Cell[105590, 3146, 295, 7, 66, "Input",ExpressionUUID->"2b87138f-ffd7-4788-90fe-47c125100560",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[105934, 3159, 117, 3, 43, "Subsection",ExpressionUUID->"ce11e043-abb7-4bcb-bbd9-c0e45f2762ae",
 InitializationCell->True,
 InitializationGroup->True],
Cell[106054, 3164, 282, 8, 126, "Input",ExpressionUUID->"e6724df5-0490-43e3-a3a6-7af00f4aafa3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[106339, 3174, 416, 12, 126, "Input",ExpressionUUID->"c00c5b95-b511-4c63-8a35-3c36a8f5735f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[106792, 3191, 111, 3, 35, "Subsection",ExpressionUUID->"a8851e50-bb9d-40ba-9ec3-157b51ed6b2a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[106906, 3196, 272, 8, 126, "Input",ExpressionUUID->"428a33fb-fe74-4f17-8e76-d10064ddea39",
 InitializationCell->True,
 InitializationGroup->True],
Cell[107181, 3206, 693, 18, 296, "Input",ExpressionUUID->"1835374f-c992-4b77-a29d-975cb3bd6153",
 InitializationCell->True],
Cell[107877, 3226, 1221, 28, 629, "Input",ExpressionUUID->"429a9273-a046-4c45-a409-2cfc22f072fc",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[109135, 3259, 111, 3, 35, "Subsection",ExpressionUUID->"cc798480-3631-4a32-b9d7-9f3535cd741d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[109249, 3264, 272, 8, 126, "Input",ExpressionUUID->"34cf2b43-7de2-4298-bc28-47a236c6c86c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[109524, 3274, 695, 18, 296, "Input",ExpressionUUID->"54773e9d-dba9-4be2-8b1d-6dc1e44a3e63",
 InitializationCell->True],
Cell[110222, 3294, 1195, 27, 629, "Input",ExpressionUUID->"ccf5656c-af2c-4049-9810-6a8cd948d490",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[111454, 3326, 179, 4, 35, "Subsection",ExpressionUUID->"9ce64b01-b824-4146-b463-2d5635f04eb4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[111636, 3332, 327, 9, 126, "Input",ExpressionUUID->"c2fa7757-e0e3-495e-842a-005fbaa1cd37",
 InitializationCell->True,
 InitializationGroup->True],
Cell[111966, 3343, 918, 26, 296, "Input",ExpressionUUID->"73687efd-1215-4563-8b00-14f251e05193",
 InitializationCell->True],
Cell[112887, 3371, 903, 27, 296, "Input",ExpressionUUID->"3304f8a0-fa2b-4e63-9ea2-be685b8a9721",
 InitializationCell->True],
Cell[113793, 3400, 419, 11, 126, "Input",ExpressionUUID->"df680670-d380-4c55-bd15-ee6f52b5d568",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[114261, 3417, 156, 3, 33, "Section",ExpressionUUID->"287db02f-0059-43bb-8420-fe7711bc6836",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[114442, 3424, 114, 3, 208, "Subsection",ExpressionUUID->"1762fb3d-3f6d-4e11-a0dc-f27efb06789d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[114581, 3431, 87, 2, 163, "Subsubsection",ExpressionUUID->"2afb841e-ac42-477b-a27c-6f310dea9748",
 InitializationCell->True,
 InitializationGroup->True],
Cell[114671, 3435, 179, 4, 126, "Input",ExpressionUUID->"2a2f64a0-6076-41c0-8188-c1e0f0692f66",
 InitializationCell->True],
Cell[114853, 3441, 815, 26, 296, "Input",ExpressionUUID->"e46695f2-6355-4c69-9475-ec375ef55039",
 InitializationCell->True,
 InitializationGroup->True],
Cell[115671, 3469, 435, 12, 213, "Input",ExpressionUUID->"b28cb223-9a90-46f7-ab74-b685699f65a6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[116109, 3483, 431, 13, 126, "Input",ExpressionUUID->"c08e0b22-f6e8-42f3-a4f5-ddaeab99ca35",
 InitializationCell->True,
 InitializationGroup->True],
Cell[116543, 3498, 418, 13, 126, "Input",ExpressionUUID->"9577d055-c7b7-4597-b94d-ebf5db9765a4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[116964, 3513, 361, 10, 126, "Input",ExpressionUUID->"f501edee-154b-4284-8a5d-eed7495e7810",
 InitializationCell->True],
Cell[117328, 3525, 426, 11, 126, "Input",ExpressionUUID->"acb9c323-8249-44b9-b6cf-a83e652c814d",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[117791, 3541, 94, 2, 135, "Subsubsection",ExpressionUUID->"912116ef-ca28-40fe-891a-7ae939765882",
 InitializationCell->True,
 InitializationGroup->True],
Cell[117888, 3545, 633, 21, 213, "Input",ExpressionUUID->"ced5df7b-be06-409a-a0fa-9d43023df33b",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[118558, 3571, 89, 2, 135, "Subsubsection",ExpressionUUID->"cec82a0f-671a-455f-a869-89f9032892df",
 InitializationCell->True,
 InitializationGroup->True],
Cell[118650, 3575, 1928, 50, 544, "Input",ExpressionUUID->"04d7a0d3-ba80-4e0e-9fcb-f976b7996db3",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[120615, 3630, 89, 2, 135, "Subsubsection",ExpressionUUID->"90c9f78e-9001-4278-84bf-78a1e2aa4cbb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[120707, 3634, 566, 15, 213, "Input",ExpressionUUID->"06181665-bbcc-4a08-8f9f-48fa0c6315cf",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[121310, 3654, 183, 4, 163, "Subsubsection",ExpressionUUID->"283ab364-accd-48d8-8990-9f6de0ff1b13",
 InitializationCell->True,
 InitializationGroup->True],
Cell[121496, 3660, 427, 11, 126, "Input",ExpressionUUID->"56a9bccc-992a-4152-8c7e-a4db561d6146",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[121972, 3677, 121, 3, 208, "Subsection",ExpressionUUID->"41dcff17-d4e5-4a4f-892b-53c0c72daf03",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[122118, 3684, 87, 2, 163, "Subsubsection",ExpressionUUID->"682e04bd-5d82-4f95-8ff1-320536b42b93",
 InitializationCell->True,
 InitializationGroup->True],
Cell[122208, 3688, 213, 4, 126, "Input",ExpressionUUID->"180b3d36-b609-4cc8-94fd-8fd53e4e711e",
 InitializationCell->True],
Cell[122424, 3694, 671, 20, 213, "Input",ExpressionUUID->"351a6972-923c-4d2d-9139-80d556b4b358",
 InitializationCell->True,
 InitializationGroup->True],
Cell[123098, 3716, 453, 12, 213, "Input",ExpressionUUID->"e6ea09b8-e2e5-47ac-aed4-38fa6daa6101",
 InitializationCell->True,
 InitializationGroup->True],
Cell[123554, 3730, 437, 13, 213, "Input",ExpressionUUID->"5c2407c3-9bdc-4538-b98c-aff9dbfeba35",
 InitializationCell->True,
 InitializationGroup->True],
Cell[123994, 3745, 434, 13, 126, "Input",ExpressionUUID->"2ece2e54-4847-47dc-bebe-28d5e45935df",
 InitializationCell->True,
 InitializationGroup->True],
Cell[124431, 3760, 758, 23, 296, "Input",ExpressionUUID->"59114072-259f-4a76-8be7-cbe02415d7fb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[125192, 3785, 587, 16, 296, "Input",ExpressionUUID->"dd0b10c5-4aef-4b15-8dec-474a3a71b56b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[125782, 3803, 428, 11, 213, "Input",ExpressionUUID->"c9ebd485-84ee-4d07-a012-7496e4112c5f",
 InitializationCell->True],
Cell[126213, 3816, 749, 22, 213, "Input",ExpressionUUID->"7bc2a8d6-3a5c-47ce-843d-2e477bedc58a",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[126999, 3843, 94, 2, 135, "Subsubsection",ExpressionUUID->"849250af-d72d-4b92-ae60-a2ab6b5a666e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[127096, 3847, 455, 15, 213, "Input",ExpressionUUID->"1d763604-37d9-4da0-ad3c-ec88595353bb",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[127588, 3867, 89, 2, 135, "Subsubsection",ExpressionUUID->"f16a01ca-c1ed-45ec-919a-d68c661cabc3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[127680, 3871, 1944, 51, 707, "Input",ExpressionUUID->"aefa9458-deab-4a29-a47f-ae202ec06239",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[129661, 3927, 89, 2, 135, "Subsubsection",ExpressionUUID->"ce8796b6-61b1-4824-9812-cfed1a56ea39",
 InitializationCell->True,
 InitializationGroup->True],
Cell[129753, 3931, 508, 14, 213, "Input",ExpressionUUID->"2faf2c17-e513-4379-bacc-25a9ed18e979",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[130298, 3950, 183, 4, 163, "Subsubsection",ExpressionUUID->"e371e166-e2fd-48d5-81d5-0ad144b67119",
 InitializationCell->True,
 InitializationGroup->True],
Cell[130484, 3956, 461, 11, 126, "Input",ExpressionUUID->"440f0ac2-c837-4857-84cf-e97879567eeb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[130982, 3972, 94, 2, 135, "Subsubsection",ExpressionUUID->"6d9df06d-c113-4f3f-8cc0-3f34b36e2942",
 InitializationCell->True,
 InitializationGroup->True],
Cell[131079, 3976, 240, 7, 213, "Input",ExpressionUUID->"57feaf2f-ffe5-4ee7-b017-1b30d7502358",
 InitializationCell->True,
 InitializationGroup->True],
Cell[131322, 3985, 251, 7, 213, "Input",ExpressionUUID->"49ac2e96-cd9b-4e53-8e2f-0bb43b3d218c",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[131634, 3999, 153, 3, 33, "Section",ExpressionUUID->"b0847074-c27d-4436-94ca-80553f241f45",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[131812, 4006, 186, 4, 44, "Subsection",ExpressionUUID->"5675bb6c-1a38-4c4c-bce6-2e7c81f56af2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[132001, 4012, 183, 3, 30, "Text",ExpressionUUID->"7f5376d0-55d8-4c84-89e0-e9ccb6814393",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[132221, 4020, 231, 5, 44, "Subsection",ExpressionUUID->"3093e536-dfff-46de-8488-1bbab825e8b6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[132455, 4027, 151, 2, 30, "Text",ExpressionUUID->"618c211e-c81d-4ef7-b314-eef3c40c77db",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[132643, 4034, 282, 6, 44, "Subsection",ExpressionUUID->"9f6475f0-16ae-4aa3-90b4-10379d3043c3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[132950, 4044, 153, 3, 35, "Subsubsection",ExpressionUUID->"9a910534-256c-4c33-b8f9-4034bd840ca5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[133106, 4049, 549, 13, 126, "Input",ExpressionUUID->"40ec7271-886b-4298-a414-3f379a7960fe",
 InitializationCell->True],
Cell[133658, 4064, 661, 20, 213, "Input",ExpressionUUID->"57062f8b-47f8-4c75-8dcb-e004266b69d8",
 InitializationCell->True],
Cell[134322, 4086, 1109, 22, 462, "Input",ExpressionUUID->"f8fc02e4-2daa-4fc5-ba6e-15fbfa25d193",
 InitializationCell->True],
Cell[135434, 4110, 246, 5, 228, "Text",ExpressionUUID->"5dcc067c-676c-4a18-b6be-496d2676f337",
 InitializationCell->True],
Cell[135683, 4117, 4854, 106, 2104, "Input",ExpressionUUID->"f7f15372-ad43-427a-83e5-722b22354cb7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[140574, 4228, 185, 4, 29, "Subsubsection",ExpressionUUID->"1411a093-7672-4f92-8865-0510ea23fad2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[140762, 4234, 739, 17, 213, "Input",ExpressionUUID->"82e0520b-acb8-4315-b932-478919aca76f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[141538, 4256, 94, 2, 29, "Subsubsection",ExpressionUUID->"7b55c285-4d3d-436f-898f-99719fb38a47",
 InitializationCell->True,
 InitializationGroup->True],
Cell[141635, 4260, 766, 18, 213, "Input",ExpressionUUID->"95dec4a7-8596-459e-aec9-494bcd7dbe6e",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[142438, 4283, 89, 2, 29, "Subsubsection",ExpressionUUID->"6bc2cb8f-2d23-49df-a7ff-0369e68462e9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[142530, 4287, 1393, 34, 462, "Input",ExpressionUUID->"7c8b2137-c099-4b42-be73-b36607fc9315",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[143960, 4326, 89, 2, 29, "Subsubsection",ExpressionUUID->"934c2e55-f77b-4168-a7ac-307fd069721e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[144052, 4330, 794, 15, 126, "Input",ExpressionUUID->"bfc369f0-2053-4709-a2f4-d5980ff99480",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[144883, 4350, 183, 4, 29, "Subsubsection",ExpressionUUID->"25f811ff-f437-4f9b-b99b-e3794900871b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[145069, 4356, 523, 12, 126, "Input",ExpressionUUID->"99a72de1-d4fd-4319-9b42-0f5abfbb7eb8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[145629, 4373, 251, 5, 29, "Subsubsection",ExpressionUUID->"677aaee7-64bd-4c6e-9c4c-6e3d3c4decba",
 InitializationCell->True],
Cell[145883, 4380, 279, 7, 213, "Input",ExpressionUUID->"c64be160-1b93-4f36-8e6f-4c1710573924",
 InitializationCell->True],
Cell[146165, 4389, 324, 7, 296, "Input",ExpressionUUID->"4252ff84-f0a6-41b3-8974-db02b54215af",
 InitializationCell->True],
Cell[146492, 4398, 393, 9, 296, "Input",ExpressionUUID->"5cfa9fa8-f4ae-4811-8bee-226b4987bc00",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[146946, 4414, 163, 3, 33, "Section",ExpressionUUID->"fbe8580a-8597-4ee6-b234-9bd6264ce60a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[147112, 4419, 520, 12, 70, "Input",ExpressionUUID->"7ef1aaf0-4809-4fce-9a0a-8da06cb13a02",
 InitializationCell->True,
 InitializationGroup->True],
Cell[147635, 4433, 747, 18, 70, "Input",ExpressionUUID->"1da51c0a-1002-4895-95a3-7d603cc47353",
 InitializationCell->True,
 InitializationGroup->True],
Cell[148385, 4453, 759, 16, 70, "Input",ExpressionUUID->"226ed70a-80a7-4467-a0fd-73a3bb6dc0fd",
 InitializationCell->True,
 InitializationGroup->True],
Cell[149147, 4471, 541, 14, 70, "Input",ExpressionUUID->"0436f295-55e2-4f0e-8e0b-cabcb29fb989",
 InitializationCell->True],
Cell[149691, 4487, 934, 24, 112, "Input",ExpressionUUID->"cc722701-095c-495a-9eb1-cdaa3f3c799f",
 InitializationCell->True],
Cell[150628, 4513, 740, 20, 70, "Input",ExpressionUUID->"beebb0e8-ec6d-411c-a3c4-2128b6a7f4ff",
 InitializationCell->True],
Cell[151371, 4535, 1214, 25, 70, "Input",ExpressionUUID->"c4104c25-9d7e-4ebf-a09e-3d9a48386b98",
 InitializationCell->True,
 InitializationGroup->True],
Cell[152588, 4562, 285, 7, 70, "Input",ExpressionUUID->"acc24692-17ee-4848-9c4f-7f155f35525f",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[152922, 4575, 174, 4, 41, "Subsubtitle",ExpressionUUID->"271e5a03-9c1c-41b5-91b8-c055b107b35a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[153121, 4583, 145, 3, 36, "Section",ExpressionUUID->"cba4bfc4-43a2-42e1-b965-7afbd9437253",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[153291, 4590, 446, 8, 49, "Subsection",ExpressionUUID->"27b3f245-e27a-4894-86b0-db269613f833",
 InitializationCell->True,
 InitializationGroup->True],
Cell[153740, 4600, 368, 9, 28, "Input",ExpressionUUID->"b777ef24-ac13-42d4-8d96-97a9882931f1",
 InitializationCell->True],
Cell[154111, 4611, 311, 6, 28, "Input",ExpressionUUID->"92aefe80-2908-42fe-a0e5-d98c6e15278f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[154459, 4622, 210, 5, 41, "Subsection",ExpressionUUID->"f5e81fd6-5962-46dc-a9f0-e3138beff4cc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[154694, 4631, 179, 4, 35, "Subsubsection",ExpressionUUID->"740844e1-530c-49e4-b376-e9c989646a11",
 InitializationCell->True,
 InitializationGroup->True],
Cell[154876, 4637, 419, 13, 126, "Input",ExpressionUUID->"c23e9b7e-497a-423a-8230-d142447e2850",
 InitializationCell->True,
 InitializationGroup->True],
Cell[155298, 4652, 557, 14, 213, "Input",ExpressionUUID->"541eb931-a09c-40af-be01-f129e4754189",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[155892, 4671, 431, 7, 29, "Subsubsection",ExpressionUUID->"d841dc5d-76cf-4434-a665-df82e43853a3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[156326, 4680, 362, 10, 48, "Input",ExpressionUUID->"83ad7448-9f14-44ef-9240-b97f067dca84",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[156737, 4696, 316, 6, 41, "Subsection",ExpressionUUID->"95541996-c0f8-4aa7-b896-a1e2bec6c39c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[157078, 4706, 345, 8, 39, "Subsubsection",ExpressionUUID->"7c16f5ce-aa39-44e9-8f39-864b6e1c3b7e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[157426, 4716, 2677, 65, 234, "Input",ExpressionUUID->"d0188b9a-9059-4a9e-9632-0b46c5fad70b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[160140, 4786, 377, 8, 33, "Subsubsection",ExpressionUUID->"b9786906-2fc3-47af-88d5-1870e0e8c55c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[160520, 4796, 542, 17, 46, "Input",ExpressionUUID->"2149bdf4-9264-4bad-a081-c35f1fafa691",
 InitializationCell->True],
Cell[161065, 4815, 671, 20, 63, "Input",ExpressionUUID->"8f67a7d1-6587-4e2b-a78d-15aa50409447",
 InitializationCell->True],
Cell[161739, 4837, 1197, 30, 63, "Input",ExpressionUUID->"abbc7cf2-53bb-4ac9-87bb-d4d937eabe4e",
 InitializationCell->True],
Cell[162939, 4869, 1006, 27, 63, "Input",ExpressionUUID->"45748602-a646-41f7-b8b4-c24afe6a83c3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[163982, 4901, 422, 7, 33, "Subsubsection",ExpressionUUID->"169a7ccc-70bd-46dd-9dce-4c205515cf2e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[164407, 4910, 1202, 32, 133, "Input",ExpressionUUID->"14d31688-0f8b-46ad-b9a7-c3e282c03877",
 InitializationCell->True],
Cell[165612, 4944, 1912, 51, 196, "Input",ExpressionUUID->"55d771a7-837a-4040-be75-4482d9f07bae",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[167561, 5000, 468, 8, 33, "Subsubsection",ExpressionUUID->"4c886dd8-a5af-4ca0-851b-d1d7df210cd1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[168032, 5010, 206, 4, 30, "Text",ExpressionUUID->"0afe1301-1a30-414c-8a71-0e8093ed3ffd"],
Cell[168241, 5016, 2823, 66, 343, "Input",ExpressionUUID->"c5f4ee9f-309a-46dd-bd19-ab82de81fd1c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[171101, 5087, 428, 7, 33, "Subsubsection",ExpressionUUID->"f32cacfb-94b3-4072-97bd-1f4658a782b1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[171532, 5096, 2736, 68, 216, "Input",ExpressionUUID->"024a6d91-cf12-4d29-9950-cf71072c7230",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[174305, 5169, 500, 9, 33, "Subsubsection",ExpressionUUID->"a941d9c2-8b82-4d42-bcd2-c72b04d0f135",
 InitializationCell->True,
 InitializationGroup->True],
Cell[174808, 5180, 1087, 27, 462, "Input",ExpressionUUID->"e8429230-1184-4fab-a6b4-a08ce029882b",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[175944, 5213, 309, 6, 49, "Subsection",ExpressionUUID->"ca57399a-566b-466d-9b7b-469da920ef98",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[176278, 5223, 191, 4, 163, "Subsubsection",ExpressionUUID->"d24004a6-12fd-4163-8949-479dd6fd5a5d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[176472, 5229, 2011, 52, 790, "Input",ExpressionUUID->"493c276f-ec8b-490f-9b57-475f33075344",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[178520, 5286, 223, 5, 135, "Subsubsection",ExpressionUUID->"0e770daf-c230-40e9-850f-a1fc82dd3d11",
 InitializationCell->True,
 InitializationGroup->True],
Cell[178746, 5293, 3771, 86, 1856, "Input",ExpressionUUID->"087565fb-b489-43ec-a84d-e41ad5440ca1",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[182566, 5385, 201, 5, 41, "Subsection",ExpressionUUID->"fcf55c5a-bad7-4d2c-8c29-49a2fb5d7f19",
 InitializationCell->True,
 InitializationGroup->True],
Cell[182770, 5392, 401, 10, 126, "Input",ExpressionUUID->"d6cc5e25-370a-4c7b-b089-da9938185b0b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[183174, 5404, 828, 19, 213, "Input",ExpressionUUID->"50dc6e5c-c7d1-46e2-a8f9-250007c31c5f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[184039, 5428, 399, 7, 41, "Subsection",ExpressionUUID->"8707bfc8-2586-4186-b704-c6f721162801",
 InitializationCell->True,
 InitializationGroup->True],
Cell[184441, 5437, 380, 9, 126, "Input",ExpressionUUID->"ae4451cd-64ed-40a9-88c5-863115a71106",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[184858, 5451, 294, 7, 36, "Subsection",ExpressionUUID->"a46f62e5-239c-4dab-8fcf-cfd3208585ee",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[185155, 5460, 280, 7, 126, "Input",ExpressionUUID->"7971cf7e-a021-4d22-a2ad-b9a5cb7a3056",
 InitializationCell->True,
 InitializationGroup->True],
Cell[185438, 5469, 620, 15, 126, "Input",ExpressionUUID->"4bf251e8-7579-4afb-ab57-a526afe7ad66",
 InitializationCell->True,
 InitializationGroup->True],
Cell[186061, 5486, 671, 16, 126, "Input",ExpressionUUID->"f0c343d9-e9e9-46a4-83f0-d04160be3f64",
 InitializationCell->True,
 InitializationGroup->True],
Cell[186735, 5504, 500, 12, 126, "Input",ExpressionUUID->"3645e2ae-da89-4e64-945b-f5b299df793d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[187238, 5518, 404, 9, 126, "Input",ExpressionUUID->"561b80d0-6867-4f3c-b2e6-728b1a695812",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[187679, 5532, 149, 3, 36, "Subsection",ExpressionUUID->"6e896d80-ba50-4088-b10a-6ffa57f5acfb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[187831, 5537, 291, 8, 126, "Input",ExpressionUUID->"74c72dd2-311a-4d57-91be-57a2fd196e82",
 InitializationCell->True,
 InitializationGroup->True],
Cell[188125, 5547, 273, 8, 126, "Input",ExpressionUUID->"f82427a1-1c42-43ca-846f-ff89f54ff36c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[188401, 5557, 432, 10, 213, "Input",ExpressionUUID->"3b7440a6-fbb2-4a78-9637-8c1523e7b624",
 InitializationCell->True,
 InitializationGroup->True],
Cell[188836, 5569, 430, 10, 213, "Input",ExpressionUUID->"0acfc7df-54f1-4e48-9530-a144ea1a8960",
 InitializationCell->True,
 InitializationGroup->True],
Cell[189269, 5581, 410, 10, 213, "Input",ExpressionUUID->"4b9fd9fe-d84e-402a-afb9-3a5e1d0348fb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[189682, 5593, 249, 7, 126, "Input",ExpressionUUID->"47a47503-a757-4ec4-88a2-e2533e4d68a3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[189934, 5602, 256, 7, 126, "Input",ExpressionUUID->"f5e6126e-72c8-4d83-abab-a4ec2868f60d",
 InitializationCell->True],
Cell[190193, 5611, 307, 7, 126, "Input",ExpressionUUID->"cb33c249-d218-4a42-b90c-faa55c6e827b",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[190549, 5624, 169, 4, 36, "Section",ExpressionUUID->"d37c2f93-8597-4e60-b686-ea42b43832d5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[190743, 5632, 420, 8, 49, "Subsection",ExpressionUUID->"270a9101-1399-4773-baa7-893f2815697d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[191166, 5642, 369, 9, 126, "Input",ExpressionUUID->"5323a25b-096a-4196-b638-a77278dbdd50",
 InitializationCell->True],
Cell[191538, 5653, 311, 6, 126, "Input",ExpressionUUID->"224b6a7c-353f-4ba8-a173-f6794a20aa0b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[191886, 5664, 182, 4, 41, "Subsection",ExpressionUUID->"309955a0-298e-43cd-acd0-0615bb328097",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[192093, 5672, 135, 3, 35, "Subsubsection",ExpressionUUID->"045ababd-aa93-4926-80a2-c0ecd6cac601",
 InitializationCell->True,
 InitializationGroup->True],
Cell[192231, 5677, 440, 13, 126, "Input",ExpressionUUID->"ad5fb6e6-ff25-4e3b-8347-23b53269e53c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[192674, 5692, 555, 14, 213, "Input",ExpressionUUID->"16dac303-b559-43f0-934b-f777b6b3da9e",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[193266, 5711, 406, 7, 29, "Subsubsection",ExpressionUUID->"09fbf3f3-90da-4706-9ffa-1d74266e70b8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[193675, 5720, 387, 10, 126, "Input",ExpressionUUID->"c5442eb0-8ae9-45cf-9026-4e0f6c8dd342",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[194111, 5736, 292, 6, 41, "Subsection",ExpressionUUID->"a352b86a-114a-404f-9919-7152b3aafeb9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[194428, 5746, 322, 8, 39, "Subsubsection",ExpressionUUID->"92f18df9-229e-4c46-bb12-6e184ab87eb5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[194753, 5756, 2506, 62, 1124, "Input",ExpressionUUID->"75547104-523e-4e40-99ea-c5427a52bb95",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[197296, 5823, 353, 8, 33, "Subsubsection",ExpressionUUID->"ca7711b4-448f-4c47-a47e-766e77c1b451",
 InitializationCell->True,
 InitializationGroup->True],
Cell[197652, 5833, 567, 17, 126, "Input",ExpressionUUID->"574ea616-f5a1-4b04-bbed-a3a1135ac90e",
 InitializationCell->True],
Cell[198222, 5852, 671, 20, 126, "Input",ExpressionUUID->"60fbf368-074a-43f5-ac2a-aaf71ba156d4",
 InitializationCell->True],
Cell[198896, 5874, 1249, 31, 199, "Input",ExpressionUUID->"d9a2e667-982d-41ea-8852-1cf1cdd7d18e",
 InitializationCell->True],
Cell[200148, 5907, 1032, 28, 199, "Input",ExpressionUUID->"470f3991-211e-47c3-bddc-3f84123c12c1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[201217, 5940, 395, 7, 33, "Subsubsection",ExpressionUUID->"e9d8813a-ec42-4b8f-b5ff-ee36d6071e3e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[201615, 5949, 1279, 33, 273, "Input",ExpressionUUID->"eabcadf3-c84b-4d45-a1b4-6caa3ff7a500",
 InitializationCell->True],
Cell[202897, 5984, 1985, 52, 564, "Input",ExpressionUUID->"86c2af74-6152-478c-b99a-ef3356516fb6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[204919, 6041, 468, 8, 33, "Subsubsection",ExpressionUUID->"93fa1f88-3582-4be5-8dc6-5779ce19f92c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[205390, 6051, 257, 5, 30, "Text",ExpressionUUID->"400548cb-c573-48f6-857d-7f32eee9095f"],
Cell[205650, 6058, 2944, 68, 343, "Input",ExpressionUUID->"f363d665-fc14-4407-889c-3d77ce77452a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[208631, 6131, 403, 7, 33, "Subsubsection",ExpressionUUID->"e7f89013-a55d-4d09-896b-21b60c1fa4be",
 InitializationCell->True,
 InitializationGroup->True],
Cell[209037, 6140, 2809, 69, 855, "Input",ExpressionUUID->"3134e4b0-dff4-4a73-8170-4f9af7cf8328",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[211883, 6214, 474, 9, 33, "Subsubsection",ExpressionUUID->"f951cc08-b21d-4bbe-819e-d173e66ab410",
 InitializationCell->True,
 InitializationGroup->True],
Cell[212360, 6225, 1165, 28, 344, "Input",ExpressionUUID->"d36a6409-3142-4d1d-be7c-97f9b5f69db5",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[213574, 6259, 283, 6, 49, "Subsection",ExpressionUUID->"3d46d4f5-208c-4f9f-ac7e-dd123f5f2eb4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[213882, 6269, 150, 3, 113, "Subsubsection",ExpressionUUID->"fce938e2-25b3-4aa0-a0ab-623bb525a193",
 InitializationCell->True,
 InitializationGroup->True],
Cell[214035, 6274, 2067, 53, 707, "Input",ExpressionUUID->"1341e6d7-9ebd-4da0-b956-232656a75622",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[216139, 6332, 197, 4, 113, "Subsubsection",ExpressionUUID->"6c1b7691-b9ec-4eb1-b64b-cfc36f0a0fd2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[216339, 6338, 3820, 86, 1648, "Input",ExpressionUUID->"c7e711e3-8bab-4974-bf3b-7e3fb44b7434",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[220208, 6430, 175, 4, 41, "Subsection",ExpressionUUID->"2ca9e27c-ac40-4ebc-a2a2-cb13178c8177",
 InitializationCell->True,
 InitializationGroup->True],
Cell[220386, 6436, 450, 11, 126, "Input",ExpressionUUID->"52227870-8a09-4d22-8130-dace4f13cca7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[220839, 6449, 880, 20, 213, "Input",ExpressionUUID->"1b22705c-ee56-4f97-a167-c7fb4947f27c",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[221756, 6474, 375, 7, 41, "Subsection",ExpressionUUID->"d0af698a-ceb3-46e5-bbf7-66bb6d0dbd5d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[222134, 6483, 380, 9, 126, "Input",ExpressionUUID->"369bbc0e-668b-4744-8af3-b49677f9fa95",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[222551, 6497, 324, 8, 41, "Subsection",ExpressionUUID->"36b619dd-671b-4bb4-9cba-2dbd3c325b2c",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[222878, 6507, 280, 7, 126, "Input",ExpressionUUID->"f1442814-4f9f-48a2-a080-6643c0c3d5ea",
 InitializationCell->True,
 InitializationGroup->True],
Cell[223161, 6516, 644, 16, 126, "Input",ExpressionUUID->"bfd64a8b-a036-436c-bb8a-d1df04435a2c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[223808, 6534, 693, 16, 126, "Input",ExpressionUUID->"3d065668-2b02-4e93-9713-81b2e116a1a8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[224504, 6552, 521, 12, 126, "Input",ExpressionUUID->"755f7fee-4e54-4ae9-b6c9-abfc6811c8b5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[225028, 6566, 402, 9, 126, "Input",ExpressionUUID->"16de4a6a-de19-4590-bd77-8474e523bff6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[225467, 6580, 127, 3, 41, "Subsection",ExpressionUUID->"9acb8931-fa33-4b26-b81e-1c19fbcc5274",
 InitializationCell->True,
 InitializationGroup->True],
Cell[225597, 6585, 291, 8, 126, "Input",ExpressionUUID->"64dbc657-d235-42e1-af88-be4245964641",
 InitializationCell->True,
 InitializationGroup->True],
Cell[225891, 6595, 273, 8, 126, "Input",ExpressionUUID->"1a3badec-ff30-4734-b415-634f128ed93a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[226167, 6605, 451, 10, 126, "Input",ExpressionUUID->"924caf10-a47b-45e9-999e-8d5f18e5400b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[226621, 6617, 432, 10, 126, "Input",ExpressionUUID->"98f7eca3-4629-4795-aade-4579c1007179",
 InitializationCell->True,
 InitializationGroup->True],
Cell[227056, 6629, 410, 10, 126, "Input",ExpressionUUID->"5d2daf10-8255-48fb-8896-889a9ad0a2ac",
 InitializationCell->True,
 InitializationGroup->True],
Cell[227469, 6641, 249, 7, 126, "Input",ExpressionUUID->"653fb848-2c7f-4b93-8442-77f87060b506",
 InitializationCell->True,
 InitializationGroup->True],
Cell[227721, 6650, 256, 7, 126, "Input",ExpressionUUID->"2673c6d9-1b0b-4777-af7e-b8be4cc5227a",
 InitializationCell->True],
Cell[227980, 6659, 307, 7, 126, "Input",ExpressionUUID->"87846997-1fdf-4f9c-aca9-4638deda55b4",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[228336, 6672, 82, 2, 36, "Section",ExpressionUUID->"a8105a2b-1692-449f-bff2-7320c6177db4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[228421, 6676, 571, 16, 68, "Input",ExpressionUUID->"be15ae0e-1eea-4567-beae-fbec64b0e70f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[228995, 6694, 527, 15, 68, "Input",ExpressionUUID->"f84399de-a550-4839-aa27-9f3468c03bf8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[229525, 6711, 359, 11, 46, "Input",ExpressionUUID->"59e95b8c-7a1a-4448-933a-2732e56db3cf",
 InitializationCell->True,
 InitializationGroup->True],
Cell[229887, 6724, 1352, 33, 194, "Input",ExpressionUUID->"d9463118-cc27-422a-9c28-1cdaba402e0a",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[231276, 6762, 172, 4, 36, "Section",ExpressionUUID->"6d0d20f1-de58-4461-a261-3fe0c6e76272",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[231473, 6770, 145, 2, 54, "Subsection",ExpressionUUID->"7f8f7f63-ae82-469f-976b-5dcbf1a26995",
 InitializationCell->True],
Cell[231621, 6774, 893, 22, 110, "Input",ExpressionUUID->"ad5ef632-d63c-4138-b8e8-a3dc5abbf8f3",
 InitializationCell->True],
Cell[232517, 6798, 914, 22, 110, "Input",ExpressionUUID->"70305424-02b1-4fdd-9f4b-e82cdadc8fdf",
 InitializationCell->True],
Cell[233434, 6822, 942, 22, 110, "Input",ExpressionUUID->"c171632e-b7f7-400d-98df-7e040ac8f526",
 InitializationCell->True],
Cell[234379, 6846, 916, 22, 110, "Input",ExpressionUUID->"9d1d13f5-be88-4ec8-99bf-fb076100e402",
 InitializationCell->True],
Cell[235298, 6870, 938, 24, 110, "Input",ExpressionUUID->"5ebd5fbc-298c-40b2-810e-7e9cd588a165",
 InitializationCell->True],
Cell[236239, 6896, 943, 25, 110, "Input",ExpressionUUID->"62f62783-8bda-45b5-bc2a-a2d805b882cd",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[237219, 6926, 187, 3, 54, "Subsection",ExpressionUUID->"fcad449f-3a11-4a0a-b808-544290153efa",
 InitializationCell->True],
Cell[237409, 6931, 731, 19, 110, "Input",ExpressionUUID->"78d8a5ca-92fe-4834-a6e0-9a28f94690bf",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[238189, 6956, 147, 3, 36, "Section",ExpressionUUID->"b9cd43a2-d101-4f72-8e86-9727ef493d71",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[238361, 6963, 197, 4, 208, "Subsection",ExpressionUUID->"418fab55-4fa7-4a2c-8380-2982956a88ed",
 InitializationCell->True],
Cell[238561, 6969, 387, 12, 126, "Input",ExpressionUUID->"28f2502a-8282-4ab3-82c4-eaaff1c7b8d1",
 InitializationCell->True],
Cell[238951, 6983, 300, 8, 126, "Input",ExpressionUUID->"fb486721-66e1-466a-9267-7e6d47f5725e",
 InitializationCell->True],
Cell[239254, 6993, 458, 13, 126, "Input",ExpressionUUID->"14cb6491-e98c-4fa4-80e0-32dfc6d50ae3",
 InitializationCell->True],
Cell[239715, 7008, 385, 11, 126, "Input",ExpressionUUID->"3091c5d4-9da3-4cb8-bbfe-b07406f935e1",
 InitializationCell->True],
Cell[240103, 7021, 826, 22, 213, "Input",ExpressionUUID->"d9c6c1c9-3163-46c1-ae3c-2dc008560c90",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[240966, 7048, 269, 4, 164, "Subsection",ExpressionUUID->"fecbce8a-43f9-4036-bdf0-b5b66283b205",
 InitializationCell->True],
Cell[241238, 7054, 181, 4, 141, "Text",ExpressionUUID->"099586ee-234b-4535-b041-2ddd3aa9502b",
 InitializationCell->True],
Cell[241422, 7060, 815, 22, 213, "Input",ExpressionUUID->"7c0af4e1-7f4c-4de1-b2ff-c239e9686b7c",
 InitializationCell->True],
Cell[242240, 7084, 824, 23, 213, "Input",ExpressionUUID->"943ba0b9-9e67-4008-bb10-7017b827b181",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[243101, 7112, 319, 5, 164, "Subsection",ExpressionUUID->"9fcd9424-e067-424b-b38a-97a41eded960",
 InitializationCell->True],
Cell[243423, 7119, 265, 5, 141, "Text",ExpressionUUID->"456146c6-0e01-4318-9761-c29c8b7d6724",
 InitializationCell->True],
Cell[243691, 7126, 4636, 110, 1693, "Input",ExpressionUUID->"e95811f3-dfa2-41ae-a21c-33f47417fec1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[248364, 7241, 198, 4, 164, "Subsection",ExpressionUUID->"d1c78a10-6445-4dd7-b580-47a05ff8e416",
 InitializationCell->True],
Cell[248565, 7247, 446, 11, 296, "Input",ExpressionUUID->"2667328b-0b63-4594-b6a9-808004224fc2",
 InitializationCell->True],
Cell[249014, 7260, 546, 12, 213, "Input",ExpressionUUID->"b0c9741c-cff2-431f-adc6-64186f0de48b",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[249609, 7278, 197, 4, 36, "Section",ExpressionUUID->"23aa0c7a-0ede-4bb1-a071-7fa6b5b4fd62",
 InitializationCell->True],
Cell[249809, 7284, 452, 12, 126, "Input",ExpressionUUID->"0ea95e67-4a8b-4fbf-833f-f6d1f93981f6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[250298, 7301, 133, 2, 36, "Section",ExpressionUUID->"2a45852d-a4c7-4893-bad1-b721e22b293b",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[250456, 7307, 121, 2, 44, "Subsection",ExpressionUUID->"2c3959b1-a983-492c-ad7e-9dfa3aca95fe",
 InitializationCell->True],
Cell[250580, 7311, 441, 12, 213, "Input",ExpressionUUID->"7a68bda9-d8eb-44b8-a42e-7385d23b322e",
 InitializationCell->True],
Cell[251024, 7325, 438, 11, 213, "Input",ExpressionUUID->"eaf83e99-f7de-4528-a7c8-bf2ad682a5c5",
 InitializationCell->True],
Cell[251465, 7338, 612, 15, 213, "Input",ExpressionUUID->"6e0cf9b2-0e3c-4bf7-86b0-895bbde647fb",
 InitializationCell->True],
Cell[252080, 7355, 541, 16, 213, "Input",ExpressionUUID->"4f4e3a3b-80e5-4170-b299-dfdb4a4ba8e5",
 InitializationCell->True],
Cell[252624, 7373, 674, 16, 296, "Input",ExpressionUUID->"740ca8b5-7c3d-4844-a9bd-458c61136d01",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[253335, 7394, 197, 3, 36, "Subsection",ExpressionUUID->"51cd8036-a7c5-4604-b768-11f9d68f9372",
 InitializationCell->True],
Cell[253535, 7399, 860, 23, 112, "Input",ExpressionUUID->"38c35a4a-ad9d-4464-92b9-f9494d58784f",
 InitializationCell->True],
Cell[254398, 7424, 1293, 34, 133, "Input",ExpressionUUID->"081b8644-6304-413e-a467-615ad0ced6d4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[255728, 7463, 185, 3, 36, "Subsection",ExpressionUUID->"da222675-33aa-4454-84e7-ad631d4d21d3",
 InitializationCell->True],
Cell[255916, 7468, 909, 24, 296, "Input",ExpressionUUID->"aa790e69-921e-4549-92bd-f20bc57748bf",
 InitializationCell->True],
Cell[256828, 7494, 909, 24, 296, "Input",ExpressionUUID->"47706e18-3a85-40ea-9ed0-7b137cfe3752",
 InitializationCell->True],
Cell[257740, 7520, 1387, 36, 544, "Input",ExpressionUUID->"1c6bdac8-badc-471c-845b-bd8f27f6a1de",
 InitializationCell->True],
Cell[259130, 7558, 670, 19, 213, "Input",ExpressionUUID->"ebd037de-2f23-454a-805e-330fd961a2e3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[259837, 7582, 171, 3, 36, "Subsection",ExpressionUUID->"c17fcee1-ccda-419e-a770-490f3ec04384",
 InitializationCell->True],
Cell[260011, 7587, 530, 11, 213, "Input",ExpressionUUID->"ca292634-021f-43f4-9de0-92dc7ba20e30",
 InitializationCell->True],
Cell[260544, 7600, 444, 9, 213, "Input",ExpressionUUID->"51ef6bf2-6d9e-490d-b63b-0e09c2792f1d",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[261049, 7616, 227, 6, 41, "Subsubtitle",ExpressionUUID->"d78bbb7b-24ad-4cfc-8ff8-aa83421cc9f0",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[261301, 7626, 106, 3, 34, "Section",ExpressionUUID->"dd247e19-9848-40bc-bf4b-f80a20689e6e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[261410, 7631, 357, 9, 48, "Input",ExpressionUUID->"da44b97f-0f68-47f8-8048-6beeb15df2c8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[261792, 7644, 117, 3, 35, "Subsubsection",ExpressionUUID->"4868fc47-512b-4ea0-aebd-0c0324f62805",
 InitializationCell->True,
 InitializationGroup->True],
Cell[261912, 7649, 212, 7, 126, "Input",ExpressionUUID->"d8907710-3326-492e-866a-00fe11476c43",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[262161, 7661, 228, 6, 29, "Subsubsection",ExpressionUUID->"c7bc3dfb-9abc-4ec1-9a2f-d6c8d72b0595",
 InitializationCell->True,
 InitializationGroup->True],
Cell[262392, 7669, 425, 12, 70, "Input",ExpressionUUID->"100b3580-f6be-4a7f-a2df-91e9fcf5bbb9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[262820, 7683, 825, 19, 91, "Input",ExpressionUUID->"4a2365bf-4f5c-4e00-b6df-bd06db78947e",
 InitializationCell->True],
Cell[263648, 7704, 1184, 27, 175, "Input",ExpressionUUID->"db0fd359-a53a-4918-855f-021d440b0a96",
 InitializationCell->True,
 InitializationGroup->True],
Cell[264835, 7733, 516, 15, 91, "Input",ExpressionUUID->"dfeb7bc5-493c-4798-b9a3-4a6c8f0ede3e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[265388, 7753, 501, 7, 35, "Subsubsection",ExpressionUUID->"4c2637eb-0aea-466e-aae0-1420f933346b",
 InitializationCell->True],
Cell[265892, 7762, 693, 14, 71, "Input",ExpressionUUID->"bd4fbecb-1bb6-4273-8dee-8eb76d18106b",
 InitializationCell->True],
Cell[266588, 7778, 759, 19, 133, "Input",ExpressionUUID->"76f04aeb-e209-4de0-9af0-42ea377b92c3",
 InitializationCell->True],
Cell[267350, 7799, 1374, 31, 175, "Input",ExpressionUUID->"5a5b139d-429f-4252-9ea6-012b81a7d3ea",
 InitializationCell->True],
Cell[268727, 7832, 933, 21, 91, "Input",ExpressionUUID->"6250d3f5-744a-49fb-9e55-0bfd3d17fefa",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[269709, 7859, 447, 8, 34, "Section",ExpressionUUID->"919f35c0-f999-4595-87e2-2bc10086d773",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[270181, 7871, 81, 2, 44, "Subsection",ExpressionUUID->"1b9f3391-d9c2-4e8e-843d-52a08501c54d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[270287, 7877, 129, 2, 35, "Subsubsection",ExpressionUUID->"9e54b035-d117-4046-ab63-9b5b8b967cea",
 InitializationCell->True],
Cell[270419, 7881, 1169, 32, 91, "Input",ExpressionUUID->"c9a0f269-a411-4aba-80c3-249399dec388",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[271625, 7918, 177, 3, 29, "Subsubsection",ExpressionUUID->"cadb88e3-76fa-4170-a0a1-781a248cd519",
 InitializationCell->True],
Cell[271805, 7923, 1965, 53, 217, "Input",ExpressionUUID->"d7400feb-6cb4-4257-bce7-1a46c549bf02",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[273819, 7982, 147, 3, 36, "Subsection",ExpressionUUID->"d273627e-c414-44d6-a6eb-90e99c584658",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[273991, 7989, 129, 2, 163, "Subsubsection",ExpressionUUID->"fec6ad99-b541-47e2-af02-d1387b3fcbd2",
 InitializationCell->True],
Cell[274123, 7993, 1218, 33, 296, "Input",ExpressionUUID->"496fe63d-81c8-4b13-a8a4-f9a298910e3b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[275378, 8031, 177, 3, 163, "Subsubsection",ExpressionUUID->"cbb68869-387e-46a9-91fe-c38ab2cd7749",
 InitializationCell->True],
Cell[275558, 8036, 1945, 53, 707, "Input",ExpressionUUID->"40c35f3f-e1bd-42af-b379-2d3fb36cc075",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[277564, 8096, 510, 11, 34, "Section",ExpressionUUID->"14cee9d2-a113-4ae9-af7f-075128cb8f42",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[278099, 8111, 81, 2, 44, "Subsection",ExpressionUUID->"c43bd30d-f7a6-433d-b390-f907dd6c0567",
 InitializationCell->True,
 InitializationGroup->True],
Cell[278183, 8115, 2043, 49, 154, "Input",ExpressionUUID->"df9b4f82-a483-4226-93d3-4f6a4359f28f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[280263, 8169, 147, 3, 44, "Subsection",ExpressionUUID->"864dac4e-5d09-43bd-a3e5-8fad98076a4f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[280413, 8174, 2060, 49, 154, "Input",ExpressionUUID->"9dcca156-3907-4a7e-ac74-b6aefdb884ec",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[282522, 8229, 449, 8, 34, "Section",ExpressionUUID->"9db4d07b-c40f-4dc4-a2a0-e330b5718f6b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[282996, 8241, 81, 2, 44, "Subsection",ExpressionUUID->"fe5093b6-d494-4a24-aaca-d573366b3091",
 InitializationCell->True,
 InitializationGroup->True],
Cell[283080, 8245, 2217, 57, 238, "Input",ExpressionUUID->"70c37809-bc65-4eb0-8060-d9e7dab4d2f5",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[285334, 8307, 149, 3, 44, "Subsection",ExpressionUUID->"13e513bd-d8c9-4df7-b580-8b1c8f3d5b2c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[285486, 8312, 2308, 59, 238, "Input",ExpressionUUID->"0580462f-81dd-47ab-a50d-bb4b3061a1ef",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[287843, 8377, 441, 8, 34, "Section",ExpressionUUID->"655c546c-a349-436f-b482-fc2bf1b021b7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[288309, 8389, 121, 3, 35, "Subsubsection",ExpressionUUID->"14f1a7c8-64e3-4c69-9e0e-e635b3532269",
 InitializationCell->True,
 InitializationGroup->True],
Cell[288433, 8394, 809, 21, 133, "Input",ExpressionUUID->"65cd4a38-1e52-440d-8701-1fddf022c100",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[289279, 8420, 134, 3, 29, "Subsubsection",ExpressionUUID->"78a62891-6749-4eb7-b396-885c98ab1c66",
 InitializationCell->True,
 InitializationGroup->True],
Cell[289416, 8425, 708, 19, 213, "Input",ExpressionUUID->"fd86c99c-ce8e-4aa1-8339-243e1a861032",
 InitializationCell->True],
Cell[290127, 8446, 1389, 32, 303, "Input",ExpressionUUID->"586e6d6a-1f11-4f3b-9cca-3e450041d496",
 InitializationCell->True,
 InitializationGroup->True],
Cell[291519, 8480, 1433, 32, 303, "Input",ExpressionUUID->"97be5798-880c-496d-a27e-1d18a2cfaa92",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[293001, 8518, 296, 5, 34, "Section",ExpressionUUID->"2e6cefdb-3cb1-415c-83d4-d9bbdfcd99aa",
 InitializationCell->True,
 InitializationGroup->True],
Cell[293300, 8525, 412, 9, 213, "Input",ExpressionUUID->"5fea97fe-77e8-45f1-b22f-df0fa850c307",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[293761, 8540, 210, 6, 41, "Subsubtitle",ExpressionUUID->"1d7ae850-817f-4758-8d96-ebf8e41bc785",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[293974, 8548, 150, 7, 208, "Input",ExpressionUUID->"f10549d8-2a4f-4d53-9d3c-6e404167ddb9",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Open  ]]
}
]
*)

