(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1093165,      27208]
NotebookOptionsPosition[    938950,      23960]
NotebookOutlinePosition[    939675,      23986]
CellTagsIndexPosition[    939632,      23983]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["QM`Liouville`", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.682593348337326*^9, 3.6825995718343973`*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"187063ca-7b27-4abf-9235-1dee47665ae7"],

Cell[CellGroupData[{

Cell["BeginPackage", "Subchapter",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9, 3.683109016913093*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"8e762383-fcd2-48b3-bd09-0e6feb622b1f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<QM`Liouville`\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Global`\>\"", ",", "\[IndentingNewLine]", "\"\<SpinDynamica`\>\"", 
      ",", "\[IndentingNewLine]", "\"\<General`UserLevel`\>\"", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"\"\<General`ModifyBuiltIn`\>\"", ","}], "*)"}], 
      "\[IndentingNewLine]", "\"\<QM`SpinOperators`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`Hilbert`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<General`Matrices`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<General`General3D`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<General`Miscellaneous`\>\""}], 
     "\[IndentingNewLine]", "}"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6825971242231607`*^9, 3.682597156161066*^9}, {
   3.682599563684887*^9, 3.682599565709125*^9}, {3.682600180412551*^9, 
   3.68260018180884*^9}, {3.6831102443489103`*^9, 3.683110248332019*^9}, {
   3.699434416910852*^9, 3.6994344240144053`*^9}, 3.7011512123398333`*^9, {
   3.7453968881327467`*^9, 3.745396891351912*^9}},
 CellLabel->
  "In[616]:=",ExpressionUUID->"ec2bcf2d-5229-401a-a1b6-5bbb430dfaba"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exports", "Subchapter",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"118d0f74-f89e-4151-8ce4-4306cfca17e0"],

Cell[CellGroupData[{

Cell["Operator Basis routines", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"548e2cf3-7328-40d3-ab05-b57997729384"],

Cell[CellGroupData[{

Cell["DefaultOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.464606576083426*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"a068a122-616f-45e2-a955-661720ad6234"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefaultOperatorBasis", "::", "usage"}], "=", 
   "\"\<DefaultOperatorBasis[] is the default setting for the operator basis, \
for the current SpinSystem[].\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.464606581149418*^9, 3.4646066025648327`*^9}, {
  3.543498562215748*^9, 3.543498570015136*^9}, {3.6826000429371147`*^9, 
  3.682600043099597*^9}},
 CellLabel->
  "In[617]:=",ExpressionUUID->"2714060c-f730-4217-91a4-aea909ce15e2"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"a1ee4236-a9e2-48da-b737-924f0bdd0c34"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasis", "::", "usage"}], "=", 
   "\"\<OperatorBasis[] returns the current operator basis.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438852277788183*^9, 3.43885228963599*^9}, 
   3.448354736261177*^9, {3.682600061434997*^9, 3.6826000678182163`*^9}},
 CellLabel->
  "In[618]:=",ExpressionUUID->"bc570312-46fe-40c4-a851-a5fa533218e9"]
}, Closed]],

Cell[CellGroupData[{

Cell["DefineOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.549961879086213*^9, 3.5499618919960623`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"272aef9f-351b-43e7-94ab-16769be1ff92"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "::", "usage"}], "=", 
   "\"\<DefineOperatorBasis[newopbasis,{op1,op2,..},opts] defines an operator \
basis newopbasis which may be used for superoperator matrix representations. \
The option CheckOperatorBasis->True may be used to check its suitability. \n\
The syntax DefineOperatorBasis[newopbasis,opbasis,ordering] defines an \
operator basis newopbasis based on an existing operator basis opbasis by \
reordering the basis operators. The List ordering specifies how the basis \
operators are reordered in the new basis. For example, if ordering is given \
by {2,1,3,4,5...}, then newopbasis  has the same basis operators as opbasis, \
but with the first two operators exchanged. \nThe syntax \
DefineOperatorBasis[newopbasis,opbasis,superop] defines an operator basis \
newopbasis based on an existing operator basis opbasis by applying the \
superoperator superop to each of the basis operators. \nThe syntax \
DefineOperatorBasis[newopbasis,opbasis,superop,ordering] defines an operator \
basis newopbasis by applying the superoperator superop to each of the basis \
operators of opbasis, ordered according to the list ordering. \nThe \
definition of a new operator basis using an arbitrary set of basis operators \
can be computationally intensive; the options described above, which build \
upon a pre-existing operator basis by reordering the operators and/or \
applying a superoperator to each of them, are computationally more efficient. \
\n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.448354744448742*^9, {3.699431130356435*^9, 3.699431564902205*^9}, {
   3.699459323083325*^9, 3.699459337206688*^9}, {3.699459376561305*^9, 
   3.699459489643423*^9}},
 CellLabel->
  "In[619]:=",ExpressionUUID->"c55c18ce-3498-41fd-99a1-73bb57dbb823"]
}, Closed]],

Cell[CellGroupData[{

Cell["DefinedOperatorBasisQ", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.549961879086213*^9, 3.549961896170025*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"4aebb580-fd78-41f1-9d3f-1eb212a90124"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedOperatorBasisQ", "::", "usage"}], "=", 
   "\"\<DefinedOperatorBasisQ[opbasis] returns True if opbasis has been \
defined as an operator basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5499618997498093`*^9, 3.549961925784142*^9}},
 CellLabel->
  "In[620]:=",ExpressionUUID->"2b5b27bb-ad78-4391-862c-66685660abc4"]
}, Closed]],

Cell[CellGroupData[{

Cell["UndefineOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"dbf5bfcb-83eb-481b-9a26-511cf3437a02"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UndefineOperatorBasis", "::", "usage"}], "=", 
   "\"\<UndefineOperatorBasis[opbasis] removes the definitions for opbasis so \
that the same symbol may be used for a different basis, if desired. \>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4483547515080433`*^9},
 CellLabel->
  "In[621]:=",ExpressionUUID->"60677553-ff4d-47d3-9ae7-e624f6a857c5"]
}, Closed]],

Cell[CellGroupData[{

Cell["SphericalRank", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.468155330782899*^9, 3.468155334051694*^9}, {
   3.46815677959601*^9, 3.4681567838570843`*^9}, {3.468164627224395*^9, 
   3.468164627767158*^9}, 3.642419888508445*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"f8fb3f26-c295-48e4-bfac-273db67c7a2a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalRank", "::", "usage"}], "=", 
   "\"\<SphericalRank is a possible setting for the Sorted option of \
SphericalTensorOperatorBasis.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429871324201727*^9, 3.429871368663629*^9}, {
  3.468154963801524*^9, 3.468155039700362*^9}, {3.468155341962016*^9, 
  3.468155383649239*^9}, {3.4681567964860077`*^9, 3.468156807276724*^9}},
 CellLabel->
  "In[622]:=",ExpressionUUID->"301755ad-7196-40b0-ada2-81c7f39da810"]
}, Closed]],

Cell[CellGroupData[{

Cell["CheckOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"f2afb4a5-4583-4803-a45e-553bb6cfe2d0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorBasis", "::", "usage"}], "=", 
   "\"\<CheckOperatorBasis[opbasis] checks an operator basis for \
orthogonality and normalization\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[623]:=",ExpressionUUID->"d9482299-a45c-4225-b445-2644e676e93f"]
}, Closed]],

Cell[CellGroupData[{

Cell["CurrentOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"9349f405-b6f7-4b6b-9f73-003dc02d947f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CurrentOperatorBasis", "::", "usage"}], "=", 
   "\"\<CurrentOperatorBasis[] has been superseded by OperatorBasis[].\>\""}],
   ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.448354774858035*^9, {3.456205487847122*^9, 3.4562054945210667`*^9}},
 CellLabel->
  "In[624]:=",ExpressionUUID->"516a4219-fbd3-458b-aec9-40e13dcf42e3"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorBasisDimension", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4526679103267593`*^9, 3.4526679254323397`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"cae6b226-1537-45f8-bebb-05a4d5cc1ee0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasisDimension", "::", "usage"}], "=", 
   "\"\<OperatorBasisDimension[opbasis] gives the dimension of the specified \
operator basis. OperatorBasisDimension[] gives the dimension of the current \
operator basis.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4526679310815573`*^9, 3.452667985726932*^9}, {
  3.4526684831707907`*^9, 3.452668495255981*^9}},
 CellLabel->
  "In[625]:=",ExpressionUUID->"1d14cc0b-558f-44a6-b863-82ca39fe3dee"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisOperators", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"d8290326-4e06-466d-aa1b-6db19e268a42"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisOperators", "::", "usage"}], "=", 
   "\"\<BasisOperators[opbasis] shows the basis operators for a particular \
operator basis. BasisOperators[] shows the basis operators for the currently \
active basis.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.448354783339031*^9},
 CellLabel->
  "In[626]:=",ExpressionUUID->"c1e35194-d5d1-4c00-aa1c-ae4f48fec4d1"]
}, Closed]],

Cell[CellGroupData[{

Cell["SetOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"990eacb6-0b1a-42bc-87ea-8ede7800756b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetOperatorBasis", "::", "usage"}], "=", 
   "\"\<SetOperatorBasis[opbasis,opts] sets the default operator basis for \
superoperator matrix representations. The option CheckOperatorBasis->False \
may be used to disable the time-consuming basis checking step. User-defined \
bases must first be defined by using the DefineOperatorBasis command.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.464607033711549*^9, 3.464607035436657*^9}, {
  3.472112511292946*^9, 3.472112527517727*^9}},
 CellLabel->
  "In[627]:=",ExpressionUUID->"4c4d7bfd-89a1-47c0-9ba2-ef560c88c60c"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Predefined Operator Bases", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4296978388064823`*^9, 3.429697840568261*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"07507f15-2e55-4fde-9bcc-9c5a0480ecd1"],

Cell[CellGroupData[{

Cell["ShiftAndPolarizationOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"e85ddb60-6497-4454-a57c-a8d340d22367"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftAndPolarizationOperatorBasis", "::", "usage"}], "=", 
   "\"\<ShiftAndPolarizationOperatorBasis[] generates a set of shift and \
polarization operators for the current spin system (which must have been set \
first using the SetSpinSystem command of the SpinOperators package). The \
operators are arranged in the same order as used in the Gamma package. The \
option Sorted\[Rule]True may be used to arrange the operators according to \
increasing coherence order. This basis may only be used if all nuclei are \
spins-1/2.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.468155062418538*^9, 3.468155063537328*^9}, {
  3.546535192130265*^9, 3.546535193938882*^9}},
 CellLabel->
  "In[628]:=",ExpressionUUID->"8d23864e-f895-4c17-98ae-07569e59c89f"]
}, Closed]],

Cell[CellGroupData[{

Cell["CartesianProductOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.459515333849709*^9, 3.459515339216311*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"033c2854-70f8-45b8-9c70-096698f43c31"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianProductOperatorBasis", "::", "usage"}], "=", 
   "\"\<CartesianProductOperatorBasis[] generates a set of Cartesian product \
operators for the current spin system (which must have been set first using \
the SetSpinSystem command of the SpinOperators package). Currently, this \
basis may only be used if all nuclei are spins-1/2. The option Sorted->True \
sorts the operators according to SpinProductRank and CoherenceOrder.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.459515345530847*^9, 3.459515371589775*^9}, {
  3.546535203516313*^9, 3.546535225627784*^9}},
 CellLabel->
  "In[629]:=",ExpressionUUID->"4ab2fb56-c1fa-48a2-a5ce-f9f275e30ca3"]
}, Closed]],

Cell[CellGroupData[{

Cell["ShiftAndZOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"8c825e3e-708d-4da4-9f2e-7c6d9bd30fcd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftAndZOperatorBasis", "::", "usage"}], "=", 
   "\"\<ShiftAndZOperatorBasis[] generates an orthonormal set of products of \
shift operators and z operators for the current spin system. The option \
Sorted->True may be used to sort according to coherence order. This basis is \
defined for any combination of spin quantum numbers. The option \
Sorted\[Rule]CoherenceOrder may be used to arrange the operators according to \
coherence order.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.462273166895113*^9, 3.462273196309677*^9}, {
  3.468155093786396*^9, 3.468155097810239*^9}, {3.546421684090328*^9, 
  3.5464217564911127`*^9}, {3.546535241669148*^9, 3.54653524219265*^9}},
 CellLabel->
  "In[630]:=",ExpressionUUID->"cc30f1c3-64c8-4ed9-ae6e-b60971d17f00"]
}, Closed]],

Cell[CellGroupData[{

Cell["SingletTripletOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4296978569276323`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"f701b516-f8b0-47ca-978b-be201877069e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletOperatorBasis", "::", "usage"}], "=", 
   "\"\<SingletTripletOperatorBasis[1] generates the direct product between \
the set of singlet-triplet bras and kets for a 2-spin-1/2 system. The option \
Sorted->True may be used to sort according to coherence order. \
SingletTripletOperatorBasis[2] generates the modified singlet-triplet \
operator basis as used in G. Pileio and M. H. Levitt, J. Chem. Phys. 130, \
214501-214514 (2009). This basis is automatically organized according to \
coherence order.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456736679916744*^9, 3.45673674802743*^9}, {
   3.4567373011814404`*^9, 3.456737311611559*^9}, 3.462273205219442*^9},
 CellLabel->
  "In[631]:=",ExpressionUUID->"dad18d23-aba3-4aa0-98ec-329cc87b867c"]
}, Closed]],

Cell[CellGroupData[{

Cell["ZeemanKetBraOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.433524791179223*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"daacff1e-fecc-4ba3-95a9-09eafdcbcfa8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ZeemanKetBraOperatorBasis", "::", "usage"}], "=", 
   "\"\<ZeemanKetBraOperatorBasis[] generates an operator basis consisting of \
ket.bra products where each ket and bra is a direct product of the Zeeman \
kets and bras for the individual spins in the defined spin system. This \
operator basis may be used for any spin quantum number. For the case of \
spins-1/2, ZeemanKetBraOperatorBasis is equivalent to \
ShiftAndPolarizationOperatorBasis. The option Sorted->True may be used to \
sort according to coherence order. The option Sorted\[Rule]\\\"Canonical\\\" \
generates canonical ordering with the set of Ket-Bra products arranged so \
that all quantum numbers for the Bras are ordered first, before the Ket \
quantum numbers are incremented. The option Sorted\[Rule]\\\"OrderBySpin\\\" \
arranges the Ket-Bra products so that all combinations of Ket-Bra quantum \
numbers for the first spin are completed before the quantum numbers for the \
second spin are incremented. \n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433524656785557*^9, 3.433524821087268*^9}, {
  3.468155132077271*^9, 3.468155135493196*^9}, {3.5464205370263166`*^9, 
  3.546420682440168*^9}, {3.5464215691043*^9, 3.546421583047607*^9}},
 CellLabel->
  "In[632]:=",ExpressionUUID->"1cd42991-335c-4dd8-b480-f2eb5c7e8c8a"]
}, Closed]],

Cell[CellGroupData[{

Cell["SphericalTensorOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.433524791179223*^9, {3.4345163664867773`*^9, 3.434516373371316*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"9bb61919-cd5f-4537-970d-9f4918264498"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensorOperatorBasis", "::", "usage"}], "=", 
   "\"\<SphericalTensorOperatorBasis[] generates an operator basis consisting \
of the complete set of irreducible spherical tensor operators for the defined \
spin system. The option Sorted->True or \
Sorted->{SphericalRank,CoherenceOrder} may be used to sort the basis, first \
according to spherical rank and then with respect to coherence order. The \
option Sorted->{CoherenceOrder,SphericalRank} sorts first with respect to \
coherence order, and then with respect to SphericalRank.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433524656785557*^9, 3.433524821087268*^9}, {
  3.4345163773062468`*^9, 3.434516410185973*^9}, {3.468155144198454*^9, 
  3.468155253199935*^9}},
 CellLabel->
  "In[633]:=",ExpressionUUID->"37629684-89f9-4e21-8bf3-a18f4b29982f"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Operator (extension of QM`SpinOperators`)", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.5320076640665073`*^9, 3.532007677935508*^9}, {
   3.6825997165873947`*^9, 3.682599725574627*^9}, 
   3.682608913810255*^9},ExpressionUUID->"fa957257-5c28-49d6-a55a-\
ce12e66cbefb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "::", "usage"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Operator", "::", "usage"}], ")"}], "<>", 
    "\"\<\nThe syntax Operator[op,opbasis,basis,options] causes an operator \
to be stored as an OperatorVectorRepresentation in the operator basis \
opbasis.\>\""}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53200769166718*^9, 3.5320077830581293`*^9}, {
  3.589263981258662*^9, 3.5892639849732647`*^9}, {3.589480064766369*^9, 
  3.589480067308*^9}, {3.682599695167693*^9, 3.682599705425665*^9}, {
  3.682609155370798*^9, 3.682609162175272*^9}},
 CellLabel->
  "In[634]:=",ExpressionUUID->"579e178b-9d8d-4a17-b871-4ac51ef4077a"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorVectorRepresentation", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.6825997458883257`*^9, 3.6825997464214087`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"d7584df1-c56c-4e5c-8fca-7d78426247d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "::", "usage"}], "=", 
   "\"\<OperatorVectorRepresentation[op,OperatorBasis->basis] derives the \
vector representation of an operator in a given operator basis.The vector \
representation of an operator Q is given by {(B1|Q),(B2|Q)..} where {|B1), \
|B2)..} are the basis operators.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[635]:=",ExpressionUUID->"0feaa58a-d210-4489-94db-240d02cf0cec"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorBasisTransformationMatrix", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.431059892057632*^9},ExpressionUUID->"f9d292b5-ee02-400c-a14a-\
93bad1915bca"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasisTransformationMatrix", "::", "usage"}], "=", 
   "\"\<OperatorBasisTransformationMatrix[opbasis2,opbasis1] is the matrix \
that may be applied to the basis operators of opbasis1 to transform them into \
the basis operators of opbasis2.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431060003530382*^9, 3.4310600308063107`*^9}, {
   3.431060247322496*^9, 3.431060282909151*^9}, 3.4310684919888067`*^9},
 CellLabel->
  "In[636]:=",ExpressionUUID->"fa7f2987-9843-4eee-b3c3-b16204745b17"]
}, Closed]],

Cell[CellGroupData[{

Cell["ExpressOperator", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.431059892057632*^9, 3.431060802965934*^9, {3.4594430378651123`*^9, 
   3.4594430410147133`*^9}},ExpressionUUID->"ed16f514-0d82-48b8-af2c-\
31d27769715b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpressOperator", "::", "usage"}], "=", 
   "\"\<ExpressOperator[op,opbasis,options] expresses an operator as a \
superposition of basis operators of the specified operator basis \
opbasis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431060003530382*^9, 3.4310600308063107`*^9}, {
   3.431060247322496*^9, 3.431060282909151*^9}, {3.431060804640409*^9, 
   3.431060847018827*^9}, 3.43107494979657*^9, {3.459443045867362*^9, 
   3.459443098345117*^9}, {3.5435149545582047`*^9, 3.543514979868443*^9}, 
   3.543944751936191*^9, {3.682599844115452*^9, 3.682599845441998*^9}},
 CellLabel->
  "In[637]:=",ExpressionUUID->"4e4feaf8-8c58-473f-8d2c-e3f42be05945"]
}, Closed]],

Cell[CellGroupData[{

Cell["LiouvilleBracket", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545643975979*^9, {3.682608729600243*^9, 3.682608750011409*^9}, {
   3.682608922627829*^9, 3.682608926620495*^9}, {3.682608991087707*^9, 
   3.682608997095499*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"fed9a1f9-fc91-421a-8eb8-d4d2f2f1a967"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleBracket", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<LiouvilleBracket[A,B,opbasis,basis,options] calculates the bracket \
Tr(\!\(\*SuperscriptBox[\(A\), \(\[Dagger]\)]\).B) using the specified \
Hilbert basis. The operator basis opbasis and Hilbert basis basis are used: \
If these are missing, the current OperatorBasis[] and Basis[] are used. \nThe \
option Normalize\[Rule]True normalizes both operators before taking the \
bracket. The default is Normalize->False.\n\
LiouvilleBracket[A,sop,B,opbasis,basis,options] calculates the bracket \
Tr(\!\(\*SuperscriptBox[\(A\), \(\[Dagger]\)]\).sop[B]) where sop is a \
superoperator. The operator basis opbasis and Hilbert basis basis are used: \
If these are missing, the current OperatorBasis[] and Basis[] are used. The \
option Normalize->True normalizes both operators before taking the bracket. \
The default is Normalize->False.\n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430894718371416*^9, 3.430894745387373*^9}, {
  3.449235021671195*^9, 3.449235029419876*^9}, {3.472112647166668*^9, 
  3.4721126526526937`*^9}, {3.4721126964946957`*^9, 3.4721127013853197`*^9}, {
  3.5330438100969467`*^9, 3.533043852487866*^9}, {3.682607836052731*^9, 
  3.682607837835514*^9}, {3.6826079236683493`*^9, 3.6826079451317663`*^9}, {
  3.682608974447358*^9, 3.6826089754952173`*^9}, {3.699434680685896*^9, 
  3.699434691124462*^9}},
 CellLabel->
  "In[638]:=",ExpressionUUID->"fd743d87-71ef-4733-8523-d24f519bcdcd"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorAmplitude", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.501995058791401*^9, 3.5019950653257504`*^9}, 
   3.502322836563464*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"a1b95aed-c89b-454d-92ee-1f3787f74cf2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorAmplitude", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<OperatorAmplitude[op1\[Rule]op2] provides the answer to a question of \
the form: \\\"How much of operator op2 is contained in operator op1?\\\".\n\
Formally, OperatorAmplitude[op1\[Rule]op2] returns the amplitude a, such that \
op1\[NonBreakingSpace]=\[NonBreakingSpace]a\[Cross]op2\[NonBreakingSpace]+\
\[NonBreakingSpace](operators orthogonal to op2).\nThe amplitude is given by \
the following expression: \
a\[NonBreakingSpace]=\[NonBreakingSpace](op2|op1)/(op2|op2) where (A|B)=Tr{\!\
\(\*SuperscriptBox[\(A\), \(\[Dagger]\)]\)B} is a Liouville bracket.\nThe \
syntax OperatorAmplitude[op2,op1] is equivalent to OperatorAmplitude[op1\
\[Rule]op2].\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430894718371416*^9, 3.430894745387373*^9}, {
  3.449235021671195*^9, 3.449235029419876*^9}, {3.472112647166668*^9, 
  3.4721126526526937`*^9}, {3.4721126964946957`*^9, 3.4721127013853197`*^9}, {
  3.501995069112587*^9, 3.5019952902251463`*^9}, {3.501995383402261*^9, 
  3.501995461658272*^9}, {3.501996544469832*^9, 3.501996555575652*^9}, {
  3.502012009191866*^9, 3.502012084917433*^9}, {3.502322838607835*^9, 
  3.502322840424123*^9}, {3.533176513272941*^9, 3.53317653980025*^9}, {
  3.674623574576624*^9, 3.674623921973181*^9}, {3.674623985884865*^9, 
  3.674624147969195*^9}, {3.6746241829599457`*^9, 3.674624187679563*^9}},
 CellLabel->
  "In[639]:=",ExpressionUUID->"11b03dc5-a773-423d-8c72-3af98db6c873"]
}, Closed]],

Cell[CellGroupData[{

Cell["Superoperators", "Section",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"c6bb8ca3-6385-4249-a68a-370815ae91e6"],

Cell[CellGroupData[{

Cell["Superoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}, 
   3.504109824945512*^9, {3.531926985057364*^9, 3.531926985926383*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"ae95a85d-4205-4fad-a402-a7ecb29ac4a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "::", "usage"}], "=", 
   "\"\<Superoperator[matrep,opbasis,basis,opts] defines a spin superoperator \
that has the matrix representation matrep in the specified operator basis \
opbasis and state basis basis. The current operator basis and state basis are \
assumed if opbasis or basis is missing. The options may include \
SuperoperatorType, which may be used to define whether the operator is \
unitary, hermitian, etc. Superoperator may also be called with the format \
Superoperator[sop,opbasis,basis,opts], where sop is a superoperator \
expression. The routine will then calculate the matrix representation and \
assign the SuperoperatorType automatically.\nSuperoperator may also have the \
form Superoperator[{X,evals,Xinv},opbasis,basis,opts] where X is a matrix \
whose columns are the eigenvectors of the matrix representation of the \
superoperator in the operator basis opbasis, evals are the eigenvalues, and \
Xinv is the inverse of X. This form is generated by applying NDiagonalize to \
a superoperator.\n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291333690934*^9, 3.448291357780293*^9}, {
   3.5041098271064587`*^9, 3.5041098609109488`*^9}, {3.5041101770207577`*^9, 
   3.504110189617758*^9}, {3.531829191563922*^9, 3.5318291919915*^9}, {
   3.531829256245398*^9, 3.531829349850441*^9}, 3.5319269893174686`*^9, {
   3.53192702098775*^9, 3.5319271510062227`*^9}, {3.5860895437716227`*^9, 
   3.5860895939143677`*^9}},
 CellLabel->
  "In[640]:=",ExpressionUUID->"b9ab0711-8dec-4db5-8fc7-19a8dbf4156a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorType", "::", "usage"}], "=", 
   "\"\<SuperoperatorType is an option for Superoperator, with possible \
values {None, Automatic, \\\"Hermitian\\\", \\\"Unitary\\\",\\\"Normal\\\"}\>\
\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531829197100492*^9, 3.5318292531763887`*^9}, {
  3.53192699331525*^9, 3.531927012747682*^9}},
 CellLabel->
  "In[641]:=",ExpressionUUID->"f318b2b9-ce66-48b8-857f-f2bea5252800"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckSuperoperatorType", "::", "usage"}], "=", 
   "\"\<CheckSuperoperatorType is an option for Superoperator, which \
suppresses checking of SuperoperatorType if \
CheckSuperoperatorType\[Rule]False\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5320048668339653`*^9, 3.5320049044374228`*^9}, {
  3.532005414704352*^9, 3.532005434061597*^9}},
 CellLabel->
  "In[642]:=",ExpressionUUID->"f4f01d5a-b77f-4915-8f9e-bf49840ec98c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "::", "usage"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"NDiagonalize", "::", "usage"}], ")"}], "<>", 
    "\"\<\\n\nThe syntax NDiagonalize[superop,opbasis,basis,opts] causes a \
superoperator to be converted into diagonalized form in the operator basis \
opbasis and state basis basis (explicit specification of these bases is \
optional). The option Assumptions may be used with NDiagonalize when it is \
applied to a superoperator. If Assumptions\[Rule]Automatic, the setting of \
SuperoperatorType determines whether assumptions of the type Assumptions\
\[Rule]{OrthogonalEigenvectors\[Rule]True} are used.\>\""}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.5860888497282*^9, 3.5860889892873507`*^9}, {
  3.586089604374913*^9, 3.586089709979775*^9}},
 CellLabel->
  "In[643]:=",ExpressionUUID->"26b04a42-0227-4ddf-af48-4ca292d5c4e8"]
}, Closed]],

Cell[CellGroupData[{

Cell["SuperoperatorQ", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}, {
  3.44834843702826*^9, 3.448348437953806*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"fd441cd3-9d11-4678-b315-380b9ab2439b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorQ", "::", "usage"}], "=", 
   "\"\<determines whether an expression has the form of a spin superoperator\
\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291333690934*^9, 3.448291357780293*^9}, {
  3.448348443010726*^9, 3.448348446668833*^9}},
 CellLabel->
  "In[644]:=",ExpressionUUID->"ce109f7a-5fa7-42d8-a8f3-7a94c145cdd2"]
}, Closed]],

Cell[CellGroupData[{

Cell["SuperoperatorType", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291327652368*^9, 3.448291329025457*^9}, 
   3.583412489866617*^9, {3.583412953317383*^9, 3.5834129541392508`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"815f9e47-f71d-44f9-a03d-44b24e4193dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorType", "::", "usage"}], "=", 
   "\"\<SuperoperatorType may also be applied to a superoperator to determine \
its type.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531829197100492*^9, 3.5318292531763887`*^9}, {
  3.583412394038204*^9, 3.583412409676866*^9}, {3.583412957545199*^9, 
  3.583412973757703*^9}, {3.583413004589858*^9, 3.5834130080896053`*^9}},
 CellLabel->
  "In[645]:=",ExpressionUUID->"4685b37b-4a64-4c20-8328-faf1eee8707f"]
}, Closed]],

Cell[CellGroupData[{

Cell["UnitySuperoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"52713970-be8d-40aa-9eac-ddfc71e86b54"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UnitySuperoperator", "::", "usage"}], "=", 
   "\"\<UnitySuperoperator[] is the unity superoperator\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4867106576014*^9, 3.486710657774458*^9}},
 CellLabel->
  "In[646]:=",ExpressionUUID->"9cabbed0-7e0f-4f05-864c-ab5d990d0db9"]
}, Closed]],

Cell[CellGroupData[{

Cell["NullSuperoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4673023563945723`*^9, 3.467302357088757*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"6435b168-8bd8-476f-a9e6-74ee6d6d1696"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NullSuperoperator", "::", "usage"}], "=", 
   "\"\<NullSuperoperator[] is the null superoperator\>\""}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.467302363213707*^9, 3.467302367308715*^9}, {
  3.486710830864059*^9, 3.486710831018444*^9}},
 CellLabel->
  "In[647]:=",ExpressionUUID->"8f00fbf2-ccda-46c5-9843-415f811db2ff"]
}, Closed]],

Cell[CellGroupData[{

Cell["CommutationSuperoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"61a95f21-0a98-48f7-8b9a-f88031f93f71"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommutationSuperoperator", "::", "usage"}], "=", 
   "\"\<CommutationSuperoperator[op,opts] is the commutation superoperator \
for the operator op. The options opts may contain specifications such as \
OperatorType\[Rule]\\\"Hermitian\\\", or Assumptions\[Rule]{OperatorType\
\[Rule]\\\"Hermitian\\\"} which determine how the CommutationSuperoperator is \
treated.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.586252148949502*^9, 3.586252243272376*^9}},
 CellLabel->
  "In[648]:=",ExpressionUUID->"d577d5fc-89a2-4d81-aa10-1042a8d3b56a"]
}, Closed]],

Cell[CellGroupData[{

Cell["LeftMultiplicationSuperoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7275227618740387`*^9, 3.7275227646246357`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"61a95f21-0a98-48f7-8b9a-f88031f93f71"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LeftMultiplicationSuperoperator", "::", "usage"}], "=", 
   "\"\<LeftMultiplicationSuperoperator[op,opts] is the superoperator that \
multiplies its operator argument from the left. The options opts may contain \
specifications such as OperatorType\[Rule]\\\"Hermitian\\\", or Assumptions\
\[Rule]{OperatorType\[Rule]\\\"Hermitian\\\"} which determine how the \
LeftMultiplicationSuperoperator is treated.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.586252148949502*^9, 3.586252243272376*^9}, {
  3.727522773974451*^9, 3.7275228607839007`*^9}},
 CellLabel->
  "In[649]:=",ExpressionUUID->"d577d5fc-89a2-4d81-aa10-1042a8d3b56a"]
}, Closed]],

Cell[CellGroupData[{

Cell["RightMultiplicationSuperoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.7275227618740387`*^9, 3.7275227720739555`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"61a95f21-0a98-48f7-8b9a-f88031f93f71"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RightMultiplicationSuperoperator", "::", "usage"}], "=", 
   "\"\<RightMultiplicationSuperoperator[op,opts] is the superoperator that \
multiplies its operator argument from the right. The options opts may contain \
specifications such as OperatorType\[Rule]\\\"Hermitian\\\", or Assumptions\
\[Rule]{OperatorType\[Rule]\\\"Hermitian\\\"} which determine how the \
RightMultiplicationSuperoperator is treated.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.586252148949502*^9, 3.586252243272376*^9}, {
  3.727522866121214*^9, 3.7275228833936357`*^9}},
 CellLabel->
  "In[650]:=",ExpressionUUID->"d577d5fc-89a2-4d81-aa10-1042a8d3b56a"]
}, Closed]],

Cell[CellGroupData[{

Cell["DoubleCommutationSuperoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"5fe1345f-c71b-4171-bda1-2d3024bf7ebf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DoubleCommutationSuperoperator", "::", "usage"}], "=", 
   "\"\<DoubleCommutationSuperoperator[op1,op2] is the double commutation \
superoperator [op1,[op2,<operand>]]\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[651]:=",ExpressionUUID->"edf08cac-ac7f-43a7-879a-335acb90a4b6"]
}, Closed]],

Cell[CellGroupData[{

Cell["ProjectionSuperoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614075954517*^9, 3.450614082159617*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"d5c3bec0-b8a5-4977-8e85-1fbbac55e282"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectionSuperoperator", "::", "usage"}], "=", 
   "\"\<ProjectionSuperoperator[op] is the superoperator for projection onto \
a normalized operator op, i.e. |op)(op|\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614085287265*^9, 3.450614109002995*^9}, 
   3.450614180007576*^9, {3.4556434524258842`*^9, 3.455643462806561*^9}},
 CellLabel->
  "In[652]:=",ExpressionUUID->"50452506-1695-496a-9c6b-9fe583149308"]
}, Closed]],

Cell[CellGroupData[{

Cell["ShiftSuperoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614075954517*^9, 3.450614082159617*^9}, 
   3.4506141488329372`*^9, {3.455462620006575*^9, 3.455462627162911*^9}, {
   3.455643408852893*^9, 3.45564340965786*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"4f4c0f0d-3b1a-4cbf-9206-da3cbb69c842"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftSuperoperator", "::", "usage"}], "=", 
   "\"\<ShiftSuperoperator[op2,op1] is the superoperator |op2)(op1|, where \
both op2 and op1 are automatically normalized before use.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614085287265*^9, 3.450614109002995*^9}, {
  3.450614150522191*^9, 3.450614177232225*^9}, {3.4554626340113564`*^9, 
  3.4554626529329844`*^9}, {3.4554626967994757`*^9, 3.455462721376337*^9}, {
  3.4554628077931547`*^9, 3.4554628125837307`*^9}, {3.455643414156969*^9, 
  3.455643443863118*^9}, {3.455643580145306*^9, 3.45564359234967*^9}},
 CellLabel->
  "In[653]:=",ExpressionUUID->"00ee9c17-d294-4379-ab81-3042f676651d"]
}, Closed]],

Cell[CellGroupData[{

Cell["CoherenceOrderFiltrationSuperoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614075954517*^9, 3.450614082159617*^9}, 
   3.4506141488329372`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"9e1c2b4e-d3cb-4fb6-9946-4f08a08fb078"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "::", "usage"}], "=", 
   "\"\<CoherenceOrderFiltrationSuperoperator[{order1, order2...}] is the \
superoperator for filtration through a set of coherence orders (all orders in \
the set {order1, order2...} being allowed, with other orders disallowed). \n\
CoherenceOrderFiltrationSuperoperator[spins,{order1, order2...}] is the \
superoperator for filtration through a set of coherence orders of spins (all \
orders of spins not included in {order1, order2...} are suppressed, while all \
orders for spins not included in spins are allowed).\n\
CoherenceOrderFiltrationSuperoperator[{spins1,{order1, \
order2...},{spins2,{order3, order4...}..}] filters successively through \
{order1, order2...} for spins1, orders {order3, order4...} for spins2, etc. \n\
Examples: After SetSpinSystem[4], CoherenceOrderFiltrationSuperoperator[0]or \
CoherenceOrderFiltrationSuperoperator[{0}] suppresses all coherences which \
are not zero-quantum for all four spins. \
CoherenceOrderFiltrationSuperoperator[{1,2},0] suppresses all coherences \
which are not zero-quantum for spins {1,2}, but permits all coherences for \
spins {3,4}. CoherenceOrderFiltrationSuperoperator[{{1,2},0},{{3,4},0}] \
suppresses all terms that are not zero-quantum for both sets of spins {1,2} \
and {3,4}. \n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614085287265*^9, 3.450614109002995*^9}, {
   3.450614150522191*^9, 3.450614177232225*^9}, 3.472112577824038*^9, {
   3.5872937849952374`*^9, 3.587293823212933*^9}, {3.722559374624462*^9, 
   3.722559552789167*^9}, {3.722559613944544*^9, 3.722559794241913*^9}, {
   3.722559828040889*^9, 3.722559970559312*^9}, {3.72256006268791*^9, 
   3.722560266661717*^9}, {3.722560359378787*^9, 3.722560374203562*^9}, {
   3.722561240220998*^9, 3.722561254765221*^9}},
 CellLabel->
  "In[654]:=",ExpressionUUID->"c63fe332-b1c6-4994-b32c-6e6c6d9e6d4e"]
}, Closed]],

Cell[CellGroupData[{

Cell["RotationSuperoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614075954517*^9, 3.450614082159617*^9}, 
   3.4506141488329372`*^9, {3.450614512363935*^9, 3.450614513504929*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"e63cf1a7-edd0-4cd3-92b6-f9f35765779a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RotationSuperoperator", "::", "usage"}], "=", 
   "\"\<RotationSuperoperator[spins,angle] is the superoperator for rotating \
a single spin or a set of spins through the specified angle. If spins is \
absent, all spins in the current SpinSystem are rotated. The following \
formats for angle may be used: 1. {\[Beta],\[Phi]} indicates a rotation \
through \[Beta] about an axis in the xy plane with the phase \[Phi]. The \
phase value may either be numeric, or be specified using the text codes \\\"x\
\\\", \\\"y\\\", \\\"-x\\\" for the quadrature phases. A code \\\"z\\\" \
indicates a rotation about the z-axis. 2. The format \
{\[Xi],{\[Theta],\[Phi]}} indicates a rotation through the angle \[Xi] about \
an axis with polar angles \[Theta] and \[Phi]. 3. The format \
{\[Alpha],\[Beta],\[Gamma]} indicates a rotation through the specified Euler \
angles, using the zyz convention.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614085287265*^9, 3.450614109002995*^9}, {
  3.450614150522191*^9, 3.450614177232225*^9}, {3.450614518943392*^9, 
  3.4506146162029953`*^9}, {3.4562008848391123`*^9, 3.456200967571823*^9}, {
  3.46036613598059*^9, 3.460366425441249*^9}},
 CellLabel->
  "In[655]:=",ExpressionUUID->"62109f1c-093d-411d-b4b5-2dcad0cd3afd"]
}, Closed]],

Cell[CellGroupData[{

Cell["SphericalComponentFiltrationSuperoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614075954517*^9, 3.450614082159617*^9}, 
   3.4506141488329372`*^9, {3.455462620006575*^9, 3.455462627162911*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"74924616-01e9-4346-bd53-644e727ba249"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalComponentFiltrationSuperoperator", "::", "usage"}], "=", 
   "\"\<SphericalComponentFiltrationSuperoperator[{\[Lambda],\[Mu]2,\[Mu]1}] \
is the superoperator for filtering out the spherical component of rank \
\[Lambda] with quantum order being transformed from \[Mu]1 to \[Mu]2.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614085287265*^9, 3.450614109002995*^9}, {
  3.450614150522191*^9, 3.450614177232225*^9}, {3.4554626340113564`*^9, 
  3.4554626529329844`*^9}, {3.4554626967994757`*^9, 3.455462721376337*^9}, {
  3.4554628077931547`*^9, 3.4554628125837307`*^9}},
 CellLabel->
  "In[656]:=",ExpressionUUID->"bf2fd61e-f0d9-448f-9670-50286d972679"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinPermutationSuperoperator", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614075954517*^9, 3.450614082159617*^9}, 
   3.4506141488329372`*^9, {3.455462620006575*^9, 3.455462627162911*^9}, 
   3.674820994422606*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"e02f9703-b8fe-4e42-aeef-965d01caaa03"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationSuperoperator", "::", "usage"}], "=", 
   "\"\<SpinPermutationSuperoperator[{j,k}] is the superoperator for exchange \
of spin j with spin k. SpinPermutationSuperoperator[{j,k,l,m..}] is the \
superoperator for a cyclic permutation of the specified spins, with \
j\[Rule]k,k\[Rule]l,l\[Rule]m, etc. \
SpinPermutationSuperoperator[{..{j2,k2..},{j1,k1..}}] is the operator for \
successive spin exchange operations, with the {j1,k1..} permutation preceding \
the {j2,k2..} permutation, and so on (i.e. right to left order of \
application).\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.450614085287265*^9, 3.450614109002995*^9}, {
  3.450614150522191*^9, 3.450614177232225*^9}, {3.4554626340113564`*^9, 
  3.4554626529329844`*^9}, {3.4554626967994757`*^9, 3.455462721376337*^9}, {
  3.4554628077931547`*^9, 3.4554628125837307`*^9}, {3.59066532252096*^9, 
  3.590665377134338*^9}},
 CellLabel->
  "In[657]:=",ExpressionUUID->"9859cfcd-1359-4911-82a8-a7ac15ff85dc"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SuperoperatorMatrixRepresentation", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.467185313640114*^9, {3.467185877859024*^9, 3.467185881511248*^9}, {
   3.504634456253194*^9, 3.504634459098456*^9}, 3.699454907630204*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"f6da1490-e755-4af9-84d5-c913a8fdd2ca"],

Cell[CellGroupData[{

Cell["SuperoperatorMatrixRepresentation", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"24667546-be9a-40a3-9cf7-6a6fc7f7e608"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "::", "usage"}], "=", 
   "\"\<SuperoperatorMatrixRepresentation[superop,opbasis] derives the matrix \
representation of a superoperator in a given operator basis. The option \
Method\[Rule]Automatic (default) uses an intermediate basis in which \
factorization of the basis operators into ket-bra products is used to speed \
up the computation. Method\[Rule]\\\"Direct\\\" uses explicit matrix \
representations of the basis operators in the chosen basis.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429871422585617*^9, 3.429871579018825*^9}, {
   3.4298716124539547`*^9, 3.429871613210964*^9}, {3.4310556287296677`*^9, 
   3.431055701460805*^9}, {3.4310557421356087`*^9, 3.431055847872901*^9}, {
   3.431055920855256*^9, 3.4310559228891277`*^9}, {3.431055962020856*^9, 
   3.4310559665290537`*^9}, {3.431056013785091*^9, 3.431056014649042*^9}, {
   3.4310575628876867`*^9, 3.431057571697908*^9}, {3.467185318844652*^9, 
   3.467185423925668*^9}, {3.467185811458497*^9, 3.467185864532456*^9}, {
   3.4671859949404078`*^9, 3.46718605657799*^9}, {3.467189316167138*^9, 
   3.467189319012134*^9}, {3.467189356341836*^9, 3.4671893676436787`*^9}, 
   3.4671897117274513`*^9, {3.5585979228721037`*^9, 3.558597925911508*^9}, {
   3.5861798917743387`*^9, 3.586179892282897*^9}},
 CellLabel->
  "In[658]:=",ExpressionUUID->"a43c875b-6ec2-4484-94bc-b0fe72b1a2bb"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["start", "Subchapter",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"fa99ccdc-127c-4b57-9db3-8f5e0e31fb95"],

Cell["Begin[\"`Private`\"];", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True,
 CellLabel->
  "In[659]:=",ExpressionUUID->"09cf0984-4fba-451b-9860-b22b7a115c70"]
}, Closed]],

Cell[CellGroupData[{

Cell["operator bases", "Subchapter",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"ecd8b176-1efe-4e10-8abe-94ffdd3692d9"],

Cell[CellGroupData[{

Cell["general OperatorBasis functions", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431060747067363*^9, 3.431060752108149*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"3bbcd1ba-4661-4efa-bfe7-300ae138b62c"],

Cell[CellGroupData[{

Cell["DefaultOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.464606553194216*^9, 3.464606554344688*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"24bae18d-4fe6-4143-a53c-b8d7babfff5e"],

Cell["\<\
set the ShiftAndZOperatorBasis unless one of the spin quantum numbers is \
larger than 3/2\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.543498715646261*^9, 
  3.543498740877181*^9}},ExpressionUUID->"7033ab28-d590-4b1d-b4be-\
820fdc9579ef"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefaultOperatorBasis", "[", "]"}], ":=", 
   RowBox[{"DefaultOperatorBasis", "[", 
    RowBox[{"SpinSystem", "[", "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.464606619141943*^9, 3.464606636838656*^9}, {
  3.4994760933722563`*^9, 3.4994760941049967`*^9}, {3.499477033634185*^9, 
  3.499477036101337*^9}, {3.5434985862473383`*^9, 3.543498610372622*^9}},
 CellLabel->
  "In[660]:=",ExpressionUUID->"477f3baf-1140-41e8-9565-7dc4f05748be"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefaultOperatorBasis", "[", "Undefined", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "undefspinsys"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.549963559707336*^9, 3.549963608769212*^9}, {
   3.549963688824651*^9, 3.549963689980289*^9}, 3.621614563586226*^9, 
   3.683131677036306*^9},
 CellLabel->
  "In[661]:=",ExpressionUUID->"b6414a09-1242-48ec-b06c-ef92907d7a80"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefaultOperatorBasis", "[", 
    RowBox[{"spinsys_", "?", "MatrixQ"}], "]"}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Max", "[", 
       RowBox[{"Last", "/@", "spinsys"}], "]"}], ">", 
      RowBox[{"3", "/", "2"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"ZeemanKetBraOperatorBasis", "[", 
      RowBox[{"spinsys", ",", 
       RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ShiftAndZOperatorBasis", "[", 
      RowBox[{"spinsys", ",", 
       RowBox[{"Sorted", "\[Rule]", "CoherenceOrder"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.543498697511668*^9, 3.543498712425684*^9}, {
  3.5434987453037643`*^9, 3.5434988321564217`*^9}, {3.546419990017642*^9, 
  3.546419996469902*^9}, {3.546420318809383*^9, 3.5464203235595903`*^9}, {
  3.5464205182186947`*^9, 3.546420523112941*^9}},
 CellLabel->
  "In[662]:=",ExpressionUUID->"98e1395b-f6ac-427f-a5fa-b2201c6fabde"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"f68c566d-f3ac-434b-a8ac-54fd81aa143f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "OperatorBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"OperatorBasis", "\[Rule]", "Undefined"}], "}"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456205513747723*^9, 3.456205514872799*^9}, 
   3.5470253241487017`*^9, 3.618474974966139*^9, {3.618475063969901*^9, 
   3.618475068779724*^9}},
 CellLabel->
  "In[663]:=",ExpressionUUID->"03260836-9110-4fe5-835c-5902f55392bf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorBasisUndefined", ":=", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{"OperatorBasis", "/.", 
      RowBox[{"Options", "[", "OperatorBasis", "]"}]}], ",", "Undefined"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.618474963641426*^9, 3.618474970634253*^9}, {
  3.618475159292572*^9, 3.618475202921008*^9}},
 CellLabel->
  "In[664]:=",ExpressionUUID->"4cbba03e-68c7-4ca7-8b01-6de4691f2d61"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"If", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"SpinSystem", "[", "]"}], ",", "Undefined"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{"OperatorBasis", "::", "undefspinsys"}], "]"}], ";", 
        "Undefined"}], ")"}], ",", "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"SetOperatorBasis", "[", 
         RowBox[{
          RowBox[{"DefaultOperatorBasis", "[", "]"}], ",", 
          RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"OperatorBasis", "[", "]"}]}], "\[IndentingNewLine]", ")"}]}],
      "]"}], "/;", "OperatorBasisUndefined"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4675719869974127`*^9, 3.467571995566154*^9}, {
   3.467572026096467*^9, 3.4675720465446873`*^9}, {3.4675721788744926`*^9, 
   3.467572295838645*^9}, {3.467572358207*^9, 3.4675723705583277`*^9}, 
   3.467572477319313*^9, 3.468059310617125*^9, {3.468069304692505*^9, 
   3.4680693189579372`*^9}, 3.468739187974431*^9, {3.468739219117922*^9, 
   3.4687392308536673`*^9}, 3.502510957976528*^9, {3.543498634351037*^9, 
   3.543498634708907*^9}, 3.547025327191963*^9, 3.618474985990484*^9, {
   3.640522065477326*^9, 3.640522068645411*^9}, 3.640598311335198*^9, {
   3.683131557687402*^9, 3.6831316305868*^9}, {3.6831317032762117`*^9, 
   3.683131786564267*^9}},
 CellLabel->
  "In[665]:=",ExpressionUUID->"1722f5e2-f856-4cd7-88f5-971ec7746d58"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"OperatorBasis", "::", "inapprop"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SetOperatorBasis", "[", 
       RowBox[{
        RowBox[{"DefaultOperatorBasis", "[", "]"}], ",", 
        RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"OperatorBasis", "[", "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"!", "OperatorBasisUndefined"}], ")"}], "&&", 
      "\[IndentingNewLine]", 
      RowBox[{"!", 
       RowBox[{"Equal", "[", 
        RowBox[{
         RowBox[{"SpinSystem", "@", 
          RowBox[{"Basis", "[", "]"}]}], ",", 
         RowBox[{"SpinSystem", "[", 
          RowBox[{
           RowBox[{"OperatorBasis", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "OperatorBasis", "]"}]}], "]"}]}], 
        "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4675719869974127`*^9, 3.467571995566154*^9}, {
   3.467572026096467*^9, 3.4675720465446873`*^9}, {3.4675721788744926`*^9, 
   3.467572295838645*^9}, {3.467572358207*^9, 3.4675723705583277`*^9}, 
   3.467572477319313*^9, 3.468059310617125*^9, {3.468069304692505*^9, 
   3.4680693189579372`*^9}, 3.482571677908627*^9, 3.502510960650214*^9, 
   3.543498640578289*^9, 3.547025328133247*^9, 3.618474996086699*^9, {
   3.618475211600966*^9, 3.6184752157931137`*^9}, {3.6405135815824738`*^9, 
   3.640513591018116*^9}, 3.640513679956243*^9, 3.6405240014726973`*^9},
 CellLabel->
  "In[666]:=",ExpressionUUID->"e6e81d1f-73c2-4379-9b18-e4718c5d082a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"OperatorBasis", "::", "inapprop"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SetOperatorBasis", "[", 
       RowBox[{
        RowBox[{"DefaultOperatorBasis", "[", "]"}], ",", 
        RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"OperatorBasis", "[", "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SpinSystem", "[", 
        RowBox[{
         RowBox[{"OperatorBasis", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "OperatorBasis", "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"SpinSystem", "[", "]"}]}], "\[IndentingNewLine]", "]"}]}]}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4675719869974127`*^9, 3.467571995566154*^9}, {
   3.467572026096467*^9, 3.4675720465446873`*^9}, {3.4675721788744926`*^9, 
   3.467572295838645*^9}, {3.467572358207*^9, 3.4675723705583277`*^9}, 
   3.467572477319313*^9, {3.467572648578116*^9, 3.467572830934133*^9}, {
   3.468068564255434*^9, 3.46806858019201*^9}, {3.468068866088204*^9, 
   3.4680688741910353`*^9}, 3.468068913971218*^9, 3.468069283163095*^9, 
   3.5025109634011383`*^9, 3.54349864196224*^9},
 CellLabel->
  "In[667]:=",ExpressionUUID->"c325434a-0f28-4a64-804f-45e08ea4feee"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{
    RowBox[{"OperatorBasis", "/.", 
     RowBox[{"{", "opts", "}"}]}], "/.", 
    RowBox[{"Options", "[", "OperatorBasis", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.456205521127266*^9, 3.456205542889594*^9}},
 CellLabel->
  "In[668]:=",ExpressionUUID->"d1a1f601-0c16-4b14-8ee1-4c2f8805c29c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasis", "::", "unknown"}], "=", 
   "\"\<Operator basis is undefined.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433526524792596*^9, 3.433526570684641*^9}, {
  3.4335267173847313`*^9, 3.433526742654161*^9}, {3.44835359230692*^9, 
  3.448353600961087*^9}, {3.448353874907015*^9, 3.448353887265395*^9}, {
  3.44835430037437*^9, 3.448354306090509*^9}},
 CellLabel->
  "In[669]:=",ExpressionUUID->"469eff81-c596-47dd-90c7-f813facef9d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasis", "::", "inapprop"}], "=", 
   "\"\<The current operator basis is inappropriate for the current spin \
system or the current spin state basis.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433526524792596*^9, 3.433526570684641*^9}, {
   3.4335267173847313`*^9, 3.433526742654161*^9}, {3.44835359230692*^9, 
   3.448353600961087*^9}, {3.448353874907015*^9, 3.448353887265395*^9}, {
   3.448353953526429*^9, 3.448354001223502*^9}, {3.448354070055814*^9, 
   3.44835409288188*^9}, {3.448354310934194*^9, 3.448354321243894*^9}, 
   3.464607059934794*^9, {3.468068837420492*^9, 3.468068860138248*^9}, {
   3.4680692268929768`*^9, 3.4680692289137173`*^9}, {3.468069389359618*^9, 
   3.4680693998191977`*^9}},
 CellLabel->
  "In[670]:=",ExpressionUUID->"77408a0b-b477-46a0-8d4e-eeab419f820d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasis", "::", "invalidsortopt"}], "=", 
   "\"\<Invalid value of Sorted. The operator basis `1` takes the following \
values of Sorted: `2`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4681554666629887`*^9, 3.46815551836884*^9}, {
  3.659536387732334*^9, 3.659536414953041*^9}, {3.659536819089313*^9, 
  3.659536830221992*^9}, {3.659536871913013*^9, 3.659536875781868*^9}, {
  3.6595471738453197`*^9, 3.659547187969236*^9}, {3.65954738749923*^9, 
  3.659547430053753*^9}},
 CellLabel->
  "In[671]:=",ExpressionUUID->"d523acd1-8ab3-4c75-8665-ab6bd1e8767c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasis", "::", "undefspinsys"}], "=", 
   "\"\<The spin system is undefined. Set the spin system using \
SetSpinSystem[..]\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.549963615473879*^9, 3.549963644230515*^9}, 
   3.68313166568804*^9},
 CellLabel->
  "In[672]:=",ExpressionUUID->"8b03a650-31e8-4b62-964f-64c677658c6c"]
}, Closed]],

Cell[CellGroupData[{

Cell["DefineOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"b415fee5-b097-41be-9a4a-58787105e70e"],

Cell[CellGroupData[{

Cell["options", "Subsubsection",
 CellChangeTimes->{{3.699431757238006*^9, 
  3.699431758373024*^9}},ExpressionUUID->"d1062567-ac53-445d-88ed-\
9673a2d13541"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DefineOperatorBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"CheckOperatorBasis", "\[Rule]", "True"}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.699455318282962*^9, 3.69945531933744*^9}},
 CellLabel->
  "In[673]:=",ExpressionUUID->"302423a5-b3f3-4d23-b89c-5177e0bdc1d6"]
}, Closed]],

Cell[CellGroupData[{

Cell["check whether already defined", "Subsubsection",
 CellChangeTimes->{{3.699431757238006*^9, 3.699431768701005*^9}, {
  3.699431922640235*^9, 3.699431929758881*^9}, {3.699455398629737*^9, 
  3.6994554049168587`*^9}},ExpressionUUID->"897b8276-023b-43e1-8bcf-\
3c042db68bf7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefineOperatorBasis", "[", 
     RowBox[{"newopbasis_", ",", "args___"}], "]"}], "/;", 
    RowBox[{"DefinedOperatorBasisQ", "[", "newopbasis", "]"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"DefineOperatorBasis", "::", "alreadydef"}], ",", 
       "newopbasis"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"UndefineOperatorBasis", "[", "newopbasis", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"DefineOperatorBasis", "[", 
      RowBox[{"newopbasis", ",", "args"}], "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699455412540601*^9, 3.699455484049519*^9}},
 CellLabel->
  "In[674]:=",ExpressionUUID->"3d30fd2c-b48b-4992-9f49-1876feb0d958"]
}, Closed]],

Cell[CellGroupData[{

Cell["define an operator basis as a synonym of an existing one", \
"Subsubsection",
 CellChangeTimes->{{3.699431757238006*^9, 3.699431768701005*^9}, {
  3.699431922640235*^9, 3.699431929758881*^9}, {3.699457368491379*^9, 
  3.699457390272089*^9}},ExpressionUUID->"4ac127f3-ac4e-4159-8ad6-\
fe648d74b9c3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "[", 
    RowBox[{"newopbasis_", ",", 
     RowBox[{"opbasis_", "?", "DefinedOperatorBasisQ"}], ",", "opts___Rule"}],
     "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"BasisOperators", "[", "newopbasis", "]"}], "=", 
      RowBox[{"BasisOperators", "[", "opbasis", "]"}]}], ";", 
     RowBox[{
      RowBox[{"DefinedOperatorBasisQ", "[", "newopbasis", "]"}], "=", 
      "True"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "newopbasis", "]"}], "^=", 
      RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"DefineOperatorBasis", "::", "defined"}], ",", "newopbasis"}], 
      "]"}], ";", "\[IndentingNewLine]", "newopbasis"}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699457403801634*^9, 3.699457479997591*^9}, {
  3.699457555512117*^9, 3.699457556589941*^9}},
 CellLabel->
  "In[675]:=",ExpressionUUID->"03096aeb-2fdb-464a-b5fa-70e8f07ec4a3"]
}, Closed]],

Cell[CellGroupData[{

Cell["define by using an existing OperatorBasis", "Subsubsection",
 CellChangeTimes->{{3.699431757238006*^9, 3.699431768701005*^9}, {
  3.6994319365206347`*^9, 3.699431956344208*^9}, {3.6994337497906847`*^9, 
  3.699433759732986*^9}, {3.6994578118797073`*^9, 3.699457820272633*^9}, {
  3.699895488088072*^9, 
  3.699895490092353*^9}},ExpressionUUID->"ca70e748-ece9-42aa-8f45-\
998dc2db6b58"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "[", 
    RowBox[{"newopbasis_", ",", 
     RowBox[{"ordering", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", 
         RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"DefineOperatorBasis", "[", 
    RowBox[{"newopbasis", ",", 
     RowBox[{"OperatorBasis", "[", "]"}], ",", "ordering", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699456510401971*^9, 3.69945653474339*^9}, {
  3.709397189529563*^9, 3.709397209981119*^9}},
 CellLabel->
  "In[676]:=",ExpressionUUID->"281832dc-2426-4e5c-8829-84d4a1ec53c8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "[", 
    RowBox[{"newopbasis_", ",", 
     RowBox[{"opbasis_", "?", "DefinedOperatorBasisQ"}], ",", 
     RowBox[{"ordering", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", 
         RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"DefineOperatorBasis", "[", 
    RowBox[{"newopbasis", ",", "opbasis", ",", 
     RowBox[{"UnitySuperoperator", "[", "]"}], ",", "ordering", ",", "opts"}],
     "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6998933710076733`*^9, 3.699893418581601*^9}, {
   3.709396846738735*^9, 3.709396849974646*^9}, 3.709397216816527*^9},
 CellLabel->
  "In[677]:=",ExpressionUUID->"10484e48-93d3-4cfb-ac9f-25efb25d015f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "[", 
    RowBox[{"newopbasis_", ",", 
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"DefineOperatorBasis", "[", 
    RowBox[{"newopbasis", ",", 
     RowBox[{"OperatorBasis", "[", "]"}], ",", "sop", ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699456573352893*^9, 3.699456599951045*^9}, {
  3.69945833971661*^9, 3.6994583444032383`*^9}},
 CellLabel->
  "In[678]:=",ExpressionUUID->"f675d2a3-0f22-4941-b834-69efd3497de0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "[", 
    RowBox[{"newopbasis_", ",", 
     RowBox[{"opbasis_", "?", "DefinedOperatorBasisQ"}], ",", 
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"DefineOperatorBasis", "[", 
    RowBox[{"newopbasis", ",", "opbasis", ",", "sop", ",", 
     RowBox[{"Range", "[", 
      RowBox[{"1", ",", 
       RowBox[{"OperatorBasisDimension", "[", "opbasis", "]"}]}], "]"}], ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699456573352893*^9, 3.699456599951045*^9}, {
   3.699458271543298*^9, 3.699458280023148*^9}, {3.699458357703807*^9, 
   3.699458394266975*^9}, 3.699459030880437*^9, 3.709396864778469*^9},
 CellLabel->
  "In[679]:=",ExpressionUUID->"d86aa196-229b-467f-8bfe-6bc7f45813dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefineOperatorBasis", "[", 
     RowBox[{"newopbasis_", ",", "opbasis_", ",", 
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
      RowBox[{"ordering", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"DefinedOperatorBasisQ", "[", "opbasis", "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"DefineOperatorBasis", "::", "undefopbasis"}], ",", 
       "opbasis"}], "]"}], ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699431985624724*^9, 3.69943202298342*^9}, {
   3.699432078019124*^9, 3.69943207957926*^9}, {3.699432229915667*^9, 
   3.699432231233994*^9}, {3.6994338422573442`*^9, 3.699433848222601*^9}, {
   3.699458431663538*^9, 3.6994584351903763`*^9}, 3.70939687625751*^9, 
   3.709397248894834*^9},
 CellLabel->
  "In[680]:=",ExpressionUUID->"d3e85f0e-e077-4037-854e-9e8b20bda8a4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefineOperatorBasis", "[", 
     RowBox[{"newopbasis_", ",", 
      RowBox[{"opbasis_", "?", "DefinedOperatorBasisQ"}], ",", 
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
      RowBox[{"ordering", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Sort", "[", "ordering", "]"}], "\[NotEqual]", 
     RowBox[{"Range", "[", 
      RowBox[{"1", ",", 
       RowBox[{"OperatorBasisDimension", "[", "opbasis", "]"}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"DefineOperatorBasis", "::", "badordering"}], ",", 
       RowBox[{"OperatorBasisDimension", "[", "opbasis", "]"}]}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699431985624724*^9, 3.69943202298342*^9}, {
   3.699432078019124*^9, 3.699432200781694*^9}, {3.699432235133656*^9, 
   3.699432246281789*^9}, {3.6994584719373093`*^9, 3.699458472695003*^9}, 
   3.709396923492346*^9, 3.709397251886978*^9},
 CellLabel->
  "In[681]:=",ExpressionUUID->"826eebd9-e08a-4306-83d9-50ba12760c92"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DefineOperatorBasis", "[", 
     RowBox[{"newopbasis_", ",", 
      RowBox[{"opbasis_", "?", "DefinedOperatorBasisQ"}], ",", 
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
      RowBox[{"ordering", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"CheckOperatorBasis", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "DefineOperatorBasis", "]"}]}], ")"}], "&&", 
     "\[IndentingNewLine]", 
     RowBox[{"!", 
      RowBox[{"UnitaryMatrixQ", "@", 
       RowBox[{"SuperoperatorMatrixRepresentation", "[", 
        RowBox[{"sop", ",", "opbasis"}], "]"}]}]}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"DefineOperatorBasis", "::", "notUsop"}], ",", "sop"}], "]"}], 
     ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699431985624724*^9, 3.69943202298342*^9}, {
   3.699432078019124*^9, 3.699432200781694*^9}, {3.699432235133656*^9, 
   3.699432246281789*^9}, {3.6994338736773148`*^9, 3.699433926464261*^9}, {
   3.6994551757411757`*^9, 3.699455223145372*^9}, {3.6994584931189528`*^9, 
   3.699458494091868*^9}, 3.7093969306199493`*^9, 3.7093972544547453`*^9},
 CellLabel->
  "In[682]:=",ExpressionUUID->"d4029c59-371f-4704-967c-2c25bc6af83e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "[", 
    RowBox[{"newopbasis_", ",", 
     RowBox[{"opbasis_", "?", "DefinedOperatorBasisQ"}], ",", 
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"ordering", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", 
         RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spinsys", ",", "basis", ",", "permmat", ",", "NL"}], "}"}], 
     ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"spinsys", "=", 
        RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"basis", "=", 
        RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"NL", "=", 
        RowBox[{"OperatorBasisDimension", "[", "opbasis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisOperators", "[", "newopbasis", "]"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"ExpressOperator", "[", 
           RowBox[{
            RowBox[{"sop", "[", "#", "]"}], ",", "opbasis"}], "]"}], "&"}], "/@", 
         RowBox[{
          RowBox[{"BasisOperators", "[", "opbasis", "]"}], 
          "\[LeftDoubleBracket]", "ordering", "\[RightDoubleBracket]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"permmat", "=", 
        RowBox[{"SparseArray", "@", 
         RowBox[{"ReplacePart", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"DiagonalMatrix", "[", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", "NL", "}"}]}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Inner", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"#1", ",", "#2"}], "}"}], "\[Rule]", "1"}], ")"}], 
              "&"}], ",", "ordering", ",", 
             RowBox[{"Range", "[", 
              RowBox[{"1", ",", "NL"}], "]"}], ",", "List"}], "]"}]}], 
          "\[IndentingNewLine]", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"OperatorBasisTransformationMatrix", "[", 
         RowBox[{"newopbasis", ",", "opbasis", ",", "basis"}], "]"}], "=", 
        "\[IndentingNewLine]", 
        RowBox[{"permmat", ".", 
         RowBox[{"Adjoint", "@", 
          RowBox[{"SuperoperatorMatrixRepresentation", "[", 
           RowBox[{"sop", ",", "opbasis", ",", "basis"}], "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"IntermediateOperatorBasis", "[", "newopbasis", "]"}], "=", 
        "opbasis"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CheckOperatorBasis", "[", "newopbasis", "]"}], "=", 
        RowBox[{
         RowBox[{"CheckOperatorBasis", "[", "opbasis", "]"}], "&&", 
         RowBox[{"UnitaryMatrixQ", "@", 
          RowBox[{"SuperoperatorMatrixRepresentation", "[", 
           RowBox[{"sop", ",", "opbasis"}], "]"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DefinedOperatorBasisQ", "[", "newopbasis", "]"}], "=", 
        "True"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SpinSystem", "[", "newopbasis", "]"}], "^=", 
        RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"DefineOperatorBasis", "::", "defined"}], ",", 
         "newopbasis"}], "]"}], ";", "\[IndentingNewLine]", "newopbasis"}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.468068684743115*^9, 3.468068702110346*^9}, {
   3.482570387736146*^9, 3.4825703968642683`*^9}, 3.4825704364665117`*^9, {
   3.699431787358808*^9, 3.69943179297229*^9}, {3.699431961098681*^9, 
   3.699431974424609*^9}, {3.699432346443796*^9, 3.6994324096195087`*^9}, {
   3.699432456862856*^9, 3.699432461572669*^9}, {3.699432499666954*^9, 
   3.69943250908047*^9}, {3.6994326158119307`*^9, 3.699432626373473*^9}, {
   3.699432672339061*^9, 3.6994327884805117`*^9}, {3.699432878909185*^9, 
   3.699433273244261*^9}, {3.699433983652973*^9, 3.699434058749394*^9}, {
   3.699456756289543*^9, 3.699456792269659*^9}, {3.6994573297722816`*^9, 
   3.6994573359215393`*^9}, {3.699457503233725*^9, 3.6994575130162497`*^9}, {
   3.699457829489066*^9, 3.699457851549273*^9}, {3.6994585056318083`*^9, 
   3.699458506228544*^9}, {3.699458544303275*^9, 3.699458545772368*^9}, {
   3.699458597277493*^9, 3.699458626266522*^9}, {3.699458806431041*^9, 
   3.699458862669587*^9}, {3.699622741901033*^9, 3.699622742238859*^9}, {
   3.699625377202503*^9, 3.699625390667809*^9}, {3.699895568992957*^9, 
   3.699895651394044*^9}, 3.709396943644741*^9, 3.7093972573198223`*^9},
 CellLabel->
  "In[683]:=",ExpressionUUID->"2bc8979c-562f-4522-bfe0-5ba18fcd8de4"]
}, Closed]],

Cell[CellGroupData[{

Cell["define by specifying basis operators", "Subsubsection",
 CellChangeTimes->{{3.699431757238006*^9, 3.699431768701005*^9}, {
  3.699431922640235*^9, 3.699431929758881*^9}, {3.699457777617359*^9, 
  3.699457783029633*^9}},ExpressionUUID->"131c12d4-7e03-47c2-b3c6-\
9401665b7ca8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "[", 
    RowBox[{"newopbasis_", ",", 
     RowBox[{"basisops", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"check", ",", "basischeck"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"DefineOperatorBasis", "::", "maybeslow"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"check", "=", 
        RowBox[{
         RowBox[{"CheckOperatorBasis", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "DefineOperatorBasis", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisOperators", "[", "newopbasis", "]"}], "=", "basisops"}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"check", "&&", 
            RowBox[{"CheckOperatorBasis", "[", "basisops", "]"}]}], ")"}], "||", 
          RowBox[{"!", "check"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"DefinedOperatorBasisQ", "[", "newopbasis", "]"}], "=", 
            "True"}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"SpinSystem", "[", "newopbasis", "]"}], "^=", 
            RowBox[{"SpinSystem", "[", "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefineOperatorBasis", "::", "defined"}], ",", 
             "newopbasis"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"!", "check"}], ",", 
             RowBox[{"Message", "[", 
              RowBox[{
               RowBox[{"DefineOperatorBasis", "::", "nocheckwarning"}], ",", 
               "newopbasis"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
           "newopbasis"}], "\[IndentingNewLine]", ")"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"DefineOperatorBasis", "::", "notdef"}], ",", 
             "newopbasis"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BasisOperators", "[", "newopbasis", "]"}], "=."}]}], 
          "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699455678021784*^9, 3.6994557753291197`*^9}, {
   3.699455824711293*^9, 3.699455847050506*^9}, {3.699455877622148*^9, 
   3.699455883746778*^9}, {3.699456047503438*^9, 3.699456087691831*^9}, {
   3.699456162671975*^9, 3.699456163044957*^9}, {3.6994562389042253`*^9, 
   3.699456245174143*^9}, {3.699457531178266*^9, 3.699457534302911*^9}, {
   3.709276526474585*^9, 3.709276543336985*^9}, {3.7092765774269342`*^9, 
   3.709276585838269*^9}, {3.709276637536909*^9, 3.709276661006999*^9}, {
   3.7092769922045794`*^9, 3.7092769923847227`*^9}, {3.709284239941059*^9, 
   3.709284263576981*^9}, {3.7092843502144337`*^9, 3.7092843544034357`*^9}, {
   3.709393875017393*^9, 3.7093938857599497`*^9}, 3.709397373547167*^9, {
   3.709397453890108*^9, 3.709397483751692*^9}, {3.7093975198143387`*^9, 
   3.709397551385014*^9}, 3.7093976003707542`*^9},
 CellLabel->
  "In[684]:=",ExpressionUUID->"7cfc5b73-703a-46fe-a85d-1c2e210cb3da"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 CellChangeTimes->{{3.699431757238006*^9, 
  3.69943177905184*^9}},ExpressionUUID->"8d4504ca-d6c7-436d-892e-\
f153d68abedc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "::", "defined"}], "=", 
   "\"\<The operator basis `1` has been defined.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[685]:=",ExpressionUUID->"e1ad9fd5-2a18-4f19-8250-bcf5a2e3308e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "::", "notdef"}], "=", 
   "\"\<The operator basis `1` has not been defined.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699455788626273*^9, 3.699455791240075*^9}},
 CellLabel->
  "In[686]:=",ExpressionUUID->"6edf1edb-2a2e-4a48-ac26-ec7cc71df102"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "::", "alreadydef"}], "=", 
   "\"\<The operator basis `1` is already defined.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699456355242173*^9, 3.6994563642876587`*^9}},
 CellLabel->
  "In[687]:=",ExpressionUUID->"f328ad23-55bf-4e02-9105-af1d38836645"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "::", "nocheck"}], "=", 
   "\"\<The operator basis `1` has not been checked for completeness or \
orthonormality.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[688]:=",ExpressionUUID->"3dc9ed77-74d8-4ef2-8188-55f7f31ad656"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "::", "undefopbasis"}], "=", 
   "\"\<The operator basis `1` has not been defined and cannot be used to \
derive a new operator basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699432036606474*^9, 3.6994320644686117`*^9}},
 CellLabel->
  "In[689]:=",ExpressionUUID->"eb0fd18d-5b2e-4a0c-8c80-97a4551b61ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "::", "badordering"}], "=", 
   "\"\<The ordering list argument must contain the integers from 1 to `1`, \
each appearing only once.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699432036606474*^9, 3.6994320644686117`*^9}, {
  3.699432257394767*^9, 3.699432324764085*^9}},
 CellLabel->
  "In[690]:=",ExpressionUUID->"03cef53c-f404-4c14-a219-31eeeb465ef9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "::", "notUsop"}], "=", 
   "\"\<The superoperator `1` is not unitary.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699432036606474*^9, 3.6994320644686117`*^9}, {
  3.699432257394767*^9, 3.699432324764085*^9}, {3.6994339506371737`*^9, 
  3.69943396240648*^9}},
 CellLabel->
  "In[691]:=",ExpressionUUID->"9755e8a0-7d88-40ca-934c-6f12b09bf033"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "::", "maybeslow"}], "=", 
   "\"\<An OperatorBasis consisting of an arbitrary set of operators may be \
slow to set up for larger spin systems. Consider using one of the special \
cases of DefineOperatorBasis (execute ?DefineOperatorBasis for \
details).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.709393687628538*^9, 3.709393816337543*^9}, 
   3.7093976283566504`*^9},
 CellLabel->
  "In[692]:=",ExpressionUUID->"135a780a-7c00-4599-b980-fab462b3ea1d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineOperatorBasis", "::", "nocheckwarning"}], "=", 
   "\"\<The new operator basis `1` has not been checked for orthonormality.\>\
\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.709397538690941*^9, 3.70939761783119*^9}},
 CellLabel->
  "In[693]:=",ExpressionUUID->"f114016c-d048-4f88-aa6c-ae2ab6d418ae"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["DefinedOperatorBasisQ", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.438854466372497*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"97823ce8-a2d5-43b0-bab3-901eb4e80803"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedOperatorBasisQ", "[", 
    RowBox[{"TransformedOperatorBasis", "[", 
     RowBox[{"opbasis_", ",", "sop_", ",", "opts___Rule"}], "]"}], "]"}], "^:=", 
   RowBox[{"DefinedOperatorBasisQ", "[", 
    RowBox[{"opbasis", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429810906571207*^9, 3.4298109624411077`*^9}},
 CellLabel->
  "In[694]:=",ExpressionUUID->"6e4c37be-3181-4b9c-a817-5a7dea056e72"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedOperatorBasisQ", "[", "opbasis_", "]"}], ":=", "False"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[695]:=",ExpressionUUID->"4ea1c0e5-0dc2-43a4-860a-b6398b9f34d6"]
}, Closed]],

Cell[CellGroupData[{

Cell["BuiltinOperatorBasisQ", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.438854466372497*^9, 3.482569899950584*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"ae1a562e-0557-4b91-ab50-5f12d8222d79"],

Cell["defined as True for the individual opbasis definitions", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.4825699112698603`*^9, 
  3.482569923804666*^9}},ExpressionUUID->"f7adcab0-4035-4300-8779-\
e878749afdcd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BuiltinOperatorBasisQ", "[", "opbasis_", "]"}], ":=", "False"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4825699030957747`*^9},
 CellLabel->
  "In[696]:=",ExpressionUUID->"6e85b082-51b1-4643-8bfd-391d19d3f38a"]
}, Closed]],

Cell[CellGroupData[{

Cell["UndefineOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"bda60a35-18f2-4756-8f89-0e86f95ea11d"],

Cell["\<\
includes clearing of any OperatorBasisTransformationMatrix and \
IntermediateOperatorBasis settings that include this basis.\
\>", "Text",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4394344493670177`*^9, 3.439434470028729*^9}, {
  3.439434525648065*^9, 3.4394345265806932`*^9}, {3.699893599761632*^9, 
  3.699893607767045*^9}},ExpressionUUID->"ddfebf69-e85b-48bc-8525-\
70743c09e311"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UndefineOperatorBasis", "[", "opbasis_", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"DefinedOperatorBasisQ", "[", "opbasis", "]"}]}]}], ":=", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"UndefineOperatorBasis", "::", "notdef"}], ",", "opbasis"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6568700642578573`*^9, 3.656870105052923*^9}, {
  3.6568703521847887`*^9, 3.656870369649864*^9}},
 CellLabel->
  "In[697]:=",ExpressionUUID->"f8f5a62e-e1c7-451f-b818-ff33dde782e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UndefineOperatorBasis", "[", "opbasis_", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"obtmdefs", ",", "iobdefs", ",", "chkobdefs"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"BasisOperators", "[", "opbasis", "]"}], "=."}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"opbasis", "/:", 
        RowBox[{"SpinSystem", "[", "opbasis", "]"}], "=."}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"obtmdefs", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{
          "DownValues", "[", "OperatorBasisTransformationMatrix", "]"}], ",", 
          
          RowBox[{
           RowBox[{"FreeQ", "[", 
            RowBox[{"#", ",", "opbasis"}], "]"}], "&"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\t", 
       RowBox[{"Clear", "[", "OperatorBasisTransformationMatrix", "]"}], ";", 
       "\[IndentingNewLine]", "\t", 
       RowBox[{
        RowBox[{"DownValues", "[", "OperatorBasisTransformationMatrix", "]"}],
         "=", "obtmdefs"}], ";", "\[IndentingNewLine]", 
       RowBox[{"iobdefs", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"DownValues", "[", "IntermediateOperatorBasis", "]"}], ",", 
          
          RowBox[{
           RowBox[{"FreeQ", "[", 
            RowBox[{"#", ",", "opbasis"}], "]"}], "&"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\t", 
       RowBox[{"Clear", "[", "IntermediateOperatorBasis", "]"}], ";", 
       "\[IndentingNewLine]", "\t", 
       RowBox[{
        RowBox[{"DownValues", "[", "IntermediateOperatorBasis", "]"}], "=", 
        "iobdefs"}], ";", "\[IndentingNewLine]", 
       RowBox[{"chkobdefs", "=", 
        RowBox[{"Select", "[", 
         RowBox[{
          RowBox[{"DownValues", "[", "CheckOperatorBasis", "]"}], ",", 
          RowBox[{
           RowBox[{"FreeQ", "[", 
            RowBox[{"#", ",", "opbasis"}], "]"}], "&"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\t", 
       RowBox[{"Clear", "[", "CheckOperatorBasis", "]"}], ";", 
       "\[IndentingNewLine]", "\t", 
       RowBox[{
        RowBox[{"DownValues", "[", "CheckOperatorBasis", "]"}], "=", 
        "chkobdefs"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DefinedOperatorBasisQ", "[", "opbasis", "]"}], "=", 
        "False"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"UndefineOperatorBasis", "::", "undefined"}], ",", 
         "opbasis"}], "]"}], ";"}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4394345333951597`*^9, 3.4394346152362823`*^9}, 
   3.439553945705853*^9, {3.46806900148256*^9, 3.4680690145475492`*^9}, {
   3.4680691031683817`*^9, 3.468069108150302*^9}, {3.6998935369637117`*^9, 
   3.699893594737034*^9}, {3.6998936570693007`*^9, 3.699893661474518*^9}, {
   3.699895664289383*^9, 3.699895702285284*^9}},
 CellLabel->
  "In[698]:=",ExpressionUUID->"f126d4e7-b68f-47ad-b143-e00c054e8b85"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedOperatorBasisQ", "[", "opbasis_", "]"}], ":=", "False"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[699]:=",ExpressionUUID->"fc7df26d-e729-4454-9675-2ccd17b58c0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UndefineOperatorBasis", "::", "undefined"}], "=", 
   "\"\<The operator basis `1` has been undefined, and associated operator \
basis transformation matrices removed.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439434625002722*^9, 3.439434641006014*^9}},
 CellLabel->
  "In[700]:=",ExpressionUUID->"7c339d8a-fcf4-45c5-99c4-f845e18657e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UndefineOperatorBasis", "::", "notdef"}], "=", 
   "\"\<The operator basis `1` is not defined, so cannot be undefined. No \
action was taken.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.438853275163869*^9, 3.438853278243451*^9}, {
  3.439434649053713*^9, 3.439434653318637*^9}, {3.656870117037912*^9, 
  3.6568701555784397`*^9}, {3.656870382558894*^9, 3.6568703855394897`*^9}},
 CellLabel->
  "In[701]:=",ExpressionUUID->"c7b06a6e-783e-4c90-a10c-e7a6cad671f6"]
}, Closed]],

Cell[CellGroupData[{

Cell["SetOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"5347247f-34c1-47f4-9e84-c4be01ef8b24"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5736371204136477`*^9, 
  3.573637130427702*^9}},ExpressionUUID->"8b116b1f-4aa8-4165-8462-\
e60c7ec77a26"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SetOperatorBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"CheckOperatorBasis", "->", "False"}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[702]:=",ExpressionUUID->"d9d7d6fa-cfe6-4c25-b86b-e18008568829"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOperatorBasis", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.6831310258354063`*^9, 3.6831310419298067`*^9}},
 CellLabel->
  "In[703]:=",ExpressionUUID->"8cc1bf41-77d0-48c9-abf3-4dfcd54a91ca"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetOperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{"SetOperatorBasis", "[", 
    RowBox[{
     RowBox[{"DefaultOperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448363658165825*^9, 3.448363724992177*^9}, {
   3.464606532636898*^9, 3.464606537668998*^9}, 3.464606643944117*^9, 
   3.5434986435130577`*^9},
 CellLabel->
  "In[704]:=",ExpressionUUID->"1aae1e06-f0b2-45f1-acda-08e6f737f557"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOperatorBasis", "[", 
     RowBox[{"opbasis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", "OperatorBasisUndefined"}], ")"}], "&&", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"opbasis", ",", 
       RowBox[{
        RowBox[{"OperatorBasis", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "OperatorBasis", "]"}]}]}], "]"}]}]}], ":=", 
   RowBox[{"Message", "[", 
    RowBox[{
     RowBox[{"SetOperatorBasis", "::", "alreadyset"}], ",", "opbasis"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6184726939971113`*^9, 3.61847273351505*^9}, {
   3.618475245560628*^9, 3.6184752560898733`*^9}, {3.618482694124762*^9, 
   3.618482698420643*^9}, {3.620580836898225*^9, 3.620580846486684*^9}, 
   3.620581299802796*^9},
 CellLabel->
  "In[705]:=",ExpressionUUID->"8287df2d-3111-41dc-8b68-5d44196afa91"]
}, Closed]],

Cell[CellGroupData[{

Cell["case of no parallel kernels", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5736371204136477`*^9, 3.573637130427702*^9}, {
  3.573637197083303*^9, 3.57363720380864*^9}, {3.57363744918861*^9, 
  3.573637459368451*^9}},ExpressionUUID->"0405437c-1612-4156-8bf8-\
392e0c0c5e7a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOperatorBasis", "[", 
     RowBox[{"opbasis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"DefinedOperatorBasisQ", "[", "opbasis", "]"}], "&&", 
     RowBox[{"(", 
      RowBox[{"$KernelCount", "\[Equal]", "0"}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "check", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"check", "=", 
        RowBox[{
         RowBox[{"CheckOperatorBasis", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "SetOperatorBasis", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{"check", ",", "\[IndentingNewLine]", "\t", 
         RowBox[{"If", "[", "\[IndentingNewLine]", "\t", 
          RowBox[{
           RowBox[{"CheckOperatorBasis", "[", "opbasis", "]"}], ",", 
           "\[IndentingNewLine]", "\t\t", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"SetOptions", "[", 
              RowBox[{"OperatorBasis", ",", 
               RowBox[{"OperatorBasis", "->", "opbasis"}]}], "]"}], ";", 
             "\[IndentingNewLine]", "\t\t", 
             RowBox[{"Message", "[", 
              RowBox[{
               RowBox[{"SetOperatorBasis", "::", "set"}], ",", "opbasis"}], 
              "]"}]}], "\[IndentingNewLine]", "\t\t", ")"}], ",", 
           "\[IndentingNewLine]", "\t\t", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Message", "[", 
              RowBox[{"SetOperatorBasis", "::", "unsuitable"}], "]"}], ";", 
             "$Failed"}], ")"}]}], "\[IndentingNewLine]", "\t", "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"BuiltinOperatorBasisQ", "[", "opbasis", "]"}], ",", 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"(", "\[IndentingNewLine]", "\t", 
          RowBox[{
           RowBox[{"SetOptions", "[", 
            RowBox[{"OperatorBasis", ",", 
             RowBox[{"OperatorBasis", "->", "opbasis"}]}], "]"}], ";", 
           "\[IndentingNewLine]", "\t", 
           RowBox[{
           "OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
            "\t\t", 
            RowBox[{"opbasis", ",", "\[IndentingNewLine]", "\t\t", 
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}]}], 
            "\[IndentingNewLine]", "\t", "]"}], ";", "\[IndentingNewLine]", 
           "\t", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"SetOperatorBasis", "::", "set"}], ",", "opbasis"}], 
            "]"}]}], "\[IndentingNewLine]", "\t", ")"}], ",", 
         "\[IndentingNewLine]", "True", ",", "\[IndentingNewLine]", "\t", 
         RowBox[{"(", "\[IndentingNewLine]", "\t", 
          RowBox[{
           RowBox[{"SetOptions", "[", 
            RowBox[{"OperatorBasis", ",", 
             RowBox[{"OperatorBasis", "->", "opbasis"}]}], "]"}], ";", 
           "\[IndentingNewLine]", "\t", 
           RowBox[{
           "OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
            "\t\t", 
            RowBox[{"opbasis", ",", "\[IndentingNewLine]", "\t\t", 
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}]}], 
            "\[IndentingNewLine]", "\t", "]"}], ";", "\[IndentingNewLine]", 
           "\t", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"SetOperatorBasis", "::", "set"}], ",", "opbasis"}], 
            "]"}], ";", "\[IndentingNewLine]", "\t", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"TrueQ", "[", 
               RowBox[{"CheckOperatorBasis", "[", "opbasis", "]"}], "]"}]}], 
             ",", 
             RowBox[{"Message", "[", 
              RowBox[{"SetOperatorBasis", "::", "nocheck"}], "]"}]}], "]"}], 
           ";"}], "\[IndentingNewLine]", "\t", ")"}]}], "\[IndentingNewLine]",
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388539208733187`*^9, 3.438853996176445*^9}, 
   3.438854436529134*^9, {3.438855035251855*^9, 3.438855035407763*^9}, {
   3.438855467770858*^9, 3.4388555566399317`*^9}, {3.438855598642376*^9, 
   3.43885563351132*^9}, {3.43885615836898*^9, 3.438856191909359*^9}, {
   3.43893852031846*^9, 3.4389385397452593`*^9}, {3.438939118099194*^9, 
   3.4389391227872887`*^9}, 3.438939160395403*^9, {3.4483561942317963`*^9, 
   3.448356246481285*^9}, {3.448356982171489*^9, 3.448356990587553*^9}, {
   3.4483572473809557`*^9, 3.448357286780758*^9}, {3.448357407934898*^9, 
   3.448357628740314*^9}, {3.448357717647818*^9, 3.4483577190272818`*^9}, {
   3.448359314874755*^9, 3.4483594920650177`*^9}, {3.4483595268663282`*^9, 
   3.448359579073408*^9}, {3.448363766277382*^9, 3.44836377159562*^9}, {
   3.46203979078051*^9, 3.462039810620604*^9}, {3.462191875568749*^9, 
   3.462191878599942*^9}, 3.464606674193232*^9, {3.464607124342613*^9, 
   3.464607200598524*^9}, {3.464607392573062*^9, 3.464607397307663*^9}, 
   3.464608043695148*^9, {3.468154783415557*^9, 3.468154787101762*^9}, {
   3.482569877390193*^9, 3.482569881179469*^9}, {3.565419072247696*^9, 
   3.5654191707854843`*^9}, {3.565419212481415*^9, 3.565419378139112*^9}, {
   3.573637259009452*^9, 3.573637270517584*^9}, {3.629118479511653*^9, 
   3.629118505469306*^9}, {3.659600857277733*^9, 3.6596008906750526`*^9}},
 CellLabel->
  "In[706]:=",ExpressionUUID->"6c57990f-0bf3-4f4c-a9ab-23a1e0db04da"]
}, Closed]],

Cell[CellGroupData[{

Cell["case of Parallel kernels", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5736371204136477`*^9, 3.573637130427702*^9}, {
  3.573637197083303*^9, 3.57363720380864*^9}, {3.5736372848531923`*^9, 
  3.573637289721788*^9}, {3.573637462384614*^9, 
  3.573637466695087*^9}},ExpressionUUID->"d38d8109-7b09-401d-9f1b-\
e87ef701ebe5"],

Cell["master kernel:", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.573637982073984*^9, 3.5736379851445503`*^9}, 
   3.5736380524723186`*^9},ExpressionUUID->"c4814db0-1776-4c7b-a2e1-\
948dfdb0528c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOperatorBasis", "[", 
     RowBox[{"opbasis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"DefinedOperatorBasisQ", "[", "opbasis", "]"}], "&&", 
     RowBox[{"(", 
      RowBox[{"$KernelCount", ">", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{"$KernelID", "\[Equal]", "0"}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "check", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"check", "=", 
        RowBox[{
         RowBox[{"CheckOperatorBasis", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "SetOperatorBasis", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{"check", ",", "\[IndentingNewLine]", "\t", 
         RowBox[{"If", "[", "\[IndentingNewLine]", "\t", 
          RowBox[{
           RowBox[{"CheckOperatorBasis", "[", "opbasis", "]"}], ",", 
           "\[IndentingNewLine]", "\t\t", 
           RowBox[{"(", "\[IndentingNewLine]", "\t\t", 
            RowBox[{
             RowBox[{"SetOptions", "[", 
              RowBox[{"OperatorBasis", ",", 
               RowBox[{"OperatorBasis", "->", "opbasis"}]}], "]"}], ";", 
             "\[IndentingNewLine]", "\t\t", 
             RowBox[{"Message", "[", 
              RowBox[{
               RowBox[{"SetOperatorBasis", "::", "set"}], ",", "opbasis"}], 
              "]"}]}], "\[IndentingNewLine]", "\t\t", ")"}], ",", 
           "\[IndentingNewLine]", "\t\t", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Message", "[", 
              RowBox[{"SetOperatorBasis", "::", "unsuitable"}], "]"}], ";", 
             "$Failed"}], ")"}]}], "\[IndentingNewLine]", "\t", "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"BuiltinOperatorBasisQ", "[", "opbasis", "]"}], ",", 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"(", "\[IndentingNewLine]", "\t", 
          RowBox[{
           RowBox[{"SetOptions", "[", 
            RowBox[{"OperatorBasis", ",", 
             RowBox[{"OperatorBasis", "->", "opbasis"}]}], "]"}], ";", 
           "\[IndentingNewLine]", "\t", 
           RowBox[{
           "OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
            "\t\t", 
            RowBox[{"opbasis", ",", "\[IndentingNewLine]", "\t\t", 
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}]}], 
            "\[IndentingNewLine]", "\t", "]"}], ";", "\[IndentingNewLine]", 
           "\t", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"SetOperatorBasis", "::", "set"}], ",", "opbasis"}], 
            "]"}]}], "\[IndentingNewLine]", "\t", ")"}], ",", 
         "\[IndentingNewLine]", "True", ",", "\[IndentingNewLine]", "\t", 
         RowBox[{"(", "\[IndentingNewLine]", "\t", 
          RowBox[{
           RowBox[{"SetOptions", "[", 
            RowBox[{"OperatorBasis", ",", 
             RowBox[{"OperatorBasis", "->", "opbasis"}]}], "]"}], ";", 
           "\[IndentingNewLine]", "\t", 
           RowBox[{
           "OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
            "\t\t", 
            RowBox[{"opbasis", ",", "\[IndentingNewLine]", "\t\t", 
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}]}], 
            "\[IndentingNewLine]", "\t", "]"}], ";", "\[IndentingNewLine]", 
           "\t", 
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"SetOperatorBasis", "::", "set"}], ",", "opbasis"}], 
            "]"}], ";", "\[IndentingNewLine]", "\t", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"TrueQ", "[", 
               RowBox[{"CheckOperatorBasis", "[", "opbasis", "]"}], "]"}]}], 
             ",", 
             RowBox[{"Message", "[", 
              RowBox[{"SetOperatorBasis", "::", "nocheck"}], "]"}]}], "]"}]}],
           "\[IndentingNewLine]", "\t", ")"}]}], "\[IndentingNewLine]", "]"}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"DistributeDefinitions", "[", 
        RowBox[{"OperatorBasis", ",", "OperatorBasisTransformationMatrix"}], 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388539208733187`*^9, 3.438853996176445*^9}, 
   3.438854436529134*^9, {3.438855035251855*^9, 3.438855035407763*^9}, {
   3.438855467770858*^9, 3.4388555566399317`*^9}, {3.438855598642376*^9, 
   3.43885563351132*^9}, {3.43885615836898*^9, 3.438856191909359*^9}, {
   3.43893852031846*^9, 3.4389385397452593`*^9}, {3.438939118099194*^9, 
   3.4389391227872887`*^9}, 3.438939160395403*^9, {3.4483561942317963`*^9, 
   3.448356246481285*^9}, {3.448356982171489*^9, 3.448356990587553*^9}, {
   3.4483572473809557`*^9, 3.448357286780758*^9}, {3.448357407934898*^9, 
   3.448357628740314*^9}, {3.448357717647818*^9, 3.4483577190272818`*^9}, {
   3.448359314874755*^9, 3.4483594920650177`*^9}, {3.4483595268663282`*^9, 
   3.448359579073408*^9}, {3.448363766277382*^9, 3.44836377159562*^9}, {
   3.46203979078051*^9, 3.462039810620604*^9}, {3.462191875568749*^9, 
   3.462191878599942*^9}, 3.464606674193232*^9, {3.464607124342613*^9, 
   3.464607200598524*^9}, {3.464607392573062*^9, 3.464607397307663*^9}, 
   3.464608043695148*^9, {3.468154783415557*^9, 3.468154787101762*^9}, {
   3.482569877390193*^9, 3.482569881179469*^9}, {3.565419072247696*^9, 
   3.5654191707854843`*^9}, {3.565419212481415*^9, 3.565419378139112*^9}, {
   3.573637259009452*^9, 3.573637440349605*^9}, {3.573637674159219*^9, 
   3.5736376875548487`*^9}, {3.57363785123735*^9, 3.5736378537163258`*^9}, 
   3.5736379098284817`*^9, {3.573637990565219*^9, 3.573638041784175*^9}, 
   3.659600909743435*^9},
 CellLabel->
  "In[707]:=",ExpressionUUID->"82ec7437-b84c-4fa7-b039-b20e1dbb0ab6"],

Cell["subkernels:", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.573638045231696*^9, 
  3.5736380491428967`*^9}},ExpressionUUID->"61bd7455-453b-4d4e-a832-\
acea780f6006"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetOperatorBasis", "[", 
     RowBox[{"opbasis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"DefinedOperatorBasisQ", "[", "opbasis", "]"}], "&&", 
     RowBox[{"(", 
      RowBox[{"$KernelCount", ">", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{"$KernelID", "!=", "0"}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "check", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"check", "=", 
        RowBox[{
         RowBox[{"CheckOperatorBasis", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "SetOperatorBasis", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{"check", ",", "\[IndentingNewLine]", "\t", 
         RowBox[{"If", "[", "\[IndentingNewLine]", "\t", 
          RowBox[{
           RowBox[{"CheckOperatorBasis", "[", "opbasis", "]"}], ",", 
           "\[IndentingNewLine]", "\t\t", 
           RowBox[{"SetOptions", "[", 
            RowBox[{"OperatorBasis", ",", 
             RowBox[{"OperatorBasis", "->", "opbasis"}]}], "]"}], ",", 
           "\[IndentingNewLine]", "\t\t", "$Failed"}], "\[IndentingNewLine]", 
          "\t", "]"}], ",", "\[IndentingNewLine]", "True", ",", 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"SetOptions", "[", 
          RowBox[{"OperatorBasis", ",", 
           RowBox[{"OperatorBasis", "->", "opbasis"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4388539208733187`*^9, 3.438853996176445*^9}, 
   3.438854436529134*^9, {3.438855035251855*^9, 3.438855035407763*^9}, {
   3.438855467770858*^9, 3.4388555566399317`*^9}, {3.438855598642376*^9, 
   3.43885563351132*^9}, {3.43885615836898*^9, 3.438856191909359*^9}, {
   3.43893852031846*^9, 3.4389385397452593`*^9}, {3.438939118099194*^9, 
   3.4389391227872887`*^9}, 3.438939160395403*^9, {3.4483561942317963`*^9, 
   3.448356246481285*^9}, {3.448356982171489*^9, 3.448356990587553*^9}, {
   3.4483572473809557`*^9, 3.448357286780758*^9}, {3.448357407934898*^9, 
   3.448357628740314*^9}, {3.448357717647818*^9, 3.4483577190272818`*^9}, {
   3.448359314874755*^9, 3.4483594920650177`*^9}, {3.4483595268663282`*^9, 
   3.448359579073408*^9}, {3.448363766277382*^9, 3.44836377159562*^9}, {
   3.46203979078051*^9, 3.462039810620604*^9}, {3.462191875568749*^9, 
   3.462191878599942*^9}, 3.464606674193232*^9, {3.464607124342613*^9, 
   3.464607200598524*^9}, {3.464607392573062*^9, 3.464607397307663*^9}, 
   3.464608043695148*^9, {3.468154783415557*^9, 3.468154787101762*^9}, {
   3.482569877390193*^9, 3.482569881179469*^9}, {3.565419072247696*^9, 
   3.5654191707854843`*^9}, {3.565419212481415*^9, 3.565419378139112*^9}, {
   3.573637259009452*^9, 3.573637440349605*^9}, {3.573637674159219*^9, 
   3.5736376875548487`*^9}, {3.57363785123735*^9, 3.5736378537163258`*^9}, 
   3.5736379098284817`*^9, {3.573638062002904*^9, 3.5736381887570267`*^9}},
 CellLabel->
  "In[708]:=",ExpressionUUID->"539e1da8-c9e7-466b-88c6-32c5fe276846"]
}, Closed]],

Cell[CellGroupData[{

Cell["return $Failed as default", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5736371204136477`*^9, 3.573637130427702*^9}, {
  3.573637170177549*^9, 
  3.5736371886570683`*^9}},ExpressionUUID->"eb557164-0256-47e3-a60d-\
5ff5a2882911"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetOperatorBasis", "[", 
    RowBox[{"opbasis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"SetOperatorBasis", "::", "undefined"}], ",", "opbasis"}], 
      "]"}], ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439553851442542*^9, 3.439553864446085*^9}},
 CellLabel->
  "In[709]:=",ExpressionUUID->"4c92b840-17e5-447a-9f9e-85d9a3cdd260"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.57363709859062*^9, 
  3.5736370997634974`*^9}},ExpressionUUID->"665e7722-9314-40a7-be4d-\
c5210ad8534f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetOperatorBasis", "::", "unsuitable"}], "=", 
   "\"\<the operator basis is unsuitable.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[710]:=",ExpressionUUID->"a4e129b6-e41e-444e-886b-475b77ae6fed"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetOperatorBasis", "::", "set"}], "=", 
   "\"\<the operator basis has been set to `1`.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[711]:=",ExpressionUUID->"6f528e1f-29f4-451d-a5d1-f889890fbb4e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetOperatorBasis", "::", "nocheck"}], "=", 
   "\"\<the operator basis has not been checked for completeness or \
orthonormality. Execute CheckOperatorBasis[] to check completeness and \
orthonormality.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434526840673403*^9, 3.434526849207477*^9}},
 CellLabel->
  "In[712]:=",ExpressionUUID->"c8d8dbe9-0980-4a9b-b6f6-4a5f8f62de0e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetOperatorBasis", "::", "undefined"}], "=", 
   "\"\<The operator basis `1` is undefined. It must be defined first using \
DefineOperatorBasis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[713]:=",ExpressionUUID->"7368852e-c982-412d-9e11-68b6158992cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SetOperatorBasis", "::", "alreadyset"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<The operator basis is already set to `1`. No action has been taken.\>\
\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.61847243681205*^9, 3.618472472208544*^9}, {
  3.6184727519885807`*^9, 3.61847275468005*^9}},
 CellLabel->
  "In[714]:=",ExpressionUUID->"58f5e968-4c18-4295-a2fe-44f6fa4aa89c"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CheckOperatorBasis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"1fb2d2cf-2913-4c1a-b1dc-15198d95d1bd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorBasis", "[", 
    RowBox[{"OperatorBasis", "\[Rule]", "opbasis_List"}], "]"}], ":=", 
   RowBox[{"CheckOperatorBasis", "[", "opbasis", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[715]:=",ExpressionUUID->"03c4efc5-d738-4ef5-ad1f-cd88b808760c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorBasis", "[", "args___", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "$Failed"}], ")"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Basis", "/.", 
        RowBox[{"Options", "[", "Basis", "]"}]}], ")"}], "==", "Undefined"}], 
     ")"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.5470252759259653`*^9},
 CellLabel->
  "In[716]:=",ExpressionUUID->"15aa9204-ad8d-4ecc-93d9-a9647f81d4fb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{"CheckOperatorBasis", "[", 
    RowBox[{
     RowBox[{"OperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430895773079342*^9, 3.4308957972363787`*^9}, 
   3.456205551607273*^9},
 CellLabel->
  "In[717]:=",ExpressionUUID->"0f550219-57e1-4d63-9d8f-8818769ed42a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorBasis", "[", 
    RowBox[{
     RowBox[{"opbasis_", "?", "BuiltInOperatorBasisQ"}], ",", "opts___Rule"}],
     "]"}], ":=", "True"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699895282533958*^9, 3.69989529738783*^9}},
 CellLabel->
  "In[718]:=",ExpressionUUID->"ea8183b4-2ad5-4ccb-a98c-e3c85ce4e69b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorBasis", "[", 
    RowBox[{
     RowBox[{"basisops", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "OperatorQ"}], "..."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vecreps", ",", "umat", ",", "topleft"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "basisops", "]"}], "!=", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Times", "@@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"2", "*", 
                   RowBox[{"SpinQuantumNumber", "[", "#", "]"}]}], "+", "1"}],
                  ")"}], "&"}], "/@", 
               RowBox[{"(", 
                RowBox[{"First", "/@", 
                 RowBox[{"SpinSystem", "[", "]"}]}], ")"}]}], ")"}]}], ")"}], 
           "^", "2"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Message", "[", 
          RowBox[{"CheckOperatorBasis", "::", "incomplete"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"umat", "=", 
          RowBox[{"Outer", "[", 
           RowBox[{"LiouvilleBracket", ",", "basisops", ",", "basisops"}], 
           "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"vecreps", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"OperatorVectorRepresentation", "[", 
           RowBox[{"#", ",", 
            RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], "]"}], "&"}], "/@", 
         RowBox[{"N", "@", "basisops"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"umat", "=", 
        RowBox[{"SparseArray", "@", 
         RowBox[{"Chop", "@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Dot", "[", 
              RowBox[{
               RowBox[{"Conjugate", "@", "vecreps"}], ",", "#"}], "]"}], 
             "&"}], "/@", "vecreps"}], ")"}]}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"topleft", "=", 
        RowBox[{"umat", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"OrthonormalQ", "[", "umat", "]"}], ",", 
         "\[IndentingNewLine]", "\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"CheckOperatorBasis", "::", "orthonormal"}], "]"}], ";", 
           "True"}], ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"DiagonalQ", "[", "umat", "]"}], "&&", 
          RowBox[{"(", 
           RowBox[{"And", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"#", "==", "topleft"}], ")"}], "&"}], "/@", 
              RowBox[{"Diagonal", "[", "umat", "]"}]}], ")"}]}], ")"}]}], ",",
          "    ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"CheckOperatorBasis", "::", "orthogonalsamenorm"}], ",", 
             "topleft"}], "]"}], ";", "False"}], ")"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"DiagonalQ", "[", "umat", "]"}], ",", "\[IndentingNewLine]", 
         "\t", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"CheckOperatorBasis", "::", "orthogonaldiffnorm"}], ",", 
             
             RowBox[{"Diagonal", "[", "umat", "]"}]}], "]"}], ";", "False"}], 
          ")"}], ",", "\[IndentingNewLine]", "True", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"CheckOperatorBasis", "::", "notorthogonal"}], "]"}], ";",
            "False"}], ")"}]}], "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430567581108365*^9, 3.430567588815233*^9}, {
   3.430567660266232*^9, 3.430567713048575*^9}, {3.434516920456045*^9, 
   3.434516921318618*^9}, 3.4561623912752857`*^9, {3.4621855262930403`*^9, 
   3.4621855457481813`*^9}, 3.462185611419692*^9, {3.462185642819957*^9, 
   3.462185681331457*^9}, {3.709274826814308*^9, 3.7092749422129245`*^9}, {
   3.7092750070153275`*^9, 3.7092750142929974`*^9}, {3.709275082086563*^9, 
   3.7092750996103144`*^9}, {3.7092756570610075`*^9, 3.709275678780469*^9}, {
   3.7092759517699986`*^9, 3.7092759576367493`*^9}, {3.709276010899392*^9, 
   3.7092760129117436`*^9}, {3.7092760938289022`*^9, 
   3.7092760940476704`*^9}, {3.7092845712166586`*^9, 3.7092845787625623`*^9}},
 
 CellLabel->
  "In[719]:=",ExpressionUUID->"6e70d533-1700-4036-8942-b78bea0c2d3c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorBasis", "[", 
    RowBox[{"opbasis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "check", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"check", "=", 
        RowBox[{"CheckOperatorBasis", "[", 
         RowBox[{
          RowBox[{"BasisOperators", "[", "opbasis", "]"}], ",", "opts"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"check", ",", 
         RowBox[{
          RowBox[{"CheckOperatorBasis", "[", 
           RowBox[{"opbasis", ",", "___Rule"}], "]"}], "=", "True"}]}], "]"}],
        ";", "\[IndentingNewLine]", "check"}], ")"}]}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430567581108365*^9, 3.430567588815233*^9}, {
   3.430567660266232*^9, 3.430567713048575*^9}, {3.434516920456045*^9, 
   3.434516921318618*^9}, 3.4561623912752857`*^9, {3.462185559619289*^9, 
   3.462185573375196*^9}, {3.65960058569324*^9, 3.659600691317739*^9}},
 CellLabel->
  "In[720]:=",ExpressionUUID->"8daf37c8-52ef-4a44-83ff-eb3a8d68e91a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorBasis", "::", "orthonormal"}], "=", 
   "\"\<Operator basis is orthonormal.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[721]:=",ExpressionUUID->"0e5aca65-fb29-43fb-b73e-59c1062b0420"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorBasis", "::", "orthogonalsamenorm"}], "=", 
   "\"\<Operator basis is orthogonal but not orthonormal. All operators have \
the same norm =`1`.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[722]:=",ExpressionUUID->"b8e69773-33e3-4d94-85ba-1c21c6905a2f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorBasis", "::", "orthogonaldiffnorm"}], "=", 
   "\"\<Operator basis is orthogonal but not orthonormal. The operators have \
different norms: `1`\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[723]:=",ExpressionUUID->"424e31c9-6410-49a0-aef2-e07f79390e19"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorBasis", "::", "notorthogonal"}], "=", 
   "\"\<Operator basis is not orthogonal.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[724]:=",ExpressionUUID->"1ad79662-bd01-412e-a276-afe0672d2d17"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CheckOperatorBasis", "::", "incomplete"}], "=", 
   "\"\<Operator basis is incomplete for the specified spin system. Matrix \
representations of superoperator products may be unreliable.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[725]:=",ExpressionUUID->"5a9ba289-99a3-4b78-86d0-37ed2b6b25e0"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisOperators", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"bdf6c2bf-a021-4ada-8107-c034eb0d4431"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisOperators", "[", "___", "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483598512286263`*^9, 
   3.448359860731179*^9}, {3.448362544926189*^9, 3.4483625460754757`*^9}, 
   3.456162392559721*^9, 3.547025292306347*^9},
 CellLabel->
  "In[726]:=",ExpressionUUID->"0913c3d4-9aca-46a5-9e39-b12b93bb38f8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisOperators", "[", "]"}], ":=", 
   RowBox[{"BasisOperators", "[", 
    RowBox[{"OperatorBasis", "[", "]"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448356681080556*^9, 3.448356682027307*^9}, 
   3.456205552979856*^9},
 CellLabel->
  "In[727]:=",ExpressionUUID->"75a7b8dd-7caa-4286-91f7-638eb703578b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisOperators", "[", 
    RowBox[{"Undefined", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "unknown"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "default"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOperatorBasis", "[", 
      RowBox[{
       RowBox[{"DefaultOperatorBasis", "[", "]"}], ",", 
       RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"BasisOperators", "[", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, {3.44835995227402*^9, 
   3.448359994938308*^9}, {3.448362609318633*^9, 3.448362612822578*^9}, 
   3.464606692138373*^9, {3.464607497113134*^9, 3.464607506662027*^9}, {
   3.543498646258339*^9, 3.543498647601879*^9}, 3.547025330017136*^9, 
   3.6405983324757767`*^9},
 CellLabel->
  "In[728]:=",ExpressionUUID->"420a5675-a984-4d87-8227-65efb2deaf1b"]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorBasisDimension", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.452668022166224*^9, 3.452668027907641*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"fff94417-0761-4a39-a493-7153a602eb6c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasisDimension", "[", "___", "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483598512286263`*^9, 
   3.448359860731179*^9}, {3.448362544926189*^9, 3.4483625460754757`*^9}, 
   3.4526680345489407`*^9, 3.4561623950827503`*^9, 3.547025293748301*^9},
 CellLabel->
  "In[729]:=",ExpressionUUID->"316d3397-60d8-4359-88e6-f1e2d8387210"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasisDimension", "[", "]"}], ":=", 
   RowBox[{"OperatorBasisDimension", "[", 
    RowBox[{"OperatorBasis", "[", "]"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448356681080556*^9, 3.448356682027307*^9}, {
   3.452668037508*^9, 3.452668039578556*^9}, 3.4562055537797537`*^9},
 CellLabel->
  "In[730]:=",ExpressionUUID->"0990139f-468b-4a48-8486-f21257e4d81f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasisDimension", "[", 
    RowBox[{"Undefined", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "unknown"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "default"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOperatorBasis", "[", 
      RowBox[{
       RowBox[{"DefaultOperatorBasis", "[", "]"}], ",", 
       RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"OperatorBasisDimension", "[", "]"}]}], "\[IndentingNewLine]", 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, {3.44835995227402*^9, 
   3.448359994938308*^9}, {3.448362609318633*^9, 3.448362612822578*^9}, {
   3.4526680521328907`*^9, 3.45266806749678*^9}, 3.4646067195955963`*^9, {
   3.46460758955436*^9, 3.4646075913597527`*^9}, {3.4646079962819138`*^9, 
   3.464607999983409*^9}, 3.543498654061944*^9, 3.547025331111189*^9, 
   3.5472987840740023`*^9},
 CellLabel->
  "In[731]:=",ExpressionUUID->"b07ab127-0637-40c5-be25-0ee3ffcec584"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasisDimension", "[", 
    RowBox[{"opbasis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"BasisDimension", "[", 
     RowBox[{"ZeemanBasis", "[", 
      RowBox[{"SpinSystem", "[", "opbasis", "]"}], "]"}], "]"}], "^", "2"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452668113925304*^9, 3.4526681605501833`*^9}, {
  3.546530883824789*^9, 3.546530893278322*^9}},
 CellLabel->
  "In[732]:=",ExpressionUUID->"0fd1fea3-9b12-46b3-b586-a04e6f5e49f6"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply SpinSystem to an operator basis", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.452668022166224*^9, 3.452668027907641*^9}, {
  3.531931429503986*^9, 3.531931436068922*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"0d2183ae-2fec-4091-ba71-739b7c066015"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", 
    RowBox[{"opbasis_", "?", "DefinedOperatorBasisQ"}], "]"}], ":=", 
   RowBox[{"First", "[", "opbasis", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531931497853717*^9, 3.5319315071138372`*^9}},
 CellLabel->
  "In[733]:=",ExpressionUUID->"cbfa1a73-9784-4219-9921-85297456dc4e"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Specific Operator Bases", "Section",
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"5343963f-f794-400a-b13a-df44cf0d2082"],

Cell[CellGroupData[{

Cell["ShiftAndPolarizationOperatorBasis (spins-1/2 only)", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"61be7320-21a9-4f14-96a3-e83647d19f57"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"3e4375f9-70ec-4993-a919-2fe64700c43e"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"ShiftAndPolarizationOperatorBasis", ",", "NHoldFirst"}], 
  "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.5320142816604567`*^9, 3.532014340125402*^9},
 CellLabel->
  "In[734]:=",ExpressionUUID->"109db5ac-3fa8-4a92-8342-25e1bb6eee39"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ShiftAndPolarizationOperatorBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Sorted", "\[Rule]", "True"}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4353813727958813`*^9, 3.435381373431304*^9}},
 CellLabel->
  "In[735]:=",ExpressionUUID->"5ff5d20e-fe5e-4731-a0bc-828d2958bd5b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AllowedSortValues", "[", 
    RowBox[{"ShiftAndPolarizationOperatorBasis", "|", 
     RowBox[{"ShiftAndPolarizationOperatorBasis", "[", "___", "]"}]}], "]"}], 
   "=", 
   RowBox[{"{", 
    RowBox[{
    "True", ",", "False", ",", "CoherenceOrder", ",", "\"\<Canonical\>\"", 
     ",", "\"\<OrderBySpin\>\""}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546519014593753*^9, 3.546519089592084*^9}, 
   3.546519306432543*^9, 3.546519537171898*^9, {3.54651966449155*^9, 
   3.546519667999522*^9}, {3.546520341617523*^9, 3.5465203450872927`*^9}, {
   3.546522859877564*^9, 3.546522870984378*^9}},
 CellLabel->
  "In[736]:=",ExpressionUUID->"2f52ea88-d4f4-4bdb-97af-046a255aeb55"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedOperatorBasisQ", "[", 
    RowBox[{"ShiftAndPolarizationOperatorBasis", "[", "___", "]"}], "]"}], 
   "=", "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[737]:=",ExpressionUUID->"e031a77a-9a07-48bb-ad0b-f5d2feceb873"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BuiltinOperatorBasisQ", "[", 
    RowBox[{"ShiftAndPolarizationOperatorBasis", "[", "___", "]"}], "]"}], 
   "=", "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.468154615716969*^9, 3.46815461902769*^9}},
 CellLabel->
  "In[738]:=",ExpressionUUID->"2fdbfede-3da4-4c5a-bfc5-b348a3466369"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftAndPolarizationOperatorBasis", "[", "opts___Rule", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
    RowBox[{
     RowBox[{"SpinSystem", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431062024816597*^9, 3.431062061525462*^9}, {
   3.431062211767852*^9, 3.431062222605216*^9}, {3.431064990910803*^9, 
   3.431065017790723*^9}, {3.4310651382614393`*^9, 3.431065140570182*^9}, {
   3.431068087828887*^9, 3.4310680911274*^9}, 3.456162398317246*^9},
 CellLabel->
  "In[739]:=",ExpressionUUID->"2828d7b1-2d2f-451b-8327-8c09735c9071"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
   RowBox[{"nspin_Integer", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
   RowBox[{
    RowBox[{"Range", "[", 
     RowBox[{"1", ",", "nspin"}], "]"}], ",", "opts"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486387704415118*^9, 3.486387710487081*^9}, {
  3.5319317300394783`*^9, 3.5319317318712873`*^9}},
 CellLabel->
  "In[740]:=",ExpressionUUID->"158af395-ebed-4786-8039-8852a37f9ad3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
    RowBox[{
     RowBox[{"labels", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#", ",", 
         RowBox[{"1", "/", "2"}]}], "}"}], "&"}], "/@", "labels"}], ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.43496998227287*^9, 3.434970003133623*^9}, {
  3.486387693256557*^9, 3.486387699623499*^9}, {3.531931734775353*^9, 
  3.531931737689125*^9}, {3.54644567094051*^9, 3.546445674625248*^9}},
 CellLabel->
  "In[741]:=",ExpressionUUID->"5470ec3b-363a-4324-b793-cc51c524e036"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
    RowBox[{
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"ShiftAndPolarizationOperatorBasis", "::", "notspinshf"}], 
       "]"}], ";", "$Failed"}], ")"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Union", "[", 
       RowBox[{"Last", "/@", "spins"}], "]"}], "!=", 
      RowBox[{"{", 
       RowBox[{"1", "/", "2"}], "}"}]}], ")"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.439553908435666*^9},
 CellLabel->
  "In[742]:=",ExpressionUUID->"97f6deab-ac3d-4c9f-afdc-024d7b3221b8"]
}, Closed]],

Cell[CellGroupData[{

Cell["Sorted", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.468155924375936*^9, 
  3.46815592824655*^9}},ExpressionUUID->"c2eb7079-281f-4b7f-9112-\
eae55864d5a4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
    RowBox[{"spins_", "?", "MatrixQ"}], "]"}], ":=", 
   RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"Sorted", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"Sorted", "/.", 
        RowBox[{"Options", "[", "ShiftAndPolarizationOperatorBasis", "]"}]}], 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546519169830247*^9, 3.546519210221899*^9}},
 CellLabel->
  "In[743]:=",ExpressionUUID->"bd5f6476-4ba1-439d-a51d-403be970f8e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Sorted", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ShiftAndPolarizationOperatorBasis", "]"}]}], 
     ")"}]}], ":=", 
   RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Sorted", "\[Rule]", "CoherenceOrder"}], ",", "opts"}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.4681557259103403`*^9}, {
  3.546519097359929*^9, 3.5465191130880337`*^9}},
 CellLabel->
  "In[744]:=",ExpressionUUID->"e55b9574-01d7-45d1-b027-8b44167a7aad"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "ShiftAndPolarizationOperatorBasis", "]"}]}], 
      ",", "False"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], ",", "opts"}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.4681557259103403`*^9}, {
  3.546519097359929*^9, 3.546519153727545*^9}, {3.546519553361746*^9, 
  3.546519562688888*^9}},
 CellLabel->
  "In[745]:=",ExpressionUUID->"3e16a59b-eb4b-4f5f-ab08-92b17733e06e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
    RowBox[{
     RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"OperatorBasis", "::", "invalidsortopt"}], ",", 
        "ShiftAndPolarizationOperatorBasis", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"#", ",", 
            RowBox[{"FormatType", "\[Rule]", "InputForm"}]}], "]"}], "&"}], 
         "@", 
         RowBox[{
         "AllowedSortValues", "[", "ShiftAndPolarizationOperatorBasis", 
          "]"}]}]}], "]"}], ";", "$Failed"}], "\[IndentingNewLine]", ")"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MemberQ", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
       "AllowedSortValues", "[", "ShiftAndPolarizationOperatorBasis", "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Sorted", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{
        "Options", "[", "ShiftAndPolarizationOperatorBasis", "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.468155814827379*^9}, {
   3.546519226776948*^9, 3.546519251941663*^9}, 3.5465193237856903`*^9, 
   3.5465196744822073`*^9, {3.546519743778636*^9, 3.546519745760778*^9}, 
   3.621614567419724*^9, {3.659536429795807*^9, 3.659536439676023*^9}, {
   3.659547034823722*^9, 3.6595470357164383`*^9}, {3.6595472120364313`*^9, 
   3.659547214193325*^9}, {3.659547253354602*^9, 3.659547271416481*^9}},
 CellLabel->
  "In[746]:=",ExpressionUUID->"b6856706-a41a-4cad-b8c7-20005200e39d"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisOperators", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"73f69a5e-7e4c-45eb-95b0-1c42a81aab1e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
     RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
      RowBox[{
       RowBox[{"spins", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "ShiftAndPolarizationOperatorBasis", "]"}]}], 
      ",", "\"\<Canonical\>\""}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spinnames", ",", "spinstates", ",", "spinstateassignments"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"spinnames", "=", 
        RowBox[{"First", "/@", "spins"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"spinstates", "=", 
        RowBox[{"Tuples", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<\[Alpha]\>\"", ",", "\"\<\[Beta]\>\""}], "}"}], ",", 
          RowBox[{"Length", "[", "spins", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"spinstateassignments", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Outer", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Thread", "[", 
              RowBox[{"spinnames", "\[Rule]", " ", 
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{"#1", ",", "#2"}], "}"}], "]"}]}], "]"}], "&"}], ",",
             "spinstates", ",", "spinstates", ",", "1"}], "]"}], ",", "1"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
         RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
          RowBox[{"spins", ",", "opts"}], "]"}], "\[IndentingNewLine]", "]"}],
         "=", "\[IndentingNewLine]", 
        RowBox[{"OperatorProduct", "@@@", 
         RowBox[{"(", 
          RowBox[{"spinstateassignments", "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"Rule", "[", 
               RowBox[{"lab_", " ", ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<\[Alpha]\>\"", ",", "\"\<\[Alpha]\>\""}], 
                 "}"}]}], "]"}], "\[RuleDelayed]", " ", 
              RowBox[{"opI", "[", 
               RowBox[{"lab", ",", "\"\<\[Alpha]\>\""}], "]"}]}], ",", 
             RowBox[{
              RowBox[{"Rule", "[", 
               RowBox[{"lab_", " ", ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<\[Alpha]\>\"", ",", "\"\<\[Beta]\>\""}], 
                 "}"}]}], "]"}], "\[RuleDelayed]", " ", 
              RowBox[{"opI", "[", 
               RowBox[{"lab", ",", "\"\<+\>\""}], "]"}]}], ",", 
             RowBox[{
              RowBox[{"Rule", "[", 
               RowBox[{"lab_", " ", ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<\[Beta]\>\"", ",", "\"\<\[Alpha]\>\""}], 
                 "}"}]}], "]"}], "\[RuleDelayed]", " ", 
              RowBox[{"opI", "[", 
               RowBox[{"lab", ",", "\"\<-\>\""}], "]"}]}], ",", 
             RowBox[{
              RowBox[{"Rule", "[", 
               RowBox[{"lab_", " ", ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<\[Beta]\>\"", ",", "\"\<\[Beta]\>\""}], "}"}]}],
                "]"}], "\[RuleDelayed]", " ", 
              RowBox[{"opI", "[", 
               RowBox[{"lab", ",", "\"\<\[Beta]\>\""}], "]"}]}]}], "}"}]}], 
          ")"}]}]}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310677050008383`*^9, 3.431067743165999*^9}, {
  3.4681559883185453`*^9, 3.468156011342642*^9}, {3.546519420617813*^9, 
  3.546519458203136*^9}, {3.546519526905551*^9, 3.546519528335887*^9}, {
  3.546534340626142*^9, 3.546534360639817*^9}, {3.718353943096964*^9, 
  3.7183539460237455`*^9}, {3.71835398039178*^9, 3.718354049049502*^9}, {
  3.7183540845427685`*^9, 3.718354102490574*^9}},
 CellLabel->
  "In[747]:=",ExpressionUUID->"0da07b9b-8912-4c16-b3df-b022bc729517"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
     RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
      RowBox[{
       RowBox[{"spins", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "ShiftAndPolarizationOperatorBasis", "]"}]}], 
      ",", "\"\<OrderBySpin\>\""}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"ShiftAndPolarizationOperatorBasis", "/:", 
    RowBox[{"BasisOperators", "[", 
     RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
      RowBox[{"spins", ",", "opts"}], "]"}], "]"}], "=", 
    "\[IndentingNewLine]", 
    RowBox[{"Flatten", "@", 
     RowBox[{"Outer", "[", "\[IndentingNewLine]", 
      RowBox[{"OperatorProduct", ",", "\[IndentingNewLine]", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"opI", "[", 
              RowBox[{"#", ",", "\"\<\[Alpha]\>\""}], "]"}], ",", 
             RowBox[{"opI", "[", 
              RowBox[{"#", ",", "\"\<\[Beta]\>\""}], "]"}], ",", 
             RowBox[{"opI", "[", 
              RowBox[{"#", ",", "\"\<+\>\""}], "]"}], ",", 
             RowBox[{"opI", "[", 
              RowBox[{"#", ",", "\"\<-\>\""}], "]"}]}], "}"}], "&"}], "/@", 
          RowBox[{"Reverse", "[", 
           RowBox[{"First", "/@", "spins"}], "]"}]}], "\[IndentingNewLine]", 
         ")"}]}]}], "]"}]}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310677050008383`*^9, 3.431067743165999*^9}, 
   3.459515450918405*^9, 3.459515828521675*^9, {3.459515969831566*^9, 
   3.459515972277948*^9}, {3.4681569297467823`*^9, 3.468156956468158*^9}, 
   3.486465197954781*^9, {3.5464472196951942`*^9, 3.5464472395094147`*^9}, {
   3.546520257918899*^9, 3.546520289508052*^9}, {3.5465343756886797`*^9, 
   3.546534392348611*^9}, {3.5465359392905893`*^9, 3.546535943780671*^9}, 
   3.573635393763555*^9, {3.717933939622114*^9, 3.7179339519274883`*^9}},
 CellLabel->
  "In[748]:=",ExpressionUUID->"abb073d6-b6c1-4e9d-b6a7-6100d13d6734"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
    RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{"MatchQ", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Sorted", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ShiftAndPolarizationOperatorBasis", "]"}]}], 
     ",", "\[IndentingNewLine]", "CoherenceOrder"}], "\[IndentingNewLine]", 
    "]"}]}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"sortfunc", ",", "g$", ",", "opts$"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"sortfunc", "[", "Q_", "]"}], ":=", 
      RowBox[{
       RowBox[{
        RowBox[{"Q", "/.", 
         RowBox[{"{", 
          RowBox[{"OperatorProduct", "\[Rule]", " ", "g$"}], "}"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"g$", "[", 
           RowBox[{"A___", ",", "opts$___Rule"}], "]"}], "\[RuleDelayed]", 
          " ", 
          RowBox[{"g$", "[", "A", "]"}]}], "}"}]}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"opI", "[", 
           RowBox[{"j_", ",", "\"\<\[Alpha]\>\""}], "]"}], "\[RuleDelayed]", 
          "0"}], ",", 
         RowBox[{
          RowBox[{"opI", "[", 
           RowBox[{"j_", ",", "\"\<\[Beta]\>\""}], "]"}], "\[RuleDelayed]", 
          " ", "0"}], ",", 
         RowBox[{
          RowBox[{"opI", "[", 
           RowBox[{"j_", ",", "\"\<+\>\""}], "]"}], "\[RuleDelayed]", " ", 
          "1"}], ",", 
         RowBox[{
          RowBox[{"opI", "[", 
           RowBox[{"j_", ",", "\"\<-\>\""}], "]"}], "\[RuleDelayed]", " ", 
          RowBox[{"-", "1"}]}], ",", 
         RowBox[{"g$", "\[Rule]", " ", "Plus"}]}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SortBy", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"BasisOperators", "[", 
        RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
         RowBox[{"spins", ",", 
          RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], "]"}], 
       ",", "\[IndentingNewLine]", "sortfunc"}], "\[IndentingNewLine]", 
      "]"}]}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431067718948139*^9, 3.431067750229857*^9}, 
   3.43106901791814*^9, 3.43109289818414*^9, 3.468155863615588*^9, {
   3.468156020060316*^9, 3.4681560386138906`*^9}, {3.468156069035633*^9, 
   3.468156077502528*^9}, {3.546420853404237*^9, 3.546420855846177*^9}, {
   3.5465202974055*^9, 3.546520299869115*^9}, {3.718358597390676*^9, 
   3.7183586221691294`*^9}, {3.7183586603037796`*^9, 3.7183586635431576`*^9}},
 
 CellLabel->
  "In[749]:=",ExpressionUUID->"26cef738-aa20-4c93-a822-0ca089d15368"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
ResolveIntoKetsAndBras: These rules are needed for calculating the \
SuperoperatorMatrixRepresentation using Method\[Rule]Automatic\
\>", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.429698175387712*^9, {3.431058123679789*^9, 
   3.431058128974515*^9}},ExpressionUUID->"b7c1e93e-8cd0-4268-b4c6-\
3f008f5b4d26"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ResolveIntoKetsAndBras", "[", 
    RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
     RowBox[{"spins_", ",", 
      RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
    "\[IndentingNewLine]", "]"}], "^:=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"BasisKets", "[", 
      RowBox[{"ZeemanBasis", "[", "spins", "]"}], "]"}], ",", 
     RowBox[{"BasisBras", "[", 
      RowBox[{"ZeemanBasis", "[", "spins", "]"}], "]"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431067731492938*^9, 3.431067738599614*^9}, {
  3.5465198320176363`*^9, 3.5465198340117483`*^9}},
 CellLabel->
  "In[750]:=",ExpressionUUID->"cbac481e-98fd-45ef-a319-f96b8b198dcf"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 
  3.468059115613844*^9}},ExpressionUUID->"6b6c3e53-2a2a-44e5-8385-\
7688c807a96f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", "\[IndentingNewLine]", 
    RowBox[{"ShiftAndPolarizationOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "^:=", "spins"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468059125578073*^9, 3.4680591405217257`*^9}},
 CellLabel->
  "In[751]:=",ExpressionUUID->"a3dfa409-3d12-4fdc-b298-e62baf34669e"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.468155910415154*^9, 
  3.468155911621647*^9}},ExpressionUUID->"0d6feab9-bb95-4d40-90f8-\
695c2e686d82"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftAndPolarizationOperatorBasis", "::", "notspinshf"}], "=", 
   "\"\<this operator basis is only available for spins-1/2\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[752]:=",ExpressionUUID->"2ecfcf09-cac7-4897-969d-d16bbf49764e"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CartesianProductOperatorBasis (general spins)", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4595154000145063`*^9, 3.459515404348384*^9}, 
   3.6391534937109003`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"10a813be-1fb8-4df1-b5b5-77a8fd558932"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"6fac2a07-106c-4ed8-9172-90ed0796f2f1"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"CartesianProductOperatorBasis", ",", "NHoldFirst"}], 
  "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5320142816604567`*^9, {3.532014340125402*^9, 3.532014353605698*^9}},
 CellLabel->
  "In[753]:=",ExpressionUUID->"3ac22b24-7d98-49f8-bef4-207d18404e31"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "CartesianProductOperatorBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Sorted", "\[Rule]", "True"}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4353813727958813`*^9, 3.435381373431304*^9}, {
  3.459515409730711*^9, 3.4595154128786592`*^9}, {3.4595163684576*^9, 
  3.459516368990307*^9}},
 CellLabel->
  "In[754]:=",ExpressionUUID->"092b4257-0e4d-4242-b15d-c17909af318f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AllowedSortValues", "[", 
    RowBox[{"CartesianProductOperatorBasis", "|", 
     RowBox[{"CartesianProductOperatorBasis", "[", "___", "]"}]}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "True", ",", "False", ",", "SpinProductRank", ",", "\"\<OrderBySpin\>\"", 
     ",", "\"\<Canonical\>\""}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546519875507392*^9, 3.5465198990568323`*^9}, {
   3.546522894515172*^9, 3.546522903298211*^9}, 3.699895351837175*^9},
 CellLabel->
  "In[755]:=",ExpressionUUID->"4bc930a9-8e07-4484-931a-5cea44d6c648"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BuiltinOperatorBasisQ", "[", 
    RowBox[{"CartesianProductOperatorBasis", "[", "___", "]"}], "]"}], "=", 
   "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.468154615716969*^9, 3.468154632590201*^9}},
 CellLabel->
  "In[756]:=",ExpressionUUID->"e6cff6d8-40e5-43cb-9d98-b38a30550bb4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedOperatorBasisQ", "[", 
    RowBox[{"CartesianProductOperatorBasis", "[", "___", "]"}], "]"}], "=", 
   "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.459515416754053*^9},
 CellLabel->
  "In[757]:=",ExpressionUUID->"078f14df-2fef-4ba8-aeab-e110ae6e0587"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianProductOperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"CartesianProductOperatorBasis", "[", 
    RowBox[{
     RowBox[{"SpinSystem", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431062024816597*^9, 3.431062061525462*^9}, {
   3.431062211767852*^9, 3.431062222605216*^9}, {3.431064990910803*^9, 
   3.431065017790723*^9}, {3.4310651382614393`*^9, 3.431065140570182*^9}, {
   3.431068087828887*^9, 3.4310680911274*^9}, 3.456162398317246*^9, {
   3.459515418704845*^9, 3.459515419937022*^9}},
 CellLabel->
  "In[758]:=",ExpressionUUID->"d74480b5-aac1-460c-b706-5c486df5fa64"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CartesianProductOperatorBasis", "[", 
   RowBox[{"nspin_Integer", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"CartesianProductOperatorBasis", "[", 
   RowBox[{
    RowBox[{"Range", "[", 
     RowBox[{"1", ",", "nspin"}], "]"}], ",", "opts"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486387704415118*^9, 3.486387710487081*^9}, {
  3.5319317300394783`*^9, 3.5319317318712873`*^9}, {3.531931772638824*^9, 
  3.5319317742314796`*^9}},
 CellLabel->
  "In[759]:=",ExpressionUUID->"dca4b675-d928-40f6-bf78-1f9affb9d92b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianProductOperatorBasis", "[", 
    RowBox[{
     RowBox[{"labels", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"CartesianProductOperatorBasis", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#", ",", 
         RowBox[{"1", "/", "2"}]}], "}"}], "&"}], "/@", "labels"}], ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.43496998227287*^9, 3.434970003133623*^9}, {
  3.486387693256557*^9, 3.486387699623499*^9}, {3.531931734775353*^9, 
  3.531931737689125*^9}, {3.5319317757791033`*^9, 3.5319317770331287`*^9}, {
  3.546445629302936*^9, 3.546445634282692*^9}},
 CellLabel->
  "In[760]:=",ExpressionUUID->"6eff5cae-1a21-4944-a7dc-ee42298c91ea"]
}, Closed]],

Cell[CellGroupData[{

Cell["Sorted", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.468155924375936*^9, 
  3.46815592824655*^9}},ExpressionUUID->"3eafaeeb-a5cd-4baf-8b88-\
3bd6480f9b0f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianProductOperatorBasis", "[", 
    RowBox[{"spins_", "?", "MatrixQ"}], "]"}], ":=", 
   RowBox[{"CartesianProductOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"Sorted", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"Sorted", "/.", 
        RowBox[{"Options", "[", "CartesianProductOperatorBasis", "]"}]}], 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546424531367845*^9, 3.546424571045986*^9}, {
  3.546447058492753*^9, 3.546447061876156*^9}},
 CellLabel->
  "In[761]:=",ExpressionUUID->"85d705b0-0505-4919-8be5-1da022e70c9b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianProductOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Sorted", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "CartesianProductOperatorBasis", "]"}]}], 
     ")"}]}], ":=", 
   RowBox[{"CartesianProductOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Sorted", "\[Rule]", "SpinProductRank"}], ",", "opts"}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.4681557259103403`*^9}, {
  3.468156879420442*^9, 3.468156890428987*^9}, {3.546447076586838*^9, 
  3.5464470792467422`*^9}},
 CellLabel->
  "In[762]:=",ExpressionUUID->"05d947af-dc8d-4e82-a31d-d7ad5525589b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CartesianProductOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "CartesianProductOperatorBasis", "]"}]}], ",", 
      
      RowBox[{"False", "|", "\"\<Canonical\>\""}]}], "]"}]}], ":=", 
   RowBox[{"CartesianProductOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Sorted", "\[Rule]", "\"\<OrderBySpin\>\""}], ",", "opts"}], 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546421882253977*^9, 3.5464219066832523`*^9}, {
  3.546422139351585*^9, 3.5464221427331533`*^9}, {3.5464471256155043`*^9, 
  3.5464471312004337`*^9}},
 CellLabel->
  "In[763]:=",ExpressionUUID->"750a2fbc-5df8-44f9-a668-ea5e597c6927"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CartesianProductOperatorBasis", "[", 
    RowBox[{
     RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"OperatorBasis", "::", "invalidsortopt"}], ",", 
        "CartesianProductOperatorBasis", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"#", ",", 
            RowBox[{"FormatType", "\[Rule]", "InputForm"}]}], "]"}], "&"}], 
         "@", 
         RowBox[{
         "AllowedSortValues", "[", "CartesianProductOperatorBasis", "]"}]}]}],
        "]"}], ";", "$Failed"}], "\[IndentingNewLine]", ")"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MemberQ", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
       "AllowedSortValues", "[", "CartesianProductOperatorBasis", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Sorted", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "CartesianProductOperatorBasis", "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.468155814827379*^9}, {
   3.4681568986936903`*^9, 3.468156907086047*^9}, 3.546447151784254*^9, {
   3.5465200220694857`*^9, 3.546520035594507*^9}, {3.65953645430716*^9, 
   3.6595364695078773`*^9}, 3.659547060418077*^9, 3.659547326695999*^9},
 CellLabel->
  "In[764]:=",ExpressionUUID->"127ec8d1-e3b0-4956-9e5b-a6574007e22f"]
}, Closed]],

Cell[CellGroupData[{

Cell["SingleSpinCartesianBasisOperators", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.462190634011159*^9, 3.462190638948386*^9}, 
   3.5434993283811913`*^9, {3.639153589098634*^9, 
   3.6391535915746*^9}},ExpressionUUID->"b6bfbcff-b231-45d2-b9da-\
35de46f59e1e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleSpinCartesianBasisOperators", "[", 
    RowBox[{"{", 
     RowBox[{"j_", ",", 
      RowBox[{"1", "/", "2"}]}], "}"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Sqrt", "[", "2", "]"}], "*", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "/", "2"}], ")"}], 
       RowBox[{"UnityOperator", "[", "]"}]}], ",", 
      RowBox[{"opI", "[", 
       RowBox[{"j", ",", "\"\<x\>\""}], "]"}], ",", 
      RowBox[{"opI", "[", 
       RowBox[{"j", ",", "\"\<y\>\""}], "]"}], ",", 
      RowBox[{"opI", "[", 
       RowBox[{"j", ",", "\"\<z\>\""}], "]"}]}], "}"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6391537999682713`*^9, 3.639153856722848*^9}, {
  3.639154449036543*^9, 3.639154452235663*^9}},
 CellLabel->
  "In[765]:=",ExpressionUUID->"0bf5a6fe-c8b6-4977-9811-d093a326fca4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SingleSpinCartesianBasisOperators", "[", 
     RowBox[{"{", 
      RowBox[{"j_", ",", "Ij_"}], "}"}], "]"}], "/;", 
    RowBox[{"Ij", ">", 
     RowBox[{"1", "/", "2"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SingleSpinCartesianBasisOperators", "[", 
     RowBox[{"{", 
      RowBox[{"j", ",", "Ij"}], "}"}], "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "shzbops", ",", "ops", ",", "ZQnumber", ",", "dim", ",", "pmpos", ",", 
        "pppos"}], "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Ij", ">", 
           RowBox[{"3", "/", "2"}]}], ",", 
          RowBox[{
          "PrintTemporary", "[", 
           "\"\<Calculating a set of Cartesian basis operators can be slow \
for spins > 3/2. Working...\>\"", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"shzbops", "=", 
         RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
          RowBox[{"{", 
           RowBox[{"j", ",", "Ij"}], "}"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ZQnumber", "=", 
         RowBox[{
          RowBox[{"2", "*", "Ij"}], "+", "1"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"dim", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "Ij"}], "+", "1"}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "Ij"}], "+", "1"}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pmpos", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"dim", "-", "ZQnumber"}], ")"}], "/", "2"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pppos", "=", 
         RowBox[{"dim", "-", "pmpos", "+", "1"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Flatten", "@", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"shzbops", "\[LeftDoubleBracket]", 
             RowBox[{
              RowBox[{"pmpos", "+", "1"}], ";;", 
              RowBox[{"pppos", "-", "1"}]}], "\[RightDoubleBracket]"}], ",", 
            RowBox[{"Transpose", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"1", "/", 
                  RowBox[{"Sqrt", "[", "2", "]"}]}], "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"shzbops", "\[LeftDoubleBracket]", 
                    RowBox[{"pppos", ";;"}], "\[RightDoubleBracket]"}], "+", 
                   RowBox[{"Reverse", "[", 
                    RowBox[{"shzbops", "\[LeftDoubleBracket]", 
                    RowBox[{"1", ";;", "pmpos"}], "\[RightDoubleBracket]"}], 
                    "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"1", "/", 
                  RowBox[{"(", 
                   RowBox[{"I", " ", 
                    RowBox[{"Sqrt", "[", "2", "]"}]}], ")"}]}], "*", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"shzbops", "\[LeftDoubleBracket]", 
                    RowBox[{"pppos", ";;"}], "\[RightDoubleBracket]"}], "-", 
                   RowBox[{"Reverse", "[", 
                    RowBox[{"shzbops", "\[LeftDoubleBracket]", 
                    RowBox[{"1", ";;", "pmpos"}], "\[RightDoubleBracket]"}], 
                    "]"}]}], ")"}]}]}], "}"}], "\[IndentingNewLine]", "/.", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"opI", "[", 
                  RowBox[{"j$_", ",", "\"\<+\>\""}], "]"}], "\[RuleDelayed]", 
                 
                 RowBox[{
                  RowBox[{"opI", "[", 
                   RowBox[{"j$", ",", "\"\<x\>\""}], "]"}], "+", 
                  RowBox[{"I", " ", 
                   RowBox[{"opI", "[", 
                    RowBox[{"j$", ",", "\"\<y\>\""}], "]"}]}]}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"opI", "[", 
                  RowBox[{"j$_", ",", "\"\<-\>\""}], "]"}], "\[RuleDelayed]", 
                 
                 RowBox[{
                  RowBox[{"opI", "[", 
                   RowBox[{"j$", ",", "\"\<x\>\""}], "]"}], "-", 
                  RowBox[{"I", " ", 
                   RowBox[{"opI", "[", 
                    RowBox[{"j$", ",", "\"\<y\>\""}], "]"}]}]}]}]}], 
               "\[IndentingNewLine]", "}"}]}], "]"}]}], "}"}]}], "//", 
         "Simplify"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639120042471846*^9, 3.639120079251799*^9}, {
   3.6391207385719223`*^9, 3.6391208410776043`*^9}, {3.639120930859823*^9, 
   3.639120941069544*^9}, {3.639121343079026*^9, 3.639121347036875*^9}, {
   3.639121421259264*^9, 3.639121427448419*^9}, {3.6391536038925867`*^9, 
   3.639153704098763*^9}, {3.639153745995174*^9, 3.639153779309784*^9}, {
   3.639153865054839*^9, 3.639153895584332*^9}, {3.6391540912196302`*^9, 
   3.639154143362854*^9}, {3.722261369838829*^9, 3.7222614502924185`*^9}, 
   3.72226167192823*^9, {3.722261747736874*^9, 3.722261844477049*^9}, {
   3.722261904765384*^9, 3.7222620828537807`*^9}, 3.7222622246923823`*^9, {
   3.722262420575679*^9, 3.7222624833295774`*^9}, {3.7222625277335625`*^9, 
   3.722262528192343*^9}, {3.722262698737358*^9, 3.722262787310136*^9}, {
   3.7222628292563567`*^9, 3.7222628465197477`*^9}, {3.7222628773874583`*^9, 
   3.722262893977709*^9}, {3.7222630068526306`*^9, 3.722263008647108*^9}, {
   3.7222630831271157`*^9, 3.722263120196663*^9}, {3.7222635119642773`*^9, 
   3.7222635258049374`*^9}, 3.7222636271228623`*^9, {3.7222638417500753`*^9, 
   3.7222638458205085`*^9}, {3.722263926910675*^9, 3.722263941942173*^9}},
 CellLabel->
  "In[766]:=",ExpressionUUID->"efad9d1c-4fa1-4c0c-a844-434dbdc48dc0"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisOperators", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"31e44bf3-ab18-42af-a797-1ce11a217b04"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
     RowBox[{"CartesianProductOperatorBasis", "[", 
      RowBox[{
       RowBox[{"spins", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "CartesianProductOperatorBasis", "]"}]}], ",", 
      "\"\<OrderBySpin\>\""}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"CartesianProductOperatorBasis", "/:", 
    RowBox[{"BasisOperators", "[", 
     RowBox[{"CartesianProductOperatorBasis", "[", 
      RowBox[{"spins", ",", "opts"}], "]"}], "]"}], "=", 
    "\[IndentingNewLine]", 
    RowBox[{"Flatten", "@", 
     RowBox[{"Outer", "[", "\[IndentingNewLine]", 
      RowBox[{"OperatorProduct", ",", "\[IndentingNewLine]", 
       RowBox[{"Sequence", "@@", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{"SingleSpinCartesianBasisOperators", "/@", 
          RowBox[{"Reverse", "[", "spins", "]"}]}], "\[IndentingNewLine]", 
         ")"}]}]}], "]"}]}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310677050008383`*^9, 3.431067743165999*^9}, 
   3.459515450918405*^9, 3.459515828521675*^9, {3.459515969831566*^9, 
   3.459515972277948*^9}, {3.4681569297467823`*^9, 3.468156956468158*^9}, 
   3.486465197954781*^9, {3.5464472196951942`*^9, 3.5464472395094147`*^9}, {
   3.546532892205682*^9, 3.546532897235244*^9}, {3.639153950234572*^9, 
   3.6391539642597446`*^9}, 3.639154416967329*^9, {3.717933818344081*^9, 
   3.717933869351845*^9}},
 CellLabel->
  "In[767]:=",ExpressionUUID->"031746b6-5205-42d0-8882-a5897aa7bf92"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
     RowBox[{"CartesianProductOperatorBasis", "[", 
      RowBox[{
       RowBox[{"spins", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "CartesianProductOperatorBasis", "]"}]}], ",", 
      "\[IndentingNewLine]", "SpinProductRank"}], "\[IndentingNewLine]", 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
     RowBox[{"CartesianProductOperatorBasis", "[", 
      RowBox[{"spins", ",", "opts"}], "]"}], "\[IndentingNewLine]", "]"}], 
    "=", "\[IndentingNewLine]", 
    RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
     RowBox[{"Sort", "/@", 
      RowBox[{"GatherBy", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisOperators", "[", 
         RowBox[{"CartesianProductOperatorBasis", "[", 
          RowBox[{"spins", ",", 
           RowBox[{"Sorted", "\[Rule]", "\"\<OrderBySpin\>\""}]}], "]"}], 
         "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        "SpinProductRank"}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431067718948139*^9, 3.431067750229857*^9}, 
   3.43106901791814*^9, 3.43109289818414*^9, {3.459515989993*^9, 
   3.4595160503760967`*^9}, 3.4595161048620234`*^9, {3.459516298271309*^9, 
   3.459516330280448*^9}, {3.4681569716922207`*^9, 3.468156982173252*^9}, {
   3.4681658213893137`*^9, 3.468165823195401*^9}, {3.5464472506460953`*^9, 
   3.546447261202886*^9}, {3.546534421779943*^9, 3.5465344283308687`*^9}},
 CellLabel->
  "In[768]:=",ExpressionUUID->"4ce47256-9d4e-4b5a-aa98-02401d0e3bd4"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 
  3.468059115613844*^9}},ExpressionUUID->"8faae5e9-7068-44c6-b059-\
70e8b64fb99d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", 
    RowBox[{"CartesianProductOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "]"}], "^:=", "spins"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468059125578073*^9, 3.468059163725421*^9}, {
  3.639153994961475*^9, 3.639153996969818*^9}},
 CellLabel->
  "In[769]:=",ExpressionUUID->"7c22c335-e345-4575-ada0-7fb5d04e0c0a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ShiftAndZOperatorBasis (general spins)", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433524955520575*^9, 3.4335249914663343`*^9}, {
  3.462189963344623*^9, 3.462189964212049*^9}, {3.462268433602673*^9, 
  3.4622684360731897`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"f62474f8-a3f0-44d6-ab28-45e0b477817c"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"0fce91a3-a120-4bda-a0d0-aa1903695ec2"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"ShiftAndZOperatorBasis", ",", "NHoldFirst"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5320142816604567`*^9, {3.532014340125402*^9, 3.532014367429585*^9}},
 CellLabel->
  "In[770]:=",ExpressionUUID->"1403da00-97f6-4c9d-b2b0-322514eeb603"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ShiftAndZOperatorBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Sorted", "\[Rule]", "CoherenceOrder"}], "}"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.546421837029048*^9, 3.546421848074087*^9}},
 CellLabel->
  "In[771]:=",ExpressionUUID->"d8861e2b-59cb-409e-b175-de7274a89106"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AllowedSortValues", "[", 
    RowBox[{"ShiftAndZOperatorBasis", "|", 
     RowBox[{"ShiftAndZOperatorBasis", "[", "___", "]"}]}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "True", ",", "False", ",", "CoherenceOrder", ",", "\"\<Canonical\>\"", 
     ",", "\"\<OrderBySpin\>\""}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546519014593753*^9, 3.546519089592084*^9}, 
   3.546519306432543*^9, 3.546519537171898*^9, {3.54651966449155*^9, 
   3.546519667999522*^9}, {3.546520401605959*^9, 3.546520408388074*^9}, {
   3.54652291003288*^9, 3.546522917367166*^9}},
 CellLabel->
  "In[772]:=",ExpressionUUID->"faf2735a-1627-4f5f-a5b6-9879f2997a08"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedOperatorBasisQ", "[", 
    RowBox[{"ShiftAndZOperatorBasis", "[", "___", "]"}], "]"}], "=", "True"}],
   ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[773]:=",ExpressionUUID->"9ac366e5-ba55-43e2-8a81-71e5968a830b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BuiltinOperatorBasisQ", "[", 
    RowBox[{"ShiftAndZOperatorBasis", "[", "___", "]"}], "]"}], "=", "True"}],
   ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.468154615716969*^9, 3.46815464261478*^9}},
 CellLabel->
  "In[774]:=",ExpressionUUID->"88f9f5c3-fc12-428b-ae5a-1b62b9b74f38"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftAndZOperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"ShiftAndZOperatorBasis", "[", 
    RowBox[{
     RowBox[{"SpinSystem", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431062024816597*^9, 3.431062061525462*^9}, {
   3.431062211767852*^9, 3.431062222605216*^9}, {3.431064990910803*^9, 
   3.431065017790723*^9}, {3.4310651382614393`*^9, 3.431065140570182*^9}, {
   3.431065173917858*^9, 3.431065175397799*^9}, {3.431068303549468*^9, 
   3.431068304383318*^9}, 3.456162399121376*^9},
 CellLabel->
  "In[775]:=",ExpressionUUID->"2b2afcaf-dd5d-4389-be9b-0e1e4d707e4e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShiftAndZOperatorBasis", "[", 
   RowBox[{"nspin_Integer", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"ShiftAndZOperatorBasis", "[", 
   RowBox[{
    RowBox[{"Range", "[", 
     RowBox[{"1", ",", "nspin"}], "]"}], ",", "opts"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486387704415118*^9, 3.486387710487081*^9}, {
  3.5319317300394783`*^9, 3.5319317318712873`*^9}, {3.531931772638824*^9, 
  3.5319317742314796`*^9}, {3.53193180727065*^9, 3.531931808670971*^9}},
 CellLabel->
  "In[776]:=",ExpressionUUID->"83b75b0f-61a8-45de-8833-269086369400"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShiftAndZOperatorBasis", "[", 
   RowBox[{"labels_List", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ShiftAndZOperatorBasis", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#", ",", 
         RowBox[{"1", "/", "2"}]}], "}"}], "&"}], "/@", "labels"}], ",", 
     "opts"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"!", 
      RowBox[{"MatrixQ", "[", "labels", "]"}]}], ")"}], "&&", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"labels", ",", 
       RowBox[{"{", "}"}]}], "]"}]}]}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.43496998227287*^9, 3.434970003133623*^9}, {
  3.486387693256557*^9, 3.486387699623499*^9}, {3.531931734775353*^9, 
  3.531931737689125*^9}, {3.5319317757791033`*^9, 3.5319317770331287`*^9}, {
  3.53193181071211*^9, 3.531931811880478*^9}},
 CellLabel->
  "In[777]:=",ExpressionUUID->"e5fef8e9-74e8-4e23-b0b5-e05916d2b6d9"]
}, Closed]],

Cell[CellGroupData[{

Cell["Sorted", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.468155924375936*^9, 
  3.46815592824655*^9}},ExpressionUUID->"ae086592-7357-4b2e-8a54-\
586f1818cefa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftAndZOperatorBasis", "[", 
    RowBox[{"spins_", "?", "MatrixQ"}], "]"}], ":=", 
   RowBox[{"ShiftAndZOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"Sorted", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"Sorted", "/.", 
        RowBox[{"Options", "[", "ShiftAndZOperatorBasis", "]"}]}], ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546424531367845*^9, 3.546424571045986*^9}},
 CellLabel->
  "In[778]:=",ExpressionUUID->"fae67ff9-8819-4afb-be83-43ade290af4d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ShiftAndZOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Sorted", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ShiftAndZOperatorBasis", "]"}]}], ")"}]}], ":=", 
   RowBox[{"ShiftAndZOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Sorted", "\[Rule]", "CoherenceOrder"}], ",", "opts"}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.4681557259103403`*^9}, {
  3.4681659131358213`*^9, 3.468165915800445*^9}, {3.546421876817932*^9, 
  3.546421879357589*^9}},
 CellLabel->
  "In[779]:=",ExpressionUUID->"77a5522f-6343-4d2a-bcd7-c9e02935d749"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ShiftAndZOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "ShiftAndZOperatorBasis", "]"}]}], ",", 
      RowBox[{"False", "|", "\"\<Canonical\>\""}]}], "]"}]}], ":=", 
   RowBox[{"ShiftAndZOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Sorted", "\[Rule]", "\"\<OrderBySpin\>\""}], ",", "opts"}], 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546421882253977*^9, 3.5464219066832523`*^9}, {
  3.546422139351585*^9, 3.5464221427331533`*^9}},
 CellLabel->
  "In[780]:=",ExpressionUUID->"5b88e6c0-745a-4194-9a76-fb2f4d8fb8f0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftAndZOperatorBasis", "[", 
    RowBox[{
     RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"OperatorBasis", "::", "invalidsortopt"}], ",", 
        "ShiftAndZOperatorBasis", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"#", ",", 
            RowBox[{"FormatType", "\[Rule]", "InputForm"}]}], "]"}], "&"}], 
         "@", 
         RowBox[{
         "AllowedSortValues", "[", "ShiftAndZOperatorBasis", "]"}]}]}], "]"}],
       ";", "$Failed"}], ")"}], "/;", "\[IndentingNewLine]", 
    RowBox[{"!", 
     RowBox[{"MemberQ", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"AllowedSortValues", "[", "ShiftAndZOperatorBasis", "]"}], ",",
        "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Sorted", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "ShiftAndZOperatorBasis", "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.468155814827379*^9}, {
   3.468165919128653*^9, 3.468165924585189*^9}, {3.468166730528789*^9, 
   3.468166732014318*^9}, 3.546421866386146*^9, 3.546421920821088*^9, {
   3.54652045205346*^9, 3.546520457436471*^9}, {3.546520586308153*^9, 
   3.546520604077557*^9}, 3.621614571426177*^9, {3.659536495075968*^9, 
   3.6595365010036497`*^9}, 3.6595470672476597`*^9, 3.6595473277614326`*^9},
 CellLabel->
  "In[781]:=",ExpressionUUID->"6807e641-55bc-429d-9f6d-80bee9f7f1e7"]
}, Closed]],

Cell[CellGroupData[{

Cell["SingleSpinShiftAndZBasisOperators", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.462190634011159*^9, 3.462190638948386*^9}, 
   3.5434993283811913`*^9},ExpressionUUID->"12fd0037-47ed-4577-b7ff-\
d37d55499de2"],

Cell["\<\
sets up orthogonal operators for an individual spin of arbitrary quantum \
number. Needed in the calculation of the complete multiple-spin basis. This \
routine gets quite slow for spins>3/2. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5434992520349207`*^9, 3.543499316568716*^9}, {
  3.639122594788381*^9, 
  3.6391225956756773`*^9}},ExpressionUUID->"3660d990-a7e7-4c52-97a7-\
c6ea86b8bce2"],

Cell["\<\
faster code was implemented in v2.12.3b1. However the basis construction is \
still very slow for spin-7/2 or higher.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.639122601886063*^9, 3.63912262094414*^9}, {
  3.63912268124967*^9, 3.639122681708716*^9}, {3.639208392125268*^9, 
  3.639208416717216*^9}},ExpressionUUID->"22b9e5d5-4927-4640-81ba-\
de545c205985"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
    RowBox[{"{", 
     RowBox[{"j_", ",", "Ij_"}], "}"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "d$", ",", "Iplus", ",", "Iz", ",", "Id", ",", "\[Phi]", ",", "SZops", 
       ",", "SZzreps", ",", "SZpreps", ",", "SZreps", ",", "\[Phi]vec", ",", 
       "len", ",", "newset"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"d$", "[", 
        RowBox[{
         RowBox[{"k_.", "*", "p_Plus"}], ",", "B_"}], "]"}], ":=", 
       RowBox[{
        RowBox[{
         RowBox[{"k", "*", 
          RowBox[{"d$", "[", 
           RowBox[{"#", ",", "B"}], "]"}]}], "&"}], "/@", "p"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"d$", "[", 
        RowBox[{"A_", ",", 
         RowBox[{"k_.", "*", "p_Plus"}]}], "]"}], ":=", 
       RowBox[{
        RowBox[{
         RowBox[{"k", "*", 
          RowBox[{"d$", "[", 
           RowBox[{"A", ",", "#"}], "]"}]}], "&"}], "/@", "p"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"d$", "[", 
        RowBox[{
         RowBox[{"k1_.", 
          RowBox[{"\[Phi]", "[", "m_", "]"}]}], ",", 
         RowBox[{"k2_.", 
          RowBox[{"\[Phi]", "[", "n_", "]"}]}]}], "]"}], ":=", 
       RowBox[{"k1", "*", "k2", "*", 
        RowBox[{
         RowBox[{"Conjugate", "[", 
          RowBox[{
          "SZreps", "\[LeftDoubleBracket]", "m", "\[RightDoubleBracket]"}], 
          "]"}], ".", 
         RowBox[{
         "SZreps", "\[LeftDoubleBracket]", "n", 
          "\[RightDoubleBracket]"}]}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Id", ",", "Iplus", ",", "Iz"}], "}"}], "=", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"IdentityMatrix", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"2", "Ij"}], "+", "1"}], ",", "SparseArray"}], "]"}], ",",
          "\[IndentingNewLine]", 
         RowBox[{"SparseArray", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Band", "[", 
               RowBox[{"{", 
                RowBox[{"1", ",", "2"}], "}"}], "]"}], "\[Rule]", 
              RowBox[{"Sqrt", "[", 
               RowBox[{
                RowBox[{"Ij", 
                 RowBox[{"(", 
                  RowBox[{"Ij", "+", "1"}], ")"}]}], "-", 
                RowBox[{"#", 
                 RowBox[{"(", 
                  RowBox[{"#", "-", "1"}], ")"}]}]}], "]"}]}], "&"}], "@", 
            RowBox[{"Range", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "Ij"}], "+", "1"}], ",", "Ij", ",", "1"}], 
             "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"2", "Ij"}], "+", "1"}], ",", 
             RowBox[{
              RowBox[{"2", "Ij"}], "+", "1"}]}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SparseArray", "[", 
          RowBox[{
           RowBox[{"Band", "[", 
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], "]"}], "\[Rule]", 
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"+", "Ij"}], ",", 
             RowBox[{"-", "Ij"}], ",", 
             RowBox[{"-", "1"}]}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
        "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"SZops", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
          RowBox[{"{", 
           RowBox[{"j", ",", "Ij", ",", "0"}], "}"}], "]"}], ",", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
             RowBox[{"{", 
              RowBox[{"j", ",", "Ij", ",", "#"}], "}"}], "]"}], "&"}], "/@", 
           RowBox[{"Range", "[", 
            RowBox[{"1", ",", 
             RowBox[{"2", "*", "Ij"}]}], "]"}]}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SZzreps", "=", 
       RowBox[{"Flatten", "/@", 
        RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
         RowBox[{"Id", ",", "Iz", ",", "Iplus", ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "Ij", ",", "0"}], "}"}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SZpreps", "=", 
       RowBox[{"Flatten", "/@", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
             RowBox[{"Id", ",", "Iz", ",", "Iplus", ",", 
              RowBox[{"{", 
               RowBox[{"j", ",", "Ij", ",", "#"}], "}"}]}], "]"}], "&"}], "/@", 
           RowBox[{"Range", "[", 
            RowBox[{"1", ",", 
             RowBox[{"2", "*", "Ij"}]}], "]"}]}], ",", "1"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SZreps", "=", 
       RowBox[{"Join", "[", 
        RowBox[{"SZzreps", ",", "SZpreps"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Phi]vec", "=", 
       RowBox[{"Array", "[", 
        RowBox[{"\[Phi]", ",", 
         RowBox[{"Length", "[", "SZops", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"len", "=", 
       RowBox[{"Length", "[", "SZzreps", "]"}]}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"newset", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Orthogonalize", "[", 
          RowBox[{"\[Phi]vec", ",", "d$"}], "]"}], ")"}], "/.", 
        RowBox[{"Thread", "[", 
         RowBox[{"\[Phi]vec", "\[Rule]", " ", "SZops"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"newset", "=", 
       RowBox[{
        RowBox[{"newset", "//", 
         RowBox[{
          RowBox[{"Collect", "[", 
           RowBox[{"#", ",", 
            RowBox[{"(", 
             RowBox[{"_opI", "|", "_OperatorProduct"}], ")"}], ",", 
            "Simplify"}], "]"}], "&"}]}], "//", "Simplify"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
        RowBox[{"{", 
         RowBox[{"j", ",", "Ij"}], "}"}], "]"}], "=", "\[IndentingNewLine]", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"Ij", ">", 
            RowBox[{"3", "/", "2"}]}], ",", 
           RowBox[{
           "PrintTemporary", "[", 
            "\"\<Calculating the basis operators for ShiftAndZOperatorBasis \
can be slow for spins > 3/2. Working...\>\"", "]"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"Reverse", "[", "#", "]"}], "/.", 
               RowBox[{"{", 
                RowBox[{"\"\<+\>\"", "\[Rule]", " ", "\"\<-\>\""}], "}"}]}], 
              ",", 
              RowBox[{"newset", "\[LeftDoubleBracket]", 
               RowBox[{"1", ";;", "len"}], "\[RightDoubleBracket]"}], ",", 
              "#"}], "}"}], "]"}], "&"}], "@", 
          RowBox[{"newset", "\[LeftDoubleBracket]", 
           RowBox[{
            RowBox[{"len", "+", "1"}], ";;"}], "\[RightDoubleBracket]"}]}]}], 
        "\[IndentingNewLine]", ")"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639120042471846*^9, 3.639120079251799*^9}, {
  3.6391207385719223`*^9, 3.6391208410776043`*^9}, {3.639120930859823*^9, 
  3.639120941069544*^9}, {3.639121343079026*^9, 3.639121347036875*^9}, {
  3.639121421259264*^9, 3.639121427448419*^9}, {3.7222595710867643`*^9, 
  3.722259577266753*^9}, {3.722259616709757*^9, 3.7222596959163895`*^9}, {
  3.72225993386871*^9, 3.7222600411355577`*^9}, {3.722260158396809*^9, 
  3.7222602197005544`*^9}, {3.7222602834008446`*^9, 3.7222603239470377`*^9}, {
  3.7222603648506413`*^9, 3.722260383828014*^9}, {3.7222604260690856`*^9, 
  3.7222604262275515`*^9}, {3.722262322315385*^9, 3.7222623795976496`*^9}, {
  3.7222625992042446`*^9, 3.7222625993592963`*^9}, {3.722586268566119*^9, 
  3.7225862716329803`*^9}, {3.722586938261746*^9, 3.722586941670783*^9}, {
  3.7225872733257656`*^9, 3.722587280825279*^9}, {3.7257420301984253`*^9, 
  3.7257420562980795`*^9}},
 CellLabel->
  "In[782]:=",ExpressionUUID->"bc174abb-d45f-4251-b895-1d7f9ed7ae34"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
     RowBox[{"{", 
      RowBox[{"j_", ",", "Ij_", ",", "p_"}], "}"}], "]"}], "/;", 
    RowBox[{"p", ">", "0"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
     RowBox[{"{", 
      RowBox[{"j", ",", "Ij", ",", "p"}], "}"}], "]"}], "=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Iplusp", ",", "zops"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Iplusp", "=", 
        RowBox[{"OperatorProduct", "@@", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"opI", "[", 
            RowBox[{"j", ",", "\"\<+\>\""}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"Abs", "[", "p", "]"}], "}"}]}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"zops", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"OperatorProduct", "@@", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"UnityOperator", "[", "]"}], "}"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"opI", "[", 
                RowBox[{"j", ",", "\"\<z\>\""}], "]"}], ",", 
               RowBox[{"{", "i", "}"}]}], "]"}]}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "0", ",", 
            RowBox[{
             RowBox[{"2", "Ij"}], "-", 
             RowBox[{"Abs", "[", "p", "]"}]}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Iplusp", ".", "#"}], ")"}], "+", 
           RowBox[{"(", 
            RowBox[{"#", ".", "Iplusp"}], ")"}]}], ")"}], "&"}], "/@", 
        "zops"}]}]}], "\[IndentingNewLine]", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639120097691979*^9, 3.63912014936368*^9}, {
   3.639120209420313*^9, 3.639120255335208*^9}, {3.639121235601907*^9, 
   3.6391212457141848`*^9}, {3.717934020249215*^9, 3.717934022925845*^9}, 
   3.717934057938322*^9, 3.7222597639352756`*^9, {3.7222598886247125`*^9, 
   3.722259893873193*^9}},
 CellLabel->
  "In[783]:=",ExpressionUUID->"583a3451-3330-46c4-8f7a-717bc10327a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
     RowBox[{"Id_", ",", "Iz_", ",", "Ip_", ",", 
      RowBox[{"{", 
       RowBox[{"j_", ",", "Ij_", ",", "p_"}], "}"}]}], "]"}], "/;", 
    RowBox[{"p", ">", "0"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
     RowBox[{"Id", ",", "Iz", ",", "Ip", ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "Ij", ",", "p"}], "}"}]}], "]"}], "=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Iplusp", ",", "zops"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Iplusp", "=", 
        RowBox[{"MatrixPower", "[", 
         RowBox[{"Ip", ",", 
          RowBox[{"Abs", "[", "p", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"zops", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", "Id", "}"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"MatrixPower", "[", 
             RowBox[{"Iz", ",", "#"}], "]"}], "&"}], "/@", 
           RowBox[{"Range", "[", 
            RowBox[{"1", ",", 
             RowBox[{
              RowBox[{"2", "Ij"}], "-", 
              RowBox[{"Abs", "[", "p", "]"}]}]}], "]"}]}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Iplusp", ".", "#"}], ")"}], "+", 
           RowBox[{"(", 
            RowBox[{"#", ".", "Iplusp"}], ")"}]}], ")"}], "&"}], "/@", 
        "zops"}]}]}], "\[IndentingNewLine]", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639120097691979*^9, 3.63912014936368*^9}, {
   3.639120209420313*^9, 3.639120255335208*^9}, {3.639121235601907*^9, 
   3.6391212457141848`*^9}, {3.717934020249215*^9, 3.717934022925845*^9}, 
   3.717934057938322*^9, {3.7222598109658055`*^9, 3.7222598199269114`*^9}, {
   3.722259857227254*^9, 3.7222598840327044`*^9}},
 CellLabel->
  "In[784]:=",ExpressionUUID->"583a3451-3330-46c4-8f7a-717bc10327a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
    RowBox[{"{", 
     RowBox[{"j_", ",", "Ij_", ",", "0"}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
     RowBox[{"{", 
      RowBox[{"j", ",", "Ij", ",", "0"}], "}"}], "]"}], "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"OperatorProduct", "@@", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"UnityOperator", "[", "]"}], "}"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"opI", "[", 
            RowBox[{"j", ",", "\"\<z\>\""}], "]"}], ",", 
           RowBox[{"{", "i", "}"}]}], "]"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "0", ",", 
        RowBox[{"2", "Ij"}]}], "}"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639116040579894*^9, 3.639116053642665*^9}, {
   3.639116243564508*^9, 3.639116290457637*^9}, {3.639116323444228*^9, 
   3.639116454480022*^9}, {3.6391167378618507`*^9, 3.639116775383243*^9}, {
   3.639116850031569*^9, 3.6391168771667128`*^9}, {3.6391173384433117`*^9, 
   3.639117340614574*^9}, {3.63912031332111*^9, 3.6391203316484528`*^9}, 
   3.6391204358751507`*^9, 3.6405260437198477`*^9, {3.640526157453354*^9, 
   3.640526160577935*^9}, 3.717934066904394*^9, {3.7222597907944*^9, 
   3.722259796703232*^9}, {3.722259862393589*^9, 3.722259868293809*^9}},
 CellLabel->
  "In[785]:=",ExpressionUUID->"775c4fe6-fd13-46a6-bb0c-064fc86d1ea3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
    RowBox[{"Id_", ",", "Iz_", ",", "Ip_", ",", 
     RowBox[{"{", 
      RowBox[{"j_", ",", "Ij_", ",", "0"}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SingleSpinShiftAndZBasisOperators", "[", 
     RowBox[{"Id", ",", "Iz", ",", "Ip", ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "Ij", ",", "0"}], "}"}]}], "]"}], "=", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", "Id", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"MatrixPower", "[", 
         RowBox[{"Iz", ",", "#"}], "]"}], "&"}], "/@", 
       RowBox[{"Range", "[", 
        RowBox[{"1", ",", 
         RowBox[{"2", "Ij"}]}], "]"}]}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639116040579894*^9, 3.639116053642665*^9}, {
   3.639116243564508*^9, 3.639116290457637*^9}, {3.639116323444228*^9, 
   3.639116454480022*^9}, {3.6391167378618507`*^9, 3.639116775383243*^9}, {
   3.639116850031569*^9, 3.6391168771667128`*^9}, {3.6391173384433117`*^9, 
   3.639117340614574*^9}, {3.63912031332111*^9, 3.6391203316484528`*^9}, 
   3.6391204358751507`*^9, 3.6405260437198477`*^9, {3.640526157453354*^9, 
   3.640526160577935*^9}, 3.717934066904394*^9, {3.7222597907944*^9, 
   3.722259796703232*^9}, {3.7222598446544333`*^9, 3.7222598500542927`*^9}, {
   3.722259898102708*^9, 3.7222599060645685`*^9}, {3.722260261430193*^9, 
   3.722260261945567*^9}},
 CellLabel->
  "In[786]:=",ExpressionUUID->"775c4fe6-fd13-46a6-bb0c-064fc86d1ea3"]
}, Open  ]],

Cell[CellGroupData[{

Cell["BasisOperators", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"3418747d-26e0-447c-ab6e-9e0c0595ceec"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
     RowBox[{"ShiftAndZOperatorBasis", "[", 
      RowBox[{
       RowBox[{"spins", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "ShiftAndZOperatorBasis", "]"}]}], ",", 
      "\"\<OrderBySpin\>\""}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ops", ",", "temp"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ops", "=", 
        RowBox[{"SingleSpinShiftAndZBasisOperators", "/@", 
         RowBox[{"Reverse", "[", "spins", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
         RowBox[{"ShiftAndZOperatorBasis", "[", 
          RowBox[{"spins", ",", "opts"}], "]"}], "\[IndentingNewLine]", "]"}],
         "=", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{"Flatten", "@", 
          RowBox[{"Fold", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Outer", "[", 
              RowBox[{"OperatorProduct", ",", "#1", ",", "#2"}], "]"}], "&"}],
             ",", 
            RowBox[{"First", "[", "ops", "]"}], ",", 
            RowBox[{"Drop", "[", 
             RowBox[{"ops", ",", "1"}], "]"}]}], "]"}]}], ")"}]}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430626052255863*^9, 3.430626053203726*^9}, {
   3.431067770081327*^9, 3.4310677781502857`*^9}, 3.462190672855556*^9, {
   3.46219079653388*^9, 3.462190825595702*^9}, {3.462191186251012*^9, 
   3.462191204095901*^9}, {3.462191648135614*^9, 3.4621916489407463`*^9}, {
   3.467573080126677*^9, 3.467573083211925*^9}, {3.467634901484851*^9, 
   3.46763490437097*^9}, {3.468165972806953*^9, 3.468165997504368*^9}, {
   3.468166935317463*^9, 3.468166937878352*^9}, 3.468167059575492*^9, {
   3.5434977459522867`*^9, 3.543497864601927*^9}, {3.5434981650553303`*^9, 
   3.543498209980459*^9}, {3.543498320150714*^9, 3.54349834071544*^9}, 
   3.543499089105369*^9, 3.543499225005609*^9, {3.545887754954588*^9, 
   3.545887758656536*^9}, {3.54642196065842*^9, 3.54642197814675*^9}, {
   3.546534459161899*^9, 3.54653446525487*^9}, 3.717934082643641*^9, 
   3.7222604095964394`*^9, {3.7257416774246564`*^9, 3.725741737973559*^9}, {
   3.7257418190981236`*^9, 3.725741819241233*^9}, {3.7257418993606963`*^9, 
   3.7257419373791103`*^9}, {3.7257421038962307`*^9, 
   3.7257421064158735`*^9}, {3.72574213929609*^9, 3.7257421744248743`*^9}},
 CellLabel->
  "In[787]:=",ExpressionUUID->"efbeceb6-d603-44e1-85ae-c495956bd287"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
    RowBox[{"ShiftAndZOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{"MatchQ", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Sorted", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ShiftAndZOperatorBasis", "]"}]}], ",", 
     "\[IndentingNewLine]", "CoherenceOrder"}], "\[IndentingNewLine]", 
    "]"}]}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"sortfunc", ",", "g$", ",", "opts$"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"sortfunc", "[", "Q_", "]"}], ":=", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"ExpandAll", "[", "Q", "]"}], "/.", 
            RowBox[{"{", 
             RowBox[{"P_Plus", "\[RuleDelayed]", 
              RowBox[{"First", "[", "P", "]"}]}], "}"}]}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"k_", " ", "*", "A_opI"}], "\[RuleDelayed]", " ", "A"}],
              ",", 
             RowBox[{
              RowBox[{"k_", " ", "*", "A_OperatorProduct"}], "\[RuleDelayed]",
               " ", "A"}]}], "}"}]}], "/.", 
          RowBox[{"{", 
           RowBox[{"OperatorProduct", "\[Rule]", " ", "g$"}], "}"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"g$", "[", 
            RowBox[{"A___", ",", "opts$___Rule"}], "]"}], "\[RuleDelayed]", 
           " ", 
           RowBox[{"g$", "[", "A", "]"}]}], "}"}]}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"opI", "[", 
            RowBox[{"_", ",", "\"\<-\>\""}], "]"}], "\[Rule]", " ", 
           RowBox[{"-", "1"}]}], ",", 
          RowBox[{
           RowBox[{"opI", "[", 
            RowBox[{"_", ",", "\"\<z\>\""}], "]"}], "\[Rule]", " ", "0"}], 
          ",", 
          RowBox[{
           RowBox[{"opI", "[", 
            RowBox[{"_", ",", "\"\<+\>\""}], "]"}], "\[Rule]", " ", 
           RowBox[{"+", "1"}]}], ",", 
          RowBox[{"_UnityOperator", "\[Rule]", " ", "0"}]}], "}"}]}], "/.", 
       RowBox[{"{", 
        RowBox[{"g$", "\[Rule]", " ", "Plus"}], "}"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"BasisOperators", "[", 
       RowBox[{"ShiftAndZOperatorBasis", "[", 
        RowBox[{"spins", ",", 
         RowBox[{"SimplifyRules", "[", 
          RowBox[{
           RowBox[{"Sorted", "\[Rule]", "CoherenceOrder"}], ",", "opts"}], 
          "]"}]}], "]"}], "]"}], "=", "\[IndentingNewLine]", 
      RowBox[{"SortBy", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisOperators", "[", 
         RowBox[{"ShiftAndZOperatorBasis", "[", 
          RowBox[{"spins", ",", 
           RowBox[{"Sorted", "\[Rule]", "\"\<OrderBySpin\>\""}], ",", 
           "opts"}], "]"}], "]"}], ",", "\[IndentingNewLine]", "sortfunc"}], 
       "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431067786496859*^9, 3.431067793574499*^9}, {
   3.431069035148629*^9, 3.431069036298024*^9}, 3.4310929107548857`*^9, 
   3.431096146411978*^9, {3.462190720133946*^9, 3.462190740637025*^9}, {
   3.462190774301931*^9, 3.462190776892181*^9}, {3.462191209458654*^9, 
   3.462191217181428*^9}, {3.467573086624929*^9, 3.4675730895665293`*^9}, {
   3.4676349114206142`*^9, 3.4676349153378696`*^9}, {3.4681660064799767`*^9, 
   3.468166051385865*^9}, {3.4681667769649363`*^9, 3.468166791347724*^9}, {
   3.468166821503912*^9, 3.4681668222536497`*^9}, 3.468166888364422*^9, {
   3.468166940596819*^9, 3.4681669434288692`*^9}, {3.4681670635657*^9, 
   3.468167072860531*^9}, 3.54642199569882*^9, {3.718358732672472*^9, 
   3.7183587450376196`*^9}, {3.718358783497983*^9, 3.7183587839416294`*^9}, {
   3.7183591039535675`*^9, 3.718359133993864*^9}, {3.718359187276557*^9, 
   3.7183591887667866`*^9}, {3.718359258988991*^9, 3.718359260220506*^9}, {
   3.722260063887718*^9, 3.7222600693716235`*^9}},
 CellLabel->
  "In[788]:=",ExpressionUUID->"5b17941b-4e2c-4583-95ac-0097464e2799"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 
  3.468059115613844*^9}},ExpressionUUID->"70fef112-bc2e-4796-8c9f-\
b2819be8d51f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", "\[IndentingNewLine]", 
    RowBox[{"ShiftAndZOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "^:=", "spins"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468059125578073*^9, 3.468059180518187*^9}},
 CellLabel->
  "In[789]:=",ExpressionUUID->"decec258-e72e-4b71-9e0d-4ad9383def24"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["SingletTripletOperatorBasis (spin-1/2 pairs only)", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"ebb46c5e-814c-44ce-8e51-cc8f866007e0"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"0eb5bcf2-94cf-472a-8169-82de0c83f69f"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"SingletTripletOperatorBasis", ",", "NHoldAll"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5320142816604567`*^9, {3.532014340125402*^9, 3.5320143958146048`*^9}},
 CellLabel->
  "In[790]:=",ExpressionUUID->"8c46d066-ac50-45a3-8e1e-4c940bd1351d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SingletTripletOperatorBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Sorted", "\[Rule]", "True"}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310652732291594`*^9, 3.4310652740581207`*^9}, {
   3.456736644515234*^9, 3.456736648036252*^9}, 3.456736760361641*^9, {
   3.546520945685165*^9, 3.546520947086912*^9}, {3.546520982104126*^9, 
   3.546520982961688*^9}},
 CellLabel->
  "In[791]:=",ExpressionUUID->"1797389b-1326-49a2-b400-e3ced3fdea08"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AllowedSortValues", "[", 
    RowBox[{"SingletTripletOperatorBasis", "|", 
     RowBox[{"SingletTripletOperatorBasis", "[", "___", "]"}]}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "True", ",", "False", ",", "CoherenceOrder", ",", "\"\<Canonical\>\""}], 
    "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546519014593753*^9, 3.546519089592084*^9}, 
   3.546519306432543*^9, 3.546519537171898*^9, {3.54651966449155*^9, 
   3.546519667999522*^9}, 3.546520997370142*^9, {3.54652292332926*^9, 
   3.546522930576913*^9}},
 CellLabel->
  "In[792]:=",ExpressionUUID->"e8df2095-8257-4779-bdfb-3392d3293bc8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletOperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{"SingletTripletOperatorBasis", "[", 
    RowBox[{"1", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.456736788842877*^9, 3.456736805434346*^9}},
 CellLabel->
  "In[793]:=",ExpressionUUID->"f355fb70-c237-47e6-8d5a-fc2b0c83ef56"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BuiltinOperatorBasisQ", "[", 
    RowBox[{"SingletTripletOperatorBasis", "[", "___", "]"}], "]"}], "=", 
   "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.468154615716969*^9, 3.468154653287601*^9}},
 CellLabel->
  "In[794]:=",ExpressionUUID->"487e29be-134c-423b-ac8c-6400a6c2dd0b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedOperatorBasisQ", "[", 
    RowBox[{"SingletTripletOperatorBasis", "[", 
     RowBox[{
      RowBox[{"1", "|", "2"}], ",", "___"}], "]"}], "]"}], "=", "True"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456736774434725*^9, 3.4567367771684*^9}},
 CellLabel->
  "In[795]:=",ExpressionUUID->"57a7412e-a559-4a22-95a7-f74fa917ced4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletOperatorBasis", "[", 
    RowBox[{"type_Integer", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"SingletTripletOperatorBasis", "[", 
    RowBox[{"type", ",", 
     RowBox[{"SpinSystem", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.431065263373439*^9, 3.4310683648919783`*^9, 3.4561623999050827`*^9, {
   3.456736817965333*^9, 3.456736828763555*^9}},
 CellLabel->
  "In[796]:=",ExpressionUUID->"c33c7930-ab07-4b81-9836-8ddf85558f8b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletOperatorBasis", "[", 
    RowBox[{"type_Integer", ",", 
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"SingletTripletOperatorBasis", "::", "notspinshf"}], "]"}], 
      ";", "$Failed"}], ")"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Union", "[", 
       RowBox[{"Last", "/@", "spins"}], "]"}], "!=", 
      RowBox[{"{", 
       RowBox[{"1", "/", "2"}], "}"}]}], ")"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.439553917375801*^9, {3.4567368464722853`*^9, 3.45673684795929*^9}, {
   3.546521012577849*^9, 3.5465210172605333`*^9}, 3.62161457305517*^9},
 CellLabel->
  "In[797]:=",ExpressionUUID->"ed75709c-cebb-493d-b513-88d7cc1906ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletOperatorBasis", "[", 
    RowBox[{"type_Integer", ",", 
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"SingletTripletOperatorBasis", "::", "nottwospinshf"}], "]"}], 
      ";", "$Failed"}], ")"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", "spins", "]"}], "!=", "2"}], ")"}]}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.43955392195973*^9, {3.456736853158267*^9, 3.456736855694317*^9}, 
   3.546521021218144*^9, 3.621614573924761*^9},
 CellLabel->
  "In[798]:=",ExpressionUUID->"faa89fff-32cc-4efa-ad92-10e0a466f75b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletOperatorBasis", "::", "notspinshf"}], "=", 
   "\"\<this operator basis is only available for spins-1/2\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[799]:=",ExpressionUUID->"dc3ec5b7-e974-4195-a47c-4049e52ae951"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletOperatorBasis", "::", "nottwospinshf"}], "=", 
   "\"\<this operator basis is only available for two spins-1/2\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellLabel->
  "In[800]:=",ExpressionUUID->"764b322c-2321-48ea-ab50-55d56a1f4daa"]
}, Closed]],

Cell[CellGroupData[{

Cell["Sorted", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.46816613115307*^9, 
  3.468166132199485*^9}},ExpressionUUID->"37ae50a7-5a9c-4798-9bb3-\
c1fa81f87a04"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletOperatorBasis", "[", 
    RowBox[{"type_Integer", ",", 
     RowBox[{"spins_", "?", "MatrixQ"}]}], "]"}], ":=", 
   RowBox[{"SingletTripletOperatorBasis", "[", 
    RowBox[{"type", ",", "spins", ",", 
     RowBox[{"Sorted", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"Sorted", "/.", 
        RowBox[{"Options", "[", "SingletTripletOperatorBasis", "]"}]}], 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546519169830247*^9, 3.546519210221899*^9}, {
  3.546521063840374*^9, 3.546521081955278*^9}},
 CellLabel->
  "In[801]:=",ExpressionUUID->"fc1d30bf-2f3c-4dee-b608-31651a646c20"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SingletTripletOperatorBasis", "[", 
     RowBox[{"type_Integer", ",", 
      RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Sorted", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "SingletTripletOperatorBasis", "]"}]}], ")"}]}],
    ":=", 
   RowBox[{"SingletTripletOperatorBasis", "[", 
    RowBox[{"type", ",", "spins", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Sorted", "\[Rule]", "CoherenceOrder"}], ",", "opts"}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.4681557259103403`*^9}, {
  3.546519097359929*^9, 3.5465191130880337`*^9}, {3.546521095906897*^9, 
  3.546521129014826*^9}},
 CellLabel->
  "In[802]:=",ExpressionUUID->"46a04e27-0876-48f6-a25b-9d677df0f3e0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SingletTripletOperatorBasis", "[", 
     RowBox[{"type_Integer", ",", 
      RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "SingletTripletOperatorBasis", "]"}]}], ",", 
      "False"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SingletTripletOperatorBasis", "[", 
    RowBox[{"type", ",", "spins", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], ",", "opts"}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.4681557259103403`*^9}, {
  3.546519097359929*^9, 3.546519153727545*^9}, {3.546519553361746*^9, 
  3.546519562688888*^9}, {3.546521130990705*^9, 3.54652115220787*^9}},
 CellLabel->
  "In[803]:=",ExpressionUUID->"9dca1f5e-6b69-4747-aba8-0f7b54760477"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SingletTripletOperatorBasis", "[", 
    RowBox[{"type_Integer", ",", 
     RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"OperatorBasis", "::", "invalidsortopt"}], ",", 
        "SingletTripletOperatorBasis", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"#", ",", 
            RowBox[{"FormatType", "\[Rule]", "InputForm"}]}], "]"}], "&"}], 
         "@", 
         RowBox[{
         "AllowedSortValues", "[", "SingletTripletOperatorBasis", "]"}]}]}], 
       "]"}], ";", "$Failed"}], "\[IndentingNewLine]", ")"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MemberQ", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"AllowedSortValues", "[", "SingletTripletOperatorBasis", "]"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Sorted", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "SingletTripletOperatorBasis", "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.468155814827379*^9}, {
   3.468166200033634*^9, 3.468166202065984*^9}, {3.46816625429112*^9, 
   3.468166256098529*^9}, {3.546521048522851*^9, 3.54652104981212*^9}, {
   3.546521166177081*^9, 3.546521176801319*^9}, 3.62161457495439*^9, {
   3.659536507564492*^9, 3.659536520498955*^9}, 3.6595470719987707`*^9, 
   3.65954732844795*^9},
 CellLabel->
  "In[804]:=",ExpressionUUID->"7e8df655-f253-422c-94e3-4daccaa7fcb7"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisOperators, type 1", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456736880608292*^9, 
  3.456736881909762*^9}},ExpressionUUID->"c16bb76a-2ecb-452c-8422-\
a7c617a1b4f2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
     RowBox[{"SingletTripletOperatorBasis", "[", 
      RowBox[{"1", ",", 
       RowBox[{"spins", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "SingletTripletOperatorBasis", "]"}]}], ",", 
      "\"\<Canonical\>\""}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Flatten", "[", 
       RowBox[{"#", ",", "1"}], "]"}], "&"}], "@", 
     RowBox[{"Outer", "[", "\[IndentingNewLine]", 
      RowBox[{"Dot", ",", "\[IndentingNewLine]", 
       RowBox[{"BasisKets", "[", 
        RowBox[{"SingletTripletBasis", "@", "spins"}], "]"}], ",", 
       RowBox[{"BasisBras", "[", 
        RowBox[{"SingletTripletBasis", "@", "spins"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431067811430799*^9, 3.431067818879265*^9}, {
   3.431093802943215*^9, 3.431093846094146*^9}, {3.43109391433204*^9, 
   3.431094002379771*^9}, {3.431094055777334*^9, 3.431094103686921*^9}, {
   3.431094221585074*^9, 3.431094225584489*^9}, {3.4567368718188066`*^9, 
   3.456736872039926*^9}, {3.468166219594532*^9, 3.468166242205621*^9}, {
   3.546521202689939*^9, 3.546521234212141*^9}, {3.546521280184861*^9, 
   3.546521281557929*^9}, 3.717934104951483*^9, {3.7183481103830495`*^9, 
   3.7183481107737107`*^9}},
 CellLabel->
  "In[805]:=",ExpressionUUID->"9274de66-0252-4a38-ae1a-9ab7e3e70391"],

Cell["the CoherenceOrder sorted basis uses manual ordering", "Text",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431093346913752*^9, 3.431093371770171*^9}, 
   3.4310942621238203`*^9, {3.546533208133339*^9, 
   3.546533212968646*^9}},ExpressionUUID->"6398f5d8-5ec2-422d-9eda-\
566cb1ccdcf1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
     RowBox[{"SingletTripletOperatorBasis", "[", 
      RowBox[{"1", ",", 
       RowBox[{"spins", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "SingletTripletOperatorBasis", "]"}]}], ",", 
      "CoherenceOrder"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "j", ",", "k", ",", "ket\[Alpha]\[Alpha]", ",", "ket\[Alpha]\[Beta]", 
       ",", "ket\[Beta]\[Alpha]", ",", "ket\[Beta]\[Beta]", ",", "ketS0", ",",
        "ketT1", ",", "ketT0", ",", "ketTm1", ",", "braS0", ",", "braT1", ",",
        "braT0", ",", "braTm1"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"j", ",", "k"}], "}"}], "=", 
         RowBox[{"First", "/@", "spins"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "ket\[Alpha]\[Alpha]", ",", "ket\[Alpha]\[Beta]", ",", 
           "ket\[Beta]\[Alpha]", ",", "ket\[Beta]\[Beta]"}], "}"}], "=", 
         RowBox[{"Flatten", "@", 
          RowBox[{"Outer", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Ket", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"j", ",", "#1"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"k", ",", "#2"}], "}"}]}], "}"}], ",", 
               RowBox[{"Validity", "\[Rule]", "True"}]}], "]"}], "&"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "/", "2"}], ",", 
              RowBox[{
               RowBox[{"-", "1"}], "/", "2"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"1", "/", "2"}], ",", 
              RowBox[{
               RowBox[{"-", "1"}], "/", "2"}]}], "}"}]}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"ketS0", ",", "ketT1", ",", "ketT0", ",", "ketTm1"}], "}"}],
          "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"ket\[Alpha]\[Beta]", "-", "ket\[Beta]\[Alpha]"}], ")"}],
             "/", 
            RowBox[{"Sqrt", "[", "2", "]"}]}], ",", "ket\[Alpha]\[Alpha]", 
           ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"ket\[Alpha]\[Beta]", "+", "ket\[Beta]\[Alpha]"}], ")"}],
             "/", 
            RowBox[{"Sqrt", "[", "2", "]"}]}], ",", "ket\[Beta]\[Beta]"}], 
          "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"braS0", ",", "braT1", ",", "braT0", ",", "braTm1"}], "}"}],
          "=", 
         RowBox[{"Adjoint", "/@", 
          RowBox[{"{", 
           RowBox[{"ketS0", ",", "ketT1", ",", "ketT0", ",", "ketTm1"}], 
           "}"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
          RowBox[{"SingletTripletOperatorBasis", "[", 
           RowBox[{"1", ",", "spins", ",", "opts"}], "]"}], 
          "\[IndentingNewLine]", "]"}], "=", "\[IndentingNewLine]", 
         RowBox[{"Reverse", "[", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ketT1", ".", "braTm1"}], ",", "\[IndentingNewLine]", 
            RowBox[{"ketT1", ".", "braS0"}], ",", 
            RowBox[{"ketT1", ".", "braT0"}], ",", 
            RowBox[{"ketS0", ".", "braTm1"}], ",", 
            RowBox[{"ketT0", ".", "braTm1"}], ",", "\[IndentingNewLine]", 
            RowBox[{"ketS0", ".", "braS0"}], ",", 
            RowBox[{"ketT1", ".", "braT1"}], ",", 
            RowBox[{"ketT0", ".", "braT0"}], ",", 
            RowBox[{"ketTm1", ".", "braTm1"}], ",", 
            RowBox[{"ketS0", ".", "braT0"}], ",", 
            RowBox[{"ketT0", ".", "braS0"}], ",", "\[IndentingNewLine]", 
            RowBox[{"ketTm1", ".", "braS0"}], ",", 
            RowBox[{"ketTm1", ".", "braT0"}], ",", 
            RowBox[{"ketS0", ".", "braT1"}], ",", 
            RowBox[{"ketT0", ".", "braT1"}], ",", "\[IndentingNewLine]", 
            RowBox[{"ketTm1", ".", "braT1"}]}], "}"}], "\[IndentingNewLine]", 
          "]"}]}]}], "\[IndentingNewLine]", ")"}], "//", "Simplify"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431067823496662*^9, 3.431067829866349*^9}, 
   3.431069048667206*^9, {3.431092920070271*^9, 3.4310929521208487`*^9}, {
   3.431093176316719*^9, 3.431093315257638*^9}, {3.43109412904134*^9, 
   3.431094202362616*^9}, 3.431094323482836*^9, {3.456736877078575*^9, 
   3.4567368772703657`*^9}, {3.468166278025557*^9, 3.468166296914318*^9}, {
   3.546521254776432*^9, 3.546521275574522*^9}, {3.5465332218664303`*^9, 
   3.546533228890253*^9}, {3.546534503236299*^9, 3.546534511865075*^9}, {
   3.547479915578752*^9, 3.5474799182707577`*^9}, {3.547479989607839*^9, 
   3.547479994693799*^9}, 3.547530520688208*^9},
 CellLabel->
  "In[806]:=",ExpressionUUID->"33f29bf8-e98e-45e7-b815-84e63285ec44"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisOperators, type 2", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.456736880608292*^9, 
  3.456736901344088*^9}},ExpressionUUID->"74763be1-8682-4348-a3be-\
2428ffad3841"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
    RowBox[{"SingletTripletOperatorBasis", "[", 
     RowBox[{"2", ",", 
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Sorted", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "SingletTripletOperatorBasis", "]"}]}], ",", 
     "\"\<Canonical\>\""}], "]"}]}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "j", ",", "k", ",", "ket\[Alpha]\[Alpha]", ",", "ket\[Alpha]\[Beta]", 
       ",", "ket\[Beta]\[Alpha]", ",", "ket\[Beta]\[Beta]", ",", "ketS0", ",",
        "ketT1", ",", "ketT0", ",", "ketTm1", ",", "braS0", ",", "braT1", ",",
        "braT0", ",", "braTm1"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"j", ",", "k"}], "}"}], "=", 
        RowBox[{"First", "/@", "spins"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "ket\[Alpha]\[Alpha]", ",", "ket\[Alpha]\[Beta]", ",", 
          "ket\[Beta]\[Alpha]", ",", "ket\[Beta]\[Beta]"}], "}"}], "=", 
        RowBox[{"Flatten", "@", 
         RowBox[{"Outer", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Ket", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"j", ",", "#1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"k", ",", "#2"}], "}"}]}], "}"}], ",", 
              RowBox[{"Validity", "\[Rule]", "True"}]}], "]"}], "&"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"1", "/", "2"}], ",", 
             RowBox[{
              RowBox[{"-", "1"}], "/", "2"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"1", "/", "2"}], ",", 
             RowBox[{
              RowBox[{"-", "1"}], "/", "2"}]}], "}"}]}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ketS0", ",", "ketT1", ",", "ketT0", ",", "ketTm1"}], "}"}], 
        "=", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"ket\[Alpha]\[Beta]", "-", "ket\[Beta]\[Alpha]"}], ")"}], 
           "/", 
           RowBox[{"Sqrt", "[", "2", "]"}]}], ",", "ket\[Alpha]\[Alpha]", ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"ket\[Alpha]\[Beta]", "+", "ket\[Beta]\[Alpha]"}], ")"}], 
           "/", 
           RowBox[{"Sqrt", "[", "2", "]"}]}], ",", "ket\[Beta]\[Beta]"}], 
         "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"braS0", ",", "braT1", ",", "braT0", ",", "braTm1"}], "}"}], 
        "=", 
        RowBox[{"Adjoint", "/@", 
         RowBox[{"{", 
          RowBox[{"ketS0", ",", "ketT1", ",", "ketT0", ",", "ketTm1"}], 
          "}"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
         RowBox[{"SingletTripletOperatorBasis", "[", 
          RowBox[{"2", ",", "spins", ",", "opts"}], "]"}], 
         "\[IndentingNewLine]", "]"}], "=", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ketT1", ".", "braTm1"}], ",", "\[IndentingNewLine]", 
          RowBox[{"ketT1", ".", "braS0"}], ",", 
          RowBox[{"ketT1", ".", "braT0"}], ",", 
          RowBox[{"ketS0", ".", "braTm1"}], ",", 
          RowBox[{"ketT0", ".", "braTm1"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "/", "2"}], ")"}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"ketS0", ".", "braS0"}], "+", 
             RowBox[{"ketT1", ".", "braT1"}], "+", 
             RowBox[{"ketT0", ".", "braT0"}], "+", 
             RowBox[{"ketTm1", ".", "braTm1"}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "/", 
             RowBox[{"(", 
              RowBox[{"2", 
               RowBox[{"Sqrt", "[", "3", "]"}]}], ")"}]}], ")"}], "\[Times]", 
           
           RowBox[{"(", 
            RowBox[{
             RowBox[{"3", 
              RowBox[{"ketS0", ".", "braS0"}]}], "-", 
             RowBox[{"ketT1", ".", "braT1"}], "-", 
             RowBox[{"ketT0", ".", "braT0"}], "-", 
             RowBox[{"ketTm1", ".", "braTm1"}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "/", 
             RowBox[{"Sqrt", "[", "2", "]"}]}], ")"}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"ketT1", ".", "braT1"}], "-", 
             RowBox[{"ketTm1", ".", "braTm1"}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "/", 
             RowBox[{"Sqrt", "[", "6", "]"}]}], ")"}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"ketT1", ".", "braT1"}]}], "+", 
             RowBox[{"2", 
              RowBox[{"ketT0", ".", "braT0"}]}], "-", 
             RowBox[{"ketTm1", ".", "braTm1"}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ketS0", ".", "braT0"}], ",", "\[IndentingNewLine]", 
          RowBox[{"ketT0", ".", "braS0"}], ",", "\[IndentingNewLine]", 
          RowBox[{"ketTm1", ".", "braS0"}], ",", 
          RowBox[{"ketTm1", ".", "braT0"}], ",", 
          RowBox[{"ketS0", ".", "braT1"}], ",", 
          RowBox[{"ketT0", ".", "braT1"}], ",", "\[IndentingNewLine]", 
          RowBox[{"ketTm1", ".", "braT1"}]}], "}"}]}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}], "//", "Simplify"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431067823496662*^9, 3.431067829866349*^9}, 
   3.431069048667206*^9, {3.431092920070271*^9, 3.4310929521208487`*^9}, {
   3.431093176316719*^9, 3.431093315257638*^9}, {3.43109412904134*^9, 
   3.431094202362616*^9}, 3.431094323482836*^9, {3.456736877078575*^9, 
   3.4567368772703657`*^9}, {3.456736980729607*^9, 3.4567371562245703`*^9}, {
   3.4567372196094522`*^9, 3.45673722062733*^9}, 3.468166374320909*^9, 
   3.546521301560512*^9, {3.54653452318333*^9, 3.546534529354658*^9}, {
   3.547479937453596*^9, 3.5474799422603073`*^9}, 3.5475305217023497`*^9},
 CellLabel->
  "In[807]:=",ExpressionUUID->"d2c66d34-2c47-4b3e-bb0c-f49546b12bd6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
     RowBox[{"SingletTripletOperatorBasis", "[", 
      RowBox[{"2", ",", 
       RowBox[{"spins", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "SingletTripletOperatorBasis", "]"}]}], ",", 
      "CoherenceOrder"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
     RowBox[{"SingletTripletOperatorBasis", "[", 
      RowBox[{"2", ",", "spins", ",", "opts"}], "]"}], "\[IndentingNewLine]", 
     "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{"SortBy", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
       RowBox[{"SingletTripletOperatorBasis", "[", 
        RowBox[{"2", ",", "spins", ",", 
         RowBox[{"SimplifyRules", "[", 
          RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}], ",", 
      "\[IndentingNewLine]", "CoherenceOrder"}], "\[IndentingNewLine]", 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546521482394998*^9, 3.546521536180794*^9}, {
  3.546521582516614*^9, 3.546521583975193*^9}, {3.5465345369566708`*^9, 
  3.546534538514996*^9}},
 CellLabel->
  "In[808]:=",ExpressionUUID->"f315ffe5-8c98-4390-ba76-357d18afb968"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 
  3.468059115613844*^9}},ExpressionUUID->"13588368-e38a-4369-aaac-\
7187d4da1151"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", "\[IndentingNewLine]", 
    RowBox[{"SingletTripletOperatorBasis", "[", 
     RowBox[{"n_Integer", ",", 
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "^:=", "spins"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468059125578073*^9, 3.468059192574951*^9}, {
  3.468167189458869*^9, 3.468167191880727*^9}},
 CellLabel->
  "In[809]:=",ExpressionUUID->"b0fce48f-0466-488e-a0c2-71faaf8d37fc"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ZeemanKetBraOperatorBasis (general spins)", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433525053725692*^9, 3.433525058018615*^9}, 
   3.4335255468608017`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"c48540e4-a9de-44ca-b0e2-37529ddcc3a4"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"56e98c65-9e6c-40d5-93c9-a1e0aab30a9e"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"ZeemanKetBraOperatorBasis", ",", "NHoldFirst"}], "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5320142816604567`*^9, {3.532014340125402*^9, 3.532014412864695*^9}},
 CellLabel->
  "In[810]:=",ExpressionUUID->"a0f0b5ac-20bb-4f4a-b50c-7dd7cf523a8a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ZeemanKetBraOperatorBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "}"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433525068576215*^9, 3.433525075209988*^9}, {
  3.546422441294633*^9, 3.546422444338703*^9}},
 CellLabel->
  "In[811]:=",ExpressionUUID->"b41c9f29-3147-445a-a882-55fd6eea4f1e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AllowedSortValues", "[", 
    RowBox[{"ZeemanKetBraOperatorBasis", "|", 
     RowBox[{"ZeemanKetBraOperatorBasis", "[", "___", "]"}]}], "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "True", ",", "False", ",", "CoherenceOrder", ",", "\"\<Canonical\>\"", 
     ",", "\"\<OrderBySpin\>\""}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546521735826906*^9, 3.546521742953022*^9}, {
   3.546522935624011*^9, 3.54652294274969*^9}, 3.631449638134663*^9},
 CellLabel->
  "In[812]:=",ExpressionUUID->"a456fb21-892a-40c5-818b-abd0b7185c04"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedOperatorBasisQ", "[", 
    RowBox[{"ZeemanKetBraOperatorBasis", "[", "___", "]"}], "]"}], "=", 
   "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.433525076751453*^9},
 CellLabel->
  "In[813]:=",ExpressionUUID->"fbfb6baa-7194-4712-94f2-d0fef3acdbe9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BuiltinOperatorBasisQ", "[", 
    RowBox[{"ZeemanKetBraOperatorBasis", "[", "___", "]"}], "]"}], "=", 
   "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.468154615716969*^9, 3.468154665312324*^9}},
 CellLabel->
  "In[814]:=",ExpressionUUID->"93e5c22d-eab6-4287-b4f1-d1a2ca87fcdd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ZeemanKetBraOperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"ZeemanKetBraOperatorBasis", "[", 
    RowBox[{
     RowBox[{"SpinSystem", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431062024816597*^9, 3.431062061525462*^9}, {
   3.431062211767852*^9, 3.431062222605216*^9}, {3.431064990910803*^9, 
   3.431065017790723*^9}, {3.4310651382614393`*^9, 3.431065140570182*^9}, {
   3.431068087828887*^9, 3.4310680911274*^9}, {3.433525079632502*^9, 
   3.433525081143784*^9}, 3.4561624007025833`*^9},
 CellLabel->
  "In[815]:=",ExpressionUUID->"c954a9f1-f29c-415b-998d-9b1e86af2061"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ZeemanKetBraOperatorBasis", "[", 
   RowBox[{"nspin_Integer", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"ZeemanKetBraOperatorBasis", "[", 
   RowBox[{
    RowBox[{"Range", "[", 
     RowBox[{"1", ",", "nspin"}], "]"}], ",", "opts"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486387704415118*^9, 3.486387710487081*^9}, {
  3.5319317300394783`*^9, 3.5319317318712873`*^9}, {3.531931772638824*^9, 
  3.5319317742314796`*^9}, {3.53193180727065*^9, 3.531931808670971*^9}, {
  3.5319318653263407`*^9, 3.531931866546776*^9}},
 CellLabel->
  "In[816]:=",ExpressionUUID->"c8ce62b6-5f03-401a-ab9a-097307411331"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ZeemanKetBraOperatorBasis", "[", 
    RowBox[{
     RowBox[{"labels", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"ZeemanKetBraOperatorBasis", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#", ",", 
         RowBox[{"1", "/", "2"}]}], "}"}], "&"}], "/@", "labels"}], ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.43496998227287*^9, 3.434970003133623*^9}, {
  3.486387693256557*^9, 3.486387699623499*^9}, {3.531931734775353*^9, 
  3.531931737689125*^9}, {3.5319317757791033`*^9, 3.5319317770331287`*^9}, {
  3.53193181071211*^9, 3.531931811880478*^9}, {3.531931868240654*^9, 
  3.53193186979478*^9}, {3.54644557942136*^9, 3.54644560122821*^9}},
 CellLabel->
  "In[817]:=",ExpressionUUID->"c5a7f3af-b504-4839-957a-0543fbb7618a"]
}, Closed]],

Cell[CellGroupData[{

Cell["Sorted", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4681664446274433`*^9, 
  3.46816644650605*^9}},ExpressionUUID->"11727ea2-2288-4a98-a45d-\
4763ca286082"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ZeemanKetBraOperatorBasis", "[", 
    RowBox[{"spins_", "?", "MatrixQ"}], "]"}], ":=", 
   RowBox[{"ZeemanKetBraOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"Sorted", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"Sorted", "/.", 
        RowBox[{"Options", "[", "ZeemanKetBraOperatorBasis", "]"}]}], 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546424531367845*^9, 3.5464245902311277`*^9}},
 CellLabel->
  "In[818]:=",ExpressionUUID->"3f520b8a-e52b-4942-819a-88960b9f94cb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ZeemanKetBraOperatorBasis", "[", 
    RowBox[{
     RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"ZeemanKetBraOperatorBasis", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{
        RowBox[{"Sorted", "\[Rule]", "CoherenceOrder"}], ",", "opts"}], 
       "]"}]}], "]"}], "/;", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"Sorted", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ZeemanKetBraOperatorBasis", "]"}]}], "]"}]}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.4681557259103403`*^9}, {
  3.468166464633123*^9, 3.468166467481203*^9}, {3.5464224535473547`*^9, 
  3.546422458883007*^9}},
 CellLabel->
  "In[819]:=",ExpressionUUID->"e811506f-37c7-41fd-9dee-7b8deecfbf6c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ZeemanKetBraOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "ZeemanKetBraOperatorBasis", "]"}]}], ",", 
      "False"}], "]"}]}], ":=", 
   RowBox[{"ZeemanKetBraOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], ",", "opts"}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.4681557259103403`*^9}, {
  3.468166464633123*^9, 3.468166467481203*^9}, {3.5464203909528093`*^9, 
  3.546420464054059*^9}, {3.546422475437491*^9, 3.546422478357855*^9}},
 CellLabel->
  "In[820]:=",ExpressionUUID->"72359c5f-c9de-4059-bfcb-56910bd4d727"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ZeemanKetBraOperatorBasis", "[", 
    RowBox[{
     RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"OperatorBasis", "::", "invalidsortopt"}], ",", 
        "ZeemanKetBraOperatorBasis", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"#", ",", 
            RowBox[{"FormatType", "\[Rule]", "InputForm"}]}], "]"}], "&"}], 
         "@", 
         RowBox[{
         "AllowedSortValues", "[", "ZeemanKetBraOperatorBasis", "]"}]}]}], 
       "]"}], ";", "$Failed"}], "\[IndentingNewLine]", ")"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MemberQ", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"AllowedSortValues", "[", "ZeemanKetBraOperatorBasis", "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Sorted", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "ZeemanKetBraOperatorBasis", "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.468155814827379*^9}, {
   3.46816647151397*^9, 3.4681664738825283`*^9}, {3.546420478459556*^9, 
   3.5464204953700542`*^9}, 3.5464215644077873`*^9, 3.546421610576826*^9, {
   3.546422539236106*^9, 3.5464225423862457`*^9}, {3.5465217645765533`*^9, 
   3.546521770890571*^9}, {3.65953652892493*^9, 3.659536535627862*^9}, 
   3.659547078047785*^9, 3.659547329179501*^9},
 CellLabel->
  "In[821]:=",ExpressionUUID->"7ecffebd-cae3-4327-a79d-99683cb71e96"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisOperators: Sorted\[Rule]\[CloseCurlyDoubleQuote]Canonical\
\[CloseCurlyDoubleQuote]", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.546420715673141*^9, 3.546420722159631*^9}, {
  3.546420759345407*^9, 
  3.546420763486157*^9}},ExpressionUUID->"a0289fb3-6e2e-45f2-a685-\
928a253a49b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
    RowBox[{"ZeemanKetBraOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Sorted", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ZeemanKetBraOperatorBasis", "]"}]}], ",", 
     "\"\<Canonical\>\""}], "]"}]}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Flatten", "@", 
   RowBox[{"Outer", "[", 
    RowBox[{"Dot", ",", "\[IndentingNewLine]", 
     RowBox[{"BasisKets", "[", 
      RowBox[{"ZeemanBasis", "[", "spins", "]"}], "]"}], ",", 
     RowBox[{"BasisBras", "[", 
      RowBox[{"ZeemanBasis", "[", "spins", "]"}], "]"}]}], "]"}]}]}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310677050008383`*^9, 3.431067743165999*^9}, {
   3.433525137332799*^9, 3.433525164438301*^9}, {3.433525272178706*^9, 
   3.433525310722043*^9}, {3.468166488899308*^9, 3.468166498043632*^9}, 
   3.5464207129610443`*^9, {3.546420768538599*^9, 3.546420778944009*^9}, {
   3.546421068390572*^9, 3.546421088181623*^9}, 3.717934143595212*^9, {
   3.7183517994927626`*^9, 3.718351799885501*^9}},
 CellLabel->
  "In[822]:=",ExpressionUUID->"5293c175-0373-4e26-a947-039dd815c702"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisOperators: Sorted\[Rule]\[CloseCurlyDoubleQuote]OrderBySpin\
\[CloseCurlyDoubleQuote]", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.546420715673141*^9, 3.546420722159631*^9}, {
   3.546420759345407*^9, 3.546420763486157*^9}, {3.5464209647155743`*^9, 
   3.5464209668264923`*^9}, 3.546421566009355*^9, 
   3.546421612375805*^9},ExpressionUUID->"b531fc00-cf31-4d42-9123-\
2b03e97b9ae1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
     RowBox[{"ZeemanKetBraOperatorBasis", "[", 
      RowBox[{
       RowBox[{"spins", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "ZeemanKetBraOperatorBasis", "]"}]}], ",", 
      "\"\<OrderBySpin\>\""}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "n", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "spins", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ZeemanKetBraOperatorBasis", "/:", "\[IndentingNewLine]", 
        RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
         RowBox[{"ZeemanKetBraOperatorBasis", "[", 
          RowBox[{"spins", ",", "opts"}], "]"}], "\[IndentingNewLine]", "]"}],
         "=", "\[IndentingNewLine]", 
        RowBox[{"ReleaseHold", "@", 
         RowBox[{"Flatten", "@", 
          RowBox[{"Outer", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Function", "[", "\[IndentingNewLine]", 
             RowBox[{"Evaluate", "@", 
              RowBox[{"Dot", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"Hold", "[", "Ket", "]"}], "[", 
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"First", "/@", "spins"}], ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"Slot", "[", "i", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", 
                    RowBox[{
                    RowBox[{"2", "n"}], "-", "1"}], ",", "1", ",", 
                    RowBox[{"-", "2"}]}], "}"}]}], "]"}]}], "}"}], "]"}], ",",
                   "spins", ",", 
                  RowBox[{"Validity", "\[Rule]", "True"}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Hold", "[", "Bra", "]"}], "[", 
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"First", "/@", "spins"}], ",", 
                    RowBox[{"Table", "[", 
                    RowBox[{
                    RowBox[{"Slot", "[", "i", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", 
                    RowBox[{"2", "n"}], ",", "2", ",", 
                    RowBox[{"-", "2"}]}], "}"}]}], "]"}]}], "}"}], "]"}], ",",
                   "spins", ",", 
                  RowBox[{"Validity", "\[Rule]", "True"}]}], "]"}]}], 
               "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"Sequence", "@@", 
                 RowBox[{"(", 
                  RowBox[{"Table", "[", 
                   RowBox[{"m", ",", 
                    RowBox[{"{", "2", "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"m", ",", "#", ",", 
                    RowBox[{"-", "#"}], ",", 
                    RowBox[{"-", "1"}]}], "}"}]}], "]"}], ")"}]}], "&"}], "/@", 
               RowBox[{"Reverse", "[", 
                RowBox[{"Last", "/@", "spins"}], "]"}]}], ")"}]}]}], 
           "\[IndentingNewLine]", "]"}]}]}]}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310677050008383`*^9, 3.431067743165999*^9}, {
   3.433525137332799*^9, 3.433525164438301*^9}, {3.433525272178706*^9, 
   3.433525310722043*^9}, {3.468166488899308*^9, 3.468166498043632*^9}, 
   3.5464207129610443`*^9, {3.546420768538599*^9, 3.546420778944009*^9}, {
   3.546420975184757*^9, 3.54642108643482*^9}, 3.5464215675777483`*^9, 
   3.546421613552475*^9, {3.546528586688047*^9, 3.54652859246012*^9}, {
   3.5465286882712183`*^9, 3.546528693214458*^9}, {3.5465345588512373`*^9, 
   3.546534566963814*^9}, {3.547298374647101*^9, 3.547298392003436*^9}, {
   3.547479960652679*^9, 3.54747996862735*^9}, {3.547530522705491*^9, 
   3.5475305239314423`*^9}, {3.717934163744776*^9, 3.717934191654039*^9}, {
   3.718348124099207*^9, 3.7183481245679655`*^9}},
 CellLabel->
  "In[823]:=",ExpressionUUID->"338e90b9-6f67-4bbb-ad8a-6becb6ec7aa0"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisOperators: Sorted\[Rule]CoherenceOrder", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.546420715673141*^9, 
  3.5464207541824827`*^9}},ExpressionUUID->"f623f75b-47d7-4c30-b015-\
4caf309e8222"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
    RowBox[{"ZeemanKetBraOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{"MatchQ", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Sorted", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ZeemanKetBraOperatorBasis", "]"}]}], ",", 
     "\[IndentingNewLine]", "CoherenceOrder"}], "\[IndentingNewLine]", 
    "]"}]}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"BasisOperators", "[", "\[IndentingNewLine]", 
    RowBox[{"ZeemanKetBraOperatorBasis", "[", 
     RowBox[{"spins", ",", "opts"}], "]"}], "\[IndentingNewLine]", "]"}], "=",
    "\[IndentingNewLine]", 
   RowBox[{"SortBy", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"BasisOperators", "[", 
      RowBox[{"ZeemanKetBraOperatorBasis", "[", 
       RowBox[{"spins", ",", 
        RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], ",", "opts"}], 
       "]"}], "]"}], ",", "\[IndentingNewLine]", "CoherenceOrder"}], 
    "\[IndentingNewLine]", "]"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431067718948139*^9, 3.431067750229857*^9}, 
   3.43106901791814*^9, 3.43109289818414*^9, {3.4335251666925488`*^9, 
   3.433525168652351*^9}, {3.468166503990981*^9, 3.4681665226634912`*^9}, 
   3.546420874732959*^9, {3.5464210967946377`*^9, 3.546421101623403*^9}, {
   3.546531240236651*^9, 3.5465312476152973`*^9}, {3.546534577299065*^9, 
   3.546534578425426*^9}},
 CellLabel->
  "In[824]:=",ExpressionUUID->"8c19157c-f25d-41aa-91e8-1ef370f50e87"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
ResolveIntoKetsAndBras: These rules are needed for calculating the \
SuperoperatorMatrixRepresentation using Method\[Rule]Automatic\
\>", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.429698175387712*^9, {3.431058123679789*^9, 
   3.431058128974515*^9}},ExpressionUUID->"3f0a2509-61a4-4a77-b145-\
cce95049df78"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ResolveIntoKetsAndBras", "[", 
    RowBox[{"ZeemanKetBraOperatorBasis", "[", 
     RowBox[{"spins_", ",", 
      RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
    "\[IndentingNewLine]", "]"}], "^:=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"BasisKets", "[", 
      RowBox[{"ZeemanBasis", "[", "spins", "]"}], "]"}], ",", 
     RowBox[{"BasisBras", "[", 
      RowBox[{"ZeemanBasis", "[", "spins", "]"}], "]"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431067731492938*^9, 3.431067738599614*^9}, 
   3.4335251852650747`*^9, 3.5464207972755337`*^9},
 CellLabel->
  "In[825]:=",ExpressionUUID->"9b6762f1-82e2-4a76-a51f-7735da8f08f6"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 
  3.468059115613844*^9}},ExpressionUUID->"6345a15a-4803-40b1-a644-\
cb1374b9b916"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", "\[IndentingNewLine]", 
    RowBox[{"ZeemanKetBraOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "^:=", "spins"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468059125578073*^9, 3.468059204359614*^9}},
 CellLabel->
  "In[826]:=",ExpressionUUID->"9184c9e3-61a3-4612-b911-779e823e16f1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SphericalTensorOperatorBasis (general spins)", "Subsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433525053725692*^9, 3.433525058018615*^9}, 
   3.4335255468608017`*^9, 3.434516460446849*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"a21dd41c-24b1-4a12-980b-0da369fa884b"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"56a3a66f-cee8-4375-8c26-0b8c647ac0fc"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"SphericalTensorOperatorBasis", ",", "NHoldFirst"}], "]"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{
  3.5320142816604567`*^9, {3.532014340125402*^9, 3.532014425900776*^9}},
 CellLabel->
  "In[827]:=",ExpressionUUID->"bc14005d-2334-47c7-8870-89e115ec66b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SphericalTensorOperatorBasis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Sorted", "\[Rule]", "True"}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.433525068576215*^9, 3.433525075209988*^9}, 
   3.434516474857822*^9, {3.434533328652972*^9, 3.4345333497540894`*^9}, {
   3.459443764898562*^9, 3.459443770928759*^9}, {3.4681679626871157`*^9, 
   3.468167966416293*^9}, {3.468168677506688*^9, 3.4681686780710373`*^9}, 
   3.468169065031991*^9},
 CellLabel->
  "In[828]:=",ExpressionUUID->"cd419784-8f2e-4745-beae-1426940db928"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AllowedSortValues", "[", 
   RowBox[{"SphericalTensorOperatorBasis", "|", 
    RowBox[{"SphericalTensorOperatorBasis", "[", "___", "]"}]}], "]"}], "=", 
  RowBox[{"{", 
   RowBox[{"True", ",", "False", ",", "CoherenceOrder", ",", 
    RowBox[{"{", 
     RowBox[{"CoherenceOrder", ",", "SphericalRank"}], "}"}], ",", 
    "SphericalRank", ",", "\"\<Canonical\>\""}], "}"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.546521919690539*^9, {3.546521981157378*^9, 3.546521986280164*^9}, {
   3.546522948184021*^9, 3.546522954704615*^9}},
 CellLabel->
  "In[829]:=",ExpressionUUID->"7c32748b-938e-4645-abdc-5ee55fd1a73b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"True", ",", "False", ",", "CoherenceOrder", ",", 
   RowBox[{"{", 
    RowBox[{"CoherenceOrder", ",", "SphericalRank"}], "}"}], ",", 
   "SphericalRank", ",", "\<\"Canonical\"\>"}], "}"}]], "Output",
 InitializationCell->True,
 CellChangeTimes->{{3.546524728326975*^9, 3.546524739464964*^9}, {
   3.562828905117732*^9, 3.562828917375229*^9}, 3.562897310268161*^9, 
   3.562897398687271*^9, {3.583425899858108*^9, 3.5834259125217247`*^9}, {
   3.583430955740369*^9, 3.583430963969981*^9}, {3.5834315000179853`*^9, 
   3.583431510257248*^9}, {3.699459013523198*^9, 3.699459019408615*^9}, 
   3.699459284073516*^9, {3.7454838353578987`*^9, 3.745483838516775*^9}},
 CellLabel->
  "Out[829]=",ExpressionUUID->"9ccf3773-a965-43ff-a137-f1725493f139"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BuiltinOperatorBasisQ", "[", 
    RowBox[{"SphericalTensorOperatorBasis", "[", "___", "]"}], "]"}], "=", 
   "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.468154615716969*^9, 3.4681546762734337`*^9}},
 CellLabel->
  "In[830]:=",ExpressionUUID->"bc92291a-3412-460c-8ae5-8e9b99bf4101"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefinedOperatorBasisQ", "[", 
    RowBox[{"SphericalTensorOperatorBasis", "[", "___", "]"}], "]"}], "=", 
   "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.433525076751453*^9, 3.434516477000907*^9},
 CellLabel->
  "In[831]:=",ExpressionUUID->"a670e8cb-bbd5-461b-883e-2dea10e9079c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensorOperatorBasis", "[", "opts___Rule", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"SphericalTensorOperatorBasis", "[", 
    RowBox[{
     RowBox[{"SpinSystem", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431062024816597*^9, 3.431062061525462*^9}, {
   3.431062211767852*^9, 3.431062222605216*^9}, {3.431064990910803*^9, 
   3.431065017790723*^9}, {3.4310651382614393`*^9, 3.431065140570182*^9}, {
   3.431068087828887*^9, 3.4310680911274*^9}, {3.433525079632502*^9, 
   3.433525081143784*^9}, {3.434516480032832*^9, 3.434516481808197*^9}, 
   3.4561624014821863`*^9},
 CellLabel->
  "In[832]:=",ExpressionUUID->"34037404-3c35-4dff-aa78-4e37e44eec7d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SphericalTensorOperatorBasis", "[", 
   RowBox[{"nspin_Integer", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"SphericalTensorOperatorBasis", "[", 
   RowBox[{
    RowBox[{"Range", "[", 
     RowBox[{"1", ",", "nspin"}], "]"}], ",", "opts"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486387704415118*^9, 3.486387710487081*^9}, {
  3.5319317300394783`*^9, 3.5319317318712873`*^9}, {3.531931772638824*^9, 
  3.5319317742314796`*^9}, {3.53193180727065*^9, 3.531931808670971*^9}, {
  3.5319318653263407`*^9, 3.531931895614526*^9}},
 CellLabel->
  "In[833]:=",ExpressionUUID->"58c06b24-cd13-47bb-8dc2-f1bcfcee5d71"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SphericalTensorOperatorBasis", "[", 
   RowBox[{"labels_List", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SphericalTensorOperatorBasis", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"#", ",", 
         RowBox[{"1", "/", "2"}]}], "}"}], "&"}], "/@", "labels"}], ",", 
     "opts"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"!", 
      RowBox[{"MatrixQ", "[", "labels", "]"}]}], ")"}], "&&", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"labels", ",", 
       RowBox[{"{", "}"}]}], "]"}]}]}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.43496998227287*^9, 3.434970003133623*^9}, {
  3.486387693256557*^9, 3.486387699623499*^9}, {3.531931734775353*^9, 
  3.531931737689125*^9}, {3.5319317757791033`*^9, 3.5319317770331287`*^9}, {
  3.53193181071211*^9, 3.531931811880478*^9}, {3.531931868240654*^9, 
  3.5319318986879883`*^9}},
 CellLabel->
  "In[834]:=",ExpressionUUID->"35217cdf-c509-4398-8e8c-e44c68240ba0"]
}, Closed]],

Cell[CellGroupData[{

Cell["Sorted", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.468155924375936*^9, 
  3.46815592824655*^9}},ExpressionUUID->"9811c307-e8e4-4296-ab18-\
5d57a3e2c97e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensorOperatorBasis", "[", 
    RowBox[{"spins_", "?", "MatrixQ"}], "]"}], ":=", 
   RowBox[{"SphericalTensorOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"Sorted", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"Sorted", "/.", 
        RowBox[{"Options", "[", "SphericalTensorOperatorBasis", "]"}]}], 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546519169830247*^9, 3.546519210221899*^9}, {
  3.546521941373549*^9, 3.546521944289716*^9}},
 CellLabel->
  "In[835]:=",ExpressionUUID->"f727dd70-0e56-4fc1-b3cd-9da6f3d560d7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensorOperatorBasis", "[", 
    RowBox[{
     RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SphericalTensorOperatorBasis", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{
        RowBox[{"Sorted", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"CoherenceOrder", ",", "SphericalRank"}], "}"}]}], ",", 
        "opts"}], "]"}]}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "SphericalTensorOperatorBasis", "]"}]}], ",", 
      RowBox[{
      "CoherenceOrder", "|", "SphericalRank", "|", "\"\<Canonical\>\"", "|", 
       "False", "|", "True"}]}], "\[IndentingNewLine]", "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.468155814827379*^9}, {
  3.468167947872768*^9, 3.468167952313285*^9}, {3.468168000037718*^9, 
  3.468168074910942*^9}, {3.546522192729951*^9, 3.546522208927643*^9}},
 CellLabel->
  "In[836]:=",ExpressionUUID->"9925e74b-e09b-485f-af3f-c55cd70686d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensorOperatorBasis", "[", 
    RowBox[{
     RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{
        RowBox[{"OperatorBasis", "::", "invalidsortopt"}], ",", 
        "SphericalTensorOperatorBasis", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"#", ",", 
            RowBox[{"FormatType", "\[Rule]", "InputForm"}]}], "]"}], "&"}], 
         "@", 
         RowBox[{
         "AllowedSortValues", "[", "SphericalTensorOperatorBasis", "]"}]}]}], 
       "]"}], ";", "$Failed"}], "\[IndentingNewLine]", ")"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MemberQ", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
       "AllowedSortValues", "[", "SphericalTensorOperatorBasis", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Sorted", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "SphericalTensorOperatorBasis", "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468155643690137*^9, 3.468155814827379*^9}, {
   3.468167947872768*^9, 3.468167952313285*^9}, {3.468168000037718*^9, 
   3.468168028156313*^9}, {3.468168100829176*^9, 3.468168101793277*^9}, {
   3.546522001186215*^9, 3.5465220073934383`*^9}, {3.546522225593034*^9, 
   3.546522228783011*^9}, 3.62161457572805*^9, {3.659536544139189*^9, 
   3.659536550987351*^9}, 3.6595470839346113`*^9, 3.65954732983676*^9},
 CellLabel->
  "In[837]:=",ExpressionUUID->"69fb7b3a-f445-4e89-8b94-cec635db6913"]
}, Closed]],

Cell[CellGroupData[{

Cell["CouplingSchemes", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434378086526754*^9, 3.4343781221537313`*^9}, 
   3.434379403097155*^9},ExpressionUUID->"22fc9097-6cfa-4016-afb3-\
3abe71d55b77"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CouplingSchemes", "[", 
   RowBox[{"spins_", "?", "MatrixQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Tuples", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"First", "@", "#"}], ",", "\[Lambda]"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\[Lambda]", ",", "0", ",", 
          RowBox[{"2", "*", 
           RowBox[{"Last", "[", "#", "]"}]}]}], "}"}]}], "]"}], "&"}], "/@", 
     "spins"}], "]"}], "//.", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a___", ",", 
       RowBox[{"{", 
        RowBox[{"j_", ",", "0"}], "}"}], ",", "b___"}], "}"}], 
     "\[RuleDelayed]", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b"}], "}"}]}], "\[IndentingNewLine]", 
    "}"}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434378220477325*^9, 3.434378244765746*^9}, {
   3.43437829637215*^9, 3.434378303469026*^9}, {3.434378414445092*^9, 
   3.4343786770273237`*^9}, {3.434378901553022*^9, 3.4343789291595173`*^9}, {
   3.4343789624081697`*^9, 3.434378963405089*^9}, {3.434379066683627*^9, 
   3.434379125514423*^9}, {3.434379177952951*^9, 3.434379178645883*^9}, {
   3.4343792152957067`*^9, 3.434379253614501*^9}, {3.434379337297278*^9, 
   3.434379366154298*^9}, 3.434479438576706*^9, {3.434480012338766*^9, 
   3.4344800220007963`*^9}, {3.434480097083851*^9, 3.434480128546184*^9}, {
   3.4345165624628067`*^9, 3.434516567358253*^9}},
 CellLabel->
  "In[838]:=",ExpressionUUID->"7045731f-ae59-4847-8c61-4f128ee0ee25"]
}, Closed]],

Cell[CellGroupData[{

Cell["CouplingHistories", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434378086526754*^9, 3.4343781221537313`*^9}, 
   3.434379403097155*^9, {3.4343795705006742`*^9, 
   3.4343795754803753`*^9}},ExpressionUUID->"1ecb26c3-96b0-454b-a954-\
48de08c8bcdd"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CouplingHistories", "[", 
   RowBox[{"{", "}"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"{", "0", "}"}], "}"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434467198840069*^9, 3.434467206289763*^9}},
 CellLabel->
  "In[839]:=",ExpressionUUID->"260c43f8-223b-47f7-a9b6-77953f78b14b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CouplingHistories", "[", 
   RowBox[{"scheme_", "?", "MatrixQ"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ranks", ",", "n", ",", "\[Lambda]table"}], "}"}], ",", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ranks", "=", 
       RowBox[{"Last", "/@", "scheme"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"n", "=", 
       RowBox[{"Length", "@", "ranks"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Lambda]table", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ToExpression", "[", 
          RowBox[{"\"\<\[Lambda]\>\"", "<>", 
           RowBox[{"ToString", "[", "i", "]"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "[", "ranks", "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{"#", ",", 
          RowBox[{"n", "-", "1"}]}], "]"}], "&"}], "@", "\[IndentingNewLine]", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Evaluate", "@", "\[Lambda]table"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"Apply", "[", 
           RowBox[{"Sequence", ",", "\[IndentingNewLine]", 
            RowBox[{"MapThread", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                 "#1", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}],
                  ",", 
                 RowBox[{"Abs", "[", 
                  RowBox[{
                   RowBox[{
                   "#1", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "-", "#2"}], "]"}], ",", 
                 RowBox[{"Abs", "[", 
                  RowBox[{
                   RowBox[{
                   "#1", "\[LeftDoubleBracket]", "1", 
                    "\[RightDoubleBracket]"}], "+", "#2"}], "]"}]}], "}"}], 
               "&"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Partition", "[", 
                 RowBox[{
                  RowBox[{"Prepend", "[", 
                   RowBox[{"\[Lambda]table", ",", "0"}], "]"}], ",", "2", ",",
                   "1"}], "]"}], ",", "ranks"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}]}],
      "\[IndentingNewLine]", ")"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434466981320249*^9, 3.4344671509825497`*^9}, {
  3.4344805441846724`*^9, 3.434480544797947*^9}},
 CellLabel->
  "In[840]:=",ExpressionUUID->"40ff3368-f2ef-4734-a589-d3ed4c24b6c2"]
}, Closed]],

Cell[CellGroupData[{

Cell["FullSphericalTensorOperatorSpecifications", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434378086526754*^9, 3.4343781221537313`*^9}, 
   3.434379403097155*^9, {3.4343795705006742`*^9, 3.4343795754803753`*^9}, {
   3.4345263945692453`*^9, 3.4345264026308727`*^9}, {3.4681699002632513`*^9, 
   3.468169913518124*^9}, 
   3.468170217073793*^9},ExpressionUUID->"f986fc01-7f48-491b-b70e-\
53fea46aa0e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"FullSphericalTensorOperatorSpecifications", "[", 
   RowBox[{"spins", ":", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Map", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{"spec", ",", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[Lambda]", "=", 
           RowBox[{"Last", "@", 
            RowBox[{
            "spec", "\[LeftDoubleBracket]", "2", 
             "\[RightDoubleBracket]"}]}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\[Lambda]", ",", "\[Mu]", ",", "spec"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"\[Mu]", ",", "\[Lambda]", ",", 
              RowBox[{"-", "\[Lambda]"}], ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
         ")"}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"FullCouplingSpecifications", "[", "spins", "]"}]}], 
     "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "1"}], 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468169924018097*^9, 3.468170002981455*^9}, {
  3.468170054155294*^9, 3.468170112054851*^9}},
 CellLabel->
  "In[841]:=",ExpressionUUID->"9c94deb7-3934-430d-bff9-d8d3f6a5a805"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FullCouplingSpecifications", "[", 
    RowBox[{"spins", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"schemes", ",", "histories"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"schemes", "=", 
        RowBox[{"CouplingSchemes", "[", "spins", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"histories", "=", 
        RowBox[{"CouplingHistories", "/@", "schemes"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MapThread", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Function", "[", 
               RowBox[{"h", ",", 
                RowBox[{"{", 
                 RowBox[{"#1", ",", "h"}], "}"}]}], "]"}], "/@", "#2"}], 
             ")"}], "&"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"schemes", ",", "histories"}], "}"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "1"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.43452641237857*^9, 3.4345264846145887`*^9}},
 CellLabel->
  "In[842]:=",ExpressionUUID->"0b73c7ec-51ac-4b7f-81a9-40152bddc53d"]
}, Closed]],

Cell[CellGroupData[{

Cell["BasisOperators (includes set up for SphericalTensorIndices)", \
"Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4345389343764267`*^9, 3.434538947147695*^9}, {
   3.434539028625444*^9, 3.434539033139813*^9}, 3.639286464822954*^9, {
   3.6392902054717417`*^9, 
   3.639290214783779*^9}},ExpressionUUID->"133948b7-8079-4a12-8a83-\
c1d540c0f413"],

Cell["\<\
save normalized operators and also lists of SphericalTensorIndices\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.639286389167408*^9, 3.639286405805744*^9}, {
  3.6392869560996933`*^9, 
  3.6392869566315107`*^9}},ExpressionUUID->"71ceae05-0b77-419d-8908-\
5c9677e2da47"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BasisOperators", "[", 
   RowBox[{
    RowBox[{"SphericalTensorOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins_", "?", "MatrixQ"}], ",", "opts___Rule"}], "]"}], ",", 
    "basisopts__Rule"}], "]"}], ":=", 
  RowBox[{"BasisOperators", "[", 
   RowBox[{"SphericalTensorOperatorBasis", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"basisopts", ",", "opts"}], "]"}]}], "]"}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.459444309508959*^9, 3.459444402896358*^9}, {
  3.4681681841393557`*^9, 3.468168190003601*^9}, {3.639287919715106*^9, 
  3.639287922333829*^9}},
 CellLabel->
  "In[843]:=",ExpressionUUID->"dcf9fd8a-160e-4374-8a57-af5a5188213c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisOperators", "[", 
    RowBox[{"SphericalTensorOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BasisOperators", "[", 
     RowBox[{"SphericalTensorOperatorBasis", "[", 
      RowBox[{"spins", ",", "opts"}], "]"}], "]"}], "=", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Simplify", "[", 
       RowBox[{"(", 
        RowBox[{"#", "/", 
         RowBox[{"OperatorNorm", "[", "#", "]"}]}], ")"}], "]"}], "&"}], "/@",
      "\[IndentingNewLine]", 
     RowBox[{"UnNormalizedBasisOperators", "[", 
      RowBox[{"SphericalTensorOperatorBasis", "[", 
       RowBox[{"spins", ",", "opts"}], "]"}], "]"}]}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310677050008383`*^9, 3.431067743165999*^9}, {
   3.433525137332799*^9, 3.433525164438301*^9}, {3.433525272178706*^9, 
   3.433525310722043*^9}, {3.434516626700858*^9, 3.434516679966545*^9}, {
   3.434517021438301*^9, 3.4345170471067133`*^9}, {3.434517115177635*^9, 
   3.4345171329403553`*^9}, {3.434517163908649*^9, 3.4345171732282677`*^9}, {
   3.434517226524723*^9, 3.434517230508614*^9}, {3.434517362518773*^9, 
   3.434517365659526*^9}, {3.434517475910326*^9, 3.434517477620759*^9}, {
   3.434517599893483*^9, 3.43451762366012*^9}, {3.434517685959073*^9, 
   3.434517687052375*^9}, {3.4345184295914793`*^9, 3.434518435700356*^9}, {
   3.4345189890425167`*^9, 3.434519024044541*^9}, {3.434519629055532*^9, 
   3.434519631670301*^9}, {3.43452633544361*^9, 3.4345263645104218`*^9}, {
   3.4345265109304953`*^9, 3.434526546492916*^9}, {3.434531122985133*^9, 
   3.434531147565674*^9}, {3.434532082676467*^9, 3.4345320860862513`*^9}, 
   3.434532441997849*^9, {3.434533519722451*^9, 3.434533572509225*^9}, {
   3.4345336703077793`*^9, 3.434533675484918*^9}, {3.4345370810414352`*^9, 
   3.434537084080826*^9}, {3.434537445990568*^9, 3.434537460480571*^9}, {
   3.434537628418325*^9, 3.434537628734702*^9}, {3.434537871830044*^9, 
   3.434537878246716*^9}, 3.43453792265772*^9, {3.434538235037848*^9, 
   3.434538240430913*^9}, {3.43453832763872*^9, 3.434538335769423*^9}, 
   3.434538383987835*^9, {3.434538527949147*^9, 3.434538529839922*^9}, {
   3.435255498322411*^9, 3.435255503091352*^9}, {3.4594439202164383`*^9, 
   3.459443944004428*^9}, {3.46816886785643*^9, 3.468168953916654*^9}, {
   3.468169139825222*^9, 3.468169140285244*^9}, {3.4681691912164583`*^9, 
   3.468169246434915*^9}, {3.468169290231594*^9, 3.46816929347082*^9}, {
   3.468169374084012*^9, 3.468169376932094*^9}, {3.639287913878305*^9, 
   3.639287917251067*^9}},
 CellLabel->
  "In[844]:=",ExpressionUUID->"71b5ed72-4b51-4125-9fc7-4279ff07e34d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UnNormalizedBasisOperators", "[", 
    RowBox[{"stob", ":", 
     RowBox[{"SphericalTensorOperatorBasis", "[", 
      RowBox[{
       RowBox[{"spins", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "fullspeclist", "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"fullspeclist", "=", 
         RowBox[{"SortBy", "[", 
          RowBox[{
           RowBox[{
           "FullSphericalTensorOperatorSpecifications", "[", "spins", "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
               ")"}], "&"}], ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
               ")"}], "&"}]}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SphericalTensorIndices", "[", "stob", "]"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
             "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
             RowBox[{
             "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
            "}"}], "&"}], "/@", "fullspeclist"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Map", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"fullspec", ",", "\[IndentingNewLine]", 
            RowBox[{"Module", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"\[Lambda]", ",", "\[Mu]", ",", "spec"}], "}"}], ",", 
              RowBox[{"(", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"\[Lambda]", ",", "\[Mu]", ",", "spec"}], "}"}], 
                 "=", "fullspec"}], ";", "\[IndentingNewLine]", 
                RowBox[{"Simplify", "@", 
                 RowBox[{"opT", "[", 
                  RowBox[{
                   RowBox[{"First", "@", "spec"}], ",", 
                   RowBox[{"Last", "@", "spec"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"\[Lambda]", ",", "\[Mu]"}], "}"}]}], "]"}]}]}], 
               "\[IndentingNewLine]", ")"}]}], "]"}]}], "\[IndentingNewLine]",
            "]"}], ",", "\[IndentingNewLine]", "fullspeclist"}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
     "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "SphericalTensorOperatorBasis", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"SphericalRank", ",", "CoherenceOrder"}], "}"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434533318116521*^9, 3.434533318977111*^9}, {
   3.434533368263129*^9, 3.4345334947146187`*^9}, {3.4345336807749434`*^9, 
   3.434533683574885*^9}, {3.434537057453609*^9, 3.434537060434857*^9}, {
   3.434537405213717*^9, 3.4345374271347103`*^9}, {3.434537531940248*^9, 
   3.4345375322011414`*^9}, {3.459443864639344*^9, 3.459443902133271*^9}, {
   3.4681682011713667`*^9, 3.468168260218951*^9}, {3.468168406327269*^9, 
   3.468168498058482*^9}, {3.468169238824918*^9, 3.468169267110828*^9}, 
   3.46816936570395*^9, {3.4681695583310957`*^9, 3.46816956222478*^9}, {
   3.468170245212031*^9, 3.4681703381201477`*^9}, {3.468170376930892*^9, 
   3.468170495195003*^9}, {3.468170712582636*^9, 3.468170795217935*^9}, {
   3.468170872225441*^9, 3.46817097114948*^9}, 3.468171144968623*^9, 
   3.546533446434987*^9, 3.639229555891374*^9, 3.639229956651042*^9, {
   3.6392866951556463`*^9, 3.63928683367006*^9}, 3.6392869161908484`*^9},
 CellLabel->
  "In[845]:=",ExpressionUUID->"8f18c08a-6fa0-45fa-a5af-494fd38e0b4b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UnNormalizedBasisOperators", "[", 
    RowBox[{"stob", ":", 
     RowBox[{"SphericalTensorOperatorBasis", "[", 
      RowBox[{
       RowBox[{"spins", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
       "opts___Rule"}], "]"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "fullspeclist", "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"fullspeclist", "=", 
         RowBox[{"SortBy", "[", 
          RowBox[{
           RowBox[{
           "FullSphericalTensorOperatorSpecifications", "[", "spins", "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}], 
               ")"}], "&"}], ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
               "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
               ")"}], "&"}]}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SphericalTensorIndices", "[", "stob", "]"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
             "#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], ",", 
             RowBox[{
             "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
            "}"}], "&"}], "/@", "fullspeclist"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Map", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"fullspec", ",", "\[IndentingNewLine]", 
            RowBox[{"Module", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"\[Lambda]", ",", "\[Mu]", ",", "spec"}], "}"}], ",", 
              RowBox[{"(", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"\[Lambda]", ",", "\[Mu]", ",", "spec"}], "}"}], 
                 "=", "fullspec"}], ";", "\[IndentingNewLine]", 
                RowBox[{"Simplify", "@", 
                 RowBox[{"opT", "[", 
                  RowBox[{
                   RowBox[{"First", "@", "spec"}], ",", 
                   RowBox[{"Last", "@", "spec"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"\[Lambda]", ",", "\[Mu]"}], "}"}]}], "]"}]}]}], 
               "\[IndentingNewLine]", ")"}]}], "]"}]}], "\[IndentingNewLine]",
            "]"}], ",", "\[IndentingNewLine]", "fullspeclist"}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
     "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Sorted", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "SphericalTensorOperatorBasis", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"CoherenceOrder", ",", "SphericalRank"}], "}"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.434533318116521*^9, 3.434533318977111*^9}, {
   3.434533368263129*^9, 3.4345334947146187`*^9}, {3.4345336807749434`*^9, 
   3.434533683574885*^9}, {3.434537057453609*^9, 3.434537060434857*^9}, {
   3.434537405213717*^9, 3.4345374271347103`*^9}, {3.434537531940248*^9, 
   3.4345375322011414`*^9}, {3.459443864639344*^9, 3.459443902133271*^9}, {
   3.4681682011713667`*^9, 3.468168260218951*^9}, {3.468168406327269*^9, 
   3.468168498058482*^9}, {3.468169238824918*^9, 3.468169267110828*^9}, 
   3.46816936570395*^9, {3.4681695583310957`*^9, 3.46816956222478*^9}, {
   3.468170245212031*^9, 3.4681703381201477`*^9}, {3.468170376930892*^9, 
   3.468170517576929*^9}, {3.468171005295722*^9, 3.468171018790699*^9}, 
   3.4681711475273867`*^9, 3.546533450108687*^9, {3.63922955013381*^9, 
   3.639229551051005*^9}, 3.639229958968005*^9, {3.639286838525836*^9, 
   3.639286908963472*^9}},
 CellLabel->
  "In[846]:=",ExpressionUUID->"b374e39f-5138-4b5c-a7fe-14b59a68e3c3"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 
  3.468059115613844*^9}},ExpressionUUID->"6955475a-02c5-4f65-aff3-\
2caccd0bb6b0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinSystem", "[", "\[IndentingNewLine]", 
    RowBox[{"SphericalTensorOperatorBasis", "[", 
     RowBox[{
      RowBox[{"spins", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
      "opts___Rule"}], "]"}], "\[IndentingNewLine]", "]"}], "^:=", "spins"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468059125578073*^9, 3.4680592180011387`*^9}},
 CellLabel->
  "In[847]:=",ExpressionUUID->"2ba842aa-77fc-4aa9-863b-800373cc8367"]
}, Closed]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["OperatorBasisTransformationMatrix", "Subchapter",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.431059892057632*^9},ExpressionUUID->"a46bf389-3a31-4396-8153-\
9be07d056978"],

Cell[CellGroupData[{

Cell["general", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.699624349225667*^9, 3.699624358585023*^9}, {
   3.6996382813993607`*^9, 
   3.69963828234944*^9}},ExpressionUUID->"25cf4f0e-5538-49f0-b757-\
a9d6de299660"],

Cell[CellGroupData[{

Cell["Options", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
  3.545905476009678*^9, 3.545905527443429*^9}, {3.546522452276318*^9, 
  3.54652245613142*^9}, {3.6996382883506203`*^9, 
  3.699638289404904*^9}},ExpressionUUID->"cf936910-f42f-4225-ae4f-\
233ca0f759bc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "OperatorBasisTransformationMatrix", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Verbose", "\[Rule]", "False"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699638291621711*^9, 3.699638302636797*^9}},
 CellLabel->
  "In[848]:=",ExpressionUUID->"364eb77c-4ec5-4838-aa0f-2c7727e33294"]
}, Closed]],

Cell[CellGroupData[{

Cell["trap undefined operator bases", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
  3.545905476009678*^9, 3.545905527443429*^9}, {3.546522452276318*^9, 
  3.54652245613142*^9}, {3.6996418014310513`*^9, 
  3.699641809133671*^9}},ExpressionUUID->"3e377441-c7f4-44ce-a121-\
0c8acf68bc86"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasisTransformationMatrix", "[", 
     RowBox[{"opbasis2_", ",", "opbasis1_", ",", "___"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"DefinedOperatorBasisQ", "[", "opbasis2", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"OperatorBasisTransformationMatrix", "::", "undefopb"}], ",", 
       "opbasis2"}], "]"}], ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6996418155346127`*^9, 3.699641853965242*^9}},
 CellLabel->
  "In[849]:=",ExpressionUUID->"913b669e-bf0d-43dd-b2fe-905450dd414b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasisTransformationMatrix", "[", 
     RowBox[{"opbasis2_", ",", "opbasis1_", ",", "___"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"DefinedOperatorBasisQ", "[", "opbasis1", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"OperatorBasisTransformationMatrix", "::", "undefopb"}], ",", 
       "opbasis1"}], "]"}], ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6996418155346127`*^9, 3.699641864003997*^9}},
 CellLabel->
  "In[850]:=",ExpressionUUID->"ecf2b83f-0fb5-4322-8368-68b4760d868b"]
}, Closed]],

Cell[CellGroupData[{

Cell["ensure spin systems match", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
  3.545905476009678*^9, 3.545905527443429*^9}, {3.546522452276318*^9, 
  3.54652245613142*^9}},ExpressionUUID->"0e28a598-b647-4419-a5f0-\
4b3f2dd4f9cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasisTransformationMatrix", "[", 
     RowBox[{"opbasis2_", ",", "opbasis1_", ",", "___"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"SpinSystem", "[", "opbasis2", "]"}], "\[Equal]", 
       RowBox[{"SpinSystem", "[", "opbasis1", "]"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasisTransformationMatrix", "::", "badspinsys"}], 
      "]"}], ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5465224698389597`*^9, 3.546522547057797*^9}, {
  3.546522592644186*^9, 3.546522592983973*^9}, {3.5465276811817083`*^9, 
  3.5465276835589542`*^9}, {3.546528116075563*^9, 3.546528116586928*^9}},
 CellLabel->
  "In[851]:=",ExpressionUUID->"897f3fc7-b4f0-46ce-aca4-900e110ce0d9"]
}, Closed]],

Cell[CellGroupData[{

Cell["default to ZeemanBasis", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.535371192708909*^9, 3.5353712056766376`*^9}, {
  3.546522336016987*^9, 
  3.546522336382114*^9}},ExpressionUUID->"e5667dac-4b27-411a-9857-\
5724e80b2388"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasisTransformationMatrix", "[", 
    RowBox[{"opbasis2_", ",", "opbasis1_", ",", "opts___Rule"}], "]"}], ":=", 
   
   RowBox[{"OperatorBasisTransformationMatrix", "[", 
    RowBox[{"opbasis2", ",", "opbasis1", ",", 
     RowBox[{"ZeemanBasis", "[", 
      RowBox[{"SpinSystem", "[", "opbasis2", "]"}], "]"}], ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310688402972383`*^9, 3.431068870287149*^9}, 
   3.456162898859923*^9, {3.50241540683878*^9, 3.502415407780038*^9}, {
   3.5465280916859627`*^9, 3.5465280978212*^9}, {3.699638317654451*^9, 
   3.699638328812414*^9}},
 CellLabel->
  "In[852]:=",ExpressionUUID->"cd76d7b7-1aa3-4e56-ae13-49a3969606b6"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["special cases", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.699624349225667*^9, 3.699624358585023*^9}, {
   3.699638013664709*^9, 
   3.699638016384004*^9}},ExpressionUUID->"039ee73b-0772-456e-85b9-\
1f0b15b084f6"],

Cell[CellGroupData[{

Cell["case of identical operator bases", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
  3.545905476009678*^9, 3.545905527443429*^9}, {3.546522607543337*^9, 
  3.546522607909149*^9}, {3.699637842160911*^9, 
  3.699637847391698*^9}},ExpressionUUID->"fd4b17bc-3c47-459a-b049-\
71ebeb57e497"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasisTransformationMatrix", "[", 
     RowBox[{
     "opbasis2_", ",", "opbasis1_", ",", "basis_", ",", "opts___Rule"}], 
     "]"}], "/;", 
    RowBox[{"OperatorBasesMatchQ", "[", 
     RowBox[{"opbasis2", ",", "opbasis1"}], "]"}]}], ":=", 
   RowBox[{"SparseArray", "@", 
    RowBox[{"DiagonalMatrix", "[", 
     RowBox[{"Table", "[", 
      RowBox[{"1", ",", 
       RowBox[{"{", 
        RowBox[{"OperatorBasisDimension", "[", "opbasis1", "]"}], "}"}]}], 
      "]"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699637852760068*^9, 3.699637929083272*^9}, {
  3.69963833740582*^9, 3.699638340395157*^9}},
 CellLabel->
  "In[853]:=",ExpressionUUID->"3ecd50bf-fc0a-4d4d-92c2-282246a51541"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
take inverse of transformation matrix for the opposite transformation, if the \
bases are not in canonical order\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
  3.545905476009678*^9, 3.545905527443429*^9}, {3.546522607543337*^9, 
  3.546522607909149*^9}},ExpressionUUID->"6f35b40d-4e6e-425d-8595-\
2c05156e5120"],

Cell["\<\
all transformation matrices are unitary, so the inverse is the \
ConjugateTranspose\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.545905529292218*^9, 3.5459055395720797`*^9}, {
  3.545905679296007*^9, 
  3.545905688749537*^9}},ExpressionUUID->"6ff1bc4d-afd7-45bc-a968-\
db2576260758"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasisTransformationMatrix", "[", 
     RowBox[{
     "opbasis1_", ",", "opbasis2_", ",", "basis_", ",", "opts___Rule"}], 
     "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"OperatorBasesOrderedQ", "[", 
      RowBox[{"{", 
       RowBox[{"opbasis1", ",", "opbasis2"}], "}"}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Verbose", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "OperatorBasisTransformationMatrix", "]"}]}], 
       ",", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<transposing order:\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"opbasis2", ",", "opbasis1"}], "}"}]}], "]"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Adjoint", "[", 
      RowBox[{"OperatorBasisTransformationMatrix", "[", 
       RowBox[{"opbasis2", ",", "opbasis1", ",", "basis", ",", "opts"}], 
       "]"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502427446253314*^9, 3.502427605615406*^9}, {
   3.545905545684466*^9, 3.545905585942316*^9}, {3.545905760361858*^9, 
   3.545905792541168*^9}, {3.54644756620695*^9, 3.546447590089662*^9}, {
   3.5464485148113003`*^9, 3.546448529194621*^9}, {3.546522375974517*^9, 
   3.5465224005445013`*^9}, {3.63888457045863*^9, 3.638884587694688*^9}, {
   3.63888462439425*^9, 3.6388846926861773`*^9}, {3.638885162108712*^9, 
   3.6388851655624866`*^9}, {3.657821337784349*^9, 3.657821341694412*^9}, 
   3.6595258322778997`*^9, 3.659525940328557*^9, {3.699637957913537*^9, 
   3.699637966037797*^9}, {3.6996383475092793`*^9, 3.699638357603319*^9}, {
   3.699638943244707*^9, 3.699638973152948*^9}},
 CellLabel->
  "In[854]:=",ExpressionUUID->"1cbd7b79-f1ad-40cc-8060-419cc0501770"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
transformations between two operator bases which differ only in the sort order\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
   3.535371217630563*^9, 3.535371247926633*^9}, {3.546422852046973*^9, 
   3.546422859900371*^9}, 
   3.546447438435734*^9},ExpressionUUID->"b81d633a-e900-416b-892c-\
e4bdb5d0d97a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"opbasis2", ":", 
      RowBox[{"type_", "[", "___", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"opbasis1", ":", 
      RowBox[{"type_", "[", "___", "]"}]}], ",", "\[IndentingNewLine]", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Verbose", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "OperatorBasisTransformationMatrix", "]"}]}], 
       ",", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<using reordering of basis operators:\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"opbasis2", ",", "opbasis1"}], "}"}]}], "]"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"PrependTo", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DownValues", "[", "OperatorBasisTransformationMatrix", "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"OperatorBasisTransformationMatrix", "[", 
         RowBox[{"opbasis2", ",", "opbasis1", ",", "basis", ",", "___Rule"}], 
         "]"}], "\[Rule]", "\[IndentingNewLine]", 
        RowBox[{"SparseArray", "@", 
         RowBox[{"ReplacePart", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"DiagonalMatrix", "[", 
            RowBox[{"Table", "[", 
             RowBox[{"0", ",", 
              RowBox[{"{", 
               RowBox[{"OperatorBasisDimension", "[", "opbasis1", "]"}], 
               "}"}]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Inner", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"#1", ",", "#2"}], "}"}], "\[Rule]", "1"}], ")"}], 
              "&"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Ordering", "@", 
              RowBox[{"BasisOperators", "[", "opbasis2", "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Ordering", "@", 
              RowBox[{"BasisOperators", "[", "opbasis1", "]"}]}], ",", 
             "\[IndentingNewLine]", "List"}], "\[IndentingNewLine]", "]"}]}], 
          "\[IndentingNewLine]", "]"}]}]}]}], "\[IndentingNewLine]", "]"}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"OperatorBasisTransformationMatrix", "[", 
      RowBox[{"opbasis2", ",", "opbasis1", ",", "basis"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429872319609107*^9, 3.42987235415386*^9}, {
   3.429874163980884*^9, 3.429874328545232*^9}, {3.431059654161275*^9, 
   3.4310596590552464`*^9}, 3.4310605050594893`*^9, {3.4310687132223873`*^9, 
   3.4310687155147257`*^9}, {3.431068826098715*^9, 3.4310688271710167`*^9}, {
   3.4526682800699797`*^9, 3.452668287453724*^9}, {3.5464226999866247`*^9, 
   3.546422753326839*^9}, {3.546422807816045*^9, 3.546422830228766*^9}, {
   3.546441632288986*^9, 3.546441635078888*^9}, {3.546446005786294*^9, 
   3.5464460553207293`*^9}, {3.5464461114248343`*^9, 
   3.5464461265638943`*^9}, {3.5464461688144693`*^9, 3.546446171213233*^9}, {
   3.5465224234486427`*^9, 3.546522428455689*^9}, {3.62911875287223*^9, 
   3.629118759411406*^9}, {3.629119126809082*^9, 3.62911913088424*^9}, {
   3.699638367628528*^9, 3.6996383679562197`*^9}, {3.699638409508663*^9, 
   3.6996384126744633`*^9}, {3.699638911360476*^9, 3.699638956695265*^9}, 
   3.699639676823647*^9, {3.6996398188761053`*^9, 3.699639819393238*^9}, {
   3.6996398713738937`*^9, 3.699639873980007*^9}, {3.6996402509100943`*^9, 
   3.699640272122411*^9}, {3.699640358609089*^9, 3.699640359510026*^9}, {
   3.699640412926306*^9, 3.699640421556595*^9}, 3.7257382271424203`*^9},
 CellLabel->
  "In[855]:=",ExpressionUUID->"393a1af3-96b4-4601-825b-c8a7e3361316"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
for multiple-spin operator bases, go through Sorted\[Rule]\
\[CloseCurlyDoubleQuote]OrderBySpin\[CloseCurlyDoubleQuote] bases.\
\>", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.699624349225667*^9, 3.6996243959917192`*^9}, {
   3.6996419495609417`*^9, 3.699641955094411*^9}, 3.699677147477998*^9, {
   3.699677651987862*^9, 
   3.6996776675001707`*^9}},ExpressionUUID->"e0c88c39-353e-46c3-b564-\
eaadc68fbcb2"],

Cell[CellGroupData[{

Cell["\<\
go through Sorted\[Rule]\[CloseCurlyDoubleQuote]OrderBySpin\
\[CloseCurlyDoubleQuote] if both operator bases allow this\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
  3.535371217630563*^9, 3.535371247926633*^9}, {3.545903734254499*^9, 
  3.545903737981646*^9}, {3.546522644563326*^9, 3.5465227100348663`*^9}, {
  3.5465232888299217`*^9, 3.5465233062908697`*^9}, {3.629118526392069*^9, 
  3.629118527382176*^9}, {3.638887688439198*^9, 
  3.638887734650709*^9}},ExpressionUUID->"17cd42e1-aeee-4aea-9e11-\
4ae747f70e5e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"opbasis2", ":", 
       RowBox[{"type2_", "[", 
        RowBox[{
         RowBox[{"stuff2", ":", 
          RowBox[{
           RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
         "opb2opts___Rule"}], "]"}]}], ",", 
      RowBox[{"opbasis1", ":", 
       RowBox[{"type1_", "[", 
        RowBox[{
         RowBox[{"stuff1", ":", 
          RowBox[{
           RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
         "opb1opts___Rule"}], "]"}]}], ",", "\[IndentingNewLine]", "basis_", 
      ",", "opts___Rule"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{
     RowBox[{"MemberQ", "[", 
      RowBox[{
       RowBox[{"AllowedSortValues", "[", "opbasis2", "]"}], ",", 
       "\"\<OrderBySpin\>\""}], "]"}], "&&", "\[IndentingNewLine]", 
     RowBox[{"MemberQ", "[", 
      RowBox[{
       RowBox[{"AllowedSortValues", "[", "opbasis1", "]"}], ",", 
       "\"\<OrderBySpin\>\""}], "]"}], "&&", 
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"MatchQ", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Sorted", "/.", 
           RowBox[{"{", "opb2opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "type2", "]"}]}], ",", 
         "\"\<OrderBySpin\>\""}], "]"}]}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", "[", 
        RowBox[{"SpinSystem", "[", "opbasis2", "]"}], "]"}], ">", "1"}], 
      ")"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "iopbasis", ",", "orderopbasis2", ",", "orderiopbasis", ",", "perm"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Verbose", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "OperatorBasisTransformationMatrix", "]"}]}], ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<setting up OrderBySpin (1):\>\"", ",", 
           RowBox[{"{", 
            RowBox[{"opbasis2", ",", "opbasis1"}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"iopbasis", "=", "\[IndentingNewLine]", 
        RowBox[{"type2", "[", 
         RowBox[{"stuff2", ",", "\[IndentingNewLine]", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"Sorted", "\[Rule]", "\"\<OrderBySpin\>\""}], ",", 
            "opb2opts"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"orderopbasis2", "=", 
        RowBox[{"Ordering", "[", 
         RowBox[{"BasisOperators", "[", "opbasis2", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"orderiopbasis", "=", 
        RowBox[{"Ordering", "[", 
         RowBox[{"BasisOperators", "[", "iopbasis", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"perm", "=", 
        RowBox[{"orderiopbasis", "\[LeftDoubleBracket]", 
         RowBox[{"InversePermutation", "[", "orderopbasis2", "]"}], 
         "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"PrependTo", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "DownValues", "[", "OperatorBasisTransformationMatrix", "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"OperatorBasisTransformationMatrix", "[", 
           RowBox[{
           "opbasis2", ",", "opbasis1", ",", "basis", ",", "___Rule"}], "]"}],
           "\[Rule]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"OperatorBasisTransformationMatrix", "[", 
            RowBox[{"iopbasis", ",", "opbasis1", ",", "basis", ",", "opts"}], 
            "]"}], "\[LeftDoubleBracket]", "perm", 
           "\[RightDoubleBracket]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"OperatorBasisTransformationMatrix", "[", 
        RowBox[{"opbasis2", ",", "opbasis1", ",", "basis"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546522738099677*^9, 3.54652280507486*^9}, {
   3.54652299341475*^9, 3.5465232506468573`*^9}, {3.5465234750157146`*^9, 
   3.546523492323884*^9}, {3.546532138935404*^9, 3.546532139112032*^9}, {
   3.54729771866474*^9, 3.547297721685399*^9}, {3.547298790045372*^9, 
   3.547298802588188*^9}, {3.62911874314255*^9, 3.6291187447168694`*^9}, 
   3.629119144667239*^9, {3.6388861482603207`*^9, 3.6388861542874117`*^9}, {
   3.699638429875489*^9, 3.699638447554625*^9}, {3.699638889044352*^9, 
   3.699638898263768*^9}, {3.699640464469482*^9, 3.699640483138154*^9}, {
   3.699677362463936*^9, 3.6996773704567423`*^9}, {3.699677411084475*^9, 
   3.6996774284027357`*^9}, {3.725618472342537*^9, 3.725618500750705*^9}, {
   3.725737348031052*^9, 3.725737353754286*^9}, {3.7257374215231357`*^9, 
   3.725737425604834*^9}, {3.725737485242607*^9, 3.7257374874263625`*^9}, 
   3.725737685197833*^9, {3.7257395888905*^9, 3.725739728552652*^9}, 
   3.7257397851078777`*^9, {3.7257399014050074`*^9, 3.7257399038350277`*^9}, 
   3.7257399831393766`*^9, {3.725740591570427*^9, 3.7257406923806467`*^9}, {
   3.7257412936819077`*^9, 3.725741307133647*^9}, {3.7257418373819666`*^9, 
   3.725741839722124*^9}, {3.7258219110090523`*^9, 3.7258219825448046`*^9}},
 CellLabel->
  "In[856]:=",ExpressionUUID->"87d90aa0-e6cb-4189-a815-3f153092131b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"opbasis2", ":", 
       RowBox[{"type2_", "[", 
        RowBox[{
         RowBox[{"stuff2", ":", 
          RowBox[{
           RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
         "opb2opts___Rule"}], "]"}]}], ",", 
      RowBox[{"opbasis1", ":", 
       RowBox[{"type1_", "[", 
        RowBox[{
         RowBox[{"stuff1", ":", 
          RowBox[{
           RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
         "opb1opts___Rule"}], "]"}]}], ",", "\[IndentingNewLine]", "basis_", 
      ",", "opts___Rule"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{
     RowBox[{"MemberQ", "[", 
      RowBox[{
       RowBox[{"AllowedSortValues", "[", "opbasis2", "]"}], ",", 
       "\"\<OrderBySpin\>\""}], "]"}], "&&", 
     RowBox[{"MemberQ", "[", 
      RowBox[{
       RowBox[{"AllowedSortValues", "[", "opbasis1", "]"}], ",", 
       "\"\<OrderBySpin\>\""}], "]"}], "&&", 
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"MatchQ", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Sorted", "/.", 
           RowBox[{"{", "opb1opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "type1", "]"}]}], ",", 
         "\"\<OrderBySpin\>\""}], "]"}]}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", "[", 
        RowBox[{"SpinSystem", "[", "opbasis1", "]"}], "]"}], ">", "1"}], 
      ")"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "iopbasis", ",", "orderopbasis1", ",", "orderiopbasis", ",", "perm"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Verbose", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "OperatorBasisTransformationMatrix", "]"}]}], ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<setting up OrderBySpin (2):\>\"", ",", 
           RowBox[{"{", 
            RowBox[{"opbasis2", ",", "opbasis1"}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"iopbasis", "=", "\[IndentingNewLine]", 
        RowBox[{"type1", "[", 
         RowBox[{"stuff1", ",", "\[IndentingNewLine]", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"Sorted", "\[Rule]", "\"\<OrderBySpin\>\""}], ",", 
            "opb1opts"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"orderopbasis1", "=", 
        RowBox[{"Ordering", "[", 
         RowBox[{"BasisOperators", "[", "opbasis1", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"orderiopbasis", "=", 
        RowBox[{"Ordering", "[", 
         RowBox[{"BasisOperators", "[", "iopbasis", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"perm", "=", 
        RowBox[{"orderiopbasis", "\[LeftDoubleBracket]", 
         RowBox[{"InversePermutation", "[", "orderopbasis1", "]"}], 
         "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"PrependTo", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "DownValues", "[", "OperatorBasisTransformationMatrix", "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"OperatorBasisTransformationMatrix", "[", 
           RowBox[{
           "opbasis2", ",", "opbasis1", ",", "basis", ",", "___Rule"}], "]"}],
           "\[Rule]", "\[IndentingNewLine]", 
          RowBox[{"Chop", "[", 
           RowBox[{
            RowBox[{"OperatorBasisTransformationMatrix", "[", 
             RowBox[{"opbasis2", ",", "iopbasis", ",", "basis", ",", "opts"}],
              "]"}], "\[LeftDoubleBracket]", 
            RowBox[{"All", ",", "perm"}], "\[RightDoubleBracket]"}], 
           "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"OperatorBasisTransformationMatrix", "[", 
        RowBox[{"opbasis2", ",", "opbasis1", ",", "basis"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546522738099677*^9, 3.54652280507486*^9}, {
   3.54652299341475*^9, 3.5465232506468573`*^9}, {3.546523321154127*^9, 
   3.546523343731605*^9}, {3.54652349722974*^9, 3.546523498308791*^9}, {
   3.5465321446265993`*^9, 3.546532144782825*^9}, {3.547297724341201*^9, 
   3.547297727213019*^9}, {3.547298791047287*^9, 3.5472987975556602`*^9}, {
   3.6291187233514423`*^9, 3.629118735135715*^9}, 3.629119156522273*^9, 
   3.6388861704242563`*^9, {3.699638457387598*^9, 3.6996384736105633`*^9}, {
   3.6996388478017197`*^9, 3.6996388834866323`*^9}, {3.699640491789503*^9, 
   3.699640512496277*^9}, {3.699677444501707*^9, 3.699677448114605*^9}, {
   3.7257405959795713`*^9, 3.725740620858777*^9}, {3.725740754548647*^9, 
   3.725740782168928*^9}, 3.725740992670294*^9, {3.725741131836161*^9, 
   3.7257411325973806`*^9}, {3.72574117396698*^9, 3.725741176304256*^9}},
 CellLabel->
  "In[857]:=",ExpressionUUID->"944b66e1-b0ee-4199-8c93-abd03687d73c"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
if both bases are Sorted\[Rule]\[CloseCurlyDoubleQuote]OrderBySpin\
\[CloseCurlyDoubleQuote], compose the OperatorBasisTransformationMatrix from \
the direct product of the individual spin transformations\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
  3.535371217630563*^9, 3.535371247926633*^9}, {3.545903734254499*^9, 
  3.545903737981646*^9}, {3.546522644563326*^9, 3.5465227100348663`*^9}, {
  3.5465232888299217`*^9, 3.5465233062908697`*^9}, {3.5465235703808947`*^9, 
  3.546523616434534*^9}, {3.6291185296941967`*^9, 
  3.629118530701926*^9}},ExpressionUUID->"fe659996-490d-4c97-b98c-\
65b2038d8678"],

Cell[CellGroupData[{

Cell["multiple-spin case", "Subsubsection",
 CellChangeTimes->{{3.699677034566764*^9, 
  3.6996770584389343`*^9}},ExpressionUUID->"c77c41db-7f48-4562-a7a3-\
82d26f2dff71"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"opbasis2", ":", 
       RowBox[{"opbtype2_", "[", 
        RowBox[{"type2___", ",", 
         RowBox[{"spins_", "?", "MatrixQ"}], ",", "opb2opts___Rule"}], 
        "]"}]}], ",", 
      RowBox[{"opbasis1", ":", 
       RowBox[{"opbtype1_", "[", 
        RowBox[{"type1___", ",", 
         RowBox[{"spins_", "?", "MatrixQ"}], ",", "opb1opts___Rule"}], 
        "]"}]}], ",", "\[IndentingNewLine]", "basis_", ",", "opts___Rule"}], 
     "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Sorted", "/.", 
          RowBox[{"{", "opb2opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "opbtype2", "]"}]}], ",", 
        "\"\<OrderBySpin\>\""}], "]"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Sorted", "/.", 
          RowBox[{"{", "opb1opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "opbtype1", "]"}]}], ",", 
        "\"\<OrderBySpin\>\""}], "]"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", "[", "spins", "]"}], ">", "1"}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"temp", ",", "spin", ",", "opbtm"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"temp", "=", 
        RowBox[{"PrintTemporary", "[", 
         RowBox[{
         "\"\<setting up OperatorBasisTransformationMatrix from \>\"", ",", 
          "opbasis1", ",", "\"\< to \>\"", ",", "opbasis2"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Verbose", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "OperatorBasisTransformationMatrix", "]"}]}], ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<using OrderBySpin (2):\>\"", ",", 
           RowBox[{"{", 
            RowBox[{"opbasis2", ",", "opbasis1"}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"PrependTo", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "DownValues", "[", "OperatorBasisTransformationMatrix", "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"OperatorBasisTransformationMatrix", "[", 
           RowBox[{
           "opbasis2", ",", "opbasis1", ",", "basis", ",", "___Rule"}], "]"}],
           "\[Rule]", "\[IndentingNewLine]", 
          RowBox[{"KroneckerProduct", "[", "\[IndentingNewLine]", 
           RowBox[{"Sequence", "@@", 
            RowBox[{"Map", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Function", "[", 
               RowBox[{"spin", ",", "\[IndentingNewLine]", 
                RowBox[{
                "OperatorBasisTransformationMatrix", "[", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"opbtype2", "[", 
                   RowBox[{"type2", ",", 
                    RowBox[{"{", "spin", "}"}], ",", 
                    RowBox[{"Sorted", "\[Rule]", "\"\<OrderBySpin\>\""}]}], 
                   "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"opbtype1", "[", 
                   RowBox[{"type1", ",", 
                    RowBox[{"{", "spin", "}"}], ",", 
                    RowBox[{"Sorted", "\[Rule]", "\"\<OrderBySpin\>\""}]}], 
                   "]"}], ",", "\[IndentingNewLine]", 
                  RowBox[{"ZeemanBasis", "[", 
                   RowBox[{"{", "spin", "}"}], "]"}]}], "\[IndentingNewLine]",
                  "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Reverse", "[", "spins", "]"}]}], "\[IndentingNewLine]",
              "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Delete", "[", "temp", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"OperatorBasisTransformationMatrix", "[", 
        RowBox[{"opbasis2", ",", "opbasis1", ",", "basis", ",", "opts"}], 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546522738099677*^9, 3.54652280507486*^9}, {
   3.54652299341475*^9, 3.5465232506468573`*^9}, {3.5465236257343483`*^9, 
   3.5465236450352573`*^9}, {3.5465237005128927`*^9, 3.546523759165287*^9}, {
   3.5465237977244997`*^9, 3.54652412956329*^9}, {3.5465247623497*^9, 
   3.5465247631801567`*^9}, {3.5465256977704*^9, 3.546525714261259*^9}, {
   3.546525853955283*^9, 3.546525862072097*^9}, {3.546525910435288*^9, 
   3.546525920625071*^9}, {3.5465309528414288`*^9, 3.546530958425008*^9}, {
   3.54653104738431*^9, 3.546531051883786*^9}, {3.546532335727497*^9, 
   3.546532339501369*^9}, {3.547297740033657*^9, 3.5472977433840303`*^9}, {
   3.547298776828474*^9, 3.547298799874161*^9}, {3.629118680018053*^9, 
   3.629118682553939*^9}, 3.629119188551559*^9, {3.631449845043017*^9, 
   3.631449847122573*^9}, {3.640525101094975*^9, 3.640525111667153*^9}, {
   3.6405251759898663`*^9, 3.6405251934925823`*^9}, {3.640598292568224*^9, 
   3.6405982987770767`*^9}, {3.657715469224202*^9, 3.657715537597727*^9}, {
   3.69963852892878*^9, 3.699638568296719*^9}, {3.699638756500698*^9, 
   3.6996388032411003`*^9}, {3.699640822351261*^9, 3.699640838245405*^9}, {
   3.6996762814727573`*^9, 3.699676282241455*^9}, {3.6996763133214283`*^9, 
   3.699676313928545*^9}, 3.7093933141207848`*^9, {3.725618510391219*^9, 
   3.7256185356361427`*^9}, {3.7256185958054495`*^9, 3.72561860506234*^9}, {
   3.7256186444388814`*^9, 3.725618651733644*^9}, {3.725618686062191*^9, 
   3.725618689681856*^9}, {3.7256187588711033`*^9, 3.725618834579347*^9}, {
   3.725619435611393*^9, 3.725619435769104*^9}, {3.7256194788591013`*^9, 
   3.725619478995862*^9}, {3.7256195193889403`*^9, 3.7256195217639637`*^9}},
 CellLabel->
  "In[858]:=",ExpressionUUID->"ded1f35b-4b9b-4133-ab1d-6bc624ba7cc4"]
}, Closed]],

Cell[CellGroupData[{

Cell["single spin case", "Subsubsection",
 CellChangeTimes->{{3.699677034566764*^9, 
  3.699677038119739*^9}},ExpressionUUID->"c79e5966-5b30-4dfa-9aeb-\
d6ea42b640dd"],

Cell["calculate and memorize the individual spin transformations", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5465244735735188`*^9, 
  3.546524488084092*^9}},ExpressionUUID->"1270e0a9-9af2-40bf-ba7b-\
491bd7667df2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"opbasis2", ":", 
       RowBox[{"opbtype2_", "[", 
        RowBox[{"type2___", ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", "opb2opts___Rule"}],
         "]"}]}], ",", 
      RowBox[{"opbasis1", ":", 
       RowBox[{"opbtype1_", "[", 
        RowBox[{"type1___", ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", "opb1opts___Rule"}],
         "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"basis", ":", 
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"j_", ",", "Ij_"}], "}"}], "}"}], ",", "opts___Rule"}], 
        "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Sorted", "/.", 
          RowBox[{"{", "opb2opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "opbtype2", "]"}]}], ",", 
        RowBox[{"\"\<OrderBySpin\>\"", "|", "\"\<Canonical\>\""}]}], "]"}], 
      ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Sorted", "/.", 
          RowBox[{"{", "opb1opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "opbtype1", "]"}]}], ",", 
        RowBox[{"\"\<OrderBySpin\>\"", "|", "\"\<Canonical\>\""}]}], "]"}], 
      ")"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"k", ",", "reps1", ",", "reps2", ",", "OBTmat"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Verbose", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "OperatorBasisTransformationMatrix", "]"}]}], ",", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<using OrderBySpin (1):\>\"", ",", 
           RowBox[{"{", 
            RowBox[{"opbasis2", ",", "opbasis1"}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"reps1", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixRepresentation", "[", 
           RowBox[{"#", ",", 
            RowBox[{"ZeemanBasis", "[", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"j", ",", "Ij"}], "}"}], "}"}], "]"}]}], "]"}], "&"}], 
         "/@", 
         RowBox[{"BasisOperators", "[", "opbasis1", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"reps2", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"MatrixRepresentation", "[", 
           RowBox[{"#", ",", 
            RowBox[{"ZeemanBasis", "[", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"j", ",", "Ij"}], "}"}], "}"}], "]"}]}], "]"}], "&"}], 
         "/@", 
         RowBox[{"BasisOperators", "[", "opbasis2", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"OBTmat", "=", 
        RowBox[{"SparseArray", "[", 
         RowBox[{"Chop", "@", 
          RowBox[{"Outer", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Tr", "[", 
              RowBox[{
               RowBox[{"Adjoint", "[", "#1", "]"}], ".", "#2"}], "]"}], "&"}],
             ",", "reps2", ",", "reps1", ",", "1"}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"PrependTo", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "DownValues", "[", "OperatorBasisTransformationMatrix", "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
          "OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"opbtype2", "[", 
             RowBox[{"type2", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"j", ",", "Ij"}], "}"}], "}"}], ",", "opb2opts"}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"opbtype1", "[", 
             RowBox[{"type1", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"j", ",", "Ij"}], "}"}], "}"}], ",", "opb1opts"}], 
             "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"ZeemanBasis", "[", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"j", ",", "Ij"}], "}"}], "}"}], "]"}], ",", 
            "___Rule"}], "]"}], "\[Rule]", "\[IndentingNewLine]", 
          "OBTmat"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"OperatorBasisTransformationMatrix", "[", 
        RowBox[{"opbasis2", ",", "opbasis1", ",", "basis"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546524160140793*^9, 3.546524374926654*^9}, {
   3.5465248524407587`*^9, 3.54652488389324*^9}, {3.546526750548018*^9, 
   3.5465267778818007`*^9}, {3.5465275427404346`*^9, 3.546527547401478*^9}, {
   3.546527775980475*^9, 3.546527778680607*^9}, {3.5465309451031637`*^9, 
   3.546530947961426*^9}, {3.5472978924224052`*^9, 3.5472978957220592`*^9}, {
   3.547298775924563*^9, 3.547298798813785*^9}, {3.629118691408773*^9, 
   3.629118698294808*^9}, {3.631449841831641*^9, 3.631449850303467*^9}, {
   3.640525076665094*^9, 3.6405250853311567`*^9}, {3.640525235018465*^9, 
   3.6405252538648233`*^9}, {3.640525344778981*^9, 3.640525352159046*^9}, {
   3.640598241525839*^9, 3.640598281642853*^9}, {3.699638485210636*^9, 
   3.6996385197503843`*^9}, {3.699638812447933*^9, 3.6996388281295853`*^9}, {
   3.699640532778451*^9, 3.699640572908388*^9}, {3.699640603717771*^9, 
   3.699640688863096*^9}, {3.699640728734881*^9, 3.699640734363391*^9}, {
   3.699640791346448*^9, 3.699640806029484*^9}, {3.699641148760655*^9, 
   3.699641149261442*^9}, 3.699677018995358*^9, {3.699677082176672*^9, 
   3.6996770942391357`*^9}, {3.699891975549284*^9, 3.699891982517419*^9}, {
   3.699892211734694*^9, 3.6998922136042633`*^9}, {3.6998923639936237`*^9, 
   3.699892376550563*^9}, {3.69989458901501*^9, 3.699894592364439*^9}, {
   3.69989462333185*^9, 3.6998946335794163`*^9}, {3.7020334232133904`*^9, 
   3.702033425548078*^9}, {3.7020334850973864`*^9, 3.7020334852745123`*^9}, {
   3.7256188726251726`*^9, 3.725618891981865*^9}, {3.725619019520482*^9, 
   3.725619066858604*^9}, {3.7256191908392735`*^9, 3.7256193282892313`*^9}, {
   3.7256193702451673`*^9, 3.7256193708927975`*^9}, {3.7256194416515913`*^9, 
   3.7256194701927714`*^9}, {3.726568971030797*^9, 3.7265689722808075`*^9}},
 CellLabel->
  "In[859]:=",ExpressionUUID->"8235fc1c-8d95-4e2a-8f49-905671830d75"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["other intermediate operator bases", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.699624349225667*^9, 3.6996243959917192`*^9}, {
   3.6996419495609417`*^9, 3.699641955094411*^9}, {3.699677762361061*^9, 
   3.699677763069788*^9}},ExpressionUUID->"b5945aca-4585-4a37-ae0a-\
eeaca1a2b37e"],

Cell[CellGroupData[{

Cell["\<\
find an intermediate operator basis for the starting basis, if needed\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
  3.535371217630563*^9, 3.535371247926633*^9}, {3.545903734254499*^9, 
  3.545903737981646*^9}, {3.546522644563326*^9, 3.5465227100348663`*^9}, {
  3.5465232888299217`*^9, 3.5465233062908697`*^9}, {3.5465235703808947`*^9, 
  3.546523616434534*^9}, {3.6291185296941967`*^9, 3.629118530701926*^9}, {
  3.638884349181109*^9, 3.638884391122486*^9}, {3.638887748603445*^9, 
  3.638887752932869*^9}, {3.699625035556334*^9, 3.699625045060193*^9}, {
  3.699625291599045*^9, 3.6996252945557013`*^9}, {3.699626202278326*^9, 
  3.6996262138650312`*^9}},ExpressionUUID->"20db33e9-5591-458a-8026-\
95ff13139be3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasisTransformationMatrix", "[", 
    RowBox[{
    "opbasis2_", ",", "opbasis1_", ",", "basis_", ",", "opts___Rule"}], "]"}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "iopbasis", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Verbose", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{
           "Options", "[", "OperatorBasisTransformationMatrix", "]"}]}], ",", 
          
          RowBox[{"Print", "[", 
           RowBox[{"\"\<going through iopb (1):\>\"", ",", "iopbasis", ",", 
            RowBox[{"{", 
             RowBox[{"opbasis2", ",", "opbasis1"}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"PrependTo", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
          "DownValues", "[", "OperatorBasisTransformationMatrix", "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"OperatorBasisTransformationMatrix", "[", 
            RowBox[{
            "opbasis2", ",", "opbasis1", ",", "basis", ",", "___Rule"}], 
            "]"}], "\[Rule]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"OperatorBasisTransformationMatrix", "[", 
             RowBox[{"opbasis2", ",", "iopbasis", ",", "basis", ",", "opts"}],
              "]"}], ".", "\[IndentingNewLine]", 
            RowBox[{"OperatorBasisTransformationMatrix", "[", 
             RowBox[{"iopbasis", ",", "opbasis1", ",", "basis", ",", "opts"}],
              "]"}]}]}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"OperatorBasisTransformationMatrix", "[", 
         RowBox[{"opbasis2", ",", "opbasis1", ",", "basis"}], "]"}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"iopbasis", "=", 
         RowBox[{"IntermediateOperatorBasis", "[", "opbasis1", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"opbasis2", ",", "iopbasis"}], "]"}]}], "&&", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"opbasis1", ",", "iopbasis"}], "]"}]}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.638884495495804*^9, 3.6388845114032993`*^9}, {
  3.638885290736833*^9, 3.638885409128693*^9}, {3.638885442721047*^9, 
  3.6388854440702763`*^9}, {3.6388854841122293`*^9, 3.63888548807038*^9}, {
  3.6996247084248447`*^9, 3.699624729470654*^9}, {3.6996249241007767`*^9, 
  3.699625002536887*^9}, {3.699625059091795*^9, 3.699625195374311*^9}, {
  3.6996255908093863`*^9, 3.699625612385442*^9}, {3.6996262796814537`*^9, 
  3.699626280411036*^9}, {3.6996263389939127`*^9, 3.6996263587456408`*^9}, {
  3.699638585288522*^9, 3.6996386000302343`*^9}, {3.699638734998288*^9, 
  3.699638743326351*^9}, {3.699640862300871*^9, 3.6996408855303373`*^9}, {
  3.699676688584194*^9, 3.6996766896583443`*^9}, {3.6996767216590977`*^9, 
  3.699676736802141*^9}},
 CellLabel->
  "In[860]:=",ExpressionUUID->"69d6cf8a-868f-44da-86a2-1bead8c7e0bc"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
case where the starting basis is the canonical ZeemanKetBraOperatorBasis, and \
the target basis is also in canonical order\
\>", "Subsection",
 CellChangeTimes->{{3.699624780254404*^9, 3.699624834164208*^9}, {
  3.699626011037663*^9, 3.699626011451573*^9}, {3.699626069086454*^9, 
  3.6996261117134523`*^9}, {3.6996262233059*^9, 
  3.699626244071712*^9}},ExpressionUUID->"bad215f1-dfc1-4b68-9d6a-\
fb00de2473ce"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"opbasis2", ":", 
       RowBox[{"type2_", "[", 
        RowBox[{
         RowBox[{"stuff2", ":", 
          RowBox[{
           RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
         "opb2opts___Rule"}], "]"}]}], ",", 
      RowBox[{"zkbop", ":", 
       RowBox[{"ZeemanKetBraOperatorBasis", "[", 
        RowBox[{
         RowBox[{"stuff1", ":", 
          RowBox[{
           RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
         "opb1opts___Rule"}], "]"}]}], ",", "\[IndentingNewLine]", "basis_", 
      ",", "opts___Rule"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Sorted", "/.", 
         RowBox[{"{", "opb1opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "type2", "]"}]}], ",", "\"\<Canonical\>\""}], 
      "]"}], ")"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"PrintTemporary", "[", 
      RowBox[{
      "\"\<setting up OperatorBasisTransformationMatrix from \>\"", ",", 
       "zkbop", ",", "\"\< to \>\"", ",", "opbasis2"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Verbose", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "OperatorBasisTransformationMatrix", "]"}]}], 
       ",", 
       RowBox[{"Print", "[", 
        RowBox[{"\"\<setting up using canonical ordering ..\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"opbasis2", ",", "zkbop"}], "}"}]}], "]"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"PrependTo", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DownValues", "[", "OperatorBasisTransformationMatrix", "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"OperatorBasisTransformationMatrix", "[", 
         RowBox[{"opbasis2", ",", "zkbop", ",", "basis", ",", "___Rule"}], 
         "]"}], "\[Rule]", "\[IndentingNewLine]", 
        RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Conjugate", "@", 
            RowBox[{"Flatten", "@", 
             RowBox[{"MatrixRepresentation", "[", 
              RowBox[{"#", ",", 
               RowBox[{"ZeemanBasis", "[", "stuff1", "]"}]}], "]"}]}]}], 
           "&"}], "/@", "\[IndentingNewLine]", 
          RowBox[{"BasisOperators", "[", "opbasis2", "]"}]}], 
         "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"OperatorBasisTransformationMatrix", "[", 
      RowBox[{"opbasis2", ",", "zkbop", ",", "basis"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546522738099677*^9, 3.54652280507486*^9}, {
   3.54652299341475*^9, 3.5465232506468573`*^9}, {3.5465234750157146`*^9, 
   3.546523492323884*^9}, {3.546532138935404*^9, 3.546532139112032*^9}, {
   3.54729771866474*^9, 3.547297721685399*^9}, {3.547298790045372*^9, 
   3.547298802588188*^9}, {3.62911874314255*^9, 3.6291187447168694`*^9}, 
   3.629119144667239*^9, {3.63888552215256*^9, 3.6388856203557043`*^9}, 
   3.6388867556253433`*^9, {3.638886958049425*^9, 3.638886963297324*^9}, {
   3.639291186257244*^9, 3.639291217064931*^9}, {3.699623105698988*^9, 
   3.699623139762815*^9}, 3.699626017687317*^9, {3.6996261279391003`*^9, 
   3.699626138016961*^9}, {3.6996386132130957`*^9, 3.699638620851171*^9}, {
   3.6996387174623823`*^9, 3.699638727276219*^9}, {3.699640895003878*^9, 
   3.69964091330787*^9}, {3.6996413239284143`*^9, 3.699641333566702*^9}, {
   3.702033078607093*^9, 3.702033111656561*^9}, {3.7020345470304995`*^9, 
   3.702034550369877*^9}, 3.7020357743289843`*^9, {3.7020358127943606`*^9, 
   3.7020358305639944`*^9}, {3.7021036212407417`*^9, 3.7021036216660423`*^9}, 
   3.709392995872962*^9, {3.709393324197484*^9, 3.709393331613652*^9}},
 CellLabel->
  "In[861]:=",ExpressionUUID->"25d79730-8eb7-47fd-84e1-b9fe60a634fd"],

Cell[CellGroupData[{

Cell["CB comment (v3.0.0b16): ", "Subsubsection",
 CellChangeTimes->{{3.709392975527852*^9, 
  3.709392980965395*^9}},ExpressionUUID->"1111b345-f239-427c-8c34-\
a7aa114b7ba3"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"SparseArray", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Flatten", "@", 
       RowBox[{"MatrixRepresentation", "[", 
        RowBox[{"#", ",", 
         RowBox[{"ZeemanBasis", "[", "stuff1", "]"}]}], "]"}]}], "&"}], "/@", 
     
     RowBox[{"BasisOperators", "[", "opbasis2", "]"}]}], "]"}], " ", 
   "changed", " ", 
   RowBox[{"to", ":", 
    RowBox[{"SparseArray", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Conjugate", "@", 
        RowBox[{"Flatten", "@", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{"#", ",", 
           RowBox[{"ZeemanBasis", "[", "stuff1", "]"}]}], "]"}]}]}], "&"}], "/@", 
      RowBox[{"BasisOperators", "[", "opbasis2", "]"}]}], "]"}]}]}], 
  "*)"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546522738099677*^9, 3.54652280507486*^9}, {
   3.54652299341475*^9, 3.5465232506468573`*^9}, {3.5465234750157146`*^9, 
   3.546523492323884*^9}, {3.546532138935404*^9, 3.546532139112032*^9}, {
   3.54729771866474*^9, 3.547297721685399*^9}, {3.547298790045372*^9, 
   3.547298802588188*^9}, {3.62911874314255*^9, 3.6291187447168694`*^9}, 
   3.629119144667239*^9, {3.63888552215256*^9, 3.6388856203557043`*^9}, 
   3.6388867556253433`*^9, {3.638886958049425*^9, 3.638886963297324*^9}, {
   3.639291186257244*^9, 3.639291217064931*^9}, {3.699623105698988*^9, 
   3.699623139762815*^9}, 3.699626017687317*^9, {3.6996261279391003`*^9, 
   3.699626138016961*^9}, {3.6996386132130957`*^9, 3.699638620851171*^9}, {
   3.6996387174623823`*^9, 3.699638727276219*^9}, {3.699640895003878*^9, 
   3.69964091330787*^9}, {3.6996413239284143`*^9, 3.699641333566702*^9}, {
   3.702033078607093*^9, 3.702033111656561*^9}, {3.7020345470304995`*^9, 
   3.702034550369877*^9}, 3.7020357743289843`*^9, {3.7020358127943606`*^9, 
   3.7020358305639944`*^9}, {3.7021036212407417`*^9, 3.7021036216660423`*^9}, 
   3.709392995872962*^9},
 CellLabel->
  "In[862]:=",ExpressionUUID->"fc500595-e626-4fef-b2c2-6c0e62a8ecc5"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
find an intermediate operator basis for the target basis, if needed\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
  3.535371217630563*^9, 3.535371247926633*^9}, {3.545903734254499*^9, 
  3.545903737981646*^9}, {3.546522644563326*^9, 3.5465227100348663`*^9}, {
  3.5465232888299217`*^9, 3.5465233062908697`*^9}, {3.5465235703808947`*^9, 
  3.546523616434534*^9}, {3.6291185296941967`*^9, 3.629118530701926*^9}, {
  3.638884349181109*^9, 3.638884391122486*^9}, {3.638887748603445*^9, 
  3.638887752932869*^9}, {3.699625035556334*^9, 3.699625045060193*^9}, {
  3.699625291599045*^9, 3.6996252945557013`*^9}, {3.699626202278326*^9, 
  3.6996262138650312`*^9}, {3.699626260790442*^9, 
  3.699626261779305*^9}},ExpressionUUID->"b113061b-faa8-40e0-8677-\
a94c55368c11"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasisTransformationMatrix", "[", 
    RowBox[{
    "opbasis2_", ",", "opbasis1_", ",", "basis_", ",", "opts___Rule"}], "]"}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "iopbasis", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Verbose", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{
           "Options", "[", "OperatorBasisTransformationMatrix", "]"}]}], ",", 
          
          RowBox[{"Print", "[", 
           RowBox[{"\"\<going through iopb (2):\>\"", ",", "iopbasis", ",", 
            RowBox[{"{", 
             RowBox[{"opbasis2", ",", "opbasis1"}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"PrependTo", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
          "DownValues", "[", "OperatorBasisTransformationMatrix", "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"OperatorBasisTransformationMatrix", "[", 
            RowBox[{
            "opbasis2", ",", "opbasis1", ",", "basis", ",", "___Rule"}], 
            "]"}], "->", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"OperatorBasisTransformationMatrix", "[", 
             RowBox[{"opbasis2", ",", "iopbasis", ",", "basis", ",", "opts"}],
              "]"}], ".", "\[IndentingNewLine]", 
            RowBox[{"OperatorBasisTransformationMatrix", "[", 
             RowBox[{"iopbasis", ",", "opbasis1", ",", "basis", ",", "opts"}],
              "]"}]}]}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"OperatorBasisTransformationMatrix", "[", 
         RowBox[{"opbasis2", ",", "opbasis1", ",", "basis"}], "]"}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"iopbasis", "=", 
         RowBox[{"IntermediateOperatorBasis", "[", "opbasis2", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"opbasis2", ",", "iopbasis"}], "]"}]}], "&&", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"iopbasis", ",", "opbasis1"}], "]"}]}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.638884495495804*^9, 3.6388845114032993`*^9}, {
   3.638885290736833*^9, 3.638885409128693*^9}, {3.638885442721047*^9, 
   3.6388854440702763`*^9}, {3.6388854841122293`*^9, 3.63888548807038*^9}, {
   3.6996247084248447`*^9, 3.699624729470654*^9}, {3.6996249241007767`*^9, 
   3.699625002536887*^9}, {3.699625059091795*^9, 3.699625195374311*^9}, {
   3.6996255908093863`*^9, 3.699625612385442*^9}, {3.699626268037362*^9, 
   3.6996263287637873`*^9}, {3.699638631486457*^9, 3.6996386439249363`*^9}, {
   3.699638698360441*^9, 3.699638704277028*^9}, {3.699640921146583*^9, 
   3.699640937927495*^9}, 3.699676744513341*^9},
 CellLabel->
  "In[863]:=",ExpressionUUID->"e05dabd4-5e9b-45e8-9091-a60d54ae2ba1"]
}, Closed]],

Cell[CellGroupData[{

Cell["last resort direct procedure", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
  3.535371217630563*^9, 3.535371241990185*^9}, {3.545905091879669*^9, 
  3.5459050932299747`*^9}, {3.638887772994794*^9, 3.638887775220387*^9}, {
  3.699641981444957*^9, 3.699641984964501*^9}, {3.6996763775600853`*^9, 
  3.6996763890047703`*^9}},ExpressionUUID->"6aac3731-eef7-459e-afcb-\
8045a7610363"],

Cell["\<\
this should never used but the code here may be used for a check\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.638887780992434*^9, 3.638887808916068*^9}, {
  3.699625888478282*^9, 
  3.699625892626937*^9}},ExpressionUUID->"8bff8f67-8590-426c-b4e1-\
671ef4966982"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasisTransformationMatrix", "[", 
    RowBox[{
    "opbasis2_", ",", "opbasis1_", ",", "basis_", ",", "opts___Rule"}], "]"}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"PrintTemporary", "[", 
      RowBox[{
      "\"\<setting up OperatorBasisTransformationMatrix from \>\"", ",", 
       "opbasis1", ",", "\"\< to \>\"", ",", "opbasis2"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Verbose", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "OperatorBasisTransformationMatrix", "]"}]}], 
       ",", 
       RowBox[{"Print", "[", 
        RowBox[{
        "\"\<setting up opbtm using direct procedure:\>\"", " ", ",", 
         RowBox[{"{", 
          RowBox[{"opbasis2", ",", "opbasis1"}], "}"}]}], "]"}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"PrependTo", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DownValues", "[", "OperatorBasisTransformationMatrix", "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"OperatorBasisTransformationMatrix", "[", 
         RowBox[{"opbasis2", ",", "opbasis1", ",", "basis", ",", "___Rule"}], 
         "]"}], "\[Rule]", "\[IndentingNewLine]", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", "spinsys", "}"}], ",", 
          RowBox[{"(", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"spinsys", "=", 
             RowBox[{"SpinSystem", "[", "opbasis2", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"SparseArray", "@", 
             RowBox[{"Outer", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"LiouvilleBracket", "[", 
                 RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"MatrixRepresentation", "[", 
                  RowBox[{"#", ",", 
                   RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "]"}], 
                 "&"}], "/@", 
                RowBox[{"BasisOperators", "[", "opbasis2", "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"MatrixRepresentation", "[", 
                  RowBox[{"#", ",", 
                   RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "]"}], 
                 "&"}], "/@", 
                RowBox[{"BasisOperators", "[", "opbasis1", "]"}]}], ",", 
               "\[IndentingNewLine]", "1"}], "\[IndentingNewLine]", "]"}]}]}],
            "\[IndentingNewLine]", ")"}]}], "]"}]}]}], "\[IndentingNewLine]", 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"OperatorBasisTransformationMatrix", "[", 
      RowBox[{"opbasis2", ",", "opbasis1", ",", "basis"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431060507531653*^9, 3.4310605243448067`*^9}, {
   3.4310605573642673`*^9, 3.431060656344018*^9}, {3.431068723362863*^9, 
   3.4310687254902067`*^9}, {3.431068809114211*^9, 3.43106882252243*^9}, 
   3.435381118675346*^9, {3.45266834068458*^9, 3.452668343787883*^9}, {
   3.464800484112955*^9, 3.464800488271772*^9}, {3.502415922958727*^9, 
   3.502415945308154*^9}, {3.502415987174296*^9, 3.502416043179842*^9}, {
   3.502416121454281*^9, 3.5024161217489843`*^9}, {3.502416695060953*^9, 
   3.502416791098618*^9}, {3.502417254088724*^9, 3.5024172547421703`*^9}, 
   3.502417447227179*^9, 3.531841859768756*^9, {3.533039765832543*^9, 
   3.5330398154766617`*^9}, {3.533180916595272*^9, 3.533180941607628*^9}, {
   3.533184577358676*^9, 3.533184607899194*^9}, {3.5464413448153553`*^9, 
   3.546441349356184*^9}, {3.546446206651186*^9, 3.546446208971862*^9}, {
   3.546524439752245*^9, 3.5465244574391537`*^9}, {3.546526617233795*^9, 
   3.546526726713138*^9}, {3.546526826884989*^9, 3.546526828832836*^9}, {
   3.5472977485897837`*^9, 3.5472977523085938`*^9}, {3.547298777708818*^9, 
   3.547298800795905*^9}, {3.550998653785769*^9, 3.550998709821364*^9}, 
   3.5509988206013203`*^9, {3.6291185531920977`*^9, 3.629118581241064*^9}, {
   3.6996232563502417`*^9, 3.699623282314002*^9}, 3.699623355983099*^9, {
   3.699624848510805*^9, 3.6996248519977293`*^9}, {3.6996258952611847`*^9, 
   3.69962589920886*^9}, {3.6996386499020777`*^9, 3.699638685365025*^9}, {
   3.699640949186764*^9, 3.699640991206596*^9}, {3.709393282584838*^9, 
   3.709393300117495*^9}, {3.709393357581574*^9, 3.7093933604839067`*^9}},
 CellLabel->
  "In[864]:=",ExpressionUUID->"8d3afddf-3c97-4e8b-8b7d-bae1385f19ea"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
  3.535371217630563*^9, 3.535371241990185*^9}, {3.545905091879669*^9, 
  3.5459050932299747`*^9}, {3.546522558689795*^9, 
  3.546522559902604*^9}},ExpressionUUID->"12468ffc-98ac-48f7-bebd-\
393364181343"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasisTransformationMatrix", "::", "badspinsys"}], "=", 
   "\"\<cannot transform between operator bases belonging to different spin \
systems.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.546522566817226*^9, 3.546522587962907*^9}},
 CellLabel->
  "In[865]:=",ExpressionUUID->"53aca2a5-f090-437e-abec-4f6e7e97ec59"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasisTransformationMatrix", "::", "undefopb"}], "=", 
   "\"\<OperatorBasis `1` is not defined.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6996418767644167`*^9, 3.699641891131736*^9}},
 CellLabel->
  "In[866]:=",ExpressionUUID->"f978940d-ddde-4d19-9c78-39bbdc709e9d"]
}, Closed]],

Cell[CellGroupData[{

Cell["subroutines", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.502427613650401*^9, 3.5024276296734123`*^9}, {
  3.535371217630563*^9, 3.535371241990185*^9}, {3.545905091879669*^9, 
  3.5459050932299747`*^9}, {3.546522558689795*^9, 3.546522559902604*^9}, {
  3.6996244083230753`*^9, 
  3.699624410347189*^9}},ExpressionUUID->"d2fb778e-3159-41b9-bff2-\
e841ad1f85d2"],

Cell[CellGroupData[{

Cell["\<\
OperatorBasesMatchQ determines whether two operator bases are the same\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.638884998796598*^9, 3.63888502986525*^9}, {
  3.699637240942233*^9, 
  3.699637251569804*^9}},ExpressionUUID->"3bc59baa-5571-4f86-8171-\
d7805cd8790b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasesMatchQ", "[", 
    RowBox[{"{", 
     RowBox[{"opbasis2_", ",", "opbasis1_"}], "}"}], "]"}], ":=", 
   RowBox[{"OperatorBasesMatchQ", "[", 
    RowBox[{"opbasis2", ",", "opbasis1"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699637255944632*^9, 3.699637278961941*^9}},
 CellLabel->
  "In[867]:=",ExpressionUUID->"12f74bd4-4721-4eaa-803b-8f324231d06d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasesMatchQ", "[", 
    RowBox[{"opbasis_", ",", "opbasis_"}], "]"}], ":=", "True"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.69963728891395*^9, 3.699637298608493*^9}},
 CellLabel->
  "In[868]:=",ExpressionUUID->"b5fcc40f-7e19-4ff4-a787-638277420fb7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasesMatchQ", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"opbasis2", ":", 
       RowBox[{"type_", "[", 
        RowBox[{
         RowBox[{"stuff", ":", 
          RowBox[{
           RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
         "opb2opts___Rule"}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"opbasis1", ":", 
       RowBox[{"type_", "[", 
        RowBox[{
         RowBox[{"stuff", ":", 
          RowBox[{
           RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
         "opb1opts___Rule"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"Options", "[", "type", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"_Rule", "..."}], "}"}]}], "]"}], "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"First", "/@", 
          RowBox[{"Options", "[", "type", "]"}]}], ")"}], "/.", 
        RowBox[{"{", "opb2opts", "}"}]}], ",", " ", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"First", "/@", 
          RowBox[{"Options", "[", "type", "]"}]}], ")"}], "/.", 
        RowBox[{"{", "opb1opts", "}"}]}]}], "]"}]}]}], ":=", "True"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699637307848592*^9, 3.699637360773952*^9}, {
  3.699637402327084*^9, 3.699637540459383*^9}, {3.6998911261371593`*^9, 
  3.699891139806583*^9}},
 CellLabel->
  "In[869]:=",ExpressionUUID->"cfa11969-b058-4226-90d3-7fe38c1eee24"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasesMatchQ", "[", 
    RowBox[{"opbasis2_", ",", "opbasis1_"}], "]"}], ":=", "False"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6996375643701344`*^9, 3.699637579888412*^9}},
 CellLabel->
  "In[870]:=",ExpressionUUID->"7b0ae87d-eaed-4c78-8d95-617f8d67633b"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
OperatorBasesOrderedQ determines whether two operator bases are ordered\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.638884998796598*^9, 3.63888502986525*^9}, {
  3.699637595338702*^9, 
  3.699637599231407*^9}},ExpressionUUID->"4f5eefdd-9b85-4dc5-a53d-\
b75d91a5992a"],

Cell["\<\
A pair of bases is ordered if the second basis of the pair is the defined \
IntermediateOperatorBasis for the basis. In most cases this is the \
ZeemanKetBraOperatorBasis with canonical ordering.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.638885034197332*^9, 3.638885060152164*^9}, {
  3.6388851975352983`*^9, 3.638885215770627*^9}, {3.699637057140057*^9, 
  3.699637141880084*^9}},ExpressionUUID->"8b1927ae-1fe1-45a9-93d2-\
8b684fcc5008"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasesOrderedQ", "[", 
     RowBox[{"{", 
      RowBox[{"opbasis2_", ",", "opbasis1_"}], "}"}], "]"}], "/;", 
    RowBox[{"OperatorBasesMatchQ", "[", 
     RowBox[{"{", 
      RowBox[{"opbasis1", ",", 
       RowBox[{"IntermediateOperatorBasis", "[", "opbasis2", "]"}]}], "}"}], 
     "]"}]}], ":=", "True"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6996371487702017`*^9, 3.699637225755166*^9}, {
  3.699637726657569*^9, 3.699637726863407*^9}},
 CellLabel->
  "In[871]:=",ExpressionUUID->"bf0dd88f-d557-4a82-807e-86c9a6b1dbb1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorBasesOrderedQ", "[", 
     RowBox[{"{", 
      RowBox[{"opbasis2_", ",", "opbasis1_"}], "}"}], "]"}], "/;", 
    RowBox[{"OperatorBasesMatchQ", "[", 
     RowBox[{"{", 
      RowBox[{"opbasis2", ",", 
       RowBox[{"IntermediateOperatorBasis", "[", "opbasis1", "]"}]}], "}"}], 
     "]"}]}], ":=", "False"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6996371487702017`*^9, 3.699637225755166*^9}, {
  3.699637726657569*^9, 3.699637758542716*^9}},
 CellLabel->
  "In[872]:=",ExpressionUUID->"e89dcaab-e084-4a79-976a-43102b0ff454"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorBasesOrderedQ", "[", 
    RowBox[{"{", 
     RowBox[{"opbasis2_", ",", "opbasis1_"}], "}"}], "]"}], ":=", 
   RowBox[{"OrderedQ", "[", 
    RowBox[{"{", 
     RowBox[{"opbasis2", ",", "opbasis1"}], "}"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6388850719780283`*^9, 3.6388851045250874`*^9}},
 CellLabel->
  "In[873]:=",ExpressionUUID->"6b306717-1adb-446e-91af-ec3154546f85"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
IntermediateOperatorBasis determines the intermediate operator basis used \
when setting up a new operator basis.\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.638884998796598*^9, 3.63888502986525*^9}, {
  3.6996244567329082`*^9, 
  3.699624485488966*^9}},ExpressionUUID->"2848f4f5-1e83-489b-9b3f-\
8ea0d1e07745"],

Cell["\<\
Normally this is the canonical ZeemanKetBraOperatorBasis. 
A different intermediate operator basis may be specified when \
DefineOperatorBasis is executed.\
\>", "Text",
 CellChangeTimes->{{3.6996244884010487`*^9, 3.6996245383182373`*^9}, {
  3.699637660677022*^9, 
  3.6996376884777527`*^9}},ExpressionUUID->"efe1b067-da1c-4552-9365-\
153e71d67937"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IntermediateOperatorBasis", "[", "opbasis_", "]"}], ":=", 
   RowBox[{"ZeemanKetBraOperatorBasis", "[", 
    RowBox[{
     RowBox[{"SpinSystem", "[", "opbasis", "]"}], ",", 
     RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699624544471035*^9, 3.699624593692045*^9}, {
   3.69962464245371*^9, 3.699624645814817*^9}, 3.699624681804256*^9},
 CellLabel->
  "In[874]:=",ExpressionUUID->"338a579e-e903-401a-bff0-6513ba58e931"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorVectorRepresentation", "Subchapter",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"68c2ebe5-3d8e-4752-b940-99c1d3977be5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "OperatorVectorRepresentation", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"Method", "\[Rule]", "Automatic"}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4298615198898983`*^9, 3.429861520462777*^9}, {
   3.4298683208432198`*^9, 3.429868342986383*^9}, 3.4298688630552683`*^9, {
   3.4306502020849247`*^9, 3.4306502028583097`*^9}, {3.430650387075979*^9, 
   3.430650387690188*^9}, {3.431056946979576*^9, 3.431056998654784*^9}, 
   3.431057258582741*^9, {3.431057395137857*^9, 3.43105740261629*^9}, {
   3.431057503002686*^9, 3.431057504074402*^9}, {3.43105774678799*^9, 
   3.4310577543755903`*^9}, {3.431059078277666*^9, 3.431059121064754*^9}, 
   3.433525881110385*^9, {3.4352397661807632`*^9, 3.435239766738275*^9}, 
   3.435241235058351*^9, 3.4473461323787937`*^9},
 CellLabel->
  "In[875]:=",ExpressionUUID->"09743a81-56f6-42b1-8500-768344841b61"],

Cell[CellGroupData[{

Cell["general properties", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 
  3.430456146975505*^9}},ExpressionUUID->"5a52c6b5-5c7f-4a8d-87f7-\
bff02b9aa4b7"],

Cell[CellGroupData[{

Cell["\<\
pass basis specificiations into function, including traps for unknown \
opbasis, basis and SpinSystem\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 
  3.448360776920339*^9}},ExpressionUUID->"8698c200-9f5f-4d22-b623-\
8b8042488a2b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{"op_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{"op", ",", 
     RowBox[{"OperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483608249090567`*^9, 3.448360834338647*^9}, 
   3.456205556430071*^9},
 CellLabel->
  "In[876]:=",ExpressionUUID->"9cbe7c57-593d-48d1-b1ef-2d27e0b9ecd9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{"op_", ",", "opbasis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{"op", ",", "opbasis", ",", 
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.429846541720842*^9, 3.429846581379725*^9, {3.448360839463299*^9, 
   3.448360847635754*^9}, 3.456162900493266*^9},
 CellLabel->
  "In[877]:=",ExpressionUUID->"3b471989-a746-4d59-bd02-57a96c2ac580"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorVectorRepresentation", "[", 
     RowBox[{"op_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
     "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483598512286263`*^9, 
   3.448359860731179*^9}, {3.448360466346766*^9, 3.448360475974476*^9}, {
   3.448360592630582*^9, 3.448360596506363*^9}, {3.4483608533917427`*^9, 
   3.4483608576596193`*^9}, 3.456162404964549*^9, 3.456201343512033*^9, 
   3.547025295923027*^9, 3.621614560910187*^9},
 CellLabel->
  "In[878]:=",ExpressionUUID->"63f87ac3-633b-4f0b-bee6-14bd35d7f78a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{"op_", ",", "opbasis_", ",", "Undefined", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "default"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{"SpinSystem", "[", "]"}], "]"}], ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"OperatorVectorRepresentation", "[", 
      RowBox[{"op", ",", "opbasis", ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, 3.448360573943112*^9, {
   3.448360607428061*^9, 3.448360654701827*^9}, {3.448360865669361*^9, 
   3.448360887526175*^9}, 3.456162405714149*^9, 3.547025279677124*^9},
 CellLabel->
  "In[879]:=",ExpressionUUID->"d35feb46-bd93-4276-9ef4-54716e864035"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{"op_", ",", "Undefined", ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "unknown"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "default"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOperatorBasis", "[", 
      RowBox[{
       RowBox[{"DefaultOperatorBasis", "[", "]"}], ",", 
       RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"OperatorVectorRepresentation", "[", 
      RowBox[{"op", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, {3.44835995227402*^9, 
   3.448359994938308*^9}, {3.4483606824647713`*^9, 3.448360738493463*^9}, {
   3.448360895536944*^9, 3.448360911604973*^9}, {3.464607683853249*^9, 
   3.464607701653131*^9}, 3.543498667587482*^9, 3.547025333072365*^9},
 CellLabel->
  "In[880]:=",ExpressionUUID->"49831860-706f-4667-99e2-3b44c52b21f8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorVectorRepresentation", "[", 
     RowBox[{"op_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
     "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"Equal", "[", 
      RowBox[{
       RowBox[{"SpinSystem", "[", "opbasis", "]"}], ",", 
       RowBox[{"SpinSystem", "[", "basis", "]"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "defaultopbasis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SetSpinSystem", "[", 
        RowBox[{"SpinSystem", "[", "basis", "]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{"OperatorBasis", "::", "default"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetOperatorBasis", "[", 
        RowBox[{
         RowBox[{"DefaultOperatorBasis", "[", "]"}], ",", 
         RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"OperatorVectorRepresentation", "[", 
        RowBox[{"op", ",", "defaultopbasis", ",", "basis", ",", "opts"}], 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, {3.44835995227402*^9, 
   3.448359994938308*^9}, {3.448361307182886*^9, 3.448361363053556*^9}, {
   3.448361419573944*^9, 3.4483614810280848`*^9}, {3.44836151594449*^9, 
   3.448361525098793*^9}, {3.448361569055385*^9, 3.448361573898075*^9}, {
   3.4483616285278997`*^9, 3.448361646636026*^9}, {3.448361938039504*^9, 
   3.448362008292676*^9}, {3.448362046747509*^9, 3.448362060878875*^9}, {
   3.448363824396117*^9, 3.448363828506321*^9}, {3.464607710486528*^9, 
   3.464607732299564*^9}, 3.482570594451775*^9, {3.482571755459525*^9, 
   3.4825717663319674`*^9}, 3.543498669034964*^9, {3.640513562856038*^9, 
   3.640513571018173*^9}, 3.640523997736587*^9},
 CellLabel->
  "In[881]:=",ExpressionUUID->"b2a25f12-569e-4411-8070-34f0e161171d"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle a single number", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.531929730192232*^9, 3.5319297359413137`*^9}, 
   3.531930027378767*^9, {3.5320070316467867`*^9, 
   3.532007035881529*^9}},ExpressionUUID->"5888cc65-be10-4b84-b4eb-\
9aa9bbc5deec"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorVectorRepresentation", "[", 
     RowBox[{
      RowBox[{"num_", "?", "NumericQ"}], ",", "more___"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", "num", "]"}], "\[Equal]", "0"}], ")"}]}], ":=", 
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{
     RowBox[{"NullOperator", "[", "]"}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929684468029*^9, 3.531929722331521*^9}, {
  3.531930036870233*^9, 3.531930061317379*^9}, {3.5319303206047087`*^9, 
  3.5319303229174423`*^9}, {3.532006991999352*^9, 3.532007019860983*^9}, {
  3.532007133030086*^9, 3.532007156145802*^9}, {3.532007258327148*^9, 
  3.532007265757206*^9}, {3.5439448117881823`*^9, 3.543944830552544*^9}},
 CellLabel->
  "In[882]:=",ExpressionUUID->"f73da4ce-8e3d-4f91-9d88-2c7ab4fc51cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{
     RowBox[{"num_", "?", "NumericQ"}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{
     RowBox[{"num", "\[Times]", 
      RowBox[{"UnityOperator", "[", "]"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468757863806199*^9, 3.46875788919879*^9}, {
  3.486710743814829*^9, 3.486710744160817*^9}, {3.5319307180361977`*^9, 
  3.531930738813519*^9}, {3.531930826214958*^9, 3.531930832693524*^9}},
 CellLabel->
  "In[883]:=",ExpressionUUID->"64caa45e-630b-4bfe-b281-8e387272e7a4"]
}, Closed]],

Cell[CellGroupData[{

Cell["fix or trap inappropriate arguments", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.5319297444260406`*^9, 3.531929753780078*^9}, {
   3.531929909532097*^9, 3.531929915726618*^9}, {3.6267782290119667`*^9, 
   3.6267782413631763`*^9}, 
   3.626778309724236*^9},ExpressionUUID->"3086e6a9-748e-4433-85e4-\
95d42f73e453"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorVectorRepresentation", "[", 
     RowBox[{
      RowBox[{"op", ":", 
       RowBox[{"Except", "[", 
        RowBox[{"_", "?", "OperatorQ"}], "]"}]}], ",", "more___"}], "]"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "fixedop", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"OperatorVectorRepresentation", "[", 
        RowBox[{"fixedop", ",", "more"}], "]"}], "\[IndentingNewLine]", ")"}],
       "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"fixedop", "=", 
         RowBox[{"Chop", "[", "op", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"fixedop", ",", 
          RowBox[{"_", "?", "OperatorQ"}]}], "]"}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.626777618316545*^9, 3.626777675617124*^9}, {
  3.626778100502324*^9, 3.626778188299364*^9}, {3.626778367837471*^9, 
  3.626778403735046*^9}},
 CellLabel->
  "In[884]:=",ExpressionUUID->"7f1e79f9-a5e3-46a5-8fdd-a7e14894b6fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{"op_", ",", "more___"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"OperatorVectorRepresentation", "::", "badop"}], "]"}], ";", 
      "$Failed"}], ")"}], "/;", 
    RowBox[{"(", 
     RowBox[{"!", 
      RowBox[{"OperatorQ", "[", "op", "]"}]}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929684468029*^9, 3.531929722331521*^9}, {
   3.531929756418811*^9, 3.531929789325817*^9}, {3.5319298388168793`*^9, 
   3.5319298734439783`*^9}, {3.531930063726522*^9, 3.5319300867107153`*^9}, {
   3.53193033230785*^9, 3.531930374757971*^9}, {3.531930522471366*^9, 
   3.5319305447228947`*^9}, 3.5319307639445972`*^9, {3.5319308405929213`*^9, 
   3.5319308551954403`*^9}, {3.5320232157942*^9, 3.532023246661594*^9}, {
   3.618400164964925*^9, 3.618400178210803*^9}, {3.6184801787384043`*^9, 
   3.618480201935235*^9}, {3.618481777536736*^9, 3.618481780988043*^9}},
 CellLabel->
  "In[885]:=",ExpressionUUID->"d2fc5b6e-37e7-456b-b38f-a140078730fb"]
}, Closed]],

Cell[CellGroupData[{

Cell["handling of sums", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"e937865a-aa08-4426-bc50-8724f357b923"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorVectorRepresentation", "[", 
     RowBox[{
      RowBox[{"Plus", "[", "ops___", "]"}], ",", "opbasis_", ",", "basis_", 
      ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Map", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"OperatorVectorRepresentation", "[", 
       RowBox[{"#", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}], "&"}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"Plus", "[", "ops", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483499662006483`*^9, 3.448349970809721*^9}, {
  3.4572685262420197`*^9, 3.4572685650473013`*^9}, {3.457269253091034*^9, 
  3.457269254829583*^9}, {3.457271896518424*^9, 3.457271924107071*^9}},
 CellLabel->
  "In[886]:=",ExpressionUUID->"80662191-286e-4264-8268-554fccbe22a7"]
}, Closed]],

Cell[CellGroupData[{

Cell["handling of numerical factors", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"21621a6f-918f-44ef-8ba1-f38b22cfc818"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{
     RowBox[{"Times", "[", 
      RowBox[{
       RowBox[{"num", ":", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}]}], ",", 
       RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"num", "*", 
    RowBox[{"OperatorVectorRepresentation", "[", 
     RowBox[{"op", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}]}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310952968056602`*^9, 3.4310952983526373`*^9}, {
  3.448348974787569*^9, 3.448348982064094*^9}, {3.448349443761387*^9, 
  3.448349491481229*^9}, {3.4483500075438013`*^9, 3.44835003357691*^9}},
 CellLabel->
  "In[887]:=",ExpressionUUID->"c41e23d3-812f-4296-a0eb-52b61aeb108e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{
     RowBox[{"Times", "[", 
      RowBox[{
       RowBox[{"op_", "?", "OperatorQ"}], ",", 
       RowBox[{"num", ":", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{"_", "?", "OperatorQ"}], "]"}], ".."}]}]}], "]"}], ",", 
     "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"num", "*", 
    RowBox[{"OperatorVectorRepresentation", "[", 
     RowBox[{"op", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}]}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310952968056602`*^9, 3.4310952983526373`*^9}, {
  3.448348974787569*^9, 3.448348982064094*^9}, {3.448349443761387*^9, 
  3.448349491481229*^9}, {3.4483500075438013`*^9, 3.448350055438802*^9}},
 CellLabel->
  "In[888]:=",ExpressionUUID->"dd2bd68a-939c-4b78-aa13-7250c7f1b95b"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
OperatorVectorRepresentation of an Operator already containing a vector \
representation\
\>", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.532008084626075*^9, 3.532008104497097*^9}, {
  3.5320082843196*^9, 3.53200830856917*^9}, {3.5320084881534147`*^9, 
  3.532008514044441*^9}, {3.6832033691383677`*^9, 
  3.683203395473323*^9}},ExpressionUUID->"22e07767-ecee-44c2-9fea-\
793aba980003"],

Cell[CellGroupData[{

Cell["operator bases are consistent", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6231688107710323`*^9, 
  3.623168826281397*^9}},ExpressionUUID->"f423c64c-66a5-454b-b22d-\
6e48aed57bbf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorVectorRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Operator", "[", 
       RowBox[{
        RowBox[{"vec_", "?", "VectorQ"}], ",", 
        RowBox[{"opbasis", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
        RowBox[{"vecbasis", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "___Rule"}], "]"}], 
      ",", "\[IndentingNewLine]", "opbasis_", ",", "basis_", ",", "___Rule"}],
      "]"}]}], ":=", "vec"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.532008318481048*^9, 3.532008410099742*^9}, 
   3.532008539973173*^9, 3.6231691910615997`*^9, {3.623334292537505*^9, 
   3.623334297793283*^9}},
 CellLabel->
  "In[889]:=",ExpressionUUID->"27fd8f67-078d-47c4-a528-8ff8b8c1c582"],

Cell["\<\
case of an interpolating function that evaluates to a vector:\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.623169451363755*^9, 
  3.623169463604198*^9}},ExpressionUUID->"0557ec3a-d8ff-41d0-a619-\
291ab6dfb479"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"OperatorVectorRepresentation", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Operator", "[", 
        RowBox[{
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         RowBox[{"opbasis", ":", 
          RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
         RowBox[{"vecbasis", ":", 
          RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "___Rule"}], "]"}], 
       ",", "\[IndentingNewLine]", "opbasis_", ",", "basis_", ",", 
       "___Rule"}], "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}],
       "&&", "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"ifunc", "[", 
         RowBox[{"ifunc", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}],
         ",", 
        RowBox[{"_", "?", "VectorQ"}]}], "]"}]}], ")"}]}], ":=", 
   RowBox[{"ifunc", "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.532008318481048*^9, 3.532008410099742*^9}, 
   3.532008539973173*^9, {3.623168876513623*^9, 3.6231689068820553`*^9}, {
   3.6231689583506393`*^9, 3.623168997614567*^9}, {3.623169184058222*^9, 
   3.62316918706257*^9}, {3.623334308533556*^9, 3.6233343107939367`*^9}},
 CellLabel->
  "In[890]:=",ExpressionUUID->"db348639-1c0b-4b27-a458-389a3699549b"]
}, Closed]],

Cell[CellGroupData[{

Cell["operator bases are different", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6231688107710323`*^9, 
  3.623168834570127*^9}},ExpressionUUID->"28ef6381-b08c-4fbc-be20-\
5b0e79f7c8b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorVectorRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Operator", "[", 
       RowBox[{"spec_", ",", 
        RowBox[{"vecopbasis", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
        RowBox[{"vecbasis", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "___Rule"}], "]"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"opbasis", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
      RowBox[{"basis", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "___Rule"}], "]"}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{
   "MultiplyMatricesAndVectorInterpolationFunctions", "[", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OperatorBasisTransformationMatrix", "[", 
      RowBox[{"opbasis", ",", "vecopbasis"}], "]"}], ",", 
     "\[IndentingNewLine]", "spec"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.62333435857979*^9, 3.623334513050263*^9}},
 CellLabel->
  "In[891]:=",ExpressionUUID->"3d70b3c6-1964-4d32-90a2-40c10a9476c5"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["calculations using Method\[Rule] Automatic", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239507168541*^9, 
   3.435239510988324*^9}},ExpressionUUID->"5adb4927-907e-45bc-aebc-\
d2ce7da4669a"],

Cell[CellGroupData[{

Cell["\<\
special calculation in the operator basis ZeemanKetBraOperatorBasis[Sorted \
\[Rule] \[OpenCurlyDoubleQuote]Canonical\[CloseCurlyDoubleQuote]]\
\>", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239560361751*^9, 3.435239596132903*^9}, {
   3.435239820173019*^9, 3.43523982842017*^9}, {3.435239862518588*^9, 
   3.435239880379974*^9}, {3.4352407116152267`*^9, 3.435240726984272*^9}, {
   3.435253401801248*^9, 3.435253402192926*^9}, {3.447346223948882*^9, 
   3.44734622479399*^9}, {3.546529191067403*^9, 
   3.546529195352223*^9}},ExpressionUUID->"b0c57370-e96f-438a-b9a7-\
c3dbfadb3eac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{"op_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "spinsys", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"SparseArray", "@", 
        RowBox[{"Flatten", "@", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{"op", ",", "basis"}], "]"}]}]}], "\[IndentingNewLine]", 
       ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "OperatorVectorRepresentation", "]"}]}], 
           ",", "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], 
          "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435240920497623*^9}, {3.435241098673073*^9, 3.435241134326395*^9}, {
   3.435241491679801*^9, 3.435241512547866*^9}, {3.435242322165255*^9, 
   3.4352423248047323`*^9}, {3.435250726932569*^9, 3.435250729367881*^9}, {
   3.435251391007934*^9, 3.435251392468975*^9}, {3.447346235069186*^9, 
   3.4473462414279222`*^9}, {3.447346293685166*^9, 3.4473463314927464`*^9}, {
   3.455598283226161*^9, 3.455598285798376*^9}, 3.546421403250719*^9, {
   3.546529255706253*^9, 3.546529327799563*^9}},
 CellLabel->
  "In[892]:=",ExpressionUUID->"0d24e81e-37f1-47a1-b94a-35a10f12a5f6"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
calculation in a general basis, using a transformation to the \
ZeemanKetBraOperatorBasis[Sorted \[Rule] \[OpenCurlyDoubleQuote]Canonical\
\[CloseCurlyDoubleQuote]] operator basis\
\>", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456369810807*^9, 3.430456391358386*^9}, 
   3.430456556431728*^9, {3.4305643986149607`*^9, 3.430564400498064*^9}, {
   3.430566885906928*^9, 3.430566886703034*^9}, {3.431058412294199*^9, 
   3.431058420738549*^9}, {3.431058915224729*^9, 3.4310589171922903`*^9}, {
   3.431058950550519*^9, 3.431058955459968*^9}, {3.4352395444378967`*^9, 
   3.4352395512201853`*^9}, {3.4352396084061203`*^9, 
   3.4352396468492527`*^9}, {3.435239945449224*^9, 3.43523994881136*^9}, {
   3.435240497650125*^9, 3.435240501008383*^9}, {3.435240629421344*^9, 
   3.435240634129475*^9}, {3.435240689801029*^9, 3.435240693456541*^9}, 
   3.447346367158256*^9, {3.546529350738365*^9, 
   3.5465293543765097`*^9}},ExpressionUUID->"5dba9b61-d526-4930-9462-\
4fedcbe8b4c7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{"op_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"iopbasis", ",", "spinsys", ",", "zb"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"iopbasis", "=", 
         RowBox[{"ZeemanKetBraOperatorBasis", "[", 
          RowBox[{"spinsys", ",", 
           RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}]}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"zb", "=", 
         RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SparseArray", "[", 
         RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"OperatorBasisTransformationMatrix", "[", 
            RowBox[{"opbasis", ",", "iopbasis", ",", "zb"}], "]"}], ".", 
           "\[IndentingNewLine]", 
           RowBox[{"OperatorVectorRepresentation", "[", 
            RowBox[{"op", ",", "iopbasis", ",", "zb", ",", 
             RowBox[{"Method", "\[Rule]", "Automatic"}], ",", "opts"}], 
            "]"}]}], "\[IndentingNewLine]", "]"}], "]"}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "OperatorVectorRepresentation", "]"}]}], 
           ",", "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"ZeemanKetBraOperatorBasis", "[", 
               RowBox[{"spinsys", ",", 
                RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
              ",", 
              RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], 
           "]"}]}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456036023714*^9, 3.43045611027256*^9}, {
   3.4305650750552273`*^9, 3.430565077965583*^9}, {3.430566896470188*^9, 
   3.430566899378647*^9}, {3.43105843999332*^9, 3.431058461190651*^9}, {
   3.431058502991736*^9, 3.4310585825002747`*^9}, 3.431058612835156*^9, {
   3.4310586453634768`*^9, 3.431058744314518*^9}, {3.431058783679401*^9, 
   3.43105886189494*^9}, {3.431058992709149*^9, 3.4310590678010406`*^9}, {
   3.431059354542647*^9, 3.431059558815053*^9}, {3.431065562490494*^9, 
   3.431065564681278*^9}, {3.431068896542932*^9, 3.431068900163909*^9}, {
   3.431091072366126*^9, 3.431091075388692*^9}, 3.435239964502668*^9, {
   3.43524047701989*^9, 3.435240541079809*^9}, {3.4473463774483023`*^9, 
   3.447346474204273*^9}, {3.4555982943169107`*^9, 3.4555982993763866`*^9}, {
   3.4567284718533297`*^9, 3.456728476184104*^9}, {3.456728655094939*^9, 
   3.456728657439526*^9}, {3.546421404662776*^9, 3.546421406526033*^9}, {
   3.54652936767837*^9, 3.54652946756905*^9}, {3.7020316868911867`*^9, 
   3.702031689212867*^9}, {3.7020320270837307`*^9, 3.702032027283873*^9}},
 CellLabel->
  "In[893]:=",ExpressionUUID->"c34cbde9-f05e-41dd-9133-6a64a632b292"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["calculations using Method\[Rule] \[OpenCurlyDoubleQuote]Direct\
\[CloseCurlyDoubleQuote]", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456369810807*^9, 3.430456391358386*^9}, 
   3.430456556431728*^9, {3.4305643986149607`*^9, 3.430564400498064*^9}, {
   3.430566885906928*^9, 3.430566886703034*^9}, {3.431058412294199*^9, 
   3.431058420738549*^9}, {3.431058915224729*^9, 3.4310589171922903`*^9}, {
   3.435239416356996*^9, 3.435239446852498*^9}, {3.558597986042652*^9, 
   3.558597988078454*^9}},ExpressionUUID->"e2d2e152-f16b-439e-9aa0-\
30db03ae2961"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "[", 
    RowBox[{"op_", ",", "opbasis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SparseArray", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"LiouvilleBracket", "[", 
        RowBox[{"#1", ",", "op", ",", "opts"}], "]"}], "&"}], "/@", 
      RowBox[{"BasisOperators", "[", "opbasis", "]"}]}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Method", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "OperatorVectorRepresentation", "]"}]}], ",", 
      "\"\<Direct\>\""}], "]"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.447346538898552*^9, 3.447346546563251*^9}, {
  3.4473471612321587`*^9, 3.4473471801644278`*^9}, {3.455598309608095*^9, 
  3.455598315084065*^9}, {3.558597995724079*^9, 3.55859799797548*^9}},
 CellLabel->
  "In[894]:=",ExpressionUUID->"2f85a7dc-732f-4978-a0d5-f6aaac533f66"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Extensions of QM`SpinOperators`", "Subchapter",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.435239277897923*^9, {3.532007915162407*^9, 3.5320079255701847`*^9}, {
   3.6167561313663692`*^9, 3.61675613557579*^9}, 
   3.682599866853743*^9},ExpressionUUID->"93320c6e-c3d5-4e21-b6c2-\
1eddf2f6bfd7"],

Cell[CellGroupData[{

Cell["store Operator as an OperatorVectorRepresentation", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.532008084626075*^9, 3.532008104497097*^9}, {
  3.630575946157336*^9, 
  3.630575946721416*^9}},ExpressionUUID->"99d02252-3f7d-4ebc-8617-\
2f41ad425bed"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Operator", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", 
     RowBox[{"opbasis", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
     RowBox[{"basis", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OperatorVectorRepresentation", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Operator", "[", 
        RowBox[{"op", ",", "basis", ",", "opts"}], "]"}], ",", 
       "\[IndentingNewLine]", "opbasis", ",", "basis"}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "opbasis", 
     ",", "basis", ",", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53200793589366*^9, 3.53200800667669*^9}, {
   3.532008038777014*^9, 3.532008074105687*^9}, 3.623335710752388*^9},
 CellLabel->
  "In[895]:=",ExpressionUUID->"fab69097-4b2f-4ba1-91f4-d535f917ec9c"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
MatrixRepresentation of an Operator containing a vector representation\
\>", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.532008084626075*^9, 3.532008104497097*^9}, {
  3.5320082843196*^9, 3.53200830856917*^9}, {3.5320084881534147`*^9, 
  3.5320085074264812`*^9}, {3.683203408016946*^9, 
  3.683203421893257*^9}},ExpressionUUID->"284c0f29-68d4-4b7e-8cca-\
4a88eb933d44"],

Cell[CellGroupData[{

Cell["requested MatrixRepresentation in Zeeman basis", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.623334692625937*^9, 3.623334695378375*^9}, {
  3.623335596269803*^9, 
  3.6233355975056973`*^9}},ExpressionUUID->"8dec1eb6-0ec8-41c0-ab87-\
be83b135cfe5"],

Cell["\<\
 take the OperatorVectorRepresentation in ZeemanKetBraOperatorBasis[Sorted \
\[Rule] \"Canonical\"] and partition it into sublists to get the \
MatrixRepresentation\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.623334705971511*^9, 
  3.62333472558913*^9}},ExpressionUUID->"a7e56ce5-0a06-401f-9a4c-\
6c9080ccd6ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"op", ":", 
       RowBox[{"Operator", "[", 
        RowBox[{
         RowBox[{"vec_", "?", "VectorQ"}], ",", "___"}], "]"}]}], ",", 
      RowBox[{"basis", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "___Rule"}], "]"}]}], "/;", 
   RowBox[{"MatchQ", "[", 
    RowBox[{"basis", ",", 
     RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"Partition", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"OperatorVectorRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{"op", ",", 
      RowBox[{"ZeemanKetBraOperatorBasis", "[", 
       RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}], ",", 
      "basis"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"BasisDimension", "[", "basis", "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellLabel->
  "In[896]:=",ExpressionUUID->"c738f160-299a-48d2-aa87-1672361772f8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"MatrixRepresentation", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"op", ":", 
        RowBox[{"Operator", "[", 
         RowBox[{
          RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
          RowBox[{"vecopbasis", ":", 
           RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
          RowBox[{"vecbasis", ":", 
           RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "___Rule"}], "]"}]}],
        ",", "\[IndentingNewLine]", 
       RowBox[{"basis", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "___Rule"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"vecopbasis", ",", "basis"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"ZeemanKetBraOperatorBasis", "[", 
          RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}], ",", 
         RowBox[{"ZeemanBasis", "[", "]"}]}], "}"}]}], "]"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], 
        ")"}], "&&", "\[IndentingNewLine]", 
       RowBox[{"MatchQ", "[", 
        RowBox[{
         RowBox[{"ifunc", "[", 
          RowBox[{"ifunc", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
          "]"}], ",", 
         RowBox[{"_", "?", "VectorQ"}]}], "]"}]}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Partition", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Replace", "[", 
       RowBox[{"ifunc", ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"v_", "?", "VectorQ"}], "\[RuleDelayed]", 
          RowBox[{"Partition", "[", 
           RowBox[{"v", ",", 
            RowBox[{"BasisDimension", "[", "basis", "]"}]}], "]"}]}], "}"}], 
        ",", 
        RowBox[{"{", "3", "}"}]}], "\[IndentingNewLine]", "]"}], "[", "t", 
      "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"BasisDimension", "[", "basis", "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.623334758746505*^9, 3.623334780644711*^9}, {
  3.623334850768051*^9, 3.623334980121045*^9}, {3.6233350153525467`*^9, 
  3.623335109868414*^9}},
 CellLabel->
  "In[897]:=",ExpressionUUID->"80db3592-3dbc-49cb-8d5e-d971c8e5fb00"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"MatrixRepresentation", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"op", ":", 
        RowBox[{"Operator", "[", 
         RowBox[{
          RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
          RowBox[{"vecopbasis", ":", 
           RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
          RowBox[{"vecbasis", ":", 
           RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "___Rule"}], "]"}]}],
        ",", "\[IndentingNewLine]", 
       RowBox[{"basis", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "___Rule"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{"basis", ",", 
       RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], 
        ")"}], "&&", "\[IndentingNewLine]", 
       RowBox[{"MatchQ", "[", 
        RowBox[{
         RowBox[{"ifunc", "[", 
          RowBox[{"ifunc", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
          "]"}], ",", 
         RowBox[{"_", "?", "VectorQ"}]}], "]"}]}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "zbasis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"zbasis", "=", 
        RowBox[{"ZeemanBasis", "[", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"MatrixRepresentation", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Operator", "[", 
          RowBox[{"op", ",", 
           RowBox[{"ZeemanKetBraOperatorBasis", "[", 
            RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}], ",", 
           "zbasis", ",", 
           RowBox[{"CheckOperatorType", "\[Rule]", "False"}]}], "]"}], ",", 
         "\[IndentingNewLine]", "zbasis"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.623335139610065*^9, 3.623335248565794*^9}, {
  3.623335633241788*^9, 3.623335646829681*^9}},
 CellLabel->
  "In[898]:=",ExpressionUUID->"37cd0f88-3ba8-45e5-a71a-dfbbbd22bb42"]
}, Closed]],

Cell[CellGroupData[{

Cell["requested MatrixRepresentation not in Zeeman basis", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.623334692625937*^9, 3.623334695378375*^9}, {
  3.623335292002219*^9, 3.623335292800414*^9}, {3.623335585435525*^9, 
  3.623335586882148*^9}},ExpressionUUID->"b9a46b35-7099-4150-829e-\
bf14c685c4a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"MatrixRepresentation", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"op", ":", 
        RowBox[{"Operator", "[", 
         RowBox[{"spec_", ",", 
          RowBox[{"Except", "[", "_Rule", "]"}], ",", 
          RowBox[{"Except", "[", "_Rule", "]"}], ",", "___"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"basis", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "___Rule"}], "]"}]}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"basis", ",", 
       RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "zbasis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"zbasis", "=", 
        RowBox[{"ZeemanBasis", "[", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
       "MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"BasisTransformationMatrix", "[", 
          RowBox[{"basis", ",", "zbasis"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{"op", ",", "zbasis"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"BasisTransformationMatrix", "[", 
          RowBox[{"zbasis", ",", "basis"}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6233354063271217`*^9, 3.623335566820306*^9}, {
  3.623335626667966*^9, 3.6233356275459137`*^9}},
 CellLabel->
  "In[899]:=",ExpressionUUID->"c758798e-246d-4b54-bbab-885dc7e12b24"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.439556134936461*^9, 3.4395561699887114`*^9}, {
   3.439556231249998*^9, 3.439556232460958*^9}, 3.460869867383815*^9, 
   3.4610005801119423`*^9, {3.531930388871133*^9, 
   3.531930390059944*^9}},ExpressionUUID->"ab8637d6-e468-4ba7-a1ba-\
cc0e71f4be35"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorVectorRepresentation", "::", "badop"}], "=", 
   "\"\<OperatorVectorRepresentation may only be applied to an \
operator.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5319303977523413`*^9, 3.5319304432399893`*^9}, {
  3.531930874126266*^9, 3.531930885497512*^9}},
 CellLabel->
  "In[900]:=",ExpressionUUID->"d22e7f8c-3fa0-4533-8e94-9945795ddc68"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ExpressOperator", "Subchapter",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.431059892057632*^9, 3.431060802965934*^9, {3.4594430378651123`*^9, 
   3.4594430410147133`*^9}},ExpressionUUID->"7fb32b84-acc1-4c04-bb02-\
68835047cbf6"],

Cell[CellGroupData[{

Cell["general properties", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 
  3.430456146975505*^9}},ExpressionUUID->"2a3d3625-239e-4544-9972-\
3579234f474e"],

Cell[CellGroupData[{

Cell["options", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, 
   3.459443314752941*^9, {3.543515043808036*^9, 
   3.543515044807495*^9}},ExpressionUUID->"aee82773-7da0-4812-8a5e-\
d8cd33e277ff"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ExpressOperator", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5435150474128*^9, 3.543515067520567*^9}, {
   3.5435156078505793`*^9, 3.543515632713056*^9}, 3.54394475790303*^9},
 CellLabel->
  "In[901]:=",ExpressionUUID->"ff9c3fb7-ceb7-4227-8543-a65e18b1ed54"]
}, Closed]],

Cell[CellGroupData[{

Cell["$Failed", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, 
   3.459443314752941*^9, {3.621156243655508*^9, 
   3.621156245781065*^9}},ExpressionUUID->"e0d3d774-bf35-4b9b-866f-\
7c192d8f0f5a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExpressOperator", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6211562517906227`*^9, 3.6211562829097023`*^9}, {
  3.621156322715345*^9, 3.621156324513763*^9}},
 CellLabel->
  "In[902]:=",ExpressionUUID->"10d1ff59-f43b-4f62-b9e7-0566fc4d2bb2"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
pass basis specifications into function, including traps for unknown opbasis\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, 
   3.459443314752941*^9, 
   3.6826086227243433`*^9},ExpressionUUID->"4ee88ad8-0bbb-418b-9bad-\
73e77337f3de"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpressOperator", "[", 
    RowBox[{"op_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"ExpressOperator", "[", 
    RowBox[{"op", ",", 
     RowBox[{"OperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483608249090567`*^9, 3.448360834338647*^9}, 
   3.456205556430071*^9, {3.4594432537231817`*^9, 3.459443254954708*^9}, {
   3.459443339656096*^9, 3.4594433414482193`*^9}, 3.461239969768067*^9},
 CellLabel->
  "In[903]:=",ExpressionUUID->"51ba9606-1200-425a-a691-209bdd502a6d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpressOperator", "[", 
    RowBox[{"op_", ",", "Undefined", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "unknown"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "default"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOperatorBasis", "[", 
      RowBox[{
       RowBox[{"DefaultOperatorBasis", "[", "]"}], ",", 
       RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ExpressOperator", "[", 
      RowBox[{"op", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, {3.44835995227402*^9, 
   3.448359994938308*^9}, {3.4483606824647713`*^9, 3.448360738493463*^9}, {
   3.448360895536944*^9, 3.448360911604973*^9}, {3.4594432773966217`*^9, 
   3.459443292875422*^9}, 3.4646077417906027`*^9, 3.5434986706054173`*^9, 
   3.547025333957465*^9},
 CellLabel->
  "In[904]:=",ExpressionUUID->"c072c856-0560-4c3f-9e7a-1afa8a1c5c7c"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["evaluation", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
  3.459443324047634*^9, 
  3.459443325566022*^9}},ExpressionUUID->"58bee56c-e908-473d-85c2-\
71dda3725ee3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ExpressOperator", "[", 
   RowBox[{
    RowBox[{"num_", "?", "NumericQ"}], ",", "opbasis_", ",", "opts___"}], 
   "]"}], ":=", "num"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.45951646310998*^9, 3.459516475982016*^9}},
 CellLabel->
  "In[905]:=",ExpressionUUID->"26e46738-9507-4e97-b5e5-7ea8277ffb20"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpressOperator", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", "opbasis_", ",", "opts___"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Chop", "[", 
    RowBox[{"Inner", "[", 
     RowBox[{"Times", ",", 
      RowBox[{"BasisOperators", "[", 
       RowBox[{"opbasis", ",", "opts"}], "]"}], ",", 
      RowBox[{"Normal", "@", 
       RowBox[{"OperatorVectorRepresentation", "[", 
        RowBox[{"op", ",", "opbasis"}], "]"}]}], ",", "Plus"}], "]"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.459443332088646*^9, 3.459443447776185*^9}, {
   3.4613301294121227`*^9, 3.461330133993479*^9}, {3.467720560612742*^9, 
   3.467720569202012*^9}, {3.5304638914490967`*^9, 3.530463897950344*^9}, {
   3.530464700139708*^9, 3.5304647017040787`*^9}, {3.53046714199828*^9, 
   3.530467167019946*^9}, {3.5435150786938877`*^9, 3.5435150949146852`*^9}, 
   3.543944739553339*^9, {3.702031363127175*^9, 3.7020314296452065`*^9}, {
   3.7020316130847425`*^9, 3.702031616360071*^9}},
 CellLabel->
  "In[906]:=",ExpressionUUID->"38f65ea5-7bcb-4b99-9bc1-b46226921a86"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["LiouvilleBracket", "Subchapter",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, {3.682608264616467*^9, 
   3.6826082687346573`*^9}, 
   3.6994347564266872`*^9},ExpressionUUID->"5be95d9e-3b09-47a9-bf91-\
245f9fd4e947"],

Cell[CellGroupData[{

Cell["general", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533043905498767*^9, 
  3.533043906392362*^9}},ExpressionUUID->"e441ca4f-6845-471b-a8a8-\
c13a44bbaf77"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "LiouvilleBracket", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Method", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"Normalize", "\[Rule]", "False"}]}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4298615198898983`*^9, 3.429861520462777*^9}, {
   3.4298683208432198`*^9, 3.429868342986383*^9}, 3.4298688630552683`*^9, {
   3.4306502020849247`*^9, 3.4306502028583097`*^9}, {3.430650387075979*^9, 
   3.430650387690188*^9}, {3.431056946979576*^9, 3.431056998654784*^9}, 
   3.431057258582741*^9, {3.431057395137857*^9, 3.43105740261629*^9}, {
   3.431057503002686*^9, 3.431057504074402*^9}, {3.43105774678799*^9, 
   3.4310577543755903`*^9}, {3.431059078277666*^9, 3.431059121064754*^9}, 
   3.433525881110385*^9, {3.4352397661807632`*^9, 3.435239766738275*^9}, 
   3.435241235058351*^9, 3.455685892369728*^9, {3.533043862584845*^9, 
   3.53304386598067*^9}},
 CellLabel->
  "In[907]:=",ExpressionUUID->"e850a97a-2c2f-4264-97ec-d43ca4c12db1"],

Cell[CellGroupData[{

Cell["$Failed", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.533043905498767*^9, 3.533043931001172*^9}, {
  3.533043966201683*^9, 3.5330439860305853`*^9}, {3.58729265801805*^9, 
  3.587292659231585*^9}},ExpressionUUID->"f851fdb6-2eb9-4e41-9124-\
d5a0c0055ef5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LiouvilleBracket", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.587292665125691*^9, 3.587292702676833*^9}, {
  3.682607596052876*^9, 3.6826076087489767`*^9}, {3.682608362996121*^9, 
  3.682608364778632*^9}},
 CellLabel->
  "In[908]:=",ExpressionUUID->"ab59d710-7fc7-4e1a-a413-1a49d4b5a8a8"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle matrices", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.533043905498767*^9, 
  3.533043917720489*^9}},ExpressionUUID->"9f37411b-b4da-4b29-b699-\
84b10fd041a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleBracket", "[", 
    RowBox[{
     RowBox[{"matrep1_", "?", "MatrixQ"}], ",", 
     RowBox[{"matrep2_", "?", "MatrixQ"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{"Adjoint", "[", 
      RowBox[{"Flatten", "[", "matrep1", "]"}], "]"}], ".", 
     RowBox[{"Flatten", "[", "matrep2", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431060314806202*^9, 3.431060453142529*^9}, {
   3.431072770768794*^9, 3.431072773585619*^9}, {3.431089308838982*^9, 
   3.431089317713994*^9}, {3.43109735791817*^9, 3.43109738006947*^9}, {
   3.435240403346181*^9, 3.435240433142581*^9}, {3.4492350403354187`*^9, 
   3.449235060566407*^9}, {3.456507527788475*^9, 3.456507579946145*^9}, {
   3.456507693246373*^9, 3.4565077118374653`*^9}, {3.462266320120281*^9, 
   3.462266323702344*^9}, {3.546527014379801*^9, 3.546527022217495*^9}, {
   3.6578211725433073`*^9, 3.657821175285927*^9}, 3.65952582853931*^9},
 CellLabel->
  "In[909]:=",ExpressionUUID->"916b0116-78b8-4972-b481-b165cc712459"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle numerics", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.533043905498767*^9, 
  3.533043931001172*^9}},ExpressionUUID->"17c94ce5-c29c-4619-8ae2-\
0599fd4cc168"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleBracket", "[", 
    RowBox[{
     RowBox[{"num_", "?", "NumericQ"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"num", "\[Times]", 
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{
      RowBox[{"UnityOperator", "[", "]"}], ",", "more", ",", "opts"}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429870368079813*^9, 3.429870430583303*^9}, 
   3.4308946726677847`*^9, {3.450289156838368*^9, 3.450289158121922*^9}, {
   3.4556859325460663`*^9, 3.455685971927601*^9}, {3.467633165089745*^9, 
   3.4676331948350077`*^9}, {3.468757517842984*^9, 3.468757548650896*^9}, 
   3.486465245718655*^9, {3.5465270319708014`*^9, 3.5465270361262903`*^9}},
 CellLabel->
  "In[910]:=",ExpressionUUID->"a63387e0-fca1-4026-8d21-fb73494a0943"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleBracket", "[", 
    RowBox[{"args__", ",", 
     RowBox[{"num_", "?", "NumericQ"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"num", "\[Times]", 
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{"args", ",", 
      RowBox[{"UnityOperator", "[", "]"}], ",", "more", ",", "opts"}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429870368079813*^9, 3.429870430583303*^9}, 
   3.4308946726677847`*^9, {3.450289156838368*^9, 3.450289158121922*^9}, {
   3.4556859325460663`*^9, 3.455685971927601*^9}, {3.467633165089745*^9, 
   3.4676331948350077`*^9}, {3.468757517842984*^9, 3.468757562789657*^9}, 
   3.4864652473361588`*^9, {3.5465270410731907`*^9, 3.546527045747596*^9}},
 CellLabel->
  "In[911]:=",ExpressionUUID->"56004075-8b48-4675-9915-e86dbcf03949"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle missing bases", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.533043905498767*^9, 3.533043931001172*^9}, {
  3.533043966201683*^9, 
  3.5330439860305853`*^9}},ExpressionUUID->"88bd6888-b735-4d5d-ac90-\
ee491db8f3c8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleBracket", "[", 
    RowBox[{
     RowBox[{"op1_", "?", "OperatorQ"}], ",", 
     RowBox[{"op2_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{"op1", ",", "op2", ",", 
      RowBox[{"ZeemanKetBraOperatorBasis", "[", 
       RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}], ",", 
      RowBox[{"ZeemanBasis", "[", "]"}], ",", "opts"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Method", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "LiouvilleBracket", "]"}]}], ",", 
      "Automatic"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429870368079813*^9, 3.429870430583303*^9}, 
   3.4308946726677847`*^9, {3.450289156838368*^9, 3.450289158121922*^9}, {
   3.4556859325460663`*^9, 3.455685971927601*^9}, {3.467633181813993*^9, 
   3.467633213677844*^9}, 3.546421409282343*^9, {3.6826080391915207`*^9, 
   3.682608043485795*^9}},
 CellLabel->
  "In[912]:=",ExpressionUUID->"0d1b0dc1-89bb-47d4-88ca-992c2ef4bd83"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LiouvilleBracket", "[", 
   RowBox[{
    RowBox[{"op1_", "?", "OperatorQ"}], ",", 
    RowBox[{"op2_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"LiouvilleBracket", "[", 
   RowBox[{"op1", ",", "op2", ",", 
    RowBox[{"OperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429870368079813*^9, 3.429870430583303*^9}, 
   3.4308946726677847`*^9, {3.450289156838368*^9, 3.450289158121922*^9}, 
   3.45620547910096*^9, 3.467633284491899*^9, 3.682608057701818*^9},
 CellLabel->
  "In[913]:=",ExpressionUUID->"c58e7bda-c562-45cd-bb0f-95909dc69020"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LiouvilleBracket", "[", 
   RowBox[{
    RowBox[{"op1_", "?", "OperatorQ"}], ",", 
    RowBox[{"op2_", "?", "OperatorQ"}], ",", "opbasis_", ",", "opts___Rule"}],
    "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"LiouvilleBracket", "[", 
   RowBox[{"op1", ",", "op2", ",", "opbasis", ",", 
    RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429870368079813*^9, 3.429870430583303*^9}, 
   3.4308946726677847`*^9, {3.450289156838368*^9, 3.4502892109991217`*^9}, 
   3.456162901267585*^9, {3.467633294290971*^9, 3.467633307322267*^9}, {
   3.682608064892791*^9, 3.682608069691862*^9}},
 CellLabel->
  "In[914]:=",ExpressionUUID->"0f566476-41c1-4296-a29c-2ef219ecbcca"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleBracket", "[", 
    RowBox[{
     RowBox[{"op1_", "?", "OperatorQ"}], ",", 
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"op2_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{"op1", ",", "sop", ",", "op2", ",", 
      RowBox[{"ZeemanKetBraOperatorBasis", "[", 
       RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}], ",", 
      RowBox[{"ZeemanBasis", "[", "]"}], ",", "opts"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Method", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "LiouvilleBracket", "]"}]}], ",", 
      "Automatic"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429870368079813*^9, 3.429870430583303*^9}, 
   3.4308946726677847`*^9, {3.450289156838368*^9, 3.450289158121922*^9}, {
   3.4556859325460663`*^9, 3.455685971927601*^9}, {3.467633181813993*^9, 
   3.467633213677844*^9}, 3.546421409282343*^9},
 CellLabel->
  "In[915]:=",ExpressionUUID->"34939d8f-63f3-4c1e-ab1a-14ad86fb7342"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LiouvilleBracket", "[", 
   RowBox[{
    RowBox[{"op1_", "?", "OperatorQ"}], ",", 
    RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
    RowBox[{"op2_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"LiouvilleBracket", "[", 
   RowBox[{"op1", ",", "op2", ",", 
    RowBox[{"OperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429870368079813*^9, 3.429870430583303*^9}, 
   3.4308946726677847`*^9, {3.450289156838368*^9, 3.450289158121922*^9}, 
   3.45620547910096*^9, 3.467633284491899*^9},
 CellLabel->
  "In[916]:=",ExpressionUUID->"bb3ed0b9-e22d-427c-87c6-71ea5392afdf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LiouvilleBracket", "[", 
   RowBox[{
    RowBox[{"op1_", "?", "OperatorQ"}], ",", 
    RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
    RowBox[{"op2_", "?", "OperatorQ"}], ",", "opbasis_", ",", "opts___Rule"}],
    "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"LiouvilleBracket", "[", 
   RowBox[{"op1", ",", "sop", ",", "op2", ",", "opbasis", ",", 
    RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429870368079813*^9, 3.429870430583303*^9}, 
   3.4308946726677847`*^9, {3.450289156838368*^9, 3.4502892109991217`*^9}, 
   3.456162901267585*^9, {3.467633294290971*^9, 3.467633307322267*^9}},
 CellLabel->
  "In[917]:=",ExpressionUUID->"80b81758-5f02-450d-9fb5-8e0ee1a3b536"]
}, Closed]],

Cell[CellGroupData[{

Cell["operators containing numericals inside dot products", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.533043905498767*^9, 3.533043931001172*^9}, {
  3.533043966201683*^9, 3.5330439860305853`*^9}, {3.5330440774462843`*^9, 
  3.5330440955971317`*^9}},ExpressionUUID->"2edcba2a-2ee4-4177-9ba5-\
afff8144b138"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleBracket", "[", 
    RowBox[{
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{"ops2b___", "?", "OperatorQ"}], ",", 
       RowBox[{"n_", "?", "NumericQ"}], ",", 
       RowBox[{"ops2a___", "?", "OperatorQ"}]}], "]"}], ",", 
     RowBox[{"op1_", "?", "OperatorQ"}], ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"n", "\[Times]", 
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{"ops2b", ",", "ops2a"}], "]"}], ",", "op1", ",", "opbasis", 
      ",", "basis", ",", "opts"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429870368079813*^9, 3.429870430583303*^9}, 
   3.4308946726677847`*^9, {3.450289156838368*^9, 3.4502892109991217`*^9}, 
   3.456162901267585*^9, {3.467633294290971*^9, 3.467633307322267*^9}, {
   3.483528344252223*^9, 3.483528419578517*^9}, {3.483528486491152*^9, 
   3.4835284993603363`*^9}, {3.682608140765251*^9, 3.6826081446667128`*^9}},
 CellLabel->
  "In[918]:=",ExpressionUUID->"1119e514-8eda-41ea-8da8-7f3b3247c70e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleBracket", "[", 
    RowBox[{
     RowBox[{"op2_", "?", "OperatorQ"}], ",", 
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{"ops1b___", "?", "OperatorQ"}], ",", 
       RowBox[{"n_", "?", "NumericQ"}], ",", 
       RowBox[{"ops1a___", "?", "OperatorQ"}]}], "]"}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"n", "\[Times]", 
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{"op2", ",", 
      RowBox[{"Dot", "[", 
       RowBox[{"ops1b", ",", "ops1a"}], "]"}], ",", "opbasis", ",", "basis", 
      ",", "opts"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429870368079813*^9, 3.429870430583303*^9}, 
   3.4308946726677847`*^9, {3.450289156838368*^9, 3.4502892109991217`*^9}, 
   3.456162901267585*^9, {3.467633294290971*^9, 3.467633307322267*^9}, {
   3.483528344252223*^9, 3.4835284703857393`*^9}, {3.682608150049411*^9, 
   3.682608153072377*^9}},
 CellLabel->
  "In[919]:=",ExpressionUUID->"2ab3b6b8-1843-4ad4-9afa-bec53acfe20f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleBracket", "[", 
    RowBox[{
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{"ops2b___", "?", "OperatorQ"}], ",", 
       RowBox[{"n_", "?", "NumericQ"}], ",", 
       RowBox[{"ops2a___", "?", "OperatorQ"}]}], "]"}], ",", 
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"op1_", "?", "OperatorQ"}], ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"n", "\[Times]", 
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{"ops2b", ",", "ops2a"}], "]"}], ",", "sop", ",", "op1", ",", 
      "opbasis", ",", "basis", ",", "opts"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429870368079813*^9, 3.429870430583303*^9}, 
   3.4308946726677847`*^9, {3.450289156838368*^9, 3.4502892109991217`*^9}, 
   3.456162901267585*^9, {3.467633294290971*^9, 3.467633307322267*^9}, {
   3.483528344252223*^9, 3.483528419578517*^9}, {3.483528486491152*^9, 
   3.4835284993603363`*^9}},
 CellLabel->
  "In[920]:=",ExpressionUUID->"8973e55d-8645-42b6-aa04-a2533f706b0c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LiouvilleBracket", "[", 
    RowBox[{
     RowBox[{"op2_", "?", "OperatorQ"}], ",", 
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{"ops1b___", "?", "OperatorQ"}], ",", 
       RowBox[{"n_", "?", "NumericQ"}], ",", 
       RowBox[{"ops1a___", "?", "OperatorQ"}]}], "]"}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"n", "\[Times]", 
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{"op2", ",", "sop", ",", 
      RowBox[{"Dot", "[", 
       RowBox[{"ops1b", ",", "ops1a"}], "]"}], ",", "opbasis", ",", "basis", 
      ",", "opts"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.429870368079813*^9, 3.429870430583303*^9}, 
   3.4308946726677847`*^9, {3.450289156838368*^9, 3.4502892109991217`*^9}, 
   3.456162901267585*^9, {3.467633294290971*^9, 3.467633307322267*^9}, {
   3.483528344252223*^9, 3.4835284703857393`*^9}},
 CellLabel->
  "In[921]:=",ExpressionUUID->"31296bcf-1bae-4347-b10a-f02c70437063"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["implement operator normalization", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533043905498767*^9, 3.533043931001172*^9}, {
  3.533043966201683*^9, 3.5330439860305853`*^9}, {3.5330440774462843`*^9, 
  3.5330441258533897`*^9}, {3.533044156341937*^9, 
  3.5330441574218388`*^9}},ExpressionUUID->"a5500022-c728-406a-82b0-\
81346b05f0ce"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{
      RowBox[{"op1_", "?", "OperatorQ"}], ",", 
      RowBox[{"op2_", "?", "OperatorQ"}], ",", "opbasis_", ",", "basis_", ",",
       "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Normalize", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "LiouvilleBracket", "]"}]}], ")"}]}], ":=", 
   RowBox[{"LiouvilleBracket", "[", 
    RowBox[{
     RowBox[{"NormalizeOperator", "[", "op1", "]"}], ",", 
     RowBox[{"NormalizeOperator", "[", "op2", "]"}], ",", "opbasis", ",", 
     "basis", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Normalize", "\[Rule]", "False"}], ",", "opts"}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533044133133057*^9, 3.533044205646542*^9}, {
  3.682608168561863*^9, 3.682608171673457*^9}},
 CellLabel->
  "In[922]:=",ExpressionUUID->"b12f2c28-625d-4417-ae85-bdb293051f46"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{
      RowBox[{"op1_", "?", "OperatorQ"}], ",", 
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
      RowBox[{"op2_", "?", "OperatorQ"}], ",", "opbasis_", ",", "basis_", ",",
       "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Normalize", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "LiouvilleBracket", "]"}]}], ")"}]}], ":=", 
   RowBox[{"LiouvilleBracket", "[", 
    RowBox[{
     RowBox[{"NormalizeOperator", "[", "op1", "]"}], ",", "sop", ",", 
     RowBox[{"NormalizeOperator", "[", "op2", "]"}], ",", "opbasis", ",", 
     "basis", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{
       RowBox[{"Normalize", "\[Rule]", "False"}], ",", "opts"}], "]"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533044133133057*^9, 3.533044205646542*^9}},
 CellLabel->
  "In[923]:=",ExpressionUUID->"9d8c6cbb-f04f-4b78-9ebb-d6ee079052f4"]
}, Closed]],

Cell[CellGroupData[{

Cell["main routine", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533043905498767*^9, 3.533043931001172*^9}, {
  3.533043966201683*^9, 3.5330439860305853`*^9}, {3.5330440774462843`*^9, 
  3.533044105989099*^9}},ExpressionUUID->"8fc45550-f96a-45d9-98d0-\
ac16a8e3ce8c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{
      RowBox[{"op1_", "?", "OperatorQ"}], ",", 
      RowBox[{"op2_", "?", "OperatorQ"}], ",", "opbasis_", ",", "basis_", ",",
       "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"!", "Normalize"}], "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "LiouvilleBracket", "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Adjoint", "[", 
      RowBox[{"OperatorVectorRepresentation", "[", 
       RowBox[{"op1", ",", "opbasis", ",", "basis"}], "]"}], "]"}], ".", 
     "\[IndentingNewLine]", 
     RowBox[{"OperatorVectorRepresentation", "[", 
      RowBox[{"op2", ",", "opbasis", ",", "basis"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4298703302175627`*^9, 3.429870360465839*^9}, {
   3.430894623149762*^9, 3.43089468253986*^9}, {3.431072756420648*^9, 
   3.43107276458302*^9}, {3.449235180341256*^9, 3.4492351824683027`*^9}, {
   3.4502890254368277`*^9, 3.4502890506634293`*^9}, {3.450289214116523*^9, 
   3.450289241497925*^9}, {3.450597508771222*^9, 3.450597519955976*^9}, {
   3.456507738443906*^9, 3.456507739926209*^9}, {3.462266291487095*^9, 
   3.4622662967807703`*^9}, 3.467633316591215*^9, {3.4676333852025414`*^9, 
   3.467633477501882*^9}, {3.533044214076049*^9, 3.533044216105426*^9}, {
   3.657821180604426*^9, 3.657821181429545*^9}, 3.659525830288056*^9, {
   3.6826081807388887`*^9, 3.68260818715582*^9}, {3.725618956764591*^9, 
   3.7256189701343417`*^9}, {3.7256190029459953`*^9, 3.7256190046938715`*^9}},
 
 CellLabel->
  "In[924]:=",ExpressionUUID->"a15dd698-ab7b-45d2-b63e-ae5b3b3aec54"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{
      RowBox[{"op1_", "?", "OperatorQ"}], ",", 
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
      RowBox[{"op2_", "?", "OperatorQ"}], ",", "opbasis_", ",", "basis_", ",",
       "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"!", "Normalize"}], "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "LiouvilleBracket", "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Simplify", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Adjoint", "[", 
      RowBox[{"OperatorVectorRepresentation", "[", 
       RowBox[{"op1", ",", "opbasis", ",", "basis"}], "]"}], "]"}], ".", 
     "\[IndentingNewLine]", 
     RowBox[{"SuperoperatorMatrixRepresentation", "[", 
      RowBox[{"sop", ",", "opbasis", ",", "basis"}], "]"}], ".", 
     RowBox[{"OperatorVectorRepresentation", "[", 
      RowBox[{"op2", ",", "opbasis", ",", "basis"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4298703302175627`*^9, 3.429870360465839*^9}, {
   3.430894623149762*^9, 3.43089468253986*^9}, {3.431072756420648*^9, 
   3.43107276458302*^9}, {3.449235180341256*^9, 3.4492351824683027`*^9}, {
   3.4502890254368277`*^9, 3.4502890506634293`*^9}, {3.450289214116523*^9, 
   3.450289241497925*^9}, {3.450597508771222*^9, 3.450597519955976*^9}, {
   3.456507738443906*^9, 3.456507739926209*^9}, {3.462266291487095*^9, 
   3.4622662967807703`*^9}, 3.467633316591215*^9, {3.4676333852025414`*^9, 
   3.467633477501882*^9}, {3.533044214076049*^9, 3.533044216105426*^9}, {
   3.657821180604426*^9, 3.657821181429545*^9}, 3.659525830288056*^9},
 CellLabel->
  "In[925]:=",ExpressionUUID->"3e3c59d0-4313-40ec-8163-70e97b9cc622"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OperatorAmplitude", "Subchapter",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.501995486271854*^9, 
  3.5023228434920187`*^9},ExpressionUUID->"f64ce82e-5ae5-4c80-a5ae-\
5b22e255bbb3"],

Cell["\<\
HoldAll attribute is used to allow checking of use with \
PolarizationLevelOperator and SingletPolarizationLevelOperator. These \
definitions are prepended in Polarization package.\
\>", "Text",
 CellChangeTimes->{{3.70938797202173*^9, 
  3.709388091658133*^9}},ExpressionUUID->"01deba27-5056-4282-a4a3-\
4a608e3214ff"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"OperatorAmplitude", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6825788036545343`*^9, 3.682578835660149*^9}},
 CellLabel->
  "In[926]:=",ExpressionUUID->"c1bccd20-68bc-4855-a795-d2ff946f2e71"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorAmplitude", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"op1_", "?", "OperatorQ"}], "\[Rule]", 
      RowBox[{"ops2", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"OperatorAmplitude", "[", 
      RowBox[{"#", ",", "op1", ",", "opts"}], "]"}], "&"}], "/@", "ops2"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53317642860861*^9, 3.533176456503396*^9}, {
  3.6149261625192957`*^9, 3.614926174324257*^9}, {3.614926214932602*^9, 
  3.614926221426915*^9}},
 CellLabel->
  "In[927]:=",ExpressionUUID->"3ab8c854-d5ec-42d4-aff3-5241dcc4a104"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorAmplitude", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"op1_", "?", "OperatorQ"}], "\[Rule]", 
      RowBox[{"op2_", "?", "OperatorQ"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"OperatorAmplitude", "[", 
    RowBox[{"op2", ",", "op1", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53317642860861*^9, 3.533176456503396*^9}, {
  3.709392078358973*^9, 3.709392082868638*^9}, {3.709392619915882*^9, 
  3.70939262245157*^9}},
 CellLabel->
  "In[928]:=",ExpressionUUID->"82db4624-664d-44d3-91f0-939cf0238abe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorAmplitude", "[", 
    RowBox[{
     RowBox[{"op2_", "?", "OperatorQ"}], ",", 
     RowBox[{"op1_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"OperatorAmplitude", "[", 
      RowBox[{"op2", ",", "opts"}], "]"}], "[", "op1", "]"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50201196434816*^9, 3.502011982899128*^9}, {
   3.502322844156321*^9, 3.50232284503621*^9}, {3.709391902575575*^9, 
   3.7093919214304943`*^9}, 3.709392633779331*^9},
 CellLabel->
  "In[929]:=",ExpressionUUID->"d3916b01-d254-48af-8d46-2cfbece1832b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OperatorAmplitude", "[", 
    RowBox[{
     RowBox[{"op2_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Function", "[", 
    RowBox[{"op1", ",", 
     RowBox[{
      RowBox[{"LiouvilleBracket", "[", 
       RowBox[{"op2", ",", "op1"}], "]"}], "/", 
      RowBox[{"LiouvilleBracket", "[", 
       RowBox[{"op2", ",", "op2"}], "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5019955094213448`*^9, 3.5019955838951807`*^9}, {
   3.501996824011607*^9, 3.501996839987803*^9}, 3.50232284570865*^9},
 CellLabel->
  "In[930]:=",ExpressionUUID->"c5b7c7a9-6126-4355-9d2c-f3b90ada2c1a"]
}, Closed]],

Cell[CellGroupData[{

Cell["Superoperators", "Subchapter",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.435239277897923*^9},ExpressionUUID->"5b5134ff-88a8-4f43-9ab4-\
4b8dd4ba61d4"],

Cell[CellGroupData[{

Cell["general properties", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.448348493237537*^9, {3.452691548815523*^9, 3.452691581492972*^9}, {
   3.4610478782013693`*^9, 3.461047883565037*^9}, {3.461067660355515*^9, 
   3.461067665856895*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"b9c36745-58a5-4d11-99a2-f9192203ba53"],

Cell[CellGroupData[{

Cell["products of superoperators applied to an operator", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.448348493237537*^9, {3.452691548815523*^9, 3.452691581492972*^9}, {
   3.4610478782013693`*^9, 3.461047883565037*^9}, {3.461067671929359*^9, 
   3.46106769129697*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"7feaaaf4-fe60-45b0-ba54-a3b94ef452e6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Dot", "/:", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"Dot", "[", 
        RowBox[{"sops__", "?", "SuperoperatorQ"}], "]"}], "[", 
       RowBox[{"op0_", "?", "OperatorQ"}], "]"}], "]"}], ":=", 
     RowBox[{"Fold", "[", 
      RowBox[{
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"op", ",", "sop"}], "}"}], ",", 
         RowBox[{"sop", "[", "op", "]"}]}], "]"}], ",", "op0", ",", 
       RowBox[{"Reverse", "[", 
        RowBox[{"{", "sops", "}"}], "]"}]}], "]"}]}]}], "\[IndentingNewLine]",
    "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120344299014*^9, 3.68312034875383*^9}, {
   3.745399697056713*^9, 3.745399700804751*^9}},
 CellLabel->
  "In[931]:=",ExpressionUUID->"5c867863-9e17-416c-95c3-38e68b6e55a1"]
}, Open  ]],

Cell[CellGroupData[{

Cell["sums of superoperators applied to an operator", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.448348493237537*^9, {3.452691548815523*^9, 3.452691581492972*^9}, {
   3.4610478782013693`*^9, 3.461047883565037*^9}, {3.461067671929359*^9, 
   3.46106769129697*^9}, {3.4612396337572517`*^9, 3.461239634403563*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"4c8ae5e8-5095-475f-b518-f667e66204ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Plus", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Plus", "/:", 
      RowBox[{"HoldPattern", "[", 
       RowBox[{
        RowBox[{"Plus", "[", 
         RowBox[{"sops__", "?", "SuperoperatorQ"}], "]"}], "[", 
        RowBox[{"op_", "?", "OperatorQ"}], "]"}], "]"}], ":=", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"#", "[", "op", "]"}], ")"}], "&"}], "/@", 
       RowBox[{"Plus", "[", "sops", "]"}]}]}], ";"}]}], "\[IndentingNewLine]",
    "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120344299014*^9, 3.683120366649678*^9}, {
   3.74539971025747*^9, 3.745399714363246*^9}},
 CellLabel->
  "In[932]:=",ExpressionUUID->"dd5b2967-b0f3-4fbc-aa3f-7e845abe8281"]
}, Open  ]],

Cell[CellGroupData[{

Cell["numerical factors of superoperators applied to an operator", \
"Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.448348493237537*^9, {3.452691548815523*^9, 3.452691581492972*^9}, {
   3.4610478782013693`*^9, 3.461047883565037*^9}, {3.461067671929359*^9, 
   3.46106769129697*^9}, {3.4612396337572517`*^9, 3.461239634403563*^9}, {
   3.4612397785740843`*^9, 3.461239782074744*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"ce3461fc-1174-4970-92d6-9211944b6c45"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Times", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Times", "/:", 
      RowBox[{"HoldPattern", "[", 
       RowBox[{
        RowBox[{"Times", "[", 
         RowBox[{"n_", ",", 
          RowBox[{"sop_", "?", "SuperoperatorQ"}]}], "]"}], "[", "op_", "]"}],
        "]"}], ":=", 
      RowBox[{"n", "\[Times]", 
       RowBox[{"sop", "[", "op", "]"}]}]}], ";"}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120344299014*^9, 3.683120385000902*^9}, {
   3.7453997199601393`*^9, 3.7453997233550453`*^9}},
 CellLabel->
  "In[933]:=",ExpressionUUID->"787908dd-8ec5-42ac-8c33-a34b02e0eece"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["SuperoperatorPattern", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.616754180353505*^9, 
  3.6167541841700897`*^9}},ExpressionUUID->"a3f8c46e-64b4-44bc-98cc-\
f5abada77b50"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SuperoperatorPattern", "=", 
   RowBox[{
   "_Superoperator", "|", "\[IndentingNewLine]", "_UnitySuperoperator", "|", 
    "_NullSuperoperator", "|", "\[IndentingNewLine]", 
    "_RotationSuperoperator", "|", "\[IndentingNewLine]", 
    "_CommutationSuperoperator", "|", "\[IndentingNewLine]", 
    "_LeftMultiplicationSuperoperator", "|", "\[IndentingNewLine]", 
    "_RightMultiplicationSuperoperator", "|", "\[IndentingNewLine]", 
    "_AntiCommutationSuperoperator", "|", "\[IndentingNewLine]", 
    "_DoubleCommutationSuperoperator", "|", "\[IndentingNewLine]", 
    "_ProjectionSuperoperator", "|", "\[IndentingNewLine]", 
    "_ShiftSuperoperator", "|", "\[IndentingNewLine]", 
    "_CoherenceOrderFiltrationSuperoperator", "|", "\[IndentingNewLine]", 
    "_SphericalComponentFiltrationSuperoperator", "|", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ifunc_InterpolatingFunction", "[", "_", "]"}], "/;", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], 
        ")"}], "&&", "\[IndentingNewLine]", 
       RowBox[{"MatchQ", "[", 
        RowBox[{
         RowBox[{"ifunc", "[", 
          RowBox[{"ifunc", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
          "]"}], ",", 
         RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}]}]}], ")"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.616753490220017*^9, 3.616753499116852*^9}, {
  3.6167535350405083`*^9, 3.61675353652645*^9}, {3.621510308752782*^9, 
  3.621510314382682*^9}, {3.727521808901579*^9, 3.727521834725322*^9}},
 CellLabel->
  "In[934]:=",ExpressionUUID->"98fcf83c-c135-482a-903b-b247cfd5e0aa"]
}, Closed]],

Cell[CellGroupData[{

Cell["SuperoperatorQ", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.448348493237537*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"2c27c355-b32a-4ee0-8526-cf4527371780"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorQ", "[", "$Failed", "]"}], "=", "$Failed"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448307746358148*^9, 3.448307754710662*^9}, 
   3.448348508873479*^9},
 CellLabel->
  "In[935]:=",ExpressionUUID->"fca145c6-d771-47c8-9f84-8812dd2bedc1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorQ", "[", 
    RowBox[{"sop", ":", "SuperoperatorPattern"}], "]"}], "=", "True"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291585748311*^9, 3.448291603371173*^9}, 
   3.4482916532125387`*^9, {3.4482919449213467`*^9, 3.448291948948346*^9}, {
   3.4483073628982487`*^9, 3.44830737590583*^9}, {3.448348553104063*^9, 
   3.448348600405418*^9}, {3.45269268318495*^9, 3.452692715110312*^9}, {
   3.4527115383025217`*^9, 3.452711562469709*^9}, {3.4554640098514442`*^9, 
   3.455464014936232*^9}, {3.455643482348558*^9, 3.4556434880155993`*^9}, {
   3.461046331688437*^9, 3.4610463392425823`*^9}, {3.46730295779823*^9, 
   3.467302959156369*^9}, {3.486710672324006*^9, 3.4867106744021072`*^9}, {
   3.531927211513831*^9, 3.531927220664624*^9}, {3.6167534516488037`*^9, 
   3.6167534869343557`*^9}, {3.6167535459739656`*^9, 3.6167535570460443`*^9}},
 
 CellLabel->
  "In[936]:=",ExpressionUUID->"3939d072-8f1c-44b6-b3a1-659aa9d4cc0c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SuperoperatorQ", "[", "notsop_", "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"notsop", ",", "SuperoperatorPattern"}], "]"}]}], ":=", 
   "False"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.617537444261169*^9, 3.617537493362212*^9}},
 CellLabel->
  "In[937]:=",ExpressionUUID->"0de9890b-eb3d-4223-a7f1-87895f32731c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SuperoperatorQ", "[", "failed_", "]"}], "/;", 
     RowBox[{"!", 
      RowBox[{"FreeQ", "[", 
       RowBox[{"failed", ",", "$Failed"}], "]"}]}]}], ":=", "$Failed"}], 
   ";"}], " "}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448307746358148*^9, 3.448307754710662*^9}, {
   3.6184010723182907`*^9, 3.618401094932248*^9}, {3.618476315091374*^9, 
   3.618476320153434*^9}, {3.618476679126749*^9, 3.618476682686364*^9}, 
   3.621510356539666*^9},
 CellLabel->
  "In[938]:=",ExpressionUUID->"7f05fabf-7311-428a-adf2-40443da0f47c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorQ", "[", 
     RowBox[{"op_", "?", "OperatorQ"}], "]"}]}], "=", "False"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.616678137947535*^9, 3.6166781565474167`*^9}, {
  3.616678282705254*^9, 3.616678284232209*^9}},
 CellLabel->
  "In[939]:=",ExpressionUUID->"e78afedf-3132-479f-8469-a85c73275137"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorQ", "[", 
     RowBox[{"Exp", "[", "x_", "]"}], "]"}]}], ":=", 
   RowBox[{"SuperoperatorQ", "[", "x", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291585748311*^9, 3.4482916413145857`*^9}, 
   3.4483076540074883`*^9, {3.448348511754261*^9, 3.448348513458089*^9}},
 CellLabel->
  "In[940]:=",ExpressionUUID->"53f3dbee-1d37-4d42-ad1e-21bdb454da8f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorQ", "[", 
     RowBox[{"E", "^", "x_"}], "]"}]}], ":=", 
   RowBox[{"SuperoperatorQ", "[", "x", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291585748311*^9, 3.4482916413145857`*^9}, 
   3.4483076540074883`*^9, {3.4483078876454773`*^9, 3.4483078921151247`*^9}, {
   3.448348515418449*^9, 3.448348517721401*^9}},
 CellLabel->
  "In[941]:=",ExpressionUUID->"90f6c981-8e57-4c8c-b027-3200281683b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorQ", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Plus", "[", 
      RowBox[{
       RowBox[{"_", "?", "SuperoperatorQ"}], ".."}], "]"}]}], "]"}], "=", 
   "True"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.616692211636157*^9, 3.6166922242134047`*^9}, {
   3.616692264597652*^9, 3.616692265413906*^9}, {3.617536967247057*^9, 
   3.6175369714990673`*^9}, {3.6184911669674664`*^9, 3.618491177716484*^9}, {
   3.6184915124763613`*^9, 3.618491516866287*^9}, 3.6184920284076977`*^9},
 CellLabel->
  "In[942]:=",ExpressionUUID->"d5fdeee7-06dc-49d0-b8d8-fa980b998cc4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorQ", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{"_", "?", "SuperoperatorQ"}], ".."}], "]"}]}], "]"}], "=", 
   "True"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448346191784813*^9, 3.448346221418975*^9}, {
   3.6166761818254642`*^9, 3.6166761851749783`*^9}, {3.616676258810763*^9, 
   3.6166762617923813`*^9}, {3.616692065277183*^9, 3.616692088382155*^9}, 
   3.616754612346336*^9, {3.617536982073863*^9, 3.617536986395844*^9}, {
   3.6184911911493807`*^9, 3.618491194850061*^9}, {3.618491533571248*^9, 
   3.618491536826786*^9}, 3.618492031170404*^9},
 CellLabel->
  "In[943]:=",ExpressionUUID->"ce93ae69-f308-47f9-b833-1948cfe28478"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorQ", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Times", "[", "x___", "]"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Switch", "[", 
    RowBox[{
     RowBox[{"Count", "[", 
      RowBox[{
       RowBox[{"{", "x", "}"}], ",", 
       RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "1", ",", "True", ",", "\[IndentingNewLine]", "0",
      ",", "False", ",", "\[IndentingNewLine]", "_", ",", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"SuperoperatorQ", "::", "badsoptimes"}], "]"}], ";", 
       "False"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.616692211636157*^9, 3.6166922242134047`*^9}, {
  3.617536951103672*^9, 3.617536956614582*^9}, {3.618491354953199*^9, 
  3.618491384966316*^9}, {3.61849228844678*^9, 3.618492387345748*^9}, {
  3.618492454491499*^9, 3.618492546405635*^9}},
 CellLabel->
  "In[944]:=",ExpressionUUID->"def4a254-855b-44ff-99ed-94b3cd028af3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorQ", "[", "x_", "]"}], ":=", "False"}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.448291844442856*^9, 3.448291854862982*^9}, 
   3.4483074348827744`*^9, {3.4483076873582897`*^9, 3.448307690050252*^9}, {
   3.4483079087170343`*^9, 3.448307910856666*^9}, 3.44834860471846*^9},
 CellLabel->
  "In[945]:=",ExpressionUUID->"3dba57a5-6935-4d47-ba27-2fef239a593f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorQ", "::", "badsoptimes"}], "=", 
   "\"\<An illegal Times product of superoperators has been detected.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.618492403747301*^9, 3.618492436360731*^9}, {
   3.6184924791317863`*^9, 3.618492484632615*^9}, 3.618492549577813*^9},
 CellLabel->
  "In[946]:=",ExpressionUUID->"4141aba1-fb29-44dd-917d-094479a1a8d6"]
}, Closed]],

Cell[CellGroupData[{

Cell["SuperoperatorType", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602942783511467`*^9, 3.460294279933426*^9}, {
   3.4602943668599854`*^9, 3.4602943676744823`*^9}, {3.502278447248674*^9, 
   3.502278473574972*^9}, 3.502283881676605*^9, 3.5041102136566563`*^9, {
   3.583412336036195*^9, 3.5834123367302322`*^9}, {3.583413035220707*^9, 
   3.583413036184409*^9}},ExpressionUUID->"c93ad0c1-7560-4ecf-9bd6-\
2f6238f74574"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5834131677343616`*^9, 
  3.583413168774453*^9}},ExpressionUUID->"c7131ed1-c0e9-4e52-ab7c-\
bc6d0bfdf9b6"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ValidSuperoperatorTypes", "=", 
   RowBox[{"{", 
    RowBox[{
    "Undefined", ",", "None", ",", "\"\<Hermitian\>\"", ",", 
     "\"\<AntiHermitian\>\"", ",", "\"\<Unitary\>\"", ",", "\"\<Normal\>\""}],
     "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531832812183824*^9, 3.531832823276425*^9}, {
  3.531927286187519*^9, 3.531927295937791*^9}, {3.586253502036892*^9, 
  3.586253505777844*^9}, {3.640490641223996*^9, 3.640490651523291*^9}},
 CellLabel->
  "In[947]:=",ExpressionUUID->"f775bb69-9468-4d6f-9214-e049c8a6b68e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SuperoperatorType", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"SuperoperatorType", "\[Rule]", "Undefined"}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583412571973632*^9, 3.583412590342128*^9}, {
  3.5834130638970613`*^9, 3.5834130653366423`*^9}, {3.5862535195499687`*^9, 
  3.5862535207061357`*^9}},
 CellLabel->
  "In[948]:=",ExpressionUUID->"af89f1c6-f1af-472f-92b3-60c36ae1a9b4"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to a Superoperator with an undetermined type", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5834131677343616`*^9, 3.5834132059134827`*^9}, {
   3.583413335297845*^9, 3.583413338630453*^9}, 3.5862536049251347`*^9, 
   3.586253839400291*^9},ExpressionUUID->"1e9db967-6d13-42d7-88a6-\
d7e810668a54"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"SuperoperatorType", "[", 
      RowBox[{"Superoperator", "[", 
       RowBox[{
        RowBox[{"args", ":", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
        "sopopts___Rule"}], "]"}], "]"}]}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"SuperoperatorType", "/.", 
        RowBox[{"{", "sopopts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Superoperator", "]"}]}], ",", "Undefined"}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SuperoperatorType", "[", "\[IndentingNewLine]", 
    RowBox[{"Superoperator", "[", 
     RowBox[{"args", ",", "\[IndentingNewLine]", 
      RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CheckSuperoperatorType", "\[Rule]", "True"}], ",", 
        "\[IndentingNewLine]", "sopopts"}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583412512271796*^9, 3.583412569063368*^9}, {
   3.58341306746511*^9, 3.5834130844516*^9}, {3.583413439090166*^9, 
   3.58341353700574*^9}, {3.5834135695913267`*^9, 3.583413577780837*^9}, {
   3.583413786896069*^9, 3.583413793776166*^9}, {3.5834138863169193`*^9, 
   3.58341388951789*^9}, 3.583414506713182*^9, {3.5862535562500257`*^9, 
   3.5862535575270452`*^9}},
 CellLabel->
  "In[949]:=",ExpressionUUID->"d31994eb-bb64-43f7-b09a-3c77f8499c04"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to a Superoperator with a predetermined type", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5834131677343616`*^9, 3.5834132059134827`*^9}, {
   3.583413335297845*^9, 3.583413338630453*^9}, 
   3.5862536049251347`*^9},ExpressionUUID->"de2f7d58-0313-453d-90d9-\
a4a315e1018d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"SuperoperatorType", "[", 
      RowBox[{"Superoperator", "[", 
       RowBox[{
        RowBox[{"args", ":", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
        "sopopts___Rule"}], "]"}], "]"}]}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SuperoperatorType", "/.", 
         RowBox[{"{", "sopopts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Superoperator", "]"}]}], ",", "Undefined"}], 
      "]"}]}]}], ":=", 
   RowBox[{
    RowBox[{"SuperoperatorType", "/.", 
     RowBox[{"{", "sopopts", "}"}]}], "/.", 
    RowBox[{"Options", "[", "SuperoperatorType", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583412512271796*^9, 3.583412569063368*^9}, {
   3.58341306746511*^9, 3.5834130844516*^9}, {3.583413439090166*^9, 
   3.5834134671439238`*^9}, 3.5834137983428783`*^9, 3.58341389338378*^9, {
   3.58341449067338*^9, 3.583414497680468*^9}, 3.586253566300415*^9},
 CellLabel->
  "In[950]:=",ExpressionUUID->"d64b5449-250e-4e02-b123-e79329d33fcc"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
apply to specific superoperator classes (without determining the matrix \
representation)\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5834131677343616`*^9, 3.583413222545339*^9}, {
  3.583414573885923*^9, 
  3.583414588617323*^9}},ExpressionUUID->"9cbc193a-71b7-42e8-94fc-\
8a5305a8bf3e"],

Cell[CellGroupData[{

Cell["\<\
CommutationSuperoperators & Left/RightMultiplicationSuperoperator\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.583414672857895*^9, 3.583414683464067*^9}, {
  3.58341485598251*^9, 3.583414856179861*^9}, {3.7275304313832483`*^9, 
  3.7275304419991894`*^9}},ExpressionUUID->"41a46fff-0f26-4b9c-9418-\
aed6dfa7c400"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorType", "[", 
    RowBox[{"CommutationSuperoperator", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], ",", "___Rule"}], "]"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Switch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OperatorType", "[", "op", "]"}], ",", "\[IndentingNewLine]", 
     "\t", "\"\<Hermitian\>\"", ",", "\"\<Hermitian\>\"", ",", 
     "\[IndentingNewLine]", "\t", "\"\<AntiHermitian\>\"", ",", 
     "\"\<AntiHermitian\>\"", ",", "\[IndentingNewLine]", "\t", 
     "\"\<Unitary\>\"", ",", "\"\<Unitary\>\"", ",", "\[IndentingNewLine]", 
     "\t", "\"\<Normal\>\"", ",", "\"\<Normal\>\"", ",", 
     "\[IndentingNewLine]", "\t", "_", ",", "None"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5862554380092*^9, 3.586255483382586*^9}, 
   3.640490700754037*^9},
 CellLabel->
  "In[951]:=",ExpressionUUID->"1283f5aa-0382-4a35-b82d-fab39fdf67e2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorType", "[", 
    RowBox[{"LeftMultiplicationSuperoperator", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], ",", "___Rule"}], "]"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Switch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OperatorType", "[", "op", "]"}], ",", "\[IndentingNewLine]", 
     "\t", "\"\<Hermitian\>\"", ",", "\"\<Hermitian\>\"", ",", 
     "\[IndentingNewLine]", "\t", "\"\<AntiHermitian\>\"", ",", 
     "\"\<AntiHermitian\>\"", ",", "\[IndentingNewLine]", "\t", 
     "\"\<Unitary\>\"", ",", "\"\<Unitary\>\"", ",", "\[IndentingNewLine]", 
     "\t", "\"\<Normal\>\"", ",", "\"\<Normal\>\"", ",", 
     "\[IndentingNewLine]", "\t", "_", ",", "None"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5862554380092*^9, 3.586255483382586*^9}, 
   3.640490700754037*^9, {3.7275236603898993`*^9, 3.7275236616897297`*^9}},
 CellLabel->
  "In[952]:=",ExpressionUUID->"1283f5aa-0382-4a35-b82d-fab39fdf67e2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorType", "[", 
    RowBox[{"RightMultiplicationSuperoperator", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], ",", "___Rule"}], "]"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Switch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OperatorType", "[", "op", "]"}], ",", "\[IndentingNewLine]", 
     "\t", "\"\<Hermitian\>\"", ",", "\"\<Hermitian\>\"", ",", 
     "\[IndentingNewLine]", "\t", "\"\<AntiHermitian\>\"", ",", 
     "\"\<AntiHermitian\>\"", ",", "\[IndentingNewLine]", "\t", 
     "\"\<Unitary\>\"", ",", "\"\<Unitary\>\"", ",", "\[IndentingNewLine]", 
     "\t", "\"\<Normal\>\"", ",", "\"\<Normal\>\"", ",", 
     "\[IndentingNewLine]", "\t", "_", ",", "None"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5862554380092*^9, 3.586255483382586*^9}, 
   3.640490700754037*^9, {3.727523670150075*^9, 3.72752367239108*^9}},
 CellLabel->
  "In[953]:=",ExpressionUUID->"1283f5aa-0382-4a35-b82d-fab39fdf67e2"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
general superoperator: determine the matrix representation and hence the type\
\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5834131677343616`*^9, 3.583413222545339*^9}, {
  3.583414650805183*^9, 
  3.5834146587227917`*^9}},ExpressionUUID->"9fcb1011-171a-4dd4-9144-\
111dc585c43c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorType", "[", 
    RowBox[{"sop_", "?", "SuperoperatorQ"}], "]"}], ":=", 
   RowBox[{"SuperoperatorType", "[", 
    RowBox[{"Superoperator", "[", "sop", "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583412597879341*^9, 3.5834126223318644`*^9}, {
  3.583413090127305*^9, 3.583413111299485*^9}},
 CellLabel->
  "In[954]:=",ExpressionUUID->"9c56a974-c0ef-4921-a4cc-82e42eecb809"]
}, Closed]],

Cell[CellGroupData[{

Cell["not a superoperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5834131677343616`*^9, 
  3.5834132310652742`*^9}},ExpressionUUID->"fdf2280a-52c8-4a32-b14a-\
22a117f59efd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorType", "[", "sop_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SuperoperatorType", "::", "notsop"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.58341263142636*^9, 3.58341265394473*^9}, {
   3.583412730693365*^9, 3.583412733218794*^9}, 3.583412815142377*^9, {
   3.5834131200593653`*^9, 3.583413128720415*^9}},
 CellLabel->
  "In[955]:=",ExpressionUUID->"ae33c9c0-d5a1-4ba4-bd2a-6ac43c058269"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorType", "::", "notsop"}], "=", 
   "\"\<SuperoperatorType may only be applied to a superoperator.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5834126708346252`*^9, 3.5834126820838127`*^9}, {
  3.583413134242036*^9, 3.583413145831051*^9}},
 CellLabel->
  "In[956]:=",ExpressionUUID->"4d0968b0-8fce-47a6-838b-9790b36e1537"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["NDiagonalize applied to superoperators", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460868924111771*^9, 3.4608689296052017`*^9}, {
  3.5860804276808357`*^9, 3.586080439135602*^9}, {3.586090268105177*^9, 
  3.586090270390416*^9}},ExpressionUUID->"323f3e9a-deab-49bc-8a11-\
24eee8b8223a"],

Cell[CellGroupData[{

Cell["$Failed", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.586080512708542*^9, 3.5860805202765512`*^9}, {
  3.586090275415501*^9, 3.586090279047696*^9}, {3.621614463221054*^9, 
  3.621614471706038*^9}},ExpressionUUID->"0ddb9f31-fabc-4af0-8089-\
0c7d80183d49"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NDiagonalize", "[", 
     RowBox[{
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "more___"}], "]"}], "/;", 
    
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"sop", ",", "more"}], "}"}], ",", "$Failed"}], "]"}]}]}], ":=",
    "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621614481386232*^9, 3.6216145002298393`*^9}, {
  3.702776922538372*^9, 3.7027769242205653`*^9}},
 CellLabel->
  "In[957]:=",ExpressionUUID->"8f088890-7695-43ea-87b2-9ed63b57315a"]
}, Closed]],

Cell[CellGroupData[{

Cell["use current OperatorBasis[] and Basis[] if missing", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.586080512708542*^9, 3.5860805202765512`*^9}, {
  3.586090275415501*^9, 
  3.586090279047696*^9}},ExpressionUUID->"6cfc3c72-3eb8-45f8-b1ba-\
a7aa7dab04e9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NDiagonalize", "[", 
    RowBox[{"sop", ",", 
     RowBox[{"OperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5860804424244223`*^9, 3.5860804854713793`*^9}, {
  3.5860902824345903`*^9, 3.586090299388029*^9}},
 CellLabel->
  "In[958]:=",ExpressionUUID->"7bd2cb38-67f3-4eeb-a0a1-81e7c3435871"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "opbasis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NDiagonalize", "[", 
    RowBox[{"sop", ",", "opbasis", ",", 
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5860804424244223`*^9, 3.5860804854713793`*^9}, {
  3.5860902824345903`*^9, 3.5860903168377037`*^9}},
 CellLabel->
  "In[959]:=",ExpressionUUID->"44632a1a-0cd2-4f66-8f6f-1b8ba71f921e"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to Superoperator in prediagonalized form", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.586080512708542*^9, 3.586080541277648*^9}, {
  3.586080775767825*^9, 3.5860808057898197`*^9}, {3.586082399407514*^9, 
  3.586082408223261*^9}, {3.5860851524986887`*^9, 3.586085155159286*^9}, {
  3.5860903218135033`*^9, 
  3.586090324177788*^9}},ExpressionUUID->"a184cbee-c2d0-4370-93a3-\
1c2fbe9f4ad0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "opbasis_", ",", 
       "basis1_", ",", "sopopts___Rule"}], "]"}], ",", "opbasis_", ",", 
     "basis2_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], ",", "opbasis", ",", 
     "basis2", ",", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"sopopts", ",", "opts"}], "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586080623025322*^9, 3.586080693204924*^9}, {
  3.5860823454200897`*^9, 3.5860823814112043`*^9}, {3.586090328674073*^9, 
  3.586090387818328*^9}, {3.58609045359559*^9, 3.58609048157124*^9}, {
  3.726057059058961*^9, 3.7260570649091744`*^9}, {3.726057254911135*^9, 
  3.726057257229808*^9}},
 CellLabel->
  "In[960]:=",ExpressionUUID->"13491074-3b99-421f-9ed0-c53e13e4a5e8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "opbasis1_", ",", 
       "basis1_", ",", "sopopts___Rule"}], "]"}], ",", "opbasis2_", ",", 
     "basis2_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Chop", "[", 
        RowBox[{
         RowBox[{"OperatorBasisTransformationMatrix", "[", 
          RowBox[{"opbasis2", ",", "opbasis1"}], "]"}], ".", "X"}], "]"}], 
       ",", "\[IndentingNewLine]", "evals", ",", "\[IndentingNewLine]", 
       RowBox[{"Chop", "[", 
        RowBox[{"Xinv", ".", 
         RowBox[{"OperatorBasisTransformationMatrix", "[", 
          RowBox[{"opbasis1", ",", "opbasis2"}], "]"}]}], "]"}]}], "}"}], ",",
      "\[IndentingNewLine]", "opbasis2", ",", "\[IndentingNewLine]", "basis2",
      ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", 
      RowBox[{"sopopts", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586080496491189*^9, 3.586080507239616*^9}, {
   3.5860805525626087`*^9, 3.586080618077929*^9}, {3.586080719050084*^9, 
   3.5860807894266167`*^9}, {3.586082275344873*^9, 3.58608228887719*^9}, 
   3.586082388633078*^9, {3.5860904037859898`*^9, 3.58609044366284*^9}, {
   3.586090492718584*^9, 3.586090547800976*^9}, {3.726057221020102*^9, 
   3.726057230289668*^9}, {3.726057263200042*^9, 3.7260572659589777`*^9}},
 CellLabel->
  "In[961]:=",ExpressionUUID->"d470c8a3-a470-4125-be71-9951f839e79b"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to Superoperator in non-prediagonalized form", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.586080512708542*^9, 3.586080541277648*^9}, {
   3.586080775767825*^9, 3.5860808057898197`*^9}, {3.586082399407514*^9, 
   3.586082422432811*^9}, {3.586085159331418*^9, 3.586085160824873*^9}, 
   3.586090564737152*^9},ExpressionUUID->"8de87d0d-8649-4966-a616-\
88675b385219"],

Cell["\<\
If NDiagonalize is used with Assumptions\[Rule]Automatic, the \
SuperoperatorType is used to determine the assumptions for \
OrthogonalEigenvectors. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5860829603371773`*^9, 3.586082993483173*^9}, {
  3.586090567954957*^9, 
  3.586090569016633*^9}},ExpressionUUID->"630cc393-b060-4417-a5fb-\
4e2fde8715ed"],

Cell["\<\
If NDiagonalize is used with Assumptions\[Rule]{a\[Rule]b..}, or Assumptions\
\[Rule]None or False, these rules supersede any based on the \
SuperoperatorType.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5860829603371773`*^9, 3.586082993483173*^9}, {
   3.58608341045536*^9, 3.586083433732214*^9}, {3.586083500890614*^9, 
   3.586083505242344*^9}, {3.5860850051935377`*^9, 3.586085013254365*^9}, {
   3.5860887513783007`*^9, 3.586088767338917*^9}, 
   3.586090574190566*^9},ExpressionUUID->"63c5949e-7e30-4978-87b5-\
e3ebb62c6d6f"],

Cell["\<\
In v2.12.3b6, the assumption of orthogonal eigenvectors was disabled for type \
\[OpenCurlyDoubleQuote]Normal\[CloseCurlyDoubleQuote]. This was incorrect and \
lead to incorrect results for thermalized relaxation superoperators.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.640411389234887*^9, 3.640411413791872*^9}, {
  3.640411469644186*^9, 3.6404114869917307`*^9}, {3.6404115171592627`*^9, 
  3.64041153201632*^9}, {3.640490245510507*^9, 
  3.6404902749942636`*^9}},ExpressionUUID->"be7f3713-4efa-4476-93d4-\
cf155d8fa1ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"mat_", "?", "MatrixQ"}], ",", "opbasis_", ",", "basis2_", ",",
        "sopopts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "opbasis_", 
     ",", "basis1_", ",", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ass1", ",", "ass2"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ass1", "=", 
        RowBox[{
         RowBox[{"Assumptions", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "NDiagonalize", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ass2", "=", 
        RowBox[{"Switch", "[", "\[IndentingNewLine]", 
         RowBox[{"ass1", ",", "\[IndentingNewLine]", 
          RowBox[{"None", "|", "False"}], ",", "False", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"_Rule", "..."}], "}"}], ",", "ass1", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Automatic", "|", "True"}], ",", "\[IndentingNewLine]", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
            "OrthogonalEigenvectors", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Switch", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"SuperoperatorType", "/.", 
                 RowBox[{"{", "sopopts", "}"}]}], "/.", 
                RowBox[{"Options", "[", "Superoperator", "]"}]}], ",", 
               "\[IndentingNewLine]", "\t", 
               RowBox[{
               "\"\<Hermitian\>\"", "|", "\"\<Unitary\>\"", "|", 
                "\"\<AntiHermitian\>\""}], ",", "True", ",", 
               "\[IndentingNewLine]", "\t", "_", ",", "False"}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"Cases", "[", 
              RowBox[{"ass1", ",", "_Rule"}], "]"}]}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "_", ",",
           "None"}], "\[IndentingNewLine]", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
          RowBox[{"mat", ",", "\[IndentingNewLine]", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Assumptions", "\[Rule]", "ass2"}], ",", 
             "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "opbasis",
          ",", "\[IndentingNewLine]", "basis1", ",", "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", 
          RowBox[{"sopopts", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586080623025322*^9, 3.586080693204924*^9}, {
   3.5860823454200897`*^9, 3.5860823814112043`*^9}, {3.586082428541574*^9, 
   3.586082730213779*^9}, {3.586082765132083*^9, 3.58608281869175*^9}, {
   3.5860828966497297`*^9, 3.586082926435439*^9}, {3.586083007680859*^9, 
   3.586083337228908*^9}, {3.586083440708686*^9, 3.586083575968532*^9}, {
   3.58608363229034*^9, 3.58608363933254*^9}, {3.586083888757841*^9, 
   3.5860839046690493`*^9}, {3.58608460907589*^9, 3.586084617680365*^9}, {
   3.586084736209659*^9, 3.586084755345783*^9}, {3.586084803159905*^9, 
   3.586084804820221*^9}, {3.586090580929549*^9, 3.5860906796625633`*^9}, 
   3.640411430291793*^9},
 CellLabel->
  "In[962]:=",ExpressionUUID->"0e1e1b2a-507d-4c8d-8a87-e166c42a12da"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to CommutationSuperoperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.586080512708542*^9, 3.586080541277648*^9}, {
   3.586080775767825*^9, 3.5860808057898197`*^9}, {3.586082399407514*^9, 
   3.586082422432811*^9}, {3.586085159331418*^9, 3.586085160824873*^9}, 
   3.586090564737152*^9, {3.586193005107567*^9, 
   3.58619301085002*^9}},ExpressionUUID->"ca071759-cb87-439f-9b06-\
aa45ca93fc5b"],

Cell[CellGroupData[{

Cell["\<\
extract a CommutationSuperoperator from inside a Superoperator\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5861930708592052`*^9, 3.586193084970389*^9}, {
   3.586193118562601*^9, 3.586193148029195*^9}, {3.586193317993219*^9, 
   3.5861933205842876`*^9}, 3.5861933562734003`*^9, {3.586194083280962*^9, 
   3.58619408751025*^9}, {3.586352550596405*^9, 3.5863525600027027`*^9}, {
   3.586352734830738*^9, 
   3.5863527424189377`*^9}},ExpressionUUID->"32069964-2a23-4b6e-a98d-\
0a0cde2707cb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
      RowBox[{
      "csop_CommutationSuperoperator", ",", "\[IndentingNewLine]", 
       "opbasis1_", ",", "basis1_", ",", "opts1___Rule"}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "opbasis2_", 
     ",", "basis2_", ",", "opts2___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"NDiagonalize", "[", 
    RowBox[{"csop", ",", "opbasis2", ",", "basis2", ",", "opts2"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586352636578087*^9, 3.586352709472597*^9}},
 CellLabel->
  "In[963]:=",ExpressionUUID->"6326fbec-82a7-4828-b8e1-1cc6233ca283"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
transform into \
ZeemanKetBraOperatorBasis[Sorted\[Rule]\[CloseCurlyDoubleQuote]Canonical\
\[CloseCurlyDoubleQuote]] and ZeemanBasis[]\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5861930708592052`*^9, 3.586193084970389*^9}, {
   3.586193118562601*^9, 3.586193148029195*^9}, {3.586193317993219*^9, 
   3.5861933205842876`*^9}, 3.5861933562734003`*^9, {3.586194083280962*^9, 
   3.58619408751025*^9}},ExpressionUUID->"cfe48c32-aa3c-49bd-8266-\
becb45bc6450"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
    "csop_CommutationSuperoperator", ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "X\[CapitalLambda]Xinv", ",", "X", ",", "evals", ",", "Xinv", ",", 
       "zkbop", ",", "zb"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"X\[CapitalLambda]Xinv", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"FreeQ", "[", 
               RowBox[{"#", ",", "$Failed"}], "]"}]}], ",", "$Failed", ",", 
             RowBox[{"First", "[", "#", "]"}]}], "]"}], "&"}], "@", 
          "\[IndentingNewLine]", 
          RowBox[{"NDiagonalize", "[", 
           RowBox[{"csop", ",", "zkbop", ",", "zb", ",", "opts"}], "]"}]}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"FreeQ", "[", 
            RowBox[{"X\[CapitalLambda]Xinv", ",", "$Failed"}], "]"}]}], ",", 
          "\[IndentingNewLine]", "$Failed", ",", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], "=", 
             "X\[CapitalLambda]Xinv"}], ";", "\[IndentingNewLine]", 
            RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"SparseArray", "@", 
                 RowBox[{"Chop", "[", 
                  RowBox[{
                   RowBox[{"OperatorBasisTransformationMatrix", "[", 
                    RowBox[{"opbasis", ",", "zkbop"}], "]"}], ".", "X"}], 
                  "]"}]}], ",", "\[IndentingNewLine]", "evals", ",", 
                "\[IndentingNewLine]", 
                RowBox[{"SparseArray", "@", 
                 RowBox[{"Chop", "[", 
                  RowBox[{"Xinv", ".", 
                   RowBox[{"OperatorBasisTransformationMatrix", "[", 
                    RowBox[{"zkbop", ",", "opbasis"}], "]"}]}], "]"}]}]}], 
               "}"}], ",", "\[IndentingNewLine]", "opbasis", ",", "zb", ",", 
              "opts"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]",
            ")"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"zkbop", "=", 
         RowBox[{"ZeemanKetBraOperatorBasis", "[", 
          RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"zb", "=", 
         RowBox[{"ZeemanBasis", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"!", 
           RowBox[{"MatchQ", "[", 
            RowBox[{"opbasis", ",", "zkbop"}], "]"}]}], ")"}], "||", 
         RowBox[{"(", 
          RowBox[{"!", 
           RowBox[{"MatchQ", "[", 
            RowBox[{"basis", ",", "zb"}], "]"}]}], ")"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586193370984785*^9, 3.58619339198556*^9}, {
   3.586193435871723*^9, 3.586193699548074*^9}, {3.586193766462414*^9, 
   3.586193783542148*^9}, {3.586194017890538*^9, 3.586194068191351*^9}, {
   3.586339386629806*^9, 3.586339426131521*^9}, 3.5863396520008173`*^9, {
   3.5863397816923437`*^9, 3.5863397848808193`*^9}, {3.586863235600972*^9, 
   3.586863241198414*^9}, {3.603296677836431*^9, 3.603296683632826*^9}, 
   3.603299526566625*^9, {3.621614593748785*^9, 3.621614624130816*^9}, {
   3.640605663257669*^9, 3.640605815353612*^9}},
 CellLabel->
  "In[964]:=",ExpressionUUID->"10e458f8-971e-4c78-8761-62460e8b2551"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
ensure operator is diagonalized in Zeeman basis, incorporating any \
assumptions used in the call to NDiagonalize\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5861930708592052`*^9, 3.586193084970389*^9}, {
  3.586193118562601*^9, 3.586193148029195*^9}, {3.586332367940892*^9, 
  3.586332376922327*^9}, {3.5863394934093103`*^9, 
  3.586339505915024*^9}},ExpressionUUID->"dd3cfdd7-e8fe-4821-9bbc-\
ff789f85a1b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NDiagonalize", "[", 
   RowBox[{
    RowBox[{"CommutationSuperoperator", "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], ",", "csopopts___Rule"}], "]"}], ",",
     "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CommutationSuperoperator", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"NDiagonalize", "[", 
        RowBox[{"op", ",", 
         RowBox[{"ZeemanBasis", "[", "]"}], ",", "csopopts", ",", "opts"}], 
        "]"}], ",", "\[IndentingNewLine]", "csopopts"}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "opbasis", 
     ",", "basis", ",", "opts"}], "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{"!", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"op", ",", 
      RowBox[{"Operator", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericMatrixQ"}], ",", "_List", ",", 
          RowBox[{"_", "?", "NumericMatrixQ"}]}], "}"}], ",", 
        RowBox[{"ZeemanBasis", "[", "]"}], ",", "___"}], "]"}]}], 
     "]"}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5861930198929243`*^9, 3.586193065439796*^9}, {
   3.586193150909848*^9, 3.5861932934494677`*^9}, 3.586193969014625*^9, {
   3.586194134024823*^9, 3.586194137279004*^9}, {3.58633238441495*^9, 
   3.5863323854535646`*^9}, {3.58633887160892*^9, 3.586338874692974*^9}, {
   3.587572223056869*^9, 3.5875722525887747`*^9}, {3.587572641059168*^9, 
   3.58757264568328*^9}},
 CellLabel->
  "In[965]:=",ExpressionUUID->"1ba50b39-3b99-4b70-b636-8e04ebb13f6f"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
CommutationSuperoperator of a diagonalized operator,  that is known or \
assumed to be Hermitian\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5861930708592052`*^9, 3.586193084970389*^9}, {
  3.586193118562601*^9, 3.586193148029195*^9}, {3.586193793280416*^9, 
  3.586193804238991*^9}, {3.5861948662666693`*^9, 3.5861948722737103`*^9}, {
  3.5863331014049463`*^9, 3.5863331186504927`*^9}, {3.586333371976274*^9, 
  3.586333378381918*^9}},ExpressionUUID->"13b150bb-e8c4-42a4-812f-\
e0c9884cf8f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CommutationSuperoperator", "[", 
      RowBox[{
       RowBox[{"op", ":", 
        RowBox[{"Operator", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Xop_", "?", "NumericMatrixQ"}], ",", "opevals_List", ",", 
            RowBox[{"Xopinv_", "?", "NumericMatrixQ"}]}], "}"}], ",", 
          "basis_", ",", "___Rule"}], "]"}]}], ",", "\[IndentingNewLine]", 
       "sopopts___Rule"}], "]"}], ",", "\[IndentingNewLine]", "opbasis_", ",",
      "basis_", ",", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "zkbop", ",", "zb", ",", "ass", ",", "opevecs", ",", "sopevecs"}], 
      "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"opevecs", "=", 
         RowBox[{"Orthogonalize", "@", 
          RowBox[{"Transpose", "[", "Xop", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"sopevecs", "=", 
         RowBox[{"KroneckerProduct", "[", 
          RowBox[{"opevecs", ",", 
           RowBox[{"ComplexExpand", "[", 
            RowBox[{"Conjugate", "/@", "opevecs"}], "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Chop", "@", 
             RowBox[{"Transpose", "[", "sopevecs", "]"}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Chop", "@", 
             RowBox[{"Flatten", "@", 
              RowBox[{"Outer", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"#1", "-", 
                   RowBox[{"Conjugate", "[", "#2", "]"}]}], ")"}], "&"}], ",",
                 "opevals", ",", "opevals"}], "]"}]}]}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Chop", "@", 
             RowBox[{"Conjugate", "[", "sopevecs", "]"}]}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          "opbasis", ",", "basis", ",", "opts"}], "\[IndentingNewLine]", 
         "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"zkbop", "=", 
         RowBox[{"ZeemanKetBraOperatorBasis", "[", 
          RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"zb", "=", 
         RowBox[{"ZeemanBasis", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"opbasis", ",", "zkbop"}], "]"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"basis", ",", "zb"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"OperatorType", "/.", 
               RowBox[{"{", "sopopts", "}"}]}], "/.", 
              RowBox[{"Options", "[", "Operator", "]"}]}], ",", 
             "\"\<Hermitian\>\""}], "]"}], "||", "\[IndentingNewLine]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"ass", "=", 
              RowBox[{
               RowBox[{"Assumptions", "/.", 
                RowBox[{"{", "sopopts", "}"}]}], "/.", 
               RowBox[{"Options", "[", "NDiagonalize", "]"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"MatchQ", "[", 
               RowBox[{"ass", ",", 
                RowBox[{"{", 
                 RowBox[{"_Rule", "..."}], "}"}]}], "]"}], "&&", 
              "\[IndentingNewLine]", 
              RowBox[{"MatchQ", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"OperatorType", "/.", "ass"}], "/.", 
                 RowBox[{"Options", "[", "NDiagonalize", "]"}]}], ",", 
                "\"\<Hermitian\>\""}], "]"}]}]}], ")"}]}], 
          "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586193825446396*^9, 3.5861939519191504`*^9}, {
   3.586194182657648*^9, 3.586194356574205*^9}, {3.586194948084222*^9, 
   3.5861949550329857`*^9}, {3.586195022953355*^9, 3.586195044277725*^9}, {
   3.586195193042886*^9, 3.586195207856022*^9}, {3.586195329481825*^9, 
   3.586195437975328*^9}, {3.586195468625557*^9, 3.5861955424197206`*^9}, {
   3.5861955890105667`*^9, 3.5861956063350887`*^9}, {3.586195710939522*^9, 
   3.586195715640574*^9}, {3.586195895047516*^9, 3.586195912140324*^9}, {
   3.586196031671316*^9, 3.586196034659556*^9}, {3.58619614593911*^9, 
   3.5861961757816563`*^9}, {3.58633313958514*^9, 3.586333316515246*^9}, {
   3.586333409458296*^9, 3.586333429937612*^9}, {3.5863334697035646`*^9, 
   3.586333526438724*^9}, {3.58633367790316*^9, 3.586333692643537*^9}, {
   3.586334265379261*^9, 3.586334305237886*^9}, {3.657821099217865*^9, 
   3.657821125072019*^9}, {3.659525835108934*^9, 3.659525836066061*^9}, {
   3.659534345235693*^9, 3.6595343549858303`*^9}, 3.6811322104665537`*^9},
 CellLabel->
  "In[966]:=",ExpressionUUID->"45673011-8d7d-45a9-be00-9fc9f043da9d"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
CommutationSuperoperator of a diagonalized operator,  that is known or \
assumed to be AntiHermitian\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5861930708592052`*^9, 3.586193084970389*^9}, {
  3.586193118562601*^9, 3.586193148029195*^9}, {3.586193793280416*^9, 
  3.586193804238991*^9}, {3.5861948662666693`*^9, 3.5861948722737103`*^9}, {
  3.5863331014049463`*^9, 3.5863331186504927`*^9}, {3.586333371976274*^9, 
  3.586333378381918*^9}, {3.586334325652465*^9, 
  3.586334326346982*^9}},ExpressionUUID->"50a70200-55fa-43ab-902c-\
6f083e78914f"],

Cell["the operator is known to be AntiHermitian:", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586335323937525*^9, 
  3.586335341919628*^9}},ExpressionUUID->"526938b7-551e-47e8-b8e0-\
83f8302f7b04"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CommutationSuperoperator", "[", 
       RowBox[{
        RowBox[{"op", ":", 
         RowBox[{"Operator", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Xop_", "?", "NumericMatrixQ"}], ",", "opevals_List", 
             ",", 
             RowBox[{"Xopinv_", "?", "NumericMatrixQ"}]}], "}"}], ",", 
           "basis_", ",", "opopts___Rule"}], "]"}]}], ",", 
        "\[IndentingNewLine]", "sopopts___Rule"}], "]"}], ",", 
      "\[IndentingNewLine]", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
     "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"OperatorType", "/.", 
        RowBox[{"{", "sopopts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Operator", "]"}]}], ",", 
      "\"\<AntiHermitian\>\""}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"MapAt", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Times", "[", 
       RowBox[{"I", ",", "#"}], "]"}], "&"}], ",", "\[IndentingNewLine]", 
     RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"CommutationSuperoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Operator", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Xop", ",", 
             RowBox[{
              RowBox[{"-", "I"}], " ", "opevals"}], ",", "Xopinv"}], "}"}], 
           ",", "basis", ",", "\[IndentingNewLine]", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"OperatorType", " ", "\[Rule]", "\"\<Hermitian\>\""}], 
             ",", "\[IndentingNewLine]", "opopts"}], "\[IndentingNewLine]", 
            "]"}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"OperatorType", " ", "\[Rule]", "\"\<Hermitian\>\""}], ",",
            "\[IndentingNewLine]", "sopopts"}], "\[IndentingNewLine]", 
          "]"}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       "opbasis", ",", "basis", ",", "opts"}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5863353513397503`*^9, 3.586335378083205*^9}, {
   3.586335410121337*^9, 3.586335428072012*^9}, {3.5863357530837793`*^9, 
   3.5863357795437813`*^9}, 3.586335849168174*^9, 3.586336274701043*^9, {
   3.586336354165769*^9, 3.586336404545393*^9}, {3.586336830945586*^9, 
   3.586336864109103*^9}},
 CellLabel->
  "In[967]:=",ExpressionUUID->"a052cf41-a2b6-496d-9193-fa3f282889de"],

Cell["the operator is assumed to be AntiHermitian:", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586335323937525*^9, 3.586335341919628*^9}, {
  3.58633538662332*^9, 
  3.586335387627162*^9}},ExpressionUUID->"9440fcca-6980-4433-83fa-\
97f547dd06fc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CommutationSuperoperator", "[", 
      RowBox[{
       RowBox[{"op", ":", 
        RowBox[{"Operator", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Xop_", "?", "NumericMatrixQ"}], ",", "opevals_List", ",", 
            RowBox[{"Xopinv_", "?", "NumericMatrixQ"}]}], "}"}], ",", 
          "basis_", ",", "opopts___Rule"}], "]"}]}], ",", 
       "\[IndentingNewLine]", "sopopts___Rule"}], "]"}], ",", 
     "\[IndentingNewLine]", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "ass", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"MapAt", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"Times", "[", 
           RowBox[{"I", ",", "#"}], "]"}], "&"}], ",", "\[IndentingNewLine]", 
         
         RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"CommutationSuperoperator", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Operator", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"Xop", ",", 
                 RowBox[{
                  RowBox[{"-", "I"}], " ", "opevals"}], ",", "Xopinv"}], 
                "}"}], ",", "basis", ",", "\[IndentingNewLine]", 
               RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"OperatorType", "\[Rule]", "Undefined"}], ",", 
                 "\[IndentingNewLine]", "opopts"}], "]"}]}], 
              "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Assumptions", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"OperatorType", "\[Rule]", "\"\<Hermitian\>\""}], 
                 "}"}]}], ",", "\[IndentingNewLine]", "sopopts"}], 
              "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
           ",", "\[IndentingNewLine]", "opbasis", ",", "basis", ",", "opts"}],
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}]}], "\[IndentingNewLine]", "]"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ass", "=", 
         RowBox[{
          RowBox[{"Assumptions", "/.", 
           RowBox[{"{", "sopopts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "NDiagonalize", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"ass", ",", 
           RowBox[{"{", 
            RowBox[{"_Rule", "..."}], "}"}]}], "]"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"OperatorType", "/.", "ass"}], "/.", 
            RowBox[{"Options", "[", "NDiagonalize", "]"}]}], ",", 
           "\"\<AntiHermitian\>\""}], "]"}]}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586193825446396*^9, 3.5861939519191504`*^9}, {
   3.586194182657648*^9, 3.586194356574205*^9}, {3.586194948084222*^9, 
   3.5861949550329857`*^9}, {3.586195022953355*^9, 3.586195044277725*^9}, {
   3.586195193042886*^9, 3.586195207856022*^9}, {3.586195329481825*^9, 
   3.586195437975328*^9}, {3.586195468625557*^9, 3.5861955424197206`*^9}, {
   3.5861955890105667`*^9, 3.5861956063350887`*^9}, {3.586195710939522*^9, 
   3.586195715640574*^9}, {3.586195895047516*^9, 3.586195912140324*^9}, {
   3.586196031671316*^9, 3.586196034659556*^9}, {3.58619614593911*^9, 
   3.5861961757816563`*^9}, {3.58633313958514*^9, 3.586333316515246*^9}, {
   3.586333409458296*^9, 3.586333429937612*^9}, {3.5863334697035646`*^9, 
   3.586333526438724*^9}, {3.58633367790316*^9, 3.586333692643537*^9}, {
   3.586334265379261*^9, 3.586334337965036*^9}, {3.5863343824933977`*^9, 
   3.586334628692149*^9}, 3.586334672123804*^9, {3.586335393393743*^9, 
   3.5863353966116333`*^9}, {3.5863354403978243`*^9, 3.586335484189693*^9}, 
   3.586336278298324*^9, {3.586336439325679*^9, 3.5863364555946007`*^9}, {
   3.5863368724249363`*^9, 3.5863368843980417`*^9}},
 CellLabel->
  "In[968]:=",ExpressionUUID->"1c562bce-41fb-481a-8cb8-411d7025a535"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to a general superoperator expression", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.586080512708542*^9, 3.586080541277648*^9}, {
  3.586080775767825*^9, 3.586080826903056*^9}, {3.58608517312304*^9, 
  3.586085180744526*^9}, {3.586090697580158*^9, 
  3.586090698368948*^9}},ExpressionUUID->"590e7e31-aa88-4a9f-8eb9-\
e5f8656935e3"],

Cell["take the matrix representation and diagonalize that", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586335505276475*^9, 3.586335509467781*^9}, {
  3.586337683848269*^9, 
  3.586337697699328*^9}},ExpressionUUID->"85099355-9edb-48c6-83dc-\
cfc320246f2e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NDiagonalize", "[", 
    RowBox[{
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "opbasis_", ",", "basis_", 
     ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
       "SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
        RowBox[{
        "sop", ",", "\[IndentingNewLine]", "opbasis", ",", "basis", ",", 
         "opts"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       "opbasis", ",", "basis", ",", "opts"}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", "opbasis", ",", "basis", ",", "opts"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5860808358429127`*^9, 3.586080885111555*^9}, {
  3.586083599118425*^9, 3.586083628851824*^9}, {3.586090702351193*^9, 
  3.58609072876567*^9}, {3.58633764201967*^9, 3.586337676249291*^9}},
 CellLabel->
  "In[969]:=",ExpressionUUID->"bf6a9465-eae7-4571-a0b0-35fee49c612a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Superoperator", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4602942783511467`*^9, 3.460294279933426*^9}, {
   3.4602943668599854`*^9, 3.4602943676744823`*^9}, {3.502278447248674*^9, 
   3.502278473574972*^9}, 3.502283881676605*^9, 3.5041102136566563`*^9, {
   3.531927265352499*^9, 
   3.5319272665493813`*^9}},ExpressionUUID->"249c2a98-4d4e-473a-a550-\
221c2f6da218"],

Cell["\<\
Superoperator converts a superoperator expression into the Superoperator[..] \
form which either contains the explicit matrix representation in a given \
operator basis, or as a CommutationSuperoperator of an operator, expressed as \
a matrix in a given basis. The options to Superoperator may specify the \
SuperoperatorType, which may be deduced automatically from the form of the \
superoperator matrix representation, or from the contained operator, in the \
case of a CommutationSuperoperator.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.583428957871188*^9, 
  3.5834290878728952`*^9}},ExpressionUUID->"b49380d2-d505-4310-8682-\
8149993a4049"],

Cell[CellGroupData[{

Cell["options", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
  3.531829109549362*^9, 
  3.531829110545513*^9}},ExpressionUUID->"2c54f03b-cba6-4f5a-a264-\
b0dccba970db"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Superoperator", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"SuperoperatorType", "\[Rule]", "Undefined"}], ",", 
     RowBox[{"CheckSuperoperatorType", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"CheckMatrixDimensions", "\[Rule]", "True"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQAWIQ/SUr531uwCtHKUe3DyD6iZXdFxAtVqv3FUTbZTnw
5wHpnHP1YPrSoXh9EG2nJm0Aoru3Ho4C0VZPr4HppsK0u3OBdOqs9Hsg+s4G
t4qFIHNtE8G06vciriNA+lF0Hh+I/sTGysIV+Mqxo08RTH/KcN7gufGVo5JW
IZiWWsy86camV46n/Kw3g+jQxUtKboLoNssqEH1D0rEbREd1rwPT/5wfhvDu
eOUYZMobBaKVqt/Fgeipq5TjQfShbd8T+IH0jVqORBD979/t14JAumnnSzCd
c1DiqzWQzk5yBtMT9sXy2wDpbxXZYDqqQOjiM/nXjlM2SoFpABExo2o=
  "],
 CellLabel->
  "In[970]:=",ExpressionUUID->"632488ff-2229-414d-98ec-535bff5317d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SuperoperatorTypeCheckDisableThreshold", "=", "32"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586157255893023*^9, 3.5861572572833157`*^9}, {
  3.586163733800481*^9, 3.586163733933466*^9}, {3.586163824422285*^9, 
  3.586163825915391*^9}},
 CellLabel->
  "In[971]:=",ExpressionUUID->"7f9b942e-efb2-4c75-9e16-a5fe735a2f50"]
}, Closed]],

Cell[CellGroupData[{

Cell["output", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.505845569522201*^9, 
  3.505845570577057*^9}},ExpressionUUID->"9225cdde-45da-484f-b40c-\
e97607fec3eb"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{"Superoperator", "[", 
     RowBox[{
      RowBox[{"mat_", "?", "MatrixQ"}], ",", "opbasis_", ",", "basis_", ",", 
      "opts___Rule"}], "]"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "soptype", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"soptype", "=", 
        RowBox[{
         RowBox[{"SuperoperatorType", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Superoperator", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"DisplayForm", "[", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ToBoxes", "[", "\"\<Superoperator[<<..>>, \>\"", "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"ToBoxes", "[", "\"\<SuperoperatorType\[Rule]\>\"", "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"StringQ", "[", "soptype", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"\"\<\\\"\>\"", "<>", "soptype", "<>", "\"\<\\\"\>\""}],
               "]"}], ",", "soptype"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"ToBoxes", "[", "\"\<]\>\"", "]"}]}], 
          "\[IndentingNewLine]", "}"}], "]"}], "\[IndentingNewLine]", "]"}]}],
       "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506526794569*^9, 3.456506591362196*^9}, {
   3.456506807868026*^9, 3.456506808025032*^9}, {3.456506916908573*^9, 
   3.4565069187852793`*^9}, {3.4565070618491907`*^9, 3.456507073361253*^9}, {
   3.456507104811401*^9, 3.456507132515758*^9}, {3.456507184889974*^9, 
   3.456507193088976*^9}, {3.456507308088336*^9, 3.456507322174239*^9}, {
   3.456507881744112*^9, 3.45650788247845*^9}, {3.45934179309993*^9, 
   3.459341855795616*^9}, {3.459341927566702*^9, 3.459342010299419*^9}, {
   3.459408401457662*^9, 3.4594084060043497`*^9}, {3.459409171653989*^9, 
   3.459409261062017*^9}, {3.459411850954893*^9, 3.459411852765896*^9}, 
   3.459427841061582*^9, {3.5058453736883297`*^9, 3.505845453285803*^9}, {
   3.505845934787327*^9, 3.5058459398965483`*^9}, {3.5059206249463463`*^9, 
   3.505920714259027*^9}, {3.5059207904390087`*^9, 3.50592084274937*^9}, {
   3.505920876055406*^9, 3.5059208795117893`*^9}, {3.505920928122828*^9, 
   3.505920943225092*^9}, {3.505921041267743*^9, 3.505921043521144*^9}, {
   3.531832898426354*^9, 3.531833020895165*^9}, {3.531833065813417*^9, 
   3.53183322926646*^9}, 3.531833300367432*^9, {3.531833366624659*^9, 
   3.531833367453512*^9}, {3.5318334173003817`*^9, 3.531833424327524*^9}, {
   3.531833487567684*^9, 3.531833512467223*^9}, {3.531833605427472*^9, 
   3.531833683472148*^9}, {3.531833727563027*^9, 3.531833817599286*^9}, {
   3.531927305597039*^9, 3.531927350794832*^9}, {3.531929402070959*^9, 
   3.531929403010537*^9}, {3.53192950144975*^9, 3.531929545661614*^9}, {
   3.531929585667576*^9, 3.531929588720183*^9}, {3.640512946852804*^9, 
   3.640512954211928*^9}},
 CellLabel->
  "In[972]:=",ExpressionUUID->"7c08b054-5311-4a0e-ba44-d8b8d6af69f8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{"Superoperator", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
        RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "opbasis_", ",", 
      "basis_", ",", "opts___Rule"}], "]"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "soptype", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"soptype", "=", 
        RowBox[{
         RowBox[{"SuperoperatorType", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Superoperator", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"DisplayForm", "[", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
          "\"\<Superoperator[DiagonalizedForm[<<..\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Dimensions", "[", "X", "]"}], ",", "\[IndentingNewLine]", 
           
           RowBox[{
           "ToBoxes", "[", "\"\<..>>], SuperoperatorType\[Rule]\>\"", "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"StringQ", "[", "soptype", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"\"\<\\\"\>\"", "<>", "soptype", "<>", "\"\<\\\"\>\""}],
               "]"}], ",", "soptype"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"ToBoxes", "[", "\"\<]\>\"", "]"}]}], 
          "\[IndentingNewLine]", "}"}], "]"}], "\[IndentingNewLine]", "]"}]}],
       "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506526794569*^9, 3.456506591362196*^9}, {
   3.456506807868026*^9, 3.456506808025032*^9}, {3.456506916908573*^9, 
   3.4565069187852793`*^9}, {3.4565070618491907`*^9, 3.456507073361253*^9}, {
   3.456507104811401*^9, 3.456507132515758*^9}, {3.456507184889974*^9, 
   3.456507193088976*^9}, {3.456507308088336*^9, 3.456507322174239*^9}, {
   3.456507881744112*^9, 3.45650788247845*^9}, {3.45934179309993*^9, 
   3.459341855795616*^9}, {3.459341927566702*^9, 3.459342010299419*^9}, {
   3.459408401457662*^9, 3.4594084060043497`*^9}, {3.459409171653989*^9, 
   3.459409261062017*^9}, {3.459411850954893*^9, 3.459411852765896*^9}, 
   3.459427841061582*^9, {3.5058453736883297`*^9, 3.505845453285803*^9}, {
   3.505845934787327*^9, 3.5058459398965483`*^9}, {3.5059206249463463`*^9, 
   3.505920714259027*^9}, {3.5059207904390087`*^9, 3.50592084274937*^9}, {
   3.505920876055406*^9, 3.5059208795117893`*^9}, {3.505920928122828*^9, 
   3.505920943225092*^9}, {3.505921041267743*^9, 3.505921043521144*^9}, {
   3.531832898426354*^9, 3.531833020895165*^9}, {3.531833065813417*^9, 
   3.53183322926646*^9}, 3.531833300367432*^9, {3.531833366624659*^9, 
   3.531833367453512*^9}, {3.5318334173003817`*^9, 3.531833424327524*^9}, {
   3.531833487567684*^9, 3.531833512467223*^9}, {3.531833605427472*^9, 
   3.531833683472148*^9}, {3.531833727563027*^9, 3.531833817599286*^9}, {
   3.5860818707442207`*^9, 3.5860819891260443`*^9}, {3.5860910840699177`*^9, 
   3.586091140674996*^9}, 3.5860913576036243`*^9},
 CellLabel->
  "In[973]:=",ExpressionUUID->"4fc56183-a4f7-480c-9f3a-744d44d60461"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"CommutationSuperoperator", "[", 
        RowBox[{
         RowBox[{"Operator", "[", 
          RowBox[{"opspecs_", ",", "___"}], "]"}], ",", "___"}], "]"}], ",", 
       "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "soptype", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"soptype", "=", 
        RowBox[{
         RowBox[{"SuperoperatorType", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Superoperator", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"DisplayForm", "[", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
          "\"\<Superoperator[CommutationSuperoperator[Operator[<<\>\"", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Switch", "[", 
            RowBox[{"opspecs", ",", "\[IndentingNewLine]", 
             RowBox[{"_", "?", "MatrixQ"}], ",", "\[IndentingNewLine]", "\t", 
             
             RowBox[{"Dimensions", "[", "opspecs", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
               RowBox[{"_", "?", "MatrixQ"}]}], "}"}], ",", 
             "\[IndentingNewLine]", "\t", 
             RowBox[{"\"\<DiagonalizedForm[\>\"", "<>", 
              RowBox[{"Dimensions", "[", 
               RowBox[{"First", "[", "opspecs", "]"}], "]"}], "<>", 
              "\"\<]\>\""}], ",", "\[IndentingNewLine]", "_", ",", 
             "\"\<\>\""}], "\[IndentingNewLine]", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
           "ToBoxes", "[", "\"\<>>]], SuperoperatorType\[Rule]\>\"", "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"StringQ", "[", "soptype", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"\"\<\\\"\>\"", "<>", "soptype", "<>", "\"\<\\\"\>\""}],
               "]"}], ",", "soptype"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"ToBoxes", "[", "\"\<]\>\"", "]"}]}], 
          "\[IndentingNewLine]", "}"}], "]"}], "\[IndentingNewLine]", "]"}]}],
       "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506526794569*^9, 3.456506591362196*^9}, {
   3.456506807868026*^9, 3.456506808025032*^9}, {3.456506916908573*^9, 
   3.4565069187852793`*^9}, {3.4565070618491907`*^9, 3.456507073361253*^9}, {
   3.456507104811401*^9, 3.456507132515758*^9}, {3.456507184889974*^9, 
   3.456507193088976*^9}, {3.456507308088336*^9, 3.456507322174239*^9}, {
   3.456507881744112*^9, 3.45650788247845*^9}, {3.45934179309993*^9, 
   3.459341855795616*^9}, {3.459341927566702*^9, 3.459342010299419*^9}, {
   3.459408401457662*^9, 3.4594084060043497`*^9}, {3.459409171653989*^9, 
   3.459409261062017*^9}, {3.459411850954893*^9, 3.459411852765896*^9}, 
   3.459427841061582*^9, {3.5058453736883297`*^9, 3.505845453285803*^9}, {
   3.505845934787327*^9, 3.5058459398965483`*^9}, {3.5059206249463463`*^9, 
   3.505920714259027*^9}, {3.5059207904390087`*^9, 3.50592084274937*^9}, {
   3.505920876055406*^9, 3.5059208795117893`*^9}, {3.505920928122828*^9, 
   3.505920943225092*^9}, {3.505921041267743*^9, 3.505921043521144*^9}, {
   3.531832898426354*^9, 3.531833020895165*^9}, {3.531833065813417*^9, 
   3.53183322926646*^9}, 3.531833300367432*^9, {3.531833366624659*^9, 
   3.531833367453512*^9}, {3.5318334173003817`*^9, 3.531833424327524*^9}, {
   3.531833487567684*^9, 3.531833512467223*^9}, {3.531833605427472*^9, 
   3.531833683472148*^9}, {3.531833727563027*^9, 3.531833817599286*^9}, {
   3.5860818707442207`*^9, 3.5860819891260443`*^9}, {3.5860910840699177`*^9, 
   3.586091140674996*^9}, 3.5860913576036243`*^9, {3.586168288905867*^9, 
   3.586168326171609*^9}, {3.586168380793283*^9, 3.586168542522773*^9}, {
   3.586168579872573*^9, 3.586168580781561*^9}, {3.586168638996498*^9, 
   3.58616864600921*^9}, {3.58616868873909*^9, 3.5861686907801943`*^9}, {
   3.586168761652248*^9, 3.586168767228177*^9}, {3.586168815416025*^9, 
   3.586168829440769*^9}, {3.7275291155470533`*^9, 3.727529119357559*^9}, {
   3.727529699405658*^9, 3.7275297019173317`*^9}, {3.727529737439627*^9, 
   3.72752973760102*^9}},
 CellLabel->
  "In[974]:=",ExpressionUUID->"bae568dd-e850-4773-9190-c50fa955e9db"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"LeftMultiplicationSuperoperator", "[", 
        RowBox[{
         RowBox[{"Operator", "[", 
          RowBox[{"opspecs_", ",", "___"}], "]"}], ",", "___"}], "]"}], ",", 
       "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "soptype", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"soptype", "=", 
        RowBox[{
         RowBox[{"SuperoperatorType", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Superoperator", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"DisplayForm", "[", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
          "\"\<Superoperator[LeftMultiplicationSuperoperator[Operator[<<\>\"",
            ",", "\[IndentingNewLine]", 
           RowBox[{"Switch", "[", 
            RowBox[{"opspecs", ",", "\[IndentingNewLine]", 
             RowBox[{"_", "?", "MatrixQ"}], ",", "\[IndentingNewLine]", "\t", 
             
             RowBox[{"Dimensions", "[", "opspecs", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
               RowBox[{"_", "?", "MatrixQ"}]}], "}"}], ",", 
             "\[IndentingNewLine]", "\t", 
             RowBox[{"\"\<DiagonalizedForm[\>\"", "<>", 
              RowBox[{"Dimensions", "[", 
               RowBox[{"First", "[", "opspecs", "]"}], "]"}], "<>", 
              "\"\<]\>\""}], ",", "\[IndentingNewLine]", "_", ",", 
             "\"\<\>\""}], "\[IndentingNewLine]", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
           "ToBoxes", "[", "\"\<>>]], SuperoperatorType\[Rule]\>\"", "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"StringQ", "[", "soptype", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"\"\<\\\"\>\"", "<>", "soptype", "<>", "\"\<\\\"\>\""}],
               "]"}], ",", "soptype"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"ToBoxes", "[", "\"\<]\>\"", "]"}]}], 
          "\[IndentingNewLine]", "}"}], "]"}], "\[IndentingNewLine]", "]"}]}],
       "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506526794569*^9, 3.456506591362196*^9}, {
   3.456506807868026*^9, 3.456506808025032*^9}, {3.456506916908573*^9, 
   3.4565069187852793`*^9}, {3.4565070618491907`*^9, 3.456507073361253*^9}, {
   3.456507104811401*^9, 3.456507132515758*^9}, {3.456507184889974*^9, 
   3.456507193088976*^9}, {3.456507308088336*^9, 3.456507322174239*^9}, {
   3.456507881744112*^9, 3.45650788247845*^9}, {3.45934179309993*^9, 
   3.459341855795616*^9}, {3.459341927566702*^9, 3.459342010299419*^9}, {
   3.459408401457662*^9, 3.4594084060043497`*^9}, {3.459409171653989*^9, 
   3.459409261062017*^9}, {3.459411850954893*^9, 3.459411852765896*^9}, 
   3.459427841061582*^9, {3.5058453736883297`*^9, 3.505845453285803*^9}, {
   3.505845934787327*^9, 3.5058459398965483`*^9}, {3.5059206249463463`*^9, 
   3.505920714259027*^9}, {3.5059207904390087`*^9, 3.50592084274937*^9}, {
   3.505920876055406*^9, 3.5059208795117893`*^9}, {3.505920928122828*^9, 
   3.505920943225092*^9}, {3.505921041267743*^9, 3.505921043521144*^9}, {
   3.531832898426354*^9, 3.531833020895165*^9}, {3.531833065813417*^9, 
   3.53183322926646*^9}, 3.531833300367432*^9, {3.531833366624659*^9, 
   3.531833367453512*^9}, {3.5318334173003817`*^9, 3.531833424327524*^9}, {
   3.531833487567684*^9, 3.531833512467223*^9}, {3.531833605427472*^9, 
   3.531833683472148*^9}, {3.531833727563027*^9, 3.531833817599286*^9}, {
   3.5860818707442207`*^9, 3.5860819891260443`*^9}, {3.5860910840699177`*^9, 
   3.586091140674996*^9}, 3.5860913576036243`*^9, {3.586168288905867*^9, 
   3.586168326171609*^9}, {3.586168380793283*^9, 3.586168542522773*^9}, {
   3.586168579872573*^9, 3.586168580781561*^9}, {3.586168638996498*^9, 
   3.58616864600921*^9}, {3.58616868873909*^9, 3.5861686907801943`*^9}, {
   3.586168761652248*^9, 3.586168767228177*^9}, {3.586168815416025*^9, 
   3.586168829440769*^9}, {3.7275291155470533`*^9, 3.727529119357559*^9}, {
   3.7275291932250056`*^9, 3.727529217105528*^9}},
 CellLabel->
  "In[975]:=",ExpressionUUID->"bae568dd-e850-4773-9190-c50fa955e9db"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"RightMultiplicationSuperoperator", "[", 
        RowBox[{
         RowBox[{"Operator", "[", 
          RowBox[{"opspecs_", ",", "___"}], "]"}], ",", "___"}], "]"}], ",", 
       "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "soptype", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"soptype", "=", 
        RowBox[{
         RowBox[{"SuperoperatorType", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Superoperator", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"DisplayForm", "[", 
        RowBox[{"RowBox", "[", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
          "\"\<Superoperator[RightMultiplicationSuperoperator[Operator[<<\>\"\
", ",", "\[IndentingNewLine]", 
           RowBox[{"Switch", "[", 
            RowBox[{"opspecs", ",", "\[IndentingNewLine]", 
             RowBox[{"_", "?", "MatrixQ"}], ",", "\[IndentingNewLine]", "\t", 
             
             RowBox[{"Dimensions", "[", "opspecs", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
               RowBox[{"_", "?", "MatrixQ"}]}], "}"}], ",", 
             "\[IndentingNewLine]", "\t", 
             RowBox[{"\"\<DiagonalizedForm[\>\"", "<>", 
              RowBox[{"Dimensions", "[", 
               RowBox[{"First", "[", "opspecs", "]"}], "]"}], "<>", 
              "\"\<]\>\""}], ",", "\[IndentingNewLine]", "_", ",", 
             "\"\<\>\""}], "\[IndentingNewLine]", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
           "ToBoxes", "[", "\"\<>>]], SuperoperatorType\[Rule]\>\"", "]"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"StringQ", "[", "soptype", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"ToBoxes", "[", 
              RowBox[{"\"\<\\\"\>\"", "<>", "soptype", "<>", "\"\<\\\"\>\""}],
               "]"}], ",", "soptype"}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"ToBoxes", "[", "\"\<]\>\"", "]"}]}], 
          "\[IndentingNewLine]", "}"}], "]"}], "\[IndentingNewLine]", "]"}]}],
       "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506526794569*^9, 3.456506591362196*^9}, {
   3.456506807868026*^9, 3.456506808025032*^9}, {3.456506916908573*^9, 
   3.4565069187852793`*^9}, {3.4565070618491907`*^9, 3.456507073361253*^9}, {
   3.456507104811401*^9, 3.456507132515758*^9}, {3.456507184889974*^9, 
   3.456507193088976*^9}, {3.456507308088336*^9, 3.456507322174239*^9}, {
   3.456507881744112*^9, 3.45650788247845*^9}, {3.45934179309993*^9, 
   3.459341855795616*^9}, {3.459341927566702*^9, 3.459342010299419*^9}, {
   3.459408401457662*^9, 3.4594084060043497`*^9}, {3.459409171653989*^9, 
   3.459409261062017*^9}, {3.459411850954893*^9, 3.459411852765896*^9}, 
   3.459427841061582*^9, {3.5058453736883297`*^9, 3.505845453285803*^9}, {
   3.505845934787327*^9, 3.5058459398965483`*^9}, {3.5059206249463463`*^9, 
   3.505920714259027*^9}, {3.5059207904390087`*^9, 3.50592084274937*^9}, {
   3.505920876055406*^9, 3.5059208795117893`*^9}, {3.505920928122828*^9, 
   3.505920943225092*^9}, {3.505921041267743*^9, 3.505921043521144*^9}, {
   3.531832898426354*^9, 3.531833020895165*^9}, {3.531833065813417*^9, 
   3.53183322926646*^9}, 3.531833300367432*^9, {3.531833366624659*^9, 
   3.531833367453512*^9}, {3.5318334173003817`*^9, 3.531833424327524*^9}, {
   3.531833487567684*^9, 3.531833512467223*^9}, {3.531833605427472*^9, 
   3.531833683472148*^9}, {3.531833727563027*^9, 3.531833817599286*^9}, {
   3.5860818707442207`*^9, 3.5860819891260443`*^9}, {3.5860910840699177`*^9, 
   3.586091140674996*^9}, 3.5860913576036243`*^9, {3.586168288905867*^9, 
   3.586168326171609*^9}, {3.586168380793283*^9, 3.586168542522773*^9}, {
   3.586168579872573*^9, 3.586168580781561*^9}, {3.586168638996498*^9, 
   3.58616864600921*^9}, {3.58616868873909*^9, 3.5861686907801943`*^9}, {
   3.586168761652248*^9, 3.586168767228177*^9}, {3.586168815416025*^9, 
   3.586168829440769*^9}, {3.7275291155470533`*^9, 3.727529119357559*^9}, {
   3.7275291932250056`*^9, 3.7275292288272285`*^9}},
 CellLabel->
  "In[976]:=",ExpressionUUID->"bae568dd-e850-4773-9190-c50fa955e9db"]
}, Closed]],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
  3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
  3.5318324474638643`*^9}, {3.531832645834181*^9, 
  3.53183264655072*^9}},ExpressionUUID->"4eb2c686-e342-4656-ab01-\
5c1a6d260d51"],

Cell[CellGroupData[{

Cell["$Failed", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.5319297444260406`*^9, 3.531929753780078*^9}, {
   3.531929909532097*^9, 3.531929915726618*^9}, {3.621507950856588*^9, 
   3.621507952165382*^9}},ExpressionUUID->"c7c66361-539f-4a84-a3cd-\
4e6de8d9fa77"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Superoperator", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5863372636394243`*^9, 3.586337294422628*^9}, {
   3.621507677072359*^9, 3.6215076905821753`*^9}, 3.621510412171022*^9},
 CellLabel->
  "In[977]:=",ExpressionUUID->"827ee96a-507f-4c23-82e3-a768457e0c7e"]
}, Closed]],

Cell[CellGroupData[{

Cell["filter options", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.531929730192232*^9, 3.5319297359413137`*^9}, 
   3.531930027378767*^9, {3.532172064259869*^9, 3.53217207514641*^9}, {
   3.53217225476757*^9, 3.532172262894217*^9}, {3.533181826917366*^9, 
   3.5331818323862467`*^9}},ExpressionUUID->"448c2b2b-bf05-418c-8704-\
4c7c5227758f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"a", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "filterrules", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Superoperator", "[", 
        RowBox[{"a", ",", 
         RowBox[{"Sequence", "@@", "filterrules"}]}], "]"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"filterrules", "=", 
         RowBox[{"FilterRules", "[", 
          RowBox[{
           RowBox[{"{", "opts", "}"}], ",", 
           RowBox[{"Options", "[", "Superoperator", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"filterrules", ",", 
           RowBox[{"{", "opts", "}"}]}], "]"}]}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5331818351287403`*^9, 3.53318199695509*^9}, {
  3.533182102871464*^9, 3.533182106963409*^9}},
 CellLabel->
  "In[978]:=",ExpressionUUID->"943cae92-e678-4792-9258-b4b807168209"]
}, Closed]],

Cell[CellGroupData[{

Cell["missing bases", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
  3.531829420950123*^9, 3.5318294228297462`*^9}, {3.531927365284212*^9, 
  3.531927366319889*^9}},ExpressionUUID->"84958263-9d3b-4e6f-bb1e-\
66a34b220b88"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "[", 
    RowBox[{"sop_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Superoperator", "[", 
    RowBox[{"sop", ",", 
     RowBox[{"OperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504110223867132*^9, 3.504110239329947*^9}, {
  3.531829399398057*^9, 3.531829417365767*^9}, {3.531927371880146*^9, 
  3.531927387484351*^9}},
 CellLabel->
  "In[979]:=",ExpressionUUID->"af056332-1c6b-4d9e-9782-e76a04d79017"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "[", 
    RowBox[{"sop_", ",", "opbasis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Superoperator", "[", 
    RowBox[{"sop", ",", "opbasis", ",", 
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.504110223867132*^9, 3.504110239329947*^9}, {
  3.531829399398057*^9, 3.531829417365767*^9}, {3.531927371880146*^9, 
  3.531927413446046*^9}},
 CellLabel->
  "In[980]:=",ExpressionUUID->"42569466-89b0-433d-beea-349c4e606494"]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate SuperoperatorType", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 
   3.531927421705441*^9},ExpressionUUID->"01b05daa-5763-4a3e-99da-\
fc2d6cb4480b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "[", 
    RowBox[{"args__", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "soptype", "}"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Superoperator", "::", "badsoptype"}], ",", "soptype"}], 
         "]"}], ";", 
        RowBox[{"Superoperator", "[", 
         RowBox[{"args", ",", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"SuperoperatorType", "\[Rule]", "None"}], ",", "opts"}], 
           "]"}]}], "]"}]}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"soptype", "=", 
         RowBox[{
          RowBox[{"SuperoperatorType", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Superoperator", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MemberQ", "[", 
          RowBox[{"ValidSuperoperatorTypes", ",", "soptype"}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531832455811256*^9, 3.531832639106235*^9}, 
   3.531832827425124*^9, {3.531927425883292*^9, 3.5319274746677094`*^9}},
 CellLabel->
  "In[981]:=",ExpressionUUID->"e30013dc-640e-4681-adfe-026f9380b48a"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle a single number", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.531929730192232*^9, 3.5319297359413137`*^9}, 
   3.531930027378767*^9, {3.5320070316467867`*^9, 
   3.532007035881529*^9}},ExpressionUUID->"f0bc0322-71b2-47e9-84e2-\
254789c0600a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"num_", "?", "NumericQ"}], ",", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"num", "\[Times]", 
      RowBox[{"UnitySuperoperator", "[", "]"}]}], ",", "opbasis", ",", 
     "basis", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929684468029*^9, 3.531929722331521*^9}},
 CellLabel->
  "In[982]:=",ExpressionUUID->"e11ef65a-9da8-4e5a-b729-382fab66875a"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle a numeric multiple of Superoperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.531929730192232*^9, 3.5319297359413137`*^9}, 
   3.531930027378767*^9, {3.532172064259869*^9, 3.53217207514641*^9}, {
   3.53217225476757*^9, 3.532172262894217*^9}, {3.5321727529571466`*^9, 
   3.532172754595356*^9}},ExpressionUUID->"2cbde142-2ced-4813-8514-\
c882f273f630"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"Times", "[", 
    RowBox[{
     RowBox[{"n1___", "?", "NumericQ"}], ",", 
     RowBox[{"Superoperator", "[", 
      RowBox[{"sop_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
      "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"Times", "[", 
      RowBox[{"n1", ",", "sop", ",", "n2"}], "]"}], ",", "opbasis", ",", 
     "basis", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SuperoperatorType", "\[Rule]", "Undefined"}], ",", 
       RowBox[{"SuperoperatorType", "\[Rule]", "Automatic"}], ",", "opts"}], 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5321720790722113`*^9, 3.532172171991928*^9}, {
   3.5321722465207253`*^9, 3.532172270916069*^9}, {3.532172316999783*^9, 
   3.5321723235172863`*^9}, {3.532172758558475*^9, 3.532172788503927*^9}, {
   3.562812869419978*^9, 3.562812883498602*^9}, {3.586157320158114*^9, 
   3.586157335594343*^9}, 3.5862527507798*^9},
 CellLabel->
  "In[983]:=",ExpressionUUID->"4373da88-8d84-483e-a5b0-bb11bac0bb70"]
}, Closed]],

Cell[CellGroupData[{

Cell["Superoperator applied to InterpolationFunction forms", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.531929730192232*^9, 3.5319297359413137`*^9}, 
   3.531930027378767*^9, {3.532172064259869*^9, 3.53217207514641*^9}, {
   3.53217225476757*^9, 3.532172262894217*^9}, {3.621391001123641*^9, 
   3.6213910383606586`*^9}, {3.621507372251388*^9, 3.621507398884102*^9}, 
   3.621510448368102*^9},ExpressionUUID->"5fe946a6-867c-4056-a8a2-\
cfb8cbf437d2"],

Cell["take numerical multiples into the InterpolatingFunction", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.62150738507344*^9, 
  3.621507396501134*^9}},ExpressionUUID->"5e31cac7-a393-4600-a1f8-\
a96a2dd8d428"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"n1___", "?", "NumericQ"}], ",", 
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], ",", "args___"}], 
      "]"}]}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Replace", "[", 
       RowBox[{"ifunc", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"mat_", "?", "MatrixQ"}], "\[RuleDelayed]", 
          RowBox[{"Times", "[", 
           RowBox[{"n1", ",", "n2", ",", "mat"}], "]"}]}], "}"}], ",", 
        RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}], ",", 
     "\[IndentingNewLine]", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.621391289570209*^9}, {
   3.62139145174896*^9, 3.621391490565153*^9}},
 CellLabel->
  "In[984]:=",ExpressionUUID->"8615bd40-e66d-4355-8c94-446cf35bb4b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"n1___", "?", "NumericQ"}], ",", 
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], ",", "args___"}], 
      "]"}]}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
         RowBox[{"_", "?", "MatrixQ"}]}], "}"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Replace", "[", 
       RowBox[{"ifunc", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"X_", "?", "MatrixQ"}], ",", "D_List", ",", 
           RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], "\[RuleDelayed]", 
         RowBox[{"{", 
          RowBox[{"X", ",", 
           RowBox[{"Times", "[", 
            RowBox[{"n1", ",", "n2", ",", "D"}], "]"}], ",", "Xinv"}], 
          "}"}]}], ",", 
        RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}], ",", 
     "\[IndentingNewLine]", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.6213913702752523`*^9}, {
   3.621391531269899*^9, 3.621391550876236*^9}},
 CellLabel->
  "In[985]:=",ExpressionUUID->"c9aa172a-7300-4e65-adc2-9b4f46294911"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"n1___", "?", "NumericQ"}], ",", 
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], ",", "args___"}], 
      "]"}]}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Replace", "[", 
       RowBox[{"ifunc", ",", 
        RowBox[{"sop_", "?", "SuperoperatorQ"}]}], "]"}], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"Times", "[", 
        RowBox[{"n1", ",", "n2", ",", "sop"}], "]"}], "[", "t", "]"}]}], ",", 
     "\[IndentingNewLine]", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.6213913702752523`*^9}, {
   3.6213915113800907`*^9, 3.621391520158724*^9}, {3.621506915857224*^9, 
   3.621506998345965*^9}, {3.6215104782994547`*^9, 3.621510496260247*^9}},
 CellLabel->
  "In[986]:=",ExpressionUUID->"d58ebfa0-17ca-420c-b7a4-55dcfdde87de"],

Cell["\<\
if the InterpolationFunction yields a symbolic superoperator form, convert \
into a matrix representation\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.62150738507344*^9, 3.621507434612221*^9}, {
  3.62151052384936*^9, 
  3.621510525773529*^9}},ExpressionUUID->"7374fe99-a2fc-402d-8b2f-\
95e1067dc4dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
       "opbasis_", ",", "basis_", ",", "args___"}], "]"}]}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Operator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Replace", "[", 
       RowBox[{"ifunc", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"sop_", "?", "SuperoperatorQ"}], "\[RuleDelayed]", 
          RowBox[{"SuperoperatorMatrixRepresentation", "[", 
           RowBox[{"sop", ",", "opbasis", ",", "basis", ",", "args"}], 
           "]"}]}], "}"}], ",", 
        RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}], ",", 
     "\[IndentingNewLine]", "args"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.621391289570209*^9}, {
   3.6213915067223797`*^9, 3.621391516472814*^9}, {3.6215070854826717`*^9, 
   3.621507146354694*^9}, {3.621510519645694*^9, 3.621510556569755*^9}},
 CellLabel->
  "In[987]:=",ExpressionUUID->"e074be32-f0a6-4734-ab81-72e39a225702"]
}, Closed]],

Cell[CellGroupData[{

Cell["trap inappropriate arguments", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.5319297444260406`*^9, 3.531929753780078*^9}, {
   3.531929909532097*^9, 
   3.531929915726618*^9}},ExpressionUUID->"f1b51523-9040-49af-87be-\
6a3ce1409017"],

Cell["\<\
trigger an error if the argument of Superoperator is not another \
superoperator, or a matrix, or the diagonalized form of a matrix, or an \
interpolating function which yields one of those forms when evaluated\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.620986477572551*^9, 3.6209865202902193`*^9}, {
  3.62098666481666*^9, 
  3.620986669091152*^9}},ExpressionUUID->"add48913-4b58-4f75-ae57-\
650f962a306c"],

Cell["\<\
also need to take into account numerical multiples of a viable interpolating \
function \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.621081927752201*^9, 3.62108194232067*^9}, {
  3.621082070917704*^9, 
  3.621082080489418*^9}},ExpressionUUID->"fcbce595-ade2-4f69-9fe6-\
3ad3bf34026c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "[", 
    RowBox[{"badsop_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"Superoperator", "::", "badsop"}], "]"}], ";", "$Failed"}], 
     ")"}], "/;", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"SuperoperatorQ", "[", "badsop", "]"}]}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"MatchQ", "[", 
        RowBox[{"badsop", ",", 
         RowBox[{
          RowBox[{"_", "?", "MatrixQ"}], "|", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
            RowBox[{"_", "?", "MatrixQ"}]}], "}"}]}]}], "]"}]}], ")"}], "&&", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{"!", 
       RowBox[{"MatchQ", "[", 
        RowBox[{"badsop", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ifunc_InterpolatingFunction", "[", "_", "]"}], "/;", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], 
            ")"}], "&&", "\[IndentingNewLine]", 
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"ifunc", "[", 
              RowBox[{"ifunc", "\[LeftDoubleBracket]", 
               RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
              "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"_", "?", "MatrixQ"}], "|", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
                RowBox[{"_", "?", "MatrixQ"}]}], "}"}]}]}], "]"}]}]}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929684468029*^9, 3.531929722331521*^9}, {
   3.531929756418811*^9, 3.531929789325817*^9}, {3.5319298388168793`*^9, 
   3.5319298734439783`*^9}, {3.586090960625332*^9, 3.5860909632545347`*^9}, {
   3.620986677368939*^9, 3.620986706345372*^9}, {3.620986874853026*^9, 
   3.6209869086865053`*^9}, 3.620986955981884*^9, {3.621009967872381*^9, 
   3.6210099755772943`*^9}, {3.621082246043489*^9, 3.62108235599824*^9}, {
   3.621187040765308*^9, 3.621187045285598*^9}, 3.62151064904769*^9},
 CellLabel->
  "In[988]:=",ExpressionUUID->"605e0306-8e51-4812-9be1-143582f7bc73"]
}, Closed]],

Cell[CellGroupData[{

Cell["replacement rules must go into the SparseArray", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
  3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
  3.5318324474638643`*^9}, {3.531832645834181*^9, 3.53183264655072*^9}, {
  3.533117791517394*^9, 
  3.5331177990902042`*^9}},ExpressionUUID->"42b6c92f-e710-4fab-85c1-\
93f68a1f2eec"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"ReplaceAll", "[", 
     RowBox[{
      RowBox[{"Superoperator", "[", 
       RowBox[{"a_", ",", "more___"}], "]"}], ",", "rules_"}], "]"}]}], ":=", 
   
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"ReplaceEverywhere", "[", 
      RowBox[{"a", ",", "rules"}], "]"}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5331178080055847`*^9, {3.533117838541552*^9, 3.533117844829962*^9}, {
   3.533210881919609*^9, 3.533210939261188*^9}, {3.533211008175622*^9, 
   3.533211010803196*^9}, {3.53321114241328*^9, 3.533211166820303*^9}, {
   3.533211240778281*^9, 3.533211256620554*^9}, {3.533211376281159*^9, 
   3.533211383994417*^9}},
 CellLabel->
  "In[989]:=",ExpressionUUID->"8f357a04-d380-472a-ac97-e4c0a98a8a06"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to 0", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5930117533496227`*^9, 
  3.593011756685623*^9}},ExpressionUUID->"9bf06bf1-6599-4e2b-a1b2-\
fe7712bbd70f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"sop_Superoperator", "[", "0", "]"}], "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.5930117750461407`*^9}},
 CellLabel->
  "In[990]:=",ExpressionUUID->"815bc13d-52b8-4352-b5e6-5cad1c04b906"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["implement matrix representations", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531927484794729*^9, 
   3.531927486863475*^9}, {3.583427930048633*^9, 3.5834279310939417`*^9}, {
   3.583429784489583*^9, 3.583429794065256*^9}, {3.58342995565445*^9, 
   3.5834300279089737`*^9}, {3.5834303275970297`*^9, 
   3.5834303446657877`*^9}, {3.586157436144133*^9, 3.586157442172673*^9}, 
   3.586163675009769*^9, {3.5861666878819437`*^9, 
   3.586166697976619*^9}},ExpressionUUID->"354ef0ad-66e9-4c54-b7de-\
8a2d8c81d080"],

Cell[CellGroupData[{

Cell["\<\
not a CommutationSuperoperator or Left/RightMultiplicationSuperoperator: \
implement the matrix representation\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.586166791599988*^9, 3.586166802406785*^9}, {
  3.621510751652025*^9, 3.621510755225348*^9}, {3.7275244740526133`*^9, 
  3.7275244748922195`*^9}},ExpressionUUID->"d3b46920-cf8e-4f16-acb6-\
9ffad2d1fd7b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "[", 
   RowBox[{
    RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "opbasis_", ",", "basis_", 
    ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SuperoperatorMatrixRepresentation", "[", 
      RowBox[{"sop", ",", "opbasis", ",", "basis"}], "]"}], ",", 
     "\[IndentingNewLine]", "opbasis", ",", "basis", ",", "opts"}], 
    "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{"!", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"sop", ",", 
      RowBox[{"(", 
       RowBox[{
       "_CommutationSuperoperator", "|", "_LeftMultiplicationSuperoperator", 
        "|", "_RightMultiplicationSuperoperator"}], ")"}]}], 
     "]"}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586166711603229*^9, 3.586166778065651*^9}, {
   3.621096210643602*^9, 3.6210962220632772`*^9}, 3.6215106902672377`*^9, {
   3.72752445112156*^9, 3.7275244650532293`*^9}, {3.7275245898444*^9, 
   3.7275246182314034`*^9}, {3.7275288371416974`*^9, 3.727528844589413*^9}},
 CellLabel->
  "In[991]:=",ExpressionUUID->"41211d13-a9bc-464d-bf48-2ccf266a2b49"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
CommutationSuperoperator or Left/RightMultiplicationSuperoperator: apply \
Operator to a symbolic operator argument\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.586166791599988*^9, 3.58616682280013*^9}, {
  3.62151072464177*^9, 3.621510737337738*^9}, {3.727524384773614*^9, 
  3.727524389628758*^9}, {3.7275244951588726`*^9, 
  3.72752449581213*^9}},ExpressionUUID->"e1ead5ca-38f2-4461-8258-\
78ec4f955ee8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"head", ":", 
       RowBox[{"(", 
        RowBox[{
        "CommutationSuperoperator", "|", "LeftMultiplicationSuperoperator", 
         "|", "RightMultiplicationSuperoperator"}], ")"}]}], ")"}], "[", 
     RowBox[{
      RowBox[{"op_", "?", "OperatorQ"}], ",", "csopopts___Rule"}], "]"}], ",",
     "\[IndentingNewLine]", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
   "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"head", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Operator", "[", 
        RowBox[{"op", ",", "basis"}], "]"}], ",", "\[IndentingNewLine]", 
       "csopopts"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]",
      "opbasis", ",", "basis", ",", "opts"}], "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{"!", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"op", ",", "_Operator"}], "]"}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586166711603229*^9, 3.586166778065651*^9}, {
  3.5861668296499853`*^9, 3.586166900576696*^9}, {3.586166940934104*^9, 
  3.586166989318296*^9}, {3.727524394789926*^9, 3.7275244084550657`*^9}, {
  3.727524456055085*^9, 3.727524457775388*^9}, {3.727524489110375*^9, 
  3.7275244897265906`*^9}, {3.7275246074475074`*^9, 3.7275246097395144`*^9}, {
  3.7275246699397044`*^9, 3.727524670374823*^9}, {3.727529359950842*^9, 
  3.7275293706502714`*^9}, {3.7275295785499735`*^9, 3.7275295806004133`*^9}, {
  3.7275296381381083`*^9, 3.7275296404612675`*^9}, {3.727529752845506*^9, 
  3.727529754022626*^9}},
 CellLabel->
  "In[992]:=",ExpressionUUID->"f78c1f77-6357-4415-81a7-976a3b342054"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["check SuperoperatorType", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531927484794729*^9, 
   3.531927486863475*^9}, {3.583427930048633*^9, 3.5834279310939417`*^9}, {
   3.583429784489583*^9, 3.583429794065256*^9}, {3.58342995565445*^9, 
   3.5834300279089737`*^9}, {3.5834303275970297`*^9, 
   3.5834303446657877`*^9}, {3.586157436144133*^9, 3.586157442172673*^9}, 
   3.586163675009769*^9},ExpressionUUID->"9ad0d9c1-4e95-48c3-99b0-\
8c485c4a4376"],

Cell[CellGroupData[{

Cell["interpret CheckSuperoperatorType\[Rule]Automatic", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5861636308554487`*^9, 3.586163640398192*^9}, {
   3.586164048314577*^9, 3.5861640551272583`*^9}, 
   3.586166592170229*^9},ExpressionUUID->"f1ecd21f-1b31-43e6-88c9-\
a7ab3a6ab44a"],

Cell["\<\
Only determine the SuperoperatorType if the matrix is numeric, and the \
dimension is not too large - or if it\[CloseCurlyQuote]s a \
CommutationSuperoperator\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5834321822769737`*^9, 3.583432195403837*^9}, {
  3.5834323826668158`*^9, 3.583432392520463*^9}, {3.586166595514784*^9, 
  3.586166603611122*^9}},ExpressionUUID->"d701d393-ad22-427c-9e4a-\
a29f63d6b9d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "[", 
    RowBox[{"specs_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
     RowBox[{
     "specs", ",", "opbasis", ",", "basis", ",", "\[IndentingNewLine]", 
      RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"CheckSuperoperatorType", "\[Rule]", "True"}], ",", 
        "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"CheckSuperoperatorType", ",", "SuperoperatorType"}], 
           "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Superoperator", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "Undefined"}], "}"}]}], "]"}], "&&", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{"specs", ",", 
          RowBox[{
          "_CommutationSuperoperator", "|", 
           "_LeftMultiplicationSuperoperator", "|", 
           "_RightMultiplicationSuperoperator"}]}], "]"}], "||", 
        "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"OperatorBasisDimension", "[", "opbasis", "]"}], 
            "\[LessEqual]", "SuperoperatorTypeCheckDisableThreshold"}], ")"}],
           "&&", "\[IndentingNewLine]", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"specs", ",", 
            RowBox[{
             RowBox[{"_", "?", "NumericMatrixQ"}], "|", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"_", "?", "NumericMatrixQ"}], ",", "_List", ",", 
               RowBox[{"_", "?", "NumericMatrixQ"}]}], "}"}]}]}], "]"}]}], 
         ")"}]}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
     ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5861574578937807`*^9, 3.586157620363146*^9}, {
   3.5861576609471292`*^9, 3.5861576732160683`*^9}, {3.586157735980118*^9, 
   3.586157796919389*^9}, 3.586161701634321*^9, {3.586163658016881*^9, 
   3.586163663126279*^9}, {3.586163705429098*^9, 3.5861637121137247`*^9}, {
   3.586163845875366*^9, 3.58616384800957*^9}, {3.5861665520804157`*^9, 
   3.586166585400873*^9}, {3.5862527628244333`*^9, 3.586252766933222*^9}, {
   3.727523781951115*^9, 3.7275237959292336`*^9}},
 CellLabel->
  "In[993]:=",ExpressionUUID->"5e3414fc-d290-4222-8285-6096529355bb"]
}, Closed]],

Cell[CellGroupData[{

Cell["check SuperoperatorType for CommutationSuperoperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5861636308554487`*^9, 3.586163640398192*^9}, {
   3.58616368165716*^9, 3.586163683120761*^9}, {3.586164065803493*^9, 
   3.586164072648814*^9}, 
   3.586167019212016*^9},ExpressionUUID->"ae4de76b-fca1-48d3-a4c0-\
ad12b6ae60ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Superoperator", "[", 
     RowBox[{
      RowBox[{"csop", ":", 
       RowBox[{"(", 
        RowBox[{
        "_CommutationSuperoperator", "|", "_LeftMultiplicationSuperoperator", 
         "|", "_RightMultiplicationSuperoperator"}], ")"}]}], ",", "opbasis_",
       ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"CheckSuperoperatorType", ",", "SuperoperatorType"}], "}"}], 
        "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Superoperator", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "Undefined"}], "}"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Superoperator", "[", 
    RowBox[{
    "csop", ",", "opbasis", ",", "basis", ",", "\[IndentingNewLine]", 
     RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SuperoperatorType", "\[Rule]", 
        RowBox[{"SuperoperatorType", "[", "csop", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"CheckSuperoperatorType", "\[Rule]", "False"}], ",", 
       "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586255588283598*^9, 3.586255749621804*^9}, {
  3.727523808896985*^9, 3.7275238233156023`*^9}},
 CellLabel->
  "In[994]:=",ExpressionUUID->"47a78ee9-dc6c-47a4-87e3-e3902b978c57"]
}, Closed]],

Cell[CellGroupData[{

Cell["check SuperoperatorType for matrix form", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5861636308554487`*^9, 3.586163640398192*^9}, {
  3.58616368165716*^9, 3.586163683120761*^9}, {3.586164065803493*^9, 
  3.586164072648814*^9}},ExpressionUUID->"3d7d5af4-49d9-44d2-9b9d-\
3cef096b16ab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"sopmat_", "?", "MatrixQ"}], ",", "opbasis_", ",", "basis_", ",",
      "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
     RowBox[{
     "sopmat", ",", "opbasis", ",", "basis", ",", "\[IndentingNewLine]", 
      RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SuperoperatorType", "\[Rule]", 
         RowBox[{"Which", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"HermitianQ", "[", "sopmat", "]"}], ",", 
           "\"\<Hermitian\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"AntiHermitianQ", "[", "sopmat", "]"}], ",", 
           "\"\<AntiHermitian\>\"", ",", "\[IndentingNewLine]", 
           RowBox[{"UnitaryQ", "[", "sopmat", "]"}], ",", "\"\<Unitary\>\"", 
           ",", "\[IndentingNewLine]", 
           RowBox[{"NormalQ", "[", "sopmat", "]"}], ",", "\"\<Normal\>\"", 
           ",", "\[IndentingNewLine]", "True", ",", "None"}], "]"}]}], ",", 
        "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"CheckSuperoperatorType", ",", "SuperoperatorType"}], 
           "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Superoperator", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "Undefined"}], "}"}]}], "]"}], "&&", 
      "\[IndentingNewLine]", 
      RowBox[{"NumericMatrixQ", "[", "sopmat", "]"}]}], "\[IndentingNewLine]",
      ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583432407146059*^9, 3.5834325434529133`*^9}, {
   3.58615764580089*^9, 3.586157650688512*^9}, {3.586157827858062*^9, 
   3.586157923065819*^9}, {3.586161532753099*^9, 3.586161533534013*^9}, 
   3.5861639785232773`*^9, {3.586252879973609*^9, 3.586252891324767*^9}, 
   3.640490322772052*^9, {3.640490715863955*^9, 3.640490719723097*^9}},
 CellLabel->
  "In[995]:=",ExpressionUUID->"81e5cabf-cc9f-4217-ab56-e91e7a7d5f33"]
}, Closed]],

Cell[CellGroupData[{

Cell["check SuperoperatorType for diagonalization form", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5861636308554487`*^9, 3.586163640398192*^9}, {
   3.58616368165716*^9, 3.5861636981218443`*^9}, 
   3.5861640792958803`*^9},ExpressionUUID->"0b197dd1-5ced-4f5c-b026-\
6fa3d73c0044"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
       RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "orthogX", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], ",", "opbasis", 
         ",", "basis", ",", "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"SuperoperatorType", "\[Rule]", 
            RowBox[{"Which", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"And", "@@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"Chop", "[", 
                    RowBox[{
                    RowBox[{"Abs", "[", "#", "]"}], "-", "1"}], "]"}], 
                    "\[Equal]", "0"}], ")"}], "&"}], "/@", "evals"}], ")"}]}],
               ",", "\"\<Unitary\>\"", ",", "\[IndentingNewLine]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"orthogX", "=", 
                 RowBox[{"OrthogonalQ", "[", "X", "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"orthogX", " ", "&&", "\[IndentingNewLine]", 
                 RowBox[{"And", "@@", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"Element", "[", 
                    RowBox[{"#", ",", "Reals"}], "]"}], "&"}], "/@", 
                    "evals"}], ")"}]}]}]}], ")"}], ",", "\"\<Hermitian\>\"", 
              ",", "\[IndentingNewLine]", 
              RowBox[{"orthogX", " ", "&&", "\[IndentingNewLine]", 
               RowBox[{"And", "@@", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Element", "[", 
                    RowBox[{
                    RowBox[{"Chop", "@", 
                    RowBox[{"N", "[", 
                    RowBox[{"I", " ", "#"}], "]"}]}], ",", "Reals"}], "]"}], 
                   "&"}], "/@", "evals"}], ")"}]}]}], ",", 
              "\"\<AntiHermitian\>\"", ",", "\[IndentingNewLine]", "True", 
              ",", "None"}], "]"}]}], ",", "\[IndentingNewLine]", "opts"}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], "/;", 
       
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"CheckSuperoperatorType", ",", "SuperoperatorType"}], 
              "}"}], "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Superoperator", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "Undefined"}], "}"}]}], "]"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"_", "?", "NumericMatrixQ"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"_", "?", "NumericQ"}], ".."}], "}"}], ",", 
             RowBox[{"_", "?", "NumericMatrixQ"}]}], "}"}]}], "]"}]}], 
        "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.583432407146059*^9, 3.5834325434529133`*^9}, {
  3.58615764580089*^9, 3.586157650688512*^9}, {3.586157827858062*^9, 
  3.586157923065819*^9}, {3.586157962270501*^9, 3.586158027225636*^9}, {
  3.586158063371315*^9, 3.586158102304427*^9}, {3.586158159024472*^9, 
  3.586158247921908*^9}, {3.58615929745537*^9, 3.58615952248623*^9}, {
  3.586161542261753*^9, 3.586161542857891*^9}, {3.586252902577396*^9, 
  3.586252912082491*^9}, {3.640490807392446*^9, 3.6404908714632463`*^9}, {
  3.640491074728283*^9, 3.640491086581079*^9}},
 CellLabel->
  "In[996]:=",ExpressionUUID->"b67b0acd-991e-4ac5-bd52-8cdeb7887365"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CheckMatrixDimensions", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531927484794729*^9, 
   3.531927486863475*^9}, {3.583427930048633*^9, 3.5834279310939417`*^9}, {
   3.583429784489583*^9, 3.583429794065256*^9}, {3.58342995565445*^9, 
   3.5834300279089737`*^9}, {3.5834303275970297`*^9, 
   3.5834303446657877`*^9}, {3.586157436144133*^9, 3.586157442172673*^9}, 
   3.586163675009769*^9, {3.586253389898407*^9, 3.5862533994474583`*^9}, {
   3.64060365526694*^9, 3.64060365619952*^9}, 
   3.6406037165289717`*^9},ExpressionUUID->"c73ce7dc-8cd9-45ac-a6b0-\
3eb21f78f28c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Superoperator", "[", 
     RowBox[{
      RowBox[{"sopmat_", "?", "MatrixQ"}], ",", "opbasis_", ",", "basis_", 
      ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"CheckMatrixDimensions", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "Superoperator", "]"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "n", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"OperatorBasisDimension", "[", "opbasis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Dimensions", "[", "sopmat", "]"}], "\[Equal]", 
          RowBox[{"{", 
           RowBox[{"n", ",", "n"}], "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Superoperator", "[", 
          RowBox[{
          "sopmat", ",", "opbasis", ",", "basis", ",", "\[IndentingNewLine]", 
           
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"CheckMatrixDimensions", "\[Rule]", "False"}], ",", 
             "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"Superoperator", "::", "baddims"}], "]"}], ";", 
           "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.640603738589243*^9, 3.640603948041686*^9}, {
   3.6406040172336903`*^9, 3.640604017885295*^9}, {3.64060408545747*^9, 
   3.640604125005014*^9}, 3.64060415984767*^9, {3.640604275481969*^9, 
   3.640604279239965*^9}, {3.640604315534403*^9, 3.6406043388002768`*^9}},
 CellLabel->
  "In[997]:=",ExpressionUUID->"7665f2de-9f9d-4835-8b5f-8e91b916c03e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Superoperator", "[", 
     RowBox[{
      RowBox[{"X\[CapitalLambda]Xinv", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}]}], ",", "opbasis_", ",", 
      "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"TrueQ", "[", 
     RowBox[{
      RowBox[{"CheckMatrixDimensions", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "Superoperator", "]"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "n", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"OperatorBasisDimension", "[", "opbasis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Dimensions", "[", "X", "]"}], "\[Equal]", 
            RowBox[{"Dimensions", "[", "Xinv", "]"}], "\[Equal]", 
            RowBox[{"{", 
             RowBox[{"n", ",", "n"}], "}"}]}], ")"}], "&&", 
          RowBox[{
           RowBox[{"Length", "[", "evals", "]"}], "\[Equal]", "n"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Superoperator", "[", 
          RowBox[{
          "X\[CapitalLambda]Xinv", ",", "opbasis", ",", "basis", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"CheckMatrixDimensions", "\[Rule]", "False"}], ",", 
             "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"Superoperator", "::", "baddims"}], "]"}], ";", 
           "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.640603738589243*^9, 3.640603948041686*^9}, {
   3.640603983045824*^9, 3.6406040638352833`*^9}, {3.640604107431094*^9, 
   3.640604130934952*^9}, 3.6406041626922417`*^9, {3.640604351063826*^9, 
   3.640604399633737*^9}},
 CellLabel->
  "In[998]:=",ExpressionUUID->"19a031ee-29fb-4d22-b9b4-4728b3fe012c"]
}, Closed]],

Cell[CellGroupData[{

Cell["request OperatorBasis and Basis of Superoperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.531834281301166*^9, 3.531834283424567*^9}, {3.586081377738758*^9, 
  3.586081381192855*^9}, {3.586081437012541*^9, 3.586081447501163*^9}, {
  3.590660286090549*^9, 3.59066028905759*^9}, {3.640508229044055*^9, 
  3.640508232057681*^9}, {3.640508296698595*^9, 3.640508300544703*^9}, {
  3.640521537212206*^9, 
  3.640521538769508*^9}},ExpressionUUID->"70b44864-8932-41d1-923e-\
f1af34ff09d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"OperatorBasis", "[", 
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"_", "?", "MatrixQ"}], "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
          RowBox[{"_", "?", "MatrixQ"}]}], "}"}]}], ",", "opbasis_", ",", 
       "basis_", ",", "opts___Rule"}], "]"}], "]"}]}], "^:=", "opbasis"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590660292634741*^9, 3.590660388453232*^9}, {
   3.590660419024871*^9, 3.590660450761305*^9}, {3.590660488652382*^9, 
   3.590660598158297*^9}, {3.64050823530961*^9, 3.640508249506859*^9}, {
   3.640508313869999*^9, 3.6405083547670813`*^9}, 3.6405083967251577`*^9, 
   3.640508451341193*^9},
 CellLabel->
  "In[999]:=",ExpressionUUID->"12b8ac0e-3f03-4374-97a7-4ce9294f903c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Basis", "[", 
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"_", "?", "MatrixQ"}], "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
          RowBox[{"_", "?", "MatrixQ"}]}], "}"}]}], ",", "opbasis_", ",", 
       "basis_", ",", "opts___Rule"}], "]"}], "]"}]}], "^:=", "basis"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590660292634741*^9, 3.590660388453232*^9}, {
   3.590660419024871*^9, 3.590660450761305*^9}, {3.590660488652382*^9, 
   3.590660598158297*^9}, {3.64050823530961*^9, 3.640508249506859*^9}, {
   3.640508313869999*^9, 3.6405083547670813`*^9}, 3.6405083967251577`*^9, 
   3.640508451341193*^9, {3.64052155135334*^9, 3.640521553825789*^9}},
 CellLabel->
  "In[1000]:=",ExpressionUUID->"4746d3d0-421a-438d-a376-d58ef9627b91"]
}, Closed]],

Cell[CellGroupData[{

Cell["exponent of diagonalized Superoperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.531834281301166*^9, 3.531834283424567*^9}, {3.586081377738758*^9, 
  3.586081381192855*^9}, {3.586081437012541*^9, 3.586081447501163*^9}, {
  3.586090108782827*^9, 
  3.586090109644865*^9}},ExpressionUUID->"82a3ca40-6b02-4f5d-81fb-\
6ea530e2468f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Exp", "[", 
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "opbasis_", ",", 
       "basis_", ",", "opts___Rule"}], "]"}], "]"}]}], ":=", 
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"X", ",", 
       RowBox[{"Exp", "/@", "evals"}], ",", "Xinv"}], "}"}], ",", "opbasis", 
     ",", "basis", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.58608138613308*^9, 3.5860813906599197`*^9}, {
   3.586081422343294*^9, 3.5860814755231953`*^9}, 3.586081593814258*^9, 
   3.586081737150496*^9, {3.586090116769417*^9, 3.5860901329697723`*^9}},
 CellLabel->
  "In[1001]:=",ExpressionUUID->"bae12d0c-be88-4c8e-8ff3-6e53d94833d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"HoldPattern", "[", 
    RowBox[{"E", "^", 
     RowBox[{"(", 
      RowBox[{"Superoperator", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
          RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "opbasis_", ",", 
        "basis_", ",", "opts___Rule"}], "]"}], ")"}]}], "]"}], ":=", 
   RowBox[{"Superoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"X", ",", 
       RowBox[{"Exp", "/@", "evals"}], ",", "Xinv"}], "}"}], ",", "opbasis", 
     ",", "basis", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.58608138613308*^9, 3.5860813906599197`*^9}, {
   3.586081422343294*^9, 3.5860814755231953`*^9}, 3.586081593814258*^9, 
   3.586081737150496*^9, {3.586090116769417*^9, 3.5860901329697723`*^9}, {
   3.589263348406322*^9, 3.5892633544926977`*^9}, {3.589480283977223*^9, 
   3.589480289301105*^9}},
 CellLabel->
  "In[1002]:=",ExpressionUUID->"e1661cbc-de42-496b-a0f6-3ddb1521fe9e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Exp", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"Exp", "[", 
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"n1___", "?", "NumericQ"}], ",", 
         RowBox[{"Superoperator", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
             RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "opbasis_", ",",
            "basis_", ",", "opts___Rule"}], "]"}], ",", 
         RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], "]"}]}], ":=", 
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"X", ",", 
         RowBox[{"Exp", "/@", 
          RowBox[{"(", 
           RowBox[{"n1", "*", "n2", "*", "evals"}], ")"}]}], ",", "Xinv"}], 
        "}"}], ",", "opbasis", ",", "basis", ",", "opts"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120407135746*^9, 3.683120414598955*^9}, {
   3.745399728350964*^9, 3.745399732249243*^9}},
 CellLabel->
  "In[1003]:=",ExpressionUUID->"3bb0dbb3-aaa0-46c0-b70d-ba922f32a46e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Power", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "[", 
      RowBox[{"E", "^", 
       RowBox[{"(", 
        RowBox[{"Times", "[", 
         RowBox[{
          RowBox[{"n1___", "?", "NumericQ"}], ",", 
          RowBox[{"Superoperator", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
              RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "opbasis_", 
            ",", "basis_", ",", "opts___Rule"}], "]"}], ",", 
          RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], ")"}]}], "]"}], ":=", 
     RowBox[{"Superoperator", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"X", ",", 
         RowBox[{"Exp", "/@", 
          RowBox[{"(", 
           RowBox[{"n1", "*", "n2", "*", "evals"}], ")"}]}], ",", "Xinv"}], 
        "}"}], ",", "opbasis", ",", "basis", ",", "opts"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120407135746*^9, 3.6831204385839577`*^9}, {
   3.7453997385512*^9, 3.745399741699047*^9}, 3.745484542259606*^9},
 CellLabel->
  "In[1004]:=",ExpressionUUID->"0792e85b-1d25-4329-b73f-5f2ce2051d80"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Adjoint of Superoperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.531834281301166*^9, 3.531834283424567*^9}, {3.586081377738758*^9, 
  3.586081381192855*^9}, {3.586081437012541*^9, 3.586081447501163*^9}, {
  3.590660286090549*^9, 3.59066028905759*^9}, {3.590666451590005*^9, 
  3.5906664525074244`*^9}},ExpressionUUID->"bc89d1af-d758-449c-9ee9-\
15c20484f7c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"Adjoint", "[", 
    RowBox[{"Superoperator", "[", 
     RowBox[{
      RowBox[{"mat_", "?", "MatrixQ"}], ",", "opbasis_", ",", "basis_", ",", 
      "opts___Rule"}], "]"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Switch", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SuperoperatorType", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Superoperator", "]"}]}], ",", 
       "\[IndentingNewLine]", "\"\<Hermitian\>\"", ",", "mat", ",", 
       "\[IndentingNewLine]", "_", ",", 
       RowBox[{"Adjoint", "[", "mat", "]"}]}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", "opbasis", ",", "basis", ",", "opts"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590660292634741*^9, 3.590660388453232*^9}, {
   3.590660419024871*^9, 3.590660450761305*^9}, {3.590660488652382*^9, 
   3.590660598158297*^9}, {3.590666459303031*^9, 3.590666514498798*^9}, 
   3.657821352257407*^9, 3.659525837177271*^9, 3.659525970359647*^9},
 CellLabel->
  "In[1005]:=",ExpressionUUID->"18002ac5-5455-4c10-89b1-2f319aef5f97"]
}, Closed]],

Cell[CellGroupData[{

Cell["application of a Superoperator to an operator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.504110447654697*^9, 3.504110452356811*^9}, {3.590666521437893*^9, 
  3.590666523121393*^9}, {3.5906675229189577`*^9, 
  3.590667526002738*^9}},ExpressionUUID->"adec2bf0-ed50-4f5c-b51a-\
f28ede7f5f1a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"sop_Superoperator", "[", "op_Operator", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"opbasis", "=", 
        RowBox[{"OperatorBasis", "[", "]"}]}], ";", 
       RowBox[{"basis", "=", 
        RowBox[{"Basis", "[", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"SuperoperatorMatrixRepresentation", "[", 
           RowBox[{"sop", ",", "opbasis", ",", "basis"}], "]"}], ".", 
          "\[IndentingNewLine]", 
          RowBox[{"OperatorVectorRepresentation", "[", 
           RowBox[{"op", ",", "opbasis", ",", "basis"}], "]"}]}], ",", 
         "\[IndentingNewLine]", "opbasis", ",", "\[IndentingNewLine]", 
         "basis"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590659844004518*^9, 3.590659881678423*^9}, {
  3.5906665265489397`*^9, 3.590666541538485*^9}, {3.616690798097127*^9, 
  3.616690833480699*^9}},
 CellLabel->
  "In[1006]:=",ExpressionUUID->"cf083b9c-5573-4f78-8899-dbaa943c1da8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"sop_Superoperator", "[", 
    RowBox[{"op_", "?", "OperatorQ"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"opbasis", "=", 
        RowBox[{"OperatorBasis", "[", "]"}]}], ";", 
       RowBox[{"basis", "=", 
        RowBox[{"Basis", "[", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BasisOperators", "[", "opbasis", "]"}], ".", 
        RowBox[{"SuperoperatorMatrixRepresentation", "[", 
         RowBox[{"sop", ",", "opbasis", ",", "basis"}], "]"}], ".", 
        RowBox[{"OperatorVectorRepresentation", "[", 
         RowBox[{"op", ",", "opbasis"}], "]"}]}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590659844004518*^9, 3.590659881678423*^9}, {
  3.5906665265489397`*^9, 3.590666541538485*^9}, {3.616690798097127*^9, 
  3.61669085557856*^9}},
 CellLabel->
  "In[1007]:=",ExpressionUUID->"51a40a67-aa5e-4378-b0aa-c771b9efe2b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "[", 
      RowBox[{"Dot", "[", 
       RowBox[{"c__", ",", "sop_Superoperator", ",", 
        RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], "]"}], ":=", 
     RowBox[{"Dot", "[", 
      RowBox[{"c", ",", 
       RowBox[{"sop", "[", "op", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120461414885*^9, 3.683120466472149*^9}, {
   3.745399749417947*^9, 3.74539975284944*^9}},
 CellLabel->
  "In[1008]:=",ExpressionUUID->"771f3215-3b3b-4cc6-9a58-9cc0f5be8e2c"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Dot", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"Dot", "[", 
        RowBox[{"c__", ",", "sop_Superoperator"}], "]"}], "[", 
       RowBox[{"op_", "?", "OperatorQ"}], "]"}], "]"}], ":=", 
     RowBox[{"Dot", "[", 
      RowBox[{"c", ",", 
       RowBox[{"sop", "[", "op", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120461414885*^9, 3.68312048058241*^9}, {
   3.745399759003271*^9, 3.745399761899294*^9}},
 CellLabel->
  "In[1009]:=",ExpressionUUID->"ca7e9206-7d2c-4bfa-bb63-b2e19381729e"]
}, Open  ]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.504110447654697*^9, 3.504110452356811*^9}, {3.504110833805093*^9, 
  3.504110834267372*^9}, {3.531830571404662*^9, 
  3.531830572473724*^9}},ExpressionUUID->"076e89e1-ef53-49b9-8b70-\
3ee669153ebd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "::", "notherm"}], "=", 
   "\"\<The context requires a hermitian superoperator, but a violation is \
suspected. Continuing anyway.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5318306093917017`*^9, 3.531830669117261*^9}, {
  3.5318307398380117`*^9, 3.53183074822178*^9}, {3.531834533054112*^9, 
  3.531834545385674*^9}, {3.531835095406083*^9, 3.531835098773775*^9}, {
  3.531927497743321*^9, 3.53192750136348*^9}, {3.531927648819942*^9, 
  3.531927656581359*^9}, {3.53193493812146*^9, 3.5319350165461807`*^9}},
 CellLabel->
  "In[1010]:=",ExpressionUUID->"6cbeb85d-e4ea-4583-8826-a19abd6cf928"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "::", "notunitary"}], "=", 
   "\"\<The context implies a unitary superoperator, but a violation is \
suspected. Continuing anyway.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5318306093917017`*^9, 3.531830669117261*^9}, {
   3.5318307326901083`*^9, 3.5318307746200542`*^9}, {3.5318345630127573`*^9, 
   3.5318345686976852`*^9}, {3.5318351024806843`*^9, 3.531835106977257*^9}, {
   3.531927663352419*^9, 3.531927678685457*^9}, 3.5319349423754463`*^9, 
   3.5319350280494213`*^9},
 CellLabel->
  "In[1011]:=",ExpressionUUID->"b7d28878-4eb7-4518-b2e3-d988224cfd0c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "::", "notnormal"}], "=", 
   "\"\<The context implies a normal superoperator, but a violation is \
suspected. Continuing anyway.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5318306093917017`*^9, 3.531830669117261*^9}, {
   3.5318307326901083`*^9, 3.5318307746200542`*^9}, {3.5318345630127573`*^9, 
   3.5318345686976852`*^9}, {3.5318351024806843`*^9, 3.531835106977257*^9}, {
   3.531927663352419*^9, 3.5319276983078012`*^9}, 3.531934946239992*^9, {
   3.531935034366679*^9, 3.5319350370609293`*^9}},
 CellLabel->
  "In[1012]:=",ExpressionUUID->"ac883e3c-9f22-4658-b33c-0e3cf9a91447"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "::", "badsoptype"}], "=", 
   "\"\<SuperoperatorType `1` not recognized.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531832786290778*^9, 3.531832798008423*^9}, {
  3.531927703123184*^9, 3.5319277077480164`*^9}},
 CellLabel->
  "In[1013]:=",ExpressionUUID->"7260d2c5-b939-4407-a69a-f0f5a8a0b5f7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "::", "incompatspinsys"}], "=", 
   "\"\<The Superoperator expression has been defined using a spin system \
incompatible with the requested operator basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531832786290778*^9, 3.531832798008423*^9}, {
  3.531842777961989*^9, 3.5318428134810133`*^9}, {3.5319277125551043`*^9, 
  3.531927725212186*^9}},
 CellLabel->
  "In[1014]:=",ExpressionUUID->"ab6f2ddd-a15d-4be6-b4cf-0f9e55e08e82"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "::", "badsop"}], "=", 
   "\"\<Superoperator may not be applied to a symbol that is not a \
superoperator, a matrix, or the diagonalized form of a matrix.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929801671324*^9, 3.531929825407236*^9}, {
  3.586163563113627*^9, 3.586163582637349*^9}},
 CellLabel->
  "In[1015]:=",ExpressionUUID->"115af249-4c11-499a-9f0b-ed7ee0d2ea5a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Superoperator", "::", "assnorm"}], "=", 
    "\"\<To reduce computation time, a superoperator has been assumed to be \
Normal. This assumption is made when the operator basis dimension is larger \
than `1`.\>\""}], ";"}], " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5834306980886097`*^9, 3.5834308008052998`*^9}},
 CellLabel->
  "In[1016]:=",ExpressionUUID->"55776a7d-c5c6-4e33-91a7-e7be92626b65"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "::", "times"}], "=", 
   "\"\<superoperators must be multiplied by Dot (\\\".\\\"), not with Times \
(\\\"\[Times]\\\")\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.589481063735985*^9, 3.5894811013561783`*^9}, {
   3.589482193124737*^9, 3.5894822074096127`*^9}, 3.589823569505417*^9, {
   3.589823966155089*^9, 3.589823969276016*^9}},
 CellLabel->
  "In[1017]:=",ExpressionUUID->"90554043-c9e8-47a9-a16e-7dcbe4d9fabe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Superoperator", "::", "baddims"}], "=", 
   "\"\<the Superoperator definition uses a matrix whose dimensions are \
inconsistent with the specified operator basis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6406042189571877`*^9, 3.640604256668478*^9}, {
  3.640604425407238*^9, 3.6406044335953712`*^9}},
 CellLabel->
  "In[1018]:=",ExpressionUUID->"826a4d49-a7d6-4103-b89f-098502ecc9d1"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["UnitySuperoperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"ec2a460b-9f5f-4254-b864-669c6c9cc63d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UnitySuperoperator", "[", "]"}], "[", "op_", "]"}], ":=", "op"}],
   ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.486710695536574*^9, 3.486710695749104*^9}},
 CellLabel->
  "In[1019]:=",ExpressionUUID->"63533103-be1a-4fb1-adc3-3e22c5a17479"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UnitySuperoperator", "/:", 
   RowBox[{"Dot", "[", 
    RowBox[{"a___", ",", 
     RowBox[{"UnitySuperoperator", "[", "]"}], ",", "b__"}], "]"}], ":=", 
   RowBox[{"Dot", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452691442358994*^9, 3.4526914626128902`*^9}, {
   3.4526919444501057`*^9, 3.452691945794935*^9}, {3.452692115277546*^9, 
   3.4526921182336187`*^9}, 3.460713243856969*^9, {3.486710699192233*^9, 
   3.486710699550582*^9}},
 CellLabel->
  "In[1020]:=",ExpressionUUID->"246c02b2-d769-4066-97f9-4c1f35e20fe2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UnitySuperoperator", "/:", 
   RowBox[{"Dot", "[", 
    RowBox[{"a__", ",", 
     RowBox[{"UnitySuperoperator", "[", "]"}], ",", "b___"}], "]"}], ":=", 
   RowBox[{"Dot", "[", 
    RowBox[{"a", ",", "b"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452691442358994*^9, 3.4526914626128902`*^9}, {
  3.4526919444501057`*^9, 3.452691945794935*^9}, {3.452692115277546*^9, 
  3.4526921182336187`*^9}, {3.460713243856969*^9, 3.460713259388493*^9}, {
  3.4867107022217197`*^9, 3.486710702577228*^9}},
 CellLabel->
  "In[1021]:=",ExpressionUUID->"0af2582d-7a81-4762-b251-bd72d8a2050b"],

Cell[CellGroupData[{

Cell["Display", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"67c6fd62-1e62-4c37-8299-72eea690c8c2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UnitySuperoperator", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{"UnitySuperoperator", "[", "]"}], "]"}], ":=", " ", 
   "\"\<\!\(\*OverscriptBox[\(\[DoubleStruckOne]\), \(^\)]\)\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.430589375877718*^9, 3.430623981159732*^9, {3.430624334592304*^9, 
   3.43062436178749*^9}, 3.4306245052321672`*^9, 3.430624615967164*^9, 
   3.43062482206208*^9, {3.430625199519032*^9, 3.430625200643235*^9}, 
   3.430625731110174*^9, {3.467302992635832*^9, 3.4673030300493107`*^9}, {
   3.4867107147045193`*^9, 3.486710715108223*^9}},
 CellLabel->
  "In[1022]:=",ExpressionUUID->"04ba97f0-0994-4602-be98-4c8d5aab7f6d"]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.5898235112181168`*^9},ExpressionUUID->"1ea2f66d-5581-4ba7-a4b4-\
9c0617424374"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UnitySuperoperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_UnitySuperoperator", ",", "b___"}], "]"}], "]"}],
     "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"SuperoperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Superoperator", "::", "times"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.589824007778718*^9, 
   3.5898240231530933`*^9}},
 CellLabel->
  "In[1023]:=",ExpressionUUID->"36220375-a834-495c-9b60-c76688d99d18"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to 0", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5930117533496227`*^9, 
  3.593011756685623*^9}},ExpressionUUID->"3cfc46a4-b942-48f0-9c6f-\
1dd0c7ad83dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UnitySuperoperator", "[", "0", "]"}], "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.593011804919347*^9}},
 CellLabel->
  "In[1024]:=",ExpressionUUID->"78ea57d2-fd94-48e8-b8e4-f7001001fd0a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["NullSuperoperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.467302471290369*^9, 3.4673024720646057`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"41f887a7-92f2-4728-922e-aaa8eb8382d3"],

Cell[CellGroupData[{

Cell["Display", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"f7f9e19a-a2b6-42f0-b675-0cb41e5d2468"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullSuperoperator", "/:", 
   RowBox[{"Format", "[", 
    RowBox[{"NullSuperoperator", "[", "]"}], "]"}], ":=", 
   "\"\<\!\(\*OverscriptBox[\(0\), \(^\)]\)\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.430589375877718*^9, 3.430623981159732*^9, {3.430624334592304*^9, 
   3.43062436178749*^9}, 3.4306245052321672`*^9, 3.430624615967164*^9, 
   3.43062482206208*^9, {3.430625199519032*^9, 3.430625200643235*^9}, 
   3.430625731110174*^9, {3.467302992635832*^9, 3.467303060448409*^9}, 
   3.486710868277564*^9},
 CellLabel->
  "In[1025]:=",ExpressionUUID->"36cc0de6-9539-4803-9290-accb4848df5c"]
}, Closed]],

Cell[CellGroupData[{

Cell["NullSuperoperator applied to an operator", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.502518267681621*^9, 
  3.502518271230503*^9}},ExpressionUUID->"8c2e950f-af3b-4b65-b5eb-\
e5729c02e8e6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NullSuperoperator", "[", "]"}], "[", "op_", "]"}], ":=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.467302476054577*^9, 3.467302480554842*^9}, {
  3.486710840951256*^9, 3.4867108436123657`*^9}},
 CellLabel->
  "In[1026]:=",ExpressionUUID->"33cb4f62-0706-400e-b80d-befc0249ef52"]
}, Closed]],

Cell[CellGroupData[{

Cell["NullSuperoperator in superoperator products", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.502518267681621*^9, 
  3.502518283686841*^9}},ExpressionUUID->"d8a702c1-6efa-48c8-8b2d-\
ba4ef860f34e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullSuperoperator", "/:", 
   RowBox[{"Dot", "[", 
    RowBox[{"a___", ",", 
     RowBox[{"NullSuperoperator", "[", "]"}], ",", "b__"}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452691442358994*^9, 3.4526914626128902`*^9}, {
   3.4526919444501057`*^9, 3.452691945794935*^9}, {3.452692115277546*^9, 
   3.4526921182336187`*^9}, 3.460713243856969*^9, {3.467302485005608*^9, 
   3.467302489365286*^9}, {3.486710854291028*^9, 3.486710859098022*^9}},
 CellLabel->
  "In[1027]:=",ExpressionUUID->"baf471ba-579a-49fb-84eb-c034269e141a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullSuperoperator", "/:", 
   RowBox[{"Dot", "[", 
    RowBox[{"a__", ",", 
     RowBox[{"NullSuperoperator", "[", "]"}], ",", "b___"}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452691442358994*^9, 3.4526914626128902`*^9}, {
  3.4526919444501057`*^9, 3.452691945794935*^9}, {3.452692115277546*^9, 
  3.4526921182336187`*^9}, {3.460713243856969*^9, 3.460713259388493*^9}, {
  3.467302493357449*^9, 3.467302498702116*^9}, {3.486710862258586*^9, 
  3.4867108636891127`*^9}},
 CellLabel->
  "In[1028]:=",ExpressionUUID->"a085b70f-0816-4fdd-ba69-6d4485ebedd0"]
}, Closed]],

Cell[CellGroupData[{

Cell["sums and numerical factors", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517764378899*^9}, {
  3.502517895129891*^9, 
  3.502517902137464*^9}},ExpressionUUID->"d15859bf-3d48-4840-a027-\
75c96dea022e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullSuperoperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Times", "[", 
     RowBox[{
      RowBox[{"n1___", "?", "NumericQ"}], ",", 
      RowBox[{"NullSuperoperator", "[", "]"}], ",", 
      RowBox[{"n2___", "?", "NumericQ"}]}], "]"}]}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502517846493984*^9, 3.502517946749755*^9}, {
  3.5025182946360073`*^9, 3.502518308832777*^9}},
 CellLabel->
  "In[1029]:=",ExpressionUUID->"647df764-de71-432c-9b0d-2f7d31a4152a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullSuperoperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{
      RowBox[{"sops2___", "?", "SuperoperatorQ"}], ",", 
      RowBox[{"NullSuperoperator", "[", "]"}], ",", 
      RowBox[{"sops1___", "?", "SuperoperatorQ"}]}], "]"}]}], ":=", 
   RowBox[{"Plus", "[", 
    RowBox[{"sops2", ",", "sops1"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.44834857702761*^9, 3.448348662101181*^9, {3.502517772676806*^9, 
   3.502517830708547*^9}, {3.5025179380946283`*^9, 3.502518003325676*^9}, {
   3.5025183202283688`*^9, 3.502518342019199*^9}, {3.502518390396392*^9, 
   3.502518405233592*^9}},
 CellLabel->
  "In[1030]:=",ExpressionUUID->"abd90a9f-075e-46d8-bb37-f8db6a2105ea"]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.5898235112181168`*^9},ExpressionUUID->"c70ef8ce-ddf3-4641-bf00-\
c93799a92d45"],

Cell[BoxData[
 RowBox[{
  RowBox[{"NullSuperoperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_NullSuperoperator", ",", "b___"}], "]"}], "]"}], 
    "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"SuperoperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Superoperator", "::", "times"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.589824007778718*^9, 
   3.5898240231530933`*^9}, {3.589824060303439*^9, 3.589824062258607*^9}},
 CellLabel->
  "In[1031]:=",ExpressionUUID->"4b70175e-c11f-4be8-b594-70eb7aafc3b1"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to 0", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5930117533496227`*^9, 
  3.593011756685623*^9}},ExpressionUUID->"24b991fe-d0dd-4f63-83db-\
c667b37ecf2a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NullSuperoperator", "[", "0", "]"}], "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.59301181782306*^9}},
 CellLabel->
  "In[1032]:=",ExpressionUUID->"5109bbbf-3fcb-4923-8be3-6c13f23a80f8"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CommutationSuperoperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435243138565358*^9, 3.435243153291615*^9}, {
   3.4483485680516853`*^9, 3.448348569105796*^9}, 3.502518224625395*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"382d62dd-f2cf-4e6c-84c3-aad85797be1e"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517764378899*^9}, {
  3.502517895129891*^9, 3.502517902137464*^9}, {3.586252293223474*^9, 
  3.586252295261443*^9}},ExpressionUUID->"d1f352a5-1628-4b30-8679-\
4948372fa91f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Options", "[", "CommutationSuperoperator", "]"}], "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"OperatorType", "\[Rule]", "Undefined"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", "None"}]}], "}"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5862522974658823`*^9, 3.586252322627699*^9}},
 CellLabel->
  "In[1033]:=",ExpressionUUID->"719f8054-9b1f-4efb-af88-989d69bd3e59"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"OperatorType", "\[Rule]", "Undefined"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", "None"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.745483836368883*^9, 3.745483839417948*^9}},
 CellLabel->
  "Out[1033]=",ExpressionUUID->"7438e479-7229-41fa-a30f-7850221647ec"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.5898235112181168`*^9},ExpressionUUID->"d47fe0f0-62d7-48f6-8b35-\
5a792cd5d3e0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CommutationSuperoperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_CommutationSuperoperator", ",", "b___"}], "]"}], 
     "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"SuperoperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Superoperator", "::", "times"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.589824007778718*^9, 
   3.5898240231530933`*^9}, {3.589824060303439*^9, 3.589824089178906*^9}},
 CellLabel->
  "In[1034]:=",ExpressionUUID->"4489909d-79f3-4691-ae0d-32314a69b7db"]
}, Closed]],

Cell[CellGroupData[{

Cell["sums and numerical factors", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517764378899*^9}, {
  3.502517895129891*^9, 
  3.502517902137464*^9}},ExpressionUUID->"ea41f146-7879-4948-ab8f-\
1d74ff1464ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CommutationSuperoperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Times", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"n1", ":", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{
           RowBox[{"_", "?", "OperatorQ"}], "|", 
           RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}], "..."}]}], ")"}], 
      ",", 
      RowBox[{"CommutationSuperoperator", "[", 
       RowBox[{
        RowBox[{"op1_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ",", 
      
      RowBox[{"(", 
       RowBox[{"n2", ":", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{
           RowBox[{"_", "?", "OperatorQ"}], "|", 
           RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}], "..."}]}], ")"}]}], 
     "]"}]}], ":=", 
   RowBox[{"CommutationSuperoperator", "[", 
    RowBox[{
     RowBox[{"Times", "[", 
      RowBox[{"n1", ",", "n2", ",", "op1"}], "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502517846493984*^9, 3.502517946749755*^9}, {
  3.5066198943388453`*^9, 3.506619944682684*^9}, {3.586252329912006*^9, 
  3.58625233839782*^9}, {3.5863500811623774`*^9, 3.5863500846221247`*^9}, {
  3.586350152045644*^9, 3.5863501546481953`*^9}},
 CellLabel->
  "In[1035]:=",ExpressionUUID->"71725114-be1c-4b49-acf0-245e495e1c8b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CommutationSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{
      RowBox[{"CommutationSuperoperator", "[", 
       RowBox[{"op1_", ",", "opts1___Rule"}], "]"}], ",", 
      RowBox[{"CommutationSuperoperator", "[", 
       RowBox[{"op2_", ",", "opts2___Rule"}], "]"}], ",", "more___"}], 
     "]"}]}], ":=", 
   RowBox[{"Plus", "[", 
    RowBox[{
     RowBox[{"CommutationSuperoperator", "[", 
      RowBox[{
       RowBox[{"op1", "+", "op2"}], ",", 
       RowBox[{"SimplifyRules", "[", 
        RowBox[{"opts1", ",", "opts2"}], "]"}]}], "]"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691059091790533*^9, 3.6910591966129837`*^9}},
 CellLabel->
  "In[1036]:=",ExpressionUUID->"c008a042-c3e6-4f21-b431-4673bd7b4f0d"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to 0", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5930117533496227`*^9, 
  3.593011756685623*^9}},ExpressionUUID->"0f3238e8-22ec-4b94-aa6a-\
70e2d11e1241"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"sop_CommutationSuperoperator", "[", "0", "]"}], "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.5930118399965353`*^9}},
 CellLabel->
  "In[1037]:=",ExpressionUUID->"4dceffb1-fe23-4dee-84ff-e6deece1d518"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle OperatorType", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.586254495213749*^9, 3.586254507924302*^9}, {3.586255024399542*^9, 
  3.586255026036367*^9}, {3.5863444657998667`*^9, 
  3.586344494875669*^9}},ExpressionUUID->"5da2ba74-a93c-490b-95b2-\
7d071fd7c259"],

Cell[CellGroupData[{

Cell["inherit the OperatorType from a contained Operator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.586254495213749*^9, 3.586254507924302*^9}, {3.586255024399542*^9, 
  3.586255026036367*^9}, {3.5863444657998667`*^9, 
  3.5863444693304377`*^9}},ExpressionUUID->"23b84ba3-fea0-4ef1-a2f9-\
3610d431758c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommutationSuperoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Operator", "[", 
      RowBox[{"op_", ",", "basis_", ",", "opopts___Rule"}], "]"}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"optype", ",", "csoptype"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"CommutationSuperoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Operator", "[", 
          RowBox[{"op", ",", "basis", ",", "opopts"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"OperatorType", "\[Rule]", "optype"}], ",", 
           "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
        "\[IndentingNewLine]", "]"}], "/;", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"optype", "=", 
          RowBox[{
           RowBox[{"OperatorType", "/.", 
            RowBox[{"{", "opopts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Operator", "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"csoptype", "=", 
          RowBox[{
           RowBox[{"OperatorType", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "CommutationSuperoperator", "]"}]}]}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"optype", ",", "csoptype"}], "]"}]}]}], 
        "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586344031467146*^9, 3.586344160475876*^9}, {
  3.586344286652322*^9, 3.586344402609536*^9}, {3.586344438122717*^9, 
  3.586344448267138*^9}},
 CellLabel->
  "In[1038]:=",ExpressionUUID->"d303b339-f7b3-4e0b-a973-ecb398e05d36"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
remove Assumptions for OperatorType is the type is fully determined and \
consistent\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.586254495213749*^9, 3.586254507924302*^9}, {3.586255024399542*^9, 
  3.586255026036367*^9}, {3.5863444657998667`*^9, 3.5863444693304377`*^9}, {
  3.586349031183301*^9, 
  3.586349058926166*^9}},ExpressionUUID->"9e2f03b5-8c20-4aa0-8fec-\
2df87b48e345"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommutationSuperoperator", "[", 
    RowBox[{"op_Operator", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ass", ",", "optype", ",", "assoptype"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"CommutationSuperoperator", "[", 
        RowBox[{"op", ",", "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Assumptions", "\[Rule]", "None"}], ",", 
           "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
        "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ass", "=", 
         RowBox[{"Assumptions", "/.", 
          RowBox[{"{", "opts", "}"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"optype", "=", 
         RowBox[{
          RowBox[{"OperatorType", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "CommutationSuperoperator", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"ass", ",", 
           RowBox[{"{", 
            RowBox[{"_Rule", ".."}], "}"}]}], "]"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"optype", ",", "Undefined"}], "]"}]}], "&&", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"assoptype", "=", 
            RowBox[{
             RowBox[{"OperatorType", "/.", "ass"}], "/.", 
             RowBox[{"Options", "[", "CommutationSuperoperator", "]"}]}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"MatchQ", "[", 
             RowBox[{"assoptype", ",", "optype"}], "]"}], "||", 
            "\[IndentingNewLine]", 
            RowBox[{"MatchQ", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"optype", ",", "assoptype"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                "\"\<Hermitian\>\"", "|", "\"\<AntiHermitian\>\"", "|", 
                 "\"\<Unitary\>\""}], ",", "\"\<Normal\>\""}], "}"}]}], 
             "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586346832228771*^9, 3.5863469518379097`*^9}, {
   3.586346987791679*^9, 3.586347284171344*^9}, {3.586347409350423*^9, 
   3.586347413499474*^9}, 3.586347478900434*^9, {3.586347832572936*^9, 
   3.5863479485195627`*^9}, {3.5863479789986467`*^9, 3.586347982093346*^9}, {
   3.5863491002729397`*^9, 3.5863491202050323`*^9}},
 CellLabel->
  "In[1039]:=",ExpressionUUID->"8c3fc7e2-e2af-4541-aad7-988d89dca8ce"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
detect a conflict between the Assumptions and a determined OperatorType, and \
issue a warning if necessary\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.586254495213749*^9, 3.586254507924302*^9}, {3.586255024399542*^9, 
  3.586255026036367*^9}, {3.5863444657998667`*^9, 3.5863444693304377`*^9}, {
  3.586344510470888*^9, 3.586344537506504*^9}, {3.586345006203725*^9, 
  3.5863450106559343`*^9}, {3.586346795746935*^9, 
  3.586346819231881*^9}},ExpressionUUID->"b5254597-100b-423f-88a6-\
3226059ac608"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommutationSuperoperator", "[", 
    RowBox[{"op_Operator", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ass", ",", "optype", ",", "assoptype"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"CommutationSuperoperator", "::", "badass"}], ",", 
          "assoptype", ",", "optype"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"CommutationSuperoperator", "[", 
         RowBox[{"op", ",", "\[IndentingNewLine]", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Assumptions", "\[Rule]", "None"}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ass", "=", 
         RowBox[{"Assumptions", "/.", 
          RowBox[{"{", "opts", "}"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"optype", "=", 
         RowBox[{
          RowBox[{"OperatorType", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "CommutationSuperoperator", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"ass", ",", 
           RowBox[{"{", 
            RowBox[{"_Rule", ".."}], "}"}]}], "]"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"optype", ",", "Undefined"}], "]"}]}], "&&", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"assoptype", "=", 
            RowBox[{
             RowBox[{"OperatorType", "/.", "ass"}], "/.", 
             RowBox[{"Options", "[", "CommutationSuperoperator", "]"}]}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"!", 
             RowBox[{"MatchQ", "[", 
              RowBox[{"assoptype", ",", "optype"}], "]"}]}], "&&", 
            "\[IndentingNewLine]", 
            RowBox[{"!", 
             RowBox[{"MatchQ", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"optype", ",", "assoptype"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                 "\"\<Hermitian\>\"", "|", "\"\<AntiHermitian\>\"", "|", 
                  "\"\<Unitary\>\""}], ",", "\"\<Normal\>\""}], "}"}]}], 
              "]"}]}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586346832228771*^9, 3.5863469518379097`*^9}, {
   3.586346987791679*^9, 3.586347284171344*^9}, {3.586347409350423*^9, 
   3.586347413499474*^9}, 3.586347478900434*^9, {3.586347832572936*^9, 
   3.5863479485195627`*^9}, {3.5863479789986467`*^9, 3.586347982093346*^9}},
 CellLabel->
  "In[1040]:=",ExpressionUUID->"36632bc5-33a5-46b6-a921-d9bfe3398080"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CommutationSuperoperator of NullOperator and UnityOperator", \
"Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517764378899*^9}, {
  3.502517895129891*^9, 3.502517902137464*^9}, {3.533182376133717*^9, 
  3.5331824073201113`*^9}},ExpressionUUID->"aa11abd9-be09-42f3-96aa-\
f864a769fefb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommutationSuperoperator", "[", 
    RowBox[{"0", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.555568788824719*^9, {3.5555688256069803`*^9, 3.5555688613653584`*^9}, {
   3.586252613769566*^9, 3.586252614085248*^9}},
 CellLabel->
  "In[1041]:=",ExpressionUUID->"7a97b6b1-f435-4d0d-a67b-356bcae7f246"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommutationSuperoperator", "[", 
    RowBox[{
     RowBox[{"NullOperator", "[", "___", "]"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533182384289412*^9, 3.5331824016047173`*^9}, {
  3.586252616708723*^9, 3.586252617045567*^9}},
 CellLabel->
  "In[1042]:=",ExpressionUUID->"2594d716-d38f-49b3-b86b-92dca9f0b91c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommutationSuperoperator", "[", 
    RowBox[{
     RowBox[{"UnityOperator", "[", "___", "]"}], ",", "opts___Rule"}], "]"}], 
   ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533182384289412*^9, 3.533182414672029*^9}, {
  3.5862526193968573`*^9, 3.5862526197015877`*^9}},
 CellLabel->
  "In[1043]:=",ExpressionUUID->"45f0e9fa-0cff-4be9-adae-6716eb91864e"]
}, Closed]],

Cell[CellGroupData[{

Cell["CommutationSuperoperator applied to an operator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 
  3.502517750937834*^9}},ExpressionUUID->"c9228dcf-bfb2-4c50-9ab1-\
faad5698b3c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommutationSuperoperator", "[", "op1_", "]"}], "[", "op2_", "]"}],
   ":=", 
  RowBox[{"Commutator", "[", 
   RowBox[{"op1", ",", "op2"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.44834857702761*^9, 3.448348662101181*^9},
 CellLabel->
  "In[1044]:=",ExpressionUUID->"cad45891-9df3-418f-926d-86d146706246"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
exponential of a CommutationSuperoperator applied to an operator\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.502518217440444*^9, 
  3.502518220222917*^9}},ExpressionUUID->"a63d20ab-9b2b-4bdc-ad47-\
87a5ebb784a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Power", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Power", "/:", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"E", ",", 
         RowBox[{"Times", "[", 
          RowBox[{"num1___", ",", 
           RowBox[{"CommutationSuperoperator", "[", 
            RowBox[{"op1_", ",", "opts___Rule"}], "]"}], ",", "num2___"}], 
          "]"}]}], "]"}], "[", "op2_", "]"}], "\[IndentingNewLine]", "]"}], ":=", 
     RowBox[{
      RowBox[{"UnitySuperoperator", "[", "]"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Times", "[", 
         RowBox[{"num1", "*", "num2"}], "]"}], "\[Equal]", "0"}], ")"}]}]}]}],
    "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120496606058*^9, 3.683120511659637*^9}, {
   3.745399770650709*^9, 3.745399773751646*^9}, {3.74548455365849*^9, 
   3.745484568507922*^9}},
 CellLabel->
  "In[1045]:=",ExpressionUUID->"8dfc1a7c-5466-4edc-b4b5-02fdd084d2a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Power", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Power", "/:", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"E", ",", 
         RowBox[{"Times", "[", 
          RowBox[{"num1___", ",", 
           RowBox[{"CommutationSuperoperator", "[", 
            RowBox[{"op1_", ",", "opts___Rule"}], "]"}], ",", "num2___"}], 
          "]"}]}], "]"}], "[", "op2_", "]"}], "\[IndentingNewLine]", "]"}], ":=", 
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{"Exp", "[", 
        RowBox[{"num1", "*", "num2", "*", "op1"}], "]"}], ",", "op2", ",", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "num1"}], "*", "num2", "*", "op1"}], "]"}]}], "]"}]}]}],
    "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120496606058*^9, 3.6831205245383*^9}, {
   3.7453997795553493`*^9, 3.74539978240212*^9}, {3.745484575356578*^9, 
   3.745484578006555*^9}},
 CellLabel->
  "In[1046]:=",ExpressionUUID->"b2f9b281-7c23-4fb7-a816-4533f5d0ea6e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Power", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Power", "/:", "\[IndentingNewLine]", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"E", ",", 
         RowBox[{"CommutationSuperoperator", "[", 
          RowBox[{"op1_", ",", "opts___Rule"}], "]"}]}], "]"}], "[", "op2_", 
       "]"}], "\[IndentingNewLine]", "]"}], ":=", 
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{"Exp", "[", "op1", "]"}], ",", "op2", ",", 
       RowBox[{"Exp", "[", 
        RowBox[{"-", "op1"}], "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120496606058*^9, 3.6831205387230997`*^9}, 
   3.745399790151847*^9, {3.745484586405575*^9, 3.7454845879187107`*^9}},
 CellLabel->
  "In[1047]:=",ExpressionUUID->"05c1987a-41d0-47b3-b073-ab7a4ec7009d"]
}, Open  ]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.502518217440444*^9, 3.502518220222917*^9}, {3.586347295915571*^9, 
  3.58634729702556*^9}},ExpressionUUID->"a0e2c95b-d4c1-4975-99b2-\
be1107ecbc2b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CommutationSuperoperator", "::", "badass"}], "=", 
   "\"\<A conflict has been detected between the assumed OperatorType \\\"`1`\
\\\" for the argument of a CommutationSuperoperator, and the determined \
OperatorType \\\"`2`\\\". Proceeding with Assumptions disabled.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586347307053904*^9, 3.586347392965835*^9}},
 CellLabel->
  "In[1048]:=",ExpressionUUID->"8fe3f063-6579-4282-82be-c7b39391576a"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["LeftMultiplicationSuperoperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435243138565358*^9, 3.435243153291615*^9}, {
   3.4483485680516853`*^9, 3.448348569105796*^9}, 3.502518224625395*^9, {
   3.7275217579004765`*^9, 3.727521762461782*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"382d62dd-f2cf-4e6c-84c3-aad85797be1e"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517764378899*^9}, {
  3.502517895129891*^9, 3.502517902137464*^9}, {3.586252293223474*^9, 
  3.586252295261443*^9}},ExpressionUUID->"d1f352a5-1628-4b30-8679-\
4948372fa91f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Options", "[", "LeftMultiplicationSuperoperator", "]"}], "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"OperatorType", "\[Rule]", "Undefined"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", "None"}]}], "}"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5862522974658823`*^9, 3.586252322627699*^9}, {
  3.727521775446906*^9, 3.727521779421384*^9}},
 CellLabel->
  "In[1049]:=",ExpressionUUID->"719f8054-9b1f-4efb-af88-989d69bd3e59"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"OperatorType", "\[Rule]", "Undefined"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", "None"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.745483836444195*^9, 3.7454838395359993`*^9}},
 CellLabel->
  "Out[1049]=",ExpressionUUID->"ec2bbae2-7b44-4fcd-9953-6cb5bade7eef"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.5898235112181168`*^9},ExpressionUUID->"d47fe0f0-62d7-48f6-8b35-\
5a792cd5d3e0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LeftMultiplicationSuperoperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_LeftMultiplicationSuperoperator", ",", "b___"}], 
      "]"}], "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"SuperoperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Superoperator", "::", "times"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.589824007778718*^9, 
   3.5898240231530933`*^9}, {3.589824060303439*^9, 3.589824089178906*^9}, {
   3.727521790591321*^9, 3.7275217947822666`*^9}},
 CellLabel->
  "In[1050]:=",ExpressionUUID->"4489909d-79f3-4691-ae0d-32314a69b7db"]
}, Closed]],

Cell[CellGroupData[{

Cell["sums and numerical factors", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517764378899*^9}, {
  3.502517895129891*^9, 
  3.502517902137464*^9}},ExpressionUUID->"ea41f146-7879-4948-ab8f-\
1d74ff1464ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LeftMultiplicationSuperoperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Times", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"n1", ":", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{
           RowBox[{"_", "?", "OperatorQ"}], "|", 
           RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}], "..."}]}], ")"}], 
      ",", 
      RowBox[{"LeftMultiplicationSuperoperator", "[", 
       RowBox[{
        RowBox[{"op1_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ",", 
      
      RowBox[{"(", 
       RowBox[{"n2", ":", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{
           RowBox[{"_", "?", "OperatorQ"}], "|", 
           RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}], "..."}]}], ")"}]}], 
     "]"}]}], ":=", 
   RowBox[{"LeftMultiplicationSuperoperator", "[", 
    RowBox[{
     RowBox[{"Times", "[", 
      RowBox[{"n1", ",", "n2", ",", "op1"}], "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502517846493984*^9, 3.502517946749755*^9}, {
  3.5066198943388453`*^9, 3.506619944682684*^9}, {3.586252329912006*^9, 
  3.58625233839782*^9}, {3.5863500811623774`*^9, 3.5863500846221247`*^9}, {
  3.586350152045644*^9, 3.5863501546481953`*^9}, {3.7275218607747226`*^9, 
  3.7275218778506317`*^9}},
 CellLabel->
  "In[1051]:=",ExpressionUUID->"71725114-be1c-4b49-acf0-245e495e1c8b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"LeftMultiplicationSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{
      RowBox[{"LeftMultiplicationSuperoperator", "[", 
       RowBox[{"op1_", ",", "opts1___Rule"}], "]"}], ",", 
      RowBox[{"LeftMultiplicationSuperoperator", "[", 
       RowBox[{"op2_", ",", "opts2___Rule"}], "]"}], ",", "more___"}], 
     "]"}]}], ":=", 
   RowBox[{"Plus", "[", 
    RowBox[{
     RowBox[{"LeftMultiplicationSuperoperator", "[", 
      RowBox[{
       RowBox[{"op1", "+", "op2"}], ",", 
       RowBox[{"SimplifyRules", "[", 
        RowBox[{"opts1", ",", "opts2"}], "]"}]}], "]"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691059091790533*^9, 3.6910591966129837`*^9}, {
  3.7275218815485*^9, 3.7275218903276386`*^9}},
 CellLabel->
  "In[1052]:=",ExpressionUUID->"c008a042-c3e6-4f21-b431-4673bd7b4f0d"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to 0", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5930117533496227`*^9, 
  3.593011756685623*^9}},ExpressionUUID->"0f3238e8-22ec-4b94-aa6a-\
70e2d11e1241"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"sop_LeftMultiplicationSuperoperator", "[", "0", "]"}], "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.5930118399965353`*^9}, 
   3.72752190374772*^9},
 CellLabel->
  "In[1053]:=",ExpressionUUID->"4dceffb1-fe23-4dee-84ff-e6deece1d518"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle OperatorType", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.586254495213749*^9, 3.586254507924302*^9}, {3.586255024399542*^9, 
  3.586255026036367*^9}, {3.5863444657998667`*^9, 
  3.586344494875669*^9}},ExpressionUUID->"5da2ba74-a93c-490b-95b2-\
7d071fd7c259"],

Cell[CellGroupData[{

Cell["inherit the OperatorType from a contained Operator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.586254495213749*^9, 3.586254507924302*^9}, {3.586255024399542*^9, 
  3.586255026036367*^9}, {3.5863444657998667`*^9, 
  3.5863444693304377`*^9}},ExpressionUUID->"23b84ba3-fea0-4ef1-a2f9-\
3610d431758c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LeftMultiplicationSuperoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Operator", "[", 
      RowBox[{"op_", ",", "basis_", ",", "opopts___Rule"}], "]"}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"optype", ",", "csoptype"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
       "LeftMultiplicationSuperoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Operator", "[", 
          RowBox[{"op", ",", "basis", ",", "opopts"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"OperatorType", "\[Rule]", "optype"}], ",", 
           "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
        "\[IndentingNewLine]", "]"}], "/;", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"optype", "=", 
          RowBox[{
           RowBox[{"OperatorType", "/.", 
            RowBox[{"{", "opopts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Operator", "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"csoptype", "=", 
          RowBox[{
           RowBox[{"OperatorType", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{
           "Options", "[", "LeftMultiplicationSuperoperator", "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"optype", ",", "csoptype"}], "]"}]}]}], 
        "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586344031467146*^9, 3.586344160475876*^9}, {
  3.586344286652322*^9, 3.586344402609536*^9}, {3.586344438122717*^9, 
  3.586344448267138*^9}, {3.727522235428914*^9, 3.727522240180231*^9}},
 CellLabel->
  "In[1054]:=",ExpressionUUID->"d303b339-f7b3-4e0b-a973-ecb398e05d36"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
remove Assumptions for OperatorType if the type is fully determined and \
consistent\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.586254495213749*^9, 3.586254507924302*^9}, {3.586255024399542*^9, 
  3.586255026036367*^9}, {3.5863444657998667`*^9, 3.5863444693304377`*^9}, {
  3.586349031183301*^9, 3.586349058926166*^9}, {3.727522251650402*^9, 
  3.7275222517690516`*^9}},ExpressionUUID->"9e2f03b5-8c20-4aa0-8fec-\
2df87b48e345"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LeftMultiplicationSuperoperator", "[", 
    RowBox[{"op_Operator", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ass", ",", "optype", ",", "assoptype"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"LeftMultiplicationSuperoperator", "[", 
        RowBox[{"op", ",", "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Assumptions", "\[Rule]", "None"}], ",", 
           "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
        "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ass", "=", 
         RowBox[{"Assumptions", "/.", 
          RowBox[{"{", "opts", "}"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"optype", "=", 
         RowBox[{
          RowBox[{"OperatorType", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "LeftMultiplicationSuperoperator", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"ass", ",", 
           RowBox[{"{", 
            RowBox[{"_Rule", ".."}], "}"}]}], "]"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"optype", ",", "Undefined"}], "]"}]}], "&&", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"assoptype", "=", 
            RowBox[{
             RowBox[{"OperatorType", "/.", "ass"}], "/.", 
             RowBox[{
             "Options", "[", "LeftMultiplicationSuperoperator", "]"}]}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"MatchQ", "[", 
             RowBox[{"assoptype", ",", "optype"}], "]"}], "||", 
            "\[IndentingNewLine]", 
            RowBox[{"MatchQ", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"optype", ",", "assoptype"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                "\"\<Hermitian\>\"", "|", "\"\<AntiHermitian\>\"", "|", 
                 "\"\<Unitary\>\""}], ",", "\"\<Normal\>\""}], "}"}]}], 
             "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586346832228771*^9, 3.5863469518379097`*^9}, {
   3.586346987791679*^9, 3.586347284171344*^9}, {3.586347409350423*^9, 
   3.586347413499474*^9}, 3.586347478900434*^9, {3.586347832572936*^9, 
   3.5863479485195627`*^9}, {3.5863479789986467`*^9, 3.586347982093346*^9}, {
   3.5863491002729397`*^9, 3.5863491202050323`*^9}, {3.7275222586504064`*^9, 
   3.7275222688399706`*^9}},
 CellLabel->
  "In[1055]:=",ExpressionUUID->"8c3fc7e2-e2af-4541-aad7-988d89dca8ce"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
detect a conflict between the Assumptions and a determined OperatorType, and \
issue a warning if necessary\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.586254495213749*^9, 3.586254507924302*^9}, {3.586255024399542*^9, 
  3.586255026036367*^9}, {3.5863444657998667`*^9, 3.5863444693304377`*^9}, {
  3.586344510470888*^9, 3.586344537506504*^9}, {3.586345006203725*^9, 
  3.5863450106559343`*^9}, {3.586346795746935*^9, 
  3.586346819231881*^9}},ExpressionUUID->"b5254597-100b-423f-88a6-\
3226059ac608"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LeftMultiplicationSuperoperator", "[", 
    RowBox[{"op_Operator", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ass", ",", "optype", ",", "assoptype"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"LeftMultiplicationSuperoperator", "::", "badass"}], ",", 
          "assoptype", ",", "optype"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"LeftMultiplicationSuperoperator", "[", 
         RowBox[{"op", ",", "\[IndentingNewLine]", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Assumptions", "\[Rule]", "None"}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ass", "=", 
         RowBox[{"Assumptions", "/.", 
          RowBox[{"{", "opts", "}"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"optype", "=", 
         RowBox[{
          RowBox[{"OperatorType", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "LeftMultiplicationSuperoperator", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"ass", ",", 
           RowBox[{"{", 
            RowBox[{"_Rule", ".."}], "}"}]}], "]"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"optype", ",", "Undefined"}], "]"}]}], "&&", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"assoptype", "=", 
            RowBox[{
             RowBox[{"OperatorType", "/.", "ass"}], "/.", 
             RowBox[{
             "Options", "[", "LeftMultiplicationSuperoperator", "]"}]}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"!", 
             RowBox[{"MatchQ", "[", 
              RowBox[{"assoptype", ",", "optype"}], "]"}]}], "&&", 
            "\[IndentingNewLine]", 
            RowBox[{"!", 
             RowBox[{"MatchQ", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"optype", ",", "assoptype"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                 "\"\<Hermitian\>\"", "|", "\"\<AntiHermitian\>\"", "|", 
                  "\"\<Unitary\>\""}], ",", "\"\<Normal\>\""}], "}"}]}], 
              "]"}]}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586346832228771*^9, 3.5863469518379097`*^9}, {
   3.586346987791679*^9, 3.586347284171344*^9}, {3.586347409350423*^9, 
   3.586347413499474*^9}, 3.586347478900434*^9, {3.586347832572936*^9, 
   3.5863479485195627`*^9}, {3.5863479789986467`*^9, 3.586347982093346*^9}, {
   3.7275222801482677`*^9, 3.727522301645707*^9}},
 CellLabel->
  "In[1056]:=",ExpressionUUID->"36632bc5-33a5-46b6-a921-d9bfe3398080"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
LeftMultiplicationSuperoperator of NullOperator and UnityOperator\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517764378899*^9}, {
   3.502517895129891*^9, 3.502517902137464*^9}, {3.533182376133717*^9, 
   3.5331824073201113`*^9}, 
   3.727522330356764*^9},ExpressionUUID->"aa11abd9-be09-42f3-96aa-\
f864a769fefb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LeftMultiplicationSuperoperator", "[", 
    RowBox[{"0", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.555568788824719*^9, {3.5555688256069803`*^9, 3.5555688613653584`*^9}, {
   3.586252613769566*^9, 3.586252614085248*^9}, 3.7275223904816647`*^9},
 CellLabel->
  "In[1057]:=",ExpressionUUID->"7a97b6b1-f435-4d0d-a67b-356bcae7f246"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LeftMultiplicationSuperoperator", "[", 
    RowBox[{
     RowBox[{"NullOperator", "[", "___", "]"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533182384289412*^9, 3.5331824016047173`*^9}, {
   3.586252616708723*^9, 3.586252617045567*^9}, 3.7275223937980785`*^9},
 CellLabel->
  "In[1058]:=",ExpressionUUID->"2594d716-d38f-49b3-b86b-92dca9f0b91c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LeftMultiplicationSuperoperator", "[", 
    RowBox[{
     RowBox[{"UnityOperator", "[", "___", "]"}], ",", "opts___Rule"}], "]"}], 
   ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533182384289412*^9, 3.533182414672029*^9}, {
   3.5862526193968573`*^9, 3.5862526197015877`*^9}, 3.72752239547912*^9},
 CellLabel->
  "In[1059]:=",ExpressionUUID->"45f0e9fa-0cff-4be9-adae-6716eb91864e"]
}, Closed]],

Cell[CellGroupData[{

Cell["LeftMultiplicationSuperoperator applied to an operator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, 
   3.7275223321778917`*^9},ExpressionUUID->"c9228dcf-bfb2-4c50-9ab1-\
faad5698b3c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LeftMultiplicationSuperoperator", "[", "op1_", "]"}], "[", "op2_",
    "]"}], ":=", 
  RowBox[{"Dot", "[", 
   RowBox[{"op1", ",", "op2"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.44834857702761*^9, 3.448348662101181*^9, {3.7275226474948406`*^9, 
   3.727522651825196*^9}, {3.7275226951198835`*^9, 3.7275226981613026`*^9}},
 CellLabel->
  "In[1060]:=",ExpressionUUID->"cad45891-9df3-418f-926d-86d146706246"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
exponential of a LeftMultiplicationSuperoperator applied to an operator\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
   3.502518217440444*^9, 3.502518220222917*^9}, 
   3.7275226607149673`*^9},ExpressionUUID->"a63d20ab-9b2b-4bdc-ad47-\
87a5ebb784a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Power", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Power", "/:", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"E", ",", 
         RowBox[{"Times", "[", 
          RowBox[{"num1___", ",", 
           RowBox[{"LeftMultiplicationSuperoperator", "[", 
            RowBox[{"op1_", ",", "opts___Rule"}], "]"}], ",", "num2___"}], 
          "]"}]}], "]"}], "[", "op2_", "]"}], "\[IndentingNewLine]", "]"}], ":=", 
     RowBox[{
      RowBox[{"UnitySuperoperator", "[", "]"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Times", "[", 
         RowBox[{"num1", "*", "num2"}], "]"}], "\[Equal]", "0"}], ")"}]}]}]}],
    "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120496606058*^9, 3.683120511659637*^9}, 
   3.7275226658576565`*^9, 3.745399795865375*^9, {3.745484594006475*^9, 
   3.745484595718545*^9}},
 CellLabel->
  "In[1061]:=",ExpressionUUID->"8dfc1a7c-5466-4edc-b4b5-02fdd084d2a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Power", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Power", "/:", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"E", ",", 
         RowBox[{"Times", "[", 
          RowBox[{"num1___", ",", 
           RowBox[{"LeftMultiplicationSuperoperator", "[", 
            RowBox[{"op1_", ",", "opts___Rule"}], "]"}], ",", "num2___"}], 
          "]"}]}], "]"}], "[", "op2_", "]"}], "\[IndentingNewLine]", "]"}], ":=", 
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{"Exp", "[", 
        RowBox[{"num1", "*", "num2", "*", "op1"}], "]"}], ",", "op2"}], 
      "]"}]}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120496606058*^9, 3.6831205245383*^9}, {
   3.7275226743533454`*^9, 3.7275226924632835`*^9}, 3.745399800150865*^9, {
   3.7454846055060787`*^9, 3.7454846073545513`*^9}},
 CellLabel->
  "In[1062]:=",ExpressionUUID->"b2f9b281-7c23-4fb7-a816-4533f5d0ea6e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Power", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Power", "/:", "\[IndentingNewLine]", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"E", ",", 
         RowBox[{"LeftMultiplicationSuperoperator", "[", 
          RowBox[{"op1_", ",", "opts___Rule"}], "]"}]}], "]"}], "[", "op2_", 
       "]"}], "\[IndentingNewLine]", "]"}], ":=", 
     RowBox[{"Dot", "[", 
      RowBox[{
       RowBox[{"Exp", "[", "op1", "]"}], ",", "op2"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120496606058*^9, 3.6831205387230997`*^9}, {
   3.727522704218912*^9, 3.7275227089023066`*^9}, 3.745399805601758*^9, {
   3.745484614905933*^9, 3.745484616304405*^9}},
 CellLabel->
  "In[1063]:=",ExpressionUUID->"05c1987a-41d0-47b3-b073-ab7a4ec7009d"]
}, Open  ]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.502518217440444*^9, 3.502518220222917*^9}, {3.586347295915571*^9, 
  3.58634729702556*^9}},ExpressionUUID->"a0e2c95b-d4c1-4975-99b2-\
be1107ecbc2b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LeftMultiplicationSuperoperator", "::", "badass"}], "=", 
   "\"\<A conflict has been detected between the assumed OperatorType \\\"`1`\
\\\" for the argument of a LeftMultiplicationSuperoperator, and the \
determined OperatorType \\\"`2`\\\". Proceeding with Assumptions \
disabled.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586347307053904*^9, 3.586347392965835*^9}, {
  3.7275230533240786`*^9, 3.7275230617440896`*^9}},
 CellLabel->
  "In[1064]:=",ExpressionUUID->"8fe3f063-6579-4282-82be-c7b39391576a"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["RightMultiplicationSuperoperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435243138565358*^9, 3.435243153291615*^9}, {
   3.4483485680516853`*^9, 3.448348569105796*^9}, 3.502518224625395*^9, {
   3.7275217579004765`*^9, 3.727521762461782*^9}, 3.7275229889812813`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"382d62dd-f2cf-4e6c-84c3-aad85797be1e"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517764378899*^9}, {
  3.502517895129891*^9, 3.502517902137464*^9}, {3.586252293223474*^9, 
  3.586252295261443*^9}},ExpressionUUID->"d1f352a5-1628-4b30-8679-\
4948372fa91f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Options", "[", "RightMultiplicationSuperoperator", "]"}], "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"OperatorType", "\[Rule]", "Undefined"}], ",", 
    RowBox[{"Assumptions", "\[Rule]", "None"}]}], "}"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5862522974658823`*^9, 3.586252322627699*^9}, {
   3.727521775446906*^9, 3.727521779421384*^9}, 3.727522989001939*^9},
 CellLabel->
  "In[1065]:=",ExpressionUUID->"719f8054-9b1f-4efb-af88-989d69bd3e59"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"OperatorType", "\[Rule]", "Undefined"}], ",", 
   RowBox[{"Assumptions", "\[Rule]", "None"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.745483836553425*^9, 3.74548383964255*^9}},
 CellLabel->
  "Out[1065]=",ExpressionUUID->"9b588862-8572-471e-af43-83409c098f91"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.5898235112181168`*^9},ExpressionUUID->"d47fe0f0-62d7-48f6-8b35-\
5a792cd5d3e0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RightMultiplicationSuperoperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_RightMultiplicationSuperoperator", ",", "b___"}],
       "]"}], "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"SuperoperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Superoperator", "::", "times"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.589824007778718*^9, 
   3.5898240231530933`*^9}, {3.589824060303439*^9, 3.589824089178906*^9}, {
   3.727521790591321*^9, 3.7275217947822666`*^9}, {3.7275229890049505`*^9, 
   3.7275229890049505`*^9}},
 CellLabel->
  "In[1066]:=",ExpressionUUID->"4489909d-79f3-4691-ae0d-32314a69b7db"]
}, Closed]],

Cell[CellGroupData[{

Cell["sums and numerical factors", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517764378899*^9}, {
  3.502517895129891*^9, 
  3.502517902137464*^9}},ExpressionUUID->"ea41f146-7879-4948-ab8f-\
1d74ff1464ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RightMultiplicationSuperoperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Times", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"n1", ":", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{
           RowBox[{"_", "?", "OperatorQ"}], "|", 
           RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}], "..."}]}], ")"}], 
      ",", 
      RowBox[{"RightMultiplicationSuperoperator", "[", 
       RowBox[{
        RowBox[{"op1_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ",", 
      
      RowBox[{"(", 
       RowBox[{"n2", ":", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{
           RowBox[{"_", "?", "OperatorQ"}], "|", 
           RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}], "..."}]}], ")"}]}], 
     "]"}]}], ":=", 
   RowBox[{"RightMultiplicationSuperoperator", "[", 
    RowBox[{
     RowBox[{"Times", "[", 
      RowBox[{"n1", ",", "n2", ",", "op1"}], "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502517846493984*^9, 3.502517946749755*^9}, {
  3.5066198943388453`*^9, 3.506619944682684*^9}, {3.586252329912006*^9, 
  3.58625233839782*^9}, {3.5863500811623774`*^9, 3.5863500846221247`*^9}, {
  3.586350152045644*^9, 3.5863501546481953`*^9}, {3.7275218607747226`*^9, 
  3.7275218778506317`*^9}, {3.7275229890049505`*^9, 3.7275229890210533`*^9}},
 CellLabel->
  "In[1067]:=",ExpressionUUID->"71725114-be1c-4b49-acf0-245e495e1c8b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RightMultiplicationSuperoperator", "/:", "\[IndentingNewLine]", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Plus", "[", 
     RowBox[{
      RowBox[{"RightMultiplicationSuperoperator", "[", 
       RowBox[{"op1_", ",", "opts1___Rule"}], "]"}], ",", 
      RowBox[{"RightMultiplicationSuperoperator", "[", 
       RowBox[{"op2_", ",", "opts2___Rule"}], "]"}], ",", "more___"}], 
     "]"}]}], ":=", 
   RowBox[{"Plus", "[", 
    RowBox[{
     RowBox[{"RightMultiplicationSuperoperator", "[", 
      RowBox[{
       RowBox[{"op1", "+", "op2"}], ",", 
       RowBox[{"SimplifyRules", "[", 
        RowBox[{"opts1", ",", "opts2"}], "]"}]}], "]"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.691059091790533*^9, 3.6910591966129837`*^9}, {
  3.7275218815485*^9, 3.7275218903276386`*^9}, {3.727522989028575*^9, 
  3.727522989032118*^9}},
 CellLabel->
  "In[1068]:=",ExpressionUUID->"c008a042-c3e6-4f21-b431-4673bd7b4f0d"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to 0", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5930117533496227`*^9, 
  3.593011756685623*^9}},ExpressionUUID->"0f3238e8-22ec-4b94-aa6a-\
70e2d11e1241"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"sop_RightMultiplicationSuperoperator", "[", "0", "]"}], "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.5930118399965353`*^9}, 
   3.72752190374772*^9, 3.7275229890381002`*^9},
 CellLabel->
  "In[1069]:=",ExpressionUUID->"4dceffb1-fe23-4dee-84ff-e6deece1d518"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle OperatorType", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.586254495213749*^9, 3.586254507924302*^9}, {3.586255024399542*^9, 
  3.586255026036367*^9}, {3.5863444657998667`*^9, 
  3.586344494875669*^9}},ExpressionUUID->"5da2ba74-a93c-490b-95b2-\
7d071fd7c259"],

Cell[CellGroupData[{

Cell["inherit the OperatorType from a contained Operator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.586254495213749*^9, 3.586254507924302*^9}, {3.586255024399542*^9, 
  3.586255026036367*^9}, {3.5863444657998667`*^9, 
  3.5863444693304377`*^9}},ExpressionUUID->"23b84ba3-fea0-4ef1-a2f9-\
3610d431758c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RightMultiplicationSuperoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Operator", "[", 
      RowBox[{"op_", ",", "basis_", ",", "opopts___Rule"}], "]"}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"optype", ",", "csoptype"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"RightMultiplicationSuperoperator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Operator", "[", 
          RowBox[{"op", ",", "basis", ",", "opopts"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"OperatorType", "\[Rule]", "optype"}], ",", 
           "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
        "\[IndentingNewLine]", "]"}], "/;", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"optype", "=", 
          RowBox[{
           RowBox[{"OperatorType", "/.", 
            RowBox[{"{", "opopts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Operator", "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"csoptype", "=", 
          RowBox[{
           RowBox[{"OperatorType", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{
           "Options", "[", "RightMultiplicationSuperoperator", "]"}]}]}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"optype", ",", "csoptype"}], "]"}]}]}], 
        "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586344031467146*^9, 3.586344160475876*^9}, {
  3.586344286652322*^9, 3.586344402609536*^9}, {3.586344438122717*^9, 
  3.586344448267138*^9}, {3.727522235428914*^9, 3.727522240180231*^9}, {
  3.727522989044648*^9, 3.727522989044648*^9}},
 CellLabel->
  "In[1070]:=",ExpressionUUID->"d303b339-f7b3-4e0b-a973-ecb398e05d36"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
remove Assumptions for OperatorType if the type is fully determined and \
consistent\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.586254495213749*^9, 3.586254507924302*^9}, {3.586255024399542*^9, 
  3.586255026036367*^9}, {3.5863444657998667`*^9, 3.5863444693304377`*^9}, {
  3.586349031183301*^9, 3.586349058926166*^9}, {3.727522251650402*^9, 
  3.7275222517690516`*^9}},ExpressionUUID->"9e2f03b5-8c20-4aa0-8fec-\
2df87b48e345"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RightMultiplicationSuperoperator", "[", 
    RowBox[{"op_Operator", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ass", ",", "optype", ",", "assoptype"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"RightMultiplicationSuperoperator", "[", 
        RowBox[{"op", ",", "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Assumptions", "\[Rule]", "None"}], ",", 
           "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
        "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ass", "=", 
         RowBox[{"Assumptions", "/.", 
          RowBox[{"{", "opts", "}"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"optype", "=", 
         RowBox[{
          RowBox[{"OperatorType", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "RightMultiplicationSuperoperator", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"ass", ",", 
           RowBox[{"{", 
            RowBox[{"_Rule", ".."}], "}"}]}], "]"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"optype", ",", "Undefined"}], "]"}]}], "&&", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"assoptype", "=", 
            RowBox[{
             RowBox[{"OperatorType", "/.", "ass"}], "/.", 
             RowBox[{
             "Options", "[", "RightMultiplicationSuperoperator", "]"}]}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"MatchQ", "[", 
             RowBox[{"assoptype", ",", "optype"}], "]"}], "||", 
            "\[IndentingNewLine]", 
            RowBox[{"MatchQ", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"optype", ",", "assoptype"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                "\"\<Hermitian\>\"", "|", "\"\<AntiHermitian\>\"", "|", 
                 "\"\<Unitary\>\""}], ",", "\"\<Normal\>\""}], "}"}]}], 
             "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586346832228771*^9, 3.5863469518379097`*^9}, {
   3.586346987791679*^9, 3.586347284171344*^9}, {3.586347409350423*^9, 
   3.586347413499474*^9}, 3.586347478900434*^9, {3.586347832572936*^9, 
   3.5863479485195627`*^9}, {3.5863479789986467`*^9, 3.586347982093346*^9}, {
   3.5863491002729397`*^9, 3.5863491202050323`*^9}, {3.7275222586504064`*^9, 
   3.7275222688399706`*^9}, {3.727522989044648*^9, 3.727522989044648*^9}},
 CellLabel->
  "In[1071]:=",ExpressionUUID->"8c3fc7e2-e2af-4541-aad7-988d89dca8ce"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
detect a conflict between the Assumptions and a determined OperatorType, and \
issue a warning if necessary\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.586254495213749*^9, 3.586254507924302*^9}, {3.586255024399542*^9, 
  3.586255026036367*^9}, {3.5863444657998667`*^9, 3.5863444693304377`*^9}, {
  3.586344510470888*^9, 3.586344537506504*^9}, {3.586345006203725*^9, 
  3.5863450106559343`*^9}, {3.586346795746935*^9, 
  3.586346819231881*^9}},ExpressionUUID->"b5254597-100b-423f-88a6-\
3226059ac608"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RightMultiplicationSuperoperator", "[", 
    RowBox[{"op_Operator", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ass", ",", "optype", ",", "assoptype"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"RightMultiplicationSuperoperator", "::", "badass"}], ",", 
          "assoptype", ",", "optype"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"RightMultiplicationSuperoperator", "[", 
         RowBox[{"op", ",", "\[IndentingNewLine]", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Assumptions", "\[Rule]", "None"}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ass", "=", 
         RowBox[{"Assumptions", "/.", 
          RowBox[{"{", "opts", "}"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"optype", "=", 
         RowBox[{
          RowBox[{"OperatorType", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "RightMultiplicationSuperoperator", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"ass", ",", 
           RowBox[{"{", 
            RowBox[{"_Rule", ".."}], "}"}]}], "]"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"optype", ",", "Undefined"}], "]"}]}], "&&", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"assoptype", "=", 
            RowBox[{
             RowBox[{"OperatorType", "/.", "ass"}], "/.", 
             RowBox[{
             "Options", "[", "RightMultiplicationSuperoperator", "]"}]}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"!", 
             RowBox[{"MatchQ", "[", 
              RowBox[{"assoptype", ",", "optype"}], "]"}]}], "&&", 
            "\[IndentingNewLine]", 
            RowBox[{"!", 
             RowBox[{"MatchQ", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"optype", ",", "assoptype"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                 "\"\<Hermitian\>\"", "|", "\"\<AntiHermitian\>\"", "|", 
                  "\"\<Unitary\>\""}], ",", "\"\<Normal\>\""}], "}"}]}], 
              "]"}]}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586346832228771*^9, 3.5863469518379097`*^9}, {
   3.586346987791679*^9, 3.586347284171344*^9}, {3.586347409350423*^9, 
   3.586347413499474*^9}, 3.586347478900434*^9, {3.586347832572936*^9, 
   3.5863479485195627`*^9}, {3.5863479789986467`*^9, 3.586347982093346*^9}, {
   3.7275222801482677`*^9, 3.727522301645707*^9}, {3.7275229890697284`*^9, 
   3.7275229890747433`*^9}},
 CellLabel->
  "In[1072]:=",ExpressionUUID->"36632bc5-33a5-46b6-a921-d9bfe3398080"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
RightMultiplicationSuperoperator of NullOperator and UnityOperator\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517764378899*^9}, {
   3.502517895129891*^9, 3.502517902137464*^9}, {3.533182376133717*^9, 
   3.5331824073201113`*^9}, 3.727522330356764*^9, 
   3.727522987884698*^9},ExpressionUUID->"aa11abd9-be09-42f3-96aa-\
f864a769fefb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RightMultiplicationSuperoperator", "[", 
    RowBox[{"0", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.555568788824719*^9, {3.5555688256069803`*^9, 3.5555688613653584`*^9}, {
   3.586252613769566*^9, 3.586252614085248*^9}, 3.7275223904816647`*^9, 
   3.7275229879038363`*^9},
 CellLabel->
  "In[1073]:=",ExpressionUUID->"7a97b6b1-f435-4d0d-a67b-356bcae7f246"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RightMultiplicationSuperoperator", "[", 
    RowBox[{
     RowBox[{"NullOperator", "[", "___", "]"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533182384289412*^9, 3.5331824016047173`*^9}, {
   3.586252616708723*^9, 3.586252617045567*^9}, 3.7275223937980785`*^9, 
   3.727522987904841*^9},
 CellLabel->
  "In[1074]:=",ExpressionUUID->"2594d716-d38f-49b3-b86b-92dca9f0b91c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RightMultiplicationSuperoperator", "[", 
    RowBox[{
     RowBox[{"UnityOperator", "[", "___", "]"}], ",", "opts___Rule"}], "]"}], 
   ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533182384289412*^9, 3.533182414672029*^9}, {
   3.5862526193968573`*^9, 3.5862526197015877`*^9}, 3.72752239547912*^9, 
   3.727522987904841*^9},
 CellLabel->
  "In[1075]:=",ExpressionUUID->"45f0e9fa-0cff-4be9-adae-6716eb91864e"]
}, Closed]],

Cell[CellGroupData[{

Cell["RightMultiplicationSuperoperator applied to an operator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, 
   3.7275223321778917`*^9, 
   3.727522988254941*^9},ExpressionUUID->"c9228dcf-bfb2-4c50-9ab1-\
faad5698b3c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RightMultiplicationSuperoperator", "[", "op1_", "]"}], "[", 
   "op2_", "]"}], ":=", 
  RowBox[{"Dot", "[", 
   RowBox[{"op2", ",", "op1"}], "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.44834857702761*^9, 3.448348662101181*^9, {3.7275226474948406`*^9, 
   3.727522651825196*^9}, {3.7275226951198835`*^9, 3.7275226981613026`*^9}, {
   3.7275229882705946`*^9, 3.7275229961648207`*^9}},
 CellLabel->
  "In[1076]:=",ExpressionUUID->"cad45891-9df3-418f-926d-86d146706246"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
exponential of a RightMultiplicationSuperoperator applied to an operator\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
   3.502518217440444*^9, 3.502518220222917*^9}, 3.7275226607149673`*^9, 
   3.727522988617217*^9},ExpressionUUID->"a63d20ab-9b2b-4bdc-ad47-\
87a5ebb784a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Power", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Power", "/:", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"E", ",", 
         RowBox[{"Times", "[", 
          RowBox[{"num1___", ",", 
           RowBox[{"RightMultiplicationSuperoperator", "[", 
            RowBox[{"op1_", ",", "opts___Rule"}], "]"}], ",", "num2___"}], 
          "]"}]}], "]"}], "[", "op2_", "]"}], "\[IndentingNewLine]", "]"}], ":=", 
     RowBox[{
      RowBox[{"UnitySuperoperator", "[", "]"}], "/;", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Times", "[", 
         RowBox[{"num1", "*", "num2"}], "]"}], "\[Equal]", "0"}], ")"}]}]}]}],
    "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120496606058*^9, 3.683120511659637*^9}, 
   3.7275226658576565`*^9, 3.727522988629507*^9, 3.745399810769562*^9, {
   3.745484622906266*^9, 3.745484624407518*^9}},
 CellLabel->
  "In[1077]:=",ExpressionUUID->"8dfc1a7c-5466-4edc-b4b5-02fdd084d2a1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Power", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Power", "/:", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"E", ",", 
         RowBox[{"Times", "[", 
          RowBox[{"num1___", ",", 
           RowBox[{"RightMultiplicationSuperoperator", "[", 
            RowBox[{"op1_", ",", "opts___Rule"}], "]"}], ",", "num2___"}], 
          "]"}]}], "]"}], "[", "op2_", "]"}], "\[IndentingNewLine]", "]"}], ":=", 
     RowBox[{"Dot", "[", 
      RowBox[{"op2", ",", 
       RowBox[{"Exp", "[", 
        RowBox[{"num1", "*", "num2", "*", "op1"}], "]"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120496606058*^9, 3.6831205245383*^9}, {
   3.7275226743533454`*^9, 3.7275226924632835`*^9}, {3.727522988635022*^9, 
   3.727523010414156*^9}, 3.745399817153824*^9, {3.7454846294659443`*^9, 
   3.7454846308535557`*^9}},
 CellLabel->
  "In[1078]:=",ExpressionUUID->"b2f9b281-7c23-4fb7-a816-4533f5d0ea6e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Power", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Power", "/:", "\[IndentingNewLine]", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"E", ",", 
         RowBox[{"RightMultiplicationSuperoperator", "[", 
          RowBox[{"op1_", ",", "opts___Rule"}], "]"}]}], "]"}], "[", "op2_", 
       "]"}], "\[IndentingNewLine]", "]"}], ":=", 
     RowBox[{"Dot", "[", 
      RowBox[{"op2", ",", 
       RowBox[{"Exp", "[", "op1", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120496606058*^9, 3.6831205387230997`*^9}, {
   3.727522704218912*^9, 3.7275227089023066`*^9}, {3.727522988635022*^9, 
   3.727523016133662*^9}, {3.7453998221555567`*^9, 3.745399823351721*^9}, {
   3.745484636955956*^9, 3.745484638904068*^9}},
 CellLabel->
  "In[1079]:=",ExpressionUUID->"05c1987a-41d0-47b3-b073-ab7a4ec7009d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Power", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{"Power", "/:", 
     RowBox[{"HoldPattern", "[", 
      RowBox[{
       RowBox[{"Power", "[", 
        RowBox[{"E", ",", "A___", ",", 
         RowBox[{"k_.", "*", 
          RowBox[{"Plus", "[", 
           RowBox[{
            RowBox[{"kRMSO_.", "*", 
             RowBox[{"RMSO", ":", 
              RowBox[{"RightMultiplicationSuperoperator", "[", 
               RowBox[{"op1_", ",", "opts1___Rule"}], "]"}]}]}], ",", 
            RowBox[{"kLMSO_.", "*", 
             RowBox[{"LMSO", ":", 
              RowBox[{"LeftMultiplicationSuperoperator", "[", 
               RowBox[{"op2_", ",", "opts2___Rule"}], "]"}]}]}]}], "]"}]}], 
         ",", "B___"}], "]"}], "[", "op_", "]"}], "\[IndentingNewLine]", 
      "]"}], ":=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Power", "[", 
         RowBox[{"E", ",", "A", ",", 
          RowBox[{"k", "*", "kRMSO", "*", "RMSO"}], ",", "B"}], "]"}], ".", 
        RowBox[{"Power", "[", 
         RowBox[{"E", ",", "A", ",", 
          RowBox[{"k", "*", "kLMSO", "*", "LMSO"}], ",", "B"}], "]"}]}], 
       ")"}], "[", "op", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120496606058*^9, 3.6831205387230997`*^9}, {
   3.727522704218912*^9, 3.7275227089023066`*^9}, {3.727522988635022*^9, 
   3.727523016133662*^9}, 3.728046315880804*^9, {3.728046399385311*^9, 
   3.728046407425044*^9}, {3.745399828404175*^9, 3.745399829458577*^9}, {
   3.745484643705996*^9, 3.7454846452545643`*^9}},
 CellLabel->
  "In[1080]:=",ExpressionUUID->"05c1987a-41d0-47b3-b073-ab7a4ec7009d"]
}, Open  ]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517750937834*^9}, {
  3.502518217440444*^9, 3.502518220222917*^9}, {3.586347295915571*^9, 
  3.58634729702556*^9}},ExpressionUUID->"a0e2c95b-d4c1-4975-99b2-\
be1107ecbc2b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RightMultiplicationSuperoperator", "::", "badass"}], "=", 
   "\"\<A conflict has been detected between the assumed OperatorType \\\"`1`\
\\\" for the argument of a RightMultiplicationSuperoperator, and the \
determined OperatorType \\\"`2`\\\". Proceeding with Assumptions \
disabled.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586347307053904*^9, 3.586347392965835*^9}, {
  3.7275230413355503`*^9, 3.7275230460534897`*^9}},
 CellLabel->
  "In[1081]:=",ExpressionUUID->"8fe3f063-6579-4282-82be-c7b39391576a"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["DoubleCommutationSuperoperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"06d2594e-4c90-4f8d-8279-41dbe787003b"],

Cell[CellGroupData[{

Cell["apply to 0", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.5930117533496227`*^9, 
  3.593011756685623*^9}},ExpressionUUID->"f29d096a-1211-4114-bf65-\
0f6bc80cc96b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"sop_DoubleCommutationSuperoperator", "[", "0", "]"}], "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.5930118575819817`*^9}},
 CellLabel->
  "In[1082]:=",ExpressionUUID->"db981fa7-0a4f-46ff-9f14-941c818b5c7d"]
}, Closed]],

Cell[CellGroupData[{

Cell["inappropriate Times", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.460866284717249*^9, 3.460866290098413*^9}, {
   3.552277085104805*^9, 3.552277086428586*^9}, {3.589480946990781*^9, 
   3.589480954492475*^9}, 
   3.5898235112181168`*^9},ExpressionUUID->"8c60f2d9-725f-43e8-9f20-\
a947bb737fcc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DoubleCommutationSuperoperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_DoubleCommutationSuperoperator", ",", "b___"}], 
      "]"}], "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"SuperoperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Superoperator", "::", "times"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.589824007778718*^9, 
   3.5898240231530933`*^9}, {3.589824060303439*^9, 3.589824105371189*^9}},
 CellLabel->
  "In[1083]:=",ExpressionUUID->"c20cb1cd-dd79-4ec1-8caa-6d330cd1baae"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
DoubleCommutationSuperoperator of NullOperator and UnityOperator\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502517743059229*^9, 3.502517764378899*^9}, {
   3.502517895129891*^9, 3.502517902137464*^9}, {3.533182376133717*^9, 
   3.5331824073201113`*^9}, 
   3.555568590818201*^9},ExpressionUUID->"36631473-e7fc-4102-8a0a-\
09576fa5dc94"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DoubleCommutationSuperoperator", "[", 
    RowBox[{"0", ",", "_"}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.555568788824719*^9, {3.5555688256069803`*^9, 3.555568829167083*^9}},
 CellLabel->
  "In[1084]:=",ExpressionUUID->"0f3d2733-b921-4459-8458-4ab737ef195e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DoubleCommutationSuperoperator", "[", 
    RowBox[{"_", ",", "0"}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.555568788824719*^9, {3.5555688256069803`*^9, 3.55556883910817*^9}},
 CellLabel->
  "In[1085]:=",ExpressionUUID->"275641ac-3175-4143-83e4-c73b2393d69e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DoubleCommutationSuperoperator", "[", 
    RowBox[{
     RowBox[{"NullOperator", "[", "___", "]"}], ",", 
     RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533182384289412*^9, 3.5331824016047173`*^9}, {
  3.555568595365096*^9, 3.555568602723114*^9}},
 CellLabel->
  "In[1086]:=",ExpressionUUID->"c40379d0-444e-4b75-bcbc-d98d19e42344"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DoubleCommutationSuperoperator", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", 
     RowBox[{"NullOperator", "[", "___", "]"}]}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533182384289412*^9, 3.5331824016047173`*^9}, {
  3.555568595365096*^9, 3.555568613730117*^9}},
 CellLabel->
  "In[1087]:=",ExpressionUUID->"5be53c17-b2df-4582-8beb-52259dd37f4e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DoubleCommutationSuperoperator", "[", 
    RowBox[{
     RowBox[{"UnityOperator", "[", "___", "]"}], ",", 
     RowBox[{"op_", "?", "OperatorQ"}]}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533182384289412*^9, 3.5331824016047173`*^9}, {
  3.555568595365096*^9, 3.55556862660401*^9}},
 CellLabel->
  "In[1088]:=",ExpressionUUID->"957fa261-ff4b-47e6-b6f0-1370a68a7e05"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DoubleCommutationSuperoperator", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", 
     RowBox[{"UnityOperator", "[", "___", "]"}]}], "]"}], ":=", 
   RowBox[{"NullSuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533182384289412*^9, 3.5331824016047173`*^9}, {
  3.555568595365096*^9, 3.5555686280899153`*^9}},
 CellLabel->
  "In[1089]:=",ExpressionUUID->"e02ff1ed-f510-4d4b-9b49-614f0a2270fc"]
}, Closed]],

Cell[CellGroupData[{

Cell["application to an operator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.55556855911162*^9, 
  3.555568572942601*^9}},ExpressionUUID->"46cc8e20-f0af-4a30-a9d7-\
7d53194f90c6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DoubleCommutationSuperoperator", "[", 
     RowBox[{"op1_", ",", "op2_"}], "]"}], "[", "op3_", "]"}], ":=", 
   RowBox[{
    RowBox[{"CommutationSuperoperator", "[", "op1", "]"}], "[", 
    RowBox[{
     RowBox[{"CommutationSuperoperator", "[", "op2", "]"}], "[", "op3", "]"}],
     "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431056882307535*^9, 3.431056909106833*^9}},
 CellLabel->
  "In[1090]:=",ExpressionUUID->"812d2673-79cc-48e7-9167-c68cbb282197"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ProjectionSuperoperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4506142165078077`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"126e0764-3065-44b8-b258-2dddc04dc01a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ProjectionSuperoperator", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Normalize", "\[Rule]", "True"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4867223811686497`*^9, 3.4867223996436043`*^9}},
 CellLabel->
  "In[1091]:=",ExpressionUUID->"8cc2fd07-15b1-48f6-97b2-6535072ce34c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"sop_ProjectionSuperoperator", "[", "0", "]"}], "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.593011874269328*^9}},
 CellLabel->
  "In[1092]:=",ExpressionUUID->"7621301d-6b4b-4ab8-8c70-e445b9c8c17a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ProjectionSuperoperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_ProjectionSuperoperator", ",", "b___"}], "]"}], 
     "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"SuperoperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Superoperator", "::", "times"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.589824007778718*^9, 
   3.5898240231530933`*^9}, {3.589824060303439*^9, 3.589824122991696*^9}},
 CellLabel->
  "In[1093]:=",ExpressionUUID->"df02c525-8719-4a8c-8c2d-74389b1d9dbc"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Plus", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{
       RowBox[{"Plus", "[", 
        RowBox[{"sops", ":", 
         RowBox[{
          RowBox[{"ProjectionSuperoperator", "[", 
           RowBox[{"_", ",", "___Rule"}], "]"}], ".."}]}], "]"}], "[", "op_", 
       "]"}]}], ":=", "\[IndentingNewLine]", 
     RowBox[{"Plus", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"#", "[", "op", "]"}], ")"}], "&"}], "/@", 
        RowBox[{"{", "sops", "}"}]}], ")"}]}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, {3.683120556355968*^9, 3.6831205611931973`*^9}, {
   3.7453998371705914`*^9, 3.745399841202269*^9}},
 CellLabel->
  "In[1094]:=",ExpressionUUID->"e6bbb079-e3a0-4355-8601-692be6182680"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProjectionSuperoperator", "[", 
    RowBox[{
     RowBox[{"n_", "?", "NumericQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"n", " ", "\[Times]", 
    RowBox[{"ProjectionSuperoperator", "[", 
     RowBox[{
      RowBox[{"UnityOperator", "[", "]"}], ",", "opts"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.461326868101194*^9, 3.461326887671747*^9}, {
   3.461326927058106*^9, 3.461326959652581*^9}, {3.461327024308506*^9, 
   3.461327036393162*^9}, 3.486465226035111*^9, {3.486722424677679*^9, 
   3.486722432075605*^9}},
 CellLabel->
  "In[1095]:=",ExpressionUUID->"3c501750-e9d1-42cb-b5c1-1d73f6f2f113"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ProjectionSuperoperator", "[", 
     RowBox[{
      RowBox[{"pop_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Normalize", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ProjectionSuperoperator", "]"}]}], ")"}]}], ":=", 
   RowBox[{"ProjectionSuperoperator", "[", 
    RowBox[{
     RowBox[{"NormalizeOperator", "[", "pop", "]"}], ",", 
     RowBox[{"Normalize", "\[Rule]", "False"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486722447469*^9, 3.486722535364265*^9}},
 CellLabel->
  "In[1096]:=",ExpressionUUID->"242daf0f-e699-44a3-90db-7732ff58b74c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ProjectionSuperoperator", "[", 
      RowBox[{
       RowBox[{"pop_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], "[", 
     "op_", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Normalize", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "ProjectionSuperoperator", "]"}]}], ")"}]}]}], 
   ":=", "\[IndentingNewLine]", 
   RowBox[{"pop", "*", 
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{"pop", ",", "op"}], "]"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431056882307535*^9, 3.431056909106833*^9}, {
  3.45061422457043*^9, 3.450614226301695*^9}, {3.450617959993046*^9, 
  3.450617971886685*^9}, {3.455643611002659*^9, 3.4556436127827806`*^9}, {
  3.486722545303587*^9, 3.48672258315699*^9}, {3.486722731974401*^9, 
  3.486722733469408*^9}},
 CellLabel->
  "In[1097]:=",ExpressionUUID->"bff93127-035d-41fc-90f3-dbd172f45884"]
}, Open  ]],

Cell[CellGroupData[{

Cell["ShiftSuperoperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4506142165078077`*^9, {3.455643507565073*^9, 3.45564350856277*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"7a2044f5-0db7-45a8-afe5-5b5c885a97d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ShiftSuperoperator", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Normalize", "\[Rule]", "True"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4867223811686497`*^9, 3.4867223996436043`*^9}, 
   3.486722599838122*^9},
 CellLabel->
  "In[1098]:=",ExpressionUUID->"bb4f8c83-bff3-401b-aec7-4ea38ab53c5c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"sop_ShiftSuperoperator", "[", "0", "]"}], "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.593011889341981*^9}},
 CellLabel->
  "In[1099]:=",ExpressionUUID->"4b938759-c936-4073-a8d3-e8bdf07beeb2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ShiftSuperoperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_ShiftSuperoperator", ",", "b___"}], "]"}], "]"}],
     "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"SuperoperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Superoperator", "::", "times"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.589824007778718*^9, 
   3.5898240231530933`*^9}, {3.589824060303439*^9, 3.589824140308934*^9}},
 CellLabel->
  "In[1100]:=",ExpressionUUID->"9aa6483c-cfbf-41a6-bf13-f4b53a7f7409"],

Cell[BoxData[
 RowBox[{
  RowBox[{"UserLevelDependentDefinition", "[", 
   RowBox[{"Plus", ",", "Infinity", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{
       RowBox[{"Plus", "[", 
        RowBox[{"sops", ":", 
         RowBox[{
          RowBox[{"ShiftSuperoperator", "[", 
           RowBox[{"__", ",", "___Rule"}], "]"}], ".."}]}], "]"}], "[", "op_",
        "]"}]}], ":=", 
     RowBox[{"Plus", "@@", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"#", "[", "op", "]"}], ")"}], "&"}], "/@", 
        RowBox[{"{", "sops", "}"}]}], ")"}]}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68311989906787*^9, 3.683119906258154*^9}, 
   3.683119993176091*^9, 3.683120578306602*^9, {3.745399850354347*^9, 
   3.7453998548136683`*^9}},
 CellLabel->
  "In[1101]:=",ExpressionUUID->"8b78e17a-f8a6-459e-8b31-e5d35332d518"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftSuperoperator", "[", 
    RowBox[{
     RowBox[{"n_", "?", "NumericQ"}], ",", 
     RowBox[{"op_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"n", " ", "\[Times]", 
    RowBox[{"ShiftSuperoperator", "[", 
     RowBox[{
      RowBox[{"UnityOperator", "[", "]"}], ",", "op", ",", "opts"}], 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.461326868101194*^9, 3.461326887671747*^9}, {
   3.461326927058106*^9, 3.461326959652581*^9}, 3.486465230460766*^9, {
   3.4867226283815737`*^9, 3.486722639139216*^9}},
 CellLabel->
  "In[1102]:=",ExpressionUUID->"0a2198ca-77a8-4c77-87d9-9dd82bcf07e1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftSuperoperator", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", 
     RowBox[{"n_", "?", "NumericQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"n", " ", "\[Times]", 
    RowBox[{"ShiftSuperoperator", "[", 
     RowBox[{"op", ",", 
      RowBox[{"UnityOperator", "[", "]"}], ",", "opts"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.461326868101194*^9, 3.461326887671747*^9}, {
   3.461326927058106*^9, 3.461326980405963*^9}, 3.486465231252831*^9, {
   3.486722646766099*^9, 3.4867226532382793`*^9}},
 CellLabel->
  "In[1103]:=",ExpressionUUID->"c7f47f29-5838-49ef-9976-11afbb713cba"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ShiftSuperoperator", "[", 
    RowBox[{
     RowBox[{"n1_", "?", "NumericQ"}], ",", 
     RowBox[{"n2_", "?", "NumericQ"}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"n1", " ", "n2", " ", "\[Times]", 
    RowBox[{"ShiftSuperoperator", "[", 
     RowBox[{
      RowBox[{"UnityOperator", "[", "]"}], ",", 
      RowBox[{"UnityOperator", "[", "]"}], ",", "opts"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.461326868101194*^9, 3.461326887671747*^9}, {
  3.461326927058106*^9, 3.461327005391595*^9}, {3.4864652321248713`*^9, 
  3.486465232842575*^9}, {3.486722660902433*^9, 3.486722666254302*^9}},
 CellLabel->
  "In[1104]:=",ExpressionUUID->"0a19a425-eef3-433b-a1f3-00551488ae46"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ShiftSuperoperator", "[", 
     RowBox[{
      RowBox[{"op2_", "?", "OperatorQ"}], ",", 
      RowBox[{"op1_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Normalize", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ShiftSuperoperator", "]"}]}], ")"}]}], ":=", 
   RowBox[{"ShiftSuperoperator", "[", 
    RowBox[{
     RowBox[{"NormalizeOperator", "[", "op2", "]"}], ",", 
     RowBox[{"NormalizeOperator", "[", "op1", "]"}], ",", 
     RowBox[{"Normalize", "\[Rule]", "False"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.486722683573187*^9, 3.486722713500183*^9}},
 CellLabel->
  "In[1105]:=",ExpressionUUID->"c16d79c0-49ae-4937-ac6c-078894549733"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ShiftSuperoperator", "[", 
      RowBox[{
       RowBox[{"op2_", "?", "OperatorQ"}], ",", 
       RowBox[{"op1_", "?", "OperatorQ"}], ",", "opts___Rule"}], "]"}], "[", 
     "op_", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Normalize", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "ShiftSuperoperator", "]"}]}], ")"}]}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"op2", "\[Times]", 
    RowBox[{"LiouvilleBracket", "[", 
     RowBox[{"op1", ",", "op"}], "]"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431056882307535*^9, 3.431056909106833*^9}, {
   3.45061422457043*^9, 3.450614226301695*^9}, {3.450617959993046*^9, 
   3.450617971886685*^9}, 3.4556435187731123`*^9, {3.4556435511382017`*^9, 
   3.4556435626148043`*^9}, {3.4556436180264587`*^9, 3.455643657453874*^9}, {
   3.4556453430014467`*^9, 3.455645348379621*^9}, {3.48672274479044*^9, 
   3.486722768667467*^9}},
 CellLabel->
  "In[1106]:=",ExpressionUUID->"61e53cf0-cf68-4904-8254-492ccd1c5438"]
}, Open  ]],

Cell[CellGroupData[{

Cell["CoherenceOrderFiltrationSuperoperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4506142165078077`*^9, 3.45061425680519*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"907d4de5-6b62-4f2f-afae-482120463f15"],

Cell[CellGroupData[{

Cell["trap illegal Times", "Subsubsection",
 CellChangeTimes->{{3.72256051849621*^9, 3.722560519615499*^9}, {
  3.72256069822631*^9, 
  3.7225607036619673`*^9}},ExpressionUUID->"a3e83598-def1-425e-b89f-\
d6b52da22c34"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CoherenceOrderFiltrationSuperoperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{
      "a___", ",", "_CoherenceOrderFiltrationSuperoperator", ",", "b___"}], 
      "]"}], "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"SuperoperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Superoperator", "::", "times"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.589824007778718*^9, 
   3.5898240231530933`*^9}, {3.589824060303439*^9, 3.589824157004993*^9}},
 CellLabel->
  "In[1107]:=",ExpressionUUID->"50d6d7ea-8424-423f-912a-eda9c2b517bb"]
}, Closed]],

Cell[CellGroupData[{

Cell["expand to general form", "Subsubsection",
 CellChangeTimes->{{3.72256051849621*^9, 3.722560519615499*^9}, {
  3.72256069822631*^9, 
  3.722560723617002*^9}},ExpressionUUID->"e4f3a1d0-a95d-46b5-a214-\
d0228dea085e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", "opts___Rule", "]"}],
    ":=", 
   RowBox[{"UnitySuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.722561923095654*^9, 3.722561936906189*^9}},
 CellLabel->
  "In[1108]:=",ExpressionUUID->"02d1209e-548d-4bfa-a0fd-e79d1e274667"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
    RowBox[{"spins___", ",", 
     RowBox[{"p", ":", 
      RowBox[{"Except", "[", "_List", "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"{", "p", "}"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450614270910026*^9, 3.450614284053668*^9}, {
  3.587293940280354*^9, 3.587293947609041*^9}, {3.722560986858445*^9, 
  3.722560988059412*^9}, {3.722561851411673*^9, 3.722561858451397*^9}},
 CellLabel->
  "In[1109]:=",ExpressionUUID->"4a0e2dc8-f351-4ca1-be1d-ca00cc5ebf33"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
    RowBox[{
     RowBox[{"orders", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
    RowBox[{
     RowBox[{"First", "/@", 
      RowBox[{"SpinSystem", "[", "]"}]}], ",", "orders", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450614270910026*^9, 3.450614284053668*^9}, {
   3.5872936578175917`*^9, 3.587293670968265*^9}, {3.587293933069028*^9, 
   3.5872939360481253`*^9}, {3.722560788711081*^9, 3.722560793312086*^9}, 
   3.7225610957082443`*^9, {3.722561863946556*^9, 3.722561868795806*^9}},
 CellLabel->
  "In[1110]:=",ExpressionUUID->"e193ce16-bdde-4090-aad0-29eed100cb5c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
    RowBox[{
     RowBox[{"spin", ":", 
      RowBox[{"Except", "[", "_List", "]"}]}], ",", 
     RowBox[{"orders", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
    RowBox[{
     RowBox[{"{", "spin", "}"}], ",", "orders", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450614270910026*^9, 3.450614284053668*^9}, {
   3.5872936578175917`*^9, 3.587293670968265*^9}, {3.587293849566351*^9, 
   3.587293866301546*^9}, {3.722560878674333*^9, 3.7225608821282988`*^9}, 
   3.722561093265332*^9, {3.722561875299466*^9, 3.722561880513546*^9}},
 CellLabel->
  "In[1111]:=",ExpressionUUID->"bcf02c03-7965-49ac-bf05-46aadab9612f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
    RowBox[{
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
     RowBox[{"orders", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spins", ",", "orders"}], "}"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450614270910026*^9, 3.450614284053668*^9}, {
  3.5872936578175917`*^9, 3.587293670968265*^9}, {3.587293933069028*^9, 
  3.5872939360481253`*^9}, {3.722560788711081*^9, 3.722560826609573*^9}, {
  3.7225610815080633`*^9, 3.722561090358046*^9}, {3.722561886294964*^9, 
  3.722561890602975*^9}},
 CellLabel->
  "In[1112]:=",ExpressionUUID->"32686b3a-a7cb-4ffc-a64f-d20172d5bedd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
    RowBox[{"arg1___", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"spins", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
       RowBox[{"p", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], ",", "arg2___", ",",
      "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
    RowBox[{"arg1", ",", 
     RowBox[{"{", 
      RowBox[{"spins", ",", 
       RowBox[{"{", "p", "}"}]}], "}"}], ",", "arg2", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450614270910026*^9, 3.450614284053668*^9}, {
   3.5872936578175917`*^9, 3.587293670968265*^9}, {3.587293933069028*^9, 
   3.5872939360481253`*^9}, {3.722560788711081*^9, 3.722560826609573*^9}, {
   3.722560905822483*^9, 3.7225609212090607`*^9}, 3.722561074009645*^9, {
   3.72256133812536*^9, 3.72256135407014*^9}, {3.722561902442807*^9, 
   3.722561908745789*^9}},
 CellLabel->
  "In[1113]:=",ExpressionUUID->"b99f2d55-b514-4da7-a0c7-d61ba1b723f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
    RowBox[{"arg1___", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"spin", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", 
       RowBox[{"orders", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}]}], "}"}], 
     ",", "arg2___", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
    RowBox[{"arg1", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "spin", "}"}], ",", "orders"}], "}"}], ",", "arg2", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450614270910026*^9, 3.450614284053668*^9}, {
   3.5872936578175917`*^9, 3.587293670968265*^9}, {3.587293933069028*^9, 
   3.5872939360481253`*^9}, {3.722560788711081*^9, 3.722560826609573*^9}, {
   3.722560905822483*^9, 3.722560957911401*^9}, 3.722561065761001*^9, {
   3.722561360306897*^9, 3.722561374503351*^9}, {3.722561913393845*^9, 
   3.722561918045229*^9}},
 CellLabel->
  "In[1114]:=",ExpressionUUID->"d9b4c4fc-7390-4dbf-9c20-51e93c2fbcd4"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply", "Subsubsection",
 CellChangeTimes->{{3.72256051849621*^9, 3.722560519615499*^9}, {
  3.722560644833902*^9, 3.7225606499672823`*^9}, {3.722561804795471*^9, 
  3.7225618084570436`*^9}, {3.72256250618113*^9, 
  3.722562506829666*^9}},ExpressionUUID->"a1c9e670-5298-44b4-83b7-\
026e3a3c733a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"sop_CoherenceOrderFiltrationSuperoperator", "[", "0", "]"}], "=", 
   
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.593011901756474*^9}},
 CellLabel->
  "In[1115]:=",ExpressionUUID->"0b9f58c3-e70f-4a33-a283-63e9388c474e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "[", 
   RowBox[{
    RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", "args___", "]"}], 
    "[", 
    RowBox[{"op_", "?", "OperatorQ"}], "]"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"BasisOperators", "[", "]"}], ".", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", "args", "]"}], 
    "\[IndentingNewLine]", "]"}], ".", 
   RowBox[{"OperatorVectorRepresentation", "[", "op", "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.500278850914916*^9, 3.5002789542100573`*^9}, {
  3.500279037674077*^9, 3.5002790407635927`*^9}, {3.587293678686426*^9, 
  3.587293687481657*^9}, {3.722560655962069*^9, 3.722560663514525*^9}},
 CellLabel->
  "In[1116]:=",ExpressionUUID->"4f6c356c-fddb-4037-a9c6-6fa27c8f5654"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SphericalComponentFiltrationSuperoperator\[AliasDelimiter]", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4506142165078077`*^9, 3.45061425680519*^9, 
  3.455463171999929*^9, 3.7027769264041166`*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"134c985f-cc37-4d32-95ae-b5545c49a1af"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"sop_SphericalComponentFiltrationSuperoperator", "[", "0", "]"}], 
   "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.593011915388439*^9}},
 CellLabel->
  "In[1117]:=",ExpressionUUID->"fdd8d34b-cb6d-41b9-b475-d750751e155b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SphericalComponentFiltrationSuperoperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{
      "a___", ",", "_SphericalComponentFiltrationSuperoperator", ",", 
       "b___"}], "]"}], "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"SuperoperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Superoperator", "::", "times"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.589824007778718*^9, 
   3.5898240231530933`*^9}, {3.589824060303439*^9, 3.589824174140123*^9}},
 CellLabel->
  "In[1118]:=",ExpressionUUID->"537419ab-68c1-4e46-9a33-fae59bb58d53"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SphericalComponentFiltrationSuperoperator", "[", 
   RowBox[{"{", 
    RowBox[{"\[Lambda]_", ",", "\[Mu]2_", ",", "\[Mu]1_"}], "}"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
      "SphericalComponentFiltrationSuperoperator", "::", "notspinshf"}], 
      "]"}], ";", "$Failed"}], ")"}], "/;", 
   RowBox[{"!", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"Last", "/@", 
       RowBox[{"SpinSystem", "[", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "/", "2"}], ")"}], "..."}], "}"}]}], 
     "]"}]}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.466770744928995*^9, 3.466770768321804*^9}, {
  3.466770802989408*^9, 3.46677084730234*^9}},
 CellLabel->
  "In[1119]:=",ExpressionUUID->"348cd3c5-d446-4d78-a16f-d933fe279b9d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalComponentFiltrationSuperoperator", "[", 
    RowBox[{"{", 
     RowBox[{"\[Lambda]_", ",", "\[Mu]2_", ",", "\[Mu]1_"}], "}"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "nspin", ",", "\[CapitalLambda]", ",", "ops2", ",", "ops1", ",", 
       "oppairs"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"nspin", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"SpinSystem", "[", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[CapitalLambda]", "=", 
        RowBox[{"Cases", "[", 
         RowBox[{
          RowBox[{"Subsets", "[", 
           RowBox[{
            RowBox[{"First", "/@", 
             RowBox[{"SpinSystem", "[", "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"\[Lambda]", ",", "nspin"}], "}"}]}], "]"}], ",", 
          RowBox[{"Except", "[", 
           RowBox[{"{", "}"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Off", "[", 
        RowBox[{"opT", "::", "multiple"}], "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"ops2", "=", 
        RowBox[{"Union", "@", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"opT", "[", 
             RowBox[{"#", ",", 
              RowBox[{"{", 
               RowBox[{"\[Lambda]", ",", "\[Mu]2"}], "}"}], ",", 
              RowBox[{"Normalize", "\[Rule]", "True"}]}], "]"}], "&"}], "/@", 
           "\[CapitalLambda]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ops1", "=", 
        RowBox[{"Union", "@", 
         RowBox[{"Flatten", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"opT", "[", 
             RowBox[{"#", ",", 
              RowBox[{"{", 
               RowBox[{"\[Lambda]", ",", "\[Mu]1"}], "}"}], ",", 
              RowBox[{"Normalize", "\[Rule]", "True"}]}], "]"}], "&"}], "/@", 
           "\[CapitalLambda]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"oppairs", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"ops2", ",", "ops1"}], "}"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"On", "[", 
        RowBox[{"opT", "::", "multiple"}], "]"}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{"ops2", ",", 
            RowBox[{"{", "}"}]}], "]"}], "||", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"ops1", ",", 
            RowBox[{"{", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"NullSuperoperator", "[", "]"}], ",", "\[IndentingNewLine]", 
         
         RowBox[{"Plus", "@@", "\[IndentingNewLine]", 
          RowBox[{"MapThread", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"ShiftSuperoperator", "[", 
              RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"ops2", ",", "ops1"}], "}"}]}], "\[IndentingNewLine]", 
           "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.431056882307535*^9, 3.431056909106833*^9}, {
   3.45061422457043*^9, 3.450614226301695*^9}, {3.450617959993046*^9, 
   3.450617971886685*^9}, {3.455462883948965*^9, 3.4554628994346848`*^9}, {
   3.455462946338703*^9, 3.455463139681161*^9}, {3.45564383789791*^9, 
   3.4556438507890787`*^9}, 3.455643949359421*^9, {3.455644396689905*^9, 
   3.455644398471559*^9}, 3.456162402282694*^9, {3.46677061392155*^9, 
   3.466770634095232*^9}, {3.466770685012686*^9, 3.4667707017951307`*^9}, {
   3.4673023849439373`*^9, 3.467302453740559*^9}, 3.486710881231989*^9, {
   3.6748208361655293`*^9, 3.674820851083053*^9}},
 CellLabel->
  "In[1120]:=",ExpressionUUID->"e4e23507-327d-4589-82e7-cb61999d0bc7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalComponentFiltrationSuperoperator", "[", 
     RowBox[{"args___", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Lambda]_", ",", "\[Mu]2_", ",", "\[Mu]1_"}], "}"}]}], 
      "]"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
      "SphericalComponentFiltrationSuperoperator", "::", "invalargs"}], "]"}],
      ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.674821074430937*^9, 3.674821133819663*^9}},
 CellLabel->
  "In[1121]:=",ExpressionUUID->"e58c5a4d-3157-41bc-bcb9-5e85bce70dd9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalComponentFiltrationSuperoperator", "::", "notspinshf"}], 
   "=", "\"\<SphericalComponentFiltrationSuperoperator is currently only \
implemented for spins-1/2\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.466770775402767*^9, 3.466770798660047*^9}},
 CellLabel->
  "In[1122]:=",ExpressionUUID->"2a5dd018-150e-4f1f-b232-1bb8da62b7b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalComponentFiltrationSuperoperator", "::", "invalargs"}], 
   "=", "\"\<Invalid arguments for SphericalComponentFiltrationSuperoperator.\
\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.674821143676626*^9, 3.67482116278872*^9}},
 CellLabel->
  "In[1123]:=",ExpressionUUID->"be75d3ff-d8c7-466b-8dc5-501cdd535a19"]
}, Closed]],

Cell[CellGroupData[{

Cell["RotationSuperoperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4506142165078077`*^9, 3.45061425680519*^9, 
  3.450614643338854*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"9bcf72d6-9cc5-464e-8319-3593e2b6e149"],

Cell[CellGroupData[{

Cell["trap invalid Times", "Subsubsection",
 CellChangeTimes->{{3.722564645986768*^9, 3.722564660584612*^9}, {
  3.7225648605642977`*^9, 
  3.7225648642622967`*^9}},ExpressionUUID->"4388f9b2-b440-476d-9408-\
4aeaf5a7c62e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RotationSuperoperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_RotationSuperoperator", ",", "b___"}], "]"}], 
     "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"SuperoperatorQ", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Superoperator", "::", "times"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.589824007778718*^9, 
   3.5898240231530933`*^9}, {3.589824060303439*^9, 3.589824200139777*^9}},
 CellLabel->
  "In[1124]:=",ExpressionUUID->"5830ab0c-a73b-44a6-97fb-db1978f66bd3"]
}, Closed]],

Cell[CellGroupData[{

Cell["generalize", "Subsubsection",
 CellChangeTimes->{{3.722564645986768*^9, 
  3.722564698243786*^9}},ExpressionUUID->"0d9933c3-5518-4281-be9b-\
2b70f18d2c94"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", "angs_List", "]"}]}], ":=", 
   RowBox[{"RotationSuperoperator", "[", 
    RowBox[{
     RowBox[{"First", "/@", 
      RowBox[{"SpinSystem", "[", "]"}]}], ",", "angs"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.456201022689602*^9, 3.456201051809086*^9}},
 CellLabel->
  "In[1125]:=",ExpressionUUID->"3f399a72-9b92-4fbb-b617-07c774fbd8dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{
      RowBox[{"j", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", "angs_List"}], "]"}]}], ":=", 
   RowBox[{"RotationSuperoperator", "[", 
    RowBox[{
     RowBox[{"{", "j", "}"}], ",", "angs"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.456201022689602*^9, 3.456201084249012*^9}},
 CellLabel->
  "In[1126]:=",ExpressionUUID->"c5447dc6-b245-48d8-b356-44976939402a"]
}, Closed]],

Cell[CellGroupData[{

Cell["traps", "Subsubsection",
 CellChangeTimes->{{3.722564645986768*^9, 3.722564698243786*^9}, {
  3.722564856180387*^9, 
  3.722564856909803*^9}},ExpressionUUID->"68bde152-83c1-469b-a222-\
00a37bee6c82"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", "\[Phi]_"}], "}"}]}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"\[Beta]", ",", 
       RowBox[{"Except", "[", 
        RowBox[{"_List", "|", "_String"}], "]"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"RotationSuperoperator", "::", "inv\[Beta]"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7225643615505247`*^9, 3.722564399443634*^9}, {
  3.722564430449308*^9, 3.722564444897505*^9}, {3.7225644890797367`*^9, 
  3.722564493025182*^9}, {3.7225649637766323`*^9, 3.722564979122712*^9}},
 CellLabel->
  "In[1127]:=",ExpressionUUID->"c6fb2370-355d-4b36-a5c8-0eec45a7a388"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", "\[Phi]_String"}], "}"}]}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"\[Phi]", ",", 
       RowBox[{
       "\"\<x\>\"", "|", "\"\<y\>\"", "|", "\"\<z\>\"", "|", 
        "\"\<\!\(\*OverscriptBox[\(x\), \(_\)]\)\>\"", "|", "\"\<-x\>\"", 
        "|", "\"\<\!\(\*OverscriptBox[\(y\), \(_\)]\)\>\"", "|", 
        "\"\<-y\>\""}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"RotationSuperoperator", "::", "inv\[Phi]"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7225643615505247`*^9, 3.722564399443634*^9}, {
  3.722564430449308*^9, 3.722564481230769*^9}, {3.722564969632277*^9, 
  3.722564983825165*^9}},
 CellLabel->
  "In[1128]:=",ExpressionUUID->"1e1e2d94-1b67-4943-bf9b-d0671c5c5b10"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_", ",", "\[CapitalOmega]_"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", "\[IndentingNewLine]", 
      RowBox[{"\[CapitalOmega]", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_List", "|", "_String"}], "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}]}], "}"}], "|", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_List", "|", "_String"}], "]"}], ",", 
          RowBox[{"Except", "[", 
           RowBox[{"_List", "|", "_String"}], "]"}], ",", 
          RowBox[{"Except", "[", 
           RowBox[{"_List", "|", "_String"}], "]"}]}], "}"}], "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", 
           RowBox[{"_List", "|", "_String"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Except", "[", 
             RowBox[{"_List", "|", "_String"}], "]"}], ",", 
            RowBox[{"Except", "[", 
             RowBox[{"_List", "|", "_String"}], "]"}]}], "}"}]}], 
         "\[IndentingNewLine]", "}"}]}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"RotationSuperoperator", "::", "invangle"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4608076480440073`*^9, 3.460807769642179*^9}, 
   3.50216369487983*^9, {3.502163725016018*^9, 3.5021638614740963`*^9}, {
   3.502163940039324*^9, 3.502163946453445*^9}, 3.5021639879762*^9, {
   3.722564169591838*^9, 3.722564173804405*^9}, {3.722564221795383*^9, 
   3.722564261347114*^9}, {3.722564546673751*^9, 3.722564573727085*^9}, {
   3.722564988222825*^9, 3.7225649979764357`*^9}},
 CellLabel->
  "In[1129]:=",ExpressionUUID->"8a70c6c3-090c-4799-8d04-e213ef35f5e8"]
}, Closed]],

Cell[CellGroupData[{

Cell["resolve into quadrature rotations", "Subsubsection",
 CellChangeTimes->{{3.722564645986768*^9, 3.722564650089849*^9}, {
  3.7225647860917807`*^9, 
  3.722564792363728*^9}},ExpressionUUID->"addfea42-6e71-4cd8-83a8-\
10eca703df3a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_List", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "\[Mu]_"}], "}"}]}], "]"}]}], ":=", 
   RowBox[{"UnitySuperoperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.451314014171859*^9, 3.451314038809937*^9}, {
  3.451314232799061*^9, 3.451314236656548*^9}, {3.456201177842156*^9, 
  3.456201181082366*^9}, {3.486710736134891*^9, 3.48671073627728*^9}},
 CellLabel->
  "In[1130]:=",ExpressionUUID->"c6c295ab-dc0c-4ad9-adcf-cc60751197f6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_List", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", "\"\<-x\>\""}], "}"}]}], "]"}]}], ":=", 
   RowBox[{"RotationSuperoperator", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "\[Beta]"}], ",", "\"\<x\>\""}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452692170476849*^9, 3.452692207884204*^9}, {
  3.45620119697359*^9, 3.456201216538509*^9}, {3.585661164338004*^9, 
  3.585661187583667*^9}},
 CellLabel->
  "In[1131]:=",ExpressionUUID->"30f3d43a-2152-4838-bb15-963b7da9d52a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_List", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", "\"\<-y\>\""}], "}"}]}], "]"}]}], ":=", 
   RowBox[{"RotationSuperoperator", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "\[Beta]"}], ",", "\"\<y\>\""}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452692170476849*^9, 3.452692207884204*^9}, {
  3.45620119697359*^9, 3.456201216538509*^9}, {3.585661164338004*^9, 
  3.585661200063548*^9}},
 CellLabel->
  "In[1132]:=",ExpressionUUID->"62fbff94-44d7-41ca-991c-810ef6c9897f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_List", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", "\"\<-z\>\""}], "}"}]}], "]"}]}], ":=", 
   RowBox[{"RotationSuperoperator", "[", 
    RowBox[{"spins", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "\[Beta]"}], ",", "\"\<z\>\""}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452692170476849*^9, 3.452692207884204*^9}, {
  3.45620119697359*^9, 3.456201216538509*^9}, {3.585661164338004*^9, 
  3.585661210159191*^9}},
 CellLabel->
  "In[1133]:=",ExpressionUUID->"0965b874-63cb-435d-b440-2b28e0a9d9b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_List", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", "\[Phi]_"}], "}"}]}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]", ",", "\"\<x\>\""}], "}"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Mod", "[", 
      RowBox[{"\[Phi]", ",", 
       RowBox[{"2", "\[Pi]"}]}], "]"}], "\[Equal]", "0"}]}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.452692170476849*^9, 3.452692207884204*^9}, {
  3.45620119697359*^9, 3.456201216538509*^9}},
 CellLabel->
  "In[1134]:=",ExpressionUUID->"673404e4-1604-4d3d-b2ea-de278dbaaba2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_List", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", "\[Phi]_"}], "}"}]}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]", ",", "\"\<y\>\""}], "}"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Mod", "[", 
      RowBox[{"\[Phi]", ",", 
       RowBox[{"2", "\[Pi]"}]}], "]"}], "\[Equal]", 
     RowBox[{"\[Pi]", "/", "2"}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452692170476849*^9, 3.45269223517979*^9}, {
  3.456201201268684*^9, 3.456201220010676*^9}},
 CellLabel->
  "In[1135]:=",ExpressionUUID->"e338dd0f-2e07-48d9-b280-149d5ef078ea"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_List", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", "\[Phi]_"}], "}"}]}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "\[Beta]"}], ",", "\"\<x\>\""}], "}"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Mod", "[", 
      RowBox[{"\[Phi]", ",", 
       RowBox[{"2", "\[Pi]"}]}], "]"}], "\[Equal]", "\[Pi]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452692170476849*^9, 3.45269225125865*^9}, {
  3.456201207388461*^9, 3.456201222858754*^9}, {3.4610374871287727`*^9, 
  3.4610374901506977`*^9}},
 CellLabel->
  "In[1136]:=",ExpressionUUID->"2b887c10-716a-40e8-81ba-4f4350f14ea1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_List", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", "\[Phi]_"}], "}"}]}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "\[Beta]"}], ",", "\"\<y\>\""}], "}"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Mod", "[", 
      RowBox[{"\[Phi]", ",", 
       RowBox[{"2", "\[Pi]"}]}], "]"}], "\[Equal]", 
     RowBox[{"3", 
      RowBox[{"\[Pi]", "/", "2"}]}]}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.452692170476849*^9, 3.4526922620364*^9}, {
  3.45620121072484*^9, 3.456201227003153*^9}, {3.461037492407509*^9, 
  3.461037496422559*^9}},
 CellLabel->
  "In[1137]:=",ExpressionUUID->"c8d9a5e6-dece-45c6-8f3a-5615485c46d9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_List", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]_", ",", 
        RowBox[{"\[Phi]", ":", 
         RowBox[{"Except", "[", 
          RowBox[{
           RowBox[{"(", "_List", ")"}], "|", "\"\<x\>\"", "|", "\"\<y\>\"", 
           "|", "\"\<z\>\"", "|", "\"\<-x\>\"", "|", "\"\<-y\>\"", "|", 
           "\"\<-z\>\""}], "]"}]}]}], "}"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Dot", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"RotationSuperoperator", "[", 
      RowBox[{"spins", ",", 
       RowBox[{"{", 
        RowBox[{"\[Phi]", ",", "\"\<z\>\""}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"RotationSuperoperator", "[", 
      RowBox[{"spins", ",", 
       RowBox[{"{", 
        RowBox[{"\[Beta]", ",", "\"\<x\>\""}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"RotationSuperoperator", "[", 
      RowBox[{"spins", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "\[Phi]"}], ",", "\"\<z\>\""}], "}"}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.450614717464363*^9, 3.450614812390133*^9}, {
  3.4506148542178993`*^9, 3.450614947190653*^9}, {3.450617930088292*^9, 
  3.450617939605917*^9}, {3.450618289853633*^9, 3.4506182928757*^9}, {
  3.452691410813532*^9, 3.452691431613398*^9}, {3.456201264310835*^9, 
  3.456201291803631*^9}, {3.4610379344399357`*^9, 3.461037947271089*^9}, {
  3.461047304590023*^9, 3.461047306541048*^9}, {3.585661125553563*^9, 
  3.585661136354961*^9}},
 CellLabel->
  "In[1138]:=",ExpressionUUID->"9144ae3a-f4d6-44bb-aed6-6081808aede8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_List", ",", 
      RowBox[{"{", 
       RowBox[{"\[Alpha]_", ",", "\[Beta]_", ",", "\[Gamma]_"}], "}"}]}], 
     "]"}]}], ":=", 
   RowBox[{
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"{", 
       RowBox[{"\[Alpha]", ",", "\"\<z\>\""}], "}"}]}], "]"}], ".", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"{", 
       RowBox[{"\[Beta]", ",", "\"\<y\>\""}], "}"}]}], "]"}], ".", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"{", 
       RowBox[{"\[Gamma]", ",", "\"\<z\>\""}], "}"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.439513074357732*^9, {3.448291148605165*^9, 3.448291151572282*^9}, {
   3.456165017476817*^9, 3.4561650293252697`*^9}, {3.456165146848401*^9, 
   3.456165239506689*^9}, 3.456165780902337*^9, {3.456201310718916*^9, 
   3.456201329074081*^9}, {3.46036585125308*^9, 3.460365875443671*^9}},
 CellLabel->
  "In[1139]:=",ExpressionUUID->"e44f4f3d-0b34-48a7-9bf7-60dff1f8d2f0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins_List", ",", 
      RowBox[{"{", 
       RowBox[{"\[Xi]_", ",", 
        RowBox[{"{", 
         RowBox[{"\[Theta]_", ",", "\[Phi]_"}], "}"}]}], "}"}]}], "]"}]}], ":=", 
   RowBox[{
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"{", 
       RowBox[{"\[Phi]", ",", "\"\<z\>\""}], "}"}]}], "]"}], ".", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"{", 
       RowBox[{"\[Theta]", ",", "\"\<y\>\""}], "}"}]}], "]"}], ".", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"{", 
       RowBox[{"\[Xi]", ",", "\"\<z\>\""}], "}"}]}], "]"}], ".", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "\[Theta]"}], ",", "\"\<y\>\""}], "}"}]}], "]"}], ".", 
    RowBox[{"RotationSuperoperator", "[", 
     RowBox[{"spins", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "\[Phi]"}], ",", "\"\<z\>\""}], "}"}]}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.439513074357732*^9, {3.448291148605165*^9, 3.448291151572282*^9}, {
   3.456165017476817*^9, 3.4561650293252697`*^9}, {3.456165146848401*^9, 
   3.456165239506689*^9}, 3.456165780902337*^9, {3.456201310718916*^9, 
   3.456201329074081*^9}},
 CellLabel->
  "In[1140]:=",ExpressionUUID->"25459034-28b3-4217-b6ea-6a2bc41441af"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to an operator", "Subsubsection",
 CellChangeTimes->{{3.722564645986768*^9, 3.722564650089849*^9}, {
  3.7225647974210157`*^9, 
  3.722564799324025*^9}},ExpressionUUID->"aa903ae0-9002-460b-804c-\
d26ee23b67ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"sop_RotationSuperoperator", "[", "0", "]"}], "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.593011931194457*^9}},
 CellLabel->
  "In[1141]:=",ExpressionUUID->"56180350-2d9a-49d4-a81e-04dbec3e37e8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{
     RowBox[{"RotationSuperoperator", "[", 
      RowBox[{"spins_List", ",", "angs_List"}], "]"}], "[", "op_", "]"}], 
    "]"}], ":=", 
   RowBox[{"Dot", "[", 
    RowBox[{
     RowBox[{"opR", "[", 
      RowBox[{"spins", ",", "angs"}], "]"}], ",", "op", ",", 
     RowBox[{"Adjoint", "[", 
      RowBox[{"opR", "[", 
       RowBox[{"spins", ",", "angs"}], "]"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.461037542942494*^9, 3.4610376156176434`*^9}, {
   3.461037705012974*^9, 3.46103771278596*^9}, {3.461037808070877*^9, 
   3.461037811064651*^9}, {3.461037997948154*^9, 3.461037999869165*^9}, {
   3.6578214145253687`*^9, 3.657821417803605*^9}, 3.6595348547644587`*^9},
 CellLabel->
  "In[1142]:=",ExpressionUUID->"fa854da4-f103-45a6-a4b1-a1299651a04c"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 CellChangeTimes->{{3.722564645986768*^9, 3.722564650089849*^9}, {
  3.7225647974210157`*^9, 3.722564799324025*^9}, {3.722564896564063*^9, 
  3.722564897764101*^9}},ExpressionUUID->"3c51672f-ef78-4652-95f3-\
379693763c01"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RotationSuperoperator", "::", "inv\[Beta]"}], "=", 
   "\"\<invalid flip angle for RotationSuperoperator.\>\""}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.46080778887774*^9, 3.460807801678125*^9}, {
   3.502163713419979*^9, 3.502163719130096*^9}, {3.722564316497818*^9, 
   3.722564341683692*^9}, {3.722564928171563*^9, 3.722564934566989*^9}, 
   3.722565232878751*^9},
 CellLabel->
  "In[1143]:=",ExpressionUUID->"c96c020c-e749-4455-9d07-b88cf1d3a995"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RotationSuperoperator", "::", "inv\[Phi]"}], "=", 
   "\"\<invalid phase for RotationSuperoperator.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.46080778887774*^9, 3.460807801678125*^9}, {
   3.502163713419979*^9, 3.502163719130096*^9}, {3.722564316497818*^9, 
   3.722564345335289*^9}, {3.722564929275869*^9, 3.722564937717301*^9}, 
   3.722565236018416*^9},
 CellLabel->
  "In[1144]:=",ExpressionUUID->"03f8cf13-5c0f-4674-8319-9aaf0a331756"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RotationSuperoperator", "::", "invangle"}], "=", 
   "\"\<invalid angle definition for RotationSuperoperator.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.46080778887774*^9, 3.460807801678125*^9}, {
   3.502163713419979*^9, 3.502163719130096*^9}, {3.7225649304804573`*^9, 
   3.722564941871359*^9}, 3.722565239818396*^9},
 CellLabel->
  "In[1145]:=",ExpressionUUID->"49c5dcf7-6f24-414b-a422-c606f9de3ec7"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinPermutationSuperoperator", "Section",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4506142165078077`*^9, 3.45061425680519*^9, 3.450614643338854*^9, {
   3.590665471199733*^9, 3.5906654771559677`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"36699be1-1093-4348-855f-ab6855787d95"],

Cell[CellGroupData[{

Cell["general", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408751851077*^9}, {
  3.590665650016817*^9, 
  3.590665650911017*^9}},ExpressionUUID->"f4809238-5913-465c-af6b-\
262bd94e9519"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"sop_SpinPermutationSuperoperator", "[", "0", "]"}], "=", 
   RowBox[{"NullOperator", "[", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.593011760056856*^9, 3.5930119436105967`*^9}},
 CellLabel->
  "In[1146]:=",ExpressionUUID->"0c45057f-8a09-4714-8eed-ff04421577f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SpinPermutationSuperoperator", "/:", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"Times", "[", 
      RowBox[{"a___", ",", "_SpinPermutationSuperoperator", ",", "b___"}], 
      "]"}], "]"}], "/;", 
    RowBox[{"Or", "@@", 
     RowBox[{"(", 
      RowBox[{"SpinPermutationSuperoperator", "/@", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Superoperator", "::", "times"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.460865150260769*^9, 3.4608652870827217`*^9}, {
   3.460867553686809*^9, 3.460867556810396*^9}, {3.460867658699642*^9, 
   3.460867661056884*^9}, 3.4675564604293623`*^9, {3.589480964469913*^9, 
   3.589481052131288*^9}, 3.589481136924074*^9, {3.589823523309821*^9, 
   3.589823530819072*^9}, 3.589823577488831*^9, {3.589824007778718*^9, 
   3.5898240231530933`*^9}, {3.589824060303439*^9, 3.589824140308934*^9}, {
   3.590665525884035*^9, 3.590665532013905*^9}},
 CellLabel->
  "In[1147]:=",ExpressionUUID->"474ea414-4275-4279-9ec7-f11e68dfa882"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationSuperoperator", "[", "perm_", "]"}], ":=", 
   RowBox[{"SpinPermutationSuperoperator", "[", 
    RowBox[{"perm", ",", 
     RowBox[{"SpinSystem", "[", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4607105770898523`*^9, 3.460710605097621*^9}, {
  3.460710680055278*^9, 3.460710707874959*^9}, {3.502278457077628*^9, 
  3.502278485577228*^9}, {3.502283882500239*^9, 3.502283883502369*^9}, {
  3.5903992635340643`*^9, 3.590399264308302*^9}, {3.5906655543143673`*^9, 
  3.590665556729253*^9}},
 CellLabel->
  "In[1148]:=",ExpressionUUID->"d0ee3e08-8e3f-42d8-9c98-130f3efb4cd4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationSuperoperator", "[", 
    RowBox[{
     RowBox[{"perms_", "?", "MatrixQ"}], ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}]}], "]"}], ":=", 
   RowBox[{"Apply", "[", 
    RowBox[{"Dot", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"SpinPermutationSuperoperator", "[", 
        RowBox[{"#", ",", "spinsys"}], "]"}], "&"}], "/@", "perms"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502278511035905*^9, 3.502278593232182*^9}, {
  3.502283884323756*^9, 3.502283885258939*^9}, {3.590399265138239*^9, 
  3.590399266064665*^9}, {3.590665575537706*^9, 3.590665580280376*^9}},
 CellLabel->
  "In[1149]:=",ExpressionUUID->"c293878b-79e0-48f4-97fc-a7d3ed79abd9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationSuperoperator", "[", 
    RowBox[{"perm_List", ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"validities", ",", " ", "invalspins"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"invalspins", "=", 
         RowBox[{"Pick", "[", 
          RowBox[{"perm", ",", "validities", ",", "False"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"SpinPermutationSuperoperator", "::", "invalspins"}], ",", 
          "invalspins"}], "]"}], ";", "\[IndentingNewLine]", "$Failed"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"validities", "=", 
         RowBox[{"ValidSpinQ", "/@", "perm"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"And", "@@", "validities"}]}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502278604968542*^9, 3.502278651447812*^9}, 
   3.502278692527524*^9, 3.502283886219783*^9, {3.50310486342553*^9, 
   3.503104864719036*^9}, {3.530465539028083*^9, 3.530465559467154*^9}, {
   3.590396116206925*^9, 3.590396320175807*^9}, {3.590396408832531*^9, 
   3.590396409403775*^9}, {3.590396641863819*^9, 3.590396655836434*^9}, 
   3.590396705519658*^9, {3.590399266935803*^9, 3.590399267918857*^9}, {
   3.590665601298279*^9, 3.590665604082515*^9}},
 CellLabel->
  "In[1150]:=",ExpressionUUID->"8c60716b-0c56-4737-9c54-49c084f8fc7c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationSuperoperator", "[", 
    RowBox[{"perm_List", ",", 
     RowBox[{"spinsys_", "?", "MatrixQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"pairs", ",", "Ivals", ",", " ", "mismatches"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"SpinPermutationSuperoperator", "::", "invalpair"}], ",", 
          "mismatches"}], "]"}], ";", "\[IndentingNewLine]", "$Failed"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"pairs", "=", 
         RowBox[{"Partition", "[", 
          RowBox[{"perm", ",", "2", ",", "1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Ivals", "=", 
         RowBox[{"Last", "/@", "spinsys"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"mismatches", "=", 
         RowBox[{"Select", "[", 
          RowBox[{"pairs", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Pick", "[", 
               RowBox[{"Ivals", ",", 
                RowBox[{"First", "/@", "spinsys"}], ",", 
                RowBox[{"First", "[", "#", "]"}]}], "]"}], "!=", 
              RowBox[{"Pick", "[", 
               RowBox[{"Ivals", ",", 
                RowBox[{"First", "/@", "spinsys"}], ",", 
                RowBox[{"Last", "[", "#", "]"}]}], "]"}]}], ")"}], "&"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"mismatches", "\[NotEqual]", 
         RowBox[{"{", "}"}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502278604968542*^9, 3.502278651447812*^9}, 
   3.502278692527524*^9, 3.502283886219783*^9, {3.50310486342553*^9, 
   3.503104864719036*^9}, {3.530465539028083*^9, 3.530465559467154*^9}, {
   3.590396116206925*^9, 3.590396320175807*^9}, {3.590396408832531*^9, 
   3.590396409403775*^9}, {3.590396641863819*^9, 3.590396655836434*^9}, 
   3.590396705519658*^9, {3.590396764540927*^9, 3.590396938226714*^9}, {
   3.590396970953225*^9, 3.590397179646167*^9}, {3.590399268865038*^9, 
   3.590399269879184*^9}, {3.5906656175729027`*^9, 3.590665619650593*^9}},
 CellLabel->
  "In[1151]:=",ExpressionUUID->"0ae3502b-c843-458c-b3d0-bb7ef73bc614"]
}, Closed]],

Cell[CellGroupData[{

Cell["convert to Superoperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.590574945189547*^9, 3.590574948531828*^9}, {3.5906656652731857`*^9, 
  3.5906656664867287`*^9}},ExpressionUUID->"c2818043-23f6-446d-9b6c-\
1d6f9724cc64"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationSuperoperator", "[", 
    RowBox[{"perm_List", ",", "spinsys_"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spop", ",", "zbasis", ",", "zkbopbasis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"spop", "=", 
        RowBox[{"SpinPermutationOperator", "[", 
         RowBox[{"perm", ",", "spinsys"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"zbasis", "=", 
        RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"zkbopbasis", "=", 
        RowBox[{"ZeemanKetBraOperatorBasis", "[", 
         RowBox[{"spinsys", ",", 
          RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SpinPermutationSuperoperator", "[", 
         RowBox[{"perm", ",", "spinsys"}], "]"}], "=", "\[IndentingNewLine]", 
        
        RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
           RowBox[{"KroneckerProduct", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"MatrixRepresentation", "[", 
              RowBox[{"spop", ",", "zbasis"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Conjugate", "@", 
              RowBox[{"MatrixRepresentation", "[", 
               RowBox[{"spop", ",", "zbasis"}], "]"}]}]}], 
            "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}], ",", 
          "\[IndentingNewLine]", "zkbopbasis", ",", "\[IndentingNewLine]", 
          "zbasis", ",", "\[IndentingNewLine]", 
          RowBox[{"SuperoperatorType", "\[Rule]", "\"\<Unitary\>\""}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"CheckSuperoperatorType", "\[Rule]", "False"}]}], 
         "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, {3.467301670664372*^9, 3.467301680927438*^9}, 
   3.4867109901112967`*^9, {3.502278953376333*^9, 3.5022790543074923`*^9}, {
   3.502279110072763*^9, 3.50227914240761*^9}, 3.502280602507122*^9, 
   3.5022838930614634`*^9, {3.502408693946967*^9, 3.502408698422359*^9}, {
   3.590397945525166*^9, 3.590397950896776*^9}, {3.590399289107698*^9, 
   3.590399290233266*^9}, {3.590574954593061*^9, 3.590575041460827*^9}, {
   3.590575091348982*^9, 3.590575114270739*^9}, {3.5905751455890417`*^9, 
   3.590575282808385*^9}, {3.590659645301021*^9, 3.5906596664988413`*^9}, 
   3.590665678058641*^9, {3.590665798334692*^9, 3.59066608394457*^9}, {
   3.6578211369854107`*^9, 3.65782113852774*^9}, 3.659525838037418*^9, 
   3.659534437777624*^9},
 CellLabel->
  "In[1152]:=",ExpressionUUID->"b5b81737-f4e1-4063-93d2-90313e5f12b4"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 
  3.502408751851077*^9}},ExpressionUUID->"ccd8df25-965c-49af-9dc6-\
71f8ac0d8d9f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpinPermutationSuperoperator", "::", "invalspins"}], "=", 
   "\"\<The following spin labels are invalid for the current SpinSystem: `1`\
\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590396662353932*^9, 3.5903967020013847`*^9}, 
   3.590399295990817*^9, 3.590665639118746*^9},
 CellLabel->
  "In[1153]:=",ExpressionUUID->"f327b2db-2fdd-400a-b7a3-1d247c9525c4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SpinPermutationSuperoperator", "::", "invalpair"}], "=", 
    "\"\<The following pairs of spins cannot be exchanged since they have \
different spin quantum numbers:`1`\>\""}], ";"}], " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.590397191816387*^9, 3.590397215564597*^9}, 
   3.5903992970023727`*^9, 3.590665640724883*^9},
 CellLabel->
  "In[1154]:=",ExpressionUUID->"b5cab568-8bd6-4494-ad4d-290e663724d7"]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["SuperoperatorMatrixRepresentation", "Subchapter",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"fbd1969b-f151-444a-92eb-6e7888327970"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SuperoperatorMatrixRepresentation", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"Method", "\[Rule]", "Automatic"}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4298615198898983`*^9, 3.429861520462777*^9}, {
   3.4298683208432198`*^9, 3.429868342986383*^9}, 3.4298688630552683`*^9, {
   3.4306502020849247`*^9, 3.4306502028583097`*^9}, {3.430650387075979*^9, 
   3.430650387690188*^9}, {3.431056946979576*^9, 3.431056998654784*^9}, 
   3.431057258582741*^9, {3.431057395137857*^9, 3.43105740261629*^9}, {
   3.431057503002686*^9, 3.431057504074402*^9}, {3.43105774678799*^9, 
   3.4310577543755903`*^9}, {3.431059078277666*^9, 3.431059121064754*^9}, 
   3.433525881110385*^9, {3.4352397661807632`*^9, 3.435239766738275*^9}, 
   3.435241235058351*^9, {3.467186463547188*^9, 3.467186467222204*^9}, {
   3.5861799085722218`*^9, 3.5861799087693357`*^9}},
 CellLabel->
  "In[1155]:=",ExpressionUUID->"56da68dc-a324-404f-b504-5ba391b019a3"],

Cell[CellGroupData[{

Cell["preliminaries", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
  3.621243796327162*^9, 
  3.6212437997451477`*^9}},ExpressionUUID->"1ee9751e-fdd8-47b8-a44a-\
87d865bc0800"],

Cell[CellGroupData[{

Cell["$Failed trap", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"3e986cc6-22ce-45e2-8ae7-76276bb3d5b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SuperoperatorMatrixRepresentation", "[", "args___", "]"}], "/;", 
    
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.570342549538795*^9, {3.621243820894185*^9, 3.621243847596671*^9}},
 CellLabel->
  "In[1156]:=",ExpressionUUID->"4b068cd7-8953-4b20-bafe-10763d2dca8f"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
pass basis specificiations into function, including traps for unknown \
opbasis, basis and SpinSystem\
\>", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 
  3.448360776920339*^9}},ExpressionUUID->"1f6f5cfd-dfb1-4bc5-b0b5-\
937447bcbd0a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{"superop_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{"superop", ",", 
     RowBox[{"OperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.456205555729723*^9},
 CellLabel->
  "In[1157]:=",ExpressionUUID->"4cfac6eb-f02c-4ed1-8d49-b3a5efb4cf3a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{"superop_", ",", "opbasis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{"superop", ",", "opbasis", ",", 
     RowBox[{"Basis", "[", "]"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.429846541720842*^9, 3.429846581379725*^9, 3.4561628997152233`*^9, {
   3.558597436480097*^9, 3.5585974373797407`*^9}, 3.558597490115704*^9},
 CellLabel->
  "In[1158]:=",ExpressionUUID->"235bd998-011e-4a29-b2f1-8528296cee9b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{"superop_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}],
      "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483598512286263`*^9, 
   3.448359860731179*^9}, {3.448360466346766*^9, 3.448360475974476*^9}, {
   3.448360592630582*^9, 3.448360596506363*^9}, 3.456162403153706*^9, 
   3.4562013424131327`*^9, 3.547025294893989*^9, {3.621614545128117*^9, 
   3.621614546522635*^9}},
 CellLabel->
  "In[1159]:=",ExpressionUUID->"1bb43cb9-4e1e-4f9f-8a59-517d20fef12f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
    "superop_", ",", "opbasis_", ",", "Undefined", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "default"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{"SpinSystem", "[", "]"}], "]"}], ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SuperoperatorMatrixRepresentation", "[", 
      RowBox[{"superop", ",", "opbasis", ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, 3.448360573943112*^9, {
   3.448360607428061*^9, 3.448360654701827*^9}, 3.456162403994369*^9, 
   3.547025278565407*^9},
 CellLabel->
  "In[1160]:=",ExpressionUUID->"5b669478-0d8a-45ec-a938-cee9941767e9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{"superop_", ",", "Undefined", ",", "basis_", ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "unknown"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "default"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOperatorBasis", "[", 
      RowBox[{
       RowBox[{"DefaultOperatorBasis", "[", "]"}], ",", 
       RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SuperoperatorMatrixRepresentation", "[", 
      RowBox[{"superop", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, {3.44835995227402*^9, 
   3.448359994938308*^9}, {3.4483606824647713`*^9, 3.448360738493463*^9}, 
   3.464606822382699*^9, 3.464607626668277*^9, 3.464608027722219*^9, 
   3.531844159695321*^9, 3.543498665030356*^9, 3.54702533213513*^9},
 CellLabel->
  "In[1161]:=",ExpressionUUID->"baa9e5ef-1c34-4300-a905-08bfafd6ebd8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{"superop_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}],
      "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"Equal", "[", 
      RowBox[{
       RowBox[{"SpinSystem", "[", "opbasis", "]"}], ",", 
       RowBox[{"SpinSystem", "[", "basis", "]"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "defaultopbasis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SetSpinSystem", "[", 
        RowBox[{"SpinSystem", "[", "basis", "]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"defaultopbasis", "=", 
        RowBox[{"DefaultOperatorBasis", "[", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{"OperatorBasis", "::", "default"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetOperatorBasis", "[", 
        RowBox[{"defaultopbasis", ",", 
         RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SuperoperatorMatrixRepresentation", "[", 
        RowBox[{"superop", ",", "defaultopbasis", ",", "basis", ",", "opts"}],
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, {3.44835995227402*^9, 
   3.448359994938308*^9}, {3.448361307182886*^9, 3.448361363053556*^9}, {
   3.448361419573944*^9, 3.4483614810280848`*^9}, {3.44836151594449*^9, 
   3.448361525098793*^9}, {3.448361569055385*^9, 3.448361573898075*^9}, {
   3.4483616285278997`*^9, 3.448361646636026*^9}, {3.448361938039504*^9, 
   3.448362008292676*^9}, {3.4483637955016203`*^9, 3.448363800986418*^9}, {
   3.4646068285513573`*^9, 3.464606850881089*^9}, {3.464607633965457*^9, 
   3.4646076430884323`*^9}, {3.4825705761860933`*^9, 3.482570579120623*^9}, {
   3.482571738073325*^9, 3.482571751649321*^9}, 3.5434986663374033`*^9, {
   3.6405135445218067`*^9, 3.640513553793993*^9}, 3.6405239958729353`*^9},
 CellLabel->
  "In[1162]:=",ExpressionUUID->"c8f2413d-a38e-495b-9466-28692d757f84"]
}, Closed]],

Cell[CellGroupData[{

Cell["handle a single number", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.531929730192232*^9, 3.5319297359413137`*^9}, 
   3.531930027378767*^9, {3.5320070316467867`*^9, 
   3.532007035881529*^9}},ExpressionUUID->"ac19a7a2-dd58-48d5-a337-\
a7a61002f96b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"num_", "?", "NumericQ"}], ",", "more___"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", "num", "]"}], "\[Equal]", "0"}], ")"}]}], ":=", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"NullSuperoperator", "[", "]"}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929684468029*^9, 3.531929722331521*^9}, {
  3.531930036870233*^9, 3.531930061317379*^9}, {3.5319303206047087`*^9, 
  3.5319303229174423`*^9}, {3.532006991999352*^9, 3.532007019860983*^9}, {
  3.532007133030086*^9, 3.532007156145802*^9}, {3.543944870575366*^9, 
  3.543944879992445*^9}},
 CellLabel->
  "In[1163]:=",ExpressionUUID->"d08b1e1a-13fc-41df-9d0a-883f7621f974"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"num_", "?", "NumericQ"}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"num", "\[Times]", 
      RowBox[{"UnitySuperoperator", "[", "]"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.468757863806199*^9, 3.46875788919879*^9}, {
  3.486710743814829*^9, 3.486710744160817*^9}, {3.5319307180361977`*^9, 
  3.531930738813519*^9}},
 CellLabel->
  "In[1164]:=",ExpressionUUID->"a8f4be18-e100-446e-b1be-2783c9ff3a57"]
}, Closed]],

Cell[CellGroupData[{

Cell["fix or trap inappropriate arguments", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408712547282*^9}, {
   3.531829420950123*^9, 3.531829450449891*^9}, {3.531832441649868*^9, 
   3.5318324474638643`*^9}, 3.531927421705441*^9, {3.531929663888846*^9, 
   3.531929673053503*^9}, {3.5319297444260406`*^9, 3.531929753780078*^9}, {
   3.531929909532097*^9, 3.531929915726618*^9}, {3.6267782290119667`*^9, 
   3.6267782413631763`*^9}, 
   3.626778309724236*^9},ExpressionUUID->"a994dd45-edd4-4a61-b957-\
62912319d9f4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"sop", ":", 
       RowBox[{"Except", "[", 
        RowBox[{"_", "?", "SuperoperatorQ"}], "]"}]}], ",", "more___"}], 
     "]"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "fixedsop", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"SuperoperatorMatrixRepresentation", "[", 
        RowBox[{"fixedsop", ",", "more"}], "]"}], "\[IndentingNewLine]", 
       ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"fixedsop", "=", 
         RowBox[{"Chop", "[", "sop", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"fixedsop", ",", 
          RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.626777618316545*^9, 3.626777675617124*^9}, {
  3.626778100502324*^9, 3.626778188299364*^9}},
 CellLabel->
  "In[1165]:=",ExpressionUUID->"93aed6be-d571-4796-a2c5-ea7374719f9a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{"sop_", ",", "more___"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Message", "[", 
       RowBox[{"SuperoperatorMatrixRepresentation", "::", "badsop"}], "]"}], 
      ";", "$Failed"}], ")"}], "/;", 
    RowBox[{"(", 
     RowBox[{"!", 
      RowBox[{"SuperoperatorQ", "[", "sop", "]"}]}], ")"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.531929684468029*^9, 3.531929722331521*^9}, {
   3.531929756418811*^9, 3.531929789325817*^9}, {3.5319298388168793`*^9, 
   3.5319298734439783`*^9}, {3.531930063726522*^9, 3.5319300867107153`*^9}, {
   3.53193033230785*^9, 3.531930374757971*^9}, {3.531930522471366*^9, 
   3.5319305447228947`*^9}, 3.5319307639445972`*^9},
 CellLabel->
  "In[1166]:=",ExpressionUUID->"ef4b4d39-9dc6-41fe-b0ce-4436550f88ee"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["sums, numerical factors, adjoints and exponentials", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435138443344489*^9, 3.435138455176607*^9}, {
  3.435138565931657*^9, 3.4351385693764677`*^9}, {3.4394288285217752`*^9, 
  3.439428830117169*^9}, {3.439430729574646*^9, 3.439430744819829*^9}, {
  3.4394307789742527`*^9, 
  3.439430797443653*^9}},ExpressionUUID->"676be8e1-ddbe-4246-af97-\
a09501bb98e9"],

Cell[CellGroupData[{

Cell["handling of sums", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"944b1792-9fb9-45ee-a362-532b658f0580"],

Cell["\<\
this needs special treatment if one operator matrix representation has the \
form of an interpolating function\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.621161068215061*^9, 
  3.6211610994125967`*^9}},ExpressionUUID->"648633f0-18f1-4a20-b298-\
5e6043bf8000"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Plus", "[", "sops___", "]"}], ",", "opbasis_", ",", "basis_", 
     ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
  RowBox[{"CombineSuperoperatorMatrixRepresentations", "@@", 
   RowBox[{"Map", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"SuperoperatorMatrixRepresentation", "[", 
       RowBox[{"#", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}], "&"}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"{", "sops", "}"}]}], "\[IndentingNewLine]", "]"}]}]}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483499662006483`*^9, 3.448349970809721*^9}, {
  3.4572685262420197`*^9, 3.4572685650473013`*^9}, {3.457268843857106*^9, 
  3.457268857081623*^9}, {3.4572692645093117`*^9, 3.457269266358811*^9}, {
  3.4572718454125977`*^9, 3.457271874679812*^9}, {3.621243939086936*^9, 
  3.621243958290017*^9}},
 CellLabel->
  "In[1167]:=",ExpressionUUID->"df4adc3a-d1ee-461e-ae34-e83c58bc141d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineSuperoperatorMatrixRepresentations", "[", "mat1_", "]"}], ":=",
    "mat1"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621161175119286*^9, 3.621161188517819*^9}, 
   3.621161223648713*^9, 3.621161489113659*^9, 3.62124397118468*^9},
 CellLabel->
  "In[1168]:=",ExpressionUUID->"b9fff92c-626f-4a28-9050-bc507b978107"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineSuperoperatorMatrixRepresentations", "[", 
    RowBox[{"mat1_", ",", "mat2_", ",", "more__"}], "]"}], ":=", 
   RowBox[{"CombineSuperoperatorMatrixRepresentations", "[", 
    RowBox[{
     RowBox[{"CombineSuperoperatorMatrixRepresentations", "[", 
      RowBox[{"mat1", ",", "mat2"}], "]"}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6211611347295723`*^9, 3.621161170179515*^9}, {
  3.621161224926882*^9, 3.6211612271470947`*^9}, {3.621161490756505*^9, 
  3.62116149280414*^9}, {3.621243972590827*^9, 3.621243975639901*^9}},
 CellLabel->
  "In[1169]:=",ExpressionUUID->"91a4a281-eef7-40da-8421-dc06a45e3aac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineSuperoperatorMatrixRepresentations", "[", 
    RowBox[{
     RowBox[{"mat1_", "?", "MatrixQ"}], ",", 
     RowBox[{"mat2_", "?", "MatrixQ"}]}], "]"}], ":=", 
   RowBox[{"mat1", "+", "mat2"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621161196364728*^9, 3.621161228834638*^9}, 
   3.621161494289155*^9, 3.62116192105905*^9, 3.621243978216229*^9},
 CellLabel->
  "In[1170]:=",ExpressionUUID->"3f9a74b6-5f17-474d-9f99-24ba6c431259"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineSuperoperatorMatrixRepresentations", "[", 
    RowBox[{
     RowBox[{"mat_", "?", "MatrixQ"}], ",", 
     RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}]}], "]"}], ":=", 
   RowBox[{"CombineSuperoperatorMatrixRepresentations", "[", 
    RowBox[{"ifunc", ",", "mat"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.621161231681098*^9, {3.62116126441649*^9, 3.621161284094994*^9}, {
   3.621161495425529*^9, 3.621161496584322*^9}, {3.621243981737884*^9, 
   3.621243983631288*^9}},
 CellLabel->
  "In[1171]:=",ExpressionUUID->"483497a5-a4ca-4b49-a8f3-141383f2e892"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CombineSuperoperatorMatrixRepresentations", "[", 
     RowBox[{
      RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
      RowBox[{"mat_", "?", "MatrixQ"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{"ifunc", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"m_", "?", "MatrixQ"}], "\[RuleDelayed]", 
        RowBox[{"m", "+", "mat"}]}], "}"}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.621161231681098*^9, {3.62116126441649*^9, 3.6211613681913443`*^9}, 
   3.621161498395927*^9, {3.6211624660165167`*^9, 3.6211624669937067`*^9}, 
   3.621243989819203*^9},
 CellLabel->
  "In[1172]:=",ExpressionUUID->"3c92b8cd-f4db-450b-89b8-6e68d40f8b76"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CombineSuperoperatorMatrixRepresentations", "[", 
     RowBox[{
      RowBox[{"ifunc1_InterpolatingFunction", "[", "t_", "]"}], ",", 
      "ifunc2_InterpolatingFunction"}], "]"}], "/;", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc1", "]"}], "\[GreaterEqual]", "3"}], ")"}],
      "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc1", "[", 
        RowBox[{"ifunc1", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}], "&&", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc2", "]"}], "\[GreaterEqual]", "3"}], ")"}],
      "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc2", "[", 
        RowBox[{"ifunc2", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "interptimes", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"interptimes", "=", 
        RowBox[{"Sort", "@", 
         RowBox[{"Union", "[", 
          RowBox[{
           RowBox[{"ifunc1", "\[LeftDoubleBracket]", 
            RowBox[{"3", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
           RowBox[{"ifunc1", "\[LeftDoubleBracket]", 
            RowBox[{"3", ",", "2"}], "\[RightDoubleBracket]"}]}], "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"ifunc1", "[", "#", "]"}], "+", 
            RowBox[{"ifunc2", "[", "#", "]"}]}], ")"}], "&"}], "/@", 
         "interptimes"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.621161231681098*^9, {3.62116126441649*^9, 3.62116145577761*^9}, 
   3.621161500668488*^9, {3.62116160430916*^9, 3.621161722810411*^9}, 
   3.621244000796517*^9},
 CellLabel->
  "In[1173]:=",ExpressionUUID->"2963e830-bbbe-4b41-bca0-05d308212247"]
}, Closed]],

Cell[CellGroupData[{

Cell["handling of numerical factors", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"ab652455-655d-4f3a-a368-4c4185c3a407"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Times", "[", 
      RowBox[{
       RowBox[{"num", ":", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{"_", "?", "SuperoperatorQ"}], "]"}], ".."}]}], ",", 
       RowBox[{"sop_", "?", "SuperoperatorQ"}]}], "]"}], ",", "opbasis_", ",",
      "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"num", "*", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{"sop", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}]}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310952968056602`*^9, 3.4310952983526373`*^9}, {
  3.448348974787569*^9, 3.448348982064094*^9}, {3.448349443761387*^9, 
  3.448349491481229*^9}},
 CellLabel->
  "In[1174]:=",ExpressionUUID->"bd6ebaa3-438c-4a6a-80c9-f7b1640bfa50"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Times", "[", 
      RowBox[{
       RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
       RowBox[{"num", ":", 
        RowBox[{
         RowBox[{"Except", "[", 
          RowBox[{"_", "?", "SuperoperatorQ"}], "]"}], ".."}]}]}], "]"}], ",",
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"num", "*", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{"sop", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}]}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310952968056602`*^9, 3.4310952983526373`*^9}, {
  3.448348974787569*^9, 3.448348982064094*^9}, {3.448349443761387*^9, 
  3.448349508578137*^9}},
 CellLabel->
  "In[1175]:=",ExpressionUUID->"f8d3bdc3-bc71-4c9d-acde-3b58f727cb83"]
}, Closed]],

Cell[CellGroupData[{

Cell["handling of numbers or undefined symbols", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.590660757363489*^9, 
  3.590660761344716*^9}},ExpressionUUID->"fc6f81ee-6b83-4f88-9f2c-\
32a9b57df1c3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"num", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
       RowBox[{"(", "_Symbol", ")"}], "|", 
       RowBox[{"HoldPattern", "@", 
        RowBox[{"Times", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], "|", "_Symbol"}], ")"}], ".."}], 
         "]"}]}]}]}], ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
    "]"}]}], ":=", "\[IndentingNewLine]", 
  RowBox[{"num", "*", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"UnitySuperoperator", "[", "]"}], ",", "opbasis", ",", "basis", 
     ",", "opts"}], "]"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4306244102313747`*^9, 3.430624410598246*^9}, 
   3.43062573684107*^9, {3.448292314130822*^9, 3.448292315616091*^9}, {
   3.448308265798131*^9, 3.448308274998784*^9}, {3.448348733671179*^9, 
   3.448348734623678*^9}, 3.486464357877039*^9, 3.570342515869124*^9, {
   3.62118887747099*^9, 3.621188884278967*^9}, {3.62124407155415*^9, 
   3.621244099912449*^9}, 3.69150120275772*^9},
 CellLabel->
  "In[1176]:=",ExpressionUUID->"6dabd861-9d8d-430e-b820-0193135ec8ab"]
}, Closed]],

Cell[CellGroupData[{

Cell["Adjoints", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"ee78f19d-4525-474c-96ee-c342a7b5d96d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"Adjoint", "[", "sop_", "]"}], ",", "opbasis_", ",", "basis_", 
     ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Adjoint", "@", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{"sop", ",", "opbasis", ",", "basis", ",", "opts"}], 
    "]"}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.570342512821164*^9, {3.6212441156312323`*^9, 3.6212441363191977`*^9}, {
   3.657821145912737*^9, 3.657821147294979*^9}, 3.659525840766275*^9, 
   3.659534558095983*^9},
 CellLabel->
  "In[1177]:=",ExpressionUUID->"eb82f0f9-cb0b-43e4-8493-1d88f9ae2c69"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exponentials", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->
  True,ExpressionUUID->"f362373a-6d45-4d84-86f5-0d4cd2438e22"],

Cell["\<\
take products of matrix reps if the exponential is sandwiched between other \
superoperators\
\>", "Text",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.621244153679573*^9, 
  3.6212441548146143`*^9}},ExpressionUUID->"fee198ed-e3b7-45d9-8d6c-\
7fa64bd9f6d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{"sop1__", ",", 
        RowBox[{
         RowBox[{"Exp", "[", "sop_", "]"}], "|", 
         RowBox[{"Power", "[", 
          RowBox[{"E", ",", "sop_"}], "]"}]}], ",", "sop2___"}], "]"}], ",", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", "sop1", "]"}], ",", "opbasis", ",", "basis", ",", 
      "opts"}], "]"}], ".", "\[IndentingNewLine]", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{
        RowBox[{"Exp", "[", "sop", "]"}], ",", "sop2"}], "]"}], ",", 
      "opbasis", ",", "basis", ",", "opts"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309348659200373`*^9, 3.4309348916732283`*^9}, 
   3.5703425094464283`*^9, {3.5892630963648033`*^9, 3.589263106744664*^9}, {
   3.6212441647544003`*^9, 3.62124423277182*^9}},
 CellLabel->
  "In[1178]:=",ExpressionUUID->"cfdf9043-24a4-4fb9-a605-983c70a732b2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"MatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{"sop1___", ",", 
        RowBox[{
         RowBox[{"Exp", "[", "sop_", "]"}], "|", 
         RowBox[{"Power", "[", 
          RowBox[{"E", ",", "sop_"}], "]"}]}], ",", "sop2__"}], "]"}], ",", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{"sop1", ",", 
        RowBox[{"Exp", "[", "sop", "]"}]}], "]"}], ",", "opbasis", ",", 
      "basis", ",", "opts"}], "]"}], ".", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", "sop2", "]"}], ",", "opbasis", ",", "basis", ",", 
      "opts"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309348659200373`*^9, 3.430934930172267*^9}, 
   3.570342507532776*^9, 3.589263115699554*^9, {3.621244252326376*^9, 
   3.621244342128562*^9}},
 CellLabel->
  "In[1179]:=",ExpressionUUID->"1529e4b9-3891-43b6-819e-3618b10f7e5a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HoldPattern", "@", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{"op_", "?", "OperatorQ"}], "]"}], "|", 
      RowBox[{"Power", "[", 
       RowBox[{"E", ",", 
        RowBox[{"sop_", "?", "SuperoperatorQ"}]}], "]"}]}], ",", "opbasis_", 
     ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"SparseArray", "@", 
   RowBox[{"MatrixExp", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{"sop", ",", "opbasis", ",", "basis", ",", "opts"}], 
     "]"}]}]}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309336300783*^9, 3.430933651985939*^9}, {
   3.431074888691966*^9, 3.431074891671363*^9}, {3.43516155451896*^9, 
   3.435161557777286*^9}, 3.448292333047392*^9, 3.5703425060449*^9, 
   3.589263118698123*^9, {3.6211605746182833`*^9, 3.62116058433862*^9}, {
   3.621244348050844*^9, 3.621244382955379*^9}},
 CellLabel->
  "In[1180]:=",ExpressionUUID->"e972478c-bf54-42f7-ba65-fe7b73171159"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["SuperoperatorMatrixRepresentation of Superoperator", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.502408711532877*^9, 3.502408743127264*^9}, {
  3.531834281301166*^9, 3.531834283424567*^9}, {3.5319285806548853`*^9, 
  3.5319285862420683`*^9}},ExpressionUUID->"227bfd89-bdf5-415a-8f7c-\
02816c51892f"],

Cell[CellGroupData[{

Cell["\<\
if the SuperoperatorMatrixRepresentation has not been implemented yet inside \
Superoperator, then do so now\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.53184316213827*^9, 3.531843170966979*^9}, {
  3.531928591322496*^9, 3.531928592457162*^9}, {3.531928632206263*^9, 
  3.531928638798332*^9}, {3.585661838463643*^9, 3.5856618621810427`*^9}, {
  3.585661975445121*^9, 
  3.585661983704999*^9}},ExpressionUUID->"66e6ea1d-68ae-48f8-abd2-\
eac8e2be260c"],

Cell["\<\
This happens when the argument of Superoperator is a \
CommutationSuperoperator, which holds the superoperator matrix evaluation\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.586089796399448*^9, 
  3.586089821099036*^9}},ExpressionUUID->"feb43004-bcc1-4ba7-952a-\
a39987452b95"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Superoperator", "/:", 
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Superoperator", "[", 
       RowBox[{
        RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", "args___"}], "]"}], ",",
       "\[IndentingNewLine]", "opbasis_", ",", "basis_", ",", "opts___Rule"}],
      "]"}]}], ":=", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{"sop", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, {3.504109982163231*^9, 3.504110017796074*^9}, {
   3.531834408986793*^9, 3.531834427835287*^9}, {3.531928602514484*^9, 
   3.531928673520411*^9}, {3.5856618702339783`*^9, 3.585661966406665*^9}, {
   3.585662071855785*^9, 3.5856620906898813`*^9}, 3.727524760204591*^9, {
   3.7275307283118944`*^9, 3.727530751452113*^9}},
 CellLabel->
  "In[1181]:=",ExpressionUUID->"dc6d3285-e613-4faf-8eb3-6c56ba8a7941"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The operator bases are the same, and Superoperator contains matrix or \
diagonalized form of matrix\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.53184316213827*^9, 3.531843170966979*^9}, {
  3.531928591322496*^9, 3.531928592457162*^9}, {3.531928632206263*^9, 
  3.531928638798332*^9}, {3.586090216943356*^9, 3.586090218811584*^9}, {
  3.621532883475977*^9, 
  3.6215328986647387`*^9}},ExpressionUUID->"70aaf8fd-09db-432e-92e9-\
0cbca8f3c22f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Superoperator", "[", 
       RowBox[{
        RowBox[{"mat_", "?", "MatrixQ"}], ",", "opbasis_", ",", "_", ",", 
        "___Rule"}], "]"}], ",", "\[IndentingNewLine]", "opbasis_", ",", "_", 
      ",", "opts___Rule"}], "]"}]}], ":=", "mat"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, {3.504109982163231*^9, 3.504110017796074*^9}, {
   3.531834408986793*^9, 3.531834427835287*^9}, {3.531928602514484*^9, 
   3.531928673520411*^9}, {3.621532946029378*^9, 3.621532956423749*^9}},
 CellLabel->
  "In[1182]:=",ExpressionUUID->"0925d463-39bc-4a96-8446-75d5b15aaa8c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Superoperator", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"X_", "?", "MatrixQ"}], ",", "evals_List", ",", 
          RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], ",", "opbasis_", ",", 
        "_", ",", "___Rule"}], "]"}], ",", "opbasis_", ",", "_", ",", 
      "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Chop", "[", 
    RowBox[{"X", ".", 
     RowBox[{"SparseArray", "[", 
      RowBox[{"DiagonalMatrix", "[", "evals", "]"}], "]"}], ".", "Xinv"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.586080347016385*^9, 3.586080380785246*^9}, {
  3.586081224280334*^9, 3.586081237044495*^9}, {3.5860821270456133`*^9, 
  3.586082130882392*^9}, {3.58608984460982*^9, 3.586089890612247*^9}, {
  3.6215329501959543`*^9, 3.62153296348111*^9}},
 CellLabel->
  "In[1183]:=",ExpressionUUID->"67a9bd39-d60a-4d06-aadf-7247be705073"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
The operator bases are the same, and Superoperator contains a valid \
Interpolation function\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6215085961902237`*^9, 3.621508633525794*^9}, {
  3.621508951564271*^9, 3.621508960765566*^9}, {3.62150969345966*^9, 
  3.6215096997678137`*^9}, {3.621509893236871*^9, 3.621509897899819*^9}, {
  3.621532936078466*^9, 
  3.621532937624155*^9}},ExpressionUUID->"89516a1e-704e-4f5c-9371-\
857a083c488a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"SuperoperatorMatrixRepresentation", "[", 
      RowBox[{
       RowBox[{"Superoperator", "[", 
        RowBox[{
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         "opbasis_", ",", "basis_", ",", "___Rule"}], "]"}], ",", "opbasis_", 
       ",", "_", ",", "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}],
       "&&", "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"ifunc", "[", 
         RowBox[{"ifunc", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}],
         ",", 
        RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}], ")"}]}], ":=", 
   RowBox[{"ifunc", "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.621391289570209*^9}, {
   3.6213915067223797`*^9, 3.621391516472814*^9}, {3.6215070854826717`*^9, 
   3.621507146354694*^9}, {3.621508110872829*^9, 3.62150818088811*^9}, 
   3.62150821304814*^9, {3.6215083052768173`*^9, 3.621508327201395*^9}, {
   3.621532968965495*^9, 3.621532994742834*^9}},
 CellLabel->
  "In[1184]:=",ExpressionUUID->"a8405792-93a0-484c-868f-c4a199d287a3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"SuperoperatorMatrixRepresentation", "[", 
      RowBox[{
       RowBox[{"Superoperator", "[", 
        RowBox[{
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         "opbasis_", ",", "basis_", ",", "___Rule"}], "]"}], ",", "opbasis_", 
       ",", "_", ",", "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}],
       "&&", "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"ifunc", "[", 
         RowBox[{"ifunc", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}],
         ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
          RowBox[{"_", "?", "MatrixQ"}]}], "}"}]}], "]"}]}], ")"}]}], ":=", 
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{"ifunc", ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "D_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], "\[RuleDelayed]", 
       RowBox[{"X", ".", 
        RowBox[{"DiagonalMatrix", "[", "D", "]"}], ".", "Xinv"}]}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.621391289570209*^9}, {
   3.6213915067223797`*^9, 3.621391516472814*^9}, {3.6215070854826717`*^9, 
   3.621507146354694*^9}, {3.621508110872829*^9, 3.62150818088811*^9}, 
   3.62150821304814*^9, {3.621508308187889*^9, 3.6215083852569523`*^9}, {
   3.621533010343812*^9, 3.621533024345908*^9}},
 CellLabel->
  "In[1185]:=",ExpressionUUID->"76af8e9c-c084-4c29-bce9-ee6b8aa52945"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"SuperoperatorMatrixRepresentation", "[", 
      RowBox[{
       RowBox[{"Superoperator", "[", 
        RowBox[{
         RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
         "opbasis_", ",", "basis_", ",", "___Rule"}], "]"}], ",", "opbasis_", 
       ",", "_", ",", "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}],
       "&&", "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"ifunc", "[", 
         RowBox[{"ifunc", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}],
         ",", 
        RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}]}], ")"}]}], ":=", 
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{"ifunc", ",", 
      RowBox[{
       RowBox[{"sop_", "?", "SuperoperatorQ"}], "\[RuleDelayed]", 
       RowBox[{"SuperoperatorMatrixRepresentation", "[", 
        RowBox[{"sop", ",", "opbasis", ",", "basis"}], "]"}]}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621157583544298*^9, 3.621157675274611*^9}, {
   3.621157718231492*^9, 3.62115775866434*^9}, {3.621158201032271*^9, 
   3.621158271265594*^9}, 3.621158332604507*^9, {3.621158749610236*^9, 
   3.621158777940007*^9}, {3.621158911123063*^9, 3.6211589305979357`*^9}, {
   3.621158966004695*^9, 3.621159069038142*^9}, {3.621162478102311*^9, 
   3.621162478975792*^9}, {3.621391269677649*^9, 3.621391289570209*^9}, {
   3.6213915067223797`*^9, 3.621391516472814*^9}, {3.6215070854826717`*^9, 
   3.621507146354694*^9}, {3.621508110872829*^9, 3.62150818088811*^9}, 
   3.62150821304814*^9, {3.621508308187889*^9, 3.6215083852569523`*^9}, {
   3.62150971047964*^9, 3.621509732630121*^9}, {3.6215330401002274`*^9, 
   3.621533076993732*^9}},
 CellLabel->
  "In[1186]:=",ExpressionUUID->"e940206a-9e15-4700-8585-eb9e3ecb7fda"]
}, Closed]],

Cell[CellGroupData[{

Cell["Different bases", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.53184316213827*^9, 3.531843194031289*^9}, {
  3.621508979183887*^9, 3.621508986475823*^9}, {3.6215097838063307`*^9, 
  3.6215097886571198`*^9}},ExpressionUUID->"138da2ac-341f-493a-b2fd-\
cc27598cc70d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Superoperator", "[", 
       RowBox[{
       "specs_", ",", "opbasis1_", ",", "basis1_", ",", "opts1__Rule"}], 
       "]"}], ",", "opbasis2_", ",", "basis2_", ",", "opts2___Rule"}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Equal", "[", 
      RowBox[{
       RowBox[{"SpinSystem", "[", "opbasis1", "]"}], ",", 
       RowBox[{"SpinSystem", "[", "opbasis2", "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
     "MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"OperatorBasisTransformationMatrix", "[", 
        RowBox[{"opbasis2", ",", "opbasis1"}], "]"}], ",", 
       RowBox[{"SuperoperatorMatrixRepresentation", "[", 
        RowBox[{
         RowBox[{"Superoperator", "[", 
          RowBox[{"specs", ",", "opbasis1", ",", "basis1", ",", "opts1"}], 
          "]"}], ",", "\[IndentingNewLine]", "opbasis1", ",", "basis2", ",", 
         "opts2"}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"OperatorBasisTransformationMatrix", "[", 
        RowBox[{"opbasis1", ",", "opbasis2"}], "]"}]}], "\[IndentingNewLine]",
       "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"Superoperator", "::", "incompatspinsys"}], "]"}], ";", 
       "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435130338250345*^9, 3.435130448277132*^9}, 
   3.435130513264825*^9, 3.4351305548176403`*^9, {3.435132617852536*^9, 
   3.4351327583537893`*^9}, 3.435134097577117*^9, {3.4351341551849546`*^9, 
   3.4351341676182623`*^9}, {3.435134223892734*^9, 3.43513423*^9}, 
   3.435138763490032*^9, 3.486464371269148*^9, {3.486464701657126*^9, 
   3.486464715839643*^9}, {3.504109982163231*^9, 3.504110055828319*^9}, 
   3.504111124170664*^9, {3.5318344228690863`*^9, 3.531834430734833*^9}, {
   3.531842698422821*^9, 3.53184273404837*^9}, {3.586082170721868*^9, 
   3.586082174638335*^9}, 3.586085270228579*^9, {3.586089361231307*^9, 
   3.586089435303177*^9}, {3.621099391065466*^9, 3.6210994051441097`*^9}, {
   3.621509381872937*^9, 3.621509387606966*^9}, {3.621509444939704*^9, 
   3.6215094463175097`*^9}, {3.621509519580372*^9, 3.621509534481842*^9}, {
   3.6215095926468287`*^9, 3.621509611031708*^9}, {3.6215097688000927`*^9, 
   3.621509822151291*^9}, {3.621533115791382*^9, 3.62153332967288*^9}, 
   3.621533434073185*^9, 3.621534033881803*^9, 3.640523996812063*^9},
 CellLabel->
  "In[1187]:=",ExpressionUUID->"ac75015f-7203-4cb3-b2b1-e08a5a44caf3"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["UnitySuperoperator[] and NullSuperoperator[]", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239507168541*^9, 3.435239510988324*^9}, 
   3.4526676754453373`*^9, {3.4526689068670673`*^9, 3.452668916563645*^9}, {
   3.467302742193129*^9, 3.467302747095245*^9}, {3.502606058488901*^9, 
   3.5026060606458406`*^9}},ExpressionUUID->"cb03b319-1fe0-4090-b51e-\
1bb3b2b3aac6"],

Cell[CellGroupData[{

Cell["UnitySuperoperator", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239507168541*^9, 3.435239510988324*^9}, 
   3.4526676754453373`*^9, {3.4526689068670673`*^9, 3.452668916563645*^9}, 
   3.4673027507461233`*^9},ExpressionUUID->"6e5797ad-061b-47e9-8be6-\
d912bb5bbc66"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"sop", ":", 
      RowBox[{"UnitySuperoperator", "[", "]"}]}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SparseArray", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", "i"}], "}"}], "\[Rule]", "1"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"OperatorBasisDimension", "[", "opbasis", "]"}]}], "}"}]}], 
     "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435240920497623*^9}, {3.435241098673073*^9, 3.435241134326395*^9}, {
   3.435241491679801*^9, 3.435241512547866*^9}, {3.435242322165255*^9, 
   3.4352423248047323`*^9}, {3.435250726932569*^9, 3.435250729367881*^9}, {
   3.435251391007934*^9, 3.435251392468975*^9}, {3.452667690265827*^9, 
   3.452667778634954*^9}, {3.4526687975002527`*^9, 3.4526688894085627`*^9}, {
   3.467188979684203*^9, 3.467189002161561*^9}, {3.486710752816547*^9, 
   3.486710753170527*^9}, 3.5861799256465797`*^9},
 CellLabel->
  "In[1188]:=",ExpressionUUID->"11ed9ea7-253b-4372-bdf4-af3ba9eccc20"]
}, Closed]],

Cell[CellGroupData[{

Cell["NullSuperoperator", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239507168541*^9, 3.435239510988324*^9}, 
   3.4526676754453373`*^9, {3.4526689068670673`*^9, 3.452668916563645*^9}, {
   3.467302757560047*^9, 3.467302758271867*^9}, 
   3.621244769899613*^9},ExpressionUUID->"b8d373f6-59b5-4d5a-89d1-\
86c298ee3a25"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"sop", ":", 
      RowBox[{"NullSuperoperator", "[", "]"}]}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SparseArray", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"i", ",", "i"}], "}"}], "\[Rule]", "0"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"OperatorBasisDimension", "[", "opbasis", "]"}]}], "}"}]}], 
     "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435240920497623*^9}, {3.435241098673073*^9, 3.435241134326395*^9}, {
   3.435241491679801*^9, 3.435241512547866*^9}, {3.435242322165255*^9, 
   3.4352423248047323`*^9}, {3.435250726932569*^9, 3.435250729367881*^9}, {
   3.435251391007934*^9, 3.435251392468975*^9}, {3.452667690265827*^9, 
   3.452667778634954*^9}, {3.4526687975002527`*^9, 3.4526688894085627`*^9}, {
   3.467188979684203*^9, 3.467189002161561*^9}, {3.467302763159485*^9, 
   3.46730279070651*^9}, 3.4867108877737427`*^9},
 CellLabel->
  "In[1189]:=",ExpressionUUID->"64b6e3f9-89db-49e6-915c-9cb550e0a9e5"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["calculations using Method\[Rule] Automatic", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239507168541*^9, 
   3.435239510988324*^9}},ExpressionUUID->"232805c1-c8f6-4373-86cb-\
eea849fbf51f"],

Cell[CellGroupData[{

Cell["calculate using ZeemanBasis[], if Method\[Rule]Automatic.", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456369810807*^9, 3.430456391358386*^9}, 
   3.430456556431728*^9, {3.4305643986149607`*^9, 3.430564400498064*^9}, {
   3.430566885906928*^9, 3.430566886703034*^9}, {3.431058412294199*^9, 
   3.431058420738549*^9}, {3.431058915224729*^9, 3.4310589171922903`*^9}, {
   3.431058950550519*^9, 3.431058955459968*^9}, {3.4352395444378967`*^9, 
   3.4352395512201853`*^9}, {3.4352396084061203`*^9, 
   3.4352396468492527`*^9}, {3.435239945449224*^9, 3.43523994881136*^9}, {
   3.435240497650125*^9, 3.435240501008383*^9}, {3.435240629421344*^9, 
   3.435240634129475*^9}, {3.435240689801029*^9, 3.435240693456541*^9}, 
   3.4545754249043207`*^9, 3.546529515383436*^9, {3.558597518917222*^9, 
   3.558597520488648*^9}, {3.5585976803339043`*^9, 
   3.558597704066495*^9}},ExpressionUUID->"058e6f70-4c69-4d12-8e10-\
0638ef3f914e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SuperoperatorMatrixRepresentation", "[", 
   RowBox[{"sop_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
   "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "spinsys", "}"}], ",", 
    RowBox[{
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{"SuperoperatorMatrixRepresentation", "[", 
       RowBox[{"sop", ",", "opbasis", ",", 
        RowBox[{"ZeemanBasis", "[", "spinsys", "]"}], ",", 
        RowBox[{"Method", "\[Rule]", "Automatic"}], ",", "opts"}], "]"}], 
      "\[IndentingNewLine]", ")"}], "/;", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"spinsys", "=", 
        RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Method", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{
           "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",", 
          "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"basis", ",", 
           RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "]"}]}]}]}], 
      "\[IndentingNewLine]", ")"}]}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.558597725221084*^9, 3.55859776670328*^9}},
 CellLabel->
  "In[1190]:=",ExpressionUUID->"fe4eb0db-3479-413f-9fdf-59cca8add908"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
calculation in a general operator basis, using a transformation to the \
ZeemanKetBraOperatorBasis[Sorted \[Rule] \[OpenCurlyDoubleQuote]Canonical\
\[CloseCurlyDoubleQuote]] operator basis\
\>", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456369810807*^9, 3.430456391358386*^9}, 
   3.430456556431728*^9, {3.4305643986149607`*^9, 3.430564400498064*^9}, {
   3.430566885906928*^9, 3.430566886703034*^9}, {3.431058412294199*^9, 
   3.431058420738549*^9}, {3.431058915224729*^9, 3.4310589171922903`*^9}, {
   3.431058950550519*^9, 3.431058955459968*^9}, {3.4352395444378967`*^9, 
   3.4352395512201853`*^9}, {3.4352396084061203`*^9, 
   3.4352396468492527`*^9}, {3.435239945449224*^9, 3.43523994881136*^9}, {
   3.435240497650125*^9, 3.435240501008383*^9}, {3.435240629421344*^9, 
   3.435240634129475*^9}, {3.435240689801029*^9, 3.435240693456541*^9}, 
   3.4545754249043207`*^9, 3.546529515383436*^9, {3.558597518917222*^9, 
   3.558597520488648*^9}},ExpressionUUID->"0d5941ee-cdd5-44c0-8b10-\
6dffd4817781"],

Cell["\<\
the routine MultiplyMatricesAndMatrixInterpolationFunctions ensures that \
interpolation functions are handled correctly\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.621159101752492*^9, 3.6211591061620617`*^9}, {
   3.621244632956635*^9, 3.6212446334619513`*^9}, {3.62125213092819*^9, 
   3.621252148072081*^9}, 
   3.621534006434849*^9},ExpressionUUID->"7977409d-c48a-4700-9cab-\
ee4b51f2cc9b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{"sop_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"iopbasis", ",", "spinsys"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"iopbasis", "=", 
         RowBox[{"ZeemanKetBraOperatorBasis", "[", 
          RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
        "MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"OperatorBasisTransformationMatrix", "[", 
           RowBox[{"opbasis", ",", "iopbasis", ",", "basis"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"SuperoperatorMatrixRepresentation", "[", 
           RowBox[{"sop", ",", "iopbasis", ",", "basis", ",", 
            RowBox[{"Method", "\[Rule]", "Automatic"}], ",", "opts"}], "]"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"OperatorBasisTransformationMatrix", "[", 
           RowBox[{"iopbasis", ",", "opbasis", ",", "basis"}], "]"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"opbasis", ",", 
            RowBox[{"ZeemanKetBraOperatorBasis", "[", 
             RowBox[{"spinsys", ",", 
              RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}]}], 
           "]"}]}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456036023714*^9, 3.43045611027256*^9}, {
   3.4305650750552273`*^9, 3.430565077965583*^9}, {3.430566896470188*^9, 
   3.430566899378647*^9}, {3.43105843999332*^9, 3.431058461190651*^9}, {
   3.431058502991736*^9, 3.4310585825002747`*^9}, 3.431058612835156*^9, {
   3.4310586453634768`*^9, 3.431058744314518*^9}, {3.431058783679401*^9, 
   3.43105886189494*^9}, {3.431058992709149*^9, 3.4310590678010406`*^9}, {
   3.431059354542647*^9, 3.431059558815053*^9}, {3.431065562490494*^9, 
   3.431065564681278*^9}, {3.431068896542932*^9, 3.431068900163909*^9}, {
   3.431091072366126*^9, 3.431091075388692*^9}, 3.435239964502668*^9, {
   3.43524047701989*^9, 3.435240541079809*^9}, {3.455598226320321*^9, 
   3.4555982292610188`*^9}, {3.45672851636167*^9, 3.4567285215181007`*^9}, 
   3.456728696387044*^9, {3.461330164801765*^9, 3.461330165912311*^9}, 
   3.4677205473362923`*^9, {3.546421380322137*^9, 3.546421382785376*^9}, {
   3.5465298071692953`*^9, 3.5465298114546623`*^9}, {3.546529845397641*^9, 
   3.5465298866686363`*^9}, {3.546529920026598*^9, 3.5465299495913773`*^9}, {
   3.558597611384966*^9, 3.5585976691867857`*^9}, {3.587293319451743*^9, 
   3.5872933908869953`*^9}, {3.621248109347301*^9, 3.621248137639824*^9}, {
   3.6212516672458353`*^9, 3.621251707466653*^9}, 3.621252098678246*^9, 
   3.6215340179051867`*^9},
 CellLabel->
  "In[1191]:=",ExpressionUUID->"44814b21-7856-4c32-a005-908fd4f3091c"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
fast calculations in the factorizable operator basis \
ZeemanKetBraOperatorBasis[Sorted \[Rule] \[OpenCurlyDoubleQuote]Canonical\
\[CloseCurlyDoubleQuote]] and the basis ZeemanBasis[].\
\>", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239560361751*^9, 3.435239596132903*^9}, {
   3.435239820173019*^9, 3.43523982842017*^9}, {3.435239862518588*^9, 
   3.435239880379974*^9}, {3.4352407116152267`*^9, 3.435240726984272*^9}, {
   3.435253401801248*^9, 3.435253402192926*^9}, {3.4545753528556147`*^9, 
   3.454575358822048*^9}, {3.454575445072146*^9, 3.454575445781612*^9}, {
   3.546529493646109*^9, 3.5465294971480913`*^9}, {3.558597785603875*^9, 
   3.558597798566132*^9}, 
   3.6212448300344143`*^9},ExpressionUUID->"3d32e91c-7002-4ce4-931d-\
5cfd63c634d9"],

Cell[CellGroupData[{

Cell["handling of dot products", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4545739764606113`*^9, 
  3.454573978922975*^9}},ExpressionUUID->"50b30d0a-ceac-489e-9380-\
d1a2dd9f96c4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"Dot", "[", 
       RowBox[{"sops", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"_", "?", "SuperoperatorQ"}], ".."}], ")"}]}], "]"}], ",", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "matreps", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"matreps", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"SuperoperatorMatrixRepresentation", "[", 
           RowBox[{"#", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}], 
          "&"}], "/@", 
         RowBox[{"{", "sops", "}"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "matreps", "]"}], "\[Equal]", "1"}], ",", 
         RowBox[{"First", "@", "matreps"}], ",", 
         RowBox[{"Fold", "[", 
          RowBox[{"Dot", ",", 
           RowBox[{"First", "@", "matreps"}], ",", 
           RowBox[{"Drop", "[", 
            RowBox[{"matreps", ",", "1"}], "]"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4310952968056602`*^9, 3.4310952983526373`*^9}, {
   3.448348974787569*^9, 3.448348982064094*^9}, {3.448349443761387*^9, 
   3.448349491481229*^9}, {3.4545739866069717`*^9, 3.4545740562298822`*^9}, {
   3.454574784113234*^9, 3.454574794159184*^9}, {3.454575164001598*^9, 
   3.4545751899769*^9}, {3.460631721243853*^9, 3.460631727184251*^9}, {
   3.4610468126294327`*^9, 3.4610468148260527`*^9}, 3.4610469566204357`*^9, {
   3.642515647803877*^9, 3.642515693493313*^9}},
 CellLabel->
  "In[1192]:=",ExpressionUUID->"1c7d70b1-7124-46f6-95ba-168332ff3cc7"]
}, Closed]],

Cell[CellGroupData[{

Cell["RotationSuperoperator", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239560361751*^9, 3.435239596132903*^9}, {
   3.435239820173019*^9, 3.43523982842017*^9}, {3.435239862518588*^9, 
   3.435239880379974*^9}, {3.4352407116152267`*^9, 3.435240726984272*^9}, {
   3.435253401801248*^9, 3.435253402192926*^9}, {3.454575367293867*^9, 
   3.454575371109571*^9}, {3.4610381251555033`*^9, 
   3.461038126240287*^9}},ExpressionUUID->"508bebb9-4fb7-4479-8d57-\
4e2de18cad94"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"sop", ":", 
       RowBox[{"RotationSuperoperator", "[", "args___", "]"}]}], ",", 
      "\[IndentingNewLine]", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
     "\[IndentingNewLine]", "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spinsys", ",", "Rmat"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Rmat", "=", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{
           RowBox[{"RotationOperator", "[", "args", "]"}], ",", "basis", ",", 
           "opts"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"SparseArray", "@", 
         RowBox[{"ComplexExpand", "@", 
          RowBox[{"Normal", "[", 
           RowBox[{"KroneckerProduct", "[", 
            RowBox[{"Rmat", ",", 
             RowBox[{"Conjugate", "@", "Rmat"}]}], "]"}], "]"}]}]}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], 
          "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5026041630322104`*^9, 3.5026042595240183`*^9}, 
   3.546421385465118*^9, {3.546530106134707*^9, 3.546530150890414*^9}, 
   3.58617993593672*^9, {3.586338794785096*^9, 3.58633879579074*^9}, {
   3.621245194938809*^9, 3.621245222390794*^9}, {3.6212465444495163`*^9, 
   3.621246551109017*^9}, {3.621247447762157*^9, 3.621247451631214*^9}, {
   3.6213578013142433`*^9, 3.621357818500803*^9}, {3.626703855264271*^9, 
   3.6267039265148706`*^9}, {3.657821072794715*^9, 3.657821077472446*^9}, {
   3.65782115241714*^9, 3.6578211533904047`*^9}, 3.6595258023387537`*^9, 
   3.6595346289687*^9, {3.659601459524692*^9, 3.659601461361424*^9}},
 CellLabel->
  "In[1193]:=",ExpressionUUID->"7a3351ab-e1c1-46d8-94e3-f532a39ebf6b"]
}, Closed]],

Cell[CellGroupData[{

Cell["CommutationSuperoperator", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239560361751*^9, 3.435239596132903*^9}, {
   3.435239820173019*^9, 3.43523982842017*^9}, {3.435239862518588*^9, 
   3.435239880379974*^9}, {3.4352407116152267`*^9, 3.435240726984272*^9}, {
   3.435253401801248*^9, 3.435253402192926*^9}, {3.454575367293867*^9, 
   3.454575371109571*^9}},ExpressionUUID->"df7d4c03-862a-4207-a933-\
558ff3bb740c"],

Cell["\<\
CommutationSuperoperator of an explicit operator which is not expressed as a \
matrix in the Zeeman basis: convert into Operator form in the Zeeman basis:\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5026042710678377`*^9, 3.50260428110767*^9}, {
   3.502604398456109*^9, 3.502604402660406*^9}, {3.621244933111451*^9, 
   3.621244945654745*^9}, 3.62124534633502*^9, {3.621245723758852*^9, 
   3.6212457464624443`*^9}},ExpressionUUID->"a341b318-985b-454f-ac14-\
5185027785e2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CommutationSuperoperator", "[", 
       RowBox[{
        RowBox[{"op_", "?", "OperatorQ"}], ",", "___"}], "]"}], ",", 
      "opbasis_", ",", "zbasis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "spinsys", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
       "SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"CommutationSuperoperator", "[", "\[IndentingNewLine]", 
          RowBox[{"Operator", "[", 
           RowBox[{"op", ",", "zbasis", ",", 
            RowBox[{"CheckOperatorType", "\[Rule]", "False"}]}], "]"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "opbasis",
          ",", "zbasis", ",", "opts"}], "\[IndentingNewLine]", "]"}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "zbasis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], "]"}], "&&",
          "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"op", ",", 
            RowBox[{"HoldPattern", "[", 
             RowBox[{
              RowBox[{"Operator", "[", 
               RowBox[{
                RowBox[{"_", "?", "MatrixQ"}], ",", "zbasis", ",", "___"}], 
               "]"}], "|", 
              RowBox[{"Operator", "[", 
               RowBox[{
                RowBox[{"_InterpolatingFunction", "[", "_", "]"}], ",", 
                "zbasis", ",", "___"}], "]"}]}], "]"}]}], "]"}]}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435240920497623*^9}, {3.435241098673073*^9, 3.435241134326395*^9}, {
   3.435241491679801*^9, 3.435241512547866*^9}, {3.435242322165255*^9, 
   3.4352423248047323`*^9}, {3.435250726932569*^9, 3.435250729367881*^9}, {
   3.435251391007934*^9, 3.435251392468975*^9}, {3.467189083017579*^9, 
   3.4671890945359364`*^9}, 3.4864652419084044`*^9, {3.502604286718144*^9, 
   3.502604386698839*^9}, 3.54642138419954*^9, {3.546530019490972*^9, 
   3.546530081948133*^9}, 3.586179931603245*^9, {3.586338786012412*^9, 
   3.586338789861945*^9}, {3.621244965580461*^9, 3.621245049588921*^9}, {
   3.6212451340490637`*^9, 3.6212451613315687`*^9}, {3.6212456776679153`*^9, 
   3.621245713342514*^9}, {3.6212478883507423`*^9, 3.6212478913073797`*^9}, {
   3.621346555101342*^9, 3.6213465580578737`*^9}, {3.621346599649377*^9, 
   3.6213466035349503`*^9}, 3.621346714364607*^9, 3.621348719238858*^9, 
   3.621357814066674*^9, {3.6215349157178087`*^9, 3.621534957053019*^9}, {
   3.7256179790867767`*^9, 3.725617981329958*^9}, {3.7256194150105276`*^9, 
   3.725619415107521*^9}, {3.7275239633599367`*^9, 3.727523982115601*^9}, {
   3.7275240655310545`*^9, 3.7275240697263603`*^9}},
 CellLabel->
  "In[1194]:=",ExpressionUUID->"23a41131-02ff-4873-8f41-b04370ae5b15"],

Cell["\<\
operator supplied as matrix in Zeeman basis \[Rule] construct \
SuperoperatorMatrixRepresentation using Kronecker products\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.502604135742118*^9, 3.502604146148756*^9}, 
   3.5026042673742723`*^9, {3.62124523736327*^9, 3.621245238238224*^9}, {
   3.621245606844225*^9, 3.621245625720862*^9}, {3.6212457929060183`*^9, 
   3.6212458008482237`*^9}, 
   3.6212460058354387`*^9},ExpressionUUID->"2cc7500a-d95c-4aa2-bb90-\
7919a587791e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CommutationSuperoperator", "[", 
       RowBox[{
        RowBox[{"Operator", "[", 
         RowBox[{
          RowBox[{"mat_", "?", "MatrixQ"}], ",", "basis_", ",", "___"}], 
         "]"}], ",", "___"}], "]"}], ",", "\[IndentingNewLine]", "opbasis_", 
      ",", "basis_", ",", "opts___Rule"}], "\[IndentingNewLine]", "]"}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spinsys", ",", "Emat"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Emat", "=", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{
           RowBox[{"UnityOperator", "[", "]"}], ",", "basis", ",", "opts"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"SparseArray", "[", 
         RowBox[{
          RowBox[{"KroneckerProduct", "[", 
           RowBox[{"mat", ",", "Emat"}], "]"}], "-", 
          RowBox[{"Transpose", "@", 
           RowBox[{"KroneckerProduct", "[", 
            RowBox[{"Emat", ",", "mat"}], "]"}]}]}], "]"}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], 
          "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5026041630322104`*^9, 3.5026042595240183`*^9}, 
   3.546421385465118*^9, {3.546530106134707*^9, 3.546530150890414*^9}, 
   3.58617993593672*^9, {3.586338794785096*^9, 3.58633879579074*^9}, {
   3.621245194938809*^9, 3.621245222390794*^9}, {3.6212465444495163`*^9, 
   3.621246551109017*^9}, {3.621247447762157*^9, 3.621247451631214*^9}, {
   3.6213578013142433`*^9, 3.621357818500803*^9}, {3.702777872493297*^9, 
   3.7027778761558986`*^9}, {3.702777964200511*^9, 3.7027779660638666`*^9}, {
   3.7027780532397995`*^9, 3.7027780873890867`*^9}, {3.7027781862353554`*^9, 
   3.702778187406218*^9}, 3.7027783080149584`*^9, {3.702778609835018*^9, 
   3.702778610184234*^9}, {3.7256179839958053`*^9, 3.7256179857389526`*^9}, {
   3.725619417918889*^9, 3.725619418049862*^9}},
 CellLabel->
  "In[1195]:=",ExpressionUUID->"87b4b61c-4ae0-4d94-9a04-b38c0d0143a5"],

Cell["\<\
operator supplied as an InterpolatingFunction generating matrix in Zeeman \
basis \[Rule] construct a new InterpolatingFunction generating \
SuperoperatorMatrixRepresentation using Kronecker products\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.502604135742118*^9, 3.502604146148756*^9}, 
   3.5026042673742723`*^9, {3.62124523736327*^9, 3.621245238238224*^9}, {
   3.621245606844225*^9, 3.621245625720862*^9}, {3.621246021182835*^9, 
   3.62124604229766*^9}},ExpressionUUID->"1c7602f2-89a9-413a-9756-\
6da1d610d1d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CommutationSuperoperator", "[", 
       RowBox[{
        RowBox[{"Operator", "[", 
         RowBox[{
          RowBox[{"Times", "[", 
           RowBox[{
            RowBox[{"n1___", "?", "NumericQ"}], ",", 
            RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
            RowBox[{"n2___", "?", "NumericQ"}]}], "]"}], ",", "basis_", ",", 
          "more1___"}], "]"}], ",", "more2___"}], "]"}], ",", 
      "\[IndentingNewLine]", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
     "\[IndentingNewLine]", "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
   "MultiplyMatricesAndMatrixInterpolationFunctions", "[", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SuperoperatorMatrixRepresentation", "[", 
      RowBox[{
       RowBox[{"Times", "[", 
        RowBox[{"n1", ",", "n2", ",", 
         RowBox[{"UnitySuperoperator", "[", "]"}]}], "]"}], ",", "opbasis", 
       ",", "basis"}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{
     "SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"CommutationSuperoperator", "[", 
        RowBox[{
         RowBox[{"Operator", "[", 
          RowBox[{
           RowBox[{"ifunc", "[", "t", "]"}], ",", "basis", ",", "more1"}], 
          "]"}], ",", "more2"}], "]"}], ",", "\[IndentingNewLine]", "opbasis",
        ",", "basis", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5026041630322104`*^9, 3.5026042595240183`*^9}, 
   3.546421385465118*^9, {3.546530106134707*^9, 3.546530150890414*^9}, 
   3.58617993593672*^9, {3.586338794785096*^9, 3.58633879579074*^9}, {
   3.621245194938809*^9, 3.621245222390794*^9}, {3.621245834446763*^9, 
   3.621245874643857*^9}, {3.621245913164927*^9, 3.621245962016173*^9}, 
   3.621247461299062*^9, {3.621273815953418*^9, 3.621273839239715*^9}, {
   3.62127388882434*^9, 3.6212739809145107`*^9}, {3.621274026136725*^9, 
   3.6212740303439074`*^9}, {3.62127407579582*^9, 3.621274114953247*^9}, {
   3.6213577915566177`*^9, 3.621357792826331*^9}, 3.621534025286907*^9},
 CellLabel->
  "In[1196]:=",ExpressionUUID->"1fdb213b-c872-4237-9754-2346aef29f50"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CommutationSuperoperator", "[", 
       RowBox[{
        RowBox[{"Operator", "[", 
         RowBox[{
          RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
          "basis_", ",", "___"}], "]"}], ",", "___"}], "]"}], ",", 
      "\[IndentingNewLine]", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
     "\[IndentingNewLine]", "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spinsys", ",", "Emat"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Emat", "=", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{
           RowBox[{"UnityOperator", "[", "]"}], ",", "basis", ",", "opts"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Replace", "[", 
          RowBox[{"ifunc", ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"mat_", "?", "MatrixQ"}], "\[RuleDelayed]", 
             RowBox[{
              RowBox[{"KroneckerProduct", "[", 
               RowBox[{"mat", ",", "Emat"}], "]"}], "-", 
              RowBox[{"Transpose", "@", 
               RowBox[{"KroneckerProduct", "[", 
                RowBox[{"Emat", ",", "mat"}], "]"}]}]}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", "3", "}"}]}], "\[IndentingNewLine]", "]"}], "[", "t", 
         "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], "]"}], "&&", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], 
          ")"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"ifunc", "[", 
            RowBox[{"ifunc", "\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
            "]"}], ",", 
           RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5026041630322104`*^9, 3.5026042595240183`*^9}, 
   3.546421385465118*^9, {3.546530106134707*^9, 3.546530150890414*^9}, 
   3.58617993593672*^9, {3.586338794785096*^9, 3.58633879579074*^9}, {
   3.621245194938809*^9, 3.621245222390794*^9}, {3.621245834446763*^9, 
   3.621245874643857*^9}, {3.621245913164927*^9, 3.621245962016173*^9}, 
   3.621247461299062*^9, {3.621357786144637*^9, 3.621357788339361*^9}},
 CellLabel->
  "In[1197]:=",ExpressionUUID->"ffb188a5-73a8-4ac2-8b6d-fc9bace50b14"]
}, Closed]],

Cell[CellGroupData[{

Cell["exponential of a CommutationSuperoperator", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239560361751*^9, 3.435239596132903*^9}, {
   3.435239820173019*^9, 3.43523982842017*^9}, {3.435239862518588*^9, 
   3.435239880379974*^9}, {3.4352407116152267`*^9, 3.435240726984272*^9}, {
   3.4352533905960608`*^9, 3.435253397376729*^9}, {3.4545753798061857`*^9, 
   3.454575382925653*^9}},ExpressionUUID->"899907ab-5f7d-4a05-9339-\
b2fbce20b50a"],

Cell["\<\
Exp[CommutationSuperoperator[..]]  of an explicit operator which is not \
expressed as a matrix in the Zeeman basis: convert into Operator form in the \
Zeeman basis:\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5026042710678377`*^9, 3.50260428110767*^9}, {
   3.502604398456109*^9, 3.502604402660406*^9}, {3.621244933111451*^9, 
   3.621244945654745*^9}, 3.62124534633502*^9, {3.621245723758852*^9, 
   3.6212457464624443`*^9}, 
   3.6212461527468*^9},ExpressionUUID->"9c728d68-3489-440f-84ea-c3afbf323522"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{"CommutationSuperoperator", "[", 
        RowBox[{
         RowBox[{"op_", "?", "OperatorQ"}], ",", "___"}], "]"}], "]"}], "|", 
      RowBox[{"E", "^", 
       RowBox[{"(", 
        RowBox[{"CommutationSuperoperator", "[", 
         RowBox[{
          RowBox[{"op_", "?", "OperatorQ"}], ",", "___"}], "]"}], ")"}]}]}], 
     ",", "opbasis_", ",", "zbasis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "spinsys", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
       "SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{"CommutationSuperoperator", "[", "\[IndentingNewLine]", 
           RowBox[{"Operator", "[", 
            RowBox[{"op", ",", "zbasis", ",", 
             RowBox[{"CheckOperatorType", "\[Rule]", "False"}]}], "]"}], 
           "\[IndentingNewLine]", "]"}], "]"}], ",", "\[IndentingNewLine]", 
         "opbasis", ",", "zbasis", ",", "opts"}], "\[IndentingNewLine]", 
        "]"}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "zbasis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], "]"}], "&&",
          "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"op", ",", 
            RowBox[{"HoldPattern", "[", 
             RowBox[{
              RowBox[{"Operator", "[", 
               RowBox[{
                RowBox[{"_", "?", "MatrixQ"}], ",", "zbasis", ",", "___"}], 
               "]"}], "|", 
              RowBox[{"Operator", "[", 
               RowBox[{"_InterpolatingFunction", "[", "_", "]"}], "]"}]}], 
             "]"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435240920497623*^9}, {3.435241098673073*^9, 3.435241134326395*^9}, {
   3.435241491679801*^9, 3.435241512547866*^9}, {3.435242322165255*^9, 
   3.4352423248047323`*^9}, {3.435250726932569*^9, 3.435250729367881*^9}, {
   3.435251391007934*^9, 3.435251392468975*^9}, {3.467189083017579*^9, 
   3.4671890945359364`*^9}, 3.4864652419084044`*^9, {3.502604286718144*^9, 
   3.502604386698839*^9}, 3.54642138419954*^9, {3.546530019490972*^9, 
   3.546530081948133*^9}, 3.586179931603245*^9, {3.586338786012412*^9, 
   3.586338789861945*^9}, {3.621244965580461*^9, 3.621245049588921*^9}, {
   3.6212451340490637`*^9, 3.6212451613315687`*^9}, {3.6212456776679153`*^9, 
   3.621245713342514*^9}, {3.621246167588237*^9, 3.621246181446273*^9}, {
   3.62124790022892*^9, 3.62124790474024*^9}},
 CellLabel->
  "In[1198]:=",ExpressionUUID->"ba9583e9-afc6-49d3-86cf-747c5dd8cf11"],

Cell["\<\
operator supplied as matrix in Zeeman basis \[Rule] construct \
SuperoperatorMatrixRepresentation using Kronecker products\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.502604135742118*^9, 3.502604146148756*^9}, 
   3.5026042673742723`*^9, {3.62124523736327*^9, 3.621245238238224*^9}, {
   3.621245606844225*^9, 3.621245625720862*^9}, {3.6212457929060183`*^9, 
   3.6212458008482237`*^9}, 
   3.6212460058354387`*^9},ExpressionUUID->"b5c042a0-718c-4831-9841-\
84058968e0fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{"CommutationSuperoperator", "[", 
        RowBox[{
         RowBox[{"HoldPattern", "@", 
          RowBox[{"Operator", "[", 
           RowBox[{
            RowBox[{"mat_", "?", "MatrixQ"}], ",", "zbasis_", ",", "___"}], 
           "]"}]}], ",", "___"}], "]"}], "]"}], "|", 
      RowBox[{"E", "^", 
       RowBox[{"(", 
        RowBox[{"CommutationSuperoperator", "[", 
         RowBox[{
          RowBox[{"HoldPattern", "@", 
           RowBox[{"Operator", "[", 
            RowBox[{
             RowBox[{"mat_", "?", "MatrixQ"}], ",", "zbasis_", ",", "___"}], 
            "]"}]}], ",", "___"}], "]"}], ")"}]}]}], ",", 
     "\[IndentingNewLine]", "opbasis_", ",", "zbasis_", ",", "opts___Rule"}], 
    "\[IndentingNewLine]", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spinsys", ",", "Rmat", ",", "Rmatinv"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Rmat", "=", 
         RowBox[{"MatrixExp", "[", "mat", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Rmatinv", "=", 
         RowBox[{"MatrixExp", "[", 
          RowBox[{"-", "mat"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"SparseArray", "[", 
         RowBox[{"KroneckerProduct", "[", 
          RowBox[{"Rmat", ",", 
           RowBox[{"Transpose", "@", "Rmatinv"}]}], "]"}], "]"}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "zbasis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], 
          "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5026041630322104`*^9, 3.5026042595240183`*^9}, 
   3.546421385465118*^9, {3.546530106134707*^9, 3.546530150890414*^9}, 
   3.58617993593672*^9, {3.586338794785096*^9, 3.58633879579074*^9}, {
   3.621245194938809*^9, 3.621245222390794*^9}, {3.621246296013234*^9, 
   3.621246327481194*^9}, {3.621246395704152*^9, 3.6212464054463*^9}, {
   3.621246464020486*^9, 3.621246516650778*^9}, {3.621247470931126*^9, 
   3.621247472614793*^9}},
 CellLabel->
  "In[1199]:=",ExpressionUUID->"7806a6d9-d5d6-42b5-b1ef-e8ee23b5cc60"],

Cell["\<\
operator supplied as an InterpolatingFunction generating matrix in Zeeman \
basis \[Rule] construct a new InterpolatingFunction generating \
SuperoperatorMatrixRepresentation using Kronecker products\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.502604135742118*^9, 3.502604146148756*^9}, 
   3.5026042673742723`*^9, {3.62124523736327*^9, 3.621245238238224*^9}, {
   3.621245606844225*^9, 3.621245625720862*^9}, {3.621246021182835*^9, 
   3.62124604229766*^9}},ExpressionUUID->"c95cc70f-812e-4d8a-8605-\
eca72087283f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{"CommutationSuperoperator", "[", 
        RowBox[{
         RowBox[{"HoldPattern", "@", 
          RowBox[{"Operator", "[", 
           RowBox[{
            RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
            "basis_", ",", "___"}], "]"}]}], ",", "___"}], "]"}], "]"}], "|", 
      
      RowBox[{"E", "^", 
       RowBox[{"(", 
        RowBox[{"CommutationSuperoperator", "[", 
         RowBox[{
          RowBox[{"HoldPattern", "@", 
           RowBox[{"Operator", "[", 
            RowBox[{
             RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
             "basis_", ",", "___"}], "]"}]}], ",", "___"}], "]"}], ")"}]}]}], 
     ",", "\[IndentingNewLine]", "opbasis_", ",", "basis_", ",", 
     "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "spinsys", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Replace", "[", 
         RowBox[{"ifunc", ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"mat_", "?", "MatrixQ"}], "\[RuleDelayed]", 
            RowBox[{"SparseArray", "[", 
             RowBox[{"KroneckerProduct", "[", 
              RowBox[{
               RowBox[{"MatrixExp", "[", "mat", "]"}], ",", 
               RowBox[{"Transpose", "@", 
                RowBox[{"MatrixExp", "[", 
                 RowBox[{"-", "mat"}], "]"}]}]}], "]"}], "]"}]}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", "3", "}"}]}], "\[IndentingNewLine]", "]"}], "[", "t", 
        "]"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], "]"}], "&&", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], 
          ")"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"ifunc", "[", 
            RowBox[{"ifunc", "\[LeftDoubleBracket]", 
             RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], 
            "]"}], ",", 
           RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5026041630322104`*^9, 3.5026042595240183`*^9}, 
   3.546421385465118*^9, {3.546530106134707*^9, 3.546530150890414*^9}, 
   3.58617993593672*^9, {3.586338794785096*^9, 3.58633879579074*^9}, {
   3.621245194938809*^9, 3.621245222390794*^9}, {3.621245834446763*^9, 
   3.621245874643857*^9}, {3.621245913164927*^9, 3.621245962016173*^9}, {
   3.621246655078067*^9, 3.621246755379154*^9}, {3.6212474767553453`*^9, 
   3.621247478296733*^9}},
 CellLabel->
  "In[1200]:=",ExpressionUUID->"1fb51a5c-e234-4208-95ed-967b9d9d172d"]
}, Closed]],

Cell[CellGroupData[{

Cell["Left/RightMultiplicationSuperoperator", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239560361751*^9, 3.435239596132903*^9}, {
   3.435239820173019*^9, 3.43523982842017*^9}, {3.435239862518588*^9, 
   3.435239880379974*^9}, {3.4352407116152267`*^9, 3.435240726984272*^9}, {
   3.435253401801248*^9, 3.435253402192926*^9}, {3.454575367293867*^9, 
   3.454575371109571*^9}, {3.727524079310356*^9, 
   3.727524088102172*^9}},ExpressionUUID->"df7d4c03-862a-4207-a933-\
558ff3bb740c"],

Cell["\<\
MultiplicationSuperoperator of an explicit operator which is not expressed as \
a matrix in the Zeeman basis: convert into Operator form in the Zeeman basis:\
\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5026042710678377`*^9, 3.50260428110767*^9}, {
   3.502604398456109*^9, 3.502604402660406*^9}, {3.621244933111451*^9, 
   3.621244945654745*^9}, 3.62124534633502*^9, {3.621245723758852*^9, 
   3.6212457464624443`*^9}, {3.727524093800276*^9, 
   3.7275240968506155`*^9}},ExpressionUUID->"a341b318-985b-454f-ac14-\
5185027785e2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"head", ":", 
         RowBox[{"(", 
          RowBox[{
          "LeftMultiplicationSuperoperator", "|", 
           "RightMultiplicationSuperoperator"}], ")"}]}], ")"}], "[", 
       RowBox[{
        RowBox[{"op_", "?", "OperatorQ"}], ",", "___"}], "]"}], ",", 
      "opbasis_", ",", "zbasis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "spinsys", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
       "SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"head", "[", "\[IndentingNewLine]", 
          RowBox[{"Operator", "[", 
           RowBox[{"op", ",", "zbasis", ",", 
            RowBox[{"CheckOperatorType", "\[Rule]", "False"}]}], "]"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "opbasis",
          ",", "zbasis", ",", "opts"}], "\[IndentingNewLine]", "]"}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "zbasis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], "]"}], "&&",
          "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"op", ",", 
            RowBox[{"HoldPattern", "[", 
             RowBox[{"Operator", "[", 
              RowBox[{
               RowBox[{"_", "?", "MatrixQ"}], ",", "zbasis", ",", "___"}], 
              "]"}], "]"}]}], "]"}]}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435240920497623*^9}, {3.435241098673073*^9, 3.435241134326395*^9}, {
   3.435241491679801*^9, 3.435241512547866*^9}, {3.435242322165255*^9, 
   3.4352423248047323`*^9}, {3.435250726932569*^9, 3.435250729367881*^9}, {
   3.435251391007934*^9, 3.435251392468975*^9}, {3.467189083017579*^9, 
   3.4671890945359364`*^9}, 3.4864652419084044`*^9, {3.502604286718144*^9, 
   3.502604386698839*^9}, 3.54642138419954*^9, {3.546530019490972*^9, 
   3.546530081948133*^9}, 3.586179931603245*^9, {3.586338786012412*^9, 
   3.586338789861945*^9}, {3.621244965580461*^9, 3.621245049588921*^9}, {
   3.6212451340490637`*^9, 3.6212451613315687`*^9}, {3.6212456776679153`*^9, 
   3.621245713342514*^9}, {3.6212478883507423`*^9, 3.6212478913073797`*^9}, {
   3.621346555101342*^9, 3.6213465580578737`*^9}, {3.621346599649377*^9, 
   3.6213466035349503`*^9}, 3.621346714364607*^9, 3.621348719238858*^9, 
   3.621357814066674*^9, {3.6215349157178087`*^9, 3.621534957053019*^9}, {
   3.7256179790867767`*^9, 3.725617981329958*^9}, {3.7256194150105276`*^9, 
   3.725619415107521*^9}, {3.7275239633599367`*^9, 3.727523982115601*^9}, {
   3.7275240655310545`*^9, 3.7275240697263603`*^9}, {3.727524105998953*^9, 
   3.72752413502296*^9}, {3.7275241900569677`*^9, 3.7275241986096544`*^9}, {
   3.727524229399705*^9, 3.727524230955228*^9}, 3.727524530346614*^9, {
   3.72752457701291*^9, 3.7275245778518934`*^9}},
 CellLabel->
  "In[1201]:=",ExpressionUUID->"23a41131-02ff-4873-8f41-b04370ae5b15"],

Cell["\<\
operator supplied as matrix in Zeeman basis \[Rule] construct \
SuperoperatorMatrixRepresentation using Kronecker products\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.502604135742118*^9, 3.502604146148756*^9}, 
   3.5026042673742723`*^9, {3.62124523736327*^9, 3.621245238238224*^9}, {
   3.621245606844225*^9, 3.621245625720862*^9}, {3.6212457929060183`*^9, 
   3.6212458008482237`*^9}, 
   3.6212460058354387`*^9},ExpressionUUID->"2cc7500a-d95c-4aa2-bb90-\
7919a587791e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"head", ":", 
         RowBox[{"(", 
          RowBox[{
          "LeftMultiplicationSuperoperator", "|", 
           "RightMultiplicationSuperoperator"}], ")"}]}], ")"}], "[", 
       RowBox[{
        RowBox[{"Operator", "[", 
         RowBox[{
          RowBox[{"mat_", "?", "MatrixQ"}], ",", "basis_", ",", "___"}], 
         "]"}], ",", "___"}], "]"}], ",", "\[IndentingNewLine]", "opbasis_", 
      ",", "basis_", ",", "opts___Rule"}], "\[IndentingNewLine]", "]"}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spinsys", ",", "Emat"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Emat", "=", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{
           RowBox[{"UnityOperator", "[", "]"}], ",", "basis", ",", "opts"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{"head", ",", "LeftMultiplicationSuperoperator"}], "]"}], 
          ",", 
          RowBox[{"SparseArray", "[", 
           RowBox[{"KroneckerProduct", "[", 
            RowBox[{"mat", ",", "Emat"}], "]"}], "]"}], ",", 
          RowBox[{"SparseArray", "[", 
           RowBox[{"Transpose", "@", 
            RowBox[{"KroneckerProduct", "[", 
             RowBox[{"Emat", ",", "mat"}], "]"}]}], "]"}]}], "]"}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], 
          "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5026041630322104`*^9, 3.5026042595240183`*^9}, 
   3.546421385465118*^9, {3.546530106134707*^9, 3.546530150890414*^9}, 
   3.58617993593672*^9, {3.586338794785096*^9, 3.58633879579074*^9}, {
   3.621245194938809*^9, 3.621245222390794*^9}, {3.6212465444495163`*^9, 
   3.621246551109017*^9}, {3.621247447762157*^9, 3.621247451631214*^9}, {
   3.6213578013142433`*^9, 3.621357818500803*^9}, {3.702777872493297*^9, 
   3.7027778761558986`*^9}, {3.702777964200511*^9, 3.7027779660638666`*^9}, {
   3.7027780532397995`*^9, 3.7027780873890867`*^9}, {3.7027781862353554`*^9, 
   3.702778187406218*^9}, 3.7027783080149584`*^9, {3.702778609835018*^9, 
   3.702778610184234*^9}, {3.7256179839958053`*^9, 3.7256179857389526`*^9}, {
   3.725619417918889*^9, 3.725619418049862*^9}, {3.727524248942669*^9, 
   3.727524314801776*^9}, {3.7275245184119887`*^9, 3.727524522982834*^9}, {
   3.7275245721556644`*^9, 3.7275245748848815`*^9}, {3.7275248440023036`*^9, 
   3.727524887026168*^9}},
 CellLabel->
  "In[1202]:=",ExpressionUUID->"87b4b61c-4ae0-4d94-9a04-b38c0d0143a5"]
}, Closed]],

Cell[CellGroupData[{

Cell["exponential of Left/RightMultiplicationSuperoperator", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239560361751*^9, 3.435239596132903*^9}, {
   3.435239820173019*^9, 3.43523982842017*^9}, {3.435239862518588*^9, 
   3.435239880379974*^9}, {3.4352407116152267`*^9, 3.435240726984272*^9}, {
   3.4352533905960608`*^9, 3.435253397376729*^9}, {3.4545753798061857`*^9, 
   3.454575382925653*^9}, 
   3.727524920753197*^9},ExpressionUUID->"899907ab-5f7d-4a05-9339-\
b2fbce20b50a"],

Cell["\<\
Exp[CommutationSuperoperator[..]]  of an explicit operator which is not \
expressed as a matrix in the Zeeman basis: convert into Operator form in the \
Zeeman basis:\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5026042710678377`*^9, 3.50260428110767*^9}, {
   3.502604398456109*^9, 3.502604402660406*^9}, {3.621244933111451*^9, 
   3.621244945654745*^9}, 3.62124534633502*^9, {3.621245723758852*^9, 
   3.6212457464624443`*^9}, 
   3.6212461527468*^9},ExpressionUUID->"9c728d68-3489-440f-84ea-c3afbf323522"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"head", ":", 
          RowBox[{"(", 
           RowBox[{
           "LeftMultiplicationSuperoperator", "|", 
            "RightMultiplicationSuperoperator"}], ")"}]}], ")"}], "[", 
        RowBox[{
         RowBox[{"op_", "?", "OperatorQ"}], ",", "___"}], "]"}], "]"}], "|", 
      RowBox[{"E", "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"head", ":", 
           RowBox[{"(", 
            RowBox[{
            "LeftMultiplicationSuperoperator", "|", 
             "RightMultiplicationSuperoperator"}], ")"}]}], ")"}], "[", 
         RowBox[{
          RowBox[{"op_", "?", "OperatorQ"}], ",", "___"}], "]"}], ")"}]}]}], 
     ",", "opbasis_", ",", "zbasis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "spinsys", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
       "SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Exp", "[", 
          RowBox[{"head", "[", "\[IndentingNewLine]", 
           RowBox[{"Operator", "[", 
            RowBox[{"op", ",", "zbasis", ",", 
             RowBox[{"CheckOperatorType", "\[Rule]", "False"}]}], "]"}], 
           "\[IndentingNewLine]", "]"}], "]"}], ",", "\[IndentingNewLine]", 
         "opbasis", ",", "zbasis", ",", "opts"}], "\[IndentingNewLine]", 
        "]"}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "zbasis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], "]"}], "&&",
          "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"op", ",", 
            RowBox[{"HoldPattern", "[", 
             RowBox[{"Operator", "[", 
              RowBox[{
               RowBox[{"_", "?", "MatrixQ"}], ",", "zbasis", ",", "___"}], 
              "]"}], "]"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435240920497623*^9}, {3.435241098673073*^9, 3.435241134326395*^9}, {
   3.435241491679801*^9, 3.435241512547866*^9}, {3.435242322165255*^9, 
   3.4352423248047323`*^9}, {3.435250726932569*^9, 3.435250729367881*^9}, {
   3.435251391007934*^9, 3.435251392468975*^9}, {3.467189083017579*^9, 
   3.4671890945359364`*^9}, 3.4864652419084044`*^9, {3.502604286718144*^9, 
   3.502604386698839*^9}, 3.54642138419954*^9, {3.546530019490972*^9, 
   3.546530081948133*^9}, 3.586179931603245*^9, {3.586338786012412*^9, 
   3.586338789861945*^9}, {3.621244965580461*^9, 3.621245049588921*^9}, {
   3.6212451340490637`*^9, 3.6212451613315687`*^9}, {3.6212456776679153`*^9, 
   3.621245713342514*^9}, {3.621246167588237*^9, 3.621246181446273*^9}, {
   3.62124790022892*^9, 3.62124790474024*^9}, {3.727525038441068*^9, 
   3.727525063773392*^9}},
 CellLabel->
  "In[1203]:=",ExpressionUUID->"ba9583e9-afc6-49d3-86cf-747c5dd8cf11"],

Cell["\<\
operator supplied as matrix in Zeeman basis \[Rule] construct \
SuperoperatorMatrixRepresentation using Kronecker products\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.502604135742118*^9, 3.502604146148756*^9}, 
   3.5026042673742723`*^9, {3.62124523736327*^9, 3.621245238238224*^9}, {
   3.621245606844225*^9, 3.621245625720862*^9}, {3.6212457929060183`*^9, 
   3.6212458008482237`*^9}, 
   3.6212460058354387`*^9},ExpressionUUID->"b5c042a0-718c-4831-9841-\
84058968e0fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"head", ":", 
          RowBox[{"(", 
           RowBox[{
           "LeftMultiplicationSuperoperator", "|", 
            "RightMultiplicationSuperoperator"}], ")"}]}], ")"}], "[", 
        RowBox[{
         RowBox[{"HoldPattern", "@", 
          RowBox[{"Operator", "[", 
           RowBox[{
            RowBox[{"mat_", "?", "MatrixQ"}], ",", "zbasis_", ",", "___"}], 
           "]"}]}], ",", "___"}], "]"}], "]"}], "|", 
      RowBox[{"E", "^", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"head", ":", 
           RowBox[{"(", 
            RowBox[{
            "LeftMultiplicationSuperoperator", "|", 
             "RightMultiplicationSuperoperator"}], ")"}]}], ")"}], "[", 
         RowBox[{
          RowBox[{"HoldPattern", "@", 
           RowBox[{"Operator", "[", 
            RowBox[{
             RowBox[{"mat_", "?", "MatrixQ"}], ",", "zbasis_", ",", "___"}], 
            "]"}]}], ",", "___"}], "]"}], ")"}]}]}], ",", 
     "\[IndentingNewLine]", "opbasis_", ",", "zbasis_", ",", "opts___Rule"}], 
    "\[IndentingNewLine]", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"spinsys", ",", "Emat"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Emat", "=", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{
           RowBox[{"UnityOperator", "[", "]"}], ",", "zbasis", ",", "opts"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{"head", ",", "LeftMultiplicationSuperoperator"}], "]"}], 
          ",", 
          RowBox[{"SparseArray", "[", 
           RowBox[{"KroneckerProduct", "[", 
            RowBox[{
             RowBox[{"MatrixExp", "[", "mat", "]"}], ",", "Emat"}], "]"}], 
           "]"}], ",", 
          RowBox[{"SparseArray", "[", 
           RowBox[{"Transpose", "@", 
            RowBox[{"KroneckerProduct", "[", 
             RowBox[{
              RowBox[{"MatrixExp", "[", "Emat", "]"}], ",", "mat"}], "]"}]}], 
           "]"}]}], "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "zbasis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], 
          "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5026041630322104`*^9, 3.5026042595240183`*^9}, 
   3.546421385465118*^9, {3.546530106134707*^9, 3.546530150890414*^9}, 
   3.58617993593672*^9, {3.586338794785096*^9, 3.58633879579074*^9}, {
   3.621245194938809*^9, 3.621245222390794*^9}, {3.621246296013234*^9, 
   3.621246327481194*^9}, {3.621246395704152*^9, 3.6212464054463*^9}, {
   3.621246464020486*^9, 3.621246516650778*^9}, {3.621247470931126*^9, 
   3.621247472614793*^9}, {3.727525072196365*^9, 3.7275251069505014`*^9}, {
   3.727525152169197*^9, 3.727525199181508*^9}},
 CellLabel->
  "In[1204]:=",ExpressionUUID->"7806a6d9-d5d6-42b5-b1ef-e8ee23b5cc60"]
}, Closed]],

Cell[CellGroupData[{

Cell["DoubleCommutationSuperoperator", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239560361751*^9, 3.435239596132903*^9}, {
   3.435239820173019*^9, 3.43523982842017*^9}, {3.435239862518588*^9, 
   3.435239880379974*^9}, {3.4352407116152267`*^9, 3.435240726984272*^9}, {
   3.4352409441063766`*^9, 3.435240945207591*^9}, {3.454575397133975*^9, 
   3.454575399333581*^9}},ExpressionUUID->"087a9717-b34a-4d18-98d7-\
6272a24db1c0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"sop", ":", 
      RowBox[{"DoubleCommutationSuperoperator", "[", 
       RowBox[{"op1_", ",", "op2_"}], "]"}]}], ",", "opbasis_", ",", "basis_",
      ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "spinsys", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"SparseArray", "@", 
        RowBox[{"Dot", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"SuperoperatorMatrixRepresentation", "[", 
           RowBox[{
            RowBox[{"CommutationSuperoperator", "[", "op1", "]"}], ",", 
            "opbasis", ",", "basis", ",", "opts"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"SuperoperatorMatrixRepresentation", "[", 
           RowBox[{
            RowBox[{"CommutationSuperoperator", "[", "op2", "]"}], ",", 
            "opbasis", ",", "basis", ",", "opts"}], "]"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], 
          "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435241019428803*^9}, {3.435241061775077*^9, 3.435241064148459*^9}, 
   3.435241141659968*^9, {3.455598183366757*^9, 3.455598186276292*^9}, {
   3.467189141494769*^9, 3.467189141895055*^9}, 3.546421389234572*^9, {
   3.546530278957757*^9, 3.5465303087659388`*^9}, 3.586179950704792*^9},
 CellLabel->
  "In[1205]:=",ExpressionUUID->"63f1e045-9b2c-45e7-9705-2980e42a8ba6"]
}, Closed]],

Cell[CellGroupData[{

Cell["ProjectionSuperoperator", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239560361751*^9, 3.435239596132903*^9}, {
   3.435239820173019*^9, 3.43523982842017*^9}, {3.435239862518588*^9, 
   3.435239880379974*^9}, {3.4352407116152267`*^9, 3.435240726984272*^9}, {
   3.4352409441063766`*^9, 3.435240945207591*^9}, {3.450615879316126*^9, 
   3.45061589451453*^9}, {3.450617459880319*^9, 3.4506174614301434`*^9}, {
   3.454575407709776*^9, 
   3.4545754098375263`*^9}},ExpressionUUID->"83f4a39f-e13f-4f77-a5e0-\
a4d39a399881"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"sop", ":", 
       RowBox[{"ProjectionSuperoperator", "[", 
        RowBox[{"op_", ",", "sopopts___Rule"}], "]"}]}], ",", "opbasis_", ",",
       "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Normalize", "/.", 
       RowBox[{"{", "sopopts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ProjectionSuperoperator", "]"}]}], ")"}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"ProjectionSuperoperator", "[", 
      RowBox[{
       RowBox[{"NormalizeOperator", "@", "op"}], ",", 
       RowBox[{"Normalize", "\[Rule]", "False"}]}], "]"}], ",", "opbasis", 
     ",", "basis", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5027824583144817`*^9, 3.502782558797331*^9}, {
   3.502785513616091*^9, 3.502785538979175*^9}, {3.502785665856077*^9, 
   3.5027856661728907`*^9}, 3.530986223272846*^9},
 CellLabel->
  "In[1206]:=",ExpressionUUID->"adf65817-d7b5-434e-ac65-2e1d59b67c35"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"sop", ":", 
      RowBox[{"ProjectionSuperoperator", "[", 
       RowBox[{"op_", ",", "sopopts___Rule"}], "]"}]}], ",", "opbasis_", ",", 
     "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"matop", ",", "spinsys"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"matop", "=", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{
           RowBox[{"NormalizeOperator", "@", "op"}], ",", 
           RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SparseArray", "@", 
         RowBox[{"Outer", "[", 
          RowBox[{"Times", ",", 
           RowBox[{"Flatten", "@", "matop"}], ",", 
           RowBox[{"Conjugate", "@", 
            RowBox[{"Flatten", "[", "matop", "]"}]}]}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Normalize", "/.", 
             RowBox[{"{", "sopopts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "ProjectionSuperoperator", "]"}]}], 
           ")"}]}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], 
          "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435241019428803*^9}, {3.435241061775077*^9, 3.435241064148459*^9}, 
   3.435241141659968*^9, 3.450615889907681*^9, {3.450615937974469*^9, 
   3.4506160095401382`*^9}, {3.4506174874272337`*^9, 3.450617581331003*^9}, {
   3.4506180411444817`*^9, 3.450618074696751*^9}, {3.4555981681685143`*^9, 
   3.455598171644006*^9}, {3.4556452947463837`*^9, 3.4556452955701036`*^9}, {
   3.467189150381721*^9, 3.467189150741824*^9}, {3.502777779462083*^9, 
   3.502777779820676*^9}, {3.5027855566193523`*^9, 3.502785586845718*^9}, {
   3.5027856506517363`*^9, 3.502785655667247*^9}, {3.530986072978099*^9, 
   3.5309861121675863`*^9}, 3.530986225035087*^9, 3.546421391004264*^9, {
   3.546530350012657*^9, 3.5465304022332706`*^9}, 3.586179960074045*^9, {
   3.6578211581931057`*^9, 3.6578211593186617`*^9}, 3.6595258419491463`*^9, 
   3.6595346647690687`*^9},
 CellLabel->
  "In[1207]:=",ExpressionUUID->"ea7de7a2-5f0d-4aa9-891b-5e6ebc663f38"]
}, Closed]],

Cell[CellGroupData[{

Cell["ShiftSuperoperator", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239560361751*^9, 3.435239596132903*^9}, {
   3.435239820173019*^9, 3.43523982842017*^9}, {3.435239862518588*^9, 
   3.435239880379974*^9}, {3.4352407116152267`*^9, 3.435240726984272*^9}, {
   3.4352409441063766`*^9, 3.435240945207591*^9}, {3.450615879316126*^9, 
   3.45061589451453*^9}, {3.450617459880319*^9, 3.4506174614301434`*^9}, {
   3.454575407709776*^9, 3.4545754098375263`*^9}, {3.4556437056766453`*^9, 
   3.455643706641863*^9}},ExpressionUUID->"c0fb0343-6f23-4495-9c6c-\
82e259c2d1a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{
      RowBox[{"sop", ":", 
       RowBox[{"ShiftSuperoperator", "[", 
        RowBox[{"op2_", ",", "op1_", ",", "sopopts___Rule"}], "]"}]}], ",", 
      "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Normalize", "/.", 
       RowBox[{"{", "sopopts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ShiftSuperoperator", "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"ShiftSuperoperator", "[", 
      RowBox[{
       RowBox[{"NormalizeOperator", "@", "op2"}], ",", 
       RowBox[{"NormalizeOperator", "@", "op1"}], ",", 
       RowBox[{"Normalize", "\[Rule]", "False"}]}], "]"}], ",", "opbasis", 
     ",", "basis", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5027824583144817`*^9, 3.502782558797331*^9}},
 CellLabel->
  "In[1208]:=",ExpressionUUID->"05f3dd94-7d14-4d81-af12-5ddf62321e9b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{
     RowBox[{"sop", ":", 
      RowBox[{"ShiftSuperoperator", "[", 
       RowBox[{"op2_", ",", "op1_", ",", "sopopts___Rule"}], "]"}]}], ",", 
     "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"matop2", ",", "matop1", ",", "spinsys"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"matop2", "=", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{"op2", ",", 
           RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"matop1", "=", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{"op1", ",", 
           RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SparseArray", "@", 
         RowBox[{"Outer", "[", 
          RowBox[{"Times", ",", 
           RowBox[{"Flatten", "@", "matop2"}], ",", 
           RowBox[{"Conjugate", "@", 
            RowBox[{"Flatten", "[", "matop1", "]"}]}]}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Normalize", "/.", 
             RowBox[{"{", "sopopts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "ProjectionSuperoperator", "]"}]}], 
           ")"}]}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Method", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{
            "Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], ",",
            "Automatic"}], "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"ZeemanKetBraOperatorBasis", "[", 
              RowBox[{"spinsys", ",", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}], 
             ",", 
             RowBox[{"ZeemanBasis", "[", "spinsys", "]"}]}], "}"}]}], 
          "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435241019428803*^9}, {3.435241061775077*^9, 3.435241064148459*^9}, 
   3.435241141659968*^9, 3.450615889907681*^9, {3.450615937974469*^9, 
   3.4506160095401382`*^9}, {3.4506174874272337`*^9, 3.450617581331003*^9}, {
   3.4506180411444817`*^9, 3.450618074696751*^9}, {3.4555981681685143`*^9, 
   3.455598171644006*^9}, {3.455643713161915*^9, 3.455643718860208*^9}, {
   3.455643749824877*^9, 3.455643782114079*^9}, {3.455644142203265*^9, 
   3.4556441519028683`*^9}, {3.455645276750188*^9, 3.455645325226089*^9}, {
   3.467189158413369*^9, 3.467189158798856*^9}, {3.502777640719982*^9, 
   3.502777646229437*^9}, {3.5027777566797113`*^9, 3.502777766557427*^9}, 
   3.502777855646368*^9, {3.5027825691880074`*^9, 3.502782588265354*^9}, {
   3.5027856084940567`*^9, 3.502785635721347*^9}, {3.530986241401681*^9, 
   3.5309862531285152`*^9}, 3.5464213921139107`*^9, {3.54653042042666*^9, 
   3.546530467329936*^9}, 3.586179963786992*^9, {3.657821164060004*^9, 
   3.6578211666614103`*^9}, 3.659525827630849*^9, 3.659534684879657*^9},
 CellLabel->
  "In[1209]:=",ExpressionUUID->"bb7270a5-4be9-421b-a8ce-715ff02bb81f"]
}, Closed]],

Cell[CellGroupData[{

Cell["CoherenceOrderFiltrationSuperoperator", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239560361751*^9, 3.435239596132903*^9}, {
   3.435239820173019*^9, 3.43523982842017*^9}, {3.435239862518588*^9, 
   3.435239880379974*^9}, {3.4352407116152267`*^9, 3.435240726984272*^9}, {
   3.4352409441063766`*^9, 3.435240945207591*^9}, {3.450615879316126*^9, 
   3.45061589451453*^9}, {3.450617459880319*^9, 3.4506174614301434`*^9}, {
   3.454575407709776*^9, 3.4545754098375263`*^9}, 
   3.5002780141038723`*^9},ExpressionUUID->"a6f289e6-30c8-45dc-8d38-\
e2bfb3337a6a"],

Cell["multiply matrix representations for successive filtrations ", "Text",
 CellChangeTimes->{{3.722561671712467*^9, 
  3.722561687399786*^9}},ExpressionUUID->"8931767e-8c7f-4bd1-af98-\
a9e065a3735e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"spins", ":", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
          RowBox[{"orders", ":", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}]}], "}"}], 
        ",", 
        RowBox[{"more", ":", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", 
        "cofsopts___Rule"}], "]"}]}], ",", "\[IndentingNewLine]", "opbasis_", 
     ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"spins", ",", "orders"}], "}"}], ",", "cofsopts"}], "]"}], 
      ",", "\[IndentingNewLine]", "opbasis", ",", "basis", ",", "opts"}], 
     "\[IndentingNewLine]", "]"}], ".", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
       RowBox[{"more", ",", "cofsopts"}], "]"}], ",", "\[IndentingNewLine]", 
      "opbasis", ",", "basis", ",", "opts"}], "\[IndentingNewLine]", 
     "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7225614810996027`*^9, 3.722561655045348*^9}},
 CellLabel->
  "In[1210]:=",ExpressionUUID->"da8d1f8b-458d-4850-a898-5da93a68fb0c"],

Cell["general filtration for a restricted set of spins", "Text",
 CellChangeTimes->{{3.722561671712467*^9, 
  3.722561704455459*^9}},ExpressionUUID->"2bfbc373-f08b-4a88-b632-\
26abe34cefc6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"HoldPattern", "@", 
      RowBox[{"CoherenceOrderFiltrationSuperoperator", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"spins", ":", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], ",", 
          RowBox[{"orders", ":", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}]}], "}"}], 
        ",", "cofsopts___Rule"}], "]"}]}], ",", "\[IndentingNewLine]", 
     "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "pos", ",", "spinsys"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"n", "=", 
         RowBox[{"OperatorBasisDimension", "[", 
          RowBox[{"ZeemanKetBraOperatorBasis", "[", 
           RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"pos", "=", 
         RowBox[{"Flatten", "@", 
          RowBox[{"Position", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"CoherenceOrder", "[", 
               RowBox[{"spins", ",", "#"}], "]"}], "&"}], "/@", 
             RowBox[{"BasisOperators", "[", 
              RowBox[{"ZeemanKetBraOperatorBasis", "[", 
               RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}], "]"}], 
              "]"}]}], ",", 
            RowBox[{"Alternatives", "@@", "orders"}]}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"#", ",", "#"}], "}"}], "\[Rule]", "1"}], ")"}], "&"}],
            "/@", "pos"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "n"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
       ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"spinsys", "=", 
         RowBox[{"SpinSystem", "[", "opbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"opbasis", ",", 
          RowBox[{"ZeemanKetBraOperatorBasis", "[", 
           RowBox[{"spinsys", ",", 
            RowBox[{"Sorted", "\[Rule]", "\"\<Canonical\>\""}]}], "]"}]}], 
         "]"}]}], "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5002764047809753`*^9, 3.5002764125578833`*^9}, {
   3.5002764488225317`*^9, 3.50027658608708*^9}, {3.5002766289926043`*^9, 
   3.500276660601983*^9}, {3.500277025585555*^9, 3.500277091391465*^9}, {
   3.5002780368526697`*^9, 3.5002780654857283`*^9}, {3.500278421353421*^9, 
   3.50027842828113*^9}, 3.500278734338067*^9, 3.500278830145061*^9, {
   3.5464213936526537`*^9, 3.5464213975117893`*^9}, {3.546530490809856*^9, 
   3.5465305476311417`*^9}, {3.587293706443413*^9, 3.587293736754099*^9}, {
   3.722561724538144*^9, 3.7225617349917927`*^9}},
 CellLabel->
  "In[1211]:=",ExpressionUUID->"90a0f431-50dd-4234-8a90-cbc10241acb1"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exponential of a general superoperator", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4304561910901012`*^9, 3.4304562067434273`*^9}, 3.430456552671953*^9, {
   3.430926883375671*^9, 3.430926889628784*^9}, {3.4310578465121937`*^9, 
   3.431057890780332*^9}, {3.431058346511351*^9, 3.431058374930328*^9}, 
   3.431071820108408*^9, {3.435239507168541*^9, 3.435239510988324*^9}, 
   3.4526676754453373`*^9, {3.4526689068670673`*^9, 3.452668916563645*^9}, {
   3.458993577458222*^9, 3.458993586760363*^9}, {3.458993732379373*^9, 
   3.45899373348205*^9}},ExpressionUUID->"5dcf470b-4407-42a3-9cda-\
878c22a51766"],

Cell["\<\
case of a superoperator which is not expressed as an InterpolationFunction\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.621246878973669*^9, 
  3.621246892023731*^9}},ExpressionUUID->"20742fe0-3550-43b0-a97c-\
a25ed530b922"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{"sop_", "?", "SuperoperatorQ"}], "]"}], "|", 
     RowBox[{"E", "^", 
      RowBox[{"sop_", "?", "SuperoperatorQ"}]}]}], ",", "opbasis_", ",", 
    "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"MatrixExp", "[", "\[IndentingNewLine]", 
    RowBox[{"SuperoperatorMatrixRepresentation", "[", 
     RowBox[{"sop", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}], 
    "\[IndentingNewLine]", "]"}], "/;", 
   RowBox[{"!", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"sop", ",", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"Superoperator", "[", 
        RowBox[{
         RowBox[{"_InterpolatingFunction", "[", "_", "]"}], ",", "___"}], 
        "]"}]}]}], "]"}]}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435240920497623*^9}, {3.435241098673073*^9, 3.435241134326395*^9}, {
   3.435241491679801*^9, 3.435241512547866*^9}, {3.435242322165255*^9, 
   3.4352423248047323`*^9}, {3.435250726932569*^9, 3.435250729367881*^9}, {
   3.435251391007934*^9, 3.435251392468975*^9}, {3.452667690265827*^9, 
   3.452667778634954*^9}, {3.4526687975002527`*^9, 3.4526688894085627`*^9}, {
   3.458993592421362*^9, 3.458993603589711*^9}, 3.458993692154749*^9, {
   3.458993739068191*^9, 3.458993778031763*^9}, {3.467189163721871*^9, 
   3.467189164147138*^9}, 3.586179970724949*^9, {3.589263461346233*^9, 
   3.589263469141415*^9}, {3.621246918251912*^9, 3.62124694259575*^9}},
 CellLabel->
  "In[1212]:=",ExpressionUUID->"de59ce28-3b8c-493e-a730-fd797ef8202e"],

Cell["\<\
case of a superoperator expressed as an InterpolationFunction\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.621246878973669*^9, 3.621246892023731*^9}, 
   3.621246962442224*^9},ExpressionUUID->"fee9002a-a007-41e6-81a5-\
c8b49c64ac13"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Exp", "[", 
        RowBox[{"HoldPattern", "@", 
         RowBox[{"Superoperator", "[", 
          RowBox[{
           RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
           "opbasis_", ",", "basis1_", ",", "___"}], "]"}]}], "]"}], "|", 
       RowBox[{"E", "^", 
        RowBox[{"(", 
         RowBox[{"HoldPattern", "@", 
          RowBox[{"Superoperator", "[", 
           RowBox[{
            RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
            "opbasis_", ",", "basis1_", ",", "___"}], "]"}]}], ")"}]}]}], ",",
       "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"_", "?", "MatrixQ"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{"ifunc", ",", 
      RowBox[{
       RowBox[{"mat_", "?", "MatrixQ"}], "\[RuleDelayed]", 
       RowBox[{"MatrixExp", "[", "mat", "]"}]}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435240920497623*^9}, {3.435241098673073*^9, 3.435241134326395*^9}, {
   3.435241491679801*^9, 3.435241512547866*^9}, {3.435242322165255*^9, 
   3.4352423248047323`*^9}, {3.435250726932569*^9, 3.435250729367881*^9}, {
   3.435251391007934*^9, 3.435251392468975*^9}, {3.452667690265827*^9, 
   3.452667778634954*^9}, {3.4526687975002527`*^9, 3.4526688894085627`*^9}, {
   3.458993592421362*^9, 3.458993603589711*^9}, 3.458993692154749*^9, {
   3.458993739068191*^9, 3.458993778031763*^9}, {3.467189163721871*^9, 
   3.467189164147138*^9}, 3.586179970724949*^9, {3.589263461346233*^9, 
   3.589263469141415*^9}, {3.621246918251912*^9, 3.62124694259575*^9}, {
   3.621246997748476*^9, 3.621247127941729*^9}},
 CellLabel->
  "In[1213]:=",ExpressionUUID->"1e30d96d-2c04-46a6-a6c3-5c77bdee18b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Exp", "[", 
        RowBox[{"HoldPattern", "@", 
         RowBox[{"Superoperator", "[", 
          RowBox[{
           RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
           "opbasis_", ",", "basis1_", ",", "___"}], "]"}]}], "]"}], "|", 
       RowBox[{"E", "^", 
        RowBox[{"(", 
         RowBox[{"HoldPattern", "@", 
          RowBox[{"Superoperator", "[", 
           RowBox[{
            RowBox[{"ifunc_InterpolatingFunction", "[", "t_", "]"}], ",", 
            "opbasis_", ",", "basis1_", ",", "___"}], "]"}]}], ")"}]}]}], ",",
       "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Depth", "[", "ifunc", "]"}], "\[GreaterEqual]", "3"}], ")"}], 
     "&&", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ifunc", "[", 
        RowBox[{"ifunc", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "MatrixQ"}], ",", "_List", ",", 
         RowBox[{"_", "?", "MatrixQ"}]}], "}"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Replace", "[", 
     RowBox[{"ifunc", ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"X_", "?", "MatrixQ"}], ",", "D_List", ",", 
         RowBox[{"Xinv_", "?", "MatrixQ"}]}], "}"}], "\[RuleDelayed]", 
       RowBox[{"X", ".", 
        RowBox[{"DiagonalMatrix", "[", 
         RowBox[{"MatrixExp", "[", "D", "]"}], "]"}], ".", "Xinv"}]}], ",", 
      RowBox[{"{", "3", "}"}]}], "]"}], "[", "t", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240753699629*^9, 3.4352407791819696`*^9}, {
   3.435240820139839*^9, 3.435240831963512*^9}, {3.435240862222262*^9, 
   3.435240920497623*^9}, {3.435241098673073*^9, 3.435241134326395*^9}, {
   3.435241491679801*^9, 3.435241512547866*^9}, {3.435242322165255*^9, 
   3.4352423248047323`*^9}, {3.435250726932569*^9, 3.435250729367881*^9}, {
   3.435251391007934*^9, 3.435251392468975*^9}, {3.452667690265827*^9, 
   3.452667778634954*^9}, {3.4526687975002527`*^9, 3.4526688894085627`*^9}, {
   3.458993592421362*^9, 3.458993603589711*^9}, 3.458993692154749*^9, {
   3.458993739068191*^9, 3.458993778031763*^9}, {3.467189163721871*^9, 
   3.467189164147138*^9}, 3.586179970724949*^9, {3.589263461346233*^9, 
   3.589263469141415*^9}, {3.621246918251912*^9, 3.62124694259575*^9}, {
   3.621246997748476*^9, 3.621247127941729*^9}, {3.621247159600204*^9, 
   3.621247208797278*^9}},
 CellLabel->
  "In[1214]:=",ExpressionUUID->"0a7ad4df-869f-4211-baec-3149b214ba54"]
}, Closed]],

Cell[CellGroupData[{

Cell["use direct method if no special Automatic method exists", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456369810807*^9, 3.430456391358386*^9}, 
   3.430456556431728*^9, {3.4305643986149607`*^9, 3.430564400498064*^9}, {
   3.430566885906928*^9, 3.430566886703034*^9}, {3.431058412294199*^9, 
   3.431058420738549*^9}, {3.431058915224729*^9, 3.4310589171922903`*^9}, {
   3.431058950550519*^9, 3.431058955459968*^9}, {3.4352395444378967`*^9, 
   3.4352395512201853`*^9}, {3.4352396084061203`*^9, 
   3.4352396468492527`*^9}, {3.435239945449224*^9, 3.43523994881136*^9}, {
   3.435240497650125*^9, 3.435240501008383*^9}, {3.4352405571637793`*^9, 
   3.435240570512993*^9}, {3.435240609677824*^9, 
   3.435240616449388*^9}},ExpressionUUID->"a581282f-f7f3-4b35-8dbd-\
f03e6d365bbb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{"sop_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"SuperoperatorMatrixRepresentation", "[", 
    RowBox[{"sop", ",", "opbasis", ",", "basis", ",", 
     RowBox[{"Method", "\[Rule]", "\"\<Direct\>\""}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.435240583909328*^9, 3.435240603002202*^9}, {
  3.558597961726952*^9, 3.558597964130342*^9}, {3.6213472983637657`*^9, 
  3.621347304356944*^9}, {3.6213487249999447`*^9, 3.621348727956588*^9}},
 CellLabel->
  "In[1215]:=",ExpressionUUID->"cf8957f1-4400-47ad-b7a7-065a5d373f9d"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["calculations using Method\[Rule] \[OpenCurlyDoubleQuote]Direct\
\[CloseCurlyDoubleQuote]", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456369810807*^9, 3.430456391358386*^9}, 
   3.430456556431728*^9, {3.4305643986149607`*^9, 3.430564400498064*^9}, {
   3.430566885906928*^9, 3.430566886703034*^9}, {3.431058412294199*^9, 
   3.431058420738549*^9}, {3.431058915224729*^9, 3.4310589171922903`*^9}, {
   3.435239416356996*^9, 3.435239446852498*^9}, {3.558597970204129*^9, 
   3.5585979723992157`*^9}},ExpressionUUID->"7aba4dbf-63f7-4790-b04e-\
a0721463a672"],

Cell["\<\
Use Liouville bracket and the relevant MatrixRepresentations of the \
operators. This should always work but can be slow. \
\>", "Text",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.43523990199058*^9, 3.435239923027184*^9}, {
  3.435242362797196*^9, 
  3.435242373074333*^9}},ExpressionUUID->"a4ca7cbd-658d-4754-b7b7-\
c19b2ab25f1a"],

Cell["\<\
memorize the MatrixRepresentations of all BasisOperators since they will \
probably be needed again\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5465340810987186`*^9, 3.546534105979957*^9}, {
  3.5465346795239058`*^9, 
  3.546534679914092*^9}},ExpressionUUID->"6f8ae18c-5acc-4a7f-8fe3-\
cca5e0a970d7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SuperoperatorMatrixRepresentation", "[", 
   RowBox[{"sop_", ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], 
   "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "n", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"OperatorBasisDimension", "[", "opbasis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"FreeQ", "[", 
            RowBox[{"#", ",", "$Failed"}], "]"}], ",", 
           RowBox[{"SparseArray", "[", "#", "]"}], ",", "$Failed"}], "]"}], 
         "&"}], "@", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"FixedPoint", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"ExpToTrig", "[", 
              RowBox[{"PowerExpand", "[", 
               RowBox[{"Simplify", "[", "#", "]"}], "]"}], "]"}], "&"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"LiouvilleBracket", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"BasisOperatorMatrixRepresentations", "[", 
                RowBox[{"opbasis", ",", "basis"}], "]"}], 
               "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"MatrixRepresentation", "[", 
               RowBox[{
                RowBox[{"sop", "[", 
                 RowBox[{
                  RowBox[{"BasisOperators", "[", "opbasis", "]"}], 
                  "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
                 "]"}], ",", "basis"}], "]"}]}], "\[IndentingNewLine]", 
             "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "n"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", "n"}], "}"}]}], "\[IndentingNewLine]", 
         "]"}]}]}], "\[IndentingNewLine]", ")"}]}], "]"}], "/;", 
   RowBox[{"MatchQ", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Method", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "SuperoperatorMatrixRepresentation", "]"}]}], 
     ",", "\"\<Direct\>\""}], "]"}]}]}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456036023714*^9, 3.43045611027256*^9}, {
   3.4305650750552273`*^9, 3.430565077965583*^9}, {3.430566896470188*^9, 
   3.430566899378647*^9}, {3.43105843999332*^9, 3.431058461190651*^9}, {
   3.431058502991736*^9, 3.4310585825002747`*^9}, 3.431058612835156*^9, {
   3.4310586453634768`*^9, 3.431058744314518*^9}, {3.431058783679401*^9, 
   3.43105886189494*^9}, {3.4310593286282988`*^9, 3.431059342908546*^9}, 
   3.431065553890624*^9, {3.431072803683929*^9, 3.43107281084464*^9}, {
   3.4310910634472713`*^9, 3.431091066131407*^9}, {3.431096670802123*^9, 
   3.431096768165139*^9}, {3.431096830424754*^9, 3.431096837620756*^9}, {
   3.439556336345037*^9, 3.439556343131435*^9}, {3.452668327430307*^9, 
   3.452668330670491*^9}, 3.458993836889963*^9, {3.467189176293356*^9, 
   3.467189176622834*^9}, {3.546533926214383*^9, 3.546534041883003*^9}, 
   3.5465342018510923`*^9, {3.546534239031472*^9, 3.546534252420114*^9}, {
   3.558597977937634*^9, 3.55859798016778*^9}, {3.586179978875102*^9, 
   3.5861799795704937`*^9}, {3.5872930931583233`*^9, 3.587293136503037*^9}},
 CellLabel->
  "In[1216]:=",ExpressionUUID->"753f114b-2b8c-4458-b1fb-2c886cc9fece"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasisOperatorMatrixRepresentations", "[", 
    RowBox[{"opbasis_", ",", "basis_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"BasisOperatorMatrixRepresentations", "[", 
      RowBox[{"opbasis", ",", "basis"}], "]"}], "=", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"#", ",", "basis"}], "]"}], "&"}], "/@", 
       RowBox[{"BasisOperators", "[", "opbasis", "]"}]}], ")"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5465341188259277`*^9, 3.546534189693144*^9}},
 CellLabel->
  "In[1217]:=",ExpressionUUID->"7272cad2-3999-44ff-b8a1-7be88dfe6b87"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.467190179156166*^9, 
  3.4671901805610447`*^9}},ExpressionUUID->"44fef391-5fa2-4557-a26d-\
426c0724738a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperoperatorMatrixRepresentation", "::", "badsop"}], "=", 
   "\"\<SuperoperatorMatrixRepresentation may only be applied to a \
superoperator.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5319303977523413`*^9, 3.5319304432399893`*^9}, {
  3.531930565502164*^9, 3.531930609933118*^9}},
 CellLabel->
  "In[1218]:=",ExpressionUUID->"5e2e1640-9efc-4646-8d48-01bd9b06ad30"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["SphericalTensorIndices", "Subchapter",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.501995486271854*^9, 3.5023228434920187`*^9, {3.6392871914926577`*^9, 
   3.639287195657621*^9}},ExpressionUUID->"2c4f9047-a583-4ea6-a8dc-\
722715bc7945"],

Cell["extension of QM`SpinOperators", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.682609360277853*^9, 
  3.682609373352352*^9}},ExpressionUUID->"77eff3a1-7485-495d-acac-\
24678a25d312"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 3.468059115613844*^9}, {
  3.639289659883665*^9, 3.639289661656825*^9}, {3.639290037817692*^9, 
  3.6392900385834293`*^9}},ExpressionUUID->"c4e81e6f-d608-45cb-9ada-\
685b2bebe0b4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalTensorIndices", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.570342549538795*^9, {3.621243820894185*^9, 3.62124383739154*^9}, 
   3.6305694259241333`*^9, 3.630581965935542*^9, 3.639287233063415*^9},
 CellLabel->
  "In[1219]:=",ExpressionUUID->"ddc41615-93c2-4de9-b985-321b61e24768"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensorIndices", "[", 
    RowBox[{"opb_", "?", "DefinedOperatorBasisQ"}], "]"}], "/;", 
   RowBox[{"!", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"opb", ",", "_SphericalTensorOperatorBasis"}], "]"}]}]}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Message", "[", 
     RowBox[{
      RowBox[{"SphericalTensorIndices", "::", "notSTOB"}], ",", "opb"}], 
     "]"}], ";", "$Failed"}], ")"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639290294104557*^9, 3.6392903375005198`*^9}, {
  3.6392905342798147`*^9, 3.639290535628099*^9}},
 CellLabel->
  "In[1220]:=",ExpressionUUID->"21237adb-05a1-481c-a48a-3e46fc6e8fa9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SphericalTensorIndices", "[", "arg_", "]"}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"OperatorQ", "[", "arg", "]"}]}], "&&", 
     RowBox[{"!", 
      RowBox[{"DefinedOperatorBasisQ", "[", "arg", "]"}]}], "&&", 
     RowBox[{"!", 
      RowBox[{"NumericQ", "[", "arg", "]"}]}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SphericalTensorIndices", "::", "notop"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6392897443588142`*^9, 3.6392898061011667`*^9}, {
  3.639290095483926*^9, 3.639290096119156*^9}, {3.639290382611416*^9, 
  3.6392903915608387`*^9}, {3.6392904581506863`*^9, 3.6392904842569523`*^9}, {
  3.639290797918363*^9, 3.639290802115533*^9}},
 CellLabel->
  "In[1221]:=",ExpressionUUID->"071903ea-f117-4cfd-902b-8981c979ebcc"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to an Operator", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 3.468059115613844*^9}, {
  3.639289659883665*^9, 3.639289661656825*^9}, {3.639290037817692*^9, 
  3.63929004807941*^9}},ExpressionUUID->"50e6100a-5a2b-46ab-aaaf-\
0799011b1067"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensorIndices", "[", 
    RowBox[{"n_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"SphericalTensorIndices", "[", 
    RowBox[{"n", "*", 
     RowBox[{"UnityOperator", "[", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639290699783683*^9, 3.639290724627981*^9}},
 CellLabel->
  "In[1222]:=",ExpressionUUID->"5f4d1f2c-62e0-4aca-9651-f394f9ee8aa8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensorIndices", "[", 
    RowBox[{"op_", "?", "OperatorQ"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "opvecrep", ",", "stob", ",", "stob\[Lambda]\[Mu]vals", ",", 
       "\[Lambda]\[Mu]vals"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"stob", "=", 
        RowBox[{"SphericalTensorOperatorBasis", "[", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"stob\[Lambda]\[Mu]vals", "=", 
        RowBox[{"SphericalTensorIndices", "[", "stob", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"opvecrep", "=", 
        RowBox[{"OperatorVectorRepresentation", "[", 
         RowBox[{"op", ",", "stob"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "#", "]"}], "\[Equal]", "1"}], ",", 
           RowBox[{"First", "[", "#", "]"}], ",", "#"}], "]"}], "&"}], "@", 
        "\[IndentingNewLine]", 
        RowBox[{"Union", "@", 
         RowBox[{"Pick", "[", 
          RowBox[{"stob\[Lambda]\[Mu]vals", ",", "opvecrep", ",", 
           RowBox[{"_", "?", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"Chop", "[", "#", "]"}], "\[NotEqual]", "0"}], "&"}], 
             ")"}]}]}], "]"}]}]}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639287281767623*^9, 3.639287605218351*^9}, {
  3.639287693534243*^9, 3.639287693712034*^9}, {3.639288827653047*^9, 
  3.639288828578508*^9}},
 CellLabel->
  "In[1223]:=",ExpressionUUID->"8358fd17-da08-49bd-8341-8f88e4dcf0a0"]
}, Closed]],

Cell[CellGroupData[{

Cell["apply to an OperatorBasis", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 3.468059115613844*^9}, {
  3.639289659883665*^9, 3.639289661656825*^9}, {3.639290037817692*^9, 
  3.639290073166567*^9}},ExpressionUUID->"6addfd04-cadb-4bb6-bf0c-\
7c4b8c003346"],

Cell["\<\
The SphericalTensorIndices for the SphericalTensorOperatorBasis are defined \
when the BasisOperators are set up. So set up the BasisOperators and then \
reapply.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.639287986429844*^9, 3.639288071426682*^9}, {
  3.639288179270958*^9, 3.6392881904668407`*^9}, {3.639290439752389*^9, 
  3.6392904431074953`*^9}},ExpressionUUID->"18d28a13-80d3-4e4c-919a-\
438a56b39d70"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensorIndices", "[", "]"}], ":=", 
   RowBox[{"SphericalTensorIndices", "[", 
    RowBox[{"OperatorBasis", "[", "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639289713875662*^9, 3.6392897282979097`*^9}},
 CellLabel->
  "In[1224]:=",ExpressionUUID->"3d74777e-41a4-43f1-a2f3-cf82ae854e17"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
   "SphericalTensorIndices", "[", "stob_SphericalTensorOperatorBasis", "]"}], 
   ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"BasisOperators", "[", "stob", "]"}], ";", 
     RowBox[{"SphericalTensorIndices", "[", "stob", "]"}]}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639288055231292*^9, 3.639288168652732*^9}},
 CellLabel->
  "In[1225]:=",ExpressionUUID->"ee03ece4-a1dc-4436-9ef8-ed6f9031895c"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4680591120234423`*^9, 3.468059115613844*^9}, {
  3.639289659883665*^9, 
  3.639289661656825*^9}},ExpressionUUID->"3ba0360e-9bb5-433a-91c1-\
c3e225a4c180"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensorIndices", "::", "notSTOB"}], "=", 
   "\"\<The operator basis `1` is not a SphericalTensorOperatorBasis.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639289669904366*^9, 3.6392897026344967`*^9}, {
   3.639289915312545*^9, 3.639289925714033*^9}, {3.6392901007643557`*^9, 
   3.63929010818264*^9}, {3.639290354911653*^9, 3.639290368447178*^9}, {
   3.639290504049471*^9, 3.639290525062148*^9}, 3.639290919579286*^9},
 CellLabel->
  "In[1226]:=",ExpressionUUID->"2c97ef85-7ffd-48a2-b76b-0f60baa9381b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SphericalTensorIndices", "::", "notop"}], "=", 
   "\"\<SphericalTensorIndices may only be applied to an operator or to a \
SphericalTensorOperatorBasis.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.639289669904366*^9, 3.6392897026344967`*^9}, {
   3.639289915312545*^9, 3.639289925714033*^9}, {3.6392901007643557`*^9, 
   3.63929010818264*^9}, 3.639290400026977*^9, 3.63929091724078*^9},
 CellLabel->
  "In[1227]:=",ExpressionUUID->"0cd4473f-b6c1-4002-bc01-d717e0fd630a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Subchapter",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"95fe1f38-4dd4-4a5f-9435-fc53c2270b9d"],

Cell["\<\
End[];
EndPackage[];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True,
 CellLabel->
  "In[1228]:=",ExpressionUUID->"5cc4be56-5e1e-4a3d-b1df-caba4f15f20e"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["history", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 CellChangeTimes->{
  3.682593334636269*^9, {3.69926171587668*^9, 3.69926172886936*^9}, {
   3.69926187929764*^9, 3.6992618809832497`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"3ec672e0-2058-4705-994e-1d0a5ef89017"],

Cell[CellGroupData[{

Cell["pre-3.0.0 release", "Subchapter",
 CellChangeTimes->{{3.699893847218297*^9, 
  3.6998938586025133`*^9}},ExpressionUUID->"eda4c879-700f-4001-a9ca-\
81771b541378"],

Cell[CellGroupData[{

Cell["170325 changes incorporated into v3.0.0b10", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, {3.699431078767263*^9, 
   3.699431081637733*^9}},ExpressionUUID->"c4dd104e-b85c-4ab2-b8ad-\
85157f4a4b81"],

Cell["MHL: enhanced functionality of DefineOperatorBasis", "Text",
 CellChangeTimes->{{3.69926175435175*^9, 3.699261757748476*^9}, {
  3.699261851554613*^9, 3.699261868878986*^9}, {3.6992619536498957`*^9, 
  3.699261955299312*^9}, {3.699267524378593*^9, 3.6992675263453903`*^9}, {
  3.699431085616239*^9, 
  3.6994311042749166`*^9}},ExpressionUUID->"55d63191-1a6d-4ef0-acff-\
d726786671d2"],

Cell["\<\
MHL: QM>SpinSuperoperators called when QM>Liouville is loaded.\
\>", "Text",
 CellChangeTimes->{{3.69926175435175*^9, 3.699261757748476*^9}, {
  3.699261851554613*^9, 3.699261868878986*^9}, {3.6992619536498957`*^9, 
  3.699261955299312*^9}, {3.699267524378593*^9, 3.6992675263453903`*^9}, {
  3.699431085616239*^9, 3.6994311042749166`*^9}, {3.69943446722237*^9, 
  3.69943451351608*^9}},ExpressionUUID->"91c1f003-cabf-4896-8c2a-\
8a75fcb902f8"],

Cell["\<\
MHL: QM>SpinSuperoperators>LiouvilleBracket (part 2) and \
SuperoperatorMatrixRepresentation moved into QM>Liouville \
\>", "Text",
 CellChangeTimes->{{3.69926175435175*^9, 3.699261757748476*^9}, {
  3.699261851554613*^9, 3.699261868878986*^9}, {3.6992619536498957`*^9, 
  3.699261955299312*^9}, {3.699267524378593*^9, 3.6992675263453903`*^9}, {
  3.699431085616239*^9, 3.6994311042749166`*^9}, {3.69943446722237*^9, 
  3.69943451351608*^9}, {3.6994348849628563`*^9, 3.699434905419281*^9}, {
  3.6994549626990957`*^9, 
  3.699454972481338*^9}},ExpressionUUID->"b1fedf78-5f33-435b-a6c4-\
a03a2054b718"]
}, Closed]],

Cell[CellGroupData[{

Cell["170327 changes incorporated into v3.0.0b11", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, {3.699431078767263*^9, 
   3.699431081637733*^9}, {3.699622810537648*^9, 
   3.699622815128627*^9}},ExpressionUUID->"6c4310a4-01b5-4ceb-a3bb-\
e278ad7b5bdf"],

Cell["\<\
MHL: Adjustments to DefineOperatorBasis and OperatorBasisTransformationMatrix \
to address 170327-MHL-300b10-DefineOperatorBasis\
\>", "Text",
 CellChangeTimes->{{3.69926175435175*^9, 3.699261757748476*^9}, {
  3.699261851554613*^9, 3.699261868878986*^9}, {3.6992619536498957`*^9, 
  3.699261955299312*^9}, {3.699267524378593*^9, 3.6992675263453903`*^9}, {
  3.699431085616239*^9, 3.6994311042749166`*^9}, {3.6996228248040648`*^9, 
  3.699622839947994*^9}, {3.6996417463988256`*^9, 
  3.699641756071595*^9}},ExpressionUUID->"ebeec524-2c44-4b1c-9f56-\
1e196f3e9a9e"]
}, Closed]],

Cell[CellGroupData[{

Cell["170330 changes incorporated into v3.0.0b12", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, {3.699431078767263*^9, 
   3.699431081637733*^9}, {3.699622810537648*^9, 3.699622815128627*^9}, {
   3.6998938093116617`*^9, 3.699893809517741*^9}, 
   3.699894242586636*^9},ExpressionUUID->"9614d31f-a7e0-41ee-838f-\
d5ccc7a534ee"],

Cell["\<\
MHL: coding changes to debug 170328-MHL-300b11-SetOperatorBasis\
\>", "Text",
 CellChangeTimes->{{3.69926175435175*^9, 3.699261757748476*^9}, {
  3.699261851554613*^9, 3.699261868878986*^9}, {3.6992619536498957`*^9, 
  3.699261955299312*^9}, {3.699267524378593*^9, 3.6992675263453903`*^9}, {
  3.699431085616239*^9, 3.6994311042749166`*^9}, {3.6996228248040648`*^9, 
  3.699622839947994*^9}, {3.6996417463988256`*^9, 3.699641756071595*^9}, {
  3.699893816982048*^9, 3.699893835543169*^9}, {3.699894248065153*^9, 
  3.6998942497920227`*^9}},ExpressionUUID->"467c5dde-c69c-4def-bb36-\
843bac5c1cda"],

Cell["\<\
MHL: QM`SpinSuperoperators code now incorporated into QM`Liouville. There was \
too much referencing in both directions to make it feasible or desirable to \
have 2 packages.\
\>", "Text",
 CellChangeTimes->{{3.701150988029005*^9, 
  3.701151051644752*^9}},ExpressionUUID->"d51d277b-bfd8-4bd6-bdc4-\
f51c79d910af"]
}, Closed]],

Cell[CellGroupData[{

Cell["170425 changes incorporated into v3.0.0b12", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, {3.699431078767263*^9, 
   3.699431081637733*^9}, {3.699622810537648*^9, 3.699622815128627*^9}, {
   3.6998938093116617`*^9, 3.699893809517741*^9}, 3.699894242586636*^9, {
   3.7021036511189885`*^9, 
   3.702103655139848*^9}},ExpressionUUID->"3416d202-98d7-48f5-b259-\
fc7f2bf779d8"],

Cell["\<\
CB: There was an error with OperatorBasisTransformationMatrix for \
\[OpenCurlyDoubleQuote]case where the starting basis is the canonical \
ZeemanKetBraOperatorBasis, and the target basis is also in canonical order\
\[CloseCurlyDoubleQuote], a conjugate was included to fix the problem. 

indicated by light orange.\
\>", "Text",
 CellChangeTimes->{{3.69926175435175*^9, 3.699261757748476*^9}, {
  3.699261851554613*^9, 3.699261868878986*^9}, {3.6992619536498957`*^9, 
  3.699261955299312*^9}, {3.699267524378593*^9, 3.6992675263453903`*^9}, {
  3.699431085616239*^9, 3.6994311042749166`*^9}, {3.6996228248040648`*^9, 
  3.699622839947994*^9}, {3.6996417463988256`*^9, 3.699641756071595*^9}, {
  3.699893816982048*^9, 3.699893835543169*^9}, {3.699894248065153*^9, 
  3.6998942497920227`*^9}, {3.7021036621898603`*^9, 3.702103693999477*^9}, {
  3.7027768932105255`*^9, 
  3.7027768987794847`*^9}},ExpressionUUID->"909cf5a5-4da8-41ad-b5cd-\
22e1701a2984"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
170717 changes incorporated into v3.0.0b16 to resolve bug \[Rule] \
170215-MHL-300b6-OperatorBasis [CB]\
\>", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, {3.699431078767263*^9, 
   3.699431081637733*^9}, {3.699622810537648*^9, 3.699622815128627*^9}, {
   3.6998938093116617`*^9, 3.699893809517741*^9}, 3.699894242586636*^9, {
   3.7021036511189885`*^9, 3.702103655139848*^9}, {3.7092917009429665`*^9, 
   3.709291728291109*^9}},ExpressionUUID->"36481c18-cef8-4da2-a7e4-\
397c56a14dce"],

Cell["\<\
Changed coding of CheckOperatorBasis[OpBasis] to work significantly faster. \
The change is indicated by light green.\
\>", "Text",
 CellChangeTimes->{{3.69926175435175*^9, 3.699261757748476*^9}, {
  3.699261851554613*^9, 3.699261868878986*^9}, {3.6992619536498957`*^9, 
  3.699261955299312*^9}, {3.699267524378593*^9, 3.6992675263453903`*^9}, {
  3.699431085616239*^9, 3.6994311042749166`*^9}, {3.6996228248040648`*^9, 
  3.699622839947994*^9}, {3.6996417463988256`*^9, 3.699641756071595*^9}, {
  3.699893816982048*^9, 3.699893835543169*^9}, {3.699894248065153*^9, 
  3.6998942497920227`*^9}, {3.7021036621898603`*^9, 3.702103693999477*^9}, {
  3.7027768932105255`*^9, 3.7027768987794847`*^9}, {3.70929173045975*^9, 
  3.7092917600443954`*^9}},ExpressionUUID->"7d13af7f-ecaa-4304-93f1-\
dccd9910bec7"]
}, Closed]],

Cell[CellGroupData[{

Cell["170718 changes incorporated into v3.0.0b18", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, {3.699431078767263*^9, 
   3.699431081637733*^9}, {3.699622810537648*^9, 3.699622815128627*^9}, {
   3.6998938093116617`*^9, 3.699893809517741*^9}, 3.699894242586636*^9, {
   3.7021036511189885`*^9, 3.702103655139848*^9}, {3.7092917009429665`*^9, 
   3.709291728291109*^9}, {3.709388178112603*^9, 
   3.709388194664283*^9}},ExpressionUUID->"2b70ecce-04b0-4cc5-9d16-\
addb8750b532"],

Cell["\<\
HoldAll attribute for OperatorAmplitude; goes together with Polarization \
package changes\
\>", "Text",
 CellChangeTimes->{{3.709388197576847*^9, 
  3.7093882361209393`*^9}},ExpressionUUID->"d48c0523-cd73-49d6-a53b-\
b76e7fc94a65"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["3.0.x", "Subchapter",
 CellChangeTimes->{{3.699893847218297*^9, 3.6998938586025133`*^9}, {
  3.718520921196909*^9, 
  3.718520935917141*^9}},ExpressionUUID->"b78f458c-9f81-4fe5-84fe-\
0fa145805654"],

Cell[CellGroupData[{

Cell["171101 changes incorporated into v3.0.0b6", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, {3.699431078767263*^9, 
   3.699431081637733*^9}, {3.718520942511551*^9, 
   3.718520960044566*^9}},ExpressionUUID->"f4bf1b04-f78e-4bf5-9b43-\
23a252d7918a"],

Cell["\<\
CB: Changed the coding of ShiftAndPolarizationOperatorBasis
Changed the coding of CoherenceOrder sorting for \
ShiftAndPolarizationOperatorBasis & ShiftAndZOperatorBasis\
\>", "Text",
 CellChangeTimes->{{3.69926175435175*^9, 3.699261757748476*^9}, {
  3.699261851554613*^9, 3.699261868878986*^9}, {3.6992619536498957`*^9, 
  3.699261955299312*^9}, {3.699267524378593*^9, 3.6992675263453903`*^9}, {
  3.699431085616239*^9, 3.6994311042749166`*^9}, {3.7185209665452213`*^9, 
  3.718521009924595*^9}},ExpressionUUID->"06404b71-d644-414f-b4f8-\
4b2373464fd4"]
}, Closed]]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{808, 715},
WindowMargins->{{105, Automatic}, {62, Automatic}},
ShowCellLabel->True,
ShowCellTags->False,
Magnification:>0.9 Inherited,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 316, 8, 102, "Title",ExpressionUUID->"187063ca-7b27-4abf-9235-1dee47665ae7",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[908, 34, 340, 8, 72, "Subchapter",ExpressionUUID->"8e762383-fcd2-48b3-bd09-0e6feb622b1f",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1251, 44, 1247, 24, 232, "Input",ExpressionUUID->"ec2bcf2d-5229-401a-a1b6-5bbb430dfaba",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[2535, 73, 213, 6, 58, "Subchapter",ExpressionUUID->"118d0f74-f89e-4151-8ce4-4306cfca17e0",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[2773, 83, 226, 6, 7, "Section",ExpressionUUID->"548e2cf3-7328-40d3-ab05-b57997729384",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[3024, 93, 268, 7, 8, "Subsection",ExpressionUUID->"a068a122-616f-45e2-a955-661720ad6234",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[3295, 102, 505, 11, 18, "Input",ExpressionUUID->"2714060c-f730-4217-91a4-aea909ce15e2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[3837, 118, 219, 6, 6, "Subsection",ExpressionUUID->"a1ee4236-a9e2-48da-b737-924f0bdd0c34",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[4059, 126, 475, 12, 9, "Input",ExpressionUUID->"bc570312-46fe-40c4-a851-a5fa533218e9",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[4571, 143, 293, 7, 6, "Subsection",ExpressionUUID->"272aef9f-351b-43e7-94ab-16769be1ff92",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[4867, 152, 1903, 32, 129, "Input",ExpressionUUID->"c55c18ce-3498-41fd-99a1-73bb57dbb823",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[6807, 189, 293, 7, 6, "Subsection",ExpressionUUID->"4aebb580-fd78-41f1-9d3f-1eb212a90124",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[7103, 198, 400, 9, 18, "Input",ExpressionUUID->"2b5b27bb-ad78-4391-862c-66685660abc4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[7540, 212, 227, 6, 6, "Subsection",ExpressionUUID->"dbf5bfcb-83eb-481b-9a26-511cf3437a02",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[7770, 220, 477, 12, 12, "Input",ExpressionUUID->"60677553-ff4d-47d3-9ae7-e624f6a857c5",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8284, 237, 408, 9, 6, "Subsection",ExpressionUUID->"f8fb3f26-c295-48e4-bfac-273db67c7a2a",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[8695, 248, 586, 13, 18, "Input",ExpressionUUID->"301755ad-7196-40b0-ada2-81c7f39da810",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9318, 266, 224, 6, 6, "Subsection",ExpressionUUID->"f2afb4a5-4583-4803-a45e-553bb6cfe2d0",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[9545, 274, 377, 10, 18, "Input",ExpressionUUID->"d9482299-a45c-4225-b445-2644e676e93f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9959, 289, 226, 6, 6, "Subsection",ExpressionUUID->"9349f405-b6f7-4b6b-9f73-003dc02d947f",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[10188, 297, 447, 12, 4, "Input",ExpressionUUID->"516a4219-fbd3-458b-aec9-40e13dcf42e3",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[10672, 314, 298, 7, 6, "Subsection",ExpressionUUID->"cae6b226-1537-45f8-bebb-05a4d5cc1ee0",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[10973, 323, 574, 13, 11, "Input",ExpressionUUID->"1d14cc0b-558f-44a6-b863-82ca39fe3dee",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[11584, 341, 220, 6, 6, "Subsection",ExpressionUUID->"d8290326-4e06-466d-aa1b-6db19e268a42",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[11807, 349, 486, 12, 23, "Input",ExpressionUUID->"c1e35194-d5d1-4c00-aa1c-ae4f48fec4d1",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[12330, 366, 222, 6, 6, "Subsection",ExpressionUUID->"990eacb6-0b1a-42bc-87ea-8ede7800756b",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[12555, 374, 696, 15, 18, "Input",ExpressionUUID->"4c4d7bfd-89a1-47c0-9ba2-ef560c88c60c",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[13300, 395, 296, 7, 7, "Section",ExpressionUUID->"07507f15-2e55-4fde-9bcc-9c5a0480ecd1",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[13621, 406, 239, 6, 8, "Subsection",ExpressionUUID->"e85ddb60-6497-4454-a57c-a8d340d22367",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[13863, 414, 878, 17, 25, "Input",ExpressionUUID->"8d23864e-f895-4c17-98ae-07569e59c89f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[14778, 436, 301, 7, 6, "Subsection",ExpressionUUID->"033c2854-70f8-45b8-9c70-096698f43c31",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[15082, 445, 786, 16, 21, "Input",ExpressionUUID->"4ab2fb56-c1fa-48a2-a5ce-f9f275e30ca3",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[15905, 466, 228, 6, 6, "Subsection",ExpressionUUID->"8c825e3e-708d-4da4-9f2e-7c6d9bd30fcd",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[16136, 474, 888, 17, 21, "Input",ExpressionUUID->"cc30f1c3-64c8-4ed9-ae6e-b60971d17f00",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[17061, 496, 277, 7, 6, "Subsection",ExpressionUUID->"f701b516-f8b0-47ca-978b-be201877069e",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[17341, 505, 888, 17, 28, "Input",ExpressionUUID->"dad18d23-aba3-4aa0-98ec-329cc87b867c",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[18266, 527, 273, 7, 6, "Subsection",ExpressionUUID->"daacff1e-fecc-4ba3-95a9-09eafdcbcfa8",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[18542, 536, 1425, 24, 49, "Input",ExpressionUUID->"1cd42991-335c-4dd8-b480-f2eb5c7e8c8a",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20004, 565, 327, 8, 6, "Subsection",ExpressionUUID->"9bb61919-cd5f-4537-970d-9f4918264498",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[20334, 575, 946, 19, 25, "Input",ExpressionUUID->"37629684-89f9-4e21-8bf3-a18f4b29982f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[21329, 600, 318, 6, 7, "Section",ExpressionUUID->"fa957257-5c28-49d6-a55a-ce12e66cbefb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[21650, 608, 721, 16, 23, "Input",ExpressionUUID->"579e178b-9d8d-4a17-b871-4ac51ef4077a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[22408, 629, 326, 8, 7, "Section",ExpressionUUID->"d7584df1-c56c-4e5c-8fca-7d78426247d1",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[22737, 639, 550, 12, 28, "Input",ExpressionUUID->"0feaa58a-d210-4489-94db-240d02cf0cec",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[23324, 656, 209, 5, 7, "Section",ExpressionUUID->"f9d292b5-ee02-400c-a14a-93bad1915bca",
 InitializationCell->True,
 InitializationGroup->True],
Cell[23536, 663, 600, 12, 23, "Input",ExpressionUUID->"fa7f2987-9843-4eee-b3c3-b16204745b17",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[24173, 680, 267, 6, 7, "Section",ExpressionUUID->"ed16f514-0d82-48b8-af2c-31d27769715b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[24443, 688, 758, 15, 17, "Input",ExpressionUUID->"4e4feaf8-8c58-473f-8d2c-e3f42be05945",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[25238, 708, 410, 10, 7, "Section",ExpressionUUID->"fed9a1f9-fc91-421a-8eb8-d4d2f2f1a967",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[25651, 720, 1607, 27, 72, "Input",ExpressionUUID->"fd743d87-71ef-4733-8523-d24f519bcdcd",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[27295, 752, 314, 8, 7, "Section",ExpressionUUID->"a1b95aed-c89b-454d-92ee-1f3787f74cf2",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[27612, 762, 1613, 27, 39, "Input",ExpressionUUID->"11b03dc5-a773-423d-8c72-3af98db6c873",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[29262, 794, 146, 3, 8, "Section",ExpressionUUID->"c6bb8ca3-6385-4249-a68a-370815ae91e6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[29433, 801, 357, 8, 9, "Subsection",ExpressionUUID->"ae95a85d-4205-4fad-a402-a7ecb29ac4a0",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[29793, 811, 1669, 28, 74, "Input",ExpressionUUID->"b9ab0711-8dec-4db5-8fc7-19a8dbf4156a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[31465, 841, 492, 11, 17, "Input",ExpressionUUID->"f318b2b9-ce66-48b8-857f-f2bea5252800",
 InitializationCell->True],
Cell[31960, 854, 500, 11, 17, "Input",ExpressionUUID->"f4f01d5a-b77f-4915-8f9e-bf49840ec98c",
 InitializationCell->True],
Cell[32463, 867, 937, 19, 39, "Input",ExpressionUUID->"26b04a42-0227-4ddf-af48-4ca292d5c4e8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[33437, 891, 334, 8, 7, "Subsection",ExpressionUUID->"fd441cd3-9d11-4678-b315-380b9ab2439b",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[33774, 901, 469, 12, 13, "Input",ExpressionUUID->"ce109f7a-5fa7-42d8-a8f3-7a94c145cdd2",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[34280, 918, 363, 8, 7, "Subsection",ExpressionUUID->"815f9e47-f71d-44f9-a03d-44b24e4193dd",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[34646, 928, 528, 11, 8, "Input",ExpressionUUID->"4685b37b-4a64-4c20-8328-faf1eee8707f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[35211, 944, 224, 6, 7, "Subsection",ExpressionUUID->"52713970-be8d-40aa-9eac-ddfc71e86b54",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[35438, 952, 401, 11, 4, "Input",ExpressionUUID->"9cabbed0-7e0f-4f05-864c-ab5d990d0db9",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[35876, 968, 291, 7, 7, "Subsection",ExpressionUUID->"6435b168-8bd8-476f-a9e6-74ee6d6d1696",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[36170, 977, 448, 12, 4, "Input",ExpressionUUID->"8f00fbf2-ccda-46c5-9843-415f811db2ff",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[36655, 994, 230, 6, 7, "Subsection",ExpressionUUID->"61a95f21-0a98-48f7-8b9a-f88031f93f71",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[36888, 1002, 665, 14, 17, "Input",ExpressionUUID->"d577d5fc-89a2-4d81-aa10-1042a8d3b56a",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[37590, 1021, 307, 7, 7, "Subsection",ExpressionUUID->"61a95f21-0a98-48f7-8b9a-f88031f93f71",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[37900, 1030, 757, 15, 17, "Input",ExpressionUUID->"d577d5fc-89a2-4d81-aa10-1042a8d3b56a",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[38694, 1050, 308, 7, 7, "Subsection",ExpressionUUID->"61a95f21-0a98-48f7-8b9a-f88031f93f71",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[39005, 1059, 761, 15, 17, "Input",ExpressionUUID->"d577d5fc-89a2-4d81-aa10-1042a8d3b56a",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[39803, 1079, 236, 6, 7, "Subsection",ExpressionUUID->"5fe1345f-c71b-4171-bda1-2d3024bf7ebf",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[40042, 1087, 402, 10, 8, "Input",ExpressionUUID->"edf08cac-ac7f-43a7-879a-335acb90a4b6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[40481, 1102, 295, 7, 7, "Subsection",ExpressionUUID->"d5c3bec0-b8a5-4977-8e85-1fbbac55e282",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[40779, 1111, 542, 12, 11, "Input",ExpressionUUID->"50452506-1695-496a-9c6b-9fe583149308",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[41358, 1128, 413, 9, 7, "Subsection",ExpressionUUID->"4f4c0f0d-3b1a-4cbf-9206-da3cbb69c842",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[41774, 1139, 779, 16, 11, "Input",ExpressionUUID->"00ee9c17-d294-4379-ab81-3042f676651d",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[42590, 1160, 337, 8, 11, "Subsection",ExpressionUUID->"9e1c2b4e-d3cb-4fb6-9946-4f08a08fb078",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[42930, 1170, 2029, 33, 44, "Input",ExpressionUUID->"c63fe332-b1c6-4994-b32c-6e6c6d9e6d4e",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[44996, 1208, 367, 8, 7, "Subsection",ExpressionUUID->"e63cf1a7-edd0-4cd3-92b6-f9f35765779a",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[45366, 1218, 1382, 24, 62, "Input",ExpressionUUID->"62109f1c-093d-411d-b4b5-2dcad0cd3afd",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[46785, 1247, 387, 8, 7, "Subsection",ExpressionUUID->"74924616-01e9-4346-bd53-644e727ba249",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[47175, 1257, 795, 16, 12, "Input",ExpressionUUID->"bf2fd61e-f0d9-448f-9670-50286d972679",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[48007, 1278, 400, 9, 7, "Subsection",ExpressionUUID->"e02f9703-b8fe-4e42-aeef-965d01caaa03",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[48410, 1289, 1105, 21, 28, "Input",ExpressionUUID->"9859cfcd-1359-4911-82a8-a7ac15ff85dc",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[49564, 1316, 399, 9, 7, "Section",ExpressionUUID->"f6da1490-e755-4af9-84d5-c913a8fdd2ca",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[49988, 1329, 239, 6, 8, "Subsection",ExpressionUUID->"24667546-be9a-40a3-9cf7-6a6fc7f7e608",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[50230, 1337, 1523, 26, 38, "Input",ExpressionUUID->"a43c875b-6ec2-4484-94bc-b0fe72b1a2bb",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[51814, 1370, 211, 6, 44, "Subchapter",ExpressionUUID->"fa99ccdc-127c-4b57-9db3-8f5e0e31fb95",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[52028, 1378, 226, 6, 9, "Input",ExpressionUUID->"09cf0984-4fba-451b-9860-b22b7a115c70",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[52291, 1389, 174, 4, 44, "Subchapter",ExpressionUUID->"ecd8b176-1efe-4e10-8abe-94ffdd3692d9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[52490, 1397, 300, 7, 32, "Section",ExpressionUUID->"3bbcd1ba-4661-4efa-bfe7-300ae138b62c",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[52815, 1408, 292, 7, 8, "Subsection",ExpressionUUID->"24bae18d-4fe6-4143-a53c-b8d7babfff5e",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[53110, 1417, 267, 7, 5, "Text",ExpressionUUID->"7033ab28-d590-4b1d-b4be-820fdc9579ef",
 InitializationCell->True],
Cell[53380, 1426, 519, 11, 9, "Input",ExpressionUUID->"477f3baf-1140-41e8-9565-7dc4f05748be",
 InitializationCell->True],
Cell[53902, 1439, 547, 14, 14, "Input",ExpressionUUID->"b6414a09-1242-48ec-b06c-ef92907d7a80",
 InitializationCell->True],
Cell[54452, 1455, 1108, 26, 28, "Input",ExpressionUUID->"98e1395b-f6ac-427f-a5fa-b2201c6fabde",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[55597, 1486, 219, 6, 6, "Subsection",ExpressionUUID->"f68c566d-f3ac-434b-a8ac-54fd81aa143f",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[55819, 1494, 521, 14, 9, "Input",ExpressionUUID->"03260836-9110-4fe5-835c-5902f55392bf",
 InitializationCell->True,
 InitializationGroup->True],
Cell[56343, 1510, 475, 12, 9, "Input",ExpressionUUID->"4cbba03e-68c7-4ca7-8b01-6de4691f2d61",
 InitializationCell->True],
Cell[56821, 1524, 1745, 38, 38, "Input",ExpressionUUID->"1722f5e2-f856-4cd7-88f5-971ec7746d58",
 InitializationCell->True],
Cell[58569, 1564, 1888, 42, 42, "Input",ExpressionUUID->"e6e81d1f-73c2-4379-9b18-e4718c5d082a",
 InitializationCell->True],
Cell[60460, 1608, 1610, 36, 42, "Input",ExpressionUUID->"c325434a-0f28-4a64-804f-45e08ea4feee",
 InitializationCell->True],
Cell[62073, 1646, 435, 11, 9, "Input",ExpressionUUID->"d1a1f601-0c16-4b14-8ee1-4c2f8805c29c",
 InitializationCell->True],
Cell[62511, 1659, 571, 13, 9, "Input",ExpressionUUID->"469eff81-c596-47dd-90c7-f813facef9d8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[63085, 1674, 927, 18, 18, "Input",ExpressionUUID->"77408a0b-b477-46a0-8d4e-eeab419f820d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[64015, 1694, 639, 13, 14, "Input",ExpressionUUID->"d523acd1-8ab3-4c75-8665-ab6bd1e8767c",
 InitializationCell->True],
Cell[64657, 1709, 402, 10, 14, "Input",ExpressionUUID->"8b03a650-31e8-4b62-964f-64c677658c6c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[65096, 1724, 225, 6, 6, "Subsection",ExpressionUUID->"b415fee5-b097-41be-9a4a-58787105e70e",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[65346, 1734, 158, 3, 6, "Subsubsection",ExpressionUUID->"d1062567-ac53-445d-88ed-9673a2d13541"],
Cell[65507, 1739, 401, 11, 9, "Input",ExpressionUUID->"302423a5-b3f3-4d23-b89c-5177e0bdc1d6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[65945, 1755, 277, 4, 4, "Subsubsection",ExpressionUUID->"897b8276-023b-43e1-8bcf-3c042db68bf7"],
Cell[66225, 1761, 814, 20, 23, "Input",ExpressionUUID->"3d30fd2c-b48b-4992-9f49-1876feb0d958",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[67076, 1786, 304, 5, 4, "Subsubsection",ExpressionUUID->"4ac127f3-ac4e-4159-8ad6-fe648d74b9c3"],
Cell[67383, 1793, 1152, 28, 38, "Input",ExpressionUUID->"03096aeb-2fdb-464a-b5fa-70e8f07ec4a3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[68572, 1826, 391, 6, 4, "Subsubsection",ExpressionUUID->"ca70e748-ece9-42aa-8f45-998dc2db6b58"],
Cell[68966, 1834, 715, 19, 14, "Input",ExpressionUUID->"281832dc-2426-4e5c-8829-84d4a1ec53c8",
 InitializationCell->True],
Cell[69684, 1855, 848, 20, 18, "Input",ExpressionUUID->"10484e48-93d3-4cfb-ac9f-25efb25d015f",
 InitializationCell->True],
Cell[70535, 1877, 581, 14, 14, "Input",ExpressionUUID->"f675d2a3-0f22-4941-b834-69efd3497de0",
 InitializationCell->True],
Cell[71119, 1893, 845, 18, 23, "Input",ExpressionUUID->"d86aa196-229b-467f-8bfe-6bc7f45813dc",
 InitializationCell->True],
Cell[71967, 1913, 1129, 28, 28, "Input",ExpressionUUID->"d3e85f0e-e077-4037-854e-9e8b20bda8a4",
 InitializationCell->True],
Cell[73099, 1943, 1298, 32, 28, "Input",ExpressionUUID->"826eebd9-e08a-4306-83d9-50ba12760c92",
 InitializationCell->True],
Cell[74400, 1977, 1572, 38, 34, "Input",ExpressionUUID->"d4029c59-371f-4704-967c-2c25bc6af83e",
 InitializationCell->True],
Cell[75975, 2017, 5111, 111, 115, "Input",ExpressionUUID->"2bc8979c-562f-4522-bfe0-5ba18fcd8de4",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[81123, 2133, 282, 4, 6, "Subsubsection",ExpressionUUID->"131c12d4-7e03-47c2-b3c6-9401665b7ca8"],
Cell[81408, 2139, 3664, 80, 91, "Input",ExpressionUUID->"7cfc5b73-703a-46fe-a85d-1c2e210cb3da",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[85109, 2224, 158, 3, 6, "Subsubsection",ExpressionUUID->"8d4504ca-d6c7-436d-892e-f153d68abedc"],
Cell[85270, 2229, 305, 8, 9, "Input",ExpressionUUID->"e1ad9fd5-2a18-4f19-8250-bcf5a2e3308e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[85578, 2239, 346, 8, 9, "Input",ExpressionUUID->"6edf1edb-2a2e-4a48-ac26-ec7cc71df102",
 InitializationCell->True],
Cell[85927, 2249, 350, 8, 9, "Input",ExpressionUUID->"f328ad23-55bf-4e02-9105-af1d38836645",
 InitializationCell->True],
Cell[86280, 2259, 371, 10, 18, "Input",ExpressionUUID->"3dc9ed77-74d8-4ef2-8188-55f7f31ad656",
 InitializationCell->True,
 InitializationGroup->True],
Cell[86654, 2271, 406, 9, 18, "Input",ExpressionUUID->"eb0fd18d-5b2e-4a0c-8c80-97a4551b61ea",
 InitializationCell->True],
Cell[87063, 2282, 453, 10, 18, "Input",ExpressionUUID->"03cef53c-f404-4c14-a219-31eeeb465ef9",
 InitializationCell->True],
Cell[87519, 2294, 441, 10, 9, "Input",ExpressionUUID->"9755e8a0-7d88-40ca-934c-6f12b09bf033",
 InitializationCell->True],
Cell[87963, 2306, 553, 12, 28, "Input",ExpressionUUID->"135a780a-7c00-4599-b980-fab462b3ea1d",
 InitializationCell->True],
Cell[88519, 2320, 378, 9, 14, "Input",ExpressionUUID->"f114016c-d048-4f88-aa6c-ae2ab6d418ae",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[88946, 2335, 269, 7, 6, "Subsection",ExpressionUUID->"97823ce8-a2d5-43b0-bab3-901eb4e80803",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[89218, 2344, 516, 12, 14, "Input",ExpressionUUID->"6e4c37be-3181-4b9c-a817-5a7dea056e72",
 InitializationCell->True,
 InitializationGroup->True],
Cell[89737, 2358, 269, 8, 9, "Input",ExpressionUUID->"4ea1c0e5-0dc2-43a4-860a-b6398b9f34d6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[90043, 2371, 291, 7, 6, "Subsection",ExpressionUUID->"ae1a562e-0557-4b91-ab50-5f12d8222d79",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[90337, 2380, 225, 4, 5, "Text",ExpressionUUID->"f7adcab0-4035-4300-8779-e878749afdcd",
 InitializationCell->True],
Cell[90565, 2386, 313, 9, 9, "Input",ExpressionUUID->"6e85b082-51b1-4643-8bfd-391d19d3f38a",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[90915, 2400, 227, 6, 6, "Subsection",ExpressionUUID->"bda60a35-18f2-4756-8f89-0e86f95ea11d",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[91145, 2408, 428, 9, 5, "Text",ExpressionUUID->"ddfebf69-e85b-48bc-8525-70743c09e311",
 InitializationCell->True,
 InitializationGroup->True],
Cell[91576, 2419, 579, 15, 14, "Input",ExpressionUUID->"f8f5a62e-e1c7-451f-b818-ff33dde782e5",
 InitializationCell->True],
Cell[92158, 2436, 3170, 75, 81, "Input",ExpressionUUID->"f126d4e7-b68f-47ad-b143-e00c054e8b85",
 InitializationCell->True,
 InitializationGroup->True],
Cell[95331, 2513, 269, 8, 9, "Input",ExpressionUUID->"fc7df26d-e729-4454-9675-2ccd17b58c0d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[95603, 2523, 442, 10, 18, "Input",ExpressionUUID->"7c339d8a-fcf4-45c5-99c4-f845e18657e5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[96048, 2535, 565, 12, 14, "Input",ExpressionUUID->"c7b06a6e-783e-4c90-a10c-e7a6cad671f6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[96650, 2552, 222, 6, 6, "Subsection",ExpressionUUID->"5347247f-34c1-47f4-9e84-c4be01ef8b24",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[96897, 2562, 187, 4, 6, "Subsubsection",ExpressionUUID->"8b116b1f-4aa8-4165-8462-e60c7ec77a26",
 InitializationCell->True],
Cell[97087, 2568, 351, 10, 9, "Input",ExpressionUUID->"d9d7d6fa-cfe6-4c25-b86b-e18008568829",
 InitializationCell->True,
 InitializationGroup->True],
Cell[97441, 2580, 506, 15, 9, "Input",ExpressionUUID->"8cc1bf41-77d0-48c9-abf3-4dfcd54a91ca",
 InitializationCell->True,
 InitializationGroup->True],
Cell[97950, 2597, 518, 13, 9, "Input",ExpressionUUID->"1aae1e06-f0b2-45f1-acda-08e6f737f557",
 InitializationCell->True],
Cell[98471, 2612, 974, 25, 23, "Input",ExpressionUUID->"8287df2d-3111-41dc-8b68-5d44196afa91",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[99482, 2642, 300, 5, 6, "Subsubsection",ExpressionUUID->"0405437c-1612-4156-8bf8-392e0c0c5e7a",
 InitializationCell->True],
Cell[99785, 2649, 5754, 117, 163, "Input",ExpressionUUID->"6c57990f-0bf3-4f4c-a9ab-23a1e0db04da",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[105576, 2771, 349, 6, 4, "Subsubsection",ExpressionUUID->"d38d8109-7b09-401d-9f1b-e87ef701ebe5",
 InitializationCell->True],
Cell[105928, 2779, 210, 4, 5, "Text",ExpressionUUID->"c4814db0-1776-4c7b-a2e1-948dfdb0528c",
 InitializationCell->True],
Cell[106141, 2785, 6119, 124, 178, "Input",ExpressionUUID->"82ec7437-b84c-4fa7-b039-b20e1dbb0ab6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[112263, 2911, 182, 4, 5, "Text",ExpressionUUID->"61bd7455-453b-4d4e-a832-acea780f6006",
 InitializationCell->True],
Cell[112448, 2917, 3304, 65, 76, "Input",ExpressionUUID->"539e1da8-c9e7-466b-88c6-32c5fe276846",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[115789, 2987, 256, 5, 4, "Subsubsection",ExpressionUUID->"eb557164-0256-47e3-a60d-5ff5a2882911",
 InitializationCell->True],
Cell[116048, 2994, 542, 15, 8, "Input",ExpressionUUID->"4c92b840-17e5-447a-9f9e-85d9a3cdd260",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[116627, 3014, 187, 4, 4, "Subsubsection",ExpressionUUID->"665e7722-9314-40a7-be4d-c5210ad8534f",
 InitializationCell->True],
Cell[116817, 3020, 323, 9, 4, "Input",ExpressionUUID->"a4e129b6-e41e-444e-886b-475b77ae6fed",
 InitializationCell->True,
 InitializationGroup->True],
Cell[117143, 3031, 322, 9, 4, "Input",ExpressionUUID->"6f528e1f-29f4-451d-a5d1-f889890fbb4e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[117468, 3042, 503, 12, 17, "Input",ExpressionUUID->"c8d8dbe9-0980-4a9b-b6f6-4a5f8f62de0e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[117974, 3056, 354, 9, 12, "Input",ExpressionUUID->"7368852e-c982-412d-9e11-68b6158992cf",
 InitializationCell->True,
 InitializationGroup->True],
Cell[118331, 3067, 448, 11, 8, "Input",ExpressionUUID->"58f5e968-4c18-4295-a2fe-44f6fa4aa89c",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[118828, 3084, 224, 6, 6, "Subsection",ExpressionUUID->"1fb2d2cf-2913-4c1a-b1dc-15198d95d1bd",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[119055, 3092, 383, 10, 9, "Input",ExpressionUUID->"03c4efc5-d738-4ef5-ad1f-cd88b808760c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[119441, 3104, 683, 21, 18, "Input",ExpressionUUID->"15aa9204-ad8d-4ecc-93d9-a9647f81d4fb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[120127, 3127, 471, 13, 9, "Input",ExpressionUUID->"0f550219-57e1-4d63-9d8f-8818769ed42a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[120601, 3142, 385, 10, 9, "Input",ExpressionUUID->"ea8183b4-2ad5-4ccb-a98c-e3c85ce4e69b",
 InitializationCell->True],
Cell[120989, 3154, 5124, 125, 110, "Input",ExpressionUUID->"6e70d533-1700-4036-8942-b78bea0c2d3c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[126116, 3281, 1245, 31, 28, "Input",ExpressionUUID->"8daf37c8-52ef-4a44-83ff-eb3a8d68e91a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[127364, 3314, 323, 9, 9, "Input",ExpressionUUID->"0e5aca65-fb29-43fb-b73e-59c1062b0420",
 InitializationCell->True,
 InitializationGroup->True],
Cell[127690, 3325, 390, 10, 18, "Input",ExpressionUUID->"b8e69773-33e3-4d94-85ba-1c21c6905a2f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[128083, 3337, 391, 10, 18, "Input",ExpressionUUID->"424e31c9-6410-49a0-aef2-e07f79390e19",
 InitializationCell->True,
 InitializationGroup->True],
Cell[128477, 3349, 328, 9, 9, "Input",ExpressionUUID->"1ad79662-bd01-412e-a276-afe0672d2d17",
 InitializationCell->True,
 InitializationGroup->True],
Cell[128808, 3360, 424, 11, 18, "Input",ExpressionUUID->"5a9ba289-99a3-4b78-86d0-37ed2b6b25e0",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[129269, 3376, 220, 6, 6, "Subsection",ExpressionUUID->"bdf6c2bf-a021-4ada-8107-c034eb0d4431",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[129492, 3384, 820, 20, 14, "Input",ExpressionUUID->"0913c3d4-9aca-46a5-9e39-b12b93bb38f8",
 InitializationCell->True],
Cell[130315, 3406, 439, 12, 9, "Input",ExpressionUUID->"75a7b8dd-7caa-4286-91f7-638eb703578b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[130757, 3420, 1483, 32, 38, "Input",ExpressionUUID->"420a5675-a984-4d87-8227-65efb2deaf1b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[132277, 3457, 294, 7, 6, "Subsection",ExpressionUUID->"fff94417-0761-4a39-a493-7153a602eb6c",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[132574, 3466, 854, 20, 8, "Input",ExpressionUUID->"316d3397-60d8-4359-88e6-f1e2d8387210",
 InitializationCell->True],
Cell[133431, 3488, 500, 12, 4, "Input",ExpressionUUID->"0990139f-468b-4a48-8486-f21257e4d81f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[133934, 3502, 1579, 33, 25, "Input",ExpressionUUID->"b07ab127-0637-40c5-be25-0ee3ffcec584",
 InitializationCell->True],
Cell[135516, 3537, 545, 14, 8, "Input",ExpressionUUID->"0fd1fea3-9b12-46b3-b586-a04e6f5e49f6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[136098, 3556, 358, 8, 6, "Subsection",ExpressionUUID->"0d2183ae-2fec-4091-ba71-739b7c066015",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[136459, 3566, 375, 9, 4, "Input",ExpressionUUID->"cbfa1a73-9784-4219-9921-85297456dc4e",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[136883, 3581, 155, 3, 32, "Section",ExpressionUUID->"5343963f-f794-400a-b13a-df44cf0d2082",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[137063, 3588, 256, 6, 48, "Subsection",ExpressionUUID->"61be7320-21a9-4f14-96a3-e83647d19f57",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[137344, 3598, 170, 4, 6, "Subsubsection",ExpressionUUID->"3e4375f9-70ec-4993-a919-2fe64700c43e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[137517, 3604, 309, 7, 8, "Input",ExpressionUUID->"109db5ac-3fa8-4a92-8342-25e1bb6eee39",
 InitializationCell->True],
Cell[137829, 3613, 428, 11, 8, "Input",ExpressionUUID->"5ff5d20e-fe5e-4731-a0bc-828d2958bd5b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[138260, 3626, 753, 17, 17, "Input",ExpressionUUID->"2f52ea88-d4f4-4bdb-97af-046a255aeb55",
 InitializationCell->True],
Cell[139016, 3645, 325, 9, 8, "Input",ExpressionUUID->"e031a77a-9a07-48bb-ad0b-f5d2feceb873",
 InitializationCell->True,
 InitializationGroup->True],
Cell[139344, 3656, 390, 10, 8, "Input",ExpressionUUID->"2fdbfede-3da4-4c5a-bfc5-b348a3466369",
 InitializationCell->True,
 InitializationGroup->True],
Cell[139737, 3668, 739, 17, 13, "Input",ExpressionUUID->"2828d7b1-2d2f-451b-8327-8c09735c9071",
 InitializationCell->True,
 InitializationGroup->True],
Cell[140479, 3687, 615, 15, 13, "Input",ExpressionUUID->"158af395-ebed-4786-8039-8852a37f9ad3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[141097, 3704, 925, 25, 13, "Input",ExpressionUUID->"5470ec3b-363a-4324-b793-cc51c524e036",
 InitializationCell->True,
 InitializationGroup->True],
Cell[142025, 3731, 915, 28, 18, "Input",ExpressionUUID->"97f6deab-ac3d-4c9f-afdc-024d7b3221b8",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[142977, 3764, 183, 4, 4, "Subsubsection",ExpressionUUID->"c2eb7079-281f-4b7f-9112-eae55864d5a4",
 InitializationCell->True],
Cell[143163, 3770, 609, 15, 18, "Input",ExpressionUUID->"bd5f6476-4ba1-439d-a51d-403be970f8e5",
 InitializationCell->True],
Cell[143775, 3787, 872, 23, 18, "Input",ExpressionUUID->"e55b9574-01d7-45d1-b027-8b44167a7aad",
 InitializationCell->True],
Cell[144650, 3812, 990, 25, 18, "Input",ExpressionUUID->"3e16a59b-eb4b-4f5f-ab08-92b17733e06e",
 InitializationCell->True],
Cell[145643, 3839, 1808, 43, 47, "Input",ExpressionUUID->"b6856706-a41a-4cad-b8c7-20005200e39d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[147488, 3887, 177, 4, 8, "Subsubsection",ExpressionUUID->"73f69a5e-7e4c-45eb-95b0-1c42a81aab1e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[147668, 3893, 4355, 103, 82, "Input",ExpressionUUID->"0da07b9b-8912-4c16-b3df-b022bc729517",
 InitializationCell->True,
 InitializationGroup->True],
Cell[152026, 3998, 2474, 56, 52, "Input",ExpressionUUID->"abb073d6-b6c1-4e9d-b6a7-6100d13d6734",
 InitializationCell->True,
 InitializationGroup->True],
Cell[154503, 4056, 3071, 78, 60, "Input",ExpressionUUID->"26cef738-aa20-4c93-a822-0ca089d15368",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[157611, 4139, 371, 9, 9, "Subsubsection",ExpressionUUID->"b7c1e93e-8cd0-4268-b4c6-3f008f5b4d26",
 InitializationCell->True,
 InitializationGroup->True],
Cell[157985, 4150, 773, 20, 8, "Input",ExpressionUUID->"cbac481e-98fd-45ef-a319-f96b8b198dcf",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[158795, 4175, 243, 6, 4, "Subsubsection",ExpressionUUID->"6b6c3e53-2a2a-44e5-8385-7688c807a96f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[159041, 4183, 588, 16, 11, "Input",ExpressionUUID->"a3dfa409-3d12-4fdc-b298-e62baf34669e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[159666, 4204, 186, 4, 4, "Subsubsection",ExpressionUUID->"0d6feab9-bb95-4d40-90f8-695c2e686d82",
 InitializationCell->True],
Cell[159855, 4210, 361, 10, 8, "Input",ExpressionUUID->"2ecfcf09-cac7-4897-969d-d16bbf49764e",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[160265, 4226, 347, 8, 34, "Subsection",ExpressionUUID->"10a813be-1fb8-4df1-b5b5-77a8fd558932",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[160637, 4238, 170, 4, 6, "Subsubsection",ExpressionUUID->"6fac2a07-106c-4ed8-9172-90ed0796f2f1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[160810, 4244, 332, 8, 8, "Input",ExpressionUUID->"3ac22b24-7d98-49f8-bef4-207d18404e31",
 InitializationCell->True],
Cell[161145, 4254, 522, 13, 8, "Input",ExpressionUUID->"092b4257-0e4d-4242-b15d-c17909af318f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[161670, 4269, 621, 14, 13, "Input",ExpressionUUID->"4bc930a9-8e07-4484-931a-5cea44d6c648",
 InitializationCell->True],
Cell[162294, 4285, 387, 10, 8, "Input",ExpressionUUID->"e6cff6d8-40e5-43cb-9d98-b38a30550bb4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[162684, 4297, 363, 10, 8, "Input",ExpressionUUID->"078f14df-2fef-4ba8-aeab-e110ae6e0587",
 InitializationCell->True,
 InitializationGroup->True],
Cell[163050, 4309, 781, 18, 13, "Input",ExpressionUUID->"d74480b5-aac1-460c-b706-5c486df5fa64",
 InitializationCell->True,
 InitializationGroup->True],
Cell[163834, 4329, 658, 16, 13, "Input",ExpressionUUID->"dca4b675-d928-40f6-bf78-1f9affb9d92b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[164495, 4347, 971, 26, 13, "Input",ExpressionUUID->"6eff5cae-1a21-4944-a7dc-ee42298c91ea",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[165503, 4378, 183, 4, 4, "Subsubsection",ExpressionUUID->"3eafaeeb-a5cd-4baf-8b88-3bd6480f9b0f",
 InitializationCell->True],
Cell[165689, 4384, 646, 16, 18, "Input",ExpressionUUID->"85d705b0-0505-4919-8be5-1da022e70c9b",
 InitializationCell->True],
Cell[166338, 4402, 910, 24, 18, "Input",ExpressionUUID->"05d947af-dc8d-4e82-a31d-d7ad5525589b",
 InitializationCell->True],
Cell[167251, 4428, 1029, 26, 23, "Input",ExpressionUUID->"750a2fbc-5df8-44f9-a668-ea5e597c6927",
 InitializationCell->True],
Cell[168283, 4456, 1627, 40, 47, "Input",ExpressionUUID->"127ec8d1-e3b0-4956-9e5b-a6574007e22f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[169947, 4501, 337, 7, 8, "Subsubsection",ExpressionUUID->"b6bfbcff-b231-45d2-b9da-35de46f59e1e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[170287, 4510, 892, 25, 13, "Input",ExpressionUUID->"0bf5a6fe-c8b6-4977-9811-d093a326fca4",
 InitializationCell->True],
Cell[171182, 4537, 6046, 136, 87, "Input",ExpressionUUID->"efad9d1c-4fa1-4c0c-a844-434dbdc48dc0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[177265, 4678, 177, 4, 8, "Subsubsection",ExpressionUUID->"31e44bf3-ab18-42af-a797-1ce11a217b04",
 InitializationCell->True,
 InitializationGroup->True],
Cell[177445, 4684, 1943, 44, 52, "Input",ExpressionUUID->"031746b6-5205-42d0-8882-a5897aa7bf92",
 InitializationCell->True,
 InitializationGroup->True],
Cell[179391, 4730, 2125, 47, 74, "Input",ExpressionUUID->"4ce47256-9d4e-4b5a-aa98-02401d0e3bd4",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[181553, 4782, 243, 6, 4, "Subsubsection",ExpressionUUID->"8faae5e9-7068-44c6-b059-70e8b64fb99d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[181799, 4790, 582, 16, 4, "Input",ExpressionUUID->"7c22c335-e345-4575-ada0-7fb5d04e0c0a",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[182430, 4812, 412, 9, 34, "Subsection",ExpressionUUID->"f62474f8-a3f0-44d6-ab28-45e0b477817c",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[182867, 4825, 170, 4, 40, "Subsubsection",ExpressionUUID->"0fce91a3-a120-4bda-a0d0-aa1903695ec2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[183040, 4831, 322, 7, 8, "Input",ExpressionUUID->"1403da00-97f6-4c9d-b2b0-322514eeb603",
 InitializationCell->True],
Cell[183365, 4840, 427, 12, 8, "Input",ExpressionUUID->"d8861e2b-59cb-409e-b175-de7274a89106",
 InitializationCell->True,
 InitializationGroup->True],
Cell[183795, 4854, 724, 16, 13, "Input",ExpressionUUID->"faf2735a-1627-4f5f-a5b6-9879f2997a08",
 InitializationCell->True],
Cell[184522, 4872, 313, 9, 8, "Input",ExpressionUUID->"9ac366e5-ba55-43e2-8a81-71e5968a830b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[184838, 4883, 378, 10, 8, "Input",ExpressionUUID->"88f9f5c3-fc12-428b-ae5a-1b62b9b74f38",
 InitializationCell->True,
 InitializationGroup->True],
Cell[185219, 4895, 769, 18, 13, "Input",ExpressionUUID->"2b2afcaf-dd5d-4389-be9b-0e1e4d707e4e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[185991, 4915, 689, 16, 13, "Input",ExpressionUUID->"83b75b0f-61a8-45de-8833-269086369400",
 InitializationCell->True,
 InitializationGroup->True],
Cell[186683, 4933, 1067, 30, 17, "Input",ExpressionUUID->"e5fef8e9-74e8-4e23-b0b5-e05916d2b6d9",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[187787, 4968, 183, 4, 33, "Subsubsection",ExpressionUUID->"ae086592-7357-4b2e-8a54-586f1818cefa",
 InitializationCell->True],
Cell[187973, 4974, 573, 15, 13, "Input",ExpressionUUID->"fae67ff9-8819-4afb-be83-43ade290af4d",
 InitializationCell->True],
Cell[188549, 4991, 882, 23, 17, "Input",ExpressionUUID->"77a5522f-6343-4d2a-bcd7-c9e02935d749",
 InitializationCell->True],
Cell[189434, 5016, 948, 24, 22, "Input",ExpressionUUID->"5b88e6c0-745a-4194-9a76-fb2f4d8fb8f0",
 InitializationCell->True],
Cell[190385, 5042, 1704, 41, 39, "Input",ExpressionUUID->"6807e641-55bc-429d-9f6d-80bee9f7f1e7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[192126, 5088, 289, 6, 26, "Subsubsection",ExpressionUUID->"12fd0037-47ed-4577-b7ff-d37d55499de2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[192418, 5096, 422, 9, 42, "Text",ExpressionUUID->"3660d990-a7e7-4c52-97a7-c6ea86b8bce2",
 InitializationCell->True],
Cell[192843, 5107, 387, 8, 25, "Text",ExpressionUUID->"22b9e5d5-4927-4640-81ba-de545c205985",
 InitializationCell->True],
Cell[193233, 5117, 8496, 214, 480, "Input",ExpressionUUID->"bc174abb-d45f-4251-b895-1d7f9ed7ae34",
 InitializationCell->True],
Cell[201732, 5333, 2385, 62, 141, "Input",ExpressionUUID->"583a3451-3330-46c4-8f7a-717bc10327a0",
 InitializationCell->True],
Cell[204120, 5397, 2138, 55, 156, "Input",ExpressionUUID->"583a3451-3330-46c4-8f7a-717bc10327a0",
 InitializationCell->True],
Cell[206261, 5454, 1575, 36, 80, "Input",ExpressionUUID->"775c4fe6-fd13-46a6-bb0c-064fc86d1ea3",
 InitializationCell->True],
Cell[207839, 5492, 1578, 35, 80, "Input",ExpressionUUID->"775c4fe6-fd13-46a6-bb0c-064fc86d1ea3",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[209454, 5532, 177, 4, 40, "Subsubsection",ExpressionUUID->"3418747d-26e0-447c-ab6e-9e0c0595ceec",
 InitializationCell->True,
 InitializationGroup->True],
Cell[209634, 5538, 3054, 67, 48, "Input",ExpressionUUID->"efbeceb6-d603-44e1-85ae-c495956bd287",
 InitializationCell->True,
 InitializationGroup->True],
Cell[212691, 5607, 4483, 107, 82, "Input",ExpressionUUID->"5b17941b-4e2c-4583-95ac-0097464e2799",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[217211, 5719, 243, 6, 33, "Subsubsection",ExpressionUUID->"70fef112-bc2e-4796-8c9f-b2819be8d51f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[217457, 5727, 575, 16, 12, "Input",ExpressionUUID->"decec258-e72e-4b71-9e0d-4ad9383def24",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[218081, 5749, 255, 6, 48, "Subsection",ExpressionUUID->"ebb46c5e-814c-44ce-8e51-cc8f866007e0",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[218361, 5759, 170, 4, 6, "Subsubsection",ExpressionUUID->"0eb5bcf2-94cf-472a-8169-82de0c83f69f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[218534, 5765, 327, 7, 9, "Input",ExpressionUUID->"8c46d066-ac50-45a3-8e1e-4c940bd1351d",
 InitializationCell->True],
Cell[218864, 5774, 596, 14, 9, "Input",ExpressionUUID->"1797389b-1326-49a2-b400-e3ced3fdea08",
 InitializationCell->True,
 InitializationGroup->True],
Cell[219463, 5790, 681, 16, 14, "Input",ExpressionUUID->"e8df2095-8257-4779-bdfb-3392d3293bc8",
 InitializationCell->True],
Cell[220147, 5808, 392, 9, 9, "Input",ExpressionUUID->"f355fb70-c237-47e6-8d5a-fc2b0c83ef56",
 InitializationCell->True],
Cell[220542, 5819, 385, 10, 9, "Input",ExpressionUUID->"487e29be-134c-423b-ac8c-6400a6c2dd0b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[220930, 5831, 435, 12, 9, "Input",ExpressionUUID->"57a7412e-a559-4a22-95a7-f74fa917ced4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[221368, 5845, 635, 17, 14, "Input",ExpressionUUID->"c33c7930-ab07-4b81-9836-8ddf85558f8b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[222006, 5864, 1046, 30, 18, "Input",ExpressionUUID->"ed75709c-cebb-493d-b513-88d7cc1906ec",
 InitializationCell->True,
 InitializationGroup->True],
Cell[223055, 5896, 939, 28, 18, "Input",ExpressionUUID->"faa89fff-32cc-4efa-ad92-10e0a466f75b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[223997, 5926, 355, 10, 13, "Input",ExpressionUUID->"dc3ec5b7-e974-4195-a47c-4049e52ae951",
 InitializationCell->True,
 InitializationGroup->True],
Cell[224355, 5938, 362, 10, 13, "Input",ExpressionUUID->"764b322c-2321-48ea-ab50-55d56a1f4daa",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[224754, 5953, 236, 6, 4, "Subsubsection",ExpressionUUID->"37ae50a7-5a9c-4798-9bb3-c1fa81f87a04",
 InitializationCell->True,
 InitializationGroup->True],
Cell[224993, 5961, 690, 17, 12, "Input",ExpressionUUID->"fc1d30bf-2f3c-4dee-b608-31651a646c20",
 InitializationCell->True],
Cell[225686, 5980, 935, 24, 17, "Input",ExpressionUUID->"46a04e27-0876-48f6-a25b-9d677df0f3e0",
 InitializationCell->True],
Cell[226624, 6006, 1051, 25, 21, "Input",ExpressionUUID->"9dca1f5e-6b69-4747-aba8-0f7b54760477",
 InitializationCell->True],
Cell[227678, 6033, 1723, 41, 35, "Input",ExpressionUUID->"7e8df655-f253-422c-94e3-4daccaa7fcb7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[229438, 6079, 253, 6, 8, "Subsubsection",ExpressionUUID->"c16bb76a-2ecb-452c-8422-a7c617a1b4f2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[229694, 6087, 1939, 45, 44, "Input",ExpressionUUID->"9274de66-0252-4a38-ae1a-9ab7e3e70391",
 InitializationCell->True,
 InitializationGroup->True],
Cell[231636, 6134, 324, 6, 5, "Text",ExpressionUUID->"6398f5d8-5ec2-422d-9eda-566cb1ccdcf1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[231963, 6142, 5589, 129, 108, "Input",ExpressionUUID->"33f29bf8-e98e-45e7-b815-84e63285ec44",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[237589, 6276, 253, 6, 4, "Subsubsection",ExpressionUUID->"74763be1-8682-4348-a3be-2428ffad3841",
 InitializationCell->True,
 InitializationGroup->True],
Cell[237845, 6284, 6807, 166, 110, "Input",ExpressionUUID->"d2c66d34-2c47-4b3e-bb0c-f49546b12bd6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[244655, 6452, 1712, 40, 59, "Input",ExpressionUUID->"f315ffe5-8c98-4390-ba76-357d18afb968",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[246404, 6497, 243, 6, 4, "Subsubsection",ExpressionUUID->"13588368-e38a-4369-aaac-7187d4da1151",
 InitializationCell->True,
 InitializationGroup->True],
Cell[246650, 6505, 647, 17, 11, "Input",ExpressionUUID->"b0fce48f-0466-488e-a0c2-71faaf8d37fc",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[247346, 6528, 341, 8, 34, "Subsection",ExpressionUUID->"c48540e4-a9de-44ca-b0e2-37529ddcc3a4",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[247712, 6540, 170, 4, 7, "Subsubsection",ExpressionUUID->"56e98c65-9e6c-40d5-93c9-a1e0aab30a9e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[247885, 6546, 325, 7, 8, "Input",ExpressionUUID->"a0f0b5ac-20bb-4f4a-b50c-7dd7cf523a8a",
 InitializationCell->True],
Cell[248213, 6555, 483, 13, 8, "Input",ExpressionUUID->"b41c9f29-3147-445a-a882-55fd6eea4f1e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[248699, 6570, 609, 14, 13, "Input",ExpressionUUID->"a456fb21-892a-40c5-818b-abd0b7185c04",
 InitializationCell->True],
Cell[249311, 6586, 359, 10, 8, "Input",ExpressionUUID->"fbfb6baa-7194-4712-94f2-d0fef3acdbe9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[249673, 6598, 383, 10, 8, "Input",ExpressionUUID->"93e5c22d-eab6-4287-b4f1-d1a2ca87fcdd",
 InitializationCell->True,
 InitializationGroup->True],
Cell[250059, 6610, 775, 18, 13, "Input",ExpressionUUID->"c954a9f1-f29c-415b-998d-9b1e86af2061",
 InitializationCell->True,
 InitializationGroup->True],
Cell[250837, 6630, 746, 17, 13, "Input",ExpressionUUID->"c8ce62b6-5f03-401a-ab9a-097307411331",
 InitializationCell->True,
 InitializationGroup->True],
Cell[251586, 6649, 1054, 27, 13, "Input",ExpressionUUID->"c5a7f3af-b504-4839-957a-0543fbb7618a",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[252677, 6681, 238, 6, 6, "Subsubsection",ExpressionUUID->"11727ea2-2288-4a98-a45d-4763ca286082",
 InitializationCell->True,
 InitializationGroup->True],
Cell[252918, 6689, 587, 15, 18, "Input",ExpressionUUID->"3f520b8a-e52b-4942-819a-88960b9f94cb",
 InitializationCell->True],
Cell[253508, 6706, 906, 24, 18, "Input",ExpressionUUID->"e811506f-37c7-41fd-9dee-7b8deecfbf6c",
 InitializationCell->True],
Cell[254417, 6732, 991, 25, 17, "Input",ExpressionUUID->"72359c5f-c9de-4059-bfcb-56910bd4d727",
 InitializationCell->True],
Cell[255411, 6759, 1724, 41, 35, "Input",ExpressionUUID->"7ecffebd-cae3-4327-a79d-99683cb71e96",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[257172, 6805, 368, 8, 9, "Subsubsection",ExpressionUUID->"a0289fb3-6e2e-45f2-a685-928a253a49b8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[257543, 6815, 1530, 37, 26, "Input",ExpressionUUID->"5293c175-0373-4e26-a947-039dd815c702",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[259110, 6857, 470, 9, 9, "Subsubsection",ExpressionUUID->"b531fc00-cf31-4d42-9123-2b03e97b9ae1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[259583, 6868, 4885, 108, 96, "Input",ExpressionUUID->"338e90b9-6f67-4bbb-ad8a-6becb6ec7aa0",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[264505, 6981, 276, 6, 6, "Subsubsection",ExpressionUUID->"f623f75b-47d7-4c30-b015-4caf309e8222",
 InitializationCell->True,
 InitializationGroup->True],
Cell[264784, 6989, 1863, 43, 60, "Input",ExpressionUUID->"8c19157c-f25d-41aa-91e8-1ef370f50e87",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[266684, 7037, 371, 9, 12, "Subsubsection",ExpressionUUID->"3f0a2509-61a4-4a77-b145-cce95049df78",
 InitializationCell->True,
 InitializationGroup->True],
Cell[267058, 7048, 764, 20, 8, "Input",ExpressionUUID->"9b6762f1-82e2-4a76-a51f-7735da8f08f6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[267859, 7073, 243, 6, 6, "Subsubsection",ExpressionUUID->"6345a15a-4803-40b1-a644-cb1374b9b916",
 InitializationCell->True,
 InitializationGroup->True],
Cell[268105, 7081, 578, 16, 11, "Input",ExpressionUUID->"9184c9e3-61a3-4612-b911-779e823e16f1",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[268732, 7103, 366, 8, 34, "Subsection",ExpressionUUID->"a21dd41c-24b1-4a12-980b-0da369fa884b",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[269123, 7115, 170, 4, 6, "Subsubsection",ExpressionUUID->"56a3a66f-cee8-4375-8c26-0b8c647ac0fc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[269296, 7121, 330, 8, 8, "Input",ExpressionUUID->"bc14005d-2334-47c7-8870-89e115ec66b7",
 InitializationCell->True],
Cell[269629, 7131, 671, 15, 8, "Input",ExpressionUUID->"cd419784-8f2e-4745-beae-1426940db928",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[270325, 7150, 670, 15, 13, "Input",ExpressionUUID->"7c32748b-938e-4645-abdc-5ee55fd1a73b",
 InitializationCell->True],
Cell[270998, 7167, 783, 14, 56, "Output",ExpressionUUID->"9ccf3773-a965-43ff-a137-f1725493f139",
 InitializationCell->True]
}, Open  ]],
Cell[271796, 7184, 388, 10, 8, "Input",ExpressionUUID->"bc92291a-3412-460c-8ae5-8e9b99bf4101",
 InitializationCell->True,
 InitializationGroup->True],
Cell[272187, 7196, 384, 10, 8, "Input",ExpressionUUID->"a670e8cb-bbd5-461b-883e-2dea10e9079c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[272574, 7208, 831, 19, 13, "Input",ExpressionUUID->"34037404-3c35-4dff-aa78-4e37e44eec7d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[273408, 7229, 752, 17, 13, "Input",ExpressionUUID->"58c06b24-cd13-47bb-8dc2-f1bcfcee5d71",
 InitializationCell->True,
 InitializationGroup->True],
Cell[274163, 7248, 1130, 31, 17, "Input",ExpressionUUID->"35217cdf-c509-4398-8e8c-e44c68240ba0",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[275330, 7284, 183, 4, 4, "Subsubsection",ExpressionUUID->"9811c307-e8e4-4296-ab18-5d57a3e2c97e",
 InitializationCell->True],
Cell[275516, 7290, 643, 16, 18, "Input",ExpressionUUID->"f727dd70-0e56-4fc1-b3cd-9da6f3d560d7",
 InitializationCell->True],
Cell[276162, 7308, 1255, 31, 34, "Input",ExpressionUUID->"9925e74b-e09b-485f-af3f-c55cd70686d8",
 InitializationCell->True],
Cell[277420, 7341, 1765, 42, 47, "Input",ExpressionUUID->"69fb7b3a-f445-4e89-8b94-cec635db6913",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[279222, 7388, 246, 5, 4, "Subsubsection",ExpressionUUID->"22fc9097-6cfa-4016-afb3-3abe71d55b77",
 InitializationCell->True,
 InitializationGroup->True],
Cell[279471, 7395, 1654, 40, 21, "Input",ExpressionUUID->"7045731f-ae59-4847-8c61-4f128ee0ee25",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[281162, 7440, 302, 6, 4, "Subsubsection",ExpressionUUID->"1ecb26c3-96b0-454b-a954-48de08c8bcdd",
 InitializationCell->True,
 InitializationGroup->True],
Cell[281467, 7448, 364, 10, 8, "Input",ExpressionUUID->"260c43f8-223b-47f7-a9b6-77953f78b14b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[281834, 7460, 2825, 69, 65, "Input",ExpressionUUID->"40ff3368-f2ef-4734-a589-d3ed4c24b6c2",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[284696, 7534, 454, 8, 6, "Subsubsection",ExpressionUUID->"f986fc01-7f48-491b-b70e-53fea46aa0e5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[285153, 7544, 1603, 39, 51, "Input",ExpressionUUID->"9c94deb7-3934-430d-bff9-d8d3f6a5a805",
 InitializationCell->True],
Cell[286759, 7585, 1613, 43, 47, "Input",ExpressionUUID->"0b73c7ec-51ac-4b7f-81a9-40152bddc53d",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[288409, 7633, 419, 9, 4, "Subsubsection",ExpressionUUID->"133948b7-8079-4a12-8a83-c1d540c0f413",
 InitializationCell->True,
 InitializationGroup->True],
Cell[288831, 7644, 296, 7, 5, "Text",ExpressionUUID->"71ceae05-0b77-419d-8908-5c9677e2da47",
 InitializationCell->True],
Cell[289130, 7653, 748, 18, 8, "Input",ExpressionUUID->"dcf9fd8a-160e-4374-8a57-af5a5188213c",
 InitializationCell->True],
Cell[289881, 7673, 2958, 57, 17, "Input",ExpressionUUID->"71b5ed72-4b51-4125-9fc7-4279ff07e34d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[292842, 7732, 4278, 99, 59, "Input",ExpressionUUID->"8f18c08a-6fa0-45fa-a5af-494fd38e0b4b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[297123, 7833, 4233, 99, 59, "Input",ExpressionUUID->"b374e39f-5138-4b5c-a7fe-14b59a68e3c3",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[301393, 7937, 243, 6, 4, "Subsubsection",ExpressionUUID->"6955475a-02c5-4f65-aff3-2caccd0bb6b0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[301639, 7945, 583, 16, 12, "Input",ExpressionUUID->"2ba842aa-77fc-4aa9-863b-800373cc8367",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[302295, 7969, 212, 5, 58, "Subchapter",ExpressionUUID->"a46bf389-3a31-4396-8153-9be07d056978",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[302532, 7978, 229, 5, 6, "Section",ExpressionUUID->"25cf4f0e-5538-49f0-b757-a9d6de299660"],
Cell[CellGroupData[{
Cell[302786, 7987, 329, 6, 8, "Subsection",ExpressionUUID->"cf936910-f42f-4225-ae4f-233ca0f759bc",
 InitializationCell->True],
Cell[303118, 7995, 375, 9, 8, "Input",ExpressionUUID->"364eb77c-4ec5-4838-aa0f-2c7727e33294",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[303530, 8009, 351, 6, 6, "Subsection",ExpressionUUID->"3e377441-c7f4-44ce-a121-0c8acf68bc86",
 InitializationCell->True],
Cell[303884, 8017, 694, 18, 23, "Input",ExpressionUUID->"913b669e-bf0d-43dd-b2fe-905450dd414b",
 InitializationCell->True],
Cell[304581, 8037, 694, 18, 23, "Input",ExpressionUUID->"ecf2b83f-0fb5-4322-8368-68b4760d868b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[305312, 8060, 296, 5, 6, "Subsection",ExpressionUUID->"0e28a598-b647-4419-a5f0-4b3f2dd4f9cd",
 InitializationCell->True],
Cell[305611, 8067, 917, 22, 23, "Input",ExpressionUUID->"897f3fc7-b4f0-46ce-aca4-900e110ce0d9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[306565, 8094, 248, 5, 6, "Subsection",ExpressionUUID->"e5667dac-4b27-411a-9857-5724e80b2388",
 InitializationCell->True],
Cell[306816, 8101, 788, 18, 18, "Input",ExpressionUUID->"cd76d7b7-1aa3-4e56-ae13-49a3969606b6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[307653, 8125, 234, 5, 6, "Section",ExpressionUUID->"039ee73b-0772-456e-85b9-1f0b15b084f6"],
Cell[CellGroupData[{
Cell[307912, 8134, 353, 6, 8, "Subsection",ExpressionUUID->"fd4b17bc-3c47-459a-b049-71ebeb57e497",
 InitializationCell->True],
Cell[308268, 8142, 792, 21, 18, "Input",ExpressionUUID->"3ecd50bf-fc0a-4d4d-92c2-282246a51541",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[309097, 8168, 392, 8, 12, "Subsection",ExpressionUUID->"6f35b40d-4e6e-425d-8595-2c05156e5120",
 InitializationCell->True],
Cell[309492, 8178, 311, 8, 5, "Text",ExpressionUUID->"6ff1bc4d-afd7-45bc-a968-db2576260758",
 InitializationCell->True],
Cell[309806, 8188, 1957, 43, 39, "Input",ExpressionUUID->"1cbd7b79-f1ad-40cc-8060-419cc0501770",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[311800, 8236, 386, 8, 6, "Subsection",ExpressionUUID->"b81d633a-e900-416b-892c-e4bdb5d0d97a",
 InitializationCell->True],
Cell[312189, 8246, 4021, 80, 99, "Input",ExpressionUUID->"393a1af3-96b4-4601-825b-c8a7e3361316",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[316259, 8332, 433, 9, 7, "Section",ExpressionUUID->"e0c88c39-353e-46c3-b564-eaadc68fbcb2"],
Cell[CellGroupData[{
Cell[316717, 8345, 598, 11, 8, "Subsection",ExpressionUUID->"17cd42e1-aeee-4aea-9e11-4ae747f70e5e",
 InitializationCell->True],
Cell[317318, 8358, 5561, 122, 117, "Input",ExpressionUUID->"87d90aa0-e6cb-4189-a815-3f153092131b",
 InitializationCell->True],
Cell[322882, 8482, 5238, 119, 117, "Input",ExpressionUUID->"944b66e1-b0ee-4199-8c93-abd03687d73c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[328157, 8606, 687, 12, 21, "Subsection",ExpressionUUID->"fe659996-490d-4c97-b98c-65b2038d8678",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[328869, 8622, 171, 3, 6, "Subsubsection",ExpressionUUID->"c77c41db-7f48-4562-a7a3-82d26f2dff71"],
Cell[329043, 8627, 6216, 128, 144, "Input",ExpressionUUID->"ded1f35b-4b9b-4133-ab1d-6bc624ba7cc4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[335296, 8760, 167, 3, 8, "Subsubsection",ExpressionUUID->"c79e5966-5b30-4dfa-9aeb-d6ea42b640dd"],
Cell[335466, 8765, 229, 4, 5, "Text",ExpressionUUID->"1270e0a9-9af2-40bf-ba7b-491bd7667df2",
 InitializationCell->True],
Cell[335698, 8771, 6846, 156, 106, "Input",ExpressionUUID->"8235fc1c-8d95-4e2a-8f49-905671830d75",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[342605, 8934, 304, 5, 6, "Section",ExpressionUUID->"b5945aca-4585-4a37-ae0a-eeaca1a2b37e"],
Cell[CellGroupData[{
Cell[342934, 8943, 795, 13, 8, "Subsection",ExpressionUUID->"20db33e9-5591-458a-8026-95ff13139be3",
 InitializationCell->True],
Cell[343732, 8958, 3374, 73, 74, "Input",ExpressionUUID->"69d6cf8a-868f-44da-86a2-1bead8c7e0bc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[347143, 9036, 423, 8, 12, "Subsection",ExpressionUUID->"bad215f1-dfc1-4b68-9d6a-fb00de2473ce"],
Cell[347569, 9046, 4168, 89, 100, "Input",ExpressionUUID->"25d79730-8eb7-47fd-84e1-b9fe60a634fd",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[351762, 9139, 175, 3, 6, "Subsubsection",ExpressionUUID->"1111b345-f239-427c-8c34-a7aa114b7ba3"],
Cell[351940, 9144, 2022, 42, 23, "Input",ExpressionUUID->"fc500595-e626-4fef-b2c2-6c0e62a8ecc5",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[354011, 9192, 842, 14, 6, "Subsection",ExpressionUUID->"b113061b-faa8-40e0-8677-a94c55368c11",
 InitializationCell->True],
Cell[354856, 9208, 3245, 71, 81, "Input",ExpressionUUID->"e05dabd4-5e9b-45e8-9091-a60d54ae2ba1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[358138, 9284, 450, 7, 6, "Subsection",ExpressionUUID->"6aac3731-eef7-459e-afcb-8045a7610363",
 InitializationCell->True],
Cell[358591, 9293, 290, 7, 5, "Text",ExpressionUUID->"8bff8f67-8590-426c-b4e1-671ef4966982",
 InitializationCell->True],
Cell[358884, 9302, 4789, 96, 115, "Input",ExpressionUUID->"8d3afddf-3c97-4e8b-8b7d-bae1385f19ea",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[363722, 9404, 328, 6, 6, "Section",ExpressionUUID->"12468ffc-98ac-48f7-bebd-393364181343",
 InitializationCell->True],
Cell[364053, 9412, 398, 9, 14, "Input",ExpressionUUID->"53aca2a5-f090-437e-abec-4f6e7e97ec59",
 InitializationCell->True],
Cell[364454, 9423, 353, 8, 9, "Input",ExpressionUUID->"f978940d-ddde-4d19-9c78-39bbdc709e9d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[364844, 9436, 382, 7, 6, "Section",ExpressionUUID->"d2fb778e-3159-41b9-bff2-e841ad1f85d2",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[365251, 9447, 304, 7, 6, "Subsubsection",ExpressionUUID->"3bc59baa-5571-4f86-8171-d7805cd8790b",
 InitializationCell->True],
Cell[365558, 9456, 444, 11, 9, "Input",ExpressionUUID->"12f74bd4-4721-4eaa-803b-8f324231d06d",
 InitializationCell->True],
Cell[366005, 9469, 335, 9, 9, "Input",ExpressionUUID->"b5fcc40f-7e19-4ff4-a787-638277420fb7",
 InitializationCell->True],
Cell[366343, 9480, 1654, 44, 42, "Input",ExpressionUUID->"cfa11969-b058-4226-90d3-7fe38c1eee24",
 InitializationCell->True],
Cell[368000, 9526, 341, 9, 9, "Input",ExpressionUUID->"7b0ae87d-eaed-4c78-8d95-617f8d67633b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[368378, 9540, 305, 7, 4, "Subsubsection",ExpressionUUID->"4f5eefdd-9b85-4dc5-a53d-b75d91a5992a",
 InitializationCell->True],
Cell[368686, 9549, 469, 9, 9, "Text",ExpressionUUID->"8b1927ae-1fe1-45a9-93d2-8b684fcc5008",
 InitializationCell->True],
Cell[369158, 9560, 620, 16, 14, "Input",ExpressionUUID->"bf0dd88f-d557-4a82-807e-86c9a6b1dbb1",
 InitializationCell->True],
Cell[369781, 9578, 621, 16, 14, "Input",ExpressionUUID->"e89dcaab-e084-4a79-976a-43102b0ff454",
 InitializationCell->True],
Cell[370405, 9596, 465, 12, 9, "Input",ExpressionUUID->"6b306717-1adb-446e-91af-ec3154546f85",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[370907, 9613, 349, 8, 9, "Subsubsection",ExpressionUUID->"2848f4f5-1e83-489b-9b3f-8ea0d1e07745",
 InitializationCell->True],
Cell[371259, 9623, 360, 8, 9, "Text",ExpressionUUID->"efe1b067-da1c-4552-9365-153e71d67937"],
Cell[371622, 9633, 555, 13, 14, "Input",ExpressionUUID->"338a579e-e903-401a-bff0-6513ba58e931",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[372238, 9653, 234, 6, 44, "Subchapter",ExpressionUUID->"68c2ebe5-3d8e-4752-b940-99c1d3977be5",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[372475, 9661, 997, 19, 8, "Input",ExpressionUUID->"09743a81-56f6-42b1-8500-768344841b61",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[373497, 9684, 218, 5, 6, "Section",ExpressionUUID->"5a52c6b5-5c7f-4a8d-87f7-bff02b9aa4b7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[373740, 9693, 342, 9, 6, "Subsubsection",ExpressionUUID->"8698c200-9f5f-4d22-b623-8b8042488a2b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[374085, 9704, 577, 15, 8, "Input",ExpressionUUID->"9cbe7c57-593d-48d1-b1ef-2d27e0b9ecd9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[374665, 9721, 648, 16, 8, "Input",ExpressionUUID->"3b471989-a746-4d59-bd02-57a96c2ac580",
 InitializationCell->True,
 InitializationGroup->True],
Cell[375316, 9739, 1054, 24, 12, "Input",ExpressionUUID->"63f87ac3-633b-4f0b-bee6-14bd35d7f78a",
 InitializationCell->True],
Cell[376373, 9765, 1484, 30, 28, "Input",ExpressionUUID->"d35feb46-bd93-4276-9ef4-54716e864035",
 InitializationCell->True],
Cell[377860, 9797, 1549, 32, 28, "Input",ExpressionUUID->"49831860-706f-4667-99e2-3b44c52b21f8",
 InitializationCell->True],
Cell[379412, 9831, 2349, 48, 32, "Input",ExpressionUUID->"b2a25f12-569e-4411-8070-34f0e161171d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[381798, 9884, 497, 8, 4, "Subsubsection",ExpressionUUID->"5888cc65-be10-4b84-b4eb-9aa9bbc5deec",
 InitializationCell->True],
Cell[382298, 9894, 908, 21, 8, "Input",ExpressionUUID->"f73da4ce-8e3d-4f91-9d88-2c7ab4fc51cc",
 InitializationCell->True],
Cell[383209, 9917, 673, 16, 8, "Input",ExpressionUUID->"64caa45e-630b-4bfe-b281-8e387272e7a4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[383919, 9938, 562, 9, 4, "Subsubsection",ExpressionUUID->"3086e6a9-748e-4433-85e4-95d42f73e453",
 InitializationCell->True],
Cell[384484, 9949, 1184, 30, 28, "Input",ExpressionUUID->"7f1e79f9-a5e3-46a5-8fdd-a7e14894b6fa",
 InitializationCell->True],
Cell[385671, 9981, 1130, 24, 12, "Input",ExpressionUUID->"d2fc5b6e-37e7-456b-b38f-a140078730fb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[386838, 10010, 179, 4, 4, "Subsubsection",ExpressionUUID->"e937865a-aa08-4426-bc50-8724f357b923",
 InitializationCell->True,
 InitializationGroup->True],
Cell[387020, 10016, 987, 23, 18, "Input",ExpressionUUID->"80662191-286e-4264-8268-554fccbe22a7",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[388044, 10044, 192, 4, 4, "Subsubsection",ExpressionUUID->"21621a6f-918f-44ef-8ba1-f38b22cfc818",
 InitializationCell->True,
 InitializationGroup->True],
Cell[388239, 10050, 978, 24, 11, "Input",ExpressionUUID->"c41e23d3-812f-4296-a0eb-52b61aeb108e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[389220, 10076, 983, 25, 11, "Input",ExpressionUUID->"dd2bd68a-939c-4b78-aa13-7250c7f1b95b",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[390252, 10107, 413, 9, 11, "Section",ExpressionUUID->"22e07767-ecee-44c2-9fea-793aba980003",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[390690, 10120, 209, 4, 6, "Subsubsection",ExpressionUUID->"f423c64c-66a5-454b-b22d-6e48aed57bbf",
 InitializationCell->True],
Cell[390902, 10126, 850, 20, 18, "Input",ExpressionUUID->"27fd8f67-078d-47c4-a528-8ff8b8c1c582",
 InitializationCell->True],
Cell[391755, 10148, 238, 6, 5, "Text",ExpressionUUID->"0557ec3a-d8ff-41d0-a619-291ab6dfb479",
 InitializationCell->True],
Cell[391996, 10156, 1524, 36, 28, "Input",ExpressionUUID->"db348639-1c0b-4b27-a458-389a3699549b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[393557, 10197, 208, 4, 6, "Subsubsection",ExpressionUUID->"28ef6381-b08c-4fbc-be20-5b0e79f7c8b5",
 InitializationCell->True],
Cell[393768, 10203, 1168, 29, 28, "Input",ExpressionUUID->"3d70b3c6-1964-4d32-90a2-40c10a9476c5",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[394985, 10238, 539, 9, 6, "Section",ExpressionUUID->"5adb4927-907e-45bc-aebc-d2ce7da4669a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[395549, 10251, 942, 16, 13, "Subsection",ExpressionUUID->"b0c57370-e96f-438a-b9a7-c3dbfadb3eac",
 InitializationCell->True,
 InitializationGroup->True],
Cell[396494, 10269, 2358, 54, 47, "Input",ExpressionUUID->"0d24e81e-37f1-47a1-b94a-35a10f12a5f6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[398889, 10328, 1036, 18, 12, "Subsection",ExpressionUUID->"5dba9b61-d526-4930-9462-4fedcbe8b4c7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[399928, 10348, 3646, 77, 65, "Input",ExpressionUUID->"c34cbde9-f05e-41dd-9133-6a64a632b292",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[403623, 10431, 607, 10, 6, "Section",ExpressionUUID->"e2d2e152-f16b-439e-9aa0-30db03ae2961",
 InitializationCell->True,
 InitializationGroup->True],
Cell[404233, 10443, 1079, 27, 12, "Input",ExpressionUUID->"2f85a7dc-732f-4978-a0d5-f6aaac533f66",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[405361, 10476, 360, 8, 44, "Subchapter",ExpressionUUID->"93320c6e-c3d5-4e21-b6c2-1eddf2f6bfd7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[405746, 10488, 270, 5, 6, "Section",ExpressionUUID->"99d02252-3f7d-4ebc-8617-2f41ad425bed",
 InitializationCell->True],
Cell[406019, 10495, 1060, 25, 42, "Input",ExpressionUUID->"fab69097-4b2f-4ba1-91f4-d535f917ec9c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[407116, 10525, 395, 8, 6, "Section",ExpressionUUID->"284c0f29-68d4-4b7e-8cca-4a88eb933d44",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[407536, 10537, 275, 5, 6, "Subsubsection",ExpressionUUID->"8dec1eb6-0ec8-41c0-ab87-be83b135cfe5",
 InitializationCell->True],
Cell[407814, 10544, 340, 8, 9, "Text",ExpressionUUID->"a7e56ce5-0a06-401f-9a4c-6c9080ccd6ba",
 InitializationCell->True],
Cell[408157, 10554, 1110, 27, 44, "Input",ExpressionUUID->"c738f160-299a-48d2-aa87-1672361772f8",
 InitializationCell->True],
Cell[409270, 10583, 2486, 63, 60, "Input",ExpressionUUID->"80db3592-3dbc-49cb-8d5e-d971c8e5fb00",
 InitializationCell->True],
Cell[411759, 10648, 2312, 57, 60, "Input",ExpressionUUID->"37cd0f88-3ba8-45e5-a71a-dfbbbd22bb42",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[414108, 10710, 323, 5, 6, "Subsubsection",ExpressionUUID->"b9a46b35-7099-4150-829e-bf14c685c4a1",
 InitializationCell->True],
Cell[414434, 10717, 1756, 42, 44, "Input",ExpressionUUID->"c758798e-246d-4b54-bbab-885dc7e12b24",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[416239, 10765, 357, 7, 6, "Section",ExpressionUUID->"ab8637d6-e468-4ba7-a1ba-cc0e71f4be35",
 InitializationCell->True,
 InitializationGroup->True],
Cell[416599, 10774, 429, 10, 8, "Input",ExpressionUUID->"d22e7f8c-3fa0-4533-8e94-9945795ddc68",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[417077, 10790, 270, 6, 44, "Subchapter",ExpressionUUID->"7fb32b84-acc1-4c04-bb02-68835047cbf6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[417372, 10800, 218, 5, 7, "Section",ExpressionUUID->"2a3d3625-239e-4544-9972-3579234f474e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[417615, 10809, 313, 7, 6, "Subsubsection",ExpressionUUID->"aee82773-7da0-4812-8a5e-d8cd33e277ff",
 InitializationCell->True,
 InitializationGroup->True],
Cell[417931, 10818, 382, 9, 8, "Input",ExpressionUUID->"ff9c3fb7-ceb7-4227-8543-a65e18b1ed54",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[418350, 10832, 313, 7, 4, "Subsubsection",ExpressionUUID->"e0d3d774-bf35-4b9b-866f-7c192d8f0f5a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[418666, 10841, 501, 14, 9, "Input",ExpressionUUID->"10d1ff59-f43b-4f62-b9e7-0566fc4d2bb2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[419204, 10860, 368, 9, 4, "Subsubsection",ExpressionUUID->"4ee88ad8-0bbb-418b-9bad-73e77337f3de",
 InitializationCell->True,
 InitializationGroup->True],
Cell[419575, 10871, 673, 16, 13, "Input",ExpressionUUID->"51ba9606-1200-425a-a691-209bdd502a6d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[420251, 10889, 1539, 33, 35, "Input",ExpressionUUID->"c072c856-0560-4c3f-9e7a-1afa8a1c5c7c",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[421839, 10928, 259, 6, 7, "Section",ExpressionUUID->"58bee56c-e908-473d-85c2-71dda3725ee3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[422101, 10936, 355, 9, 8, "Input",ExpressionUUID->"26e46738-9507-4e97-b5e5-7ea8277ffb20",
 InitializationCell->True],
Cell[422459, 10947, 1183, 25, 21, "Input",ExpressionUUID->"38f65ea5-7bcb-4b99-9bc1-b46226921a86",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[423691, 10978, 322, 8, 44, "Subchapter",ExpressionUUID->"5be95d9e-3b09-47a9-bf91-245f9fd4e947",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[424038, 10990, 179, 4, 6, "Section",ExpressionUUID->"e441ca4f-6845-471b-a8a8-c13a44bbaf77",
 InitializationCell->True],
Cell[424220, 10996, 1102, 22, 9, "Input",ExpressionUUID->"e850a97a-2c2f-4264-97ec-d43ca4c12db1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[425347, 11022, 278, 5, 8, "Subsection",ExpressionUUID->"f851fdb6-2eb9-4e41-9124-d5a0c0055ef5",
 InitializationCell->True],
Cell[425628, 11029, 549, 15, 9, "Input",ExpressionUUID->"ab59d710-7fc7-4e1a-a413-1a49d4b5a8a8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[426214, 11049, 190, 4, 6, "Subsection",ExpressionUUID->"9f37411b-b4da-4b29-b699-84b10fd041a0",
 InitializationCell->True],
Cell[426407, 11055, 1270, 27, 18, "Input",ExpressionUUID->"916b0116-78b8-4972-b481-b165cc712459",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[427714, 11087, 190, 4, 6, "Subsection",ExpressionUUID->"17c94ce5-c29c-4619-8ae2-0599fd4cc168",
 InitializationCell->True],
Cell[427907, 11093, 985, 23, 14, "Input",ExpressionUUID->"a63387e0-fca1-4026-8d21-fb73494a0943",
 InitializationCell->True,
 InitializationGroup->True],
Cell[428895, 11118, 1013, 23, 14, "Input",ExpressionUUID->"56004075-8b48-4675-9915-e86dbcf03949",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[429945, 11146, 246, 5, 6, "Subsection",ExpressionUUID->"88bd6888-b735-4d5d-ac90-ee491db8f3c8",
 InitializationCell->True],
Cell[430194, 11153, 1217, 29, 23, "Input",ExpressionUUID->"0d1b0dc1-89bb-47d4-88ca-992c2ef4bd83",
 InitializationCell->True,
 InitializationGroup->True],
Cell[431414, 11184, 713, 16, 14, "Input",ExpressionUUID->"c58e7bda-c562-45cd-bb0f-95909dc69020",
 InitializationCell->True,
 InitializationGroup->True],
Cell[432130, 11202, 794, 17, 14, "Input",ExpressionUUID->"0f566476-41c1-4296-a29c-2ef219ecbcca",
 InitializationCell->True,
 InitializationGroup->True],
Cell[432927, 11221, 1229, 29, 28, "Input",ExpressionUUID->"34939d8f-63f3-4c1e-ab1a-14ad86fb7342",
 InitializationCell->True,
 InitializationGroup->True],
Cell[434159, 11252, 742, 17, 18, "Input",ExpressionUUID->"bb3ed0b9-e22d-427c-87c6-71ea5392afdf",
 InitializationCell->True,
 InitializationGroup->True],
Cell[434904, 11271, 807, 17, 18, "Input",ExpressionUUID->"80b81758-5f02-450d-9fb5-8e0ee1a3b536",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[435748, 11293, 327, 5, 6, "Subsection",ExpressionUUID->"2edcba2a-2ee4-4177-9ba5-afff8144b138",
 InitializationCell->True],
Cell[436078, 11300, 1150, 26, 18, "Input",ExpressionUUID->"1119e514-8eda-41ea-8da8-7f3b3247c70e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[437231, 11328, 1102, 26, 23, "Input",ExpressionUUID->"2ab3b6b8-1843-4ad4-9afa-bec53acfe20f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[438336, 11356, 1166, 27, 18, "Input",ExpressionUUID->"8973e55d-8645-42b6-aa04-a2533f706b0c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[439505, 11385, 1116, 26, 23, "Input",ExpressionUUID->"31296bcf-1bae-4347-b10a-f02c70437063",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[440670, 11417, 356, 6, 6, "Section",ExpressionUUID->"a5500022-c728-406a-82b0-81346b05f0ce",
 InitializationCell->True],
Cell[441029, 11425, 1033, 27, 23, "Input",ExpressionUUID->"b12f2c28-625d-4417-ae85-bdb293051f46",
 InitializationCell->True],
Cell[442065, 11454, 1049, 27, 28, "Input",ExpressionUUID->"9d8c6cbb-f04f-4b78-9ebb-d6ee079052f4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[443151, 11486, 283, 5, 6, "Section",ExpressionUUID->"8fc45550-f96a-45d9-98d0-ac16a8e3ce8c",
 InitializationCell->True],
Cell[443437, 11493, 1891, 41, 30, "Input",ExpressionUUID->"a15dd698-ab7b-45d2-b63e-ae5b3b3aec54",
 InitializationCell->True,
 InitializationGroup->True],
Cell[445331, 11536, 1911, 41, 35, "Input",ExpressionUUID->"3e3c59d0-4313-40ec-8163-70e97b9cc622",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[447291, 11583, 245, 6, 44, "Subchapter",ExpressionUUID->"f64ce82e-5ae5-4c80-a5ae-5b22e255bbb3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[447539, 11591, 329, 7, 9, "Text",ExpressionUUID->"01deba27-5056-4282-a4a3-4a608e3214ff"],
Cell[447871, 11600, 452, 13, 9, "Input",ExpressionUUID->"c1bccd20-68bc-4855-a795-d2ff946f2e71",
 InitializationCell->True],
Cell[448326, 11615, 760, 22, 14, "Input",ExpressionUUID->"3ab8c854-d5ec-42d4-aff3-5241dcc4a104",
 InitializationCell->True],
Cell[449089, 11639, 615, 15, 14, "Input",ExpressionUUID->"82db4624-664d-44d3-91f0-939cf0238abe",
 InitializationCell->True],
Cell[449707, 11656, 695, 18, 14, "Input",ExpressionUUID->"d3916b01-d254-48af-8d46-2cfbece1832b",
 InitializationCell->True],
Cell[450405, 11676, 710, 18, 14, "Input",ExpressionUUID->"c5b7c7a9-6126-4355-9d2c-f3b90ada2c1a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[451152, 11699, 218, 6, 44, "Subchapter",ExpressionUUID->"5b5134ff-88a8-4f43-9ab4-4b8dd4ba61d4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[451395, 11709, 393, 9, 32, "Section",ExpressionUUID->"b9c36745-58a5-4d11-99a2-f9192203ba53",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[451813, 11722, 426, 9, 48, "Subsection",ExpressionUUID->"7feaaaf4-fe60-45b0-ba54-a3b94ef452e6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[452242, 11733, 1036, 25, 99, "Input",ExpressionUUID->"5c867863-9e17-416c-95c3-38e68b6e55a1",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[453315, 11763, 470, 9, 48, "Subsection",ExpressionUUID->"4c8ae5e8-5095-475f-b518-f667e66204ac",
 InitializationCell->True,
 InitializationGroup->True],
Cell[453788, 11774, 904, 22, 80, "Input",ExpressionUUID->"dd5b2967-b0f3-4fbc-aa3f-7e845abe8281",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[454729, 11801, 537, 11, 48, "Subsection",ExpressionUUID->"ce3461fc-1174-4970-92d6-9211944b6c45",
 InitializationCell->True,
 InitializationGroup->True],
Cell[455269, 11814, 828, 20, 80, "Input",ExpressionUUID->"787908dd-8ec5-42ac-8c33-a34b02e0eece",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[456146, 11840, 194, 4, 32, "Section",ExpressionUUID->"a3f8c46e-64b4-44bc-98cc-f5abada77b50",
 InitializationCell->True],
Cell[456343, 11846, 1817, 38, 75, "Input",ExpressionUUID->"98fcf83c-c135-482a-903b-b247cfd5e0aa",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[458197, 11889, 259, 7, 32, "Section",ExpressionUUID->"2c27c355-b32a-4ee0-8526-cf4527371780",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[458459, 11898, 326, 9, 4, "Input",ExpressionUUID->"fca145c6-d771-47c8-9f84-8812dd2bedc1",
 InitializationCell->True],
Cell[458788, 11909, 1044, 20, 4, "Input",ExpressionUUID->"3939d072-8f1c-44b6-b3a1-659aa9d4cc0c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[459835, 11931, 410, 11, 4, "Input",ExpressionUUID->"0de9890b-eb3d-4223-a7f1-87895f32731c",
 InitializationCell->True],
Cell[460248, 11944, 647, 17, 4, "Input",ExpressionUUID->"7f05fabf-7311-428a-adf2-40443da0f47c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[460898, 11963, 414, 11, 4, "Input",ExpressionUUID->"e78afedf-3132-479f-8469-a85c73275137",
 InitializationCell->True],
Cell[461315, 11976, 501, 12, 4, "Input",ExpressionUUID->"53f3dbee-1d37-4d42-ad1e-21bdb454da8f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[461819, 11990, 548, 13, 4, "Input",ExpressionUUID->"90f6c981-8e57-4c8c-b027-3200281683b3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[462370, 12005, 653, 15, 4, "Input",ExpressionUUID->"d5fdeee7-06dc-49d0-b8d8-fa980b998cc4",
 InitializationCell->True],
Cell[463026, 12022, 800, 18, 4, "Input",ExpressionUUID->"ce93ae69-f308-47f9-b833-1948cfe28478",
 InitializationCell->True,
 InitializationGroup->True],
Cell[463829, 12042, 1088, 26, 24, "Input",ExpressionUUID->"def4a254-855b-44ff-99ed-94b3cd028af3",
 InitializationCell->True],
Cell[464920, 12070, 471, 11, 4, "Input",ExpressionUUID->"3dba57a5-6935-4d47-ba27-2fef239a593f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[465394, 12083, 440, 10, 8, "Input",ExpressionUUID->"4141aba1-fb29-44dd-917d-094479a1a8d6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[465871, 12098, 493, 9, 32, "Section",ExpressionUUID->"c93ad0c1-7560-4ecf-9bd6-2f6238f74574",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[466389, 12111, 184, 4, 9, "Subsection",ExpressionUUID->"c7131ed1-c0e9-4e52-ab7c-bc6d0bfdf9b6",
 InitializationCell->True],
Cell[466576, 12117, 588, 13, 8, "Input",ExpressionUUID->"f775bb69-9468-4d6f-9214-e049c8a6b68e",
 InitializationCell->True],
Cell[467167, 12132, 482, 12, 4, "Input",ExpressionUUID->"af89f1c6-f1af-472f-92b3-60c36ae1a9b4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[467686, 12149, 326, 5, 7, "Subsection",ExpressionUUID->"1e9db967-6d13-42d7-88a6-d7e810668a54",
 InitializationCell->True],
Cell[468015, 12156, 1559, 36, 44, "Input",ExpressionUUID->"d31994eb-bb64-43f7-b09a-3c77f8499c04",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[469611, 12197, 304, 5, 9, "Subsection",ExpressionUUID->"de2f7d58-0313-453d-90d9-a4a315e1018d",
 InitializationCell->True],
Cell[469918, 12204, 1176, 30, 8, "Input",ExpressionUUID->"d64b5449-250e-4e02-b123-e79329d33fcc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[471131, 12239, 323, 8, 9, "Subsection",ExpressionUUID->"9cbc193a-71b7-42e8-94fc-8a5305a8bf3e",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[471479, 12251, 349, 7, 7, "Subsubsection",ExpressionUUID->"41a46fff-0f26-4b9c-9418-aed6dfa7c400",
 InitializationCell->True],
Cell[471831, 12260, 1015, 22, 44, "Input",ExpressionUUID->"1283f5aa-0382-4a35-b82d-fab39fdf67e2",
 InitializationCell->True],
Cell[472849, 12284, 1072, 22, 44, "Input",ExpressionUUID->"1283f5aa-0382-4a35-b82d-fab39fdf67e2",
 InitializationCell->True],
Cell[473924, 12308, 1068, 22, 44, "Input",ExpressionUUID->"1283f5aa-0382-4a35-b82d-fab39fdf67e2",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[475041, 12336, 315, 8, 9, "Subsection",ExpressionUUID->"9fcb1011-171a-4dd4-9144-111dc585c43c",
 InitializationCell->True],
Cell[475359, 12346, 470, 11, 8, "Input",ExpressionUUID->"9c56a974-c0ef-4921-a4cc-82e42eecb809",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[475866, 12362, 198, 4, 7, "Subsection",ExpressionUUID->"fdf2280a-52c8-4a32-b14a-22a117f59efd",
 InitializationCell->True],
Cell[476067, 12368, 560, 14, 9, "Input",ExpressionUUID->"ae33c9c0-d5a1-4ba4-bd2a-6ac43c058269",
 InitializationCell->True],
Cell[476630, 12384, 413, 10, 8, "Input",ExpressionUUID->"4d0968b0-8fce-47a6-838b-9790b36e1537",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[477092, 12400, 362, 7, 32, "Section",ExpressionUUID->"323f3e9a-deab-49bc-8a11-24eee8b8223a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[477479, 12411, 279, 5, 9, "Subsection",ExpressionUUID->"0ddb9f31-fabc-4af0-8089-0c7d80183d49",
 InitializationCell->True],
Cell[477761, 12418, 603, 18, 8, "Input",ExpressionUUID->"8f088890-7695-43ea-87b2-9ed63b57315a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[478401, 12441, 276, 5, 8, "Subsection",ExpressionUUID->"6cfc3c72-3eb8-45f8-b1ba-a7aa7dab04e9",
 InitializationCell->True],
Cell[478680, 12448, 537, 14, 9, "Input",ExpressionUUID->"7bd2cb38-67f3-4eeb-a0a1-81e7c3435871",
 InitializationCell->True],
Cell[479220, 12464, 567, 14, 9, "Input",ExpressionUUID->"44632a1a-0cd2-4f66-8f6f-1b8ba71f921e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[479824, 12483, 420, 7, 8, "Subsection",ExpressionUUID->"a184cbee-c2d0-4370-93a3-1c2fbe9f4ad0",
 InitializationCell->True],
Cell[480247, 12492, 1156, 27, 17, "Input",ExpressionUUID->"13491074-3b99-421f-9ed0-c53e13e4a5e8",
 InitializationCell->True],
Cell[481406, 12521, 1817, 39, 48, "Input",ExpressionUUID->"d470c8a3-a470-4125-be71-9951f839e79b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[483260, 12565, 396, 6, 8, "Subsection",ExpressionUUID->"8de87d0d-8649-4966-a616-88675b385219",
 InitializationCell->True],
Cell[483659, 12573, 377, 9, 9, "Text",ExpressionUUID->"630cc393-b060-4417-a5fb-4e2fde8715ed",
 InitializationCell->True],
Cell[484039, 12584, 560, 11, 9, "Text",ExpressionUUID->"63c5949e-7e30-4978-87b5-e3ebb62c6d6f",
 InitializationCell->True],
Cell[484602, 12597, 554, 10, 9, "Text",ExpressionUUID->"be7f3713-4efa-4476-93d4-cf155d8fa1ba",
 InitializationCell->True],
Cell[485159, 12609, 3909, 79, 172, "Input",ExpressionUUID->"0e1e1b2a-507d-4c8d-8a87-e166c42a12da",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[489105, 12693, 428, 7, 8, "Subsection",ExpressionUUID->"ca071759-cb87-439f-9b06-aa45ca93fc5b",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[489558, 12704, 526, 10, 7, "Subsubsection",ExpressionUUID->"32069964-2a23-4b6e-a98d-0a0cde2707cb",
 InitializationCell->True],
Cell[490087, 12716, 770, 17, 35, "Input",ExpressionUUID->"6326fbec-82a7-4828-b8e1-1cc6233ca283",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[490894, 12738, 494, 10, 6, "Subsubsection",ExpressionUUID->"cfe48c32-aa3c-49bd-8266-becb45bc6450",
 InitializationCell->True],
Cell[491391, 12750, 3931, 89, 94, "Input",ExpressionUUID->"10e458f8-971e-4c78-8761-62460e8b2551",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[495359, 12844, 447, 9, 6, "Subsubsection",ExpressionUUID->"dd3cfdd7-e8fe-4821-9bbc-ff789f85a1b8",
 InitializationCell->True],
Cell[495809, 12855, 1669, 38, 35, "Input",ExpressionUUID->"1ba50b39-3b99-4b70-b636-8e04ebb13f6f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[497515, 12898, 531, 10, 6, "Subsubsection",ExpressionUUID->"13b150bb-e8c4-42a4-812f-e0c9884cf8f3",
 InitializationCell->True],
Cell[498049, 12910, 5357, 119, 117, "Input",ExpressionUUID->"45673011-8d7d-45a9-be00-9fc9f043da9d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[503443, 13034, 584, 11, 6, "Subsubsection",ExpressionUUID->"50a70200-55fa-43ab-902c-6f083e78914f",
 InitializationCell->True],
Cell[504030, 13047, 211, 4, 5, "Text",ExpressionUUID->"526938b7-551e-47e8-b8e0-83f8302f7b04",
 InitializationCell->True],
Cell[504244, 13053, 2881, 65, 108, "Input",ExpressionUUID->"a052cf41-a2b6-496d-9193-fa3f282889de",
 InitializationCell->True],
Cell[507128, 13120, 261, 5, 5, "Text",ExpressionUUID->"9440fcca-6980-4433-83fa-97f547dd06fc",
 InitializationCell->True],
Cell[507392, 13127, 4583, 96, 131, "Input",ExpressionUUID->"1c562bce-41fb-481a-8cb8-411d7025a535",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[512024, 13229, 361, 6, 8, "Subsection",ExpressionUUID->"590e7e31-aa88-4a9f-8eb9-e5f8656935e3",
 InitializationCell->True],
Cell[512388, 13237, 269, 5, 5, "Text",ExpressionUUID->"85099355-9edb-48c6-83dc-cfc320246f2e",
 InitializationCell->True],
Cell[512660, 13244, 1149, 24, 58, "Input",ExpressionUUID->"bf6a9465-eae7-4571-a0b0-35fee49c612a",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[513858, 13274, 443, 9, 32, "Section",ExpressionUUID->"249c2a98-4d4e-473a-a550-221c2f6da218",
 InitializationCell->True,
 InitializationGroup->True],
Cell[514304, 13285, 677, 12, 114, "Text",ExpressionUUID->"b49380d2-d505-4310-8682-8149993a4049",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[515006, 13301, 231, 5, 48, "Subsection",ExpressionUUID->"2c54f03b-cba6-4f5a-a264-b0dccba970db",
 InitializationCell->True],
Cell[515240, 13308, 863, 20, 8, "Input",ExpressionUUID->"632488ff-2229-414d-98ec-535bff5317d2",
 InitializationCell->True],
Cell[516106, 13330, 384, 9, 4, "Input",ExpressionUUID->"7f9b942e-efb2-4c75-9e16-a5fe735a2f50",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[516527, 13344, 181, 4, 34, "Subsection",ExpressionUUID->"9225cdde-45da-484f-b40c-e97607fec3eb",
 InitializationCell->True],
Cell[516711, 13350, 3342, 63, 57, "Input",ExpressionUUID->"7c08b054-5311-4a0e-ba44-d8b8d6af69f8",
 InitializationCell->True],
Cell[520056, 13415, 3435, 68, 60, "Input",ExpressionUUID->"4fc56183-a4f7-480c-9f3a-744d44d60461",
 InitializationCell->True],
Cell[523494, 13485, 4750, 91, 87, "Input",ExpressionUUID->"bae568dd-e850-4773-9190-c50fa955e9db",
 InitializationCell->True],
Cell[528247, 13578, 4715, 90, 87, "Input",ExpressionUUID->"bae568dd-e850-4773-9190-c50fa955e9db",
 InitializationCell->True],
Cell[532965, 13670, 4709, 90, 87, "Input",ExpressionUUID->"bae568dd-e850-4773-9190-c50fa955e9db",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[537711, 13765, 327, 6, 34, "Subsection",ExpressionUUID->"4eb2c686-e342-4656-ab01-5c1a6d260d51",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[538063, 13775, 504, 8, 7, "Subsubsection",ExpressionUUID->"c7c66361-539f-4a84-a3cd-4e6de8d9fa77",
 InitializationCell->True],
Cell[538570, 13785, 522, 14, 4, "Input",ExpressionUUID->"827ee96a-507f-4c23-82e3-a768457e0c7e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[539129, 13804, 583, 9, 6, "Subsubsection",ExpressionUUID->"448c2b2b-bf05-418c-8704-4c7c5227758f",
 InitializationCell->True],
Cell[539715, 13815, 1300, 35, 28, "Input",ExpressionUUID->"943cae92-e678-4792-9258-b4b807168209",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[541052, 13855, 288, 5, 6, "Subsubsection",ExpressionUUID->"84958263-9d3b-4e6f-bb1e-66a34b220b88",
 InitializationCell->True],
Cell[541343, 13862, 543, 14, 4, "Input",ExpressionUUID->"af056332-1c6b-4d9e-9782-e76a04d79017",
 InitializationCell->True],
Cell[541889, 13878, 565, 13, 8, "Input",ExpressionUUID->"42569466-89b0-433d-beea-349c4e606494",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[542491, 13896, 334, 6, 6, "Subsubsection",ExpressionUUID->"01b05daa-5763-4a3e-99da-fc2d6cb4480b",
 InitializationCell->True],
Cell[542828, 13904, 1438, 38, 25, "Input",ExpressionUUID->"e30013dc-640e-4681-adfe-026f9380b48a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[544303, 13947, 497, 8, 6, "Subsubsection",ExpressionUUID->"f0bc0322-71b2-47e9-84e2-254789c0600a",
 InitializationCell->True],
Cell[544803, 13957, 578, 15, 8, "Input",ExpressionUUID->"e11ef65a-9da8-4e5a-b729-382fab66875a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[545418, 13977, 611, 9, 6, "Subsubsection",ExpressionUUID->"2cbde142-2ced-4813-8514-c882f273f630",
 InitializationCell->True],
Cell[546032, 13988, 1302, 27, 28, "Input",ExpressionUUID->"4373da88-8d84-483e-a5b0-bb11bac0bb70",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[547371, 14020, 693, 10, 6, "Subsubsection",ExpressionUUID->"5fe946a6-867c-4056-a8a2-cfb8cbf437d2",
 InitializationCell->True],
Cell[548067, 14032, 223, 4, 5, "Text",ExpressionUUID->"5e31cac7-a393-4600-a1f8-a96a2dd8d428",
 InitializationCell->True],
Cell[548293, 14038, 1929, 47, 24, "Input",ExpressionUUID->"8615bd40-e66d-4355-8c94-446cf35bb4b8",
 InitializationCell->True],
Cell[550225, 14087, 2213, 55, 28, "Input",ExpressionUUID->"c9aa172a-7300-4e65-adc2-9b4f46294911",
 InitializationCell->True],
Cell[552441, 14144, 1962, 46, 24, "Input",ExpressionUUID->"d58ebfa0-17ca-420c-b7a4-55dcfdde87de",
 InitializationCell->True],
Cell[554406, 14192, 329, 8, 5, "Text",ExpressionUUID->"7374fe99-a2fc-402d-8b2f-95e1067dc4dd",
 InitializationCell->True],
Cell[554738, 14202, 1973, 45, 32, "Input",ExpressionUUID->"e074be32-f0a6-4734-ab81-72e39a225702",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[556748, 14252, 479, 8, 6, "Subsubsection",ExpressionUUID->"f1b51523-9040-49af-87be-6a3ce1409017",
 InitializationCell->True],
Cell[557230, 14262, 437, 9, 9, "Text",ExpressionUUID->"add48913-4b58-4f75-ae57-650f962a306c",
 InitializationCell->True],
Cell[557670, 14273, 313, 8, 5, "Text",ExpressionUUID->"fcbce595-ade2-4f69-9fe6-3ad3bf34026c",
 InitializationCell->True],
Cell[557986, 14283, 2562, 62, 44, "Input",ExpressionUUID->"605e0306-8e51-4812-9be1-143582f7bc73",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[560585, 14350, 420, 7, 6, "Subsubsection",ExpressionUUID->"42b6c92f-e710-4fab-85c1-93f68a1f2eec",
 InitializationCell->True],
Cell[561008, 14359, 876, 22, 8, "Input",ExpressionUUID->"8f357a04-d380-472a-ac97-e4c0a98a8a06",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[561921, 14386, 190, 4, 6, "Subsubsection",ExpressionUUID->"9bf06bf1-6599-4e2b-a1b2-fe7712bbd70f",
 InitializationCell->True],
Cell[562114, 14392, 325, 8, 4, "Input",ExpressionUUID->"815bc13d-52b8-4352-b5e6-5cad1c04b906",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[562488, 14406, 631, 10, 34, "Subsection",ExpressionUUID->"354ef0ad-66e9-4c54-b7de-8a2d8c81d080",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[563144, 14420, 395, 8, 7, "Subsubsection",ExpressionUUID->"d3b46920-cf8e-4f16-acb6-9ffad2d1fd7b",
 InitializationCell->True],
Cell[563542, 14430, 1198, 27, 26, "Input",ExpressionUUID->"41211d13-a9bc-464d-bf48-2ccf266a2b49",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[564777, 14462, 444, 9, 9, "Subsubsection",ExpressionUUID->"e1ead5ca-38f2-4461-8258-78ec4f955ee8",
 InitializationCell->True],
Cell[565224, 14473, 1801, 38, 51, "Input",ExpressionUUID->"f78c1f77-6357-4415-81a7-976a3b342054",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[567074, 14517, 570, 9, 34, "Subsection",ExpressionUUID->"9ad0d9c1-4e95-48c3-99b0-8c485c4a4376",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[567669, 14530, 303, 5, 7, "Subsubsection",ExpressionUUID->"f1ecd21f-1b31-43e6-88c9-a7ab3a6ab44a",
 InitializationCell->True],
Cell[567975, 14537, 434, 9, 5, "Text",ExpressionUUID->"d701d393-ad22-427c-9e4a-a29f63d6b9d5",
 InitializationCell->True],
Cell[568412, 14548, 2714, 63, 61, "Input",ExpressionUUID->"5e3414fc-d290-4222-8285-6096529355bb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[571163, 14616, 354, 6, 7, "Subsubsection",ExpressionUUID->"ae4de76b-fca1-48d3-a4c0-ad12b6ae60ac",
 InitializationCell->True],
Cell[571520, 14624, 1547, 39, 44, "Input",ExpressionUUID->"47a78ee9-dc6c-47a4-87e3-e3902b978c57",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[573104, 14668, 313, 5, 7, "Subsubsection",ExpressionUUID->"3d7d5af4-49d9-44d2-9b9d-3cef096b16ab",
 InitializationCell->True],
Cell[573420, 14675, 2289, 49, 66, "Input",ExpressionUUID->"81e5cabf-cc9f-4217-ab56-e91e7a7d5f33",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[575746, 14729, 304, 5, 6, "Subsubsection",ExpressionUUID->"0b197dd1-5ced-4f5c-b026-6fa3d73c0044",
 InitializationCell->True],
Cell[576053, 14736, 4458, 102, 90, "Input",ExpressionUUID->"b67b0acd-991e-4ac5-bd52-8cdeb7887365",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[580560, 14844, 692, 11, 34, "Subsection",ExpressionUUID->"c73ce7dc-8cd9-45ac-a6b0-3eb21f78f28c",
 InitializationCell->True],
Cell[581255, 14857, 2064, 49, 72, "Input",ExpressionUUID->"7665f2de-9f9d-4835-8b5f-8e91b916c03e",
 InitializationCell->True],
Cell[583322, 14908, 2422, 59, 76, "Input",ExpressionUUID->"19a031ee-29fb-4d22-b9b4-4728b3fe012c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[585781, 14972, 559, 9, 34, "Subsection",ExpressionUUID->"70b44864-8932-41d1-923e-f1af34ff09d5",
 InitializationCell->True],
Cell[586343, 14983, 907, 22, 9, "Input",ExpressionUUID->"12b8ac0e-3f03-4374-97a7-4ce9294f903c",
 InitializationCell->True],
Cell[587253, 15007, 943, 22, 9, "Input",ExpressionUUID->"4746d3d0-421a-438d-a376-d58ef9627b91",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[588233, 15034, 406, 7, 34, "Subsection",ExpressionUUID->"82a3ca40-6b02-4f5d-81fb-6ea530e2468f",
 InitializationCell->True],
Cell[588642, 15043, 962, 23, 80, "Input",ExpressionUUID->"bae12d0c-be88-4c8e-8ff3-6e53d94833d8",
 InitializationCell->True],
Cell[589607, 15068, 1095, 26, 99, "Input",ExpressionUUID->"e1661cbc-de42-496b-a0f6-3ddb1521fe9e",
 InitializationCell->True],
Cell[590705, 15096, 1339, 32, 137, "Input",ExpressionUUID->"3bb0dbb3-aaa0-46c0-b70d-ba922f32a46e",
 InitializationCell->True],
Cell[592047, 15130, 1400, 33, 137, "Input",ExpressionUUID->"0792e85b-1d25-4329-b73f-5f2ce2051d80",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[593484, 15168, 439, 7, 48, "Subsection",ExpressionUUID->"bc89d1af-d758-449c-9ee9-15c20484f7c5",
 InitializationCell->True],
Cell[593926, 15177, 1271, 27, 47, "Input",ExpressionUUID->"18002ac5-5455-4c10-89b1-2f319aef5f97",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[595234, 15209, 366, 6, 34, "Subsection",ExpressionUUID->"adec2bf0-ed50-4f5c-b51a-f28ede7f5f1a",
 InitializationCell->True],
Cell[595603, 15217, 1354, 31, 213, "Input",ExpressionUUID->"cf083b9c-5573-4f78-8899-dbaa943c1da8",
 InitializationCell->True],
Cell[596960, 15250, 1178, 27, 137, "Input",ExpressionUUID->"51a40a67-aa5e-4378-b0aa-c771b9efe2b3",
 InitializationCell->True],
Cell[598141, 15279, 781, 18, 80, "Input",ExpressionUUID->"771f3215-3b3b-4cc6-9a58-9cc0f5be8e2c",
 InitializationCell->True],
Cell[598925, 15299, 804, 19, 80, "Input",ExpressionUUID->"ca7e9206-7d2c-4bfa-bb63-b2e19381729e",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[599766, 15323, 327, 6, 48, "Subsection",ExpressionUUID->"076e89e1-ef53-49b9-8b70-3ee669153ebd",
 InitializationCell->True],
Cell[600096, 15331, 687, 13, 12, "Input",ExpressionUUID->"6cbeb85d-e4ea-4583-8826-a19abd6cf928",
 InitializationCell->True],
Cell[600786, 15346, 656, 13, 12, "Input",ExpressionUUID->"b7d28878-4eb7-4518-b2e3-d988224cfd0c",
 InitializationCell->True],
Cell[601445, 15361, 678, 13, 12, "Input",ExpressionUUID->"ac883e3c-9f22-4658-b33c-0e3cf9a91447",
 InitializationCell->True],
Cell[602126, 15376, 389, 9, 4, "Input",ExpressionUUID->"7260d2c5-b939-4407-a69a-f0f5a8a0b5f7",
 InitializationCell->True],
Cell[602518, 15387, 523, 11, 12, "Input",ExpressionUUID->"ab6f2ddd-a15d-4be6-b4cf-0f9e55e08e82",
 InitializationCell->True],
Cell[603044, 15400, 472, 11, 12, "Input",ExpressionUUID->"115af249-4c11-499a-9f0b-ed7ee0d2ea5a",
 InitializationCell->True],
Cell[603519, 15413, 479, 11, 17, "Input",ExpressionUUID->"55776a7d-c5c6-4e33-91a7-e7be92626b65",
 InitializationCell->True],
Cell[604001, 15426, 511, 11, 12, "Input",ExpressionUUID->"90554043-c9e8-47a9-a16e-7dcbe4d9fabe",
 InitializationCell->True],
Cell[604515, 15439, 464, 10, 12, "Input",ExpressionUUID->"826a4d49-a7d6-4103-b89f-098502ecc9d1",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[605028, 15455, 221, 6, 32, "Section",ExpressionUUID->"ec2a460b-9f5f-4254-b864-669c6c9cc63d",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[605252, 15463, 375, 11, 4, "Input",ExpressionUUID->"63533103-be1a-4fb1-adc3-3e22c5a17479",
 InitializationCell->True,
 InitializationGroup->True],
Cell[605630, 15476, 621, 14, 4, "Input",ExpressionUUID->"246c02b2-d769-4066-97f9-4c1f35e20fe2",
 InitializationCell->True],
Cell[606254, 15492, 644, 14, 4, "Input",ExpressionUUID->"0af2582d-7a81-4762-b251-bd72d8a2050b",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[606923, 15510, 167, 4, 6, "Subsection",ExpressionUUID->"67c6fd62-1e62-4c37-8299-72eea690c8c2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[607093, 15516, 766, 17, 5, "Input",ExpressionUUID->"04ba97f0-0994-4602-be98-4c8d5aab7f6d",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[607896, 15538, 372, 8, 6, "Subsection",ExpressionUUID->"1ea2f66d-5581-4ba7-a4b4-9c0617424374",
 InitializationCell->True,
 InitializationGroup->True],
Cell[608271, 15548, 1053, 26, 8, "Input",ExpressionUUID->"36220375-a834-495c-9b60-c76688d99d18",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[609361, 15579, 187, 4, 6, "Subsection",ExpressionUUID->"3cfc46a4-b942-48f0-9c6f-1dd0c7ad83dd",
 InitializationCell->True],
Cell[609551, 15585, 325, 8, 4, "Input",ExpressionUUID->"78ea57d2-fd94-48e8-b8e4-f7001001fd0a",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[609925, 15599, 288, 7, 32, "Section",ExpressionUUID->"41f887a7-92f2-4728-922e-aaa8eb8382d3",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[610238, 15610, 167, 4, 6, "Subsection",ExpressionUUID->"f7f9e19a-a2b6-42f0-b675-0cb41e5d2468",
 InitializationCell->True,
 InitializationGroup->True],
Cell[610408, 15616, 711, 16, 5, "Input",ExpressionUUID->"36cc0de6-9539-4803-9290-accb4848df5c",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[611156, 15637, 268, 6, 4, "Subsection",ExpressionUUID->"8c2e950f-af3b-4b65-b5eb-e5729c02e8e6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[611427, 15645, 456, 12, 4, "Input",ExpressionUUID->"33cb4f62-0706-400e-b80d-befc0249ef52",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[611920, 15662, 271, 6, 4, "Subsection",ExpressionUUID->"d8a702c1-6efa-48c8-8b2d-ba4ef860f34e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[612194, 15670, 649, 13, 4, "Input",ExpressionUUID->"baf471ba-579a-49fb-84eb-c034269e141a",
 InitializationCell->True],
Cell[612846, 15685, 675, 14, 4, "Input",ExpressionUUID->"a085b70f-0816-4fdd-ba69-6d4485ebedd0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[613558, 15704, 250, 5, 4, "Subsection",ExpressionUUID->"d15859bf-3d48-4840-a027-75c96dea022e",
 InitializationCell->True],
Cell[613811, 15711, 586, 14, 8, "Input",ExpressionUUID->"647df764-de71-432c-9b0d-2f7d31a4152a",
 InitializationCell->True],
Cell[614400, 15727, 830, 20, 11, "Input",ExpressionUUID->"abd90a9f-075e-46d8-bb37-f8db6a2105ea",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[615267, 15752, 372, 8, 4, "Subsection",ExpressionUUID->"c70ef8ce-ddf3-4641-bf00-c93799a92d45",
 InitializationCell->True,
 InitializationGroup->True],
Cell[615642, 15762, 1097, 26, 8, "Input",ExpressionUUID->"4b70175e-c11f-4be8-b594-70eb7aafc3b1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[616776, 15793, 187, 4, 6, "Subsection",ExpressionUUID->"24b991fe-d0dd-4f63-83db-c667b37ecf2a",
 InitializationCell->True],
Cell[616966, 15799, 323, 8, 4, "Input",ExpressionUUID->"5109bbbf-3fcb-4923-8be3-6c13f23a80f8",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[617338, 15813, 367, 8, 32, "Section",ExpressionUUID->"382d62dd-f2cf-4e6c-84c3-aad85797be1e",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[617730, 15825, 277, 5, 48, "Subsection",ExpressionUUID->"d1f352a5-1628-4b30-8679-4948372fa91f",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[618032, 15834, 426, 10, 8, "Input",ExpressionUUID->"719f8054-9b1f-4efb-af88-989d69bd3e59",
 InitializationCell->True],
Cell[618461, 15846, 315, 7, 56, "Output",ExpressionUUID->"7438e479-7229-41fa-a30f-7850221647ec"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[618825, 15859, 372, 8, 34, "Subsection",ExpressionUUID->"d47fe0f0-62d7-48f6-8b35-5a792cd5d3e0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[619200, 15869, 1112, 26, 8, "Input",ExpressionUUID->"4489909d-79f3-4691-ae0d-32314a69b7db",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[620349, 15900, 250, 5, 34, "Subsection",ExpressionUUID->"ea41f146-7879-4948-ab8f-1d74ff1464ed",
 InitializationCell->True],
Cell[620602, 15907, 1371, 37, 28, "Input",ExpressionUUID->"71725114-be1c-4b49-acf0-245e495e1c8b",
 InitializationCell->True],
Cell[621976, 15946, 873, 22, 23, "Input",ExpressionUUID->"c008a042-c3e6-4f21-b431-4673bd7b4f0d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[622886, 15973, 187, 4, 34, "Subsection",ExpressionUUID->"0f3238e8-22ec-4b94-aa6a-70e2d11e1241",
 InitializationCell->True],
Cell[623076, 15979, 337, 8, 4, "Input",ExpressionUUID->"4dceffb1-fe23-4dee-84ff-e6deece1d518",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[623450, 15992, 340, 6, 34, "Subsection",ExpressionUUID->"5da2ba74-a93c-490b-95b2-7d071fd7c259",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[623815, 16002, 376, 6, 6, "Subsubsection",ExpressionUUID->"23b84ba3-fea0-4ef1-a2f9-3610d431758c",
 InitializationCell->True],
Cell[624194, 16010, 2022, 48, 55, "Input",ExpressionUUID->"d303b339-f7b3-4e0b-a973-ecb398e05d36",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[626253, 16063, 467, 10, 10, "Subsubsection",ExpressionUUID->"9e2f03b5-8c20-4aa0-8fec-2df87b48e345",
 InitializationCell->True],
Cell[626723, 16075, 2957, 69, 82, "Input",ExpressionUUID->"8c3fc7e2-e2af-4541-aad7-988d89dca8ce",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[629717, 16149, 587, 11, 12, "Subsubsection",ExpressionUUID->"b5254597-100b-423f-88a6-3226059ac608",
 InitializationCell->True],
Cell[630307, 16162, 3193, 75, 86, "Input",ExpressionUUID->"36632bc5-33a5-46b6-a921-d9bfe3398080",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[633549, 16243, 332, 6, 34, "Subsection",ExpressionUUID->"aa11abd9-be09-42f3-96aa-f864a769fefb",
 InitializationCell->True],
Cell[633884, 16251, 451, 11, 4, "Input",ExpressionUUID->"7a97b6b1-f435-4d0d-a67b-356bcae7f246",
 InitializationCell->True],
Cell[634338, 16264, 467, 11, 4, "Input",ExpressionUUID->"2594d716-d38f-49b3-b86b-92dca9f0b91c",
 InitializationCell->True],
Cell[634808, 16277, 474, 12, 4, "Input",ExpressionUUID->"45f0e9fa-0cff-4be9-adae-6716eb91864e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[635319, 16294, 222, 4, 34, "Subsection",ExpressionUUID->"c9228dcf-bfb2-4c50-9ab1-faad5698b3c9",
 InitializationCell->True],
Cell[635544, 16300, 431, 12, 4, "Input",ExpressionUUID->"cad45891-9df3-418f-926d-86d146706246",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[636012, 16317, 296, 7, 34, "Subsection",ExpressionUUID->"a63d20ab-9b2b-4bdc-ad47-87a5ebb784a3",
 InitializationCell->True],
Cell[636311, 16326, 1163, 27, 137, "Input",ExpressionUUID->"8dfc1a7c-5466-4edc-b4b5-02fdd084d2a1",
 InitializationCell->True],
Cell[637477, 16355, 1217, 28, 137, "Input",ExpressionUUID->"b2f9b281-7c23-4fb7-a816-4533f5d0ea6e",
 InitializationCell->True],
Cell[638697, 16385, 1027, 23, 118, "Input",ExpressionUUID->"05c1987a-41d0-47b3-b073-ab7a4ec7009d",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[639761, 16413, 277, 5, 48, "Subsection",ExpressionUUID->"a0e2c95b-d4c1-4975-99b2-be1107ecbc2b",
 InitializationCell->True],
Cell[640041, 16420, 519, 11, 17, "Input",ExpressionUUID->"8fe3f063-6579-4282-82be-c7b39391576a",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[640609, 16437, 426, 9, 32, "Section",ExpressionUUID->"382d62dd-f2cf-4e6c-84c3-aad85797be1e",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[641060, 16450, 277, 5, 48, "Subsection",ExpressionUUID->"d1f352a5-1628-4b30-8679-4948372fa91f",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[641362, 16459, 482, 11, 8, "Input",ExpressionUUID->"719f8054-9b1f-4efb-af88-989d69bd3e59",
 InitializationCell->True],
Cell[641847, 16472, 317, 7, 56, "Output",ExpressionUUID->"ec2bbae2-7b44-4fcd-9953-6cb5bade7eef"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[642213, 16485, 372, 8, 34, "Subsection",ExpressionUUID->"d47fe0f0-62d7-48f6-8b35-5a792cd5d3e0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[642588, 16495, 1179, 27, 9, "Input",ExpressionUUID->"4489909d-79f3-4691-ae0d-32314a69b7db",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[643804, 16527, 250, 5, 34, "Subsection",ExpressionUUID->"ea41f146-7879-4948-ab8f-1d74ff1464ed",
 InitializationCell->True],
Cell[644057, 16534, 1445, 38, 13, "Input",ExpressionUUID->"71725114-be1c-4b49-acf0-245e495e1c8b",
 InitializationCell->True],
Cell[645505, 16574, 950, 23, 13, "Input",ExpressionUUID->"c008a042-c3e6-4f21-b431-4673bd7b4f0d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[646492, 16602, 187, 4, 34, "Subsection",ExpressionUUID->"0f3238e8-22ec-4b94-aa6a-70e2d11e1241",
 InitializationCell->True],
Cell[646682, 16608, 369, 9, 8, "Input",ExpressionUUID->"4dceffb1-fe23-4dee-84ff-e6deece1d518",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[647088, 16622, 340, 6, 34, "Subsection",ExpressionUUID->"5da2ba74-a93c-490b-95b2-7d071fd7c259",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[647453, 16632, 376, 6, 7, "Subsubsection",ExpressionUUID->"23b84ba3-fea0-4ef1-a2f9-3610d431758c",
 InitializationCell->True],
Cell[647832, 16640, 2109, 50, 74, "Input",ExpressionUUID->"d303b339-f7b3-4e0b-a973-ecb398e05d36",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[649978, 16695, 515, 10, 6, "Subsubsection",ExpressionUUID->"9e2f03b5-8c20-4aa0-8fec-2df87b48e345",
 InitializationCell->True],
Cell[650496, 16707, 3064, 72, 87, "Input",ExpressionUUID->"8c3fc7e2-e2af-4541-aad7-988d89dca8ce",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[653597, 16784, 587, 11, 6, "Subsubsection",ExpressionUUID->"b5254597-100b-423f-88a6-3226059ac608",
 InitializationCell->True],
Cell[654187, 16797, 3305, 78, 92, "Input",ExpressionUUID->"36632bc5-33a5-46b6-a921-d9bfe3398080",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[657541, 16881, 373, 8, 34, "Subsection",ExpressionUUID->"aa11abd9-be09-42f3-96aa-f864a769fefb",
 InitializationCell->True],
Cell[657917, 16891, 482, 11, 8, "Input",ExpressionUUID->"7a97b6b1-f435-4d0d-a67b-356bcae7f246",
 InitializationCell->True],
Cell[658402, 16904, 499, 11, 8, "Input",ExpressionUUID->"2594d716-d38f-49b3-b86b-92dca9f0b91c",
 InitializationCell->True],
Cell[658904, 16917, 503, 12, 8, "Input",ExpressionUUID->"45f0e9fa-0cff-4be9-adae-6716eb91864e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[659444, 16934, 254, 4, 34, "Subsection",ExpressionUUID->"c9228dcf-bfb2-4c50-9ab1-faad5698b3c9",
 InitializationCell->True],
Cell[659701, 16940, 537, 14, 8, "Input",ExpressionUUID->"cad45891-9df3-418f-926d-86d146706246",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[660275, 16959, 329, 7, 34, "Subsection",ExpressionUUID->"a63d20ab-9b2b-4bdc-ad47-87a5ebb784a3",
 InitializationCell->True],
Cell[660607, 16968, 1171, 27, 137, "Input",ExpressionUUID->"8dfc1a7c-5466-4edc-b4b5-02fdd084d2a1",
 InitializationCell->True],
Cell[661781, 16997, 1139, 25, 137, "Input",ExpressionUUID->"b2f9b281-7c23-4fb7-a816-4533f5d0ea6e",
 InitializationCell->True],
Cell[662923, 17024, 1013, 22, 118, "Input",ExpressionUUID->"05c1987a-41d0-47b3-b073-ab7a4ec7009d",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[663973, 17051, 277, 5, 48, "Subsection",ExpressionUUID->"a0e2c95b-d4c1-4975-99b2-be1107ecbc2b",
 InitializationCell->True],
Cell[664253, 17058, 585, 12, 8, "Input",ExpressionUUID->"8fe3f063-6579-4282-82be-c7b39391576a",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[664887, 17076, 451, 9, 32, "Section",ExpressionUUID->"382d62dd-f2cf-4e6c-84c3-aad85797be1e",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[665363, 17089, 277, 5, 48, "Subsection",ExpressionUUID->"d1f352a5-1628-4b30-8679-4948372fa91f",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[665665, 17098, 506, 11, 8, "Input",ExpressionUUID->"719f8054-9b1f-4efb-af88-989d69bd3e59",
 InitializationCell->True],
Cell[666174, 17111, 314, 7, 56, "Output",ExpressionUUID->"9b588862-8572-471e-af43-83409c098f91"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[666537, 17124, 372, 8, 34, "Subsection",ExpressionUUID->"d47fe0f0-62d7-48f6-8b35-5a792cd5d3e0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[666912, 17134, 1235, 28, 9, "Input",ExpressionUUID->"4489909d-79f3-4691-ae0d-32314a69b7db",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[668184, 17167, 250, 5, 34, "Subsection",ExpressionUUID->"ea41f146-7879-4948-ab8f-1d74ff1464ed",
 InitializationCell->True],
Cell[668437, 17174, 1498, 38, 13, "Input",ExpressionUUID->"71725114-be1c-4b49-acf0-245e495e1c8b",
 InitializationCell->True],
Cell[669938, 17214, 1003, 24, 13, "Input",ExpressionUUID->"c008a042-c3e6-4f21-b431-4673bd7b4f0d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[670978, 17243, 187, 4, 34, "Subsection",ExpressionUUID->"0f3238e8-22ec-4b94-aa6a-70e2d11e1241",
 InitializationCell->True],
Cell[671168, 17249, 394, 9, 8, "Input",ExpressionUUID->"4dceffb1-fe23-4dee-84ff-e6deece1d518",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[671599, 17263, 340, 6, 34, "Subsection",ExpressionUUID->"5da2ba74-a93c-490b-95b2-7d071fd7c259",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[671964, 17273, 376, 6, 7, "Subsubsection",ExpressionUUID->"23b84ba3-fea0-4ef1-a2f9-3610d431758c",
 InitializationCell->True],
Cell[672343, 17281, 2153, 50, 74, "Input",ExpressionUUID->"d303b339-f7b3-4e0b-a973-ecb398e05d36",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[674533, 17336, 515, 10, 6, "Subsubsection",ExpressionUUID->"9e2f03b5-8c20-4aa0-8fec-2df87b48e345",
 InitializationCell->True],
Cell[675051, 17348, 3114, 72, 87, "Input",ExpressionUUID->"8c3fc7e2-e2af-4541-aad7-988d89dca8ce",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[678202, 17425, 587, 11, 6, "Subsubsection",ExpressionUUID->"b5254597-100b-423f-88a6-3226059ac608",
 InitializationCell->True],
Cell[678792, 17438, 3364, 79, 92, "Input",ExpressionUUID->"36632bc5-33a5-46b6-a921-d9bfe3398080",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[682205, 17523, 396, 8, 34, "Subsection",ExpressionUUID->"aa11abd9-be09-42f3-96aa-f864a769fefb",
 InitializationCell->True],
Cell[682604, 17533, 511, 12, 8, "Input",ExpressionUUID->"7a97b6b1-f435-4d0d-a67b-356bcae7f246",
 InitializationCell->True],
Cell[683118, 17547, 526, 12, 8, "Input",ExpressionUUID->"2594d716-d38f-49b3-b86b-92dca9f0b91c",
 InitializationCell->True],
Cell[683647, 17561, 530, 13, 8, "Input",ExpressionUUID->"45f0e9fa-0cff-4be9-adae-6716eb91864e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[684214, 17579, 281, 5, 34, "Subsection",ExpressionUUID->"c9228dcf-bfb2-4c50-9ab1-faad5698b3c9",
 InitializationCell->True],
Cell[684498, 17586, 592, 15, 8, "Input",ExpressionUUID->"cad45891-9df3-418f-926d-86d146706246",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[685127, 17606, 352, 7, 34, "Subsection",ExpressionUUID->"a63d20ab-9b2b-4bdc-ad47-87a5ebb784a3",
 InitializationCell->True],
Cell[685482, 17615, 1194, 27, 156, "Input",ExpressionUUID->"8dfc1a7c-5466-4edc-b4b5-02fdd084d2a1",
 InitializationCell->True],
Cell[686679, 17644, 1187, 26, 156, "Input",ExpressionUUID->"b2f9b281-7c23-4fb7-a816-4533f5d0ea6e",
 InitializationCell->True],
Cell[687869, 17672, 1090, 23, 118, "Input",ExpressionUUID->"05c1987a-41d0-47b3-b073-ab7a4ec7009d",
 InitializationCell->True],
Cell[688962, 17697, 1826, 41, 175, "Input",ExpressionUUID->"05c1987a-41d0-47b3-b073-ab7a4ec7009d",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[690825, 17743, 277, 5, 48, "Subsection",ExpressionUUID->"a0e2c95b-d4c1-4975-99b2-be1107ecbc2b",
 InitializationCell->True],
Cell[691105, 17750, 587, 12, 8, "Input",ExpressionUUID->"8fe3f063-6579-4282-82be-c7b39391576a",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[691741, 17768, 233, 6, 32, "Section",ExpressionUUID->"06d2594e-4c90-4f8d-8279-41dbe787003b",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[691999, 17778, 187, 4, 9, "Subsection",ExpressionUUID->"f29d096a-1211-4114-bf65-0f6bc80cc96b",
 InitializationCell->True],
Cell[692189, 17784, 343, 8, 8, "Input",ExpressionUUID->"db981fa7-0a4f-46ff-9f14-941c818b5c7d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[692569, 17797, 372, 8, 7, "Subsection",ExpressionUUID->"8c60f2d9-725f-43e8-9f20-a947bb737fcc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[692944, 17807, 1125, 26, 11, "Input",ExpressionUUID->"c20cb1cd-dd79-4ec1-8caa-6d330cd1baae",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[694106, 17838, 372, 8, 7, "Subsection",ExpressionUUID->"36631473-e7fc-4102-8a0a-09576fa5dc94",
 InitializationCell->True],
Cell[694481, 17848, 395, 10, 4, "Input",ExpressionUUID->"0f3d2733-b921-4459-8458-4ab737ef195e",
 InitializationCell->True],
Cell[694879, 17860, 394, 10, 4, "Input",ExpressionUUID->"275641ac-3175-4143-83e4-c73b2393d69e",
 InitializationCell->True],
Cell[695276, 17872, 499, 12, 4, "Input",ExpressionUUID->"c40379d0-444e-4b75-bcbc-d98d19e42344",
 InitializationCell->True],
Cell[695778, 17886, 499, 12, 4, "Input",ExpressionUUID->"5be53c17-b2df-4582-8beb-52259dd37f4e",
 InitializationCell->True],
Cell[696280, 17900, 499, 12, 4, "Input",ExpressionUUID->"957fa261-ff4b-47e6-b6f0-1370a68a7e05",
 InitializationCell->True],
Cell[696782, 17914, 502, 12, 4, "Input",ExpressionUUID->"e02ff1ed-f510-4d4b-9b49-614f0a2270fc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[697321, 17931, 200, 4, 7, "Subsection",ExpressionUUID->"46cc8e20-f0af-4a30-a9d7-7d53194f90c6",
 InitializationCell->True],
Cell[697524, 17937, 598, 16, 8, "Input",ExpressionUUID->"812d2673-79cc-48e7-9167-c68cbb282197",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[698171, 17959, 270, 7, 32, "Section",ExpressionUUID->"126e0764-3065-44b8-b258-2dddc04dc01a",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[698444, 17968, 371, 9, 41, "Input",ExpressionUUID->"8cc2fd07-15b1-48f6-97b2-6535072ce34c",
 InitializationCell->True],
Cell[698818, 17979, 334, 8, 41, "Input",ExpressionUUID->"7621301d-6b4b-4ab8-8c70-e445b9c8c17a",
 InitializationCell->True],
Cell[699155, 17989, 1110, 26, 80, "Input",ExpressionUUID->"df02c525-8719-4a8c-8c2d-74389b1d9dbc",
 InitializationCell->True],
Cell[700268, 18017, 1021, 26, 99, "Input",ExpressionUUID->"e6bbb079-e3a0-4355-8601-692be6182680",
 InitializationCell->True],
Cell[701292, 18045, 696, 17, 61, "Input",ExpressionUUID->"3c501750-e9d1-42cb-b5c1-1d73f6f2f113",
 InitializationCell->True],
Cell[701991, 18064, 757, 20, 80, "Input",ExpressionUUID->"242daf0f-e699-44a3-90db-7732ff58b74c",
 InitializationCell->True],
Cell[702751, 18086, 1063, 28, 80, "Input",ExpressionUUID->"bff93127-035d-41fc-90f3-dbd172f45884",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[703851, 18119, 313, 8, 32, "Section",ExpressionUUID->"7a2044f5-0db7-45a8-afe5-5b5c885a97d1",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[704167, 18129, 392, 10, 41, "Input",ExpressionUUID->"bb4f8c83-bff3-401b-aec7-4ea38ab53c5c",
 InitializationCell->True],
Cell[704562, 18141, 329, 8, 41, "Input",ExpressionUUID->"4b938759-c936-4073-a8d3-e8bdf07beeb2",
 InitializationCell->True],
Cell[704894, 18151, 1099, 26, 80, "Input",ExpressionUUID->"9aa6483c-cfbf-41a6-bf13-f4b53a7f7409",
 InitializationCell->True],
Cell[705996, 18179, 968, 26, 80, "Input",ExpressionUUID->"8b78e17a-f8a6-459e-8b31-e5d35332d518",
 InitializationCell->True],
Cell[706967, 18207, 698, 17, 61, "Input",ExpressionUUID->"0a2198ca-77a8-4c77-87d9-9dd82bcf07e1",
 InitializationCell->True],
Cell[707668, 18226, 695, 17, 61, "Input",ExpressionUUID->"c7f47f29-5838-49ef-9976-11afbb713cba",
 InitializationCell->True],
Cell[708366, 18245, 767, 18, 61, "Input",ExpressionUUID->"0a19a425-eef3-433b-a1f3-00551488ae46",
 InitializationCell->True],
Cell[709136, 18265, 852, 22, 80, "Input",ExpressionUUID->"c16d79c0-49ae-4937-ac6c-078894549733",
 InitializationCell->True],
Cell[709991, 18289, 1193, 30, 80, "Input",ExpressionUUID->"61e53cf0-cf68-4904-8254-492ccd1c5438",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[711221, 18324, 305, 7, 32, "Section",ExpressionUUID->"907d4de5-6b62-4f2f-afae-482120463f15",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[711551, 18335, 218, 4, 6, "Subsubsection",ExpressionUUID->"a3e83598-def1-425e-b89f-d6b52da22c34"],
Cell[711772, 18341, 1146, 27, 23, "Input",ExpressionUUID->"50d6d7ea-8424-423f-912a-eda9c2b517bb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[712955, 18373, 220, 4, 4, "Subsubsection",ExpressionUUID->"e4f3a1d0-a95d-46b5-a214-d0228dea085e"],
Cell[713178, 18379, 365, 9, 9, "Input",ExpressionUUID->"02d1209e-548d-4bfa-a0fd-e79d1e274667",
 InitializationCell->True],
Cell[713546, 18390, 706, 15, 14, "Input",ExpressionUUID->"4a0e2dc8-f351-4ca1-be1d-ca00cc5ebf33",
 InitializationCell->True],
Cell[714255, 18407, 880, 21, 14, "Input",ExpressionUUID->"e193ce16-bdde-4090-aad0-29eed100cb5c",
 InitializationCell->True],
Cell[715138, 18430, 918, 22, 18, "Input",ExpressionUUID->"bcf02c03-7965-49ac-bf05-46aadab9612f",
 InitializationCell->True],
Cell[716059, 18454, 1016, 26, 18, "Input",ExpressionUUID->"32686b3a-a7cb-4ffc-a64f-d20172d5bedd",
 InitializationCell->True],
Cell[717078, 18482, 1168, 28, 18, "Input",ExpressionUUID->"b99f2d55-b514-4da7-a0c7-d61ba1b723f1",
 InitializationCell->True],
Cell[718249, 18512, 1179, 28, 18, "Input",ExpressionUUID->"d9b4c4fc-7390-4dbf-9c20-51e93c2fbcd4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[719465, 18545, 302, 5, 4, "Subsubsection",ExpressionUUID->"a1c9e670-5298-44b4-83b7-026e3a3c733a"],
Cell[719770, 18552, 352, 9, 9, "Input",ExpressionUUID->"0b9f58c3-e70f-4a33-a283-63e9388c474e",
 InitializationCell->True],
Cell[720125, 18563, 865, 19, 23, "Input",ExpressionUUID->"4f6c356c-fddb-4037-a9c6-6fa27c8f5654",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[721039, 18588, 375, 8, 32, "Section",ExpressionUUID->"134c985f-cc37-4d32-95ae-b5545c49a1af",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[721417, 18598, 356, 9, 4, "Input",ExpressionUUID->"fdd8d34b-cb6d-41b9-b475-d750751e155b",
 InitializationCell->True],
Cell[721776, 18609, 1155, 27, 17, "Input",ExpressionUUID->"537419ab-68c1-4e46-9a33-fae59bb58d53",
 InitializationCell->True],
Cell[722934, 18638, 895, 26, 12, "Input",ExpressionUUID->"348cd3c5-d446-4d78-a16f-d933fe279b9d",
 InitializationCell->True],
Cell[723832, 18666, 4104, 98, 75, "Input",ExpressionUUID->"e4e23507-327d-4589-82e7-cb61999d0bc7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[727939, 18766, 795, 22, 12, "Input",ExpressionUUID->"e58c5a4d-3157-41bc-bcb9-5e85bce70dd9",
 InitializationCell->True],
Cell[728737, 18790, 416, 9, 8, "Input",ExpressionUUID->"2a5dd018-150e-4f1f-b232-1bb8da62b7b5",
 InitializationCell->True],
Cell[729156, 18801, 393, 9, 8, "Input",ExpressionUUID->"be75d3ff-d8c7-466b-8dc5-501cdd535a19",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[729586, 18815, 314, 8, 32, "Section",ExpressionUUID->"9bcf72d6-9cc5-464e-8319-3593e2b6e149",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[729925, 18827, 222, 4, 6, "Subsubsection",ExpressionUUID->"4388f9b2-b440-476d-9408-4aeaf5a7c62e"],
Cell[730150, 18833, 1106, 26, 18, "Input",ExpressionUUID->"5830ab0c-a73b-44a6-97fb-db1978f66bd3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[731293, 18864, 161, 3, 4, "Subsubsection",ExpressionUUID->"0d9933c3-5518-4281-be9b-2b70f18d2c94"],
Cell[731457, 18869, 484, 13, 14, "Input",ExpressionUUID->"3f399a72-9b92-4fbb-b617-07c774fbd8dc",
 InitializationCell->True],
Cell[731944, 18884, 535, 14, 14, "Input",ExpressionUUID->"c5447dc6-b245-48d8-b356-44976939402a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[732516, 18903, 205, 4, 4, "Subsubsection",ExpressionUUID->"68bde152-83c1-469b-a222-00a37bee6c82"],
Cell[732724, 18909, 917, 24, 18, "Input",ExpressionUUID->"c6fb2370-355d-4b36-a5c8-0eec45a7a388",
 InitializationCell->True],
Cell[733644, 18935, 1006, 26, 24, "Input",ExpressionUUID->"1e1e2d94-1b67-4943-bf9b-d0671c5c5b10",
 InitializationCell->True],
Cell[734653, 18963, 2019, 49, 42, "Input",ExpressionUUID->"8a70c6c3-090c-4799-8d04-e213ef35f5e8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[736709, 19017, 235, 4, 4, "Subsubsection",ExpressionUUID->"addfea42-6e71-4cd8-83a8-10eca703df3a"],
Cell[736947, 19023, 608, 14, 9, "Input",ExpressionUUID->"c6c295ab-dc0c-4ad9-adcf-cc60751197f6",
 InitializationCell->True],
Cell[737558, 19039, 703, 19, 14, "Input",ExpressionUUID->"30f3d43a-2152-4838-bb15-963b7da9d52a",
 InitializationCell->True],
Cell[738264, 19060, 703, 19, 14, "Input",ExpressionUUID->"62fbff94-44d7-41ca-991c-810ef6c9897f",
 InitializationCell->True],
Cell[738970, 19081, 703, 19, 14, "Input",ExpressionUUID->"0965b874-63cb-435d-b440-2b28e0a9d9b8",
 InitializationCell->True],
Cell[739676, 19102, 780, 22, 14, "Input",ExpressionUUID->"673404e4-1604-4d3d-b2ea-de278dbaaba2",
 InitializationCell->True],
Cell[740459, 19126, 808, 22, 14, "Input",ExpressionUUID->"e338dd0f-2e07-48d9-b280-149d5ef078ea",
 InitializationCell->True],
Cell[741270, 19150, 862, 24, 14, "Input",ExpressionUUID->"2b887c10-716a-40e8-81ba-4f4350f14ea1",
 InitializationCell->True],
Cell[742135, 19176, 901, 25, 14, "Input",ExpressionUUID->"c8d9a5e6-dece-45c6-8f3a-5615485c46d9",
 InitializationCell->True],
Cell[743039, 19203, 1764, 42, 38, "Input",ExpressionUUID->"9144ae3a-f4d6-44bb-aed6-6081808aede8",
 InitializationCell->True],
Cell[744806, 19247, 1216, 31, 18, "Input",ExpressionUUID->"e44f4f3d-0b34-48a7-9bf7-60dff1f8d2f0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[746025, 19280, 1572, 42, 23, "Input",ExpressionUUID->"25459034-28b3-4217-b6ea-6a2bc41441af",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[747634, 19327, 222, 4, 4, "Subsubsection",ExpressionUUID->"aa903ae0-9002-460b-804c-d26ee23b67ec"],
Cell[747859, 19333, 332, 8, 9, "Input",ExpressionUUID->"56180350-2d9a-49d4-a81e-04dbec3e37e8",
 InitializationCell->True],
Cell[748194, 19343, 882, 22, 14, "Input",ExpressionUUID->"fa854da4-f103-45a6-a4b1-a1299651a04c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[749113, 19370, 256, 4, 4, "Subsubsection",ExpressionUUID->"3c51672f-ef78-4652-95f3-379693763c01"],
Cell[749372, 19376, 527, 12, 9, "Input",ExpressionUUID->"c96c020c-e749-4455-9d07-b88cf1d3a995",
 InitializationCell->True],
Cell[749902, 19390, 519, 11, 9, "Input",ExpressionUUID->"03f8cf13-5c0f-4674-8319-9aaf0a331756",
 InitializationCell->True],
Cell[750424, 19403, 484, 11, 14, "Input",ExpressionUUID->"49c5dcf7-6f24-414b-a422-c606f9de3ec7",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[750957, 19420, 373, 9, 32, "Section",ExpressionUUID->"36699be1-1093-4348-855f-ab6855787d95",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[751355, 19433, 231, 5, 8, "Subsection",ExpressionUUID->"f4809238-5913-465c-af6b-262bd94e9519",
 InitializationCell->True],
Cell[751589, 19440, 341, 8, 9, "Input",ExpressionUUID->"0c45057f-8a09-4714-8eed-ff04421577f3",
 InitializationCell->True],
Cell[751933, 19450, 1185, 27, 23, "Input",ExpressionUUID->"474ea414-4275-4279-9ec7-f11e68dfa882",
 InitializationCell->True],
Cell[753121, 19479, 672, 14, 14, "Input",ExpressionUUID->"d0ee3e08-8e3f-42d8-9c98-130f3efb4cd4",
 InitializationCell->True],
Cell[753796, 19495, 759, 19, 14, "Input",ExpressionUUID->"c293878b-79e0-48f4-97fc-a7d3ed79abd9",
 InitializationCell->True],
Cell[754558, 19516, 1723, 39, 47, "Input",ExpressionUUID->"8c60716b-0c56-4737-9c54-49c084f8fc7c",
 InitializationCell->True],
Cell[756284, 19557, 2435, 55, 66, "Input",ExpressionUUID->"0ae3502b-c843-458c-b3d0-bb7ef73bc614",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[758756, 19617, 298, 5, 8, "Subsection",ExpressionUUID->"c2818043-23f6-446d-9b6c-1d6f9724cc64",
 InitializationCell->True],
Cell[759057, 19624, 3235, 65, 96, "Input",ExpressionUUID->"b5b81737-f4e1-4063-93d2-90313e5f12b4",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[762329, 19694, 183, 4, 8, "Subsection",ExpressionUUID->"ccd8df25-965c-49af-9dc6-71f8ac0d8d9f",
 InitializationCell->True],
Cell[762515, 19700, 437, 10, 8, "Input",ExpressionUUID->"f327b2db-2fdd-400a-b7a3-1d247c9525c4",
 InitializationCell->True],
Cell[762955, 19712, 487, 11, 11, "Input",ExpressionUUID->"b5cab568-8bd6-4494-ad4d-290e663724d7",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[763503, 19730, 239, 6, 58, "Subchapter",ExpressionUUID->"fbd1969b-f151-444a-92eb-6e7888327970",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[763745, 19738, 1079, 20, 41, "Input",ExpressionUUID->"56da68dc-a324-404f-b504-5ba391b019a3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[764849, 19762, 264, 6, 32, "Section",ExpressionUUID->"1ee9751e-fdd8-47b8-a44a-87d865bc0800",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[765138, 19772, 175, 4, 6, "Subsubsection",ExpressionUUID->"3e986cc6-22ce-45e2-8ae7-76276bb3d5b3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[765316, 19778, 525, 16, 9, "Input",ExpressionUUID->"4b068cd7-8953-4b20-bafe-10763d2dca8f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[765878, 19799, 342, 9, 12, "Subsubsection",ExpressionUUID->"1f6f5cfd-dfb1-4bc5-b0b5-937447bcbd0a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[766223, 19810, 550, 15, 8, "Input",ExpressionUUID->"4cfac6eb-f02c-4ed1-8d49-b3a5efb4cf3a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[766776, 19827, 695, 16, 8, "Input",ExpressionUUID->"235bd998-011e-4a29-b2f1-8528296cee9b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[767474, 19845, 1041, 24, 12, "Input",ExpressionUUID->"1bb43cb9-4e1e-4f9f-8a59-517d20fef12f",
 InitializationCell->True],
Cell[768518, 19871, 1464, 31, 32, "Input",ExpressionUUID->"5b669478-0d8a-45ec-a938-cee9941767e9",
 InitializationCell->True],
Cell[769985, 19904, 1567, 32, 32, "Input",ExpressionUUID->"baa9e5ef-1c34-4300-a905-08bfafd6ebd8",
 InitializationCell->True],
Cell[771555, 19938, 2500, 50, 35, "Input",ExpressionUUID->"c8f2413d-a38e-495b-9466-28692d757f84",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[774092, 19993, 497, 8, 4, "Subsubsection",ExpressionUUID->"ac19a7a2-dd58-48d5-a337-a7a61002f96b",
 InitializationCell->True],
Cell[774592, 20003, 876, 21, 12, "Input",ExpressionUUID->"d08b1e1a-13fc-41df-9d0a-883f7621f974",
 InitializationCell->True],
Cell[775471, 20026, 643, 16, 8, "Input",ExpressionUUID->"a8f4be18-e100-446e-b1be-2783c9ff3a57",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[776151, 20047, 562, 9, 4, "Subsubsection",ExpressionUUID->"a994dd45-edd4-4a61-b957-62912319d9f4",
 InitializationCell->True],
Cell[776716, 20058, 1169, 30, 28, "Input",ExpressionUUID->"93aed6be-d571-4796-a2c5-ea7374719f9a",
 InitializationCell->True],
Cell[777888, 20090, 906, 22, 12, "Input",ExpressionUUID->"ef4b4d39-9dc6-41fe-b0ce-4436550f88ee",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[778843, 20118, 474, 9, 32, "Section",ExpressionUUID->"676be8e1-ddbe-4246-af97-a09501bb98e9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[779342, 20131, 179, 4, 40, "Subsubsection",ExpressionUUID->"944b1792-9fb9-45ee-a362-532b658f0580",
 InitializationCell->True,
 InitializationGroup->True],
Cell[779524, 20137, 289, 7, 9, "Text",ExpressionUUID->"648633f0-18f1-4a20-b298-5e6043bf8000",
 InitializationCell->True],
Cell[779816, 20146, 1134, 25, 24, "Input",ExpressionUUID->"df4adc3a-d1ee-461e-ae34-e83c58bc141d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[780953, 20173, 394, 9, 4, "Input",ExpressionUUID->"b9fff92c-626f-4a28-9050-bc507b978107",
 InitializationCell->True],
Cell[781350, 20184, 713, 15, 12, "Input",ExpressionUUID->"91a4a281-eef7-40da-8421-dc06a45e3aac",
 InitializationCell->True],
Cell[782066, 20201, 510, 12, 8, "Input",ExpressionUUID->"3f9a74b6-5f17-474d-9f99-24ba6c431259",
 InitializationCell->True],
Cell[782579, 20215, 656, 15, 12, "Input",ExpressionUUID->"483497a5-a4ca-4b49-a8f3-141383f2e892",
 InitializationCell->True],
Cell[783238, 20232, 1305, 35, 17, "Input",ExpressionUUID->"3c92b8cd-f4db-450b-89b8-6e68d40f8b76",
 InitializationCell->True],
Cell[784546, 20269, 2364, 61, 39, "Input",ExpressionUUID->"2963e830-bbbe-4b41-bca0-05d308212247",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[786947, 20335, 192, 4, 33, "Subsubsection",ExpressionUUID->"ab652455-655d-4f3a-a368-4c4185c3a407",
 InitializationCell->True,
 InitializationGroup->True],
Cell[787142, 20341, 954, 24, 17, "Input",ExpressionUUID->"bd6ebaa3-438c-4a6a-80c9-f7b1640bfa50",
 InitializationCell->True,
 InitializationGroup->True],
Cell[788099, 20367, 958, 25, 17, "Input",ExpressionUUID->"f8d3bdc3-bc71-4c9d-acde-3b58f727cb83",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[789094, 20397, 271, 6, 33, "Subsubsection",ExpressionUUID->"fc6f81ee-6b83-4f88-9f2c-32a9b57df1c3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[789368, 20405, 1382, 33, 23, "Input",ExpressionUUID->"6dabd861-9d8d-430e-b820-0193135ec8ab",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[790787, 20443, 171, 4, 33, "Subsubsection",ExpressionUUID->"ee78f19d-4525-474c-96ee-c342a7b5d96d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[790961, 20449, 792, 19, 12, "Input",ExpressionUUID->"eb82f0f9-cb0b-43e4-8493-1d88f9ae2c69",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[791790, 20473, 175, 4, 33, "Subsubsection",ExpressionUUID->"f362373a-6d45-4d84-86f5-0d4cd2438e22",
 InitializationCell->True,
 InitializationGroup->True],
Cell[791968, 20479, 299, 8, 31, "Text",ExpressionUUID->"fee198ed-e3b7-45d9-8d6c-7fa64bd9f6d8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[792270, 20489, 1270, 31, 99, "Input",ExpressionUUID->"cfdf9043-24a4-4fb9-a605-983c70a732b2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[793543, 20522, 1203, 31, 99, "Input",ExpressionUUID->"1529e4b9-3891-43b6-819e-3618b10f7e5a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[794749, 20555, 1136, 27, 80, "Input",ExpressionUUID->"e972478c-bf54-42f7-ba65-fe7b73171159",
 InitializationCell->True,
 InitializationGroup->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[795934, 20588, 321, 5, 32, "Section",ExpressionUUID->"227bfd89-bdf5-415a-8f7c-02816c51892f",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[796280, 20597, 488, 10, 63, "Subsubsection",ExpressionUUID->"66e6ea1d-68ae-48f8-abd2-eac8e2be260c",
 InitializationCell->True],
Cell[796771, 20609, 305, 7, 5, "Text",ExpressionUUID->"feb43004-bcc1-4ba7-952a-a39987452b95",
 InitializationCell->True],
Cell[797079, 20618, 1378, 27, 13, "Input",ExpressionUUID->"dc6d3285-e613-4faf-8eb3-6c56ba8a7941",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[798494, 20650, 479, 10, 56, "Subsubsection",ExpressionUUID->"70aaf8fd-09db-432e-92e9-0cbca8f3c22f",
 InitializationCell->True],
Cell[798976, 20662, 1123, 22, 17, "Input",ExpressionUUID->"0925d463-39bc-4a96-8446-75d5b15aaa8c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[800102, 20686, 1065, 25, 21, "Input",ExpressionUUID->"67a9bd39-d60a-4d06-aadf-7247be705073",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[801204, 20716, 474, 10, 33, "Subsubsection",ExpressionUUID->"89516a1e-704e-4f5c-9371-857a083c488a",
 InitializationCell->True],
Cell[801681, 20728, 1753, 38, 17, "Input",ExpressionUUID->"a8405792-93a0-484c-868f-c4a199d287a3",
 InitializationCell->True],
Cell[803437, 20768, 2241, 51, 24, "Input",ExpressionUUID->"76af8e9c-c084-4c29-bce9-ee6b8aa52945",
 InitializationCell->True],
Cell[805681, 20821, 2110, 46, 24, "Input",ExpressionUUID->"e940206a-9e15-4700-8585-eb9e3ecb7fda",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[807828, 20872, 291, 5, 33, "Subsubsection",ExpressionUUID->"138da2ac-341f-493a-b2fd-cc27598cc70d",
 InitializationCell->True],
Cell[808122, 20879, 2854, 57, 59, "Input",ExpressionUUID->"ac75015f-7203-4cb3-b2b1-e08a5a44caf3",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[811025, 20942, 715, 11, 32, "Section",ExpressionUUID->"cb03b319-1fe0-4090-b51e-1bb3b2b3aac6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[811765, 20957, 618, 10, 8, "Subsection",ExpressionUUID->"6e5797ad-061b-47e9-8be6-d912bb5bbc66",
 InitializationCell->True,
 InitializationGroup->True],
Cell[812386, 20969, 1393, 30, 12, "Input",ExpressionUUID->"11ed9ea7-253b-4372-bdf4-af3ba9eccc20",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[813816, 21004, 665, 11, 8, "Subsection",ExpressionUUID->"b8d373f6-59b5-4d5a-89d1-86c298ee3a25",
 InitializationCell->True,
 InitializationGroup->True],
Cell[814484, 21017, 1391, 30, 12, "Input",ExpressionUUID->"64b6e3f9-89db-49e6-915c-9cb550e0a9e5",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[815924, 21053, 539, 9, 32, "Section",ExpressionUUID->"232805c1-c8f6-4373-86cb-eea849fbf51f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[816488, 21066, 980, 15, 48, "Subsection",ExpressionUUID->"058e6f70-4c69-4d12-8e10-0638ef3f914e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[817471, 21083, 1511, 37, 39, "Input",ExpressionUUID->"fe4eb0db-3479-413f-9fdf-59cca8add908",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[819019, 21125, 1067, 18, 58, "Subsection",ExpressionUUID->"0d5941ee-cdd5-44c0-8b10-6dffd4817781",
 InitializationCell->True,
 InitializationGroup->True],
Cell[820089, 21145, 423, 9, 9, "Text",ExpressionUUID->"7977409d-c48a-4700-9cab-ee4b51f2cc9b",
 InitializationCell->True],
Cell[820515, 21156, 3715, 75, 76, "Input",ExpressionUUID->"44814b21-7856-4c32-a005-908fd4f3091c",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[824267, 21236, 1113, 19, 58, "Subsection",ExpressionUUID->"3d32e91c-7002-4ce4-931d-5cfd63c634d9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[825405, 21259, 257, 6, 40, "Subsubsection",ExpressionUUID->"50b30d0a-ceac-489e-9380-d1a2dd9f96c4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[825665, 21267, 2001, 48, 42, "Input",ExpressionUUID->"1c7d70b1-7124-46f6-95ba-168332ff3cc7",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[827703, 21320, 819, 13, 33, "Subsubsection",ExpressionUUID->"508bebb9-4fb7-4479-8d57-4e2de18cad94",
 InitializationCell->True,
 InitializationGroup->True],
Cell[828525, 21335, 2948, 67, 63, "Input",ExpressionUUID->"7a3351ab-e1c1-46d8-94e3-f532a39ebf6b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[831510, 21407, 770, 12, 33, "Subsubsection",ExpressionUUID->"df7d4c03-862a-4207-a933-558ff3bb740c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[832283, 21421, 502, 9, 5, "Text",ExpressionUUID->"a341b318-985b-454f-ac14-5185027785e2",
 InitializationCell->True],
Cell[832788, 21432, 4092, 86, 65, "Input",ExpressionUUID->"23a41131-02ff-4873-8f41-b04370ae5b15",
 InitializationCell->True,
 InitializationGroup->True],
Cell[836883, 21520, 501, 10, 5, "Text",ExpressionUUID->"2cc7500a-d95c-4aa2-bb90-7919a587791e",
 InitializationCell->True],
Cell[837387, 21532, 3242, 74, 57, "Input",ExpressionUUID->"87b4b61c-4ae0-4d94-9a04-b38c0d0143a5",
 InitializationCell->True],
Cell[840632, 21608, 545, 10, 5, "Text",ExpressionUUID->"1c7602f2-89a9-413a-9756-6da1d610d1d1",
 InitializationCell->True],
Cell[841180, 21620, 2368, 50, 48, "Input",ExpressionUUID->"1fdb213b-c872-4237-9754-2346aef29f50",
 InitializationCell->True],
Cell[843551, 21672, 3700, 86, 74, "Input",ExpressionUUID->"ffb188a5-73a8-4ac2-8b6d-fc9bace50b14",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[847288, 21763, 791, 12, 13, "Subsubsection",ExpressionUUID->"899907ab-5f7d-4a05-9339-b2fbce20b50a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[848082, 21777, 536, 10, 5, "Text",ExpressionUUID->"9c728d68-3489-440f-84ea-c3afbf323522",
 InitializationCell->True],
Cell[848621, 21789, 3915, 88, 66, "Input",ExpressionUUID->"ba9583e9-afc6-49d3-86cf-747c5dd8cf11",
 InitializationCell->True,
 InitializationGroup->True],
Cell[852539, 21879, 501, 10, 5, "Text",ExpressionUUID->"b5c042a0-718c-4831-9841-84058968e0fa",
 InitializationCell->True],
Cell[853043, 21891, 3245, 78, 61, "Input",ExpressionUUID->"7806a6d9-d5d6-42b5-b1ef-e8ee23b5cc60",
 InitializationCell->True],
Cell[856291, 21971, 545, 10, 5, "Text",ExpressionUUID->"c95cc70f-812e-4d8a-8605-eca72087283f",
 InitializationCell->True],
Cell[856839, 21983, 3940, 94, 69, "Input",ExpressionUUID->"1fb51a5c-e234-4208-95ed-967b9d9d172d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[860816, 22082, 833, 13, 13, "Subsubsection",ExpressionUUID->"df7d4c03-862a-4207-a933-558ff3bb740c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[861652, 22097, 559, 11, 5, "Text",ExpressionUUID->"a341b318-985b-454f-ac14-5185027785e2",
 InitializationCell->True],
Cell[862214, 22110, 4255, 90, 68, "Input",ExpressionUUID->"23a41131-02ff-4873-8f41-b04370ae5b15",
 InitializationCell->True,
 InitializationGroup->True],
Cell[866472, 22202, 501, 10, 5, "Text",ExpressionUUID->"2cc7500a-d95c-4aa2-bb90-7919a587791e",
 InitializationCell->True],
Cell[866976, 22214, 3843, 88, 59, "Input",ExpressionUUID->"87b4b61c-4ae0-4d94-9a04-b38c0d0143a5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[870856, 22307, 828, 13, 13, "Subsubsection",ExpressionUUID->"899907ab-5f7d-4a05-9339-b2fbce20b50a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[871687, 22322, 536, 10, 5, "Text",ExpressionUUID->"9c728d68-3489-440f-84ea-c3afbf323522",
 InitializationCell->True],
Cell[872226, 22334, 4169, 97, 65, "Input",ExpressionUUID->"ba9583e9-afc6-49d3-86cf-747c5dd8cf11",
 InitializationCell->True,
 InitializationGroup->True],
Cell[876398, 22433, 501, 10, 5, "Text",ExpressionUUID->"b5c042a0-718c-4831-9841-84058968e0fa",
 InitializationCell->True],
Cell[876902, 22445, 4126, 102, 61, "Input",ExpressionUUID->"7806a6d9-d5d6-42b5-b1ef-e8ee23b5cc60",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[881065, 22552, 778, 12, 13, "Subsubsection",ExpressionUUID->"087a9717-b34a-4d18-98d7-6272a24db1c0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[881846, 22566, 2743, 63, 72, "Input",ExpressionUUID->"63f1e045-9b2c-45e7-9705-2980e42a8ba6",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[884626, 22634, 874, 14, 13, "Subsubsection",ExpressionUUID->"83f4a39f-e13f-4f77-a5e0-a4d39a399881",
 InitializationCell->True,
 InitializationGroup->True],
Cell[885503, 22650, 1166, 28, 28, "Input",ExpressionUUID->"adf65817-d7b5-434e-ac65-2e1d59b67c35",
 InitializationCell->True],
Cell[886672, 22680, 3537, 80, 59, "Input",ExpressionUUID->"ea7de7a2-5f0d-4aa9-891b-5e6ebc663f38",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[890246, 22765, 917, 14, 13, "Subsubsection",ExpressionUUID->"c0fb0343-6f23-4495-9c6c-82e259c2d1a0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[891166, 22781, 1098, 27, 28, "Input",ExpressionUUID->"05f3dd94-7d14-4d81-af12-5ddf62321e9b",
 InitializationCell->True],
Cell[892267, 22810, 3912, 87, 66, "Input",ExpressionUUID->"bb7270a5-4be9-421b-a8ce-715ff02bb81f",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[896216, 22902, 912, 14, 13, "Subsubsection",ExpressionUUID->"a6f289e6-30c8-45dc-8d38-e2bfb3337a6a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[897131, 22918, 201, 3, 5, "Text",ExpressionUUID->"8931767e-8c7f-4bd1-af98-a9e065a3735e"],
Cell[897335, 22923, 1786, 43, 62, "Input",ExpressionUUID->"da8d1f8b-458d-4850-a898-5da93a68fb0c",
 InitializationCell->True],
Cell[899124, 22968, 190, 3, 5, "Text",ExpressionUUID->"2bfbc373-f08b-4a88-b632-26abe34cefc6"],
Cell[899317, 22973, 3434, 81, 85, "Input",ExpressionUUID->"90a0f431-50dd-4234-8a90-cbc10241acb1",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[902800, 23060, 709, 11, 19, "Subsection",ExpressionUUID->"5dcf470b-4407-42a3-9cda-878c22a51766",
 InitializationCell->True,
 InitializationGroup->True],
Cell[903512, 23073, 251, 6, 5, "Text",ExpressionUUID->"20742fe0-3550-43b0-a97c-a25ed530b922",
 InitializationCell->True],
Cell[903766, 23081, 1832, 37, 28, "Input",ExpressionUUID->"de59ce28-3b8c-493e-a730-fd797ef8202e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[905601, 23120, 261, 6, 5, "Text",ExpressionUUID->"fee9002a-a007-41e6-81a5-c8b49c64ac13",
 InitializationCell->True],
Cell[905865, 23128, 2524, 56, 33, "Input",ExpressionUUID->"1e30d96d-2c04-46a6-a6c3-5c77bdee18b7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[908392, 23186, 2883, 65, 36, "Input",ExpressionUUID->"0a7ad4df-869f-4211-baec-3149b214ba54",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[911312, 23256, 832, 13, 13, "Subsection",ExpressionUUID->"a581282f-f7f3-4b35-8dbd-f03e6d365bbb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[912147, 23271, 764, 16, 12, "Input",ExpressionUUID->"cf8957f1-4400-47ad-b7a7-065a5d373f9d",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[912960, 23293, 609, 10, 12, "Section",ExpressionUUID->"7aba4dbf-63f7-4790-b04e-a0721463a672",
 InitializationCell->True,
 InitializationGroup->True],
Cell[913572, 23305, 375, 9, 5, "Text",ExpressionUUID->"a4ca7cbd-658d-4754-b7b7-c19b2ab25f1a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[913950, 23316, 329, 8, 5, "Text",ExpressionUUID->"6f8ae18c-5acc-4a7f-8fe3-cca5e0a970d7",
 InitializationCell->True],
Cell[914282, 23326, 3651, 77, 66, "Input",ExpressionUUID->"753f114b-2b8c-4458-b1fb-2c886cc9fece",
 InitializationCell->True,
 InitializationGroup->True],
Cell[917936, 23405, 786, 19, 21, "Input",ExpressionUUID->"7272cad2-3999-44ff-b8a1-7be88dfe6b87",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[918759, 23429, 182, 4, 12, "Section",ExpressionUUID->"44fef391-5fa2-4557-a26d-426c0724738a",
 InitializationCell->True],
Cell[918944, 23435, 445, 10, 12, "Input",ExpressionUUID->"5e2e1640-9efc-4646-8d48-01bd9b06ad30",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[919438, 23451, 302, 7, 28, "Subchapter",ExpressionUUID->"2c4f9047-a583-4ea6-a8dc-722715bc7945",
 InitializationCell->True,
 InitializationGroup->True],
Cell[919743, 23460, 198, 4, 5, "Text",ExpressionUUID->"77eff3a1-7485-495d-acac-24678a25d312",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[919966, 23468, 337, 7, 6, "Subsubsection",ExpressionUUID->"c4e81e6f-d608-45cb-9ada-685b2bebe0b4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[920306, 23477, 580, 16, 9, "Input",ExpressionUUID->"ddc41615-93c2-4de9-b985-321b61e24768",
 InitializationCell->True,
 InitializationGroup->True],
Cell[920889, 23495, 690, 18, 18, "Input",ExpressionUUID->"21237adb-05a1-481c-a48a-3e46fc6e8fa9",
 InitializationCell->True],
Cell[921582, 23515, 915, 23, 18, "Input",ExpressionUUID->"071903ea-f117-4cfd-902b-8981c979ebcc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[922534, 23543, 347, 7, 4, "Subsubsection",ExpressionUUID->"50e6100a-5a2b-46ab-aaaf-0799011b1067",
 InitializationCell->True,
 InitializationGroup->True],
Cell[922884, 23552, 441, 11, 9, "Input",ExpressionUUID->"5f4d1f2c-62e0-4aca-9651-f394f9ee8aa8",
 InitializationCell->True],
Cell[923328, 23565, 1798, 45, 42, "Input",ExpressionUUID->"8358fd17-da08-49bd-8341-8f88e4dcf0a0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[925163, 23615, 353, 7, 4, "Subsubsection",ExpressionUUID->"6addfd04-cadb-4bb6-bf0c-7c4b8c003346",
 InitializationCell->True,
 InitializationGroup->True],
Cell[925519, 23624, 438, 9, 9, "Text",ExpressionUUID->"18d28a13-80d3-4e4c-919a-438a56b39d70",
 InitializationCell->True],
Cell[925960, 23635, 379, 9, 9, "Input",ExpressionUUID->"3d74777e-41a4-43f1-a2f3-cf82ae854e17",
 InitializationCell->True],
Cell[926342, 23646, 512, 14, 18, "Input",ExpressionUUID->"ee03ece4-a1dc-4436-9ef8-ed6f9031895c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[926891, 23665, 290, 7, 4, "Subsubsection",ExpressionUUID->"3ba0360e-9bb5-433a-91c1-c3e225a4c180",
 InitializationCell->True,
 InitializationGroup->True],
Cell[927184, 23674, 592, 12, 14, "Input",ExpressionUUID->"2c97ef85-7ffd-48a2-b76b-0f60baa9381b",
 InitializationCell->True],
Cell[927779, 23688, 548, 11, 18, "Input",ExpressionUUID->"0cd4473f-b6c1-4002-bc01-d717e0fd630a",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[928376, 23705, 209, 6, 28, "Subchapter",ExpressionUUID->"95fe1f38-4dd4-4a5f-9435-fc53c2270b9d",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[928588, 23713, 234, 9, 13, "Input",ExpressionUUID->"5cc4be56-5e1e-4a3d-b1df-caba4f15f20e",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[928871, 23728, 293, 7, 57, "Title",ExpressionUUID->"3ec672e0-2058-4705-994e-1d0a5ef89017",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[929189, 23739, 167, 3, 12, "Subchapter",ExpressionUUID->"eda4c879-700f-4001-a9ca-81771b541378"],
Cell[CellGroupData[{
Cell[929381, 23746, 361, 5, 8, "Subsection",ExpressionUUID->"c4dd104e-b85c-4ab2-b8ad-85157f4a4b81"],
Cell[929745, 23753, 390, 6, 5, "Text",ExpressionUUID->"55d63191-1a6d-4ef0-acff-d726786671d2"],
Cell[930138, 23761, 454, 8, 5, "Text",ExpressionUUID->"91c1f003-cabf-4896-8c2a-8a75fcb902f8"],
Cell[930595, 23771, 611, 11, 9, "Text",ExpressionUUID->"b1fedf78-5f33-435b-a6c4-a03a2054b718"]
}, Closed]],
Cell[CellGroupData[{
Cell[931243, 23787, 411, 6, 6, "Subsection",ExpressionUUID->"6c4310a4-01b5-4ceb-a3bb-e278ad7b5bdf"],
Cell[931657, 23795, 575, 10, 9, "Text",ExpressionUUID->"ebeec524-2c44-4b1c-9f56-1e196f3e9a9e"]
}, Closed]],
Cell[CellGroupData[{
Cell[932269, 23810, 485, 7, 6, "Subsection",ExpressionUUID->"9614d31f-a7e0-41ee-838f-d5ccc7a534ee"],
Cell[932757, 23819, 607, 10, 5, "Text",ExpressionUUID->"467c5dde-c69c-4def-bb36-843bac5c1cda"],
Cell[933367, 23831, 324, 7, 9, "Text",ExpressionUUID->"d51d277b-bfd8-4bd6-bdc4-f51c79d910af"]
}, Closed]],
Cell[CellGroupData[{
Cell[933728, 23843, 537, 8, 6, "Subsection",ExpressionUUID->"3416d202-98d7-48f5-b259-fc7f2bf779d8"],
Cell[934268, 23853, 963, 17, 22, "Text",ExpressionUUID->"909cf5a5-4da8-41ad-b5cd-22e1701a2984"]
}, Closed]],
Cell[CellGroupData[{
Cell[935268, 23875, 654, 11, 12, "Subsection",ExpressionUUID->"36481c18-cef8-4da2-a7e4-397c56a14dce"],
Cell[935925, 23888, 812, 13, 9, "Text",ExpressionUUID->"7d13af7f-ecaa-4304-93f1-dccd9910bec7"]
}, Closed]],
Cell[CellGroupData[{
Cell[936774, 23906, 635, 9, 6, "Subsection",ExpressionUUID->"2b70ecce-04b0-4cc5-9d16-addb8750b532"],
Cell[937412, 23917, 242, 6, 5, "Text",ExpressionUUID->"d48c0523-cd73-49d6-a53b-b76e7fc94a65"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[937703, 23929, 204, 4, 8, "Subchapter",ExpressionUUID->"b78f458c-9f81-4fe5-84fe-0fa145805654"],
Cell[CellGroupData[{
Cell[937932, 23937, 410, 6, 8, "Subsection",ExpressionUUID->"f4bf1b04-f78e-4bf5-9b43-23a252d7918a"],
Cell[938345, 23945, 565, 10, 13, "Text",ExpressionUUID->"06404b71-d644-414f-b4f8-4b2373464fd4"]
}, Closed]]
}, Closed]]
}, Closed]]
}
]
*)

