(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    111224,       2969]
NotebookOptionsPosition[     96644,       2649]
NotebookOutlinePosition[     97318,       2673]
CellTagsIndexPosition[     97275,       2670]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["SD`Approximations`", "Title",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4526855795508213`*^9, 3.452685580972721*^9}, 
   3.682593449496829*^9, {3.683108316372006*^9, 3.683108316618305*^9}, 
   3.683108496382702*^9, {3.683118320520026*^9, 3.6831183238614798`*^9}},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"a4c2fb73-1266-479e-a3d9-6857c77f5f62"],

Cell[CellGroupData[{

Cell["BeginPackage", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9, 3.683109016913093*^9},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"4c091790-3b79-4b39-b737-995dba02af2b"],

Cell["\<\
an evolution generator is a Hamiltonian, a Liouvillian superoperator, or \
time-dependent functions of these, which may be used in event specifications\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.614934233307365*^9, 
  3.614934285396604*^9}},ExpressionUUID->"17266953-6a87-4493-91c2-\
ca90e3543b4a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<SD`Approximations`\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Global`\>\"", ",", "\[IndentingNewLine]", "\"\<SpinDynamica`\>\"", 
      ",", "\[IndentingNewLine]", "\"\<General`UserLevel`\>\"", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"\"\<General`ModifyBuiltIn`\>\"", ","}], "*)"}], 
      "\[IndentingNewLine]", "\"\<General`Matrices`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<General`Miscellaneous`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`Hilbert`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`SpinOperators`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`Liouville`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<SD`Generators`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Rotations`Wigner`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Units`\>\"", ",", "\[IndentingNewLine]", 
      "\"\<General`PhysicalConstants`\>\""}], "}"}]}], "]"}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.682597329576949*^9, 3.682597339617495*^9}, {
   3.682611681453899*^9, 3.682611690204586*^9}, 3.682611819113118*^9, {
   3.6826128177214537`*^9, 3.682612818096237*^9}, {3.6831083938005047`*^9, 
   3.68310839584037*^9}, {3.683108457078102*^9, 3.683108458420087*^9}, {
   3.683108860481447*^9, 3.683108865855433*^9}, 3.6831102927632017`*^9, 
   3.683111933228162*^9, {3.683118333010003*^9, 3.683118358394383*^9}, {
   3.683214865937806*^9, 3.683214883095929*^9}, 3.701151257586261*^9, 
   3.745396670107452*^9},ExpressionUUID->"fe8a52fd-f077-4599-b5b8-\
cdb32ed1866e"]
}, Open  ]],

Cell[CellGroupData[{

Cell["exports", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.605545641519261*^9, 3.605546445799432*^9, 
  3.629385531775414*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"218e79c5-726a-45f4-a98b-7cc31ff676e8"],

Cell[CellGroupData[{

Cell["Thermalization", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, {3.456506289466201*^9, 3.456506295406816*^9}, {
   3.456508348653371*^9, 3.456508356052676*^9}, {3.4565084005859623`*^9, 
   3.4565084007536383`*^9}, {3.4565084369209948`*^9, 3.456508438583412*^9}, {
   3.456509275980582*^9, 3.456509283884789*^9}, {3.461320168884572*^9, 
   3.461320185715005*^9}, {3.681102556780306*^9, 3.681102557915639*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"2e60d649-3d52-4780-a198-13f6a4db497e"],

Cell[CellGroupData[{

Cell["general thermalization symbols", "Subsubsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, {3.456506289466201*^9, 3.456506295406816*^9}, {
   3.456508348653371*^9, 3.456508356052676*^9}, {3.4565084005859623`*^9, 
   3.4565084007536383`*^9}, {3.4565084369209948`*^9, 3.456508438583412*^9}, {
   3.456509275980582*^9, 3.456509283884789*^9}, {3.461320168884572*^9, 
   3.461320185715005*^9}, 3.681102591039863*^9, {3.681102630424881*^9, 
   3.681102636319174*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"cba970d0-b06c-4ea1-a7d4-6cde0ffb03d8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Temperature", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"Temperature\",
FontSlant->\"Italic\"]\) is an option for \!\(\*
StyleBox[\"ThermalEquilibriumDensityOperator\",
FontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"ThermalizeSuperoperator\",
FontSlant->\"Italic\"]\). The default is \!\(\*
StyleBox[\"Temperature\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Infinity\",
FontSlant->\"Italic\"]\) in which case thermalization has no effect.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.461318338005664*^9, 3.461318407684705*^9}, {
  3.461322324808297*^9, 3.461322326727097*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HighTemperatureApproximation", "::", "usage"}], "=", "\"\<\!\(\*
StyleBox[\"HighTemperatureApproximation\",
FontSlant->\"Italic\"]\) is an option for \!\(\*
StyleBox[\"ThermalEquilibriumDensityOperator\",
FontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"ThermalizeSuperoperator\",
FontSlant->\"Italic\"]\). The default is \!\(\*
StyleBox[\"HighTemperatureApproximation\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\) in which case high-order thermal terms are \
ignored.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.461318338005664*^9, 3.461318407684705*^9}, {
  3.461322324808297*^9, 3.461322326727097*^9}, {3.461322853557392*^9, 
  3.461322882179802*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HighTemperatureApproximationWarningThreshold", "::", "usage"}], 
   "=", "\"\<\!\(\*
StyleBox[\"HighTemperatureApproximationWarningThreshold\",
FontSlant->\"Italic\"]\) is an option for \!\(\*
StyleBox[\"ThermalEquilibriumDensityOperator\",
FontSlant->\"Italic\"]\) and \!\(\*
StyleBox[\"ThermalizeSuperoperator\",
FontSlant->\"Italic\"]\). The default is \!\(\*
StyleBox[\"HighTemperatureApproximationWarningThreshold\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"0.9\",
FontSlant->\"Italic\"]\). A warning is given if \!\(\*
StyleBox[\"HighTemperatureApproximation\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\) and one of the exponential factors in the Boltzmann \
distribution is less than this number. The warning may be disabled using \!\(\*
StyleBox[\"HighTemperatureApproximationWarningThreshold\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"0.\",
FontSlant->\"Italic\"]\)\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.461318338005664*^9, 3.461318407684705*^9}, {
   3.461322324808297*^9, 3.461322326727097*^9}, {3.461322853557392*^9, 
   3.461322882179802*^9}, {3.461327268586905*^9, 3.4613274116362267`*^9}, 
   3.683110642907247*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["ThermalEquilibriumDensityOperator", "Subsubsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, {3.456506289466201*^9, 3.456506295406816*^9}, {
   3.456508348653371*^9, 3.456508356052676*^9}, {3.4565084005859623`*^9, 
   3.4565084007536383`*^9}, {3.4565084369209948`*^9, 3.456508438583412*^9}, {
   3.456509275980582*^9, 3.456509283884789*^9}, {3.461320168884572*^9, 
   3.461320185715005*^9}, 3.681102579551071*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"ef476140-6faa-4520-8777-c63686aa02df"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ThermalEquilibriumDensityOperator", "::", "usage"}], "=", 
   "\"\<\!\(\*
StyleBox[\"ThermalEquilibriumDensityOperator\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Hlab\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Temperature\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"options\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) sets up a thermal equilibrium density operator under \
the laboratory frame Hamiltonian \!\(\*
StyleBox[\"Hlab\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)at the specified temperature. The syntax \!\(\*
StyleBox[\"ThermalEquilibriumDensityOperator\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Hlab\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Temperature\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"options\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)may also be used.\nThe \!\(\*
StyleBox[\"options\",
FontSlant->\"Italic\"]\) may include \!\(\*
StyleBox[\"HighTemperatureApproximation\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"False\",
FontSlant->\"Italic\"]\) or \!\(\*
StyleBox[\"HighTemperatureApproximation\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\).\n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.461322189599052*^9, 3.461322301335417*^9}, {
  3.461322383937756*^9, 3.4613223861361113`*^9}, {3.5330073061371107`*^9, 
  3.533007340653668*^9}, {3.682609913670834*^9, 3.682609931941511*^9}, {
  3.68261000158818*^9, 3.6826100155645857`*^9}, {3.682610166446845*^9, 
  3.682610212517551*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ThermalizeSuperoperator", "Subsubsection",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, {3.456506289466201*^9, 3.456506295406816*^9}, {
   3.456508348653371*^9, 3.456508356052676*^9}, {3.4565084005859623`*^9, 
   3.4565084007536383`*^9}, {3.4565084369209948`*^9, 3.456508438583412*^9}, {
   3.456509275980582*^9, 3.456509283884789*^9}, {3.461320168884572*^9, 
   3.461320185715005*^9}, {3.681102591039863*^9, 3.681102613000289*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"d86bed14-3b46-40d0-b7f3-527350f85260"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ThermalizeSuperoperator", "::", "usage"}], "=", 
   "\[IndentingNewLine]", "\"\<\!\(\*
StyleBox[\"ThermalizeSuperoperator\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"sop\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Hlab\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Temperature\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"options\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) corrects the eigenoperators of a superoperator so \
that a Boltzmann population distribution under the laboratory frame \
Hamiltonian \!\(\*
StyleBox[\"Hlab\",
FontSlant->\"Italic\"]\) is established at long evolution times. The syntax \
\!\(\*
StyleBox[\"ThermalizeSuperoperator\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"sop\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Hlab\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"Temperature\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"options\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)may also be used. The \!\(\*
StyleBox[\"options\",
FontSlant->\"Italic\"]\) may include \!\(\*
StyleBox[\"HighTemperatureApproximation\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"False\",
FontSlant->\"Italic\"]\) or \!\(\*
StyleBox[\"HighTemperatureApproximation\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"\[Rule]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"True\",
FontSlant->\"Italic\"]\).\n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.461318023862507*^9, 3.461318225188365*^9}, {
  3.461322353530472*^9, 3.461322374010648*^9}, {3.5331155459278584`*^9, 
  3.533115563979067*^9}, {3.682609949307102*^9, 3.682609993981852*^9}, {
  3.6826102285423813`*^9, 3.682610243316102*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Secularization", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, {3.456506289466201*^9, 3.456506295406816*^9}, {
   3.456508348653371*^9, 3.456508356052676*^9}, {3.4565084005859623`*^9, 
   3.4565084007536383`*^9}, {3.4565084369209948`*^9, 3.456508438583412*^9}, {
   3.456509275980582*^9, 3.456509283884789*^9}, {3.461320168884572*^9, 
   3.461320185715005*^9}, {3.681102556780306*^9, 3.681102557915639*^9}, {
   3.681102857681046*^9, 3.6811028596716137`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"9962d3d7-65c3-4baa-b068-bb656ed547c7"],

Cell[CellGroupData[{

Cell["Secularize", "Subsubsection",
 PageWidth->WindowWidth,
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4308939920692368`*^9, 3.430893995066204*^9}, {
  3.4345255863674593`*^9, 3.434525586931498*^9}, {3.447343231667141*^9, 
  3.447343234368677*^9}, {3.63056882567334*^9, 3.6305688273014803`*^9}},
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "::", "usage"}], "=", "\[IndentingNewLine]", 
   "\"\<\!\(\*
StyleBox[\"Secularize\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"args\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) implements secularization of an operator, meaning \
the removal of terms that are non-secular with respect to a particular \
Hamiltonian.\nThe syntax \!\(\*
StyleBox[\"Secularize\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"H0\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) secularizes the operator \!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\) with respect to the Hamiltonian \!\(\*
StyleBox[\"H0\",
FontSlant->\"Italic\"]\). This removes all off-diagonal terms in \!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\), when expressed in the eigenbasis of \!\(\*
StyleBox[\"H0\",
FontSlant->\"Italic\"]\), unless the off-diagonal terms connect degenerate \
eigenvalues of \!\(\*
StyleBox[\"H0\",
FontSlant->\"Italic\"]\). The syntax \!\(\*
StyleBox[\"Secularize\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"H0\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"threshold\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) only removes off-diagonal terms if the corresponding \
eigenvalues differ by more than the numerical \!\(\*
StyleBox[\"threshold\",
FontSlant->\"Italic\"]\).    \nThe syntax \!\(\*
StyleBox[\"Secularize\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"op\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spins1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spins2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",
FontSlant->\"Italic\"]\)secularizes with respect to a Zeeman Hamiltonian in \
which the sets of spins belong to different isotopic types. If only one list \
of spins is present, the routine assumes a homonuclear system. \nThe syntax \
\!\(\*
StyleBox[\"Secularize\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"[\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"sop\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spins1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spins2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"]\",
FontSlant->\"Italic\"]\) secularizes a superoperator \!\(\*
StyleBox[\"sop\",
FontSlant->\"Italic\"]\) with respect to a Zeeman Hamiltonian in which the \
sets of spins \!\(\*
StyleBox[\"{\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spins1\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\",\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"spins2\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"..\",
FontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"}\",
FontSlant->\"Italic\"]\) belong to different isotopic types. Secularization \
of a superoperator implies deletion of all matrix elements connecting \
different sets of coherence orders for the specified spins.\n\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430893998221677*^9, 3.430894014980308*^9}, {
  3.434525590977869*^9, 3.434525626453712*^9}, {3.4472271271273623`*^9, 
  3.447227169088076*^9}, {3.4472277095226297`*^9, 3.4472277154567223`*^9}, {
  3.447343237954089*^9, 3.447343296828744*^9}, {3.630568838688796*^9, 
  3.63056928668631*^9}, {3.681103094367158*^9, 3.681103121884204*^9}}]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["start", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"66dfe670-9c4f-4a3a-bb2d-52aa4a2270ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$Chronology", "=", "\"\<LeftToRight\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545050393596538*^9, 3.5450503995208893`*^9}, {
  3.545050732985859*^9, 3.545050735366548*^9}}],

Cell["Begin[\"`Private`\"];", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Thermalization", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.452690479112947*^9, 3.452690506563347*^9}, {
   3.4526906425151577`*^9, 3.452690675101125*^9}, {3.452712675169849*^9, 
   3.452712685532673*^9}, {3.452770736612377*^9, 3.452770745914432*^9}, {
   3.4528340628299294`*^9, 3.4528340639240847`*^9}, 3.4975736975953903`*^9, {
   3.5028403677196217`*^9, 3.502840372078033*^9}, {3.504204304171247*^9, 
   3.5042043103134203`*^9}, 3.5069309517835827`*^9, {3.5414885345095863`*^9, 
   3.54148853944915*^9}, {3.683110092837247*^9, 3.6831100989157333`*^9}, 
   3.683110185279236*^9},ExpressionUUID->"331abe72-8ecd-4e4c-9bec-\
b19cf5293fab"],

Cell[CellGroupData[{

Cell["ThermalEquilibriumDensityOperator", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.461322405084854*^9, 
  3.461322412285613*^9}},ExpressionUUID->"7901a7db-ba0c-417a-8860-\
cbda5a9c04ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ThermalEquilibriumDensityOperator", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"HighTemperatureApproximation", "\[Rule]", "True"}], ",", 
     RowBox[{
     "HighTemperatureApproximationWarningThreshold", "\[Rule]", "0.9"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Temperature", "\[Rule]", "Infinity"}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.46132241731936*^9, 3.461322431197822*^9}, {
   3.461322893741844*^9, 3.461322897147202*^9}, {3.461327439852338*^9, 
   3.4613274430899*^9}, 3.497571426587963*^9, {3.533007254715562*^9, 
   3.533007262071013*^9}, {3.5331157628269053`*^9, 3.533115765027976*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ThermalEquilibriumDensityOperator", "[", "args___", "]"}], "/;", 
    
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6826100340317593`*^9, 3.6826100532041483`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ThermalEquilibriumDensityOperator", "[", 
    RowBox[{
     RowBox[{"H\[CapitalTheta]_", "?", "OperatorQ"}], ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"ThermalEquilibriumDensityOperator", "[", 
    RowBox[{"H\[CapitalTheta]", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Temperature", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ThermalEquilibriumDensityOperator", "]"}]}], 
     ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533005236176984*^9, 3.533005345393694*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ThermalEquilibriumDensityOperator", "[", 
    RowBox[{
     RowBox[{"H\[CapitalTheta]_", "?", "OperatorQ"}], ",", 
     RowBox[{"T", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"ThermalEquilibriumDensityOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"H\[CapitalTheta]", ",", "T"}], "}"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.68261010018707*^9, 3.682610120892734*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ThermalEquilibriumDensityOperator", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"H\[CapitalTheta]_", "?", "OperatorQ"}], ",", 
        RowBox[{"T", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}]}], "}"}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"T", ",", 
       RowBox[{"(", 
        RowBox[{"_Symbol", "|", 
         RowBox[{"_", "?", "NumericQ"}]}], ")"}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"ThermalEquilibriumDensityOperator", "::", "badT"}], ",", 
       "T"}], "]"}], ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533005374868957*^9, 3.533005445867835*^9}, {
  3.533005539686653*^9, 3.533005567238909*^9}, {3.5330056461851482`*^9, 
  3.533005669323782*^9}, {3.6826101357930193`*^9, 3.682610138515572*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ThermalEquilibriumDensityOperator", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"H\[CapitalTheta]_", "?", "OperatorQ"}], ",", 
       RowBox[{"T", ":", 
        RowBox[{"(", 
         RowBox[{"_Symbol", "|", 
          RowBox[{"_", "?", "NumericQ"}]}], ")"}]}]}], "}"}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "H\[Theta]mat", ",", "H\[Theta]evals", ",", "H\[Theta]evecs", ",", 
       "expfacs", ",", "Z", ",", "htapprox", ",", "htapproxwth", ",", 
       "numericH\[Theta]mat", ",", "X", ",", "Xinv"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"htapprox", "=", 
        RowBox[{
         RowBox[{"HighTemperatureApproximation", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{
         "Options", "[", "ThermalEquilibriumDensityOperator", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"htapproxwth", "=", 
        RowBox[{
         RowBox[{"HighTemperatureApproximationWarningThreshold", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{
         "Options", "[", "ThermalEquilibriumDensityOperator", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"H\[Theta]mat", "=", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"H\[CapitalTheta]", ",", 
          RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"numericH\[Theta]mat", "=", 
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{"Normal", "@", 
           RowBox[{"Flatten", "[", "H\[Theta]mat", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], "..."}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"H\[Theta]evals", ",", "H\[Theta]evecs"}], "}"}], "=", 
        RowBox[{"Eigensystem", "[", "H\[Theta]mat", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"expfacs", "=", 
        RowBox[{"If", "[", 
         RowBox[{"htapprox", ",", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", " ", 
              RowBox[{"1", "+", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", 
                  RowBox[{"(", 
                   RowBox[{"\[HBar]", "\[Times]", "#"}], ")"}]}], "/", 
                 RowBox[{"(", 
                  RowBox[{"kB", "*", "T"}], ")"}]}], ")"}]}], ")"}], "&"}], "/@",
             "H\[Theta]evals"}], ")"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Exp", "[", 
              RowBox[{
               RowBox[{"-", 
                RowBox[{"(", 
                 RowBox[{"\[HBar]", "\[Times]", "#"}], ")"}]}], "/", 
               RowBox[{"(", 
                RowBox[{"kB", "*", "T"}], ")"}]}], "]"}], "&"}], "/@", 
            "H\[Theta]evals"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"numericH\[Theta]mat", ",", 
         RowBox[{"expfacs", "=", 
          RowBox[{"expfacs", "/.", "PhysicalConstantValues"}]}]}], "]"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Or", "@@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"#", "<", "htapproxwth"}], ")"}], "&"}], "/@", 
               "expfacs"}], ")"}]}], ")"}], "&&", "htapprox"}], ")"}], ",", 
         RowBox[{"Message", "[", 
          RowBox[{
          "ThermalEquilibriumDensityOperator", "::", "highTapproxwarning"}], 
          "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Z", "=", 
        RowBox[{"Plus", "@@", "expfacs"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"X", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{"Normalize", "/@", "H\[Theta]evecs"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Xinv", "=", 
        RowBox[{"ConjugateTranspose", "[", "X", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
          RowBox[{"X", ".", 
           RowBox[{"SparseArray", "[", 
            RowBox[{
             RowBox[{"Band", "[", 
              RowBox[{"{", 
               RowBox[{"1", ",", "1"}], "}"}], "]"}], "->", 
             RowBox[{"expfacs", "/", "Z"}]}], "]"}], ".", "Xinv"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"ZeemanBasis", "[", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.461322443670993*^9, 3.46132261230086*^9}, {
   3.461322770559325*^9, 3.46132277609359*^9}, {3.461322904565185*^9, 
   3.4613229243173857`*^9}, {3.4613229761346283`*^9, 3.461323132301033*^9}, 
   3.4613263636059637`*^9, {3.461327448974304*^9, 3.461327474983881*^9}, {
   3.4613275709412603`*^9, 3.4613276216397*^9}, {3.46150314715212*^9, 
   3.4615032008066473`*^9}, {3.461503401437149*^9, 3.461503443184784*^9}, {
   3.462861317249971*^9, 3.4628613179989367`*^9}, {3.465285199128441*^9, 
   3.465285199365672*^9}, 3.467720507165506*^9, {3.4975436724141083`*^9, 
   3.49754367914012*^9}, {3.497547158440283*^9, 3.4975471586360207`*^9}, {
   3.497547327509939*^9, 3.497547376409048*^9}, {3.4975476156179533`*^9, 
   3.497547635060628*^9}, {3.497547676464126*^9, 3.4975477505183363`*^9}, {
   3.497547794337741*^9, 3.497547825093441*^9}, 3.497571855483877*^9, {
   3.533005274036438*^9, 3.533005275203673*^9}, {3.533005707166617*^9, 
   3.533005721974371*^9}, {3.5330070607223997`*^9, 3.533007072104372*^9}, {
   3.5330390624226294`*^9, 3.53303916611005*^9}, {3.533039225666603*^9, 
   3.5330392557294197`*^9}, {3.533039293657074*^9, 3.533039297784772*^9}, {
   3.53303934265387*^9, 3.533039350849597*^9}, {3.533039421738606*^9, 
   3.5330394250796547`*^9}, {3.533039537569289*^9, 3.5330395579345493`*^9}, {
   3.533039683854607*^9, 3.533039696711424*^9}, {3.596886289385931*^9, 
   3.596886301440935*^9}, {3.596887138610948*^9, 3.5968871630020037`*^9}, {
   3.6826101460735292`*^9, 3.682610149207636*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ThermalEquilibriumDensityOperator", "::", "badT"}], "=", 
   "\"\<The temperature `1` is invalid.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4613275020536757`*^9, 3.461327564671322*^9}, {
  3.5330054567263308`*^9, 3.533005470905169*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ThermalEquilibriumDensityOperator", "::", "highTapproxwarning"}], 
   "=", "\"\<The high-temperature approximation may not be valid. Use the \
option HighTemperatureApproximation\[Rule]False\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4613275020536757`*^9, 3.461327564671322*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["ThermalizeSuperoperator", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{3.4506142165078077`*^9, 3.45061425680519*^9, 
  3.450614643338854*^9, 3.461318299846078*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"603d5372-ae66-4c52-815a-5003192779d2"],

Cell[CellGroupData[{

Cell["reasoning", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.486738467888925*^9, 3.4867384756873083`*^9}, {
  3.48673918939602*^9, 
  3.48673919257613*^9}},ExpressionUUID->"5981bde3-ebaa-414e-9079-\
c93d99e44193"],

Cell[TextData[{
 "g",
 Cell[BoxData[
  FormBox[
   TagBox[GridBox[{
      {
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
               Cell["set\[NonBreakingSpace]of\[NonBreakingSpace]Liouvillian\
\[NonBreakingSpace]eigenoperators\[NonBreakingSpace]", "Text"], "|", 
                SubscriptBox["Q", "a"]}], ")"}], Cell[
              "\[NonBreakingSpace]with\[NonBreakingSpace]", "Text"]}], "|", 
             SubscriptBox["Q", "0"]}], ")"}], Cell[
           "\[NonBreakingSpace]=\[NonBreakingSpace]", "Text"]}], "|", "1"}], 
         ")"}], Cell[".", "Text"]}]},
      {
       RowBox[{
       Cell["All\[NonBreakingSpace]eigenops\[NonBreakingSpace]are\
\[NonBreakingSpace]assumed\[NonBreakingSpace]to\[NonBreakingSpace]be\
\[NonBreakingSpace]orthogonal", "Text"], Cell[".", "Text"]}]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
         Cell["Desired\[NonBreakingSpace]properties\[NonBreakingSpace]of\
\[NonBreakingSpace]thermalization\[NonBreakingSpace]superoperator\
\[NonBreakingSpace]", "Text"], 
          RowBox[{
           OverscriptBox["\[CapitalTheta]", "^",
            DiacriticalPositioning->True], ":", 
           RowBox[{
           Cell["\[NonBreakingSpace]where\[NonBreakingSpace]", "Text"], "|", 
            "\[Theta]"}]}]}], ")"}], Cell[
        "\[NonBreakingSpace]is\[NonBreakingSpace]thermal\[NonBreakingSpace]\
equilib\[NonBreakingSpace]dop:", "Text"]}]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
               Cell["1", "Text"], Cell[
                ".\[NonBreakingSpace]\[NonBreakingSpace]", "Text"], 
                OverscriptBox["\[CapitalTheta]", "^",
                 DiacriticalPositioning->True]}], "|", "\[Theta]"}], ")"}], 
             "\[Proportional]"}], "|", 
            SubscriptBox["Q", "0"]}], ")"}], ";", 
          RowBox[{
          Cell["\[NonBreakingSpace]this\[NonBreakingSpace]ensures\
\[NonBreakingSpace]that\[NonBreakingSpace]", "Text"], "|", "\[Theta]"}]}], 
         ")"}], Cell[
        "\[NonBreakingSpace]is\[NonBreakingSpace]transformed\
\[NonBreakingSpace]into\[NonBreakingSpace]null\[NonBreakingSpace]space\
\[NonBreakingSpace]of\[NonBreakingSpace]Liouvillian", "Text"], Cell[
        ".", "Text"]}]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
            Cell["2", "Text"], Cell[
             ".\[NonBreakingSpace]\[NonBreakingSpace]", "Text"], 
             OverscriptBox["\[CapitalTheta]", "^",
              DiacriticalPositioning->True]}], "|", 
            SubscriptBox["Q", 
             RowBox[{"a", ">", "0"}]]}], ")"}], "=", 
          RowBox[{"|", 
           SubscriptBox["Q", "a"]}]}], ")"}], ";", 
        RowBox[{Cell["\<\
\[NonBreakingSpace]this\[NonBreakingSpace]ensures\[NonBreakingSpace]that\
\[NonBreakingSpace]other\[NonBreakingSpace]eigenvectors\[NonBreakingSpace]are\
\[NonBreakingSpace]unchanged\[NonBreakingSpace]by\[NonBreakingSpace]\
thermalization\
\>", "Text"], Cell[".", "Text"]}]}]},
      {Cell["Consider:", "Text"]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          OverscriptBox["X", "^",
           DiacriticalPositioning->True], "=", 
          RowBox[{
           RowBox[{
            RowBox[{
             UnderscriptBox["\[Sum]", 
              RowBox[{"a", ">", "0"}]], 
             FractionBox[
              RowBox[{
               RowBox[{
                RowBox[{"|", 
                 SubscriptBox["Q", "a"]}], ")"}], 
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox["Q", "a"], "|"}]}]}], 
              RowBox[{"(", 
               RowBox[{
                SubscriptBox["Q", "a"], "|", 
                SubscriptBox["Q", "a"]}], ")"}]]}], "+"}], "|", 
           "\[Theta]"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["Q", "0"], "|"}]}]}]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            OverscriptBox["X", "^",
             DiacriticalPositioning->True], "|", 
            SubscriptBox["Q", "0"]}], ")"}], "=", 
          RowBox[{"|", "\[Theta]"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["Q", "0"], "|", 
          SubscriptBox["Q", "0"]}], ")"}]}]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           OverscriptBox["X", "^",
            DiacriticalPositioning->True], "|", 
           SubscriptBox["Q", 
            RowBox[{"a", ">", "0"}]]}], ")"}], "=", 
         RowBox[{"|", 
          SubscriptBox["Q", "a"]}]}], ")"}]},
      {Cell["then:", "Text"]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              OverscriptBox["X", "^",
               DiacriticalPositioning->True], 
              RowBox[{"\[Minus]", "1"}]], 
             OverscriptBox["X", "^",
              DiacriticalPositioning->True]}], "|", 
            SubscriptBox["Q", "0"]}], ")"}], "=", 
          RowBox[{
           SuperscriptBox[
            OverscriptBox["X", "^",
             DiacriticalPositioning->True], 
            RowBox[{"\[Minus]", "1"}]], "|", "\[Theta]"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["Q", "0"], "|", 
          SubscriptBox["Q", "0"]}], ")"}]}]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            SuperscriptBox[
             OverscriptBox["X", "^",
              DiacriticalPositioning->True], 
             RowBox[{"\[Minus]", "1"}]], 
            OverscriptBox["X", "^",
             DiacriticalPositioning->True]}], "|", 
           SubscriptBox["Q", 
            RowBox[{"a", ">", "0"}]]}], ")"}], "=", 
         RowBox[{
          SuperscriptBox[
           OverscriptBox["X", "^",
            DiacriticalPositioning->True], 
           RowBox[{"\[Minus]", "1"}]], "|", 
          SubscriptBox["Q", "a"]}]}], ")"}]},
      {Cell["hence:", "Text"]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          SuperscriptBox[
           OverscriptBox["X", "^",
            DiacriticalPositioning->True], 
           RowBox[{"\[Minus]", "1"}]], "|", "\[Theta]"}], ")"}], "=", 
        FractionBox[
         RowBox[{
          RowBox[{"|", 
           SubscriptBox["Q", "0"]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["Q", "0"], "|", 
           SubscriptBox["Q", "0"]}], ")"}]]}]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            OverscriptBox["X", "^",
             DiacriticalPositioning->True], 
            RowBox[{"\[Minus]", "1"}]], "|", 
           SubscriptBox["Q", 
            RowBox[{"a", ">", "0"}]]}], ")"}], "=", 
         RowBox[{"|", 
          SubscriptBox["Q", "a"]}]}], ")"}]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            OverscriptBox["X", "^",
             DiacriticalPositioning->True], 
            RowBox[{"\[Minus]", "1"}]], "|", "\[Theta]"}], ")"}], "=", 
         RowBox[{"|", 
          SubscriptBox["Q", "0"]}]}], ")"}]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            OverscriptBox["X", "^",
             DiacriticalPositioning->True], 
            RowBox[{"\[Minus]", "1"}]], "|", 
           SubscriptBox["Q", 
            RowBox[{"a", ">", "0"}]]}], ")"}], "=", 
         RowBox[{"|", 
          SubscriptBox["Q", "a"]}]}], ")"}]},
      {
       RowBox[{
       Cell["we\[NonBreakingSpace]can\[NonBreakingSpace]therefore\
\[NonBreakingSpace]identify\[NonBreakingSpace]", "Text"], 
        OverscriptBox["\[CapitalTheta]", "^",
         DiacriticalPositioning->True], Cell[
        "\[NonBreakingSpace]with\[NonBreakingSpace]", "Text"], 
        SuperscriptBox[
         OverscriptBox["X", "^",
          DiacriticalPositioning->True], 
         RowBox[{"\[Minus]", "1"}]], Cell[":", "Text"]}]},
      {
       RowBox[{
        OverscriptBox["\[CapitalTheta]", "^",
         DiacriticalPositioning->True], "=", 
        SuperscriptBox[
         OverscriptBox["X", "^",
          DiacriticalPositioning->True], 
         RowBox[{"\[Minus]", "1"}]]}]},
      {
       RowBox[{
       Cell["try\[NonBreakingSpace]to\[NonBreakingSpace]find\
\[NonBreakingSpace]a\[NonBreakingSpace]convenient\[NonBreakingSpace]way\
\[NonBreakingSpace]to\[NonBreakingSpace]calculate\[NonBreakingSpace]", 
         "Text"], 
        RowBox[{
         OverscriptBox["X", "^",
          DiacriticalPositioning->True], ".", "\[NonBreakingSpace]"}]}]},
      {
       RowBox[{
       Cell["Consider\[NonBreakingSpace]the\[NonBreakingSpace]unity\
\[NonBreakingSpace]superoperator\[NonBreakingSpace]", "Text"], 
        OverscriptBox["1", "^",
         DiacriticalPositioning->True]}]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          OverscriptBox["1", "^",
           DiacriticalPositioning->True], "=", 
          RowBox[{
           RowBox[{
            UnderscriptBox["\[Sum]", "a"], 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"|", 
                SubscriptBox["Q", "a"]}], ")"}], 
              RowBox[{"(", 
               RowBox[{
                SubscriptBox["Q", "a"], "|"}]}]}], 
             RowBox[{"(", 
              RowBox[{
               SubscriptBox["Q", "a"], "|", 
               SubscriptBox["Q", "a"]}], ")"}]]}], "=", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               UnderscriptBox["\[Sum]", 
                RowBox[{"a", ">", "0"}]], 
               FractionBox[
                RowBox[{
                 RowBox[{
                  RowBox[{"|", 
                   SubscriptBox["Q", "a"]}], ")"}], 
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["Q", "a"], "|"}]}]}], 
                RowBox[{"(", 
                 RowBox[{
                  SubscriptBox["Q", "a"], "|", 
                  SubscriptBox["Q", "a"]}], ")"}]]}], "+"}], 
             SuperscriptBox["N", 
              RowBox[{"\[Minus]", "1"}]]}], "|", "1"}]}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{"1", "|"}]}]}]},
      {
       RowBox[{
       Cell["where\[NonBreakingSpace]", "Text"], "N", Cell[
        "\[NonBreakingSpace]is\[NonBreakingSpace]the\[NonBreakingSpace]\
operator\[NonBreakingSpace]basis\[NonBreakingSpace]dimension", "Text"], Cell[
        ".\[NonBreakingSpace]Hence", "Text"]}]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              UnderscriptBox["\[Sum]", 
               RowBox[{"a", ">", "0"}]], 
              FractionBox[
               RowBox[{
                RowBox[{
                 RowBox[{"|", 
                  SubscriptBox["Q", "a"]}], ")"}], 
                RowBox[{"(", 
                 RowBox[{
                  SubscriptBox["Q", "a"], "|"}]}]}], 
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox["Q", "a"], "|", 
                 SubscriptBox["Q", "a"]}], ")"}]]}], "="}], 
            OverscriptBox["1", "^",
             DiacriticalPositioning->True]}], "\[Minus]", 
           SuperscriptBox["N", 
            RowBox[{"\[Minus]", "1"}]]}], "|", "1"}], ")"}], 
        RowBox[{"(", 
         RowBox[{"1", "|"}]}]}]},
      {Cell["and", "Text"]},
      {
       RowBox[{
        RowBox[{
         RowBox[{
          SuperscriptBox[
           OverscriptBox["\[CapitalTheta]", "^",
            DiacriticalPositioning->True], 
           RowBox[{"\[Minus]", "1"}]], "=", 
          RowBox[{
           OverscriptBox["X", "^",
            DiacriticalPositioning->True], "=", 
           RowBox[{
            RowBox[{
             RowBox[{
              UnderscriptBox["\[Sum]", 
               RowBox[{"a", ">", "0"}]], 
              FractionBox[
               RowBox[{
                RowBox[{
                 RowBox[{"|", 
                  SubscriptBox["Q", "a"]}], ")"}], 
                RowBox[{"(", 
                 RowBox[{
                  SubscriptBox["Q", "a"], "|"}]}]}], 
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox["Q", "a"], "|", 
                 SubscriptBox["Q", "a"]}], ")"}]]}], "+"}], "|", 
            "\[Theta]"}]}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["Q", "0"], "|", 
          RowBox[{"=", 
           RowBox[{
            RowBox[{
             OverscriptBox["1", "^",
              DiacriticalPositioning->True], "\[Minus]", 
             SuperscriptBox["N", 
              RowBox[{"\[Minus]", "1"}]]}], "|", "1"}]}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{"1", "|", 
          RowBox[{"+", 
           RowBox[{"|", "\[Theta]"}]}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{"1", "|", 
          RowBox[{"=", 
           RowBox[{
            RowBox[{
             OverscriptBox["1", "^",
              DiacriticalPositioning->True], "\[Minus]"}], "|", 
            RowBox[{
             RowBox[{
              SuperscriptBox["N", 
               RowBox[{"\[Minus]", "1"}]], "1"}], "\[Minus]", 
             "\[Theta]"}]}]}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{"1", "|"}]}]}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}],
    "MathMLPresentationTag",
    AutoDelete->True], TraditionalForm]], "Input",
  FontWeight->"Plain"]
}], "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5027816913667192`*^9, 3.5027816924803143`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["code", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.486738467888925*^9, 
  3.4867384683110523`*^9}},ExpressionUUID->"a4b4671f-4e55-45e1-8f49-\
a66252eff3b3"],

Cell[TextData[{
 "The spec ",
 StyleBox["SuperoperatorType\[Rule]None (blue)",
  FontColor->RGBColor[0, 0, 1]],
 " is important in order to ensure correct handling on diagonalization"
}], "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.6404061793111143`*^9, 
  3.640406204370673*^9}},ExpressionUUID->"7da3bad3-2caa-437d-a9ec-\
573fef5457b0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ThermalizeSuperoperator", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"HighTemperatureApproximation", "\[Rule]", "True"}], ",", 
     RowBox[{"Temperature", "\[Rule]", "Infinity"}]}], "}"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4613183178844233`*^9, 3.4613183279410753`*^9}, {
   3.461318465919201*^9, 3.461318478613089*^9}, 3.461323272905582*^9, 
   3.533115604625354*^9, {3.533115777403369*^9, 
   3.533115777896406*^9}},ExpressionUUID->"2c142acb-b502-44cc-9104-\
4a179d3a8801"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ThermalizeSuperoperator", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6826100340317593`*^9, 3.6826100532041483`*^9}, 
   3.6826102793164587`*^9},ExpressionUUID->"223a46fb-0c14-4c59-b8c0-\
7e51c144c114"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ThermalizeSuperoperator", "[", 
    RowBox[{
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"H\[CapitalTheta]_", "?", "OperatorQ"}], ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"ThermalizeSuperoperator", "[", 
    RowBox[{"sop", ",", "H\[CapitalTheta]", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Temperature", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "ThermalizeSuperoperator", "]"}]}], ",", 
     "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533005236176984*^9, 3.533005345393694*^9}, {
   3.533115801618219*^9, 3.533115821558771*^9}, 
   3.6826103574516363`*^9},ExpressionUUID->"ee3e04cc-649b-4f24-a8d8-\
328483f2f511"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ThermalizeSuperoperator", "[", 
    RowBox[{
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"H\[CapitalTheta]_", "?", "OperatorQ"}], ",", 
     RowBox[{"T", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"ThermalizeSuperoperator", "[", 
    RowBox[{"sop", ",", 
     RowBox[{"{", 
      RowBox[{"H\[CapitalTheta]", ",", "T"}], "}"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.682610304390629*^9, 
  3.682610322270039*^9}},ExpressionUUID->"4981e142-52ef-451a-b0d0-\
2cd842cfc480"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ThermalizeSuperoperator", "[", 
     RowBox[{
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"H\[CapitalTheta]_", "?", "OperatorQ"}], ",", 
        RowBox[{"T", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}]}], "}"}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"T", ",", 
       RowBox[{"(", 
        RowBox[{"_Symbol", "|", 
         RowBox[{"_", "?", "NumericQ"}]}], ")"}]}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"ThermalizeSuperoperator", "::", "badT"}], ",", "T"}], "]"}], 
     ";", "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533005374868957*^9, 3.533005445867835*^9}, {
  3.533005539686653*^9, 3.533005567238909*^9}, {3.5330056461851482`*^9, 
  3.533005669323782*^9}, {3.5331156701381083`*^9, 3.5331156882748957`*^9}, {
  3.6826103280829563`*^9, 
  3.682610331584962*^9}},ExpressionUUID->"2efba258-7ff6-4023-91a0-\
3516b5c674c4"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ThermalizeSuperoperator", "[", 
   RowBox[{
    RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"H\[CapitalTheta]_", "?", "OperatorQ"}], ",", 
      RowBox[{"T", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}]}], "}"}], ",", "opts___Rule"}],
    "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "n", ",", "UnityH", ",", "UnityL", ",", "\[Rho]eq", ",", 
      "\[CapitalTheta]", ",", "\[CapitalGamma]mat", ",", 
      "\[CapitalGamma]\[CapitalTheta]raw", ",", 
      "\[CapitalGamma]\[CapitalTheta]", ",", "BT"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"n", "=", 
      RowBox[{"BasisDimension", "[", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"UnityH", "=", 
      RowBox[{"IdentityMatrix", "[", 
       RowBox[{"n", ",", "SparseArray"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"UnityL", "=", 
      RowBox[{"IdentityMatrix", "[", 
       RowBox[{
        RowBox[{"n", "*", "n"}], ",", "SparseArray"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"\[Rho]eq", "=", 
      RowBox[{"MatrixRepresentation", "[", 
       RowBox[{
        RowBox[{"ThermalEquilibriumDensityOperator", "[", 
         RowBox[{"H\[CapitalTheta]", ",", "T", ",", "opts"}], "]"}], ",", 
        RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"\[CapitalTheta]", "=", "\[IndentingNewLine]", 
      RowBox[{"Chop", "[", 
       RowBox[{"UnityL", "-", "\[IndentingNewLine]", 
        RowBox[{"KroneckerProduct", "[", 
         RowBox[{
          RowBox[{"Flatten", "[", 
           RowBox[{"(", 
            RowBox[{"\[Rho]eq", "-", 
             RowBox[{
              RowBox[{"n", "^", 
               RowBox[{"-", "1"}]}], " ", "UnityH"}]}], ")"}], "]"}], ",", 
          RowBox[{"Flatten", "[", "UnityH", "]"}]}], "]"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"\[CapitalGamma]mat", "=", 
      RowBox[{"N", "@", 
       RowBox[{"SuperoperatorMatrixRepresentation", "[", 
        RowBox[{"sop", ",", 
         RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], "]"}]}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"\[CapitalGamma]\[CapitalTheta]raw", "=", 
      RowBox[{"\[CapitalGamma]mat", ".", "\[CapitalTheta]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"\[CapitalGamma]\[CapitalTheta]", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"NumericMatrixQ", "[", 
           RowBox[{"#", "/.", "PhysicalConstantValues"}], "]"}], ",", 
          RowBox[{"#", "/.", "PhysicalConstantValues"}], ",", "#"}], "]"}], 
        "&"}], "@", "\[CapitalGamma]\[CapitalTheta]raw"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"OperatorBasis", "[", "]"}], "===", " ", 
        RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], ",", 
       RowBox[{"Superoperator", "[", 
        RowBox[{
         RowBox[{"Simplify", "[", "\[CapitalGamma]\[CapitalTheta]", "]"}], 
         ",", 
         RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}], ",", 
         RowBox[{"ZeemanBasis", "[", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"SuperoperatorType", "\[Rule]", "None"}]}], "]"}], ",", 
       RowBox[{
        RowBox[{"BT", "=", 
         RowBox[{"OperatorBasisTransformationMatrix", "[", 
          RowBox[{
           RowBox[{"OperatorBasis", "[", "]"}], ",", 
           RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], "]"}]}], ";", 
        RowBox[{"Superoperator", "[", 
         RowBox[{
          RowBox[{"Simplify", "[", 
           RowBox[{"BT", ".", "\[CapitalGamma]\[CapitalTheta]", ".", 
            RowBox[{"ConjugateTranspose", "[", "BT", "]"}]}], "]"}], ",", 
          RowBox[{"OperatorBasis", "[", "]"}], ",", 
          RowBox[{"ZeemanBasis", "[", "]"}], ",", "\[IndentingNewLine]", 
          StyleBox[
           RowBox[{"SuperoperatorType", "\[Rule]", "None"}],
           FontColor->RGBColor[0, 0, 1]]}], "]"}]}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.461318540735222*^9, 3.461318583559379*^9}, {
   3.4613186177132673`*^9, 3.4613187663987827`*^9}, {3.461319162740191*^9, 
   3.461319247673558*^9}, {3.46131928726821*^9, 3.461319390564929*^9}, {
   3.461319422509548*^9, 3.461319524109853*^9}, {3.461319554278779*^9, 
   3.46131962061481*^9}, {3.4613196507920303`*^9, 3.4613197087686987`*^9}, {
   3.461319747113997*^9, 3.461319848288114*^9}, {3.46131998171839*^9, 
   3.461319994184554*^9}, {3.4613233123340883`*^9, 3.461323468658164*^9}, {
   3.46132349884311*^9, 3.4613235678120327`*^9}, {3.461323608184057*^9, 
   3.4613236710248528`*^9}, {3.461323736475059*^9, 3.461323787557354*^9}, {
   3.461324598495862*^9, 3.461324700723447*^9}, {3.461325188749758*^9, 
   3.4613251955801287`*^9}, {3.4613256497985373`*^9, 3.461325682232992*^9}, {
   3.4613258844836073`*^9, 3.461325945310627*^9}, {3.461326025370944*^9, 
   3.4613260287980328`*^9}, {3.461326477157523*^9, 3.461326482115354*^9}, {
   3.462009460705168*^9, 3.46200967395273*^9}, {3.462009943001855*^9, 
   3.462009949568097*^9}, {3.46201097412572*^9, 3.462010978280098*^9}, 
   3.462011093594398*^9, {3.462011158491927*^9, 3.462011163709221*^9}, {
   3.462011393364534*^9, 3.4620114060090218`*^9}, {3.4677205150289927`*^9, 
   3.467720516905736*^9}, {3.486723902735751*^9, 3.4867239062223597`*^9}, {
   3.486723941336356*^9, 3.486723978232542*^9}, {3.486724048184387*^9, 
   3.486724059750381*^9}, {3.4867243206666737`*^9, 3.4867243416572323`*^9}, {
   3.486737191598591*^9, 3.486737424181254*^9}, {3.486737466086595*^9, 
   3.486737498100713*^9}, {3.48673785133427*^9, 3.486737885181361*^9}, {
   3.4867382571317167`*^9, 3.486738269323206*^9}, {3.4867462418171453`*^9, 
   3.4867462426541433`*^9}, {3.48674661154856*^9, 3.486746667286379*^9}, {
   3.5027787725845337`*^9, 3.502778784518363*^9}, {3.502779122574522*^9, 
   3.502779130889739*^9}, {3.5027791969799137`*^9, 3.50277924025587*^9}, {
   3.502779289136899*^9, 3.5027792893639593`*^9}, {3.502779330199833*^9, 
   3.502779356675761*^9}, {3.502781544302431*^9, 3.5027815452672987`*^9}, {
   3.502781582542427*^9, 3.502781588651928*^9}, 3.502781910479104*^9, {
   3.502782122095582*^9, 3.50278212653824*^9}, {3.5330451646087313`*^9, 
   3.5330451829224987`*^9}, {3.5331155960095654`*^9, 
   3.5331156127042837`*^9}, {3.5331159426242943`*^9, 3.533115943293807*^9}, {
   3.5331162320971823`*^9, 3.533116375626315*^9}, 3.5331164903476677`*^9, {
   3.6404105260296497`*^9, 3.640410526753026*^9}, {3.640410587337783*^9, 
   3.640410589518819*^9}, {3.657717245739121*^9, 3.6577172887364798`*^9}, {
   3.6577173396975403`*^9, 3.6577174606912127`*^9}, {3.657717633412244*^9, 
   3.657717641091639*^9}, {3.682610335927122*^9, 3.682610338576661*^9}, {
   3.7119555341199665`*^9, 3.7119555386360483`*^9}, {3.7284238583954353`*^9, 
   3.7284238587346783`*^9}},ExpressionUUID->"3c62ca59-5cde-46fa-a712-\
711bf8d55585"]
}, Open  ]],

Cell[CellGroupData[{

Cell["messages", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.486738467888925*^9, 3.4867384683110523`*^9}, {
  3.533115698258894*^9, 3.533115699430669*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ThermalizeSuperoperator", "::", "badT"}], "=", 
   "\"\<The temperature `1` is invalid.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4613275020536757`*^9, 3.461327564671322*^9}, {
   3.5330054567263308`*^9, 3.533005470905169*^9}, 3.5331157211992083`*^9}]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Secularization", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.461320196487152*^9, 3.461320199130999*^9}, {
  3.461322172862348*^9, 3.461322178107759*^9}, {3.681102899127542*^9, 
  3.6811029021418333`*^9}}],

Cell[CellGroupData[{

Cell["general", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[CellGroupData[{

Cell["$Failed trap", "Subsubsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Secularize", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.570342549538795*^9, {3.621243820894185*^9, 3.62124383739154*^9}, 
   3.6305694259241333`*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Secularization of operators", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309347750764313`*^9, 3.430934777473254*^9}, {
  3.630569452949441*^9, 3.6305694882451687`*^9}, {3.6811030283040133`*^9, 
  3.681103031587934*^9}}],

Cell[CellGroupData[{

Cell["Secularize symbolic operator", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309347750764313`*^9, 3.430934777473254*^9}, {
  3.630569452949441*^9, 3.6305694882451687`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Secularize", "[", 
     RowBox[{
      RowBox[{"op", ":", 
       RowBox[{"Except", "[", "_Operator", "]"}]}], ",", "args___"}], "]"}], "/;", 
    RowBox[{"OperatorQ", "[", "op", "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"ExpressOperator", "@", 
    RowBox[{"Secularize", "[", 
     RowBox[{
      RowBox[{"Operator", "[", 
       RowBox[{"op", ",", 
        RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}], ",", "args"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630569491094027*^9, 3.6305696194458017`*^9}, {
   3.630570929004553*^9, 3.630570937704236*^9}, 3.6305761234652443`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Secularize using Zeeman interaction, by specifying sets of spins of different \
isotopic types\
\>", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309347750764313`*^9, 3.430934777473254*^9}, {
  3.630569452949441*^9, 3.630569463371832*^9}, {3.630569640628294*^9, 
  3.6305696445546618`*^9}, {3.630572269832868*^9, 3.6305722717882566`*^9}, {
  3.630573108537704*^9, 3.630573109268743*^9}, {3.630573204271954*^9, 
  3.6305732305549393`*^9}}],

Cell[CellGroupData[{

Cell["unify format and check legality of spin sets", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.63057044027773*^9, 3.630570467740078*^9}, {
  3.6305722853213243`*^9, 3.630572288085539*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", "op_Operator", "]"}], ":=", 
   RowBox[{"Secularize", "[", 
    RowBox[{"op", ",", 
     RowBox[{"First", "/@", 
      RowBox[{"SpinSystem", "[", "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630569662835341*^9, 3.630569689213319*^9}, {
  3.630569726681322*^9, 3.6305697342890863`*^9}, {3.6305698145453863`*^9, 
  3.6305698163443108`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{"op_Operator", ",", 
     RowBox[{"spin", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_List", "|", 
        RowBox[{"_", "?", "OperatorQ"}]}], "]"}]}]}], "]"}], ":=", 
   RowBox[{"Secularize", "[", 
    RowBox[{"op", ",", 
     RowBox[{"{", "spin", "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.630570483716804*^9, {3.6305705408822412`*^9, 3.630570567903096*^9}, {
   3.682611189500578*^9, 3.682611198627277*^9}, {3.682611443060771*^9, 
   3.682611450159144*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{"op_Operator", ",", 
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], "..."}], "}"}]}]}], "]"}], ":=", 
   RowBox[{"Secularize", "[", 
    RowBox[{"op", ",", 
     RowBox[{"{", "spins", "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.630570483716804*^9, {3.6305705408822412`*^9, 3.630570567903096*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{"op_Operator", ",", 
     RowBox[{"spinsets", ":", 
      RowBox[{"{", 
       RowBox[{"_List", ".."}], "}"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"includedspins", ",", "missingspins"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Secularize", "[", 
        RowBox[{"op", ",", 
         RowBox[{"Append", "[", 
          RowBox[{"spinsets", ",", "missingspins"}], "]"}]}], "]"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"includedspins", "=", 
         RowBox[{"Union", "@@", "spinsets"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"missingspins", "=", 
         RowBox[{"Complement", "[", 
          RowBox[{
           RowBox[{"First", "/@", 
            RowBox[{"SpinSystem", "[", "]"}]}], ",", "includedspins"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"missingspins", ",", 
           RowBox[{"{", "}"}]}], "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630570588257105*^9, 3.6305706485312634`*^9}, {
   3.6305707230705423`*^9, 3.630570772020211*^9}, 3.630571403304888*^9, 
   3.6305714870213013`*^9, 3.630571928879696*^9, {3.630572085034416*^9, 
   3.63057212446196*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{"op_Operator", ",", 
     RowBox[{"spinsets", ":", 
      RowBox[{"{", 
       RowBox[{"_List", ".."}], "}"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "sharedspins", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Secularize", "::", "sharedspins"}], ",", "sharedspins"}], 
         "]"}], ";", "$Failed"}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"sharedspins", "=", 
         RowBox[{"Switch", "[", 
          RowBox[{"spinsets", ",", 
           RowBox[{"{", "_List", "}"}], ",", 
           RowBox[{"{", "}"}], ",", "_", ",", 
           RowBox[{"Intersection", "@@", "spinsets"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"sharedspins", ",", 
           RowBox[{"{", "}"}]}], "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6305700821713133`*^9, 3.630570108981728*^9}, {
  3.630570144853739*^9, 3.630570150515978*^9}, {3.630570249848374*^9, 
  3.630570342808316*^9}, {3.630570521014085*^9, 3.630570533280492*^9}, {
  3.630571057075523*^9, 3.630571156032605*^9}, {3.630571922928693*^9, 
  3.6305719258321333`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Secularize", "[", 
     RowBox[{"op_Operator", ",", 
      RowBox[{"spinsets", ":", 
       RowBox[{"{", 
        RowBox[{"_List", ".."}], "}"}]}]}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{"And", "@@", 
       RowBox[{"(", 
        RowBox[{"ValidSpinQ", "/@", 
         RowBox[{"Flatten", "[", "spinsets", "]"}]}], ")"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Secularize", "::", "invalspin"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.63056975862849*^9, 3.63056978634433*^9}, {
  3.630569818111472*^9, 3.6305698833126583`*^9}, {3.630569987935734*^9, 
  3.630570052274193*^9}, {3.630571683081625*^9, 3.6305716933576803`*^9}, {
  3.630571917351275*^9, 3.630571917995408*^9}, {3.682611232043708*^9, 
  3.6826112359528723`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Zeeman-secularize Operator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.63057044027773*^9, 3.630570467740078*^9}, {
   3.630572241872452*^9, 3.630572259238188*^9}, {3.630572424246961*^9, 
   3.630572430250551*^9}, 3.630573576673665*^9, {3.630576008480644*^9, 
   3.6305760130997267`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{"op_Operator", ",", 
     RowBox[{"spinsets", ":", 
      RowBox[{"{", 
       RowBox[{"_List", ".."}], "}"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "opmatrep", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"opmatrep", "=", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"op", ",", 
          RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SparseArray", "[", 
          RowBox[{"opmatrep", "*", 
           RowBox[{"SecularizationMatrix", "[", 
            RowBox[{"spinsets", ",", 
             RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}], "]"}], ",", 
         RowBox[{"ZeemanBasis", "[", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630572369354238*^9, 3.6305725305463467`*^9}, {
  3.6305728286811037`*^9, 3.63057289463489*^9}, {3.6305731280240393`*^9, 
  3.630573150558585*^9}, {3.630574616508292*^9, 3.6305746168177013`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["memorize SecularizationMatrix", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.63057044027773*^9, 3.630570467740078*^9}, {
  3.630572241872452*^9, 3.630572259238188*^9}, {3.630572424246961*^9, 
  3.630572430250551*^9}, {3.630572918302849*^9, 3.6305729244523*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SecularizationMatrix", "[", 
    RowBox[{
     RowBox[{"spinsets", ":", 
      RowBox[{"{", 
       RowBox[{"_List", ".."}], "}"}]}], ",", "zb_ZeemanBasis"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SecularizationMatrix", "[", 
     RowBox[{"spinsets", ",", "zb"}], "]"}], "=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Mvals", ",", "n"}], "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Mvals", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"MagneticQuantumNumber", "[", 
            RowBox[{"#", ",", "spinsets"}], "]"}], "&"}], "/@", 
          RowBox[{"BasisKets", "[", "zb", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"n", "=", 
         RowBox[{"BasisDimension", "[", "zb", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SparseArray", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i_", ",", "j_"}], "}"}], "/;", 
             RowBox[{
              RowBox[{
              "Mvals", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}],
               "\[Equal]", 
              RowBox[{
              "Mvals", "\[LeftDoubleBracket]", "j", 
               "\[RightDoubleBracket]"}]}]}], "\[Rule]", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "n"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
       ")"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630572929394086*^9, 3.630573091334279*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Secularize against arbitrary Hamiltonian", "Subsection",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309347750764313`*^9, 3.430934777473254*^9}, {
  3.630569452949441*^9, 3.630569463371832*^9}, {3.630569640628294*^9, 
  3.6305696445546618`*^9}, {3.630572269832868*^9, 3.6305722717882566`*^9}, {
  3.630573108537704*^9, 3.630573109268743*^9}, {3.630573204271954*^9, 
  3.6305732305549393`*^9}, {3.630573650341456*^9, 3.630573660899003*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{
     RowBox[{"op_", "?", "OperatorQ"}], ",", 
     RowBox[{"H0_", "?", "OperatorQ"}]}], "]"}], ":=", 
   RowBox[{"Secularize", "[", 
    RowBox[{"op", ",", "H0", ",", "$ChopThreshold"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6305737592311993`*^9, 3.630573797350795*^9}, {
  3.682611379798973*^9, 3.6826113822440767`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Secularize", "[", 
     RowBox[{"op_Operator", ",", 
      RowBox[{"H0", ":", 
       RowBox[{"Except", "[", "_Operator", "]"}]}], ",", 
      RowBox[{"thresh_", "?", "NumericQ"}]}], "]"}], "/;", 
    RowBox[{"OperatorQ", "[", "H0", "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Secularize", "[", 
    RowBox[{"op", ",", 
     RowBox[{"Operator", "[", 
      RowBox[{"H0", ",", 
       RowBox[{"Basis", "[", "]"}]}], "]"}], ",", "thresh"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630573696245317*^9, 3.630573738855513*^9}, {
  3.630573802254353*^9, 3.630573871260398*^9}, {3.682611384396469*^9, 
  3.6826113904281473`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Secularize", "[", 
     RowBox[{"op_Operator", ",", 
      RowBox[{"Operator", "[", 
       RowBox[{
        RowBox[{"H0mat_", "?", "MatrixQ"}], ",", "basis_", ",", 
        "opts___Rule"}], "]"}], ",", 
      RowBox[{"thresh_", "?", "NumericQ"}]}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"NumericMatrixQ", "[", "H0mat", "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Secularize", "::", "nonnumH0mat"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630573696245317*^9, 3.630573738855513*^9}, {
  3.630573802254353*^9, 3.6305739832676287`*^9}, {3.682611396149675*^9, 
  3.6826114020031137`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Secularize", "[", 
     RowBox[{"op_Operator", ",", 
      RowBox[{"H0", ":", 
       RowBox[{"Operator", "[", 
        RowBox[{"H0mat_", ",", "basis_", ",", "opts___Rule"}], "]"}]}], ",", 
      RowBox[{"thresh_", "?", "NumericQ"}]}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"OperatorType", "[", "H0", "]"}], ",", "\"\<Hermitian\>\""}], 
      "]"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Secularize", "::", "nonhermH0"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630573696245317*^9, 3.630573738855513*^9}, {
  3.630573802254353*^9, 3.6305739832676287`*^9}, {3.6305741465888023`*^9, 
  3.6305741578881483`*^9}, {3.630574213304593*^9, 3.6305742565687637`*^9}, {
  3.682611406996817*^9, 3.6826114159060383`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{"op_Operator", ",", 
     RowBox[{"H0", ":", 
      RowBox[{"Operator", "[", 
       RowBox[{
        RowBox[{"H0mat_", "?", "NumericMatrixQ"}], ",", "basis_", ",", 
        "opts___Rule"}], "]"}]}], ",", 
     RowBox[{"thresh_", "?", "NumericQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Secularize", "[", 
    RowBox[{"op", ",", 
     RowBox[{"NDiagonalize", "[", "H0", "]"}], ",", "thresh"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630573696245317*^9, 3.630573738855513*^9}, {
  3.630573802254353*^9, 3.6305739832676287`*^9}, {3.630574062462582*^9, 
  3.6305740689379272`*^9}, {3.630574515857189*^9, 3.630574542952602*^9}}],

Cell["\<\
secularize the operator by transforming into the eigenbasis of H0, deleting \
elements connecting eigenvalues which differ by more than the specified \
threshold, and transform back:\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.6305754566295233`*^9, 3.6305754951486692`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{"op_Operator", ",", 
     RowBox[{"H0", ":", 
      RowBox[{"Operator", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Xmat_", "?", "NumericMatrixQ"}], ",", "evals_List", ",", 
          RowBox[{"Xinvmat_", "?", "NumericMatrixQ"}]}], "}"}], ",", "basis_",
         ",", "opts___Rule"}], "]"}]}], ",", 
     RowBox[{"thresh_", "?", "NumericQ"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"opmatinH0eb", ",", "secmat", ",", "n"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"opmatinH0eb", "=", 
        RowBox[{"Xinvmat", ".", 
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{"op", ",", "basis"}], "]"}], ".", "Xmat"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "evals", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"secmat", "=", 
        RowBox[{"SparseArray", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i_", ",", "j_"}], "}"}], "/;", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{
                RowBox[{
                "evals", "\[LeftDoubleBracket]", "i", 
                 "\[RightDoubleBracket]"}], "-", 
                RowBox[{
                "evals", "\[LeftDoubleBracket]", "j", 
                 "\[RightDoubleBracket]"}]}], "]"}], "\[LessEqual]", 
              "thresh"}]}], "\[Rule]", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "n"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Operator", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SparseArray", "[", 
          RowBox[{"Xmat", ".", 
           RowBox[{"(", 
            RowBox[{"opmatinH0eb", "*", "secmat"}], ")"}], ".", "Xinvmat"}], 
          "]"}], ",", "\[IndentingNewLine]", "basis", ",", 
         "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630573696245317*^9, 3.630573738855513*^9}, {
  3.630573802254353*^9, 3.6305739832676287`*^9}, {3.630574062462582*^9, 
  3.6305740689379272`*^9}, {3.630574515857189*^9, 3.630574824204751*^9}, {
  3.630574861158437*^9, 3.63057489877102*^9}, {3.6305750960752*^9, 
  3.630575098230262*^9}, {3.630575403154128*^9, 3.630575447955853*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Zeeman-Secularize superoperator", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309347750764313`*^9, 3.430934777473254*^9}, {
  3.630569452949441*^9, 3.6305694882451687`*^9}, {3.630576859357814*^9, 
  3.630576867228147*^9}}],

Cell[CellGroupData[{

Cell["unify format and check legality of spin sets", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.63057044027773*^9, 3.630570467740078*^9}, {
  3.6305722853213243`*^9, 3.630572288085539*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{"sop_", "?", "SuperoperatorQ"}], "]"}], ":=", 
   RowBox[{"Secularize", "[", 
    RowBox[{"sop", ",", 
     RowBox[{"First", "/@", 
      RowBox[{"SpinSystem", "[", "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630569662835341*^9, 3.630569689213319*^9}, {
  3.630569726681322*^9, 3.6305697342890863`*^9}, {3.6305698145453863`*^9, 
  3.6305698163443108`*^9}, {3.630576899941843*^9, 3.630576921467667*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"spins", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Except", "[", "_List", "]"}], "..."}], "}"}]}]}], "]"}], ":=", 
   RowBox[{"Secularize", "[", 
    RowBox[{"sop", ",", 
     RowBox[{"{", "spins", "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.630570483716804*^9, {3.6305705408822412`*^9, 3.630570567903096*^9}, {
   3.63057692809943*^9, 3.630576930843279*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"spinsets", ":", 
      RowBox[{"{", 
       RowBox[{"_List", ".."}], "}"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"includedspins", ",", "missingspins"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Secularize", "[", 
        RowBox[{"sop", ",", 
         RowBox[{"Append", "[", 
          RowBox[{"spinsets", ",", "missingspins"}], "]"}]}], "]"}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"includedspins", "=", 
         RowBox[{"Union", "@@", "spinsets"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"missingspins", "=", 
         RowBox[{"Complement", "[", 
          RowBox[{
           RowBox[{"First", "/@", 
            RowBox[{"SpinSystem", "[", "]"}]}], ",", "includedspins"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"missingspins", ",", 
           RowBox[{"{", "}"}]}], "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630570588257105*^9, 3.6305706485312634`*^9}, {
   3.6305707230705423`*^9, 3.630570772020211*^9}, 3.630571403304888*^9, 
   3.6305714870213013`*^9, 3.630571928879696*^9, {3.630572085034416*^9, 
   3.63057212446196*^9}, {3.630576935335011*^9, 3.6305769373392773`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{
     RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
     RowBox[{"spinsets", ":", 
      RowBox[{"{", 
       RowBox[{"_List", ".."}], "}"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "sharedspins", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"Secularize", "::", "sharedspins"}], ",", "sharedspins"}], 
         "]"}], ";", "$Failed"}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"sharedspins", "=", 
         RowBox[{"Switch", "[", 
          RowBox[{"spinsets", ",", 
           RowBox[{"{", "_List", "}"}], ",", 
           RowBox[{"{", "}"}], ",", "_", ",", 
           RowBox[{"Intersection", "@@", "spinsets"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"sharedspins", ",", 
           RowBox[{"{", "}"}]}], "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6305700821713133`*^9, 3.630570108981728*^9}, {
   3.630570144853739*^9, 3.630570150515978*^9}, {3.630570249848374*^9, 
   3.630570342808316*^9}, {3.630570521014085*^9, 3.630570533280492*^9}, {
   3.630571057075523*^9, 3.630571156032605*^9}, {3.630571922928693*^9, 
   3.6305719258321333`*^9}, 3.6305769445254297`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Secularize", "[", 
     RowBox[{
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
      RowBox[{"spinsets", ":", 
       RowBox[{"{", 
        RowBox[{"_List", ".."}], "}"}]}]}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{"And", "@@", 
       RowBox[{"(", 
        RowBox[{"ValidSpinQ", "/@", 
         RowBox[{"Flatten", "[", "spinsets", "]"}]}], ")"}]}], ")"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Secularize", "::", "invalspin"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.63056975862849*^9, 3.63056978634433*^9}, {
   3.630569818111472*^9, 3.6305698833126583`*^9}, {3.630569987935734*^9, 
   3.630570052274193*^9}, {3.630571683081625*^9, 3.6305716933576803`*^9}, {
   3.630571917351275*^9, 3.630571917995408*^9}, 3.630576957957061*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Secularize", "[", 
     RowBox[{
      RowBox[{"sop_", "?", "SuperoperatorQ"}], ",", 
      RowBox[{"spinsets", ":", 
       RowBox[{"{", 
        RowBox[{"_List", ".."}], "}"}]}]}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"sop", ",", "_Superoperator"}], "]"}]}]}], ":=", 
   RowBox[{"Secularize", "[", 
    RowBox[{
     RowBox[{"Superoperator", "[", "sop", "]"}], ",", "spinsets"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630577211105616*^9, 3.630577255525811*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
transform if necessary to an operator basis suitable for Zeeman-secularization\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.63057044027773*^9, 3.630570467740078*^9}, {
   3.630572241872452*^9, 3.630572259238188*^9}, {3.630572424246961*^9, 
   3.630572430250551*^9}, 3.630573576673665*^9, {3.630576008480644*^9, 
   3.6305760130997267`*^9}, {3.630576981803216*^9, 3.63057698464674*^9}, {
   3.6305777768085423`*^9, 3.6305777863886127`*^9}, {3.631439989538929*^9, 
   3.631440002857154*^9}, {3.631440352508213*^9, 3.631440375617095*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{
     RowBox[{"sop", ":", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"Superoperator", "[", 
        RowBox[{"_", ",", 
         RowBox[{"opbasis", ":", 
          RowBox[{"Except", "[", 
           RowBox[{
           "_ZeemanKetBraOperatorBasis", "|", "_ShiftAndZOperatorBasis", "|", 
            "_ShiftAndPolarizationOperatorBasis"}], "]"}]}], ",", "more___"}],
         "]"}]}]}], ",", 
     RowBox[{"spinsets", ":", 
      RowBox[{"{", 
       RowBox[{"_List", ".."}], "}"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Secularize", "[", 
      RowBox[{
       RowBox[{"Superoperator", "[", 
        RowBox[{"sop", ",", 
         RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], "]"}], ",", 
       "spinsets"}], "]"}], ",", "\[IndentingNewLine]", "opbasis", ",", 
     "more"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630577211105616*^9, 3.630577517015472*^9}, {
   3.6305778950887213`*^9, 3.630577907988069*^9}, {3.6305781560070343`*^9, 
   3.630578158691366*^9}, {3.630578595559382*^9, 3.630578601117723*^9}, {
   3.6314400159544077`*^9, 3.631440022921545*^9}, 3.63144038433947*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["secularize in a suitable operator basis", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.63057044027773*^9, 3.630570467740078*^9}, {
   3.630572241872452*^9, 3.630572259238188*^9}, {3.630572424246961*^9, 
   3.630572430250551*^9}, 3.630573576673665*^9, {3.630576008480644*^9, 
   3.6305760130997267`*^9}, {3.630576981803216*^9, 3.63057698464674*^9}, {
   3.6305777768085423`*^9, 3.630577803358493*^9}, {3.631440029622654*^9, 
   3.631440035380398*^9}, {3.6314403942615213`*^9, 3.631440397337337*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "[", 
    RowBox[{
     RowBox[{"sop", ":", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"Superoperator", "[", 
        RowBox[{"_", ",", 
         RowBox[{"zsecopbasis", ":", 
          RowBox[{"(", 
           RowBox[{
           "_ZeemanKetBraOperatorBasis", "|", "_ShiftAndZOperatorBasis", "|", 
            "_ShiftAndPolarizationOperatorBasis"}], ")"}]}], ",", "more___"}],
         "]"}]}]}], ",", 
     RowBox[{"spinsets", ":", 
      RowBox[{"{", 
       RowBox[{"_List", ".."}], "}"}]}]}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Superoperator", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"SparseArray", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SuperoperatorMatrixRepresentation", "[", 
        RowBox[{"sop", ",", "zsecopbasis"}], "]"}], "*", 
       RowBox[{"SecularizationMatrix", "[", 
        RowBox[{"spinsets", ",", "zsecopbasis"}], "]"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "zsecopbasis", ",", "more"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630572369354238*^9, 3.6305725305463467`*^9}, {
   3.6305728286811037`*^9, 3.63057289463489*^9}, {3.6305731280240393`*^9, 
   3.630573150558585*^9}, {3.630574616508292*^9, 3.6305746168177013`*^9}, {
   3.6305770009303207`*^9, 3.630577126357079*^9}, {3.6305771587347393`*^9, 
   3.630577179218701*^9}, {3.630577552983061*^9, 3.630577600217414*^9}, {
   3.6305776308945093`*^9, 3.6305776621612167`*^9}, 3.630578169491417*^9, {
   3.631440045731997*^9, 3.63144008104923*^9}, {3.631440123507847*^9, 
   3.631440134961607*^9}, {3.631440166471827*^9, 3.6314401683066196`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["calculate & memorize SecularizationMatrix", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.63057044027773*^9, 3.630570467740078*^9}, {
  3.630572241872452*^9, 3.630572259238188*^9}, {3.630572424246961*^9, 
  3.630572430250551*^9}, {3.630572918302849*^9, 3.6305729244523*^9}, {
  3.6314494220877953`*^9, 3.631449424524742*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SecularizationMatrix", "[", 
    RowBox[{
     RowBox[{"spinsets", ":", 
      RowBox[{"{", 
       RowBox[{"_List", ".."}], "}"}]}], ",", 
     RowBox[{"zsecopbasis", ":", 
      RowBox[{"(", 
       RowBox[{
       "_ZeemanKetBraOperatorBasis", "|", "_ShiftAndZOperatorBasis", "|", 
        "_ShiftAndPolarizationOperatorBasis"}], ")"}]}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SecularizationMatrix", "[", 
     RowBox[{"spinsets", ",", "zsecopbasis"}], "]"}], "=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"pvals", ",", "n"}], "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"pvals", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"CoherenceOrder", "[", 
            RowBox[{"spinsets", ",", "#"}], "]"}], "&"}], "/@", 
          RowBox[{"BasisOperators", "[", "zsecopbasis", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"n", "=", 
         RowBox[{"OperatorBasisDimension", "[", "zsecopbasis", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SparseArray", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"i_", ",", "j_"}], "}"}], "/;", 
             RowBox[{
              RowBox[{
              "pvals", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}],
               "\[Equal]", 
              RowBox[{
              "pvals", "\[LeftDoubleBracket]", "j", 
               "\[RightDoubleBracket]"}]}]}], "\[Rule]", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"n", ",", "n"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
       ")"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630572929394086*^9, 3.630573091334279*^9}, {
   3.630577148193748*^9, 3.630577153814825*^9}, {3.630577687822699*^9, 
   3.630577727089981*^9}, {3.630578489257731*^9, 3.6305785042080507`*^9}, {
   3.631440092672268*^9, 3.6314401000528708`*^9}, {3.6314401371159*^9, 
   3.63144014170604*^9}, 3.631440174664318*^9}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4309347750764313`*^9, 3.430934777473254*^9}, {
  3.630569452949441*^9, 3.630569463371832*^9}, {3.630569640628294*^9, 
  3.6305696445546618`*^9}, {3.630569918003433*^9, 3.630569919177614*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "::", "invalspin"}], "=", 
   "\"\<One or more of the spins specified in Secularize is not a member of \
the current SpinSystem\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630569923109297*^9, 3.6305699772512074`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Secularize", "::", "sharedspins"}], "=", 
    "\"\<The spins `1` occur in two or more of the lists of spins used in \
Secularize. This is illegal.\>\""}], ";"}], " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630570365722898*^9, 3.630570419358684*^9}, {
  3.630571162884025*^9, 3.630571169077112*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "::", "nonnumH0mat"}], "=", 
   "\"\<The Hamiltonian used for secularization must have a numeric matrix \
representation.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630573988822723*^9, 3.630574028073731*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Secularize", "::", "nonhermH0"}], "=", 
   "\"\<The Hamiltonian used for secularization must be Hermitian.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.630574175881102*^9, 3.630574196914371*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["end", "Subsubtitle",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True],

Cell["\<\
End[];
EndPackage[];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.51238794480797*^9, 3.512387952205147*^9}, 
   3.513231730353488*^9},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["expand $RecursionLimit", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.513231739775526*^9, 3.513231743945022*^9}}],

Cell["$RecursionLimit=1000;", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.51238794480797*^9, 3.512387952205147*^9}, {
  3.513231730353488*^9, 3.513231750805922*^9}},
 AspectRatioFixed->True]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["history", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 CellChangeTimes->{
  3.682593334636269*^9, {3.69926171587668*^9, 3.69926172886936*^9}, {
   3.69926187929764*^9, 3.6992618809832497`*^9}},
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["170817 changes incorporated into v3.0.0b18 [CB]", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, {3.7119557293677454`*^9, 
   3.711955754991335*^9}}],

Cell[TextData[{
 "ThermalizeSuperoperator routine has been modified so it does not calculate ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[CapitalTheta]", 
    RowBox[{"-", "1"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "explicitly."
}], "Text",
 CellChangeTimes->{{3.6992793268113956`*^9, 3.699279350177552*^9}, {
  3.711955751162795*^9, 3.711955788480177*^9}}]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{831, 1021},
WindowMargins->{{Automatic, 339}, {Automatic, 4}},
ShowCellLabel->True,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 444, 9, 114, "Title",ExpressionUUID->"a4c2fb73-1266-479e-a3d9-6857c77f5f62",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1036, 35, 341, 8, 57, "Subsubtitle",ExpressionUUID->"4c091790-3b79-4b39-b737-995dba02af2b",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1380, 45, 328, 7, 58, "Text",ExpressionUUID->"17266953-6a87-4493-91c2-ca90e3543b4a",
 InitializationCell->True],
Cell[1711, 54, 1633, 30, 320, "Input",ExpressionUUID->"fe8a52fd-f077-4599-b5b8-cdb32ed1866e",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3381, 89, 278, 7, 41, "Subsubtitle",ExpressionUUID->"218e79c5-726a-45f4-a98b-7cc31ff676e8",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[3684, 100, 1098, 18, 36, "Section",ExpressionUUID->"2e60d649-3d52-4780-a198-13f6a4db497e",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[4807, 122, 1146, 19, 45, "Subsubsection",ExpressionUUID->"cba970d0-b06c-4ea1-a7d4-6cde0ffb03d8",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[5956, 143, 736, 20, 112, "Input",ExpressionUUID->"344a2aba-ac50-4af9-b1e5-5239d13699e9",
 InitializationCell->True],
Cell[6695, 165, 839, 21, 133, "Input",ExpressionUUID->"04994ef4-610c-47aa-9df2-badac38fa2bf",
 InitializationCell->True],
Cell[7537, 188, 1432, 35, 196, "Input",ExpressionUUID->"cd60504b-af1c-4ad7-bd2c-3ad8d7b19e2e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9006, 228, 1099, 18, 37, "Subsubsection",ExpressionUUID->"ef476140-6faa-4520-8777-c63686aa02df",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[10108, 248, 2271, 72, 217, "Input",ExpressionUUID->"51f0818c-ee3e-4f0f-9aba-46baa9dd36c4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[12416, 325, 1113, 18, 37, "Subsubsection",ExpressionUUID->"d86bed14-3b46-40d0-b7f3-527350f85260",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[13532, 345, 2323, 75, 180, "Input",ExpressionUUID->"665ff0a1-d007-425d-8f94-9be778f7fb65",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15904, 426, 1150, 19, 36, "Section",ExpressionUUID->"9962d3d7-65c3-4baa-b068-bb656ed547c7",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[17079, 449, 376, 8, 39, "Subsubsection",ExpressionUUID->"adf748ed-12fb-47e4-bec8-ccb0a423b82c",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[17458, 459, 4309, 135, 490, "Input",ExpressionUUID->"3f62f89a-3c02-468b-b204-f1184513bbe4",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[21828, 601, 187, 5, 41, "Subsubtitle",ExpressionUUID->"66dfe670-9c4f-4a3a-bb2d-52aa4a2270ba",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[22018, 608, 239, 5, 48, "Input",ExpressionUUID->"65067ebb-9044-4db1-8b58-75292c1d589d",
 InitializationCell->True],
Cell[22260, 615, 143, 4, 48, "Input",ExpressionUUID->"357eec7e-ae89-4c31-b1d4-891be95046e5",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[22440, 624, 666, 10, 41, "Subsubtitle",ExpressionUUID->"331abe72-8ecd-4e4c-9bec-b19cf5293fab",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[23131, 638, 205, 4, 36, "Section",ExpressionUUID->"7901a7db-ba0c-417a-8860-cbda5a9c04ae",
 InitializationCell->True],
Cell[23339, 644, 779, 17, 104, "Input",ExpressionUUID->"e036d167-d1b6-462b-8642-f7b427fd897a",
 InitializationCell->True],
Cell[24121, 663, 392, 12, 49, "Input",ExpressionUUID->"2f1bbf5f-d0fc-44f9-bd1c-79f10e5b4610",
 InitializationCell->True],
Cell[24516, 677, 670, 16, 123, "Input",ExpressionUUID->"cbe5ded9-6bc7-4312-9128-867e3acad979",
 InitializationCell->True],
Cell[25189, 695, 543, 14, 66, "Input",ExpressionUUID->"dd905fe6-42c5-4c37-9fea-159f295febc9",
 InitializationCell->True],
Cell[25735, 711, 994, 27, 90, "Input",ExpressionUUID->"cfcd36e5-a399-444e-9170-a51f1442bd1d",
 InitializationCell->True],
Cell[26732, 740, 6603, 148, 542, "Input",ExpressionUUID->"a1ffa300-eaaf-4704-9208-9bf43dbe287b",
 InitializationCell->True],
Cell[33338, 890, 340, 8, 46, "Input",ExpressionUUID->"8bce54f0-e01e-46dd-afbb-b902527f4df4",
 InitializationCell->True],
Cell[33681, 900, 382, 8, 85, "Input",ExpressionUUID->"2f9f6329-1a95-413d-9af5-bbabd70ed691",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[34100, 913, 313, 7, 36, "Section",ExpressionUUID->"603d5372-ae66-4c52-815a-5003192779d2",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[34438, 924, 233, 5, 54, "Subsection",ExpressionUUID->"5981bde3-ebaa-414e-9079-c93d99e44193",
 InitializationCell->True],
Cell[34674, 931, 14004, 416, 696, "Text",ExpressionUUID->"7eaf52c9-d1fb-41a0-8f43-4b0deb99b8e2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[48715, 1352, 181, 4, 38, "Subsection",ExpressionUUID->"a4b4671f-4e55-45e1-8f49-a66252eff3b3",
 InitializationCell->True],
Cell[48899, 1358, 350, 9, 35, "Text",ExpressionUUID->"7da3bad3-2caa-437d-a9ec-573fef5457b0",
 InitializationCell->True],
Cell[49252, 1369, 614, 15, 68, "Input",ExpressionUUID->"2c142acb-b502-44cc-9104-4a179d3a8801",
 InitializationCell->True],
Cell[49869, 1386, 462, 13, 46, "Input",ExpressionUUID->"223a46fb-0c14-4c59-b8c0-7e51c144c114",
 InitializationCell->True],
Cell[50334, 1401, 862, 20, 131, "Input",ExpressionUUID->"ee3e04cc-649b-4f24-a8d8-328483f2f511",
 InitializationCell->True],
Cell[51199, 1423, 648, 17, 68, "Input",ExpressionUUID->"4981e142-52ef-451a-b0d0-2cd842cfc480",
 InitializationCell->True],
Cell[51850, 1442, 1138, 31, 110, "Input",ExpressionUUID->"2efba258-7ff6-4023-91a0-3516b5c674c4",
 InitializationCell->True],
Cell[52991, 1475, 7092, 140, 488, "Input",ExpressionUUID->"3c62ca59-5cde-46fa-a712-711bf8d55585",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[60120, 1620, 174, 3, 43, "Subsection",ExpressionUUID->"42378b41-d58e-4fbf-8681-4e02c470f647",
 InitializationCell->True],
Cell[60297, 1625, 355, 8, 46, "Input",ExpressionUUID->"c080aa95-634a-4ea3-b3f9-323da0953639",
 InitializationCell->True]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[60713, 1640, 230, 4, 37, "Subsubtitle",ExpressionUUID->"133b4aaa-859b-4ea7-b8ce-f823bd6278b5",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[60968, 1648, 106, 3, 33, "Section",ExpressionUUID->"addcacd3-858c-42f0-9502-c2d037bedc3e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[61099, 1655, 117, 3, 35, "Subsubsection",ExpressionUUID->"d11f9fd6-bd91-4161-92ed-11740691eb1e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[61219, 1660, 440, 14, 48, "Input",ExpressionUUID->"daa680ae-ffef-4c91-b88a-d1d52fc54153",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[61708, 1680, 296, 6, 33, "Section",ExpressionUUID->"5533e2b7-e7de-4a74-9ee7-6f1175ed5f38",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[62029, 1690, 249, 5, 44, "Subsection",ExpressionUUID->"3d543262-45bb-4854-89a1-22c31f54b8e8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[62281, 1697, 685, 18, 70, "Input",ExpressionUUID->"8e7a8a58-1915-48a1-afeb-eec9eca1a51a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[63003, 1720, 520, 11, 61, "Subsection",ExpressionUUID->"b4baccbb-32c1-46f8-a95c-30af6008b0c2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[63548, 1735, 212, 3, 35, "Subsubsection",ExpressionUUID->"d34ee267-5ae2-4fa3-8a2a-e789cacdf965",
 InitializationCell->True],
Cell[63763, 1740, 444, 11, 48, "Input",ExpressionUUID->"6377c00b-d308-43e3-ba4b-e5365a2714a9",
 InitializationCell->True],
Cell[64210, 1753, 589, 16, 70, "Input",ExpressionUUID->"e7f147e3-d83f-4254-857b-e1f4b3386313",
 InitializationCell->True],
Cell[64802, 1771, 480, 14, 48, "Input",ExpressionUUID->"22f48bc1-7832-4f6e-8ea8-19dad4073365",
 InitializationCell->True],
Cell[65285, 1787, 1519, 38, 196, "Input",ExpressionUUID->"f2746890-fa47-4291-b717-948b241dbc01",
 InitializationCell->True],
Cell[66807, 1827, 1469, 37, 154, "Input",ExpressionUUID->"34b166f4-dc89-4f5a-affe-cc48b0d839f3",
 InitializationCell->True],
Cell[68279, 1866, 931, 25, 91, "Input",ExpressionUUID->"a9269603-d548-4acf-a56c-1dac07da2cad",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[69247, 1896, 317, 5, 35, "Subsubsection",ExpressionUUID->"d866a10c-0ea5-4367-a250-b19b279befbc",
 InitializationCell->True],
Cell[69567, 1903, 1263, 30, 196, "Input",ExpressionUUID->"f2c4ee35-f723-457d-b17a-f4bb4a9279d4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[70867, 1938, 288, 4, 35, "Subsubsection",ExpressionUUID->"76f65764-b041-46ad-9cb2-4d6b5f7a82b8",
 InitializationCell->True],
Cell[71158, 1944, 1684, 46, 175, "Input",ExpressionUUID->"bda181a1-3afd-49dd-b77b-7224378cb282",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[72891, 1996, 504, 8, 44, "Subsection",ExpressionUUID->"03a868d6-4eee-4df5-9bce-34554b75da4d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[73398, 2006, 439, 12, 48, "Input",ExpressionUUID->"e93b32bb-c868-4db9-8e9a-6241b4485d90",
 InitializationCell->True],
Cell[73840, 2020, 727, 19, 91, "Input",ExpressionUUID->"3be2683c-790c-4633-9ade-14c4881a0bff",
 InitializationCell->True],
Cell[74570, 2041, 793, 22, 112, "Input",ExpressionUUID->"f6c1085b-8112-4dfe-b793-e20ed227d329",
 InitializationCell->True],
Cell[75366, 2065, 957, 24, 112, "Input",ExpressionUUID->"3f00d6e9-a27b-4c64-9c26-b6bcbd523245",
 InitializationCell->True],
Cell[76326, 2091, 758, 19, 91, "Input",ExpressionUUID->"8d981467-8cf0-4ded-afd5-a0d64ee2c95b",
 InitializationCell->True],
Cell[77087, 2112, 303, 6, 49, "Text",ExpressionUUID->"38442d74-fe10-4e18-b702-c956761d9159",
 InitializationCell->True],
Cell[77393, 2120, 2600, 63, 322, "Input",ExpressionUUID->"eda9993a-7662-4e34-8d4d-49ed5da09777",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[80042, 2189, 298, 6, 33, "Section",ExpressionUUID->"f33b104a-f52a-425b-9a6a-af22b6a40fcd",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[80365, 2199, 212, 3, 35, "Subsubsection",ExpressionUUID->"12864037-93f4-4ea1-bc69-2fea2125261b",
 InitializationCell->True],
Cell[80580, 2204, 522, 12, 28, "Input",ExpressionUUID->"428f8383-216f-4ade-8cfd-72d5f466bef3",
 InitializationCell->True],
Cell[81105, 2218, 562, 16, 46, "Input",ExpressionUUID->"177f5cd5-53d3-493a-bfd6-6e03ad37ffff",
 InitializationCell->True],
Cell[81670, 2236, 1600, 39, 148, "Input",ExpressionUUID->"c03b26c5-3af3-474a-b257-c5fa4eaefa4b",
 InitializationCell->True],
Cell[83273, 2277, 1529, 38, 114, "Input",ExpressionUUID->"a362957a-d1d3-4d12-98cf-4f979a19436e",
 InitializationCell->True],
Cell[84805, 2317, 938, 25, 63, "Input",ExpressionUUID->"83db74bc-64d4-4dc6-b0c3-bf4105159863",
 InitializationCell->True],
Cell[85746, 2344, 601, 18, 46, "Input",ExpressionUUID->"5f2e8934-3359-47b7-90f2-47d498965071",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[86384, 2367, 572, 9, 29, "Subsubsection",ExpressionUUID->"db2f1a36-d130-4568-912c-cbf8e0815988",
 InitializationCell->True],
Cell[86959, 2378, 1318, 31, 183, "Input",ExpressionUUID->"7f11586a-dc3f-4421-829f-f6a9898656d4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[88314, 2414, 525, 7, 29, "Subsubsection",ExpressionUUID->"1f0f5799-b4fe-4d76-a17a-2540905298d2",
 InitializationCell->True],
Cell[88842, 2423, 1707, 36, 259, "Input",ExpressionUUID->"47768b7b-6d27-4a1b-b9f6-ce8f1cadf3f5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[90586, 2464, 351, 5, 35, "Subsubsection",ExpressionUUID->"387e4ba0-aec2-4a98-bac5-fcd866222d1a",
 InitializationCell->True],
Cell[90940, 2471, 2176, 56, 217, "Input",ExpressionUUID->"1bc9602e-bcc5-4fd5-80eb-e82df6d9c199",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[93165, 2533, 321, 6, 33, "Section",ExpressionUUID->"635b6955-182c-4532-a377-fb83914cc4c4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[93489, 2541, 307, 7, 91, "Input",ExpressionUUID->"0ba24e83-eebe-465f-9994-d0575de01be4",
 InitializationCell->True],
Cell[93799, 2550, 380, 9, 91, "Input",ExpressionUUID->"f7343ceb-8358-473d-b048-28a6c1b6e59f",
 InitializationCell->True],
Cell[94182, 2561, 299, 7, 91, "Input",ExpressionUUID->"5ebe3ea4-9fdb-4ab8-b316-e40fef7a6c80",
 InitializationCell->True],
Cell[94484, 2570, 274, 7, 48, "Input",ExpressionUUID->"d68ada81-f460-4b64-9d4f-337453bd9b3e",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[94807, 2583, 127, 4, 37, "Subsubtitle",ExpressionUUID->"2bd627e0-d13f-476a-8175-a36a06911523",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[94937, 2589, 241, 9, 66, "Input",ExpressionUUID->"509f59d7-086e-4176-bc2c-52b3c9f8f203",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[95203, 2602, 137, 2, 44, "Subsection",ExpressionUUID->"8324e6e5-a45d-4f5e-ab44-666af4d8408e",
 InitializationCell->True],
Cell[95343, 2606, 257, 6, 48, "Input",ExpressionUUID->"16261c2e-fb34-40ac-be57-f75319d075be",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[95661, 2619, 235, 6, 90, "Title",ExpressionUUID->"c8c6fa0f-f1e1-4ad7-93ba-44d1b53db78f",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[95921, 2629, 311, 4, 43, "Subsection",ExpressionUUID->"d5a2ce5a-8ab5-42fd-bd2e-968d676abc60"],
Cell[96235, 2635, 381, 10, 32, "Text",ExpressionUUID->"0d06ca71-66b1-434a-a505-35ce9aa4767e"]
}, Open  ]]
}, Open  ]]
}
]
*)

