(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1800944,      39898]
NotebookOptionsPosition[   1634656,      36570]
NotebookOutlinePosition[   1635329,      36594]
CellTagsIndexPosition[   1635286,      36591]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Simulations`Simulations`", "Title",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4526855795508213`*^9, 3.452685580972721*^9}, 
   3.682593370900442*^9, 3.682593438599123*^9, {3.682612802252809*^9, 
   3.682612802512134*^9}, 3.691678321227023*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"5e4a1278-e3ba-46d0-8447-3e4dc783ee47"],

Cell[CellGroupData[{

Cell["BeginPackage", "Chapter",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, 
   3.683109016913093*^9, {3.7135526301439686`*^9, 3.7135526309836345`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"b000a75b-363b-4f47-b8df-9c3061e578d7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<Simulations`Simulations`\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Global`\>\"", ",", "\[IndentingNewLine]", "\"\<SpinDynamica`\>\"", 
      ",", "\[IndentingNewLine]", "\"\<General`UserLevel`\>\"", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"\"\<General`ModifyBuiltIn`\>\"", ","}], "*)"}], 
      "\[IndentingNewLine]", "\"\<QM`Hilbert`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`SpinOperators`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<QM`Liouville`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<SD`Generators`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<SD`Approximations`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<SD`Propagation`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Events`Events`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Events`PulseSequence`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Interactions`Interactions`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Interactions`Hamiltonians`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Interactions`Relaxation`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Simulations`Polarization`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Signals`Signal`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<General`Matrices`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<General`Miscellaneous`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Rotations`Wigner`\>\"", ",", 
      "\[IndentingNewLine]", "\"\<Units`\>\"", ",", "\[IndentingNewLine]", 
      "\"\<General`PhysicalConstants`\>\""}], "}"}]}], "]"}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.682597248826211*^9, 3.682597294461053*^9}, {
   3.682597351454564*^9, 3.6825973593973713`*^9}, {3.682598408412565*^9, 
   3.682598414442441*^9}, 3.682611835156332*^9, {3.682612805087681*^9, 
   3.682612806848287*^9}, {3.6826135193470697`*^9, 3.682613519578733*^9}, 
   3.683108999154292*^9, {3.6831099847917843`*^9, 3.683109991194178*^9}, 
   3.683110338026148*^9, 3.683127201432787*^9, {3.683214854449751*^9, 
   3.683214861642379*^9}, {3.691678328194463*^9, 3.691678351175767*^9}, {
   3.691833229197735*^9, 3.691833235387183*^9}, {3.691833517358656*^9, 
   3.691833522890497*^9}, {3.69225582749205*^9, 3.692255829824971*^9}, {
   3.69225615947401*^9, 3.692256188085162*^9}, 3.701151279017712*^9, {
   3.745396448625269*^9, 3.745396452970998*^9}, {3.745396501867449*^9, 
   3.745396507770002*^9}},ExpressionUUID->"8818fe29-4224-42d7-b79f-\
8d82f42a4d3b"]
}, Closed]],

Cell[CellGroupData[{

Cell["exports", "Chapter",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.605545641519261*^9, 3.605546445799432*^9, 3.629385531775414*^9, {
   3.7136019175861187`*^9, 3.713601917681364*^9}, {3.7136028082279615`*^9, 
   3.7136028083633275`*^9}},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"3e5a7c9e-efee-4064-9d77-c13378b614db"],

Cell[CellGroupData[{

Cell["Trajectory, TrajectoryFunction", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, {3.456506289466201*^9, 3.456506295406816*^9}, {
   3.456508348653371*^9, 3.456508356052676*^9}, {3.4565084005859623`*^9, 
   3.4565084007536383`*^9}, {3.4565084369209948`*^9, 3.456508438583412*^9}, {
   3.456509275980582*^9, 3.456509283884789*^9}, 3.62115644410917*^9, 
   3.682613482715426*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"8d1251b0-f032-406d-a10f-e12dc7c79a67"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Trajectory", "::", "usage"}], "=", 
   "\"\<Trajectory[\[Rho]ini\[Rule]operator, events] generates a trajectory \
function for the expectation value of operator, when the initial density \
operator \[Rho]ini is propagated under the specified events.  Trajectory[\
\[Rho]ini\[Rule]{op1,op2..}, events] generates a set of trajectory functions \
for several different operators. \nThe option NormalizationFactor is used to \
control the vertical scale of the trajectories. If \
NormalizationFactor\[Rule]number, the trajectories are divided by number. If \
NormalizationFactor\[Rule]operator, the trajectories are divided by the \
normalized LiouvilleBracket of \[Rho]ini and the reference operator. This \
syntax is useful when handling thermal equilibrium density operators. \
NormalizationFactor\[Rule]False disables the normalization. The option \
EnsembleAverage may be used to average the trajectories over a set of values \
for any parameter. In this case, the option InterpolationPoints specifies the \
number of points used for interpolation when combining the ensemble \
trajectories.\nThe output of Trajectory is one or more TrajectoryFunction \
objects.\n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.452685645562502*^9, 3.45268596259144*^9}, {
   3.452686007045341*^9, 3.452686024085301*^9}, {3.45268620091995*^9, 
   3.452686229304071*^9}, {3.4526890536560707`*^9, 3.4526890683727083`*^9}, {
   3.45269039577855*^9, 3.4526904110664663`*^9}, {3.4527118279826117`*^9, 
   3.452712227130121*^9}, {3.452712277449806*^9, 3.452712280755077*^9}, {
   3.452712380593004*^9, 3.452712381700644*^9}, {3.452712440922771*^9, 
   3.452712454114936*^9}, {3.4527126208999443`*^9, 3.452712629385104*^9}, {
   3.452712715419836*^9, 3.452712759967291*^9}, {3.452712897486701*^9, 
   3.452712995788553*^9}, {3.452714346495099*^9, 3.452714552284289*^9}, {
   3.452791964028174*^9, 3.452792398306984*^9}, 3.4527924459630947`*^9, {
   3.452792644226605*^9, 3.4527926849281473`*^9}, {3.4527927209681797`*^9, 
   3.452792741061995*^9}, {3.452792783081061*^9, 3.45279281940061*^9}, {
   3.4527928670506573`*^9, 3.452792894220006*^9}, {3.45279292667695*^9, 
   3.452793088020947*^9}, {3.45279312594724*^9, 3.4527931360714693`*^9}, {
   3.454560061350251*^9, 3.4545602516118813`*^9}, {3.454571523067834*^9, 
   3.454571580274415*^9}, {3.454571615796256*^9, 3.454571731313817*^9}, {
   3.454571797247858*^9, 3.454571869797944*^9}, {3.454578908211237*^9, 
   3.454578924543745*^9}, {3.454587299797113*^9, 3.454587443427005*^9}, {
   3.455118364222556*^9, 3.45511865827855*^9}, {3.455118689418354*^9, 
   3.4551187064071817`*^9}, {3.4551187874827213`*^9, 
   3.4551188019210043`*^9}, {3.455258355837818*^9, 3.455258370966402*^9}, {
   3.455259238906035*^9, 3.4552593753760843`*^9}, 3.455268612922326*^9, {
   3.455346721466736*^9, 3.4553467219827414`*^9}, {3.455377365093207*^9, 
   3.455377376240534*^9}, {3.455631743707788*^9, 3.455631802467959*^9}, {
   3.4556354392890043`*^9, 3.455635443992669*^9}, {3.4565062997331142`*^9, 
   3.456506432305655*^9}, {3.456508442525239*^9, 3.4565086094059362`*^9}, {
   3.45654472052695*^9, 3.456544720871257*^9}, {3.462796042540196*^9, 
   3.462796064587679*^9}, {3.4973643370282793`*^9, 3.497364438327374*^9}, {
   3.5098917240299063`*^9, 3.509891741765029*^9}, {3.533083334846498*^9, 
   3.5330836492105017`*^9}, {3.5331014283025837`*^9, 3.533101648308227*^9}, {
   3.533101754608747*^9, 3.533101757424103*^9}, {3.533305826178133*^9, 
   3.533305964067937*^9}, {3.623342208997919*^9, 3.623342223006844*^9}, 
   3.682613193511573*^9, {3.682613232028916*^9, 3.6826132329972563`*^9}, {
   3.682613267132729*^9, 3.682613284922573*^9}},
 CellLabel->
  "In[1699]:=",ExpressionUUID->"7b9dbbf7-8267-4f62-9d53-6384c9b59a12"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TimePrecisionForPiecewiseInterpolation", "::", "usage"}], "=", 
   "\"\<A small time shift which is used to handle time discontinuities when \
evaluating Piecewise interpolation of trajectories\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5586061128595057`*^9, 3.558606149216752*^9}},
 CellLabel->
  "In[1700]:=",ExpressionUUID->"cdf2acb5-3e38-40c6-9d2a-6443d77b3f86"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TrajectoryFunction", "::", "usage"}], "=", 
   "\"\<TrajectoryFunction[timerange,trajectory] is a function which provides \
the value of an observable when evaluated at any time point within timerange. \
It is provided as the output of a Trajectory routine. A trajectory function \
trajfun may be plotted using syntax of the form \
Plot[trajfun[t],{t,tmin,tmax}]\n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.452685645562502*^9, 3.45268596259144*^9}, {
   3.452686007045341*^9, 3.452686024085301*^9}, {3.45268620091995*^9, 
   3.452686229304071*^9}, {3.4526890536560707`*^9, 3.4526890683727083`*^9}, {
   3.45269039577855*^9, 3.4526904110664663`*^9}, {3.4527118279826117`*^9, 
   3.452712227130121*^9}, {3.452712277449806*^9, 3.452712280755077*^9}, {
   3.452712380593004*^9, 3.452712381700644*^9}, {3.452712440922771*^9, 
   3.452712454114936*^9}, {3.4527126208999443`*^9, 3.452712629385104*^9}, {
   3.452712715419836*^9, 3.452712759967291*^9}, {3.452712897486701*^9, 
   3.452712995788553*^9}, {3.452714346495099*^9, 3.452714552284289*^9}, {
   3.452791964028174*^9, 3.452792398306984*^9}, 3.4527924459630947`*^9, {
   3.452792644226605*^9, 3.4527926849281473`*^9}, {3.4527927209681797`*^9, 
   3.452792741061995*^9}, {3.452792783081061*^9, 3.45279281940061*^9}, {
   3.4527928670506573`*^9, 3.452792894220006*^9}, {3.45279292667695*^9, 
   3.452793088020947*^9}, {3.45279312594724*^9, 3.4527931360714693`*^9}, {
   3.454560061350251*^9, 3.4545602516118813`*^9}, {3.454571523067834*^9, 
   3.454571580274415*^9}, {3.454571615796256*^9, 3.454571731313817*^9}, {
   3.454571797247858*^9, 3.454571869797944*^9}, {3.454578908211237*^9, 
   3.454578924543745*^9}, {3.454587299797113*^9, 3.454587443427005*^9}, {
   3.455118364222556*^9, 3.45511865827855*^9}, {3.455118689418354*^9, 
   3.4551187064071817`*^9}, {3.4551187874827213`*^9, 
   3.4551188019210043`*^9}, {3.455258355837818*^9, 3.455258370966402*^9}, {
   3.455259238906035*^9, 3.4552593753760843`*^9}, 3.455268612922326*^9, {
   3.455346721466736*^9, 3.4553467219827414`*^9}, {3.455377365093207*^9, 
   3.455377376240534*^9}, {3.455631743707788*^9, 3.455631802467959*^9}, {
   3.4556354392890043`*^9, 3.455635443992669*^9}, {3.4565062997331142`*^9, 
   3.456506432305655*^9}, {3.45650924655049*^9, 3.456509267284596*^9}, {
   3.6826133037639914`*^9, 3.682613349856641*^9}},
 CellLabel->
  "In[1701]:=",ExpressionUUID->"222025e4-1caf-4874-bbcd-89761313eb5f"]
}, Closed]],

Cell[CellGroupData[{

Cell["TransformationAmplitude, TransformationAmplitudeBounds", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, {3.456506289466201*^9, 3.456506295406816*^9}, {
   3.456508348653371*^9, 3.456508356052676*^9}, {3.4565084005859623`*^9, 
   3.4565084007536383`*^9}, {3.4565084369209948`*^9, 3.456508438583412*^9}, {
   3.456509275980582*^9, 3.456509283884789*^9}, {3.497529440552011*^9, 
   3.4975294445104427`*^9}, {3.505020062311255*^9, 3.505020066263239*^9}, {
   3.722473556521186*^9, 3.7224735602151537`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"603a34d1-9d34-4ca2-8cb7-c5f856050763"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "::", "usage"}], "=", 
   "\"\<TransformationAmplitude[\[Rho]ini\[Rule]obs,events] generates the \
amplitude for transformation of an initial density operator \[Rho]ini into an \
observable obs. TransformationAmplitude[\[Rho]ini\[Rule]{op1,op2..}, events] \
generates a list of transformation amplitudes. The option BackgroundGenerator \
specifies the background generator for the calculation. The option \
EnsembleAverage may be used to specify a weighted average over an arbitrary \
variable involved in the event specifications or in the option \
BackgroundGenerator. See the usage message for EnsembleAverage.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.452685645562502*^9, 3.45268596259144*^9}, {
   3.452686007045341*^9, 3.452686024085301*^9}, {3.45268620091995*^9, 
   3.452686229304071*^9}, {3.4526890536560707`*^9, 3.4526890683727083`*^9}, {
   3.45269039577855*^9, 3.4526904110664663`*^9}, {3.4527118279826117`*^9, 
   3.452712227130121*^9}, {3.452712277449806*^9, 3.452712280755077*^9}, {
   3.452712380593004*^9, 3.452712381700644*^9}, {3.452712440922771*^9, 
   3.452712454114936*^9}, {3.4527126208999443`*^9, 3.452712629385104*^9}, {
   3.452712715419836*^9, 3.452712759967291*^9}, {3.452712897486701*^9, 
   3.452712995788553*^9}, {3.452714346495099*^9, 3.452714552284289*^9}, {
   3.452791964028174*^9, 3.452792398306984*^9}, 3.4527924459630947`*^9, {
   3.452792644226605*^9, 3.4527926849281473`*^9}, {3.4527927209681797`*^9, 
   3.452792741061995*^9}, {3.452792783081061*^9, 3.45279281940061*^9}, {
   3.4527928670506573`*^9, 3.452792894220006*^9}, {3.45279292667695*^9, 
   3.452793088020947*^9}, {3.45279312594724*^9, 3.4527931360714693`*^9}, {
   3.454560061350251*^9, 3.4545602516118813`*^9}, {3.454571523067834*^9, 
   3.454571580274415*^9}, {3.454571615796256*^9, 3.454571731313817*^9}, {
   3.454571797247858*^9, 3.454571869797944*^9}, {3.454578908211237*^9, 
   3.454578924543745*^9}, {3.454587299797113*^9, 3.454587443427005*^9}, {
   3.455118364222556*^9, 3.45511865827855*^9}, {3.455118689418354*^9, 
   3.4551187064071817`*^9}, {3.4551187874827213`*^9, 
   3.4551188019210043`*^9}, {3.455258355837818*^9, 3.455258370966402*^9}, {
   3.455259238906035*^9, 3.4552593753760843`*^9}, 3.455268612922326*^9, {
   3.455346721466736*^9, 3.4553467219827414`*^9}, {3.455377365093207*^9, 
   3.455377376240534*^9}, {3.455631743707788*^9, 3.455631802467959*^9}, {
   3.4556354392890043`*^9, 3.455635443992669*^9}, {3.4565062997331142`*^9, 
   3.456506432305655*^9}, {3.456508442525239*^9, 3.4565086094059362`*^9}, {
   3.45654472052695*^9, 3.456544720871257*^9}, {3.462796042540196*^9, 
   3.462796064587679*^9}, {3.4973643370282793`*^9, 3.497364438327374*^9}, {
   3.497529448958867*^9, 3.497529576444746*^9}, {3.506759076076675*^9, 
   3.506759241758301*^9}, {3.509890897383914*^9, 3.50989091778014*^9}, {
   3.623342233103118*^9, 3.6233422424459333`*^9}, {3.709375487551264*^9, 
   3.709375489373148*^9}, {3.722473686222665*^9, 3.722473725087193*^9}},
 CellLabel->
  "In[1702]:=",ExpressionUUID->"d32a8115-27dc-469a-82df-15d0ab33b5e3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximumTransformationAmplitude", "::", "usage"}], " ", "=", " ", 
   "\"\<MaximumTransformationAmplitude has been superseded by \
TransformationAmplitudeBounds.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.722473566968852*^9, 3.722473649823444*^9}},
 CellLabel->
  "In[1703]:=",ExpressionUUID->"bf4068f2-5d89-4f76-bbdf-3a5663a6243d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeBounds", "::", "usage"}], "=", 
   "\"\<TransformationAmplitudeBounds[\[Rho]ini\[Rule]obs] generates the \
bounds {min,max} on the possible amplitude for transformation of an initial \
density operator \[Rho]ini into an observable obs. \
MaximumTransformationAmplitude[\[Rho]ini\[Rule]{op1,op2..}] generates a set \
of transformation amplitude bounds.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.452685645562502*^9, 3.45268596259144*^9}, {
   3.452686007045341*^9, 3.452686024085301*^9}, {3.45268620091995*^9, 
   3.452686229304071*^9}, {3.4526890536560707`*^9, 3.4526890683727083`*^9}, {
   3.45269039577855*^9, 3.4526904110664663`*^9}, {3.4527118279826117`*^9, 
   3.452712227130121*^9}, {3.452712277449806*^9, 3.452712280755077*^9}, {
   3.452712380593004*^9, 3.452712381700644*^9}, {3.452712440922771*^9, 
   3.452712454114936*^9}, {3.4527126208999443`*^9, 3.452712629385104*^9}, {
   3.452712715419836*^9, 3.452712759967291*^9}, {3.452712897486701*^9, 
   3.452712995788553*^9}, {3.452714346495099*^9, 3.452714552284289*^9}, {
   3.452791964028174*^9, 3.452792398306984*^9}, 3.4527924459630947`*^9, {
   3.452792644226605*^9, 3.4527926849281473`*^9}, {3.4527927209681797`*^9, 
   3.452792741061995*^9}, {3.452792783081061*^9, 3.45279281940061*^9}, {
   3.4527928670506573`*^9, 3.452792894220006*^9}, {3.45279292667695*^9, 
   3.452793088020947*^9}, {3.45279312594724*^9, 3.4527931360714693`*^9}, {
   3.454560061350251*^9, 3.4545602516118813`*^9}, {3.454571523067834*^9, 
   3.454571580274415*^9}, {3.454571615796256*^9, 3.454571731313817*^9}, {
   3.454571797247858*^9, 3.454571869797944*^9}, {3.454578908211237*^9, 
   3.454578924543745*^9}, {3.454587299797113*^9, 3.454587443427005*^9}, {
   3.455118364222556*^9, 3.45511865827855*^9}, {3.455118689418354*^9, 
   3.4551187064071817`*^9}, {3.4551187874827213`*^9, 
   3.4551188019210043`*^9}, {3.455258355837818*^9, 3.455258370966402*^9}, {
   3.455259238906035*^9, 3.4552593753760843`*^9}, 3.455268612922326*^9, {
   3.455346721466736*^9, 3.4553467219827414`*^9}, {3.455377365093207*^9, 
   3.455377376240534*^9}, {3.455631743707788*^9, 3.455631802467959*^9}, {
   3.4556354392890043`*^9, 3.455635443992669*^9}, {3.4565062997331142`*^9, 
   3.456506432305655*^9}, {3.456508442525239*^9, 3.4565086094059362`*^9}, {
   3.45654472052695*^9, 3.456544720871257*^9}, {3.462796042540196*^9, 
   3.462796064587679*^9}, {3.4973643370282793`*^9, 3.497364438327374*^9}, {
   3.497529448958867*^9, 3.497529576444746*^9}, {3.505019828268046*^9, 
   3.505019848219556*^9}, {3.505019882863441*^9, 3.505019883484459*^9}, {
   3.505020040069811*^9, 3.505020045324003*^9}, {3.5050211691718197`*^9, 
   3.505021181800922*^9}, {3.5098909265340757`*^9, 3.50989093541502*^9}, {
   3.529506793368496*^9, 3.5295068206320677`*^9}, {3.5295069519540653`*^9, 
   3.5295069600649242`*^9}, {3.623342243595001*^9, 3.6233422471426697`*^9}, {
   3.722473745419641*^9, 3.7224738149410067`*^9}, {3.722474316410596*^9, 
   3.722474316961344*^9}, {3.7225587415665407`*^9, 3.722558751259851*^9}},
 CellLabel->
  "In[1704]:=",ExpressionUUID->"264a82aa-c391-4c8c-baf8-611ec3cc2f91"]
}, Closed]],

Cell[CellGroupData[{

Cell["TransformationAmplitudeTable", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, {3.456506289466201*^9, 3.456506295406816*^9}, {
   3.456508348653371*^9, 3.456508356052676*^9}, {3.4565084005859623`*^9, 
   3.4565084007536383`*^9}, {3.4565084369209948`*^9, 3.456508438583412*^9}, {
   3.456509275980582*^9, 3.456509283884789*^9}, {3.497529440552011*^9, 
   3.4975294445104427`*^9}, {3.505020062311255*^9, 3.505020066263239*^9}, {
   3.5067592714096613`*^9, 3.50675927216*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"ed6250c0-dd24-4f47-aaee-a2be80ebae51"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "usage"}], "=", 
   "\"\<TransformationAmplitudeTable[\[Rho]ini\[Rule]obs,events,{p,pmin,pmax,\
dp},opts] generates a table of TransformationAmplitude values, varying the \
parameter p from pmin to pmax in steps of dp. The events or any of the option \
values may depend on p. The observable obs may be a list of operators, in \
which case several tables are calculated simultaneously. The syntax \
TransformationAmplitudeTable[\[Rho]ini\[Rule]obs,events,{p,pmin,pmax,{np}},\
opts] may also be used, indicating the number of values np sampled between \
pmin and pmax.\nThe option BackgroundGenerator specifies the background \
evolution generator for the calculation. This may also depend on p.\nThe \
option EnsembleAverage may be used to specify a weighted average over an \
arbitrary variable involved in the event specifications or in any of the \
option values, including BackgroundGenerator. See the usage message for \
EnsembleAverage.\nThe option TableCoordinates specifies the point coordinates \
which are included in the output table. TableCoordinates\[Rule]<expr(p)> \
implements x-coordinates which are given by <expr(p)>, where <expr(p)> is an \
expression that depends on p, and p is the incremented parameter.\nThe output \
of TransformationAmplitudeTable with a single incremented parameter may be \
plotted directly using the ListPlot routine of Mathematica. \n\
TransformationAmplitudeTable may also employ several iterators, using syntax \
of the form \
TransformationAmplitudeTable[\[Rho]ini\[Rule]obs,events,{p1,p1min,p1max,dp1},{\
p2,p2min,p2max,dp2}..,opts]. The coordinates may then be specified using \
TableCoordinates\[Rule]{<expr(p1)>,<expr(p2)>..}. The output of \
TransformationAmplitudeTable with two iterators may be plotted directly using \
the ListContourPlot and ListDensityPlot routines.\n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.452685645562502*^9, 3.45268596259144*^9}, {
   3.452686007045341*^9, 3.452686024085301*^9}, {3.45268620091995*^9, 
   3.452686229304071*^9}, {3.4526890536560707`*^9, 3.4526890683727083`*^9}, {
   3.45269039577855*^9, 3.4526904110664663`*^9}, {3.4527118279826117`*^9, 
   3.452712227130121*^9}, {3.452712277449806*^9, 3.452712280755077*^9}, {
   3.452712380593004*^9, 3.452712381700644*^9}, {3.452712440922771*^9, 
   3.452712454114936*^9}, {3.4527126208999443`*^9, 3.452712629385104*^9}, {
   3.452712715419836*^9, 3.452712759967291*^9}, {3.452712897486701*^9, 
   3.452712995788553*^9}, {3.452714346495099*^9, 3.452714552284289*^9}, {
   3.452791964028174*^9, 3.452792398306984*^9}, 3.4527924459630947`*^9, {
   3.452792644226605*^9, 3.4527926849281473`*^9}, {3.4527927209681797`*^9, 
   3.452792741061995*^9}, {3.452792783081061*^9, 3.45279281940061*^9}, {
   3.4527928670506573`*^9, 3.452792894220006*^9}, {3.45279292667695*^9, 
   3.452793088020947*^9}, {3.45279312594724*^9, 3.4527931360714693`*^9}, {
   3.454560061350251*^9, 3.4545602516118813`*^9}, {3.454571523067834*^9, 
   3.454571580274415*^9}, {3.454571615796256*^9, 3.454571731313817*^9}, {
   3.454571797247858*^9, 3.454571869797944*^9}, {3.454578908211237*^9, 
   3.454578924543745*^9}, {3.454587299797113*^9, 3.454587443427005*^9}, {
   3.455118364222556*^9, 3.45511865827855*^9}, {3.455118689418354*^9, 
   3.4551187064071817`*^9}, {3.4551187874827213`*^9, 
   3.4551188019210043`*^9}, {3.455258355837818*^9, 3.455258370966402*^9}, {
   3.455259238906035*^9, 3.4552593753760843`*^9}, 3.455268612922326*^9, {
   3.455346721466736*^9, 3.4553467219827414`*^9}, {3.455377365093207*^9, 
   3.455377376240534*^9}, {3.455631743707788*^9, 3.455631802467959*^9}, {
   3.4556354392890043`*^9, 3.455635443992669*^9}, {3.4565062997331142`*^9, 
   3.456506432305655*^9}, {3.456508442525239*^9, 3.4565086094059362`*^9}, {
   3.45654472052695*^9, 3.456544720871257*^9}, {3.462796042540196*^9, 
   3.462796064587679*^9}, {3.4973643370282793`*^9, 3.497364438327374*^9}, {
   3.497529448958867*^9, 3.497529576444746*^9}, {3.506759076076675*^9, 
   3.506759241758301*^9}, {3.506759275898944*^9, 3.506759440335146*^9}, {
   3.5067595084616127`*^9, 3.506759543118602*^9}, {3.506759600410699*^9, 
   3.5067598558941917`*^9}, 3.506759924676757*^9, {3.506759966451091*^9, 
   3.506759984467004*^9}, {3.50676049556107*^9, 3.506760553034739*^9}, {
   3.506760618245913*^9, 3.506760625923717*^9}, {3.506794515174374*^9, 
   3.5067945544153137`*^9}, {3.50685512718398*^9, 3.50685516909583*^9}, 
   3.506855204397396*^9, {3.5068552389943743`*^9, 3.5068552390167093`*^9}, {
   3.5068552960643587`*^9, 3.5068552970136633`*^9}, {3.5071262443641768`*^9, 
   3.5071263671139793`*^9}, {3.509891293319278*^9, 3.509891300273151*^9}, {
   3.50989136549286*^9, 3.509891422036111*^9}, {3.509891467728736*^9, 
   3.509891487672999*^9}, 3.53439833597149*^9, {3.615291658312726*^9, 
   3.615291695893518*^9}, {3.615291726520569*^9, 3.6152917438982563`*^9}, {
   3.709375490542859*^9, 3.709375491206705*^9}, {3.720232375271572*^9, 
   3.7202324370528517`*^9}, {3.721754984223358*^9, 3.721755068648058*^9}, {
   3.721887859708981*^9, 3.7218878608967237`*^9}, {3.7218879457479267`*^9, 
   3.7218881475689697`*^9}, {3.72188821703861*^9, 3.721888222407333*^9}, {
   3.7218888055335484`*^9, 3.7218891081691303`*^9}, {3.722474187868596*^9, 
   3.722474194181658*^9}, {3.72247425218154*^9, 3.7224742750766563`*^9}},
 CellLabel->
  "In[1705]:=",ExpressionUUID->"ed59407f-2898-4147-be34-3cec13b7511b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TableCoordinates", "::", "usage"}], "=", 
    "\"\<TableCoordinates is an option for TransformationAmplitudeTable and \
specifies the coordinates of the output are calculated for each point in the \
table. The value of TableCoordinates may be a function of the iterators for \
TransformationAmplitudeTable.\>\""}], ";"}], " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506759867602029*^9, 3.50675991158648*^9}, {
   3.506760004057835*^9, 3.5067600735564833`*^9}, {3.506760606851493*^9, 
   3.50676060714981*^9}, 3.506767086354364*^9, {3.506855239048687*^9, 
   3.506855239113619*^9}, {3.509891325665125*^9, 3.5098913502479773`*^9}, {
   3.509891427081077*^9, 3.509891445766361*^9}, {3.615291752361157*^9, 
   3.615291754130143*^9}, {3.721888233977294*^9, 3.721888237781934*^9}, {
   3.72247428361299*^9, 3.722474284068129*^9}},
 CellLabel->
  "In[1706]:=",ExpressionUUID->"296219b8-4fb6-4ed7-895f-6d6c3dbbcd7d"]
}, Closed]],

Cell[CellGroupData[{

Cell["MaximizeTransformationAmplitude", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, {3.456506289466201*^9, 3.456506295406816*^9}, {
   3.456508348653371*^9, 3.456508356052676*^9}, {3.4565084005859623`*^9, 
   3.4565084007536383`*^9}, {3.4565084369209948`*^9, 3.456508438583412*^9}, {
   3.456509275980582*^9, 3.456509283884789*^9}, {3.497529440552011*^9, 
   3.4975294445104427`*^9}, {3.505020062311255*^9, 3.505020066263239*^9}, {
   3.5067592714096613`*^9, 3.50675927216*^9}, {3.744197951078443*^9, 
   3.7441979548276997`*^9}},
 AspectRatioFixed->True,
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"5e412516-8bd0-4a34-b909-578df9024b26"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "::", "usage"}], "=", 
   "\"\<\!\(\*StyleBox[\"MaximizeTransformationAmplitude\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"[\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
\[Rho]ini\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\[Rule]\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"obs\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\"\
,FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"events\",FontSlant->\"Italic\"]\)\!\
\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"{\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p1\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"p1ini\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"{\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p2\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p2ini\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"..\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"opts\",FontSlant->\"Italic\"]\)\!\
\(\*StyleBox[\"]\",FontSlant->\"Italic\"]\) numerically optimizes a \
\!\(\*StyleBox[\"TransformationAmplitude\",FontSlant->\"Italic\"]\) quantity \
with respect to parameters \
\!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p1\",FontSlant->\
\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p2\
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"..\",FontSlant->\"Italic\"]\)\!\(\
\*StyleBox[\"}\",FontSlant->\"Italic\"]\), starting from initial parameter \
values \!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p1ini\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"p2ini\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"..\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"Italic\"]\). \nThe option rules \
\!\(\*StyleBox[\"opts\",FontSlant->\"Italic\"]\) may include \
\!\(\*StyleBox[\"BackgroundGenerator\",FontSlant->\"Italic\"]\) and any of \
the other usual option specifications for \
\!\(\*StyleBox[\"TransformationAmplitude\",FontSlant->\"Italic\"]\). The \
values specified in \!\(\*StyleBox[\"opts\",FontSlant->\"Italic\"]\) may \
depend on the parameters \
\!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p1\",FontSlant->\
\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p2\
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"..\",FontSlant->\"Italic\"]\)\!\(\
\*StyleBox[\"}\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\".\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"\\\\n\",FontSlant->\"Italic\"]\)The option rules \
\!\(\*StyleBox[\"opts\",FontSlant->\"Italic\"]\) may include the directive \!\
\(\*StyleBox[\"ConstrainPositive\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
\[Rule]\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"True\",FontSlant->\"Italic\
\"]\) which constrains all parameters \
\!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p1\",FontSlant->\
\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p2\
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"..\",FontSlant->\"Italic\"]\)\!\(\
\*StyleBox[\"}\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Italic\"]\)to positive values. The syntax \
\!\(\*StyleBox[\"ConstrainPositive\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
\[Rule]\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\
\)\!\(\*StyleBox[\"p1\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p2\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"..\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\" \",FontSlant->\"Italic\"]\)may be used to \
constrain only a subset of parameters to positive values. This is frequently \
required for pulse sequence delays, etc., which cannot take negative values. \
\nMore general constraints may be implemented by using \
\!\(\*StyleBox[\"MaximizeTransformationAmplitude\",FontSlant->\"Italic\"]\)\!\
\(\*StyleBox[\"[\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\[Rho]ini\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\[Rule]\",FontSlant->\"Italic\"]\)\!\
\(\*StyleBox[\"obs\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\
\"Italic\"]\)\!\(\*StyleBox[\"events\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\
\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\
\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p1\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
p1ini\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\
\!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p1min\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"p1max\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"..\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"opts\",FontSlant->\"Italic\"]\)\!\
\(\*StyleBox[\"]\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Italic\"]\)subjects the parameter \
\!\(\*StyleBox[\"p1\",FontSlant->\"Italic\"]\) to the constraint \
\!\(\*StyleBox[\"p1min\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
\[NonBreakingSpace]\",FontSize->4,FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
\[LessEqual]\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\[NonBreakingSpace]\",\
FontSize->4,FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p1\",FontSlant->\"Italic\
\"]\)\!\(\*StyleBox[\"\[NonBreakingSpace]\",FontSize->4,FontSlant->\"Italic\"]\
\)\!\(\*StyleBox[\"\[LessEqual]\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
\[NonBreakingSpace]\",FontSize->4,FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
p1max\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\".\",FontSlant->\"Italic\"]\)\
\!\(\*StyleBox[\" \",FontSlant->\"Italic\"]\)If the maximum value \
\!\(\*StyleBox[\"p1max\",FontSlant->\"Italic\"]\) is omitted, there is no \
upper constraint. Any of the parameters \
\!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p1\",FontSlant->\
\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p2\
\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"..\",FontSlant->\"Italic\"]\)\!\(\
\*StyleBox[\"}\",FontSlant->\"Italic\"]\) may be constrained in this way.\!\(\
\*StyleBox[\" \",FontSlant->\"Italic\"]\) \nConstrained optimization is often \
computationally more intensive than unconstrained optimization.\n\
\!\(\*StyleBox[\"MaximizeTransformationAmplitude\",FontSlant->\"Italic\"]\) \
deploys the \!\(\*StyleBox[\"Mathematica\",FontSlant->\"Italic\"]\) routine \
\!\(\*StyleBox[\"FindMinimum\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Italic\"]\)to find a local minimum of the negative \
transformation amplitude, starting from a specified point. The rules \
specified in \!\(\*StyleBox[\"opts\",FontSlant->\"Italic\"]\) may include \
specifications for \!\(\*StyleBox[\"FindMinimum\",FontSlant->\"Italic\"]\), \
including a value for the \!\(\*StyleBox[\"Method\",FontSlant->\"Italic\"]\) \
option (see the documentation for \
\!\(\*StyleBox[\"FindMinimum\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\")\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\".\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"\\\\n\",FontSlant->\"Italic\"]\)The output of \
\!\(\*StyleBox[\"MaximizeTransformationAmplitude\",FontSlant->\"Italic\"]\) \
has the form \
\!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"maxval\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"rules\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"\
Italic\"]\) where \!\(\*StyleBox[\"maxval\",FontSlant->\"Italic\"]\) is the \
optimized value of the \!\(\*StyleBox[\"TransformationAmplitude\",FontSlant->\
\"Italic\"]\) and \!\(\*StyleBox[\"rules\",FontSlant->\"Italic\"]\) specify \
the values of the optimized parameters. \>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.452685645562502*^9, 3.45268596259144*^9}, {
   3.452686007045341*^9, 3.452686024085301*^9}, {3.45268620091995*^9, 
   3.452686229304071*^9}, {3.4526890536560707`*^9, 3.4526890683727083`*^9}, {
   3.45269039577855*^9, 3.4526904110664663`*^9}, {3.4527118279826117`*^9, 
   3.452712227130121*^9}, {3.452712277449806*^9, 3.452712280755077*^9}, {
   3.452712380593004*^9, 3.452712381700644*^9}, {3.452712440922771*^9, 
   3.452712454114936*^9}, {3.4527126208999443`*^9, 3.452712629385104*^9}, {
   3.452712715419836*^9, 3.452712759967291*^9}, {3.452712897486701*^9, 
   3.452712995788553*^9}, {3.452714346495099*^9, 3.452714552284289*^9}, {
   3.452791964028174*^9, 3.452792398306984*^9}, 3.4527924459630947`*^9, {
   3.452792644226605*^9, 3.4527926849281473`*^9}, {3.4527927209681797`*^9, 
   3.452792741061995*^9}, {3.452792783081061*^9, 3.45279281940061*^9}, {
   3.4527928670506573`*^9, 3.452792894220006*^9}, {3.45279292667695*^9, 
   3.452793088020947*^9}, {3.45279312594724*^9, 3.4527931360714693`*^9}, {
   3.454560061350251*^9, 3.4545602516118813`*^9}, {3.454571523067834*^9, 
   3.454571580274415*^9}, {3.454571615796256*^9, 3.454571731313817*^9}, {
   3.454571797247858*^9, 3.454571869797944*^9}, {3.454578908211237*^9, 
   3.454578924543745*^9}, {3.454587299797113*^9, 3.454587443427005*^9}, {
   3.455118364222556*^9, 3.45511865827855*^9}, {3.455118689418354*^9, 
   3.4551187064071817`*^9}, {3.4551187874827213`*^9, 
   3.4551188019210043`*^9}, {3.455258355837818*^9, 3.455258370966402*^9}, {
   3.455259238906035*^9, 3.4552593753760843`*^9}, 3.455268612922326*^9, {
   3.455346721466736*^9, 3.4553467219827414`*^9}, {3.455377365093207*^9, 
   3.455377376240534*^9}, {3.455631743707788*^9, 3.455631802467959*^9}, {
   3.4556354392890043`*^9, 3.455635443992669*^9}, {3.4565062997331142`*^9, 
   3.456506432305655*^9}, {3.456508442525239*^9, 3.4565086094059362`*^9}, {
   3.45654472052695*^9, 3.456544720871257*^9}, {3.462796042540196*^9, 
   3.462796064587679*^9}, {3.4973643370282793`*^9, 3.497364438327374*^9}, {
   3.497529448958867*^9, 3.497529576444746*^9}, {3.506759076076675*^9, 
   3.506759241758301*^9}, {3.506759275898944*^9, 3.506759440335146*^9}, {
   3.5067595084616127`*^9, 3.506759543118602*^9}, {3.506759600410699*^9, 
   3.5067598558941917`*^9}, 3.506759924676757*^9, {3.506759966451091*^9, 
   3.506759984467004*^9}, {3.50676049556107*^9, 3.506760553034739*^9}, {
   3.506760618245913*^9, 3.506760625923717*^9}, {3.506794515174374*^9, 
   3.5067945544153137`*^9}, {3.50685512718398*^9, 3.50685516909583*^9}, 
   3.506855204397396*^9, {3.5068552389943743`*^9, 3.5068552390167093`*^9}, {
   3.5068552960643587`*^9, 3.5068552970136633`*^9}, {3.5071262443641768`*^9, 
   3.5071263671139793`*^9}, {3.509891293319278*^9, 3.509891300273151*^9}, {
   3.50989136549286*^9, 3.509891422036111*^9}, {3.509891467728736*^9, 
   3.509891487672999*^9}, 3.53439833597149*^9, {3.615291658312726*^9, 
   3.615291695893518*^9}, {3.615291726520569*^9, 3.6152917438982563`*^9}, {
   3.709375490542859*^9, 3.709375491206705*^9}, {3.720232375271572*^9, 
   3.7202324370528517`*^9}, {3.721754984223358*^9, 3.721755068648058*^9}, {
   3.721887859708981*^9, 3.7218878608967237`*^9}, {3.7218879457479267`*^9, 
   3.7218881475689697`*^9}, {3.72188821703861*^9, 3.721888222407333*^9}, {
   3.7218888055335484`*^9, 3.7218891081691303`*^9}, {3.722474187868596*^9, 
   3.722474194181658*^9}, {3.72247425218154*^9, 3.7224742750766563`*^9}, {
   3.7441979728061857`*^9, 3.7441982071846743`*^9}, {3.744198243586884*^9, 
   3.744198420168029*^9}, {3.744198459636565*^9, 3.744198683885248*^9}, {
   3.74420011374732*^9, 3.744200181838018*^9}, {3.7442004800958548`*^9, 
   3.744200504089458*^9}, {3.7442681571501627`*^9, 3.744268349713698*^9}, 
   3.7442683804631977`*^9, {3.744268417130619*^9, 3.7442685922943277`*^9}, {
   3.744277249536759*^9, 3.744277487927601*^9}, {3.744277596262108*^9, 
   3.744277624129046*^9}},ExpressionUUID->"4d4bc8ef-9d77-4a92-b2e9-\
7d483c5224bd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ConstrainPositive", "::", "usage"}], "=", 
   "\"\<\!\(\*StyleBox[\"ConstrainPositive\",FontSlant->\"Italic\"]\) is an \
option for \
\!\(\*StyleBox[\"MaximizeTransformationAmplitude\",FontSlant->\"Italic\"]\). \
If \!\(\*StyleBox[\"ConstrainPositive\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"\[Rule]\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"True\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Plain\"]\)\!\(\*StyleBox[\"or\",FontSlant->\"Plain\"]\)\!\(\*\
StyleBox[\" \
\",FontSlant->\"Plain\"]\)\!\(\*StyleBox[\"ConstrainPositive\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\"\[Rule]\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\
\"All\",FontSlant->\"Italic\"]\), all variable parameters of \
\!\(\*StyleBox[\" \
\",FontSlant->\"Plain\"]\)\!\(\*StyleBox[\"MaximizeTransformationAmplitude\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Plain\"]\)\!\(\*StyleBox[\"are\",FontSlant->\"Plain\"]\)\!\(\*\
StyleBox[\" \
\",FontSlant->\"Plain\"]\)\!\(\*StyleBox[\"constrained\",FontSlant->\"Plain\"]\
\)\!\(\*StyleBox[\" \
\",FontSlant->\"Plain\"]\)\!\(\*StyleBox[\"to\",FontSlant->\"Plain\"]\)\!\(\*\
StyleBox[\" \",FontSlant->\"Plain\"]\)\!\(\*StyleBox[\"positive\",FontSlant->\
\"Plain\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Plain\"]\)\!\(\*StyleBox[\"values\",FontSlant->\"Plain\"]\)\!\
\(\*StyleBox[\".\",FontSlant->\"Plain\"]\)\!\(\*StyleBox[\" \
\",FontSlant->\"Plain\"]\)This is frequently required for pulse sequence \
delays, etc., which cannot take negative values. The syntax \
\!\(\*StyleBox[\"ConstrainPositive\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"\
\[Rule]\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"{\",FontSlant->\"Italic\"]\
\)\!\(\*StyleBox[\"p1\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\",\",\
FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"p2\",FontSlant->\"Italic\"]\)\!\(\*\
StyleBox[\"..\",FontSlant->\"Italic\"]\)\!\(\*StyleBox[\"}\",FontSlant->\"\
Italic\"]\)\!\(\*StyleBox[\" \",FontSlant->\"Italic\"]\)may be used to \
constrain only a subset of parameters to positive values.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7442775033600273`*^9, 3.744277590832155*^9}, {
  3.744277631926694*^9, 
  3.744277684721187*^9}},ExpressionUUID->"68d3f213-08c3-493c-b2ed-\
271322d31942"]
}, Closed]],

Cell[CellGroupData[{

Cell["Signal1D and options", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, {3.456506289466201*^9, 3.456506295406816*^9}, {
   3.456508348653371*^9, 3.456508356052676*^9}, {3.4565084005859623`*^9, 
   3.4565084007536383`*^9}, {3.4565084369209948`*^9, 3.456508438583412*^9}, {
   3.456509275980582*^9, 3.456509283884789*^9}, {3.461320168884572*^9, 
   3.461320185715005*^9}, {3.469876606308988*^9, 3.469876610499407*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"55fc7164-9445-4ec7-aae1-2dcd84238999"],

Cell[CellGroupData[{

Cell["Signal1D", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.62938461083008*^9},ExpressionUUID->"5677fffe-1f6e-448a-85a0-4b219fee311d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "usage"}], "=", 
   "\"\<Signal1D[timing, options] simulates a 1D magnetic resonance signal. \
The parameter timing specifies the digitization of the sampled signal. There \
are several possible syntaxes for timing: (1) If timing has the form \
{tmin,tmax,\[Delta]t}, then the signal is sampled between time points tmin \
and tmax, with increments (dwell time) \[Delta]t. If tmin is omitted, the \
value 0 is used. (2) The parameter timing may also have the syntax \
{tmin,tmax,{nsample}}, where nsample is the number of sampling points in the \
interval [tmin,tmax]. The number of sampling points nsample may be an even \
integer or may  be specified using strings \\\"1k\\\", \\\"2k\\\" etc. If \
tmin is omitted, the value 0 is used. (3) timing may have the syntax {tmin,{\
\[Omega]SW,nsample}}, where \[Omega]SW is the spectral bandwidth in rad\
\[NonBreakingSpace]\!\(\*SuperscriptBox[\(s\), \(-1\)]\). The number of \
sampling points nsample may be an even integer, or may be specified using \
strings \\\"1k\\\", \\\"2k\\\" etc. If tmin is omitted, the value 0 is used. \
In practice, the timing syntax {{\[Omega]SW,nsample}} is often the most \
convenient.\nSignal1D[timing, evgen, options] applies an evolution generator \
evgen throughout the signal evolution, where evgen is an operator or a \
superoperator, or a time-dependent function of an operator or a \
superoperator. If evgen is absent, the default None is used, in which case \
the option BackgroundGenerator may be used to specify the Hamiltonian or \
Liouvillian under which the signal evolves.  \n\tSignal1D[timing, events, \
options] performs the specified list of events while the signal is detected \
(padding out the remaining acquisition time with None). The events argument \
may have the form Repeat[events,n] in which case a repetition of the events \
is performed at the beginning of the acquisition interval. The syntax \
Repeat[events] fills the entire signal acquisition interval with the \
appropriate number of repetitions. \nThe available options include \
InitialDensityOperator, Observable, Preparation, BackgroundGenerator, \
NormalizationFactor, SignalCalculationMethod, MatchSamplingToPeriod, \
ReportSignalCalculationMethod, LineBroadening, EnsembleAverage, \
CarouselAverage, DigitalFrequencyResolution, ZeroFill, and \
ForceEvenNumberOfPoints. The option BackgroundGenerator may be of the form \
{prepbackg,detbackg} (in case of default \\\"LeftToRight\\\" chronology), \
indicating different values of BackgroundGenerator during the Preparation \
sequence and the signal detection. \>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.461322189599052*^9, 3.461322301335417*^9}, {
   3.461322383937756*^9, 3.4613223861361113`*^9}, {3.469876621589324*^9, 
   3.469876841350842*^9}, {3.469876927853476*^9, 3.469876935458284*^9}, {
   3.46987721264432*^9, 3.469877215899377*^9}, {3.469877250487714*^9, 
   3.469877256710096*^9}, {3.4698782308332872`*^9, 3.4698782613619223`*^9}, {
   3.469882345432494*^9, 3.4698823745454483`*^9}, {3.469882438350027*^9, 
   3.46988244095815*^9}, {3.46989465566475*^9, 3.469894663306656*^9}, 
   3.469895612226006*^9, {3.469896417369451*^9, 3.469896453391149*^9}, {
   3.469961800659601*^9, 3.469961906544622*^9}, {3.469967287920261*^9, 
   3.46996729958292*^9}, {3.469967371773782*^9, 3.469967531870295*^9}, {
   3.469967563274653*^9, 3.469967603578313*^9}, {3.470139118103303*^9, 
   3.470139123547707*^9}, {3.4701393290290117`*^9, 3.4701393297226152`*^9}, {
   3.470842564500786*^9, 3.470842569049342*^9}, {3.497364014541912*^9, 
   3.497364017999982*^9}, 3.497572355084609*^9, {3.499325921225973*^9, 
   3.499326060256521*^9}, {3.499658486531308*^9, 3.499658500960567*^9}, {
   3.500257205088316*^9, 3.500257322727289*^9}, {3.5002573725858307`*^9, 
   3.5002575391517553`*^9}, {3.50025761827977*^9, 3.500257701981772*^9}, 
   3.500257750453519*^9, {3.505726875092043*^9, 3.5057269479330378`*^9}, {
   3.505889522513678*^9, 3.505889538528777*^9}, 3.544622217620997*^9, {
   3.590220286329699*^9, 3.590220398751937*^9}, {3.590220460123917*^9, 
   3.5902204732903347`*^9}, {3.6269451890068607`*^9, 3.626945267107547*^9}, {
   3.626960103256062*^9, 3.626960153892613*^9}, {3.629384002103195*^9, 
   3.6293843169565687`*^9}, {3.629384353154498*^9, 3.629384468152547*^9}, {
   3.629384591592429*^9, 3.629384593829466*^9}, {3.682580001435072*^9, 
   3.6825800514897757`*^9}, {3.682580124402523*^9, 3.682580289742428*^9}, {
   3.682580340146474*^9, 3.682580467891767*^9}, {3.68258050734831*^9, 
   3.682580597555071*^9}, 3.682580641280854*^9, {3.684946895147665*^9, 
   3.684946895154255*^9}, {3.69284855297287*^9, 3.6928485538323393`*^9}, {
   3.709375493291877*^9, 3.7093754959353933`*^9}, 3.713696160990213*^9},
 CellLabel->
  "In[1708]:=",ExpressionUUID->"0a341e1b-05d9-41a8-90ea-5aa0e88a11bc"]
}, Closed]],

Cell[CellGroupData[{

Cell["SignalCalculationMethod", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.6293846188200703`*^9},ExpressionUUID->"66935e0a-6249-4019-8b51-\
4d5cff5ff9a7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SignalCalculationMethod", "::", "usage"}], "=", 
   "\"\<SignalCalculationMethod is an option for Signal1D. The default is \
SignalCalculationMethod\[Rule]Automatic, in which case the most appropriate \
method is chosen automatically. The currently available choices are:\n\n\
SignalCalculationMethod\[Rule]\\\"Direct\\\", which uses an explicit \
calculation of the spin evolution during the acquisition interval. Although \
the direct method is fully general, it is usually not the most efficient \
method for time-independent or periodic problems. \n\nSignalCalculationMethod\
\[Rule]\\\"Diagonalization\\\", which diagonalizes a time-independent \
Liouvillian or Hamiltonian. This is only appropriate for time-independent \
evolution generators.\n\nSignalCalculationMethod\[Rule]\\\"COMPUTE\\\" which \
assumes a periodic time-dependent Liouvillian or Hamiltonian.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4701391409814253`*^9, 3.4701393096101723`*^9}, {
   3.470654157533765*^9, 3.470654292400275*^9}, {3.4706543454964237`*^9, 
   3.4706543718474693`*^9}, 3.4993747484266376`*^9, {3.5002577197044287`*^9, 
   3.5002577351190042`*^9}, {3.5902204921821833`*^9, 3.590220503641452*^9}, {
   3.629384485032661*^9, 3.629384515870825*^9}},
 CellLabel->
  "In[1709]:=",ExpressionUUID->"b429a310-eeda-4eec-9597-4451d81a15c3"]
}, Closed]],

Cell[CellGroupData[{

Cell["ReportSignalCalculationMethod", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.6293846188200703`*^9, 
  3.6293846319784927`*^9}},ExpressionUUID->"dacfcf00-56db-41d3-9e76-\
4824fd09e2f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ReportSignalCalculationMethod", "::", "usage"}], "=", 
   "\[IndentingNewLine]", 
   "\"\<ReportSignalCalculationMethod is an option for Signal1D. If True, the \
chosen SignalCalculationMethod is reported.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.499658524434168*^9, 3.499658572008519*^9}},
 CellLabel->
  "In[1710]:=",ExpressionUUID->"0b902bae-142e-4488-87bf-8babd1a30365"]
}, Closed]],

Cell[CellGroupData[{

Cell["MatchSamplingToPeriod", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.629384641320005*^9},ExpressionUUID->"d2bae161-2678-4d17-a4df-\
24c5a85ae35a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MatchSamplingToPeriod", "::", "usage"}], "=", 
   "\"\<MatchSamplingToPeriod is an option for Signal1D. If set to True \
(default), and the events during signal detection are periodic, Signal1D will \
adjust the sampling interval to match the next highest even subdivisor of the \
period.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.470654305519123*^9, 3.470654326509406*^9}, {
  3.4706543788591137`*^9, 3.47065442129324*^9}, {3.470654451702224*^9, 
  3.470654454953371*^9}, {3.470810618690041*^9, 3.470810819573533*^9}, {
  3.470830364169375*^9, 3.470830378985155*^9}, {3.6293846606336412`*^9, 
  3.6293847069601507`*^9}},
 CellLabel->
  "In[1711]:=",ExpressionUUID->"47990f77-77c4-4acb-9c36-61d6fd617292"]
}, Closed]],

Cell[CellGroupData[{

Cell["InitialDensityOperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{3.629384641320005*^9, 
  3.6293847218083887`*^9},ExpressionUUID->"037dcca6-c9d0-4e0c-84f8-\
bba2da66f27a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InitialDensityOperator", "::", "usage"}], "=", 
   "\"\<InitialDensityOperator is an option for Signal1D, indicating the \
initial density operator upon which the Preparation is applied, before data \
acquisition. The default is opI[\\\"z\\\"].\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469877991470448*^9, 3.46987801563752*^9}, {
   3.469894712100382*^9, 3.469894736825623*^9}, 3.4698956029597282`*^9, {
   3.469896311104533*^9, 3.4698963196126747`*^9}, {3.4699676661526833`*^9, 
   3.4699676943527737`*^9}, {3.469967747316628*^9, 3.4699677597234898`*^9}, {
   3.629384732616497*^9, 3.6293847404999657`*^9}},
 CellLabel->
  "In[1712]:=",ExpressionUUID->"b9f42749-05be-4d08-bef3-b50edd49a07d"]
}, Closed]],

Cell[CellGroupData[{

Cell["Preparation", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{3.629384641320005*^9, 3.6293847218083887`*^9, 
  3.629384751905472*^9},ExpressionUUID->"a419f03e-a450-41ec-83ab-\
dff0b28abfa4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Preparation", "::", "usage"}], "=", 
   "\"\<Preparation is an option for Signal1D, defining the set of events \
applied to the initial density operator before signal acquisition. The \
default is RotationSuperoperator[{\[Pi]/2,\\\"x\\\"}], corresponding to a \
strong non-selective 90\[Degree] pulse with phase 0.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469877991470448*^9, 3.46987801563752*^9}, {
  3.46989467279669*^9, 3.469894700225692*^9}, {3.469895601753048*^9, 
  3.469895613399057*^9}, {3.469895663995325*^9, 3.4698956711819468`*^9}, {
  3.469967639104101*^9, 3.469967663855196*^9}, {3.4699677968499517`*^9, 
  3.4699678053904333`*^9}, {3.6293847621491947`*^9, 3.629384805712762*^9}},
 CellLabel->
  "In[1713]:=",ExpressionUUID->"6095f033-135d-4707-8ffa-9c57dbaac0d0"]
}, Closed]],

Cell[CellGroupData[{

Cell["Observable", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{3.629384641320005*^9, 3.6293847218083887`*^9, 
  3.629384751905472*^9, 
  3.629384821495875*^9},ExpressionUUID->"039b1b50-d963-48b4-89e1-\
bc4ae58fa212"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Observable", "::", "usage"}], "=", 
   "\"\<Observable is an option for Signal1D. The option value may be an \
operator, or a list of spins in the current spin system. \nIf Observable is \
an operator, then this operator is used as the observable quantity operator \
during signal detection. If Observable\[Rule]{j,k..} is used, where the list \
{j,k..} defines spins in the current spin system, then the Observable is set \
to the operator for quadrature detection signal of that set of spins. The \
default value of Observable is -(I/2)opI[\\\"-\\\"], representing quadrature \
detection of all spins. \n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469877991470448*^9, 3.469878038523985*^9}, {
   3.469967701907137*^9, 3.469967737634742*^9}, {3.469967773430297*^9, 
   3.469967781101982*^9}, 3.544621851062533*^9, {3.5446219453463383`*^9, 
   3.5446221360175047`*^9}, {3.629384849689027*^9, 3.629384997772092*^9}},
 CellLabel->
  "In[1714]:=",ExpressionUUID->"be29b6f8-89e8-40cc-a9ab-6aea1b4a08dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ObservableOperator", "::", "usage"}], "=", 
   "\"\<ObservableOperator has been superseded by Observable (version 2.4).\>\
\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469877991470448*^9, 3.469878038523985*^9}, {
  3.469967701907137*^9, 3.469967737634742*^9}, {3.469967773430297*^9, 
  3.469967781101982*^9}, {3.5446218574257*^9, 3.544621896667543*^9}, {
  3.5446221427809687`*^9, 3.544622163863533*^9}},
 CellLabel->
  "In[1715]:=",ExpressionUUID->"e730eafc-1a92-47d5-8a5d-99617b32e281"]
}, Closed]],

Cell[CellGroupData[{

Cell["CarouselAverage", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{3.629384641320005*^9, 3.6293847218083887`*^9, 
  3.629384751905472*^9, 3.629384821495875*^9, 
  3.62938504961034*^9},ExpressionUUID->"0f6e9eb4-ce94-45a2-ac34-d25b1fead152"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CarouselAverage", "::", "usage"}], "=", 
   "\"\<CarouselAverage is an option for Signal1D. CarouselAverage\[Rule]True \
may be used with the SignalCalculationMethod\[Rule]\\\"COMPUTE\\\" option, in \
which case a fast implementation of the carousel average is used (i.e. \\\"\
\[Gamma]-COMPUTE\\\"). This if often used for computing the NMR spectra of \
rotating powders, where use of the carousel average allows a rapid estimate \
of the average over the \[Gamma]MR Euler angle. This option must be used with \
care since it is only valid if the density operator at the start of signal \
acquisition is independent of the \[Gamma]MR Euler angle.\n \>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469878218285511*^9, 3.469878219035956*^9}, {
  3.469882329319214*^9, 3.46988233483611*^9}, {3.4698823788891363`*^9, 
  3.4698825887486143`*^9}, {3.469882889257883*^9, 3.469882911594975*^9}, {
  3.46988357886088*^9, 3.469883629467374*^9}, {3.4698839918137827`*^9, 
  3.469883993162998*^9}, {3.469895899559732*^9, 3.469896114745575*^9}, {
  3.469896255880765*^9, 3.4698963640561743`*^9}, {3.469968254440872*^9, 
  3.469968386290052*^9}, {3.469968443768298*^9, 3.469968459535329*^9}, {
  3.46996849544396*^9, 3.469968561796905*^9}, {3.469968718568787*^9, 
  3.469968794106196*^9}, {3.469968876479117*^9, 3.469969169081202*^9}, {
  3.470842583246513*^9, 3.470842786099983*^9}, {3.470842851457941*^9, 
  3.470842896745532*^9}, {3.6293850700890093`*^9, 3.6293850814819593`*^9}},
 CellLabel->
  "In[1716]:=",ExpressionUUID->"09f771b5-6841-4d79-8fcf-d945627d467c"]
}, Closed]],

Cell[CellGroupData[{

Cell["ForceEvenNumberOfPoints", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.629385157218207*^9},ExpressionUUID->"71d51f4c-20f7-40cf-be0f-\
837155802212"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ForceEvenNumberOfPoints", "::", "usage"}], "=", 
   "\"\<ForceEvenNumberOfPoints is an option for Signal1D. The default is \
ForceEvenNumberOfPoints\[Rule]True, in which case the last acquisition point \
is dropped if the requested number of acquired points is odd. An even number \
of sampling points is usually required by the fast Fourier transform.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469878218285511*^9, 3.469878219035956*^9}, {
   3.469882329319214*^9, 3.46988233483611*^9}, {3.4698823788891363`*^9, 
   3.4698825887486143`*^9}, {3.469882889257883*^9, 3.469882911594975*^9}, {
   3.46988357886088*^9, 3.469883629467374*^9}, {3.4698839918137827`*^9, 
   3.469883993162998*^9}, {3.469895899559732*^9, 3.469896114745575*^9}, {
   3.469896255880765*^9, 3.4698963640561743`*^9}, {3.469966740037486*^9, 
   3.469966792788151*^9}, 3.469967318006187*^9, {3.629385180975749*^9, 
   3.6293852063013687`*^9}},
 CellLabel->
  "In[1717]:=",ExpressionUUID->"72ab65c8-c7f4-47fd-b153-a65b0f7cb648"]
}, Closed]],

Cell[CellGroupData[{

Cell["SignalGeneratorPeriod", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.629385157218207*^9, {3.700325085903152*^9, 3.700325086862088*^9}, 
   3.700325258211198*^9, 
   3.7004813552847033`*^9},ExpressionUUID->"7337d809-ba4a-4840-9b45-\
498fde5c6661"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SignalGeneratorPeriod", "::", "usage"}], "=", 
   "\"\<SignalGeneratorPeriod is an option for Signal1D. It is used \
internally by algorithms which exploit periodicity during acquisition of the \
signal.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469878218285511*^9, 3.469878219035956*^9}, {
   3.469882329319214*^9, 3.46988233483611*^9}, {3.4698823788891363`*^9, 
   3.4698825887486143`*^9}, {3.469882889257883*^9, 3.469882911594975*^9}, {
   3.46988357886088*^9, 3.469883629467374*^9}, {3.4698839918137827`*^9, 
   3.469883993162998*^9}, {3.469895899559732*^9, 3.469896114745575*^9}, {
   3.469896255880765*^9, 3.4698963640561743`*^9}, {3.469966740037486*^9, 
   3.469966792788151*^9}, 3.469967318006187*^9, {3.629385180975749*^9, 
   3.6293852063013687`*^9}, {3.700325093200938*^9, 3.700325252609008*^9}, {
   3.700325309573038*^9, 3.7003253106769857`*^9}, {3.700481384320806*^9, 
   3.7004813856495123`*^9}},
 CellLabel->
  "In[1718]:=",ExpressionUUID->"7845e95e-be00-4d44-868e-e0d2c7652613"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["EnsembleAverage", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.5067588809059*^9, 3.506758883800753*^9}, {
   3.506794559463007*^9, 3.506794559870281*^9}, 
   3.506855386938195*^9},ExpressionUUID->"14f09ae6-816f-4d44-ab0a-\
871ba4e2f0e1"],

Cell[CellGroupData[{

Cell["EnsembleAverage", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.56596035516168*^9},ExpressionUUID->"fb7776b0-d09b-4859-8d26-01495a3aef15"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EnsembleAverage", "::", "usage"}], "=", 
   "\"\<EnsembleAverage is an option for high-level SpinDynamica routines \
including Signal1D, Trajectory, TransformationAmplitude and \
TransformationAmplitudeTable. The default is EnsembleAverage\[Rule]False, in \
which case no ensemble averaging is done. A general setting is \
EnsembleAverage\[Rule]{var,samplingscheme}, which implements an ensemble \
average of the variable  var, using the scheme samplingscheme, which takes \
the form {{val1,weight1},{val2,weight2}...}. In this case, the signal is \
calculated for all the defined values of the variable var, and the results \
superposed using the values of weight. The averaged variable var may appear \
in any of the other arguments, including option specifications such as \
BackgroundGenerator. \nThe additional option setting Parallel\[Rule]True will \
attempt to distribute computation of the EnsembleAverage over the available \
kernels.\n\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469878218285511*^9, 3.469878219035956*^9}, {
   3.469882329319214*^9, 3.46988233483611*^9}, {3.4698823788891363`*^9, 
   3.4698825887486143`*^9}, {3.469882889257883*^9, 3.469882911594975*^9}, {
   3.46988357886088*^9, 3.469883629467374*^9}, {3.4698839918137827`*^9, 
   3.469883993162998*^9}, {3.469895899559732*^9, 3.469896114745575*^9}, {
   3.469896255880765*^9, 3.4698963640561743`*^9}, {3.469968254440872*^9, 
   3.469968386290052*^9}, {3.469968443768298*^9, 3.469968459535329*^9}, {
   3.46996849544396*^9, 3.469968561796905*^9}, {3.469968718568787*^9, 
   3.469968794106196*^9}, {3.469968876479117*^9, 3.469969169081202*^9}, {
   3.497572364388338*^9, 3.497572367005416*^9}, {3.5067589016675377`*^9, 
   3.506759033796514*^9}, {3.506794600832019*^9, 3.5067946101051617`*^9}, {
   3.565181444982514*^9, 3.565181512251227*^9}, 3.565264202665979*^9, {
   3.565264364561963*^9, 3.565264383753728*^9}, {3.5652644708001747`*^9, 
   3.5652644751884317`*^9}, 3.709375496809476*^9},
 CellLabel->
  "In[1719]:=",ExpressionUUID->"6e7a7fee-8f63-4557-954a-5ea4d73b5e3a"]
}, Closed]],

Cell[CellGroupData[{

Cell["MaxBatchSize", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.56596035516168*^9, 3.565960383864678*^9}, 
   3.565960533832921*^9},ExpressionUUID->"b1c0f228-75d5-4ee5-8f27-\
b87e1be636b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaxBatchSize", "::", "usage"}], "=", 
   "\"\<MaxBatchSize is an option associated with EnsembleAverage which \
causes the ensemble average to be divided into batches of dimension not \
larger than MaxBatchSize. The results of each batch are combined first before \
the overall combination is generated. This procedure conserves memory for \
large ensemble averages.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469878218285511*^9, 3.469878219035956*^9}, {
   3.469882329319214*^9, 3.46988233483611*^9}, {3.4698823788891363`*^9, 
   3.4698825887486143`*^9}, {3.469882889257883*^9, 3.469882911594975*^9}, {
   3.46988357886088*^9, 3.469883629467374*^9}, {3.4698839918137827`*^9, 
   3.469883993162998*^9}, {3.469895899559732*^9, 3.469896114745575*^9}, {
   3.469896255880765*^9, 3.4698963640561743`*^9}, {3.469968254440872*^9, 
   3.469968386290052*^9}, {3.469968443768298*^9, 3.469968459535329*^9}, {
   3.46996849544396*^9, 3.469968561796905*^9}, {3.469968718568787*^9, 
   3.469968794106196*^9}, {3.469968876479117*^9, 3.469969169081202*^9}, {
   3.497572364388338*^9, 3.497572367005416*^9}, {3.5067589016675377`*^9, 
   3.506759033796514*^9}, {3.506794600832019*^9, 3.5067946101051617`*^9}, {
   3.565181444982514*^9, 3.565181512251227*^9}, 3.565264202665979*^9, {
   3.565264364561963*^9, 3.565264383753728*^9}, {3.5652644708001747`*^9, 
   3.5652644751884317`*^9}, {3.565960388070404*^9, 3.5659606057833033`*^9}},
 CellLabel->
  "In[1720]:=",ExpressionUUID->"c505df3e-a278-49a5-8920-a1500f73b3f4"]
}, Closed]],

Cell[CellGroupData[{

Cell["Parallel", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.56596035516168*^9, 
  3.565960363351491*^9}},ExpressionUUID->"2efc791b-c6ae-4d78-9086-\
2bf9be0d769b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Parallel", "::", "usage"}], "=", 
   "\"\<Parallel is an option for high-level SpinDynamica routines including \
Signal1D, Trajectory, TransformationAmplitude and \
TransformationAmplitudeTable. If True, then the members of EnsembleAverage \
are computed in parallel using the available kernels. If \
Parallel\[Rule]<integer>, then the specified number of kernels is \
used.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5652643379613657`*^9, 3.565264359826251*^9}, {
  3.565264395945901*^9, 3.5652644960987453`*^9}, {3.570346581312025*^9, 
  3.5703465985156193`*^9}},
 CellLabel->
  "In[1721]:=",ExpressionUUID->"a24878fb-79a4-43fc-b61e-b3db9c19365c"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["NormalizationFactor", "Section",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.4526856290175543`*^9, {3.4526857703029137`*^9, 3.452685773062087*^9}, {
   3.454560053522246*^9, 3.454560058216958*^9}, {3.454560100594059*^9, 
   3.4545601017292137`*^9}, {3.454571512615376*^9, 3.454571533798867*^9}, {
   3.455118358989929*^9, 3.455118360699583*^9}, 3.455118777072443*^9, {
   3.455258350884461*^9, 3.455258351588242*^9}, {3.455259235163052*^9, 
   3.455259235841276*^9}, {3.4556317366262007`*^9, 3.455631739792364*^9}, {
   3.455635072682274*^9, 3.455635076244506*^9}, {3.45563543338888*^9, 
   3.455635434064197*^9}, {3.456506289466201*^9, 3.456506295406816*^9}, {
   3.456508348653371*^9, 3.456508356052676*^9}, {3.4565084005859623`*^9, 
   3.4565084007536383`*^9}, {3.4565084369209948`*^9, 3.456508438583412*^9}, {
   3.456509275980582*^9, 3.456509283884789*^9}, {3.461320168884572*^9, 
   3.461320185715005*^9}, {3.469876606308988*^9, 3.469876610499407*^9}, 
   3.4973602209669857`*^9, {3.497421245216651*^9, 3.497421248918776*^9}, 
   3.501996245589388*^9, 3.533207160497904*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"c88f47b0-2625-4dd0-828d-bfca5eb5e835"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Normalization", "::", "usage"}], "=", 
   "\"\<Normalization has been superseded by NormalizationFactor.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533207179478581*^9, 3.5332071943726788`*^9}},
 CellLabel->
  "In[1722]:=",ExpressionUUID->"e79b523f-54b6-48f8-9f4c-6ee1d2a743f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"NormalizationFactor", "::", "usage"}], "=", 
   "\"\<NormalizationFactor is an option for Trajectory, Signal1D, \
TransformationAmplitude and other simulation routines which provides the \
normalization factor for the calculation. NormalizationFactor\[Rule]None or \
NormalizationFactor\[Rule]False does not normalize. \
NormalizationFactor\[Rule]n divides the result of the calculation by \
n).\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.461322189599052*^9, 3.461322301335417*^9}, {
   3.461322383937756*^9, 3.4613223861361113`*^9}, {3.469876621589324*^9, 
   3.469876841350842*^9}, {3.469876927853476*^9, 3.469876935458284*^9}, {
   3.46987721264432*^9, 3.469877215899377*^9}, {3.469877250487714*^9, 
   3.469877256710096*^9}, {3.4698782308332872`*^9, 3.4698782613619223`*^9}, {
   3.469882345432494*^9, 3.4698823745454483`*^9}, {3.469882438350027*^9, 
   3.46988244095815*^9}, {3.46989465566475*^9, 3.469894663306656*^9}, 
   3.469895612226006*^9, {3.469896417369451*^9, 3.469896453391149*^9}, {
   3.469961800659601*^9, 3.469961906544622*^9}, {3.469967287920261*^9, 
   3.46996729958292*^9}, {3.469967371773782*^9, 3.469967531870295*^9}, {
   3.469967563274653*^9, 3.469967603578313*^9}, {3.470139118103303*^9, 
   3.470139123547707*^9}, {3.4701393290290117`*^9, 3.4701393297226152`*^9}, {
   3.470842564500786*^9, 3.470842569049342*^9}, {3.497360221861237*^9, 
   3.497360370747094*^9}, {3.4974213429732437`*^9, 3.497421362680093*^9}, {
   3.499291751460223*^9, 3.499291798650703*^9}, {3.501995847698637*^9, 
   3.501995979129361*^9}, {3.5019960208861713`*^9, 3.501996169669347*^9}, {
   3.501996204776485*^9, 3.5019962380687227`*^9}, {3.502328959964713*^9, 
   3.502328985163006*^9}, {3.533081835705448*^9, 3.5330820470319*^9}, {
   3.5331016929769*^9, 3.533101748555407*^9}, {3.533176604114311*^9, 
   3.533176699373554*^9}, {3.533176736823841*^9, 3.533176747628931*^9}, 
   3.6233422588823147`*^9, {3.682613106087813*^9, 3.682613155639629*^9}},
 CellLabel->
  "In[1723]:=",ExpressionUUID->"becd273a-ded8-43a4-aedf-f8da79731344"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["start", "Chapter",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.713540147298855*^9, 3.713540147898288*^9}, {
   3.7136034080327606`*^9, 3.7136034081120296`*^9}, {3.7136041068146367`*^9, 
   3.7136041087337327`*^9}, 3.722473537382512*^9},
 AspectRatioFixed->
  True,ExpressionUUID->"67084a09-f1b0-4584-ad10-7e0e86f67b14"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$Chronology", "=", "\"\<LeftToRight\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545050393596538*^9, 3.5450503995208893`*^9}, {
  3.545050732985859*^9, 3.545050735366548*^9}},
 CellLabel->
  "In[1724]:=",ExpressionUUID->"224b0594-7343-40b1-abd4-71c795c2fe9b"],

Cell["Begin[\"`Private`\"];", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->True,
 CellLabel->
  "In[1725]:=",ExpressionUUID->"8ad7b403-e355-4090-8e0a-f7a48a4db6da"]
}, Closed]],

Cell[CellGroupData[{

Cell["general routines", "Chapter",
 InitializationCell->True,
 CellChangeTimes->{{3.683265263823209*^9, 3.683265267208638*^9}, {
  3.683265403184783*^9, 3.683265404061427*^9}, {3.7136013981670327`*^9, 
  3.7136013982533054`*^9}, {3.7136370270338955`*^9, 3.7136370271544247`*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"fb0155e4-e338-4f38-9d51-ccc28f32a792"],

Cell[CellGroupData[{

Cell["EnsembleAverage", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4553332615084953`*^9, 3.4553332635463343`*^9}, 3.45633123998427*^9, {
   3.462856583205394*^9, 3.462856584467523*^9}, {3.464327973738139*^9, 
   3.464327976586143*^9}, 3.497377191025092*^9, 3.5079870163866787`*^9, {
   3.642747540519401*^9, 3.642747547583919*^9}, {3.713271396884931*^9, 
   3.713271397955665*^9}},ExpressionUUID->"2fe36fb9-1423-44b3-aff9-\
139a4c402934"],

Cell["\<\
routines for standardizing the EnsembleAverage specification, converting \
multidimensional variables into arrayed variables, and deriving the \
substitution rule sets used to construct the EnsembleAverage\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.642940972041935*^9, 3.642940981874317*^9}, {
  3.642941033257865*^9, 
  3.642941068751875*^9}},ExpressionUUID->"802cad79-7910-4b21-8a85-\
0df4aaf77ca4"],

Cell[CellGroupData[{

Cell["StandardizeEnsembleAverage", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, 
   3.507987350544482*^9, {3.642747617248518*^9, 
   3.6427476238293056`*^9}},ExpressionUUID->"ec95bce6-30c7-45a2-9cfb-\
028ef003aa0c"],

Cell["\<\
this very complex routine standardizes all possible formats for the \
EnsembleAverage specification, including weights automatically, if needed. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.64294129122226*^9, 3.6429413212046223`*^9}, {
  3.642941627551239*^9, 
  3.64294163535594*^9}},ExpressionUUID->"71aeb8cf-dede-4e3d-b323-\
0ecfd19b4faf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeEnsembleAverage", "[", 
    RowBox[{"None", "|", "False"}], "]"}], "=", "False"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429416640240088`*^9, 3.6429416760542593`*^9}},
 CellLabel->
  "In[1726]:=",ExpressionUUID->"b54a0b4e-3b97-4620-8028-e5ad3e7c4ae9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StandardizeEnsembleAverage", "[", "expr_", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{"expr", ",", "$Failed"}], "]"}]}]}], ":=", "$Failed"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429393579744463`*^9, 3.642939375116969*^9}, 
   3.642941019985894*^9},
 CellLabel->
  "In[1727]:=",ExpressionUUID->"92bcadf0-240a-4f54-be4e-2c09096ffd3c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeEnsembleAverage", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"var", ":", 
       RowBox[{"Except", "[", "_List", "]"}]}], ",", "vals_List"}], "}"}], 
    "]"}], ":=", 
   RowBox[{"StandardizeEnsembleAverage", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", "var", "}"}], ",", "vals"}], "}"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642747635307279*^9, 3.642747679847151*^9}, {
  3.642773007784128*^9, 3.64277301670394*^9}},
 CellLabel->
  "In[1728]:=",ExpressionUUID->"36ed0780-5ca3-4777-ab07-def4b24921cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeEnsembleAverage", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"vars", ":", 
       RowBox[{"{", 
        RowBox[{"___", ",", "_List", ",", "___"}], "}"}]}], ",", "vals_"}], 
     "}"}], "]"}], ":=", 
   RowBox[{"StandardizeEnsembleAverage", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Flatten", "@", "vars"}], ",", "vals"}], "}"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.643032683319745*^9, 3.643032710157177*^9}, {
  3.643032782523444*^9, 3.643032789339138*^9}},
 CellLabel->
  "In[1729]:=",ExpressionUUID->"520e6eed-9f19-4e1f-9fe2-1a9150f041c6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StandardizeEnsembleAverage", "[", 
     RowBox[{"{", 
      RowBox[{"vars_", ",", "vals_"}], "}"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{"vars", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"_Symbol", "|", 
           RowBox[{"_Symbol", "[", "_Integer", "]"}]}], ")"}], ".."}], 
        "}"}]}], "]"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"EnsembleAverage", "::", "badvar"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642747635307279*^9, 3.642747679847151*^9}, {
   3.64274772797209*^9, 3.642747842722557*^9}, {3.642773019606586*^9, 
   3.642773022621743*^9}, {3.6428448261723137`*^9, 3.6428448373872538`*^9}, {
   3.642871152595683*^9, 3.642871158473353*^9}, {3.642872184593464*^9, 
   3.64287218593561*^9}, {3.642872217955454*^9, 3.642872249268363*^9}, {
   3.642872304168414*^9, 3.642872306116169*^9}, {3.642872854461731*^9, 
   3.642872886884803*^9}, {3.642873050923691*^9, 3.642873051248239*^9}, 
   3.642938899814725*^9, 3.642940070681757*^9, {3.643032735441802*^9, 
   3.643032737046379*^9}, 3.643032805891158*^9},
 CellLabel->
  "In[1730]:=",ExpressionUUID->"226cd92c-162b-488c-b22d-173d7f6fd69e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StandardizeEnsembleAverage", "[", 
     RowBox[{"{", 
      RowBox[{"vars_List", ",", 
       RowBox[{"vals", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}]}], "}"}], 
     "]"}], "/;", 
    RowBox[{
     RowBox[{"Length", "[", "vars", "]"}], ">", "1"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"EnsembleAverage", "::", "toomanyvars"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642747635307279*^9, 3.642747679847151*^9}, {
   3.64274772797209*^9, 3.642747842722557*^9}, {3.642773019606586*^9, 
   3.642773022621743*^9}, {3.6428448261723137`*^9, 3.6428448373872538`*^9}, {
   3.642871152595683*^9, 3.642871158473353*^9}, 3.642872311411893*^9, {
   3.642941508595998*^9, 3.642941530962517*^9}},
 CellLabel->
  "In[1731]:=",ExpressionUUID->"19180164-8384-4354-94fd-0684bdefcac0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StandardizeEnsembleAverage", "[", 
     RowBox[{"{", 
      RowBox[{"vars_List", ",", 
       RowBox[{"vals", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}]}], "}"}], 
     "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", "vars", "]"}], "==", "1"}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nvals", ",", "weights"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"nvals", "=", 
        RowBox[{"Length", "[", "vals", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"weights", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"1", "/", "nvals"}], ",", 
          RowBox[{"{", "nvals", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"StandardizeEnsembleAverage", "[", 
        RowBox[{"{", 
         RowBox[{"vars", ",", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"List", "/@", "vals"}], ",", "weights"}], "}"}], "]"}]}],
          "}"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642747635307279*^9, 3.642747679847151*^9}, {
   3.64274772797209*^9, 3.642747842722557*^9}, {3.6427479092419653`*^9, 
   3.6427480007736063`*^9}, {3.642748060165168*^9, 3.642748061355771*^9}, {
   3.642771415564039*^9, 3.642771418923977*^9}, {3.642772620547371*^9, 
   3.642772623157402*^9}, {3.642773026797718*^9, 3.6427730418266087`*^9}, {
   3.642844851800356*^9, 3.6428448538594427`*^9}, 3.6428711654729033`*^9, {
   3.6429415414731207`*^9, 3.642941546152523*^9}},
 CellLabel->
  "In[1732]:=",ExpressionUUID->"7077ff63-a7b9-4e76-9e6b-ccc33345573b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StandardizeEnsembleAverage", "[", 
     RowBox[{"{", 
      RowBox[{"vars_List", ",", 
       RowBox[{"vals", ":", 
        RowBox[{"{", 
         RowBox[{"_List", ".."}], "}"}]}]}], "}"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"Equal", "@@", 
      RowBox[{"(", 
       RowBox[{"Length", "/@", "vals"}], ")"}]}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"EnsembleAverage", "::", "inconslengths"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642748211844677*^9, 3.64274826786198*^9}, {
  3.642773060279436*^9, 3.6427730640127163`*^9}, {3.642941582581685*^9, 
  3.642941586258731*^9}},
 CellLabel->
  "In[1733]:=",ExpressionUUID->"cf2fe04a-d314-46f1-81f7-13f55d0baa24"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StandardizeEnsembleAverage", "[", 
     RowBox[{"{", 
      RowBox[{"vars_List", ",", 
       RowBox[{"vals", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}], ".."}], 
         "}"}]}]}], "}"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", "vars", "]"}], "==", "1"}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"EnsembleAverage", "::", "ambig"}], ",", 
       RowBox[{"Length", "@", 
        RowBox[{"First", "@", "vals"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"StandardizeEnsembleAverage", "[", 
      RowBox[{"{", 
       RowBox[{"vars", ",", 
        RowBox[{"List", "/@", "vals"}]}], "}"}], "]"}]}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642748211844677*^9, 3.64274826786198*^9}, {
   3.642749568673777*^9, 3.64274958840658*^9}, {3.642749641329391*^9, 
   3.642749676776525*^9}, {3.6427497801378736`*^9, 3.642749797081605*^9}, {
   3.6427498365937767`*^9, 3.64274985970024*^9}, {3.642771438219529*^9, 
   3.642771450820738*^9}, 3.64277150033573*^9, {3.642773067356188*^9, 
   3.6427730795171843`*^9}, 3.6427882198078337`*^9, {3.6427882736567297`*^9, 
   3.642788274870736*^9}, 3.642844860352222*^9, 3.642871171520136*^9, {
   3.6428712515374603`*^9, 3.642871253123774*^9}, {3.6429415577176456`*^9, 
   3.6429415795083017`*^9}},
 CellLabel->
  "In[1734]:=",ExpressionUUID->"274258e3-0592-48e6-b991-33bbb7a91ea1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StandardizeEnsembleAverage", "[", 
     RowBox[{"{", 
      RowBox[{"vars_List", ",", 
       RowBox[{"vals", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}], ".."}], 
         "}"}]}]}], "}"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", "vars", "]"}], "\[Equal]", 
      RowBox[{"Length", "@", 
       RowBox[{"First", "[", "vals", "]"}]}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"EnsembleAverage", "::", "ambig"}], ",", "1"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"StandardizeEnsembleAverage", "[", 
      RowBox[{"{", 
       RowBox[{"vars", ",", 
        RowBox[{"Map", "[", 
         RowBox[{"List", ",", "vals", ",", "1"}], "]"}]}], "}"}], "]"}]}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642748211844677*^9, 3.64274826786198*^9}, {
   3.642749568673777*^9, 3.64274958840658*^9}, {3.642749641329391*^9, 
   3.642749676776525*^9}, {3.6427497801378736`*^9, 3.642749797081605*^9}, {
   3.6427498365937767`*^9, 3.64274985970024*^9}, {3.642771438219529*^9, 
   3.642771450820738*^9}, 3.64277150033573*^9, {3.642773067356188*^9, 
   3.6427730795171843`*^9}, {3.6427882198078337`*^9, 3.64278828108156*^9}, {
   3.642788375652337*^9, 3.642788378896937*^9}, 3.6427884702480288`*^9, 
   3.642788508880891*^9, 3.642843665642193*^9, 3.642844863772477*^9, 
   3.642871176084804*^9, 3.642871258368454*^9, {3.642941562184396*^9, 
   3.642941570980351*^9}},
 CellLabel->
  "In[1735]:=",ExpressionUUID->"d802c8ce-58a0-4b02-93e2-1f73366fc133"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeEnsembleAverage", "[", 
    RowBox[{"{", 
     RowBox[{"vars_List", ",", 
      RowBox[{"vals", ":", 
       RowBox[{"{", 
        RowBox[{"_List", ".."}], "}"}]}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nvar", ",", "valdim", ",", "nvals", ",", "weights"}], "}"}], 
     ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"nvals", "=", 
         RowBox[{"Length", "[", "vals", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"weights", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"1", "/", "nvals"}], ",", 
           RowBox[{"{", "nvals", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"StandardizeEnsembleAverage", "[", 
         RowBox[{"{", 
          RowBox[{"vars", ",", 
           RowBox[{"MapThread", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "#1", "}"}], ",", 
                RowBox[{"{", "#2", "}"}]}], "]"}], "&"}], ",", 
             RowBox[{"{", 
              RowBox[{"vals", ",", "weights"}], "}"}]}], "]"}]}], "}"}], 
         "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"nvar", "=", 
         RowBox[{"Length", "[", "vars", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"valdim", "=", 
         RowBox[{"Length", "[", 
          RowBox[{
          "vals", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"nvar", "\[Equal]", "valdim"}], ")"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{
            RowBox[{"First", "@", "vals"}], ",", 
            RowBox[{"{", 
             RowBox[{"_List", ",", 
              RowBox[{"Except", "[", "_List", "]"}]}], "}"}]}], "]"}]}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642747635307279*^9, 3.642747679847151*^9}, {
   3.64274772797209*^9, 3.642747842722557*^9}, {3.6427479092419653`*^9, 
   3.6427480007736063`*^9}, {3.642748060165168*^9, 3.642748061355771*^9}, {
   3.642748128763768*^9, 3.642748129770981*^9}, {3.6427481761730967`*^9, 
   3.642748193184301*^9}, {3.642748307881472*^9, 3.642748309780836*^9}, 
   3.642748344882782*^9, 3.642749799160841*^9, {3.642750179625175*^9, 
   3.642750345640671*^9}, {3.642771457053317*^9, 3.642771463207389*^9}, 
   3.642771881584584*^9, 3.6427729805140467`*^9, {3.642773084952568*^9, 
   3.6427730960567017`*^9}, {3.642787410497843*^9, 3.642787467925228*^9}, {
   3.6427875262218847`*^9, 3.642787547753962*^9}, 3.642787619753276*^9, {
   3.642787874548518*^9, 3.642787881729371*^9}, {3.642787980944868*^9, 
   3.6427879826966887`*^9}, {3.642788706899007*^9, 3.642788715362916*^9}, {
   3.642788780745103*^9, 3.642788780992957*^9}, {3.642788869086587*^9, 
   3.642788870719427*^9}, 3.642844866687592*^9, 3.642871180328189*^9, {
   3.642941591156506*^9, 3.6429415918632507`*^9}},
 CellLabel->
  "In[1736]:=",ExpressionUUID->"61ba7679-2e50-460f-bcae-c039e9c9b77b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeEnsembleAverage", "[", 
    RowBox[{"{", 
     RowBox[{"vars_List", ",", 
      RowBox[{"vals", ":", 
       RowBox[{"{", 
        RowBox[{"_List", ".."}], "}"}]}]}], "}"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"nvar", ",", "valdim", ",", "nvals", ",", "weights"}], "}"}], 
     ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"nvals", "=", 
         RowBox[{"Length", "[", "vals", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"weights", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"1", "/", "nvals"}], ",", 
           RowBox[{"{", "nvals", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"StandardizeEnsembleAverage", "[", 
         RowBox[{"{", 
          RowBox[{"vars", ",", 
           RowBox[{"MapThread", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{"#1", ",", 
                RowBox[{"{", "#2", "}"}]}], "]"}], "&"}], ",", 
             RowBox[{"{", 
              RowBox[{"vals", ",", "weights"}], "}"}]}], "]"}]}], "}"}], 
         "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"nvar", "=", 
         RowBox[{"Length", "[", "vars", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"valdim", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"vals", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"nvar", "\[Equal]", "valdim"}], ")"}], "&&", 
         "\[IndentingNewLine]", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{
            RowBox[{"First", "@", "vals"}], ",", 
            RowBox[{"{", 
             RowBox[{"_List", ",", 
              RowBox[{"Except", "[", "_List", "]"}]}], "}"}]}], "]"}]}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642747635307279*^9, 3.642747679847151*^9}, {
   3.64274772797209*^9, 3.642747842722557*^9}, {3.6427479092419653`*^9, 
   3.6427480007736063`*^9}, {3.642748060165168*^9, 3.642748061355771*^9}, {
   3.642748128763768*^9, 3.642748129770981*^9}, {3.6427481761730967`*^9, 
   3.642748193184301*^9}, {3.642748307881472*^9, 3.642748309780836*^9}, 
   3.642748344882782*^9, 3.642749799160841*^9, {3.642750179625175*^9, 
   3.642750345640671*^9}, {3.642771457053317*^9, 3.642771463207389*^9}, 
   3.642771881584584*^9, 3.6427729805140467`*^9, {3.642773084952568*^9, 
   3.6427730960567017`*^9}, {3.642787410497843*^9, 3.642787467925228*^9}, {
   3.6427875262218847`*^9, 3.642787547753962*^9}, 3.642787619753276*^9, {
   3.642787874548518*^9, 3.642787881729371*^9}, {3.642787980944868*^9, 
   3.6427879826966887`*^9}, {3.642788706899007*^9, 3.642788715362916*^9}, {
   3.642788780745103*^9, 3.642788780992957*^9}, {3.642788869086587*^9, 
   3.642788879513359*^9}, 3.642788938626176*^9, {3.64278901836833*^9, 
   3.642789025104738*^9}, 3.6428448702305517`*^9, 3.642871185321597*^9, {
   3.642941596206025*^9, 3.642941596689948*^9}},
 CellLabel->
  "In[1737]:=",ExpressionUUID->"84d37266-8437-414c-9f9f-ebbe77166d53"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeEnsembleAverage", "[", 
    RowBox[{"{", 
     RowBox[{"vars_List", ",", 
      RowBox[{"valws", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", 
           RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}]}], 
     "}"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"vals", ",", "weights"}], "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"vals", ",", "weights"}], "}"}], "=", 
         RowBox[{"Transpose", "@", "valws"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"StandardizeEnsembleAverage", "[", 
         RowBox[{"{", 
          RowBox[{"vars", ",", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"List", "/@", "vals"}], ",", "weights"}], "}"}], 
            "]"}]}], "}"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"valws", "\[LeftDoubleBracket]", 
        RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
       RowBox[{"Except", "[", "_List", "]"}]}], "]"}], "||", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"MatchQ", "[", 
        RowBox[{
         RowBox[{"valws", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}]}], "]"}], "&&", 
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"valws", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}], 
        "\[NotEqual]", 
        RowBox[{"Length", "[", "vars", "]"}]}]}], ")"}]}]}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6428440627953463`*^9, 3.64284408359724*^9}, {
   3.6428442637083883`*^9, 3.6428443130639973`*^9}, {3.6428446342215557`*^9, 
   3.6428447472269077`*^9}, {3.6428448745040827`*^9, 3.642844880738415*^9}, {
   3.642844915885169*^9, 3.642844924051025*^9}, {3.6428450407351713`*^9, 
   3.6428450788937693`*^9}, {3.642845163038969*^9, 3.6428451632294416`*^9}, 
   3.6428452781905537`*^9, {3.642845509493588*^9, 3.642845523554306*^9}, 
   3.64284560605857*^9, {3.6428457520561333`*^9, 3.642845755169261*^9}, {
   3.642845818648978*^9, 3.6428458854408417`*^9}, {3.642846011337721*^9, 
   3.642846034029953*^9}, 3.642871190902005*^9, {3.642941601372078*^9, 
   3.642941602292715*^9}},
 CellLabel->
  "In[1738]:=",ExpressionUUID->"0c2908e1-d651-4998-bd79-fc6f50f02db6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StandardizeEnsembleAverage", "[", 
     RowBox[{"{", 
      RowBox[{"vars_List", ",", 
       RowBox[{"valws", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_List", ",", 
            RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}]}],
       "}"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", "[", "vars", "]"}], "!=", 
       RowBox[{"Length", "[", 
        RowBox[{"valws", "\[LeftDoubleBracket]", 
         RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", "[", "vars", "]"}], "\[Equal]", 
       RowBox[{"Length", "@", 
        RowBox[{"Flatten", "[", 
         RowBox[{"valws", "\[LeftDoubleBracket]", 
          RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}]}], 
      ")"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vals", ",", "weights"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vals", ",", "weights"}], "}"}], "=", 
        RowBox[{"Transpose", "@", "valws"}]}], ";", 
       RowBox[{"{", 
        RowBox[{"vars", ",", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Flatten", "/@", "vals"}], ",", "weights"}], "}"}], 
          "]"}]}], "}"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6427488823857203`*^9, 3.642748975258689*^9}, {
  3.642773100388254*^9, 3.6427731039433126`*^9}, {3.642773194210058*^9, 
  3.6427732469030857`*^9}, {3.642844668213971*^9, 3.64284467380541*^9}, {
  3.642940271264037*^9, 3.642940312069211*^9}, {3.642940804759165*^9, 
  3.642940828903846*^9}},
 CellLabel->
  "In[1739]:=",ExpressionUUID->"282e999f-ff9a-4c44-bb64-e877c63e1d6b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StandardizeEnsembleAverage", "[", 
     RowBox[{"{", 
      RowBox[{"vars_List", ",", 
       RowBox[{"valws", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_List", ",", 
            RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}]}],
       "}"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"Length", "[", "vars", "]"}], "\[Equal]", 
     RowBox[{"Length", "[", 
      RowBox[{"valws", "\[LeftDoubleBracket]", 
       RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}]}], ":=", 
   RowBox[{"{", 
    RowBox[{"vars", ",", "valws"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6427488823857203`*^9, 3.642748975258689*^9}, {
  3.642773100388254*^9, 3.6427731039433126`*^9}, {3.642773194210058*^9, 
  3.6427732469030857`*^9}, {3.642844668213971*^9, 3.64284467380541*^9}},
 CellLabel->
  "In[1740]:=",ExpressionUUID->"070faa8a-98b3-488e-8f5d-8f40fe25e1d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StandardizeEnsembleAverage", "[", "expr_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"EnsembleAverage", "::", "badspec"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429417132227297`*^9, 3.6429417305711727`*^9}, {
  3.642942596109461*^9, 3.642942597228766*^9}},
 CellLabel->
  "In[1741]:=",ExpressionUUID->"9d5bf624-656b-44fc-ae15-01ccb1406465"]
}, Closed]],

Cell[CellGroupData[{

Cell["EnsembleWeights", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, 
   3.507987350544482*^9, {3.642747617248518*^9, 3.6427476238293056`*^9}, {
   3.642846222486425*^9, 3.642846230158252*^9}, {3.642846506958704*^9, 
   3.6428465081612883`*^9}},ExpressionUUID->"05544b1c-eae9-46db-9a57-\
ddafac990e53"],

Cell["\<\
derives the set of weights defined by the EnsembleAverage specification. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.64294135832122*^9, 
  3.642941377030312*^9}},ExpressionUUID->"b31582a0-b286-4181-9093-\
ac2cb05eee63"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EnsembleWeights", "[", "expr_", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{"expr", ",", "$Failed"}], "]"}]}]}], ":=", "$Failed"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429393579744463`*^9, 3.642939375116969*^9}, 
   3.642941019985894*^9, 3.642941420767928*^9},
 CellLabel->
  "In[1742]:=",ExpressionUUID->"13b2765a-4d44-49e8-a56d-41a71972a118"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EnsembleWeights", "[", 
     RowBox[{"{", 
      RowBox[{"vars_", ",", "valws_"}], "}"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vars", ",", "valws"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"_List", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_List", ",", 
              RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}],
          "}"}]}], "]"}]}], "||", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Length", "[", "vars", "]"}], "\[NotEqual]", 
      RowBox[{"Length", "[", 
       RowBox[{"valws", "\[LeftDoubleBracket]", 
        RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}]}]}], ":=", 
   RowBox[{"EnsembleWeights", "@", 
    RowBox[{"StandardizeEnsembleAverage", "[", 
     RowBox[{"{", 
      RowBox[{"vars", ",", "valws"}], "}"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.64284651228345*^9, 3.642846521612974*^9}},
 CellLabel->
  "In[1743]:=",ExpressionUUID->"cc8111e2-c7c0-4c4d-b911-71f4e01c03b0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EnsembleWeights", "[", 
    RowBox[{"{", 
     RowBox[{"vars_", ",", "valws_"}], "}"}], "]"}], ":=", 
   RowBox[{"Last", "/@", "valws"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6428465382586937`*^9, 3.642846554368265*^9}},
 CellLabel->
  "In[1744]:=",ExpressionUUID->"c81f1fa8-7116-48a8-ab06-17238a408be7"]
}, Closed]],

Cell[CellGroupData[{

Cell["MultidimensionalEnsembleVariables", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, 
   3.507987350544482*^9, {3.642747617248518*^9, 3.6427476238293056`*^9}, {
   3.642846222486425*^9, 3.642846230158252*^9}, {3.642873183457076*^9, 
   3.6428731901441708`*^9}, {3.6429167282886133`*^9, 3.642916750080133*^9}, {
   3.6429168008205423`*^9, 3.6429168064231777`*^9}, 3.642916888868623*^9, 
   3.642917466859425*^9},ExpressionUUID->"af383bd0-f0b2-4d83-ae46-\
5bf53544af34"],

Cell["\<\
extracts multidimensional ensemble variables and their dimension from an \
EnsembleAverage specification\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.6429167565162487`*^9, 3.64291684563165*^9}, {
  3.642917494177169*^9, 3.642917514436311*^9}, {3.6429180566068907`*^9, 
  3.642918057166483*^9}},ExpressionUUID->"65326144-b31c-4bf4-9e21-\
46ed7db84c24"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MultidimensionalEnsembleVariables", "[", "expr_", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{"expr", ",", "$Failed"}], "]"}]}]}], ":=", "$Failed"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429393579744463`*^9, 3.642939375116969*^9}, 
   3.642941019985894*^9, {3.642941420767928*^9, 3.642941432217441*^9}},
 CellLabel->
  "In[1745]:=",ExpressionUUID->"f81f8622-28cf-47c6-8e13-4e161cd269f4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MultidimensionalEnsembleVariables", "[", 
     RowBox[{"{", 
      RowBox[{"vars_", ",", "valws_"}], "}"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vars", ",", "valws"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"_List", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_List", ",", 
              RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}],
          "}"}]}], "]"}]}], "||", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Length", "[", "vars", "]"}], "\[NotEqual]", 
      RowBox[{"Length", "[", 
       RowBox[{"valws", "\[LeftDoubleBracket]", 
        RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}]}]}], ":=", 
   RowBox[{"MultidimensionalEnsembleVariables", "@", 
    RowBox[{"StandardizeEnsembleAverage", "[", 
     RowBox[{"{", 
      RowBox[{"vars", ",", "valws"}], "}"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429167544178534`*^9, 3.6429167544200277`*^9}, {
  3.64291685225095*^9, 3.6429168938492727`*^9}, {3.642917468504272*^9, 
  3.642917470641584*^9}},
 CellLabel->
  "In[1746]:=",ExpressionUUID->"ea347197-2306-4331-b604-434808211bed"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MultidimensionalEnsembleVariables", "[", 
    RowBox[{"{", 
     RowBox[{"vars_", ",", "valws_"}], "}"}], "]"}], ":=", 
   RowBox[{"Cases", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"vars", ",", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"MatchQ", "[", 
              RowBox[{"#", ",", "_List"}], "]"}], ",", 
             RowBox[{"Length", "[", "#", "]"}], ",", "0"}], "]"}], "&"}], ",", 
          RowBox[{"valws", "\[LeftDoubleBracket]", 
           RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}]}], "]"}]}], 
       "}"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"_", ",", 
       RowBox[{"Except", "[", "0", "]"}]}], "}"}]}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.642917052059669*^9, 3.642917084798214*^9}, 
   3.642917133629307*^9, {3.6429174721603622`*^9, 3.642917490519043*^9}, 
   3.657195730604949*^9},
 CellLabel->
  "In[1747]:=",ExpressionUUID->"c35b2c3f-8cb1-422b-949a-15c15ab2e3ce"]
}, Closed]],

Cell[CellGroupData[{

Cell["ExpandMultidimensionalEnsembleVariables", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, 
   3.507987350544482*^9, {3.642747617248518*^9, 3.6427476238293056`*^9}, {
   3.642846222486425*^9, 3.642846230158252*^9}, {3.642873183457076*^9, 
   3.6428731901441708`*^9}, {3.6429167282886133`*^9, 3.642916750080133*^9}, {
   3.6429168008205423`*^9, 3.6429168064231777`*^9}, 3.642916888868623*^9, {
   3.642917210827785*^9, 
   3.64291722062611*^9}},ExpressionUUID->"394ba4d9-aac6-4ec8-bc12-\
e8884d284efc"],

Cell["\<\
determines any multidimensional ensemble variables var and replaces any \
expression including var by an array of the type {var[1],var[2]..}. This \
allows simplication of complex expressions prior to the ensemble average \
itself taking place. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.6429167565162487`*^9, 3.64291684563165*^9}, {
   3.642917223979175*^9, 3.642917333683661*^9}, {3.642941160187546*^9, 
   3.642941163403327*^9}, 
   3.682577944949789*^9},ExpressionUUID->"7d3442ae-31a4-4ad4-ab23-\
d7d5be6cca4e"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ExpandMultidimensionalEnsembleVariables", ",", "HoldFirst"}], 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429173760051327`*^9, 3.642917411596561*^9}},
 CellLabel->
  "In[1748]:=",ExpressionUUID->"aa357a57-bfc3-441a-8269-cd7fb36b330e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExpandMultidimensionalEnsembleVariables", "[", "exprs__", "]"}], 
    "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"Hold", "@", 
        RowBox[{"{", "exprs", "}"}]}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429393579744463`*^9, 3.642939375116969*^9}, 
   3.642941019985894*^9, {3.642941420767928*^9, 3.642941467519742*^9}, {
   3.642942695921417*^9, 3.6429427033110456`*^9}},
 CellLabel->
  "In[1749]:=",ExpressionUUID->"14711fe4-9eed-4bb3-86a9-d60423287874"],

Cell[CellGroupData[{

Cell["\<\
expansion of multidimensional variables in an EnsembleAverage specification\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.643042353674642*^9, 
  3.643042376276082*^9}},ExpressionUUID->"9a6ae8bc-7fca-4c95-b726-\
13ef4ae14c85"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExpandMultidimensionalEnsembleVariables", "[", "expr_", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"ReleaseHold", "[", "expr", "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_", ",", 
            RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}], 
       "}"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vars", ",", "valws"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vars", ",", "valws"}], "}"}], "=", "expr"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"StandardizeEnsembleAverage", "[", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"ExpandMultidimensionalEnsembleVariables", "[", 
           RowBox[{
            RowBox[{"Evaluate", "@", "vars"}], ",", 
            RowBox[{"{", 
             RowBox[{"vars", ",", "valws"}], "}"}]}], "]"}], ",", "valws"}], 
         "}"}], "\[IndentingNewLine]", "]"}]}], ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.643032099462943*^9, 3.643032125575068*^9}, {
   3.64303226632274*^9, 3.643032271776737*^9}, {3.643032310391097*^9, 
   3.6430323144192467`*^9}, {3.64303247453014*^9, 3.643032500391748*^9}, 
   3.643032913077755*^9, {3.643033000031711*^9, 3.643033007673112*^9}, {
   3.643041585078405*^9, 3.6430415902521267`*^9}, {3.6430416759839354`*^9, 
   3.643041760003487*^9}, {3.6430418522697687`*^9, 3.643041858368133*^9}, {
   3.6430420458933487`*^9, 3.643042073167309*^9}, {3.643042118448412*^9, 
   3.643042121180335*^9}, {3.643042309169038*^9, 3.643042338727264*^9}},
 CellLabel->
  "In[1750]:=",ExpressionUUID->"c13b68e8-adc9-4f6c-9233-9b96eb57badd"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
expansion of multidimensional variables in general expressions\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.643042353674642*^9, 
  3.643042392015752*^9}},ExpressionUUID->"35b8d093-5e24-4d83-b608-\
26c1ed862816"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpandMultidimensionalEnsembleVariables", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"None", "|", "False"}]}], "]"}], ":=", "expr"}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.643033490447771*^9, 3.643033497262442*^9}},
 CellLabel->
  "In[1751]:=",ExpressionUUID->"1e863dd7-3c6a-40e7-a98e-f15371ec4e07"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExpandMultidimensionalEnsembleVariables", "[", 
     RowBox[{"expr_", ",", 
      RowBox[{"{", 
       RowBox[{"vars_", ",", "valws_"}], "}"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vars", ",", "valws"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"_List", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_List", ",", 
              RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}],
          "}"}]}], "]"}]}], "||", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Length", "[", "vars", "]"}], "\[NotEqual]", 
      RowBox[{"Length", "[", 
       RowBox[{"valws", "\[LeftDoubleBracket]", 
        RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}]}]}], ":=", 
   RowBox[{"ExpandMultidimensionalEnsembleVariables", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"StandardizeEnsembleAverage", "[", 
      RowBox[{"{", 
       RowBox[{"vars", ",", "valws"}], "}"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429173408633204`*^9, 3.6429173733101883`*^9}},
 CellLabel->
  "In[1752]:=",ExpressionUUID->"24f1b5c9-ef52-4d70-bb49-bacfa74127f8"],

Cell["\<\
The SetAttributes[..,NHoldFirst] below is needed to prevent {var[1],var[2]..} \
resolutions of a multidimensional variable being converted into \
{var[1.],var[2.]..} forms upon applying N, which cannot be evaluated. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.661161479595036*^9, 3.6611615874709253`*^9}, {
  3.661161636173225*^9, 
  3.66116165832467*^9}},ExpressionUUID->"2aa71410-ea3f-43dd-9d6f-\
4301070c97fb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExpandMultidimensionalEnsembleVariables", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", 
      RowBox[{"vars_", ",", "valws_"}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "multidensvar", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"multidensvar", "=", 
        RowBox[{"MultidimensionalEnsembleVariables", "[", 
         RowBox[{"{", 
          RowBox[{"vars", ",", "valws"}], "}"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"SetAttributes", "[", 
          RowBox[{
           RowBox[{"Evaluate", "[", 
            RowBox[{"First", "[", "#", "]"}], "]"}], ",", "NHoldFirst"}], 
          "]"}], "&"}], "/@", "multidensvar"}], ";", "\[IndentingNewLine]", 
       RowBox[{"ReleaseHold", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Hold", "[", "expr", "]"}], "/.", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"Rule", "[", 
             RowBox[{
              RowBox[{"First", "[", "#", "]"}], ",", 
              RowBox[{"Array", "[", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], ",", 
                RowBox[{"Last", "[", "#", "]"}]}], "]"}]}], "]"}], "&"}], "/@",
            "multidensvar"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429176629458523`*^9, 3.642917679934267*^9}, {
   3.642917778451037*^9, 3.642917814535918*^9}, 3.6429179138830557`*^9, {
   3.642918227408184*^9, 3.64291823280046*^9}, {3.642939823233528*^9, 
   3.642939825367877*^9}, {3.642939865186502*^9, 3.642939866910304*^9}, 
   3.642942939813946*^9, 3.6577149331845617`*^9, 3.657714981659852*^9, {
   3.661160748470437*^9, 3.661160815080768*^9}, {3.661160845441309*^9, 
   3.661160894303584*^9}, {3.661160995037784*^9, 3.661161000892263*^9}, {
   3.683217620463871*^9, 3.683217630829874*^9}, {3.683217762316778*^9, 
   3.683217792135125*^9}},
 CellLabel->
  "In[1753]:=",ExpressionUUID->"db9bd7a7-ef37-4351-bb59-e29e3431a28d"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["EnsembleVariablesSubstitutionRules", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, 
   3.507987350544482*^9, {3.642747617248518*^9, 3.6427476238293056`*^9}, {
   3.642846222486425*^9, 3.642846230158252*^9}, {3.642873183457076*^9, 
   3.6428731901441708`*^9}, 3.6429386904947767`*^9, 3.642939065678797*^9, {
   3.642939387730214*^9, 
   3.6429393916994953`*^9}},ExpressionUUID->"d484d08e-71c2-48ea-bcdb-\
db005ffef9ca"],

Cell["\<\
takes an EnsembleAverage specification and derives a set of variable \
substitution rules for each element. The substitution rules include arrayed \
forms of multidimensional variables.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.6429410880697613`*^9, 
  3.6429411427022133`*^9}},ExpressionUUID->"37d7a533-ae8b-4878-93b9-\
48aa9a48ee6d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EnsembleVariablesSubstitutionRules", "[", "expr_", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{"expr", ",", "$Failed"}], "]"}]}]}], ":=", "$Failed"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429393579744463`*^9, 3.642939375116969*^9}},
 CellLabel->
  "In[1754]:=",ExpressionUUID->"9804cbec-9ff1-4f76-830f-b6a588400d04"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EnsembleVariablesSubstitutionRules", "[", 
     RowBox[{"{", 
      RowBox[{"vars_", ",", "valws_"}], "}"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vars", ",", "valws"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"_List", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_List", ",", 
              RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}],
          "}"}]}], "]"}]}], "||", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Length", "[", "vars", "]"}], "\[NotEqual]", 
      RowBox[{"Length", "[", 
       RowBox[{"valws", "\[LeftDoubleBracket]", 
        RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}]}]}], ":=", 
   RowBox[{"EnsembleVariablesSubstitutionRules", "@", 
    RowBox[{"StandardizeEnsembleAverage", "[", 
     RowBox[{"{", 
      RowBox[{"vars", ",", "valws"}], "}"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6428462391144257`*^9, 3.642846386386539*^9}, {
  3.642873198313826*^9, 3.6428732005880537`*^9}},
 CellLabel->
  "In[1755]:=",ExpressionUUID->"96f18df0-f3df-428d-9c54-2e7dd71be8e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EnsembleVariablesSubstitutionRules", "[", 
     RowBox[{"{", 
      RowBox[{"vars_", ",", "valws_"}], "}"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"MultidimensionalEnsembleVariables", "[", 
        RowBox[{"{", 
         RowBox[{"vars", ",", "valws"}], "}"}], "]"}], ",", 
       RowBox[{"{", "}"}]}], "]"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"EnsembleVariablesSubstitutionRules", "@", "\[IndentingNewLine]", 
    RowBox[{"StandardizeEnsembleAverage", "[", "\[IndentingNewLine]", 
     RowBox[{"MapAt", "[", 
      RowBox[{"Flatten", ",", "\[IndentingNewLine]", 
       RowBox[{"ReleaseHold", "@", 
        RowBox[{"ExpandMultidimensionalEnsembleVariables", "[", 
         RowBox[{
          RowBox[{"Evaluate", "@", 
           RowBox[{"{", 
            RowBox[{"vars", ",", "valws"}], "}"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"vars", ",", "valws"}], "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", "1"}], "]"}], "\[IndentingNewLine]", "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429390159187813`*^9, 3.642939097980088*^9}, {
  3.642939192297415*^9, 3.642939206054418*^9}, {3.6429398862460003`*^9, 
  3.642939888212915*^9}, {3.6429429723293333`*^9, 3.642943004178673*^9}, {
  3.642943113871477*^9, 3.642943139264845*^9}, {3.683217648462797*^9, 
  3.683217651901374*^9}},
 CellLabel->
  "In[1756]:=",ExpressionUUID->"bba1fce1-109f-4ec2-a881-2a41e906f306"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EnsembleVariablesSubstitutionRules", "[", 
     RowBox[{"{", 
      RowBox[{"vars_", ",", "valws_"}], "}"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"MultidimensionalEnsembleVariables", "[", 
       RowBox[{"{", 
        RowBox[{"vars", ",", "valws"}], "}"}], "]"}], ",", 
      RowBox[{"{", "}"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vals", ",", "nvar"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vals", "=", 
        RowBox[{"First", "/@", "valws"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"nvar", "=", 
        RowBox[{"Length", "[", "vars", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Transpose", "@", 
        RowBox[{"Map", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Function", "[", 
              RowBox[{"val", ",", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "\[Rule]", "val"}]}], "]"}],
              "/@", 
             RowBox[{"Last", "[", "#", "]"}]}], ")"}], "&"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
              "vars", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
              ",", 
              RowBox[{
               RowBox[{
                RowBox[{"Part", "[", 
                 RowBox[{"#", ",", "i"}], "]"}], "&"}], "/@", "vals"}]}], 
             "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", "nvar"}], "}"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.64284640698577*^9, 3.6428464409636183`*^9}, {
   3.6428464993901463`*^9, 3.6428464997914467`*^9}, {3.642847510157514*^9, 
   3.6428475389913588`*^9}, {3.642847621853475*^9, 3.642847622007794*^9}, {
   3.642871844562622*^9, 3.642871901427628*^9}, {3.64287202590245*^9, 
   3.642872027851728*^9}, 3.64287320282227*^9, 3.6429391167712603`*^9, {
   3.642939219802113*^9, 3.642939225320322*^9}},
 CellLabel->
  "In[1757]:=",ExpressionUUID->"a53b9d16-d8dd-44d7-8ae7-870f68e0adf5"]
}, Closed]],

Cell[CellGroupData[{

Cell["EnsembleVariablesFreeQ", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, 
   3.507987350544482*^9, {3.642747617248518*^9, 3.6427476238293056`*^9}, {
   3.642846222486425*^9, 3.642846230158252*^9}, {3.642873183457076*^9, 
   3.6428731901441708`*^9}, 3.6429386904947767`*^9, 3.642939065678797*^9, {
   3.642939387730214*^9, 3.6429393916994953`*^9}, {3.643009547414784*^9, 
   3.643009548415351*^9}},ExpressionUUID->"e2698725-58dc-4a1b-9959-\
a866bdd9bbec"],

Cell["\<\
determines whether an expression is free of all ensemble variables\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.643009552982834*^9, 
  3.64300956853131*^9}},ExpressionUUID->"2d2701f2-b164-458d-994f-\
5c66e1271e5a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EnsembleVariablesFreeQ", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"(", 
      RowBox[{"None", "|", "False"}], ")"}]}], "]"}], ":=", "True"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.643009572963627*^9, 3.6430096159645357`*^9}, {
  3.722429760007815*^9, 3.722429765074533*^9}},
 CellLabel->
  "In[1758]:=",ExpressionUUID->"8692ab79-0fbf-448f-b04d-3d4784e9664a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EnsembleVariablesFreeQ", "[", 
     RowBox[{"expr_", ",", 
      RowBox[{"{", 
       RowBox[{"vars_", ",", "valws_"}], "}"}]}], "]"}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vars", ",", "valws"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"_List", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"_List", ",", 
              RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}],
          "}"}]}], "]"}]}], "||", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Length", "[", "vars", "]"}], "\[NotEqual]", 
      RowBox[{"Length", "[", 
       RowBox[{"valws", "\[LeftDoubleBracket]", 
        RowBox[{"1", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]}]}]}], ":=", 
   RowBox[{"EnsembleVariablesFreeQ", "[", 
    RowBox[{"expr", ",", 
     RowBox[{"StandardizeEnsembleAverage", "[", 
      RowBox[{"{", 
       RowBox[{"vars", ",", "valws"}], "}"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.643009630370162*^9, 3.643009657513218*^9}},
 CellLabel->
  "In[1759]:=",ExpressionUUID->"50fb5ffb-6085-4525-9287-98e4c2d11976"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EnsembleVariablesFreeQ", "[", 
    RowBox[{"expr_", ",", 
     RowBox[{"{", 
      RowBox[{"vars_", ",", "valws_"}], "}"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"And", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"FreeQ", "[", 
        RowBox[{"expr", ",", "#"}], "]"}], "&"}], "/@", "vars"}], ")"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.643009669068266*^9, 3.643009700996972*^9}},
 CellLabel->
  "In[1760]:=",ExpressionUUID->"c5a86212-677a-4ea0-88f3-213f13f73b1d"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, 
   3.507987350544482*^9, {3.642747617248518*^9, 
   3.642747631007298*^9}},ExpressionUUID->"a609b5a9-9e86-4b8d-a6b1-\
078a71fc4420"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EnsembleAverage", "::", "badvar"}], "=", 
   "\"\<One or more ensemble average variables already has an assigned value.\
\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6428722694050417`*^9, 3.642872294978662*^9}, {
  3.642873119054124*^9, 3.642873120701045*^9}},
 CellLabel->
  "In[1761]:=",ExpressionUUID->"5659473a-2346-43e4-b002-c906ea591433"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EnsembleAverage", "::", "toomanyvars"}], "=", 
   "\"\<The number of ensemble average variables exceeds the dimension of the \
ensemble average values.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6427478468651943`*^9, 3.642747886082192*^9}},
 CellLabel->
  "In[1762]:=",ExpressionUUID->"f3d53d8e-de6e-418b-bfb2-1b0019e019fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EnsembleAverage", "::", "inconslengths"}], "=", 
   "\"\<The ensemble average values have inconsistent lengths.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6427482750957527`*^9, 3.6427482917570744`*^9}},
 CellLabel->
  "In[1763]:=",ExpressionUUID->"c1474105-36ac-4bdf-9315-d43dbc64c894"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"EnsembleAverage", "::", "ambig"}], "=", 
    "\"\<The syntax is ambiguous. Equally weighted values of dimension `1` \
have been assumed.\>\""}], ";"}], " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.642749683820735*^9, 3.642749689804624*^9}, {
   3.64274973353588*^9, 3.642749764193712*^9}, {3.642749846741538*^9, 
   3.642749864000781*^9}, 3.642871265204175*^9},
 CellLabel->
  "In[1764]:=",ExpressionUUID->"4a003365-3f35-411d-9db4-a2bc609d1c1e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EnsembleAverage", "::", "badspec"}], "=", 
   "\"\<Cannot interpret EnsembleAverage specification.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6429417444094687`*^9, 3.642941758292055*^9}, {
  3.642942486163621*^9, 3.6429424918891897`*^9}},
 CellLabel->
  "In[1765]:=",ExpressionUUID->"fe8e1158-b456-4335-b4b4-565e0e77e69f"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Parallel", "Subchapter",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.45268559236838*^9, 3.452685596612178*^9}, 
   3.452685977341175*^9, {3.456221032206551*^9, 3.456221041675785*^9}, 
   3.456387573527132*^9, {3.533046062439581*^9, 3.533046079306073*^9}, 
   3.533046828844969*^9, {3.565959721007791*^9, 3.5659597305902767`*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"1cdba7bf-5669-43b1-af21-2c12cae3310f"],

Cell[CellGroupData[{

Cell["Parallel", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.5659597342388773`*^9, 3.565959737101898*^9}, 
   3.570346719306499*^9},ExpressionUUID->"f120f95b-e11a-44c9-a1bf-\
9a2d11341128"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Parallel", "::", "toomany"}], "=", 
   "\"\<The number of requested kernels is too high. Calculation is \
proceeding with `1` kernels\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570346632308558*^9, 3.570346667677554*^9}, {
  3.5703467308656597`*^9, 3.5703467659843903`*^9}},
 CellLabel->
  "In[1766]:=",ExpressionUUID->"afc120b5-9fa8-4f19-b40e-8d8d202dfd1a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Parallel", "::", "inval"}], "=", 
   "\"\<The value of Parallel is invalid.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570346632308558*^9, 3.570346667677554*^9}, 
   3.570346776058858*^9},
 CellLabel->
  "In[1767]:=",ExpressionUUID->"be765ace-b974-48d6-a22c-5058f79ac0ba"]
}, Closed]],

Cell[CellGroupData[{

Cell["PrepareParallel", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.5659597342388773`*^9, 3.565959737101898*^9}, {
  3.7136986358767185`*^9, 3.713698636636607*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"43b0a01a-e605-458c-a5f1-a5fd12b6ec63"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "PrepareParallel", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Parallel", "\[Rule]", "True"}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5703461530414133`*^9, 3.5703461647935963`*^9}},
 CellLabel->
  "In[1768]:=",ExpressionUUID->"2578657e-6d5b-4d2b-9a89-f2f9f299da57"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrepareParallel", "[", "opts___Rule", "]"}], ":=", 
   RowBox[{"PrepareParallel", "[", 
    RowBox[{
     RowBox[{"OperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5703444678293858`*^9, 3.57034450458134*^9}, {
   3.573635612100655*^9, 3.573635612691197*^9}, 3.573638385474079*^9, {
   3.7131150560365715`*^9, 3.7131150715558243`*^9}, {3.713115466209565*^9, 
   3.7131154679587874`*^9}},
 CellLabel->
  "In[1769]:=",ExpressionUUID->"3f26689f-4cca-407d-abd6-56c337858665"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrepareParallel", "[", 
    RowBox[{"opbasis_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"PrepareParallel", "[", 
    RowBox[{"opbasis", ",", 
     RowBox[{"ZeemanBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5703444678293858`*^9, 3.570344488532195*^9}, {
  3.7131150229075627`*^9, 3.7131150247867804`*^9}},
 CellLabel->
  "In[1770]:=",ExpressionUUID->"60a9a46a-eb5c-4c4f-bd4b-bb9f2ef708fa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PrepareParallel", "[", 
     RowBox[{"opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Parallel", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "PrepareParallel", "]"}]}], ",", 
        RowBox[{"True", "|", "All", "|", 
         RowBox[{"_", "?", "IntegerQ"}]}]}], "]"}]}], "||", 
     "\[IndentingNewLine]", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Parallel", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "PrepareParallel", "]"}]}], ")"}], "<", 
       "0"}], "]"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Parallel", "::", "inval"}], "]"}], ";", "$Failed"}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.570346195716674*^9, 3.570346263467668*^9}, {
   3.5703462984014673`*^9, 3.570346299232018*^9}, {3.5703466919187737`*^9, 
   3.570346693421026*^9}, {3.570346871896903*^9, 3.570346955513183*^9}, {
   3.5703470201318407`*^9, 3.570347022963469*^9}, {3.570347264540843*^9, 
   3.570347265721712*^9}, 3.570347472990398*^9},
 CellLabel->
  "In[1771]:=",ExpressionUUID->"7ed53c72-332b-4ecb-80a2-2745a32b3a6c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PrepareParallel", "[", 
     RowBox[{"opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "parallel", ",", "nkernelsrunning", ",", "nkernelsrequested", ",", 
        "path", ",", "chronology", ",", "stufftodistribute", ",", "ul"}], 
       "}"}], ",", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"parallel", "=", 
         RowBox[{
          RowBox[{"Parallel", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "PrepareParallel", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{"parallel", ",", 
             RowBox[{"True", "|", "All"}]}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{"$ProcessorCount", ">", "$KernelCount"}], "]"}]}], ",", 
          "\[IndentingNewLine]", "\t", 
          RowBox[{"LaunchKernels", "[", 
           RowBox[{"$ProcessorCount", "-", "$KernelCount"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"IntegerQ", "[", "parallel", "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{"parallel", ">", "$ProcessorCount"}], "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{"parallel", ">", "$KernelCount"}], "]"}]}], ",", 
          "\[IndentingNewLine]", "\t", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Message", "[", 
             RowBox[{"PrepareParallel", "::", "nonparkernels"}], "]"}], ";", 
            "\[IndentingNewLine]", "\t", 
            RowBox[{"LaunchKernels", "[", 
             RowBox[{"parallel", "-", "$KernelCount"}], "]"}]}], ")"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"IntegerQ", "[", "parallel", "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{"parallel", ">", "$KernelCount"}], "]"}]}], ",", 
          "\[IndentingNewLine]", "\t", 
          RowBox[{"LaunchKernels", "[", 
           RowBox[{"parallel", "-", "$KernelCount"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"IntegerQ", "[", "parallel", "]"}], "&&", 
           RowBox[{"TrueQ", "[", 
            RowBox[{"parallel", "<", "$KernelCount"}], "]"}]}], ",", 
          "\[IndentingNewLine]", "\t", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Message", "[", 
             RowBox[{"PrepareParallel", "::", "relaunch"}], "]"}], ";", 
            "\[IndentingNewLine]", "\t", 
            RowBox[{"CloseKernels", "[", "]"}], ";", "\[IndentingNewLine]", 
            "\t", 
            RowBox[{"LaunchKernels", "[", "parallel", "]"}]}], ")"}], ",", 
          "\[IndentingNewLine]", "True", ",", "\[IndentingNewLine]", "\t", 
          "Null"}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"$KernelID", "==", "0"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"path", "=", "$Path"}], ";", "\[IndentingNewLine]", 
            RowBox[{"chronology", "=", "$Chronology"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"DistributeDefinitions", "[", 
             RowBox[{"path", ",", "chronology"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"ul", "=", 
             RowBox[{"UserLevel", "[", "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"ParallelEvaluate", "[", 
             RowBox[{"$Path", "=", "path"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"ParallelEvaluate", "[", 
             RowBox[{"$Chronology", "=", "chronology"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"DistributeDefinitions", "[", 
             RowBox[{
              RowBox[{"SpinSystem", "[", "]"}], ",", 
              RowBox[{"Basis", "[", "]"}], ",", 
              RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], "]"}], ";"}],
            "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"ParallelNeeds", "[", "\"\<SpinDynamica`\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ParallelEvaluate", "[", 
         RowBox[{"Quiet", "@", 
          RowBox[{"SetUserLevel", "[", "ul", "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ParallelEvaluate", "[", 
         RowBox[{"Quiet", "@", 
          RowBox[{"SetSpinSystem", "[", 
           RowBox[{"SpinSystem", "[", "basis", "]"}], "]"}]}], "]"}], ";", 
        "\n", "\t", 
        RowBox[{"ParallelEvaluate", "[", 
         RowBox[{"Quiet", "@", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"basis", "===", 
             RowBox[{"Basis", "[", "]"}]}], ",", "Nothing", ",", 
            RowBox[{"SetBasis", "[", "basis", "]"}]}], "]"}]}], "]"}], ";", 
        "\n", "\t", 
        RowBox[{"ParallelEvaluate", "[", 
         RowBox[{"Quiet", "@", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"opbasis", "===", 
             RowBox[{"OperatorBasis", "[", "]"}]}], ",", "Nothing", ",", 
            RowBox[{"SetOperatorBasis", "[", "opbasis", "]"}]}], "]"}]}], 
         "]"}], ";", "\n", "\t", 
        RowBox[{"stufftodistribute", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"SpinSystem", "[", "]"}], ",", 
           RowBox[{"Basis", "[", "]"}], ",", 
           RowBox[{"OperatorBasis", "[", "]"}], ",", "$RecursionLimit", ",", 
           "$IterationLimit", ",", "$ChopThreshold", ",", "$Chronology"}], 
          "}"}]}], ";", "\n", "\t", 
        RowBox[{"DistributeDefinitions", "[", "stufftodistribute", "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"ParallelEvaluate", "[", "stufftodistribute", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"DistributeDefinitions", "[", 
         RowBox[{
         "\"\<Global`\>\"", ",", "\"\<General`PhysicalConstants`\>\""}], 
         "]"}], ";"}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}], 
  " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5659597405228863`*^9, 3.565959794820539*^9}, {
   3.566308513813841*^9, 3.5663085152066803`*^9}, {3.570344355826043*^9, 
   3.5703443650397587`*^9}, {3.570344895560005*^9, 3.5703448992600737`*^9}, {
   3.570346027966632*^9, 3.570346060000032*^9}, {3.57034610059522*^9, 
   3.570346177546124*^9}, {3.570346280682013*^9, 3.570346419533489*^9}, {
   3.570346473423524*^9, 3.570346479199448*^9}, {3.5703465128814163`*^9, 
   3.570346523342997*^9}, {3.570542096063176*^9, 3.570542115750395*^9}, {
   3.5705423618768044`*^9, 3.570542702035592*^9}, {3.570542735698241*^9, 
   3.570542813105939*^9}, {3.570542905013208*^9, 3.570542910104897*^9}, 
   3.570542996016033*^9, {3.5705431207631187`*^9, 3.5705431415383244`*^9}, {
   3.57054328893822*^9, 3.570543298152245*^9}, {3.570543926837233*^9, 
   3.570544006897215*^9}, {3.570796510098917*^9, 3.570796515468453*^9}, {
   3.570797044481374*^9, 3.570797047961137*^9}, {3.570811708805113*^9, 
   3.570811737528631*^9}, {3.570884748650909*^9, 3.570884774182358*^9}, {
   3.5736355665074*^9, 3.573635570272338*^9}, {3.573635672211985*^9, 
   3.573635786413437*^9}, {3.573636533656402*^9, 3.5736365562922163`*^9}, 
   3.573636595672402*^9, {3.5736383294808083`*^9, 3.5736383491736383`*^9}, 
   3.5776216278412247`*^9, {3.579870446212014*^9, 3.579870446500402*^9}, {
   3.5798709729436502`*^9, 3.579870978249331*^9}, {3.592988731408965*^9, 
   3.592988770629465*^9}, {3.592988887074868*^9, 3.5929888915679703`*^9}, {
   3.6205812308791733`*^9, 3.620581269132387*^9}, {3.62946667153225*^9, 
   3.629466731035145*^9}, {3.629466926394682*^9, 3.629466943257262*^9}, 
   3.6294670085232143`*^9, {3.639583783813465*^9, 3.639583806808364*^9}, 
   3.639584044921756*^9, {3.6395849289650803`*^9, 3.639584938177549*^9}, {
   3.657730451158465*^9, 3.65773051680359*^9}, {3.657730551035067*^9, 
   3.6577305565616417`*^9}, {3.7027097229436426`*^9, 
   3.7027097834953203`*^9}, {3.702709844584635*^9, 3.702709862488923*^9}, {
   3.7027103452489815`*^9, 3.702710345385115*^9}, {3.7027275066146917`*^9, 
   3.702727511046077*^9}, {3.7027275444618845`*^9, 3.7027276199982405`*^9}, {
   3.702727658732856*^9, 3.7027276589887733`*^9}, {3.702728862699436*^9, 
   3.7027289124586153`*^9}, {3.7027289518191547`*^9, 
   3.7027289711788316`*^9}, {3.7039198713893833`*^9, 3.703919975359326*^9}, {
   3.7039200140985923`*^9, 3.703920035738411*^9}, {3.703920099318185*^9, 
   3.7039201917219396`*^9}, {3.7039202488789177`*^9, 3.703920305262965*^9}, {
   3.703920340025774*^9, 3.7039203409240675`*^9}, {3.713115112253389*^9, 
   3.71311512015506*^9}, {3.7131151553408527`*^9, 3.713115161018524*^9}, {
   3.713115265889943*^9, 3.713115303696686*^9}, {3.713115345382719*^9, 
   3.713115348136629*^9}, {3.7131153994115477`*^9, 3.713115417628652*^9}, {
   3.7136977284627714`*^9, 3.713697781472501*^9}, {3.7136978361069098`*^9, 
   3.713697851182539*^9}, {3.713697886361947*^9, 3.713697999617491*^9}, {
   3.7136980307086926`*^9, 3.7136980425313435`*^9}, {3.7136980796570005`*^9, 
   3.7136981516882005`*^9}, {3.7136981862901335`*^9, 
   3.7136981957190924`*^9}, {3.713698282931387*^9, 3.7136982831276464`*^9}, {
   3.713698367288762*^9, 3.7136983789786224`*^9}, {3.7136984288378267`*^9, 
   3.7136984953669796`*^9}, {3.7136986049371095`*^9, 3.713698605213378*^9}, {
   3.7137707828570757`*^9, 3.7137707877676992`*^9}, 3.713783273423442*^9, 
   3.7137835330600753`*^9, {3.7260035726037536`*^9, 3.7260035749475083`*^9}, {
   3.7260036223459387`*^9, 3.726003628582618*^9}, {3.7260062711970596`*^9, 
   3.72600627646385*^9}, {3.745509696513242*^9, 
   3.745509799444583*^9}},ExpressionUUID->"56b75acc-b6c6-40b2-8eab-\
52b1112c0c5f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrepareParallel", "::", "relaunch"}], "=", 
   "\"\<Closing and relaunching kernels since the requested number of \
parallel kernels is less than those already running.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5705432489840384`*^9, 3.570543280928747*^9}, {
  3.570543314455514*^9, 3.5705433364277554`*^9}, {3.57079701492843*^9, 
  3.57079701882866*^9}},
 CellLabel->
  "In[1773]:=",ExpressionUUID->"c69f66df-4865-4a79-893a-c2c3f0151e4a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PrepareParallel", "::", "nonparkernels"}], "=", 
   "\"\<The number of requested kernels is more than the number of \
processors, so the kernels will not all run in parallel. Proceeding anyway.\>\
\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5705432489840384`*^9, 3.570543280928747*^9}, {
  3.570543314455514*^9, 3.5705433364277554`*^9}, {3.570543859645702*^9, 
  3.5705439041661177`*^9}},
 CellLabel->
  "In[1774]:=",ExpressionUUID->"9428deca-9c31-4fb3-bc84-5f292beefa34"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["NormalizationFactor", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{{3.461320196487152*^9, 3.461320199130999*^9}, {
   3.461322172862348*^9, 3.461322178107759*^9}, {3.5331768076973743`*^9, 
   3.533176810645401*^9}, {3.533207219481163*^9, 3.533207225329205*^9}, {
   3.682614135168255*^9, 3.682614142389533*^9}, 
   3.683132197313528*^9},ExpressionUUID->"8404bbee-00d8-474d-a3b1-\
84c2d0ff8960"],

Cell[CellGroupData[{

Cell["Normalization (obsolete)", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.461320196487152*^9, 3.461320199130999*^9}, {
  3.461322172862348*^9, 3.461322178107759*^9}, {3.5331768076973743`*^9, 
  3.533176810645401*^9}, {3.533207234612897*^9, 
  3.533207237583701*^9}},ExpressionUUID->"f8376509-45d6-40bc-88d3-\
cc4b0c30d57f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Normalization", ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Normalization", "::", "usage"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533207240602182*^9, 3.533207258261868*^9}, 
   3.533207370488759*^9, {3.623342556544882*^9, 3.623342557864008*^9}},
 CellLabel->
  "In[1775]:=",ExpressionUUID->"cf30830c-e446-42d7-891f-fc13d96eb62f"]
}, Closed]],

Cell[CellGroupData[{

Cell["NormalizationFactor", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.461320196487152*^9, 3.461320199130999*^9}, {
  3.461322172862348*^9, 3.461322178107759*^9}, {3.5331768076973743`*^9, 
  3.533176810645401*^9}},ExpressionUUID->"f86874a2-cf61-4b34-8d7b-\
5eb1269d9265"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NormalizationFactor", "::", "zero"}], "=", 
    "\"\<NormalizationFactor cannot be zero. Continuing without \
normalization.\>\""}], ";"}], "  "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533176813922866*^9, 3.533176852931397*^9}},
 CellLabel->
  "In[1776]:=",ExpressionUUID->"cecf3270-e196-4935-afb6-416624080dfa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"NormalizationFactor", "::", "bad"}], "=", 
    "\"\<Inappropriate value for NormalizationFactor.\>\""}], ";"}], 
  "  "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533176813922866*^9, 3.533176852931397*^9}, {
  3.533176920863854*^9, 3.533176939841555*^9}},
 CellLabel->
  "In[1777]:=",ExpressionUUID->"f82737d2-ce03-4aed-b183-aad569396d01"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["local routines", "Subchapter",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4553332615084953`*^9, 3.4553332635463343`*^9}, 3.45633123998427*^9, {
   3.462856583205394*^9, 3.462856584467523*^9}, {3.464327973738139*^9, 
   3.464327976586143*^9}, 3.497377191025092*^9, 3.5079870163866787`*^9, {
   3.642747540519401*^9, 3.642747547583919*^9}, {3.713271396884931*^9, 
   3.713271397955665*^9}, {3.7220528814942017`*^9, 
   3.722052883442943*^9}},ExpressionUUID->"63aef8ef-6f9e-4994-aa74-\
25ea81cb2a7c"],

Cell[CellGroupData[{

Cell["Status routines", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.72205289130439*^9, 
   3.7220528964415073`*^9}},ExpressionUUID->"8d4d7a88-0f95-4712-9d76-\
3c8f0097c90d"],

Cell[CellGroupData[{

Cell["status patterns", "Subsubsection",
 CellChangeTimes->{{3.721755257829026*^9, 3.721755269084174*^9}, {
  3.72175545354712*^9, 
  3.721755498912274*^9}},ExpressionUUID->"aa5ff608-1973-431e-9c0f-\
79e04a9bbd94"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SingleStatusPattern", "=", 
   RowBox[{"True", "|", "False", "|", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"True", "|", "False"}], ")"}], "..."}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"StatusListPattern", "=", 
   RowBox[{"SingleStatusPattern", "|", 
    RowBox[{"{", 
     RowBox[{"SingleStatusPattern", ".."}], "}"}], "|", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"SingleStatusPattern", ".."}], "}"}], "|", 
        "SingleStatusPattern"}], ")"}], ".."}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"GeneralStatusListPattern", "=", 
   RowBox[{"SingleStatusPattern", "|", "StatusListPattern", "|", 
    RowBox[{"{", 
     RowBox[{"StatusListPattern", "..."}], "}"}]}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700572856981989*^9, 3.700572869188698*^9}, 
   3.7005730073294277`*^9, {3.7005730596997633`*^9, 3.700573136257099*^9}, {
   3.700573178219075*^9, 3.700573221600915*^9}, {3.700573284729032*^9, 
   3.7005732923973827`*^9}},
 CellLabel->
  "In[1778]:=",ExpressionUUID->"3ddf605c-5468-4580-b9b3-42d030fb36df"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["TransformationAmplitudeBounds", "Chapter",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.45268559236838*^9, 3.452685596612178*^9}, 
   3.452685977341175*^9, {3.456221032206551*^9, 3.456221041675785*^9}, 
   3.456387573527132*^9, {3.456508634043894*^9, 3.456508635514103*^9}, {
   3.497529605471568*^9, 3.4975296086541243`*^9}, {3.505019908545583*^9, 
   3.505019916694314*^9}, {3.505019947230769*^9, 3.505019955491987*^9}, 
   3.722473844805752*^9},ExpressionUUID->"5c11b280-3f12-423b-a38c-\
d477f63d79ed"],

Cell[CellGroupData[{

Cell["trap MaximumTransformationAmplitude", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.509890958854889*^9, 3.5098909645578957`*^9}, {
  3.509891167092675*^9, 3.5098911716419077`*^9}, {3.7225584530531807`*^9, 
  3.722558460046748*^9}},ExpressionUUID->"a48065c8-d5b3-4316-a898-\
3f4639b6c666"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximumTransformationAmplitude", "[", "args___", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"MaximumTransformationAmplitude", "::", "usage"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.722558466055184*^9, 3.722558499611628*^9}},
 CellLabel->
  "In[1781]:=",ExpressionUUID->"3e5c3c97-2c31-4b1d-b06d-475ce1f29826"]
}, Closed]],

Cell[CellGroupData[{

Cell["general", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, 
   3.502510261662442*^9},ExpressionUUID->"48a5f51e-2a40-494f-838a-\
fba4750a1adb"],

Cell[CellGroupData[{

Cell["options", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
  3.462796315357738*^9}, {3.533213181227337*^9, 
  3.533213182104349*^9}},ExpressionUUID->"93540379-e57d-4d8c-b6c7-\
3851dea1d58e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "TransformationAmplitudeBounds", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"NormalizationFactor", "\[Rule]", "None"}], "}"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.46279631759762*^9, 3.462796327632659*^9}, {
   3.462796499979474*^9, 3.462796500513019*^9}, {3.4639405693833437`*^9, 
   3.463940573195265*^9}, 3.4648620535854683`*^9, {3.465814564759466*^9, 
   3.465814565148946*^9}, {3.465814951086645*^9, 3.465814954331346*^9}, {
   3.486719403502572*^9, 3.486719404123908*^9}, {3.4973642921097937`*^9, 
   3.497364297163127*^9}, {3.497371897761854*^9, 3.497371906743175*^9}, {
   3.49737232158766*^9, 3.4973723346500463`*^9}, 3.497529619779294*^9, 
   3.497572546269267*^9, {3.5050199660976667`*^9, 3.505019981685699*^9}, {
   3.505022524398131*^9, 3.505022528436545*^9}, {3.5331044641528254`*^9, 
   3.533104464678041*^9}, 3.533176995087632*^9, 3.7224738456623*^9},
 CellLabel->
  "In[1782]:=",ExpressionUUID->"ba8a32c6-23cc-4370-899d-fd19d6aafe11"]
}, Closed]],

Cell[CellGroupData[{

Cell["translate rule input form", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.509890958854889*^9, 3.5098909645578957`*^9}, {
  3.509891167092675*^9, 
  3.5098911716419077`*^9}},ExpressionUUID->"054cab53-b3c6-45c2-b6d9-\
fa17856b3bb4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeBounds", "[", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "ops_"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TransformationAmplitudeBounds", "[", 
     RowBox[{
      RowBox[{"Evaluate", "@", "ops"}], ",", "more", ",", "opts"}], "]"}], 
    "[", "\[Rho]ini", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.509890982675839*^9, 3.509891031125326*^9}, {
   3.509891199252946*^9, 3.509891201017083*^9}, 3.510458466771434*^9, {
   3.7224738464736347`*^9, 3.722473847725912*^9}},
 CellLabel->
  "In[1783]:=",ExpressionUUID->"a482bbcb-954d-4d25-80c7-9df15366703a"]
}, Closed]],

Cell[CellGroupData[{

Cell["NormalizationFactor", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.497372485943301*^9, 3.4973724974441853`*^9}, 3.499291042679791*^9, 
   3.533177008939392*^9},ExpressionUUID->"4d7f56ab-e667-4deb-af0f-\
be62c7f6b374"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{
      RowBox[{"TransformationAmplitudeBounds", "[", 
       RowBox[{"ops_", ",", 
        RowBox[{"more", ":", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
        "opts___Rule"}], "]"}], "[", 
      RowBox[{"\[Rho]ini_", "?", "OperatorQ"}], "]"}]}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"NormalizationFactor", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "TransformationAmplitudeBounds", "]"}]}], ",", 
      
      RowBox[{"None", "|", "False"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"TransformationAmplitudeBounds", "[", 
     RowBox[{"ops", ",", "more", ",", "\[IndentingNewLine]", 
      RowBox[{"Evaluate", "@", 
       RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"NormalizationFactor", "\[Rule]", "1"}], ",", 
         "\[IndentingNewLine]", "opts"}], "]"}]}]}], "\[IndentingNewLine]", 
     "]"}], "[", "\[Rho]ini", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.501997986827223*^9, 3.501998023607252*^9}, {
   3.5020017765030212`*^9, 3.502001801502676*^9}, 3.502003095795176*^9, 
   3.506692225172867*^9, {3.533104433360054*^9, 3.533104458767729*^9}, {
   3.533177018910317*^9, 3.533177021112982*^9}, {3.7224738485549088`*^9, 
   3.722473849846846*^9}},
 CellLabel->
  "In[1784]:=",ExpressionUUID->"a9e2bad5-e9b2-45ee-9464-012423609a8d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{
      RowBox[{"TransformationAmplitudeBounds", "[", 
       RowBox[{"ops_", ",", 
        RowBox[{"more", ":", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
        "opts___Rule"}], "]"}], "[", 
      RowBox[{"\[Rho]ini_", "?", "OperatorQ"}], "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", 
       RowBox[{
        RowBox[{"NormalizationFactor", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "TransformationAmplitudeBounds", "]"}]}], 
       "]"}], "\[Equal]", "0"}], ")"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"NormalizationFactor", "::", "zero"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"TransformationAmplitudeBounds", "[", 
       RowBox[{"ops", ",", "more", ",", "\[IndentingNewLine]", 
        RowBox[{"Evaluate", "@", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"NormalizationFactor", "\[Rule]", "1"}], ",", 
           "\[IndentingNewLine]", "opts"}], "]"}]}]}], "\[IndentingNewLine]", 
       "]"}], "[", "\[Rho]ini", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.501997986827223*^9, 3.501998023607252*^9}, {
   3.5020017765030212`*^9, 3.502001801502676*^9}, 3.502003095795176*^9, 
   3.506692225172867*^9, {3.533104150200594*^9, 3.533104173759008*^9}, {
   3.533104450054908*^9, 3.533104456710986*^9}, {3.533104500953287*^9, 
   3.533104503767408*^9}, {3.533177024600931*^9, 3.5331770328832407`*^9}, {
   3.7224738504970503`*^9, 3.722473851700227*^9}},
 CellLabel->
  "In[1785]:=",ExpressionUUID->"08c55c91-c7a9-4734-bd53-6b0f600611e1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{
      RowBox[{"TransformationAmplitudeBounds", "[", 
       RowBox[{"ops_", ",", 
        RowBox[{"more", ":", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
        "opts___Rule"}], "]"}], "[", 
      RowBox[{"\[Rho]ini_", "?", "OperatorQ"}], "]"}]}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NormalizationFactor", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "TransformationAmplitudeBounds", "]"}]}], ",", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], "|", "None", "|", "False"}]}], 
      "]"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"NormalizationFactor", "::", "badnorm"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.501997986827223*^9, 3.5019980897983723`*^9}, {
   3.5020002608110647`*^9, 3.5020002875539417`*^9}, {3.5020006083926*^9, 
   3.502000609963409*^9}, {3.5020018082971077`*^9, 3.502001814416572*^9}, {
   3.5050201888852654`*^9, 3.505020196243208*^9}, 3.506692234084848*^9, {
   3.533104268252405*^9, 3.5331042820011883`*^9}, {3.5331045088725233`*^9, 
   3.5331045157004013`*^9}, {3.5331770601205597`*^9, 3.53317707226921*^9}, {
   3.7224738525286837`*^9, 3.722473853203367*^9}},
 CellLabel->
  "In[1786]:=",ExpressionUUID->"ffae2cb2-6547-4ef4-9d9f-ddf1dd66f27f"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem, Basis and OperatorBasis", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.502510245476363*^9, 3.502510249180208*^9}, 
   3.502510361079013*^9},ExpressionUUID->"318e7a16-d4bd-4b6c-a122-\
3ca812e1bcda"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeBounds", "[", 
    RowBox[{
     RowBox[{"ops", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_", "?", "OperatorQ"}], ")"}], "|", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeBounds", "[", 
    RowBox[{"ops", ",", 
     RowBox[{"DefaultOperatorBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.454563821094757*^9, 3.454563822278015*^9}, {
   3.4545638764221907`*^9, 3.454563889446521*^9}, {3.454564181051017*^9, 
   3.4545642103756332`*^9}, {3.454564867476873*^9, 3.454564867741087*^9}, {
   3.455271966941128*^9, 3.4552719703405457`*^9}, {3.455272142385132*^9, 
   3.455272145839773*^9}, 3.455275172291848*^9, 3.4562050743530188`*^9, 
   3.456508761374711*^9, {3.4565088256506777`*^9, 3.4565088380189667`*^9}, {
   3.497529694930337*^9, 3.4975296968104553`*^9}, 3.502429511631192*^9, {
   3.505020214430655*^9, 3.505020218693625*^9}, {3.505020286783457*^9, 
   3.505020304032464*^9}, {3.543836049658412*^9, 3.543836050021751*^9}, {
   3.722473854561665*^9, 3.72247385514811*^9}},
 CellLabel->
  "In[1787]:=",ExpressionUUID->"d09a04c9-a6b3-4e47-b9e3-7f5b2127f6ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeBounds", "[", 
    RowBox[{
     RowBox[{"ops", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_", "?", "OperatorQ"}], ")"}], "|", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}]}], ",", "opbasis_", 
     ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeBounds", "[", 
    RowBox[{"ops", ",", "opbasis", ",", 
     RowBox[{"ZeemanBasis", "[", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.429846541720842*^9, 3.429846581379725*^9, {3.454563825254508*^9, 
   3.454563826638453*^9}, {3.454563905455122*^9, 3.4545639089804993`*^9}, {
   3.4545642154878063`*^9, 3.454564239088064*^9}, {3.4545648699969673`*^9, 
   3.454564870236917*^9}, {3.45527197466923*^9, 3.455271976581058*^9}, 
   3.455272150746269*^9, 3.4552751740254707`*^9, 3.456205057735742*^9, {
   3.4565088394293213`*^9, 3.456508850327935*^9}, {3.4975296987873497`*^9, 
   3.497529700746916*^9}, {3.502429514766972*^9, 3.502429515780357*^9}, {
   3.5050202988154173`*^9, 3.5050203099599*^9}, {3.722473856236484*^9, 
   3.722473856821889*^9}},
 CellLabel->
  "In[1788]:=",ExpressionUUID->"b3f86c99-3aba-4642-9ca5-5cdf0b06c5af"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TransformationAmplitudeBounds", "[", 
     RowBox[{
      RowBox[{"ops", ":", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_", "?", "OperatorQ"}], ")"}], "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}]}], ",", "opbasis_",
       ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483598512286263`*^9, 
   3.448359860731179*^9}, {3.448360466346766*^9, 3.448360475974476*^9}, {
   3.448360592630582*^9, 3.448360596506363*^9}, 3.454563828806386*^9, 
   3.4545639120761642`*^9, 3.454564240912786*^9, {3.454564271954568*^9, 
   3.454564286530512*^9}, {3.454564872669664*^9, 3.454564872885377*^9}, 
   3.455271981846101*^9, 3.455272152154932*^9, 3.455275175802754*^9, {
   3.4553763513008337`*^9, 3.455376352469843*^9}, 3.456205398020976*^9, {
   3.4565088545678453`*^9, 3.4565088607175417`*^9}, 3.4975297050191803`*^9, {
   3.50502031397584*^9, 3.505020318246683*^9}, 3.683130851382503*^9, 
   3.7224738574719257`*^9},
 CellLabel->
  "In[1789]:=",ExpressionUUID->"0f06fa5a-dea8-426c-bc73-0dfd540c7843"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeBounds", "[", 
    RowBox[{
     RowBox[{"ops", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_", "?", "OperatorQ"}], ")"}], "|", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}]}], ",", "opbasis_", 
     ",", "Undefined", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "default"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{"SpinSystem", "[", "]"}], "]"}], ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"TransformationAmplitudeBounds", "[", 
      RowBox[{"ops", ",", "opbasis", ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, 3.448360573943112*^9, {
   3.448360607428061*^9, 3.448360654701827*^9}, {3.454563843246985*^9, 
   3.454563845319368*^9}, {3.454563914293174*^9, 3.454563916476424*^9}, {
   3.4545642454662247`*^9, 3.4545642902349997`*^9}, {3.454564874990457*^9, 
   3.454564875262397*^9}, {3.455271984527185*^9, 3.455271987335227*^9}, 
   3.45527215418008*^9, 3.4552751777084007`*^9, 3.456205399659954*^9, {
   3.456508867284601*^9, 3.45650888148532*^9}, {3.497529710300468*^9, 
   3.4975297125325317`*^9}, {3.505020327304719*^9, 3.505020340726982*^9}, 
   3.683130859736133*^9, {3.7224738581616364`*^9, 3.7224738592026253`*^9}},
 CellLabel->
  "In[1790]:=",ExpressionUUID->"af7b37d9-0bd4-470e-9c58-5281265b4385"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeBounds", "[", 
    RowBox[{
     RowBox[{"ops", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_", "?", "OperatorQ"}], ")"}], "|", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}]}], ",", "Undefined",
      ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "unknown"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "default"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOperatorBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}], ",", 
       RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"TransformationAmplitudeBounds", "[", 
      RowBox[{"ops", ",", "opts"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, {3.44835995227402*^9, 
   3.448359994938308*^9}, {3.4483606824647713`*^9, 3.448360738493463*^9}, {
   3.4545638495437107`*^9, 3.454563852615542*^9}, {3.454563918733029*^9, 
   3.454563922100461*^9}, {3.4545642537057667`*^9, 3.454564293851018*^9}, {
   3.45456487755042*^9, 3.454564877774334*^9}, {3.455271990255906*^9, 
   3.455271992495614*^9}, 3.455272156203349*^9, 3.455275179596388*^9, {
   3.456508893964306*^9, 3.456508910282003*^9}, {3.497529715484561*^9, 
   3.49752971898841*^9}, {3.505020346031551*^9, 3.505020360997529*^9}, 
   3.6831308720017033`*^9, {3.722473859974535*^9, 3.722473860681781*^9}},
 CellLabel->
  "In[1791]:=",ExpressionUUID->"3d57cf64-3d7a-4397-ba64-417cea2b28ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TransformationAmplitudeBounds", "[", 
     RowBox[{
      RowBox[{"ops", ":", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_", "?", "OperatorQ"}], ")"}], "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}]}], ",", "opbasis_",
       ",", "basis_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"First", "@", "opbasis"}], "\[NotEqual]", 
      RowBox[{"First", "@", "basis"}]}], ")"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "defaultopbasis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"defaultopbasis", "=", 
        RowBox[{"ZeemanKetBraOperatorBasis", "[", 
         RowBox[{
          RowBox[{"First", "@", "basis"}], ",", 
          RowBox[{"Sorted", "\[Rule]", "True"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{"OperatorBasis", "::", "default"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetOperatorBasis", "[", 
        RowBox[{"defaultopbasis", ",", 
         RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitudeBounds", "[", 
        RowBox[{"ops", ",", "defaultopbasis", ",", "basis", ",", "opts"}], 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, {3.44835995227402*^9, 
   3.448359994938308*^9}, {3.448361307182886*^9, 3.448361363053556*^9}, {
   3.448361419573944*^9, 3.4483614810280848`*^9}, {3.44836151594449*^9, 
   3.448361525098793*^9}, {3.448361569055385*^9, 3.448361573898075*^9}, {
   3.4483616285278997`*^9, 3.448361646636026*^9}, {3.448361938039504*^9, 
   3.448362008292676*^9}, {3.4483637955016203`*^9, 3.448363800986418*^9}, {
   3.45456386018486*^9, 3.4545638626085463`*^9}, {3.454563925910449*^9, 
   3.454563928085649*^9}, {3.4545642586114893`*^9, 3.454564298604599*^9}, {
   3.454564879983574*^9, 3.454564880191662*^9}, {3.4552719949132977`*^9, 
   3.4552719969932947`*^9}, 3.455272157965658*^9, 3.455275181844925*^9, {
   3.456508914270056*^9, 3.456508928915512*^9}, {3.49752972270133*^9, 
   3.497529727589673*^9}, {3.505020366511375*^9, 3.505020380237709*^9}, {
   3.5464495331809587`*^9, 3.546449536542595*^9}, {3.722473861828965*^9, 
   3.722473862665783*^9}},
 CellLabel->
  "In[1792]:=",ExpressionUUID->"46af663d-6f73-4a09-a75a-702769a26ef8"]
}, Closed]],

Cell[CellGroupData[{

Cell["trap non-Hermitian operators", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.502002117857419*^9, 
   3.5020021434008913`*^9}, 3.5020021999478073`*^9, 3.505020395201495*^9, {
   3.505020697642976*^9, 
   3.5050207025530252`*^9}},ExpressionUUID->"256cdb7a-4adb-40de-a7f4-\
75caa5ed460b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"TransformationAmplitudeBounds", "[", 
      RowBox[{
       RowBox[{"op_", "?", "OperatorQ"}], ",", "opbasis_", ",", "basis_", ",",
        "opts___Rule"}], "]"}], "[", 
     RowBox[{"\[Rho]ini_", "?", "OperatorQ"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"HermitianQ", "[", 
      RowBox[{"MatrixRepresentation", "[", 
       RowBox[{"op", ",", "basis"}], "]"}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"TransformationAmplitudeBounds", "::", "nonherm"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5050207136361923`*^9, 3.5050207577771263`*^9}, {
  3.722473863859333*^9, 3.722473864899517*^9}},
 CellLabel->
  "In[1793]:=",ExpressionUUID->"99339a62-3158-4cbb-be77-b606e6cf0833"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"TransformationAmplitudeBounds", "[", 
      RowBox[{
       RowBox[{"op_", "?", "OperatorQ"}], ",", "opbasis_", ",", "basis_", ",",
        "opts___Rule"}], "]"}], "[", 
     RowBox[{"\[Rho]ini_", "?", "OperatorQ"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"HermitianQ", "[", 
      RowBox[{"MatrixRepresentation", "[", 
       RowBox[{"\[Rho]ini", ",", "basis"}], "]"}], "]"}]}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"TransformationAmplitudeBounds", "::", "nonherm"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5050207136361923`*^9, 3.505020768890346*^9}, {
  3.722473865923263*^9, 3.722473866704515*^9}},
 CellLabel->
  "In[1794]:=",ExpressionUUID->"1f92b46e-c92b-4d57-9819-7b1e9d888b8a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["main calculations", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.502002117857419*^9, 
   3.5020021434008913`*^9}, 3.5020021999478073`*^9, {3.507572481822721*^9, 
   3.507572484437044*^9}},ExpressionUUID->"dc180867-5177-46d2-9e14-\
7167bf3325df"],

Cell[CellGroupData[{

Cell["TransformationAmplitudeBounds for single operator", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.502002117857419*^9, 
   3.5020021434008913`*^9}, 3.5020021999478073`*^9, 3.505020395201495*^9, 
   3.722473869752171*^9, {3.722473903316416*^9, 
   3.722473908180708*^9}},ExpressionUUID->"a859b841-a9b4-4ecc-9a6c-\
baa358bff382"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"TransformationAmplitudeBounds", "[", 
      RowBox[{
       RowBox[{"op_", "?", "OperatorQ"}], ",", "opbasis_", ",", "basis_", ",",
        "opts___Rule"}], "]"}], "[", 
     RowBox[{"\[Rho]ini_", "?", "OperatorQ"}], "]"}], "/;", 
    RowBox[{"NumericQ", "[", 
     RowBox[{
      RowBox[{"NormalizationFactor", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "TransformationAmplitudeBounds", "]"}]}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "norm", ",", "\[CapitalLambda]\[Rho]", ",", "\[CapitalLambda]op"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"norm", "=", 
        RowBox[{
         RowBox[{"NormalizationFactor", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeBounds", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"\[CapitalLambda]\[Rho]", "=", 
        RowBox[{"SortBy", "[", 
         RowBox[{
          RowBox[{"Eigenvalues", "[", 
           RowBox[{"MatrixRepresentation", "[", 
            RowBox[{"\[Rho]ini", ",", "basis"}], "]"}], "]"}], ",", "N"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[CapitalLambda]op", "=", 
        RowBox[{"SortBy", "[", 
         RowBox[{
          RowBox[{"Eigenvalues", "[", 
           RowBox[{"MatrixRepresentation", "[", 
            RowBox[{"op", ",", "basis"}], "]"}], "]"}], ",", "N"}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"\[CapitalLambda]\[Rho]", ".", 
           RowBox[{"Reverse", "[", "\[CapitalLambda]op", "]"}]}], "/", 
          RowBox[{"(", 
           RowBox[{"norm", "\[Times]", 
            RowBox[{"\[CapitalLambda]op", ".", "\[CapitalLambda]op"}]}], 
           ")"}]}], ",", 
         RowBox[{
          RowBox[{"\[CapitalLambda]\[Rho]", ".", "\[CapitalLambda]op"}], "/", 
          
          RowBox[{"(", 
           RowBox[{"norm", "\[Times]", 
            RowBox[{"\[CapitalLambda]op", ".", "\[CapitalLambda]op"}]}], 
           ")"}]}]}], "}"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456508639886243*^9, 3.45650868185382*^9}, {
   3.456509037620788*^9, 3.4565091550569553`*^9}, {3.456509306055188*^9, 
   3.456509320760811*^9}, {3.4565093993122263`*^9, 3.456509477912705*^9}, {
   3.456509632074041*^9, 3.456509637733838*^9}, 3.470141403049787*^9, {
   3.4973727977578773`*^9, 3.497372899045732*^9}, {3.4975297537003107`*^9, 
   3.4975297990225973`*^9}, {3.4975298453058577`*^9, 3.497529874792801*^9}, {
   3.497529910031045*^9, 3.4975299700371733`*^9}, {3.497530189072179*^9, 
   3.497530193381241*^9}, {3.5020021573524923`*^9, 3.502002179186638*^9}, {
   3.502010661658701*^9, 3.502010698927549*^9}, {3.505020396912941*^9, 
   3.505020566345888*^9}, {3.505022583816833*^9, 3.505022586045663*^9}, {
   3.529578108321844*^9, 3.5295781111586514`*^9}, {3.5295788182067413`*^9, 
   3.52957883192388*^9}, {3.533177078980104*^9, 3.533177080849074*^9}, {
   3.7224738723970137`*^9, 3.7224738749819937`*^9}, {3.722473915019959*^9, 
   3.72247393942118*^9}},
 CellLabel->
  "In[1795]:=",ExpressionUUID->"679341ed-5ff2-4f9c-9ff2-df2a8cf8ad7a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["several TransformationAmplitudeBounds at the same time", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.456510357569454*^9, 
   3.456510365295979*^9}, {3.497529807096361*^9, 3.497529811925864*^9}, 
   3.5020022052676563`*^9, {3.505022193608006*^9, 3.5050221945593767`*^9}, 
   3.722473876406229*^9, 
   3.72247394593946*^9},ExpressionUUID->"29bc45bb-18a5-4d44-b425-\
ef571ce9f1f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"TransformationAmplitudeBounds", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}], ",", "opbasis_", 
       ",", "basis_", ",", "opts___Rule"}], "]"}], "[", 
     RowBox[{"\[Rho]ini_", "?", "OperatorQ"}], "]"}], "/;", 
    RowBox[{"NumericQ", "[", 
     RowBox[{
      RowBox[{"NormalizationFactor", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "TransformationAmplitudeBounds", "]"}]}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"TransformationAmplitudeBounds", "[", 
        RowBox[{"#", ",", "opts"}], "]"}], "[", "\[Rho]ini", "]"}], ")"}], 
     "&"}], "/@", "ops"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456510372984645*^9, 3.456510416352416*^9}, 
   3.470141406872658*^9, {3.497372916740807*^9, 3.4973729584051847`*^9}, {
   3.497529817090352*^9, 3.497529823936967*^9}, {3.497529983706531*^9, 
   3.4975300383177347`*^9}, {3.4975302053575172`*^9, 3.497530214709453*^9}, {
   3.502002217668207*^9, 3.502002290523698*^9}, {3.502010716922909*^9, 
   3.502010736984891*^9}, {3.50502057945393*^9, 3.505020655768759*^9}, 
   3.53317708343445*^9, {3.722473877468012*^9, 3.7224738792086363`*^9}},
 CellLabel->
  "In[1796]:=",ExpressionUUID->"15810de7-6aa1-43f9-8ec3-ecbcb0635bde"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.456510357569454*^9, 
   3.456510365295979*^9}, {3.497529807096361*^9, 3.497529811925864*^9}, 
   3.5020022052676563`*^9, {3.5050207794453793`*^9, 
   3.505020781531652*^9}},ExpressionUUID->"3b8aa9e2-0e66-4572-9973-\
8142c689feb5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeBounds", "::", "nonherm"}], "=", 
   "\"\<TransformationAmplitudeBounds has only been implemented for Hermitian \
operators.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5050207867904367`*^9, 3.505020809836047*^9}, {
  3.72247388056642*^9, 3.722473882864983*^9}},
 CellLabel->
  "In[1797]:=",ExpressionUUID->"778477ce-fc5c-4707-b905-701f202aa4b5"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Trajectory", "Chapter",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.45268559236838*^9, 3.452685596612178*^9}, 
   3.452685977341175*^9, {3.456221032206551*^9, 3.456221041675785*^9}, 
   3.456387573527132*^9, {3.456508634043894*^9, 3.456508635514103*^9}, {
   3.53300518702918*^9, 3.5330051935941*^9}, 3.53317094624787*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"f1bc8b7b-d128-4429-9b5b-4c5347fdfd88"],

Cell[CellGroupData[{

Cell["general", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, 
   3.5111805238602448`*^9},ExpressionUUID->"1364129d-c7e4-4992-b052-\
b535ff9cfd57"],

Cell[CellGroupData[{

Cell["options", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
  3.462796315357738*^9}, {3.511180548643223*^9, 3.511180551064575*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"d6943771-d4bb-4eed-820c-0b9d0688bf2a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Trajectory", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OperatorBasis", "\[RuleDelayed]", 
      RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Basis", "\[RuleDelayed]", 
      RowBox[{"ZeemanBasis", "[", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"NormalizationFactor", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"UseMatrixExpWhenPossible", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"UseHilbertSpaceWhenPossible", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"UseDiagonalizationWhenPossible", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"InitialTimePoint", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"BackgroundGenerator", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"EnsembleAverage", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"InterpolationPoints", "\[Rule]", "500"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"AccuracyGoal", "\[Rule]", "10"}], ",", " ", 
     "\[IndentingNewLine]", 
     RowBox[{"PrecisionGoal", "\[Rule]", "10"}], ",", "\[IndentingNewLine]", 
     RowBox[{"MaxSteps", "\[Rule]", "Automatic"}], ",", "\[IndentingNewLine]", 
     RowBox[{"MaxStepSize", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"InterpolationStepSize", "\[Rule]", " ", 
      SuperscriptBox["10.", 
       RowBox[{"-", "6"}]]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Chronology", "\[RuleDelayed]", "$Chronology"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Parallel", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"MaxBatchSize", "\[Rule]", "128"}], ",", "\[IndentingNewLine]", 
     RowBox[{"EnsembleVariableDimension", "\[Rule]", "Undefined"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"EnsembleSetUp", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ParallelSetUp", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"EnsembleAverageStandardized", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PolarizationLevelOperatorsChecked", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"MinimumRecommendedUserLevel", "\[Rule]", "2"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.46279631759762*^9, 3.462796327632659*^9}, {
   3.462796499979474*^9, 3.462796500513019*^9}, {3.4639405693833437`*^9, 
   3.463940573195265*^9}, 3.4648620535854683`*^9, {3.465814564759466*^9, 
   3.465814565148946*^9}, {3.465814951086645*^9, 3.465814954331346*^9}, {
   3.486719403502572*^9, 3.486719404123908*^9}, {3.4973642921097937`*^9, 
   3.497364297163127*^9}, {3.497371897761854*^9, 3.497371906743175*^9}, {
   3.49737232158766*^9, 3.4973723346500463`*^9}, 3.497572542270018*^9, {
   3.507967964539795*^9, 3.5079679692385*^9}, {3.511180565189105*^9, 
   3.511180566652227*^9}, {3.5111817568565273`*^9, 3.511181757493741*^9}, {
   3.5144547816418247`*^9, 3.514454790887295*^9}, 3.514799186326868*^9, {
   3.515071543464944*^9, 3.515071544566348*^9}, 3.515078034979989*^9, {
   3.532349446483905*^9, 3.532349456742868*^9}, 3.532439059826687*^9, {
   3.533082264790551*^9, 3.5330822995514507`*^9}, {3.5330836335679293`*^9, 
   3.533083635715336*^9}, {3.533101778189283*^9, 3.5331017787928133`*^9}, 
   3.533177088372941*^9, {3.533305020822483*^9, 3.533305028490658*^9}, {
   3.5333060215967817`*^9, 3.5333060225449343`*^9}, 3.534399021886918*^9, {
   3.542729976553961*^9, 3.542729990822439*^9}, 3.5434989292132893`*^9, {
   3.543515415728628*^9, 3.543515425390691*^9}, {3.543944533879713*^9, 
   3.543944535152514*^9}, 3.545050555234438*^9, {3.552215740759017*^9, 
   3.552215740941823*^9}, {3.5522157836395197`*^9, 3.552215783999215*^9}, {
   3.558606690923038*^9, 3.558606697314704*^9}, {3.561802995278061*^9, 
   3.561803002268405*^9}, {3.561949940592711*^9, 3.561949940755332*^9}, {
   3.5619501927670918`*^9, 3.561950193394458*^9}, 3.561950612738797*^9, {
   3.561975940653287*^9, 3.5619759440660477`*^9}, {3.561975980225223*^9, 
   3.5619760038115673`*^9}, {3.562218710069285*^9, 3.562218715322425*^9}, 
   3.562219094865807*^9, {3.572542292797228*^9, 3.572542293731896*^9}, {
   3.626027699127179*^9, 3.626027699853552*^9}, {3.699598330527219*^9, 
   3.699598337761112*^9}, {3.7028090503152385`*^9, 3.702809055523021*^9}, {
   3.7028159828069963`*^9, 3.7028159874944324`*^9}, {3.702816046418797*^9, 
   3.702816048407116*^9}, 3.7093755170592613`*^9, {3.709381217252412*^9, 
   3.7093812198350763`*^9}, 3.70938189578022*^9, {3.745467633599511*^9, 
   3.745467640502162*^9}, 3.745467760186534*^9, 
   3.745506580893681*^9},ExpressionUUID->"d74001eb-cbc9-4255-af93-\
d0e523fe17bd"]
}, Open  ]],

Cell[CellGroupData[{

Cell["attributes", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
  3.462796315357738*^9}, {3.5066920752301064`*^9, 
  3.506692087435828*^9}},ExpressionUUID->"564fce24-1da3-459d-950b-\
897567f65b61"],

Cell["\<\
HoldAll is needed to allow implementation of EnsembleAverage, and checking of \
the polarization operators\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.469896600541757*^9, 3.4698966136273127`*^9}, {
  3.502883935209774*^9, 3.5028839362384663`*^9}, {3.5316513327127953`*^9, 
  3.531651335709177*^9}, {3.643005879667712*^9, 3.643005880059268*^9}, {
  3.7093872652464*^9, 
  3.709387268652398*^9}},ExpressionUUID->"cbbda62c-fa86-43f5-aa8c-\
f0afdd23f031"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Trajectory", ",", "HoldAll"}], "]"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4698943573427773`*^9, 3.469894367696088*^9}, 
   3.506692150083893*^9, 3.51118053846406*^9, 3.531651354484613*^9, {
   3.70938209278211*^9, 3.709382097629541*^9}},
 CellLabel->
  "In[1799]:=",ExpressionUUID->"590a76a1-de16-4664-9400-a5e801b932dc"]
}, Closed]],

Cell[CellGroupData[{

Cell["special handling of arguments", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
  3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
  3.533211924876773*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"62c3fe94-8ad5-47ba-a5fa-c66c5370922c"],

Cell[CellGroupData[{

Cell["check UserLevel", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469877652562336*^9, 
   3.469877654440535*^9}, {3.4698786125145903`*^9, 3.4698786191211853`*^9}, {
   3.469883247163637*^9, 3.469883260409108*^9}, {3.469905506864237*^9, 
   3.4699055103160048`*^9}, {3.469906283820899*^9, 3.4699063030097322`*^9}, {
   3.469906546731975*^9, 3.4699065510413637`*^9}, 3.469960282710096*^9, {
   3.4701369772984257`*^9, 3.4701369799061337`*^9}, 3.4701379835572653`*^9, 
   3.470138023065645*^9, 3.506761004498254*^9, 3.5068552392209272`*^9, {
   3.508582702189824*^9, 3.5085827136608353`*^9}, {3.508584132512385*^9, 
   3.508584140362259*^9}, {3.508681090619546*^9, 3.508681091425757*^9}, 
   3.508695882316738*^9, {3.509201851881226*^9, 3.5092018570142927`*^9}, {
   3.509205054512384*^9, 3.5092050550265303`*^9}, 3.5094569122955112`*^9, {
   3.509458340046239*^9, 3.5094583442450027`*^9}, {3.509458406147339*^9, 
   3.509458415504978*^9}, 3.515002821795414*^9, {3.621601059179372*^9, 
   3.621601062414098*^9}, {3.657712432385127*^9, 3.6577124412974253`*^9}, {
   3.7093762654742947`*^9, 3.7093762933848352`*^9}, {3.709376455400814*^9, 
   3.709376463082358*^9}, {3.745467522762582*^9, 3.745467525856588*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"6c90bf09-240f-4823-82b0-dc5caac0ccf8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Trajectory", "[", 
    RowBox[{"args1___", ",", 
     RowBox[{"args2", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], ".."}]}], ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ul", ",", "rul"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"UserLevel", "::", "toolow"}], ",", "ul", ",", "rul"}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Trajectory", "[", 
         RowBox[{"args1", ",", "args2", ",", 
          RowBox[{"MinimumRecommendedUserLevel", "\[Rule]", "0"}], ",", 
          "opts"}], "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ul", "=", 
         RowBox[{"UserLevel", "[", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"rul", "=", 
         RowBox[{
          RowBox[{"MinimumRecommendedUserLevel", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Trajectory", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"TrueQ", "[", 
         RowBox[{"ul", "<", "rul"}], "]"}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.745467553302506*^9, 3.745467590277307*^9}, {
  3.745467776130665*^9, 3.745467986122507*^9}, {3.745468118747753*^9, 
  3.745468149184456*^9}, {3.745506582018076*^9, 
  3.745506584490264*^9}},ExpressionUUID->"0900dccf-2abe-4e9e-81ab-\
0fb89a89d90c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["translate rule input form", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469877652562336*^9, 
   3.469877654440535*^9}, {3.4698786125145903`*^9, 3.4698786191211853`*^9}, {
   3.469883247163637*^9, 3.469883260409108*^9}, {3.469905506864237*^9, 
   3.4699055103160048`*^9}, {3.469906283820899*^9, 3.4699063030097322`*^9}, {
   3.469906546731975*^9, 3.4699065510413637`*^9}, 3.469960282710096*^9, {
   3.4701369772984257`*^9, 3.4701369799061337`*^9}, 3.4701379835572653`*^9, 
   3.470138023065645*^9, 3.506761004498254*^9, 3.5068552392209272`*^9, {
   3.508582702189824*^9, 3.5085827136608353`*^9}, {3.508584132512385*^9, 
   3.508584140362259*^9}, {3.508681090619546*^9, 3.508681091425757*^9}, 
   3.508695882316738*^9, {3.509201851881226*^9, 3.5092018570142927`*^9}, {
   3.509205054512384*^9, 3.5092050550265303`*^9}, 3.5094569122955112`*^9, {
   3.509458340046239*^9, 3.5094583442450027`*^9}, {3.509458406147339*^9, 
   3.509458415504978*^9}, 3.515002821795414*^9, {3.621601059179372*^9, 
   3.621601062414098*^9}, {3.657712432385127*^9, 
   3.6577124412974253`*^9}},ExpressionUUID->"b414d5e4-0d54-4eb5-a6e9-\
734f587021c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Trajectory", "[", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "ops_"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Trajectory", "[", 
     RowBox[{"ops", ",", "more", ",", "opts"}], "]"}], "[", "\[Rho]ini", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6577124582744083`*^9, 3.6577125033767242`*^9}, {
   3.657713342927353*^9, 3.6577133476144257`*^9}, {3.7093790935080643`*^9, 
   3.709379130521006*^9}, {3.709379161212916*^9, 3.7093791851513367`*^9}, {
   3.709379251214013*^9, 3.709379252832327*^9}, {3.7093792919961777`*^9, 
   3.7093793412943153`*^9}, {3.709379402948552*^9, 3.709379431473517*^9}, {
   3.709379652946171*^9, 3.7093796581756983`*^9}, {3.7093797115250473`*^9, 
   3.709379721348227*^9}, {3.709379988660128*^9, 3.7093799937899113`*^9}, {
   3.709381122084107*^9, 3.7093811244462767`*^9}, {3.709381964192359*^9, 
   3.709381965337901*^9}, 3.709382111168017*^9},
 CellLabel->
  "In[1800]:=",ExpressionUUID->"a64ab7db-3209-4088-ac23-aaf2225c40db"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
check use of PolarizationLevelOperator or SingletPolarizationLevelOperator\
\>", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469877652562336*^9, 
   3.469877654440535*^9}, {3.4698786125145903`*^9, 3.4698786191211853`*^9}, {
   3.469883247163637*^9, 3.469883260409108*^9}, {3.469905506864237*^9, 
   3.4699055103160048`*^9}, {3.469906283820899*^9, 3.4699063030097322`*^9}, {
   3.469906546731975*^9, 3.4699065510413637`*^9}, 3.469960282710096*^9, {
   3.4701369772984257`*^9, 3.4701369799061337`*^9}, 3.4701379835572653`*^9, 
   3.470138023065645*^9, 3.506761004498254*^9, 3.5068552392209272`*^9, {
   3.508582702189824*^9, 3.5085827136608353`*^9}, {3.508584132512385*^9, 
   3.508584140362259*^9}, {3.508681090619546*^9, 3.508681091425757*^9}, 
   3.508695882316738*^9, {3.509201851881226*^9, 3.5092018570142927`*^9}, {
   3.509205054512384*^9, 3.5092050550265303`*^9}, 3.5094569122955112`*^9, {
   3.509458340046239*^9, 3.5094583442450027`*^9}, {3.509458406147339*^9, 
   3.509458415504978*^9}, 3.515002821795414*^9, {3.621601059179372*^9, 
   3.621601062414098*^9}, {3.657712432385127*^9, 3.6577124412974253`*^9}, {
   3.7093762654742947`*^9, 3.7093762933848352`*^9}, {3.709376455400814*^9, 
   3.709376463082358*^9}},ExpressionUUID->"aaf19751-4cc0-415a-9eb8-\
9a0eb82f2a79"],

Cell["density operator must have unit trace", "Text",
 CellChangeTimes->{{3.709376466131023*^9, 
  3.7093764712386227`*^9}},ExpressionUUID->"95bfdcda-7f95-4865-a8d2-\
0599c67a0c29"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Trajectory", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
       RowBox[{"more", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
       "opts___Rule"}], "]"}], "[", "\[Rho]ini_", "]"}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"PolarizationLevelOperatorsChecked", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Trajectory", "]"}]}], ")"}]}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"FreeQ", "[", 
        RowBox[{
         RowBox[{"Hold", "@", "ops"}], ",", 
         RowBox[{
         "PolarizationLevelOperator", "|", 
          "SingletPolarizationLevelOperator"}]}], "]"}], "||", 
       "\[IndentingNewLine]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Chop", "[", 
          RowBox[{
           RowBox[{"Tr", "@", 
            RowBox[{"MatrixRepresentation", "[", "\[Rho]ini", "]"}]}], "-", 
           "1"}], "]"}], "\[Equal]", "0"}], ")"}]}], "\[IndentingNewLine]", 
      ")"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Trajectory", "[", "\[IndentingNewLine]", 
     RowBox[{"ops", ",", "more", ",", "\[IndentingNewLine]", 
      RowBox[{"Evaluate", "@", 
       RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"PolarizationLevelOperatorsChecked", "\[Rule]", "True"}], 
         ",", "opts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], "[", 
    "\[Rho]ini", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6577124582744083`*^9, 3.6577125033767242`*^9}, {
   3.657713342927353*^9, 3.6577133476144257`*^9}, {3.709376303984931*^9, 
   3.709376340725746*^9}, {3.70937647527731*^9, 3.709376571199052*^9}, {
   3.709376607299329*^9, 3.7093766796707983`*^9}, {3.7093767112294703`*^9, 
   3.709376818104075*^9}, 3.709376899917894*^9, {3.709377430116222*^9, 
   3.709377431138129*^9}, 3.70937803689382*^9, {3.7093783448562613`*^9, 
   3.709378397257351*^9}, {3.709378514058612*^9, 3.709378571128728*^9}, {
   3.7093788114779663`*^9, 3.709378814267007*^9}, {3.709380004052987*^9, 
   3.709380012353105*^9}, {3.709380095392529*^9, 3.7093800965044117`*^9}, {
   3.709380169767528*^9, 3.7093801726227827`*^9}, {3.709381295426608*^9, 
   3.709381302075678*^9}, 3.709381875533319*^9, {3.709381984903058*^9, 
   3.709382009135016*^9}, {3.7093821301363077`*^9, 3.709382144004632*^9}},
 CellLabel->
  "In[1801]:=",ExpressionUUID->"3918c957-fcc2-4259-aa51-089be77c4637"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Trajectory", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
       RowBox[{"more", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
       "opts___Rule"}], "]"}], "[", "\[Rho]ini_", "]"}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"PolarizationLevelOperatorsChecked", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Trajectory", "]"}]}], ")"}]}], "&&", 
     RowBox[{"!", 
      RowBox[{"FreeQ", "[", 
       RowBox[{
        RowBox[{"Hold", "@", "ops"}], ",", "PolarizationLevelOperator"}], 
       "]"}]}], "&&", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Chop", "[", 
        RowBox[{
         RowBox[{"Tr", "@", 
          RowBox[{"MatrixRepresentation", "[", "\[Rho]ini", "]"}]}], "-", 
         "1"}], "]"}], "\[NotEqual]", "0"}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"PolarizationLevelOperator", "::", "inval\[Rho]"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Trajectory", "[", "\[IndentingNewLine]", 
       RowBox[{"ops", ",", "more", ",", "\[IndentingNewLine]", 
        RowBox[{"Evaluate", "@", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"PolarizationLevelOperatorsChecked", "\[Rule]", "True"}], 
           ",", "opts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], "[", 
      "\[Rho]ini", "]"}]}], "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6577124582744083`*^9, 3.6577125033767242`*^9}, {
   3.657713342927353*^9, 3.6577133476144257`*^9}, {3.709376303984931*^9, 
   3.709376340725746*^9}, {3.70937647527731*^9, 3.709376571199052*^9}, {
   3.709376607299329*^9, 3.7093766796707983`*^9}, {3.7093767112294703`*^9, 
   3.709376818104075*^9}, {3.709376850685532*^9, 3.7093769339472837`*^9}, {
   3.7093771726218843`*^9, 3.7093771810575237`*^9}, {3.709377435774085*^9, 
   3.709377436695591*^9}, 3.709378040897727*^9, {3.709378393491707*^9, 
   3.709378408693035*^9}, {3.7093800160660763`*^9, 3.709380018619536*^9}, {
   3.7093801110640507`*^9, 3.709380112130887*^9}, {3.7093813044156237`*^9, 
   3.709381306633512*^9}, 3.7093818783655148`*^9, {3.709382018936681*^9, 
   3.709382029220903*^9}, {3.7093821491152763`*^9, 3.709382162983883*^9}},
 CellLabel->
  "In[1802]:=",ExpressionUUID->"73cbccc5-eba9-4268-870c-4b15273826b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Trajectory", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
       RowBox[{"more", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
       "opts___Rule"}], "]"}], "[", "\[Rho]ini_", "]"}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"PolarizationLevelOperatorsChecked", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Trajectory", "]"}]}], ")"}]}], "&&", 
     RowBox[{"!", 
      RowBox[{"FreeQ", "[", 
       RowBox[{
        RowBox[{"Hold", "@", "ops"}], ",", 
        "SingletPolarizationLevelOperator"}], "]"}]}], "&&", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Chop", "[", 
        RowBox[{
         RowBox[{"Tr", "@", 
          RowBox[{"MatrixRepresentation", "[", "\[Rho]ini", "]"}]}], "-", 
         "1"}], "]"}], "\[NotEqual]", "0"}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SingletPolarizationLevelOperator", "::", "inval\[Rho]"}], 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Trajectory", "[", "\[IndentingNewLine]", 
       RowBox[{"ops", ",", "more", ",", "\[IndentingNewLine]", 
        RowBox[{"Evaluate", "@", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"PolarizationLevelOperatorsChecked", "\[Rule]", "True"}], 
           ",", "opts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], "[", 
      "\[Rho]ini", "]"}]}], "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6577124582744083`*^9, 3.6577125033767242`*^9}, {
   3.657713342927353*^9, 3.6577133476144257`*^9}, {3.709376303984931*^9, 
   3.709376340725746*^9}, {3.70937647527731*^9, 3.709376571199052*^9}, {
   3.709376607299329*^9, 3.7093766796707983`*^9}, {3.7093767112294703`*^9, 
   3.709376818104075*^9}, {3.709376850685532*^9, 3.709376959858553*^9}, 
   3.709377185987487*^9, {3.709377443671575*^9, 3.709377444593259*^9}, {
   3.7093780459602623`*^9, 3.709378046218286*^9}, {3.7093784202807817`*^9, 
   3.7093784320592623`*^9}, {3.7093800224457407`*^9, 3.709380024897018*^9}, {
   3.709380115990416*^9, 3.7093801169123487`*^9}, {3.709381308881936*^9, 
   3.709381311525701*^9}, 3.709381883450769*^9, {3.709382035688314*^9, 
   3.7093820449064198`*^9}, {3.709382152183836*^9, 3.709382165078319*^9}},
 CellLabel->
  "In[1803]:=",ExpressionUUID->"d7eedcce-c7f7-4e0a-92e8-a7081d4358bd"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardize EnsembleAverage", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.509890958854889*^9, 3.5098909645578957`*^9}, {
   3.509891167092675*^9, 3.5098911716419077`*^9}, {3.6430331301444807`*^9, 
   3.643033168521751*^9}, 3.657712521896942*^9, {3.657712876898527*^9, 
   3.657712884070901*^9}},ExpressionUUID->"f646733e-d6bc-4853-bb35-\
669f668ef6f4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Trajectory", "[", 
     RowBox[{
      RowBox[{"args", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"FreeQ", "[", 
     RowBox[{
      RowBox[{"{", "opts", "}"}], ",", "EnsembleAverage"}], "]"}]}], ":=", 
   RowBox[{"Trajectory", "[", 
    RowBox[{"args", ",", "opts", ",", 
     RowBox[{"EnsembleAverage", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{"EnsembleAverage", "/.", 
        RowBox[{"Options", "[", "Trajectory", "]"}]}], ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.643033252012233*^9, 3.6430333101640453`*^9}, {
  3.643034072521511*^9, 3.643034088708249*^9}, {3.657208670556534*^9, 
  3.657208674524699*^9}, {3.657712629178989*^9, 3.657712662327817*^9}, {
  3.657713392079541*^9, 3.6577133948939667`*^9}, {3.709381154811051*^9, 
  3.709381161313135*^9}},
 CellLabel->
  "In[1804]:=",ExpressionUUID->"709c9164-a7a4-4bb5-b347-fb7bf8c9674b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Trajectory", "[", 
      RowBox[{"ops_", ",", 
       RowBox[{"more", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
       "opts1___Rule", ",", 
       RowBox[{"EnsembleAverage", "\[Rule]", "ensav_"}], ",", 
       "opts2___Rule"}], "]"}], "[", "\[Rho]ini_", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"EnsembleAverageStandardized", "/.", 
        RowBox[{"{", 
         RowBox[{"opts1", ",", "opts2"}], "}"}]}], "/.", 
       RowBox[{"Options", "[", "Trajectory", "]"}]}], ")"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "standensav", ",", "modmore", ",", "modopts", ",", "mod\[Rho]ini", ",", 
       "modops"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"standensav", "=", 
        RowBox[{"StandardizeEnsembleAverage", "[", "ensav", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "modmore", ",", "modopts", ",", "mod\[Rho]ini", ",", "modops"}], 
         "}"}], "=", "\[IndentingNewLine]", 
        RowBox[{
        "ExpandMultidimensionalEnsembleVariables", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "more", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"opts1", ",", "opts2"}], "}"}], ",", "\[Rho]ini", ",", 
            "ops"}], "}"}], ",", "\[IndentingNewLine]", "standensav"}], 
         "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Trajectory", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Evaluate", "@", 
           RowBox[{"ReleaseHold", "@", "modops"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Evaluate", "[", 
           RowBox[{"Sequence", "@@", 
            RowBox[{"ReleaseHold", "@", "modmore"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Evaluate", "@", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"EnsembleAverage", "\[Rule]", "standensav"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"EnsembleAverageStandardized", "\[Rule]", "True"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Sequence", "@@", 
              RowBox[{"ReleaseHold", "@", "modopts"}]}]}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
        "[", "mod\[Rho]ini", "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.509890982675839*^9, 3.509891031125326*^9}, {
   3.5104584527234697`*^9, 3.51045845456103*^9}, 3.6430294974330883`*^9, 
   3.6430299938428507`*^9, {3.64303061118714*^9, 3.643030632977294*^9}, {
   3.643030996847068*^9, 3.643031005507723*^9}, {3.643031056566902*^9, 
   3.6430310601661987`*^9}, {3.64303115249931*^9, 3.6430312861099863`*^9}, {
   3.643031367307214*^9, 3.64303149246885*^9}, {3.643031526571825*^9, 
   3.643031697941168*^9}, {3.6430317309967957`*^9, 3.6430317395888033`*^9}, 
   3.643033160612338*^9, {3.643033376320385*^9, 3.64303339072334*^9}, {
   3.643033553249166*^9, 3.6430336434432383`*^9}, 3.643033682697362*^9, {
   3.6430337285140343`*^9, 3.6430337578064127`*^9}, {3.643033849296508*^9, 
   3.643033867072448*^9}, {3.643033971754499*^9, 3.643033973312628*^9}, {
   3.6430383891499367`*^9, 3.6430383932557898`*^9}, 3.643038465519759*^9, 
   3.64303856101443*^9, {3.643040141770208*^9, 3.643040149474834*^9}, 
   3.643040499078794*^9, 3.643040581006206*^9, {3.643040665272991*^9, 
   3.643040671517618*^9}, {3.643040707598023*^9, 3.643040719163267*^9}, {
   3.6430407722794037`*^9, 3.643040864543888*^9}, {3.64304096271735*^9, 
   3.643041044856021*^9}, {3.6430411000758953`*^9, 3.643041138789296*^9}, {
   3.64304246831113*^9, 3.643042548595397*^9}, {3.6430425821209106`*^9, 
   3.643042582366146*^9}, 3.6430429153905907`*^9, {3.643043325438242*^9, 
   3.6430433261789*^9}, {3.657713403676804*^9, 3.657713452780488*^9}, {
   3.657714412020155*^9, 3.65771443585655*^9}, {3.657714539334787*^9, 
   3.657714550291667*^9}, 3.657714712568657*^9, {3.657715365190609*^9, 
   3.657715372003255*^9}, {3.683217663430046*^9, 3.6832176689416037`*^9}, {
   3.683217741504078*^9, 3.6832177486078978`*^9}, {3.7093811517959757`*^9, 
   3.709381180769637*^9}},
 CellLabel->
  "In[1805]:=",ExpressionUUID->"b8dd260b-9fa5-497e-8b30-2e05dea52334"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["NormalizationFactor", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.497372485943301*^9, 3.4973724974441853`*^9}, 3.499290949258265*^9, 
   3.5331770910154057`*^9},ExpressionUUID->"fc8562c6-6c75-4eca-8d19-\
8210d45102be"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Trajectory", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "events_", ",", 
       RowBox[{"more", ":", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"NormalizationFactor", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Trajectory", "]"}]}], ",", 
      RowBox[{"None", "|", "False"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"Trajectory", "[", 
    RowBox[{"ops", ",", "events", ",", "more", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"NormalizationFactor", "\[Rule]", "1"}], ",", 
        "\[IndentingNewLine]", "opts"}], "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.501997986827223*^9, 3.501998023607252*^9}, {
   3.502003079897297*^9, 3.502003083079468*^9}, 3.505833331603818*^9, {
   3.505833473420662*^9, 3.505833477450014*^9}, 3.511182306719418*^9, 
   3.511183164490087*^9, {3.533177095576392*^9, 3.533177096511965*^9}},
 CellLabel->
  "In[1806]:=",ExpressionUUID->"4f72dbc4-df1d-4897-b496-8c2088978fcc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Trajectory", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "events_", ",", 
       RowBox[{"more", ":", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
       "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", 
       RowBox[{
        RowBox[{"NormalizationFactor", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}], "\[Equal]", 
      "0"}], ")"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"NormalizationFactor", "::", "zero"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Trajectory", "[", 
      RowBox[{"ops", ",", "events", ",", "more", ",", "\[IndentingNewLine]", 
       RowBox[{"Evaluate", "@", 
        RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"NormalizationFactor", "\[Rule]", "1"}], ",", 
          "\[IndentingNewLine]", "opts"}], "]"}]}]}], "\[IndentingNewLine]", 
      "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.501997986827223*^9, 3.501998023607252*^9}, {
   3.502003079897297*^9, 3.502003083079468*^9}, 3.505833331603818*^9, {
   3.505833473420662*^9, 3.505833477450014*^9}, 3.511182306719418*^9, 
   3.511183164490087*^9, {3.533082973604351*^9, 3.53308303027947*^9}, {
   3.533177099069167*^9, 3.533177109334484*^9}},
 CellLabel->
  "In[1807]:=",ExpressionUUID->"d2b5db67-1dcd-4060-84f4-f733046b6dee"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{
      RowBox[{"Trajectory", "[", 
       RowBox[{
        RowBox[{"ops", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "events_", ",", 
        RowBox[{"more", ":", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
        "opts___Rule"}], "]"}], "[", 
      RowBox[{"\[Rho]ini_", "?", "OperatorQ"}], "]"}]}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NormalizationFactor", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Trajectory", "]"}]}], ",", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], "|", "None", "|", "False"}]}], 
      "]"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"NormalizationFactor", "::", "bad"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.501997986827223*^9, 3.5019980897983723`*^9}, {
   3.5020002608110647`*^9, 3.5020002875539417`*^9}, {3.5020006083926*^9, 
   3.502000609963409*^9}, 3.5058333448842287`*^9, 3.5058335049189367`*^9, 
   3.5111823209515247`*^9, 3.511183171227545*^9, {3.5330827995863953`*^9, 
   3.533082853346493*^9}, {3.533083864921671*^9, 3.5330838730284233`*^9}, {
   3.533101874853612*^9, 3.53310188173709*^9}, {3.533177125468355*^9, 
   3.533177136587484*^9}},
 CellLabel->
  "In[1808]:=",ExpressionUUID->"838ea7aa-7307-41e7-859a-ebd9fc51cdad"]
}, Closed]],

Cell[CellGroupData[{

Cell["SpinSystem, Basis and OperatorBasis", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
  3.502510349231102*^9, 
  3.502510353852003*^9}},ExpressionUUID->"59fae4d9-ee62-44e7-bdf5-\
3969ecd605c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Trajectory", "[", 
     RowBox[{
      RowBox[{"ops", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "events_", ",", 
      "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Trajectory", "[", 
    RowBox[{"ops", ",", "events", ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"OperatorBasis", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}], ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.454563821094757*^9, 3.454563822278015*^9}, {
   3.4545638764221907`*^9, 3.454563889446521*^9}, {3.454564181051017*^9, 
   3.4545642103756332`*^9}, {3.454564867476873*^9, 3.454564867741087*^9}, {
   3.455271966941128*^9, 3.4552719703405457`*^9}, {3.455272142385132*^9, 
   3.455272145839773*^9}, 3.455275172291848*^9, 3.4562050743530188`*^9, 
   3.456508761374711*^9, {3.4565088256506777`*^9, 3.4565088380189667`*^9}, {
   3.50242944331122*^9, 3.502429448574504*^9}, 3.510310766541836*^9, 
   3.5111823320954237`*^9, {3.515078054065243*^9, 3.5150780591043453`*^9}, {
   3.573739804105489*^9, 3.5737398083349457`*^9}},
 CellLabel->
  "In[1809]:=",ExpressionUUID->"7b4e948d-3ec7-41ac-9544-e74868d89969"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Trajectory", "[", 
     RowBox[{
      RowBox[{"ops", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "events_", ",", 
      "opbasis_", ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"Trajectory", "[", 
    RowBox[{"ops", ",", "events", ",", "opbasis", ",", 
     RowBox[{"Evaluate", "[", 
      RowBox[{
       RowBox[{"Basis", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}], ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{
  3.429846541720842*^9, 3.429846581379725*^9, {3.454563825254508*^9, 
   3.454563826638453*^9}, {3.454563905455122*^9, 3.4545639089804993`*^9}, {
   3.4545642154878063`*^9, 3.454564239088064*^9}, {3.4545648699969673`*^9, 
   3.454564870236917*^9}, {3.45527197466923*^9, 3.455271976581058*^9}, 
   3.455272150746269*^9, 3.4552751740254707`*^9, 3.456205057735742*^9, {
   3.4565088394293213`*^9, 3.456508850327935*^9}, {3.502429450573906*^9, 
   3.502429451860333*^9}, 3.510310765116618*^9, 3.511182335572093*^9, {
   3.5150780648178062`*^9, 3.5150780669661837`*^9}, {3.573739811006716*^9, 
   3.57373981553518*^9}},
 CellLabel->
  "In[1810]:=",ExpressionUUID->"e6943a37-2fc1-4cd4-b1ef-2e57208cb81a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Trajectory", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "events_", ",", 
       "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"SpinSystem", "[", "]"}], "==", "Undefined"}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"SpinSystem", "::", "notready"}], "]"}], ";", 
     RowBox[{"Abort", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483598512286263`*^9, 
   3.448359860731179*^9}, {3.448360466346766*^9, 3.448360475974476*^9}, {
   3.448360592630582*^9, 3.448360596506363*^9}, 3.454563828806386*^9, 
   3.4545639120761642`*^9, 3.454564240912786*^9, {3.454564271954568*^9, 
   3.454564286530512*^9}, {3.454564872669664*^9, 3.454564872885377*^9}, 
   3.455271981846101*^9, 3.455272152154932*^9, 3.455275175802754*^9, {
   3.4553763513008337`*^9, 3.455376352469843*^9}, 3.456205398020976*^9, {
   3.4565088545678453`*^9, 3.4565088607175417`*^9}, 3.510310763792523*^9, 
   3.511182340420223*^9, 3.6831308481431017`*^9},
 CellLabel->
  "In[1811]:=",ExpressionUUID->"862cc783-746f-408f-ba8d-228bc05b6ea7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Trajectory", "[", 
     RowBox[{
      RowBox[{"ops", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "events_", ",", 
      "opbasis_", ",", "Undefined", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "unknown"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"Basis", "::", "default"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SetBasis", "[", 
      RowBox[{
       RowBox[{"ZeemanBasis", "[", 
        RowBox[{"SpinSystem", "[", "]"}], "]"}], ",", 
       RowBox[{"CheckBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Trajectory", "[", 
      RowBox[{"ops", ",", "events", ",", "opbasis", ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, 3.448360573943112*^9, {
   3.448360607428061*^9, 3.448360654701827*^9}, {3.454563843246985*^9, 
   3.454563845319368*^9}, {3.454563914293174*^9, 3.454563916476424*^9}, {
   3.4545642454662247`*^9, 3.4545642902349997`*^9}, {3.454564874990457*^9, 
   3.454564875262397*^9}, {3.455271984527185*^9, 3.455271987335227*^9}, 
   3.45527215418008*^9, 3.4552751777084007`*^9, 3.456205399659954*^9, {
   3.456508867284601*^9, 3.45650888148532*^9}, 3.510310762401688*^9, 
   3.5111823444046993`*^9, 3.683130860490141*^9},
 CellLabel->
  "In[1812]:=",ExpressionUUID->"7cc2baef-3746-47bb-87f5-d6cd73c84d01"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Trajectory", "[", 
     RowBox[{
      RowBox[{"ops", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "events_", ",", 
      "Undefined", ",", "basis_", ",", "opts___Rule"}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "unknown"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Message", "[", 
      RowBox[{"OperatorBasis", "::", "default"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"SetOperatorBasis", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"OperatorBasis", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Trajectory", "]"}]}], ",", 
       RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Trajectory", "[", 
      RowBox[{"ops", ",", "events", ",", "opts"}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, {3.44835995227402*^9, 
   3.448359994938308*^9}, {3.4483606824647713`*^9, 3.448360738493463*^9}, {
   3.4545638495437107`*^9, 3.454563852615542*^9}, {3.454563918733029*^9, 
   3.454563922100461*^9}, {3.4545642537057667`*^9, 3.454564293851018*^9}, {
   3.45456487755042*^9, 3.454564877774334*^9}, {3.455271990255906*^9, 
   3.455271992495614*^9}, 3.455272156203349*^9, 3.455275179596388*^9, {
   3.456508893964306*^9, 3.456508910282003*^9}, 3.510310760969611*^9, 
   3.5111823498923683`*^9, 3.515078078578989*^9, 3.683130872667235*^9},
 CellLabel->
  "In[1813]:=",ExpressionUUID->"ae8bfd8f-50ee-4ca2-8f8c-20a30477b95b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{"Trajectory", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "events_", ",", 
       "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"First", "@", "opbasis"}], "\[NotEqual]", 
      RowBox[{"First", "@", "basis"}]}], ")"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "defaultopbasis", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SetSpinSystem", "[", 
        RowBox[{"First", "@", "basis"}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"defaultopbasis", "=", 
        RowBox[{
         RowBox[{"OperatorBasis", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Trajectory", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{"OperatorBasis", "::", "default"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetOperatorBasis", "[", 
        RowBox[{"defaultopbasis", ",", 
         RowBox[{"CheckOperatorBasis", "\[Rule]", "False"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Trajectory", "[", 
        RowBox[{"ops", ",", "events", ",", 
         RowBox[{"Evaluate", "@", "defaultopbasis"}], ",", "basis", ",", 
         "opts"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.448355309823902*^9, 3.44835533980553*^9}, {
   3.4483553713604593`*^9, 3.448355397806663*^9}, 3.448355802295836*^9, {
   3.44835668734658*^9, 3.44835669214686*^9}, {3.4483567586681767`*^9, 
   3.4483567776232557`*^9}, {3.448359710259263*^9, 3.448359792861126*^9}, {
   3.4483598825030727`*^9, 3.4483599127530537`*^9}, {3.44835995227402*^9, 
   3.448359994938308*^9}, {3.448361307182886*^9, 3.448361363053556*^9}, {
   3.448361419573944*^9, 3.4483614810280848`*^9}, {3.44836151594449*^9, 
   3.448361525098793*^9}, {3.448361569055385*^9, 3.448361573898075*^9}, {
   3.4483616285278997`*^9, 3.448361646636026*^9}, {3.448361938039504*^9, 
   3.448362008292676*^9}, {3.4483637955016203`*^9, 3.448363800986418*^9}, {
   3.45456386018486*^9, 3.4545638626085463`*^9}, {3.454563925910449*^9, 
   3.454563928085649*^9}, {3.4545642586114893`*^9, 3.454564298604599*^9}, {
   3.454564879983574*^9, 3.454564880191662*^9}, {3.4552719949132977`*^9, 
   3.4552719969932947`*^9}, 3.455272157965658*^9, 3.455275181844925*^9, {
   3.456508914270056*^9, 3.456508928915512*^9}, 3.510310759522567*^9, 
   3.5111823549827833`*^9, {3.515078084693153*^9, 3.515078090485298*^9}, {
   3.573739841698348*^9, 3.573739843383979*^9}},
 CellLabel->
  "In[1814]:=",ExpressionUUID->"05501b81-3f0e-4d79-8836-a76c6a7f08de"]
}, Closed]],

Cell[CellGroupData[{

Cell["set up BackgroundGenerator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, 3.587551595034563*^9, 
   3.709375517997508*^9},ExpressionUUID->"5e1e8d2a-3c8a-4050-9e60-\
cce43e61a754"],

Cell["\<\
pre-diagonalize if no EnsembleAverage, or if the ensemble average variable \
does not occur in the BackgroundGenerator\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.587645395238482*^9, 3.587645438486599*^9}, 
   3.7093755188410397`*^9},ExpressionUUID->"23adc2a5-5bb5-4735-8aa8-\
bbacc4ec1893"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Trajectory", "[", 
     RowBox[{
     "ops_", ",", "events_", ",", "opbasis_", ",", "basis_", ",", 
      "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ensav", ",", "backg"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Trajectory", "[", 
        RowBox[{
        "ops", ",", "events", ",", "opbasis", ",", "basis", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Evaluate", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"Which", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"MatchQ", "[", 
                   RowBox[{"#", ",", 
                    RowBox[{"_", "?", "OperatorQ"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", "\t", 
                  RowBox[{"NDiagonalize", "[", 
                   RowBox[{"#", ",", "basis"}], "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"MatchQ", "[", 
                   RowBox[{"#", ",", 
                    RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}], ",", 
                  "\[IndentingNewLine]", "\t", 
                  RowBox[{"NDiagonalize", "[", 
                   RowBox[{"#", ",", "opbasis", ",", "basis"}], "]"}], ",", 
                  "\[IndentingNewLine]", "True", ",", "#"}], 
                 "\[IndentingNewLine]", "]"}], "&"}], "@", " ", "backg"}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"EnsembleAverage", "\[Rule]", "ensav"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"BackgroundGeneratorPrepared", "\[Rule]", "True"}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"!", "BackgroundGeneratorPrepared"}], "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Trajectory", "]"}]}], ")"}], "&&", 
        "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ensav", "=", 
           RowBox[{"StandardizeEnsembleAverage", "[", 
            RowBox[{
             RowBox[{"EnsembleAverage", "/.", 
              RowBox[{"{", "opts", "}"}]}], "/.", 
             RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"backg", "=", 
           RowBox[{"StandardizeGenerator", "[", 
            RowBox[{
             RowBox[{"BackgroundGenerator", "/.", 
              RowBox[{"{", "opts", "}"}]}], "/.", 
             RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"EnsembleVariablesFreeQ", "[", 
           RowBox[{"backg", ",", "ensav"}], "]"}]}], "\[IndentingNewLine]", 
         ")"}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.643009505148532*^9, {3.643009786728458*^9, 3.643009972937849*^9}, {
   3.643010133574416*^9, 3.643010144575513*^9}, {3.6430102274949083`*^9, 
   3.643010262337393*^9}, {3.6430382275773087`*^9, 3.643038231987815*^9}, {
   3.64303872176362*^9, 3.643038792225811*^9}, 3.643038871608749*^9, {
   3.643038923654436*^9, 3.643038958180341*^9}, {3.6430390265972967`*^9, 
   3.643039052787613*^9}, {3.643039101277804*^9, 3.643039117016541*^9}, 
   3.643039339083623*^9, 3.64304039537121*^9, 3.643040574819605*^9, {
   3.643042885530466*^9, 3.643042886057007*^9}, {3.657192462718676*^9, 
   3.657192497093966*^9}, 3.7093740519715853`*^9, {3.7093755195909452`*^9, 
   3.709375521773472*^9}},
 CellLabel->
  "In[1815]:=",ExpressionUUID->"8e59f6cf-3ab9-42ac-ac42-e51d6adf5d1b"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["EnsembleAverage", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469877652562336*^9, 
   3.469877654440535*^9}, {3.4698786125145903`*^9, 3.4698786191211853`*^9}, {
   3.469883247163637*^9, 3.469883260409108*^9}, {3.469905506864237*^9, 
   3.4699055103160048`*^9}, {3.469906283820899*^9, 3.4699063030097322`*^9}, {
   3.469906546731975*^9, 3.4699065510413637`*^9}, 3.469960282710096*^9, {
   3.4701369772984257`*^9, 3.4701369799061337`*^9}, 3.4701379835572653`*^9, 
   3.470138023065645*^9},ExpressionUUID->"0e9c0dd5-5dc0-4f88-b1c6-\
79a7831ffd1f"],

Cell[CellGroupData[{

Cell["PrepareParallel", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506767146878869*^9, 3.5067671531811543`*^9}, {
   3.507554915952759*^9, 3.507554918310874*^9}, {3.507556747116287*^9, 
   3.507556755028116*^9}, 
   3.57251737614824*^9},ExpressionUUID->"767aeda5-a248-44f2-9c6e-\
fcd50564a695"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{
      RowBox[{"Trajectory", "[", 
       RowBox[{
        RowBox[{"ops", ":", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"_", "?", "OperatorQ"}], "|", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}], ")"}]}], ",", 
        RowBox[{"events", ":", 
         RowBox[{"Except", "[", 
          RowBox[{"_EventList", "|", 
           RowBox[{"Event", "[", "___", "]"}]}], "]"}]}], ",", 
        RowBox[{"more", ":", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Except", "[", "_Rule", "]"}], ".."}], ")"}]}], ",", 
        "opts___Rule"}], "]"}], "[", "\[Rho]ini_", "]"}]}], "/;", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Parallel", ",", "ParallelSetUp", ",", "EnsembleAverage"}],
            "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Trajectory", "]"}]}], ")"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"True", "|", "All", "|", 
          RowBox[{"_", "?", "NumericQ"}]}], ",", "False", ",", 
         RowBox[{"Except", "[", 
          RowBox[{"None", "|", "False"}], "]"}]}], "}"}]}], "]"}], ")"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Trajectory", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"PrepareParallel", "[", 
        RowBox[{"opbasis", ",", "basis", ",", "opts"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Trajectory", "[", 
         RowBox[{
         "ops", ",", "events", ",", "more", ",", "\[IndentingNewLine]", 
          RowBox[{"Evaluate", "@", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"ParallelSetUp", "\[Rule]", "True"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Parallel", "\[Rule]", "True"}], ",", 
             "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
            "]"}]}]}], "\[IndentingNewLine]", "]"}], "[", "\[Rho]ini", 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5066923457061167`*^9, 3.506692417095523*^9, {3.506692453561578*^9, 
   3.506692505334669*^9}, {3.506692629031838*^9, 3.5066926957678747`*^9}, {
   3.506692736496896*^9, 3.50669284440497*^9}, {3.5066932116562147`*^9, 
   3.5066932278932133`*^9}, {3.506693484789329*^9, 3.506693509806026*^9}, 
   3.5066937284851503`*^9, {3.506693825888592*^9, 3.5066938273192873`*^9}, {
   3.506694063994944*^9, 3.5066940724142714`*^9}, {3.506694282191956*^9, 
   3.506694290211069*^9}, {3.506694359514119*^9, 3.506694371097918*^9}, 
   3.506694557239192*^9, 3.5066946187962008`*^9, {3.506694956344503*^9, 
   3.506694966203347*^9}, {3.506767553660231*^9, 3.506767555723261*^9}, 
   3.507571977254531*^9, {3.5075720101717157`*^9, 3.5075720359721937`*^9}, 
   3.5079673116836157`*^9, 3.507967455235785*^9, 3.509086006880698*^9, {
   3.511169483376247*^9, 3.5111694899172277`*^9}, {3.511179134199709*^9, 
   3.511179135156444*^9}, {3.511181612953557*^9, 3.511181615691659*^9}, 
   3.514871485726852*^9, 3.51500229615989*^9, {3.5150034460383387`*^9, 
   3.5150034755713577`*^9}, {3.532452004836784*^9, 3.532452006869091*^9}, {
   3.533115042654971*^9, 3.533115044248684*^9}, {3.533212834140656*^9, 
   3.5332128999055433`*^9}, {3.533304235024026*^9, 3.5333042542713127`*^9}, 
   3.538910585155138*^9, {3.563101653945359*^9, 3.563101655272718*^9}, 
   3.566464932293323*^9, {3.572517264107789*^9, 3.5725173812422953`*^9}, 
   3.5725174357271767`*^9, 3.62157419799231*^9, 3.64303800847545*^9, 
   3.643038041099032*^9, {3.643040009163521*^9, 3.6430400094050617`*^9}, {
   3.643040400872725*^9, 3.64304040559799*^9}, {3.643042888239263*^9, 
   3.6430428882430363`*^9}, 3.657192571018672*^9, {3.657192614183758*^9, 
   3.65719263377696*^9}, {3.7281308372218833`*^9, 3.728130839312199*^9}, {
   3.7281308707910967`*^9, 3.7281308710219975`*^9}, {3.7281309046500463`*^9, 
   3.7281309606552725`*^9}, {3.7281309965708637`*^9, 3.728131110122013*^9}, 
   3.7281312218701377`*^9},
 CellLabel->
  "In[1816]:=",ExpressionUUID->"8c9fb110-e818-4a7d-8cfc-35d41e520bdc"]
}, Open  ]],

Cell[CellGroupData[{

Cell["divide into batches, calculate and combine", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506767146878869*^9, 3.5067671531811543`*^9}, {
   3.507554915952759*^9, 3.507554918310874*^9}, {3.507556747116287*^9, 
   3.507556755028116*^9}, {3.565419601881979*^9, 3.565419618207242*^9}, 
   3.565971500181367*^9, {3.565973348279451*^9, 3.56597335195018*^9}, {
   3.565973877245042*^9, 
   3.565973918345532*^9}},ExpressionUUID->"06d7a93e-dea4-423c-9578-\
060504ddb7f2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
     RowBox[{"Trajectory", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
       RowBox[{"events", ":", 
        RowBox[{"Except", "[", 
         RowBox[{"_EventList", "|", 
          RowBox[{"Event", "[", "___", "]"}]}], "]"}]}], ",", 
       RowBox[{"more", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
       "opts___Rule"}], "]"}], "[", "\[Rho]ini_", "]"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ensav", ",", "var", ",", "vals", ",", "weights", ",", "nens", ",", 
       "maxbatchsize", ",", "valwbatches", ",", "nbatch", ",", "opbasis", ",",
        "basis", ",", "ib", ",", "temp", ",", "traj"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Trajectory", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nens", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"maxbatchsize", "=", 
         RowBox[{"Min", "[", 
          RowBox[{
           RowBox[{"Max", "[", 
            RowBox[{"maxbatchsize", ",", "1"}], "]"}], ",", "nens"}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"var", "=", 
         RowBox[{"First", "[", "ensav", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"valwbatches", "=", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Last", "[", "ensav", "]"}], ",", "maxbatchsize", ",", 
           "maxbatchsize", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"nbatch", "=", 
         RowBox[{"Length", "[", "valwbatches", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"nbatch", "==", "1"}], ",", "\[IndentingNewLine]", 
          RowBox[{
          "PrintTemporary", "[", 
           "\"\<ensemble averaging using 1 batch ..\>\"", "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PrintTemporary", "[", 
           RowBox[{"\"\<ensemble averaging using \>\"", "<>", 
            RowBox[{"ToString", "[", "nbatch", "]"}], "<>", 
            "\"\< batches..\>\""}], "]"}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"CombineTrajectoryFunctions", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Monitor", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"temp", "=", 
                 RowBox[{"PrintTemporary", "[", 
                  RowBox[{"\"\<computing batch \>\"", "<>", 
                   RowBox[{"ToString", "[", "ib", "]"}], "<>", "\"\< of \>\"",
                    "<>", 
                   RowBox[{"ToString", "[", "nbatch", "]"}], "<>", 
                   "\"\<..\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"traj", "=", 
                 RowBox[{
                  RowBox[{"Trajectory", "[", 
                   RowBox[{
                   "ops", ",", "\[IndentingNewLine]", "events", ",", "more", 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Evaluate", "@", 
                    RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"EnsembleAverage", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"var", ",", 
                    RowBox[{
                    "valwbatches", "\[LeftDoubleBracket]", "ib", 
                    "\[RightDoubleBracket]"}]}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"OperatorBasis", "\[Rule]", "opbasis"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Basis", "\[Rule]", "basis"}], ",", 
                    "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
                    "]"}]}]}], "\[IndentingNewLine]", "]"}], "[", "\[Rho]ini",
                   "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"NotebookDelete", "[", "temp", "]"}], ";", 
                "\[IndentingNewLine]", "traj"}], "\[IndentingNewLine]", ")"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"ib", ",", "1", ",", "nbatch"}], "}"}]}], 
             "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"ProgressIndicator", "[", 
             RowBox[{"ib", ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"nbatch", "+", "1"}]}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Table", "[", 
           RowBox[{"1", ",", 
            RowBox[{"{", "nbatch", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", "opts", "}"}], ",", 
               RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Options", "[", "CombineTrajectoryFunctions", "]"}]}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"ensav", ",", "maxbatchsize"}], "}"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"EnsembleAverage", ",", "MaxBatchSize"}], "}"}], "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Trajectory", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"EnsembleAverage", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Trajectory", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"_", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"_", ",", "_"}], "}"}], "..."}], "}"}]}], "}"}]}], 
          "]"}], "&&", "\[IndentingNewLine]", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"nens", "=", 
            RowBox[{"Length", "[", 
             RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"maxbatchsize", "=", 
            RowBox[{"Min", "[", 
             RowBox[{
              RowBox[{"Max", "[", 
               RowBox[{"maxbatchsize", ",", "1"}], "]"}], ",", "nens"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"maxbatchsize", "<", "nens"}]}], "\[IndentingNewLine]", 
          ")"}]}]}], "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.565973616626845*^9, 3.565973646938964*^9}, {
   3.565973704450218*^9, 3.565973792473486*^9}, {3.565973833957481*^9, 
   3.5659738417145357`*^9}, {3.565974054462031*^9, 3.565974486123555*^9}, {
   3.565974518256566*^9, 3.565974565209744*^9}, {3.5659798951711817`*^9, 
   3.565979896529059*^9}, {3.5661487167383833`*^9, 3.566148809409091*^9}, {
   3.566148841085351*^9, 3.566148910373026*^9}, 3.566148957582659*^9, {
   3.566148997323354*^9, 3.566148997527849*^9}, {3.566236134850613*^9, 
   3.5662361806023083`*^9}, {3.566463016717122*^9, 3.566463039597144*^9}, {
   3.566464270741766*^9, 3.566464284139461*^9}, {3.5664643242018433`*^9, 
   3.566464388867107*^9}, 3.5664645533377542`*^9, 3.566464680822782*^9, {
   3.566465258046586*^9, 3.5664652708622026`*^9}, {3.566465307380603*^9, 
   3.566465313920671*^9}, {3.5664688939931173`*^9, 3.5664688989712343`*^9}, {
   3.566903936029044*^9, 3.566903941372896*^9}, {3.5669039983988333`*^9, 
   3.5669040096094723`*^9}, {3.566904080790515*^9, 3.566904143473688*^9}, {
   3.566904551154718*^9, 3.56690457016008*^9}, {3.566904647204361*^9, 
   3.566904647327443*^9}, {3.566904824406974*^9, 3.566904825010825*^9}, {
   3.5669048800746717`*^9, 3.5669048997208843`*^9}, {3.5669053345885553`*^9, 
   3.5669053671167107`*^9}, {3.567698791691313*^9, 3.567698793381279*^9}, {
   3.572517471552414*^9, 3.57251751919834*^9}, {3.572517562343161*^9, 
   3.572517636252063*^9}, 3.572517692279484*^9, {3.572517751261952*^9, 
   3.5725177755183973`*^9}, {3.5725178221127453`*^9, 3.572517853368493*^9}, {
   3.572517884779625*^9, 3.572517894615494*^9}, {3.572520396771442*^9, 
   3.5725203991097107`*^9}, {3.57254261391385*^9, 3.572542634288578*^9}, {
   3.5725426732238293`*^9, 3.572542727433609*^9}, {3.5725427584083023`*^9, 
   3.57254276424008*^9}, {3.572543742753783*^9, 3.572543755927135*^9}, {
   3.572543879393731*^9, 3.57254388578903*^9}},
 CellLabel->
  "In[1817]:=",ExpressionUUID->"f3f112cf-c68d-456c-b74d-63053a3e7944"]
}, Closed]],

Cell[CellGroupData[{

Cell["ensemble average of a batch (Parallel\[Rule]False)", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506767146878869*^9, 3.5067671531811543`*^9}, {
   3.507554915952759*^9, 3.507554918310874*^9}, {3.507556747116287*^9, 
   3.507556755028116*^9}, 
   3.5725179287109833`*^9},ExpressionUUID->"080f299e-d3c3-49f6-973f-\
e371d56a2300"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{
      RowBox[{"Trajectory", "[", 
       RowBox[{
        RowBox[{"ops", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
        RowBox[{"events", ":", 
         RowBox[{"Except", "[", 
          RowBox[{"_EventList", "|", 
           RowBox[{"Event", "[", "___", "]"}]}], "]"}]}], ",", 
        RowBox[{"more", ":", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
        "opts___Rule"}], "]"}], "[", "\[Rho]ini_", "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EnsembleAverage", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Trajectory", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], "..."}], "}"}]}], "}"}]}], "]"}], 
     ")"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ensav", ",", "var", ",", "vals", ",", "weights", ",", "nens", ",", 
       "message", ",", "i", ",", "temp", ",", "opbasis", ",", "basis", ",", 
       "vardim", ",", "varsubrules", ",", "maxbatchsize"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp", "=", 
         RowBox[{"PrintTemporary", "[", "\"\<setting up batch..\>\"", "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Trajectory", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nens", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"varsubrules", "=", 
         RowBox[{"EnsembleVariablesSubstitutionRules", "[", "ensav", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"weights", "=", 
         RowBox[{"EnsembleWeights", "[", "ensav", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"NotebookDelete", "[", "temp", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"CombineTrajectoryFunctions", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Monitor", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"Trajectory", "[", "\[IndentingNewLine]", 
                RowBox[{"ops", ",", "\[IndentingNewLine]", 
                 RowBox[{"ReleaseHold", "[", 
                  RowBox[{
                   RowBox[{"Hold", "[", "events", "]"}], "/.", 
                   RowBox[{
                   "varsubrules", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}]}], "]"}], ",", 
                 "\[IndentingNewLine]", "more", ",", "\[IndentingNewLine]", 
                 RowBox[{"Evaluate", "@", 
                  RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"EnsembleAverage", "\[Rule]", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"OperatorBasis", "\[Rule]", "opbasis"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Basis", "\[Rule]", "basis"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ReleaseHold", "[", 
                    RowBox[{
                    RowBox[{"Hold", "[", "opts", "]"}], "/.", 
                    RowBox[{
                    "varsubrules", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}]}], "]"}]}], 
                   "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
                "]"}], "[", 
               RowBox[{"ReleaseHold", "[", 
                RowBox[{
                 RowBox[{"Hold", "[", "\[Rho]ini", "]"}], "/.", 
                 RowBox[{
                 "varsubrules", "\[LeftDoubleBracket]", "i", 
                  "\[RightDoubleBracket]"}]}], "]"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", "nens"}], "}"}]}], 
             "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"ProgressIndicator", "[", 
             RowBox[{"i", ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"nens", "+", "1"}]}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          "weights", ",", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Parallel", "\[Rule]", "False"}], ",", "opts"}], 
                "}"}], ",", 
               RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Options", "[", "CombineTrajectoryFunctions", "]"}]}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"Parallel", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}]}], "&&", 
        "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"ensav", ",", "maxbatchsize"}], "}"}], "=", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"EnsembleAverage", ",", "MaxBatchSize"}], "}"}], "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Trajectory", "]"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"EnsembleAverage", "/.", 
               RowBox[{"{", "opts", "}"}]}], "/.", 
              RowBox[{"Options", "[", "Trajectory", "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"_", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"_", ",", "_"}], "}"}], "..."}], "}"}]}], "}"}]}], 
            "]"}], "&&", "\[IndentingNewLine]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"nens", "=", 
              RowBox[{"Length", "[", 
               RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"maxbatchsize", "=", 
              RowBox[{"Min", "[", 
               RowBox[{
                RowBox[{"Max", "[", 
                 RowBox[{"maxbatchsize", ",", "1"}], "]"}], ",", "nens"}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"maxbatchsize", ">=", "nens"}]}], "\[IndentingNewLine]", 
            ")"}]}]}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5066923457061167`*^9, 3.506692417095523*^9, {3.506692453561578*^9, 
   3.506692505334669*^9}, {3.506692629031838*^9, 3.5066926957678747`*^9}, {
   3.506692736496896*^9, 3.50669284440497*^9}, {3.5066932116562147`*^9, 
   3.5066932278932133`*^9}, {3.506693484789329*^9, 3.506693509806026*^9}, 
   3.5066937284851503`*^9, {3.506693825888592*^9, 3.5066938273192873`*^9}, {
   3.506694063994944*^9, 3.5066940724142714`*^9}, {3.506694282191956*^9, 
   3.506694290211069*^9}, {3.506694359514119*^9, 3.506694371097918*^9}, 
   3.506694557239192*^9, 3.5066946187962008`*^9, {3.506694956344503*^9, 
   3.506694966203347*^9}, {3.506767553660231*^9, 3.506767555723261*^9}, 
   3.507571977254531*^9, {3.5075720101717157`*^9, 3.5075720359721937`*^9}, 
   3.5079673116836157`*^9, 3.507967455235785*^9, 3.509086006880698*^9, {
   3.511169483376247*^9, 3.5111694899172277`*^9}, {3.511179134199709*^9, 
   3.511179135156444*^9}, {3.511181612953557*^9, 3.511181615691659*^9}, 
   3.514871485726852*^9, 3.51500229615989*^9, {3.5150034460383387`*^9, 
   3.5150034755713577`*^9}, {3.532452004836784*^9, 3.532452006869091*^9}, {
   3.533115042654971*^9, 3.533115044248684*^9}, {3.533212834140656*^9, 
   3.5332128999055433`*^9}, {3.533304235024026*^9, 3.5333042542713127`*^9}, 
   3.538910585155138*^9, {3.563101653945359*^9, 3.563101655272718*^9}, 
   3.566464932293323*^9, {3.572517264107789*^9, 3.572517411145286*^9}, {
   3.572517942023305*^9, 3.572518195337679*^9}, {3.572518238631237*^9, 
   3.572518345469981*^9}, {3.572518641867065*^9, 3.57251864232745*^9}, 
   3.572519090897337*^9, {3.572519143750848*^9, 3.572519159896471*^9}, {
   3.5725428172779703`*^9, 3.572542851272428*^9}, {3.572542889324548*^9, 
   3.572542929549974*^9}, {3.572543767445759*^9, 3.572543788994877*^9}, {
   3.572543891178838*^9, 3.5725439084125013`*^9}, {3.5826076694071198`*^9, 
   3.582607684133844*^9}, {3.639306920231697*^9, 3.6393069491951447`*^9}, {
   3.639307027385469*^9, 3.639307054584996*^9}, {3.639307184493383*^9, 
   3.639307191425723*^9}, {3.6393073331051283`*^9, 3.639307340255151*^9}, {
   3.639307421444813*^9, 3.6393074340105247`*^9}, {3.639307524721356*^9, 
   3.639307581359171*^9}, {3.639307637980091*^9, 3.639307669813033*^9}, {
   3.639307738534745*^9, 3.639307757028803*^9}, {3.6393079485481167`*^9, 
   3.6393079764244537`*^9}, {3.63930801399693*^9, 3.639308017334038*^9}, 
   3.639308134340364*^9, {3.6571927362622347`*^9, 3.6571927628048286`*^9}, {
   3.657193051953068*^9, 3.65719306973895*^9}, {3.728130397034731*^9, 
   3.728130399721469*^9}, {3.728130451284192*^9, 3.72813045141424*^9}},
 CellLabel->
  "In[1818]:=",ExpressionUUID->"3d5381dd-bc2e-40f8-9efc-93a1498b7d60"]
}, Closed]],

Cell[CellGroupData[{

Cell["ensemble average of a batch (Parallel\[Rule]True)", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506767146878869*^9, 3.5067671531811543`*^9}, {
   3.507554915952759*^9, 3.507554918310874*^9}, {3.507556747116287*^9, 
   3.507556755028116*^9}, 3.5725179287109833`*^9, {3.5725430282022867`*^9, 
   3.572543028836421*^9}},ExpressionUUID->"4e0c6e45-7b43-4fee-ba14-\
4497ba46802c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{
      RowBox[{"Trajectory", "[", 
       RowBox[{
        RowBox[{"ops", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
        RowBox[{"events", ":", 
         RowBox[{"Except", "[", 
          RowBox[{"_EventList", "|", 
           RowBox[{"Event", "[", "___", "]"}]}], "]"}]}], ",", 
        RowBox[{"more", ":", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
        "opts___Rule"}], "]"}], "[", "\[Rho]ini_", "]"}]}], "/;", 
    RowBox[{"(", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"EnsembleAverage", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Trajectory", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}], "..."}], "}"}]}], "}"}]}], "]"}], 
     ")"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ensav", ",", "var", ",", "vals", ",", "weights", ",", "nens", ",", 
       "message", ",", "i", ",", "temp", ",", "opbasis", ",", "basis", ",", 
       "vardim", ",", "varsubrules", ",", "maxbatchsize", ",", "eventslist"}],
       "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp", "=", 
         RowBox[{"PrintTemporary", "[", "\"\<setting up batch..\>\"", "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nens", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"varsubrules", "=", 
         RowBox[{"EnsembleVariablesSubstitutionRules", "[", "ensav", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"weights", "=", 
         RowBox[{"EnsembleWeights", "[", "ensav", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SetSharedVariable", "[", 
         RowBox[{"opbasis", ",", "basis"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"eventslist", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"ReleaseHold", "[", 
            RowBox[{
             RowBox[{"Hold", "[", "events", "]"}], "/.", "#"}], "]"}], "&"}], 
          "/@", "varsubrules"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"DistributeDefinitions", "[", 
         RowBox[{"varsubrules", ",", "eventslist"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"NotebookDelete", "[", "temp", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"CombineTrajectoryFunctions", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Parallelize", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Trajectory", "[", "\[IndentingNewLine]", 
                 RowBox[{"ops", ",", "\[IndentingNewLine]", 
                  RowBox[{"Evaluate", "[", 
                   RowBox[{
                   "eventslist", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}], "]"}], ",", 
                  "\[IndentingNewLine]", "more", ",", "\[IndentingNewLine]", 
                  RowBox[{"Evaluate", "@", 
                   RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"EnsembleAverage", "\[Rule]", "False"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"OperatorBasis", "\[Rule]", "opbasis"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Basis", "\[Rule]", "basis"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ReleaseHold", "[", 
                    RowBox[{
                    RowBox[{"Hold", "[", "opts", "]"}], "/.", 
                    RowBox[{
                    "varsubrules", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
                 "]"}], "[", 
                RowBox[{"ReleaseHold", "[", 
                 RowBox[{
                  RowBox[{"Hold", "[", "\[Rho]ini", "]"}], "/.", 
                  RowBox[{
                  "varsubrules", "\[LeftDoubleBracket]", "i", 
                   "\[RightDoubleBracket]"}]}], "]"}], "]"}], 
               "\[IndentingNewLine]", ")"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", "nens"}], "}"}]}], 
             "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Method", "\[Rule]", "\"\<CoarsestGrained\>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"DistributedContexts", "\[Rule]", "\"\<Global`\>\""}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          "weights", ",", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Parallel", "\[Rule]", "False"}], ",", "opts"}], 
                "}"}], ",", 
               RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Options", "[", "CombineTrajectoryFunctions", "]"}]}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"Parallel", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}], "&&", 
        "\[IndentingNewLine]", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"ParallelSetUp", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}], "&&", 
        "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"ensav", ",", "maxbatchsize"}], "}"}], "=", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"EnsembleAverage", ",", "MaxBatchSize"}], "}"}], "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Trajectory", "]"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"EnsembleAverage", "/.", 
               RowBox[{"{", "opts", "}"}]}], "/.", 
              RowBox[{"Options", "[", "Trajectory", "]"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"_", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"_", ",", "_"}], "}"}], "..."}], "}"}]}], "}"}]}], 
            "]"}], "&&", "\[IndentingNewLine]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"nens", "=", 
              RowBox[{"Length", "[", 
               RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"maxbatchsize", "=", 
              RowBox[{"Min", "[", 
               RowBox[{
                RowBox[{"Max", "[", 
                 RowBox[{"maxbatchsize", ",", "1"}], "]"}], ",", "nens"}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"maxbatchsize", ">=", "nens"}]}], "\[IndentingNewLine]", 
            ")"}]}]}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5066923457061167`*^9, 3.506692417095523*^9, {3.506692453561578*^9, 
   3.506692505334669*^9}, {3.506692629031838*^9, 3.5066926957678747`*^9}, {
   3.506692736496896*^9, 3.50669284440497*^9}, {3.5066932116562147`*^9, 
   3.5066932278932133`*^9}, {3.506693484789329*^9, 3.506693509806026*^9}, 
   3.5066937284851503`*^9, {3.506693825888592*^9, 3.5066938273192873`*^9}, {
   3.506694063994944*^9, 3.5066940724142714`*^9}, {3.506694282191956*^9, 
   3.506694290211069*^9}, {3.506694359514119*^9, 3.506694371097918*^9}, 
   3.506694557239192*^9, 3.5066946187962008`*^9, {3.506694956344503*^9, 
   3.506694966203347*^9}, {3.506767553660231*^9, 3.506767555723261*^9}, 
   3.507571977254531*^9, {3.5075720101717157`*^9, 3.5075720359721937`*^9}, 
   3.5079673116836157`*^9, 3.507967455235785*^9, 3.509086006880698*^9, {
   3.511169483376247*^9, 3.5111694899172277`*^9}, {3.511179134199709*^9, 
   3.511179135156444*^9}, {3.511181612953557*^9, 3.511181615691659*^9}, 
   3.514871485726852*^9, 3.51500229615989*^9, {3.5150034460383387`*^9, 
   3.5150034755713577`*^9}, {3.532452004836784*^9, 3.532452006869091*^9}, {
   3.533115042654971*^9, 3.533115044248684*^9}, {3.533212834140656*^9, 
   3.5332128999055433`*^9}, {3.533304235024026*^9, 3.5333042542713127`*^9}, 
   3.538910585155138*^9, {3.563101653945359*^9, 3.563101655272718*^9}, 
   3.566464932293323*^9, {3.572517264107789*^9, 3.572517411145286*^9}, {
   3.572517942023305*^9, 3.572518195337679*^9}, {3.572518238631237*^9, 
   3.572518345469981*^9}, {3.572518641867065*^9, 3.57251864232745*^9}, 
   3.572519090897337*^9, {3.572519143750848*^9, 3.572519159896471*^9}, {
   3.5725428172779703`*^9, 3.572542851272428*^9}, {3.572542889324548*^9, 
   3.572542929549974*^9}, {3.572543043880783*^9, 3.572543097953179*^9}, {
   3.572543800114778*^9, 3.572543840422735*^9}, 3.572543917280282*^9, 
   3.577621667646344*^9, {3.577621765743609*^9, 3.577621765924461*^9}, {
   3.5826076959266148`*^9, 3.582607770352068*^9}, 3.639308053828351*^9, {
   3.639476994782526*^9, 3.639476995264542*^9}, 3.639540391952669*^9, {
   3.639540522320633*^9, 3.6395405284767933`*^9}, {3.63954074262659*^9, 
   3.639540758047329*^9}, {3.639540860506116*^9, 3.6395408698829193`*^9}, {
   3.6395409251827497`*^9, 3.6395409368359137`*^9}, {3.6395409994384813`*^9, 
   3.639541013890917*^9}, 3.639541047357686*^9, {3.639541079726735*^9, 
   3.6395411107902613`*^9}, {3.639541230548667*^9, 3.6395412508290043`*^9}, {
   3.6395413244081917`*^9, 3.639541328628274*^9}, {3.639541411893964*^9, 
   3.639541464475615*^9}, {3.639541540085075*^9, 3.6395416476894903`*^9}, {
   3.639541777965012*^9, 3.6395418002951527`*^9}, {3.639541855066278*^9, 
   3.639541869765298*^9}, {3.639541923556963*^9, 3.639541931128682*^9}, 
   3.639541990868034*^9, 3.639542033665017*^9, {3.639542102007207*^9, 
   3.6395421088061037`*^9}, 3.639542150687276*^9, {3.639542195004294*^9, 
   3.639542200893811*^9}, {3.6395422511662893`*^9, 3.639542267600668*^9}, {
   3.639542307833033*^9, 3.639542308194298*^9}, 3.639542343884287*^9, {
   3.639542390427496*^9, 3.63954241325983*^9}, {3.6395424681833344`*^9, 
   3.639542482986236*^9}, {3.639542618699532*^9, 3.6395426189755993`*^9}, {
   3.639542712374563*^9, 3.63954271859391*^9}, {3.639542818870885*^9, 
   3.639542860494453*^9}, {3.6395429409863*^9, 3.6395429552425833`*^9}, 
   3.6395430084213552`*^9, {3.639543291789673*^9, 3.639543298632206*^9}, {
   3.6395433546913147`*^9, 3.639543360230632*^9}, {3.6395434517772293`*^9, 
   3.639543452186729*^9}, 3.639582468149991*^9, {3.6395826953399763`*^9, 
   3.639582736469879*^9}, {3.639582826611096*^9, 3.6395828520096817`*^9}, {
   3.639583288480069*^9, 3.6395832964762173`*^9}, {3.639584981463458*^9, 
   3.6395849847858677`*^9}, {3.6395852174286127`*^9, 3.63958522666579*^9}, {
   3.6395853435414343`*^9, 3.6395853438859243`*^9}, {3.639585429024774*^9, 
   3.6395854296549797`*^9}, {3.639585506659257*^9, 3.639585507260556*^9}, {
   3.639585791724125*^9, 3.6395857967841387`*^9}, 3.639585875303803*^9, {
   3.657192872042297*^9, 3.6571929041021748`*^9}, {3.657192947576251*^9, 
   3.657192983039253*^9}, {3.7027292783111353`*^9, 3.7027292889591265`*^9}, {
   3.7028155356030793`*^9, 3.702815539763117*^9}, {3.7028155964595385`*^9, 
   3.702815596627986*^9}, 3.7039204939157248`*^9, {3.728130583441956*^9, 
   3.7281305853218307`*^9}, {3.72813063354331*^9, 3.728130633683571*^9}, {
   3.728130749782813*^9, 3.7281308006382704`*^9}, 3.728130865544693*^9, {
   3.728131197223194*^9, 3.728131197369768*^9}},
 CellLabel->
  "In[1819]:=",ExpressionUUID->"83ce7f18-23e0-4f49-80dd-297695ca6b42"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["main calculations", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.502002117857419*^9, 
   3.5020021434008913`*^9}, 3.5020021999478073`*^9, {3.507572481822721*^9, 
   3.507572484437044*^9}},ExpressionUUID->"d363df82-f11f-48b1-aacd-\
24b213048e7e"],

Cell[CellGroupData[{

Cell["convert operator into Operator form", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
  3.456508942983632*^9, 3.456508989966378*^9}, {3.502510371950556*^9, 
  3.502510397007187*^9}, {3.511182524762195*^9, 3.5111825276074877`*^9}, {
  3.532021494984589*^9, 3.532021517925418*^9}, {3.532021562211097*^9, 
  3.5320215628062687`*^9}, {3.533047172475444*^9, 
  3.5330471770062*^9}},ExpressionUUID->"9497a42b-b066-4571-8973-8811e266a83f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
     RowBox[{"Trajectory", "[", 
      RowBox[{
       RowBox[{"ops", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "events_", ",", 
       RowBox[{"opbasis", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
       RowBox[{"basis", ":", 
        RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], 
     "[", 
     RowBox[{"\[Rho]ini_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{"#", ",", 
            RowBox[{"Except", "[", "_Operator", "]"}]}], "]"}], "&&", 
          RowBox[{"OperatorQ", "[", "#", "]"}]}], ")"}], "&"}], ")"}]}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Trajectory", "[", 
     RowBox[{
     "ops", ",", "events", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}],
     "[", "\[IndentingNewLine]", 
    RowBox[{"Operator", "[", 
     RowBox[{
     "\[Rho]ini", ",", "opbasis", ",", "basis", ",", "\[IndentingNewLine]", 
      RowBox[{"Sequence", "@@", 
       RowBox[{"FilterRules", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", "opts"}], 
          "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], 
     "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456508639886243*^9, 3.45650868185382*^9}, {
   3.456509037620788*^9, 3.4565091550569553`*^9}, {3.456509306055188*^9, 
   3.456509320760811*^9}, {3.4565093993122263`*^9, 3.456509477912705*^9}, {
   3.456509632074041*^9, 3.456509637733838*^9}, 3.470141403049787*^9, {
   3.4973727977578773`*^9, 3.497372899045732*^9}, {3.501998235358918*^9, 
   3.501998292325285*^9}, {3.50262272266681*^9, 3.502622722951645*^9}, {
   3.502622767618544*^9, 3.502622768767267*^9}, {3.505833204667287*^9, 
   3.505833247909564*^9}, 3.510310732193097*^9, {3.5111821060313463`*^9, 
   3.511182157884756*^9}, {3.5111824905013313`*^9, 3.511182493351407*^9}, {
   3.511182536541813*^9, 3.511182605450266*^9}, {3.514872301916871*^9, 
   3.514872304939823*^9}, {3.532021536242111*^9, 3.532021556811419*^9}, 
   3.5321468659543877`*^9, {3.532692214054059*^9, 3.532692221420445*^9}, 
   3.618401578850541*^9, 3.618401611153432*^9, 3.6184022754240026`*^9, 
   3.618403465328258*^9, {3.618481506623539*^9, 3.618481541060628*^9}},
 CellLabel->
  "In[1820]:=",ExpressionUUID->"9da56580-0c05-4092-89cd-497e6f8958b9"]
}, Closed]],

Cell[CellGroupData[{

Cell["trajectory of single operator", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
  3.456508942983632*^9, 3.456508989966378*^9}, {3.502510371950556*^9, 
  3.502510397007187*^9}, {3.5111825088736057`*^9, 
  3.5111825129918613`*^9}},ExpressionUUID->"a0e6522f-91eb-4f7e-adc9-\
db574d1f1e15"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{
      RowBox[{"Trajectory", "[", 
       RowBox[{
        RowBox[{"op_", "?", "OperatorQ"}], ",", "events_", ",", 
        RowBox[{"opbasis", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
        RowBox[{"basis", ":", 
         RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}],
       "[", "\[Rho]ini_Operator", "]"}]}], "/;", "\[IndentingNewLine]", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"EnsembleAverage", ",", "NormalizationFactor"}], "}"}], "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Trajectory", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"None", "|", "False"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"First", "@", 
    RowBox[{
     RowBox[{"Trajectory", "[", 
      RowBox[{
       RowBox[{"{", "op", "}"}], ",", "events", ",", "opbasis", ",", "basis", 
       ",", "opts"}], "]"}], "[", "\[Rho]ini", "]"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456508639886243*^9, 3.45650868185382*^9}, {
   3.456509037620788*^9, 3.4565091550569553`*^9}, {3.456509306055188*^9, 
   3.456509320760811*^9}, {3.4565093993122263`*^9, 3.456509477912705*^9}, {
   3.456509632074041*^9, 3.456509637733838*^9}, 3.470141403049787*^9, {
   3.4973727977578773`*^9, 3.497372899045732*^9}, {3.501998235358918*^9, 
   3.501998292325285*^9}, {3.50262272266681*^9, 3.502622722951645*^9}, {
   3.502622767618544*^9, 3.502622768767267*^9}, {3.505833146375599*^9, 
   3.505833192138406*^9}, {3.510310720622402*^9, 3.510310723188088*^9}, {
   3.511181287480062*^9, 3.511181316276935*^9}, 3.511182621354314*^9, {
   3.5111826610075893`*^9, 3.5111827070404882`*^9}, {3.514872311524377*^9, 
   3.51487231738069*^9}, {3.532021574139674*^9, 3.532021581871385*^9}, {
   3.532692229596718*^9, 3.53269223650031*^9}, 3.533177147682378*^9, {
   3.534399042944796*^9, 3.534399045731633*^9}, {3.6993020345895844`*^9, 
   3.6993020444079275`*^9}, {3.699302938080473*^9, 3.6993029400842323`*^9}},
 CellLabel->
  "In[1821]:=",ExpressionUUID->"49d06feb-3156-4bd0-8627-15828010dc39"]
}, Closed]],

Cell[CellGroupData[{

Cell["trajectories of several operators", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.456510357569454*^9, 
   3.456510365295979*^9}, 3.502510430181912*^9, {3.511182640165556*^9, 
   3.511182645634788*^9}},ExpressionUUID->"cfd785a2-b139-470f-bdf1-\
0dd3da305f74"],

Cell["\<\
BackgroundGenerator will have been automatically wrapped in Hold in order to \
conduct the EnsembleAverage. So ReleaseHold is needed now.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.533195364724825*^9, 3.533195479226943*^9}, {
   3.5331994475134573`*^9, 3.53319945117275*^9}, {3.53319996173472*^9, 
   3.53319996388442*^9}, {3.533208252004567*^9, 3.533208256014975*^9}, {
   3.533208294006229*^9, 3.533208349716641*^9}, 
   3.709375522576262*^9},ExpressionUUID->"ed257b41-4472-4a40-b147-\
ee05c2824661"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "@", 
     RowBox[{
      RowBox[{"Trajectory", "[", 
       RowBox[{
        RowBox[{"ops", ":", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"_", "?", "OperatorQ"}], ".."}], "}"}]}], ",", "events_", 
        ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], "[", 
      "\[Rho]ini_Operator", "]"}]}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"EnsembleAverage", ",", "NormalizationFactor"}], "}"}], "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Trajectory", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"None", "|", "False"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\[Rho]func", ",", "\[Rho]funclist", ",", "\[Rho]funct", ",", "tfin", 
       ",", "tini", ",", "norm", ",", "opnormsqlist", ",", "conjgopvecs", ",",
        "tval", ",", "t", ",", "backg", ",", "tintervals", ",", "ninterps", 
       ",", "\[Rho]intervalfuncs", ",", "interppoints", ",", "maxstepsize"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"norm", ",", "interppoints", ",", "maxstepsize"}], "}"}], 
        "=", 
        RowBox[{"ReleaseHold", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "NormalizationFactor", ",", "InterpolationPoints", ",", 
             "MaxStepSize"}], "}"}], "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"backg", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Which", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"MatchQ", "[", 
             RowBox[{"#", ",", 
              RowBox[{"NullOperator", "[", "]"}]}], "]"}], ",", "#", ",", 
            "\[IndentingNewLine]", 
            RowBox[{"MatchQ", "[", 
             RowBox[{"#", ",", 
              RowBox[{"_", "?", "OperatorQ"}]}], "]"}], ",", 
            RowBox[{"NDiagonalize", "[", 
             RowBox[{"#", ",", "basis"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"MatchQ", "[", 
             RowBox[{"#", ",", 
              RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}], ",", 
            RowBox[{"NDiagonalize", "[", 
             RowBox[{"#", ",", "opbasis", ",", "basis"}], "]"}], ",", 
            "\[IndentingNewLine]", "True", ",", "#"}], "\[IndentingNewLine]", 
           "]"}], "&"}], "@", " ", 
         RowBox[{"ReleaseHold", "[", 
          RowBox[{
           RowBox[{"BackgroundGenerator", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Trajectory", "]"}]}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"opnormsqlist", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"OperatorNorm", "[", "#", "]"}], "^", "2"}], ")"}], "&"}],
          "/@", "ops"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Rho]func", "=", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"NPropagate", "[", 
          RowBox[{"events", ",", 
           RowBox[{"OperatorBasis", "\[Rule]", "opbasis"}], ",", 
           RowBox[{"Basis", "\[Rule]", " ", "basis"}], ",", 
           RowBox[{"Continuous", "\[Rule]", "True"}], ",", 
           RowBox[{"BackgroundGenerator", "\[Rule]", " ", "backg"}], ",", 
           RowBox[{"Sequence", "@@", 
            RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "opts", "}"}], ",", 
                RowBox[{"CurrentOptionsToPassDown", "[", 
                 RowBox[{"Trajectory", ",", "NPropagate"}], "]"}], ",", 
                RowBox[{"CurrentOptionsToPassDown", "[", 
                 RowBox[{"Trajectory", ",", "NDSolve"}], "]"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"Options", "[", "Trajectory", "]"}], ",", 
                RowBox[{"Options", "[", "NPropagate", "]"}], ",", 
                RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}], 
             "]"}]}]}], "\[IndentingNewLine]", "]"}], "[", "\[Rho]ini", 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"FreeQ", "[", 
           RowBox[{"\[Rho]func", ",", "$Failed"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"Trajectory", "::", "failed"}], "]"}], ";", 
           RowBox[{"Table", "[", 
            RowBox[{"$Failed", ",", 
             RowBox[{"{", 
              RowBox[{"Length", "[", "ops", "]"}], "}"}]}], "]"}]}], ")"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
           "ConvertOperatorTrajectoryFunctionToTrajectoryFunction", "[", 
            "\[IndentingNewLine]", 
            RowBox[{"\[Rho]func", ",", "#", ",", "opts"}], "]"}], "&"}], "/@",
           "ops"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456510372984645*^9, 3.456510416352416*^9}, 
   3.470141406872658*^9, {3.497372916740807*^9, 3.4973729584051847`*^9}, {
   3.501726895124645*^9, 3.501726984426737*^9}, {3.501727017387485*^9, 
   3.501727030472975*^9}, {3.501727074963641*^9, 3.501727178939012*^9}, {
   3.501727240265745*^9, 3.501727311762375*^9}, {3.501727463832203*^9, 
   3.5017274667172203`*^9}, {3.501727767092012*^9, 3.501727770978115*^9}, {
   3.501728144808923*^9, 3.501728185108396*^9}, {3.50199831859202*^9, 
   3.5019983935433607`*^9}, 3.510310739060955*^9, 3.511181346481368*^9, 
   3.5111813981663094`*^9, {3.511182205980513*^9, 3.5111822186828117`*^9}, {
   3.511184823102943*^9, 3.511184928968968*^9}, {3.5111851524212227`*^9, 
   3.511185158313632*^9}, {3.511185222917562*^9, 3.5111852258342047`*^9}, {
   3.511186186631297*^9, 3.511186212771203*^9}, {3.513233421174205*^9, 
   3.513233424329383*^9}, {3.513283350899295*^9, 3.51328349085555*^9}, {
   3.514872325221861*^9, 3.514872331773896*^9}, {3.515057647549715*^9, 
   3.515057765261259*^9}, {3.515057799359412*^9, 3.515057895160985*^9}, {
   3.515061087836505*^9, 3.515061092353285*^9}, {3.5150716115819483`*^9, 
   3.515071639773539*^9}, {3.515071675680122*^9, 3.515071679671053*^9}, {
   3.51507176284516*^9, 3.515071768794137*^9}, {3.515072100692648*^9, 
   3.51507210380029*^9}, {3.515072684072762*^9, 3.5150727291595993`*^9}, 
   3.5150727654895487`*^9, {3.5150728132814283`*^9, 3.5150728143416157`*^9}, {
   3.5150729554302273`*^9, 3.515073061356761*^9}, {3.51507309905271*^9, 
   3.515073121387802*^9}, {3.515073231246881*^9, 3.5150732611352863`*^9}, {
   3.5150732947833157`*^9, 3.5150732970914993`*^9}, {3.515073796172511*^9, 
   3.515073808836276*^9}, {3.515074208640542*^9, 3.515074223545542*^9}, {
   3.516603786766738*^9, 3.516603795749242*^9}, {3.532021595155319*^9, 
   3.532021620788225*^9}, {3.532021656793305*^9, 3.532021685284947*^9}, {
   3.532064038527025*^9, 3.532064126326332*^9}, {3.532064265495635*^9, 
   3.532064267994989*^9}, 3.532064317886044*^9, {3.5320643874904327`*^9, 
   3.532064423973586*^9}, {3.532065180549094*^9, 3.532065210908704*^9}, {
   3.532065302869718*^9, 3.532065318478793*^9}, {3.53206550533144*^9, 
   3.532065508897657*^9}, {3.532236889641214*^9, 3.532236890749675*^9}, {
   3.5322369402163553`*^9, 3.532236957317439*^9}, 3.5322370232246847`*^9, {
   3.5326922451025467`*^9, 3.5326922525818996`*^9}, {3.533045658562806*^9, 
   3.53304566019169*^9}, {3.533177149611288*^9, 3.533177151971899*^9}, {
   3.533205827775998*^9, 3.53320585887685*^9}, {3.533205967595626*^9, 
   3.5332059731358128`*^9}, {3.533206176983672*^9, 3.533206183050153*^9}, {
   3.533206251782598*^9, 3.533206273747035*^9}, {3.533206341121275*^9, 
   3.533206343491208*^9}, {3.534399049827454*^9, 3.53439905264345*^9}, {
   3.543516696920844*^9, 3.543516719252428*^9}, {3.543946656322263*^9, 
   3.5439467333729763`*^9}, {3.543946781877743*^9, 3.543946787002297*^9}, {
   3.5442039334963417`*^9, 3.544203943918622*^9}, {3.54420399346726*^9, 
   3.544204001138094*^9}, {3.54538798604065*^9, 3.545387987006597*^9}, 
   3.5456703655498133`*^9, {3.5522148258362226`*^9, 3.55221486674006*^9}, 
   3.5522149300163937`*^9, {3.5522149628889713`*^9, 3.552214966718816*^9}, {
   3.5522151741385927`*^9, 3.552215177175571*^9}, {3.552215753865322*^9, 
   3.552215770977713*^9}, {3.5522158155668297`*^9, 3.552215819509636*^9}, {
   3.552215873274434*^9, 3.552215878544043*^9}, {3.552215923401444*^9, 
   3.552215925398942*^9}, {3.558599541722023*^9, 3.5585995675776777`*^9}, {
   3.558605752997266*^9, 3.558605882237158*^9}, {3.558606169578332*^9, 
   3.558606193506386*^9}, 3.5586072865359087`*^9, {3.5586293275142183`*^9, 
   3.558629329362659*^9}, {3.55948354107297*^9, 3.559483564408949*^9}, {
   3.559484124809889*^9, 3.5594842591840687`*^9}, {3.559484330614358*^9, 
   3.559484335981954*^9}, {3.5604132130478773`*^9, 3.560413227653303*^9}, {
   3.5618005103943863`*^9, 3.561800679868181*^9}, {3.5618007263654757`*^9, 
   3.5618007285427437`*^9}, {3.56180076104226*^9, 3.561800761354149*^9}, {
   3.561800820676508*^9, 3.561800878389901*^9}, {3.561800915850626*^9, 
   3.561800926108383*^9}, 3.56180125971684*^9, {3.561801511661786*^9, 
   3.561801513355523*^9}, {3.561801702793641*^9, 3.561801705797963*^9}, {
   3.561803060343864*^9, 3.5618030617757187`*^9}, {3.561803203829665*^9, 
   3.561803204057184*^9}, {3.5618039406163387`*^9, 3.561804070348497*^9}, {
   3.561949643808937*^9, 3.561949649438442*^9}, {3.561949691125848*^9, 
   3.561949723886878*^9}, {3.561949914084606*^9, 3.561949954139312*^9}, 
   3.561975914676145*^9, {3.561978246803912*^9, 3.5619782713293953`*^9}, {
   3.561978353444961*^9, 3.561978392560193*^9}, {3.561980988406595*^9, 
   3.561981288382784*^9}, 3.5619813734200974`*^9, {3.5619815147095547`*^9, 
   3.5619816248315153`*^9}, {3.5619816940214157`*^9, 
   3.5619817360490313`*^9}, {3.561981794351755*^9, 3.561981825564251*^9}, {
   3.561982409731296*^9, 3.561982416663473*^9}, {3.561982447175317*^9, 
   3.561982483342243*^9}, {3.5619827363792963`*^9, 3.5619827449771442`*^9}, {
   3.561982827331937*^9, 3.561982846008585*^9}, {3.5620464126623373`*^9, 
   3.562046421116076*^9}, {3.562046469773774*^9, 3.562046476493668*^9}, {
   3.562046738555545*^9, 3.562046747376256*^9}, {3.562046784865691*^9, 
   3.562046785408187*^9}, 3.562046927705907*^9, {3.562046960186174*^9, 
   3.562046966135254*^9}, 3.56204702577561*^9, {3.562047635591248*^9, 
   3.562047636673503*^9}, {3.562047748714669*^9, 3.562047754286805*^9}, 
   3.562048223108178*^9, 3.562048277808278*^9, {3.562148558350285*^9, 
   3.562148668803924*^9}, {3.562148802541917*^9, 3.562148940255323*^9}, {
   3.562148981790167*^9, 3.562149020522036*^9}, {3.5621490587669086`*^9, 
   3.562149168037602*^9}, {3.562149390447617*^9, 3.562149393661105*^9}, {
   3.5621495506631393`*^9, 3.5621495612323523`*^9}, {3.562211220183406*^9, 
   3.56221122043845*^9}, {3.562218592011177*^9, 3.5622186355752497`*^9}, {
   3.5627602494127493`*^9, 3.56276025004889*^9}, {3.573743836679323*^9, 
   3.573743858090453*^9}, {3.573744475750661*^9, 3.573744478573045*^9}, {
   3.5801194180979767`*^9, 3.5801195805687304`*^9}, {3.580119797285522*^9, 
   3.580119800669195*^9}, {3.580119834138994*^9, 3.5801198697903767`*^9}, {
   3.580119907408061*^9, 3.5801199148069563`*^9}, {3.580120679553979*^9, 
   3.580120685677815*^9}, {3.5801207594931803`*^9, 3.580120808506589*^9}, {
   3.580121557207399*^9, 3.580121661801983*^9}, {3.5801216966313877`*^9, 
   3.580121701684423*^9}, {3.5801217508204193`*^9, 3.580121762424629*^9}, {
   3.580121792505739*^9, 3.5801220290766497`*^9}, {3.580122073214982*^9, 
   3.58012209290126*^9}, {3.580122156964665*^9, 3.580122240093544*^9}, {
   3.580122326742324*^9, 3.5801223335617237`*^9}, {3.580122386194888*^9, 
   3.580122398638707*^9}, {3.580122823201496*^9, 3.580122832759281*^9}, {
   3.580122912373027*^9, 3.580122915313048*^9}, {3.5801229649731407`*^9, 
   3.580122977021188*^9}, {3.583409022177101*^9, 3.583409025766852*^9}, {
   3.587646084160553*^9, 3.5876461032352867`*^9}, {3.593264467779855*^9, 
   3.5932645081257687`*^9}, 3.593264779026291*^9, {3.593265384320813*^9, 
   3.593265437112138*^9}, 3.5932662070717573`*^9, {3.593266240397163*^9, 
   3.593266245705474*^9}, {3.5932667408671083`*^9, 3.593266743104947*^9}, {
   3.593285623233152*^9, 3.593285626294421*^9}, 3.5932861394941*^9, 
   3.5932870667427597`*^9, {3.618481581041939*^9, 3.618481581431614*^9}, {
   3.621079133413437*^9, 3.621079246815783*^9}, {3.621079500802413*^9, 
   3.6210795112475033`*^9}, {3.6213563702817593`*^9, 3.621356386641285*^9}, {
   3.623337819263853*^9, 3.623337929491961*^9}, 3.623337971243712*^9, {
   3.6233380250556393`*^9, 3.623338058429562*^9}, {3.623339072539239*^9, 
   3.623339078354615*^9}, {3.623339366867638*^9, 3.623339383571323*^9}, 
   3.62333961035321*^9, {3.639583021379841*^9, 3.63958307731581*^9}, {
   3.639583582978014*^9, 3.6395835869180517`*^9}, {3.63958498961898*^9, 
   3.6395849920743628`*^9}, {3.639585804265519*^9, 3.639585808343059*^9}, 
   3.683130515215961*^9, {3.699301272631448*^9, 3.699301279451225*^9}, {
   3.6993014200155044`*^9, 3.6993014251985846`*^9}, {3.69930147183051*^9, 
   3.6993014803165197`*^9}, {3.6993015160274935`*^9, 3.699301518698988*^9}, {
   3.699301589246477*^9, 3.699301614706581*^9}, 3.6993016938571205`*^9, {
   3.699301740265417*^9, 3.6993017412062206`*^9}, {3.699301989472964*^9, 
   3.699301992657382*^9}, {3.6993020817274475`*^9, 3.6993021556870537`*^9}, {
   3.6993021990952263`*^9, 3.699302201537891*^9}, {3.6993022687242117`*^9, 
   3.699302271658081*^9}, {3.6993023164262595`*^9, 3.699302384114684*^9}, {
   3.699302561483265*^9, 3.6993026306295953`*^9}, {3.6993026943073845`*^9, 
   3.6993027017403307`*^9}, {3.6993027678070903`*^9, 3.699302802471918*^9}, {
   3.699302876241394*^9, 3.699302896310934*^9}, {3.699559700607379*^9, 
   3.6995597033512836`*^9}, {3.699559904597885*^9, 3.6995599077740927`*^9}, {
   3.6995600318179617`*^9, 3.6995600347123604`*^9}, {3.699562146554759*^9, 
   3.69956215350882*^9}, {3.699562189079527*^9, 3.6995621909860497`*^9}, 
   3.6995622404373*^9, {3.699564192285054*^9, 3.6995641967255254`*^9}, {
   3.699564263162368*^9, 3.6995642794225445`*^9}, {3.6995644387714586`*^9, 
   3.6995644560087175`*^9}, {3.699564541086362*^9, 3.699564541374699*^9}, {
   3.6995653398942723`*^9, 3.6995653434862723`*^9}, {3.6996148749616804`*^9, 
   3.6996148949927063`*^9}, {3.699618063425915*^9, 3.6996180696262937`*^9}, {
   3.702809854209592*^9, 3.70280987305295*^9}, {3.7028099109516983`*^9, 
   3.7028099111239243`*^9}, {3.7028154617882414`*^9, 3.7028154860837*^9}, {
   3.702815520443861*^9, 3.702815520651411*^9}, {3.702815659066641*^9, 
   3.7028156598818035`*^9}, {3.703927293116727*^9, 3.7039273240789843`*^9}, {
   3.709375523258782*^9, 3.70937552392286*^9}},
 CellLabel->
  "In[1822]:=",ExpressionUUID->"c1ae2ed7-38d3-4d7b-93fc-6137702b0522"],

Cell[CellGroupData[{

Cell["\<\
local routine: ConvertOperatorTrajectoryFunctionToTrajectoryFunction\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.623337190645422*^9, 3.623337205579728*^9}, {
  3.623339866225156*^9, 
  3.6233398691192493`*^9}},ExpressionUUID->"78c48384-f621-4126-a26a-\
0544e1c62670"],

Cell["\<\
ExpToTrig is desirable for simplifying complex exponentials into sines and \
cosines, removing imaginary factors. However the generation of hyperbolic \
trig functions causes bad rounding errors on evaluation in some circumstances \
(see bug 141221-MHL-2111b2-Trajectory). The conversion is therefore reversed \
if hyperbolic trig functions are generated.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.6314290734959993`*^9, 
  3.631429267388995*^9}},ExpressionUUID->"8e99f6a6-efed-4804-9957-\
bd86172b02e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{
    "ConvertOperatorTrajectoryFunctionToTrajectoryFunction", "[", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"OperatorTrajectoryFunction", "[", 
       RowBox[{"timing_", ",", 
        RowBox[{"Function", "[", 
         RowBox[{"t_", ",", "arg_"}], "]"}], ",", "more___"}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"obsop_", "?", "OperatorQ"}], ",", "\[IndentingNewLine]", 
      "opts___Rule"}], "\[IndentingNewLine]", "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "norm", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"norm", "=", 
        RowBox[{
         RowBox[{"NormalizationFactor", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{"NormalizationFactor", "\[Rule]", "1"}], "}"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"TrajectoryFunction", "[", 
        RowBox[{"timing", ",", "\[IndentingNewLine]", 
         RowBox[{"Function", "[", 
          RowBox[{"t", ",", 
           RowBox[{"Evaluate", "[", 
            RowBox[{"arg", "/.", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
              "op_Operator", "\[RuleDelayed]", "\[IndentingNewLine]", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"FreeQ", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"Cosh", "|", "Sinh"}]}], "]"}], ",", "#", ",", 
                    RowBox[{"TrigToExp", "[", "#", "]"}]}], "]"}], "&"}], "@", 
                 RowBox[{"ExpToTrig", "[", 
                  RowBox[{
                   RowBox[{"OperatorAmplitude", "[", 
                    RowBox[{"op", "\[Rule]", "obsop"}], "]"}], "/", "norm"}], 
                  "]"}]}], ")"}]}], "\[IndentingNewLine]", "}"}]}], 
            "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.62333721557078*^9, 3.6233372180923157`*^9}, {
   3.6233372665829287`*^9, 3.623337335024548*^9}, {3.623337365173994*^9, 
   3.623337420519058*^9}, 3.623337482425338*^9, {3.623337514402156*^9, 
   3.6233375988777113`*^9}, {3.62333773219913*^9, 3.623337798183189*^9}, {
   3.62333809219481*^9, 3.6233380948533487`*^9}, {3.623338454784726*^9, 
   3.623338455333288*^9}, {3.6233394650763683`*^9, 3.623339473869177*^9}, {
   3.631429274460902*^9, 3.631429351353907*^9}, {3.6995618979522505`*^9, 
   3.6995619035645485`*^9}, {3.699564205362108*^9, 3.6995642057103944`*^9}, 
   3.6995643195307407`*^9},
 CellLabel->
  "In[1823]:=",ExpressionUUID->"aca8163d-9c6b-4f1e-94fb-91eb0edcc20f"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["TrajectoryFunction", "Section",
 InitializationCell->True,
 CellChangeTimes->{
  3.454575871518672*^9, {3.454575931488456*^9, 3.454575937638855*^9}, {
   3.4553332615084953`*^9, 3.4553332635463343`*^9}, {3.455631913573341*^9, 
   3.4556319149857397`*^9}, {3.455635639784648*^9, 3.455635640352126*^9}, {
   3.456506507218137*^9, 3.456506512303032*^9}, 
   3.4565091774907017`*^9},ExpressionUUID->"1d8f8726-823e-4737-8a74-\
9bb6924e1cc7"],

Cell[CellGroupData[{

Cell["TrajectoryFunction", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506767146878869*^9, 3.5067671531811543`*^9}, {
  3.507554915952759*^9, 3.507554918310874*^9}, {3.507556747116287*^9, 
  3.507556755028116*^9}, {3.511189139777685*^9, 3.5111891456161633`*^9}, {
  3.53320949935858*^9, 
  3.533209500826803*^9}},ExpressionUUID->"2cc38c04-692a-495f-bd9a-\
285508927056"],

Cell[CellGroupData[{

Cell["general", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.552211415714978*^9, 
  3.5522114165528593`*^9}},ExpressionUUID->"9ee87d77-b1f2-49ab-8698-\
c18c2e6b5586"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "TrajectoryFunction", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5435154664503603`*^9, 3.543515479855259*^9}, {
   3.543515681441785*^9, 3.543515685567815*^9}, 3.543944498361163*^9},
 CellLabel->
  "In[1824]:=",ExpressionUUID->"cb3d5fc7-1069-424e-9a84-97d34c427dbd"]
}, Closed]],

Cell[CellGroupData[{

Cell["output format", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.552211415714978*^9, 
  3.5522114341124277`*^9}},ExpressionUUID->"1e50219f-83a1-44f4-bf44-\
cf3a7e20a632"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Format", "[", 
    RowBox[{"TrajectoryFunction", "[", 
     RowBox[{
      RowBox[{"range", ":", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tb_", "?", "NumericQ"}], ",", 
          RowBox[{"ta_", "?", "NumericQ"}]}], "}"}], "}"}]}], ",", "opfunc_", 
      ",", "opts___Rule"}], "]"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"RowBox", "[", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"\"\<TrajectoryFunction[\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"ToBoxes", "[", 
        RowBox[{"EngineeringForm", "@", 
         RowBox[{"Chop", "[", "\[IndentingNewLine]", 
          RowBox[{"N", "@", 
           RowBox[{"(", 
            RowBox[{"Reverse", "/@", "range"}], ")"}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"ToBoxes", "[", "\"\<, <>]\>\"", "]"}]}], 
      "\[IndentingNewLine]", "}"}], "]"}], "//", "DisplayForm"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506526794569*^9, 3.456506591362196*^9}, {
   3.456506807868026*^9, 3.456506808025032*^9}, {3.456506916908573*^9, 
   3.4565069187852793`*^9}, {3.4565070618491907`*^9, 3.456507073361253*^9}, {
   3.456507104811401*^9, 3.456507132515758*^9}, {3.456507184889974*^9, 
   3.456507193088976*^9}, {3.456507308088336*^9, 3.456507322174239*^9}, {
   3.456507881744112*^9, 3.45650788247845*^9}, {3.45934179309993*^9, 
   3.459341855795616*^9}, {3.459341927566702*^9, 3.459342010299419*^9}, {
   3.459408401457662*^9, 3.4594084060043497`*^9}, {3.459409171653989*^9, 
   3.459409261062017*^9}, {3.459411850954893*^9, 3.459411852765896*^9}, 
   3.459427841061582*^9, {3.543515745874045*^9, 3.543515750661955*^9}, {
   3.543516479690681*^9, 3.5435165173236723`*^9}, 3.543944505456719*^9},
 CellLabel->
  "In[1825]:=",ExpressionUUID->"381a2416-4372-479d-81b9-db55db232219"]
}, Closed]],

Cell[CellGroupData[{

Cell["evaluation", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.552211415714978*^9, 
  3.552211476912644*^9}},ExpressionUUID->"5fc72ea3-2833-49d4-9292-\
b50995691557"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TrajectoryFunction", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621156400658635*^9, 3.621156422158201*^9}},
 CellLabel->
  "In[1826]:=",ExpressionUUID->"b015c233-2335-457c-bd92-b6e685d504dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"TrajectoryFunction", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"tb_", "?", "NumericQ"}], ",", 
          RowBox[{"ta_", "?", "NumericQ"}]}], "}"}], "}"}], ",", 
       RowBox[{"func", ":", 
        RowBox[{"Except", "[", "_String", "]"}]}], ",", "opts___Rule"}], 
      "]"}], "[", 
     RowBox[{"t_", "?", "NumericQ"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"TrueQ", "[", 
       RowBox[{
        RowBox[{"Chop", "@", 
         RowBox[{"N", "[", 
          RowBox[{"t", "-", "ta"}], "]"}]}], "<", "0"}], "]"}], "||", 
      RowBox[{"TrueQ", "[", 
       RowBox[{
        RowBox[{"Chop", "@", 
         RowBox[{"N", "[", 
          RowBox[{"t", "-", "tb"}], "]"}]}], ">", "0"}], "]"}]}], ")"}]}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"TrajectoryFunction", "::", "outofrange"}], ",", 
       RowBox[{"N", "@", "t"}], ",", 
       RowBox[{"N", "@", "ta"}], ",", 
       RowBox[{"N", "@", "tb"}]}], "]"}], ";", "0"}], ")"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4565066387991533`*^9, 3.456506747185598*^9}, {
   3.456506813471656*^9, 3.456506813658473*^9}, {3.45650693381577*^9, 
   3.456506980806471*^9}, {3.456507328570256*^9, 3.456507331247641*^9}, {
   3.45650918768852*^9, 3.456509205133624*^9}, {3.4565098187416058`*^9, 
   3.4565098238250647`*^9}, 3.456510232214699*^9, {3.4996604754122763`*^9, 
   3.4996605602497053`*^9}, {3.543515769686039*^9, 3.543515770075313*^9}, {
   3.552211559762656*^9, 3.552211571391519*^9}, {3.552211632879628*^9, 
   3.552211636264051*^9}},
 CellLabel->
  "In[1827]:=",ExpressionUUID->"fd431ccb-61ca-4307-b54f-2f7333452c5d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TrajectoryFunction", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tb_", "?", "NumericQ"}], ",", 
         RowBox[{"ta_", "?", "NumericQ"}]}], "}"}], "}"}], ",", 
      RowBox[{"func", ":", 
       RowBox[{"Except", "[", "_String", "]"}]}], ",", "opts___Rule"}], "]"}],
     "[", 
    RowBox[{"t_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"Chop", "[", 
    RowBox[{"N", "@", 
     RowBox[{"func", "[", "t", "]"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506791728052*^9, 3.4565068210568933`*^9}, 
   3.456506986746358*^9, {3.456507336137793*^9, 3.4565073382651787`*^9}, {
   3.4565091931010513`*^9, 3.456509211188219*^9}, {3.532237056787715*^9, 
   3.532237058639518*^9}, {3.543515709144252*^9, 3.543515712662642*^9}, {
   3.5435157847901154`*^9, 3.543515820295774*^9}, {3.543944513325498*^9, 
   3.543944514479164*^9}},
 CellLabel->
  "In[1828]:=",ExpressionUUID->"2df73172-1b4c-4cc9-a0ab-a43f059b9b4d"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.552211415714978*^9, 
  3.552211452447939*^9}},ExpressionUUID->"aab59d81-ee45-4751-9e85-\
b2488ba4696a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TrajectoryFunction", "::", "outofrange"}], "=", 
   "\"\<time point `1` does not lie in the interval between `2` and \
`3`\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456506726342424*^9, 3.456506769186385*^9}, 
   3.456506871325568*^9, 3.456509214488474*^9},
 CellLabel->
  "In[1829]:=",ExpressionUUID->"ce3cf860-c347-47c9-a6ae-bbc6936a0c80"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CombineTrajectoryFunctions", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506767146878869*^9, 3.5067671531811543`*^9}, {
  3.507554915952759*^9, 3.507554918310874*^9}, {3.507556747116287*^9, 
  3.507556755028116*^9}, {3.511189139777685*^9, 
  3.5111891456161633`*^9}},ExpressionUUID->"d4346af4-75df-4e97-ba86-\
604464a8a816"],

Cell[CellGroupData[{

Cell["defaults", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.505930793844303*^9, 3.50593079541113*^9}, 
   3.51118701474756*^9, {3.511189504541121*^9, 3.511189525129212*^9}, {
   3.533305207165804*^9, 
   3.533305208282667*^9}},ExpressionUUID->"87c9f8b8-2979-402f-b7c1-\
98e85e75be99"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "CombineTrajectoryFunctions", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"InterpolationPoints", "\[Rule]", "100"}], ",", 
     RowBox[{"AccuracyGoal", "\[Rule]", "11"}], ",", 
     RowBox[{"PrecisionGoal", "\[Rule]", "11"}], ",", 
     RowBox[{"InterpolationPrecision", "\[Rule]", "11"}], ",", 
     RowBox[{"InterpolationOrder", "\[Rule]", "3"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5333052101999493`*^9, 3.5333052263411207`*^9}, {
  3.5333060092089987`*^9, 3.5333060101733513`*^9}, {3.5522177821658897`*^9, 
  3.552217782496731*^9}},
 CellLabel->
  "In[1830]:=",ExpressionUUID->"68ec5f11-3e05-4504-be03-d7fdd2244742"]
}, Closed]],

Cell[CellGroupData[{

Cell["combine multiple TrajectoryFunctions", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.505930793844303*^9, 3.50593079541113*^9}, 
   3.51118701474756*^9, {3.511189504541121*^9, 
   3.511189525129212*^9}},ExpressionUUID->"f08f350b-a78e-4f71-bd8e-\
91806ff0c07b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineTrajectoryFunctions", "[", 
    RowBox[{
     RowBox[{"tfuncset", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_TrajectoryFunction", ".."}], "}"}], ".."}], "}"}]}], ",", 
     "weights_List", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CombineTrajectoryFunctions", "[", 
      RowBox[{"#", ",", "weights", ",", "opts"}], "]"}], "&"}], "/@", 
    RowBox[{"Transpose", "[", "tfuncset", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.50593055828701*^9, 3.505930628422043*^9}, {
   3.5059306899672623`*^9, 3.505930703414269*^9}, {3.511157103738802*^9, 
   3.5111571134351673`*^9}, 3.5111598253622704`*^9, {3.511186897568306*^9, 
   3.5111870541312437`*^9}, 3.5111891991711073`*^9, {3.511189546374185*^9, 
   3.511189601409058*^9}, {3.511189668849819*^9, 3.511189698350309*^9}},
 CellLabel->
  "In[1831]:=",ExpressionUUID->"43f878be-d998-4e83-8011-8c5714e4bf61"]
}, Closed]],

Cell[CellGroupData[{

Cell["combine single TrajectoryFunctions", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.505930793844303*^9, 3.50593079541113*^9}, 
   3.51118701474756*^9, {3.511189504541121*^9, 
   3.511189515841934*^9}},ExpressionUUID->"bda564c0-9b79-4aa7-b997-\
5e78dc25c84a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineTrajectoryFunctions", "[", 
    RowBox[{
     RowBox[{"tfuncs", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"TrajectoryFunction", "[", 
         RowBox[{"interval_", ",", "__"}], "]"}], ".."}], "}"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CombineTrajectoryFunctions", "[", 
    RowBox[{"tfuncs", ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"1", "/", 
        RowBox[{"Length", "[", "tfuncs", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"Length", "[", "tfuncs", "]"}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533209434718495*^9, 3.533209472130229*^9}, {
  3.5333052402772293`*^9, 3.533305243072968*^9}, {3.543516573107708*^9, 
  3.5435165784358253`*^9}},
 CellLabel->
  "In[1832]:=",ExpressionUUID->"5f856395-8204-4ac3-8ee2-90ea931a77dd"],

Cell["\<\
v2.5.4: New code avoids the use of the problematic FunctionInterpolation \
routine, at the expense of much coding complexity\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.5622198329044657`*^9, 3.56221987496484*^9}, {
  3.5622248281180773`*^9, 3.56222484477143*^9}, {3.56222827530713*^9, 
  3.562228291033123*^9}},ExpressionUUID->"830fcdb6-ec6a-4073-935c-\
f5e3764d344d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CombineTrajectoryFunctions", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tfuncs", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"TrajectoryFunction", "[", 
          RowBox[{"interval_", ",", "__"}], "]"}], ".."}], "}"}]}], ",", 
      "\[IndentingNewLine]", "weights_List", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", "tfuncs", "]"}], "\[Equal]", 
      RowBox[{"Length", "[", "weights", "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "tintervals", ",", "nintervals", ",", "pwtfuncs", ",", "pwtfunc", ",", 
       "ninterps", ",", "maxstepsize", ",", "interppoints", ",", "tinterps", 
       ",", "combtfuncs", ",", "tfin", ",", "tini", ",", "t"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
       "PrintTemporary", "[", "\"\<combining trajectory functions..\>\"", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"maxstepsize", ",", "interppoints"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"InterpolationStepSize", ",", "InterpolationPoints"}], 
           "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"Options", "[", "Trajectory", "]"}], ",", 
           RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tintervals", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"Sort", "@", 
           RowBox[{"Union", "@", 
            RowBox[{"Flatten", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"First", "[", "#", "]"}], ",", 
                 RowBox[{"Last", "[", "#", "]"}]}], "}"}], "&"}], "/@", 
              RowBox[{"Cases", "[", 
               RowBox[{"tfuncs", ",", 
                RowBox[{
                "_Inequality", "|", "_Greater", "|", "_GreaterEqual", "|", 
                 "_LessEqual"}], ",", "Infinity"}], "]"}]}], "]"}]}]}], ",", 
          "\[IndentingNewLine]", "2", ",", "1"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"tfin", ",", "tini"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Max", "[", "#", "]"}], ",", 
            RowBox[{"Min", "[", "#", "]"}]}], "}"}], "&"}], "@", 
         RowBox[{"Flatten", "[", "tintervals", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"nintervals", "=", 
        RowBox[{"Length", "[", "tintervals", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"pwtfuncs", "=", "\[IndentingNewLine]", 
        RowBox[{"Transpose", "@", 
         RowBox[{"Map", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{"tfunc", ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"Function", "[", 
                RowBox[{"t", ",", 
                 RowBox[{"Evaluate", "@", 
                  RowBox[{"Assuming", "[", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"First", "[", "#", "]"}], "<", "t", "<", 
                    RowBox[{"Last", "[", "#", "]"}]}], ")"}], ",", 
                    RowBox[{"Refine", "[", 
                    RowBox[{
                    RowBox[{
                    "tfunc", "\[LeftDoubleBracket]", "2", 
                    "\[RightDoubleBracket]"}], "[", "t", "]"}], "]"}]}], 
                   "]"}]}]}], "]"}], "&"}], "/@", "tintervals"}]}], 
            "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
           "tfuncs"}], "\[IndentingNewLine]", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"pwtfunc", "=", "\[IndentingNewLine]", 
        RowBox[{"Map", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Function", "[", 
            RowBox[{
             RowBox[{"Evaluate", "[", "t", "]"}], ",", 
             RowBox[{"Evaluate", "[", "#", "]"}]}], "]"}], "&"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Map", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"Dot", "[", 
              RowBox[{"weights", ",", "#"}], "]"}], "&"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#", "[", "t", "]"}], "&"}], ",", "pwtfuncs", ",", 
              RowBox[{"{", "2", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
           "]"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ninterps", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Min", "[", 
           RowBox[{
            RowBox[{"Max", "[", 
             RowBox[{"interppoints", ",", "3"}], "]"}], ",", 
            RowBox[{"Ceiling", "[", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{
                RowBox[{"First", "[", "#", "]"}], "-", 
                RowBox[{"Last", "[", "#", "]"}]}], "]"}], "/", 
              "maxstepsize"}], "]"}]}], "]"}], "&"}], "/@", "tintervals"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"tinterps", "=", 
        RowBox[{"MapThread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{
             RowBox[{"Min", "[", "#1", "]"}], ",", 
             RowBox[{"Max", "[", "#1", "]"}], ",", 
             RowBox[{
              RowBox[{"Abs", "[", 
               RowBox[{
                RowBox[{"First", "[", "#1", "]"}], "-", 
                RowBox[{"Last", "[", "#1", "]"}]}], "]"}], "/", "#2"}]}], 
            "]"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"tintervals", ",", "ninterps"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"combtfuncs", "=", "\[IndentingNewLine]", 
        RowBox[{"MapThread", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Interpolation", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"{", 
               RowBox[{"#2", ",", 
                RowBox[{"Map", "[", 
                 RowBox[{"#1", ",", "#2"}], "]"}]}], "}"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Sequence", "@@", 
              RowBox[{"Join", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"CurrentOptionsToPassDown", "[", 
                 RowBox[{"Trajectory", ",", "Interpolation"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"CurrentOptionsToPassDown", "[", 
                 RowBox[{"NPropagate", ",", "Interpolation"}], "]"}]}], 
               "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}],
            "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"pwtfunc", ",", "tinterps"}], "}"}]}], 
         "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"TrajectoryFunction", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"tfin", ",", "tini"}], "}"}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Function", "[", 
          RowBox[{"t", ",", "\[IndentingNewLine]", 
           RowBox[{"Evaluate", "@", 
            RowBox[{"Piecewise", "[", 
             RowBox[{"Transpose", "[", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Through", "[", 
                 RowBox[{"combtfuncs", "[", "t", "]"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Join", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"First", "[", "#", "]"}], "\[LessEqual]", "t", 
                    "<", 
                    RowBox[{"Last", "[", "#", "]"}]}], ")"}], "&"}], "/@", 
                   RowBox[{"Most", "[", "tintervals", "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"First", "[", "#", "]"}], "\[LessEqual]", "t", 
                    "\[LessEqual]", 
                    RowBox[{"Last", "[", "#", "]"}]}], ")"}], "&"}], "/@", 
                   RowBox[{"{", 
                    RowBox[{"Last", "[", "tintervals", "]"}], "}"}]}]}], 
                 "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "}"}],
               "\[IndentingNewLine]", "]"}], "]"}]}]}], "\[IndentingNewLine]",
           "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.562224886909651*^9, 3.5622254728161592`*^9}, 
   3.562225702743791*^9, {3.562225794060033*^9, 3.562225892107211*^9}, {
   3.562227364869685*^9, 3.5622273696773663`*^9}, {3.562227419288724*^9, 
   3.562227460230513*^9}, 3.5622280366792583`*^9, 3.562228079757347*^9, 
   3.593341806976056*^9, 3.623341513569565*^9, {3.639586274010272*^9, 
   3.639586287142221*^9}, {3.7028158409536448`*^9, 3.7028158442503915`*^9}, {
   3.7028159426093473`*^9, 3.702815958192691*^9}},
 CellLabel->
  "In[1833]:=",ExpressionUUID->"7fb3d5f9-5e59-4ed4-9819-63ea907d1fb4"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.456510357569454*^9, 
   3.456510365295979*^9}, 3.502510430181912*^9, {3.511180745810684*^9, 
   3.511180747088955*^9}},ExpressionUUID->"3139e8ef-c308-485a-9e9d-\
b50678a59e02"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Trajectory", "::", "badensvar"}], "=", 
   "\"\<The variable used in the EnsembleAverage may not have an assigned \
value.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.507554648001753*^9, 3.507554665657736*^9}, 
   3.507571938437752*^9, 3.511180767957324*^9},
 CellLabel->
  "In[1834]:=",ExpressionUUID->"25142868-06df-4c35-9eb1-cf56ea4e6919"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Trajectory", "::", "incompattraj"}], "=", 
   "\"\<The domains of the trajectory functions do not match.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.511165982678907*^9, 3.511166007125594*^9}, {
   3.511187315857345*^9, 3.511187331286338*^9}, 3.511189248488757*^9, {
   3.542730094335019*^9, 3.542730095493778*^9}},
 CellLabel->
  "In[1835]:=",ExpressionUUID->"7217c9ef-b7a0-4c1e-802e-6df637a88172"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Trajectory", "::", "cantinterpret"}], "=", 
   "\"\<A problem has been encountered in interpreting the Trajectory \
function.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5801221134033737`*^9, 3.58012213294736*^9}},
 CellLabel->
  "In[1836]:=",ExpressionUUID->"ca024741-50cb-4a9b-856d-7f933c10ce67"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Trajectory", "::", "failed"}], "=", 
   "\"\<Trajectory has encountered a $Failed condition.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.621079269839004*^9, 3.621079285599312*^9}},
 CellLabel->
  "In[1837]:=",ExpressionUUID->"d1b23e08-e0a3-4337-ad68-8061fe76f1c8"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["TransformationAmplitude", "Chapter",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.45268559236838*^9, 3.452685596612178*^9}, 
   3.452685977341175*^9, {3.456221032206551*^9, 3.456221041675785*^9}, 
   3.456387573527132*^9, {3.456508634043894*^9, 3.456508635514103*^9}, {
   3.497529605471568*^9, 3.4975296086541243`*^9}, {3.505019908545583*^9, 
   3.505019916694314*^9}, 3.505019947230769*^9, {3.505022202959749*^9, 
   3.5050222067433023`*^9}, 3.506691865831951*^9, 3.72242389191741*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"aa7199cf-eb49-41eb-824f-f4af87623ab3"],

Cell[CellGroupData[{

Cell["options & attributes", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957871043387*^9, {3.722053600474162*^9, 3.722053604311769*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"c569203d-30c4-4e2b-a4ab-8c3db0215628"],

Cell[CellGroupData[{

Cell["options", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469894351830557*^9, 3.469894355180109*^9}, 
   3.470141048075708*^9, {3.721861723063643*^9, 3.721861730059412*^9}, 
   3.7218872429930058`*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"29f70a24-3d17-44ac-9860-32f8704366fb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "TransformationAmplitude", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OperatorBasis", "\[RuleDelayed]", 
      RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Basis", "\[RuleDelayed]", 
      RowBox[{"ZeemanBasis", "[", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"NormalizationFactor", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"UseMatrixExpWhenPossible", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"UseHilbertSpaceWhenPossible", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"InitialTimePoint", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"BackgroundGenerator", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"EnsembleAverage", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Chronology", "\[RuleDelayed]", "$Chronology"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Parallel", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"MaxBatchSize", "\[Rule]", "128"}], ",", "\[IndentingNewLine]", 
     RowBox[{"MinimumRecommendedUserLevel", "\[Rule]", "1"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.46279631759762*^9, 3.462796327632659*^9}, {
   3.462796499979474*^9, 3.462796500513019*^9}, {3.4639405693833437`*^9, 
   3.463940573195265*^9}, 3.4648620535854683`*^9, {3.465814564759466*^9, 
   3.465814565148946*^9}, {3.465814951086645*^9, 3.465814954331346*^9}, {
   3.486719403502572*^9, 3.486719404123908*^9}, {3.4973642921097937`*^9, 
   3.497364297163127*^9}, {3.497371897761854*^9, 3.497371906743175*^9}, {
   3.49737232158766*^9, 3.4973723346500463`*^9}, 3.497529619779294*^9, 
   3.497572546269267*^9, {3.506694571364847*^9, 3.506694574619191*^9}, {
   3.50676066374996*^9, 3.506760689656033*^9}, {3.5067668601939793`*^9, 
   3.506766861670865*^9}, 3.506767076536017*^9, {3.5067753444118958`*^9, 
   3.506775349337023*^9}, {3.506794750324267*^9, 3.50679476197094*^9}, 
   3.5068552391541147`*^9, 3.50685540941826*^9, {3.50712640599798*^9, 
   3.507126420035283*^9}, {3.5071285226083727`*^9, 3.507128534709289*^9}, {
   3.5072759370082808`*^9, 3.5072759384319563`*^9}, {3.507571622270445*^9, 
   3.5075716295419292`*^9}, {3.508583070814494*^9, 3.508583079551385*^9}, 
   3.5085831257459*^9, {3.508584092301716*^9, 3.508584116149168*^9}, {
   3.508584165855364*^9, 3.508584166935214*^9}, 3.508609688184823*^9, {
   3.508673942173622*^9, 3.508673942722736*^9}, {3.508681447965564*^9, 
   3.508681455651271*^9}, {3.508681808863309*^9, 3.508681809524273*^9}, {
   3.509187475972389*^9, 3.5091874863682537`*^9}, 3.509187572766778*^9, {
   3.509202710447878*^9, 3.509202713244726*^9}, 3.50920275639815*^9, 
   3.509456901722925*^9, {3.509458294721397*^9, 3.509458300182678*^9}, {
   3.5104897434595137`*^9, 3.5104897556279583`*^9}, {3.5148764613531857`*^9, 
   3.5148764622118397`*^9}, 3.515004308085532*^9, 3.515004360424423*^9, 
   3.515078115971826*^9, {3.533177158503834*^9, 3.533177162699546*^9}, {
   3.534399058676367*^9, 3.5343990645072727`*^9}, {3.539112680722073*^9, 
   3.539112681512909*^9}, 3.543413759248107*^9, 3.5434989374615183`*^9, 
   3.545050561058374*^9, {3.572539894675764*^9, 3.5725398982129307`*^9}, {
   3.6260277162778673`*^9, 3.626027716941956*^9}, {3.657712903551982*^9, 
   3.6577129097977*^9}, {3.702816071150379*^9, 3.702816072340538*^9}, {
   3.703082532778181*^9, 3.7030825455365334`*^9}, {3.709375525012845*^9, 
   3.7093755256093388`*^9}, {3.709387217297209*^9, 3.709387218485963*^9}, {
   3.721764466735124*^9, 3.721764515985629*^9}, {3.721764987162115*^9, 
   3.7217649886473846`*^9}, {3.721778102712504*^9, 3.721778104958108*^9}, {
   3.7218617045697727`*^9, 3.721861705770383*^9}, 3.721887083176839*^9, {
   3.7218871198157377`*^9, 3.7218871207421503`*^9}, {3.72188717773267*^9, 
   3.7218872198338137`*^9}, {3.7224209620794086`*^9, 3.7224209673057737`*^9}, 
   3.723293025208782*^9, {3.745507584306425*^9, 
   3.745507586552944*^9}},ExpressionUUID->"66dc5bec-78b3-49fc-8e48-\
dd1493da3364"]
}, Closed]],

Cell[CellGroupData[{

Cell["attributes", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469894351830557*^9, 3.469894355180109*^9}, 
   3.470141044562385*^9},ExpressionUUID->"6f751c2e-8708-4f8d-80aa-\
8d44a04c6016"],

Cell["\<\
HoldAll is needed to allow implementation of EnsembleAverage, the iterators, \
and checking of the polarization operators\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.469896600541757*^9, 3.4698966136273127`*^9}, {
   3.502883935209774*^9, 3.5028839362384663`*^9}, 3.5316513563546267`*^9, {
   3.683219583707953*^9, 3.683219586501233*^9}, {3.709387235018564*^9, 
   3.709387252116486*^9}, 
   3.721754734641655*^9},ExpressionUUID->"3411b3ad-e6ab-4527-a992-\
42b42889608f"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"TransformationAmplitude", ",", "HoldAll"}], "]"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4698943573427773`*^9, 3.469894367696088*^9}, 
   3.506692150083893*^9, 3.506760713626753*^9, {3.509284598709249*^9, 
   3.509284599881653*^9}, 3.509456888329686*^9, 3.531651357297093*^9, 
   3.709387231697034*^9, {3.721775598710197*^9, 3.721775599299631*^9}, 
   3.721856805081901*^9, 3.722420978682555*^9},
 CellLabel->
  "In[1839]:=",ExpressionUUID->"e0a41ad3-d61c-4d3f-8b3c-7e4cd03c37cd"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["prelude", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699967260343471*^9, {3.722053214664496*^9, 3.7220532200010366`*^9}, 
   3.722053471964946*^9, {3.722053502408568*^9, 3.72205350480744*^9}, {
   3.722053548226399*^9, 
   3.72205354882628*^9}},ExpressionUUID->"af59bf71-4ca4-4a1a-87b2-\
8f3abe6119d7"],

Cell[CellGroupData[{

Cell["traps", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.6999576793161383`*^9, 3.699957682623167*^9}, {
   3.69995837404912*^9, 3.699958377592299*^9}, {3.699967314659217*^9, 
   3.69996732698726*^9}, {3.721755437564663*^9, 3.7217554392598343`*^9}, {
   3.721755487379294*^9, 3.721755489697517*^9}, {3.722053233901409*^9, 
   3.722053235049282*^9}},ExpressionUUID->"ddd6a019-cb91-424d-abd0-\
60467a58abce"],

Cell[CellGroupData[{

Cell["$Failed trap", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683958534614377*^9, 3.683958551028832*^9}, {
   3.68395858577393*^9, 3.6839585874144278`*^9}, 3.683959406338385*^9, {
   3.683963242982894*^9, 3.6839632443419228`*^9}, {3.683964445776389*^9, 
   3.683964455294318*^9}, {3.683983901941537*^9, 3.6839839032008667`*^9}, {
   3.700566501467436*^9, 
   3.7005665022666397`*^9}},ExpressionUUID->"a0a63208-6ee7-47b9-93bc-\
d1c40f6eef5e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TransformationAmplitude", "[", 
     RowBox[{
      RowBox[{"Evaluate", "@", "GeneralStatusListPattern"}], ",", "args___"}],
      "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"Hold", "@", 
        RowBox[{"{", "args", "}"}]}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683983914149064*^9, 3.6839839305516777`*^9}, 
   3.6850335693888206`*^9, 3.699957835020547*^9, {3.7004890118870163`*^9, 
   3.70048902834022*^9}, {3.700489149274678*^9, 3.7004891505765*^9}, {
   3.700565404281258*^9, 3.700565407769747*^9}, {3.700566488876607*^9, 
   3.700566491048864*^9}, 3.700572254982481*^9, 3.700573232051622*^9, 
   3.721755166189555*^9, {3.721857228215165*^9, 3.7218572318601723`*^9}, 
   3.722420992242989*^9},
 CellLabel->
  "In[1840]:=",ExpressionUUID->"76b77afc-1f41-4974-a1f5-4766c17eb426"]
}, Closed]],

Cell[CellGroupData[{

Cell["general syntax checking", "Subsubsection",
 CellChangeTimes->{{3.721755257829026*^9, 3.721755269084174*^9}, {
  3.72175545354712*^9, 3.721755467634141*^9}, {3.7220523608727627`*^9, 
  3.7220523700185738`*^9}},ExpressionUUID->"04c5e39c-41a0-49ab-a83d-\
b87271b2d530"],

Cell["trap an incorrect placing of Rule", "Text",
 CellChangeTimes->{{3.722052453368568*^9, 
  3.722052465315625*^9}},ExpressionUUID->"aaec75c3-0646-4af0-ae4a-\
6990763bd78f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{"Except", "[", "GeneralStatusListPattern", "]"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Except", "[", "_Rule", "]"}], ".."}], ",", "_Rule", ",", "___",
      ",", 
     RowBox[{"Except", "[", "_Rule", "]"}], ",", "___"}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"TransformationAmplitude", "::", "badsyntax"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.722052376439558*^9, 3.7220524908650227`*^9}, {
  3.722053797985751*^9, 3.7220538542992277`*^9}, {3.722421001042227*^9, 
  3.72242100623458*^9}},
 CellLabel->
  "In[1841]:=",ExpressionUUID->"3f9b94dd-9345-4291-9fdf-0b179b488128"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["wrap symbols in Hold", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.6999576793161383`*^9, 3.699957682623167*^9}, {
   3.69995837404912*^9, 3.699958377592299*^9}, {3.699967314659217*^9, 
   3.69996732698726*^9}, {3.721755437564663*^9, 3.7217554392598343`*^9}, {
   3.721755487379294*^9, 3.721755489697517*^9}, {3.722053233901409*^9, 
   3.7220532967837133`*^9}},ExpressionUUID->"0d866ba3-a315-482e-b1d5-\
5a1a447d4171"],

Cell["\<\
needed to allow symbol substitution and handling of multidimensional \
variables in EnsembleAverage\
\>", "Text",
 CellChangeTimes->{{3.722053305582299*^9, 3.7220533155303793`*^9}, {
  3.722053418219347*^9, 
  3.722053432883181*^9}},ExpressionUUID->"08fc9845-9c38-44c7-a1b4-\
b5154ad40812"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{"arg", ":", 
       RowBox[{"Except", "[", "GeneralStatusListPattern", "]"}]}], "]"}], ",",
      "moreA___", ",", 
     RowBox[{"BackgroundGenerator", "\[Rule]", " ", "backg_"}], ",", 
     "moreB___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{"False", ",", "arg", ",", "moreA", ",", 
     RowBox[{"BackgroundGenerator", "\[Rule]", " ", 
      RowBox[{"Hold", "[", "backg", "]"}]}], ",", "moreB"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958380154027*^9, 3.6999584815554132`*^9}, {
   3.699959772469471*^9, 3.699959793223897*^9}, 3.69995998791234*^9, {
   3.699962032492901*^9, 3.699962033672257*^9}, {3.700489087209752*^9, 
   3.70048913507517*^9}, {3.700565459147201*^9, 3.700565461704858*^9}, {
   3.7005664849261103`*^9, 3.7005664870277843`*^9}, 3.700572249823097*^9, 
   3.700573227435656*^9, {3.7027974893302355`*^9, 3.7027975561033072`*^9}, {
   3.702797620390955*^9, 3.7027976388289504`*^9}, {3.702798354048998*^9, 
   3.7027984113896713`*^9}, {3.7093755333830423`*^9, 3.709375534182023*^9}, {
   3.721755117001544*^9, 3.7217551465889883`*^9}, 3.721755219451017*^9, {
   3.7217745489981127`*^9, 3.721774552851432*^9}, {3.7217746087314568`*^9, 
   3.721774610491249*^9}, {3.721774667183178*^9, 3.721774669253531*^9}, 
   3.721774990142713*^9, {3.722421148221162*^9, 3.722421153436884*^9}, {
   3.7260046666100426`*^9, 3.7260046679860287`*^9}, {3.726004714747449*^9, 
   3.7260047175920577`*^9}},
 CellLabel->
  "In[1842]:=",ExpressionUUID->"d31f9819-71ca-4235-b263-238c5dfdf27d"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["status flags", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699967260343471*^9, {3.722053214664496*^9, 3.7220532200010366`*^9}, {
   3.722053280508946*^9, 3.722053281354823*^9}, {3.722053562258954*^9, 
   3.722053563252039*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"d5d7bf4e-912f-4e86-9321-1c870aa80e35"],

Cell[CellGroupData[{

Cell["syntax", "Section",
 CellChangeTimes->{{3.700297621581056*^9, 3.7002976227883387`*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"b36e66ce-5ce9-49d6-b196-4175fe8ada95"],

Cell["\<\
status:{
1. <Chronology>
2. <InputRule>
3.<EnsembleAverage>,\[LineSeparator]4.<NormalizationFactor>,\[LineSeparator]5.\
 <BackgroundGenerator>,\[LineSeparator]6. <InitialDensityOperator>,\
\[LineSeparator]7. <Observables>
8.<Events>
9. <Precalculation>
10. <userlevel>
11.<Ready>
}\
\>", "Text",
 CellChangeTimes->{{3.689409839714465*^9, 3.689409859202746*^9}, {
   3.6999581143942537`*^9, 3.699958263807562*^9}, {3.699962603269265*^9, 
   3.699962621819932*^9}, 3.699963887599286*^9, {3.699964901802113*^9, 
   3.699964932726914*^9}, {3.699964975344315*^9, 3.699964975983858*^9}, {
   3.6999665398265333`*^9, 3.699966540522017*^9}, {3.70029757547184*^9, 
   3.700297616436632*^9}, {3.700297696082258*^9, 3.700297696600065*^9}, {
   3.700323347837442*^9, 3.700323358616118*^9}, {3.700571398427099*^9, 
   3.7005714040563297`*^9}, {3.701092857308374*^9, 3.701092879229843*^9}, {
   3.7217547857425537`*^9, 3.7217547866139517`*^9}, {3.721754831635726*^9, 
   3.721754915503562*^9}, 3.72175494616641*^9, {3.72175564929993*^9, 
   3.7217556826868467`*^9}, {3.721755835959484*^9, 3.721755839852759*^9}, 
   3.721755874886621*^9, 3.7217561327432404`*^9, {3.7217563246864643`*^9, 
   3.721756329191581*^9}, 3.721756395877213*^9, 3.72175646711969*^9, 
   3.7217565528359547`*^9, 3.721757183888377*^9, {3.721757246970799*^9, 
   3.721757270136608*^9}, {3.721757418716744*^9, 3.72175742054029*^9}, {
   3.7217578259446907`*^9, 3.721757835863649*^9}, {3.7218005968803787`*^9, 
   3.721800616860139*^9}, {3.721861602209313*^9, 3.721861613668989*^9}, 
   3.721864679498011*^9, {3.7224211724851217`*^9, 3.722421196775077*^9}, {
   3.745507624529334*^9, 
   3.74550763024043*^9}},ExpressionUUID->"dcc463ae-6ecc-4ae7-a434-\
6aa0c4eb6307"],

Cell["when all flags are True, the overall status is set to True. ", "Text",
 CellChangeTimes->{{3.689409869650942*^9, 3.6894098789918537`*^9}, {
  3.699958073882622*^9, 3.699958084660014*^9}, {3.699958278423551*^9, 
  3.699958326909779*^9}},ExpressionUUID->"4aab0f8c-fa55-4666-922d-\
49380ed5ea69"]
}, Closed]],

Cell[CellGroupData[{

Cell["initialization", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.6999576793161383`*^9, 3.699957682623167*^9}, {
   3.69995837404912*^9, 3.699958377592299*^9}, {3.699967314659217*^9, 
   3.69996732698726*^9}, {3.721755437564663*^9, 3.7217554392598343`*^9}, {
   3.721755487379294*^9, 3.721755489697517*^9}, {3.722052958933054*^9, 
   3.722052963743114*^9}, 3.7220533419830437`*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"16f52e92-882f-4750-8982-9216ed5bc97d"],

Cell[CellGroupData[{

Cell["initialize global status", "Subsection",
 CellChangeTimes->{{3.721755257829026*^9, 3.72175528429959*^9}, {
  3.722053061369829*^9, 3.7220530701666317`*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"1c29be00-aa29-4d06-86c1-6774d39fbf7b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusDimension", "[", "TransformationAmplitude", "]"}], "=", 
   "11"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999583403975887`*^9, 3.699958356036769*^9}, {
   3.701092633684363*^9, 3.70109263380866*^9}, 3.701092903635845*^9, {
   3.72175531673285*^9, 3.721755321475318*^9}, {3.721755707999535*^9, 
   3.721755708125235*^9}, 3.721757858638781*^9, 3.721861689826372*^9, 
   3.7218647142650137`*^9, {3.722421214927999*^9, 3.7224212253848677`*^9}, {
   3.745507687185013*^9, 
   3.7455076873995657`*^9}},ExpressionUUID->"ef2bd440-824c-477f-bce7-\
7e0197dd16da"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{"arg", ":", 
       RowBox[{"Except", "[", "GeneralStatusListPattern", "]"}]}], "]"}], ",",
      "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{"False", ",", "arg", ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958380154027*^9, 3.6999584815554132`*^9}, {
   3.699959772469471*^9, 3.699959793223897*^9}, 3.69995998791234*^9, {
   3.699962032492901*^9, 3.699962033672257*^9}, {3.700489087209752*^9, 
   3.70048913507517*^9}, {3.700565459147201*^9, 3.700565461704858*^9}, {
   3.7005664849261103`*^9, 3.7005664870277843`*^9}, 3.700572249823097*^9, 
   3.700573227435656*^9, {3.7027974893302355`*^9, 3.7027975561033072`*^9}, {
   3.702797620390955*^9, 3.7027976388289504`*^9}, {3.702798354048998*^9, 
   3.7027984113896713`*^9}, {3.7093755333830423`*^9, 3.709375534182023*^9}, {
   3.721755117001544*^9, 3.7217551465889883`*^9}, 3.721755219451017*^9, {
   3.721774529671377*^9, 3.721774532571965*^9}, {3.7217748781650143`*^9, 
   3.721774880938284*^9}, {3.721774942967628*^9, 3.72177494915154*^9}, {
   3.7224212155859632`*^9, 3.7224212161430063`*^9}},
 CellLabel->
  "In[1844]:=",ExpressionUUID->"e49cb92e-8c19-418a-8e50-38adcf52dd66"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{"False", ",", "items___", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"Table", "[", 
       RowBox[{"False", ",", 
        RowBox[{"{", 
         RowBox[{"StatusDimension", "[", "TransformationAmplitude", "]"}], 
         "}"}]}], "]"}]}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700566324922236*^9, 3.700566329608988*^9}, {
   3.700566384439968*^9, 3.700566384781948*^9}, {3.70109538631076*^9, 
   3.701095451635306*^9}, {3.701095624695593*^9, 3.701095624965757*^9}, {
   3.701095712124366*^9, 3.701095712359507*^9}, 3.721755412408339*^9, 
   3.7217555415616693`*^9, {3.721775221362338*^9, 3.721775227583768*^9}, 
   3.721775812187272*^9, {3.7218575802211447`*^9, 3.721857581867342*^9}, {
   3.722421216846705*^9, 3.722421219917362*^9}},
 CellLabel->
  "In[1845]:=",ExpressionUUID->"85ac0c4a-5007-49b2-8bd2-0a6dd1c2fd5d"]
}, Closed]],

Cell[CellGroupData[{

Cell["initialize individual categories", "Subsection",
 CellChangeTimes->{{3.699960043090076*^9, 3.699960055700795*^9}, {
  3.701095115014482*^9, 3.701095116885454*^9}, {3.722053025374083*^9, 
  3.722053031569543*^9}, {3.7220530811653013`*^9, 3.722053083064291*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"ea17cff1-a7c3-406c-b5ad-ae14ac958940"],

Cell[CellGroupData[{

Cell["1. Chronology", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.699965078900024*^9, 
   3.699965079215186*^9}, 3.6999673551934147`*^9, 
   3.721757169016224*^9},ExpressionUUID->"bd0287b9-4f9e-4269-a0ff-\
3fc6b54d69b1"],

Cell["<Chronology>={< request >, <valid>, <standardized>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.700312985944944*^9, 
   3.700312998460401*^9}, 
   3.7217571737693*^9},ExpressionUUID->"c613c57d-32ba-46c4-9624-f335b9dbe503"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Chronology\>\""}], "]"}], 
   "=", "1"}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Chronology\>\""}], "]"}], 
   "=", "3"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, 3.699961074484026*^9, 
   3.700313001577042*^9, {3.721755724047927*^9, 3.721755725638839*^9}, {
   3.72242124345718*^9, 3.722421243973831*^9}},
 CellLabel->
  "In[1846]:=",ExpressionUUID->"fb437609-38a8-426f-ae41-7116352b65fd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", "False"}], ",", "morest___"}], "}"}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"TransformationAmplitude", ",", "\"\<Chronology\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.6999610036889277`*^9, 3.699961014575673*^9}, {3.6999610780148363`*^9, 
   3.699961104711626*^9}, {3.7217557388445168`*^9, 3.7217557441257963`*^9}, {
   3.722421244675149*^9, 3.722421246194942*^9}},
 CellLabel->
  "In[1847]:=",ExpressionUUID->"b4ef34cb-cad2-45dc-889b-3a7ac1196da0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}]}], ",", "morest___"}], "}"}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ",", "morest"}], "}"}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
  3.6999608074403543`*^9, 3.699960815796681*^9}, {3.6999610219694366`*^9, 
  3.699961036648464*^9}, {3.69996108777975*^9, 3.699961119876425*^9}, {
  3.7217557508373833`*^9, 3.72175575362092*^9}, {3.722421247424686*^9, 
  3.72242124875977*^9}},
 CellLabel->
  "In[1848]:=",ExpressionUUID->"5ab6d05a-98b0-491f-b0ef-8b8fbaccb1c8"]
}, Closed]],

Cell[CellGroupData[{

Cell["2. InputRule", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699965076323723*^9, 3.699965076616291*^9}, 
   3.699967358600157*^9, {3.7010871278610983`*^9, 3.701087133313622*^9}, {
   3.7217558425899963`*^9, 3.7217558477177*^9}, 
   3.721755982164069*^9},ExpressionUUID->"053532e7-1a33-4a8a-a1ee-\
b714ebe85157"],

Cell["<InputRule>={<request>, <implement>,<check>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
  3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
  3.6999607626383677`*^9}, {3.700482091706748*^9, 3.700482094792623*^9}, {
  3.701087144827612*^9, 3.701087174743593*^9}, {3.701087635307239*^9, 
  3.7010876670777807`*^9}, {3.721755773212618*^9, 3.721755804928439*^9}, {
  3.721755850173799*^9, 3.721755871560854*^9}, {3.721763072800804*^9, 
  3.721763077118885*^9}, {3.7217636927760067`*^9, 
  3.721763699693534*^9}},ExpressionUUID->"a6a0b35d-14aa-4698-9ee0-\
bf50e04b215e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], "]"}], "=",
    "2"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], "]"}], 
       "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], "]"}], "=",
    "3"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.700303595564148*^9, 3.7003035998204327`*^9}, 3.700482089116626*^9, 
   3.700482467483755*^9, 3.7010871991145077`*^9, {3.7010918955891333`*^9, 
   3.701091895923306*^9}, 3.7217558210667477`*^9, {3.721755855166141*^9, 
   3.7217559125588903`*^9}, 3.7217633440806227`*^9, {3.7224212623778*^9, 
   3.722421263958448*^9}},
 CellLabel->
  "In[1849]:=",ExpressionUUID->"9677dfb4-aa76-4ca4-8ed9-1f412c892657"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.721755925141917*^9, 3.721755946707847*^9}, 3.721775824730948*^9, {
   3.722421264650556*^9, 3.722421267008284*^9}},
 CellLabel->
  "In[1850]:=",ExpressionUUID->"52d9abf5-0127-4a25-a607-0c292f16b1c6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
  3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
  3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, {
  3.7217559552436457`*^9, 3.7217559690174837`*^9}, {3.7224212678712263`*^9, 
  3.722421272240086*^9}},
 CellLabel->
  "In[1851]:=",ExpressionUUID->"ee211a11-7fdd-4533-9f70-fedc87cea32d"]
}, Closed]],

Cell[CellGroupData[{

Cell["3. EnsembleAverage", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, 
   3.722421286296929*^9},ExpressionUUID->"3971af6f-405f-4c3a-bf8e-\
223cae7e150c"],

Cell["\<\
<EnsembleAverage>={< request set up >, <standardized>, <multiDvars expanded>}\
\
\>", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, 3.7217845912657022`*^9, 
   3.7217846310243273`*^9},ExpressionUUID->"923eb4f7-99f9-429c-bb3c-\
d58701afbe71"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}], 
    "]"}], "=", "3"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}], 
    "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}], 
    "]"}], "=", "3"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, 
   3.721784604664185*^9, {3.7224213110918417`*^9, 3.7224213281909246`*^9}},
 CellLabel->
  "In[1852]:=",ExpressionUUID->"4b6ef65d-21e6-4d78-aaa4-010615f6e0c6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}],
           "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.722421315177926*^9, 
   3.722421318041603*^9}},
 CellLabel->
  "In[1853]:=",ExpressionUUID->"bcd44ba5-ba13-47fa-a423-1eb50cca07b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}],
           "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, {3.7224213197216167`*^9, 
   3.722421322731812*^9}},
 CellLabel->
  "In[1854]:=",ExpressionUUID->"130b5ccc-3931-4e8a-9131-82de9028735d"]
}, Closed]],

Cell[CellGroupData[{

Cell["4. NormalizationFactor", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, 
   3.722421288030552*^9},ExpressionUUID->"c49f952c-bd32-4434-b24e-\
107c12506a3b"],

Cell["<normfac>={< request set up >, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.7217975898495502`*^9, 
   3.721797591007513*^9}},ExpressionUUID->"27fb84ce-709d-4fee-b875-\
fbd2df764dc8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<NormalizationFactor\>\""}], 
    "]"}], "=", "4"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<NormalizationFactor\>\""}], 
    "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{
        "TransformationAmplitude", ",", "\"\<NormalizationFactor\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<NormalizationFactor\>\""}], 
    "]"}], "=", "2"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7224213376481323`*^9, 
   3.7224213510462513`*^9}},
 CellLabel->
  "In[1855]:=",ExpressionUUID->"fc0bd939-241f-44d3-bcf2-68ebc41d00ee"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitude", ",", "\"\<NormalizationFactor\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitude", ",", "\"\<NormalizationFactor\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.72242134092905*^9, 3.722421344019142*^9}},
 CellLabel->
  "In[1856]:=",ExpressionUUID->"601fc651-cfd1-4a59-9c4f-bc6cb21a6d83"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitude", ",", "\"\<NormalizationFactor\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, {
   3.72242134501364*^9, 3.722421347330523*^9}},
 CellLabel->
  "In[1857]:=",ExpressionUUID->"5e519a54-236f-46e2-9f58-1ec18018b492"]
}, Closed]],

Cell[CellGroupData[{

Cell["5. BackgroundGenerator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, 
   3.722421289903771*^9},ExpressionUUID->"5caf1cd9-096f-4965-afcf-\
9dcf25e53825"],

Cell["\<\
<backg>={<request set up>,<standardization>,<diagonalization>}\
\>", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.7217975848005323`*^9, 3.721797625621028*^9}, 
   3.721799531633738*^9, {3.7232727556775103`*^9, 
   3.723272765835154*^9}},ExpressionUUID->"bdb2169d-baa0-42f1-908c-\
b8f5ee698f36"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<BackgroundGenerator\>\""}], 
    "]"}], "=", "5"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<BackgroundGenerator\>\""}], 
    "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{
        "TransformationAmplitude", ",", "\"\<BackgroundGenerator\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<BackgroundGenerator\>\""}], 
    "]"}], "=", "3"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, 3.7217976306720133`*^9, 3.7217995346073933`*^9, {
   3.7224213621245832`*^9, 3.722421374589579*^9}},
 CellLabel->
  "In[1858]:=",ExpressionUUID->"55030dc8-748b-494b-b7a3-90edf438ee47"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitude", ",", "\"\<BackgroundGenerator\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitude", ",", "\"\<BackgroundGenerator\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.722421364671933*^9, 3.7224213671250353`*^9}},
 CellLabel->
  "In[1859]:=",ExpressionUUID->"0d550c8b-f3fe-468e-9f8e-a84dfa688e72"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitude", ",", "\"\<BackgroundGenerator\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, {3.722421368016879*^9, 3.722421370604847*^9}},
 CellLabel->
  "In[1860]:=",ExpressionUUID->"44b0fffd-8489-40ad-b567-f78d4be6f430"]
}, Closed]],

Cell[CellGroupData[{

Cell["6. InitialDensityOperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, {3.7217564508871813`*^9, 3.7217564568857813`*^9}, 
   3.7224212918231897`*^9},ExpressionUUID->"ec597d98-674c-4e48-a200-\
b594a7bc5803"],

Cell["<prep>={<request set up>, <check>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.721799667957322*^9, 
   3.721799680810709*^9}},ExpressionUUID->"1706437b-8695-4d6d-bc47-\
75e8012cfbec"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{
    "TransformationAmplitude", ",", "\"\<InitialDensityOperator\>\""}], "]"}],
    "=", "6"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{
    "TransformationAmplitude", ",", "\"\<InitialDensityOperator\>\""}], "]"}],
    "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{
        "TransformationAmplitude", ",", "\"\<InitialDensityOperator\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{
    "TransformationAmplitude", ",", "\"\<InitialDensityOperator\>\""}], "]"}],
    "=", "2"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, {3.7217564769697237`*^9, 
   3.7217564899578247`*^9}, {3.72242138465436*^9, 3.722421395148682*^9}},
 CellLabel->
  "In[1861]:=",ExpressionUUID->"1ea53dc5-9714-4aae-98e9-50d362e6e05f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitude", ",", "\"\<InitialDensityOperator\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitude", ",", 
             "\"\<InitialDensityOperator\>\""}], "]"}], "}"}]}], "]"}], ",", 
        "morest"}], "}"}]}], ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.721756497150454*^9, 3.721756500397401*^9}, {3.72242138689816*^9, 
   3.722421388865672*^9}},
 CellLabel->
  "In[1862]:=",ExpressionUUID->"bffc305f-aeb0-41a3-8520-b9f8be7d103a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitude", ",", "\"\<InitialDensityOperator\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, 3.7217565039662046`*^9, {3.7224213899792833`*^9, 
   3.722421391963077*^9}},
 CellLabel->
  "In[1863]:=",ExpressionUUID->"5bf42c3d-731e-4058-babb-6696df2ea851"]
}, Closed]],

Cell[CellGroupData[{

Cell["7. Observables", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, {3.7217564508871813`*^9, 3.7217564568857813`*^9}, {
   3.721756520611273*^9, 3.721756540319769*^9}, {3.721757376492264*^9, 
   3.721757395181261*^9}, 3.72175742722253*^9, {3.7218005835424547`*^9, 
   3.721800583989327*^9}, 
   3.722421293550584*^9},ExpressionUUID->"1c3a6595-8edc-49e3-96ba-\
ad06e2e30fc9"],

Cell["\<\
<Observables>={<request>,<standardize>,<check for nonrig\[Rho]>,<operator \
form>}\
\>", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.7217574010409193`*^9, 3.721757403225362*^9}, {
   3.721800489962534*^9, 3.721800503020648*^9}, {3.721800777560731*^9, 
   3.721800785174819*^9}, {3.721801594231718*^9, 3.721801599700938*^9}, {
   3.721801980939446*^9, 
   3.7218019921883163`*^9}},ExpressionUUID->"da30d7d7-5ff6-4e2b-aac3-\
c06cac2fa265"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Observables\>\""}], "]"}], 
   "=", "7"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Observables\>\""}], "]"}], 
   "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitude", ",", "\"\<Observables\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Observables\>\""}], "]"}], 
   "=", "4"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, {3.7217564769697237`*^9, 
   3.7217564899578247`*^9}, {3.721756563781021*^9, 3.72175657523405*^9}, {
   3.721757432356854*^9, 3.721757440518906*^9}, 3.72180063938231*^9, 
   3.72180078871417*^9, 3.721801605262192*^9, {3.722421410644135*^9, 
   3.722421420598068*^9}},
 CellLabel->
  "In[1864]:=",ExpressionUUID->"57895b8a-fccc-4c6b-99f7-2c8e30c4d478"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Observables\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"TransformationAmplitude", ",", "\"\<Observables\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.721756497150454*^9, 3.721756500397401*^9}, {3.721756582107078*^9, 
   3.721756585825021*^9}, {3.721757443199085*^9, 3.721757445870673*^9}, {
   3.72242142152431*^9, 3.7224214234013166`*^9}},
 CellLabel->
  "In[1865]:=",ExpressionUUID->"7ec0bbf4-7190-4324-8172-594a4cef9bbd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Observables\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, 3.7217565039662046`*^9, 3.721756589336817*^9, 
   3.721757449230076*^9, {3.722421424317067*^9, 3.722421426689765*^9}},
 CellLabel->
  "In[1866]:=",ExpressionUUID->"7d8a0b0f-1161-4a7d-b929-ff14f40dac91"]
}, Closed]],

Cell[CellGroupData[{

Cell["8. Events", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, {3.7217564508871813`*^9, 3.7217564568857813`*^9}, {
   3.721756520611273*^9, 3.721756540319769*^9}, {3.721757376492264*^9, 
   3.721757395181261*^9}, 3.72175742722253*^9, {3.7217578042789497`*^9, 
   3.721757820461225*^9}, 3.721800629931551*^9, 
   3.7224212953977222`*^9},ExpressionUUID->"f89d1a29-a59c-4e77-8b60-\
7c7a75aa08b3"],

Cell["<prep>={<request>, <insert null>,<PulseSequence>,<check>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.7217574010409193`*^9, 3.721757403225362*^9}, {
   3.721776980547686*^9, 3.721776990089419*^9}, {3.721777635903672*^9, 
   3.721777642406269*^9}, {3.7255207372608957`*^9, 
   3.725520748941895*^9}},ExpressionUUID->"c535834e-8058-42f0-b9e0-\
8a8122c25f3a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], "]"}], "=", 
   "8"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], "]"}], 
       "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], "]"}], "=", 
   "4"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, {3.7217564769697237`*^9, 
   3.7217564899578247`*^9}, {3.721756563781021*^9, 3.72175657523405*^9}, {
   3.721757432356854*^9, 3.721757440518906*^9}, {3.721757878319634*^9, 
   3.7217578842844067`*^9}, 3.7217769950278473`*^9, {3.721800645102062*^9, 
   3.721800645219689*^9}, {3.7224214398891563`*^9, 3.722421450480866*^9}, 
   3.725520754415503*^9},
 CellLabel->
  "In[1867]:=",ExpressionUUID->"35138b9e-9ce1-44a6-90c0-74181eef62a0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], "]"}]}],
         ",", "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], 
     ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], "]"}],
            "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.721756497150454*^9, 3.721756500397401*^9}, {3.721756582107078*^9, 
   3.721756585825021*^9}, {3.721757443199085*^9, 3.721757445870673*^9}, {
   3.721757890469747*^9, 3.7217578922437963`*^9}, {3.722421443001792*^9, 
   3.722421444968891*^9}},
 CellLabel->
  "In[1868]:=",ExpressionUUID->"0471017a-9ec2-41f9-86be-ed210cbea08f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], "]"}]}],
         ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, 3.7217565039662046`*^9, 3.721756589336817*^9, 
   3.721757449230076*^9, {3.721757895652873*^9, 3.721757898084654*^9}, {
   3.7224214459246607`*^9, 3.722421447906809*^9}},
 CellLabel->
  "In[1869]:=",ExpressionUUID->"71b5f4e1-fcf9-42e2-8d60-f04f5d38b24e"]
}, Closed]],

Cell[CellGroupData[{

Cell["9. Precalculation", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, {3.7217564508871813`*^9, 3.7217564568857813`*^9}, {
   3.721756520611273*^9, 3.721756540319769*^9}, {3.72180058691722*^9, 
   3.721800587053234*^9}, 3.721800628036878*^9, 
   3.7224212973021793`*^9},ExpressionUUID->"56f4c657-8773-45ad-b159-\
200c3cd37897"],

Cell["<prep>={< request set up >, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}},ExpressionUUID->"3ec2ff47-3639-4972-907b-\
671c8447401a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Precalculation\>\""}], "]"}],
    "=", "9"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Precalculation\>\""}], "]"}],
    "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitude", ",", "\"\<Precalculation\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Precalculation\>\""}], "]"}],
    "=", "2"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, {3.7217564769697237`*^9, 
   3.7217564899578247`*^9}, {3.721756563781021*^9, 3.72175657523405*^9}, {
   3.721800650069376*^9, 3.721800650228479*^9}, {3.7224214601760197`*^9, 
   3.722421470937964*^9}},
 CellLabel->
  "In[1870]:=",ExpressionUUID->"601c4cec-da77-45c3-b91e-0eb9d1a0388b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Precalculation\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitude", ",", "\"\<Precalculation\>\""}], "]"}],
            "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.721756497150454*^9, 3.721756500397401*^9}, {3.721756582107078*^9, 
   3.721756585825021*^9}, {3.722421462205776*^9, 3.7224214642051067`*^9}},
 CellLabel->
  "In[1871]:=",ExpressionUUID->"42bba432-e506-404f-a362-5d8a756bc77b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Precalculation\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}]}], ",", 
     "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, 3.7217565039662046`*^9, 3.721756589336817*^9, {
   3.7218581475231237`*^9, 3.721858148017562*^9}, {3.72242146516893*^9, 
   3.722421467932158*^9}},
 CellLabel->
  "In[1872]:=",ExpressionUUID->"e61583f6-5f9b-4e38-8d51-e1aebf9686c5"]
}, Closed]],

Cell[CellGroupData[{

Cell["10. UserLevel", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, {3.7217564508871813`*^9, 3.7217564568857813`*^9}, {
   3.721756520611273*^9, 3.721756540319769*^9}, {3.721756613270803*^9, 
   3.72175661602112*^9}, {3.721757378506689*^9, 3.72175737874658*^9}, 
   3.7217578096632442`*^9, {3.722421299070591*^9, 3.7224212992451153`*^9}, {
   3.745507715598283*^9, 3.7455077366878366`*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"1f43e0d0-2b8b-4a76-b826-d12c19e501fe"],

Cell["<userlevel>={<request>, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.721756623575251*^9, 3.72175662562084*^9}, {
   3.7218616459726677`*^9, 3.7218616467087383`*^9}, 
   3.745507725393688*^9},ExpressionUUID->"b7541ad5-bf85-4c73-a021-\
0e60548bd6ce"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<UserLevel\>\""}], "]"}], "=",
    "10"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<UserLevel\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitude", ",", "\"\<UserLevel\>\""}], "]"}], 
       "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<UserLevel\>\""}], "]"}], "=",
    "2"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, {3.7217564769697237`*^9, 
   3.7217564899578247`*^9}, {3.721756563781021*^9, 3.72175657523405*^9}, {
   3.721756631888152*^9, 3.7217566421344213`*^9}, 3.721757383451694*^9, 
   3.721757906077087*^9, {3.7224214806929007`*^9, 3.7224214915942783`*^9}, {
   3.7455077337949657`*^9, 
   3.74550774926229*^9}},ExpressionUUID->"1d1bc823-1d21-40c8-a957-\
253ab13917cb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<UserLevel\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"TransformationAmplitude", ",", "\"\<UserLevel\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.721756497150454*^9, 3.721756500397401*^9}, {3.721756582107078*^9, 
   3.721756585825021*^9}, {3.721756648119502*^9, 3.721756651916052*^9}, {
   3.722421483177207*^9, 3.7224214853592167`*^9}, {3.745507751136578*^9, 
   3.745507752808257*^9}},ExpressionUUID->"c223093c-1b76-4899-a14e-\
a83e2b897f1b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<UserLevel\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, 3.7217565039662046`*^9, 3.721756589336817*^9, 
   3.7217566550999317`*^9, {3.722421486306301*^9, 3.7224214882651787`*^9}, 
   3.745507755496892*^9},ExpressionUUID->"b854a65f-34d5-4b36-98ea-\
63724ebfd6d8"]
}, Closed]],

Cell[CellGroupData[{

Cell["11. Ready", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, {3.7217564508871813`*^9, 3.7217564568857813`*^9}, {
   3.721756520611273*^9, 3.721756540319769*^9}, {3.721756613270803*^9, 
   3.72175661602112*^9}, {3.721757378506689*^9, 3.72175737874658*^9}, 
   3.7217578096632442`*^9, {3.722421299070591*^9, 3.7224212992451153`*^9}, 
   3.745507739861779*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"1bd9cbc6-034f-4dfe-95a4-ea2ca8ec2b8a"],

Cell["<Ready>={<request>, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.721756623575251*^9, 3.72175662562084*^9}, {
   3.7218616459726677`*^9, 
   3.7218616467087383`*^9}},ExpressionUUID->"85b1c05d-550a-4700-aac4-\
756eb2e7b08e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Ready\>\""}], "]"}], "=", 
   "11"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Ready\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitude", ",", "\"\<Ready\>\""}], "]"}], "-",
        "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitude", ",", "\"\<Ready\>\""}], "]"}], "=", 
   "2"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, {3.7217564769697237`*^9, 
   3.7217564899578247`*^9}, {3.721756563781021*^9, 3.72175657523405*^9}, {
   3.721756631888152*^9, 3.7217566421344213`*^9}, 3.721757383451694*^9, 
   3.721757906077087*^9, {3.7224214806929007`*^9, 3.7224214915942783`*^9}, {
   3.745507768703951*^9, 
   3.745507768927498*^9}},ExpressionUUID->"79ce8a3b-a80e-458e-b77d-\
dc9354492426"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Ready\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",",
      "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"TransformationAmplitude", ",", "\"\<Ready\>\""}], "]"}], 
           "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.721756497150454*^9, 3.721756500397401*^9}, {3.721756582107078*^9, 
   3.721756585825021*^9}, {3.721756648119502*^9, 3.721756651916052*^9}, {
   3.722421483177207*^9, 3.7224214853592167`*^9}},
 CellLabel->
  "In[1874]:=",ExpressionUUID->"3b4b4f4b-7517-48de-88e0-6c418dfc55f5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Ready\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, 3.7217565039662046`*^9, 3.721756589336817*^9, 
   3.7217566550999317`*^9, {3.722421486306301*^9, 3.7224214882651787`*^9}},
 CellLabel->
  "In[1875]:=",ExpressionUUID->"7caedabd-0fe8-43ef-92e2-11a9e57562a1"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["consolidation", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.6999576793161383`*^9, 3.699957682623167*^9}, {
   3.69995837404912*^9, 3.699958377592299*^9}, {3.699958574875738*^9, 
   3.699958587182394*^9}, {3.699958628011107*^9, 3.699958629539061*^9}, {
   3.701095126622422*^9, 3.7010951289726562`*^9}, {3.722053347637271*^9, 
   3.722053349587484*^9}},ExpressionUUID->"e26d2aa6-e1ae-4d3a-a6e6-\
073e3553bc7b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ".."}], "}"}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{"True", ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958594214953*^9, 3.699958606071868*^9}, {
  3.721756676028056*^9, 3.721756677804595*^9}, {3.72242389623881*^9, 
  3.722423897303442*^9}},
 CellLabel->
  "In[1876]:=",ExpressionUUID->"add71dd1-7792-4850-b1f0-5814308cccb0"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["preparation", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957885713748*^9, {3.72205347486777*^9, 3.722053476910309*^9}, 
   3.722053515919626*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"3c84d945-3890-4454-807c-4623c395707f"],

Cell[CellGroupData[{

Cell["1. Chronology", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 
   3.7217627764566717`*^9},ExpressionUUID->"d9e57147-30ab-48bf-a18d-\
316617657e4b"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"063e66fc-af65-4616-84ab-\
509ab562f9d7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "checked_", ",", "morelocst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", "items___", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762808727313*^9, 
   3.721762826935285*^9}, {3.721775483028036*^9, 3.721775485042083*^9}, {
   3.721797156190708*^9, 3.721797167519938*^9}, {3.722421517264243*^9, 
   3.722421518507831*^9}},
 CellLabel->
  "In[1877]:=",ExpressionUUID->"9e177b79-8155-4a18-bb0b-0dc0af6478b3"]
}, Closed]],

Cell[CellGroupData[{

Cell["check validity", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003128834717216`*^9}},ExpressionUUID->"95558766-9f51-4687-825f-\
3e9019300aac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
       "morest___"}], "}"}], ",", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Chronology", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}], ",", 
       RowBox[{"\"\<RightToLeft\>\"", "|", "\"\<LeftToRight\>\""}]}], "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"TransformationAmplitude", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
         "morest"}], "}"}], ",", "items", ",", "opts"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"TransformationAmplitude", "::", "invalchron"}], "]"}], ";", 
       "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545060613969104*^9, 3.545060677315857*^9}, {
  3.699959501759419*^9, 3.6999595031746063`*^9}, {3.69996123531818*^9, 
  3.699961258964602*^9}, {3.6999613887140293`*^9, 3.699961497961199*^9}, {
  3.7027974045607414`*^9, 3.7027974136209464`*^9}, {3.702797581629608*^9, 
  3.7027975827761307`*^9}, {3.7217576729283247`*^9, 3.721757682608348*^9}, {
  3.721797178230218*^9, 3.7217971878626623`*^9}, {3.722421519628624*^9, 
  3.722421522909741*^9}},
 CellLabel->
  "In[1878]:=",ExpressionUUID->"5518d783-e285-4f2b-928c-c978fbd31710"]
}, Closed]],

Cell[CellGroupData[{

Cell["set flag when RtoL chronology is imposed throughout", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003129334155684`*^9}},ExpressionUUID->"9603f23c-5e49-428d-9a16-\
59c95f98fb50"],

Cell["\<\
Indicate RtoL chronology when events has been implemented with RtoL chronology\
\>", "Text",
 CellChangeTimes->{{3.7003131837412367`*^9, 3.700313213172423*^9}, {
   3.700323281449465*^9, 3.700323294991837*^9}, {3.700884900813744*^9, 
   3.7008849595387087`*^9}, {3.7093755408130093`*^9, 3.709375541419942*^9}, 
   3.7136933481804*^9, {3.721757734228219*^9, 
   3.721757754751378*^9}},ExpressionUUID->"ce2f40ec-1d6f-4d61-89e4-\
270e6f9f9644"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False"}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"morest1", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], 
              "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{"TransformationAmplitude", ",", "\"\<Chronology\>\""}], 
              "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"evst", ":", "True"}], ",", "\[IndentingNewLine]", 
        "morest2___"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True"}], "}"}], ",", "morest1", 
       ",", "evst", ",", "morest2"}], "}"}], ",", "more", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, 3.721773879282402*^9, 
   3.721797202556916*^9, {3.722421524056334*^9, 3.7224215291858063`*^9}},
 CellLabel->
  "In[1879]:=",ExpressionUUID->"9bbd7dc0-2661-442f-b0f8-0b08f0a2f111"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2. InputRule", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9},ExpressionUUID->"5c32426c-70e0-4ab0-bb35-\
cbca39e428a6"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"8c3564d4-1d49-4f9a-b438-\
07d36ddff4c5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "items___", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], 
     ",", "items", ",", "\[IndentingNewLine]", "opts"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721773889521596*^9, {
   3.721797009996429*^9, 3.7217970336582747`*^9}, {3.722421544163026*^9, 
   3.722421545874731*^9}},
 CellLabel->
  "In[1880]:=",ExpressionUUID->"994644ea-d66c-4fdd-a300-045d02c863ce"]
}, Closed]],

Cell[CellGroupData[{

Cell["implement", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003129334155684`*^9}, {3.721763123629573*^9, 
   3.721763125114709*^9}},ExpressionUUID->"d582f298-b624-4041-9e91-\
7ae5eebe3d23"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "\[IndentingNewLine]", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "\[Rho]ini", ",", 
     RowBox[{"Hold", "[", "obs", "]"}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, {3.721763137982553*^9, 
   3.721763295259151*^9}, {3.721763477155196*^9, 3.7217635012103233`*^9}, 
   3.721773896065181*^9, {3.721797041723003*^9, 3.7217970642402782`*^9}, {
   3.721856480296698*^9, 3.721856484373815*^9}, {3.7224215481367197`*^9, 
   3.722421550556594*^9}},
 CellLabel->
  "In[1881]:=",ExpressionUUID->"f47d0d22-1146-4191-9aeb-ded17d886bda"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, {3.721763137982553*^9, 
   3.721763295259151*^9}, {3.721763477155196*^9, 3.72176351888826*^9}, 
   3.7217636174566183`*^9, 3.721773900041164*^9, {3.7217970726019363`*^9, 
   3.721797105553602*^9}, {3.722421551831973*^9, 3.722421555567287*^9}},
 CellLabel->
  "In[1882]:=",ExpressionUUID->"584f165a-5b5c-4584-bd09-e8ed5e7d1f22"]
}, Closed]],

Cell[CellGroupData[{

Cell["check", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003129334155684`*^9}, {3.721763123629573*^9, 3.721763125114709*^9}, {
   3.7217633261462297`*^9, 
   3.721763327073567*^9}},ExpressionUUID->"249ae056-8a8e-4f97-aade-\
07fb89d018d4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], "}"}], 
       ",", "morest"}], "}"}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, {3.721763137982553*^9, 
   3.721763295259151*^9}, {3.721763477155196*^9, 3.72176351888826*^9}, {
   3.7217635728616657`*^9, 3.7217636121056423`*^9}, 3.7217739080808268`*^9, {
   3.721797114720999*^9, 3.721797136383321*^9}, {3.722421561361519*^9, 
   3.7224215637199707`*^9}},
 CellLabel->
  "In[1883]:=",ExpressionUUID->"948a6fdb-1a1f-4f3d-9d2e-75e1cf9f3ad9"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["3. EnsembleAverage", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.721784520604287*^9, 
   3.721784528586845*^9}, 
   3.722421575990965*^9},ExpressionUUID->"5dc4721e-130b-41d0-ad32-\
ba1fdfc84e1a"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}},ExpressionUUID->"7ab506a8-a5ca-4d26-aa49-\
ee4a03ca3720"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}],
           "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "\[IndentingNewLine]", "}"}]}], 
     ",", "\[IndentingNewLine]", "items___", ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], 
     ",", "\[IndentingNewLine]", "items", ",", "opts"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, 3.7217848581675463`*^9, {
   3.721784906747036*^9, 3.721784942930396*^9}, {3.721785002374063*^9, 
   3.721785029776099*^9}, {3.721796166564324*^9, 3.72179620833635*^9}, 
   3.7217973755614653`*^9, {3.722421602054446*^9, 3.722421603638015*^9}},
 CellLabel->
  "In[1884]:=",ExpressionUUID->"8374ee3a-acd6-47d5-ae84-d48b0150ca09"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 
   3.700298704750389*^9}},ExpressionUUID->"8068e201-4d49-436b-8e7f-\
867599c44af5"],

Cell[CellGroupData[{

Cell["case of no EnsembleAverage", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.6999651865551662`*^9, 3.699965204305951*^9}, {3.722424510236498*^9, 
   3.722424511651566*^9}},ExpressionUUID->"4f447303-af9b-4b82-b691-\
33c3a8bf8124"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TransformationAmplitude", "[", 
     RowBox[{
      RowBox[{"Evaluate", "@", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"prefix", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{
           "TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}], 
           "]"}]}], ",", 
         RowBox[{"locst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "_", ",", "morelocst___"}], 
           "}"}]}], ",", "morest___"}], "}"}]}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts1___Rule", ",", 
      RowBox[{"EnsembleAverage", "\[Rule]", "ensav_"}], ",", "opts2___Rule"}],
      "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"ReleaseHold", "@", "ensav"}], ",", 
      RowBox[{"None", "|", "False"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], "}"}], 
       ",", "morest"}], "}"}], ",", "more", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{
        RowBox[{"EnsembleAverage", "\[Rule]", "False"}], ",", "opts1", ",", 
        "opts2"}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.69996522458116*^9, 
   3.6999652253555193`*^9}, {3.699965256768085*^9, 3.699965393759205*^9}, {
   3.699965595298367*^9, 3.699965598163332*^9}, {3.721785093189507*^9, 
   3.721785104402804*^9}, 3.7218569896158943`*^9, {3.722421618818179*^9, 
   3.7224216204983263`*^9}, {3.7224243441439953`*^9, 3.722424390308343*^9}, {
   3.722424520261018*^9, 3.722424539069127*^9}, {3.72242492920494*^9, 
   3.722424929866457*^9}},
 CellLabel->
  "In[1885]:=",ExpressionUUID->"a6ab4882-b257-4a62-a000-2d2cc21ea6f0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TransformationAmplitude", "[", 
     RowBox[{
      RowBox[{"Evaluate", "@", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"prefix", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{
           "TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}], 
           "]"}]}], ",", 
         RowBox[{"locst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "_", ",", "morelocst___"}], 
           "}"}]}], ",", "morest___"}], "}"}]}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"EnsembleAverage", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}], ",", 
      RowBox[{"None", "|", "False"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], "}"}], 
       ",", "morest"}], "}"}], ",", "more", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{
        RowBox[{"EnsembleAverage", "\[Rule]", "False"}], ",", "opts"}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.69996522458116*^9, 
   3.6999652253555193`*^9}, {3.699965256768085*^9, 3.699965393759205*^9}, {
   3.699965595298367*^9, 3.699965598163332*^9}, {3.721785093189507*^9, 
   3.721785104402804*^9}, 3.7218569896158943`*^9, {3.722421618818179*^9, 
   3.7224216204983263`*^9}, {3.7224243441439953`*^9, 3.722424390308343*^9}, {
   3.722424520261018*^9, 3.722424539069127*^9}, {3.722424749492827*^9, 
   3.722424777247703*^9}, {3.722424935220338*^9, 3.722424935643167*^9}},
 CellLabel->
  "In[1886]:=",ExpressionUUID->"05f3bc1e-c640-4551-b116-1b17f04586c5"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardize EnsembleAverage", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.6999651865551662`*^9, 
   3.699965204305951*^9}},ExpressionUUID->"ed7a0ef1-f6da-4b7e-b077-\
c86aeebd1457"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}],
           "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts1___Rule", ",", 
     RowBox[{"EnsembleAverage", "\[Rule]", "ensav_"}], ",", "opts2___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{
        RowBox[{"EnsembleAverage", "->", 
         RowBox[{"StandardizeEnsembleAverage", "[", "ensav", "]"}]}], ",", 
        "opts1", ",", "opts2"}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.69996522458116*^9, 
   3.6999652253555193`*^9}, {3.699965256768085*^9, 3.699965393759205*^9}, {
   3.699965595298367*^9, 3.699965598163332*^9}, {3.721785093189507*^9, 
   3.721785104402804*^9}, 3.7218569896158943`*^9, {3.722421618818179*^9, 
   3.7224216204983263`*^9}, {3.7224243441439953`*^9, 3.722424390308343*^9}, 
   3.7224245520554953`*^9},
 CellLabel->
  "In[1887]:=",ExpressionUUID->"4f4d4377-3640-432b-bd47-a3e70c2ab6e1"]
}, Closed]],

Cell[CellGroupData[{

Cell["expand multidimensional variables", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.6999651865551662`*^9, 3.699965204305951*^9}, {3.699965473230483*^9, 
   3.699965485379623*^9}},ExpressionUUID->"fbd66220-9e9a-4e86-bfa4-\
1cec683f26cc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}],
           "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "morest___"}], "}"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts1___Rule", ",", 
     RowBox[{"EnsembleAverage", "\[Rule]", "ensav_"}], ",", "opts2___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"modmore", ",", "modopts"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"modmore", ",", "modopts"}], "}"}], "=", 
        "\[IndentingNewLine]", 
        RowBox[{
        "ExpandMultidimensionalEnsembleVariables", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "more", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"opts1", ",", "opts2"}], "}"}]}], "}"}], ",", 
          "\[IndentingNewLine]", "ensav"}], "\[IndentingNewLine]", "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitude", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], 
            "}"}], ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "[", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"ReleaseHold", "@", "modmore"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"EnsembleAverage", "\[Rule]", 
             RowBox[{
             "ExpandMultidimensionalEnsembleVariables", "@", "ensav"}]}], ",",
             "\[IndentingNewLine]", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"ReleaseHold", "@", "modopts"}]}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.69996522458116*^9, 
   3.6999652253555193`*^9}, {3.699965256768085*^9, 3.699965393759205*^9}, {
   3.699965488982991*^9, 3.699965674024057*^9}, {3.700487922322399*^9, 
   3.700487923368285*^9}, {3.700488350781142*^9, 3.700488351369256*^9}, {
   3.702806661995947*^9, 3.7028066658606462`*^9}, {3.702806885653371*^9, 
   3.7028068858408885`*^9}, {3.721785119691728*^9, 3.721785126370204*^9}, 
   3.721797380240395*^9, 3.721856992503956*^9, {3.7224216220141897`*^9, 
   3.7224216242895184`*^9}},
 CellLabel->
  "In[1888]:=",ExpressionUUID->"1f29ad8b-6a41-417e-b1da-a4d7bff9752d"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["4. NormalizationFactor", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.721784520604287*^9, 
   3.721784528586845*^9}, {3.7217957989634943`*^9, 3.721795803242463*^9}, 
   3.722421577654079*^9},ExpressionUUID->"c45a4023-a673-4062-b2dc-\
cd310832fa15"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}},ExpressionUUID->"1a7da3aa-ecc2-4995-a555-\
5a8f1390fd4e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitude", ",", "\"\<NormalizationFactor\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "\[IndentingNewLine]", "}"}]}], 
     ",", "\[IndentingNewLine]", "items___", ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "\[IndentingNewLine]",
        "morest"}], "}"}], ",", "\[IndentingNewLine]", "items", ",", 
     "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, 3.7217848581675463`*^9, {
   3.721784906747036*^9, 3.721784942930396*^9}, {3.721785002374063*^9, 
   3.721785029776099*^9}, 3.721795811294278*^9, {3.721797799172823*^9, 
   3.721797824246089*^9}, {3.722421641792651*^9, 3.722421643384583*^9}},
 CellLabel->
  "In[1889]:=",ExpressionUUID->"a62805a2-27f4-4afc-8b40-8863221032d5"]
}, Open  ]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 
   3.700298704750389*^9}},ExpressionUUID->"1c1527b4-7d36-4faf-aa1c-\
e4eea49c6511"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitude", ",", "\"\<NormalizationFactor\>\""}], 
          "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "normfac", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"normfac", "=", 
        RowBox[{
         RowBox[{"NormalizationFactor", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Switch", "[", "\[IndentingNewLine]", 
        RowBox[{"normfac", ",", "\[IndentingNewLine]", 
         RowBox[{"False", "|", "None"}], ",", 
         RowBox[{"TransformationAmplitude", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"prefix", ",", "True", ",", "morest"}], "}"}], ",", 
           "more", ",", 
           RowBox[{"Evaluate", "@", 
            RowBox[{"SimplifyRules", "[", 
             RowBox[{
              RowBox[{"NormalizationFactor", "\[Rule]", "1"}], ",", "opts"}], 
             "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"TransformationAmplitude", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"prefix", ",", "True", ",", "morest"}], "}"}], ",", 
           "more", ",", 
           RowBox[{"Evaluate", "@", 
            RowBox[{"SimplifyRules", "[", 
             RowBox[{
              RowBox[{"NormalizationFactor", "\[Rule]", "normfac"}], ",", 
              "opts"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", "_", 
         ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"TransformationAmplitude", "::", "badnormfac"}], "]"}], 
           ";", "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699966016692745*^9, 3.69996611662718*^9}, {
   3.6999662442283573`*^9, 3.6999662553192368`*^9}, {3.69996641843752*^9, 
   3.6999664234195013`*^9}, 3.721784975481917*^9, {3.721785063292615*^9, 
   3.721785076132764*^9}, {3.721795879267696*^9, 3.721796066909163*^9}, 
   3.721856999983809*^9, {3.722421645200904*^9, 3.722421653268573*^9}},
 CellLabel->
  "In[1890]:=",ExpressionUUID->"0b1e69d6-a39d-4f4f-ac84-ef4759100d5e"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["5. BackgroundGenerator", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.721784520604287*^9, 
   3.721784528586845*^9}, {3.7217957989634943`*^9, 3.721795803242463*^9}, {
   3.7217977282049847`*^9, 3.721797734068042*^9}, 
   3.7224215797190237`*^9},ExpressionUUID->"420b1c28-4961-4ac4-8d09-\
500632291cf4"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"a9df87a5-25ea-4e1d-be77-\
67b2620fcab9"],

Cell["only do this after the EnsembleAverage has been set up.", "Text",
 CellChangeTimes->{{3.70048766577647*^9, 3.700487684342527*^9}, {
  3.700487825172986*^9, 3.700487830817691*^9}, {3.7217981597060127`*^9, 
  3.7217981710317097`*^9}, {3.721798261256089*^9, 3.7217982622291107`*^9}, {
  3.722421663997818*^9, 
  3.722421668683709*^9}},ExpressionUUID->"58a811fb-7a82-4907-8cf9-\
c7fee1f91527"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}],
           "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"ensavst", ":", "True"}], ",", "\[IndentingNewLine]", 
        RowBox[{"morest2", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitude", ",", "\"\<BackgroundGenerator\>\""}],
               "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitude", ",", "\"\<EnsembleAverage\>\""}], 
              "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest3___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "prefix", ",", "ensavst", ",", "morest2", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest3"}], "}"}], 
     ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700487694223301*^9, 3.70048781391779*^9}, {
   3.7191693214038315`*^9, 3.7191693596416545`*^9}, {3.721797777869356*^9, 
   3.72179778087085*^9}, {3.721797849901107*^9, 3.72179786944099*^9}, {
   3.72179791512945*^9, 3.721797933731482*^9}, {3.721797976486981*^9, 
   3.7217980423259983`*^9}, {3.721798194371152*^9, 3.721798254502233*^9}, {
   3.72179948341151*^9, 3.721799483968858*^9}, 3.721857006046548*^9, {
   3.722421672501658*^9, 3.722421678155498*^9}, {3.722421730875716*^9, 
   3.722421756804281*^9}},
 CellLabel->
  "In[1891]:=",ExpressionUUID->"64917ccf-f190-46b7-872f-0c4a741c5f01"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardization", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700309598202568*^9, 
   3.7003096016263037`*^9}},ExpressionUUID->"9804369d-d243-41ca-af2b-\
2099b6118145"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitude", ",", "\"\<BackgroundGenerator\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "backg", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"backg", "=", 
        RowBox[{"StandardizeGenerator", "[", 
         RowBox[{"(", 
          RowBox[{"ReleaseHold", "[", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}], "]"}],
           ")"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitude", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
           "morest"}], "}"}], ",", "more", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", 
             RowBox[{"StandardizeGenerator", "[", "backg", "]"}]}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700309626432626*^9, 3.700309825969651*^9}, {
   3.700310056716866*^9, 3.700310057347103*^9}, {3.7027706940881877`*^9, 
   3.7027707578389273`*^9}, 3.702771187249196*^9, 3.702771711904467*^9, {
   3.7027717793794394`*^9, 3.7027717795115347`*^9}, {3.703235069363023*^9, 
   3.703235082012912*^9}, {3.7093740519364653`*^9, 3.7093740519399548`*^9}, {
   3.709375544993725*^9, 3.709375546231031*^9}, {3.719169486627988*^9, 
   3.719169489470293*^9}, {3.7191697012935205`*^9, 3.7191697245752764`*^9}, {
   3.7191697606300526`*^9, 3.7191698532499914`*^9}, {3.719169887689986*^9, 
   3.719169889079546*^9}, {3.719170053125657*^9, 3.719170064604946*^9}, {
   3.7217980595195503`*^9, 3.7217981405134697`*^9}, {3.721798300512731*^9, 
   3.7217983057272167`*^9}, 3.721857008431657*^9, {3.7224217753662148`*^9, 
   3.7224217785179787`*^9}, {3.7260032029040737`*^9, 3.726003229584774*^9}, {
   3.726004759645319*^9, 3.7260047622706842`*^9}, {3.726004819784633*^9, 
   3.726004819956513*^9}, 3.7260703595397396`*^9, {3.7284245068652744`*^9, 
   3.7284245088356752`*^9}, {3.728424556544027*^9, 3.728424556723155*^9}},
 CellLabel->
  "In[1892]:=",ExpressionUUID->"a64e44b0-df57-41b3-a1bf-84e8c3f4cd44"]
}, Closed]],

Cell[CellGroupData[{

Cell["diagonalization", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700309598202568*^9, 3.7003096016263037`*^9}, {3.700310956349225*^9, 
   3.700310958635674*^9}},ExpressionUUID->"d5edf83f-05bd-437f-85b2-\
09b237602a27"],

Cell["\<\
pre-diagonalization disabled in v3.0.3b6m if a PrecalculatedEvent is \
detected. Pre-diagonalization impedes the validation of the \
PrecalculatedEvent through identification of matched background generators.\
\>", "Text",
 CellChangeTimes->{{3.700311026475007*^9, 3.7003110367448473`*^9}, {
   3.721798321238275*^9, 3.721798325075145*^9}, 3.722421792509099*^9, 
   3.722429404739366*^9, {3.723272830850107*^9, 3.723272845057336*^9}, {
   3.723272881225842*^9, 3.72327288247309*^9}, {3.7232730271904163`*^9, 
   3.723273050858573*^9}, {3.723274396723278*^9, 3.723274415004168*^9}, {
   3.7232745234485283`*^9, 
   3.723274622673964*^9}},ExpressionUUID->"87fe2c72-34a5-4149-911c-\
27c4790ba493"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitude", ",", "\"\<BackgroundGenerator\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "backg", ",", "ensav", ",", "diagfunc", ",", "opbasis", ",", "basis"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"backg", "=", 
        RowBox[{"StandardizeGenerator", "[", 
         RowBox[{"(", 
          RowBox[{"ReleaseHold", "[", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}], "]"}],
           ")"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ensav", "=", 
        RowBox[{
         RowBox[{"EnsembleAverage", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"diagfunc", "=", 
        RowBox[{"Function", "[", 
         RowBox[{"backg", ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"FreeQ", "[", 
              RowBox[{
               RowBox[{"{", "more", "}"}], ",", "_PrecalculatedEvent"}], 
              "]"}], "&&", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"UnassignedSymbols", "[", "backg", "]"}], "]"}], "==", 
              "0"}]}], ",", "\[IndentingNewLine]", "\t", 
            RowBox[{"Switch", "[", 
             RowBox[{"backg", ",", "\[IndentingNewLine]", "\t", 
              RowBox[{"NullOperator", "[", "]"}], ",", "backg", ",", 
              "\[IndentingNewLine]", "\t", 
              RowBox[{"_", "?", "OperatorQ"}], ",", 
              RowBox[{"NDiagonalize", "[", 
               RowBox[{"backg", ",", "basis"}], "]"}], ",", 
              "\[IndentingNewLine]", "\t", 
              RowBox[{"_", "?", "SuperoperatorQ"}], ",", 
              RowBox[{"NDiagonalize", "[", 
               RowBox[{"backg", ",", "opbasis", ",", "basis"}], "]"}], ",", 
              "\[IndentingNewLine]", "\t", "_", ",", "backg"}], 
             "\[IndentingNewLine]", "\t", "]"}], ",", "\[IndentingNewLine]", 
            "backg"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], 
            "}"}], ",", "morest"}], "}"}], ",", "more", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", 
             RowBox[{"diagfunc", "[", "backg", "]"}]}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700309626432626*^9, 3.700309825969651*^9}, {
   3.700310056716866*^9, 3.700310057347103*^9}, {3.7003109674381866`*^9, 
   3.700310970564481*^9}, {3.700311001837414*^9, 3.700311070112496*^9}, {
   3.7003111193491707`*^9, 3.700311121309247*^9}, {3.7003111654495497`*^9, 
   3.700311251899686*^9}, {3.70031131378601*^9, 3.700311332780781*^9}, 
   3.700311733832684*^9, 3.700311787146143*^9, 3.7003134105552397`*^9, {
   3.700313498353919*^9, 3.700313498815946*^9}, {3.700483219531069*^9, 
   3.7004832554188547`*^9}, {3.700483352277752*^9, 3.700483360462049*^9}, {
   3.7004833972605753`*^9, 3.700483520007393*^9}, 3.7010882228410883`*^9, {
   3.7027706435992904`*^9, 3.7027706466855135`*^9}, {3.702772068810874*^9, 
   3.7027720697845917`*^9}, {3.702772204178095*^9, 3.702772208683292*^9}, {
   3.702772241521645*^9, 3.7027722420099926`*^9}, {3.7027766718350515`*^9, 
   3.702776693683591*^9}, {3.703235265111353*^9, 3.703235275222041*^9}, {
   3.709375546895355*^9, 3.709375547515277*^9}, {3.7185318943490877`*^9, 
   3.718531918369113*^9}, {3.7185319612993393`*^9, 3.718531971387257*^9}, {
   3.7185320251046305`*^9, 3.718532082778624*^9}, {3.7185322118469276`*^9, 
   3.7185322154746275`*^9}, {3.719169611765709*^9, 3.719169644249029*^9}, {
   3.7191696752370825`*^9, 3.719169677826317*^9}, {3.721798336494039*^9, 
   3.721798461968627*^9}, {3.7217985289366207`*^9, 3.721798593149304*^9}, {
   3.721798656708432*^9, 3.721798673922778*^9}, 3.721857011688685*^9, {
   3.722421796782308*^9, 3.72242184091077*^9}, {3.722429885837022*^9, 
   3.7224298862434893`*^9}, {3.722429943560017*^9, 3.72243004377699*^9}, {
   3.722430102736929*^9, 3.722430112653372*^9}, {3.7224301694967747`*^9, 
   3.722430216953331*^9}, {3.722430248258794*^9, 3.7224302816501827`*^9}, {
   3.722430347727871*^9, 3.722430565637971*^9}, {3.722430989359939*^9, 
   3.722431070958187*^9}, {3.7224311139027863`*^9, 3.722431114902648*^9}, {
   3.722431159255898*^9, 3.7224311671807823`*^9}, {3.722431203057433*^9, 
   3.722431237519247*^9}, 3.7224314282630367`*^9, {3.723274487523876*^9, 
   3.723274512143664*^9}, 3.7232747086473837`*^9, {3.7260028765798006`*^9, 
   3.7260029124264297`*^9}, {3.7260029788766747`*^9, 3.726002979032976*^9}, {
   3.7260041295170326`*^9, 3.7260041742171707`*^9}, {3.726004204961955*^9, 
   3.7260042069780064`*^9}, 3.726070359553248*^9},
 CellLabel->
  "In[1893]:=",ExpressionUUID->"ae3e64c3-95e0-41cf-b2d9-866bba90a3a5"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["6. InitialDensityOperator", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.721784520604287*^9, 
   3.721784528586845*^9}, {3.7217957989634943`*^9, 3.721795803242463*^9}, {
   3.7217977282049847`*^9, 3.721797734068042*^9}, {3.721799704018629*^9, 
   3.721799710660409*^9}, 
   3.722421581615117*^9},ExpressionUUID->"780cde09-94e1-49c7-8462-\
b9f60fadb90e"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"fe2f3114-51c0-4b9a-8156-\
fd6082f6f36c"],

Cell["do this after InputRule completed", "Text",
 CellChangeTimes->{{3.70048766577647*^9, 3.700487684342527*^9}, {
  3.700487825172986*^9, 3.700487830817691*^9}, {3.7217981597060127`*^9, 
  3.7217981710317097`*^9}, {3.721798261256089*^9, 3.7217982622291107`*^9}, {
  3.721799741569415*^9, 
  3.721799746832315*^9}},ExpressionUUID->"9530959d-f476-4d0b-b090-\
2db99e064f1c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"inputrulest", ":", "True"}], ",", 
        RowBox[{"morest1", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitude", ",", 
               "\"\<InitialDensityOperator\>\""}], "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
              "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest2___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", "True", ",", "morest1", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest2"}], "}"}], 
     ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700487694223301*^9, 3.70048781391779*^9}, {
   3.7191693214038315`*^9, 3.7191693596416545`*^9}, {3.721797777869356*^9, 
   3.72179778087085*^9}, {3.721797849901107*^9, 3.72179786944099*^9}, {
   3.72179791512945*^9, 3.721797933731482*^9}, {3.721797976486981*^9, 
   3.7217980423259983`*^9}, {3.721798194371152*^9, 3.721798254502233*^9}, {
   3.72179948341151*^9, 3.721799483968858*^9}, {3.72179975166746*^9, 
   3.7217998034466267`*^9}, 3.721857018016018*^9, {3.722421858433625*^9, 
   3.722421865209674*^9}},
 CellLabel->
  "In[1894]:=",ExpressionUUID->"76b6e196-005f-4a9a-928c-aea1cdcf32fa"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 
   3.7010863549023314`*^9},ExpressionUUID->"de88987c-ee92-44bc-84c6-\
d6c7be6f5630"],

Cell[CellGroupData[{

Cell["convert to Operator in ZeemanBasis", "Subsubsection",
 CellChangeTimes->{{3.7010864603545218`*^9, 3.7010864659691887`*^9}, {
  3.7010867609612627`*^9, 
  3.7010867637837343`*^9}},ExpressionUUID->"a9ea8160-bb79-4ef3-b072-\
415b5eb0a469"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitude", ",", 
               "\"\<InitialDensityOperator\>\""}], "]"}], "-", "1"}], "}"}]}],
           "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "\[Rho]0_", ",", "more___", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]0vec", ",", "opbasis", ",", "basis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"opbasis", ",", "basis"}], "}"}], "=", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
           "morest"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"Operator", "[", 
           RowBox[{"\[Rho]0", ",", 
            RowBox[{"ZeemanBasis", "[", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"FilterRules", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
                 "opts"}], "}"}], ",", 
               RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], 
           "]"}]}], ",", "\[IndentingNewLine]", "more", ",", "opts"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505831667958248*^9, 3.505831748490183*^9}, {
   3.505832309441513*^9, 3.505832312941794*^9}, {3.505832599922316*^9, 
   3.505832740073543*^9}, {3.506250210416719*^9, 3.506250237611433*^9}, {
   3.513186469192401*^9, 3.513186469829424*^9}, 3.51318681605831*^9, 
   3.513187651452241*^9, {3.532147304855291*^9, 3.532147439537492*^9}, {
   3.532149329896896*^9, 3.532149338319561*^9}, 3.532149372569627*^9, {
   3.533181425525577*^9, 3.533181430442663*^9}, {3.533182504670869*^9, 
   3.5331825131288147`*^9}, {3.5659827691398582`*^9, 3.565982782116868*^9}, {
   3.5659830268451757`*^9, 3.5659830434887037`*^9}, {3.5659830820186157`*^9, 
   3.56598308349586*^9}, 3.5659838988626003`*^9, 3.6184039837849693`*^9, 
   3.618404028231964*^9, {3.618480923911574*^9, 3.6184809991430187`*^9}, 
   3.618485751950809*^9, 3.618485814320808*^9, {3.699543683122245*^9, 
   3.6995437105638285`*^9}, {3.699543897851222*^9, 3.6995439024443913`*^9}, {
   3.6995439475325623`*^9, 3.699543947873602*^9}, {3.6995440913626137`*^9, 
   3.6995440975835285`*^9}, {3.6995441636725135`*^9, 3.699544163910169*^9}, {
   3.699544238338408*^9, 3.699544244690833*^9}, {3.699544291911933*^9, 
   3.6995443148411703`*^9}, {3.6995446345330815`*^9, 3.699544636765685*^9}, {
   3.6995448209907894`*^9, 3.699544822105002*^9}, {3.699544856660718*^9, 
   3.6995448878803053`*^9}, {3.699544938301976*^9, 3.6995449433501616`*^9}, {
   3.6999596180955772`*^9, 3.6999596194796953`*^9}, {3.70108647947666*^9, 
   3.701086681379079*^9}, {3.701086775234342*^9, 3.7010868771727133`*^9}, {
   3.7027831377703085`*^9, 3.7027831434043283`*^9}, {3.7027831936710367`*^9, 
   3.7027831939812574`*^9}, {3.709549793846383*^9, 3.70954982461693*^9}, {
   3.7095499072778535`*^9, 3.7095499404445014`*^9}, {3.721799867297668*^9, 
   3.721799875013403*^9}, {3.721799910533779*^9, 3.721800032000155*^9}, 
   3.7218002167971087`*^9, {3.721800250827134*^9, 3.7218002524327374`*^9}, 
   3.7218570206551237`*^9, {3.7218598425731297`*^9, 3.721859844820859*^9}, {
   3.7224218724403963`*^9, 3.722421876059126*^9}},
 CellLabel->
  "In[1895]:=",ExpressionUUID->"17c7f2cc-56b8-45fb-a111-cd713e91a633"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["7. Observables", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.721784520604287*^9, 
   3.721784528586845*^9}, {3.7217957989634943`*^9, 3.721795803242463*^9}, {
   3.7217977282049847`*^9, 3.721797734068042*^9}, {3.721799704018629*^9, 
   3.721799710660409*^9}, {3.7218001690356913`*^9, 3.721800184268475*^9}, 
   3.7224215833914022`*^9},ExpressionUUID->"56b8c1c9-569d-4123-944d-\
8304c4d8a670"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"c5d29309-1aad-4434-a108-\
9a7fffb84b92"],

Cell["do this after InputRule completed", "Text",
 CellChangeTimes->{{3.70048766577647*^9, 3.700487684342527*^9}, {
  3.700487825172986*^9, 3.700487830817691*^9}, {3.7217981597060127`*^9, 
  3.7217981710317097`*^9}, {3.721798261256089*^9, 3.7217982622291107`*^9}, {
  3.721799741569415*^9, 
  3.721799746832315*^9}},ExpressionUUID->"d11f0218-e806-4fa0-984b-\
df7576d5c520"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"inputrulest", ":", "True"}], ",", 
        RowBox[{"morest1", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{"TransformationAmplitude", ",", "\"\<Observables\>\""}],
               "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
              "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest2___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", "True", ",", "morest1", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest2"}], "}"}], 
     ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700487694223301*^9, 3.70048781391779*^9}, {
   3.7191693214038315`*^9, 3.7191693596416545`*^9}, {3.721797777869356*^9, 
   3.72179778087085*^9}, {3.721797849901107*^9, 3.72179786944099*^9}, {
   3.72179791512945*^9, 3.721797933731482*^9}, {3.721797976486981*^9, 
   3.7217980423259983`*^9}, {3.721798194371152*^9, 3.721798254502233*^9}, {
   3.72179948341151*^9, 3.721799483968858*^9}, {3.72179975166746*^9, 
   3.7217998034466267`*^9}, 3.721800750309065*^9, 3.721857033003721*^9, {
   3.7224218898785477`*^9, 3.722421892816492*^9}},
 CellLabel->
  "In[1896]:=",ExpressionUUID->"b1c0b0ec-d01c-4295-87e9-49ac2fde69ee"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
check for use of PolarizationLevelOperator or \
SingletPolarizationLevelOperator with a non-rigorous density operator\
\>", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 3.7010863549023314`*^9, {3.721800818245639*^9, 
   3.721800819925597*^9}, {3.721800957810176*^9, 3.721800976840838*^9}, {
   3.7218014223002577`*^9, 
   3.721801431810382*^9}},ExpressionUUID->"c1cb459b-2098-4c44-960f-\
8903ebe44217"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Observables\>\""}], 
          "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]0_", ",", 
     "obs_", ",", "more___", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Chop", "[", 
           RowBox[{
            RowBox[{"Tr", "@", 
             RowBox[{"MatrixRepresentation", "[", 
              RowBox[{"\[Rho]0", ",", 
               RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}], "-", "1"}], 
           "]"}], "\[NotEqual]", "0"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"FreeQ", "[", 
               RowBox[{"obs", ",", "PolarizationLevelOperator"}], "]"}]}], 
             ",", "\[IndentingNewLine]", "\t", 
             RowBox[{"Message", "[", 
              RowBox[{"PolarizationLevelOperator", "::", "inval\[Rho]"}], 
              "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"FreeQ", "[", 
               RowBox[{"obs", ",", "SingletPolarizationLevelOperator"}], 
               "]"}]}], ",", "\[IndentingNewLine]", "\t", 
             RowBox[{"Message", "[", 
              RowBox[{
              "SingletPolarizationLevelOperator", "::", "inval\[Rho]"}], 
              "]"}]}], "\[IndentingNewLine]", "]"}]}], ")"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Evaluate", "@", 
          RowBox[{"{", 
           RowBox[{"prefix", ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
            "morest"}], "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]0", ",", 
         RowBox[{"ReleaseHold", "@", "obs"}], ",", "more", ",", "opts"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505831667958248*^9, 3.505831748490183*^9}, {
   3.505832309441513*^9, 3.505832312941794*^9}, {3.505832599922316*^9, 
   3.505832740073543*^9}, {3.506250210416719*^9, 3.506250237611433*^9}, {
   3.513186469192401*^9, 3.513186469829424*^9}, 3.51318681605831*^9, 
   3.513187651452241*^9, {3.532147304855291*^9, 3.532147439537492*^9}, {
   3.532149329896896*^9, 3.532149338319561*^9}, 3.532149372569627*^9, {
   3.533181425525577*^9, 3.533181430442663*^9}, {3.533182504670869*^9, 
   3.5331825131288147`*^9}, {3.5659827691398582`*^9, 3.565982782116868*^9}, {
   3.5659830268451757`*^9, 3.5659830434887037`*^9}, {3.5659830820186157`*^9, 
   3.56598308349586*^9}, 3.5659838988626003`*^9, 3.6184039837849693`*^9, 
   3.618404028231964*^9, {3.618480923911574*^9, 3.6184809991430187`*^9}, 
   3.618485751950809*^9, 3.618485814320808*^9, {3.699543683122245*^9, 
   3.6995437105638285`*^9}, {3.699543897851222*^9, 3.6995439024443913`*^9}, {
   3.6995439475325623`*^9, 3.699543947873602*^9}, {3.6995440913626137`*^9, 
   3.6995440975835285`*^9}, {3.6995441636725135`*^9, 3.699544163910169*^9}, {
   3.699544238338408*^9, 3.699544244690833*^9}, {3.699544291911933*^9, 
   3.6995443148411703`*^9}, {3.6995446345330815`*^9, 3.699544636765685*^9}, {
   3.6995448209907894`*^9, 3.699544822105002*^9}, {3.699544856660718*^9, 
   3.6995448878803053`*^9}, {3.699544938301976*^9, 3.6995449433501616`*^9}, {
   3.6999596180955772`*^9, 3.6999596194796953`*^9}, {3.70108647947666*^9, 
   3.701086681379079*^9}, {3.701086775234342*^9, 3.7010868771727133`*^9}, {
   3.7027831377703085`*^9, 3.7027831434043283`*^9}, {3.7027831936710367`*^9, 
   3.7027831939812574`*^9}, {3.709549793846383*^9, 3.70954982461693*^9}, {
   3.7095499072778535`*^9, 3.7095499404445014`*^9}, {3.721799867297668*^9, 
   3.721799875013403*^9}, {3.721799910533779*^9, 3.721800032000155*^9}, 
   3.7218002167971087`*^9, {3.721800250827134*^9, 3.7218002524327374`*^9}, {
   3.721800835186301*^9, 3.7218009105389643`*^9}, {3.721800998969076*^9, 
   3.7218011424446497`*^9}, {3.721801223075515*^9, 3.7218013419579268`*^9}, {
   3.7218013741345243`*^9, 3.7218014016754217`*^9}, {3.721801678367235*^9, 
   3.7218016833218203`*^9}, {3.7218020174255667`*^9, 3.721802020655949*^9}, {
   3.7218565670594473`*^9, 3.7218565800988913`*^9}, 3.721857024487259*^9, 
   3.721858729003027*^9, {3.721860016953003*^9, 3.7218600308714113`*^9}, {
   3.722421900958624*^9, 3.7224219031870728`*^9}},
 CellLabel->
  "In[1897]:=",ExpressionUUID->"ba0ffe6d-e66f-491a-8777-734ec3efa4fd"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardize", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 3.7010863549023314`*^9, {3.721800818245639*^9, 
   3.721800819925597*^9}},ExpressionUUID->"854be039-116c-47a1-aace-\
ef3f5470b138"],

Cell[CellGroupData[{

Cell["place single observable in list", "Subsubsection",
 CellChangeTimes->{{3.7010864603545218`*^9, 3.7010864659691887`*^9}, {
  3.7010867609612627`*^9, 3.7010867637837343`*^9}, {3.7218008227682543`*^9, 
  3.721800827669806*^9}},ExpressionUUID->"78e44fdf-dd67-431f-bc82-\
3533693fdfde"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Observables\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "\[Rho]0_", ",", "obs_", ",", "more___", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"prefix", ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], "}"}], 
        ",", "morest"}], "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]0", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{"obs", ",", "_List"}], "]"}], ",", "obs", ",", 
        RowBox[{"{", "obs", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
     "more", ",", "opts"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505831667958248*^9, 3.505831748490183*^9}, {
   3.505832309441513*^9, 3.505832312941794*^9}, {3.505832599922316*^9, 
   3.505832740073543*^9}, {3.506250210416719*^9, 3.506250237611433*^9}, {
   3.513186469192401*^9, 3.513186469829424*^9}, 3.51318681605831*^9, 
   3.513187651452241*^9, {3.532147304855291*^9, 3.532147439537492*^9}, {
   3.532149329896896*^9, 3.532149338319561*^9}, 3.532149372569627*^9, {
   3.533181425525577*^9, 3.533181430442663*^9}, {3.533182504670869*^9, 
   3.5331825131288147`*^9}, {3.5659827691398582`*^9, 3.565982782116868*^9}, {
   3.5659830268451757`*^9, 3.5659830434887037`*^9}, {3.5659830820186157`*^9, 
   3.56598308349586*^9}, 3.5659838988626003`*^9, 3.6184039837849693`*^9, 
   3.618404028231964*^9, {3.618480923911574*^9, 3.6184809991430187`*^9}, 
   3.618485751950809*^9, 3.618485814320808*^9, {3.699543683122245*^9, 
   3.6995437105638285`*^9}, {3.699543897851222*^9, 3.6995439024443913`*^9}, {
   3.6995439475325623`*^9, 3.699543947873602*^9}, {3.6995440913626137`*^9, 
   3.6995440975835285`*^9}, {3.6995441636725135`*^9, 3.699544163910169*^9}, {
   3.699544238338408*^9, 3.699544244690833*^9}, {3.699544291911933*^9, 
   3.6995443148411703`*^9}, {3.6995446345330815`*^9, 3.699544636765685*^9}, {
   3.6995448209907894`*^9, 3.699544822105002*^9}, {3.699544856660718*^9, 
   3.6995448878803053`*^9}, {3.699544938301976*^9, 3.6995449433501616`*^9}, {
   3.6999596180955772`*^9, 3.6999596194796953`*^9}, {3.70108647947666*^9, 
   3.701086681379079*^9}, {3.701086775234342*^9, 3.7010868771727133`*^9}, {
   3.7027831377703085`*^9, 3.7027831434043283`*^9}, {3.7027831936710367`*^9, 
   3.7027831939812574`*^9}, {3.709549793846383*^9, 3.70954982461693*^9}, {
   3.7095499072778535`*^9, 3.7095499404445014`*^9}, {3.721799867297668*^9, 
   3.721799875013403*^9}, {3.721799910533779*^9, 3.721800032000155*^9}, 
   3.7218002167971087`*^9, {3.721800250827134*^9, 3.7218002524327374`*^9}, {
   3.721800835186301*^9, 3.7218009105389643`*^9}, {3.721801471314417*^9, 
   3.721801474634534*^9}, {3.7218015362357903`*^9, 3.721801550703266*^9}, {
   3.721856588548257*^9, 3.7218565961540833`*^9}, 3.721857037870182*^9, 
   3.7218587401148863`*^9, {3.721859701528343*^9, 3.721859703944476*^9}, 
   3.721860040625682*^9, {3.722421907002056*^9, 3.722421910375207*^9}},
 CellLabel->
  "In[1898]:=",ExpressionUUID->"c1a1a38b-d109-410e-8bf3-28d242d4747d"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["convert to Operator form", "Subsection",
 CellChangeTimes->{{3.7010864603545218`*^9, 3.7010864659691887`*^9}, {
  3.7010867609612627`*^9, 3.7010867637837343`*^9}, {3.7218008227682543`*^9, 
  3.721800827669806*^9}, {3.7218015666949177`*^9, 
  3.721801569930509*^9}},ExpressionUUID->"da3f721a-f685-4f45-9032-\
e4ab8f217138"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Observables\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{
          "True", ",", "True", ",", "True", ",", "False", ",", 
           "morelocst___"}], "}"}]}], ",", "\[IndentingNewLine]", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]0_", ",", 
     "obs_List", ",", "more___", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"prefix", ",", 
        RowBox[{"{", 
         RowBox[{
         "True", ",", "True", ",", "True", ",", "True", ",", "morelocst"}], 
         "}"}], ",", "morest"}], "}"}]}], ",", "\[IndentingNewLine]", 
     "\[Rho]0", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Operator", "[", 
         RowBox[{"#", ",", 
          RowBox[{"ZeemanBasis", "[", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
               "opts"}], "}"}], ",", 
             RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], "]"}], 
        "&"}], "/@", "obs"}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", "more", ",", "opts"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505831667958248*^9, 3.505831748490183*^9}, {
   3.505832309441513*^9, 3.505832312941794*^9}, {3.505832599922316*^9, 
   3.505832740073543*^9}, {3.506250210416719*^9, 3.506250237611433*^9}, {
   3.513186469192401*^9, 3.513186469829424*^9}, 3.51318681605831*^9, 
   3.513187651452241*^9, {3.532147304855291*^9, 3.532147439537492*^9}, {
   3.532149329896896*^9, 3.532149338319561*^9}, 3.532149372569627*^9, {
   3.533181425525577*^9, 3.533181430442663*^9}, {3.533182504670869*^9, 
   3.5331825131288147`*^9}, {3.5659827691398582`*^9, 3.565982782116868*^9}, {
   3.5659830268451757`*^9, 3.5659830434887037`*^9}, {3.5659830820186157`*^9, 
   3.56598308349586*^9}, 3.5659838988626003`*^9, 3.6184039837849693`*^9, 
   3.618404028231964*^9, {3.618480923911574*^9, 3.6184809991430187`*^9}, 
   3.618485751950809*^9, 3.618485814320808*^9, {3.699543683122245*^9, 
   3.6995437105638285`*^9}, {3.699543897851222*^9, 3.6995439024443913`*^9}, {
   3.6995439475325623`*^9, 3.699543947873602*^9}, {3.6995440913626137`*^9, 
   3.6995440975835285`*^9}, {3.6995441636725135`*^9, 3.699544163910169*^9}, {
   3.699544238338408*^9, 3.699544244690833*^9}, {3.699544291911933*^9, 
   3.6995443148411703`*^9}, {3.6995446345330815`*^9, 3.699544636765685*^9}, {
   3.6995448209907894`*^9, 3.699544822105002*^9}, {3.699544856660718*^9, 
   3.6995448878803053`*^9}, {3.699544938301976*^9, 3.6995449433501616`*^9}, {
   3.6999596180955772`*^9, 3.6999596194796953`*^9}, {3.70108647947666*^9, 
   3.701086681379079*^9}, {3.701086775234342*^9, 3.7010868771727133`*^9}, {
   3.7027831377703085`*^9, 3.7027831434043283`*^9}, {3.7027831936710367`*^9, 
   3.7027831939812574`*^9}, {3.709549793846383*^9, 3.70954982461693*^9}, {
   3.7095499072778535`*^9, 3.7095499404445014`*^9}, {3.721799867297668*^9, 
   3.721799875013403*^9}, {3.721799910533779*^9, 3.721800032000155*^9}, 
   3.7218002167971087`*^9, {3.721800250827134*^9, 3.7218002524327374`*^9}, {
   3.721800835186301*^9, 3.7218009105389643`*^9}, {3.721801471314417*^9, 
   3.721801474634534*^9}, {3.7218015362357903`*^9, 3.721801550703266*^9}, {
   3.721801620978948*^9, 3.721801668971882*^9}, {3.7218020297290907`*^9, 
   3.721802034855185*^9}, 3.72185704031859*^9, {3.721857849565053*^9, 
   3.721857930400457*^9}, {3.721858019223929*^9, 3.721858022221402*^9}, 
   3.721858744785597*^9, {3.721859723625017*^9, 3.72185972624787*^9}, 
   3.721860045271552*^9, {3.722421915540203*^9, 3.722421916923832*^9}},
 CellLabel->
  "In[1899]:=",ExpressionUUID->"0edebc02-9e44-4043-858f-72b3c3975ddb"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["8. Events", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.72177606254001*^9, 
   3.721776065403016*^9}, 3.721800716003613*^9, 3.722421585431459*^9},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"c48ce61b-4c11-4c0e-8c8f-c910db137842"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}},ExpressionUUID->"ee9266b2-436e-46cc-8b2a-\
02d2bcdc6f4f"],

Cell["request when InputRule has been done", "Text",
 CellChangeTimes->{{3.721776346443213*^9, 3.7217763670266323`*^9}, {
  3.721776532785104*^9, 3.721776538969142*^9}, {3.721776589897064*^9, 
  3.7217765903027267`*^9}},ExpressionUUID->"dfd93f83-a343-4c10-940a-\
d01a81faa665"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"morest1", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "True", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"morest2", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], 
              "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{"TransformationAmplitude", ",", "\"\<InputRule\>\""}], 
              "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"eventsst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "moreeventsst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest3___"}], "\[IndentingNewLine]", "}"}]}],
      ",", "\[IndentingNewLine]", "items___", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "morest1", ",", "True", ",", "morest2", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "moreeventsst"}], "}"}], ",", 
       "\[IndentingNewLine]", "morest3"}], "}"}], ",", "\[IndentingNewLine]", 
     "items", ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, {3.721776238800034*^9, 
   3.721776279522221*^9}, {3.721776387581098*^9, 3.7217764377752867`*^9}, {
   3.721859903123616*^9, 3.7218599032573233`*^9}, {3.721860091478952*^9, 
   3.72186010291691*^9}, {3.722421932032691*^9, 3.722421934628846*^9}, {
   3.728425313112768*^9, 3.7284253217318873`*^9}, {3.7284259396923246`*^9, 
   3.7284259433919535`*^9}},
 CellLabel->
  "In[1900]:=",ExpressionUUID->"f941aa35-8f4f-48b0-8779-998e562f0453"]
}, Closed]],

Cell[CellGroupData[{

Cell["insert null event if needed", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}, {3.721776307391692*^9, 3.72177631150943*^9}, {
   3.721777459537271*^9, 3.721777464751844*^9}, {3.7217775695881987`*^9, 
   3.721777571386384*^9}},ExpressionUUID->"119c9f6a-0542-4ab8-9ee8-\
9597d4203b16"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Evaluate", "@", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"morest1", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], 
           "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"eventsst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "moreeventsst___"}], "}"}]}], 
         ",", "\[IndentingNewLine]", "morest2___"}], "\[IndentingNewLine]", 
        "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]ini_", ",", "ops_", ",", 
      "\[IndentingNewLine]", "event_", ",", "\[IndentingNewLine]", "more___", 
      ",", "\[IndentingNewLine]", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ReleaseHold", "[", "event", "]"}], ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "ValidEventSpecificationQ"}], "|", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"_", "?", "ValidEventSpecificationQ"}], ".."}], "}"}], "|", 
         RowBox[{"_", "?", "PulseSequenceQ"}], "|", "_EventList"}], ")"}]}], 
      "]"}], ")"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"morest1", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "moreeventsst"}], "}"}], ",", 
       "\[IndentingNewLine]", "morest2"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[Rho]ini", ",", "ops", ",", "event", ",", "more", ",", 
     "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, {3.721776238800034*^9, 
   3.721776279522221*^9}, {3.721776329863151*^9, 3.7217763359485598`*^9}, {
   3.72177644948855*^9, 3.721776466830428*^9}, {3.721776498613871*^9, 
   3.721776504507472*^9}, {3.7217766350918303`*^9, 3.721776694665353*^9}, {
   3.7217767629917107`*^9, 3.7217767675650043`*^9}, {3.721777321432776*^9, 
   3.721777327495986*^9}, {3.721777360056284*^9, 3.721777360877708*^9}, {
   3.721777563549159*^9, 3.721777610680574*^9}, {3.721860117454707*^9, 
   3.7218601367978897`*^9}, 3.7218864099391527`*^9, {3.7224219445805798`*^9, 
   3.722421946954934*^9}, 3.723295267640069*^9, 3.725521433372982*^9, {
   3.7284247173912506`*^9, 3.7284247265917854`*^9}, {3.728424854919919*^9, 
   3.7284248567992525`*^9}, {3.72842566950586*^9, 3.728425720726187*^9}, {
   3.7284258250542784`*^9, 3.7284258582935205`*^9}, {3.72842592081392*^9, 
   3.7284259282021666`*^9}, {3.728425960587164*^9, 3.728425961001459*^9}, {
   3.7284260056828127`*^9, 3.728426006030061*^9}, {3.728426037960099*^9, 
   3.7284261198789673`*^9}, 3.728426157517947*^9, {3.7284261956780453`*^9, 
   3.728426265479616*^9}, 
   3.744354241103458*^9},ExpressionUUID->"5d350bfd-e49e-4496-83bb-\
c4d84c687ff2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"morest1", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], "]"}]}],
         ",", "\[IndentingNewLine]", 
        RowBox[{"eventsst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "moreeventsst___"}], "}"}]}], 
        ",", "\[IndentingNewLine]", "morest2___"}], "\[IndentingNewLine]", 
       "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]ini_", ",", "ops_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"notevent", ":", 
      RowBox[{"Except", "[", 
       RowBox[{
        RowBox[{"_", "?", "ValidEventSpecificationQ"}], "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "ValidEventSpecificationQ"}], ".."}], "}"}], "|", 
        
        RowBox[{"_", "?", "PulseSequenceQ"}], "|", "_EventList"}], "]"}]}], 
     ",", "\[IndentingNewLine]", "more___", ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"morest1", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "moreeventsst"}], "}"}], ",", 
       "\[IndentingNewLine]", "morest2"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[Rho]ini", ",", "ops", ",", "None", ",", "notevent", ",", "more", ",", 
     "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, {3.721776238800034*^9, 
   3.721776279522221*^9}, {3.721776329863151*^9, 3.7217763359485598`*^9}, {
   3.72177644948855*^9, 3.721776466830428*^9}, {3.721776498613871*^9, 
   3.721776504507472*^9}, {3.7217766350918303`*^9, 3.721776694665353*^9}, {
   3.7217767629917107`*^9, 3.7217767675650043`*^9}, {3.721777321432776*^9, 
   3.721777327495986*^9}, {3.721777360056284*^9, 3.721777360877708*^9}, {
   3.721777563549159*^9, 3.7217775648669767`*^9}, {3.721860114087949*^9, 
   3.721860133318347*^9}, {3.721886390023093*^9, 3.7218863945107203`*^9}, {
   3.722421940136319*^9, 3.722421941875366*^9}, {3.723295245111096*^9, 
   3.72329524886213*^9}, {3.725521316317101*^9, 3.725521317990024*^9}, {
   3.7284250569961834`*^9, 3.7284250649958644`*^9}, {3.7284250966763625`*^9, 
   3.7284251057648163`*^9}, {3.7284253602122154`*^9, 3.728425442430601*^9}, {
   3.7284254772103004`*^9, 3.7284254791496778`*^9}, {3.728425767835642*^9, 
   3.7284257704555025`*^9}, {3.7284259330526114`*^9, 3.7284259351030655`*^9}},
 
 CellLabel->
  "In[1902]:=",ExpressionUUID->"f57db6f3-7f6c-4ba1-a708-d1df36309dbd"]
}, Closed]],

Cell[CellGroupData[{

Cell["implement PulseSequence if needed", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}, {3.721776307391692*^9, 3.72177631150943*^9}, {
   3.721777459537271*^9, 3.721777464751844*^9}, {3.7217775695881987`*^9, 
   3.721777571386384*^9}, {3.725520810908017*^9, 3.725520817283524*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"5faefe59-f454-4640-aa83-7d2d1c4a187f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"morest1", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], "]"}]}],
         ",", "\[IndentingNewLine]", 
        RowBox[{"eventsst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "moreeventsst___"}],
           "}"}]}], ",", "\[IndentingNewLine]", "morest2___"}], 
       "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
     "\[Rho]ini_", ",", "ops_", ",", "\[IndentingNewLine]", "event_", ",", 
     "\[IndentingNewLine]", "more___", ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"morest1", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True", ",", "moreeventsst"}], 
        "}"}], ",", "\[IndentingNewLine]", "morest2"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[Rho]ini", ",", "ops", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"PulseSequenceQ", "[", "event", "]"}], ",", 
        RowBox[{"PulseSequence", "[", "event", "]"}], ",", "event"}], "]"}]}],
      ",", "\[IndentingNewLine]", "more", ",", "\[IndentingNewLine]", 
     "opts"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, {3.721776238800034*^9, 
   3.721776279522221*^9}, {3.721776329863151*^9, 3.7217763359485598`*^9}, {
   3.72177644948855*^9, 3.721776466830428*^9}, {3.721776498613871*^9, 
   3.721776504507472*^9}, {3.7217766350918303`*^9, 3.721776694665353*^9}, {
   3.7217767629917107`*^9, 3.7217767675650043`*^9}, {3.721777321432776*^9, 
   3.721777327495986*^9}, {3.721777360056284*^9, 3.721777360877708*^9}, {
   3.721777563549159*^9, 3.721777610680574*^9}, {3.721860117454707*^9, 
   3.7218601367978897`*^9}, 3.7218864099391527`*^9, {3.7224219445805798`*^9, 
   3.722421946954934*^9}, 3.723295267640069*^9, {3.7255208870106363`*^9, 
   3.7255209514847603`*^9}, {3.725521475540057*^9, 3.725521521484353*^9}, {
   3.7284245847330475`*^9, 3.7284245925325823`*^9}, {3.728424622842109*^9, 
   3.7284246912406807`*^9}, {3.7284247298120728`*^9, 
   3.7284247299911995`*^9}, {3.7284248438810787`*^9, 3.728424850039452*^9}, {
   3.728424898709015*^9, 3.728424964556777*^9}, {3.7284250093766055`*^9, 
   3.7284250437157526`*^9}, {3.728425077595812*^9, 3.7284250792850127`*^9}, {
   3.7284256045987663`*^9, 3.728425604915991*^9}, {3.744360653121917*^9, 
   3.7443606555180893`*^9}},ExpressionUUID->"a3e78e0d-55c9-4b8e-be8c-\
de4caf04d270"]
}, Closed]],

Cell[CellGroupData[{

Cell["check", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}, {3.721776307391692*^9, 3.72177631150943*^9}, {
   3.7217767084888153`*^9, 
   3.721776709575411*^9}},ExpressionUUID->"61f50a0c-670c-46e2-81de-\
32aab0048796"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"morest1", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Events\>\""}], "]"}]}],
         ",", "\[IndentingNewLine]", 
        RowBox[{"eventsst", ":", 
         RowBox[{"{", 
          RowBox[{
          "True", ",", "True", ",", "True", ",", "False", ",", 
           "moreeventsst___"}], "}"}]}], ",", "\[IndentingNewLine]", 
        "morest2___"}], "\[IndentingNewLine]", "}"}]}], ",", 
     "\[IndentingNewLine]", "\[Rho]ini_", ",", "ops_", ",", "event_", ",", 
     "more___", ",", "\[IndentingNewLine]", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{"event", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "ValidEventSpecificationQ"}], "|", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"_", "?", "ValidEventSpecificationQ"}], ".."}], "}"}], "|",
          "_PulseSequence", "|", "_EventList"}], ")"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"morest1", ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "True", ",", "moreeventsst"}], 
          "}"}], ",", "\[IndentingNewLine]", "morest2"}], "}"}], ",", 
       "\[IndentingNewLine]", "\[Rho]ini", ",", "ops", ",", "event", ",", 
       "more", ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"TransformationAmplitude", "::", "invalevent"}], "]"}], ";", 
       "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, {3.721776238800034*^9, 
   3.721776279522221*^9}, {3.721776329863151*^9, 3.7217763359485598`*^9}, {
   3.72177644948855*^9, 3.721776466830428*^9}, {3.721776498613871*^9, 
   3.721776504507472*^9}, {3.7217766350918303`*^9, 3.7217767501345177`*^9}, {
   3.721776797478134*^9, 3.7217768395979357`*^9}, {3.721776875784424*^9, 
   3.721776914637542*^9}, 3.7218601436213713`*^9, 3.721886512776519*^9, {
   3.722421948626915*^9, 3.722421954771985*^9}, 3.723295279256877*^9, {
   3.72552094656577*^9, 3.725520947349144*^9}},
 CellLabel->
  "In[1904]:=",ExpressionUUID->"56b9408d-35c3-43b1-966b-be7e8f3af576"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["9. Precalculation (* not yet implemented *)", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.72177606254001*^9, 
   3.721776065403016*^9}, 3.721800716003613*^9, {3.721859958818491*^9, 
   3.721859966559452*^9}, {3.7218610048865433`*^9, 3.721861005948319*^9}, {
   3.722127068227075*^9, 3.722127071119166*^9}, 
   3.7224215875597343`*^9},ExpressionUUID->"55d544a5-9f04-4a38-ae03-\
e5b9798727c7"],

Cell[CellGroupData[{

Cell["skip", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}, {3.721860282865163*^9, 
   3.721860283693969*^9}},ExpressionUUID->"b1cf6b61-02e3-41fd-ae01-\
e26c8e106dd6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Precalculation\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "\[IndentingNewLine]", "}"}]}], 
     ",", "\[IndentingNewLine]", "more___", ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"prefix", ",", "True", ",", "morest"}], "}"}]}], ",", "more", 
     ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.721860169314082*^9, 3.721860276774633*^9}, {
  3.722421961331483*^9, 3.722421963385503*^9}},
 CellLabel->
  "In[1905]:=",ExpressionUUID->"6ea7ea16-b59f-4aa0-9889-0349fcd0bc9a"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["10. UserLevel", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469882637143063*^9, 
   3.469882639820516*^9}, 3.4698965783855743`*^9, {3.497350131321055*^9, 
   3.497350134039557*^9}, 3.497572555273549*^9, {3.49962571930704*^9, 
   3.499625720633676*^9}, 3.700309573483725*^9, {3.700323416023525*^9, 
   3.700323416886857*^9}, 3.700325339948*^9, 3.700481393433628*^9, 
   3.7005714895228167`*^9, {3.700579885774226*^9, 3.7005799122948*^9}, 
   3.701092012391735*^9, {3.701092960495016*^9, 3.7010929611494503`*^9}, {
   3.7010937617650757`*^9, 3.701093778079844*^9}, {3.7010979198596363`*^9, 
   3.701097920532009*^9}, {3.721861748713746*^9, 3.721861749480152*^9}, {
   3.7224215901583347`*^9, 3.722421590255219*^9}, {3.74550782057421*^9, 
   3.745507822300722*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"aa5b8947-0f62-4d68-93d9-ee5af893b77a"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"63c0b62b-ed9b-4dd2-8cc4-c56d03b6b837"],

Cell["only request when everything else is done", "Text",
 CellChangeTimes->{{3.7010920581339617`*^9, 3.701092065349743*^9}, {
  3.701092546206051*^9, 
  3.70109254684184*^9}},ExpressionUUID->"d4f959b1-26de-4aa8-af8f-\
283fdcd8b122"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<UserLevel\>\""}], 
          "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", "morest___"}],
        "}"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"prefix", ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest"}], "}"}]}], 
     ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.70057991472042*^9, {3.701092025435781*^9, 3.701092055203823*^9}, {
   3.7010929675372458`*^9, 3.701092968310589*^9}, {3.721860409237769*^9, 
   3.721860432906308*^9}, {3.721861825126231*^9, 3.721861827756007*^9}, {
   3.72186193245578*^9, 3.7218619354030237`*^9}, {3.7224219680158978`*^9, 
   3.722421970365679*^9}, 
   3.745507840920343*^9},ExpressionUUID->"04d60c76-131c-443d-a821-\
8ff7c0545707"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 3.7010863549023314`*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"40865630-390b-4560-845c-38efa1fbf0b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<UserLevel\>\""}], 
          "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}], ",", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", "more___", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"minrul", ",", "ul"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"minrul", "=", 
        RowBox[{
         RowBox[{"MinimumRecommendedUserLevel", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ul", "=", 
        RowBox[{"UserLevel", "[", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"ul", "<", "minrul"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"UserLevel", "::", "toolow"}], ",", "ul", ",", "minrul"}], 
          "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Evaluate", "@", 
          RowBox[{"{", 
           RowBox[{"prefix", ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
            "morest"}], "}"}]}], ",", "\[IndentingNewLine]", "more", ",", 
         "opts"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.701092169605324*^9, 3.701092526598296*^9}, {
   3.7010929944817467`*^9, 3.701093013403054*^9}, {3.7010934705429573`*^9, 
   3.701093752204941*^9}, {3.721860444653264*^9, 3.721860490875362*^9}, {
   3.721860549552677*^9, 3.7218605919815283`*^9}, {3.7218606616623287`*^9, 
   3.721860683099204*^9}, 3.72186183481744*^9, {3.7218619451093197`*^9, 
   3.721861952153483*^9}, {3.72242197596154*^9, 3.722422004859377*^9}, {
   3.744105661755102*^9, 3.7441056705634527`*^9}, {3.744107084064022*^9, 
   3.7441071397736*^9}, {3.744197861888859*^9, 3.744197870248898*^9}, 
   3.745507853063405*^9, {3.7455078865600433`*^9, 
   3.745507967483952*^9}},ExpressionUUID->"3428c6e0-b6b7-452e-8db7-\
d3cfde69c6f9"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["11. Ready", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469882637143063*^9, 
   3.469882639820516*^9}, 3.4698965783855743`*^9, {3.497350131321055*^9, 
   3.497350134039557*^9}, 3.497572555273549*^9, {3.49962571930704*^9, 
   3.499625720633676*^9}, 3.700309573483725*^9, {3.700323416023525*^9, 
   3.700323416886857*^9}, 3.700325339948*^9, 3.700481393433628*^9, 
   3.7005714895228167`*^9, {3.700579885774226*^9, 3.7005799122948*^9}, 
   3.701092012391735*^9, {3.701092960495016*^9, 3.7010929611494503`*^9}, {
   3.7010937617650757`*^9, 3.701093778079844*^9}, {3.7010979198596363`*^9, 
   3.701097920532009*^9}, {3.721861748713746*^9, 3.721861749480152*^9}, {
   3.7224215901583347`*^9, 3.722421590255219*^9}, 
   3.745507818486476*^9},ExpressionUUID->"db26b614-6e2d-4da1-927a-\
0852006d8d05"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"eaa682f6-7887-426b-9b57-\
3642cc5809c9"],

Cell["only request when everything else is done", "Text",
 CellChangeTimes->{{3.7010920581339617`*^9, 3.701092065349743*^9}, {
  3.701092546206051*^9, 
  3.70109254684184*^9}},ExpressionUUID->"ca459b8d-966b-462c-9585-\
ca27715d2a47"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Ready\>\""}], "]"}]}], 
        ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", "morest___"}],
        "}"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"prefix", ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest"}], "}"}]}], 
     ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.70057991472042*^9, {3.701092025435781*^9, 3.701092055203823*^9}, {
   3.7010929675372458`*^9, 3.701092968310589*^9}, {3.721860409237769*^9, 
   3.721860432906308*^9}, {3.721861825126231*^9, 3.721861827756007*^9}, {
   3.72186193245578*^9, 3.7218619354030237`*^9}, {3.7224219680158978`*^9, 
   3.722421970365679*^9}},
 CellLabel->
  "In[1906]:=",ExpressionUUID->"af3bde47-8f99-4af4-a81b-30309cf5e141"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 
   3.7010863549023314`*^9},ExpressionUUID->"97adf75a-5d3c-4d0a-bcdd-\
5251ccb3c3dc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitude", ",", "\"\<Ready\>\""}], "]"}]}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}], ",", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", "more___", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ensavvars", ",", "suspectsymbols"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ensavvars", "=", 
        RowBox[{"UnassignedSymbols", "[", 
         RowBox[{
          RowBox[{"EnsembleAverage", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"suspectsymbols", "=", 
        RowBox[{"UnassignedSymbols", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"more", ",", "opts"}], "}"}], ",", 
          RowBox[{"PermittedSymbols", "\[Rule]", "ensavvars"}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "suspectsymbols", "]"}], "\[Equal]", "0"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Evaluate", "@", 
            RowBox[{"{", 
             RowBox[{"prefix", ",", 
              RowBox[{"{", 
               RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
              "morest"}], "}"}]}], ",", "\[IndentingNewLine]", "more", ",", 
           "opts"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"TransformationAmplitude", "::", "suspsymbs"}], ",", 
             "suspectsymbols"}], "]"}], ";", "\[IndentingNewLine]", 
           "$Failed"}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]",
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.701092169605324*^9, 3.701092526598296*^9}, {
   3.7010929944817467`*^9, 3.701093013403054*^9}, {3.7010934705429573`*^9, 
   3.701093752204941*^9}, {3.721860444653264*^9, 3.721860490875362*^9}, {
   3.721860549552677*^9, 3.7218605919815283`*^9}, {3.7218606616623287`*^9, 
   3.721860683099204*^9}, 3.72186183481744*^9, {3.7218619451093197`*^9, 
   3.721861952153483*^9}, {3.72242197596154*^9, 3.722422004859377*^9}, {
   3.744105661755102*^9, 3.7441056705634527`*^9}, {3.744107084064022*^9, 
   3.7441071397736*^9}, {3.744197861888859*^9, 3.744197870248898*^9}},
 CellLabel->
  "In[1907]:=",ExpressionUUID->"e91bc926-2980-45a4-ae31-b397782f4d5b"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["EnsembleAverage", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957885713748*^9, {3.721861118876135*^9, 3.721861140250825*^9}, {
   3.721861426074029*^9, 3.7218614300400057`*^9}, {3.721887057113096*^9, 
   3.7218870576108294`*^9}, {3.7220535191088867`*^9, 3.722053520869001*^9}, {
   3.722422059434581*^9, 3.722422065169848*^9}, {3.722425214432053*^9, 
   3.722425217254858*^9}, {3.722429254980283*^9, 3.722429257616514*^9}, 
   3.723272671648266*^9},ExpressionUUID->"64adbeda-31b7-4bca-8b49-\
0be3b20a7e58"],

Cell["\<\
second status flag batch: {<request>,<Parallel>,<batches set up>}\
\>", "Text",
 CellChangeTimes->{{3.721864601052649*^9, 3.72186464774921*^9}, {
  3.72186474409944*^9, 3.721864744795882*^9}, {3.721864795007752*^9, 
  3.721864799347962*^9}, {3.722425050683749*^9, 
  3.722425052010807*^9}},ExpressionUUID->"91bb777b-604f-4089-b547-\
d60803b15258"],

Cell[CellGroupData[{

Cell["case of no EnsembleAverage \[Rule] skip batch", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.7218645857576847`*^9, 3.721864589068324*^9}, {3.721864737495653*^9, 
   3.721864740245639*^9}, {3.722425059316646*^9, 3.7224250655157537`*^9}, {
   3.722425232185265*^9, 3.722425235951613*^9}, {3.722431822714676*^9, 
   3.7224318288805532`*^9}},ExpressionUUID->"202920a3-4275-41d0-9b55-\
af8d9a00270c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TransformationAmplitude", "[", 
     RowBox[{"True", ",", 
      RowBox[{"Evaluate", "@", 
       RowBox[{"(", 
        RowBox[{"more1", ":", 
         RowBox[{"Except", "[", "GeneralStatusListPattern", "]"}]}], ")"}]}], 
      ",", 
      RowBox[{"more2", ":", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"EnsembleAverage", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}], ",", 
      RowBox[{"None", "|", "False"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
    "True", ",", "True", ",", "False", ",", "more1", ",", "more2", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.722425094789987*^9, 3.722425175856604*^9}, 
   3.7224252404421463`*^9, {3.722429050357078*^9, 3.722429051395547*^9}, {
   3.722431673909505*^9, 3.722431677859782*^9}, {3.722432068476512*^9, 
   3.722432094325923*^9}, 3.722432500847939*^9, {3.722432625479622*^9, 
   3.7224326314230833`*^9}, 3.722432683060858*^9, {3.722470802690922*^9, 
   3.72247080328913*^9}},
 CellLabel->
  "In[1908]:=",ExpressionUUID->"cbf95a8c-1b13-4529-963d-3d1300fb8799"]
}, Open  ]],

Cell[CellGroupData[{

Cell["setup batch computations", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.7218645857576847`*^9, 3.721864589068324*^9}, {3.721864737495653*^9, 
   3.721864740245639*^9}},ExpressionUUID->"5d62efb8-382a-4dd0-b1e9-\
a47bdef113ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{"True", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"(", 
       RowBox[{"more1", ":", 
        RowBox[{"Except", "[", "GeneralStatusListPattern", "]"}]}], ")"}]}], 
     ",", "more2___", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{"True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False", ",", "False"}], "}"}], ",", "more1", ",", 
     "more2", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.70057991472042*^9, {3.701092025435781*^9, 3.701092055203823*^9}, {
   3.7010929675372458`*^9, 3.701092968310589*^9}, {3.721860409237769*^9, 
   3.721860432906308*^9}, {3.7218617667286673`*^9, 3.7218617680573397`*^9}, {
   3.721861846431069*^9, 3.721861850928974*^9}, {3.721861906617837*^9, 
   3.721861910702876*^9}, {3.7218647558642883`*^9, 3.721864771760084*^9}, {
   3.721864811094944*^9, 3.721864812193372*^9}, {3.721867691675612*^9, 
   3.721867728078298*^9}, {3.7218679893626547`*^9, 3.721868013831073*^9}, {
   3.7224221244335823`*^9, 3.722422124999874*^9}},
 CellLabel->
  "In[1909]:=",ExpressionUUID->"b005ea25-bd80-4df1-9e75-5293feb8029e"]
}, Closed]],

Cell[CellGroupData[{

Cell["setup Parallel", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.7218645857576847`*^9, 
   3.721864589068324*^9}},ExpressionUUID->"298acd5b-6ab2-49fe-9961-\
8174c1b1ada5"],

Cell["PrepareParallel if needed", "Text",
 CellChangeTimes->{{3.721862077597292*^9, 
  3.7218620817473717`*^9}},ExpressionUUID->"12cb8e0e-21e2-44d5-85ec-\
3eaa960eb2aa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{"True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False", ",", "False"}], "}"}], ",", 
     "\[IndentingNewLine]", "more___", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Parallel", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}], ",", 
           RowBox[{"True", "|", "All", "|", 
            RowBox[{"_", "?", "NumericQ"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"PrepareParallel", "[", 
          RowBox[{"opbasis", ",", "basis", ",", "opts"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False"}], "}"}], ",", 
         "\[IndentingNewLine]", "more", ",", "opts"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5066923457061167`*^9, 3.506692417095523*^9, {3.506692453561578*^9, 
   3.506692505334669*^9}, {3.506692629031838*^9, 3.5066926957678747`*^9}, {
   3.506692736496896*^9, 3.50669284440497*^9}, {3.5066932116562147`*^9, 
   3.5066932278932133`*^9}, {3.506693484789329*^9, 3.506693509806026*^9}, 
   3.5066937284851503`*^9, {3.506693825888592*^9, 3.5066938273192873`*^9}, {
   3.506694063994944*^9, 3.5066940724142714`*^9}, {3.506694282191956*^9, 
   3.506694290211069*^9}, {3.506694359514119*^9, 3.506694371097918*^9}, 
   3.506694557239192*^9, 3.5066946187962008`*^9, {3.506694956344503*^9, 
   3.506694966203347*^9}, {3.506767553660231*^9, 3.506767555723261*^9}, 
   3.507571977254531*^9, {3.5075720101717157`*^9, 3.5075720359721937`*^9}, 
   3.5079673116836157`*^9, 3.507967455235785*^9, 3.509086006880698*^9, {
   3.511169483376247*^9, 3.5111694899172277`*^9}, {3.511179134199709*^9, 
   3.511179135156444*^9}, {3.511181612953557*^9, 3.511181615691659*^9}, 
   3.514871485726852*^9, 3.51500229615989*^9, {3.5150034460383387`*^9, 
   3.5150034755713577`*^9}, {3.532452004836784*^9, 3.532452006869091*^9}, {
   3.533115042654971*^9, 3.533115044248684*^9}, {3.533212834140656*^9, 
   3.5332128999055433`*^9}, {3.533304235024026*^9, 3.5333042542713127`*^9}, 
   3.538910585155138*^9, {3.563101653945359*^9, 3.563101655272718*^9}, 
   3.566464932293323*^9, {3.572517264107789*^9, 3.5725173812422953`*^9}, 
   3.5725174357271767`*^9, {3.572541051492104*^9, 3.572541086953547*^9}, {
   3.61530544999538*^9, 3.615305472182384*^9}, 3.615308834361294*^9, {
   3.621591784012995*^9, 3.6215917879738693`*^9}, 3.621592386701013*^9, 
   3.62159641007325*^9, {3.6572088080138273`*^9, 3.657208819332693*^9}, {
   3.657209730782929*^9, 3.6572097397898293`*^9}, {3.721861224666458*^9, 
   3.72186129455264*^9}, {3.721861357518001*^9, 3.721861360926199*^9}, {
   3.721861795308818*^9, 3.721861799464417*^9}, 3.72186185976598*^9, {
   3.721861891023263*^9, 3.721861894716977*^9}, {3.721861973369492*^9, 
   3.721861995000147*^9}, {3.721862042023798*^9, 3.721862106895032*^9}, {
   3.721864841862556*^9, 3.721864885589512*^9}, 3.721867436835265*^9, 
   3.721868742302473*^9, 3.7218690653248377`*^9, 3.721880264372191*^9, {
   3.722422130871648*^9, 3.722422135444089*^9}},
 CellLabel->
  "In[1910]:=",ExpressionUUID->"ddb938ef-68cf-4f9a-b6fa-cb97439302e7"]
}, Closed]],

Cell[CellGroupData[{

Cell["batch computations", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.7218645857576847`*^9, 3.72186459560113*^9}, {3.7218785685293407`*^9, 
   3.721878611231189*^9}},ExpressionUUID->"abffdf4c-ddf3-49a2-a660-\
d4d2769740aa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "False"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[Rho]ini_", ",", "obs_", ",", "events_", ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ensav", ",", "weights", ",", "rules", ",", "nens", ",", "vars", ",", 
       "vals", ",", "maxbatchsize", ",", "nbatch", ",", "opbasis", ",", 
       "basis", ",", "ib", ",", "temp", ",", "rulesandweights", ",", 
       "rulesandweightsbatches", ",", "amplitudes", ",", "batchresult", ",", 
       "parallel"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"opbasis", ",", "basis", ",", "ensav", ",", "maxbatchsize"}],
          "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "OperatorBasis", ",", "Basis", ",", "EnsembleAverage", ",", 
            "MaxBatchSize"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"parallel", "=", 
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Parallel", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}], ",", 
          RowBox[{"True", "|", "All", "|", 
           RowBox[{"_", "?", "NumericQ"}]}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"nens", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"vars", "=", 
        RowBox[{"First", "[", "ensav", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"vals", "=", 
        RowBox[{"First", "/@", 
         RowBox[{"Last", "[", "ensav", "]"}]}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"weights", "=", 
        RowBox[{"Last", "/@", 
         RowBox[{"Last", "[", "ensav", "]"}]}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"rules", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Apply", "[", "Rule", "]"}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Transpose", "[", 
             RowBox[{"{", 
              RowBox[{"vars", ",", "#"}], "}"}], "]"}], "&"}], "/@", "vals"}],
           ",", 
          RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"rulesandweights", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"rules", ",", "weights"}], "}"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"rulesandweightsbatches", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{
         "rulesandweights", ",", "maxbatchsize", ",", "maxbatchsize", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}], ",", 
          RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"nbatch", "=", 
        RowBox[{"Length", "[", "rulesandweightsbatches", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"nbatch", "==", "1"}], ",", "\[IndentingNewLine]", 
         RowBox[{
         "PrintTemporary", "[", "\"\<computing using 1 batch ..\>\"", "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"PrintTemporary", "[", 
          RowBox[{"\"\<computing using \>\"", "<>", 
           RowBox[{"ToString", "[", "nbatch", "]"}], "<>", 
           "\"\< batches..\>\""}], "]"}]}], "\[IndentingNewLine]", "]"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"Apply", "[", 
        RowBox[{"Plus", ",", "\[IndentingNewLine]", 
         RowBox[{"Monitor", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"temp", "=", 
                RowBox[{"PrintTemporary", "[", 
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                   "parallel", ",", "\"\<parallel computing batch \>\"", ",", 
                    "\"\<computing batch \>\""}], "]"}], "<>", 
                  RowBox[{"ToString", "[", "ib", "]"}], "<>", "\"\< of \>\"", 
                  "<>", 
                  RowBox[{"ToString", "[", "nbatch", "]"}], "<>", 
                  "\"\<..\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"rules", ",", "weights"}], "}"}], "=", 
                RowBox[{"Transpose", "[", 
                 RowBox[{
                 "rulesandweightsbatches", "\[LeftDoubleBracket]", "ib", 
                  "\[RightDoubleBracket]"}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"amplitudes", "=", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{"parallel", ",", "ParallelMap", ",", "Map"}], "]"}],
                  "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Function", "[", 
                   RowBox[{"rule", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "TransformationAmplitude", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    "True", ",", "True", ",", "False", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Evaluate", "@", "\[Rho]ini"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Evaluate", "@", "obs"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Evaluate", "[", 
                    RowBox[{"events", "/.", "rule"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Evaluate", "[", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
                    RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"EnsembleAverage", "\[Rule]", "None"}], ",", 
                    "opts"}], "}"}], "/.", "rule"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Join", "[", 
                    RowBox[{
                    RowBox[{"Options", "[", "NPropagate", "]"}], ",", 
                    RowBox[{"Options", "[", "NDSolve", "]"}], ",", 
                    RowBox[{
                    "Options", "[", "TransformationAmplitude", "]"}]}], 
                    "]"}]}], "\[IndentingNewLine]", "]"}], "]"}]}], 
                    "\[IndentingNewLine]", "]"}]}], "]"}]}], 
                   "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
                  "rules"}], "\[IndentingNewLine]", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"batchresult", "=", 
                RowBox[{"Plus", "@@", 
                 RowBox[{"MapThread", "[", 
                  RowBox[{"Times", ",", 
                   RowBox[{"{", 
                    RowBox[{"amplitudes", ",", "weights"}], "}"}]}], 
                  "]"}]}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"NotebookDelete", "[", "temp", "]"}], ";", 
               "\[IndentingNewLine]", "batchresult"}], "\[IndentingNewLine]", 
              ")"}], ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"ib", ",", "1", ",", "nbatch"}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"ProgressIndicator", "[", 
            RowBox[{"ib", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"nbatch", "+", "1"}]}], "}"}]}], "]"}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.565973616626845*^9, 3.565973646938964*^9}, {
   3.565973704450218*^9, 3.565973792473486*^9}, {3.565973833957481*^9, 
   3.5659738417145357`*^9}, {3.565974054462031*^9, 3.565974486123555*^9}, {
   3.565974518256566*^9, 3.565974565209744*^9}, {3.5659798951711817`*^9, 
   3.565979896529059*^9}, {3.5661487167383833`*^9, 3.566148809409091*^9}, {
   3.566148841085351*^9, 3.566148910373026*^9}, 3.566148957582659*^9, {
   3.566148997323354*^9, 3.566148997527849*^9}, {3.566236134850613*^9, 
   3.5662361806023083`*^9}, {3.566463016717122*^9, 3.566463039597144*^9}, {
   3.566464270741766*^9, 3.566464284139461*^9}, {3.5664643242018433`*^9, 
   3.566464388867107*^9}, 3.5664645533377542`*^9, 3.566464680822782*^9, {
   3.566465258046586*^9, 3.5664652708622026`*^9}, {3.566465307380603*^9, 
   3.566465313920671*^9}, {3.5664688939931173`*^9, 3.5664688989712343`*^9}, {
   3.566903936029044*^9, 3.566903941372896*^9}, {3.5669039983988333`*^9, 
   3.5669040096094723`*^9}, {3.566904080790515*^9, 3.566904143473688*^9}, {
   3.566904551154718*^9, 3.56690457016008*^9}, {3.566904647204361*^9, 
   3.566904647327443*^9}, {3.566904824406974*^9, 3.566904825010825*^9}, {
   3.5669048800746717`*^9, 3.5669048997208843`*^9}, {3.5669053345885553`*^9, 
   3.5669053671167107`*^9}, {3.567698791691313*^9, 3.567698793381279*^9}, {
   3.572517471552414*^9, 3.57251751919834*^9}, {3.572517562343161*^9, 
   3.572517636252063*^9}, 3.572517692279484*^9, {3.572517751261952*^9, 
   3.5725177755183973`*^9}, {3.5725178221127453`*^9, 3.572517853368493*^9}, {
   3.572517884779625*^9, 3.572517894615494*^9}, {3.572520396771442*^9, 
   3.5725203991097107`*^9}, {3.572541126034028*^9, 3.5725411482382174`*^9}, 
   3.57254119425219*^9, {3.5725435942747583`*^9, 3.572543604072201*^9}, 
   3.572544029760531*^9, 3.621592413447895*^9, 3.621596422836117*^9, {
   3.640875437493799*^9, 3.640875486096925*^9}, 3.640876691247757*^9, {
   3.721864487065763*^9, 3.721864538804225*^9}, {3.721864897596545*^9, 
   3.7218649134048977`*^9}, {3.721864956938938*^9, 3.72186513328631*^9}, {
   3.721865281423382*^9, 3.7218653037727003`*^9}, {3.721865343133821*^9, 
   3.721865346341983*^9}, {3.721866441042356*^9, 3.7218665418538933`*^9}, 
   3.721866653300789*^9, {3.72186687894873*^9, 3.721866881481352*^9}, {
   3.721866966125082*^9, 3.7218669804716454`*^9}, {3.721867102381485*^9, 
   3.721867104669599*^9}, {3.721867165368045*^9, 3.721867198584531*^9}, {
   3.721867252744833*^9, 3.721867280487173*^9}, {3.721868754208745*^9, 
   3.721868888913989*^9}, {3.7218786463781137`*^9, 3.721878678280694*^9}, {
   3.721878906055903*^9, 3.7218789984119368`*^9}, {3.721879039044265*^9, 
   3.721879090826075*^9}, 3.721880092171465*^9, 3.7218802743337107`*^9, {
   3.721880318147517*^9, 3.721880329913924*^9}, {3.721880439943881*^9, 
   3.72188044162884*^9}, {3.721880827161125*^9, 3.721880851398651*^9}, {
   3.721882519744735*^9, 3.7218825264857616`*^9}, {3.722422147184082*^9, 
   3.72242222421471*^9}, {3.7224229972795153`*^9, 3.7224230354077997`*^9}, {
   3.722423066204584*^9, 3.722423071346023*^9}, {3.722423122771199*^9, 
   3.722423193835361*^9}, {3.722423301418376*^9, 3.722423347044642*^9}, {
   3.7224233834700603`*^9, 3.722423388653479*^9}, 3.722424072762014*^9, {
   3.722432743018691*^9, 3.722432747995202*^9}, {3.722466804844137*^9, 
   3.722466808738824*^9}, 3.7224669115961027`*^9, 3.722467091903469*^9, {
   3.7224672864580317`*^9, 3.722467299663659*^9}, 3.722467528796977*^9, {
   3.722467579553935*^9, 3.722467587878146*^9}, {3.722469611953425*^9, 
   3.72246964603577*^9}, 3.7224697707994537`*^9, {3.722470086563484*^9, 
   3.7224700872585363`*^9}},
 CellLabel->
  "In[1911]:=",ExpressionUUID->"36048c11-c377-4d0d-9e39-6c73ee655584"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["main calculation", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957885713748*^9, {3.721861118876135*^9, 3.721861140250825*^9}, {
   3.721861426074029*^9, 3.7218614300400057`*^9}, {3.721887057113096*^9, 
   3.7218870576108294`*^9}, {3.7220535191088867`*^9, 3.722053520869001*^9}, {
   3.722422059434581*^9, 3.722422065169848*^9}, {3.722425214432053*^9, 
   3.722425217254858*^9}, {3.722425294531713*^9, 3.722425301803357*^9}, 
   3.7224292417799473`*^9},ExpressionUUID->"9e495e95-7e96-477c-9a2c-\
783570154db2"],

Cell[CellGroupData[{

Cell["third status flag", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.502002117857419*^9, 
   3.5020021434008913`*^9}, 3.5020021999478073`*^9, {3.722470097766745*^9, 
   3.7224701006170797`*^9}},ExpressionUUID->"20ab9076-3720-429d-97ce-\
063ae770ce7d"],

Cell["third status flag: {<initiate>,<simplification needed>}", "Text",
 CellChangeTimes->{{3.721864601052649*^9, 3.72186464774921*^9}, {
   3.72186474409944*^9, 3.721864744795882*^9}, {3.721864795007752*^9, 
   3.721864799347962*^9}, {3.722425050683749*^9, 3.722425052010807*^9}, {
   3.722425442153036*^9, 3.722425445800403*^9}, {3.7224254849703207`*^9, 
   3.722425486875085*^9}, {3.722429056333686*^9, 3.722429091214965*^9}, {
   3.722470106359075*^9, 3.722470163477285*^9}, {3.722470282916546*^9, 
   3.722470286889413*^9}, {3.722470385275681*^9, 3.7224703872733994`*^9}, {
   3.722470518284401*^9, 3.72247052818137*^9}, {3.722470585233897*^9, 
   3.722470598991973*^9}, 
   3.722470778441936*^9},ExpressionUUID->"e0e9f34d-3763-4ec8-8639-\
d2bf516ae1f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{"True", ",", "True", ",", "False", ",", "more___"}], "]"}], ":=", 
   
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{"True", ",", "True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False"}], "}"}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.722470177172801*^9, 3.722470207763907*^9}, {
  3.722470392580605*^9, 3.722470392775017*^9}, {3.722470534733281*^9, 
  3.722470535537106*^9}, {3.722470766555768*^9, 3.722470766753641*^9}},
 CellLabel->
  "In[1912]:=",ExpressionUUID->"6a87aed3-160c-4715-8480-845d652c0d7f"]
}, Closed]],

Cell[CellGroupData[{

Cell["simplify", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.502002117857419*^9, 
   3.5020021434008913`*^9}, 3.5020021999478073`*^9, {3.722470467077067*^9, 
   3.722470468347796*^9}},ExpressionUUID->"b2c6cd32-4d5e-4e99-af0e-\
2c5b5275b822"],

Cell[CellGroupData[{

Cell["single TransformationAmplitude", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.502002117857419*^9, 
   3.5020021434008913`*^9}, 
   3.5020021999478073`*^9},ExpressionUUID->"52f60dad-aee4-457e-a5d6-\
e1db0d92339d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{"True", ",", "True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False"}], "}"}], ",", "\[Rho]ini_", ",", 
     RowBox[{"ops", ":", 
      RowBox[{"{", "_", "}"}]}], ",", "events_", ",", "opts___Rule"}], "]"}], 
   ":=", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"!", 
        RowBox[{"FreeQ", "[", 
         RowBox[{"#", ",", "$Failed"}], "]"}]}], ",", "$Failed", ",", 
       RowBox[{"First", "[", "#", "]"}]}], "]"}], "&"}], "@", 
    "\[IndentingNewLine]", 
    RowBox[{"TransformationAmplitude", "[", 
     RowBox[{
     "True", ",", "True", ",", "True", ",", "\[Rho]ini", ",", "ops", ",", 
      "events", ",", "opts"}], "]"}]}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456508639886243*^9, 3.45650868185382*^9}, {
   3.456509037620788*^9, 3.4565091550569553`*^9}, {3.456509306055188*^9, 
   3.456509320760811*^9}, {3.4565093993122263`*^9, 3.456509477912705*^9}, {
   3.456509632074041*^9, 3.456509637733838*^9}, 3.470141403049787*^9, {
   3.4973727977578773`*^9, 3.497372899045732*^9}, {3.4975297537003107`*^9, 
   3.4975297990225973`*^9}, {3.4975298453058577`*^9, 3.497529874792801*^9}, {
   3.497529910031045*^9, 3.4975299700371733`*^9}, {3.497530189072179*^9, 
   3.497530193381241*^9}, {3.5020021573524923`*^9, 3.502002179186638*^9}, {
   3.502010661658701*^9, 3.502010698927549*^9}, {3.5066928883353148`*^9, 
   3.506692892957728*^9}, 3.507572427033757*^9, {3.5148717464702473`*^9, 
   3.514871750029744*^9}, {3.532066235593257*^9, 3.532066317138743*^9}, {
   3.5331769738046713`*^9, 3.533176977456181*^9}, {3.53330804481417*^9, 
   3.53330805075835*^9}, {3.534398991468945*^9, 3.534398994521908*^9}, {
   3.542729682671507*^9, 3.5427297057133408`*^9}, 3.5427297535236807`*^9, {
   3.5434148544944363`*^9, 3.543414865383502*^9}, {3.543415159987276*^9, 
   3.5434151733040323`*^9}, {3.543415243687743*^9, 3.543415255005365*^9}, {
   3.543415944244067*^9, 3.543415972497794*^9}, {3.543416271217004*^9, 
   3.5434162756542997`*^9}, {3.543416365392281*^9, 3.5434164057962227`*^9}, {
   3.543416487914608*^9, 3.543416522919197*^9}, {3.543416593041333*^9, 
   3.543416596433132*^9}, {3.543416754832996*^9, 3.5434167923078127`*^9}, 
   3.564576355511372*^9, {3.564576389816852*^9, 3.564576390950754*^9}, {
   3.5645765013582077`*^9, 3.56457650375616*^9}, {3.5876455266507597`*^9, 
   3.5876455881459846`*^9}, 3.621574239507913*^9, {3.64300881514704*^9, 
   3.64300881580974*^9}, 3.643040444886462*^9, 3.6430428882970753`*^9, {
   3.6993005055265565`*^9, 3.699300513936078*^9}, {3.699300995274084*^9, 
   3.699301005966159*^9}, {3.6993011302027674`*^9, 3.6993011410729475`*^9}, {
   3.7027100253141212`*^9, 3.7027100560895205`*^9}, {3.7027111107210484`*^9, 
   3.702711163535473*^9}, 3.7027115308314495`*^9, {3.702728788828159*^9, 
   3.702728789099369*^9}, {3.703854180277012*^9, 3.7038541820583525`*^9}, {
   3.7038542261454687`*^9, 3.703854229616168*^9}, {3.703854270779293*^9, 
   3.703854283558916*^9}, {3.7038548136895227`*^9, 3.7038548178476734`*^9}, {
   3.70385507733879*^9, 3.7038550889237165`*^9}, {3.703855174541603*^9, 
   3.703855175650447*^9}, {3.703855219087753*^9, 3.7038552192596464`*^9}, {
   3.709227675566183*^9, 3.7092277113495784`*^9}, {3.709227780267521*^9, 
   3.7092280077640862`*^9}, {3.7092280504894185`*^9, 
   3.7092280900885696`*^9}, {3.709228130717392*^9, 3.709228139109354*^9}, {
   3.709228189311034*^9, 3.7092281901005726`*^9}, {3.7092282604834633`*^9, 
   3.7092282647264867`*^9}, {3.709228331128583*^9, 3.709228342886903*^9}, {
   3.709228375525082*^9, 3.709228400905134*^9}, {3.709228443020621*^9, 
   3.709228550180749*^9}, {3.7092286420679746`*^9, 3.7092286924887953`*^9}, {
   3.7092287290097246`*^9, 3.709228780167076*^9}, {3.709228812916185*^9, 
   3.709228859864503*^9}, {3.7092289652388725`*^9, 3.7092289715243573`*^9}, {
   3.7092290210284843`*^9, 3.7092290226026306`*^9}, {3.7092290765609384`*^9, 
   3.7092291417492437`*^9}, {3.7092298848780923`*^9, 3.709229913651553*^9}, {
   3.709230123517023*^9, 3.709230123696128*^9}, {3.709375513178608*^9, 
   3.709375514056032*^9}, {3.722423487495564*^9, 3.722423548815565*^9}, {
   3.7224286376492453`*^9, 3.7224287019640837`*^9}, {3.7224289754129677`*^9, 
   3.7224289930573874`*^9}, {3.722429074176813*^9, 3.722429078863039*^9}, {
   3.722469910613134*^9, 3.722469926322296*^9}, 3.722470168231481*^9, {
   3.722470311994727*^9, 3.7224703128188267`*^9}, {3.722470410241003*^9, 
   3.722470428976861*^9}, {3.722470729997209*^9, 3.722470730695073*^9}, {
   3.7225670657764606`*^9, 3.722567088319509*^9}},
 CellLabel->
  "In[1913]:=",ExpressionUUID->"39896965-4793-4407-b570-6dfd47e8bb2f"]
}, Closed]],

Cell[CellGroupData[{

Cell["several transformation amplitudes", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.456510357569454*^9, 
   3.456510365295979*^9}, {3.497529807096361*^9, 3.497529811925864*^9}, 
   3.5020022052676563`*^9, 
   3.722428957955089*^9},ExpressionUUID->"2be8c773-612d-4c34-8273-\
af6b7b6b31ab"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{"True", ",", "True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False"}], "}"}], ",", "\[Rho]ini_", ",", 
     RowBox[{"ops", ":", 
      RowBox[{"{", 
       RowBox[{"_", ",", "__"}], "}"}]}], ",", "events_", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
    "True", ",", "True", ",", "True", ",", "\[Rho]ini", ",", "ops", ",", 
     "events", ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456508639886243*^9, 3.45650868185382*^9}, {
   3.456509037620788*^9, 3.4565091550569553`*^9}, {3.456509306055188*^9, 
   3.456509320760811*^9}, {3.4565093993122263`*^9, 3.456509477912705*^9}, {
   3.456509632074041*^9, 3.456509637733838*^9}, 3.470141403049787*^9, {
   3.4973727977578773`*^9, 3.497372899045732*^9}, {3.4975297537003107`*^9, 
   3.4975297990225973`*^9}, {3.4975298453058577`*^9, 3.497529874792801*^9}, {
   3.497529910031045*^9, 3.4975299700371733`*^9}, {3.497530189072179*^9, 
   3.497530193381241*^9}, {3.5020021573524923`*^9, 3.502002179186638*^9}, {
   3.502010661658701*^9, 3.502010698927549*^9}, {3.5066928883353148`*^9, 
   3.506692892957728*^9}, 3.507572427033757*^9, {3.5148717464702473`*^9, 
   3.514871750029744*^9}, {3.532066235593257*^9, 3.532066317138743*^9}, {
   3.5331769738046713`*^9, 3.533176977456181*^9}, {3.53330804481417*^9, 
   3.53330805075835*^9}, {3.534398991468945*^9, 3.534398994521908*^9}, {
   3.542729682671507*^9, 3.5427297057133408`*^9}, 3.5427297535236807`*^9, {
   3.5434148544944363`*^9, 3.543414865383502*^9}, {3.543415159987276*^9, 
   3.5434151733040323`*^9}, {3.543415243687743*^9, 3.543415255005365*^9}, {
   3.543415944244067*^9, 3.543415972497794*^9}, {3.543416271217004*^9, 
   3.5434162756542997`*^9}, {3.543416365392281*^9, 3.5434164057962227`*^9}, {
   3.543416487914608*^9, 3.543416522919197*^9}, {3.543416593041333*^9, 
   3.543416596433132*^9}, {3.543416754832996*^9, 3.5434167923078127`*^9}, 
   3.564576355511372*^9, {3.564576389816852*^9, 3.564576390950754*^9}, {
   3.5645765013582077`*^9, 3.56457650375616*^9}, {3.5876455266507597`*^9, 
   3.5876455881459846`*^9}, 3.621574239507913*^9, {3.64300881514704*^9, 
   3.64300881580974*^9}, 3.643040444886462*^9, 3.6430428882970753`*^9, {
   3.6993005055265565`*^9, 3.699300513936078*^9}, {3.699300995274084*^9, 
   3.699301005966159*^9}, {3.6993011302027674`*^9, 3.6993011410729475`*^9}, {
   3.7027100253141212`*^9, 3.7027100560895205`*^9}, {3.7027111107210484`*^9, 
   3.702711163535473*^9}, 3.7027115308314495`*^9, {3.702728788828159*^9, 
   3.702728789099369*^9}, {3.703854180277012*^9, 3.7038541820583525`*^9}, {
   3.7038542261454687`*^9, 3.703854229616168*^9}, {3.703854270779293*^9, 
   3.703854283558916*^9}, {3.7038548136895227`*^9, 3.7038548178476734`*^9}, {
   3.70385507733879*^9, 3.7038550889237165`*^9}, {3.703855174541603*^9, 
   3.703855175650447*^9}, {3.703855219087753*^9, 3.7038552192596464`*^9}, {
   3.709227675566183*^9, 3.7092277113495784`*^9}, {3.709227780267521*^9, 
   3.7092280077640862`*^9}, {3.7092280504894185`*^9, 
   3.7092280900885696`*^9}, {3.709228130717392*^9, 3.709228139109354*^9}, {
   3.709228189311034*^9, 3.7092281901005726`*^9}, {3.7092282604834633`*^9, 
   3.7092282647264867`*^9}, {3.709228331128583*^9, 3.709228342886903*^9}, {
   3.709228375525082*^9, 3.709228400905134*^9}, {3.709228443020621*^9, 
   3.709228550180749*^9}, {3.7092286420679746`*^9, 3.7092286924887953`*^9}, {
   3.7092287290097246`*^9, 3.709228780167076*^9}, {3.709228812916185*^9, 
   3.709228859864503*^9}, {3.7092289652388725`*^9, 3.7092289715243573`*^9}, {
   3.7092290210284843`*^9, 3.7092290226026306`*^9}, {3.7092290765609384`*^9, 
   3.7092291417492437`*^9}, {3.7092298848780923`*^9, 3.709229913651553*^9}, {
   3.709230123517023*^9, 3.709230123696128*^9}, {3.709375513178608*^9, 
   3.709375514056032*^9}, {3.722423487495564*^9, 3.722423548815565*^9}, {
   3.7224286376492453`*^9, 3.7224287019640837`*^9}, {3.7224289754129677`*^9, 
   3.7224289930573874`*^9}, {3.722429074176813*^9, 3.722429078863039*^9}, {
   3.722469910613134*^9, 3.722469926322296*^9}, 3.722470168231481*^9, {
   3.722470311994727*^9, 3.7224703128188267`*^9}, {3.722470347372205*^9, 
   3.722470354321557*^9}, {3.722470442180449*^9, 3.722470451744796*^9}, {
   3.722470735244466*^9, 3.722470735954308*^9}},
 CellLabel->
  "In[1914]:=",ExpressionUUID->"d80c00b5-17d7-4999-be4e-0dd5be1ffdf4"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["computation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.502002117857419*^9, 
   3.5020021434008913`*^9}, 3.5020021999478073`*^9, {3.722470467077067*^9, 
   3.7224704897905073`*^9}},ExpressionUUID->"d5975089-8cc7-4976-93ef-\
c07f871492a4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "[", 
    RowBox[{
    "True", ",", "True", ",", "True", ",", "\[Rho]ini_", ",", "ops_List", ",",
      "events_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\[Rho]vecfinal", ",", "norm", ",", "opnormsqlist", ",", "opbasis", ",",
        "basis", ",", "optstopassdown"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"norm", ",", "opbasis", ",", "basis"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "NormalizationFactor", ",", "OperatorBasis", ",", "Basis"}], "}"}],
           "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"optstopassdown", "=", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"CurrentOptionsToPassDown", "[", 
          RowBox[{"TransformationAmplitude", ",", "NPropagate"}], "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"opnormsqlist", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"OperatorNorm", "[", "#", "]"}], "^", "2"}], ")"}], "&"}],
          "/@", "ops"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Rho]vecfinal", "=", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"NPropagate", "[", 
          RowBox[{"events", ",", 
           RowBox[{"OperatorBasis", "\[Rule]", " ", "opbasis"}], ",", 
           RowBox[{"Basis", "\[Rule]", " ", "basis"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Sequence", "@@", 
            RowBox[{"FilterRules", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"SimplifyRules", "[", 
                RowBox[{
                 RowBox[{"Continuous", "\[Rule]", "False"}], ",", "opts", ",",
                  "optstopassdown"}], "]"}], "}"}], ",", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"Options", "[", "NPropagate", "]"}], ",", 
                RowBox[{"Options", "[", "NDSolve", "]"}]}], "]"}]}], 
             "\[IndentingNewLine]", "]"}]}], ",", "opts"}], "]"}], "[", 
         "\[Rho]ini", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"FreeQ", "[", 
           RowBox[{"\[Rho]vecfinal", ",", "$Failed"}], "]"}]}], ",", 
         "\[IndentingNewLine]", "$Failed", ",", "\[IndentingNewLine]", 
         RowBox[{"MapThread", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"Chop", "@", 
             RowBox[{"N", "[", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Conjugate", "[", 
                  RowBox[{"OperatorVectorRepresentation", "[", 
                   RowBox[{"#1", ",", "opbasis", ",", "basis"}], "]"}], "]"}],
                  ".", 
                 RowBox[{"OperatorVectorRepresentation", "[", 
                  RowBox[{"\[Rho]vecfinal", ",", "opbasis", ",", "basis"}], 
                  "]"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{"norm", "\[Times]", "#2"}], ")"}]}], "]"}]}], "&"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"ops", ",", "opnormsqlist"}], "}"}]}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.456510372984645*^9, 3.456510416352416*^9}, 
   3.470141406872658*^9, {3.497372916740807*^9, 3.4973729584051847`*^9}, {
   3.497529817090352*^9, 3.497529823936967*^9}, {3.497529983706531*^9, 
   3.4975300383177347`*^9}, {3.4975302053575172`*^9, 3.497530214709453*^9}, {
   3.502002217668207*^9, 3.502002290523698*^9}, {3.502010716922909*^9, 
   3.502010736984891*^9}, 3.506692904450615*^9, 3.507572434337636*^9, {
   3.514871760665353*^9, 3.514871765650012*^9}, {3.532066337389822*^9, 
   3.532066366930421*^9}, {3.5331769849026833`*^9, 3.53317698882611*^9}, {
   3.533212980876586*^9, 3.533212993627602*^9}, {3.533213030704091*^9, 
   3.533213061555048*^9}, {3.533308058753483*^9, 3.53330806200968*^9}, {
   3.5333082349912577`*^9, 3.533308245323744*^9}, {3.5333082898868732`*^9, 
   3.5333083537802353`*^9}, {3.5343990076073*^9, 3.534399011061495*^9}, {
   3.543416784948185*^9, 3.5434167872348146`*^9}, 3.56457628884199*^9, 
   3.564577616554966*^9, 3.58764559507514*^9, 3.6215742449435167`*^9, {
   3.6430088238221273`*^9, 3.643008824146455*^9}, 3.643040451230811*^9, 
   3.6430428883054857`*^9, {3.6993005253867826`*^9, 3.6993005339566936`*^9}, {
   3.7027100609142475`*^9, 3.702710084761237*^9}, {3.702711147294923*^9, 
   3.702711153247834*^9}, {3.702711403640671*^9, 3.7027114711276293`*^9}, {
   3.7027287958193097`*^9, 3.702728795971504*^9}, {3.7038540489311867`*^9, 
   3.703854050986796*^9}, {3.703854111677664*^9, 3.7038541117557983`*^9}, {
   3.7038541762356806`*^9, 3.703854176376321*^9}, {3.7039197737975483`*^9, 
   3.7039198010513163`*^9}, {3.709226386020894*^9, 3.709226388443647*^9}, {
   3.7092264221631*^9, 3.7092264291625185`*^9}, {3.7092265198368125`*^9, 
   3.7092265348301153`*^9}, {3.7092265999081335`*^9, 3.709226602810867*^9}, {
   3.7092266846309223`*^9, 3.709226691641675*^9}, 3.709226741768919*^9, {
   3.709226774937371*^9, 3.7092267751963224`*^9}, {3.7092275980769873`*^9, 
   3.7092276003756084`*^9}, {3.7092276660494385`*^9, 
   3.7092276662285643`*^9}, {3.70922917048662*^9, 3.7092291923801985`*^9}, {
   3.7092299216712284`*^9, 3.709229935281884*^9}, {3.709230078805244*^9, 
   3.709230083159363*^9}, {3.7092301278640966`*^9, 3.7092301303238564`*^9}, {
   3.7092302687427063`*^9, 3.7092302747660103`*^9}, {3.7092315442660837`*^9, 
   3.709231547290262*^9}, {3.709231613057786*^9, 3.7092316133580008`*^9}, 
   3.709372231094721*^9, {3.7093755149223423`*^9, 3.7093755156649113`*^9}, {
   3.7224236028592987`*^9, 3.7224236578957167`*^9}, {3.722428746095661*^9, 
   3.7224287590241327`*^9}, {3.722429095482448*^9, 3.722429132056128*^9}, 
   3.722470170923612*^9, {3.722566889869359*^9, 3.722566922714408*^9}, 
   3.7225671213676987`*^9, {3.723293978802568*^9, 3.723293998278214*^9}, {
   3.723294029241784*^9, 3.72329402974434*^9}, {3.7259689900673003`*^9, 
   3.7259690541871567`*^9}, {3.725999710909093*^9, 3.7259997424918942`*^9}, {
   3.7259999548786573`*^9, 3.725999955113312*^9}, {3.726000026870307*^9, 
   3.7260000949476423`*^9}, {3.726000148531404*^9, 3.726000156827612*^9}, {
   3.726000190250677*^9, 3.7260002244040627`*^9}, {3.7260002575530148`*^9, 
   3.7260002620410767`*^9}, {3.7260004354330125`*^9, 3.7260004471440296`*^9}, 
   3.7260051154040365`*^9, {3.726005156319227*^9, 3.7260052961752405`*^9}, {
   3.7260053637405167`*^9, 3.726005435336229*^9}, 3.726005466088826*^9},
 CellLabel->
  "In[1915]:=",ExpressionUUID->"394a6c77-599c-4c23-9537-37f5e6384682"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubtitle",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.456510357569454*^9, 
   3.456510365295979*^9}, {3.497529807096361*^9, 3.497529811925864*^9}, 
   3.5020022052676563`*^9, {3.5067611334401627`*^9, 
   3.506761136950787*^9}},ExpressionUUID->"1d8e64ad-06f8-44f4-913a-\
138054873e27"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "::", "invalchron"}], "=", 
   "\"\<Invalid value for Chronology.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.721758035405245*^9, 3.721758054323201*^9}, 
   3.722421048771838*^9},
 CellLabel->
  "In[1916]:=",ExpressionUUID->"205beac4-1629-4ae1-b7fa-41d932cc1fd3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "::", "invalevent"}], "=", 
   "\"\<Invalid event specification encountered.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7217769292922583`*^9, 3.721776949402382*^9}, 
   3.722421061349683*^9},
 CellLabel->
  "In[1917]:=",ExpressionUUID->"f2ae8859-6418-40ce-956e-51c0f2995435"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "::", "badnormfac"}], "=", 
   "\"\<The normalization factor must be None, False, or numeric.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.721796119538319*^9, 3.721796142202935*^9}, 
   3.72242107657441*^9},
 CellLabel->
  "In[1918]:=",ExpressionUUID->"c2d14941-c1fe-4faa-9c75-6f32b3bcd398"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "::", "suspsymbs"}], "=", 
   "\"\<The following symbols do not have numerical values: `1`.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.701093796050228*^9, 3.701093848737091*^9}, {
   3.701093978300651*^9, 3.701093979196167*^9}, 3.7218605183060083`*^9, 
   3.72242107823133*^9},
 CellLabel->
  "In[1919]:=",ExpressionUUID->"48d16248-a33e-48fc-8b60-0db240bbe4ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitude", "::", "badsyntax"}], "=", 
   "\"\<There is a syntax error in TransformationAmplitude. A common error is \
to place one or more option rules of the form a\[Rule]b before one of the \
other arguments.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.722052576481176*^9, 3.722052720803439*^9}, {
  3.722421093589075*^9, 3.7224211224927807`*^9}},
 CellLabel->
  "In[1920]:=",ExpressionUUID->"a7417a8d-52f9-43dc-8a23-598af91351d7"],

Cell[CellGroupData[{

Cell["more", "Subsection",
 CellChangeTimes->{{3.7217581184875317`*^9, 
  3.721758119852337*^9}},ExpressionUUID->"5c452fe0-bc57-4dbb-9059-\
d07dd9db95c4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "inapplims"}], "=", 
   "\"\<The limits of the iterator and its increment must be integers.\>\""}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5072789074144583`*^9, 3.507278949684041*^9}, 
   3.5075478618999977`*^9, {3.5111795668077*^9, 3.511179588300497*^9}},
 CellLabel->
  "In[1921]:=",ExpressionUUID->"5473aff5-c779-488e-b6d7-e255447d641e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "badensvar"}], "=", 
   "\"\<The variable used in the EnsembleAverage may not have an assigned \
value.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.507554648001753*^9, 3.507554665657736*^9}},
 CellLabel->
  "In[1922]:=",ExpressionUUID->"11eadf55-2e61-4fc7-a626-29e4a3b0ba6a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "nprecalnotfound"}], "=", 
   "\"\<Cannot find a value of the iterator specifying the timing of all \
precalculation symbols. The timing will be determined using the iterator `1` \
= `2`.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5104908209386578`*^9, 3.5104908824290867`*^9}, {
  3.510491325730711*^9, 3.510491340688993*^9}},
 CellLabel->
  "In[1923]:=",ExpressionUUID->"b04303e0-5e60-441e-8b66-948eaedf70dd"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["TransformationAmplitudeTable", "Chapter",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.45268559236838*^9, 3.452685596612178*^9}, 
   3.452685977341175*^9, {3.456221032206551*^9, 3.456221041675785*^9}, 
   3.456387573527132*^9, {3.456508634043894*^9, 3.456508635514103*^9}, {
   3.497529605471568*^9, 3.4975296086541243`*^9}, {3.505019908545583*^9, 
   3.505019916694314*^9}, 3.505019947230769*^9, {3.505022202959749*^9, 
   3.5050222067433023`*^9}, 3.506691865831951*^9, {3.506760653445973*^9, 
   3.5067606552344303`*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"d58ce204-100e-431e-8c48-785a95c4c586"],

Cell[CellGroupData[{

Cell["options & attributes", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957871043387*^9, {3.722053600474162*^9, 3.722053604311769*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"3020c932-2ab6-473c-b9af-82f9ee78e42d"],

Cell[CellGroupData[{

Cell["options", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469894351830557*^9, 3.469894355180109*^9}, 
   3.470141048075708*^9, {3.721861723063643*^9, 3.721861730059412*^9}, 
   3.7218872429930058`*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"be15ae92-7aec-4bbc-ac24-d4a6109ce71b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OperatorBasis", "\[RuleDelayed]", 
      RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Basis", "\[RuleDelayed]", 
      RowBox[{"ZeemanBasis", "[", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"NormalizationFactor", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"UseMatrixExpWhenPossible", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"UseHilbertSpaceWhenPossible", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"InitialTimePoint", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"BackgroundGenerator", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"EnsembleAverage", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"TableCoordinates", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Chronology", "\[RuleDelayed]", "$Chronology"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Parallel", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"MaxBatchSize", "\[Rule]", "128"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TableVariables", "\[Rule]", "Undefined"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"MinimumRecommendedUserLevel", "\[Rule]", "1"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.46279631759762*^9, 3.462796327632659*^9}, {
   3.462796499979474*^9, 3.462796500513019*^9}, {3.4639405693833437`*^9, 
   3.463940573195265*^9}, 3.4648620535854683`*^9, {3.465814564759466*^9, 
   3.465814565148946*^9}, {3.465814951086645*^9, 3.465814954331346*^9}, {
   3.486719403502572*^9, 3.486719404123908*^9}, {3.4973642921097937`*^9, 
   3.497364297163127*^9}, {3.497371897761854*^9, 3.497371906743175*^9}, {
   3.49737232158766*^9, 3.4973723346500463`*^9}, 3.497529619779294*^9, 
   3.497572546269267*^9, {3.506694571364847*^9, 3.506694574619191*^9}, {
   3.50676066374996*^9, 3.506760689656033*^9}, {3.5067668601939793`*^9, 
   3.506766861670865*^9}, 3.506767076536017*^9, {3.5067753444118958`*^9, 
   3.506775349337023*^9}, {3.506794750324267*^9, 3.50679476197094*^9}, 
   3.5068552391541147`*^9, 3.50685540941826*^9, {3.50712640599798*^9, 
   3.507126420035283*^9}, {3.5071285226083727`*^9, 3.507128534709289*^9}, {
   3.5072759370082808`*^9, 3.5072759384319563`*^9}, {3.507571622270445*^9, 
   3.5075716295419292`*^9}, {3.508583070814494*^9, 3.508583079551385*^9}, 
   3.5085831257459*^9, {3.508584092301716*^9, 3.508584116149168*^9}, {
   3.508584165855364*^9, 3.508584166935214*^9}, 3.508609688184823*^9, {
   3.508673942173622*^9, 3.508673942722736*^9}, {3.508681447965564*^9, 
   3.508681455651271*^9}, {3.508681808863309*^9, 3.508681809524273*^9}, {
   3.509187475972389*^9, 3.5091874863682537`*^9}, 3.509187572766778*^9, {
   3.509202710447878*^9, 3.509202713244726*^9}, 3.50920275639815*^9, 
   3.509456901722925*^9, {3.509458294721397*^9, 3.509458300182678*^9}, {
   3.5104897434595137`*^9, 3.5104897556279583`*^9}, {3.5148764613531857`*^9, 
   3.5148764622118397`*^9}, 3.515004308085532*^9, 3.515004360424423*^9, 
   3.515078115971826*^9, {3.533177158503834*^9, 3.533177162699546*^9}, {
   3.534399058676367*^9, 3.5343990645072727`*^9}, {3.539112680722073*^9, 
   3.539112681512909*^9}, 3.543413759248107*^9, 3.5434989374615183`*^9, 
   3.545050561058374*^9, {3.572539894675764*^9, 3.5725398982129307`*^9}, {
   3.6260277162778673`*^9, 3.626027716941956*^9}, {3.657712903551982*^9, 
   3.6577129097977*^9}, {3.702816071150379*^9, 3.702816072340538*^9}, {
   3.703082532778181*^9, 3.7030825455365334`*^9}, {3.709375525012845*^9, 
   3.7093755256093388`*^9}, {3.709387217297209*^9, 3.709387218485963*^9}, {
   3.721764466735124*^9, 3.721764515985629*^9}, {3.721764987162115*^9, 
   3.7217649886473846`*^9}, {3.721778102712504*^9, 3.721778104958108*^9}, {
   3.7218617045697727`*^9, 3.721861705770383*^9}, 3.721887083176839*^9, {
   3.7218871198157377`*^9, 3.7218871207421503`*^9}, {3.72188717773267*^9, 
   3.7218872198338137`*^9}, {3.7455083879809637`*^9, 
   3.7455083887862167`*^9}},ExpressionUUID->"5f421a6e-8bc7-4cc9-a938-\
ba3346754f8f"]
}, Closed]],

Cell[CellGroupData[{

Cell["attributes", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469894351830557*^9, 3.469894355180109*^9}, 
   3.470141044562385*^9},ExpressionUUID->"0b268c22-7e01-4437-b293-\
83d38fc1e48b"],

Cell["\<\
HoldAll is needed to allow implementation of EnsembleAverage, the iterators, \
and checking of the polarization operators\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.469896600541757*^9, 3.4698966136273127`*^9}, {
   3.502883935209774*^9, 3.5028839362384663`*^9}, 3.5316513563546267`*^9, {
   3.683219583707953*^9, 3.683219586501233*^9}, {3.709387235018564*^9, 
   3.709387252116486*^9}, 
   3.721754734641655*^9},ExpressionUUID->"28129bbc-48c2-4ccd-87ab-\
d0646d51cc60"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"TransformationAmplitudeTable", ",", "HoldAll"}], "]"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4698943573427773`*^9, 3.469894367696088*^9}, 
   3.506692150083893*^9, 3.506760713626753*^9, {3.509284598709249*^9, 
   3.509284599881653*^9}, 3.509456888329686*^9, 3.531651357297093*^9, 
   3.709387231697034*^9, {3.721775598710197*^9, 3.721775599299631*^9}, 
   3.721856805081901*^9},
 CellLabel->
  "In[1925]:=",ExpressionUUID->"1475746e-0da8-417b-b230-a2c27e3606e1"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["prelude", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699967260343471*^9, {3.722053214664496*^9, 3.7220532200010366`*^9}, 
   3.722053471964946*^9, {3.722053502408568*^9, 3.72205350480744*^9}, {
   3.722053548226399*^9, 
   3.72205354882628*^9}},ExpressionUUID->"9b801f42-aa3e-47f0-9cf1-\
921162f33a0b"],

Cell[CellGroupData[{

Cell["traps", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.6999576793161383`*^9, 3.699957682623167*^9}, {
   3.69995837404912*^9, 3.699958377592299*^9}, {3.699967314659217*^9, 
   3.69996732698726*^9}, {3.721755437564663*^9, 3.7217554392598343`*^9}, {
   3.721755487379294*^9, 3.721755489697517*^9}, {3.722053233901409*^9, 
   3.722053235049282*^9}},ExpressionUUID->"59106b80-f0d1-44f0-963a-\
40175e994866"],

Cell[CellGroupData[{

Cell["$Failed trap", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683958534614377*^9, 3.683958551028832*^9}, {
   3.68395858577393*^9, 3.6839585874144278`*^9}, 3.683959406338385*^9, {
   3.683963242982894*^9, 3.6839632443419228`*^9}, {3.683964445776389*^9, 
   3.683964455294318*^9}, {3.683983901941537*^9, 3.6839839032008667`*^9}, {
   3.700566501467436*^9, 
   3.7005665022666397`*^9}},ExpressionUUID->"32b20361-c342-47b1-939f-\
6a7c455e6403"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TransformationAmplitudeTable", "[", 
     RowBox[{
      RowBox[{"Evaluate", "@", "GeneralStatusListPattern"}], ",", "args___"}],
      "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"Hold", "@", 
        RowBox[{"{", "args", "}"}]}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683983914149064*^9, 3.6839839305516777`*^9}, 
   3.6850335693888206`*^9, 3.699957835020547*^9, {3.7004890118870163`*^9, 
   3.70048902834022*^9}, {3.700489149274678*^9, 3.7004891505765*^9}, {
   3.700565404281258*^9, 3.700565407769747*^9}, {3.700566488876607*^9, 
   3.700566491048864*^9}, 3.700572254982481*^9, 3.700573232051622*^9, 
   3.721755166189555*^9, {3.721857228215165*^9, 3.7218572318601723`*^9}},
 CellLabel->
  "In[1926]:=",ExpressionUUID->"62655dc5-e99f-4f9b-9029-515de8138e19"]
}, Closed]],

Cell[CellGroupData[{

Cell["general syntax checking", "Subsubsection",
 CellChangeTimes->{{3.721755257829026*^9, 3.721755269084174*^9}, {
  3.72175545354712*^9, 3.721755467634141*^9}, {3.7220523608727627`*^9, 
  3.7220523700185738`*^9}},ExpressionUUID->"3d344252-1d94-4a7b-8429-\
4bbe0a86e811"],

Cell["trap an incorrect placing of Rule", "Text",
 CellChangeTimes->{{3.722052453368568*^9, 
  3.722052465315625*^9}},ExpressionUUID->"885007e5-24e7-4345-aa2b-\
ff660f0c81c6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{"Except", "[", "GeneralStatusListPattern", "]"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Except", "[", "_Rule", "]"}], ".."}], ",", "_Rule", ",", "___",
      ",", 
     RowBox[{"Except", "[", "_Rule", "]"}], ",", "___"}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"TransformationAmplitudeTable", "::", "badsyntax"}], "]"}], ";",
      "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.722052376439558*^9, 3.7220524908650227`*^9}, {
  3.722053797985751*^9, 3.7220538542992277`*^9}},
 CellLabel->
  "In[1927]:=",ExpressionUUID->"502e2bbe-155d-4a64-bb35-f069e751d2b7"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["wrap symbols in Hold", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.6999576793161383`*^9, 3.699957682623167*^9}, {
   3.69995837404912*^9, 3.699958377592299*^9}, {3.699967314659217*^9, 
   3.69996732698726*^9}, {3.721755437564663*^9, 3.7217554392598343`*^9}, {
   3.721755487379294*^9, 3.721755489697517*^9}, {3.722053233901409*^9, 
   3.7220532967837133`*^9}},ExpressionUUID->"2d81471c-48ba-4ec3-a532-\
f5123d4a423a"],

Cell["\<\
needed to allow symbol substitution and handling of multidimensional \
variables in EnsembleAverage\
\>", "Text",
 CellChangeTimes->{{3.722053305582299*^9, 3.7220533155303793`*^9}, {
  3.722053418219347*^9, 
  3.722053432883181*^9}},ExpressionUUID->"767b92ed-d00e-48d9-8bc9-\
294a5b3cbd0b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{"arg", ":", 
       RowBox[{"Except", "[", "GeneralStatusListPattern", "]"}]}], "]"}], ",",
      "moreA___", ",", 
     RowBox[{"BackgroundGenerator", "\[Rule]", " ", "backg_"}], ",", 
     "moreB___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{"False", ",", "arg", ",", "moreA", ",", 
     RowBox[{"BackgroundGenerator", "\[Rule]", " ", 
      RowBox[{"Hold", "[", "backg", "]"}]}], ",", "moreB"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958380154027*^9, 3.6999584815554132`*^9}, {
   3.699959772469471*^9, 3.699959793223897*^9}, 3.69995998791234*^9, {
   3.699962032492901*^9, 3.699962033672257*^9}, {3.700489087209752*^9, 
   3.70048913507517*^9}, {3.700565459147201*^9, 3.700565461704858*^9}, {
   3.7005664849261103`*^9, 3.7005664870277843`*^9}, 3.700572249823097*^9, 
   3.700573227435656*^9, {3.7027974893302355`*^9, 3.7027975561033072`*^9}, {
   3.702797620390955*^9, 3.7027976388289504`*^9}, {3.702798354048998*^9, 
   3.7027984113896713`*^9}, {3.7093755333830423`*^9, 3.709375534182023*^9}, {
   3.721755117001544*^9, 3.7217551465889883`*^9}, 3.721755219451017*^9, {
   3.7217745489981127`*^9, 3.721774552851432*^9}, {3.7217746087314568`*^9, 
   3.721774610491249*^9}, {3.721774667183178*^9, 3.721774669253531*^9}, 
   3.721774990142713*^9},
 CellLabel->
  "In[1928]:=",ExpressionUUID->"5fa857f0-9766-4ff4-8d41-4f201a3cfb97"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{"arg", ":", 
       RowBox[{"Except", "[", "GeneralStatusListPattern", "]"}]}], "]"}], ",",
      "moreA___", ",", 
     RowBox[{"TableCoordinates", "\[Rule]", " ", "tabcoord_"}], ",", 
     "moreB___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{"False", ",", "arg", ",", "moreA", ",", 
     RowBox[{"TableCoordinates", "\[Rule]", " ", 
      RowBox[{"Hold", "[", "tabcoord", "]"}]}], ",", "moreB"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958380154027*^9, 3.6999584815554132`*^9}, {
   3.699959772469471*^9, 3.699959793223897*^9}, 3.69995998791234*^9, {
   3.699962032492901*^9, 3.699962033672257*^9}, {3.700489087209752*^9, 
   3.70048913507517*^9}, {3.700565459147201*^9, 3.700565461704858*^9}, {
   3.7005664849261103`*^9, 3.7005664870277843`*^9}, 3.700572249823097*^9, 
   3.700573227435656*^9, {3.7027974893302355`*^9, 3.7027975561033072`*^9}, {
   3.702797620390955*^9, 3.7027976388289504`*^9}, {3.702798354048998*^9, 
   3.7027984113896713`*^9}, {3.7093755333830423`*^9, 3.709375534182023*^9}, {
   3.721755117001544*^9, 3.7217551465889883`*^9}, {3.721755219451017*^9, 
   3.7217552480076227`*^9}, {3.7217745554749947`*^9, 3.721774559275668*^9}, {
   3.721774602467104*^9, 3.721774604617373*^9}, {3.72177477670621*^9, 
   3.7217747798001328`*^9}, 3.721774987550267*^9},
 CellLabel->
  "In[1929]:=",ExpressionUUID->"a32e5461-8638-4fd6-baa3-dace1f081853"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["status flags", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699967260343471*^9, {3.722053214664496*^9, 3.7220532200010366`*^9}, {
   3.722053280508946*^9, 3.722053281354823*^9}, {3.722053562258954*^9, 
   3.722053563252039*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"6b24c118-724a-4b00-8ef7-f6faef115fc7"],

Cell[CellGroupData[{

Cell["syntax", "Section",
 CellChangeTimes->{{3.700297621581056*^9, 3.7002976227883387`*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"5f507f57-9d95-4588-aefc-3587f8f8b6b9"],

Cell["\<\
status:{
1. <Chronology>
2. <InputRule>
3. <iterators>\[LineSeparator]4.<TableCoordinates>,\[LineSeparator]5.<\
EnsembleAverage>,\[LineSeparator]6.<NormalizationFactor>,\[LineSeparator]7. \
<BackgroundGenerator>,\[LineSeparator]8. <InitialDensityOperator>,\
\[LineSeparator]9. <Observables>
10.<Events>
11. <Precalculation>
12. <UserLevel>
13.<Ready>
}\
\>", "Text",
 CellChangeTimes->{{3.689409839714465*^9, 3.689409859202746*^9}, {
   3.6999581143942537`*^9, 3.699958263807562*^9}, {3.699962603269265*^9, 
   3.699962621819932*^9}, 3.699963887599286*^9, {3.699964901802113*^9, 
   3.699964932726914*^9}, {3.699964975344315*^9, 3.699964975983858*^9}, {
   3.6999665398265333`*^9, 3.699966540522017*^9}, {3.70029757547184*^9, 
   3.700297616436632*^9}, {3.700297696082258*^9, 3.700297696600065*^9}, {
   3.700323347837442*^9, 3.700323358616118*^9}, {3.700571398427099*^9, 
   3.7005714040563297`*^9}, {3.701092857308374*^9, 3.701092879229843*^9}, {
   3.7217547857425537`*^9, 3.7217547866139517`*^9}, {3.721754831635726*^9, 
   3.721754915503562*^9}, 3.72175494616641*^9, {3.72175564929993*^9, 
   3.7217556826868467`*^9}, {3.721755835959484*^9, 3.721755839852759*^9}, 
   3.721755874886621*^9, 3.7217561327432404`*^9, {3.7217563246864643`*^9, 
   3.721756329191581*^9}, 3.721756395877213*^9, 3.72175646711969*^9, 
   3.7217565528359547`*^9, 3.721757183888377*^9, {3.721757246970799*^9, 
   3.721757270136608*^9}, {3.721757418716744*^9, 3.72175742054029*^9}, {
   3.7217578259446907`*^9, 3.721757835863649*^9}, {3.7218005968803787`*^9, 
   3.721800616860139*^9}, {3.721861602209313*^9, 3.721861613668989*^9}, 
   3.721864679498011*^9, {3.74550842807642*^9, 
   3.745508437337023*^9}},ExpressionUUID->"d9256be1-6958-4814-b498-\
2212d102e58a"],

Cell["when all flags are True, the overall status is set to True. ", "Text",
 CellChangeTimes->{{3.689409869650942*^9, 3.6894098789918537`*^9}, {
  3.699958073882622*^9, 3.699958084660014*^9}, {3.699958278423551*^9, 
  3.699958326909779*^9}},ExpressionUUID->"0de8b211-135f-4645-99c4-\
107b56867727"]
}, Closed]],

Cell[CellGroupData[{

Cell["initialization", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.6999576793161383`*^9, 3.699957682623167*^9}, {
   3.69995837404912*^9, 3.699958377592299*^9}, {3.699967314659217*^9, 
   3.69996732698726*^9}, {3.721755437564663*^9, 3.7217554392598343`*^9}, {
   3.721755487379294*^9, 3.721755489697517*^9}, {3.722052958933054*^9, 
   3.722052963743114*^9}, 3.7220533419830437`*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"164c8f06-6259-448e-b0b4-bd3d153ab48e"],

Cell[CellGroupData[{

Cell["initialize global status", "Subsection",
 CellChangeTimes->{{3.721755257829026*^9, 3.72175528429959*^9}, {
  3.722053061369829*^9, 3.7220530701666317`*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"5ac3c095-b9d1-4197-8c0a-8f1fe0577000"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusDimension", "[", "TransformationAmplitudeTable", "]"}], "=",
    "13"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999583403975887`*^9, 3.699958356036769*^9}, {
   3.701092633684363*^9, 3.70109263380866*^9}, 3.701092903635845*^9, {
   3.72175531673285*^9, 3.721755321475318*^9}, {3.721755707999535*^9, 
   3.721755708125235*^9}, 3.721757858638781*^9, 3.721861689826372*^9, 
   3.7218647142650137`*^9, 
   3.745508515905402*^9},ExpressionUUID->"c07bff71-a55b-4d52-a311-\
885cb3e88428"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "[", 
      RowBox[{"arg", ":", 
       RowBox[{"Except", "[", "GeneralStatusListPattern", "]"}]}], "]"}], ",",
      "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{"False", ",", "arg", ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958380154027*^9, 3.6999584815554132`*^9}, {
   3.699959772469471*^9, 3.699959793223897*^9}, 3.69995998791234*^9, {
   3.699962032492901*^9, 3.699962033672257*^9}, {3.700489087209752*^9, 
   3.70048913507517*^9}, {3.700565459147201*^9, 3.700565461704858*^9}, {
   3.7005664849261103`*^9, 3.7005664870277843`*^9}, 3.700572249823097*^9, 
   3.700573227435656*^9, {3.7027974893302355`*^9, 3.7027975561033072`*^9}, {
   3.702797620390955*^9, 3.7027976388289504`*^9}, {3.702798354048998*^9, 
   3.7027984113896713`*^9}, {3.7093755333830423`*^9, 3.709375534182023*^9}, {
   3.721755117001544*^9, 3.7217551465889883`*^9}, 3.721755219451017*^9, {
   3.721774529671377*^9, 3.721774532571965*^9}, {3.7217748781650143`*^9, 
   3.721774880938284*^9}, {3.721774942967628*^9, 3.72177494915154*^9}},
 CellLabel->
  "In[1931]:=",ExpressionUUID->"e5d9f848-1cb4-4735-9700-b750314128b0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{"False", ",", "items___", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"Table", "[", 
       RowBox[{"False", ",", 
        RowBox[{"{", 
         RowBox[{
         "StatusDimension", "[", "TransformationAmplitudeTable", "]"}], 
         "}"}]}], "]"}]}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700566324922236*^9, 3.700566329608988*^9}, {
   3.700566384439968*^9, 3.700566384781948*^9}, {3.70109538631076*^9, 
   3.701095451635306*^9}, {3.701095624695593*^9, 3.701095624965757*^9}, {
   3.701095712124366*^9, 3.701095712359507*^9}, 3.721755412408339*^9, 
   3.7217555415616693`*^9, {3.721775221362338*^9, 3.721775227583768*^9}, 
   3.721775812187272*^9, {3.7218575802211447`*^9, 3.721857581867342*^9}},
 CellLabel->
  "In[1932]:=",ExpressionUUID->"42357887-9181-4378-aba4-8c0cefea8ae1"]
}, Closed]],

Cell[CellGroupData[{

Cell["initialize individual categories", "Subsection",
 CellChangeTimes->{{3.699960043090076*^9, 3.699960055700795*^9}, {
  3.701095115014482*^9, 3.701095116885454*^9}, {3.722053025374083*^9, 
  3.722053031569543*^9}, {3.7220530811653013`*^9, 3.722053083064291*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"c4f3970c-601b-4cac-b98e-10b23a83d46c"],

Cell[CellGroupData[{

Cell["1. Chronology", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.699965078900024*^9, 
   3.699965079215186*^9}, 3.6999673551934147`*^9, 
   3.721757169016224*^9},ExpressionUUID->"25df8f39-4008-4d36-910a-\
af2de43b297a"],

Cell["<Chronology>={< request >, <valid>, <standardized>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.700312985944944*^9, 
   3.700312998460401*^9}, 
   3.7217571737693*^9},ExpressionUUID->"27919a99-261b-4ae8-9455-a9bacf75e294"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Chronology\>\""}], 
    "]"}], "=", "1"}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Chronology\>\""}], 
    "]"}], "=", "3"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, 3.699961074484026*^9, 
   3.700313001577042*^9, {3.721755724047927*^9, 3.721755725638839*^9}},
 CellLabel->
  "In[1933]:=",ExpressionUUID->"a2f8f222-41ec-4907-a870-13f580984a14"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", "False"}], ",", "morest___"}], "}"}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitudeTable", ",", "\"\<Chronology\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.6999610036889277`*^9, 3.699961014575673*^9}, {3.6999610780148363`*^9, 
   3.699961104711626*^9}, {3.7217557388445168`*^9, 3.7217557441257963`*^9}},
 CellLabel->
  "In[1934]:=",ExpressionUUID->"dce7785f-dffc-4686-ba94-34f56ac8d305"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}]}], ",", "morest___"}], "}"}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ",", "morest"}], "}"}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
  3.6999608074403543`*^9, 3.699960815796681*^9}, {3.6999610219694366`*^9, 
  3.699961036648464*^9}, {3.69996108777975*^9, 3.699961119876425*^9}, {
  3.7217557508373833`*^9, 3.72175575362092*^9}},
 CellLabel->
  "In[1935]:=",ExpressionUUID->"c37ab526-a3ba-463c-857f-ed163a625b0c"]
}, Closed]],

Cell[CellGroupData[{

Cell["2. InputRule", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699965076323723*^9, 3.699965076616291*^9}, 
   3.699967358600157*^9, {3.7010871278610983`*^9, 3.701087133313622*^9}, {
   3.7217558425899963`*^9, 3.7217558477177*^9}, 
   3.721755982164069*^9},ExpressionUUID->"a7c0d1e7-97e5-4cc9-ab21-\
d4bc0b980dde"],

Cell["<InputRule>={<request>, <implement>,<check>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
  3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
  3.6999607626383677`*^9}, {3.700482091706748*^9, 3.700482094792623*^9}, {
  3.701087144827612*^9, 3.701087174743593*^9}, {3.701087635307239*^9, 
  3.7010876670777807`*^9}, {3.721755773212618*^9, 3.721755804928439*^9}, {
  3.721755850173799*^9, 3.721755871560854*^9}, {3.721763072800804*^9, 
  3.721763077118885*^9}, {3.7217636927760067`*^9, 
  3.721763699693534*^9}},ExpressionUUID->"7baa1f42-dcd2-4e82-a438-\
96128845b098"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], "]"}],
    "=", "2"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], "]"}],
    "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], "]"}],
    "=", "3"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.700303595564148*^9, 3.7003035998204327`*^9}, 3.700482089116626*^9, 
   3.700482467483755*^9, 3.7010871991145077`*^9, {3.7010918955891333`*^9, 
   3.701091895923306*^9}, 3.7217558210667477`*^9, {3.721755855166141*^9, 
   3.7217559125588903`*^9}, 3.7217633440806227`*^9},
 CellLabel->
  "In[1936]:=",ExpressionUUID->"6d0d85c2-aea4-496c-a8b4-4af206416dd2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], "]"}],
            "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.721755925141917*^9, 3.721755946707847*^9}, 3.721775824730948*^9},
 CellLabel->
  "In[1937]:=",ExpressionUUID->"5840597c-c4df-4727-acef-c99fb297e599"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
  3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
  3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, {
  3.7217559552436457`*^9, 3.7217559690174837`*^9}},
 CellLabel->
  "In[1938]:=",ExpressionUUID->"602542f8-eb54-43a7-b209-8e057c8fabb3"]
}, Closed]],

Cell[CellGroupData[{

Cell["3. Iterators", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699965073365028*^9, 3.6999650736913357`*^9}, 3.699967361469036*^9, 
   3.7003021035556297`*^9, {3.721755990952639*^9, 
   3.721755992454547*^9}},ExpressionUUID->"acd379c3-35f4-43d5-a06a-\
f2a8c5e6b0a8"],

Cell["\<\
<Iterators>={<request set up>, <combine>,<determine iter vars>,<check \
validity>,<standardize>,<done>}\
\>", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963444005171*^9, 3.699963456637158*^9}, {3.7003022890388412`*^9, 
   3.700302295447094*^9}, 3.700313742540327*^9, 3.7003140655501223`*^9, {
   3.72175600598464*^9, 3.721756019103134*^9}, {3.721763953423211*^9, 
   3.7217640400677013`*^9}, {3.721764596903632*^9, 3.721764598037333*^9}, {
   3.7217653843017673`*^9, 
   3.721765399826581*^9}},ExpressionUUID->"7e091a8a-87c3-48de-a85d-\
49174a1f244c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], "]"}],
    "=", "3"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], "]"}],
    "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], "]"}],
    "=", "6"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.700302272106821*^9, 
   3.7003022762645483`*^9}, {3.700303611630294*^9, 3.7003036144675627`*^9}, 
   3.7003051749205103`*^9, 3.700306573104793*^9, 3.7003066802353277`*^9, 
   3.700313745474448*^9, 3.700314068763255*^9, 3.700329310634688*^9, {
   3.721756033535726*^9, 3.721756054636475*^9}, 3.721764055346573*^9, 
   3.721765405354843*^9},
 CellLabel->
  "In[1939]:=",ExpressionUUID->"17c70e7c-4794-413b-a440-964e236712bd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], "]"}],
            "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.700302278185021*^9, 
   3.7003022799214697`*^9}, {3.721756061918919*^9, 3.721756079300571*^9}},
 CellLabel->
  "In[1940]:=",ExpressionUUID->"38640821-920d-4ba2-a65c-08f00b2da5d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.700302281832322*^9, {3.721756086092648*^9, 
   3.721756095316222*^9}},
 CellLabel->
  "In[1941]:=",ExpressionUUID->"52d5ac40-4b17-4bcf-b3c1-dc1f4357a42a"]
}, Closed]],

Cell[CellGroupData[{

Cell["4. TableCoordinates", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}},ExpressionUUID->"4294ce17-76a1-47c2-95aa-\
216bda6a9584"],

Cell["\<\
<TableCoordinates>={<request set up>, <standardize>, <implement>,<check>}\
\>", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.721770540572309*^9, 3.721770553328949*^9}, {
   3.7217716086087027`*^9, 3.721771618928801*^9}, {3.7217717140593653`*^9, 
   3.721771719425559*^9}, {3.721784596792137*^9, 
   3.721784622761429*^9}},ExpressionUUID->"a9e2c2da-6387-4dc4-a653-\
671ec330bb60"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<TableCoordinates\>\""}],
     "]"}], "=", "4"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<TableCoordinates\>\""}],
     "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{
        "TransformationAmplitudeTable", ",", "\"\<TableCoordinates\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<TableCoordinates\>\""}],
     "]"}], "=", "4"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, 3.721770564371181*^9, 3.7217716275946293`*^9},
 CellLabel->
  "In[1942]:=",ExpressionUUID->"b612f91a-75d7-42d5-9304-8789cd2f9f3d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<TableCoordinates\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitudeTable", ",", "\"\<TableCoordinates\>\""}],
             "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}},
 CellLabel->
  "In[1943]:=",ExpressionUUID->"ae6d947b-3bb0-4581-a20d-1e5390f5f1d1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<TableCoordinates\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}},
 CellLabel->
  "In[1944]:=",ExpressionUUID->"6db3e8b3-8f8c-419d-9044-57ce94847f35"]
}, Closed]],

Cell[CellGroupData[{

Cell["5. EnsembleAverage", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 
   3.721756261098542*^9}},ExpressionUUID->"4c18639e-9c66-4008-910c-\
25e79c4daf25"],

Cell["\<\
<EnsembleAverage>={< request set up >, <standardized>, <multiDvars expanded>}\
\
\>", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, 3.7217845912657022`*^9, 
   3.7217846310243273`*^9},ExpressionUUID->"0da3f960-5409-45e3-bb55-\
70b35ba0bd81"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<EnsembleAverage\>\""}], 
    "]"}], "=", "5"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<EnsembleAverage\>\""}], 
    "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{
        "TransformationAmplitudeTable", ",", "\"\<EnsembleAverage\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<EnsembleAverage\>\""}], 
    "]"}], "=", "3"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, 
   3.721784604664185*^9},
 CellLabel->
  "In[1945]:=",ExpressionUUID->"2ce7ff4c-feff-460d-aa08-331592699985"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<EnsembleAverage\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitudeTable", ",", "\"\<EnsembleAverage\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}},
 CellLabel->
  "In[1946]:=",ExpressionUUID->"27c051ec-e2e0-4050-bf89-1a5f668c8fdb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<EnsembleAverage\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9},
 CellLabel->
  "In[1947]:=",ExpressionUUID->"12d2674e-f213-4581-8517-97e7692d9d1c"]
}, Closed]],

Cell[CellGroupData[{

Cell["6. NormalizationFactor", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 
   3.7217563186931353`*^9}},ExpressionUUID->"6054158c-63c2-4017-ba35-\
68700799d8e6"],

Cell["<normfac>={< request set up >, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.7217975898495502`*^9, 
   3.721797591007513*^9}},ExpressionUUID->"b193157c-6eb1-4fb7-8f1a-\
6fca9ae61883"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{
    "TransformationAmplitudeTable", ",", "\"\<NormalizationFactor\>\""}], 
    "]"}], "=", "6"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{
    "TransformationAmplitudeTable", ",", "\"\<NormalizationFactor\>\""}], 
    "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{
        "TransformationAmplitudeTable", ",", "\"\<NormalizationFactor\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{
    "TransformationAmplitudeTable", ",", "\"\<NormalizationFactor\>\""}], 
    "]"}], "=", "2"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}},
 CellLabel->
  "In[1948]:=",ExpressionUUID->"8739a29f-7dbb-44a8-b396-dce94d2d65f7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", 
           "\"\<NormalizationFactor\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitudeTable", ",", 
             "\"\<NormalizationFactor\>\""}], "]"}], "}"}]}], "]"}], ",", 
        "morest"}], "}"}]}], ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}},
 CellLabel->
  "In[1949]:=",ExpressionUUID->"021c0af4-259b-41d4-a7bc-9e111ab9a5f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", 
           "\"\<NormalizationFactor\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9},
 CellLabel->
  "In[1950]:=",ExpressionUUID->"1a237d54-d786-46fb-85d6-3304613e2fea"]
}, Closed]],

Cell[CellGroupData[{

Cell["7. BackgroundGenerator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}},ExpressionUUID->"1cd67d3b-650a-4dee-b280-\
dd9e72f85c62"],

Cell["<backg>={<request set up>,<stand>,<diag>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.7217975848005323`*^9, 3.721797625621028*^9}, 
   3.721799531633738*^9},ExpressionUUID->"071e8690-def6-49c4-b52e-\
823cddee467a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{
    "TransformationAmplitudeTable", ",", "\"\<BackgroundGenerator\>\""}], 
    "]"}], "=", "7"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{
    "TransformationAmplitudeTable", ",", "\"\<BackgroundGenerator\>\""}], 
    "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{
        "TransformationAmplitudeTable", ",", "\"\<BackgroundGenerator\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{
    "TransformationAmplitudeTable", ",", "\"\<BackgroundGenerator\>\""}], 
    "]"}], "=", "3"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, 3.7217976306720133`*^9, 3.7217995346073933`*^9},
 CellLabel->
  "In[1951]:=",ExpressionUUID->"2b8645bc-4b2b-4f2c-8bde-9fe9e08a5d85"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", 
           "\"\<BackgroundGenerator\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitudeTable", ",", 
             "\"\<BackgroundGenerator\>\""}], "]"}], "}"}]}], "]"}], ",", 
        "morest"}], "}"}]}], ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}},
 CellLabel->
  "In[1952]:=",ExpressionUUID->"170df02c-3cf9-4c61-9103-de4da054d4b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", 
           "\"\<BackgroundGenerator\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9},
 CellLabel->
  "In[1953]:=",ExpressionUUID->"f632503b-245b-49e0-b80c-bf5881a02cb9"]
}, Closed]],

Cell[CellGroupData[{

Cell["8. InitialDensityOperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, {3.7217564508871813`*^9, 
   3.7217564568857813`*^9}},ExpressionUUID->"81fd063a-8424-4986-a2d2-\
6932e1dcb647"],

Cell["<prep>={<request set up>, <check>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.721799667957322*^9, 
   3.721799680810709*^9}},ExpressionUUID->"a6c75492-0aea-4ccc-afd5-\
ce7d4845521f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{
    "TransformationAmplitudeTable", ",", "\"\<InitialDensityOperator\>\""}], 
    "]"}], "=", "8"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{
    "TransformationAmplitudeTable", ",", "\"\<InitialDensityOperator\>\""}], 
    "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{
        "TransformationAmplitudeTable", ",", 
         "\"\<InitialDensityOperator\>\""}], "]"}], "-", "1"}], "}"}]}], 
    "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{
    "TransformationAmplitudeTable", ",", "\"\<InitialDensityOperator\>\""}], 
    "]"}], "=", "2"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, {3.7217564769697237`*^9, 3.7217564899578247`*^9}},
 
 CellLabel->
  "In[1954]:=",ExpressionUUID->"79394b3b-38f0-4b99-ab0a-e49cf376b180"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", 
           "\"\<InitialDensityOperator\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitudeTable", ",", 
             "\"\<InitialDensityOperator\>\""}], "]"}], "}"}]}], "]"}], ",", 
        "morest"}], "}"}]}], ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.721756497150454*^9, 3.721756500397401*^9}},
 CellLabel->
  "In[1955]:=",ExpressionUUID->"f6801917-901d-4032-877e-80fd3cd0dde7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", 
           "\"\<InitialDensityOperator\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, 3.7217565039662046`*^9},
 CellLabel->
  "In[1956]:=",ExpressionUUID->"6c01a436-9d01-42a6-a783-22a28b7d288b"]
}, Closed]],

Cell[CellGroupData[{

Cell["9. Observables", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, {3.7217564508871813`*^9, 3.7217564568857813`*^9}, {
   3.721756520611273*^9, 3.721756540319769*^9}, {3.721757376492264*^9, 
   3.721757395181261*^9}, 3.72175742722253*^9, {3.7218005835424547`*^9, 
   3.721800583989327*^9}},ExpressionUUID->"22a50a5d-d9ab-40e1-a03d-\
48ab056ae14c"],

Cell["\<\
<Observables>={<request>,<standardize>,<check for nonrig\[Rho]>,<operator \
form>}\
\>", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.7217574010409193`*^9, 3.721757403225362*^9}, {
   3.721800489962534*^9, 3.721800503020648*^9}, {3.721800777560731*^9, 
   3.721800785174819*^9}, {3.721801594231718*^9, 3.721801599700938*^9}, {
   3.721801980939446*^9, 
   3.7218019921883163`*^9}},ExpressionUUID->"7a034127-cd55-4e6c-b7cd-\
494a1f85ccb0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Observables\>\""}], 
    "]"}], "=", "9"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Observables\>\""}], 
    "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitudeTable", ",", "\"\<Observables\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Observables\>\""}], 
    "]"}], "=", "4"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, {3.7217564769697237`*^9, 
   3.7217564899578247`*^9}, {3.721756563781021*^9, 3.72175657523405*^9}, {
   3.721757432356854*^9, 3.721757440518906*^9}, 3.72180063938231*^9, 
   3.72180078871417*^9, 3.721801605262192*^9},
 CellLabel->
  "In[1957]:=",ExpressionUUID->"60b18bb9-0895-4e80-beb0-06adc6f9572b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<Observables\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitudeTable", ",", "\"\<Observables\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.721756497150454*^9, 3.721756500397401*^9}, {3.721756582107078*^9, 
   3.721756585825021*^9}, {3.721757443199085*^9, 3.721757445870673*^9}},
 CellLabel->
  "In[1958]:=",ExpressionUUID->"09fa74c7-339d-45c3-b159-e795f87d89e5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<Observables\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, 3.7217565039662046`*^9, 3.721756589336817*^9, 
   3.721757449230076*^9},
 CellLabel->
  "In[1959]:=",ExpressionUUID->"bcdd7841-6e18-44c7-8d88-3850c36e2059"]
}, Closed]],

Cell[CellGroupData[{

Cell["10. Events", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, {3.7217564508871813`*^9, 3.7217564568857813`*^9}, {
   3.721756520611273*^9, 3.721756540319769*^9}, {3.721757376492264*^9, 
   3.721757395181261*^9}, 3.72175742722253*^9, {3.7217578042789497`*^9, 
   3.721757820461225*^9}, 3.721800629931551*^9},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"41d7a5ee-d1fb-473b-b417-d6561ff62512"],

Cell["<prep>={<request>, <insert null>,<PulseSequence>,<check>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.7217574010409193`*^9, 3.721757403225362*^9}, {
   3.721776980547686*^9, 3.721776990089419*^9}, {3.721777635903672*^9, 
   3.721777642406269*^9}, 
   3.744352632882736*^9},ExpressionUUID->"a1ef7e8e-7dca-4ac4-b869-\
9d92c5c89bdd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}], "]"}], 
   "=", "10"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}], "]"}], 
   "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}], "]"}], 
   "=", "4"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, {3.7217564769697237`*^9, 
   3.7217564899578247`*^9}, {3.721756563781021*^9, 3.72175657523405*^9}, {
   3.721757432356854*^9, 3.721757440518906*^9}, {3.721757878319634*^9, 
   3.7217578842844067`*^9}, 3.7217769950278473`*^9, {3.721800645102062*^9, 
   3.721800645219689*^9}, 
   3.7443526001244907`*^9},ExpressionUUID->"1904edfe-d5ea-4f69-b60d-\
318a0dd1981d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.721756497150454*^9, 3.721756500397401*^9}, {3.721756582107078*^9, 
   3.721756585825021*^9}, {3.721757443199085*^9, 3.721757445870673*^9}, {
   3.721757890469747*^9, 3.7217578922437963`*^9}},
 CellLabel->
  "In[1961]:=",ExpressionUUID->"c293a912-ad00-4423-a81f-5925425031af"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, 3.7217565039662046`*^9, 3.721756589336817*^9, 
   3.721757449230076*^9, {3.721757895652873*^9, 3.721757898084654*^9}},
 CellLabel->
  "In[1962]:=",ExpressionUUID->"cd743acd-2220-4ddf-864a-6ec596f2f7f2"]
}, Closed]],

Cell[CellGroupData[{

Cell["11. Precalculation", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, {3.7217564508871813`*^9, 3.7217564568857813`*^9}, {
   3.721756520611273*^9, 3.721756540319769*^9}, {3.72180058691722*^9, 
   3.721800587053234*^9}, 
   3.721800628036878*^9},ExpressionUUID->"1234dd93-7b5b-451d-93be-\
1bc031c40571"],

Cell["<prep>={< request set up >, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}},ExpressionUUID->"77e0d30c-038c-4d03-beaf-\
d8cecf913c42"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Precalculation\>\""}], 
    "]"}], "=", "11"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Precalculation\>\""}], 
    "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{
        "TransformationAmplitudeTable", ",", "\"\<Precalculation\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Precalculation\>\""}], 
    "]"}], "=", "2"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, {3.7217564769697237`*^9, 
   3.7217564899578247`*^9}, {3.721756563781021*^9, 3.72175657523405*^9}, {
   3.721800650069376*^9, 3.721800650228479*^9}},
 CellLabel->
  "In[1963]:=",ExpressionUUID->"abe99f14-8078-45da-96f6-b83d5e6cb86b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<Precalculation\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitudeTable", ",", "\"\<Precalculation\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.721756497150454*^9, 3.721756500397401*^9}, {3.721756582107078*^9, 
   3.721756585825021*^9}},
 CellLabel->
  "In[1964]:=",ExpressionUUID->"f70056c8-7bea-4ef4-acb3-8578f290d3a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<Precalculation\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}]}], ",", 
     "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, 3.7217565039662046`*^9, 3.721756589336817*^9, {
   3.7218581475231237`*^9, 3.721858148017562*^9}},
 CellLabel->
  "In[1965]:=",ExpressionUUID->"3ce4752b-3210-4fab-b5b8-22af796c977b"]
}, Closed]],

Cell[CellGroupData[{

Cell["12. UserLevel", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, {3.7217564508871813`*^9, 3.7217564568857813`*^9}, {
   3.721756520611273*^9, 3.721756540319769*^9}, {3.721756613270803*^9, 
   3.72175661602112*^9}, {3.721757378506689*^9, 3.72175737874658*^9}, 
   3.7217578096632442`*^9, {3.745508537551936*^9, 3.745508539150895*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"9308974c-f49d-44a1-81ad-3535c3a51c70"],

Cell["<UserLevel>={<request>, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.721756623575251*^9, 3.72175662562084*^9}, {
   3.7218616459726677`*^9, 3.7218616467087383`*^9}, {3.745508575560679*^9, 
   3.745508578625554*^9}},ExpressionUUID->"e30aadf4-d647-458e-8d76-\
027be4113d8d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<UserLevel\>\""}], "]"}],
    "=", "12"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<UserLevel\>\""}], "]"}],
    "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitudeTable", ",", "\"\<UserLevel\>\""}], 
        "]"}], "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<UserLevel\>\""}], "]"}],
    "=", "2"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, {3.7217564769697237`*^9, 
   3.7217564899578247`*^9}, {3.721756563781021*^9, 3.72175657523405*^9}, {
   3.721756631888152*^9, 3.7217566421344213`*^9}, 3.721757383451694*^9, 
   3.721757906077087*^9, {3.7455085862830553`*^9, 
   3.7455085914422073`*^9}},ExpressionUUID->"f7c62c7d-c0f2-48d0-b70e-\
6be24b403ac2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<UserLevel\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{
            "TransformationAmplitudeTable", ",", "\"\<UserLevel\>\""}], "]"}],
            "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.721756497150454*^9, 3.721756500397401*^9}, {3.721756582107078*^9, 
   3.721756585825021*^9}, {3.721756648119502*^9, 3.721756651916052*^9}, {
   3.7455086235552893`*^9, 
   3.745508625273687*^9}},ExpressionUUID->"489eb424-c8b6-4ca0-8492-\
63c0a3298e64"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<UserLevel\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, 3.7217565039662046`*^9, 3.721756589336817*^9, 
   3.7217566550999317`*^9, 
   3.745508628345965*^9},ExpressionUUID->"d5e2e0b3-53b0-40f8-88da-\
c32954149012"]
}, Closed]],

Cell[CellGroupData[{

Cell["13. Ready", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 3.699967366452743*^9, {3.72175612222404*^9, 
   3.721756126006216*^9}, {3.72175624159445*^9, 3.721756261098542*^9}, {
   3.721756309262741*^9, 3.7217563186931353`*^9}, {3.721756380426717*^9, 
   3.721756390835338*^9}, {3.7217564508871813`*^9, 3.7217564568857813`*^9}, {
   3.721756520611273*^9, 3.721756540319769*^9}, {3.721756613270803*^9, 
   3.72175661602112*^9}, {3.721757378506689*^9, 3.72175737874658*^9}, 
   3.7217578096632442`*^9, 3.7455085416322327`*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"b580df28-b1cf-4955-8155-850f226e9e64"],

Cell["<Ready>={<request>, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 3.701095895985952*^9, {3.721756146342596*^9, 
   3.721756149638283*^9}, {3.721756623575251*^9, 3.72175662562084*^9}, {
   3.7218616459726677`*^9, 
   3.7218616467087383`*^9}},ExpressionUUID->"d36ff8c9-ba2c-4372-80b4-\
ffbfa8222ca1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Ready\>\""}], "]"}], 
   "=", "13"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Ready\>\""}], "]"}], 
   "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"TransformationAmplitudeTable", ",", "\"\<Ready\>\""}], "]"}],
        "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"TransformationAmplitudeTable", ",", "\"\<Ready\>\""}], "]"}], 
   "=", "2"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}, {3.721756161231827*^9, 
   3.7217561803181467`*^9}, {3.721756253436029*^9, 3.72175626857819*^9}, {
   3.7217563393681*^9, 3.721756349838518*^9}, {3.7217564072767572`*^9, 
   3.7217564172664967`*^9}, {3.7217564769697237`*^9, 
   3.7217564899578247`*^9}, {3.721756563781021*^9, 3.72175657523405*^9}, {
   3.721756631888152*^9, 3.7217566421344213`*^9}, 3.721757383451694*^9, 
   3.721757906077087*^9, 
   3.7455086005782003`*^9},ExpressionUUID->"d68b73f4-6c1f-4ef1-9f7e-\
281d62468aaa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Ready\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"TransformationAmplitudeTable", ",", "\"\<Ready\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.721756186551195*^9, 3.721756206117304*^9}, {
   3.721756273601676*^9, 3.72175627760855*^9}, {3.7217563567023563`*^9, 
   3.72175635950136*^9}, {3.7217564295385447`*^9, 3.721756432713704*^9}, {
   3.721756497150454*^9, 3.721756500397401*^9}, {3.721756582107078*^9, 
   3.721756585825021*^9}, {3.721756648119502*^9, 3.721756651916052*^9}},
 CellLabel->
  "In[1967]:=",ExpressionUUID->"223e31f6-7672-422b-9286-08f0d5ba6748"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Ready\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, {3.721756193574607*^9, 
   3.7217562087168903`*^9}, 3.721756287426445*^9, 3.7217563631476583`*^9, 
   3.721756435993504*^9, 3.7217565039662046`*^9, 3.721756589336817*^9, 
   3.7217566550999317`*^9},
 CellLabel->
  "In[1968]:=",ExpressionUUID->"ba9003d1-ba9e-40ff-8f1d-e39f45c3c8ce"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["consolidation", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.6999576793161383`*^9, 3.699957682623167*^9}, {
   3.69995837404912*^9, 3.699958377592299*^9}, {3.699958574875738*^9, 
   3.699958587182394*^9}, {3.699958628011107*^9, 3.699958629539061*^9}, {
   3.701095126622422*^9, 3.7010951289726562`*^9}, {3.722053347637271*^9, 
   3.722053349587484*^9}},ExpressionUUID->"8d660882-28f4-45c8-9ae8-\
865cb455c9ad"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ".."}], "}"}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{"True", ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958594214953*^9, 3.699958606071868*^9}, {
  3.721756676028056*^9, 3.721756677804595*^9}},
 CellLabel->
  "In[1969]:=",ExpressionUUID->"b7931865-9166-4ac4-8889-d6ec12575c23"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["preparation", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957885713748*^9, {3.72205347486777*^9, 3.722053476910309*^9}, 
   3.722053515919626*^9},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"7f42e3ed-e23b-4e2f-992a-773e0604c3a9"],

Cell[CellGroupData[{

Cell["1. Chronology", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 
   3.7217627764566717`*^9},ExpressionUUID->"5a6f3844-d293-4874-a9b0-\
b027fb683a13"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"f25efe23-e8df-441c-be9c-\
a4745d985f37"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "checked_", ",", "morelocst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", "items___", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762808727313*^9, 
   3.721762826935285*^9}, {3.721775483028036*^9, 3.721775485042083*^9}, {
   3.721797156190708*^9, 3.721797167519938*^9}},
 CellLabel->
  "In[1970]:=",ExpressionUUID->"6133b61c-7934-4f3f-987f-bafa6ed7611d"]
}, Closed]],

Cell[CellGroupData[{

Cell["check validity", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003128834717216`*^9}},ExpressionUUID->"1a2415ba-fb7b-43cd-a34a-\
ff3bbc09b913"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
       "morest___"}], "}"}], ",", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Chronology", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}], ",", 
       
       RowBox[{"\"\<RightToLeft\>\"", "|", "\"\<LeftToRight\>\""}]}], "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"TransformationAmplitudeTable", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
         "morest"}], "}"}], ",", "items", ",", "opts"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"TransformationAmplitudeTable", "::", "invalchron"}], "]"}], 
       ";", "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545060613969104*^9, 3.545060677315857*^9}, {
  3.699959501759419*^9, 3.6999595031746063`*^9}, {3.69996123531818*^9, 
  3.699961258964602*^9}, {3.6999613887140293`*^9, 3.699961497961199*^9}, {
  3.7027974045607414`*^9, 3.7027974136209464`*^9}, {3.702797581629608*^9, 
  3.7027975827761307`*^9}, {3.7217576729283247`*^9, 3.721757682608348*^9}, {
  3.721797178230218*^9, 3.7217971878626623`*^9}},
 CellLabel->
  "In[1971]:=",ExpressionUUID->"eb9b998b-b199-4e5c-a08e-0dcd5a59626f"]
}, Closed]],

Cell[CellGroupData[{

Cell["set flag when RtoL chronology is imposed throughout", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003129334155684`*^9}},ExpressionUUID->"9e2efbc9-4f08-49dc-8e28-\
7a029ef56bdd"],

Cell["\<\
Indicate RtoL chronology when events has been implemented with RtoL chronology\
\>", "Text",
 CellChangeTimes->{{3.7003131837412367`*^9, 3.700313213172423*^9}, {
   3.700323281449465*^9, 3.700323294991837*^9}, {3.700884900813744*^9, 
   3.7008849595387087`*^9}, {3.7093755408130093`*^9, 3.709375541419942*^9}, 
   3.7136933481804*^9, {3.721757734228219*^9, 
   3.721757754751378*^9}},ExpressionUUID->"35c1bcc6-6828-455a-a66f-\
7e728ab33a1c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False"}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"morest1", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}],
               "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", "\"\<Chronology\>\""}], 
              "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"evst", ":", "True"}], ",", "\[IndentingNewLine]", 
        "morest2___"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True"}], "}"}], ",", "morest1", 
       ",", "evst", ",", "morest2"}], "}"}], ",", "more", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, 3.721773879282402*^9, 
   3.721797202556916*^9},
 CellLabel->
  "In[1972]:=",ExpressionUUID->"d6eade72-9b97-4d16-be13-5ba92a182741"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2. InputRule", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9},ExpressionUUID->"bab5d08f-dc42-4046-93c5-\
b85554a3f615"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"1d6f4df0-1193-4279-b4bc-\
cdeb40ae0f31"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "items___", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], 
     ",", "items", ",", "\[IndentingNewLine]", "opts"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721773889521596*^9, {
   3.721797009996429*^9, 3.7217970336582747`*^9}},
 CellLabel->
  "In[1973]:=",ExpressionUUID->"11a55fd7-6250-4f34-a7e8-de82d4d7bd31"]
}, Closed]],

Cell[CellGroupData[{

Cell["implement", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003129334155684`*^9}, {3.721763123629573*^9, 
   3.721763125114709*^9}},ExpressionUUID->"fbd92a9c-788e-4a21-bdfe-\
be4929995787"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "\[IndentingNewLine]", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "\[Rho]ini", ",", 
     RowBox[{"Hold", "[", "obs", "]"}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, {3.721763137982553*^9, 
   3.721763295259151*^9}, {3.721763477155196*^9, 3.7217635012103233`*^9}, 
   3.721773896065181*^9, {3.721797041723003*^9, 3.7217970642402782`*^9}, {
   3.721856480296698*^9, 3.721856484373815*^9}},
 CellLabel->
  "In[1974]:=",ExpressionUUID->"757d46d2-9742-4e96-b7a9-e2f5d31a6f2c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, {3.721763137982553*^9, 
   3.721763295259151*^9}, {3.721763477155196*^9, 3.72176351888826*^9}, 
   3.7217636174566183`*^9, 3.721773900041164*^9, {3.7217970726019363`*^9, 
   3.721797105553602*^9}},
 CellLabel->
  "In[1975]:=",ExpressionUUID->"b7554135-8fd5-4646-8569-de2f1782ae31"]
}, Closed]],

Cell[CellGroupData[{

Cell["check", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003129334155684`*^9}, {3.721763123629573*^9, 3.721763125114709*^9}, {
   3.7217633261462297`*^9, 
   3.721763327073567*^9}},ExpressionUUID->"d1ec9f22-54c4-473e-8205-\
15fbd77ba3c2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], "}"}], 
       ",", "morest"}], "}"}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, {3.721763137982553*^9, 
   3.721763295259151*^9}, {3.721763477155196*^9, 3.72176351888826*^9}, {
   3.7217635728616657`*^9, 3.7217636121056423`*^9}, 3.7217739080808268`*^9, {
   3.721797114720999*^9, 3.721797136383321*^9}},
 CellLabel->
  "In[1976]:=",ExpressionUUID->"84bcd681-a5d1-416a-8bea-3a8d333b867e"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["3. Iterators", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 
   3.721763865131412*^9}},ExpressionUUID->"9ec94b5b-de6e-4608-a26e-\
823e94db251d"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 
   3.721763934144582*^9}},ExpressionUUID->"90a47ec8-1aa5-4b28-81e0-\
d493875426b7"],

Cell["request setup when InputRule and events are done", "Text",
 CellChangeTimes->{{3.721764080737742*^9, 
  3.72176410067066*^9}},ExpressionUUID->"0a7167f2-4dd5-44d0-9667-\
4f91cd8c8dc7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "True", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"morest1", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
              "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
              "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"morest2", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}],
               "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
              "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]",
         "True", ",", "\[IndentingNewLine]", "morest3___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "items___", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "prefix", ",", "True", ",", "morest1", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "\[IndentingNewLine]",
        "morest2", ",", " ", "True", ",", "morest3"}], "}"}], ",", 
     "\[IndentingNewLine]", "items", ",", "\[IndentingNewLine]", "opts"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, 3.72177391600037*^9, {
   3.7217965414077473`*^9, 3.721796619690773*^9}},
 CellLabel->
  "In[1977]:=",ExpressionUUID->"9ce08f70-9d81-406b-b119-aac8602d935e"]
}, Closed]],

Cell[CellGroupData[{

Cell["collate iterator specs", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003129334155684`*^9}, {3.721763123629573*^9, 3.721763125114709*^9}, {
   3.721764405615903*^9, 3.721764413591166*^9}, {3.721764645900546*^9, 
   3.721764649234672*^9}, {3.7217650378632*^9, 3.7217650495878696`*^9}, {
   3.7218854731895*^9, 
   3.721885474430853*^9}},ExpressionUUID->"a00875ab-4cb7-44e2-9d49-\
69eb97ee0f28"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "\[Rho]ini_", ",", "obs_", ",", "events_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"iterspecs", ":", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ".."}], ",", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], "|", 
          RowBox[{"{", "_Integer", "}"}]}]}], "}"}], ".."}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "\[IndentingNewLine]", "\[Rho]ini", ",", "obs",
      ",", "events", ",", "\[IndentingNewLine]", 
     RowBox[{"{", "iterspecs", "}"}], ",", "\[IndentingNewLine]", "opts"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, {3.721763137982553*^9, 
   3.721763295259151*^9}, {3.721763477155196*^9, 3.7217635012103233`*^9}, {
   3.721764660783278*^9, 3.721764961288756*^9}, {3.721764996387323*^9, 
   3.721765012785329*^9}, {3.7217650930355453`*^9, 3.721765153887142*^9}, 
   3.7217739259997597`*^9, {3.721796648004319*^9, 3.721796682987761*^9}, {
   3.7218854168320847`*^9, 3.721885460975251*^9}},
 CellLabel->
  "In[1978]:=",ExpressionUUID->"53f289d9-c6c1-4ed1-9043-2a663fd29845"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "\[Rho]ini_", ",", "obs_", ",", "events_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"iterlists", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"Except", "[", "_List", "]"}], ".."}], ",", 
          RowBox[{
           RowBox[{"Except", "[", "_List", "]"}], "|", 
           RowBox[{"{", "_Integer", "}"}]}]}], "}"}], ".."}], "}"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "\[IndentingNewLine]", "\[Rho]ini", ",", "obs",
      ",", "events", ",", "\[IndentingNewLine]", "iterlists", ",", 
     "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, {3.721763137982553*^9, 
   3.721763295259151*^9}, {3.721763477155196*^9, 3.7217635012103233`*^9}, {
   3.721764660783278*^9, 3.721764961288756*^9}, {3.721764996387323*^9, 
   3.721765012785329*^9}, {3.7217650930355453`*^9, 3.7217651867760277`*^9}, 
   3.721773930358589*^9, {3.7217966904520197`*^9, 3.7217967151553926`*^9}, {
   3.721885420477438*^9, 3.7218854208862867`*^9}, {3.721885453740267*^9, 
   3.721885465751404*^9}},
 CellLabel->
  "In[1979]:=",ExpressionUUID->"ad3496ce-65ee-4342-b6c5-86163e8f6a13"]
}, Closed]],

Cell[CellGroupData[{

Cell["determine TableVariables", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003129334155684`*^9}, {3.721763123629573*^9, 3.721763125114709*^9}, {
   3.721764405615903*^9, 3.721764413591166*^9}, {3.721764645900546*^9, 
   3.721764649234672*^9}, {3.7217650378632*^9, 
   3.721765075755958*^9}},ExpressionUUID->"ad32d919-6ddf-4c74-965b-\
ca5bc69c8961"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "\[Rho]ini_", ",", "obs_", ",", "events_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"iterlists", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"Except", "[", "_List", "]"}], ".."}], ",", 
          RowBox[{
           RowBox[{"Except", "[", "_List", "]"}], "|", 
           RowBox[{"{", "_Integer", "}"}]}]}], "}"}], ".."}], "}"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "tabvars", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tabvars", "=", 
        RowBox[{"First", "/@", "iterlists"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], 
            "}"}], ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", 
         "\[Rho]ini", ",", "obs", ",", "events", ",", "\[IndentingNewLine]", 
         "iterlists", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableVariables", "\[Rule]", "tabvars"}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, {3.721763137982553*^9, 
   3.721763295259151*^9}, {3.721763477155196*^9, 3.7217635012103233`*^9}, {
   3.721764660783278*^9, 3.721764961288756*^9}, {3.721764996387323*^9, 
   3.721765012785329*^9}, {3.7217652132401657`*^9, 3.721765247626152*^9}, 
   3.7217739386873426`*^9, {3.72179672616359*^9, 3.721796750801838*^9}, 
   3.7218856764047194`*^9},
 CellLabel->
  "In[1980]:=",ExpressionUUID->"1aadbaef-962d-465b-a17f-a7b70a2befa2"]
}, Closed]],

Cell[CellGroupData[{

Cell["check table variable validity", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003129334155684`*^9}, {3.721763123629573*^9, 3.721763125114709*^9}, {
   3.721764405615903*^9, 3.721764413591166*^9}, {3.721764645900546*^9, 
   3.721764649234672*^9}, {3.7217650378632*^9, 3.721765075755958*^9}, {
   3.721765270578555*^9, 3.72176527902451*^9}, 3.721765422620377*^9, 
   3.721769170645533*^9},ExpressionUUID->"bd0c10ed-b1d2-47f7-9a1c-\
28867ad69edb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{
          "True", ",", "True", ",", "True", ",", "False", ",", 
           "morelocst___"}], "}"}]}], ",", "\[IndentingNewLine]", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", "items___", ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "tabvars", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tabvars", "=", 
        RowBox[{
         RowBox[{"TableVariables", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"tabvars", ",", 
            RowBox[{"{", 
             RowBox[{"_Symbol", ".."}], "}"}]}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"TransformationAmplitudeTable", "::", "invaltabvars"}], 
            "]"}], ";", "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"prefix", ",", 
             RowBox[{"{", 
              RowBox[{
              "True", ",", "True", ",", "True", ",", "True", ",", 
               "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
           "\[IndentingNewLine]", "items", ",", "opts"}], 
          "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, {3.721763137982553*^9, 
   3.721763295259151*^9}, {3.721763477155196*^9, 3.7217635012103233`*^9}, {
   3.721764660783278*^9, 3.721764961288756*^9}, {3.721764996387323*^9, 
   3.721765012785329*^9}, {3.7217652132401657`*^9, 3.721765247626152*^9}, {
   3.721768925080737*^9, 3.72176906165761*^9}, {3.7217691419177933`*^9, 
   3.721769158429021*^9}, 3.721773948638259*^9, {3.721778040075983*^9, 
   3.7217780445370703`*^9}, {3.721796761899312*^9, 3.7217967843124247`*^9}},
 CellLabel->
  "In[1981]:=",ExpressionUUID->"59e064cd-0c12-436a-ba51-6106cea45272"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardize iteration specifications", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003129334155684`*^9}, {3.721763123629573*^9, 3.721763125114709*^9}, {
   3.721764405615903*^9, 3.721764413591166*^9}, {3.721764645900546*^9, 
   3.721764649234672*^9}, {3.7217650378632*^9, 3.721765075755958*^9}, {
   3.721765270578555*^9, 3.721765304383*^9}, 3.721765423995179*^9, 
   3.721769786052793*^9},ExpressionUUID->"03a4f826-1338-499c-9771-\
9e8295e0a53e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{
          "True", ",", "True", ",", "True", ",", "True", ",", "False", ",", 
           "morelocst___"}], "}"}]}], ",", "\[IndentingNewLine]", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]ini_", ",",
      "obs_", ",", "events_", ",", "\[IndentingNewLine]", 
     RowBox[{"iterlists", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"Except", "[", "_List", "]"}], ".."}], ",", 
          RowBox[{
           RowBox[{"Except", "[", "_List", "]"}], "|", 
           RowBox[{"{", "_Integer", "}"}]}]}], "}"}], ".."}], "}"}]}], ",", 
     "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{
        "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", 
         "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[Rho]ini", ",", "obs", ",", "events", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "[", "\[IndentingNewLine]", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"#", "//.", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"v_Symbol", ",", 
                RowBox[{"vmax", ":", 
                 RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], 
              "\[RuleDelayed]", 
              RowBox[{"{", 
               RowBox[{"v", ",", "0", ",", "vmax"}], "}"}]}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"v_Symbol", ",", 
                RowBox[{"vmin", ":", 
                 RowBox[{"Except", "[", "_List", "]"}]}], ",", 
                RowBox[{"vmax", ":", 
                 RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], 
              "\[RuleDelayed]", 
              RowBox[{"{", 
               RowBox[{"v", ",", "vmin", ",", "vmax", ",", "1"}], "}"}]}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"v_Symbol", ",", 
                RowBox[{"vmin", ":", 
                 RowBox[{"Except", "[", "_List", "]"}]}], ",", 
                RowBox[{"vmax", ":", 
                 RowBox[{"Except", "[", "_List", "]"}]}], ",", 
                RowBox[{"{", "nv_", "}"}]}], "}"}], "\[RuleDelayed]", 
              "\[IndentingNewLine]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"!", 
                    RowBox[{"IntegerQ", "[", "nv", "]"}]}], ")"}], "||", 
                   RowBox[{"(", 
                    RowBox[{"nv", "<", "1"}], ")"}]}], ",", 
                  RowBox[{"Message", "[", 
                   RowBox[{
                   "TransformationAmplitudeTable", "::", "badnumincr"}], 
                   "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"v", ",", "vmin", ",", "vmax", ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"vmax", "-", "vmin"}], ")"}], "/", 
                   RowBox[{"Max", "[", 
                    RowBox[{
                    RowBox[{"nv", "-", "1"}], ",", "1"}], "]"}]}]}], "}"}]}], 
               ")"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"v_Symbol", ",", 
                RowBox[{"vmax", ":", 
                 RowBox[{"Except", "[", "_List", "]"}]}], ",", 
                RowBox[{"{", "nv_", "}"}]}], "}"}], "\[RuleDelayed]", 
              "\[IndentingNewLine]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"!", 
                    RowBox[{"IntegerQ", "[", "nv", "]"}]}], ")"}], "||", 
                   RowBox[{"(", 
                    RowBox[{"nv", "<", "1"}], ")"}]}], ",", 
                  RowBox[{"Message", "[", 
                   RowBox[{
                   "TransformationAmplitudeTable", "::", "badnumincr"}], 
                   "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"{", 
                 RowBox[{"v", ",", "0", ",", "vmax", ",", 
                  RowBox[{"vmax", "/", 
                   RowBox[{"Max", "[", 
                    RowBox[{
                    RowBox[{"nv", "-", "1"}], ",", "1"}], "]"}]}]}], "}"}]}], 
               ")"}]}]}], "\[IndentingNewLine]", "}"}]}], ")"}], "&"}], ",", 
        "\[IndentingNewLine]", "iterlists"}], "\[IndentingNewLine]", "]"}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "opts"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, {3.721763137982553*^9, 
   3.721763295259151*^9}, {3.721763477155196*^9, 3.7217635012103233`*^9}, {
   3.721764660783278*^9, 3.721764961288756*^9}, {3.721764996387323*^9, 
   3.721765012785329*^9}, {3.7217652132401657`*^9, 3.721765247626152*^9}, {
   3.721768925080737*^9, 3.72176906165761*^9}, {3.7217691419177933`*^9, 
   3.721769158429021*^9}, {3.7217692063710747`*^9, 3.72176920952901*^9}, {
   3.721769246977785*^9, 3.721769255368125*^9}, {3.7217692894466248`*^9, 
   3.721769302579574*^9}, {3.721769513818646*^9, 3.7217696759853487`*^9}, {
   3.721769798172063*^9, 3.721769799016498*^9}, {3.721769979996657*^9, 
   3.7217699906148*^9}, 3.7217739563980427`*^9, {3.72177781775953*^9, 
   3.7217778270852823`*^9}, {3.721796793169269*^9, 3.72179682016787*^9}, {
   3.721883651148448*^9, 3.721883731743985*^9}, {3.721883772846732*^9, 
   3.721883878531439*^9}, {3.721883911241013*^9, 3.72188395551014*^9}, {
   3.721883985936607*^9, 3.72188401442181*^9}, {3.721884095340803*^9, 
   3.721884108597761*^9}, 3.721885862977635*^9},
 CellLabel->
  "In[1982]:=",ExpressionUUID->"2931bf28-7eda-4e52-bb11-95bf13762ec5"]
}, Closed]],

Cell[CellGroupData[{

Cell["check validity", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003129334155684`*^9}, {3.721763123629573*^9, 3.721763125114709*^9}, {
   3.7217633261462297`*^9, 3.721763327073567*^9}, 3.7217644181929483`*^9, {
   3.721769965578519*^9, 
   3.721769967328532*^9}},ExpressionUUID->"db0ede5b-e92b-4724-8d1e-\
81c85ec9e0f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{
          "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", 
           "False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "\[Rho]ini_", ",", "obs_", ",", "events_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"iterlists", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}], ".."}], 
       "}"}]}], ",", "\[IndentingNewLine]", "opts___Rule"}], 
    "\[IndentingNewLine]", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{"iterlists", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_Symbol", ",", 
            RowBox[{"_", "?", "NumericQ"}], ",", 
            RowBox[{"_", "?", "NumericQ"}], ",", 
            RowBox[{"_", "?", "NumericQ"}]}], "}"}], ".."}], "}"}]}], "]"}]}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"TransformationAmplitudeTable", "::", "invaliter"}], "]"}], 
       ";", "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TransformationAmplitudeTable", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"prefix", ",", 
         RowBox[{"{", 
          RowBox[{
          "True", ",", "True", ",", "True", ",", "True", ",", "True", ",", 
           "True", ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
       "\[Rho]ini", ",", "obs", ",", "events", ",", "iterlists", ",", 
       "opts"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
   3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
   3.700314392970945*^9}, 3.7217577607636147`*^9, 3.721757998655884*^9, {
   3.7217582009324408`*^9, 3.721758207842355*^9}, {3.721758291781991*^9, 
   3.7217583332836523`*^9}, {3.721758371779457*^9, 3.721758386185363*^9}, {
   3.721758445967671*^9, 3.721758499937566*^9}, {3.721763137982553*^9, 
   3.721763295259151*^9}, {3.721763477155196*^9, 3.72176351888826*^9}, {
   3.7217635728616657`*^9, 3.7217636121056423`*^9}, {3.721769858048794*^9, 
   3.721769957202897*^9}, 3.721773963757813*^9, 3.721778481654581*^9, {
   3.7217785954050407`*^9, 3.7217786062937117`*^9}, {3.72179683213687*^9, 
   3.721796857526898*^9}},
 CellLabel->
  "In[1983]:=",ExpressionUUID->"a4992eac-4932-4358-904c-f3d1fb44bfc5"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["4. TableCoordinates", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"9e396be7-acd2-49f5-b0a4-a705f3223a54"],

Cell[CellGroupData[{

Cell["skip when TableCoordinates\[Rule]None", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773218146742*^9, 
   3.721773223988451*^9}},ExpressionUUID->"783e1125-5795-4255-a748-\
0f351a9ca340"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Evaluate", "@", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"prefix", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{
           "TransformationAmplitudeTable", ",", "\"\<TableCoordinates\>\""}], 
           "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"locst", ":", 
          RowBox[{"{", 
           RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
         "\[IndentingNewLine]", "morest___"}], "\[IndentingNewLine]", "}"}]}],
       ",", "\[IndentingNewLine]", "items___", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"ReleaseHold", "[", 
       RowBox[{
        RowBox[{"TableCoordinates", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}], 
       "]"}], ",", "None"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", "True", ",", "morest"}], "}"}], ",", 
     "\[IndentingNewLine]", "items", ",", "\[IndentingNewLine]", "opts"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, {3.721773039421446*^9, 3.72177309168038*^9}, 
   3.721773972509595*^9, {3.721779212629012*^9, 3.7217792203868628`*^9}, {
   3.721796465178507*^9, 3.721796500816513*^9}},
 CellLabel->
  "In[1984]:=",ExpressionUUID->"826665b7-5055-454d-bc17-55c4b1171e44"]
}, Closed]],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}},ExpressionUUID->"f5f1c064-4fa8-409d-b7a0-\
5463018a44cd"],

Cell["request setup when Iterators are done", "Text",
 CellChangeTimes->{{3.721764080737742*^9, 3.72176410067066*^9}, {
  3.721770232661127*^9, 
  3.72177023588104*^9}},ExpressionUUID->"366acab5-3481-4a61-8d4d-\
e0912ce56665"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "True", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "\[IndentingNewLine]", "}"}]}], 
     ",", "\[IndentingNewLine]", "items___", ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", "True", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "\[IndentingNewLine]",
        "morest"}], "}"}], ",", "\[IndentingNewLine]", "items", ",", 
     "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, {3.721796265696759*^9, 
   3.721796305086853*^9}},
 CellLabel->
  "In[1985]:=",ExpressionUUID->"003bf918-fedd-444c-8e7b-89648199d32e"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardize", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721770445350749*^9, 
   3.721770451397625*^9}, {3.721771585915578*^9, 3.721771589506217*^9}, {
   3.721771698974478*^9, 
   3.721771701524107*^9}},ExpressionUUID->"42582f7a-2342-4609-9fcd-\
4c36786fcea5"],

Cell["\<\
Special cases: 
1. TableCoordinates\[Rule]Automatic 
2. TableCoordinates is not a List, and there is only a single table variable.\
\
\>", "Text",
 CellChangeTimes->{{3.721784284655487*^9, 
  3.72178435521935*^9}},ExpressionUUID->"3ee26c33-826f-4eb8-897d-\
549c281a4707"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<TableCoordinates\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "\[IndentingNewLine]", "}"}]}], 
     ",", "\[IndentingNewLine]", "items__", ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tabcoordfuncs", ",", "tabcoords", ",", "tabvars"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"tabcoordfuncs", ",", "tabvars"}], "}"}], "=", 
        RowBox[{"ReleaseHold", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"TableCoordinates", ",", "TableVariables"}], "}"}], "/.", 
           
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
           "\[IndentingNewLine]", "morest"}], "}"}], ",", 
         "\[IndentingNewLine]", "items", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableCoordinates", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Switch", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"tabcoordfuncs", ",", "tabvars"}], "}"}], ",", 
               "\[IndentingNewLine]", "\t", 
               RowBox[{"{", 
                RowBox[{"Automatic", ",", "_"}], "}"}], ",", "tabvars", ",", 
               "\[IndentingNewLine]", "\t", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Except", "[", "_List", "]"}], ",", 
                 RowBox[{"{", "_", "}"}]}], "}"}], ",", 
               RowBox[{"{", "tabcoordfuncs", "}"}], ",", 
               "\[IndentingNewLine]", "\t", "_", ",", "tabcoordfuncs"}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            "opts"}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]",
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, {3.7217706267029448`*^9, 3.7217706657479343`*^9}, {
   3.7217707054892693`*^9, 3.72177070940135*^9}, {3.721770798159156*^9, 
   3.721770921126378*^9}, {3.721770957076427*^9, 3.7217709620597477`*^9}, {
   3.721771453122353*^9, 3.721771495015555*^9}, {3.7217715321520557`*^9, 
   3.721771554117087*^9}, {3.7217716731994667`*^9, 3.72177167944552*^9}, {
   3.721771742130898*^9, 3.7217717580812197`*^9}, {3.721771788562106*^9, 
   3.72177182786203*^9}, {3.721771872951623*^9, 3.721771982037363*^9}, {
   3.7217720130927067`*^9, 3.7217720452744217`*^9}, 3.7217739856049213`*^9, {
   3.721779186669347*^9, 3.7217791934367647`*^9}, 3.7217840947641277`*^9, {
   3.7217841863976517`*^9, 3.7217842686963997`*^9}, {3.7217844079724827`*^9, 
   3.721784413033152*^9}, {3.721796316406125*^9, 3.721796359030073*^9}},
 CellLabel->
  "In[1986]:=",ExpressionUUID->"cafd4329-3b6b-40a7-9e79-25e362c02581"]
}, Closed]],

Cell[CellGroupData[{

Cell["implement", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721770445350749*^9, 
   3.721770451397625*^9}, 3.72177277367618*^9},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"67a247ce-927d-4075-aada-149268e9fbf9"],

Cell["\<\
Note: The use of Sort below ensures that the sorting of coordinates matches \
the arrangement of the final data (see CombineAndSort routine in the main \
computation)\
\>", "Text",
 CellChangeTimes->{{3.721887358678248*^9, 3.7218873828761187`*^9}, {
  3.721887413333337*^9, 
  3.7218874328343887`*^9}},ExpressionUUID->"11ea0d57-2e1a-4f9d-95f9-\
5bba604a7c02"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<TableCoordinates\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "\[IndentingNewLine]", "morest___"}], 
       "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
     "\[Rho]ini_", ",", "obs_", ",", "events_", ",", "\[IndentingNewLine]", 
     RowBox[{"iterlists", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ".."}], "}"}], ".."}], 
       "}"}]}], ",", "\[IndentingNewLine]", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tabcoordfuncs", ",", "tabcoords", ",", "tabvars"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"tabcoordfuncs", ",", "tabvars"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"TableCoordinates", ",", "TableVariables"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], 
            "}"}], ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", 
         "\[Rho]ini", ",", "obs", ",", "events", ",", "\[IndentingNewLine]", 
         "iterlists", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableCoordinates", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"SortBy", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Flatten", "[", 
                RowBox[{
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{"Evaluate", "@", "tabcoordfuncs"}], ",", 
                   RowBox[{"Evaluate", "[", 
                    RowBox[{"Sequence", "@@", "iterlists"}], "]"}]}], "]"}], 
                 ",", 
                 RowBox[{
                  RowBox[{"Length", "[", "tabvars", "]"}], "-", "1"}]}], 
                "]"}], ",", "\[IndentingNewLine]", "N"}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            "opts"}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]",
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, {3.7217706267029448`*^9, 3.7217706657479343`*^9}, {
   3.7217707054892693`*^9, 3.72177070940135*^9}, {3.721770798159156*^9, 
   3.721770921126378*^9}, {3.721770957076427*^9, 3.7217709620597477`*^9}, {
   3.721771453122353*^9, 3.721771495015555*^9}, {3.7217715321520557`*^9, 
   3.721771554117087*^9}, {3.721772134982747*^9, 3.721772199554792*^9}, {
   3.721772235041692*^9, 3.7217722651819963`*^9}, {3.721772304470376*^9, 
   3.721772331588046*^9}, {3.721772426215995*^9, 3.7217724274208307`*^9}, 
   3.721773992164154*^9, 3.721779944959466*^9, {3.7217963755337553`*^9, 
   3.721796401524129*^9}, {3.721887347632042*^9, 3.721887349478333*^9}, {
   3.744366887956205*^9, 
   3.744366904140287*^9}},ExpressionUUID->"1880b41a-3365-4792-8578-\
6c5da48e21a0"]
}, Closed]],

Cell[CellGroupData[{

Cell["check", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721770445350749*^9, 
   3.721770458007115*^9}, 
   3.721772907084477*^9},ExpressionUUID->"8d37e96a-5fac-4460-9340-\
c77a508ffcb6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<TableCoordinates\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{
          "True", ",", "True", ",", "True", ",", "False", ",", 
           "morelocst___"}], "}"}]}], ",", "\[IndentingNewLine]", 
        "morest___"}], "\[IndentingNewLine]", "}"}]}], ",", 
     "\[IndentingNewLine]", "items___", ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tabcoords", ",", "tabvars"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"tabcoords", ",", "tabvars"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"TableCoordinates", ",", "TableVariables"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"tabcoords", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"Repeated", "[", 
               RowBox[{"_", ",", 
                RowBox[{"{", 
                 RowBox[{"Length", "[", "tabvars", "]"}], "}"}]}], "]"}], 
              "}"}], ".."}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"prefix", ",", 
             RowBox[{"{", 
              RowBox[{
              "True", ",", "True", ",", "True", ",", "True", ",", 
               "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
           "\[IndentingNewLine]", "items", ",", "opts"}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", "tabvars", "]"}], "==", "1"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Message", "[", 
              RowBox[{
              "TransformationAmplitudeTable", "::", "invaltabcoords1"}], 
              "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Message", "[", 
              RowBox[{
               RowBox[{
               "TransformationAmplitudeTable", "::", "invaltabcoordsn"}], ",", 
               RowBox[{"Length", "[", "tabvars", "]"}]}], "]"}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           "$Failed"}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]",
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, {3.7217706267029448`*^9, 3.7217706657479343`*^9}, {
   3.7217707054892693`*^9, 3.72177070940135*^9}, {3.721770798159156*^9, 
   3.721770921126378*^9}, {3.721770957076427*^9, 3.7217709620597477`*^9}, {
   3.721771453122353*^9, 3.721771495015555*^9}, {3.7217715321520557`*^9, 
   3.721771554117087*^9}, {3.721772134982747*^9, 3.721772199554792*^9}, {
   3.721772235041692*^9, 3.7217722651819963`*^9}, {3.721772304470376*^9, 
   3.721772331588046*^9}, {3.721772426215995*^9, 3.7217724274208307`*^9}, {
   3.721772473707074*^9, 3.72177271183696*^9}, 3.721773997844249*^9, 
   3.721774060337267*^9, {3.721778713775853*^9, 3.721778779528943*^9}, {
   3.7217789040376673`*^9, 3.721778910667713*^9}, 3.721780332633089*^9, {
   3.721783806953574*^9, 3.721783814127831*^9}, {3.721783883669744*^9, 
   3.721783886476598*^9}, {3.721796413701036*^9, 3.7217964444259787`*^9}, {
   3.721888386643923*^9, 3.721888391721418*^9}, {3.7218884500478563`*^9, 
   3.721888552475429*^9}, 3.721888684913643*^9},
 CellLabel->
  "In[1988]:=",ExpressionUUID->"a65179a0-5e0f-4feb-896b-6e073933edc0"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["5. EnsembleAverage", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.721784520604287*^9, 
   3.721784528586845*^9}},ExpressionUUID->"0b9153c9-2679-465b-aa0e-\
a6d424a4f15e"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}},ExpressionUUID->"788849d1-f964-4fc5-92ef-\
90662a6a5c7f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<EnsembleAverage\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "\[IndentingNewLine]", "}"}]}], 
     ",", "\[IndentingNewLine]", "items___", ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], 
     ",", "\[IndentingNewLine]", "items", ",", "opts"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, 3.7217848581675463`*^9, {
   3.721784906747036*^9, 3.721784942930396*^9}, {3.721785002374063*^9, 
   3.721785029776099*^9}, {3.721796166564324*^9, 3.72179620833635*^9}, 
   3.7217973755614653`*^9},
 CellLabel->
  "In[1989]:=",ExpressionUUID->"b6bf78ba-2c72-416e-8b40-c83f08ce7db4"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 
   3.700298704750389*^9}},ExpressionUUID->"8aba1763-3ba5-4734-8e83-\
0cf45f47104b"],

Cell[CellGroupData[{

Cell["case of no EnsembleAverage", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.6999651865551662`*^9, 3.699965204305951*^9}, {3.6999659996591463`*^9, 
   3.699966001255926*^9}},ExpressionUUID->"3aeaebaa-7f87-4c81-813b-\
71205ba26641"],

Cell["\<\
insert a dummy ensemble average, to allow the following calculations to \
proceed without trouble\
\>", "Text",
 CellChangeTimes->{{3.6999664451434402`*^9, 3.69996645198256*^9}, {
  3.72188676036405*^9, 
  3.721886780888501*^9}},ExpressionUUID->"a948d6f7-b43e-4821-9ed9-\
6310648417ff"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TransformationAmplitudeTable", "[", 
     RowBox[{
      RowBox[{"Evaluate", "@", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"prefix", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{
           "TransformationAmplitudeTable", ",", "\"\<EnsembleAverage\>\""}], 
           "]"}]}], ",", 
         RowBox[{"locst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
         "morest___"}], "}"}]}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"EnsembleAverage", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}], ",", 
      RowBox[{"False", "|", "None"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "dummyensvar", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"prefix", ",", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
          "morest"}], "}"}], ",", "more", ",", "\[IndentingNewLine]", 
        RowBox[{"Evaluate", "@", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"EnsembleAverage", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"dummyensvar", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", "1", "}"}], ",", "1"}], "}"}], "}"}]}], "}"}]}],
            ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
          "]"}]}]}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699966016692745*^9, 3.69996611662718*^9}, {
   3.6999662442283573`*^9, 3.6999662553192368`*^9}, {3.69996641843752*^9, 
   3.6999664234195013`*^9}, 3.721784975481917*^9, {3.721785063292615*^9, 
   3.721785076132764*^9}, 3.72185698620201*^9, {3.721886788184494*^9, 
   3.721886866118922*^9}},
 CellLabel->
  "In[1990]:=",ExpressionUUID->"10f81bd7-ca3d-4e8a-b736-7a1ec9e19ebb"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardize EnsembleAverage", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.6999651865551662`*^9, 
   3.699965204305951*^9}},ExpressionUUID->"2f750348-3ee8-439b-82d0-\
5060c5454e2e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<EnsembleAverage\>\""}], 
          "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts1___Rule", ",", 
     RowBox[{"EnsembleAverage", "\[Rule]", "ensav_"}], ",", "opts2___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{
        RowBox[{"EnsembleAverage", "->", 
         RowBox[{"StandardizeEnsembleAverage", "[", "ensav", "]"}]}], ",", 
        "opts1", ",", "opts2"}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.69996522458116*^9, 
   3.6999652253555193`*^9}, {3.699965256768085*^9, 3.699965393759205*^9}, {
   3.699965595298367*^9, 3.699965598163332*^9}, {3.721785093189507*^9, 
   3.721785104402804*^9}, 3.7218569896158943`*^9},
 CellLabel->
  "In[1991]:=",ExpressionUUID->"09a560f8-5aa2-4cbe-b9b3-335df763af9a"]
}, Closed]],

Cell[CellGroupData[{

Cell["expand multidimensional variables", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.6999651865551662`*^9, 3.699965204305951*^9}, {3.699965473230483*^9, 
   3.699965485379623*^9}},ExpressionUUID->"a287f759-3fbf-4232-9f93-\
c421fec1e28e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<EnsembleAverage\>\""}], 
          "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "morest___"}], "}"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts1___Rule", ",", 
     RowBox[{"EnsembleAverage", "\[Rule]", "ensav_"}], ",", "opts2___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"modmore", ",", "modopts"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"modmore", ",", "modopts"}], "}"}], "=", 
        "\[IndentingNewLine]", 
        RowBox[{
        "ExpandMultidimensionalEnsembleVariables", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "more", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"opts1", ",", "opts2"}], "}"}]}], "}"}], ",", 
          "\[IndentingNewLine]", "ensav"}], "\[IndentingNewLine]", "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitudeTable", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], 
            "}"}], ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "[", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"ReleaseHold", "@", "modmore"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"EnsembleAverage", "\[Rule]", 
             RowBox[{
             "ExpandMultidimensionalEnsembleVariables", "@", "ensav"}]}], ",",
             "\[IndentingNewLine]", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"ReleaseHold", "@", "modopts"}]}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.69996522458116*^9, 
   3.6999652253555193`*^9}, {3.699965256768085*^9, 3.699965393759205*^9}, {
   3.699965488982991*^9, 3.699965674024057*^9}, {3.700487922322399*^9, 
   3.700487923368285*^9}, {3.700488350781142*^9, 3.700488351369256*^9}, {
   3.702806661995947*^9, 3.7028066658606462`*^9}, {3.702806885653371*^9, 
   3.7028068858408885`*^9}, {3.721785119691728*^9, 3.721785126370204*^9}, 
   3.721797380240395*^9, 3.721856992503956*^9},
 CellLabel->
  "In[1992]:=",ExpressionUUID->"4cd39090-5523-4805-a976-9eb0db1cc5ca"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["6. NormalizationFactor", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.721784520604287*^9, 
   3.721784528586845*^9}, {3.7217957989634943`*^9, 
   3.721795803242463*^9}},ExpressionUUID->"95fd919a-c13f-4593-972b-\
b7dd8b3a49af"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}},ExpressionUUID->"993a490a-61bf-43d8-bb19-\
779b1683fe5e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", 
           "\"\<NormalizationFactor\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "\[IndentingNewLine]", "}"}]}], 
     ",", "\[IndentingNewLine]", "items___", ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "\[IndentingNewLine]",
        "morest"}], "}"}], ",", "\[IndentingNewLine]", "items", ",", 
     "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, 3.7217848581675463`*^9, {
   3.721784906747036*^9, 3.721784942930396*^9}, {3.721785002374063*^9, 
   3.721785029776099*^9}, 3.721795811294278*^9, {3.721797799172823*^9, 
   3.721797824246089*^9}},
 CellLabel->
  "In[1993]:=",ExpressionUUID->"a09eb37f-33c6-4017-ad88-898c20ff63cc"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 
   3.700298704750389*^9}},ExpressionUUID->"13f5e7d4-7e29-4885-9a15-\
79d927ca51f4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", 
           "\"\<NormalizationFactor\>\""}], "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "normfac", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"normfac", "=", 
        RowBox[{
         RowBox[{"NormalizationFactor", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"Switch", "[", "\[IndentingNewLine]", 
        RowBox[{"normfac", ",", "\[IndentingNewLine]", 
         RowBox[{"False", "|", "None"}], ",", 
         RowBox[{"TransformationAmplitudeTable", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"prefix", ",", "True", ",", "morest"}], "}"}], ",", 
           "more", ",", 
           RowBox[{"Evaluate", "@", 
            RowBox[{"SimplifyRules", "[", 
             RowBox[{
              RowBox[{"NormalizationFactor", "\[Rule]", "1"}], ",", "opts"}], 
             "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"TransformationAmplitudeTable", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"prefix", ",", "True", ",", "morest"}], "}"}], ",", 
           "more", ",", 
           RowBox[{"Evaluate", "@", 
            RowBox[{"SimplifyRules", "[", 
             RowBox[{
              RowBox[{"NormalizationFactor", "\[Rule]", "normfac"}], ",", 
              "opts"}], "]"}]}]}], "]"}], ",", "\[IndentingNewLine]", "_", 
         ",", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"TransformationAmplitudeTable", "::", "badnormfac"}], 
            "]"}], ";", "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699966016692745*^9, 3.69996611662718*^9}, {
   3.6999662442283573`*^9, 3.6999662553192368`*^9}, {3.69996641843752*^9, 
   3.6999664234195013`*^9}, 3.721784975481917*^9, {3.721785063292615*^9, 
   3.721785076132764*^9}, {3.721795879267696*^9, 3.721796066909163*^9}, 
   3.721856999983809*^9},
 CellLabel->
  "In[1994]:=",ExpressionUUID->"67667958-c7ad-4bef-8d66-44a973c2a045"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["7. BackgroundGenerator", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.721784520604287*^9, 
   3.721784528586845*^9}, {3.7217957989634943`*^9, 3.721795803242463*^9}, {
   3.7217977282049847`*^9, 
   3.721797734068042*^9}},ExpressionUUID->"9335be0d-dfe0-4052-a358-\
1ff69e7d0ec7"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"e67149aa-1ed2-42c2-8e67-\
3885f9537859"],

Cell["\<\
only do this after both the EnsembleAverage and the Iterators have been set \
up.\
\>", "Text",
 CellChangeTimes->{{3.70048766577647*^9, 3.700487684342527*^9}, {
  3.700487825172986*^9, 3.700487830817691*^9}, {3.7217981597060127`*^9, 
  3.7217981710317097`*^9}, {3.721798261256089*^9, 
  3.7217982622291107`*^9}},ExpressionUUID->"a4454d83-bc0b-4b32-a9bb-\
289b2c70f1e9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"iterst", ":", "True"}], ",", 
        RowBox[{"morest1", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", 
               "\"\<EnsembleAverage\>\""}], "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", "\"\<Iterators\>\""}], 
              "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", 
        RowBox[{"ensavst", ":", "True"}], ",", "\[IndentingNewLine]", 
        RowBox[{"morest2", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", 
               "\"\<BackgroundGenerator\>\""}], "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", 
               "\"\<EnsembleAverage\>\""}], "]"}], "-", "1"}], "}"}]}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest3___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "prefix", ",", "True", ",", "morest1", ",", "True", ",", "morest2", ",",
        "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest3"}], "}"}], 
     ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700487694223301*^9, 3.70048781391779*^9}, {
   3.7191693214038315`*^9, 3.7191693596416545`*^9}, {3.721797777869356*^9, 
   3.72179778087085*^9}, {3.721797849901107*^9, 3.72179786944099*^9}, {
   3.72179791512945*^9, 3.721797933731482*^9}, {3.721797976486981*^9, 
   3.7217980423259983`*^9}, {3.721798194371152*^9, 3.721798254502233*^9}, {
   3.72179948341151*^9, 3.721799483968858*^9}, 3.721857006046548*^9},
 CellLabel->
  "In[1995]:=",ExpressionUUID->"f8774926-e215-46d4-95cb-8b33f22d20f4"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardization", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700309598202568*^9, 
   3.7003096016263037`*^9}},ExpressionUUID->"37ddcf78-30af-42bc-9f82-\
a9c3bef41e30"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", 
           "\"\<BackgroundGenerator\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "backg", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"backg", "=", 
        RowBox[{"StandardizeGenerator", "[", 
         RowBox[{"(", 
          RowBox[{"ReleaseHold", "[", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}], 
           "]"}], ")"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitudeTable", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
           "morest"}], "}"}], ",", "more", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", 
             RowBox[{"StandardizeGenerator", "[", "backg", "]"}]}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700309626432626*^9, 3.700309825969651*^9}, {
   3.700310056716866*^9, 3.700310057347103*^9}, {3.7027706940881877`*^9, 
   3.7027707578389273`*^9}, 3.702771187249196*^9, 3.702771711904467*^9, {
   3.7027717793794394`*^9, 3.7027717795115347`*^9}, {3.703235069363023*^9, 
   3.703235082012912*^9}, {3.7093740519364653`*^9, 3.7093740519399548`*^9}, {
   3.709375544993725*^9, 3.709375546231031*^9}, {3.719169486627988*^9, 
   3.719169489470293*^9}, {3.7191697012935205`*^9, 3.7191697245752764`*^9}, {
   3.7191697606300526`*^9, 3.7191698532499914`*^9}, {3.719169887689986*^9, 
   3.719169889079546*^9}, {3.719170053125657*^9, 3.719170064604946*^9}, {
   3.7217980595195503`*^9, 3.7217981405134697`*^9}, {3.721798300512731*^9, 
   3.7217983057272167`*^9}, 3.721857008431657*^9, 3.7260703597599134`*^9},
 CellLabel->
  "In[1996]:=",ExpressionUUID->"e60ce49f-9045-4579-9aa9-173f9a1634af"]
}, Closed]],

Cell[CellGroupData[{

Cell["diagonalization", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700309598202568*^9, 3.7003096016263037`*^9}, {3.700310956349225*^9, 
   3.700310958635674*^9}},ExpressionUUID->"f9c8c1de-8d0e-408e-aa59-\
a08c7e2ba574"],

Cell["\<\
pre-diagonalization disabled in v3.0.3b6m if a PrecalculatedEvent is \
detected. Pre-diagonalization impedes the validation of the \
PrecalculatedEvent through identification of matched background generators.\
\>", "Text",
 CellChangeTimes->{{3.700311026475007*^9, 3.7003110367448473`*^9}, {
   3.721798321238275*^9, 3.721798325075145*^9}, 3.722421792509099*^9, 
   3.722429404739366*^9, {3.723272830850107*^9, 3.723272845057336*^9}, {
   3.723272881225842*^9, 3.72327288247309*^9}, {3.7232730271904163`*^9, 
   3.723273050858573*^9}, {3.723274396723278*^9, 3.723274415004168*^9}, {
   3.7232745234485283`*^9, 
   3.723274622673964*^9}},ExpressionUUID->"646ffe82-8dd6-48de-aa27-\
c55390338cad"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", 
           "\"\<BackgroundGenerator\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "backg", ",", "ensav", ",", "diagfunc", ",", "opbasis", ",", "basis", 
       ",", "tabvars"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"backg", "=", 
        RowBox[{"StandardizeGenerator", "[", 
         RowBox[{"(", 
          RowBox[{"ReleaseHold", "[", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}], 
           "]"}], ")"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ensav", "=", 
        RowBox[{
         RowBox[{"EnsembleAverage", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"tabvars", "=", 
        RowBox[{
         RowBox[{"TableVariables", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"diagfunc", "=", 
        RowBox[{"Function", "[", 
         RowBox[{"backg", ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"FreeQ", "[", 
              RowBox[{
               RowBox[{"{", "more", "}"}], ",", "_PrecalculatedEvent"}], 
              "]"}], "&&", 
             RowBox[{
              RowBox[{"Length", "[", 
               RowBox[{"UnassignedSymbols", "[", "backg", "]"}], "]"}], "==", 
              "0"}]}], ",", "\[IndentingNewLine]", "\t", 
            RowBox[{"Switch", "[", 
             RowBox[{"backg", ",", "\[IndentingNewLine]", "\t", 
              RowBox[{"NullOperator", "[", "]"}], ",", "backg", ",", 
              "\[IndentingNewLine]", "\t", 
              RowBox[{"_", "?", "OperatorQ"}], ",", 
              RowBox[{"NDiagonalize", "[", 
               RowBox[{"backg", ",", "basis"}], "]"}], ",", 
              "\[IndentingNewLine]", "\t", 
              RowBox[{"_", "?", "SuperoperatorQ"}], ",", 
              RowBox[{"NDiagonalize", "[", 
               RowBox[{"backg", ",", "opbasis", ",", "basis"}], "]"}], ",", 
              "\[IndentingNewLine]", "\t", "_", ",", "backg"}], 
             "\[IndentingNewLine]", "\t", "]"}], ",", "\[IndentingNewLine]", 
            "backg"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], 
            "}"}], ",", "morest"}], "}"}], ",", "more", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", 
             RowBox[{"diagfunc", "[", "backg", "]"}]}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700309626432626*^9, 3.700309825969651*^9}, {
   3.700310056716866*^9, 3.700310057347103*^9}, {3.7003109674381866`*^9, 
   3.700310970564481*^9}, {3.700311001837414*^9, 3.700311070112496*^9}, {
   3.7003111193491707`*^9, 3.700311121309247*^9}, {3.7003111654495497`*^9, 
   3.700311251899686*^9}, {3.70031131378601*^9, 3.700311332780781*^9}, 
   3.700311733832684*^9, 3.700311787146143*^9, 3.7003134105552397`*^9, {
   3.700313498353919*^9, 3.700313498815946*^9}, {3.700483219531069*^9, 
   3.7004832554188547`*^9}, {3.700483352277752*^9, 3.700483360462049*^9}, {
   3.7004833972605753`*^9, 3.700483520007393*^9}, 3.7010882228410883`*^9, {
   3.7027706435992904`*^9, 3.7027706466855135`*^9}, {3.702772068810874*^9, 
   3.7027720697845917`*^9}, {3.702772204178095*^9, 3.702772208683292*^9}, {
   3.702772241521645*^9, 3.7027722420099926`*^9}, {3.7027766718350515`*^9, 
   3.702776693683591*^9}, {3.703235265111353*^9, 3.703235275222041*^9}, {
   3.709375546895355*^9, 3.709375547515277*^9}, {3.7185318943490877`*^9, 
   3.718531918369113*^9}, {3.7185319612993393`*^9, 3.718531971387257*^9}, {
   3.7185320251046305`*^9, 3.718532082778624*^9}, {3.7185322118469276`*^9, 
   3.7185322154746275`*^9}, {3.719169611765709*^9, 3.719169644249029*^9}, {
   3.7191696752370825`*^9, 3.719169677826317*^9}, {3.721798336494039*^9, 
   3.721798461968627*^9}, {3.7217985289366207`*^9, 3.721798593149304*^9}, {
   3.721798656708432*^9, 3.721798673922778*^9}, 3.721857011688685*^9, 
   3.722430647323399*^9, 3.7224312463368063`*^9, 3.722431454544351*^9, {
   3.7232746813926697`*^9, 3.7232746951891108`*^9}, {3.72600301998534*^9, 
   3.7260030254720893`*^9}, {3.7260031048671217`*^9, 3.726003112165004*^9}, {
   3.7260031485923166`*^9, 3.7260031582065253`*^9}, {3.7260042240981035`*^9, 
   3.726004281203994*^9}, {3.726004341604781*^9, 3.7260043468924217`*^9}, 
   3.7260703597809105`*^9},
 CellLabel->
  "In[1997]:=",ExpressionUUID->"cb19113c-b58a-4987-bb51-681e5dcac760"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["8. InitialDensityOperator", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.721784520604287*^9, 
   3.721784528586845*^9}, {3.7217957989634943`*^9, 3.721795803242463*^9}, {
   3.7217977282049847`*^9, 3.721797734068042*^9}, {3.721799704018629*^9, 
   3.721799710660409*^9}},ExpressionUUID->"59c24145-5bda-4a5f-9068-\
28f6fcb0eaf8"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"cdf21de4-bb59-432f-a1db-\
e35fac802ba0"],

Cell["do this after InputRule completed", "Text",
 CellChangeTimes->{{3.70048766577647*^9, 3.700487684342527*^9}, {
  3.700487825172986*^9, 3.700487830817691*^9}, {3.7217981597060127`*^9, 
  3.7217981710317097`*^9}, {3.721798261256089*^9, 3.7217982622291107`*^9}, {
  3.721799741569415*^9, 
  3.721799746832315*^9}},ExpressionUUID->"a9a05aba-6586-4021-9b9b-\
cfe807b92737"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"inputrulest", ":", "True"}], ",", 
        RowBox[{"morest1", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", 
               "\"\<InitialDensityOperator\>\""}], "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
              "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest2___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", "True", ",", "morest1", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest2"}], "}"}], 
     ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700487694223301*^9, 3.70048781391779*^9}, {
   3.7191693214038315`*^9, 3.7191693596416545`*^9}, {3.721797777869356*^9, 
   3.72179778087085*^9}, {3.721797849901107*^9, 3.72179786944099*^9}, {
   3.72179791512945*^9, 3.721797933731482*^9}, {3.721797976486981*^9, 
   3.7217980423259983`*^9}, {3.721798194371152*^9, 3.721798254502233*^9}, {
   3.72179948341151*^9, 3.721799483968858*^9}, {3.72179975166746*^9, 
   3.7217998034466267`*^9}, 3.721857018016018*^9},
 CellLabel->
  "In[1998]:=",ExpressionUUID->"ace1721e-617b-45b1-8406-577a09b52ce1"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 
   3.7010863549023314`*^9},ExpressionUUID->"7206a89c-db06-44eb-8164-\
fb141173a1b6"],

Cell[CellGroupData[{

Cell["convert to Operator in ZeemanBasis", "Subsubsection",
 CellChangeTimes->{{3.7010864603545218`*^9, 3.7010864659691887`*^9}, {
  3.7010867609612627`*^9, 
  3.7010867637837343`*^9}},ExpressionUUID->"b0119d5a-7039-4ed9-8a34-\
ea4cde80b0a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", 
               "\"\<InitialDensityOperator\>\""}], "]"}], "-", "1"}], "}"}]}],
           "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "\[Rho]0_", ",", "more___", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]0vec", ",", "opbasis", ",", "basis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"opbasis", ",", "basis"}], "}"}], "=", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
           "morest"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"Operator", "[", 
           RowBox[{"\[Rho]0", ",", 
            RowBox[{"ZeemanBasis", "[", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"FilterRules", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
                 "opts"}], "}"}], ",", 
               RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], 
           "]"}]}], ",", "\[IndentingNewLine]", "more", ",", "opts"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505831667958248*^9, 3.505831748490183*^9}, {
   3.505832309441513*^9, 3.505832312941794*^9}, {3.505832599922316*^9, 
   3.505832740073543*^9}, {3.506250210416719*^9, 3.506250237611433*^9}, {
   3.513186469192401*^9, 3.513186469829424*^9}, 3.51318681605831*^9, 
   3.513187651452241*^9, {3.532147304855291*^9, 3.532147439537492*^9}, {
   3.532149329896896*^9, 3.532149338319561*^9}, 3.532149372569627*^9, {
   3.533181425525577*^9, 3.533181430442663*^9}, {3.533182504670869*^9, 
   3.5331825131288147`*^9}, {3.5659827691398582`*^9, 3.565982782116868*^9}, {
   3.5659830268451757`*^9, 3.5659830434887037`*^9}, {3.5659830820186157`*^9, 
   3.56598308349586*^9}, 3.5659838988626003`*^9, 3.6184039837849693`*^9, 
   3.618404028231964*^9, {3.618480923911574*^9, 3.6184809991430187`*^9}, 
   3.618485751950809*^9, 3.618485814320808*^9, {3.699543683122245*^9, 
   3.6995437105638285`*^9}, {3.699543897851222*^9, 3.6995439024443913`*^9}, {
   3.6995439475325623`*^9, 3.699543947873602*^9}, {3.6995440913626137`*^9, 
   3.6995440975835285`*^9}, {3.6995441636725135`*^9, 3.699544163910169*^9}, {
   3.699544238338408*^9, 3.699544244690833*^9}, {3.699544291911933*^9, 
   3.6995443148411703`*^9}, {3.6995446345330815`*^9, 3.699544636765685*^9}, {
   3.6995448209907894`*^9, 3.699544822105002*^9}, {3.699544856660718*^9, 
   3.6995448878803053`*^9}, {3.699544938301976*^9, 3.6995449433501616`*^9}, {
   3.6999596180955772`*^9, 3.6999596194796953`*^9}, {3.70108647947666*^9, 
   3.701086681379079*^9}, {3.701086775234342*^9, 3.7010868771727133`*^9}, {
   3.7027831377703085`*^9, 3.7027831434043283`*^9}, {3.7027831936710367`*^9, 
   3.7027831939812574`*^9}, {3.709549793846383*^9, 3.70954982461693*^9}, {
   3.7095499072778535`*^9, 3.7095499404445014`*^9}, {3.721799867297668*^9, 
   3.721799875013403*^9}, {3.721799910533779*^9, 3.721800032000155*^9}, 
   3.7218002167971087`*^9, {3.721800250827134*^9, 3.7218002524327374`*^9}, 
   3.7218570206551237`*^9, {3.7218598425731297`*^9, 3.721859844820859*^9}},
 CellLabel->
  "In[1999]:=",ExpressionUUID->"a7df5fe0-7fc3-4b62-93e8-bd407c0cec09"]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["9. Observables", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.721784520604287*^9, 
   3.721784528586845*^9}, {3.7217957989634943`*^9, 3.721795803242463*^9}, {
   3.7217977282049847`*^9, 3.721797734068042*^9}, {3.721799704018629*^9, 
   3.721799710660409*^9}, {3.7218001690356913`*^9, 
   3.721800184268475*^9}},ExpressionUUID->"de654e4c-0043-45b4-a583-\
625044a7878b"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"273a9540-c130-4323-9efc-\
8d76d424b611"],

Cell["do this after InputRule completed", "Text",
 CellChangeTimes->{{3.70048766577647*^9, 3.700487684342527*^9}, {
  3.700487825172986*^9, 3.700487830817691*^9}, {3.7217981597060127`*^9, 
  3.7217981710317097`*^9}, {3.721798261256089*^9, 3.7217982622291107`*^9}, {
  3.721799741569415*^9, 
  3.721799746832315*^9}},ExpressionUUID->"6388bf50-f2aa-44d6-a0a0-\
34aafaeba49c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"inputrulest", ":", "True"}], ",", 
        RowBox[{"morest1", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", "\"\<Observables\>\""}], 
              "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
              "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest2___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", "True", ",", "morest1", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest2"}], "}"}], 
     ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700487694223301*^9, 3.70048781391779*^9}, {
   3.7191693214038315`*^9, 3.7191693596416545`*^9}, {3.721797777869356*^9, 
   3.72179778087085*^9}, {3.721797849901107*^9, 3.72179786944099*^9}, {
   3.72179791512945*^9, 3.721797933731482*^9}, {3.721797976486981*^9, 
   3.7217980423259983`*^9}, {3.721798194371152*^9, 3.721798254502233*^9}, {
   3.72179948341151*^9, 3.721799483968858*^9}, {3.72179975166746*^9, 
   3.7217998034466267`*^9}, 3.721800750309065*^9, 3.721857033003721*^9},
 CellLabel->
  "In[2000]:=",ExpressionUUID->"6c093549-5bdb-483f-b4ec-897c70fad11b"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
check for use of PolarizationLevelOperator or \
SingletPolarizationLevelOperator with a non-rigorous density operator\
\>", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 3.7010863549023314`*^9, {3.721800818245639*^9, 
   3.721800819925597*^9}, {3.721800957810176*^9, 3.721800976840838*^9}, {
   3.7218014223002577`*^9, 
   3.721801431810382*^9}},ExpressionUUID->"d6d2d919-aa34-4dd4-a496-\
5cccc41376a9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<Observables\>\""}], 
          "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]0_", ",", 
     "obs_", ",", "more___", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Chop", "[", 
           RowBox[{
            RowBox[{"Tr", "@", 
             RowBox[{"MatrixRepresentation", "[", 
              RowBox[{"\[Rho]0", ",", 
               RowBox[{"ZeemanBasis", "[", "]"}]}], "]"}]}], "-", "1"}], 
           "]"}], "\[NotEqual]", "0"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"FreeQ", "[", 
               RowBox[{"obs", ",", "PolarizationLevelOperator"}], "]"}]}], 
             ",", "\[IndentingNewLine]", "\t", 
             RowBox[{"Message", "[", 
              RowBox[{"PolarizationLevelOperator", "::", "inval\[Rho]"}], 
              "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"FreeQ", "[", 
               RowBox[{"obs", ",", "SingletPolarizationLevelOperator"}], 
               "]"}]}], ",", "\[IndentingNewLine]", "\t", 
             RowBox[{"Message", "[", 
              RowBox[{
              "SingletPolarizationLevelOperator", "::", "inval\[Rho]"}], 
              "]"}]}], "\[IndentingNewLine]", "]"}]}], ")"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Evaluate", "@", 
          RowBox[{"{", 
           RowBox[{"prefix", ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
            "morest"}], "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]0", ",", 
         RowBox[{"ReleaseHold", "@", "obs"}], ",", "more", ",", "opts"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505831667958248*^9, 3.505831748490183*^9}, {
   3.505832309441513*^9, 3.505832312941794*^9}, {3.505832599922316*^9, 
   3.505832740073543*^9}, {3.506250210416719*^9, 3.506250237611433*^9}, {
   3.513186469192401*^9, 3.513186469829424*^9}, 3.51318681605831*^9, 
   3.513187651452241*^9, {3.532147304855291*^9, 3.532147439537492*^9}, {
   3.532149329896896*^9, 3.532149338319561*^9}, 3.532149372569627*^9, {
   3.533181425525577*^9, 3.533181430442663*^9}, {3.533182504670869*^9, 
   3.5331825131288147`*^9}, {3.5659827691398582`*^9, 3.565982782116868*^9}, {
   3.5659830268451757`*^9, 3.5659830434887037`*^9}, {3.5659830820186157`*^9, 
   3.56598308349586*^9}, 3.5659838988626003`*^9, 3.6184039837849693`*^9, 
   3.618404028231964*^9, {3.618480923911574*^9, 3.6184809991430187`*^9}, 
   3.618485751950809*^9, 3.618485814320808*^9, {3.699543683122245*^9, 
   3.6995437105638285`*^9}, {3.699543897851222*^9, 3.6995439024443913`*^9}, {
   3.6995439475325623`*^9, 3.699543947873602*^9}, {3.6995440913626137`*^9, 
   3.6995440975835285`*^9}, {3.6995441636725135`*^9, 3.699544163910169*^9}, {
   3.699544238338408*^9, 3.699544244690833*^9}, {3.699544291911933*^9, 
   3.6995443148411703`*^9}, {3.6995446345330815`*^9, 3.699544636765685*^9}, {
   3.6995448209907894`*^9, 3.699544822105002*^9}, {3.699544856660718*^9, 
   3.6995448878803053`*^9}, {3.699544938301976*^9, 3.6995449433501616`*^9}, {
   3.6999596180955772`*^9, 3.6999596194796953`*^9}, {3.70108647947666*^9, 
   3.701086681379079*^9}, {3.701086775234342*^9, 3.7010868771727133`*^9}, {
   3.7027831377703085`*^9, 3.7027831434043283`*^9}, {3.7027831936710367`*^9, 
   3.7027831939812574`*^9}, {3.709549793846383*^9, 3.70954982461693*^9}, {
   3.7095499072778535`*^9, 3.7095499404445014`*^9}, {3.721799867297668*^9, 
   3.721799875013403*^9}, {3.721799910533779*^9, 3.721800032000155*^9}, 
   3.7218002167971087`*^9, {3.721800250827134*^9, 3.7218002524327374`*^9}, {
   3.721800835186301*^9, 3.7218009105389643`*^9}, {3.721800998969076*^9, 
   3.7218011424446497`*^9}, {3.721801223075515*^9, 3.7218013419579268`*^9}, {
   3.7218013741345243`*^9, 3.7218014016754217`*^9}, {3.721801678367235*^9, 
   3.7218016833218203`*^9}, {3.7218020174255667`*^9, 3.721802020655949*^9}, {
   3.7218565670594473`*^9, 3.7218565800988913`*^9}, 3.721857024487259*^9, 
   3.721858729003027*^9, {3.721860016953003*^9, 3.7218600308714113`*^9}},
 CellLabel->
  "In[2001]:=",ExpressionUUID->"358b729a-67eb-49bf-9c19-15b90103cd77"]
}, Open  ]],

Cell[CellGroupData[{

Cell["standardize", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 3.7010863549023314`*^9, {3.721800818245639*^9, 
   3.721800819925597*^9}},ExpressionUUID->"05fd98e0-e106-4ae9-8ae5-\
350a7c6e8c85"],

Cell[CellGroupData[{

Cell["place single observable in list", "Subsubsection",
 CellChangeTimes->{{3.7010864603545218`*^9, 3.7010864659691887`*^9}, {
  3.7010867609612627`*^9, 3.7010867637837343`*^9}, {3.7218008227682543`*^9, 
  3.721800827669806*^9}},ExpressionUUID->"54c8feb5-5832-4c7c-8868-\
b32e657d0857"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<Observables\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "\[IndentingNewLine]", "morest___"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "\[Rho]0_", ",", "obs_", ",", "more___", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"prefix", ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], "}"}], 
        ",", "morest"}], "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]0", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{"obs", ",", "_List"}], "]"}], ",", "obs", ",", 
        RowBox[{"{", "obs", "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
     "more", ",", "opts"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505831667958248*^9, 3.505831748490183*^9}, {
   3.505832309441513*^9, 3.505832312941794*^9}, {3.505832599922316*^9, 
   3.505832740073543*^9}, {3.506250210416719*^9, 3.506250237611433*^9}, {
   3.513186469192401*^9, 3.513186469829424*^9}, 3.51318681605831*^9, 
   3.513187651452241*^9, {3.532147304855291*^9, 3.532147439537492*^9}, {
   3.532149329896896*^9, 3.532149338319561*^9}, 3.532149372569627*^9, {
   3.533181425525577*^9, 3.533181430442663*^9}, {3.533182504670869*^9, 
   3.5331825131288147`*^9}, {3.5659827691398582`*^9, 3.565982782116868*^9}, {
   3.5659830268451757`*^9, 3.5659830434887037`*^9}, {3.5659830820186157`*^9, 
   3.56598308349586*^9}, 3.5659838988626003`*^9, 3.6184039837849693`*^9, 
   3.618404028231964*^9, {3.618480923911574*^9, 3.6184809991430187`*^9}, 
   3.618485751950809*^9, 3.618485814320808*^9, {3.699543683122245*^9, 
   3.6995437105638285`*^9}, {3.699543897851222*^9, 3.6995439024443913`*^9}, {
   3.6995439475325623`*^9, 3.699543947873602*^9}, {3.6995440913626137`*^9, 
   3.6995440975835285`*^9}, {3.6995441636725135`*^9, 3.699544163910169*^9}, {
   3.699544238338408*^9, 3.699544244690833*^9}, {3.699544291911933*^9, 
   3.6995443148411703`*^9}, {3.6995446345330815`*^9, 3.699544636765685*^9}, {
   3.6995448209907894`*^9, 3.699544822105002*^9}, {3.699544856660718*^9, 
   3.6995448878803053`*^9}, {3.699544938301976*^9, 3.6995449433501616`*^9}, {
   3.6999596180955772`*^9, 3.6999596194796953`*^9}, {3.70108647947666*^9, 
   3.701086681379079*^9}, {3.701086775234342*^9, 3.7010868771727133`*^9}, {
   3.7027831377703085`*^9, 3.7027831434043283`*^9}, {3.7027831936710367`*^9, 
   3.7027831939812574`*^9}, {3.709549793846383*^9, 3.70954982461693*^9}, {
   3.7095499072778535`*^9, 3.7095499404445014`*^9}, {3.721799867297668*^9, 
   3.721799875013403*^9}, {3.721799910533779*^9, 3.721800032000155*^9}, 
   3.7218002167971087`*^9, {3.721800250827134*^9, 3.7218002524327374`*^9}, {
   3.721800835186301*^9, 3.7218009105389643`*^9}, {3.721801471314417*^9, 
   3.721801474634534*^9}, {3.7218015362357903`*^9, 3.721801550703266*^9}, {
   3.721856588548257*^9, 3.7218565961540833`*^9}, 3.721857037870182*^9, 
   3.7218587401148863`*^9, {3.721859701528343*^9, 3.721859703944476*^9}, 
   3.721860040625682*^9},
 CellLabel->
  "In[2002]:=",ExpressionUUID->"42a973c6-fdce-47fb-b1a1-855ea56ce2b7"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["convert to Operator form", "Subsection",
 CellChangeTimes->{{3.7010864603545218`*^9, 3.7010864659691887`*^9}, {
  3.7010867609612627`*^9, 3.7010867637837343`*^9}, {3.7218008227682543`*^9, 
  3.721800827669806*^9}, {3.7218015666949177`*^9, 
  3.721801569930509*^9}},ExpressionUUID->"5d91c211-ba3d-48d2-a185-\
6afe989cd5f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<Observables\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{
          "True", ",", "True", ",", "True", ",", "False", ",", 
           "morelocst___"}], "}"}]}], ",", "\[IndentingNewLine]", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]0_", ",", 
     "obs_List", ",", "more___", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"prefix", ",", 
        RowBox[{"{", 
         RowBox[{
         "True", ",", "True", ",", "True", ",", "True", ",", "morelocst"}], 
         "}"}], ",", "morest"}], "}"}]}], ",", "\[IndentingNewLine]", 
     "\[Rho]0", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Operator", "[", 
         RowBox[{"#", ",", 
          RowBox[{"ZeemanBasis", "[", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
               "opts"}], "}"}], ",", 
             RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], "]"}], 
        "&"}], "/@", "obs"}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", "more", ",", "opts"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505831667958248*^9, 3.505831748490183*^9}, {
   3.505832309441513*^9, 3.505832312941794*^9}, {3.505832599922316*^9, 
   3.505832740073543*^9}, {3.506250210416719*^9, 3.506250237611433*^9}, {
   3.513186469192401*^9, 3.513186469829424*^9}, 3.51318681605831*^9, 
   3.513187651452241*^9, {3.532147304855291*^9, 3.532147439537492*^9}, {
   3.532149329896896*^9, 3.532149338319561*^9}, 3.532149372569627*^9, {
   3.533181425525577*^9, 3.533181430442663*^9}, {3.533182504670869*^9, 
   3.5331825131288147`*^9}, {3.5659827691398582`*^9, 3.565982782116868*^9}, {
   3.5659830268451757`*^9, 3.5659830434887037`*^9}, {3.5659830820186157`*^9, 
   3.56598308349586*^9}, 3.5659838988626003`*^9, 3.6184039837849693`*^9, 
   3.618404028231964*^9, {3.618480923911574*^9, 3.6184809991430187`*^9}, 
   3.618485751950809*^9, 3.618485814320808*^9, {3.699543683122245*^9, 
   3.6995437105638285`*^9}, {3.699543897851222*^9, 3.6995439024443913`*^9}, {
   3.6995439475325623`*^9, 3.699543947873602*^9}, {3.6995440913626137`*^9, 
   3.6995440975835285`*^9}, {3.6995441636725135`*^9, 3.699544163910169*^9}, {
   3.699544238338408*^9, 3.699544244690833*^9}, {3.699544291911933*^9, 
   3.6995443148411703`*^9}, {3.6995446345330815`*^9, 3.699544636765685*^9}, {
   3.6995448209907894`*^9, 3.699544822105002*^9}, {3.699544856660718*^9, 
   3.6995448878803053`*^9}, {3.699544938301976*^9, 3.6995449433501616`*^9}, {
   3.6999596180955772`*^9, 3.6999596194796953`*^9}, {3.70108647947666*^9, 
   3.701086681379079*^9}, {3.701086775234342*^9, 3.7010868771727133`*^9}, {
   3.7027831377703085`*^9, 3.7027831434043283`*^9}, {3.7027831936710367`*^9, 
   3.7027831939812574`*^9}, {3.709549793846383*^9, 3.70954982461693*^9}, {
   3.7095499072778535`*^9, 3.7095499404445014`*^9}, {3.721799867297668*^9, 
   3.721799875013403*^9}, {3.721799910533779*^9, 3.721800032000155*^9}, 
   3.7218002167971087`*^9, {3.721800250827134*^9, 3.7218002524327374`*^9}, {
   3.721800835186301*^9, 3.7218009105389643`*^9}, {3.721801471314417*^9, 
   3.721801474634534*^9}, {3.7218015362357903`*^9, 3.721801550703266*^9}, {
   3.721801620978948*^9, 3.721801668971882*^9}, {3.7218020297290907`*^9, 
   3.721802034855185*^9}, 3.72185704031859*^9, {3.721857849565053*^9, 
   3.721857930400457*^9}, {3.721858019223929*^9, 3.721858022221402*^9}, 
   3.721858744785597*^9, {3.721859723625017*^9, 3.72185972624787*^9}, 
   3.721860045271552*^9},
 CellLabel->
  "In[2003]:=",ExpressionUUID->"e913e85e-bff2-4830-a82c-6ec82556b37f"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["10. Events", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.72177606254001*^9, 
   3.721776065403016*^9}, 3.721800716003613*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"72a411cd-d2a3-48a0-9667-db2f19119268"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}},ExpressionUUID->"7229ba80-98c1-4082-9b67-\
ab6cbeabb1e8"],

Cell["request when InputRule has been done", "Text",
 CellChangeTimes->{{3.721776346443213*^9, 3.7217763670266323`*^9}, {
  3.721776532785104*^9, 3.721776538969142*^9}, {3.721776589897064*^9, 
  3.7217765903027267`*^9}},ExpressionUUID->"87b70449-4f12-4cb0-ab35-\
3138449dc153"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"morest1", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "True", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"morest2", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}],
               "]"}], "-", 
             RowBox[{"StatusPosition", "[", 
              RowBox[{
              "TransformationAmplitudeTable", ",", "\"\<InputRule\>\""}], 
              "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"eventsst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "moreeventsst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest3___"}], "\[IndentingNewLine]", "}"}]}],
      ",", "\[IndentingNewLine]", "items___", ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "morest1", ",", "True", ",", "morest2", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "moreeventsst"}], "}"}], ",", 
       "\[IndentingNewLine]", "morest3"}], "}"}], ",", "\[IndentingNewLine]", 
     "items", ",", "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, {3.721776238800034*^9, 
   3.721776279522221*^9}, {3.721776387581098*^9, 3.7217764377752867`*^9}, {
   3.721859903123616*^9, 3.7218599032573233`*^9}, {3.721860091478952*^9, 
   3.72186010291691*^9}},
 CellLabel->
  "In[2004]:=",ExpressionUUID->"788bd88d-c90a-4d91-8a50-b37c3751f913"]
}, Closed]],

Cell[CellGroupData[{

Cell["insert null event if needed", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}, {3.721776307391692*^9, 3.72177631150943*^9}, {
   3.721777459537271*^9, 3.721777464751844*^9}, {3.7217775695881987`*^9, 
   3.721777571386384*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"4dd47fb8-d58e-4c0a-8899-5296656e2fa3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"morest1", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"eventsst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "moreeventsst___"}], "}"}]}], 
        ",", "\[IndentingNewLine]", "morest2___"}], "\[IndentingNewLine]", 
       "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]ini_", ",", "ops_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"notevent", ":", 
      RowBox[{"Except", "[", 
       RowBox[{
        RowBox[{"_", "?", "ValidEventSpecificationQ"}], "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "ValidEventSpecificationQ"}], ".."}], "}"}], "|", 
        
        RowBox[{"_", "?", "PulseSequenceQ"}]}], "]"}]}], ",", 
     "\[IndentingNewLine]", "more___", ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"morest1", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "moreeventsst"}], "}"}], ",", 
       "\[IndentingNewLine]", "morest2"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[Rho]ini", ",", "ops", ",", "None", ",", "notevent", ",", "more", ",", 
     "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, {3.721776238800034*^9, 
   3.721776279522221*^9}, {3.721776329863151*^9, 3.7217763359485598`*^9}, {
   3.72177644948855*^9, 3.721776466830428*^9}, {3.721776498613871*^9, 
   3.721776504507472*^9}, {3.7217766350918303`*^9, 3.721776694665353*^9}, {
   3.7217767629917107`*^9, 3.7217767675650043`*^9}, {3.721777321432776*^9, 
   3.721777327495986*^9}, {3.721777360056284*^9, 3.721777360877708*^9}, {
   3.721777563549159*^9, 3.7217775648669767`*^9}, {3.721860114087949*^9, 
   3.721860133318347*^9}, {3.721886390023093*^9, 3.7218863945107203`*^9}, {
   3.7443538407676983`*^9, 
   3.744353842706863*^9}},ExpressionUUID->"9c3876eb-d2de-455c-ab4d-\
293af53e7f59"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"morest1", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"eventsst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "moreeventsst___"}], "}"}]}], 
        ",", "\[IndentingNewLine]", "morest2___"}], "\[IndentingNewLine]", 
       "}"}]}], ",", "\[IndentingNewLine]", "\[Rho]ini_", ",", "ops_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"event", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"_", "?", "ValidEventSpecificationQ"}], "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "ValidEventSpecificationQ"}], ".."}], "}"}], "|", 
        
        RowBox[{"_", "?", "PulseSequenceQ"}]}], ")"}]}], ",", 
     "\[IndentingNewLine]", "more___", ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"morest1", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "moreeventsst"}], "}"}], ",", 
       "\[IndentingNewLine]", "morest2"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[Rho]ini", ",", "ops", ",", "event", ",", "more", ",", 
     "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, {3.721776238800034*^9, 
   3.721776279522221*^9}, {3.721776329863151*^9, 3.7217763359485598`*^9}, {
   3.72177644948855*^9, 3.721776466830428*^9}, {3.721776498613871*^9, 
   3.721776504507472*^9}, {3.7217766350918303`*^9, 3.721776694665353*^9}, {
   3.7217767629917107`*^9, 3.7217767675650043`*^9}, {3.721777321432776*^9, 
   3.721777327495986*^9}, {3.721777360056284*^9, 3.721777360877708*^9}, {
   3.721777563549159*^9, 3.721777610680574*^9}, {3.721860117454707*^9, 
   3.7218601367978897`*^9}, 3.7218864099391527`*^9, 
   3.744353864307107*^9},ExpressionUUID->"4065f96c-fc92-4404-87fe-\
caaa79465c97"]
}, Closed]],

Cell[CellGroupData[{

Cell["implement PulseSequence if needed", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}, {3.721776307391692*^9, 3.72177631150943*^9}, {
   3.721777459537271*^9, 3.721777464751844*^9}, {3.7217775695881987`*^9, 
   3.721777571386384*^9}, {3.725520810908017*^9, 3.725520817283524*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"4821143a-8045-446d-8f7c-04478204e2b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"morest1", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"eventsst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "moreeventsst___"}],
           "}"}]}], ",", "\[IndentingNewLine]", "morest2___"}], 
       "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
     "\[Rho]ini_", ",", "ops_", ",", "\[IndentingNewLine]", "event_", ",", 
     "\[IndentingNewLine]", "more___", ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"morest1", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True", ",", "moreeventsst"}], 
        "}"}], ",", "\[IndentingNewLine]", "morest2"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[Rho]ini", ",", "ops", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"PulseSequenceQ", "[", "event", "]"}], ",", 
        RowBox[{"PulseSequence", "[", "event", "]"}], ",", "event"}], "]"}]}],
      ",", "\[IndentingNewLine]", "more", ",", "\[IndentingNewLine]", 
     "opts"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, {3.721776238800034*^9, 
   3.721776279522221*^9}, {3.721776329863151*^9, 3.7217763359485598`*^9}, {
   3.72177644948855*^9, 3.721776466830428*^9}, {3.721776498613871*^9, 
   3.721776504507472*^9}, {3.7217766350918303`*^9, 3.721776694665353*^9}, {
   3.7217767629917107`*^9, 3.7217767675650043`*^9}, {3.721777321432776*^9, 
   3.721777327495986*^9}, {3.721777360056284*^9, 3.721777360877708*^9}, {
   3.721777563549159*^9, 3.721777610680574*^9}, {3.721860117454707*^9, 
   3.7218601367978897`*^9}, 3.7218864099391527`*^9, {3.7224219445805798`*^9, 
   3.722421946954934*^9}, 3.723295267640069*^9, {3.7255208870106363`*^9, 
   3.7255209514847603`*^9}, {3.725521475540057*^9, 3.725521521484353*^9}, {
   3.7284245847330475`*^9, 3.7284245925325823`*^9}, {3.728424622842109*^9, 
   3.7284246912406807`*^9}, {3.7284247298120728`*^9, 
   3.7284247299911995`*^9}, {3.7284248438810787`*^9, 3.728424850039452*^9}, {
   3.728424898709015*^9, 3.728424964556777*^9}, {3.7284250093766055`*^9, 
   3.7284250437157526`*^9}, {3.728425077595812*^9, 3.7284250792850127`*^9}, {
   3.7284256045987663`*^9, 3.728425604915991*^9}, {3.7443527803412437`*^9, 
   3.744352789678001*^9}, {3.7443544038067904`*^9, 3.744354406047573*^9}, {
   3.745509014316646*^9, 
   3.745509015907444*^9}},ExpressionUUID->"7fabbfa7-aff2-4985-b5b8-\
60c41acf30f9"]
}, Closed]],

Cell[CellGroupData[{

Cell["check", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}, {3.721776307391692*^9, 3.72177631150943*^9}, {
   3.7217767084888153`*^9, 3.721776709575411*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"e4af1e57-bf04-4fbc-a7c6-94d7819e1b24"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"morest1", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Events\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"eventsst", ":", 
         RowBox[{"{", 
          RowBox[{
          "True", ",", "True", ",", "True", ",", "False", ",", 
           "moreeventsst___"}], "}"}]}], ",", "\[IndentingNewLine]", 
        "morest2___"}], "\[IndentingNewLine]", "}"}]}], ",", 
     "\[IndentingNewLine]", "\[Rho]ini_", ",", "ops_", ",", "event_", ",", 
     "more___", ",", "\[IndentingNewLine]", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{"event", ",", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"_", "?", "ValidEventSpecificationQ"}], "|", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"_", "?", "ValidEventSpecificationQ"}], ".."}], "}"}], "|",
          "_PulseSequence", "|", "_EventList"}], ")"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"morest1", ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
          "True", ",", "True", ",", "True", ",", "True", ",", 
           "moreeventsst"}], "}"}], ",", "\[IndentingNewLine]", "morest2"}], 
        "}"}], ",", "\[IndentingNewLine]", "\[Rho]ini", ",", "ops", ",", 
       "event", ",", "more", ",", "\[IndentingNewLine]", "opts"}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"TransformationAmplitudeTable", "::", "invalevent"}], "]"}], 
       ";", "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9, {
   3.721757653113482*^9, 3.721757661240988*^9}, {3.721762880762374*^9, 
   3.721763048657189*^9}, {3.721763090376438*^9, 3.7217631137087107`*^9}, {
   3.7217633762495403`*^9, 3.721763443329236*^9}, 3.721763930725128*^9, {
   3.721764119049327*^9, 3.721764359869021*^9}, {3.721770277556265*^9, 
   3.721770407344914*^9}, 3.72177397826121*^9, {3.721776238800034*^9, 
   3.721776279522221*^9}, {3.721776329863151*^9, 3.7217763359485598`*^9}, {
   3.72177644948855*^9, 3.721776466830428*^9}, {3.721776498613871*^9, 
   3.721776504507472*^9}, {3.7217766350918303`*^9, 3.7217767501345177`*^9}, {
   3.721776797478134*^9, 3.7217768395979357`*^9}, {3.721776875784424*^9, 
   3.721776914637542*^9}, 3.7218601436213713`*^9, 3.721886512776519*^9, {
   3.7443528060797987`*^9, 3.744352813890793*^9}, 
   3.744354275250288*^9},ExpressionUUID->"015de6b3-23f1-43c5-92cd-\
a43c5fa8329a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["11. Precalculation (* not yet implemented *)", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 3.701097884054083*^9}, 3.721762771111022*^9, 
   3.721762853476575*^9, {3.721763859181538*^9, 3.721763865131412*^9}, {
   3.721770200093958*^9, 3.7217702092548943`*^9}, {3.72177606254001*^9, 
   3.721776065403016*^9}, 3.721800716003613*^9, {3.721859958818491*^9, 
   3.721859966559452*^9}, {3.7218610048865433`*^9, 3.721861005948319*^9}, {
   3.722127068227075*^9, 
   3.722127071119166*^9}},ExpressionUUID->"369030bf-526b-4900-9286-\
7ddaa80fdb34"],

Cell[CellGroupData[{

Cell["skip", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.721763901954496*^9, 3.721763934144582*^9}, {3.721773264226529*^9, 
   3.721773271616001*^9}, {3.721860282865163*^9, 
   3.721860283693969*^9}},ExpressionUUID->"341362fe-6be5-4a77-945f-\
ea98da032a64"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "\"\<Precalculation\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", 
        "\[IndentingNewLine]", "morest___"}], "\[IndentingNewLine]", "}"}]}], 
     ",", "\[IndentingNewLine]", "more___", ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"prefix", ",", "True", ",", "morest"}], "}"}]}], ",", "more", 
     ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.721860169314082*^9, 3.721860276774633*^9}},
 CellLabel->
  "In[2008]:=",ExpressionUUID->"9c806ab3-7289-4cfa-aa78-b81cda9fa3e1"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["12. UserLevel", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469882637143063*^9, 
   3.469882639820516*^9}, 3.4698965783855743`*^9, {3.497350131321055*^9, 
   3.497350134039557*^9}, 3.497572555273549*^9, {3.49962571930704*^9, 
   3.499625720633676*^9}, 3.700309573483725*^9, {3.700323416023525*^9, 
   3.700323416886857*^9}, 3.700325339948*^9, 3.700481393433628*^9, 
   3.7005714895228167`*^9, {3.700579885774226*^9, 3.7005799122948*^9}, 
   3.701092012391735*^9, {3.701092960495016*^9, 3.7010929611494503`*^9}, {
   3.7010937617650757`*^9, 3.701093778079844*^9}, {3.7010979198596363`*^9, 
   3.701097920532009*^9}, {3.721861748713746*^9, 3.721861749480152*^9}, {
   3.7224215901583347`*^9, 3.722421590255219*^9}, {3.74550782057421*^9, 
   3.745507822300722*^9}, 3.7455086821914587`*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"38c9a9a2-0151-4a62-b036-c0f208431cd7"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"bc63e5bb-4856-4daa-8c1f-1a46a90f7f88"],

Cell["only request when everything else is done", "Text",
 CellChangeTimes->{{3.7010920581339617`*^9, 3.701092065349743*^9}, {
  3.701092546206051*^9, 
  3.70109254684184*^9}},ExpressionUUID->"95626dc4-c212-4e69-a1de-\
ed251b01e45c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<UserLevel\>\""}], 
          "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", "morest___"}],
        "}"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"prefix", ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest"}], "}"}]}], 
     ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.70057991472042*^9, {3.701092025435781*^9, 3.701092055203823*^9}, {
   3.7010929675372458`*^9, 3.701092968310589*^9}, {3.721860409237769*^9, 
   3.721860432906308*^9}, {3.721861825126231*^9, 3.721861827756007*^9}, {
   3.72186193245578*^9, 3.7218619354030237`*^9}, {3.7224219680158978`*^9, 
   3.722421970365679*^9}, 3.745507840920343*^9, {3.745508692697071*^9, 
   3.745508695239883*^9}, 
   3.7455095357664957`*^9},ExpressionUUID->"7d775cda-662d-400f-be12-\
9d8e7da1f7d6"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 3.7010863549023314`*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"66ae6b2f-b950-49b7-b927-66b892880724"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<UserLevel\>\""}], 
          "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}], ",", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", "more___", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"minrul", ",", "ul"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"minrul", "=", 
        RowBox[{
         RowBox[{"MinimumRecommendedUserLevel", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"ul", "=", 
        RowBox[{"UserLevel", "[", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"ul", "<", "minrul"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"UserLevel", "::", "toolow"}], ",", "ul", ",", "minrul"}], 
          "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Evaluate", "@", 
          RowBox[{"{", 
           RowBox[{"prefix", ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
            "morest"}], "}"}]}], ",", "\[IndentingNewLine]", "more", ",", 
         "opts"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.701092169605324*^9, 3.701092526598296*^9}, {
   3.7010929944817467`*^9, 3.701093013403054*^9}, {3.7010934705429573`*^9, 
   3.701093752204941*^9}, {3.721860444653264*^9, 3.721860490875362*^9}, {
   3.721860549552677*^9, 3.7218605919815283`*^9}, {3.7218606616623287`*^9, 
   3.721860683099204*^9}, 3.72186183481744*^9, {3.7218619451093197`*^9, 
   3.721861952153483*^9}, {3.72242197596154*^9, 3.722422004859377*^9}, {
   3.744105661755102*^9, 3.7441056705634527`*^9}, {3.744107084064022*^9, 
   3.7441071397736*^9}, {3.744197861888859*^9, 3.744197870248898*^9}, 
   3.745507853063405*^9, {3.7455078865600433`*^9, 3.745507967483952*^9}, {
   3.745508703633057*^9, 
   3.745508713753224*^9}},ExpressionUUID->"2b71ffc1-29ef-4f45-a810-\
ba8e4eedd3a7"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["13. Ready", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469882637143063*^9, 
   3.469882639820516*^9}, 3.4698965783855743`*^9, {3.497350131321055*^9, 
   3.497350134039557*^9}, 3.497572555273549*^9, {3.49962571930704*^9, 
   3.499625720633676*^9}, 3.700309573483725*^9, {3.700323416023525*^9, 
   3.700323416886857*^9}, 3.700325339948*^9, 3.700481393433628*^9, 
   3.7005714895228167`*^9, {3.700579885774226*^9, 3.7005799122948*^9}, 
   3.701092012391735*^9, {3.701092960495016*^9, 3.7010929611494503`*^9}, {
   3.7010937617650757`*^9, 3.701093778079844*^9}, {3.7010979198596363`*^9, 
   3.701097920532009*^9}, {3.721861748713746*^9, 3.721861749480152*^9}, 
   3.745508660160902*^9},ExpressionUUID->"ee653d38-6fd7-47c6-840b-\
253b2fb0b95e"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"333c688e-f6c7-4038-ac72-\
fd8e96a37698"],

Cell["only request when everything else is done", "Text",
 CellChangeTimes->{{3.7010920581339617`*^9, 3.701092065349743*^9}, {
  3.701092546206051*^9, 
  3.70109254684184*^9}},ExpressionUUID->"c20fe1c3-e1ea-4013-9b0a-\
1b308f3d23ce"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Ready\>\""}], 
          "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"False", ",", "morelocst___"}], "}"}]}], ",", "morest___"}],
        "}"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"prefix", ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "morelocst"}], "}"}], ",", "morest"}], "}"}]}], 
     ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.70057991472042*^9, {3.701092025435781*^9, 3.701092055203823*^9}, {
   3.7010929675372458`*^9, 3.701092968310589*^9}, {3.721860409237769*^9, 
   3.721860432906308*^9}, {3.721861825126231*^9, 3.721861827756007*^9}, {
   3.72186193245578*^9, 3.7218619354030237`*^9}},
 CellLabel->
  "In[2009]:=",ExpressionUUID->"6c4b7e16-b0a1-485c-ae28-b9c2b8bbb13d"]
}, Open  ]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 
   3.7010863549023314`*^9},ExpressionUUID->"e81412e5-93fd-410a-a6f4-\
a836ad583880"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"TransformationAmplitudeTable", ",", "\"\<Ready\>\""}], 
          "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}], ",", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", "more___", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ensavvars", ",", "tabvars", ",", "suspectsymbols"}], "}"}], 
     ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ensavvars", "=", 
        RowBox[{"UnassignedSymbols", "[", 
         RowBox[{
          RowBox[{"EnsembleAverage", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tabvars", "=", 
        RowBox[{
         RowBox[{"TableVariables", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"suspectsymbols", "=", 
        RowBox[{"UnassignedSymbols", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"more", ",", "opts"}], "}"}], ",", 
          RowBox[{"PermittedSymbols", "\[Rule]", 
           RowBox[{"Join", "[", 
            RowBox[{"ensavvars", ",", "tabvars"}], "]"}]}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "suspectsymbols", "]"}], "\[Equal]", "0"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Evaluate", "@", 
            RowBox[{"{", 
             RowBox[{"prefix", ",", 
              RowBox[{"{", 
               RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
              "morest"}], "}"}]}], ",", "\[IndentingNewLine]", "more", ",", 
           "opts"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"TransformationAmplitudeTable", "::", "suspsymbs"}], ",",
              "suspectsymbols"}], "]"}], ";", "$Failed"}], ")"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.701092169605324*^9, 3.701092526598296*^9}, {
   3.7010929944817467`*^9, 3.701093013403054*^9}, {3.7010934705429573`*^9, 
   3.701093752204941*^9}, {3.721860444653264*^9, 3.721860490875362*^9}, {
   3.721860549552677*^9, 3.7218605919815283`*^9}, {3.7218606616623287`*^9, 
   3.721860683099204*^9}, 3.72186183481744*^9, {3.7218619451093197`*^9, 
   3.721861952153483*^9}, 3.722422040219071*^9},
 CellLabel->
  "In[2010]:=",ExpressionUUID->"94373a0b-4aab-4752-8c53-734a22816c64"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["computation", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957885713748*^9, {3.721861118876135*^9, 3.721861140250825*^9}, {
   3.721861426074029*^9, 3.7218614300400057`*^9}, {3.721887057113096*^9, 
   3.7218870576108294`*^9}, {3.7220535191088867`*^9, 3.722053520869001*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"71c89072-29ed-4b14-a02c-2666c1b789b7"],

Cell["second status flag {<request>,<Parallel>,<batches set up>}", "Text",
 CellChangeTimes->{{3.721864601052649*^9, 3.72186464774921*^9}, {
  3.72186474409944*^9, 3.721864744795882*^9}, {3.721864795007752*^9, 
  3.721864799347962*^9}},ExpressionUUID->"7a418f6f-e1ba-404c-a99d-\
48de30fde2e4"],

Cell[CellGroupData[{

Cell["setup batch computations", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.7218645857576847`*^9, 3.721864589068324*^9}, {3.721864737495653*^9, 
   3.721864740245639*^9}},ExpressionUUID->"6b742096-c077-471f-8b6e-\
ae07577d35cd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{"True", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"(", 
       RowBox[{"more1", ":", 
        RowBox[{"Except", "[", "GeneralStatusListPattern", "]"}]}], ")"}]}], 
     ",", "more2___", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{"True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False", ",", "False"}], "}"}], ",", "more1", ",", 
     "more2", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.70057991472042*^9, {3.701092025435781*^9, 3.701092055203823*^9}, {
   3.7010929675372458`*^9, 3.701092968310589*^9}, {3.721860409237769*^9, 
   3.721860432906308*^9}, {3.7218617667286673`*^9, 3.7218617680573397`*^9}, {
   3.721861846431069*^9, 3.721861850928974*^9}, {3.721861906617837*^9, 
   3.721861910702876*^9}, {3.7218647558642883`*^9, 3.721864771760084*^9}, {
   3.721864811094944*^9, 3.721864812193372*^9}, {3.721867691675612*^9, 
   3.721867728078298*^9}, {3.7218679893626547`*^9, 3.721868013831073*^9}},
 CellLabel->
  "In[2011]:=",ExpressionUUID->"2f6a3e85-8c70-49f1-b42b-9f93259aae0c"]
}, Closed]],

Cell[CellGroupData[{

Cell["setup Parallel", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.7218645857576847`*^9, 
   3.721864589068324*^9}},ExpressionUUID->"86035964-b07f-4df8-a169-\
248eb7bf9a3c"],

Cell["PrepareParallel if needed", "Text",
 CellChangeTimes->{{3.721862077597292*^9, 
  3.7218620817473717`*^9}},ExpressionUUID->"b7c85dc1-10d7-46b8-865d-\
7c20e5003278"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", 
    RowBox[{"True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "False", ",", "False"}], "}"}], ",", 
     "\[IndentingNewLine]", "more___", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Parallel", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}], 
           ",", 
           RowBox[{"True", "|", "All", "|", 
            RowBox[{"_", "?", "NumericQ"}]}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"PrepareParallel", "[", 
          RowBox[{"opbasis", ",", "basis", ",", "opts"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False"}], "}"}], ",", 
         "\[IndentingNewLine]", "more", ",", "opts"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5066923457061167`*^9, 3.506692417095523*^9, {3.506692453561578*^9, 
   3.506692505334669*^9}, {3.506692629031838*^9, 3.5066926957678747`*^9}, {
   3.506692736496896*^9, 3.50669284440497*^9}, {3.5066932116562147`*^9, 
   3.5066932278932133`*^9}, {3.506693484789329*^9, 3.506693509806026*^9}, 
   3.5066937284851503`*^9, {3.506693825888592*^9, 3.5066938273192873`*^9}, {
   3.506694063994944*^9, 3.5066940724142714`*^9}, {3.506694282191956*^9, 
   3.506694290211069*^9}, {3.506694359514119*^9, 3.506694371097918*^9}, 
   3.506694557239192*^9, 3.5066946187962008`*^9, {3.506694956344503*^9, 
   3.506694966203347*^9}, {3.506767553660231*^9, 3.506767555723261*^9}, 
   3.507571977254531*^9, {3.5075720101717157`*^9, 3.5075720359721937`*^9}, 
   3.5079673116836157`*^9, 3.507967455235785*^9, 3.509086006880698*^9, {
   3.511169483376247*^9, 3.5111694899172277`*^9}, {3.511179134199709*^9, 
   3.511179135156444*^9}, {3.511181612953557*^9, 3.511181615691659*^9}, 
   3.514871485726852*^9, 3.51500229615989*^9, {3.5150034460383387`*^9, 
   3.5150034755713577`*^9}, {3.532452004836784*^9, 3.532452006869091*^9}, {
   3.533115042654971*^9, 3.533115044248684*^9}, {3.533212834140656*^9, 
   3.5332128999055433`*^9}, {3.533304235024026*^9, 3.5333042542713127`*^9}, 
   3.538910585155138*^9, {3.563101653945359*^9, 3.563101655272718*^9}, 
   3.566464932293323*^9, {3.572517264107789*^9, 3.5725173812422953`*^9}, 
   3.5725174357271767`*^9, {3.572541051492104*^9, 3.572541086953547*^9}, {
   3.61530544999538*^9, 3.615305472182384*^9}, 3.615308834361294*^9, {
   3.621591784012995*^9, 3.6215917879738693`*^9}, 3.621592386701013*^9, 
   3.62159641007325*^9, {3.6572088080138273`*^9, 3.657208819332693*^9}, {
   3.657209730782929*^9, 3.6572097397898293`*^9}, {3.721861224666458*^9, 
   3.72186129455264*^9}, {3.721861357518001*^9, 3.721861360926199*^9}, {
   3.721861795308818*^9, 3.721861799464417*^9}, 3.72186185976598*^9, {
   3.721861891023263*^9, 3.721861894716977*^9}, {3.721861973369492*^9, 
   3.721861995000147*^9}, {3.721862042023798*^9, 3.721862106895032*^9}, {
   3.721864841862556*^9, 3.721864885589512*^9}, 3.721867436835265*^9, 
   3.721868742302473*^9, 3.7218690653248377`*^9, 3.721880264372191*^9},
 CellLabel->
  "In[2012]:=",ExpressionUUID->"3a784959-6a9f-4756-858a-3b923eb19081"]
}, Closed]],

Cell[CellGroupData[{

Cell["batch computations", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.7218645857576847`*^9, 3.72186459560113*^9}, {3.7218785685293407`*^9, 
   3.721878611231189*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"fde03888-fe7e-42ec-b6a2-abd6fe667c43"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "[", "\[IndentingNewLine]", 
    RowBox[{"True", ",", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "False"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[Rho]ini_", ",", "obs_", ",", "events_", ",", 
     "iterlists_", ",", "\[IndentingNewLine]", "opts___Rule"}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ensav", ",", "weights", ",", "rules", ",", "nens", ",", "nvar", ",", 
       "vars", ",", "maxbatchsize", ",", "nbatch", ",", "opbasis", ",", 
       "basis", ",", "ib", ",", "temp", ",", "tabvars", ",", "itervals", ",", 
       "rulesandweights", ",", "rulesandweightsbatches", ",", "coords", ",", 
       "amplitudes", ",", "batchresult", ",", "parallel", ",", 
       "optstopassdown"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "opbasis", ",", "basis", ",", "ensav", ",", "maxbatchsize", ",", 
          "tabvars"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "OperatorBasis", ",", "Basis", ",", "EnsembleAverage", ",", 
            "MaxBatchSize", ",", "TableVariables"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"optstopassdown", "=", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"CurrentOptionsToPassDown", "[", 
          RowBox[{
          "TransformationAmplitudeTable", ",", "TransformationAmplitude"}], 
          "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"parallel", "=", 
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Parallel", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}], 
          ",", 
          RowBox[{"True", "|", "All", "|", 
           RowBox[{"_", "?", "NumericQ"}]}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"nens", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"nvar", "=", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"iter", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"Range", "@@", 
              RowBox[{"iter", "\[LeftDoubleBracket]", 
               RowBox[{"2", ";;"}], "\[RightDoubleBracket]"}]}], "]"}]}], 
           "]"}], ",", "iterlists"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"vars", "=", 
        RowBox[{"Join", "[", 
         RowBox[{"tabvars", ",", 
          RowBox[{"First", "[", "ensav", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"itervals", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"tabvars", ",", 
            RowBox[{"Evaluate", "[", 
             RowBox[{"Sequence", "@@", "iterlists"}], "]"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{"Length", "[", "tabvars", "]"}], "-", "1"}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"rulesandweights", "=", "\[IndentingNewLine]", 
        RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Outer", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Map", "[", 
                RowBox[{
                 RowBox[{"Apply", "[", "Rule", "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Transpose", "[", 
                  RowBox[{"{", 
                   RowBox[{"vars", ",", 
                    RowBox[{"Join", "[", 
                    RowBox[{"#1", ",", 
                    RowBox[{"First", "[", "#2", "]"}]}], "]"}]}], "}"}], 
                  "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Last", "[", "#2", "]"}]}], "\[IndentingNewLine]", 
              "}"}], "&"}], ",", "\[IndentingNewLine]", "itervals", ",", 
            RowBox[{"Last", "[", "ensav", "]"}], ",", "1"}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "1"}], 
         "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"rulesandweightsbatches", "=", 
        RowBox[{"Partition", "[", 
         RowBox[{
         "rulesandweights", ",", "maxbatchsize", ",", "maxbatchsize", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "1"}], "}"}], ",", 
          RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"nbatch", "=", 
        RowBox[{"Length", "[", "rulesandweightsbatches", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"nbatch", "==", "1"}], ",", "\[IndentingNewLine]", 
         RowBox[{
         "PrintTemporary", "[", "\"\<computing using 1 batch ..\>\"", "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"PrintTemporary", "[", 
          RowBox[{"\"\<computing using \>\"", "<>", 
           RowBox[{"ToString", "[", "nbatch", "]"}], "<>", 
           "\"\< batches..\>\""}], "]"}]}], "\[IndentingNewLine]", "]"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"CombineAndSort", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Monitor", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"temp", "=", 
                RowBox[{"PrintTemporary", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                   "parallel", ",", "\"\<parallel computing batch \>\"", ",", 
                    "\"\<computing batch \>\""}], "]"}], "<>", 
                  RowBox[{"ToString", "[", "ib", "]"}], "<>", "\"\< of \>\"", 
                  "<>", 
                  RowBox[{"ToString", "[", "nbatch", "]"}], "<>", 
                  "\"\<..\>\""}], "\[IndentingNewLine]", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"rules", ",", "weights"}], "}"}], "=", 
                RowBox[{"Transpose", "[", 
                 RowBox[{
                 "rulesandweightsbatches", "\[LeftDoubleBracket]", "ib", 
                  "\[RightDoubleBracket]"}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{"parallel", ",", 
                 RowBox[{
                 "DistributeDefinitions", "[", "optstopassdown", "]"}]}], 
                "]"}], ";", "\[IndentingNewLine]", 
               RowBox[{"amplitudes", "=", 
                RowBox[{
                 RowBox[{"If", "[", 
                  RowBox[{"parallel", ",", "ParallelMap", ",", "Map"}], "]"}],
                  "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Function", "[", 
                   RowBox[{"rule", ",", "\[IndentingNewLine]", 
                    RowBox[{"TransformationAmplitude", "[", 
                    RowBox[{
                    "True", ",", "True", ",", "True", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Evaluate", "[", "\[Rho]ini", "]"}], ",", 
                    RowBox[{"Evaluate", "[", "obs", "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Evaluate", "[", 
                    RowBox[{"events", "/.", "rule"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Evaluate", "[", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
                    RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"EnsembleAverage", "\[Rule]", "None"}], ",", 
                    "opts", ",", "optstopassdown"}], "}"}], "/.", "rule"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Join", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Options", "[", "TransformationAmplitude", "]"}], 
                    ",", 
                    RowBox[{"Options", "[", "NPropagate", "]"}], ",", 
                    RowBox[{"Options", "[", "NDSolve", "]"}]}], "}"}], 
                    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                    "]"}], "\[IndentingNewLine]", "]"}]}], "]"}]}], 
                    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                   "]"}], ",", "\[IndentingNewLine]", "rules"}], 
                 "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"coords", "=", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"tabvars", "/.", "#"}], ")"}], "&"}], "/@", 
                 "rules"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"batchresult", "=", 
                RowBox[{"MapThread", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Join", "[", 
                    RowBox[{"#1", ",", 
                    RowBox[{"Times", "[", 
                    RowBox[{"#2", ",", 
                    RowBox[{"{", "#3", "}"}]}], "]"}]}], "]"}], "&"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"coords", ",", "weights", ",", "amplitudes"}], 
                   "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"NotebookDelete", "[", "temp", "]"}], ";", 
               "\[IndentingNewLine]", "batchresult"}], "\[IndentingNewLine]", 
              ")"}], ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"ib", ",", "1", ",", "nbatch"}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"ProgressIndicator", "[", 
            RowBox[{"ib", ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"nbatch", "+", "1"}]}], "}"}]}], "]"}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "opts"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.565973616626845*^9, 3.565973646938964*^9}, {
   3.565973704450218*^9, 3.565973792473486*^9}, {3.565973833957481*^9, 
   3.5659738417145357`*^9}, {3.565974054462031*^9, 3.565974486123555*^9}, {
   3.565974518256566*^9, 3.565974565209744*^9}, {3.5659798951711817`*^9, 
   3.565979896529059*^9}, {3.5661487167383833`*^9, 3.566148809409091*^9}, {
   3.566148841085351*^9, 3.566148910373026*^9}, 3.566148957582659*^9, {
   3.566148997323354*^9, 3.566148997527849*^9}, {3.566236134850613*^9, 
   3.5662361806023083`*^9}, {3.566463016717122*^9, 3.566463039597144*^9}, {
   3.566464270741766*^9, 3.566464284139461*^9}, {3.5664643242018433`*^9, 
   3.566464388867107*^9}, 3.5664645533377542`*^9, 3.566464680822782*^9, {
   3.566465258046586*^9, 3.5664652708622026`*^9}, {3.566465307380603*^9, 
   3.566465313920671*^9}, {3.5664688939931173`*^9, 3.5664688989712343`*^9}, {
   3.566903936029044*^9, 3.566903941372896*^9}, {3.5669039983988333`*^9, 
   3.5669040096094723`*^9}, {3.566904080790515*^9, 3.566904143473688*^9}, {
   3.566904551154718*^9, 3.56690457016008*^9}, {3.566904647204361*^9, 
   3.566904647327443*^9}, {3.566904824406974*^9, 3.566904825010825*^9}, {
   3.5669048800746717`*^9, 3.5669048997208843`*^9}, {3.5669053345885553`*^9, 
   3.5669053671167107`*^9}, {3.567698791691313*^9, 3.567698793381279*^9}, {
   3.572517471552414*^9, 3.57251751919834*^9}, {3.572517562343161*^9, 
   3.572517636252063*^9}, 3.572517692279484*^9, {3.572517751261952*^9, 
   3.5725177755183973`*^9}, {3.5725178221127453`*^9, 3.572517853368493*^9}, {
   3.572517884779625*^9, 3.572517894615494*^9}, {3.572520396771442*^9, 
   3.5725203991097107`*^9}, {3.572541126034028*^9, 3.5725411482382174`*^9}, 
   3.57254119425219*^9, {3.5725435942747583`*^9, 3.572543604072201*^9}, 
   3.572544029760531*^9, 3.621592413447895*^9, 3.621596422836117*^9, {
   3.640875437493799*^9, 3.640875486096925*^9}, 3.640876691247757*^9, {
   3.721864487065763*^9, 3.721864538804225*^9}, {3.721864897596545*^9, 
   3.7218649134048977`*^9}, {3.721864956938938*^9, 3.72186513328631*^9}, {
   3.721865281423382*^9, 3.7218653037727003`*^9}, {3.721865343133821*^9, 
   3.721865346341983*^9}, {3.721866441042356*^9, 3.7218665418538933`*^9}, 
   3.721866653300789*^9, {3.72186687894873*^9, 3.721866881481352*^9}, {
   3.721866966125082*^9, 3.7218669804716454`*^9}, {3.721867102381485*^9, 
   3.721867104669599*^9}, {3.721867165368045*^9, 3.721867198584531*^9}, {
   3.721867252744833*^9, 3.721867280487173*^9}, {3.721868754208745*^9, 
   3.721868888913989*^9}, {3.7218786463781137`*^9, 3.721878678280694*^9}, {
   3.721878906055903*^9, 3.7218789984119368`*^9}, {3.721879039044265*^9, 
   3.721879090826075*^9}, 3.721880092171465*^9, 3.7218802743337107`*^9, {
   3.721880318147517*^9, 3.721880329913924*^9}, {3.721880439943881*^9, 
   3.72188044162884*^9}, {3.721880827161125*^9, 3.721880851398651*^9}, {
   3.721882519744735*^9, 3.7218825264857616`*^9}, 3.722467479402416*^9, {
   3.7224696711634207`*^9, 3.722469697911283*^9}, {3.722469729963874*^9, 
   3.72246975269143*^9}, {3.722471133309705*^9, 3.7224711392934837`*^9}, {
   3.7224712406604*^9, 3.722471241310656*^9}, {3.722471307205851*^9, 
   3.722471311208465*^9}, {3.722471421178219*^9, 3.7224714217819147`*^9}, {
   3.723290739948078*^9, 3.723290745148999*^9}, {3.7232908484551983`*^9, 
   3.72329093099683*^9}, 3.723291077900611*^9, {3.723291159661364*^9, 
   3.723291169251553*^9}, {3.723291292647064*^9, 3.723291392867872*^9}, {
   3.723291445713578*^9, 3.723291446498827*^9}, {3.7232914800263977`*^9, 
   3.723291494947557*^9}, {3.7232916388853683`*^9, 3.723291654230835*^9}, 
   3.723291753798657*^9, {3.723293139070065*^9, 3.7232931442550297`*^9}, {
   3.723293608817526*^9, 3.72329364079241*^9}, 3.7232936828279467`*^9, {
   3.7232937894182043`*^9, 3.723293855313773*^9}, {3.7232940792591963`*^9, 
   3.723294099884536*^9}, 3.7232942156435432`*^9, {3.7232943922614517`*^9, 
   3.723294416017524*^9}, 3.725522068701132*^9, {3.725522114942389*^9, 
   3.725522123690661*^9}, {3.7255221539440737`*^9, 3.7255221811432543`*^9}, {
   3.7259994719390893`*^9, 3.7259994722984676`*^9}, {3.725999585799267*^9, 
   3.7259996248098326`*^9}, {3.725999663518501*^9, 3.7259996637216625`*^9}, {
   3.72600371303111*^9, 3.726003717320368*^9}, {3.7260037481809816`*^9, 
   3.7260037685971127`*^9}, {3.7260038620860453`*^9, 3.726003864867891*^9}, {
   3.726004836318697*^9, 3.726004948945911*^9}, {3.726004994010936*^9, 
   3.7260050070399537`*^9}, {3.7260050548562336`*^9, 
   3.7260050688018866`*^9}, {3.726006530649188*^9, 3.726006531314678*^9}},
 CellLabel->
  "In[2013]:=",ExpressionUUID->"2217621f-69c3-45b4-8962-f4176cc6e3e9"],

Cell[CellGroupData[{

Cell["CombineAndSort (local function)", "Subsubsection",
 CellChangeTimes->{{3.721880969768764*^9, 3.721880978231934*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"38bef4c2-0114-4fb9-9d6e-e16d20a3b010"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CombineAndSort", "[", "args___", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"{", "args", "}"}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.722567223962716*^9, 3.722567248708498*^9}},
 CellLabel->
  "In[2014]:=",ExpressionUUID->"a6fbfcaa-15af-49c8-8009-ceba10839880"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineAndSort", "[", 
    RowBox[{
     RowBox[{"data", ":", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_List", ".."}], "}"}], ".."}], "}"}], ".."}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"CombineAndSort", "[", 
    RowBox[{
     RowBox[{"Join", "@@", "data"}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.721880985036104*^9, 3.721880985038348*^9}, {
  3.72188101536797*^9, 3.721881038381719*^9}, {3.721882151531205*^9, 
  3.721882155687372*^9}, {3.721882211957735*^9, 3.7218822183186607`*^9}},
 CellLabel->
  "In[2015]:=",ExpressionUUID->"9b096558-8029-4570-8eff-da1911f617ed"],

Cell["\<\
combine the batch data, combining points with identical coordinates. Then \
edit in the TableCoordinates. If the TransformationAmplitudeTable has only a \
single output operator, remove the enclosing List. \
\>", "Text",
 CellChangeTimes->{{3.721884355608967*^9, 
  3.721884426685499*^9}},ExpressionUUID->"a4b9acc0-0115-42b6-a782-\
526ab9a1802c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CombineAndSort", "[", 
    RowBox[{
     RowBox[{"data", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"Except", "[", "_List", "]"}], ".."}], ",", "_List"}], 
         "}"}], ".."}], "}"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"decimateddata", ",", "tabcoords", ",", "vals", ",", "output"}],
       "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tabcoords", "=", 
        RowBox[{
         RowBox[{"TableCoordinates", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "TransformationAmplitudeTable", "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"decimateddata", "=", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SortBy", "[", 
          RowBox[{"data", ",", 
           RowBox[{
            RowBox[{"N", "[", 
             RowBox[{"First", "[", "#", "]"}], "]"}], "&"}]}], "]"}], "//.", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"a___", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"vars", ":", 
               RowBox[{
                RowBox[{"Except", "[", "_List", "]"}], ".."}]}], ",", 
              "val1_"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"vars", ":", 
               RowBox[{
                RowBox[{"Except", "[", "_List", "]"}], ".."}]}], ",", 
              "val2_"}], "}"}], ",", "b___"}], "}"}], "\[RuleDelayed]", 
          RowBox[{"{", 
           RowBox[{"a", ",", 
            RowBox[{"{", 
             RowBox[{"vars", ",", 
              RowBox[{"val1", "+", "val2"}]}], "}"}], ",", "b"}], "}"}]}]}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"vals", "=", 
        RowBox[{"Transpose", "[", 
         RowBox[{"Last", "/@", "decimateddata"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"output", "=", 
        RowBox[{"Map", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"vals", ",", "\[IndentingNewLine]", 
            RowBox[{"MapThread", "[", 
             RowBox[{"Append", ",", 
              RowBox[{"{", 
               RowBox[{"tabcoords", ",", "vals"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "vals"}],
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "output", "]"}], "\[Equal]", "1"}], ",", 
         RowBox[{"First", "@", "output"}], ",", "output"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7218821720559473`*^9, 3.721882303051622*^9}, {
  3.721884299812639*^9, 3.721884342236257*^9}, {3.7443668337529993`*^9, 
  3.7443668524928093`*^9}},ExpressionUUID->"86e71367-b066-4507-abd0-\
9e6d09850064"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubtitle",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.456510357569454*^9, 
   3.456510365295979*^9}, {3.497529807096361*^9, 3.497529811925864*^9}, 
   3.5020022052676563`*^9, {3.5067611334401627`*^9, 
   3.506761136950787*^9}},ExpressionUUID->"ac28a40c-2a9b-4bf7-82dc-\
b1c05f62775e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "invalchron"}], "=", 
   "\"\<Invalid value for Chronology.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.721758035405245*^9, 3.721758054323201*^9}},
 CellLabel->
  "In[2017]:=",ExpressionUUID->"84df0f20-83bd-4560-90ad-011841b86966"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "invaltabcoords1"}], "=", 
   "\"\<TableCoordinates should be a single expression when a single iterator \
is used.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.721758035405245*^9, 3.721758054323201*^9}, {
  3.7217728566726837`*^9, 3.721772861894512*^9}, {3.7218884051390953`*^9, 
  3.721888434255424*^9}, {3.721888571685878*^9, 3.7218886412001953`*^9}},
 CellLabel->
  "In[2018]:=",ExpressionUUID->"9106962a-ae80-484a-9952-2ce64f596741"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "invaltabcoordsn"}], "=", 
   "\"\<TableCoordinates must be a list of length `1`, when `1` iterators are \
used.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.721758035405245*^9, 3.721758054323201*^9}, {
  3.7217728566726837`*^9, 3.721772861894512*^9}, {3.7218884051390953`*^9, 
  3.721888434255424*^9}, {3.721888571685878*^9, 3.721888598241852*^9}, {
  3.7218886483626328`*^9, 3.7218886555677433`*^9}},
 CellLabel->
  "In[2019]:=",ExpressionUUID->"43299e34-0b26-4d26-b22f-37d6881a9b1c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "invalevent"}], "=", 
   "\"\<Invalid event specification encountered.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7217769292922583`*^9, 3.721776949402382*^9}},
 CellLabel->
  "In[2020]:=",ExpressionUUID->"8eaba2d9-1e56-485f-ab73-b70dc1e1ad76"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "invaltabvars"}], "=", 
   "\"\<One or more table variables has an assigned value. Each table \
variable must be a symbol.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5072789074144583`*^9, 3.507278949684041*^9}, 
   3.5075478618999977`*^9, {3.720233061480392*^9, 3.72023306419107*^9}, {
   3.7202331025601053`*^9, 3.720233110789403*^9}, {3.721769088249818*^9, 
   3.721769130173073*^9}},
 CellLabel->
  "In[2021]:=",ExpressionUUID->"5af2f121-b47d-4f67-b6c4-37ce390188ed"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "invaliter"}], "=", 
   "\"\<The iteration specifications cannot be interpreted.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.721769686207041*^9, 3.72176971689319*^9}},
 CellLabel->
  "In[2022]:=",ExpressionUUID->"a12891fb-f86b-40cc-827a-b4926f178400"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "badnormfac"}], "=", 
   "\"\<The normalization factor must be None, False, or numeric.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.721796119538319*^9, 3.721796142202935*^9}},
 CellLabel->
  "In[2023]:=",ExpressionUUID->"2c81efb8-1fe7-4cf0-8c9f-66607ed3b210"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "suspsymbs"}], "=", 
   "\"\<The following symbols do not have numerical values: `1`.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.701093796050228*^9, 3.701093848737091*^9}, {
   3.701093978300651*^9, 3.701093979196167*^9}, 3.7218605183060083`*^9},
 CellLabel->
  "In[2024]:=",ExpressionUUID->"90eef6ec-4723-43c3-bfcc-c08ebbd41095"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "badnumincr"}], "=", 
   "\"\<The number of increments of each variable must be an integer greater \
or equal to 1.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.72188403225916*^9, 3.721884066451009*^9}},
 CellLabel->
  "In[2025]:=",ExpressionUUID->"8ccebce6-f4aa-4fe3-8e17-b89e8801e2dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "badsyntax"}], "=", 
   "\"\<There is a syntax error in TransformationAmplitudeTable. A common \
error is to place one or more option rules of the form a\[Rule]b before one \
of the parameter incrementation specifications {p,pmin,pmax,dp}.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.722052576481176*^9, 3.722052720803439*^9}},
 CellLabel->
  "In[2026]:=",ExpressionUUID->"64580b45-f91c-47b0-8ae7-48350e732855"],

Cell[CellGroupData[{

Cell["more", "Subsection",
 CellChangeTimes->{{3.7217581184875317`*^9, 
  3.721758119852337*^9}},ExpressionUUID->"f402d643-c2cc-4748-88f6-\
cd627dca9e98"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "inapplims"}], "=", 
   "\"\<The limits of the iterator and its increment must be integers.\>\""}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5072789074144583`*^9, 3.507278949684041*^9}, 
   3.5075478618999977`*^9, {3.5111795668077*^9, 3.511179588300497*^9}},
 CellLabel->
  "In[2027]:=",ExpressionUUID->"05e9f7bd-355a-4f57-9307-55ef954d3f22"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "badensvar"}], "=", 
   "\"\<The variable used in the EnsembleAverage may not have an assigned \
value.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.507554648001753*^9, 3.507554665657736*^9}},
 CellLabel->
  "In[2028]:=",ExpressionUUID->"7179383c-e7b8-47d0-a879-c3b16973c711"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TransformationAmplitudeTable", "::", "nprecalnotfound"}], "=", 
   "\"\<Cannot find a value of the iterator specifying the timing of all \
precalculation symbols. The timing will be determined using the iterator `1` \
= `2`.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5104908209386578`*^9, 3.5104908824290867`*^9}, {
  3.510491325730711*^9, 3.510491340688993*^9}},
 CellLabel->
  "In[2029]:=",ExpressionUUID->"2af50f9e-5232-431e-94af-11e7b0ee8431"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["MaximizeTransformationAmplitude", "Chapter",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.45268559236838*^9, 3.452685596612178*^9}, 
   3.452685977341175*^9, {3.456221032206551*^9, 3.456221041675785*^9}, 
   3.456387573527132*^9, {3.456508634043894*^9, 3.456508635514103*^9}, {
   3.497529605471568*^9, 3.4975296086541243`*^9}, {3.505019908545583*^9, 
   3.505019916694314*^9}, 3.505019947230769*^9, {3.505022202959749*^9, 
   3.5050222067433023`*^9}, 3.506691865831951*^9, 3.72242389191741*^9, {
   3.7441979237278757`*^9, 3.744197925203421*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"5f831a4f-365c-496f-bdb8-0779de81b648"],

Cell[CellGroupData[{

Cell["options & attributes", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957871043387*^9, {3.722053600474162*^9, 
   3.722053604311769*^9}},ExpressionUUID->"36e266ae-ca0f-4997-b485-\
94686c7b9c5b"],

Cell[CellGroupData[{

Cell["options", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469894351830557*^9, 3.469894355180109*^9}, 
   3.470141048075708*^9, {3.721861723063643*^9, 3.721861730059412*^9}, 
   3.7218872429930058`*^9},ExpressionUUID->"818b90a0-e06d-417f-a50e-\
5b6b97980d00"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "MaximizeTransformationAmplitude", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Method", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ConstrainPositive", "\[Rule]", "Automatic"}]}], "}"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.46279631759762*^9, 3.462796327632659*^9}, {
   3.462796499979474*^9, 3.462796500513019*^9}, {3.4639405693833437`*^9, 
   3.463940573195265*^9}, 3.4648620535854683`*^9, {3.465814564759466*^9, 
   3.465814565148946*^9}, {3.465814951086645*^9, 3.465814954331346*^9}, {
   3.486719403502572*^9, 3.486719404123908*^9}, {3.4973642921097937`*^9, 
   3.497364297163127*^9}, {3.497371897761854*^9, 3.497371906743175*^9}, {
   3.49737232158766*^9, 3.4973723346500463`*^9}, 3.497529619779294*^9, 
   3.497572546269267*^9, {3.506694571364847*^9, 3.506694574619191*^9}, {
   3.50676066374996*^9, 3.506760689656033*^9}, {3.5067668601939793`*^9, 
   3.506766861670865*^9}, 3.506767076536017*^9, {3.5067753444118958`*^9, 
   3.506775349337023*^9}, {3.506794750324267*^9, 3.50679476197094*^9}, 
   3.5068552391541147`*^9, 3.50685540941826*^9, {3.50712640599798*^9, 
   3.507126420035283*^9}, {3.5071285226083727`*^9, 3.507128534709289*^9}, {
   3.5072759370082808`*^9, 3.5072759384319563`*^9}, {3.507571622270445*^9, 
   3.5075716295419292`*^9}, {3.508583070814494*^9, 3.508583079551385*^9}, 
   3.5085831257459*^9, {3.508584092301716*^9, 3.508584116149168*^9}, {
   3.508584165855364*^9, 3.508584166935214*^9}, 3.508609688184823*^9, {
   3.508673942173622*^9, 3.508673942722736*^9}, {3.508681447965564*^9, 
   3.508681455651271*^9}, {3.508681808863309*^9, 3.508681809524273*^9}, {
   3.509187475972389*^9, 3.5091874863682537`*^9}, 3.509187572766778*^9, {
   3.509202710447878*^9, 3.509202713244726*^9}, 3.50920275639815*^9, 
   3.509456901722925*^9, {3.509458294721397*^9, 3.509458300182678*^9}, {
   3.5104897434595137`*^9, 3.5104897556279583`*^9}, {3.5148764613531857`*^9, 
   3.5148764622118397`*^9}, 3.515004308085532*^9, 3.515004360424423*^9, 
   3.515078115971826*^9, {3.533177158503834*^9, 3.533177162699546*^9}, {
   3.534399058676367*^9, 3.5343990645072727`*^9}, {3.539112680722073*^9, 
   3.539112681512909*^9}, 3.543413759248107*^9, 3.5434989374615183`*^9, 
   3.545050561058374*^9, {3.572539894675764*^9, 3.5725398982129307`*^9}, {
   3.6260277162778673`*^9, 3.626027716941956*^9}, {3.657712903551982*^9, 
   3.6577129097977*^9}, {3.702816071150379*^9, 3.702816072340538*^9}, {
   3.703082532778181*^9, 3.7030825455365334`*^9}, {3.709375525012845*^9, 
   3.7093755256093388`*^9}, {3.709387217297209*^9, 3.709387218485963*^9}, {
   3.721764466735124*^9, 3.721764515985629*^9}, {3.721764987162115*^9, 
   3.7217649886473846`*^9}, {3.721778102712504*^9, 3.721778104958108*^9}, {
   3.7218617045697727`*^9, 3.721861705770383*^9}, 3.721887083176839*^9, {
   3.7218871198157377`*^9, 3.7218871207421503`*^9}, {3.72188717773267*^9, 
   3.7218872198338137`*^9}, {3.7441987213160763`*^9, 3.744198749966634*^9}, {
   3.7441994576459103`*^9, 3.744199459692824*^9}, {3.744277839733025*^9, 
   3.74427784657507*^9}, {3.744280236400559*^9, 
   3.744280239597035*^9}},ExpressionUUID->"854297ca-d8f1-4578-aa0a-\
2608e324903a"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["preparations", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957871043387*^9, {3.722053600474162*^9, 3.722053604311769*^9}, {
   3.7441988231621027`*^9, 
   3.7441988248793783`*^9}},ExpressionUUID->"09fc7921-368e-432c-884b-\
b8724d1822ec"],

Cell[CellGroupData[{

Cell["traps", "Section",
 CellChangeTimes->{{3.7441990281856194`*^9, 
  3.744199028807974*^9}},ExpressionUUID->"d8e341d3-b30b-46a0-9987-\
e4a8c549677d"],

Cell[CellGroupData[{

Cell["multiple observables are disallowed", "Subsection",
 CellChangeTimes->{{3.744198879476315*^9, 3.744198887862782*^9}, {
  3.74419892846472*^9, 3.7441989308589563`*^9}, {3.7442686417358513`*^9, 
  3.7442686419272013`*^9}, {3.744282570400301*^9, 
  3.7442825734516172`*^9}},ExpressionUUID->"256ca297-0212-446d-9a25-\
1b9529d53d1a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_List"}], ",", "more___"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"MaximizeTransformationAmplitude", "::", "multobs"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744198891727161*^9, 3.744198935422387*^9}, {
  3.744199009336542*^9, 3.7441990153115253`*^9}},
 CellLabel->
  "In[2031]:=",ExpressionUUID->"03e5ac0c-8249-4694-87fd-b85d8f488bfc"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["syntax standardization", "Section",
 CellChangeTimes->{{3.7441990281856194`*^9, 
  3.7441990515573807`*^9}},ExpressionUUID->"6954f715-65cb-4fb6-a6fe-\
0fbaec0837cd"],

Cell[CellGroupData[{

Cell["single parameter", "Subsection",
 CellChangeTimes->{{3.744268654383067*^9, 3.744268676253565*^9}, {
   3.7442797402438393`*^9, 3.744279746698517*^9}, 
   3.744281558272043*^9},ExpressionUUID->"7accf3a5-44c0-4fd8-80d5-\
44ac69f31390"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "events_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"v", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", 
       RowBox[{"vini", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], ",", "more___"}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", "events", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"v", ",", "vini"}], "}"}], "}"}], ",", "more"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744199079736761*^9, 3.744199179063078*^9}},
 CellLabel->
  "In[2032]:=",ExpressionUUID->"85900b34-27db-43d9-a75a-c0a5aa4ab4ca"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "events_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"v", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", 
       RowBox[{"vini", ":", 
        RowBox[{"Except", "[", "_List", "]"}]}], ",", "vconstr_"}], "}"}], 
     ",", "more___"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", "events", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"v", ",", "vini", ",", "vconstr"}], "}"}], "}"}], ",", 
     "more"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744199079736761*^9, 3.744199179063078*^9}, {
  3.7442686849106913`*^9, 3.744268700165257*^9}},
 CellLabel->
  "In[2033]:=",ExpressionUUID->"b303d3ba-3648-4dfb-bcef-b86d471905f1"]
}, Closed]],

Cell[CellGroupData[{

Cell["ConstrainPositive", "Subsection",
 CellChangeTimes->{{3.74427771704383*^9, 3.7442777195870543`*^9}, 
   3.744277759713423*^9},ExpressionUUID->"3e1d0f88-2da8-4aba-a82a-\
23195a7f2adc"],

Cell[CellGroupData[{

Cell["convert True to All", "Subsubsection",
 CellChangeTimes->{{3.744281232073284*^9, 
  3.744281237889523*^9}},ExpressionUUID->"0e691400-39c9-4e35-8c8b-\
3bbe9c62c3f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "events_", ",", 
     "vars_List", ",", 
     RowBox[{"more", ":", 
      RowBox[{
       RowBox[{"Except", "[", 
        RowBox[{"(", 
         RowBox[{"_Rule", "|", "_RuleDelayed"}], ")"}], "]"}], "..."}]}], ",",
      "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "constrpos", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
       "MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", "events", ",", "vars", 
         ",", "more", ",", "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", 
          RowBox[{
           RowBox[{"ConstrainPositive", "\[Rule]", "All"}], ",", "opts"}], 
          "]"}]}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}],
       "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"constrpos", "=", 
         RowBox[{
          RowBox[{"ConstrainPositive", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "MaximizeTransformationAmplitude", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"constrpos", ",", "True"}], "]"}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744277777577664*^9, 3.744277948974262*^9}, {
   3.744283338112158*^9, 3.74428334518244*^9}, {3.744283386672727*^9, 
   3.744283416837393*^9}, 3.7442839347958527`*^9, 
   3.744284664080236*^9},ExpressionUUID->"05864145-e876-4b84-b431-\
60cd946b107a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["interpret All", "Subsubsection",
 CellChangeTimes->{{3.744281232073284*^9, 
  3.744281258129087*^9}},ExpressionUUID->"5b01612c-b2ec-43bd-a453-\
1ebe8a5da7d7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "events_", ",", 
     RowBox[{"varspecs", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}], 
     ",", 
     RowBox[{"more", ":", 
      RowBox[{
       RowBox[{"Except", "[", 
        RowBox[{"(", 
         RowBox[{"_Rule", "|", "_RuleDelayed"}], ")"}], "]"}], "..."}]}], ",",
      "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"constrpos", ",", "vars", ",", "varinivals"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"vars", ",", "varinivals"}], "}"}], "=", 
         RowBox[{"Transpose", "[", "varspecs", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", "events", ",", 
          "varspecs", ",", "more", ",", "\[IndentingNewLine]", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"ConstrainPositive", "\[Rule]", "vars"}], ",", "opts"}], 
           "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"constrpos", "=", 
         RowBox[{
          RowBox[{"ConstrainPositive", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "MaximizeTransformationAmplitude", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"constrpos", ",", "All"}], "]"}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744277777577664*^9, 3.744277948974262*^9}, {
   3.744278012516142*^9, 3.744278107266035*^9}, {3.744278285542115*^9, 
   3.7442782990326157`*^9}, {3.744283438378557*^9, 3.744283450077379*^9}, {
   3.744283484164381*^9, 3.744283489246504*^9}, 3.744283940937015*^9, 
   3.744284669733333*^9},ExpressionUUID->"800e0cec-631f-4b42-9da8-\
e0a167fe9f0e"]
}, Open  ]],

Cell[CellGroupData[{

Cell["single constrained parameter", "Subsubsection",
 CellChangeTimes->{{3.744281232073284*^9, 3.7442813427253923`*^9}, {
  3.744281436725033*^9, 3.744281441523223*^9}, {3.744281578424193*^9, 
  3.744281582767428*^9}},ExpressionUUID->"e6047448-3570-4ebc-bdf0-\
dae751417f50"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "events_", ",", 
     RowBox[{"varspecs", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}], 
     ",", 
     RowBox[{"more", ":", 
      RowBox[{
       RowBox[{"Except", "[", 
        RowBox[{"(", 
         RowBox[{"_Rule", "|", "_RuleDelayed"}], ")"}], "]"}], "..."}]}], ",",
      "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "constrpos", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
       "MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", "events", ",", 
         "varspecs", ",", "more", ",", "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", 
          RowBox[{
           RowBox[{"ConstrainPositive", "\[Rule]", 
            RowBox[{"{", "constrpos", "}"}]}], ",", "opts"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"constrpos", "=", 
         RowBox[{
          RowBox[{"ConstrainPositive", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "MaximizeTransformationAmplitude", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"constrpos", ",", 
           RowBox[{
           "_List", "|", "All", "|", "False", "|", "True", "|", 
            "Automatic"}]}], "]"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744277777577664*^9, 3.744277948974262*^9}, {
   3.744278012516142*^9, 3.744278107266035*^9}, {3.744278176268837*^9, 
   3.744278270598173*^9}, {3.744278317294277*^9, 3.744278495996976*^9}, {
   3.7442785915177107`*^9, 3.7442786304084463`*^9}, {3.744278740198392*^9, 
   3.744278748629757*^9}, {3.744279527449058*^9, 3.744279527749641*^9}, {
   3.744279830309925*^9, 3.744279836159008*^9}, {3.744281027086418*^9, 
   3.744281028633031*^9}, {3.7442810654437838`*^9, 3.744281126576437*^9}, {
   3.744281370676139*^9, 3.744281429167144*^9}, {3.744281487374736*^9, 
   3.744281499684928*^9}, {3.744281568075562*^9, 3.744281573083713*^9}, 
   3.744283946546198*^9, 
   3.744284675183341*^9},ExpressionUUID->"c95d6142-e814-4e93-9534-\
6b06c99ccc2c"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
insert min value of 0 into constraints on all indicated variables\
\>", "Subsubsection",
 CellChangeTimes->{{3.744281232073284*^9, 
  3.744281308222134*^9}},ExpressionUUID->"3cca8c74-5fd7-4c0a-acd7-\
904e99de8152"],

Cell["\<\
generate error message if a constrained variable is not recognized\
\>", "Text",
 CellChangeTimes->{{3.744281834462741*^9, 
  3.74428184656288*^9}},ExpressionUUID->"9be3b350-efa5-4426-a7eb-\
4de1b30f2ac8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "events_", ",", 
     RowBox[{"varspecs", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}], 
     ",", 
     RowBox[{"more", ":", 
      RowBox[{
       RowBox[{"Except", "[", 
        RowBox[{"(", 
         RowBox[{"_Rule", "|", "_RuleDelayed"}], ")"}], "]"}], "..."}]}], ",",
      "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"constrpos", ",", "constrposvars"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"constrposvars", "=", "constrpos"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"SubsetQ", "[", 
            RowBox[{
             RowBox[{"First", "/@", "varspecs"}], ",", "constrposvars"}], 
            "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Message", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
              "MaximizeTransformationAmplitude", "::", "badconstrvar"}], ",", 
              "constrposvars"}], "]"}], ";", "\[IndentingNewLine]", 
            "$Failed"}], "\[IndentingNewLine]", ")"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
          "MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", "events", ",", 
            "\[IndentingNewLine]", 
            RowBox[{"varspecs", "/.", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"#1", ",", "inival_"}], "}"}], ":>", 
                  RowBox[{"{", 
                   RowBox[{"#1", ",", "inival", ",", 
                    RowBox[{"{", "0", "}"}]}], "}"}]}], ")"}], "&"}], "/@", 
               "constrposvars"}], ")"}]}], ",", "\[IndentingNewLine]", "more",
             ",", "\[IndentingNewLine]", 
            RowBox[{"SimplifyRules", "[", 
             RowBox[{
              RowBox[{"ConstrainPositive", "\[Rule]", "Automatic"}], ",", 
              "opts"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
         "\[IndentingNewLine]", "]"}]}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"constrpos", "=", 
         RowBox[{
          RowBox[{"ConstrainPositive", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "MaximizeTransformationAmplitude", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"constrpos", ",", 
          RowBox[{"{", 
           RowBox[{"_Symbol", ".."}], "}"}]}], "]"}]}], "\[IndentingNewLine]",
        ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744277777577664*^9, 3.744277948974262*^9}, {
   3.744278012516142*^9, 3.744278107266035*^9}, {3.744278176268837*^9, 
   3.744278270598173*^9}, {3.744278317294277*^9, 3.744278495996976*^9}, {
   3.7442785915177107`*^9, 3.7442786304084463`*^9}, {3.744278740198392*^9, 
   3.744278748629757*^9}, {3.744279527449058*^9, 3.744279527749641*^9}, {
   3.744279830309925*^9, 3.744279836159008*^9}, {3.744281027086418*^9, 
   3.744281028633031*^9}, {3.744281688777438*^9, 3.744281821820197*^9}, {
   3.7442822022731867`*^9, 3.744282221512125*^9}, 3.744283951797909*^9, 
   3.7442846805839653`*^9},ExpressionUUID->"bb723d82-a872-4ba5-a475-\
1f5366899c63"]
}, Open  ]],

Cell[CellGroupData[{

Cell["trap constraint conflict", "Subsubsection",
 CellChangeTimes->{{3.744281232073284*^9, 3.744281308222134*^9}, {
  3.744281877619587*^9, 
  3.744281881517639*^9}},ExpressionUUID->"50ce487a-5fec-4b5b-973d-\
3201ec2af692"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "events_", ",", 
     RowBox[{"varspecs", ":", 
      RowBox[{"{", 
       RowBox[{"___", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}], ",", "_"}], "}"}], ",", 
        "___"}], "}"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{
       RowBox[{"Except", "[", 
        RowBox[{"(", 
         RowBox[{"_Rule", "|", "_RuleDelayed"}], ")"}], "]"}], "..."}]}], ",",
      "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"constrpos", ",", "constrposvars"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"MaximizeTransformationAmplitude", "::", "constrposconf"}], 
          ",", "constrpos"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", "events", ",", 
          "\[IndentingNewLine]", "varspecs", ",", "\[IndentingNewLine]", 
          "more", ",", "\[IndentingNewLine]", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"ConstrainPositive", "\[Rule]", "Automatic"}], ",", 
            "opts"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"constrpos", "=", 
         RowBox[{
          RowBox[{"ConstrainPositive", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "MaximizeTransformationAmplitude", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"constrpos", ",", "Automatic"}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744277777577664*^9, 3.744277948974262*^9}, {
   3.744278012516142*^9, 3.744278107266035*^9}, {3.744278176268837*^9, 
   3.744278270598173*^9}, {3.744278317294277*^9, 3.744278495996976*^9}, {
   3.7442785915177107`*^9, 3.7442786304084463`*^9}, {3.744278670202725*^9, 
   3.744278727041493*^9}, {3.7442787663737593`*^9, 3.744278823616399*^9}, {
   3.744279425870192*^9, 3.7442794305050917`*^9}, {3.744279617305771*^9, 
   3.7442796195154963`*^9}, {3.7442799068928633`*^9, 3.7442799112658453`*^9}, 
   3.744280018408389*^9, 3.7442839572502127`*^9, 
   3.7442846864483757`*^9},ExpressionUUID->"e8e0a762-0817-4514-b477-\
651bd789fdad"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
set ConstrainPositive\[Rule]False if no constraint indication detected\
\>", "Subsubsection",
 CellChangeTimes->{{3.744281232073284*^9, 3.744281308222134*^9}, {
  3.744281877619587*^9, 3.744281881517639*^9}, {3.744281959420184*^9, 
  3.744281977813328*^9}, {3.7442832171467447`*^9, 
  3.744283222593617*^9}},ExpressionUUID->"6e53c7d7-4191-44e3-b5f2-\
8b35c6db0c76"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "events_", ",", 
     RowBox[{"varspecs", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}]}], "}"}], ".."}], "}"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{
       RowBox[{"Except", "[", 
        RowBox[{"(", 
         RowBox[{"_Rule", "|", "_RuleDelayed"}], ")"}], "]"}], "..."}]}], ",",
      "\[IndentingNewLine]", "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"constrpos", ",", "constrposvars"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"constrposvars", "=", "constrpos"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", "events", ",", 
          "\[IndentingNewLine]", "varspecs", ",", "more", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"ConstrainPositive", "\[Rule]", "False"}], ",", "opts"}], 
           "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"constrpos", "=", 
         RowBox[{
          RowBox[{"ConstrainPositive", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "MaximizeTransformationAmplitude", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"constrpos", ",", "Automatic"}], "]"}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744277777577664*^9, 3.744277948974262*^9}, {
   3.744278012516142*^9, 3.744278107266035*^9}, {3.744278176268837*^9, 
   3.744278270598173*^9}, {3.744278317294277*^9, 3.744278495996976*^9}, {
   3.7442785915177107`*^9, 3.7442786304084463`*^9}, {3.744278740198392*^9, 
   3.744278748629757*^9}, {3.744279527449058*^9, 3.744279527749641*^9}, {
   3.744279830309925*^9, 3.744279836159008*^9}, {3.744280486061185*^9, 
   3.744280502697468*^9}, 3.744282769709928*^9, 3.744282814865819*^9, 
   3.744283294888875*^9, {3.7442835572948427`*^9, 3.744283559627396*^9}, {
   3.744283654555971*^9, 3.744283657203278*^9}, {3.7442838230895*^9, 
   3.744283827854986*^9}, {3.7442838891595173`*^9, 3.7442839104528427`*^9}, 
   3.7442846934363613`*^9, 
   3.744284869632679*^9},ExpressionUUID->"6c410d11-a24f-43d1-908b-\
32967f54c087"]
}, Open  ]],

Cell[CellGroupData[{

Cell["general constrained syntax", "Subsubsection",
 CellChangeTimes->{{3.74427771704383*^9, 3.7442777195870543`*^9}, {
  3.744279925079965*^9, 3.744279928694098*^9}, {3.744283675565488*^9, 
  3.744283683017881*^9}},ExpressionUUID->"d1b34d77-90cc-48ce-b7ee-\
8a8dc1e0e063"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "events_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"va___", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"vb", ":", 
          RowBox[{"Except", "[", "_List", "]"}]}], ",", 
         RowBox[{"vbini", ":", 
          RowBox[{"Except", "[", "_List", "]"}]}], ",", 
         RowBox[{"vbmin", ":", 
          RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], ",", "vc___"}], 
      "}"}], ",", "more___"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", "events", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"va", ",", 
       RowBox[{"{", 
        RowBox[{"vb", ",", "vbini", ",", 
         RowBox[{"{", "vbmin", "}"}]}], "}"}], ",", "vc"}], "}"}], ",", 
     "more"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744199079736761*^9, 3.744199179063078*^9}, {
  3.744268735753817*^9, 3.744268792171048*^9}, {3.744270397442937*^9, 
  3.7442704129697857`*^9}},
 CellLabel->
  "In[2034]:=",ExpressionUUID->"e61b2eda-61d2-4c2f-ab27-27b6f8db289e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "events_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"va___", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"vb", ":", 
          RowBox[{"Except", "[", "_List", "]"}]}], ",", 
         RowBox[{"vbini", ":", 
          RowBox[{"Except", "[", "_List", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"vbmin", ":", 
           RowBox[{"Except", "[", "_List", "]"}]}], "}"}]}], "}"}], ",", 
       "vc___"}], "}"}], ",", "more___"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", "events", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"va", ",", 
       RowBox[{"{", 
        RowBox[{"vb", ",", "vbini", ",", 
         RowBox[{"{", 
          RowBox[{"vbmin", ",", "Infinity"}], "}"}]}], "}"}], ",", "vc"}], 
      "}"}], ",", "more"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744199079736761*^9, 3.744199179063078*^9}, {
  3.744268735753817*^9, 3.744268792171048*^9}, {3.744268832250239*^9, 
  3.744268841848669*^9}, {3.744270368104595*^9, 3.7442703875695953`*^9}},
 CellLabel->
  "In[2035]:=",ExpressionUUID->"47742de6-f5ba-4b02-b34d-f912964fc738"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "events_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"va___", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"vb", ":", 
          RowBox[{"Except", "[", "_List", "]"}]}], ",", 
         RowBox[{"vbini", ":", 
          RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], ",", "vc___", ",", 
       RowBox[{"vd", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Except", "[", "_List", "]"}], ",", 
            RowBox[{"Except", "[", "_List", "]"}]}], "}"}]}], "}"}]}], ",", 
       "ve___"}], "}"}], ",", "more___"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", "events", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"va", ",", 
       RowBox[{"{", 
        RowBox[{"vb", ",", "vbini", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "Infinity"}], ",", "Infinity"}], "}"}]}], "}"}], ",", 
       "vc", ",", "vd", ",", "ve"}], "}"}], ",", "more"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744199079736761*^9, 3.744199179063078*^9}, {
  3.744268735753817*^9, 3.744268792171048*^9}, {3.744268832250239*^9, 
  3.744268841848669*^9}, {3.744268876473351*^9, 3.744268893070602*^9}, {
  3.744270152655787*^9, 3.744270263418435*^9}},
 CellLabel->
  "In[2036]:=",ExpressionUUID->"7ce0dacb-68f8-42a1-99ce-de73b5ba1511"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "events_", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"va___", ",", 
       RowBox[{"vb", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"Except", "[", "_List", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Except", "[", "_List", "]"}], ",", 
            RowBox[{"Except", "[", "_List", "]"}]}], "}"}]}], "}"}]}], ",", 
       "vc___", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"vd", ":", 
          RowBox[{"Except", "[", "_List", "]"}]}], ",", 
         RowBox[{"vdini", ":", 
          RowBox[{"Except", "[", "_List", "]"}]}]}], "}"}], ",", "ve___"}], 
      "}"}], ",", "more___"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", "events", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"va", ",", "vb", ",", "vc", ",", 
       RowBox[{"{", 
        RowBox[{"vd", ",", "vdini", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "Infinity"}], ",", "Infinity"}], "}"}]}], "}"}], ",", 
       "ve"}], "}"}], ",", "more"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744199079736761*^9, 3.744199179063078*^9}, {
  3.744268735753817*^9, 3.744268792171048*^9}, {3.744268832250239*^9, 
  3.744268841848669*^9}, {3.744268876473351*^9, 3.744268893070602*^9}, {
  3.744270152655787*^9, 3.7442703449370127`*^9}},
 CellLabel->
  "In[2037]:=",ExpressionUUID->"2a4d9745-982e-49d7-b1d5-ac6769458564"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["unconstrained optimization", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957871043387*^9, {3.722053600474162*^9, 3.722053604311769*^9}, {
   3.7441988231621027`*^9, 
   3.744198834823688*^9}},ExpressionUUID->"a734e686-40b5-4c40-924c-\
53ad72839c88"],

Cell["default Method in this case is \[OpenCurlyDoubleQuote]InteriorPoint\
\[CloseCurlyDoubleQuote]", "Text",
 CellChangeTimes->{{3.744199362301531*^9, 3.744199378121757*^9}, 
   3.744280567686783*^9},ExpressionUUID->"1835c82d-d627-4a6c-9553-\
424efe101afe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "\[IndentingNewLine]", 
     "events_", ",", "\[IndentingNewLine]", 
     RowBox[{"varspecs", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ".."}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"opts", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_Rule", "|", "_RuleDelayed"}], ")"}], "..."}]}]}], 
    "\[IndentingNewLine]", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "negta", ",", "minval", ",", "varrules", ",", "vars", ",", "varinivals",
        ",", "nvar", ",", "method", ",", "constrpos"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"vars", ",", "varinivals"}], "}"}], "=", 
         RowBox[{"Transpose", "[", "varspecs", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nvar", "=", 
         RowBox[{"Length", "[", "vars", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"negta", "[", 
          RowBox[{"Repeated", "[", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], ",", 
            RowBox[{"{", "nvar", "}"}]}], "]"}], "]"}], ":=", 
         "\[IndentingNewLine]", 
         RowBox[{"-", 
          RowBox[{"TransformationAmplitude", "[", 
           RowBox[{
            RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", 
            "\[IndentingNewLine]", "events", ",", "\[IndentingNewLine]", 
            RowBox[{"Evaluate", "[", 
             RowBox[{"Sequence", "@@", 
              RowBox[{"FilterRules", "[", 
               RowBox[{
                RowBox[{"{", "opts", "}"}], ",", 
                RowBox[{"Options", "[", "TransformationAmplitude", "]"}]}], 
               "]"}]}], "]"}]}], "\[IndentingNewLine]", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Message", "[", 
         RowBox[{"MaximizeTransformationAmplitude", "::", "unconstr"}], "]"}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"method", "=", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Method", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "MaximizeTransformationAmplitude", "]"}]}],
           "/.", 
          RowBox[{"{", 
           RowBox[{"Automatic", "\[Rule]", "\"\<InteriorPoint\>\""}], 
           "}"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"MatchQ", "[", 
            RowBox[{"method", ",", "Automatic"}], "]"}]}], ",", 
          RowBox[{"Message", "[", 
           RowBox[{
            RowBox[{"MaximizeTransformationAmplitude", "::", "meth"}], ",", 
            "method"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Check", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"minval", ",", "varrules"}], "}"}], "=", 
             "\[IndentingNewLine]", 
             RowBox[{"FindMinimum", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"negta", "[", 
                RowBox[{"Sequence", "@@", "vars"}], "]"}], ",", 
               "\[IndentingNewLine]", "varspecs", ",", "\[IndentingNewLine]", 
               
               RowBox[{"Evaluate", "[", 
                RowBox[{"Sequence", "@@", 
                 RowBox[{"FilterRules", " ", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Join", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Method", "\[Rule]", "method"}], ",", "opts"}], 
                    "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Options", "[", "MaximizeTransformationAmplitude", 
                    "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Options", "[", "FindMinimum", "]"}]}], 
                  "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                "]"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "minval"}], ",", "varrules"}], "}"}]}], ")"}], ",",
           "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Message", "[", 
             RowBox[{"MaximizeTransformationAmplitude", "::", "fail"}], "]"}],
             ";", "\[IndentingNewLine]", "$Failed"}], ")"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Event", "::", "negdur"}], ",", 
            RowBox[{"Delay", "::", "negdur"}], ",", 
            RowBox[{"Pulse", "::", "inval\[Beta]"}], ",", 
            RowBox[{"Pulse", "::", "inval\[Phi]"}], ",", 
            RowBox[{"Pulse", "::", "neg\[Tau]"}], ",", 
            RowBox[{"ShapedPulse", "::", "invaldur"}], ",", 
            RowBox[{"FindMinimum", "::", "nrnum"}]}], "}"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"constrpos", "=", 
         RowBox[{
          RowBox[{"ConstrainPositive", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{
          "Options", "[", "MaximizeTransformationAmplitude", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"constrpos", ",", "False"}], "]"}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.7441992159325113`*^9, {3.7441993863304663`*^9, 3.744199441927689*^9}, {
   3.744199472121543*^9, 3.744199553459427*^9}, {3.744199625186706*^9, 
   3.7441996429448023`*^9}, {3.744208825893285*^9, 3.7442088619388933`*^9}, 
   3.744208969988455*^9, 3.744209082938859*^9, {3.744209510488188*^9, 
   3.744209526392623*^9}, 3.7442098066161833`*^9, {3.744214192054021*^9, 
   3.744214192494932*^9}, {3.744274095744903*^9, 3.744274102645*^9}, {
   3.7442806070110693`*^9, 3.744280622157024*^9}, {3.744282513657896*^9, 
   3.7442825222640867`*^9}, 
   3.74428487672464*^9},ExpressionUUID->"1b21da4a-5bcb-4ac8-812e-\
0853373cc8b7"]
}, Closed]],

Cell[CellGroupData[{

Cell["constrained optimization", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957871043387*^9, {3.722053600474162*^9, 3.722053604311769*^9}, {
   3.7441988231621027`*^9, 
   3.7441988403208447`*^9}},ExpressionUUID->"1dbe24cf-b36c-4596-8e3d-\
199f42a01b1d"],

Cell["default Method is Automatic in this case", "Text",
 CellChangeTimes->{{3.744199362301531*^9, 3.744199378121757*^9}, {
  3.7441997180046577`*^9, 
  3.744199723484242*^9}},ExpressionUUID->"f4eb047e-14e9-4c82-a8c6-\
e26d2e254279"],

Cell["\<\
implement reflective boundaries, so that even if FindMinimum transgresses \
into a non-physical region, a TransformationAmplitude error will not be \
generated.\
\>", "Text",
 CellChangeTimes->{{3.744270492003914*^9, 3.744270560426846*^9}, 
   3.744273823438403*^9},ExpressionUUID->"cb1cad72-8c46-487d-9735-\
4d82c8b863fc"],

Cell[TextData[{
 "The additional error trap ",
 StyleBox["Check[..] ",
  FontWeight->"Bold"],
 "should be obsolete but does no harm. "
}], "Text",
 CellChangeTimes->{{3.7442738306871967`*^9, 3.744273868997435*^9}, {
  3.744277183033781*^9, 
  3.744277192679408*^9}},ExpressionUUID->"58ba8414-b4d3-4646-a10c-\
70b50f89c9b2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"\[Rho]ini_", "\[Rule]", "obs_"}], ",", "\[IndentingNewLine]", 
     "events_", ",", "\[IndentingNewLine]", 
     RowBox[{"varspecs", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_", ",", 
          RowBox[{"{", 
           RowBox[{"_", ",", "_"}], "}"}]}], "}"}], ".."}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"opts", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_Rule", "|", "_RuleDelayed"}], ")"}], "..."}]}]}], 
    "\[IndentingNewLine]", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "negta", ",", "minval", ",", "varrules", ",", "vars", ",", "varinivals",
        ",", "nvar", ",", "method", ",", "varbounds", ",", "varminvals", ",", 
       "varmaxvals", ",", "constraints"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"vars", ",", "varinivals", ",", "varbounds"}], "}"}], "=", 
        RowBox[{"Transpose", "[", "varspecs", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"varminvals", ",", "varmaxvals"}], "}"}], "=", 
        RowBox[{"Transpose", "[", "varbounds", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"constraints", "=", 
        RowBox[{"And", "@@", 
         RowBox[{"MapThread", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"#1", "\[LessEqual]", "#2", "\[LessEqual]", "#3"}], 
             ")"}], "&"}], ",", 
           RowBox[{"{", 
            RowBox[{"varminvals", ",", "vars", ",", "varmaxvals"}], "}"}]}], 
          "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"MaximizeTransformationAmplitude", "::", "constr"}], ",", 
         "constraints"}], "]"}], ";", 
       RowBox[{"nvar", "=", 
        RowBox[{"Length", "[", "vars", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"negta", "[", 
         RowBox[{"vars", ":", 
          RowBox[{"Repeated", "[", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], ",", 
            RowBox[{"{", "nvar", "}"}]}], "]"}]}], "]"}], ":=", 
        "\[IndentingNewLine]", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"varvals", ",", "reflvarvals"}], "}"}], ",", 
          RowBox[{"(", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"varvals", "=", 
             RowBox[{"{", "vars", "}"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"reflvarvals", "=", 
             RowBox[{"MapThread", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"Which", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"#1", ">", "#2"}], ",", 
                  RowBox[{"#1", "+", 
                   RowBox[{"Abs", "[", 
                    RowBox[{"#2", "-", "#1"}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"#2", ">", "#3"}], ",", 
                  RowBox[{"#3", "-", 
                   RowBox[{"Abs", "[", 
                    RowBox[{"#2", "-", "#3"}], "]"}]}], ",", 
                  "\[IndentingNewLine]", "True", ",", "#2"}], "]"}], "&"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"varminvals", ",", "varvals", ",", "varmaxvals"}], 
                "}"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"TransformationAmplitude", "[", 
               RowBox[{
                RowBox[{"\[Rho]ini", "\[Rule]", "obs"}], ",", 
                "\[IndentingNewLine]", "events", ",", "\[IndentingNewLine]", 
                RowBox[{"Evaluate", "[", 
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"FilterRules", "[", 
                   RowBox[{
                    RowBox[{"{", "opts", "}"}], ",", 
                    RowBox[{
                    "Options", "[", "TransformationAmplitude", "]"}]}], 
                   "]"}]}], "]"}]}], "\[IndentingNewLine]", "]"}]}], "/.", 
             RowBox[{"MapThread", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"#1", "\[Rule]", "#2"}], ")"}], "&"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", "vars", "}"}], ",", "reflvarvals"}], "}"}]}], 
              "]"}]}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"method", "=", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Method", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "MaximizeTransformationAmplitude", "]"}]}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"method", ",", "Automatic"}], "]"}]}], ",", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"MaximizeTransformationAmplitude", "::", "meth"}], ",", 
           "method"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Check", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"minval", ",", "varrules"}], "}"}], "=", 
            "\[IndentingNewLine]", 
            RowBox[{"FindMinimum", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"negta", "[", 
                 RowBox[{"Sequence", "@@", "vars"}], "]"}], ",", 
                "constraints"}], "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{"vars", ",", "varinivals"}], "}"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Evaluate", "[", 
               RowBox[{"Sequence", "@@", 
                RowBox[{"FilterRules", " ", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Join", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Method", "\[Rule]", "method"}], ",", "opts"}], 
                    "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    "Options", "[", "MaximizeTransformationAmplitude", 
                    "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"Options", "[", "FindMinimum", "]"}]}], 
                 "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
               "]"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "minval"}], ",", "varrules"}], "}"}]}], ")"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"MaximizeTransformationAmplitude", "::", "fail"}], "]"}], 
           ";", "\[IndentingNewLine]", "$Failed"}], ")"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Event", "::", "negdur"}], ",", 
           RowBox[{"Delay", "::", "negdur"}], ",", 
           RowBox[{"Pulse", "::", "inval\[Beta]"}], ",", 
           RowBox[{"Pulse", "::", "inval\[Phi]"}], ",", 
           RowBox[{"Pulse", "::", "neg\[Tau]"}], ",", 
           RowBox[{"ShapedPulse", "::", "invaldur"}], ",", 
           RowBox[{"FindMinimum", "::", "nrnum"}]}], "}"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.7441992159325113`*^9, {3.7441993863304663`*^9, 3.744199441927689*^9}, {
   3.744199472121543*^9, 3.744199553459427*^9}, {3.744199625186706*^9, 
   3.7441996429448023`*^9}, {3.744199701309751*^9, 3.744199746608117*^9}, {
   3.744200233143704*^9, 3.7442002409905987`*^9}, {3.744200609434312*^9, 
   3.7442006131546707`*^9}, {3.744209094990562*^9, 3.7442090967930927`*^9}, 
   3.744209536835313*^9, {3.744209815220118*^9, 3.744209817975624*^9}, {
   3.744214202045223*^9, 3.744214202394396*^9}, {3.74427059145019*^9, 
   3.7442707813629*^9}, {3.744270865020771*^9, 3.744270898933025*^9}, {
   3.7442709291189337`*^9, 3.7442709517970457`*^9}, {3.744270993972619*^9, 
   3.744271061617485*^9}, {3.744271098988882*^9, 3.7442711862777977`*^9}, {
   3.744271223510599*^9, 3.7442713107924232`*^9}, {3.7442713489490433`*^9, 
   3.744271383125759*^9}, {3.744271457203677*^9, 3.744271493615012*^9}, {
   3.7442715824292088`*^9, 3.744271674351265*^9}, {3.744271751695507*^9, 
   3.744271754698601*^9}, {3.744271832363768*^9, 3.7442719531758966`*^9}, {
   3.7442719993732033`*^9, 3.7442720279424343`*^9}, {3.744272061068301*^9, 
   3.744272441031548*^9}, {3.744272490092059*^9, 3.74427256728865*^9}, {
   3.74427260761841*^9, 3.744272617455245*^9}, {3.744272959612751*^9, 
   3.744272983040737*^9}, 3.7442733509419527`*^9, {3.7442738991967497`*^9, 
   3.7442739167422457`*^9}, {3.744274479139971*^9, 3.744274484688467*^9}, {
   3.744274561123698*^9, 3.744274756593893*^9}, {3.7442747983794003`*^9, 
   3.744274890034616*^9}, {3.744277170584386*^9, 
   3.744277171282589*^9}},ExpressionUUID->"c22acc24-c06d-4824-803d-\
f7049d3b3850"]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubtitle",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.456508942983632*^9, 3.456508989966378*^9}, {3.456510357569454*^9, 
   3.456510365295979*^9}, {3.497529807096361*^9, 3.497529811925864*^9}, 
   3.5020022052676563`*^9, {3.5067611334401627`*^9, 
   3.506761136950787*^9}},ExpressionUUID->"f61f8e15-ac26-4490-83a6-\
25f20441ed21"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "::", "fail"}], "=", 
   "\"\<An event duration, or pulse flip angle, has transgressed into an \
unphysical region, causing \
\!\(\*StyleBox[\"MaximizeTransformationAmplitude\",FontSlant->\"Italic\"]\) \
to fail. Try again with a different starting point, or incorporate \
constraints on the parameters (see usage message for \
\!\(\*StyleBox[\"MaximizeTransformationAmplitude\",FontSlant->\"Italic\"]\)).\
\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.721758035405245*^9, 3.721758054323201*^9}, 
   3.7441987936638947`*^9, {3.7442085850828533`*^9, 3.744208613280489*^9}},
 CellLabel->
  "In[2040]:=",ExpressionUUID->"48f6d1ca-0590-43c0-b0a1-b4652eed8afa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "::", "multobs"}], "=", 
   "\"\<Only a single target observable may be specified.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744198945909642*^9, 3.7441989697209997`*^9}},
 CellLabel->
  "In[2041]:=",ExpressionUUID->"be020dda-cf87-4ade-a0e0-a3a04fe30f45"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "::", "constr"}], "=", 
   "\"\<Deploying \!\(\*StyleBox[\"FindMinimum\",FontSlant->\"Italic\"]\) \
with constraints `1`.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744198945909642*^9, 3.7441989697209997`*^9}, {
  3.744200532404533*^9, 3.744200595186355*^9}, {3.744208659080576*^9, 
  3.744208660077382*^9}, {3.7442733573933992`*^9, 3.7442733735853148`*^9}, {
  3.744273925201261*^9, 3.7442739265834007`*^9}},
 CellLabel->
  "In[2042]:=",ExpressionUUID->"37a1f92d-cff4-41d9-9eb6-0861de0c66f3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "::", "unconstr"}], "=", 
   "\"\<Deploying \!\(\*StyleBox[\"FindMinimum\",FontSlant->\"Italic\"]\) \
without constraints.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744198945909642*^9, 3.7441989697209997`*^9}, {
  3.744200532404533*^9, 3.744200595186355*^9}, {3.744208659080576*^9, 
  3.744208660077382*^9}, {3.7442733573933992`*^9, 3.7442733735853148`*^9}, {
  3.744273925201261*^9, 3.7442739265834007`*^9}, {3.744274123592579*^9, 
  3.744274128298059*^9}},
 CellLabel->
  "In[2043]:=",ExpressionUUID->"8e219093-8f0e-42a9-88e5-59cde04d0a66"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "::", "meth"}], "=", 
   "\"\<Executing \!\(\*StyleBox[\"FindMinimum\",FontSlant->\"Italic\"]\) \
using \!\(\*StyleBox[\"Method\",FontSlant->\"Italic\"]\) \[Rule] \\\"`1`\\\". \
See the usage message for \
\!\(\*StyleBox[\"FindMinimum\",FontSlant->\"Italic\"]\) for other possible \
values of \!\(\*StyleBox[\"Method\",FontSlant->\"Italic\"]\). \>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744208873635969*^9, 3.74420893008661*^9}, {
  3.744209007336115*^9, 3.744209055885598*^9}, {3.7442092525900993`*^9, 
  3.7442092846837873`*^9}},
 CellLabel->
  "In[2044]:=",ExpressionUUID->"2a048743-336b-4c9f-9be9-7a523d94b4d7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "::", "constrposconf"}], "=", 
   "\"\<Explicit constraints take precedence. The directive \
\!\(\*StyleBox[\"ConstrainPositive\",FontSlant->\"Italic\"]\)\[Rule]`1` has \
been ignored.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744278863979792*^9, 3.7442789102993813`*^9}, {
  3.7442830892484217`*^9, 
  3.744283094946815*^9}},ExpressionUUID->"776d1797-c25d-45e4-b03a-\
736860428edb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaximizeTransformationAmplitude", "::", "badconstrvar"}], "=", 
   "\"\<One or more of the constrained variables `1` are \
inappropriate.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.744278863979792*^9, 3.7442789102993813`*^9}, {
  3.744282254166321*^9, 
  3.744282297269389*^9}},ExpressionUUID->"c9b8b685-3976-42f6-ae89-\
ba433ed44f20"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Signal1D", "Chapter",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.45268559236838*^9, 3.452685596612178*^9}, 
   3.452685977341175*^9, {3.456221032206551*^9, 3.456221041675785*^9}, 
   3.456387573527132*^9, {3.456508634043894*^9, 3.456508635514103*^9}, {
   3.469876978403769*^9, 3.4698769805856333`*^9}, {3.662921354281863*^9, 
   3.662921355527502*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"4a6f9def-6717-45ac-85a1-8a09cce47dc9"],

Cell[CellGroupData[{

Cell["options & attributes", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957871043387*^9, 3.744369395378006*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"b896718e-4d1b-4b5c-8072-d05aa03125ae"],

Cell[CellGroupData[{

Cell["options", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469894351830557*^9, 3.469894355180109*^9}, 
   3.470141048075708*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"38fc809e-ac94-439a-b013-5bbbe328bab8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "Signal1D", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"OperatorBasis", "\[RuleDelayed]", 
      RowBox[{"ZeemanKetBraOperatorBasis", "[", "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Basis", "\[RuleDelayed]", 
      RowBox[{"ZeemanBasis", "[", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"InitialDensityOperator", "\[RuleDelayed]", 
      RowBox[{"opI", "[", "\"\<z\>\"", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Preparation", "\[RuleDelayed]", 
      RowBox[{"RotationSuperoperator", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\[Pi]", "/", "2"}], ",", "\"\<x\>\""}], "}"}], "]"}]}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"Observable", "\[Rule]", "All"}], ",", "\[IndentingNewLine]", 
     RowBox[{"NormalizationFactor", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"BackgroundGenerator", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"LineBroadening", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"SignalCalculationMethod", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"UseHilbertSpaceWhenPossible", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"EnsembleAverage", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"CarouselAverage", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ForceEvenNumberOfPoints", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"DigitalFrequencyResolution", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ZeroFill", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"MatchSamplingToPeriod", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ReportSignalCalculationMethod", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Chronology", "\[RuleDelayed]", "$Chronology"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Parallel", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"MaxBatchSize", "\[Rule]", "128"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Assumptions", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
     RowBox[{"SignalGeneratorPeriod", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PeriodicDetectionEventSpecificationList", "\[Rule]", "None"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"WarnAboutMissingPreparationBackground", "\[Rule]", "True"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"EnsembleVariableDimension", "\[Rule]", "Undefined"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"EnsembleSetUp", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ParallelSetUp", "\[Rule]", "False"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"MinimumRecommendedUserLevel", "\[Rule]", "Automatic"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.46279631759762*^9, 3.462796327632659*^9}, {
   3.462796499979474*^9, 3.462796500513019*^9}, {3.4639405693833437`*^9, 
   3.463940573195265*^9}, 3.4648620535854683`*^9, {3.465814564759466*^9, 
   3.465814565148946*^9}, {3.465814951086645*^9, 3.465814954331346*^9}, {
   3.469877004592615*^9, 3.4698770811970654`*^9}, {3.469877397223441*^9, 
   3.4698774049255953`*^9}, {3.469878273875712*^9, 3.469878280489011*^9}, {
   3.469881841779317*^9, 3.4698818531616497`*^9}, {3.469882206728376*^9, 
   3.4698822434970417`*^9}, {3.4698826513798113`*^9, 3.469882663562688*^9}, {
   3.4698835680892887`*^9, 3.4698835701184683`*^9}, {3.469894758789688*^9, 
   3.469894782996603*^9}, 3.469895604080037*^9, {3.4698961417697906`*^9, 
   3.4698961495587873`*^9}, {3.469966803841773*^9, 3.469966807430723*^9}, {
   3.470138401388834*^9, 3.470138421027953*^9}, 3.470139092519865*^9, {
   3.47014099119671*^9, 3.470141024102951*^9}, {3.470141922780723*^9, 
   3.4701419280668917`*^9}, 3.470141986016358*^9, {3.470386426279091*^9, 
   3.470386427700551*^9}, {3.470809872427116*^9, 3.470809893058433*^9}, {
   3.470842516873625*^9, 3.470842522248283*^9}, {3.497361683023593*^9, 
   3.497361690172566*^9}, 3.497572549942425*^9, 3.499326075129023*^9, {
   3.499559688478319*^9, 3.4995596961882553`*^9}, 3.499560985312983*^9, {
   3.499626188201215*^9, 3.4996262463306427`*^9}, {3.499626282723304*^9, 
   3.499626298851163*^9}, {3.499658448456381*^9, 3.499658465533085*^9}, {
   3.499914670947939*^9, 3.499914700658819*^9}, 3.500172250117547*^9, {
   3.502001846545474*^9, 3.502001848446683*^9}, {3.502429537618495*^9, 
   3.5024295472400312`*^9}, {3.502889829752199*^9, 3.502889849934205*^9}, {
   3.50392808956443*^9, 3.50392809272114*^9}, {3.5042722503384666`*^9, 
   3.504272250991145*^9}, {3.505725727149248*^9, 3.505725744462886*^9}, 
   3.505830104615274*^9, {3.506169264745618*^9, 3.506169269614566*^9}, {
   3.5080645697636833`*^9, 3.508064571161645*^9}, {3.514350519315996*^9, 
   3.514350531524049*^9}, 3.514799187072723*^9, {3.515078226903805*^9, 
   3.515078231694207*^9}, {3.533104667366485*^9, 3.5331046679005136`*^9}, 
   3.5331773167888603`*^9, {3.534398166344675*^9, 3.5343981697990723`*^9}, 
   3.534399144722679*^9, {3.534762879327838*^9, 3.5347629029286747`*^9}, {
   3.5348190211833076`*^9, 3.5348190270484343`*^9}, {3.539112702212984*^9, 
   3.539112706698762*^9}, 3.543498946079884*^9, 3.5440836766252413`*^9, 
   3.544622192165019*^9, {3.5446222334258127`*^9, 3.544622245791588*^9}, {
   3.5446223520601673`*^9, 3.544622352571886*^9}, {3.5446231974126053`*^9, 
   3.54462320490758*^9}, 3.545050567431244*^9, {3.547621326592222*^9, 
   3.547621332253735*^9}, {3.565181532816287*^9, 3.56518155760737*^9}, 
   3.565264213234704*^9, {3.5659606158346663`*^9, 3.565960618863595*^9}, {
   3.566149351241362*^9, 3.56614935155872*^9}, {3.566152792495764*^9, 
   3.566152817580344*^9}, {3.5661528629659033`*^9, 3.566152864055181*^9}, {
   3.5661529059168253`*^9, 3.566152916297842*^9}, {3.566234607367382*^9, 
   3.5662346147832527`*^9}, {3.566236215905428*^9, 3.5662362215206347`*^9}, {
   3.566237869415925*^9, 3.566237888575845*^9}, {3.566378551411989*^9, 
   3.566378556930173*^9}, {3.586107163813429*^9, 3.586107170595903*^9}, 
   3.5861803979380074`*^9, {3.587816884000373*^9, 3.587816885705822*^9}, {
   3.6152897835811462`*^9, 3.615289796287087*^9}, 3.6233423434619713`*^9, {
   3.626027754178823*^9, 3.626027754911145*^9}, 3.6260840968606577`*^9, {
   3.629102558984145*^9, 3.629102589838677*^9}, {3.629103074095827*^9, 
   3.629103078987115*^9}, {3.6292855701210117`*^9, 3.629285578876772*^9}, 
   3.629286043806713*^9, {3.6333474281234827`*^9, 3.633347432351344*^9}, {
   3.657215611852326*^9, 3.657215618802754*^9}, 3.680956813392806*^9, {
   3.699966323238743*^9, 3.699966326870669*^9}, {3.700310374519025*^9, 
   3.700310382920499*^9}, {3.700325272745584*^9, 3.700325302431896*^9}, 
   3.700481386663906*^9, {3.702797207871772*^9, 3.702797209051688*^9}, 
   3.703090265427495*^9, 3.703090304078393*^9, 3.709375532685755*^9, {
   3.745506180614443*^9, 3.7455061867731*^9}, 
   3.745506585942374*^9},ExpressionUUID->"9e8389ca-4716-4e52-a428-\
3aba9b8c6b94"],

Cell["\<\
The Private option DividedPeriodicEventList signals the construction of a \
subdivided list of periodic events, used for feeding the COMPUTE algorithm. \
This option is used as a flag so that the construction of a subdivided event \
list is performed outside the ensemble average.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.4996262593504047`*^9, 3.499626433940646*^9}, {
  3.500066382374103*^9, 3.500066497380484*^9}, {3.504272265907702*^9, 
  3.5042722670485067`*^9}},ExpressionUUID->"9435917c-7410-481c-b116-\
a774e4e01528"]
}, Open  ]],

Cell[CellGroupData[{

Cell["attributes", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469894351830557*^9, 3.469894355180109*^9}, 
   3.470141044562385*^9},ExpressionUUID->"3f005276-b5f2-46ef-97b8-\
34784e92c153"],

Cell["\<\
HoldRest is needed to allow implementation of EnsembleAverage\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.469896600541757*^9, 3.4698966136273127`*^9}, {
   3.502883935209774*^9, 3.5028839362384663`*^9}, 3.531651359143433*^9, 
   3.700488682297624*^9},ExpressionUUID->"a1f6bec6-e2e2-4b30-988d-\
040b39512cdf"],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"Signal1D", ",", "HoldRest"}], "]"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4698943573427773`*^9, 3.469894367696088*^9}, 
   3.531651360034911*^9, {3.7004886746873283`*^9, 3.700488675827775*^9}, {
   3.702797456032315*^9, 3.7027974717104187`*^9}, 3.7093877132880573`*^9},
 CellLabel->
  "In[2046]:=",ExpressionUUID->"bb6e07a0-068f-41ac-914f-630e70fa13bf"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["status flags", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699967260343471*^9, {3.7443693774136753`*^9, 3.744369383162512*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"b5818fab-49c8-4ed9-b41e-7464252c41c1"],

Cell[CellGroupData[{

Cell["syntax", "Section",
 CellChangeTimes->{{3.700297621581056*^9, 3.7002976227883387`*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"6e1a064a-f683-4c48-932f-4720e521b63d"],

Cell["\<\
status:{\[LineSeparator]1.<chron>,\[LineSeparator]2.<sampling>,\
\[LineSeparator]3.<acqevents>,\[LineSeparator]4.<prep>,\[LineSeparator]5.<\
ensav>,\[LineSeparator]6.<normfac>,\[LineSeparator]7.<obs>,\[LineSeparator]8. \
<evbackg>,\[LineSeparator]9. <sigcalc>,\[LineSeparator]10. <\[Rho]ini>,\
\[LineSeparator]11. <lineb>
12. <userlevel>
13.<ready>
}\
\>", "Text",
 CellChangeTimes->{{3.689409839714465*^9, 3.689409859202746*^9}, {
   3.6999581143942537`*^9, 3.699958263807562*^9}, {3.699962603269265*^9, 
   3.699962621819932*^9}, 3.699963887599286*^9, {3.699964901802113*^9, 
   3.699964932726914*^9}, {3.699964975344315*^9, 3.699964975983858*^9}, {
   3.6999665398265333`*^9, 3.699966540522017*^9}, {3.70029757547184*^9, 
   3.700297616436632*^9}, {3.700297696082258*^9, 3.700297696600065*^9}, {
   3.700323347837442*^9, 3.700323358616118*^9}, {3.700571398427099*^9, 
   3.7005714040563297`*^9}, {3.701092857308374*^9, 3.701092879229843*^9}, {
   3.7455058710711412`*^9, 
   3.745505885413363*^9}},ExpressionUUID->"a782c495-5a1a-41ce-a87e-\
bbb62f58d06d"],

Cell["when all flags are True, the overall status is set to True. ", "Text",
 CellChangeTimes->{{3.689409869650942*^9, 3.6894098789918537`*^9}, {
  3.699958073882622*^9, 3.699958084660014*^9}, {3.699958278423551*^9, 
  3.699958326909779*^9}},ExpressionUUID->"a801e04e-52c2-4b8c-840f-\
f17db0c49023"]
}, Closed]],

Cell[CellGroupData[{

Cell["insert global status", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.6999576793161383`*^9, 3.699957682623167*^9}, {
   3.69995837404912*^9, 3.699958377592299*^9}, {3.699967314659217*^9, 
   3.69996732698726*^9}},ExpressionUUID->"324d8b45-ea15-441a-b658-\
f383d52b3e34"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SingleStatusPattern", "=", 
   RowBox[{"True", "|", "False", "|", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"True", "|", "False"}], ")"}], "..."}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"StatusListPattern", "=", 
   RowBox[{"SingleStatusPattern", "|", 
    RowBox[{"{", 
     RowBox[{"SingleStatusPattern", ".."}], "}"}], "|", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"SingleStatusPattern", ".."}], "}"}], "|", 
        "SingleStatusPattern"}], ")"}], ".."}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"GeneralStatusListPattern", "=", 
   RowBox[{"SingleStatusPattern", "|", "StatusListPattern", "|", 
    RowBox[{"{", 
     RowBox[{"StatusListPattern", "..."}], "}"}]}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700572856981989*^9, 3.700572869188698*^9}, 
   3.7005730073294277`*^9, {3.7005730596997633`*^9, 3.700573136257099*^9}, {
   3.700573178219075*^9, 3.700573221600915*^9}, {3.700573284729032*^9, 
   3.7005732923973827`*^9}},
 CellLabel->
  "In[2047]:=",ExpressionUUID->"f4544a54-bd44-4cdc-9a75-7d23fa034254"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"arg", ":", 
       RowBox[{"Except", "[", "GeneralStatusListPattern", "]"}]}], ",", 
      "moreA___", ",", 
      RowBox[{"BackgroundGenerator", "\[Rule]", " ", "evbg_"}], ",", 
      "moreB___"}], "]"}], ":=", 
    RowBox[{"Signal1D", "[", 
     RowBox[{"False", ",", "arg", ",", "moreA", ",", 
      RowBox[{"BackgroundGenerator", "\[Rule]", " ", 
       RowBox[{"Hold", "[", "evbg", "]"}]}], ",", "moreB"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"arg", ":", 
      RowBox[{"Except", "[", "GeneralStatusListPattern", "]"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{"False", ",", "arg", ",", "more"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958380154027*^9, 3.6999584815554132`*^9}, {
   3.699959772469471*^9, 3.699959793223897*^9}, 3.69995998791234*^9, {
   3.699962032492901*^9, 3.699962033672257*^9}, {3.700489087209752*^9, 
   3.70048913507517*^9}, {3.700565459147201*^9, 3.700565461704858*^9}, {
   3.7005664849261103`*^9, 3.7005664870277843`*^9}, 3.700572249823097*^9, 
   3.700573227435656*^9, {3.7027974893302355`*^9, 3.7027975561033072`*^9}, {
   3.702797620390955*^9, 3.7027976388289504`*^9}, {3.702798354048998*^9, 
   3.7027984113896713`*^9}, {3.7093755333830423`*^9, 3.709375534182023*^9}, 
   3.721857195677223*^9},
 CellLabel->
  "In[2050]:=",ExpressionUUID->"6724df13-b0bb-4380-98a3-0f8da7ed225f"]
}, Closed]],

Cell[CellGroupData[{

Cell["$Failed trap", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683958534614377*^9, 3.683958551028832*^9}, {
   3.68395858577393*^9, 3.6839585874144278`*^9}, 3.683959406338385*^9, {
   3.683963242982894*^9, 3.6839632443419228`*^9}, {3.683964445776389*^9, 
   3.683964455294318*^9}, {3.683983901941537*^9, 3.6839839032008667`*^9}, {
   3.700566501467436*^9, 
   3.7005665022666397`*^9}},ExpressionUUID->"4c15d8ad-a034-4ae4-9b3b-\
8d8cca48d595"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{"GeneralStatusListPattern", ",", "args___"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"FreeQ", "[", 
      RowBox[{
       RowBox[{"Hold", "@", 
        RowBox[{"{", "args", "}"}]}], ",", "$Failed"}], "]"}]}]}], ":=", 
   "$Failed"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.683983914149064*^9, 3.6839839305516777`*^9}, 
   3.6850335693888206`*^9, 3.699957835020547*^9, {3.7004890118870163`*^9, 
   3.70048902834022*^9}, {3.700489149274678*^9, 3.7004891505765*^9}, {
   3.700565404281258*^9, 3.700565407769747*^9}, {3.700566488876607*^9, 
   3.700566491048864*^9}, 3.700572254982481*^9, 3.700573232051622*^9},
 CellLabel->
  "In[2052]:=",ExpressionUUID->"ab9c8097-3953-4eac-808f-d742a19a81aa"]
}, Closed]],

Cell[CellGroupData[{

Cell["preparation status categories", "Section",
 CellChangeTimes->{
  3.605545643975979*^9, {3.6999576793161383`*^9, 3.699957682623167*^9}, {
   3.69995837404912*^9, 3.699958377592299*^9}, {3.699967292382577*^9, 
   3.6999672987831783`*^9}, {3.701095107247962*^9, 3.701095109227105*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"f8b47124-839b-4aed-9c8c-951802bc78fd"],

Cell[CellGroupData[{

Cell["initialize all preparation status categories", "Subsection",
 CellChangeTimes->{{3.699960043090076*^9, 3.699960055700795*^9}, {
  3.701095115014482*^9, 3.701095116885454*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"091e9ba4-2904-4fcc-9c42-ef22e4b5459c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusDimension", "[", "Signal1D", "]"}], "=", "13"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999583403975887`*^9, 3.699958356036769*^9}, {
   3.701092633684363*^9, 3.70109263380866*^9}, 3.701092903635845*^9, 
   3.745505929216679*^9},ExpressionUUID->"9e0181d8-8c0c-4231-8c0c-\
feba9e9d4ed4"],

Cell["\<\
The awkward coding below ensures that any evolution generator is immediately \
wrapped in Hold, to allow correct handling of multidimensional variables in \
the case of EnsembleAverage\
\>", "Text",
 CellChangeTimes->{{3.700566423405435*^9, 
  3.7005664816830387`*^9}},ExpressionUUID->"c941c9f3-c542-4027-8b74-\
744f6dbd9d37"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{"False", ",", 
     RowBox[{"timing", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"False", ",", 
       RowBox[{"{", 
        RowBox[{"StatusDimension", "[", "Signal1D", "]"}], "}"}]}], "]"}], 
     ",", "timing", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700566324922236*^9, 3.700566329608988*^9}, {
  3.700566384439968*^9, 3.700566384781948*^9}, {3.70109538631076*^9, 
  3.701095451635306*^9}, {3.701095624695593*^9, 3.701095624965757*^9}, {
  3.701095712124366*^9, 3.701095712359507*^9}},
 CellLabel->
  "In[2054]:=",ExpressionUUID->"2aac6d99-39dd-4146-b6d3-41f2e446edc3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{"False", ",", 
     RowBox[{"timing", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
     RowBox[{"evgen", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"False", ",", 
       RowBox[{"{", 
        RowBox[{"StatusDimension", "[", "Signal1D", "]"}], "}"}]}], "]"}], 
     ",", "timing", ",", 
     RowBox[{"Hold", "[", "evgen", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.69995850797114*^9, 3.699958536905984*^9}, {
   3.699959103578638*^9, 3.699959108313175*^9}, 3.699960108500506*^9, {
   3.700565084200432*^9, 3.7005650854213343`*^9}, {3.700565154545217*^9, 
   3.7005651996548643`*^9}, 3.7005652866919813`*^9, {3.7005653593177443`*^9, 
   3.70056536383565*^9}, {3.7005657140577717`*^9, 3.700565733038519*^9}, {
   3.700566244080645*^9, 3.700566269252013*^9}, {3.700566310963993*^9, 
   3.7005663886389933`*^9}, {3.701095460115888*^9, 3.701095464970928*^9}, {
   3.701095629051941*^9, 3.701095647356036*^9}, {3.701098412838253*^9, 
   3.701098415210989*^9}},
 CellLabel->
  "In[2055]:=",ExpressionUUID->"93e500a7-980a-4990-89ba-3fd73bfde2a8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{"False", ",", 
     RowBox[{"timing", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
     RowBox[{"evgen", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], ".."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"False", ",", 
       RowBox[{"{", 
        RowBox[{"StatusDimension", "[", "Signal1D", "]"}], "}"}]}], "]"}], 
     ",", "timing", ",", 
     RowBox[{"Hold", "[", "evgen", "]"}], ",", "more", ",", "opts"}], "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.69995850797114*^9, 3.699958536905984*^9}, {
   3.699959103578638*^9, 3.699959108313175*^9}, 3.699960108500506*^9, {
   3.700565084200432*^9, 3.7005650854213343`*^9}, {3.700565154545217*^9, 
   3.7005651996548643`*^9}, 3.7005652866919813`*^9, {3.7005653593177443`*^9, 
   3.70056536383565*^9}, {3.7005657140577717`*^9, 3.700565733038519*^9}, {
   3.700566244080645*^9, 3.700566269252013*^9}, {3.700566310963993*^9, 
   3.7005663886389933`*^9}, {3.701095460115888*^9, 3.701095464970928*^9}, {
   3.701095629051941*^9, 3.701095647356036*^9}},
 CellLabel->
  "In[2056]:=",ExpressionUUID->"30e74a7b-34d1-4a63-a411-2ce2590dd2c9"]
}, Closed]],

Cell[CellGroupData[{

Cell["1. chronology", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.699965078900024*^9, 
   3.699965079215186*^9}, 
   3.6999673551934147`*^9},ExpressionUUID->"8ccd2ffa-d52d-47c1-bb40-\
e4a9e29bdd40"],

Cell["<chron>={< request >, <valid>, <standardized>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
  3.699960637347527*^9, 3.699960654130438*^9}, {3.700312985944944*^9, 
  3.700312998460401*^9}},ExpressionUUID->"bd7d882a-1aa0-469a-bce5-\
303218f25343"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<Chronology\>\""}], "]"}], "=", "1"}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<Chronology\>\""}], "]"}], "=", "3"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, 3.699961074484026*^9, 
   3.700313001577042*^9},
 CellLabel->
  "In[2057]:=",ExpressionUUID->"03e14fa5-5295-48ae-8179-626a1dd177b9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", "False"}], ",", "morest___"}], "}"}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<Chronology\>\""}], "]"}], "}"}]}], 
         "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.6999610036889277`*^9, 3.699961014575673*^9}, {3.6999610780148363`*^9, 
   3.699961104711626*^9}},
 CellLabel->
  "In[2058]:=",ExpressionUUID->"ae01d601-dccc-4f0b-80e4-53418c654e03"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}]}], ",", "morest___"}], "}"}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ",", "morest"}], "}"}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
  3.6999608074403543`*^9, 3.699960815796681*^9}, {3.6999610219694366`*^9, 
  3.699961036648464*^9}, {3.69996108777975*^9, 3.699961119876425*^9}},
 CellLabel->
  "In[2059]:=",ExpressionUUID->"cc5c1db3-43f4-4efa-8b6c-a25e948c441c"]
}, Closed]],

Cell[CellGroupData[{

Cell["2. sampling", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699965076323723*^9, 3.699965076616291*^9}, 
   3.699967358600157*^9, {3.7010871278610983`*^9, 
   3.701087133313622*^9}},ExpressionUUID->"355c83d1-b64f-4c06-b993-\
febe2cb679e9"],

Cell["\<\
<sampling>={< request set up sampling >, <1st pass>, <adjust-to-period>, \
<force even #pts>, <sampling set up done>}\
\>", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
  3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
  3.6999607626383677`*^9}, {3.700482091706748*^9, 3.700482094792623*^9}, {
  3.701087144827612*^9, 3.701087174743593*^9}, {3.701087635307239*^9, 
  3.7010876670777807`*^9}},ExpressionUUID->"0ebac51c-aeb6-4ff0-8d3f-\
4444c39c7eee"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}], "=", "2"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}], "-", "1"}], 
      "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}], "=", "4"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.700303595564148*^9, 3.7003035998204327`*^9}, 3.700482089116626*^9, 
   3.700482467483755*^9, 3.7010871991145077`*^9, {3.7010918955891333`*^9, 
   3.701091895923306*^9}},
 CellLabel->
  "In[2060]:=",ExpressionUUID->"2382f784-dbf4-4330-a4ec-9cd6792f4ade"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}], "}"}]}], 
         "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}},
 CellLabel->
  "In[2061]:=",ExpressionUUID->"1a36f5ab-73b8-4d2d-8341-102af0c0adcb"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
  3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
  3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}},
 CellLabel->
  "In[2062]:=",ExpressionUUID->"eb71ad0c-53d0-4af7-be53-d569aa6828d0"]
}, Closed]],

Cell[CellGroupData[{

Cell["3. acquisition events", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699965073365028*^9, 3.6999650736913357`*^9}, 3.699967361469036*^9, 
   3.7003021035556297`*^9},ExpressionUUID->"71238257-ba1d-4461-8c85-\
b0431e0bf6e7"],

Cell["<acqevents>={< request set up>, <prepared>,<done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963444005171*^9, 3.699963456637158*^9}, {3.7003022890388412`*^9, 
   3.700302295447094*^9}, 3.700313742540327*^9, 
   3.7003140655501223`*^9},ExpressionUUID->"4b1a6cea-d1ec-489c-94fc-\
4a5fcfabec3c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<AcquisitionEvents\>\""}], "]"}], "=", "3"}],
   ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"Signal1D", ",", "\"\<AcquisitionEvents\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"Signal1D", ",", "\"\<AcquisitionEvents\>\""}], "]"}], "-", 
       "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<AcquisitionEvents\>\""}], "]"}], "=", "3"}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.700302272106821*^9, 
   3.7003022762645483`*^9}, {3.700303611630294*^9, 3.7003036144675627`*^9}, 
   3.7003051749205103`*^9, 3.700306573104793*^9, 3.7003066802353277`*^9, 
   3.700313745474448*^9, 3.700314068763255*^9, 3.700329310634688*^9},
 CellLabel->
  "In[2063]:=",ExpressionUUID->"30083fd0-544d-4210-93d3-d511e16cbb6f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<AcquisitionEvents\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",",
      "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<AcquisitionEvents\>\""}], "]"}], 
           "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.700302278185021*^9, 
   3.7003022799214697`*^9}},
 CellLabel->
  "In[2064]:=",ExpressionUUID->"04424905-bf3f-4e39-b9c8-8c4759b4da56"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<AcquisitionEvents\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.700302281832322*^9},
 CellLabel->
  "In[2065]:=",ExpressionUUID->"1ef202ff-09e6-4bfd-b231-ca0b302efc90"]
}, Closed]],

Cell[CellGroupData[{

Cell["4. preparation", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.699965070428596*^9, 
   3.699965070822577*^9}, 
   3.699967366452743*^9},ExpressionUUID->"1c2ff8c3-98b1-4f28-b36e-\
42f7cbfd8da8"],

Cell["<prep>={< request set up >, <standardized>, <valid>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.70109580608044*^9, 
   3.701095816657627*^9}, 
   3.701095895985952*^9},ExpressionUUID->"77d331ea-c984-4b3b-911e-\
bd58bb21f922"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<Preparation\>\""}], "]"}], "=", "4"}], ";", 
  
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"Signal1D", ",", "\"\<Preparation\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"Signal1D", ",", "\"\<Preparation\>\""}], "]"}], "-", "1"}], 
      "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<Preparation\>\""}], "]"}], "=", "3"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.700303620493458*^9, 3.7003036230513678`*^9}},
 CellLabel->
  "In[2066]:=",ExpressionUUID->"dc94ca58-bccf-4f0e-b6c0-4c6bb6353797"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Preparation\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<Preparation\>\""}], "]"}], "}"}]}], 
         "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}},
 CellLabel->
  "In[2067]:=",ExpressionUUID->"db6ab517-e8cf-4bb0-ae7c-98d4c545a80b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Preparation\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9},
 CellLabel->
  "In[2068]:=",ExpressionUUID->"77f70236-88fb-4ccb-9fa3-09781e07d072"]
}, Closed]],

Cell[CellGroupData[{

Cell["5. ensemble average", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.6999649668380327`*^9, 
   3.699964969998307*^9}, {3.699965067742071*^9, 3.699965068099847*^9}, 
   3.699967369557475*^9},ExpressionUUID->"396161b5-3486-4ddd-afe7-\
ffba40b13f6e"],

Cell["\<\
<ensav>={< request set up >, <standardized>, <multiDvars expanded>}\
\>", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
  3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
  3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
  3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
  3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
  3.699964752501457*^9, 3.699964753298031*^9}, {3.699964985064561*^9, 
  3.6999650459371634`*^9}},ExpressionUUID->"d7f758fb-91fc-4aaf-8e0d-\
84ee967d4315"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<EnsembleAverage\>\""}], "]"}], "=", "5"}], 
  ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"Signal1D", ",", "\"\<EnsembleAverage\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"Signal1D", ",", "\"\<EnsembleAverage\>\""}], "]"}], "-", 
       "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<EnsembleAverage\>\""}], "]"}], "=", "3"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.6999650519701777`*^9, 3.699965090479546*^9}, {3.700303628940432*^9, 
   3.700303631866754*^9}},
 CellLabel->
  "In[2069]:=",ExpressionUUID->"67016bf9-56ba-4a5b-8e88-07991c63f17e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<EnsembleAverage\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<EnsembleAverage\>\""}], "]"}], 
           "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.699965092504613*^9, 3.699965094755056*^9}},
 CellLabel->
  "In[2070]:=",ExpressionUUID->"75e0c211-5ccd-4577-9897-7642fe31488a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<EnsembleAverage\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, 3.699965097645801*^9},
 CellLabel->
  "In[2071]:=",ExpressionUUID->"9df3349f-54e4-4c55-b74c-4924074d5b9d"]
}, Closed]],

Cell[CellGroupData[{

Cell["6. normalization factor", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.6999649668380327`*^9, 
   3.699964969998307*^9}, {3.699965067742071*^9, 3.699965068099847*^9}, {
   3.699966554315508*^9, 3.69996657954851*^9}, 
   3.699967373045126*^9},ExpressionUUID->"57463dea-0b14-4dde-b9a8-\
0aee88f08e4f"],

Cell["<normfac>={< request set up >, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
  3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
  3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
  3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
  3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
  3.699964752501457*^9, 3.699964753298031*^9}, {3.699964985064561*^9, 
  3.6999650459371634`*^9}, {3.6999665607181664`*^9, 
  3.699966569479875*^9}},ExpressionUUID->"e3c4c3ed-9d5d-4ac0-b953-\
e226767f92ec"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<NormalizationFactor\>\""}], "]"}], "=", 
   "6"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"Signal1D", ",", "\"\<NormalizationFactor\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"Signal1D", ",", "\"\<NormalizationFactor\>\""}], "]"}], "-", 
       "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<NormalizationFactor\>\""}], "]"}], "=", 
   "2"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.6999650519701777`*^9, 3.699965090479546*^9}, {3.699966573127636*^9, 
   3.699966600295377*^9}, {3.700303637636141*^9, 3.7003036398823633`*^9}},
 CellLabel->
  "In[2072]:=",ExpressionUUID->"f25092d0-2cde-41ab-a69b-e488f7995079"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<NormalizationFactor\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",",
      "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<NormalizationFactor\>\""}], "]"}], 
           "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.699965092504613*^9, 3.699965094755056*^9}, {
   3.6999665941096067`*^9, 3.699966596595845*^9}},
 CellLabel->
  "In[2073]:=",ExpressionUUID->"13d93685-0cb5-42bc-8a74-3d5f7f5a4b6d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<NormalizationFactor\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, 3.699965097645801*^9, 
   3.699966605248719*^9},
 CellLabel->
  "In[2074]:=",ExpressionUUID->"e7d43783-15c9-4b54-9e32-e3d5d26e4b3e"]
}, Closed]],

Cell[CellGroupData[{

Cell["7. Observable", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.6999649668380327`*^9, 
   3.699964969998307*^9}, {3.699965067742071*^9, 3.699965068099847*^9}, {
   3.699966554315508*^9, 3.69996657954851*^9}, 3.699967373045126*^9, {
   3.700297682369924*^9, 3.700297687120805*^9}, 
   3.703087611317234*^9},ExpressionUUID->"a454d891-96b1-42b6-b266-\
eb43749ecd7d"],

Cell["<obs>={< request set up >, <done>,<check>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
  3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
  3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
  3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
  3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
  3.699964752501457*^9, 3.699964753298031*^9}, {3.699964985064561*^9, 
  3.6999650459371634`*^9}, {3.6999665607181664`*^9, 3.699966569479875*^9}, {
  3.7002976895855837`*^9, 3.700297690152369*^9}, {3.7005698938700323`*^9, 
  3.7005698986824837`*^9}},ExpressionUUID->"cdc84025-9db6-4db1-88b5-\
cd7c47d8319e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}], "=", "7"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}], "-", "1"}], 
      "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}], "=", "3"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.6999650519701777`*^9, 3.699965090479546*^9}, {3.699966573127636*^9, 
   3.699966600295377*^9}, {3.7002977035288486`*^9, 3.700297714850411*^9}, {
   3.7003036454040127`*^9, 3.700303647713851*^9}, 3.7005698883810377`*^9},
 CellLabel->
  "In[2075]:=",ExpressionUUID->"6612ddec-777f-4c91-9fff-2e1c1dcf2f0d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}], "}"}]}], 
         "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.699965092504613*^9, 3.699965094755056*^9}, {
   3.6999665941096067`*^9, 3.699966596595845*^9}, {3.700297717696663*^9, 
   3.7002977201690073`*^9}},
 CellLabel->
  "In[2076]:=",ExpressionUUID->"03544665-fb23-40ab-a96e-8547789df309"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, 3.699965097645801*^9, 
   3.699966605248719*^9, 3.70029772212831*^9},
 CellLabel->
  "In[2077]:=",ExpressionUUID->"f0ce31a8-8007-4289-aa6d-da1bd0a96ac7"]
}, Closed]],

Cell[CellGroupData[{

Cell["8. BackgroundGenerator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.6999649668380327`*^9, 
   3.699964969998307*^9}, {3.699965067742071*^9, 3.699965068099847*^9}, {
   3.699966554315508*^9, 3.69996657954851*^9}, 3.699967373045126*^9, {
   3.700297682369924*^9, 3.700297687120805*^9}, {3.700309490306013*^9, 
   3.700309498536682*^9}, 
   3.709375535018867*^9},ExpressionUUID->"40148378-7db2-4598-a274-\
f08e8e72308e"],

Cell["\<\
<evbackg>={< request set up >, <standardized>,  <diagonalized>, <split>, \
<standchron>}\
\>", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.699964985064561*^9, 
   3.6999650459371634`*^9}, {3.6999665607181664`*^9, 3.699966569479875*^9}, {
   3.7002976895855837`*^9, 3.700297690152369*^9}, {3.700309504975276*^9, 
   3.7003095353902483`*^9}, {3.7003102924437838`*^9, 3.700310298604307*^9}, {
   3.700310515749428*^9, 3.7003105353393087`*^9}, {3.7003112768000526`*^9, 
   3.700311278615312*^9}, {3.700311343221862*^9, 3.7003113479965563`*^9}, {
   3.700312016084929*^9, 3.7003120225355053`*^9}, 
   3.7003143255129757`*^9},ExpressionUUID->"4b6f846d-ef85-4c7d-a7dc-\
5097ecde2c8b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<BackgroundGenerator\>\""}], "]"}], "=", 
   "8"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"Signal1D", ",", "\"\<BackgroundGenerator\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"Signal1D", ",", "\"\<BackgroundGenerator\>\""}], "]"}], "-", 
       "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<BackgroundGenerator\>\""}], "]"}], "=", 
   "5"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.6999650519701777`*^9, 3.699965090479546*^9}, {3.699966573127636*^9, 
   3.699966600295377*^9}, {3.7002977035288486`*^9, 3.700297714850411*^9}, {
   3.7003036454040127`*^9, 3.700303647713851*^9}, {3.7003095391517057`*^9, 
   3.7003095606395893`*^9}, 3.700310541181225*^9, 3.700311353926566*^9, 
   3.700311915355034*^9, 3.700312026722583*^9, 3.700314328619864*^9, {
   3.709375535825508*^9, 3.70937553799562*^9}},
 CellLabel->
  "In[2078]:=",ExpressionUUID->"373f7fe4-2ba6-4d35-af05-0504077fbea8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<BackgroundGenerator\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",",
      "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<BackgroundGenerator\>\""}], "]"}], 
           "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.699965092504613*^9, 3.699965094755056*^9}, {
   3.6999665941096067`*^9, 3.699966596595845*^9}, {3.700297717696663*^9, 
   3.7002977201690073`*^9}, {3.70030955222392*^9, 3.700309553927802*^9}, {
   3.70937553871566*^9, 3.7093755393682737`*^9}},
 CellLabel->
  "In[2079]:=",ExpressionUUID->"e775c46b-a369-4b20-a5ae-1b338af364c4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<BackgroundGenerator\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, 3.699965097645801*^9, 
   3.699966605248719*^9, 3.70029772212831*^9, 3.7003095559441843`*^9, 
   3.709375540009308*^9},
 CellLabel->
  "In[2080]:=",ExpressionUUID->"32b5ce03-1c4d-4ac5-9da2-fdb84b341602"]
}, Closed]],

Cell[CellGroupData[{

Cell["9. SignalCalculation", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.6999649668380327`*^9, 
   3.699964969998307*^9}, {3.699965067742071*^9, 3.699965068099847*^9}, {
   3.699966554315508*^9, 3.69996657954851*^9}, 3.699967373045126*^9, {
   3.700297682369924*^9, 3.700297687120805*^9}, {3.700309490306013*^9, 
   3.700309498536682*^9}, {3.700323336485111*^9, 3.70032333917166*^9}, 
   3.700325330842703*^9, 3.7004813874960938`*^9, {3.700571021309107*^9, 
   3.700571032442786*^9}, 
   3.703087604254806*^9},ExpressionUUID->"a0510a52-7c19-4c6c-8108-\
d430224a3ae5"],

Cell["\<\
<sigcalc>={< request set up >, {<method>,<period>,<perevents>,<carav>},<done>}\
\>", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.699964985064561*^9, 
   3.6999650459371634`*^9}, {3.6999665607181664`*^9, 3.699966569479875*^9}, {
   3.7002976895855837`*^9, 3.700297690152369*^9}, {3.700309504975276*^9, 
   3.7003095353902483`*^9}, {3.7003102924437838`*^9, 3.700310298604307*^9}, {
   3.700310515749428*^9, 3.7003105353393087`*^9}, {3.7003112768000526`*^9, 
   3.700311278615312*^9}, {3.700311343221862*^9, 3.7003113479965563`*^9}, {
   3.700312016084929*^9, 3.7003120225355053`*^9}, 3.7003143255129757`*^9, {
   3.700323373083699*^9, 3.700323382688663*^9}, {3.700571036372684*^9, 
   3.7005711046138287`*^9}, {3.703084606777307*^9, 
   3.7030846138861723`*^9}},ExpressionUUID->"49543b5d-0a00-4a2d-9692-\
c46679dac08c"],

Cell["\<\
the <method> subcategory has the form {<request>,<resolve>,<check>,<report>}
the <period> subcategory has the form {<request>,<done>}
the <perevents> subcategory has the form {<request>,<done>}
the <carav> subcategory has the form {<request>,<checkvalid>,<checkprep>}\
\>", "Text",
 CellChangeTimes->{{3.700571093592724*^9, 3.700571118438364*^9}, {
   3.7005760118398323`*^9, 3.700576068782198*^9}, {3.703084631743847*^9, 
   3.703084636688451*^9}, 3.703085096906292*^9, {3.7030897459980907`*^9, 
   3.703089764404842*^9}},ExpressionUUID->"8807da94-1169-41a6-b6fc-\
f5956787881d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}], "=", "9"}],
   ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}], "-", 
       "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}], "=", "3"}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.6999650519701777`*^9, 3.699965090479546*^9}, {3.699966573127636*^9, 
   3.699966600295377*^9}, {3.7002977035288486`*^9, 3.700297714850411*^9}, {
   3.7003036454040127`*^9, 3.700303647713851*^9}, {3.7003095391517057`*^9, 
   3.7003095606395893`*^9}, 3.700310541181225*^9, 3.700311353926566*^9, 
   3.700311915355034*^9, 3.700312026722583*^9, 3.700314328619864*^9, {
   3.7003233874277487`*^9, 3.7003233977310658`*^9}, 3.700323945085599*^9, {
   3.7003253331621532`*^9, 3.70032533546968*^9}, 3.7003262355313673`*^9, {
   3.700481390503015*^9, 3.7004813933935137`*^9}, {3.7005711250812902`*^9, 
   3.700571135528716*^9}, 3.703084643973728*^9, 3.703084985139638*^9},
 CellLabel->
  "In[2081]:=",ExpressionUUID->"7fb1706b-93d6-4850-8022-8423fc807677"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",",
      "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}], 
           "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.699965092504613*^9, 3.699965094755056*^9}, {
   3.6999665941096067`*^9, 3.699966596595845*^9}, {3.700297717696663*^9, 
   3.7002977201690073`*^9}, {3.70030955222392*^9, 3.700309553927802*^9}, {
   3.7003233995227547`*^9, 3.700323401105749*^9}, {3.700325336607098*^9, 
   3.700325337458767*^9}, {3.7004813933991137`*^9, 3.700481393402935*^9}, {
   3.700571144065618*^9, 3.700571146105022*^9}},
 CellLabel->
  "In[2082]:=",ExpressionUUID->"381c89b8-7a8b-4fc0-9256-0f3f1b9a7296"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, 3.699965097645801*^9, 
   3.699966605248719*^9, 3.70029772212831*^9, 3.7003095559441843`*^9, 
   3.7003234031224413`*^9, 3.700325338724759*^9, 3.700481393412938*^9, 
   3.700571148864463*^9},
 CellLabel->
  "In[2083]:=",ExpressionUUID->"de7a40b6-4d03-45a3-84ba-b3a882e5dfcd"],

Cell[CellGroupData[{

Cell["subcategories", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.70057115588581*^9, 
  3.7005711609723797`*^9}},ExpressionUUID->"5de63327-bc67-4c07-ab40-\
e9182a6ea97d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ",", "False", ",", "False"}], "}"}], ",", 
        "morest___"}], "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"False", ",", "False", ",", "False", ",", "False"}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"False", ",", "False"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"False", ",", "False"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"False", ",", "False", ",", "False"}], "}"}]}], "}"}], 
         ",", "False"}], "}"}], ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700571173052329*^9, 3.7005712249651613`*^9}, 
   3.700572106808667*^9, {3.7005760790462847`*^9, 3.700576097069829*^9}, {
   3.701099312161009*^9, 3.7010993144949093`*^9}, {3.7030847690669327`*^9, 
   3.703084772960948*^9}, {3.703084818536377*^9, 3.703084819816194*^9}, 
   3.703084868488039*^9, {3.703084991402913*^9, 3.7030850017949743`*^9}, {
   3.703089782260047*^9, 3.703089783788383*^9}},
 CellLabel->
  "In[2084]:=",ExpressionUUID->"4050e830-31e6-42cf-bdb6-d284eaa825fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{"subcat1___", ",", 
            RowBox[{"{", 
             RowBox[{"True", ".."}], "}"}], ",", "subcat2___"}], "}"}], ",", 
          "False"}], "}"}], ",", "morest___"}], "}"}]}], ",", "more___"}], 
    "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{"subcat1", ",", "True", ",", "subcat2"}], "}"}], ",", 
         "False"}], "}"}], ",", "morest"}], "}"}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700571173052329*^9, 3.7005712720832872`*^9}, {
  3.700576626565525*^9, 3.7005766267733717`*^9}},
 CellLabel->
  "In[2085]:=",ExpressionUUID->"84a3e81f-3928-4aef-bda9-091b39b77e10"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{"True", ".."}], "}"}], ",", "False"}], "}"}], ",", 
        "morest___"}], "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "False"}], "}"}], ",", "morest"}], 
      "}"}], ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700571173052329*^9, 3.700571291289373*^9}},
 CellLabel->
  "In[2086]:=",ExpressionUUID->"81b802a3-1e61-4e74-8e02-0e74ed9c4b91"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["10. InitialDensityOperator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.6999649668380327`*^9, 
   3.699964969998307*^9}, {3.699965067742071*^9, 3.699965068099847*^9}, {
   3.699966554315508*^9, 3.69996657954851*^9}, 3.699967373045126*^9, {
   3.700297682369924*^9, 3.700297687120805*^9}, {3.700309490306013*^9, 
   3.700309498536682*^9}, {3.700323336485111*^9, 3.70032333917166*^9}, 
   3.700325330842703*^9, 3.7004813874960938`*^9, {3.700571021309107*^9, 
   3.700571032442786*^9}, {3.700579796209138*^9, 3.7005797978962584`*^9}, {
   3.700579832534051*^9, 3.7005798327034616`*^9}, 
   3.70057990344963*^9},ExpressionUUID->"f2f19b6d-6ef1-4020-a438-\
d1f112445b3b"],

Cell["<\[Rho]ini>={<request>, <convert to op>, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.699964985064561*^9, 
   3.6999650459371634`*^9}, {3.6999665607181664`*^9, 3.699966569479875*^9}, {
   3.7002976895855837`*^9, 3.700297690152369*^9}, {3.700309504975276*^9, 
   3.7003095353902483`*^9}, {3.7003102924437838`*^9, 3.700310298604307*^9}, {
   3.700310515749428*^9, 3.7003105353393087`*^9}, {3.7003112768000526`*^9, 
   3.700311278615312*^9}, {3.700311343221862*^9, 3.7003113479965563`*^9}, {
   3.700312016084929*^9, 3.7003120225355053`*^9}, 3.7003143255129757`*^9, {
   3.700323373083699*^9, 3.700323382688663*^9}, {3.700571036372684*^9, 
   3.7005711046138287`*^9}, {3.700579810707121*^9, 3.700579814513385*^9}, 
   3.70057985223291*^9, {3.701086400658972*^9, 
   3.701086422257688*^9}},ExpressionUUID->"b4482553-6760-4d14-bc04-\
48a3c8f762f5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<InitialDensityOperator\>\""}], "]"}], "=", 
   "10"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"Signal1D", ",", "\"\<InitialDensityOperator\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"Signal1D", ",", "\"\<InitialDensityOperator\>\""}], "]"}], 
       "-", "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<InitialDensityOperator\>\""}], "]"}], "=", 
   "3"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.6999650519701777`*^9, 3.699965090479546*^9}, {3.699966573127636*^9, 
   3.699966600295377*^9}, {3.7002977035288486`*^9, 3.700297714850411*^9}, {
   3.7003036454040127`*^9, 3.700303647713851*^9}, {3.7003095391517057`*^9, 
   3.7003095606395893`*^9}, 3.700310541181225*^9, 3.700311353926566*^9, 
   3.700311915355034*^9, 3.700312026722583*^9, 3.700314328619864*^9, {
   3.7003233874277487`*^9, 3.7003233977310658`*^9}, 3.700323945085599*^9, {
   3.7003253331621532`*^9, 3.70032533546968*^9}, 3.7003262355313673`*^9, {
   3.700481390503015*^9, 3.7004813933935137`*^9}, {3.7005711250812902`*^9, 
   3.700571135528716*^9}, {3.700579825209322*^9, 3.700579848568371*^9}, 
   3.7010864304055223`*^9},
 CellLabel->
  "In[2087]:=",ExpressionUUID->"c5425620-214d-4757-bcf4-22edc4ff4e5b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<InitialDensityOperator\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", "False", ",", "morest___"}], 
       "}"}]}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<InitialDensityOperator\>\""}], 
            "]"}], "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.699965092504613*^9, 3.699965094755056*^9}, {
   3.6999665941096067`*^9, 3.699966596595845*^9}, {3.700297717696663*^9, 
   3.7002977201690073`*^9}, {3.70030955222392*^9, 3.700309553927802*^9}, {
   3.7003233995227547`*^9, 3.700323401105749*^9}, {3.700325336607098*^9, 
   3.700325337458767*^9}, {3.7004813933991137`*^9, 3.700481393402935*^9}, {
   3.700571144065618*^9, 3.700571146105022*^9}, {3.700579857146373*^9, 
   3.700579858576989*^9}},
 CellLabel->
  "In[2088]:=",ExpressionUUID->"6d7abf6b-58a8-4808-a9d7-64f6ab6fc3b5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<InitialDensityOperator\>\""}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, 3.699965097645801*^9, 
   3.699966605248719*^9, 3.70029772212831*^9, 3.7003095559441843`*^9, 
   3.7003234031224413`*^9, 3.700325338724759*^9, 3.700481393412938*^9, 
   3.700571148864463*^9, 3.700579860329589*^9},
 CellLabel->
  "In[2089]:=",ExpressionUUID->"a4aad218-70a4-4d4f-9b7d-900e5c8d633a"]
}, Closed]],

Cell[CellGroupData[{

Cell["11. LineBroadening", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.6999649668380327`*^9, 
   3.699964969998307*^9}, {3.699965067742071*^9, 3.699965068099847*^9}, {
   3.699966554315508*^9, 3.69996657954851*^9}, 3.699967373045126*^9, {
   3.700297682369924*^9, 3.700297687120805*^9}, {3.700309490306013*^9, 
   3.700309498536682*^9}, {3.700323336485111*^9, 3.70032333917166*^9}, 
   3.700325330842703*^9, 3.7004813874960938`*^9, {3.700571021309107*^9, 
   3.700571032442786*^9}, {3.700579796209138*^9, 3.7005797978962584`*^9}, {
   3.700579832534051*^9, 3.7005798327034616`*^9}, 3.70057990344963*^9, {
   3.701091959241446*^9, 
   3.701091963961322*^9}},ExpressionUUID->"2e7ab0a8-2853-4837-b7f1-\
6463e118204e"],

Cell["<LB>={<request>, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.699964985064561*^9, 
   3.6999650459371634`*^9}, {3.6999665607181664`*^9, 3.699966569479875*^9}, {
   3.7002976895855837`*^9, 3.700297690152369*^9}, {3.700309504975276*^9, 
   3.7003095353902483`*^9}, {3.7003102924437838`*^9, 3.700310298604307*^9}, {
   3.700310515749428*^9, 3.7003105353393087`*^9}, {3.7003112768000526`*^9, 
   3.700311278615312*^9}, {3.700311343221862*^9, 3.7003113479965563`*^9}, {
   3.700312016084929*^9, 3.7003120225355053`*^9}, 3.7003143255129757`*^9, {
   3.700323373083699*^9, 3.700323382688663*^9}, {3.700571036372684*^9, 
   3.7005711046138287`*^9}, {3.700579810707121*^9, 3.700579814513385*^9}, 
   3.70057985223291*^9, {3.701086400658972*^9, 3.701086422257688*^9}, {
   3.7010919670457*^9, 
   3.7010919714008617`*^9}},ExpressionUUID->"22f9a1c7-55b9-4a47-ac00-\
bd47bb411af7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<LineBroadening\>\""}], "]"}], "=", "11"}], 
  ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"Signal1D", ",", "\"\<LineBroadening\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"Signal1D", ",", "\"\<LineBroadening\>\""}], "]"}], "-", 
       "1"}], "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<LineBroadening\>\""}], "]"}], "=", "2"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.6999650519701777`*^9, 3.699965090479546*^9}, {3.699966573127636*^9, 
   3.699966600295377*^9}, {3.7002977035288486`*^9, 3.700297714850411*^9}, {
   3.7003036454040127`*^9, 3.700303647713851*^9}, {3.7003095391517057`*^9, 
   3.7003095606395893`*^9}, 3.700310541181225*^9, 3.700311353926566*^9, 
   3.700311915355034*^9, 3.700312026722583*^9, 3.700314328619864*^9, {
   3.7003233874277487`*^9, 3.7003233977310658`*^9}, 3.700323945085599*^9, {
   3.7003253331621532`*^9, 3.70032533546968*^9}, 3.7003262355313673`*^9, {
   3.700481390503015*^9, 3.7004813933935137`*^9}, {3.7005711250812902`*^9, 
   3.700571135528716*^9}, {3.700579825209322*^9, 3.700579848568371*^9}, 
   3.7010864304055223`*^9, {3.7010919737865*^9, 3.70109198572132*^9}, 
   3.701092070724275*^9},
 CellLabel->
  "In[2090]:=",ExpressionUUID->"d53c6ea7-a6a9-420f-a758-b44e25ce9218"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<LineBroadening\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<LineBroadening\>\""}], "]"}], 
           "}"}]}], "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.699965092504613*^9, 3.699965094755056*^9}, {
   3.6999665941096067`*^9, 3.699966596595845*^9}, {3.700297717696663*^9, 
   3.7002977201690073`*^9}, {3.70030955222392*^9, 3.700309553927802*^9}, {
   3.7003233995227547`*^9, 3.700323401105749*^9}, {3.700325336607098*^9, 
   3.700325337458767*^9}, {3.7004813933991137`*^9, 3.700481393402935*^9}, {
   3.700571144065618*^9, 3.700571146105022*^9}, {3.700579857146373*^9, 
   3.700579858576989*^9}, {3.701091987770454*^9, 3.701091989411731*^9}},
 CellLabel->
  "In[2091]:=",ExpressionUUID->"41837b7b-9cdb-4011-8601-2865be834bea"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<LineBroadening\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, 3.699965097645801*^9, 
   3.699966605248719*^9, 3.70029772212831*^9, 3.7003095559441843`*^9, 
   3.7003234031224413`*^9, 3.700325338724759*^9, 3.700481393412938*^9, 
   3.700571148864463*^9, 3.700579860329589*^9, 3.701091991070116*^9},
 CellLabel->
  "In[2092]:=",ExpressionUUID->"2bf9cd77-c8b9-46b3-bb27-4c207285709e"]
}, Closed]],

Cell[CellGroupData[{

Cell["12. UserLevel", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.6999649668380327`*^9, 
   3.699964969998307*^9}, {3.699965067742071*^9, 3.699965068099847*^9}, {
   3.699966554315508*^9, 3.69996657954851*^9}, 3.699967373045126*^9, {
   3.700297682369924*^9, 3.700297687120805*^9}, {3.700309490306013*^9, 
   3.700309498536682*^9}, {3.700323336485111*^9, 3.70032333917166*^9}, 
   3.700325330842703*^9, 3.7004813874960938`*^9, {3.700571021309107*^9, 
   3.700571032442786*^9}, {3.700579796209138*^9, 3.7005797978962584`*^9}, {
   3.700579832534051*^9, 3.7005798327034616`*^9}, 3.70057990344963*^9, {
   3.701091959241446*^9, 3.701091963961322*^9}, {3.7010928904315777`*^9, 
   3.701092892433165*^9}, {3.745505918065406*^9, 3.745505920021455*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"b6071dd6-0380-4e41-8177-d670d8bfc76a"],

Cell["<userlevel>={<request>, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.699964985064561*^9, 
   3.6999650459371634`*^9}, {3.6999665607181664`*^9, 3.699966569479875*^9}, {
   3.7002976895855837`*^9, 3.700297690152369*^9}, {3.700309504975276*^9, 
   3.7003095353902483`*^9}, {3.7003102924437838`*^9, 3.700310298604307*^9}, {
   3.700310515749428*^9, 3.7003105353393087`*^9}, {3.7003112768000526`*^9, 
   3.700311278615312*^9}, {3.700311343221862*^9, 3.7003113479965563`*^9}, {
   3.700312016084929*^9, 3.7003120225355053`*^9}, 3.7003143255129757`*^9, {
   3.700323373083699*^9, 3.700323382688663*^9}, {3.700571036372684*^9, 
   3.7005711046138287`*^9}, {3.700579810707121*^9, 3.700579814513385*^9}, 
   3.70057985223291*^9, {3.701086400658972*^9, 3.701086422257688*^9}, {
   3.7010919670457*^9, 3.7010919714008617`*^9}, {3.70109291287438*^9, 
   3.701092913632064*^9}, {3.745505941664322*^9, 
   3.745505945161763*^9}},ExpressionUUID->"f74c06ca-a21d-4511-ba8b-\
556645908375"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<UserLevel\>\""}], "]"}], "=", "12"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"Signal1D", ",", "\"\<UserLevel\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"Signal1D", ",", "\"\<UserLevel\>\""}], "]"}], "-", "1"}], 
      "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<UserLevel\>\""}], "]"}], "=", "2"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.6999650519701777`*^9, 3.699965090479546*^9}, {3.699966573127636*^9, 
   3.699966600295377*^9}, {3.7002977035288486`*^9, 3.700297714850411*^9}, {
   3.7003036454040127`*^9, 3.700303647713851*^9}, {3.7003095391517057`*^9, 
   3.7003095606395893`*^9}, 3.700310541181225*^9, 3.700311353926566*^9, 
   3.700311915355034*^9, 3.700312026722583*^9, 3.700314328619864*^9, {
   3.7003233874277487`*^9, 3.7003233977310658`*^9}, 3.700323945085599*^9, {
   3.7003253331621532`*^9, 3.70032533546968*^9}, 3.7003262355313673`*^9, {
   3.700481390503015*^9, 3.7004813933935137`*^9}, {3.7005711250812902`*^9, 
   3.700571135528716*^9}, {3.700579825209322*^9, 3.700579848568371*^9}, 
   3.7010864304055223`*^9, {3.7010919737865*^9, 3.70109198572132*^9}, 
   3.701092070724275*^9, {3.701092917923321*^9, 3.7010929299210253`*^9}, {
   3.745505965613956*^9, 
   3.745505976517062*^9}},ExpressionUUID->"96f3c145-2681-4f07-83ec-\
f44b72195473"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<UserLevel\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<UserLevel\>\""}], "]"}], "}"}]}], 
         "]"}], ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.699965092504613*^9, 3.699965094755056*^9}, {
   3.6999665941096067`*^9, 3.699966596595845*^9}, {3.700297717696663*^9, 
   3.7002977201690073`*^9}, {3.70030955222392*^9, 3.700309553927802*^9}, {
   3.7003233995227547`*^9, 3.700323401105749*^9}, {3.700325336607098*^9, 
   3.700325337458767*^9}, {3.7004813933991137`*^9, 3.700481393402935*^9}, {
   3.700571144065618*^9, 3.700571146105022*^9}, {3.700579857146373*^9, 
   3.700579858576989*^9}, {3.701091987770454*^9, 3.701091989411731*^9}, {
   3.7010929318329897`*^9, 3.701092933927112*^9}, {3.745505983715008*^9, 
   3.745505985469885*^9}},ExpressionUUID->"a75fb807-52dd-432a-9ba2-\
c91ecd08eefa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<UserLevel\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, 3.699965097645801*^9, 
   3.699966605248719*^9, 3.70029772212831*^9, 3.7003095559441843`*^9, 
   3.7003234031224413`*^9, 3.700325338724759*^9, 3.700481393412938*^9, 
   3.700571148864463*^9, 3.700579860329589*^9, 3.701091991070116*^9, 
   3.701092935962367*^9, 
   3.745505987814001*^9},ExpressionUUID->"32ec1ee2-1def-4e60-ae58-\
42f090805aff"]
}, Open  ]],

Cell[CellGroupData[{

Cell["13. Ready", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.69995868694879*^9, 3.699958693777459*^9}, {
   3.699960070057869*^9, 3.699960071754833*^9}, {3.69996074406511*^9, 
   3.699960745324297*^9}, {3.699962633553566*^9, 3.699962635802616*^9}, {
   3.699963430076414*^9, 3.6999634317853947`*^9}, {3.6999649668380327`*^9, 
   3.699964969998307*^9}, {3.699965067742071*^9, 3.699965068099847*^9}, {
   3.699966554315508*^9, 3.69996657954851*^9}, 3.699967373045126*^9, {
   3.700297682369924*^9, 3.700297687120805*^9}, {3.700309490306013*^9, 
   3.700309498536682*^9}, {3.700323336485111*^9, 3.70032333917166*^9}, 
   3.700325330842703*^9, 3.7004813874960938`*^9, {3.700571021309107*^9, 
   3.700571032442786*^9}, {3.700579796209138*^9, 3.7005797978962584`*^9}, {
   3.700579832534051*^9, 3.7005798327034616`*^9}, 3.70057990344963*^9, {
   3.701091959241446*^9, 3.701091963961322*^9}, {3.7010928904315777`*^9, 
   3.701092892433165*^9}, 3.7455059163150063`*^9},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"65cde813-3eaa-4983-b2c4-c75ac83682d6"],

Cell["<ready>={<request>, <done>}", "Text",
 CellChangeTimes->{{3.699958808227449*^9, 3.69995883516975*^9}, {
   3.699960637347527*^9, 3.699960654130438*^9}, {3.6999607479794693`*^9, 
   3.6999607626383677`*^9}, {3.699962639879198*^9, 3.699962666425818*^9}, {
   3.699963434645192*^9, 3.699963472083734*^9}, {3.699963836287859*^9, 
   3.6999638369486713`*^9}, {3.699964022724579*^9, 3.6999640609629793`*^9}, {
   3.699964752501457*^9, 3.699964753298031*^9}, {3.699964985064561*^9, 
   3.6999650459371634`*^9}, {3.6999665607181664`*^9, 3.699966569479875*^9}, {
   3.7002976895855837`*^9, 3.700297690152369*^9}, {3.700309504975276*^9, 
   3.7003095353902483`*^9}, {3.7003102924437838`*^9, 3.700310298604307*^9}, {
   3.700310515749428*^9, 3.7003105353393087`*^9}, {3.7003112768000526`*^9, 
   3.700311278615312*^9}, {3.700311343221862*^9, 3.7003113479965563`*^9}, {
   3.700312016084929*^9, 3.7003120225355053`*^9}, 3.7003143255129757`*^9, {
   3.700323373083699*^9, 3.700323382688663*^9}, {3.700571036372684*^9, 
   3.7005711046138287`*^9}, {3.700579810707121*^9, 3.700579814513385*^9}, 
   3.70057985223291*^9, {3.701086400658972*^9, 3.701086422257688*^9}, {
   3.7010919670457*^9, 3.7010919714008617`*^9}, {3.70109291287438*^9, 
   3.701092913632064*^9}},ExpressionUUID->"fa2f49ed-f596-496a-b886-\
f7035d8b2827"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StatusPosition", "[", 
    RowBox[{"Signal1D", ",", "\"\<Ready\>\""}], "]"}], "=", "13"}], ";", 
  RowBox[{
   RowBox[{"StatusPatternPrefix", "[", 
    RowBox[{"Signal1D", ",", "\"\<Ready\>\""}], "]"}], "=", 
   RowBox[{"Repeated", "[", 
    RowBox[{"_", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"StatusPosition", "[", 
        RowBox[{"Signal1D", ",", "\"\<Ready\>\""}], "]"}], "-", "1"}], 
      "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"StatusDimension", "[", 
    RowBox[{"Signal1D", ",", "\"\<Ready\>\""}], "]"}], "=", "2"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958853699781*^9, 3.6999589049773827`*^9}, {
   3.699959318727004*^9, 3.6999594343113937`*^9}, {3.699960369989234*^9, 
   3.699960372506035*^9}, {3.699960457693959*^9, 3.6999604595259113`*^9}, {
   3.699960503144853*^9, 3.6999605057300367`*^9}, 3.699960657463168*^9, {
   3.6999607013959618`*^9, 3.6999607037218103`*^9}, {3.699960766150857*^9, 
   3.699960787019964*^9}, {3.69996086440975*^9, 3.699960874692507*^9}, {
   3.699962672616041*^9, 3.699962687792474*^9}, {3.699963476575247*^9, 
   3.699963489130471*^9}, 3.6999640682774763`*^9, 3.699964757956272*^9, {
   3.6999650519701777`*^9, 3.699965090479546*^9}, {3.699966573127636*^9, 
   3.699966600295377*^9}, {3.7002977035288486`*^9, 3.700297714850411*^9}, {
   3.7003036454040127`*^9, 3.700303647713851*^9}, {3.7003095391517057`*^9, 
   3.7003095606395893`*^9}, 3.700310541181225*^9, 3.700311353926566*^9, 
   3.700311915355034*^9, 3.700312026722583*^9, 3.700314328619864*^9, {
   3.7003233874277487`*^9, 3.7003233977310658`*^9}, 3.700323945085599*^9, {
   3.7003253331621532`*^9, 3.70032533546968*^9}, 3.7003262355313673`*^9, {
   3.700481390503015*^9, 3.7004813933935137`*^9}, {3.7005711250812902`*^9, 
   3.700571135528716*^9}, {3.700579825209322*^9, 3.700579848568371*^9}, 
   3.7010864304055223`*^9, {3.7010919737865*^9, 3.70109198572132*^9}, 
   3.701092070724275*^9, {3.701092917923321*^9, 3.7010929299210253`*^9}, 
   3.74550599506539*^9},ExpressionUUID->"04e4ea8b-1a0d-47b2-83dd-\
3d691838726f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Ready\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", "False", ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"firstst", ",", 
        RowBox[{"Table", "[", 
         RowBox[{"False", ",", 
          RowBox[{"{", 
           RowBox[{"StatusDimension", "[", 
            RowBox[{"Signal1D", ",", "\"\<Ready\>\""}], "]"}], "}"}]}], "]"}],
         ",", "morest"}], "}"}]}], ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958648503283*^9, 3.6999587326811743`*^9}, {
   3.699958918850692*^9, 3.699958975043654*^9}, {3.699959019281234*^9, 
   3.699959035131531*^9}, 3.699959121636579*^9, 3.699959158076075*^9, {
   3.699959245847829*^9, 3.699959246049168*^9}, 3.6999594262351503`*^9, 
   3.699960513258522*^9, {3.69996067757854*^9, 3.6999606792977133`*^9}, {
   3.699960782329977*^9, 3.6999607843540993`*^9}, {3.699960888192569*^9, 
   3.699960903907063*^9}, {3.699960936849784*^9, 3.699960971050047*^9}, {
   3.6999626959387836`*^9, 3.69996269789542*^9}, {3.699963496804166*^9, 
   3.6999635007180023`*^9}, {3.699965092504613*^9, 3.699965094755056*^9}, {
   3.6999665941096067`*^9, 3.699966596595845*^9}, {3.700297717696663*^9, 
   3.7002977201690073`*^9}, {3.70030955222392*^9, 3.700309553927802*^9}, {
   3.7003233995227547`*^9, 3.700323401105749*^9}, {3.700325336607098*^9, 
   3.700325337458767*^9}, {3.7004813933991137`*^9, 3.700481393402935*^9}, {
   3.700571144065618*^9, 3.700571146105022*^9}, {3.700579857146373*^9, 
   3.700579858576989*^9}, {3.701091987770454*^9, 3.701091989411731*^9}, {
   3.7010929318329897`*^9, 3.701092933927112*^9}},
 CellLabel->
  "In[2094]:=",ExpressionUUID->"beef0269-fdc1-4550-8af2-81c182e605ef"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"firstst", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Ready\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"True", ".."}], "}"}], ",", "morest___"}], "}"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"firstst", ",", "True", ",", "morest"}], "}"}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958743134482*^9, 3.699958767995947*^9}, {
   3.6999608074403543`*^9, 3.699960815796681*^9}, {3.699960917995645*^9, 
   3.699960943576139*^9}, {3.6999609760901527`*^9, 3.6999609847536583`*^9}, 
   3.6999627039592123`*^9, 3.699963508268085*^9, 3.699965097645801*^9, 
   3.699966605248719*^9, 3.70029772212831*^9, 3.7003095559441843`*^9, 
   3.7003234031224413`*^9, 3.700325338724759*^9, 3.700481393412938*^9, 
   3.700571148864463*^9, 3.700579860329589*^9, 3.701091991070116*^9, 
   3.701092935962367*^9},
 CellLabel->
  "In[2095]:=",ExpressionUUID->"c8d7e423-315e-4c49-ad3b-f2e251e1b3a9"]
}, Open  ]],

Cell[CellGroupData[{

Cell["consolidate overall True preparation status", "Subsection",
 CellChangeTimes->{
  3.605545643975979*^9, {3.6999576793161383`*^9, 3.699957682623167*^9}, {
   3.69995837404912*^9, 3.699958377592299*^9}, {3.699958574875738*^9, 
   3.699958587182394*^9}, {3.699958628011107*^9, 3.699958629539061*^9}, {
   3.701095126622422*^9, 
   3.7010951289726562`*^9}},ExpressionUUID->"8169b104-ef9b-4160-a8e2-\
1caa435ec593"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"True", ".."}], "}"}], ",", "more___"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{"True", ",", "more"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699958594214953*^9, 3.699958606071868*^9}},
 CellLabel->
  "In[2096]:=",ExpressionUUID->"f0f7da72-7c56-44ef-9795-0ebf144892ec"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["preparations", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, 
   3.699957885713748*^9},ExpressionUUID->"94eba405-d2fd-4e76-9b9b-\
a6a931c99e77"],

Cell[CellGroupData[{

Cell["1. Chronology", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.533205306190312*^9, 3.533205338644391*^9}, {
   3.533207951931931*^9, 3.533207953214973*^9}, {3.533211918247785*^9, 
   3.533211924876773*^9}, {3.544622262191017*^9, 3.5446222673612127`*^9}, {
   3.5450605796792517`*^9, 3.545060587485919*^9}, 3.699965812108637*^9, {
   3.70109788372791*^9, 
   3.701097884054083*^9}},ExpressionUUID->"f98b69ee-5adb-4bfc-999e-\
64559203008f"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"b28540b9-4dd1-4fd6-9f4f-\
ad768473fcaa"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "checked_", ",", "morechronst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morechronst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961872819072*^9, 3.699961873909457*^9}, 3.7004888505737963`*^9},
 CellLabel->
  "In[2097]:=",ExpressionUUID->"d755d2c5-7459-4980-b291-c2d2ff276119"]
}, Closed]],

Cell[CellGroupData[{

Cell["check validity", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003128834717216`*^9}},ExpressionUUID->"974cafb3-4381-4920-b0cc-\
bc57b97de724"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "False", ",", "morechronst___"}], "}"}]}], ",", 
       "morest___"}], "}"}], ",", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Chronology", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
       RowBox[{"\"\<RightToLeft\>\"", "|", "\"\<LeftToRight\>\""}]}], "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"Signal1D", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "morechronst"}], "}"}], ",", 
         "morest"}], "}"}], ",", "items", ",", "opts"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"Signal1D", "::", "invalchron"}], "]"}], ";", "$Failed"}], 
      ")"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545060613969104*^9, 3.545060677315857*^9}, {
  3.699959501759419*^9, 3.6999595031746063`*^9}, {3.69996123531818*^9, 
  3.699961258964602*^9}, {3.6999613887140293`*^9, 3.699961497961199*^9}, {
  3.7027974045607414`*^9, 3.7027974136209464`*^9}, {3.702797581629608*^9, 
  3.7027975827761307`*^9}},
 CellLabel->
  "In[2098]:=",ExpressionUUID->"c05a8657-0669-4edc-9547-392caaf86077"]
}, Closed]],

Cell[CellGroupData[{

Cell["set flag when RtoL chronology is imposed throughout", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700312880834124*^9, 
   3.7003129334155684`*^9}},ExpressionUUID->"bde4fbba-cf4c-42da-8e08-\
6af83929b35b"],

Cell["\<\
Indicate RtoL chronology when BackgroundGenerator, acquisition events, \
Preparation, have all been converted to RtoL chronology\
\>", "Text",
 CellChangeTimes->{{3.7003131837412367`*^9, 3.700313213172423*^9}, {
   3.700323281449465*^9, 3.700323294991837*^9}, {3.700884900813744*^9, 
   3.7008849595387087`*^9}, {3.7093755408130093`*^9, 3.709375541419942*^9}, 
   3.7136933481804*^9},ExpressionUUID->"71b78e28-3729-494b-8a6b-8343d26d5309"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", "False"}], "}"}]}], ",", "sampst_",
        ",", 
       RowBox[{"acqevst", ":", "True"}], ",", 
       RowBox[{"prepst", ":", "True"}], ",", "ensavst_", ",", "normfacst_", 
       ",", "obsst_", ",", 
       RowBox[{"evbackgst", ":", "True"}], ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True"}], "}"}], ",", "sampst", ",",
        "acqevst", ",", "prepst", ",", "ensavst", ",", "normfacst", ",", 
       "obsst", ",", "evbackgst", ",", "morest"}], "}"}], ",", "more", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70031296744199*^9, 3.7003129745684643`*^9}, {
  3.7003130140965357`*^9, 3.700313202181363*^9}, {3.700314376115902*^9, 
  3.700314392970945*^9}},
 CellLabel->
  "In[2099]:=",ExpressionUUID->"65f4a525-e3bc-494b-9017-2778e888e522"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2. sampling", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4708100337563677`*^9, 3.470810036177558*^9}, {3.4708249624088182`*^9, 
   3.470824969917295*^9}, {3.499326427012347*^9, 3.4993264426186132`*^9}, {
   3.499326986527643*^9, 3.499327000564424*^9}, 3.5025102950785418`*^9, {
   3.626778470764328*^9, 3.6267784813614273`*^9}, {3.69996580462748*^9, 
   3.699965807674411*^9}, {3.701087086645164*^9, 3.701087090428464*^9}, 
   3.701091877837075*^9, {3.7010978857501907`*^9, 
   3.701097886788761*^9}},ExpressionUUID->"82dc1d0a-4f0b-46d0-8bd7-\
7d8b73a29f30"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"226b5d1a-8d26-492c-a9b5-\
eeffc2d54b5b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
       RowBox[{"sampst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "done_", ",", "moresampst___"}], "}"}]}], ",", 
       "morest___"}], "}"}], ",", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "moresampst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, 3.700488895273015*^9},
 CellLabel->
  "In[2100]:=",ExpressionUUID->"a976bbc8-65c5-44a0-8710-547bac432974"]
}, Closed]],

Cell[CellGroupData[{

Cell["1. set up {tmin,tmax,\[Delta]t} (first pass)", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.701087369412834*^9, 
   3.701087376145616*^9}, {3.701087490992058*^9, 3.701087498109182*^9}, {
   3.701087672993814*^9, 
   3.7010876757273903`*^9}},ExpressionUUID->"789ccad4-ea39-403f-9aec-\
9a8df94639e3"],

Cell[CellGroupData[{

Cell["missing tmin \[Rule] use default of zero", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.626778567182033*^9, 3.626778573357584*^9}, {
  3.6267787411837177`*^9, 
  3.626778749913686*^9}},ExpressionUUID->"dc67ad47-b0c4-41b4-9c44-\
8231c87d847a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"stat", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
        RowBox[{"sampst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "moresampst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"times", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], "|", 
        RowBox[{"{", "_List", "}"}]}], ")"}]}], ",", "more___"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{"stat", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"Prepend", "[", 
       RowBox[{"times", ",", "0"}], "]"}]}], ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469877106456835*^9, 3.4698771515511723`*^9}, {
   3.499326385248507*^9, 3.499326390317404*^9}, {3.499326471471155*^9, 
   3.499326504132845*^9}, {3.626778771823463*^9, 3.6267788111628227`*^9}, {
   3.626778871987771*^9, 3.6267788737274857`*^9}, {3.626780660579941*^9, 
   3.6267807098065443`*^9}, {3.699959503950549*^9, 3.699959504513555*^9}, {
   3.6999616908825083`*^9, 3.699961745813599*^9}, {3.699962118070732*^9, 
   3.6999621567619543`*^9}, {3.699962200018888*^9, 3.6999622020991373`*^9}, {
   3.700481777777062*^9, 3.700481777950316*^9}, 3.700482531255048*^9},
 CellLabel->
  "In[2101]:=",ExpressionUUID->"b925ad50-0f95-4947-9151-2ea59dac9873"]
}, Closed]],

Cell[CellGroupData[{

Cell["specify # points as String ", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.626778567182033*^9, 3.6267785842483273`*^9}, {
   3.6267786277328043`*^9, 3.626778629959525*^9}, {3.626778852858041*^9, 
   3.626778859517427*^9}, {3.626959462526327*^9, 3.626959475224743*^9}, {
   3.626960057677719*^9, 3.626960061193907*^9}, 
   3.626960416015376*^9},ExpressionUUID->"9c3466d9-0961-4350-a101-\
d904cfbd152f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"stat", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
        RowBox[{"sampst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "moresampst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Omega]SW_", ",", "k_String"}], "}"}], ",", "more___"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{"stat", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"\[Omega]SW", ",", "k"}], "}"}], "}"}]}], ",", "more"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6269594903551903`*^9, 3.626959501329596*^9}, {
   3.626959548176683*^9, 3.6269596591134787`*^9}, {3.6269596969127703`*^9, 
   3.626959954928238*^9}, {3.6999595050879927`*^9, 3.699959506189987*^9}, {
   3.69996210881581*^9, 3.699962128151554*^9}, {3.699962163379177*^9, 
   3.699962175110332*^9}, 3.699962213903537*^9, {3.700482757430109*^9, 
   3.7004828452527437`*^9}},
 CellLabel->
  "In[2102]:=",ExpressionUUID->"45b39a2c-5fe1-476b-a105-17032a5b05cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"stat", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
        RowBox[{"sampst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "moresampst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"times__", ",", 
       RowBox[{"{", 
        RowBox[{"\[Omega]SW___", ",", "k_String"}], "}"}]}], "}"}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "n", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"StringToNumberOfPoints", "[", "k", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", 
        RowBox[{"stat", ",", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"{", 
           RowBox[{"times", ",", 
            RowBox[{"{", 
             RowBox[{"\[Omega]SW", ",", "n"}], "}"}]}], "}"}]}], ",", 
         "more"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6269594903551903`*^9, 3.626959501329596*^9}, {
   3.626959548176683*^9, 3.6269596591134787`*^9}, {3.6269596969127703`*^9, 
   3.626959954928238*^9}, {3.6999595050879927`*^9, 3.699959506189987*^9}, {
   3.69996210881581*^9, 3.699962128151554*^9}, {3.699962163379177*^9, 
   3.699962175110332*^9}, 3.699962213903537*^9, {3.700482757430109*^9, 
   3.700482779419051*^9}},
 CellLabel->
  "In[2103]:=",ExpressionUUID->"6cd7e960-333c-4406-a9d6-f1d10d9e21d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StringToNumberOfPoints", "[", "k_String", "]"}], ":=", 
   RowBox[{"Switch", "[", 
    RowBox[{"k", ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<1k\>\"", "|", "\"\<1K\>\""}], ",", "1024", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\"\<2k\>\"", "|", "\"\<2K\>\""}], ",", "2048", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"\"\<4k\>\"", "|", "\"\<4K\>\""}], ",", 
     RowBox[{"2", "^", "12"}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<8k\>\"", "|", "\"\<8K\>\""}], ",", 
     RowBox[{"2", "^", "13"}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<16k\>\"", "|", "\"\<16K\>\""}], ",", 
     RowBox[{"2", "^", "14"}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<32k\>\"", "|", "\"\<32K\>\""}], ",", 
     RowBox[{"2", "^", "15"}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<64k\>\"", "|", "\"\<64K\>\""}], ",", 
     RowBox[{"2", "^", "16"}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<128k\>\"", "|", "\"\<128K\>\""}], ",", 
     RowBox[{"2", "^", "17"}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<256k\>\"", "|", "\"\<256K\>\""}], ",", 
     RowBox[{"2", "^", "18"}], ",", "\[IndentingNewLine]", 
     RowBox[{"\"\<512k\>\"", "|", "\"\<512K\>\""}], ",", 
     RowBox[{"2", "^", "19"}], ",", "\[IndentingNewLine]", "_", ",", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{
         RowBox[{"Signal1D", "::", "unreck"}], ",", "k"}], "]"}], ";", 
       "1024"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7004827388951187`*^9, 3.7004827643333473`*^9}},
 CellLabel->
  "In[2104]:=",ExpressionUUID->"fcc0ede8-512b-4d19-b408-06801cd0d814"]
}, Closed]],

Cell[CellGroupData[{

Cell["spectral width and #points specified", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.626778567182033*^9, 3.6267785842483273`*^9}, {
  3.6267786277328043`*^9, 3.626778629959525*^9}, {3.626778852858041*^9, 
  3.626778859517427*^9}},ExpressionUUID->"b70c6718-ec0e-403e-9061-\
f99b9cdf7c10"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"stat", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"prefix", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
         RowBox[{"sampst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "moresampst___"}], "}"}]}], ",",
          "morest___"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", 
        RowBox[{"{", 
         RowBox[{"\[Omega]spec_", ",", "n_Integer"}], "}"}]}], "}"}], ",", 
      "more___"}], "]"}], "/;", 
    RowBox[{"n", ">", "1"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "\[Delta]t", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Delta]t", "=", 
        RowBox[{"2", 
         RowBox[{"\[Pi]", "/", "\[Omega]spec"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", 
        RowBox[{"stat", ",", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"{", 
           RowBox[{"tmin", ",", 
            RowBox[{"tmin", "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"n", "-", "1"}], ")"}], "\[Times]", "\[Delta]t"}]}], 
            ",", 
            RowBox[{"{", "n", "}"}]}], "}"}]}], ",", "more"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.626778493765777*^9, 3.626778549338313*^9}, {
   3.6267786355221*^9, 3.626778718232696*^9}, {3.6267788641124496`*^9, 
   3.62677901981789*^9}, {3.626779080042574*^9, 3.626779092813285*^9}, {
   3.626959428870758*^9, 3.626959446978488*^9}, {3.699959506752264*^9, 
   3.699959507292163*^9}, {3.699962237111871*^9, 3.699962253414115*^9}, 
   3.699962364957827*^9},
 CellLabel->
  "In[2105]:=",ExpressionUUID->"ab3b9042-f65d-498a-b190-ed10faacde6c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"stat", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"prefix", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
         RowBox[{"sampst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "moresampst___"}], "}"}]}], ",",
          "morest___"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", 
        RowBox[{"{", 
         RowBox[{"\[Omega]spec_", ",", "n_Integer"}], "}"}]}], "}"}], ",", 
      "more___"}], "]"}], "/;", 
    RowBox[{"n", ">", "1"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "\[Delta]t", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Delta]t", "=", 
        RowBox[{"2", 
         RowBox[{"\[Pi]", "/", "\[Omega]spec"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", 
        RowBox[{"stat", ",", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"{", 
           RowBox[{"tmin", ",", 
            RowBox[{"tmin", "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"n", "-", "1"}], ")"}], "\[Times]", "\[Delta]t"}]}], 
            ",", 
            RowBox[{"{", "n", "}"}]}], "}"}]}], ",", "more"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.626778493765777*^9, 3.626778549338313*^9}, {
  3.6267786355221*^9, 3.626778718232696*^9}, {3.6267788641124496`*^9, 
  3.62677901981789*^9}, {3.626779080042574*^9, 3.626779092813285*^9}, {
  3.699959507764863*^9, 3.69995950827108*^9}, {3.699962262425702*^9, 
  3.699962280400126*^9}, {3.699962358590069*^9, 3.699962360286833*^9}},
 CellLabel->
  "In[2106]:=",ExpressionUUID->"fa8f905a-ec97-4c6b-be21-db1dff871622"]
}, Closed]],

Cell[CellGroupData[{

Cell["tmax and #points specified", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.626778567182033*^9, 3.6267785842483273`*^9}, {
  3.6267786277328043`*^9, 
  3.626778629959525*^9}},ExpressionUUID->"62469fd1-d238-4cd9-b177-\
3e7fd2ff0ef7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"stat", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"prefix", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
         RowBox[{"sampst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "moresampst___"}], "}"}]}], ",",
          "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", 
        RowBox[{"{", "n_Integer", "}"}]}], "}"}], ",", "more___"}], "]"}], "/;", 
    RowBox[{"n", ">", "1"}]}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{"stat", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"{", 
       RowBox[{"tmin", ",", "tmax", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"tmax", "-", "tmin"}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"n", "-", "1"}], ")"}]}]}], "}"}]}], ",", "more"}], "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.626778493765777*^9, 3.626778549338313*^9}, {
   3.6267786355221*^9, 3.626778718232696*^9}, {3.699959508765913*^9, 
   3.699959509272253*^9}, {3.699962288549065*^9, 3.6999623131380033`*^9}, 
   3.6999623681525383`*^9},
 CellLabel->
  "In[2107]:=",ExpressionUUID->"573227c0-8e34-4b74-8c97-701c2ecc3b22"]
}, Closed]],

Cell[CellGroupData[{

Cell["trap error or set flag", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700482123808276*^9, 
   3.700482124727014*^9}, {3.70108741351562*^9, 3.701087419000986*^9}, {
   3.701087521293564*^9, 
   3.701087529580037*^9}},ExpressionUUID->"7b38d0d9-af2d-43d4-b7a6-\
be750d3b7e0c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"stat", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
        RowBox[{"sampst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "moresampst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"times", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"tmin_", "?", "NumericQ"}], ",", 
        RowBox[{"tmax_", "?", "NumericQ"}], ",", 
        RowBox[{"\[Delta]t_", "?", "NumericQ"}]}], "}"}]}], ",", "more___"}], 
    "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "moresampst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "times", ",", "more"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700482170276421*^9, 3.700482228683271*^9}, {
   3.700482326512042*^9, 3.700482328619019*^9}, {3.700483972261959*^9, 
   3.7004839730035954`*^9}, 3.700488913536429*^9},
 CellLabel->
  "In[2108]:=",ExpressionUUID->"aa6038fc-ed11-489a-aa47-75f2b903bf0f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"stat", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
        RowBox[{"sampst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "moresampst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"times", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"tmin_", "?", "NumericQ"}], ",", 
         RowBox[{"tmax_", "?", "NumericQ"}], ",", 
         RowBox[{"\[Delta]t_", "?", "NumericQ"}]}], "}"}], "]"}]}], ",", 
     "more___"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{
       RowBox[{"Signal1D", "::", "badtimes"}], ",", "times"}], "]"}], ";", 
     "$Failed"}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700482170276421*^9, 3.700482228683271*^9}, {
   3.700482326512042*^9, 3.700482328619019*^9}, {3.700482403420025*^9, 
   3.700482437028755*^9}, {3.700482570098563*^9, 3.7004825851854362`*^9}, 
   3.7004889169057913`*^9},
 CellLabel->
  "In[2109]:=",ExpressionUUID->"166ae690-3627-452b-a690-2f8a205b3b41"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["2. MatchSamplingToSignalGeneratorPeriod", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.701087369412834*^9, 
   3.701087376145616*^9}, {3.701087490992058*^9, 3.701087498109182*^9}, {
   3.70108753846*^9, 3.7010875450782137`*^9}, 
   3.701087588958478*^9},ExpressionUUID->"5565f777-0948-46f4-b799-\
6508f53cda41"],

Cell[CellGroupData[{

Cell["initiate subcategory", "Subsubsection",
 CellChangeTimes->{{3.70108772770216*^9, 
  3.701087736628746*^9}},ExpressionUUID->"9a9a48dd-6d18-48ec-aa1b-\
c66d44e26631"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"sampst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", "False", ",", "moresampst___"}], 
         "}"}]}], ",", "morest___"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", 
         RowBox[{"{", 
          RowBox[{"False", ",", "False"}], "}"}], ",", "moresampst"}], "}"}], 
       ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", "items", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7010876911588297`*^9, 3.701087779645369*^9}},
 CellLabel->
  "In[2110]:=",ExpressionUUID->"006a3872-2870-459f-8cd3-5c8f11d1fa81"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
request implementation (or close if MatchSamplingToSignalGeneratorPeriod\
\[Rule]False)\
\>", "Subsubsection",
 CellChangeTimes->{{3.70108772770216*^9, 3.701087736628746*^9}, {
  3.701087834074416*^9, 3.701087838282117*^9}, {3.701090916301612*^9, 
  3.701090934370227*^9}},ExpressionUUID->"0e1b235b-2ec1-4ecb-a8aa-\
a35e1d70b390"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"sampst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", 
          RowBox[{"{", 
           RowBox[{"False", ",", "moresubcatst___"}], "}"}], ",", 
          "moresampst___"}], "}"}]}], ",", "morest___"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"MatchSamplingToPeriod", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"True", ",", "moresubcatst"}], "}"}], ",", 
           "\[IndentingNewLine]", "True"}], "]"}], ",", "\[IndentingNewLine]",
          "moresampst"}], "}"}], ",", "\[IndentingNewLine]", "morest"}], 
      "}"}], ",", "\[IndentingNewLine]", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7010876911588297`*^9, 3.701087779645369*^9}, {
   3.7010878710810757`*^9, 3.701087945664917*^9}, {3.70108932627071*^9, 
   3.7010893272722073`*^9}, {3.7010893683114223`*^9, 3.701089419100286*^9}, 
   3.7010894580463343`*^9, 3.701089521604374*^9},
 CellLabel->
  "In[2111]:=",ExpressionUUID->"ed64bc25-8fe8-4ef9-8db3-5160e8520d4b"]
}, Closed]],

Cell[CellGroupData[{

Cell["skip if SignalCalculationMethod\[Rule]\[CloseCurlyDoubleQuote]Direct\
\[CloseCurlyDoubleQuote]", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812154438703*^9, 3.47081219334733*^9}, 3.497572553105742*^9, 
   3.4995570448366747`*^9, {3.499627836802288*^9, 3.499627846002262*^9}, 
   3.500068493620173*^9, 3.5346499211238317`*^9, {3.56221140293016*^9, 
   3.562211411164014*^9}, {3.701088967922205*^9, 3.701088969529191*^9}, 
   3.701089160875533*^9},ExpressionUUID->"6ff01a39-ec73-4b42-96d0-\
a040b40ee365"],

Cell["requires prior implementation of SignalCalculation", "Text",
 CellChangeTimes->{{3.701087841464612*^9, 
  3.7010878650257072`*^9}},ExpressionUUID->"c220e427-2853-4b71-9ba6-\
e5a7bffe12d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"sampst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "False", ",", "moresubcatst___"}], "}"}], 
           ",", "moresampst___"}], "}"}]}], ",", "acqevst_", ",", "prepst_", 
        ",", "ensavst_", ",", "normfacst_", ",", "obsst_", ",", "evbackgst_", 
        ",", 
        RowBox[{"sigcalcst", ":", "True"}], ",", "morest___"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"timing", ":", 
       RowBox[{"{", 
        RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}]}], ",", 
      "\[IndentingNewLine]", "acqevents_", ",", "opts___Rule"}], "]"}], "/;", 
    
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"SignalCalculationMethod", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", "\"\<Direct\>\""}], 
     "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "moresubcatst"}], "}"}], ",", 
         "moresampst"}], "}"}], ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", "sigcalcst", 
       ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", "timing", ",", 
     "acqevents", ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4708122044683323`*^9, 3.470812283486446*^9}, {
   3.4708123140269003`*^9, 3.470812315805029*^9}, {3.470812453229537*^9, 
   3.470812461957295*^9}, {3.470815739462834*^9, 3.470815740741301*^9}, 
   3.497572554136409*^9, {3.499326595956079*^9, 3.4993265997614183`*^9}, {
   3.499557050602365*^9, 3.499557062288371*^9}, 3.4995606921116743`*^9, {
   3.4996278835453157`*^9, 3.499627901183432*^9}, {3.500068581835861*^9, 
   3.500068663152459*^9}, {3.500150038939156*^9, 3.500150043799708*^9}, {
   3.514352831902204*^9, 3.514352837502304*^9}, 3.515065093164517*^9, {
   3.5622114177732143`*^9, 3.562211472450637*^9}, {3.683957723974483*^9, 
   3.683957723976712*^9}, {3.699959588046186*^9, 3.699959590003736*^9}, {
   3.701088974693465*^9, 3.701089075185114*^9}, {3.701089119305808*^9, 
   3.701089129605571*^9}, {3.701089191895134*^9, 3.7010892571717253`*^9}, {
   3.701089510685384*^9, 3.70108957375991*^9}, {3.7010897062787313`*^9, 
   3.7010897202514544`*^9}},
 CellLabel->
  "In[2112]:=",ExpressionUUID->"6eeece3e-4a46-4d29-8df2-d3e4539eff29"]
}, Closed]],

Cell[CellGroupData[{

Cell["skip if SignalGeneratorPeriod\[Rule]None|False", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812154438703*^9, 3.47081219334733*^9}, 3.497572553105742*^9, 
   3.4995570448366747`*^9, {3.499627836802288*^9, 3.499627846002262*^9}, 
   3.500068493620173*^9, 3.5346499211238317`*^9, {3.56221140293016*^9, 
   3.562211411164014*^9}, {3.701088967922205*^9, 3.701088969529191*^9}, 
   3.701089160875533*^9, {3.701090197931752*^9, 
   3.70109020583442*^9}},ExpressionUUID->"87301361-f549-4411-b0ac-\
e13de77b9e17"],

Cell["requires prior implementation of SignalCalculation", "Text",
 CellChangeTimes->{{3.701087841464612*^9, 
  3.7010878650257072`*^9}},ExpressionUUID->"c681c4fc-aa88-431a-9912-\
6c0759cc9d4c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"sampst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "False", ",", "moresubcatst___"}], "}"}], 
           ",", "moresampst___"}], "}"}]}], ",", "acqevst_", ",", "prepst_", 
        ",", "ensavst_", ",", "normfacst_", ",", "obsst_", ",", "evbackgst_", 
        ",", 
        RowBox[{"sigcalcst", ":", "True"}], ",", "morest___"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"timing", ":", 
       RowBox[{"{", 
        RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}]}], ",", 
      "\[IndentingNewLine]", "acqevents_", ",", "opts___Rule"}], "]"}], "/;", 
    
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"SignalGeneratorPeriod", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
      RowBox[{"None", "|", "False", "|", "SignalGeneratorPeriod"}]}], "]"}]}],
    ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "moresubcatst"}], "}"}], ",", 
         "moresampst"}], "}"}], ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", "sigcalcst", 
       ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", "timing", ",", 
     "acqevents", ",", "opts"}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4708122044683323`*^9, 3.470812283486446*^9}, {
   3.4708123140269003`*^9, 3.470812315805029*^9}, {3.470812453229537*^9, 
   3.470812461957295*^9}, {3.470815739462834*^9, 3.470815740741301*^9}, 
   3.497572554136409*^9, {3.499326595956079*^9, 3.4993265997614183`*^9}, {
   3.499557050602365*^9, 3.499557062288371*^9}, 3.4995606921116743`*^9, {
   3.4996278835453157`*^9, 3.499627901183432*^9}, {3.500068581835861*^9, 
   3.500068663152459*^9}, {3.500150038939156*^9, 3.500150043799708*^9}, {
   3.514352831902204*^9, 3.514352837502304*^9}, 3.515065093164517*^9, {
   3.5622114177732143`*^9, 3.562211472450637*^9}, {3.683957723974483*^9, 
   3.683957723976712*^9}, {3.699959588046186*^9, 3.699959590003736*^9}, {
   3.701088974693465*^9, 3.701089075185114*^9}, {3.701089119305808*^9, 
   3.701089129605571*^9}, {3.701089191895134*^9, 3.7010892571717253`*^9}, {
   3.701089510685384*^9, 3.70108957375991*^9}, {3.7010897062787313`*^9, 
   3.7010897202514544`*^9}, {3.7010902431752253`*^9, 3.7010902522787113`*^9}},
 
 CellLabel->
  "In[2113]:=",ExpressionUUID->"4f2f6821-de62-4f0b-a512-599e3a52a37b"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
do not adjust \[Delta]t if it is already an exact even submultiple, or a \
multiple, of the Period\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811162976123*^9}, {
  3.470811592866928*^9, 3.470811598526716*^9}, {3.470812364064789*^9, 
  3.4708123694036503`*^9}, {3.470830407953205*^9, 
  3.4708304199907084`*^9}},ExpressionUUID->"af2ee08b-33d6-44a2-b27b-\
2601434204c7"],

Cell["\<\
nsub is the even subdivision of the period that is nearest to \[Delta]t; 
nsup is the multiple of the period that is nearest to \[Delta]t; \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.499825541714264*^9, 
  3.499825612512775*^9}},ExpressionUUID->"7db17c61-1c13-4458-bdad-\
c31bcebaa2b2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"sampst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "False", ",", "moresubcatst___"}], "}"}], 
           ",", "moresampst___"}], "}"}]}], ",", "acqevst_", ",", "prepst_", 
        ",", "ensavst_", ",", "normfacst_", ",", "obsst_", ",", "evbackgst_", 
        ",", 
        RowBox[{"sigcalcst", ":", "True"}], ",", "morest___"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"timing", ":", 
       RowBox[{"{", 
        RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}]}], ",", 
      "acqevents_", ",", "opts___Rule"}], "]"}], "/;", "\[IndentingNewLine]", 
    
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"T", ",", "nsub", ",", "nsup"}], "}"}], ",", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"T", "=", 
          RowBox[{
           RowBox[{"SignalGeneratorPeriod", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"nsub", ",", "nsup"}], "}"}], "=", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Round", "[", 
             RowBox[{"T", "/", "\[Delta]t"}], "]"}], ",", 
            RowBox[{"Round", "[", 
             RowBox[{"\[Delta]t", "/", "T"}], "]"}]}], "}"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"EvenQ", "[", "nsub", "]"}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Chop", "@", 
               RowBox[{"N", "[", 
                RowBox[{"nsub", "-", 
                 RowBox[{"(", 
                  RowBox[{"T", "/", "\[Delta]t"}], ")"}]}], "]"}]}], 
              "\[Equal]", "0"}], ")"}]}], ")"}], "\[IndentingNewLine]", "||", 
          
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Chop", "@", 
             RowBox[{"N", "[", 
              RowBox[{"nsup", "-", 
               RowBox[{"(", 
                RowBox[{"\[Delta]t", "/", "T"}], ")"}]}], "]"}]}], "\[Equal]",
             "0"}], ")"}]}]}], "\[IndentingNewLine]", ")"}]}], "]"}], 
     "\[IndentingNewLine]", ")"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "moresubcatst"}], "}"}], ",", 
         "moresampst"}], "}"}], ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", "sigcalcst", 
       ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", "timing", ",", 
     "acqevents", ",", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.470810487010668*^9, 3.470810553520398*^9}, {
   3.4708108706129293`*^9, 3.4708110130438232`*^9}, 3.470811086312331*^9, {
   3.470811174443421*^9, 3.470811307194642*^9}, {3.4708113460434017`*^9, 
   3.470811371353405*^9}, {3.470811602219199*^9, 3.470811621734416*^9}, {
   3.470830459879746*^9, 3.4708305917944317`*^9}, {3.499326619431905*^9, 
   3.49932662367511*^9}, {3.499561554432108*^9, 3.499561558956778*^9}, {
   3.502439875072382*^9, 3.502439880414897*^9}, {3.514352843562015*^9, 
   3.514352848658801*^9}, {3.683957723985705*^9, 3.683957723988309*^9}, {
   3.6999595904989567`*^9, 3.699959592006386*^9}, {3.7010892805859613`*^9, 
   3.701089280904482*^9}, {3.701089634040882*^9, 3.70108969749501*^9}, {
   3.7010897386614037`*^9, 3.70108982392203*^9}, {3.7010905959063387`*^9, 
   3.70109060650294*^9}},
 CellLabel->
  "In[2114]:=",ExpressionUUID->"9f4626a2-02f8-4506-8c18-aded52fc045c"]
}, Closed]],

Cell[CellGroupData[{

Cell["adjust \[Delta]t and Period as required", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811162976123*^9}, {
  3.4708114076644297`*^9, 3.470811436086144*^9}, {3.470830610005479*^9, 
  3.4708306251097717`*^9}, {3.470831130789372*^9, 
  3.470831140255818*^9}},ExpressionUUID->"56af88f1-f48f-4c43-8ee7-\
49c20686cd70"],

Cell["\<\
nsub is the even subdivision of the period that is nearest to \[Delta]t; 
nsup is the multiple of the period that is nearest to \[Delta]t; \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.499825541714264*^9, 
  3.499825612512775*^9}},ExpressionUUID->"9b2be7e5-5f5e-4294-a16b-\
9e0c90907dd8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"sampst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "moresubcatst___"}], "}"}], ",",
           "moresampst___"}], "}"}]}], ",", "acqevst_", ",", "prepst_", ",", 
       "ensavst_", ",", "normfacst_", ",", "obsst_", ",", "evbackgst_", ",", 
       RowBox[{"sigcalcst", ":", "True"}], ",", "morest___"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"timing", ":", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}]}], ",", 
     "acqevents_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "T", ",", "nsub", ",", "nsup", ",", "new\[Delta]t", ",", "newT"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"T", "=", 
        RowBox[{
         RowBox[{"SignalGeneratorPeriod", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"nsub", "=", 
        RowBox[{"2", 
         RowBox[{"Max", "[", 
          RowBox[{"1", ",", 
           RowBox[{"Round", "@", 
            RowBox[{"Abs", "[", 
             RowBox[{"T", "/", 
              RowBox[{"(", 
               RowBox[{"2", "\[Delta]t"}], ")"}]}], "]"}]}]}], "]"}]}]}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"nsup", "=", 
        RowBox[{"Max", "[", 
         RowBox[{"1", ",", 
          RowBox[{"Round", "@", 
           RowBox[{"Abs", "[", 
            RowBox[{"\[Delta]t", "/", "T"}], "]"}]}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"new\[Delta]t", ",", "newT"}], "}"}], "=", 
        "\[IndentingNewLine]", 
        RowBox[{"Which", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"nsub", ">", "1"}], ",", "\[IndentingNewLine]", "\t", 
          RowBox[{"(", "\[IndentingNewLine]", "\t", 
           RowBox[{
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"Signal1D", "::", "new\[Delta]t"}], ",", 
              RowBox[{
               RowBox[{"N", "[", 
                RowBox[{"T", "/", "nsub"}], "]"}], "//", 
               "EngineeringForm"}]}], "]"}], ";", "\[IndentingNewLine]", "\t", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"T", "/", "nsub"}], ",", "T"}], "}"}]}], 
           "\[IndentingNewLine]", "\t", ")"}], ",", "\[IndentingNewLine]", 
          RowBox[{"nsup", ">", "1"}], ",", "\[IndentingNewLine]", "\t", 
          RowBox[{"(", "\[IndentingNewLine]", "\t", 
           RowBox[{
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"Signal1D", "::", "new\[Delta]t"}], ",", 
              RowBox[{
               RowBox[{"N", "[", 
                RowBox[{"T", "\[Times]", "nsup"}], "]"}], "//", 
               "EngineeringForm"}]}], "]"}], ";", "\[IndentingNewLine]", "\t", 
            RowBox[{"{", 
             RowBox[{"\[Delta]t", ",", 
              RowBox[{"T", "\[Times]", "nsup"}]}], "}"}]}], 
           "\[IndentingNewLine]", "\t", ")"}], ",", "\[IndentingNewLine]", 
          "True", ",", "\[IndentingNewLine]", "\t", 
          RowBox[{"{", 
           RowBox[{"\[Delta]t", ",", "T"}], "}"}]}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True", ",", "moresubcatst"}], "}"}], ",", 
             "moresampst"}], "}"}], ",", "acqevst", ",", "prepst", ",", 
           "ensavst", ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
           "sigcalcst", ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"{", 
           RowBox[{"tmin", ",", "tmax", ",", "new\[Delta]t"}], "}"}]}], ",", 
         "\[IndentingNewLine]", "acqevents", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"SignalGeneratorPeriod", "\[Rule]", "newT"}], ",", 
            "opts"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7010898582075157`*^9, 3.7010899393661613`*^9}, {
  3.701090616288413*^9, 3.7010906267200108`*^9}},
 CellLabel->
  "In[2115]:=",ExpressionUUID->"ca609cb9-424d-4ec9-9b73-5d48248b498b"]
}, Closed]],

Cell[CellGroupData[{

Cell["close subcategory", "Subsubsection",
 CellChangeTimes->{{3.70108772770216*^9, 3.701087736628746*^9}, {
  3.7010877927481413`*^9, 
  3.701087793491551*^9}},ExpressionUUID->"0404567b-6148-45a7-a3d7-\
10174118da91"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"sampst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", 
          RowBox[{"{", 
           RowBox[{"True", ".."}], "}"}], ",", "moresampst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True", ",", "moresampst"}], "}"}], 
       ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", "items", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7010876911588297`*^9, 3.701087809922934*^9}},
 CellLabel->
  "In[2116]:=",ExpressionUUID->"67b94bf5-6f75-47fd-b848-9ac834102296"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["3. ForceEvenNumberOfPoints", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4708100337563677`*^9, 3.470810036177558*^9}, {3.4708249624088182`*^9, 
   3.470824969917295*^9}, {3.499327401834897*^9, 3.499327405282339*^9}, {
   3.4993275939770517`*^9, 3.4993275962154427`*^9}, {3.499327642179414*^9, 
   3.499327643185897*^9}, {3.49962650936719*^9, 3.499626522132051*^9}, {
   3.499628683754075*^9, 3.4996286987351723`*^9}, 3.49970735330583*^9, {
   3.701090824039523*^9, 
   3.701090824390565*^9}},ExpressionUUID->"12dbcc4c-0e27-44cc-b06e-\
6529d7465045"],

Cell[CellGroupData[{

Cell["initiate subcategory", "Subsubsection",
 CellChangeTimes->{{3.70108772770216*^9, 
  3.701087736628746*^9}},ExpressionUUID->"a94bdb22-0f53-4cf0-9bec-\
5941376c02bc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"sampst", ":", 
        RowBox[{"{", 
         RowBox[{
         "True", ",", "True", ",", "True", ",", "False", ",", 
          "moresampst___"}], "}"}]}], ",", "morest___"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True", ",", 
         RowBox[{"{", 
          RowBox[{"False", ",", "False"}], "}"}], ",", "moresampst"}], "}"}], 
       ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", "items", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7010876911588297`*^9, 3.701087779645369*^9}, {
  3.701090838638831*^9, 3.701090849358397*^9}},
 CellLabel->
  "In[2117]:=",ExpressionUUID->"48fbe7a2-2dc4-4810-98db-4527a068686e"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
request implementation (or close if ForceEvenNumberOfPoints\[Rule]False)\
\>", "Subsubsection",
 CellChangeTimes->{{3.70108772770216*^9, 3.701087736628746*^9}, {
  3.701087834074416*^9, 3.701087838282117*^9}, {3.701090940179652*^9, 
  3.701090944516548*^9}},ExpressionUUID->"9c355a77-c1ac-4eec-a761-\
b6f80a321274"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"sampst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", "True", ",", 
          RowBox[{"{", 
           RowBox[{"False", ",", "moresubcatst___"}], "}"}], ",", 
          "moresampst___"}], "}"}]}], ",", "morest___"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
        "True", ",", "True", ",", "True", ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ForceEvenNumberOfPoints", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"True", ",", "moresubcatst"}], "}"}], ",", 
           "\[IndentingNewLine]", "True"}], "]"}], ",", "\[IndentingNewLine]",
          "moresampst"}], "}"}], ",", "\[IndentingNewLine]", "morest"}], 
      "}"}], ",", "\[IndentingNewLine]", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7010876911588297`*^9, 3.701087779645369*^9}, {
   3.7010878710810757`*^9, 3.701087945664917*^9}, {3.70108932627071*^9, 
   3.7010893272722073`*^9}, {3.7010893683114223`*^9, 3.701089419100286*^9}, 
   3.7010894580463343`*^9, 3.701089521604374*^9, {3.701090874686825*^9, 
   3.701090893355432*^9}},
 CellLabel->
  "In[2118]:=",ExpressionUUID->"32f49843-79a1-425b-b30d-dc4d43e3b72b"]
}, Closed]],

Cell[CellGroupData[{

Cell["implement", "Subsubsection",
 CellChangeTimes->{{3.70108772770216*^9, 3.701087736628746*^9}, {
  3.701087834074416*^9, 3.701087838282117*^9}, {3.7010908639099503`*^9, 
  3.701090865306897*^9}},ExpressionUUID->"75cb3a0b-31e7-4fc1-a2d3-\
4a09727bbf49"],

Cell["\<\
if necessary, drop the last point to make the number of points even.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.499825677461419*^9, 
  3.4998257035413017`*^9}},ExpressionUUID->"8e82ca5c-5bee-44e8-8cfc-\
b2ad719b5243"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"sampst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", "True", ",", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "moresubcatst___"}], "}"}], ",",
           "moresampst___"}], "}"}]}], ",", "morest___"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"timing", ":", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}]}], ",", 
     "acqevents_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "modtmax"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"Round", "[", 
         RowBox[{
          RowBox[{"Abs", "[", 
           RowBox[{"tmax", "-", "tmin"}], "]"}], "/", "\[Delta]t"}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"modtmax", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"EvenQ", "[", "n", "]"}], ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Message", "[", 
             RowBox[{"Signal1D", "::", "droplast"}], "]"}], ";", "tmax"}], 
           ")"}], ",", 
          RowBox[{"tmax", "-", "\[Delta]t"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "True", ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True", ",", "moresubcatst"}], "}"}], ",", 
             "moresampst"}], "}"}], ",", "morest"}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"{", 
           RowBox[{"tmin", ",", "modtmax", ",", "\[Delta]t"}], "}"}]}], ",", 
         "\[IndentingNewLine]", "acqevents", ",", "opts"}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469877106456835*^9, 3.4698771515511723`*^9}, {
   3.4699668317131777`*^9, 3.469966960657042*^9}, {3.47082520986065*^9, 
   3.47082521196518*^9}, {3.499326643837493*^9, 3.499326648942895*^9}, {
   3.499661717108493*^9, 3.499661747408987*^9}, {3.4997081925289717`*^9, 
   3.499708193069504*^9}, 3.4998256909382563`*^9, 3.500163268306842*^9, {
   3.51435287325369*^9, 3.514352880765483*^9}, {3.566469044940686*^9, 
   3.5664691155224524`*^9}, 3.56646921940659*^9, {3.587819390919183*^9, 
   3.587819405829081*^9}, {3.6839577240089617`*^9, 3.683957724011376*^9}, {
   3.699959595224032*^9, 3.69995959668633*^9}, {3.701090999831361*^9, 
   3.7010911058383713`*^9}, {3.701091238106544*^9, 3.701091238537775*^9}, {
   3.701091612422967*^9, 3.701091798795981*^9}},
 CellLabel->
  "In[2119]:=",ExpressionUUID->"8351a5e5-3a1d-4b51-8905-80d1d82d4fdd"]
}, Closed]],

Cell[CellGroupData[{

Cell["close subcategory", "Subsubsection",
 CellChangeTimes->{{3.70108772770216*^9, 3.701087736628746*^9}, {
  3.7010877927481413`*^9, 
  3.701087793491551*^9}},ExpressionUUID->"faa989eb-214c-4f28-b544-\
91eabfc89e95"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<Sampling\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"sampst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", "True", ",", 
          RowBox[{"{", 
           RowBox[{"True", ".."}], "}"}], ",", "moresampst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{
        "True", ",", "True", ",", "True", ",", "True", ",", "moresampst"}], 
        "}"}], ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", "items", 
     ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7010876911588297`*^9, 3.701087809922934*^9}, {
  3.7010909665314713`*^9, 3.701090972937545*^9}},
 CellLabel->
  "In[2120]:=",ExpressionUUID->"5b858378-c6eb-4671-833e-f88cc444cc7f"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["3. acquisition events", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4708100337563677`*^9, 3.470810036177558*^9}, {3.4708249624088182`*^9, 
   3.470824969917295*^9}, {3.499326427012347*^9, 3.4993264426186132`*^9}, {
   3.499326986527643*^9, 3.499327000564424*^9}, 3.5025102950785418`*^9, {
   3.69996277341606*^9, 3.699962776261106*^9}, {3.7010978899498873`*^9, 
   3.7010978902621927`*^9}},ExpressionUUID->"d6fb69fb-f9de-4534-a6bd-\
991d2839fd8b"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"9aa928ef-1411-485c-8e68-\
1081292a44b1"],

Cell["\<\
request set up only when sampling (first pass) and EnsembleAverage are set up\
\
\>", "Text",
 CellChangeTimes->{{3.700302421262439*^9, 3.700302426381648*^9}, {
   3.700302478423265*^9, 3.7003024796619263`*^9}, {3.700302514102523*^9, 
   3.700302525411582*^9}, {3.7003133306536283`*^9, 3.7003133333855753`*^9}, 
   3.700314161513726*^9, {3.7004881087947903`*^9, 3.70048811987219*^9}, {
   3.700488172245214*^9, 3.70048818157102*^9}, {3.700488234327723*^9, 
   3.700488238629614*^9}, {3.701087306469873*^9, 3.701087309316659*^9}, {
   3.7010873571480017`*^9, 
   3.701087362073277*^9}},ExpressionUUID->"bdb5cd65-e81a-4434-9fa7-\
0761feab53f7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"chronst_", ",", 
       RowBox[{"samplingst", ":", 
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
       RowBox[{"acqevst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "_", ",", "morelocst___"}], "}"}]}], ",", 
       "prepst_", ",", 
       RowBox[{"ensavst", ":", "True"}], ",", "morest___"}], "}"}], ",", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"chronst", ",", "samplingst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
       "prepst", ",", "ensavst", ",", "morest"}], "}"}], ",", "items", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.7003022653767443`*^9, {3.700302435480123*^9, 3.7003024966369133`*^9}, {
   3.700305211874774*^9, 3.700305217712449*^9}, 3.700306724381501*^9, 
   3.700313295269217*^9, {3.700314163935392*^9, 3.700314164862854*^9}, {
   3.7004838264037123`*^9, 3.7004838573392076`*^9}, {3.70048813185814*^9, 
   3.7004881657320347`*^9}, 3.700488919786149*^9, {3.700567559542041*^9, 
   3.700567559907357*^9}, {3.701087334919013*^9, 3.701087343627912*^9}},
 CellLabel->
  "In[2121]:=",ExpressionUUID->"783e9c04-3c10-49ef-99c0-27745de906b9"]
}, Closed]],

Cell[CellGroupData[{

Cell["preparations", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627994703074`*^9}, {
   3.699962983120303*^9, 3.699962984873206*^9}, 3.7003022344675903`*^9, {
   3.700305226439003*^9, 
   3.7003052281746693`*^9}},ExpressionUUID->"69707e92-3c1f-436d-83ff-\
40680122179e"],

Cell[CellGroupData[{

Cell["missing acq event generator", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627994703074`*^9}, {
   3.699962983120303*^9, 3.699962984873206*^9}, 
   3.7003022344675903`*^9},ExpressionUUID->"ee993b5f-29eb-4b13-a5ab-\
e29d98ea3f2c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<AcquisitionEvents\>\""}], "]"}]}], 
        ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", "timing_List", ",", "opts___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{"status", ",", "timing", ",", "None", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.497572755249617*^9, 3.497572921111905*^9}, {
   3.4975735078232603`*^9, 3.497573580934906*^9}, 3.497573722854797*^9, {
   3.49932620249533*^9, 3.499326227413639*^9}, {3.699959509744532*^9, 
   3.699959510228266*^9}, {3.6999628638691177`*^9, 3.699962921265547*^9}, {
   3.700302142713305*^9, 3.700302155621682*^9}, 3.7003022598408737`*^9},
 CellLabel->
  "In[2122]:=",ExpressionUUID->"e02029d9-eb44-40cc-aa85-f6eca704e44d"]
}, Closed]],

Cell[CellGroupData[{

Cell["create null event", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.4698826319018106`*^9, 
   3.469882634476049*^9}, {3.4699668164774103`*^9, 3.46996682390167*^9}, {
   3.470809989981741*^9, 3.47080999168219*^9}, {3.47081041498164*^9, 
   3.470810416538479*^9}, {3.4993271862571287`*^9, 3.499327199599419*^9}, {
   3.499327658641523*^9, 3.4993276854652967`*^9}, {3.4993277206188993`*^9, 
   3.4993277509611473`*^9}, {3.500256851277314*^9, 3.500256870547772*^9}, {
   3.5002569147252293`*^9, 3.50025691770752*^9}, {3.5972334290751667`*^9, 
   3.597233432410079*^9}, {3.597233745551605*^9, 3.5972337472872334`*^9}, 
   3.7002988629423647`*^9, {3.700305257014155*^9, 
   3.700305260356162*^9}},ExpressionUUID->"fe04d5ed-c808-4b44-a43d-\
b910b3fbb7c7"],

Cell["\<\
create a null event, filling the acquisition interval, and combine the \
specified evolution generator with any specifications for the \
BackgroundGenerator\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.597233354686061*^9, 3.59723336402857*^9}, {
   3.597233439938725*^9, 3.597233466898196*^9}, {3.5972336160616293`*^9, 
   3.597233637275755*^9}, {3.597233735761682*^9, 3.5972337593030863`*^9}, {
   3.597234223822361*^9, 3.597234250050905*^9}, 
   3.709375542117763*^9},ExpressionUUID->"d6b4ee56-1b3d-48f8-a1b4-\
f3af46b278b4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<AcquisitionEvents\>\""}], "]"}]}], 
        ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}], ",", 
     RowBox[{"evgen_", "?", "ValidGeneratorQ"}], ",", "opts___Rule"}], "]"}], 
   ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "backg", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"backg", "=", 
        RowBox[{"ReleaseHold", "[", 
         RowBox[{
          RowBox[{"BackgroundGenerator", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{"status", ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"None", ",", 
             RowBox[{"tmax", "-", "tmin"}]}], "}"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Switch", "[", "\[IndentingNewLine]", 
              RowBox[{"backg", ",", "\[IndentingNewLine]", 
               RowBox[{"Except", "[", "_List", "]"}], ",", 
               "\[IndentingNewLine]", "\t", 
               RowBox[{"CombineGenerators", "[", 
                RowBox[{"evgen", ",", "backg"}], "]"}], ",", 
               "\[IndentingNewLine]", "_List", ",", "\[IndentingNewLine]", 
               "\t", 
               RowBox[{
                RowBox[{
                 RowBox[{"CombineGenerators", "[", 
                  RowBox[{"evgen", ",", "#"}], "]"}], "&"}], "/@", "backg"}], 
               ",", "\[IndentingNewLine]", "_", ",", "\[IndentingNewLine]", 
               "\t", "$Failed"}], "\[IndentingNewLine]", "]"}]}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}]}], ")"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.499327730269598*^9, 3.4993277821323023`*^9}, {
   3.4993278431001987`*^9, 3.499327844840743*^9}, {3.499329696717948*^9, 
   3.4993297010504637`*^9}, {3.499709144070877*^9, 3.499709147059876*^9}, {
   3.500256919926849*^9, 3.5002569392868633`*^9}, {3.5662357359577312`*^9, 
   3.5662357461976957`*^9}, {3.597233496101321*^9, 3.597233538836124*^9}, {
   3.597233572133402*^9, 3.597233600738001*^9}, 3.597233710969305*^9, 
   3.59723381588133*^9, {3.597234263333962*^9, 3.597234314692061*^9}, {
   3.5972343891892853`*^9, 3.597234515874625*^9}, {3.657389530030369*^9, 
   3.6573895465890903`*^9}, {3.6573901524477863`*^9, 3.657390158646649*^9}, {
   3.657390813096025*^9, 3.657390824038124*^9}, 3.657392939451887*^9, {
   3.699545073265814*^9, 3.6995450751987143`*^9}, {3.699545117838155*^9, 
   3.6995451204067955`*^9}, {3.6995451655699253`*^9, 
   3.6995451657801514`*^9}, {3.699959524538904*^9, 3.699959525540222*^9}, {
   3.7002983691254663`*^9, 3.700298476650034*^9}, {3.709373419834598*^9, 
   3.709373419838187*^9}, 3.709373778287774*^9, {3.709375542799745*^9, 
   3.709375543452552*^9}, {3.7136383176833277`*^9, 3.713638318925284*^9}, 
   3.7136933750068274`*^9},
 CellLabel->
  "In[2123]:=",ExpressionUUID->"ab754d0d-aa8a-4188-80da-56165edafcc6"]
}, Closed]],

Cell[CellGroupData[{

Cell["set number of event repetitions for Repeat[_,Automatic]", \
"Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.4698826319018106`*^9, 
   3.469882634476049*^9}, {3.4699668164774103`*^9, 3.46996682390167*^9}, {
   3.470809989981741*^9, 3.47080999168219*^9}, {3.47081041498164*^9, 
   3.470810416538479*^9}, {3.4993271862571287`*^9, 3.499327199599419*^9}, {
   3.499370246979075*^9, 3.49937024813869*^9}, {3.499558701297306*^9, 
   3.499558708038742*^9}, {3.499660320734047*^9, 3.499660330058764*^9}, 
   3.6629213610929728`*^9, {3.700305284316709*^9, 
   3.700305286324009*^9}},ExpressionUUID->"c1ece637-a37d-4e1b-88dc-\
6220959735fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"prefix", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{"Signal1D", ",", "\"\<AcquisitionEvents\>\""}], "]"}]}], 
         ",", 
         RowBox[{"acqevst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
         "morest___"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}], ",", 
      RowBox[{"events", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"ReleaseHold", "[", "events", "]"}], ",", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"Repeat", "[", 
        RowBox[{"_", ",", "___Rule"}], "]"}]}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{"status", ",", 
     RowBox[{"{", 
      RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"Repeat", "[", 
       RowBox[{
        RowBox[{"First", "@", 
         RowBox[{"ReleaseHold", "[", "events", "]"}]}], ",", "Automatic"}], 
       "]"}]}], ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.500257001256736*^9, 3.500257053678643*^9}, {
   3.515063976684062*^9, 3.515064025168743*^9}, {3.515064061446439*^9, 
   3.5150640617017097`*^9}, 3.515064515984935*^9, {3.684946895333987*^9, 
   3.684946895338628*^9}, {3.692848557442482*^9, 3.692848558539612*^9}, {
   3.699959526012205*^9, 3.699959526496418*^9}, {3.70030262583214*^9, 
   3.700302656525301*^9}, 3.700304020389317*^9, 3.700567683193845*^9, {
   3.7005679371826468`*^9, 3.700567945595449*^9}, 3.7005680509137383`*^9, 
   3.7005683380604153`*^9},
 CellLabel->
  "In[2124]:=",ExpressionUUID->"ef3fb483-2efb-47e9-a1d7-a0599ae92c04"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{"chronst_", ",", 
         RowBox[{"samplingst", ":", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
         RowBox[{"acqevst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
         "morest___"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}], ",", 
      RowBox[{"events", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], "/;",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ReleaseHold", "[", "events", "]"}], ",", 
       RowBox[{"HoldPattern", "@", 
        RowBox[{"Repeat", "[", 
         RowBox[{"_", ",", "Automatic", ",", "___Rule"}], "]"}]}]}], "]"}], "&&",
      "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"EvenQ", "[", 
        RowBox[{"Length", "[", 
         RowBox[{"Range", "[", 
          RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "]"}], "]"}], 
        "]"}], "||", 
       RowBox[{"!", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"ForceEvenNumberOfPoints", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}]}], ")"}]}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"repev", ",", "repevdur"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"repev", "=", 
        RowBox[{"First", "@", 
         RowBox[{"ReleaseHold", "[", "events", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"repevdur", "=", 
        RowBox[{"EventDuration", "[", "repev", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Chop", "[", "repevdur", "]"}], "\[Equal]", "0"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"Signal1D", "::", "zerorepeldur"}], "]"}], ";", 
           "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
          RowBox[{"status", ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Evaluate", "@", 
            RowBox[{"Repeat", "[", 
             RowBox[{"repev", ",", 
              RowBox[{"Ceiling", "[", 
               RowBox[{"Abs", "[", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"tmax", "-", "tmin"}], ")"}], "/", "repevdur"}], 
                "]"}], "]"}]}], "]"}]}], ",", "opts"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.499327218635776*^9, 3.4993273025328827`*^9}, {
   3.499329453168728*^9, 3.4993294736538277`*^9}, 3.499329533071166*^9, 
   3.49932956872147*^9, 3.499329755048649*^9, {3.4993682621839857`*^9, 
   3.499368331357382*^9}, {3.499368361782454*^9, 3.4993684349607773`*^9}, {
   3.499627547041923*^9, 3.49962756597501*^9}, 3.4996602628290033`*^9, {
   3.499707543688168*^9, 3.499707604108417*^9}, 3.4997092826939383`*^9, {
   3.500163653552977*^9, 3.5001636611984243`*^9}, {3.500164592152432*^9, 
   3.500164594214258*^9}, 3.507987032012286*^9, 3.515064166605357*^9, {
   3.515064357119782*^9, 3.515064367348303*^9}, {3.51506450790978*^9, 
   3.515064539582945*^9}, 3.515075131694436*^9, {3.662921516734845*^9, 
   3.662921518949012*^9}, 3.680955506235381*^9, {3.6849468953534613`*^9, 
   3.684946895359563*^9}, {3.6928485594203157`*^9, 3.692848560241921*^9}, {
   3.6999595269802847`*^9, 3.699959528454039*^9}, {3.700303970313342*^9, 
   3.700304057889516*^9}, {3.7003141996507*^9, 3.700314200130826*^9}, 
   3.700567687240507*^9, {3.700567952051416*^9, 3.70056796285211*^9}, 
   3.700568047624522*^9, {3.700568123589815*^9, 3.700568134636784*^9}, 
   3.700568341763295*^9, 3.701088121793994*^9},
 CellLabel->
  "In[2125]:=",ExpressionUUID->"49f28f4e-30c5-482c-944a-ff15d73c8af8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{"chronst_", ",", 
         RowBox[{"samplingst", ":", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
         RowBox[{"acqevst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
         "morest___"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}], ",", 
      RowBox[{"events", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], "/;",
     "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ReleaseHold", "[", "events", "]"}], ",", 
       RowBox[{"HoldPattern", "@", 
        RowBox[{"Repeat", "[", 
         RowBox[{"_", ",", "Automatic", ",", "___Rule"}], "]"}]}]}], "]"}], "&&",
      "\[IndentingNewLine]", 
     RowBox[{"OddQ", "[", 
      RowBox[{"Length", "[", 
       RowBox[{"Range", "[", 
        RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "]"}], "]"}], "]"}], 
     "&&", 
     RowBox[{"TrueQ", "[", 
      RowBox[{
       RowBox[{"ForceEvenNumberOfPoints", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"repev", ",", "repevdur"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"repev", "=", 
        RowBox[{"First", "@", 
         RowBox[{"ReleaseHold", "[", "events", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"repevdur", "=", 
        RowBox[{"EventDuration", "[", "repev", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Chop", "[", "repevdur", "]"}], "\[Equal]", "0"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"Signal1D", "::", "zerorepeldur"}], "]"}], ";", 
           "$Failed"}], ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
          RowBox[{"status", ",", "\[IndentingNewLine]", 
           RowBox[{"Evaluate", "@", 
            RowBox[{"{", 
             RowBox[{"tmin", ",", 
              RowBox[{"tmax", "+", "\[Delta]t"}], ",", "\[Delta]t"}], "}"}]}],
            ",", "\[IndentingNewLine]", 
           RowBox[{"Evaluate", "@", 
            RowBox[{"Repeat", "[", 
             RowBox[{"repev", ",", 
              RowBox[{"Ceiling", "[", 
               RowBox[{"Abs", "[", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"\[Delta]t", "+", "tmax", "-", "tmin"}], ")"}], "/",
                  "repevdur"}], "]"}], "]"}]}], "]"}]}], ",", "opts"}], 
          "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.499327218635776*^9, 3.4993273025328827`*^9}, {
   3.499329453168728*^9, 3.4993294736538277`*^9}, 3.499329533071166*^9, 
   3.49932956872147*^9, 3.499329755048649*^9, {3.4993682621839857`*^9, 
   3.499368331357382*^9}, {3.499368361782454*^9, 3.4993684349607773`*^9}, {
   3.499627547041923*^9, 3.49962756597501*^9}, 3.4996602628290033`*^9, {
   3.499707543688168*^9, 3.4997076704090223`*^9}, 3.499707823570306*^9, {
   3.499709270374084*^9, 3.4997092731404133`*^9}, {3.500163672546093*^9, 
   3.500163675208375*^9}, 3.5001646050410748`*^9, 3.5079870326514893`*^9, 
   3.5150640897903347`*^9, {3.515064518294002*^9, 3.515064542308256*^9}, {
   3.662921530607649*^9, 3.6629215309022093`*^9}, 3.680955507248003*^9, {
   3.6849468953798532`*^9, 3.68494689538437*^9}, {3.692848561192*^9, 
   3.692848561923256*^9}, {3.699959528903864*^9, 3.699959530332786*^9}, {
   3.700304096962429*^9, 3.700304129260919*^9}, {3.700314203769966*^9, 
   3.700314204215918*^9}, 3.700567690824065*^9, {3.7005679590615997`*^9, 
   3.700567966578178*^9}, {3.700568039682994*^9, 3.700568042502722*^9}, 
   3.700568344500873*^9, 3.701088124303598*^9},
 CellLabel->
  "In[2126]:=",ExpressionUUID->"c0952dd5-14ad-4e5e-86fa-548c227e4d7d"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["apply EventSpecifications, padding events if needed", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.4698826319018106`*^9, 
   3.469882634476049*^9}, {3.4699668164774103`*^9, 3.46996682390167*^9}, {
   3.470809989981741*^9, 3.47080999168219*^9}, {3.47081041498164*^9, 
   3.470810416538479*^9}, {3.4993271862571287`*^9, 3.499327199599419*^9}, {
   3.499327815815411*^9, 3.499327832053439*^9}, {3.5143504099189034`*^9, 
   3.51435042354111*^9}, {3.514350643141842*^9, 3.514350670923064*^9}, {
   3.700306282149856*^9, 3.700306292724945*^9}, 
   3.700309355338585*^9},ExpressionUUID->"82d327c0-1cb5-4552-b4ec-\
3a7f7770a905"],

Cell["RtoL chronology is imposed by EventSpecifications.", "Text",
 CellChangeTimes->{{3.7003140952134247`*^9, 3.7003141054518127`*^9}, {
  3.700885033430917*^9, 
  3.700885039372299*^9}},ExpressionUUID->"983a5d9c-9f03-48df-8a7c-\
e85aa053d222"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{"chronst_", ",", 
         RowBox[{"samplingst", ":", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
         RowBox[{"acqevst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
         "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"events", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "\[IndentingNewLine]", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"ReleaseHold", "[", "events", "]"}], ",", 
      RowBox[{"Except", "[", "_EventSpecifications", "]"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "chron", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"chron", "=", 
        RowBox[{
         RowBox[{"Chronology", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{"status", ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"EventSpecifications", "[", 
           RowBox[{
            RowBox[{"ReleaseHold", "[", "events", "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Chronology", "\[Rule]", "chron"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Sequence", "@@", 
               RowBox[{"FilterRules", "[", 
                RowBox[{
                 RowBox[{"{", "opts", "}"}], ",", 
                 RowBox[{"Options", "[", "EventSpecifications", "]"}]}], 
                "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
           "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
         "opts"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7003087163370647`*^9, 3.700308742380763*^9}, {
   3.700309173540329*^9, 3.700309177385789*^9}, 3.7003138184532146`*^9, {
   3.700313945730966*^9, 3.7003139887496758`*^9}, {3.70031404778382*^9, 
   3.7003140485572853`*^9}, {3.700314211514686*^9, 3.700314211983698*^9}, {
   3.700323077717979*^9, 3.700323119970735*^9}, {3.7005684195438766`*^9, 
   3.700568472439925*^9}, 3.701088097649478*^9, {3.711452331895512*^9, 
   3.711452360905159*^9}},
 CellLabel->
  "In[2127]:=",ExpressionUUID->"be220460-4306-4a0e-a8e2-8a399ca79d04"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{"chronst_", ",", 
        RowBox[{"samplingst", ":", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
        RowBox[{"acqevst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"events", ":", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"EventSpecifications", "[", 
        RowBox[{"True", ",", "evspecs_List", ",", "evspecopts___Rule"}], 
        "]"}]}]}], ",", "\[IndentingNewLine]", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "dur", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{"status", ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"EventSpecifications", "[", 
           RowBox[{"True", ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"None", ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"tmax", "-", "tmin"}], ")"}], "-", "dur"}]}], 
                 "}"}], "}"}], ",", "evspecs"}], "]"}], "//.", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"c___List", ",", 
                RowBox[{"{", 
                 RowBox[{"b_", ",", 
                  RowBox[{"\[Tau]2_", "?", "NumericQ"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"b_", ",", 
                  RowBox[{"\[Tau]1_", "?", "NumericQ"}]}], "}"}], ",", 
                "a___List"}], "}"}], "\[RuleDelayed]", 
              RowBox[{"{", 
               RowBox[{"c", ",", 
                RowBox[{"{", 
                 RowBox[{"b", ",", 
                  RowBox[{"\[Tau]2", "+", "\[Tau]1"}]}], "}"}], ",", "a"}], 
               "}"}]}]}], ",", "\[IndentingNewLine]", "evspecopts"}], 
           "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
         "opts"}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}],
       "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"dur", "=", 
         RowBox[{"EventDuration", "[", 
          RowBox[{"Evaluate", "@", "events"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"dur", "<", 
         RowBox[{"(", 
          RowBox[{"tmax", "-", "tmin"}], ")"}]}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.499327872267666*^9, 3.499328000590036*^9}, {
   3.499329493893284*^9, 3.499329509471486*^9}, 3.499329565010051*^9, {
   3.499367830092774*^9, 3.499367848393485*^9}, {3.4993679898039837`*^9, 
   3.4993679935054083`*^9}, {3.499368902467636*^9, 3.4993689042822638`*^9}, {
   3.4993733797942343`*^9, 3.4993734586984177`*^9}, {3.4993736135237303`*^9, 
   3.49937373453093*^9}, {3.4993738105424643`*^9, 3.49937382472435*^9}, {
   3.4993740413283033`*^9, 3.499374057046618*^9}, {3.499707941680563*^9, 
   3.49970805105443*^9}, {3.499708538913508*^9, 3.499708542950912*^9}, {
   3.502448112272884*^9, 3.502448129822002*^9}, {3.507987033289814*^9, 
   3.507987034554571*^9}, 3.508005033214636*^9, {3.514350215254765*^9, 
   3.514350243156735*^9}, {3.514350686954677*^9, 3.514351014842613*^9}, {
   3.51435106293622*^9, 3.514351191724299*^9}, 3.514799188036746*^9, {
   3.514799269599784*^9, 3.514799272270234*^9}, 3.517826609599682*^9, 
   3.680955508215551*^9, {3.683957723816353*^9, 3.683957723819289*^9}, {
   3.6999595327068167`*^9, 3.6999595341695232`*^9}, {3.7003056781611443`*^9, 
   3.700305756234868*^9}, {3.7003057874817553`*^9, 3.700305864945025*^9}, {
   3.700306130278116*^9, 3.700306276710384*^9}, {3.700308765621922*^9, 
   3.7003088136657677`*^9}, {3.700308943001436*^9, 3.700309080152261*^9}, 
   3.700309296268972*^9, {3.700314216715424*^9, 3.700314217223884*^9}, {
   3.7003231465389967`*^9, 3.700323175770203*^9}, 3.701088099816502*^9},
 CellLabel->
  "In[2128]:=",ExpressionUUID->"51824d5f-5999-462b-b847-5aa056150d04"]
}, Closed]],

Cell[CellGroupData[{

Cell["check validity and set flag", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.4698826319018106`*^9, 
   3.469882634476049*^9}, {3.4699668164774103`*^9, 3.46996682390167*^9}, {
   3.470809989981741*^9, 3.47080999168219*^9}, {3.47081041498164*^9, 
   3.470810416538479*^9}, {3.4993271862571287`*^9, 3.499327199599419*^9}, {
   3.499370246979075*^9, 3.49937024813869*^9}, {3.499558701297306*^9, 
   3.499558708038742*^9}, {3.499660320734047*^9, 3.499660330058764*^9}, 
   3.6629213610929728`*^9, {3.700304169749876*^9, 3.700304170508382*^9}, {
   3.70030420550863*^9, 
   3.7003042101625967`*^9}},ExpressionUUID->"53d0bfd5-4c8c-44fd-9979-\
a053890330b3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{"chronst_", ",", 
         RowBox[{"samplingst", ":", 
          RowBox[{"True", "|", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
         RowBox[{"acqevst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
         "morest___"}], "}"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}], ",", 
      "evspecs_EventSpecifications", ",", "opts___Rule"}], "]"}], "/;", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"EventDuration", "[", "evspecs", "]"}], "\[GreaterEqual]", 
     RowBox[{"(", 
      RowBox[{"tmax", "-", "tmin"}], ")"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"chronst", ",", "samplingst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "}"}], ",", 
     RowBox[{"Evaluate", "@", "evspecs"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70030421356476*^9, 3.7003043070363083`*^9}, {
   3.7003044152640333`*^9, 3.700304416758236*^9}, {3.700304765379957*^9, 
   3.700304783740057*^9}, {3.700304980124453*^9, 3.700304995866633*^9}, {
   3.700305941945332*^9, 3.7003059421015587`*^9}, {3.700306329567501*^9, 
   3.700306329829739*^9}, {3.700309108840488*^9, 3.70030912922015*^9}, {
   3.700309247948966*^9, 3.700309260463151*^9}, {3.7003142277620373`*^9, 
   3.700314228208597*^9}, {3.700329086303331*^9, 3.7003290903588037`*^9}, 
   3.701088105592227*^9},
 CellLabel->
  "In[2129]:=",ExpressionUUID->"7e2b64d9-129b-4be1-8f90-94a1fefd0fe5"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardize and set flag", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.4698826319018106`*^9, 
   3.469882634476049*^9}, {3.4699668164774103`*^9, 3.46996682390167*^9}, {
   3.470809989981741*^9, 3.47080999168219*^9}, {3.47081041498164*^9, 
   3.470810416538479*^9}, {3.4993271862571287`*^9, 3.499327199599419*^9}, {
   3.499370246979075*^9, 3.49937024813869*^9}, {3.499558701297306*^9, 
   3.499558708038742*^9}, {3.499660320734047*^9, 3.499660330058764*^9}, 
   3.6629213610929728`*^9, {3.700304169749876*^9, 3.700304170508382*^9}, {
   3.70030420550863*^9, 3.7003042101625967`*^9}, {3.700329360946804*^9, 
   3.7003293672093*^9}},ExpressionUUID->"e2e96121-c164-48bd-8e84-\
828a0e9d6bb8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{"chronst_", ",", 
        RowBox[{"samplingst", ":", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
        RowBox[{"acqevst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "morest___"}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}], ",", 
     RowBox[{"evspecs", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"chronst", ",", "samplingst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], "}"}], 
       ",", "morest"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "}"}], ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"EventSpecifications", "[", "evspecs", "]"}]}], ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.70030421356476*^9, 3.7003043070363083`*^9}, {
   3.7003044152640333`*^9, 3.700304416758236*^9}, {3.700304765379957*^9, 
   3.700304783740057*^9}, {3.700304980124453*^9, 3.700304995866633*^9}, {
   3.700305941945332*^9, 3.7003059421015587`*^9}, {3.700306329567501*^9, 
   3.700306329829739*^9}, {3.700309108840488*^9, 3.70030912922015*^9}, {
   3.700309247948966*^9, 3.700309260463151*^9}, {3.7003142277620373`*^9, 
   3.700314228208597*^9}, {3.700329086303331*^9, 3.7003290903588037`*^9}, {
   3.700329376226108*^9, 3.7003294156999826`*^9}, 3.700329494287722*^9, 
   3.7010881096093693`*^9},
 CellLabel->
  "In[2130]:=",ExpressionUUID->"a266473c-d8aa-47ba-9ad1-d343d480b89f"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["4. Preparation", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.430456142359412*^9, 3.430456146975505*^9}, {
   3.4708100337563677`*^9, 3.470810036177558*^9}, {3.4708249624088182`*^9, 
   3.470824969917295*^9}, {3.499326427012347*^9, 3.4993264426186132`*^9}, {
   3.499326986527643*^9, 3.499327000564424*^9}, 3.5025102950785418`*^9, {
   3.699963410547476*^9, 3.699963420332803*^9}, {3.699965795481142*^9, 
   3.699965800431175*^9}, {3.701097892858964*^9, 
   3.70109789318943*^9}},ExpressionUUID->"df35ab80-1d97-4388-b870-\
8893f95479a2"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"da1a5e19-1409-4348-994b-\
25a5ad05e721"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<Preparation\>\""}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "done_", ",", "morelocst___"}], "}"}]}], ",", 
       "morest___"}], "}"}], ",", 
     RowBox[{"items", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "items", ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9},
 CellLabel->
  "In[2131]:=",ExpressionUUID->"81d991ce-a913-40e5-aaee-996dc2a45a56"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 
   3.700298704750389*^9}},ExpressionUUID->"2cc309d3-1d3a-4a30-9d43-\
4e0097a92dd2"],

Cell[CellGroupData[{

Cell["standardize Preparation", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.500259193423772*^9, 
   3.500259201718212*^9}, {3.699963638238307*^9, 3.699963648700026*^9}, {
   3.699963998839843*^9, 3.699964005453691*^9}, {3.69996418069976*^9, 
   3.699964188190331*^9}, {3.700303211846243*^9, 
   3.700303214242257*^9}},ExpressionUUID->"c4da0cd4-c6b1-4d12-ab28-\
ae7d9eb8e200"],

Cell["RtoL chronology is imposed by EventSpecifications", "Text",
 CellChangeTimes->{{3.700885070727372*^9, 
  3.7008850824776382`*^9}},ExpressionUUID->"49c8147e-9d0e-4fc7-88a9-\
06f0b33335d2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Preparation\>\""}], "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", "sampling_List", ",", "more___", ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prep", ",", "standprep"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"standprep", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"Switch", "[", 
            RowBox[{"#", ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"_", "?", "ValidEventSpecificationQ"}], "|", 
              "_PulseSequence"}], ",", "\[IndentingNewLine]", "\t", 
             RowBox[{"StandardizeEventSpecification", "[", "#", "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"_", "?", "PulseSequenceQ"}], ",", "\[IndentingNewLine]", 
             RowBox[{"StandardizeEventSpecification", "@", 
              RowBox[{"PulseSequence", "[", 
               RowBox[{"#", ",", "opts"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"_", "?", "ValidEventSpecificationQ"}], "..."}], "}"}],
              ",", "\[IndentingNewLine]", "\t", 
             RowBox[{"StandardizeEventSpecification", "/@", "#"}], ",", 
             "\[IndentingNewLine]", "_", ",", "$Failed"}], "]"}], "&"}], "@", 
          "prep"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Signal1D", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"prefix", ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
            "morest"}], "}"}], ",", "sampling", ",", "more", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Evaluate", "@", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Preparation", "\[Rule]", "\[IndentingNewLine]", 
              RowBox[{"EventSpecifications", "[", "\[IndentingNewLine]", 
               RowBox[{"standprep", ",", "\[IndentingNewLine]", 
                RowBox[{"Sequence", "@@", 
                 RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"SimplifyRules", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Chronology", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Chronology", "/.", 
                    RowBox[{"{", "opts", "}"}]}], "/.", 
                    RowBox[{"Options", "[", "Signal1D", "]"}]}], ")"}]}], ",",
                     "opts"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Options", "[", "EventSpecifications", "]"}]}], 
                  "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
               "]"}]}], ",", "\[IndentingNewLine]", "opts"}], 
            "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"prep", "=", 
         RowBox[{
          RowBox[{"Preparation", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"prep", ",", 
          RowBox[{
           RowBox[{"_", "?", "ValidEventSpecificationQ"}], "|", 
           "_PulseSequence", "|", 
           RowBox[{"_", "?", "PulseSequenceQ"}], "|", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"_", "?", "ValidEventSpecificationQ"}], "..."}], 
            "}"}]}]}], "]"}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699963672135429*^9, 3.699963720454352*^9}, {
   3.699963770159423*^9, 3.699963794682675*^9}, {3.6999641987233458`*^9, 
   3.699964333981978*^9}, {3.699964781402458*^9, 3.699964786025526*^9}, {
   3.700303446668886*^9, 3.700303451579649*^9}, {3.700303508188171*^9, 
   3.700303516681468*^9}, 3.700303669234022*^9, {3.7004843857145348`*^9, 
   3.70048446555569*^9}, {3.7004845873053827`*^9, 3.700484651889249*^9}, 
   3.700485800546091*^9, {3.7004858886257763`*^9, 3.700485893353343*^9}, {
   3.7004861145790443`*^9, 3.70048612541033*^9}, {3.700486203837716*^9, 
   3.7004862688886013`*^9}, {3.700486400006469*^9, 3.7004865801346483`*^9}, {
   3.700487003830055*^9, 3.700487084912019*^9}, {3.700564464857862*^9, 
   3.7005644975200157`*^9}, {3.700564529961708*^9, 3.700564534367502*^9}, {
   3.709549525983711*^9, 3.7095495299129725`*^9}, {3.709549573023179*^9, 
   3.7095495785351286`*^9}, 3.7095496255848236`*^9, {3.709549669388558*^9, 
   3.709549669569013*^9}, {3.711452419780551*^9, 3.711452454794961*^9}, {
   3.71145272255962*^9, 3.7114527226991453`*^9}, {3.71145362324718*^9, 
   3.711453628894271*^9}, {3.7114537573050475`*^9, 3.7114537574649897`*^9}, {
   3.7117134579322815`*^9, 3.7117134628725367`*^9}, {3.7117134988034763`*^9, 
   3.711713498982953*^9}, {3.717241634702315*^9, 3.71724166493878*^9}, {
   3.7172420344723797`*^9, 3.717242037141159*^9}, {3.717243507578418*^9, 
   3.7172435199778385`*^9}, {3.7191688915394287`*^9, 3.719168912480367*^9}},
 CellLabel->
  "In[2132]:=",ExpressionUUID->"96c9e1a6-4bd5-49ac-b8f1-b6a9c00e6916"]
}, Closed]],

Cell[CellGroupData[{

Cell["check validity of Preparation and set status", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.500259193423772*^9, 
   3.500259201718212*^9}, {3.699963638238307*^9, 
   3.699963648700026*^9}},ExpressionUUID->"08655e3d-503d-4d3b-b54d-\
e5b45350db08"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Preparation\>\""}], "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "morest___"}], "}"}]}], ",", "sampling_List", ",", 
     "more___", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "prep", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"prep", "=", 
        RowBox[{
         RowBox[{"Preparation", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"prep", ",", 
           RowBox[{"EventSpecifications", "[", 
            RowBox[{"True", ",", "___"}], "]"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Signal1D", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"prefix", ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], 
              "}"}], ",", "morest"}], "}"}], ",", "sampling", ",", "more", 
           ",", "opts"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"Signal1D", "::", "invalprep"}], ",", "prep"}], "]"}], 
           ";", "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699963672135429*^9, 3.699963720454352*^9}, {
  3.699963770159423*^9, 3.699963794682675*^9}, {3.699964356418219*^9, 
  3.6999644593315077`*^9}, {3.699964509340963*^9, 3.699964509946117*^9}, {
  3.6999646691384287`*^9, 3.699964669788949*^9}, {3.6999647920330687`*^9, 
  3.699964798243396*^9}, {3.700486694178811*^9, 3.700486714207755*^9}, {
  3.7004868562254887`*^9, 3.700486897679411*^9}, {3.70048693133565*^9, 
  3.700486941844046*^9}, {3.709549685030747*^9, 3.7095497468862123`*^9}, {
  3.717240802776307*^9, 3.717240807240482*^9}, {3.7172420471136074`*^9, 
  3.7172420472422047`*^9}},
 CellLabel->
  "In[2133]:=",ExpressionUUID->"07bd2859-0e04-4f62-902c-5a73c2dbb821"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["5. EnsembleAverage", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.509890958854889*^9, 3.5098909645578957`*^9}, {
   3.509891167092675*^9, 3.5098911716419077`*^9}, {3.6430331301444807`*^9, 
   3.643033168521751*^9}, 3.657214360985279*^9, 3.699965000263547*^9, 
   3.699965789428555*^9, {3.701097895549698*^9, 
   3.701097895834693*^9}},ExpressionUUID->"cdd24cde-3b89-4b72-afa7-\
b763bdbf0211"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"2ae63c9c-ed02-439d-96d7-\
1350872015c6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<EnsembleAverage\>\""}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "nextlocst_", ",", "morelocst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}},
 CellLabel->
  "In[2134]:=",ExpressionUUID->"32b04aa2-ea6f-46af-91aa-f18036976a59"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 
   3.700298704750389*^9}},ExpressionUUID->"20863d0b-3f9e-4948-a5fa-\
66fa9985d60f"],

Cell[CellGroupData[{

Cell["case of no EnsembleAverage", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.6999651865551662`*^9, 3.699965204305951*^9}, {3.6999659996591463`*^9, 
   3.699966001255926*^9}},ExpressionUUID->"0fe331bb-4334-41e8-b112-\
40ad6a3aca8a"],

Cell["indicate that all preparations have been done", "Text",
 CellChangeTimes->{{3.6999664451434402`*^9, 
  3.69996645198256*^9}},ExpressionUUID->"819adeda-7e6f-460c-920d-\
69fbf79a7791"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<EnsembleAverage\>\""}], "]"}]}], ",", 
        
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"EnsembleAverage", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
      RowBox[{"False", "|", "None"}]}], "]"}]}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", "True", ",", "morest"}], "}"}], ",", "more", ",", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{
        RowBox[{"EnsembleAverage", "\[Rule]", "False"}], ",", "opts"}], 
       "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699966016692745*^9, 3.69996611662718*^9}, {
  3.6999662442283573`*^9, 3.6999662553192368`*^9}, {3.69996641843752*^9, 
  3.6999664234195013`*^9}},
 CellLabel->
  "In[2135]:=",ExpressionUUID->"e3d66090-a4d6-44c2-8f58-9776206fc0f2"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardize EnsembleAverage", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.6999651865551662`*^9, 
   3.699965204305951*^9}},ExpressionUUID->"4108dd6a-98fd-407a-8fb8-\
a3e906a5ae77"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<EnsembleAverage\>\""}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
       "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts1___Rule", ",", 
     RowBox[{"EnsembleAverage", "\[Rule]", "ensav_"}], ",", "opts2___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{
        RowBox[{"EnsembleAverage", "->", 
         RowBox[{"StandardizeEnsembleAverage", "[", "ensav", "]"}]}], ",", 
        "opts1", ",", "opts2"}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.69996522458116*^9, 
   3.6999652253555193`*^9}, {3.699965256768085*^9, 3.699965393759205*^9}, {
   3.699965595298367*^9, 3.699965598163332*^9}},
 CellLabel->
  "In[2136]:=",ExpressionUUID->"93c09dea-48fc-4daf-a823-89fcd8507ed8"]
}, Closed]],

Cell[CellGroupData[{

Cell["expand multidimensional variables", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.6999651865551662`*^9, 3.699965204305951*^9}, {3.699965473230483*^9, 
   3.699965485379623*^9}},ExpressionUUID->"2597a2d8-5db9-4fb9-8c48-\
abb679df0858"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<EnsembleAverage\>\""}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
         "}"}]}], ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts1___Rule", ",", 
     RowBox[{"EnsembleAverage", "\[Rule]", "ensav_"}], ",", "opts2___Rule"}], 
    "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"modmore", ",", "modopts"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"modmore", ",", "modopts"}], "}"}], "=", 
        "\[IndentingNewLine]", 
        RowBox[{
        "ExpandMultidimensionalEnsembleVariables", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "more", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"opts1", ",", "opts2"}], "}"}]}], "}"}], ",", 
          "\[IndentingNewLine]", "ensav"}], "\[IndentingNewLine]", "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], 
            "}"}], ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "[", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"ReleaseHold", "@", "modmore"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"EnsembleAverage", "\[Rule]", 
             RowBox[{
             "ExpandMultidimensionalEnsembleVariables", "@", "ensav"}]}], ",",
             "\[IndentingNewLine]", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"ReleaseHold", "@", "modopts"}]}]}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.69996522458116*^9, 
   3.6999652253555193`*^9}, {3.699965256768085*^9, 3.699965393759205*^9}, {
   3.699965488982991*^9, 3.699965674024057*^9}, {3.700487922322399*^9, 
   3.700487923368285*^9}, {3.700488350781142*^9, 3.700488351369256*^9}, {
   3.702806661995947*^9, 3.7028066658606462`*^9}, {3.702806885653371*^9, 
   3.7028068858408885`*^9}},
 CellLabel->
  "In[2137]:=",ExpressionUUID->"866085e5-867c-4da2-a39a-1c409021b43f"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["6. NormalizationFactor", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469882637143063*^9, 
   3.469882639820516*^9}, 3.4698965783855743`*^9, {3.497350131321055*^9, 
   3.497350134039557*^9}, {3.497361829032502*^9, 3.497361831030924*^9}, 
   3.533177318822701*^9, {3.70109789934643*^9, 
   3.701097899822394*^9}},ExpressionUUID->"bf8ce338-7452-4e04-9a97-\
6b7f52f148f1"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"86d7ff89-107f-462e-8cd5-\
ee298c8ebe32"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<NormalizationFactor\>\""}], "]"}]}], 
       ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "nextlocst_", ",", "morelocst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, 3.7004888218963623`*^9},
 CellLabel->
  "In[2138]:=",ExpressionUUID->"325589ce-f8db-483c-886a-6462ecb599c6"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 
   3.700298704750389*^9}},ExpressionUUID->"ef1fab06-7d3b-4b08-a9ce-\
b1ab055acfc9"],

Cell[CellGroupData[{

Cell["trap", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.699966639175864*^9, 3.699966640682085*^9}, {3.699966909213282*^9, 
   3.699966932185123*^9}},ExpressionUUID->"b51e8f02-dbb9-489a-ab87-\
0dfe98f0ee7e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<NormalizationFactor\>\""}], "]"}]}], 
        ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NormalizationFactor", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], "|", "None", "|", "False"}]}], 
      "]"}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"NormalizationFactor", "::", "bad"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999669479834423`*^9, 3.699966953813917*^9}},
 CellLabel->
  "In[2139]:=",ExpressionUUID->"e49ad345-36e1-4b0c-b516-13cf1e0e89d7"]
}, Closed]],

Cell[CellGroupData[{

Cell["implement", "Subsubsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.699966639175864*^9, 
   3.699966640682085*^9}},ExpressionUUID->"b5f03970-1b15-414a-a4ad-\
128a796dcdd0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<NormalizationFactor\>\""}], "]"}]}], 
        ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"NormalizationFactor", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
      RowBox[{"None", "|", "False"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", 
       RowBox[{
        RowBox[{"NormalizationFactor", "\[Rule]", "1"}], ",", "opts"}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.49929083823372*^9, 3.4992909193759117`*^9}, {
   3.499326356177109*^9, 3.499326362675103*^9}, {3.502001914672365*^9, 
   3.50200192600642*^9}, 3.5020031090184727`*^9, {3.53317732255233*^9, 
   3.533177323779237*^9}, {3.699959513783826*^9, 3.6999595147061567`*^9}, {
   3.699966650339589*^9, 3.6999667321693583`*^9}, {3.699966846756225*^9, 
   3.699966858758287*^9}, 3.699967116634654*^9},
 CellLabel->
  "In[2140]:=",ExpressionUUID->"8ade1e14-3c34-420b-8348-51ed85a740f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"stat", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"prefix", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{"Signal1D", ",", "\"\<NormalizationFactor\>\""}], "]"}]}], 
         ",", 
         RowBox[{"locst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
         "morest___"}], "}"}]}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", 
       RowBox[{
        RowBox[{"NormalizationFactor", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], "\[Equal]", "0"}],
      ")"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"NormalizationFactor", "::", "zero"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Signal1D", "[", 
      RowBox[{"stat", ",", "more", ",", "\[IndentingNewLine]", 
       RowBox[{"Evaluate", "@", 
        RowBox[{"SimplifyRules", "[", 
         RowBox[{
          RowBox[{"NormalizationFactor", "\[Rule]", "1"}], ",", "opts"}], 
         "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ")"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.49929083823372*^9, 3.4992909193759117`*^9}, {
   3.499326356177109*^9, 3.499326362675103*^9}, {3.502001914672365*^9, 
   3.50200192600642*^9}, 3.5020031090184727`*^9, {3.53310464618274*^9, 
   3.533104688200778*^9}, {3.533177327660001*^9, 3.533177337156756*^9}, {
   3.6999595152573423`*^9, 3.699959516280979*^9}, {3.699966743625852*^9, 
   3.699966778351943*^9}, {3.699966869380278*^9, 3.699966887039794*^9}},
 CellLabel->
  "In[2141]:=",ExpressionUUID->"e696bcdb-dd82-414e-8aee-0d4f60383253"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ready", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.699966639175864*^9, 3.699966640682085*^9}, {3.699966909213282*^9, 
   3.6999669190918713`*^9}},ExpressionUUID->"0a5ca307-e092-4278-8aae-\
06bd228027c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"stat", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"prefix", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{"Signal1D", ",", "\"\<NormalizationFactor\>\""}], "]"}]}], 
         ",", 
         RowBox[{"locst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
         "morest___"}], "}"}]}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"NumericQ", "[", 
     RowBox[{
      RowBox[{"NormalizationFactor", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4698826859811773`*^9, 3.4698827878510637`*^9}, {
   3.469883666792901*^9, 3.4698837065279207`*^9}, {3.469883871916778*^9, 
   3.46988388557224*^9}, {3.469894558017357*^9, 3.469894561621529*^9}, {
   3.4973493441747*^9, 3.497349356132997*^9}, {3.497349761854837*^9, 
   3.497349762454198*^9}, {3.49734991684128*^9, 3.497349917519363*^9}, {
   3.497350183546541*^9, 3.4973502058233137`*^9}, {3.4973618383598347`*^9, 
   3.4973620009547777`*^9}, {3.497363309231777*^9, 3.497363310581868*^9}, {
   3.497363866961959*^9, 3.4973638710147676`*^9}, {3.499326370172661*^9, 
   3.499326375553574*^9}, {3.502001957857398*^9, 3.5020019874408712`*^9}, {
   3.502002030670822*^9, 3.502002056193275*^9}, {3.533104817781901*^9, 
   3.5331048255224943`*^9}, {3.533104893937894*^9, 3.53310489781619*^9}, {
   3.533177356679551*^9, 3.5331773702571373`*^9}, {3.699959516753861*^9, 
   3.699959517237462*^9}, {3.699966803160285*^9, 3.699966819909266*^9}, {
   3.699966986765307*^9, 3.699967042606062*^9}, 3.699967088588106*^9},
 CellLabel->
  "In[2142]:=",ExpressionUUID->"2270350e-79c8-48f1-ad2d-78968f450199"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["7. Observable", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469882637143063*^9, 
   3.469882639820516*^9}, 3.4698965783855743`*^9, {3.497350131321055*^9, 
   3.497350134039557*^9}, {3.497361829032502*^9, 3.497361831030924*^9}, 
   3.533177318822701*^9, {3.700297646915533*^9, 3.7002976485686913`*^9}, {
   3.7010979030844707`*^9, 
   3.701097903484579*^9}},ExpressionUUID->"ac4fbb13-f9ee-4c33-b232-\
93e84158f61b"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"6ff3e332-b92a-4179-8134-\
606f94352168"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "nextlocst_", ",", "morelocst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, {
   3.719169268484451*^9, 3.719169304862713*^9}},
 CellLabel->
  "In[2143]:=",ExpressionUUID->"222618be-c6e7-4edc-bc89-990556f87702"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 
   3.700298704750389*^9}},ExpressionUUID->"d73fd50f-47df-4761-9197-\
c83f1a1ba595"],

Cell[CellGroupData[{

Cell["trap obsolete use of ObservableOperator", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.544622606331711*^9, 
  3.5446226124560738`*^9}},ExpressionUUID->"6efcebe4-5e31-42b1-ac9d-\
c064622fd7ba"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}], ",", 
      RowBox[{"args", ":", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{"ObservableOperator", "/.", 
        RowBox[{"{", "opts", "}"}]}], ",", "ObservableOperator"}], "]"}]}]}], 
   ":=", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"Signal1D", "::", "obsopobsol"}], "]"}], ";", "$Failed"}], 
    ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.544622321206872*^9, 3.544622529714563*^9}, 
   3.544623322504581*^9, {3.54462365420227*^9, 3.544623656039424*^9}, {
   3.6233423786340437`*^9, 3.6233425031799183`*^9}, {3.6999595177435913`*^9, 
   3.699959518227489*^9}, {3.700297752123376*^9, 3.7002977774436913`*^9}},
 CellLabel->
  "In[2144]:=",ExpressionUUID->"d1e03f15-f6d2-421f-83f4-a95c2af88e56"]
}, Closed]],

Cell[CellGroupData[{

Cell["Observable \[Rule] All", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.544622606331711*^9, 3.5446226355120564`*^9}, {
  3.544622717307953*^9, 3.5446227224024343`*^9}, {3.544623095584015*^9, 
  3.544623125698204*^9}, {3.544623464697445*^9, 
  3.5446234671850023`*^9}},ExpressionUUID->"ea553ec4-62fc-413c-a646-\
b46f83afc60d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"prefix", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}]}], ",", 
         RowBox[{"locst", ":", 
          RowBox[{"{", 
           RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
         "morest___"}], "}"}]}], ",", 
      RowBox[{"args", ":", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Observable", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", "All"}], "]"}]}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{"status", ",", "args", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Observable", "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"First", "/@", 
           RowBox[{"SpinSystem", "[", "]"}]}], ")"}]}], ",", 
        "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.544622321206872*^9, 3.544622529714563*^9}, {
   3.5446226444236937`*^9, 3.5446227008696404`*^9}, {3.544622765768495*^9, 
   3.544622803317958*^9}, {3.544623106182523*^9, 3.5446231421349583`*^9}, 
   3.544623328512183*^9, {3.5446234101670103`*^9, 3.5446234591040363`*^9}, {
   3.5446235933530207`*^9, 3.544623594940132*^9}, {3.699959518700163*^9, 
   3.69995951963342*^9}, {3.7002977956766148`*^9, 3.700297826081217*^9}},
 CellLabel->
  "In[2145]:=",ExpressionUUID->"d889d418-a3d1-40bd-a745-4b6d0c0964ea"]
}, Closed]],

Cell[CellGroupData[{

Cell["Observable set to a single valid spin", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.544622606331711*^9, 3.5446226355120564`*^9}, {
  3.544622717307953*^9, 3.5446227224024343`*^9}, {3.544623095584015*^9, 
  3.544623097897524*^9}, {3.6810431920082417`*^9, 
  3.681043192828753*^9}},ExpressionUUID->"86be7e17-5ff1-416a-9e77-\
80728cb57974"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"args", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "obsspin", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", 
        RowBox[{"status", ",", "args", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Observable", "\[Rule]", 
             RowBox[{"{", "obsspin", "}"}]}], ",", "\[IndentingNewLine]", 
            "opts"}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]",
         "]"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"obsspin", "=", 
         RowBox[{
          RowBox[{"Observable", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"obsspin", ",", 
           RowBox[{"Except", "[", "_List", "]"}]}], "]"}], "&&", 
         RowBox[{"ValidSpinQ", "[", 
          RowBox[{"obsspin", ",", 
           RowBox[{"SpinSystem", "[", "]"}]}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.681043111886224*^9, 3.681043158764976*^9}, {
  3.6823510526144733`*^9, 3.682351065855837*^9}, {3.682577463266877*^9, 
  3.6825774762379093`*^9}, {3.699543375717372*^9, 3.6995433778002567`*^9}, {
  3.699543450618759*^9, 3.6995434508478208`*^9}, {3.699959520117363*^9, 
  3.699959521107308*^9}, {3.700297846177743*^9, 3.700297867599674*^9}, {
  3.700569984515587*^9, 3.7005699849702263`*^9}},
 CellLabel->
  "In[2146]:=",ExpressionUUID->"764ee131-2f8c-48ee-8842-9e67e50e247a"]
}, Closed]],

Cell[CellGroupData[{

Cell["Observable set to a list of valid spins", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.544622606331711*^9, 3.5446226355120564`*^9}, {
  3.544622717307953*^9, 3.5446227224024343`*^9}, {3.544623095584015*^9, 
  3.544623125698204*^9}, {3.544623156393998*^9, 3.544623160343684*^9}, {
  3.681043196284523*^9, 
  3.6810431970363703`*^9}},ExpressionUUID->"e1fd42cb-8b87-4a5a-8760-\
17658c4d47c2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"args", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "obsspins", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
           "morest"}], "}"}], ",", "\[IndentingNewLine]", "args", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Observable", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                RowBox[{"(", 
                 RowBox[{"1", "/", "2"}], ")"}]}], "I", " ", 
               RowBox[{"opI", "[", 
                RowBox[{"obsspins", ",", "\"\<-\>\""}], "]"}]}], ")"}]}], ",",
             "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
           "]"}]}]}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
       ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"obsspins", "=", 
         RowBox[{
          RowBox[{"Observable", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"obsspins", ",", "_List"}], "]"}], "&&", 
         RowBox[{"ValidSpinQ", "[", 
          RowBox[{"obsspins", ",", 
           RowBox[{"SpinSystem", "[", "]"}]}], "]"}]}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.544622321206872*^9, 3.544622529714563*^9}, {
   3.5446226444236937`*^9, 3.5446227008696404`*^9}, {3.544622758944714*^9, 
   3.544622996656443*^9}, {3.54462304479603*^9, 3.5446230527745533`*^9}, 
   3.544623331194955*^9, {3.544623415429081*^9, 3.544623417937141*^9}, 
   3.5446236021793833`*^9, {3.618477768187441*^9, 3.618477808525128*^9}, {
   3.618478060123385*^9, 3.618478063377081*^9}, 3.618485258750977*^9, {
   3.681043035441444*^9, 3.681043056488799*^9}, {3.681043205465005*^9, 
   3.681043221428401*^9}, {3.681043256102331*^9, 3.68104325754034*^9}, {
   3.682577754534328*^9, 3.682577768139454*^9}, {3.6825778239040537`*^9, 
   3.682577827856718*^9}, {3.6995450132765713`*^9, 3.699545018029442*^9}, {
   3.6995450588277893`*^9, 3.699545059047986*^9}, {3.699959521636119*^9, 
   3.6999595226149893`*^9}, {3.700297885671331*^9, 3.700297908502122*^9}, {
   3.700570017114457*^9, 3.700570045970531*^9}},
 CellLabel->
  "In[2147]:=",ExpressionUUID->"17aac3bc-7a1c-4653-b6d1-72434e15c99c"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Observable set to PolarizationLevel or SingletPolarizationLevel\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.544622606331711*^9, 3.5446226355120564`*^9}, {
  3.544622717307953*^9, 3.5446227224024343`*^9}, {3.544623095584015*^9, 
  3.544623125698204*^9}, {3.544623156393998*^9, 3.544623160343684*^9}, {
  3.681043196284523*^9, 3.6810431970363703`*^9}, {3.700568951017972*^9, 
  3.7005689606782217`*^9}},ExpressionUUID->"c5e4502e-6d39-40cc-9a30-\
a2709ff7bace"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"args", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "obs", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{"Signal1D", "::", "obspollevel"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"prefix", ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
            "morest"}], "}"}], ",", "\[IndentingNewLine]", "args", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Evaluate", "@", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Observable", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"obs", "/.", 
                RowBox[{
                "PolarizationLevel", "\[Rule]", 
                 "PolarizationLevelOperator"}]}], ")"}]}], ",", 
             "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
            "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"obs", "=", 
         RowBox[{
          RowBox[{"Observable", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"obs", ",", "_PolarizationLevel"}], "]"}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.544622321206872*^9, 3.544622529714563*^9}, {
   3.5446226444236937`*^9, 3.5446227008696404`*^9}, {3.544622758944714*^9, 
   3.544622996656443*^9}, {3.54462304479603*^9, 3.5446230527745533`*^9}, 
   3.544623331194955*^9, {3.544623415429081*^9, 3.544623417937141*^9}, 
   3.5446236021793833`*^9, {3.618477768187441*^9, 3.618477808525128*^9}, {
   3.618478060123385*^9, 3.618478063377081*^9}, 3.618485258750977*^9, {
   3.681043035441444*^9, 3.681043056488799*^9}, {3.681043205465005*^9, 
   3.681043221428401*^9}, {3.681043256102331*^9, 3.68104325754034*^9}, {
   3.682577754534328*^9, 3.682577768139454*^9}, {3.6825778239040537`*^9, 
   3.682577827856718*^9}, {3.6995450132765713`*^9, 3.699545018029442*^9}, {
   3.6995450588277893`*^9, 3.699545059047986*^9}, {3.699959521636119*^9, 
   3.6999595226149893`*^9}, {3.700297885671331*^9, 3.700297908502122*^9}, {
   3.700568976631811*^9, 3.700569058310191*^9}, {3.7005700597764263`*^9, 
   3.700570069789168*^9}, {3.7005704361638823`*^9, 3.7005704503775454`*^9}, {
   3.700570645897653*^9, 3.700570651310615*^9}, 3.7005708070078278`*^9},
 CellLabel->
  "In[2148]:=",ExpressionUUID->"df6d0f46-bc68-4e96-a284-e48566e17db5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"args", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "obs", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Message", "[", 
         RowBox[{"Signal1D", "::", "obssingpollevel"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"prefix", ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
            "morest"}], "}"}], ",", "\[IndentingNewLine]", "args", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Evaluate", "@", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Observable", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"obs", "/.", 
                RowBox[{
                "SingletPolarizationLevel", "\[Rule]", 
                 "SingletPolarizationLevelOperator"}]}], ")"}]}], ",", 
             "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
            "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"obs", "=", 
         RowBox[{
          RowBox[{"Observable", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"obs", ",", "_SingletPolarizationLevel"}], "]"}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.544622321206872*^9, 3.544622529714563*^9}, {
   3.5446226444236937`*^9, 3.5446227008696404`*^9}, {3.544622758944714*^9, 
   3.544622996656443*^9}, {3.54462304479603*^9, 3.5446230527745533`*^9}, 
   3.544623331194955*^9, {3.544623415429081*^9, 3.544623417937141*^9}, 
   3.5446236021793833`*^9, {3.618477768187441*^9, 3.618477808525128*^9}, {
   3.618478060123385*^9, 3.618478063377081*^9}, 3.618485258750977*^9, {
   3.681043035441444*^9, 3.681043056488799*^9}, {3.681043205465005*^9, 
   3.681043221428401*^9}, {3.681043256102331*^9, 3.68104325754034*^9}, {
   3.682577754534328*^9, 3.682577768139454*^9}, {3.6825778239040537`*^9, 
   3.682577827856718*^9}, {3.6995450132765713`*^9, 3.699545018029442*^9}, {
   3.6995450588277893`*^9, 3.699545059047986*^9}, {3.699959521636119*^9, 
   3.6999595226149893`*^9}, {3.700297885671331*^9, 3.700297908502122*^9}, {
   3.700568976631811*^9, 3.7005690812698193`*^9}, {3.7005700785501547`*^9, 
   3.700570086287575*^9}},
 CellLabel->
  "In[2149]:=",ExpressionUUID->"82668630-acd2-4122-b0cc-8268322004b7"]
}, Closed]],

Cell[CellGroupData[{

Cell["pass on to final check", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.544622606331711*^9, 3.5446226355120564`*^9}, {
  3.544622717307953*^9, 3.5446227224024343`*^9}, {3.544623095584015*^9, 
  3.544623125698204*^9}, {3.544623156393998*^9, 3.544623160343684*^9}, {
  3.681043196284523*^9, 3.6810431970363703`*^9}, {3.700568951017972*^9, 
  3.7005689606782217`*^9}, {3.700570142162047*^9, 3.700570144122814*^9}, {
  3.700570334816165*^9, 
  3.700570340868417*^9}},ExpressionUUID->"777e7bb8-cf4e-476b-8c5b-\
a2e257c7387c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}]}], ",", 
     RowBox[{"args", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "args", ",", "opts"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.544622321206872*^9, 3.544622529714563*^9}, {
   3.5446226444236937`*^9, 3.5446227008696404`*^9}, {3.544622758944714*^9, 
   3.544622996656443*^9}, {3.54462304479603*^9, 3.5446230527745533`*^9}, 
   3.544623331194955*^9, {3.544623415429081*^9, 3.544623417937141*^9}, 
   3.5446236021793833`*^9, {3.618477768187441*^9, 3.618477808525128*^9}, {
   3.618478060123385*^9, 3.618478063377081*^9}, 3.618485258750977*^9, {
   3.681043035441444*^9, 3.681043056488799*^9}, {3.681043205465005*^9, 
   3.681043221428401*^9}, {3.681043256102331*^9, 3.68104325754034*^9}, {
   3.682577754534328*^9, 3.682577768139454*^9}, {3.6825778239040537`*^9, 
   3.682577827856718*^9}, {3.6995450132765713`*^9, 3.699545018029442*^9}, {
   3.6995450588277893`*^9, 3.699545059047986*^9}, {3.699959521636119*^9, 
   3.6999595226149893`*^9}, {3.700297885671331*^9, 3.700297908502122*^9}, {
   3.700568976631811*^9, 3.7005690812698193`*^9}, {3.7005700785501547`*^9, 
   3.700570086287575*^9}, {3.7005701563613987`*^9, 3.700570208849615*^9}, 
   3.700570346031013*^9},
 CellLabel->
  "In[2150]:=",ExpressionUUID->"724ee90b-9abe-4fd5-97cf-6d70a67a3c30"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["check & set ready flag", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.544622606331711*^9, 3.5446226355120564`*^9}, {
   3.544622717307953*^9, 3.5446227224024343`*^9}, {3.544623095584015*^9, 
   3.544623125698204*^9}, {3.544623156393998*^9, 3.544623160343684*^9}, {
   3.681043196284523*^9, 3.6810431970363703`*^9}, {3.6810449364743433`*^9, 
   3.68104494111967*^9}, {3.700297960861977*^9, 3.700297962324567*^9}, {
   3.7002981143212967`*^9, 3.700298120344182*^9}, {3.700298175508358*^9, 
   3.7002981760754967`*^9}, 
   3.700570902802927*^9},ExpressionUUID->"e5036602-91e7-4ee0-94ad-\
f75e52fdf0c4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<Observable\>\""}], "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
          "}"}]}], ",", "morest___"}], "}"}]}], ",", 
     RowBox[{"args", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "obs", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"obs", "=", 
        RowBox[{
         RowBox[{"Observable", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"OperatorQ", "[", "obs", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Signal1D", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"prefix", ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], 
              "}"}], ",", "morest"}], "}"}], ",", "args", ",", "opts"}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"Signal1D", "::", "invalobs"}], ",", "obs"}], "]"}], ";",
            "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.681044949997314*^9, 3.681045083750194*^9}, {
   3.6810451257357693`*^9, 3.6810451997279873`*^9}, {3.6825778560817213`*^9, 
   3.6825778771756983`*^9}, {3.699959523098477*^9, 3.69995952404381*^9}, {
   3.700297969857798*^9, 3.700298097285434*^9}, 3.7005695406797132`*^9, {
   3.700570093021923*^9, 3.700570103491774*^9}, {3.70057026711775*^9, 
   3.700570267483206*^9}},
 CellLabel->
  "In[2151]:=",ExpressionUUID->"8c2a9306-4a63-4ac6-9180-25da75d1fc13"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["8. BackgroundGenerator", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469882637143063*^9, 
   3.469882639820516*^9}, 3.4698965783855743`*^9, {3.497350131321055*^9, 
   3.497350134039557*^9}, 3.497572555273549*^9, {3.49962571930704*^9, 
   3.499625720633676*^9}, 3.700309573483725*^9, {3.701097906540648*^9, 
   3.701097907693223*^9}, 
   3.7093755442111073`*^9},ExpressionUUID->"123c0f57-f224-46b8-8adf-\
1e87b7c8fdc2"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"9887f721-4f57-4e3e-8769-\
1ca6b4acfffd"],

Cell["\<\
only do this after the EnsembleAverage has been set up, to ensure \
multidimensional variables have been expanded\
\>", "Text",
 CellChangeTimes->{{3.70048766577647*^9, 3.700487684342527*^9}, {
  3.700487825172986*^9, 
  3.700487830817691*^9}},ExpressionUUID->"d46e50a5-d15e-4c3d-bb76-\
0c938ad42a1e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"chron_", ",", "samp_", ",", "acqev_", ",", "prep_", ",", 
       RowBox[{"ensav", ":", "True"}], ",", "normfac_", ",", "obs_", ",", 
       "\[IndentingNewLine]", 
       RowBox[{"evbst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "nextevbst_", ",", "moreevbst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chron", ",", "samp", ",", "acqev", ",", "prep", ",", "ensav", ",", 
       "normfac", ",", "obs", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "moreevbst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700487694223301*^9, 3.70048781391779*^9}, {
   3.7191693214038315`*^9, 3.7191693596416545`*^9}},
 CellLabel->
  "In[2152]:=",ExpressionUUID->"a1a35657-e691-4b02-bba7-003c26cfebcc"]
}, Closed]],

Cell[CellGroupData[{

Cell["standardization", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700309598202568*^9, 
   3.7003096016263037`*^9}},ExpressionUUID->"0a06bc43-2fe9-4635-821c-\
db9ccaffa2bc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<BackgroundGenerator\>\""}], "]"}]}], 
       ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
       "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "evbackg", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"evbackg", "=", 
        RowBox[{"StandardizeGenerator", "[", 
         RowBox[{"(", 
          RowBox[{"ReleaseHold", "[", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], ")"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
           "morest"}], "}"}], ",", "more", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Switch", "[", 
              RowBox[{"evbackg", ",", "\[IndentingNewLine]", 
               RowBox[{"Except", "[", "_List", "]"}], ",", 
               RowBox[{"StandardizeGenerator", "[", "evbackg", "]"}], ",", 
               "\[IndentingNewLine]", "_List", ",", 
               RowBox[{"StandardizeGenerator", "/@", "evbackg"}], ",", 
               "\[IndentingNewLine]", "_", ",", "$Failed"}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            "opts"}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]",
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700309626432626*^9, 3.700309825969651*^9}, {
   3.700310056716866*^9, 3.700310057347103*^9}, {3.7027706940881877`*^9, 
   3.7027707578389273`*^9}, 3.702771187249196*^9, 3.702771711904467*^9, {
   3.7027717793794394`*^9, 3.7027717795115347`*^9}, {3.703235069363023*^9, 
   3.703235082012912*^9}, {3.7093740519364653`*^9, 3.7093740519399548`*^9}, {
   3.709375544993725*^9, 3.709375546231031*^9}, {3.719169486627988*^9, 
   3.719169489470293*^9}, {3.7191697012935205`*^9, 3.7191697245752764`*^9}, {
   3.7191697606300526`*^9, 3.7191698532499914`*^9}, {3.719169887689986*^9, 
   3.719169889079546*^9}, {3.719170053125657*^9, 3.719170064604946*^9}, 
   3.726070360032089*^9},
 CellLabel->
  "In[2153]:=",ExpressionUUID->"bb68f620-a288-4538-b588-51543cdd446f"]
}, Closed]],

Cell[CellGroupData[{

Cell["diagonalization", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700309598202568*^9, 3.7003096016263037`*^9}, {3.700310956349225*^9, 
   3.700310958635674*^9}},ExpressionUUID->"560e30e3-2547-41a4-9f05-\
73f4ad0d0ae4"],

Cell["requires EnsembleAverage to be set up", "Text",
 CellChangeTimes->{{3.700311026475007*^9, 
  3.7003110367448473`*^9}},ExpressionUUID->"6b2c5d41-aee9-419f-8459-\
0e23cb281634"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"chronst_", ",", 
       RowBox[{"sampst", ":", 
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
       "acqevst_", ",", 
       RowBox[{"prepst", ":", "True"}], ",", 
       RowBox[{"ensavst", ":", "True"}], ",", "normfacst_", ",", "obsst_", 
       ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", "False", ",", "morelocst___"}], 
         "}"}]}], ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "evbackg", ",", "ensav", ",", "diagfunc", ",", "opbasis", ",", 
       "basis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"evbackg", "=", 
        RowBox[{"StandardizeGenerator", "[", 
         RowBox[{"(", 
          RowBox[{"ReleaseHold", "[", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], ")"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"ensav", "=", 
        RowBox[{
         RowBox[{"EnsembleAverage", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"diagfunc", "=", 
        RowBox[{"Function", "[", 
         RowBox[{"backg", ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"UnassignedSymbols", "[", "backg", "]"}], "]"}], "==", 
             "0"}], ",", "\[IndentingNewLine]", "\t", 
            RowBox[{"Switch", "[", 
             RowBox[{"backg", ",", "\[IndentingNewLine]", "\t", 
              RowBox[{"NullOperator", "[", "]"}], ",", "backg", ",", 
              "\[IndentingNewLine]", "\t", 
              RowBox[{"_", "?", "OperatorQ"}], ",", 
              RowBox[{"NDiagonalize", "[", 
               RowBox[{"backg", ",", "basis"}], "]"}], ",", 
              "\[IndentingNewLine]", "\t", 
              RowBox[{"_", "?", "SuperoperatorQ"}], ",", 
              RowBox[{"NDiagonalize", "[", 
               RowBox[{"backg", ",", "opbasis", ",", "basis"}], "]"}], ",", 
              "\[IndentingNewLine]", "\t", "_", ",", "backg"}], 
             "\[IndentingNewLine]", "\t", "]"}], ",", "\[IndentingNewLine]", 
            "backg"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", 
           "ensavst", ",", "normfacst", ",", "obsst", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "True", ",", "morelocst"}], 
            "}"}], ",", "morest"}], "}"}], ",", "more", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Switch", "[", 
              RowBox[{"evbackg", ",", "\[IndentingNewLine]", 
               RowBox[{"Except", "[", "_List", "]"}], ",", 
               RowBox[{"diagfunc", "[", "evbackg", "]"}], ",", 
               "\[IndentingNewLine]", "_List", ",", 
               RowBox[{"diagfunc", "/@", "evbackg"}], ",", 
               "\[IndentingNewLine]", "_", ",", "$Failed"}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            "opts"}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]",
         "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.700309626432626*^9, 3.700309825969651*^9}, {
   3.700310056716866*^9, 3.700310057347103*^9}, {3.7003109674381866`*^9, 
   3.700310970564481*^9}, {3.700311001837414*^9, 3.700311070112496*^9}, {
   3.7003111193491707`*^9, 3.700311121309247*^9}, {3.7003111654495497`*^9, 
   3.700311251899686*^9}, {3.70031131378601*^9, 3.700311332780781*^9}, 
   3.700311733832684*^9, 3.700311787146143*^9, 3.7003134105552397`*^9, {
   3.700313498353919*^9, 3.700313498815946*^9}, {3.700483219531069*^9, 
   3.7004832554188547`*^9}, {3.700483352277752*^9, 3.700483360462049*^9}, {
   3.7004833972605753`*^9, 3.700483520007393*^9}, 3.7010882228410883`*^9, {
   3.7027706435992904`*^9, 3.7027706466855135`*^9}, {3.702772068810874*^9, 
   3.7027720697845917`*^9}, {3.702772204178095*^9, 3.702772208683292*^9}, {
   3.702772241521645*^9, 3.7027722420099926`*^9}, {3.7027766718350515`*^9, 
   3.702776693683591*^9}, {3.703235265111353*^9, 3.703235275222041*^9}, {
   3.709375546895355*^9, 3.709375547515277*^9}, {3.7185318943490877`*^9, 
   3.718531918369113*^9}, {3.7185319612993393`*^9, 3.718531971387257*^9}, {
   3.7185320251046305`*^9, 3.718532082778624*^9}, {3.7185322118469276`*^9, 
   3.7185322154746275`*^9}, {3.719169611765709*^9, 3.719169644249029*^9}, {
   3.7191696752370825`*^9, 3.719169677826317*^9}, 3.722430578816113*^9, 
   3.722431254170321*^9, 3.722431462969501*^9, 3.726070360053104*^9},
 CellLabel->
  "In[2154]:=",ExpressionUUID->"be39bd53-a674-47c2-8782-0051c336dfd7"]
}, Open  ]],

Cell[CellGroupData[{

Cell["split BackgroundGenerator for preparation and detection", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.50283957862626*^9, 3.502839628378392*^9}, {3.505725476122719*^9, 
   3.5057255051693068`*^9}, {3.505725553158922*^9, 3.50572555691636*^9}, {
   3.700310591259241*^9, 3.7003105952248793`*^9}, 
   3.7093755481590157`*^9},ExpressionUUID->"d52b0459-2c0c-4dff-b28d-\
1bf11ed84014"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<BackgroundGenerator\>\""}], "]"}]}], 
        ",", 
        RowBox[{"evbackgst", ":", 
         RowBox[{"{", 
          RowBox[{
          "True", ",", "True", ",", "True", ",", "False", ",", 
           "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}]}], ",", 
     "timing_List", ",", 
     RowBox[{"events", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "evbackg", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
        "status", ",", "\[IndentingNewLine]", "timing", ",", "events", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Switch", "[", 
              RowBox[{"evbackg", ",", "\[IndentingNewLine]", 
               RowBox[{"Except", "[", "_List", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"evbackg", ",", "evbackg"}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"_", ",", "_"}], "}"}], ",", "evbackg", ",", 
               "\[IndentingNewLine]", "_", ",", "$Failed"}], "]"}]}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"evbackg", "=", 
         RowBox[{"StandardizeGenerator", "[", 
          RowBox[{"(", 
           RowBox[{"ReleaseHold", "[", 
            RowBox[{
             RowBox[{"BackgroundGenerator", "/.", 
              RowBox[{"{", "opts", "}"}]}], "/.", 
             RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], ")"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"evbackg", ",", 
          RowBox[{"Except", "[", "_List", "]"}]}], "]"}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5028402285941477`*^9, 3.5028402465022793`*^9}, {
   3.5057255127113657`*^9, 3.505725543257128*^9}, {3.533181376731399*^9, 
   3.533181387053466*^9}, {3.533182494516632*^9, 3.533182497405678*^9}, {
   3.533251929873798*^9, 3.5332519343337107`*^9}, {3.533252215945718*^9, 
   3.533252223141436*^9}, {3.566153502063692*^9, 3.566153507695636*^9}, {
   3.587552637566441*^9, 3.587552695032723*^9}, {3.587552725584037*^9, 
   3.587552901063295*^9}, {3.587553034150319*^9, 3.5875530361457148`*^9}, 
   3.587553330229055*^9, {3.587553714258482*^9, 3.587553721623069*^9}, {
   3.5876467982459173`*^9, 3.587646820394253*^9}, {3.587646860014176*^9, 
   3.587646876573028*^9}, {3.5929979713169117`*^9, 3.5929979762984343`*^9}, 
   3.593002963125325*^9, {3.618404288652458*^9, 3.61840429189876*^9}, 
   3.618485266130248*^9, 3.6184858995019608`*^9, {3.618487623636416*^9, 
   3.618487623912013*^9}, {3.633345239363801*^9, 3.633345256605791*^9}, {
   3.633345638205864*^9, 3.6333456412762337`*^9}, {3.6333456718199263`*^9, 
   3.6333457539404783`*^9}, {3.633345791335599*^9, 3.6333458012826433`*^9}, {
   3.633345862531114*^9, 3.63334602544032*^9}, {3.6333469001850967`*^9, 
   3.633346952625083*^9}, {3.633347020353992*^9, 3.63334704472264*^9}, {
   3.633347111269652*^9, 3.633347203447557*^9}, {3.633347382683057*^9, 
   3.633347387989971*^9}, {3.6333474504217587`*^9, 3.6333474626064177`*^9}, {
   3.6334360885864897`*^9, 3.633436099835129*^9}, {3.633436216236589*^9, 
   3.6334362195645638`*^9}, {3.633436317267034*^9, 3.6334363451237698`*^9}, 
   3.6334363939414988`*^9, {3.633436681990089*^9, 3.6334366858356953`*^9}, {
   3.6334397846317987`*^9, 3.633439791437908*^9}, {3.657219898076639*^9, 
   3.657219902316566*^9}, {3.6572199976104813`*^9, 3.6572200765985403`*^9}, {
   3.657220336368799*^9, 3.657220352367311*^9}, 3.657393319774577*^9, {
   3.657393462160089*^9, 3.657393476702121*^9}, {3.65739352912711*^9, 
   3.657393539571176*^9}, {3.65739390461771*^9, 3.657393909295542*^9}, {
   3.69995953769077*^9, 3.699959540188054*^9}, {3.700309934404004*^9, 
   3.70030993840024*^9}, {3.700310007288061*^9, 3.700310026813355*^9}, {
   3.700310071212886*^9, 3.700310228026745*^9}, {3.700310406031281*^9, 
   3.700310428122061*^9}, {3.700310569222739*^9, 3.7003105797424192`*^9}, {
   3.700310617090024*^9, 3.7003106770148*^9}, {3.700310711048622*^9, 
   3.7003107180985537`*^9}, {3.700310852518441*^9, 3.700310855160977*^9}, {
   3.700311422545804*^9, 3.7003114545029287`*^9}, {3.70031148492*^9, 
   3.700311631653571*^9}, {3.70031207723146*^9, 3.700312080677689*^9}, 
   3.7003122385256987`*^9, 3.7027720978945465`*^9, 3.702772180242075*^9, {
   3.7032353096492558`*^9, 3.703235318065052*^9}, {3.7093755498761187`*^9, 
   3.70937555119263*^9}, 3.7260703600711155`*^9},
 CellLabel->
  "In[2155]:=",ExpressionUUID->"287f8b1d-3962-4cab-8a3b-7551be075432"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"status", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"prefix", ":", 
          RowBox[{"StatusPatternPrefix", "[", 
           RowBox[{"Signal1D", ",", "\"\<BackgroundGenerator\>\""}], "]"}]}], 
         ",", 
         RowBox[{"evbackgst", ":", 
          RowBox[{"{", 
           RowBox[{
           "True", ",", "True", ",", "True", ",", "False", ",", 
            "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}]}], ",", 
      "timing_List", ",", 
      RowBox[{"events", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"ReleaseHold", "[", 
       RowBox[{
        RowBox[{"BackgroundGenerator", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_"}], "}"}]}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{
        "True", ",", "True", ",", "True", ",", "True", ",", "morelocst"}], 
        "}"}], ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", "timing", 
     ",", "events", ",", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7003121600948563`*^9, 3.700312211397312*^9}, {
   3.709375551844788*^9, 3.7093755525534563`*^9}, 3.713692922615169*^9},
 CellLabel->
  "In[2156]:=",ExpressionUUID->"c5a2bc4a-bef7-4299-8441-796deca0c583"]
}, Closed]],

Cell[CellGroupData[{

Cell["impose RtoL chronology", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.50283957862626*^9, 3.502839628378392*^9}, {3.505725476122719*^9, 
   3.5057255051693068`*^9}, {3.505725553158922*^9, 3.50572555691636*^9}, {
   3.700310591259241*^9, 3.7003105952248793`*^9}, {3.7010888071835938`*^9, 
   3.701088807767129*^9}, {3.713693446136705*^9, 3.713693488615252*^9}, 
   3.713693757310891*^9},ExpressionUUID->"61e0557d-4d3f-4b17-8c1f-\
0180890ec350"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"status", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"StatusPatternPrefix", "[", 
          RowBox[{"Signal1D", ",", "\"\<BackgroundGenerator\>\""}], "]"}]}], 
        ",", 
        RowBox[{"evbackgst", ":", 
         RowBox[{"{", 
          RowBox[{
          "True", ",", "True", ",", "True", ",", "True", ",", "False"}], 
          "}"}]}], ",", "morest___"}], "}"}]}], ",", "timing_List", ",", 
     RowBox[{"events", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"backg", ",", "chron"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"backg", "=", 
        RowBox[{"ReleaseHold", "[", 
         RowBox[{
          RowBox[{"BackgroundGenerator", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"chron", "=", 
        RowBox[{
         RowBox[{"Chronology", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{
            "True", ",", "True", ",", "True", ",", "True", ",", "True"}], 
            "}"}], ",", "morest"}], "}"}], ",", "\[IndentingNewLine]", 
         "timing", ",", "events", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Switch", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"backg", ",", "chron"}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Except", "[", "_List", "]"}], ",", "_"}], "}"}], 
               ",", "backg", ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"_", ",", "_"}], "}"}], ",", 
                 "\"\<LeftToRight\>\""}], "}"}], ",", 
               RowBox[{"Reverse", "@", "backg"}], ",", "\[IndentingNewLine]", 
               
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"_", ",", "_"}], "}"}], ",", 
                 "\"\<RightToLeft\>\""}], "}"}], ",", "backg", ",", 
               "\[IndentingNewLine]", "_", ",", "$Failed"}], "]"}]}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.7003121600948563`*^9, 3.700312211397312*^9}, {
   3.7010888216315107`*^9, 3.701088852861158*^9}, 3.7093755548348*^9, {
   3.713693515502684*^9, 3.7136935165167294`*^9}, {3.7136935758716393`*^9, 
   3.713693691864441*^9}, {3.7136938379815073`*^9, 3.713693844291169*^9}, {
   3.713693914051652*^9, 3.713693996554196*^9}},
 CellLabel->
  "In[2157]:=",ExpressionUUID->"862d660d-2358-402c-bbc6-d97d76c3d647"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["9. SignalCalculation", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469882637143063*^9, 
   3.469882639820516*^9}, 3.4698965783855743`*^9, {3.497350131321055*^9, 
   3.497350134039557*^9}, 3.497572555273549*^9, {3.49962571930704*^9, 
   3.499625720633676*^9}, 3.700309573483725*^9, {3.700323416023525*^9, 
   3.700323416886857*^9}, 3.700325339948*^9, 3.700481393433628*^9, 
   3.7005714895228167`*^9, {3.701097910405406*^9, 
   3.701097911172687*^9}},ExpressionUUID->"46272f31-6c16-466b-9bc1-\
9a0fd11c6360"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"02dc70ae-6360-4302-84ba-\
e7d4a849b20c"],

Cell["requires sampling, acqevents, ensav, evbackg to be ready", "Text",
 CellChangeTimes->{{3.700323497078107*^9, 3.7003235103773193`*^9}, {
  3.7005742386007233`*^9, 3.700574261649876*^9}, {3.700574350657331*^9, 
  3.700574365579748*^9}},ExpressionUUID->"6e1d62b4-3be3-433e-b7f4-\
72156e072a68"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", "True"}], ",", 
       RowBox[{"sampst", ":", 
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
       RowBox[{"acqevst", ":", "True"}], ",", "prepst_", ",", 
       RowBox[{"ensavst", ":", "True"}], ",", "normfacst_", ",", "obsst_", 
       ",", 
       RowBox[{"evbackgst", ":", "True"}], ",", "\[IndentingNewLine]", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "nextlocst_", ",", "morelocst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.7003234224719067`*^9, 3.700323423407679*^9}, 
   3.700323487606675*^9, {3.7003235334507027`*^9, 3.700323562646338*^9}, 
   3.700325340855411*^9, 3.700481393447546*^9, {3.700488780586094*^9, 
   3.7004887825675898`*^9}, 3.700571495162578*^9, {3.70057260555066*^9, 
   3.7005726078283253`*^9}, {3.700573315814458*^9, 3.700573316074943*^9}, {
   3.700574265444388*^9, 3.700574343231988*^9}, 3.701088256583205*^9, {
   3.7191694507426744`*^9, 3.7191694620697002`*^9}, {3.719169507762493*^9, 
   3.7191695102295837`*^9}},
 CellLabel->
  "In[2158]:=",ExpressionUUID->"d14ec1c6-fd12-451b-b2f5-2cebc5887cac"]
}, Open  ]],

Cell[CellGroupData[{

Cell["subcategory 1: SignalCalculationMethod", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700323603223743*^9, 3.700323619442904*^9}, {3.7003236919388866`*^9, 
   3.7003236933443213`*^9}, {3.700571517662788*^9, 3.7005715363528843`*^9}, {
   3.7005735219986467`*^9, 3.7005735223264513`*^9}, {3.700574036638969*^9, 
   3.7005740393925543`*^9}},ExpressionUUID->"2e163770-bbb1-4d7d-9328-\
6654816a20a8"],

Cell[CellGroupData[{

Cell["request set up", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812330624641*^9, 3.470812336603714*^9}, {3.499557113585561*^9, 
   3.499557172623969*^9}, {3.505725943541356*^9, 3.50572594617164*^9}, 
   3.7003253426838512`*^9, 3.700481393463455*^9, {3.7005715514318523`*^9, 
   3.700571555237199*^9}},ExpressionUUID->"4c344f21-c091-42e7-a2c1-\
deca21d3e90c"],

Cell["subcategories: {<request>,<resolve>,<check>,<report>}", "Text",
 CellChangeTimes->{{3.7010986136618633`*^9, 3.7010986589603453`*^9}, {
  3.701098800873864*^9, 
  3.701098806087248*^9}},ExpressionUUID->"5220afbe-0734-4e22-a3c7-\
137075e210fc"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", "True"}], ",", 
       RowBox[{"sampst", ":", 
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
       RowBox[{"acqevst", ":", "True"}], ",", 
       RowBox[{"prepst", ":", "True"}], ",", 
       RowBox[{"ensavst", ":", "True"}], ",", 
       RowBox[{"normfacst", ":", "True"}], ",", 
       RowBox[{"obsst", ":", "True"}], ",", 
       RowBox[{"evbackgst", ":", "True"}], ",", "\[IndentingNewLine]", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"False", ".."}], "}"}], ",", "moresubcatst__"}], "}"}], 
          ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"True", ",", "False", ",", "False", ",", "False"}], "}"}],
            ",", "moresubcatst"}], "}"}], ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.7003234224719067`*^9, 3.700323423407679*^9}, 
   3.700323487606675*^9, {3.7003235334507027`*^9, 3.700323562646338*^9}, 
   3.700325340855411*^9, 3.700481393447546*^9, {3.700488780586094*^9, 
   3.7004887825675898`*^9}, 3.700571495162578*^9, {3.7005715826727*^9, 
   3.700571630261539*^9}, {3.7005735309437723`*^9, 3.700573551160348*^9}, {
   3.7005740471334143`*^9, 3.700574064901948*^9}, {3.7005741788425426`*^9, 
   3.7005742040102663`*^9}, {3.7005761171730957`*^9, 3.700576121587064*^9}, {
   3.701088290267632*^9, 3.701088353735344*^9}, {3.701099122615576*^9, 
   3.701099126982423*^9}, {3.701099159238517*^9, 3.70109916032139*^9}, {
   3.701099642849152*^9, 3.701099643073596*^9}},
 CellLabel->
  "In[2159]:=",ExpressionUUID->"6be78b5e-b932-455b-ac97-6901a0797795"]
}, Closed]],

Cell[CellGroupData[{

Cell["resolve SignalCalculationMethod\[Rule]Automatic", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470137070872547*^9, 3.470137108041605*^9}, 
   3.470139104995274*^9, 3.499315841453224*^9, {3.7010989846812773`*^9, 
   3.701098985666548*^9}},ExpressionUUID->"69d8c413-178a-470c-9789-\
212fa761d2c8"],

Cell["\<\
require that SignalGeneratorPeriod subcategory has been defined\
\>", "Text",
 CellChangeTimes->{{3.700574983318068*^9, 3.700575006638151*^9}, {
  3.700575051470113*^9, 
  3.700575060906867*^9}},ExpressionUUID->"4c5a8acb-9c4e-4c4c-897b-\
766d2d49ae19"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"Repeated", "[", 
         RowBox[{"_", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"StatusPosition", "[", 
             RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}], 
            "-", "1"}], "}"}]}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"True", ",", "False", ",", "False", ",", "False"}], 
             "}"}], ",", 
            RowBox[{"sgenperst", ":", "True"}], ",", "moresubcatst__"}], 
           "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"timing", ":", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"HoldPattern", "@", 
      RowBox[{"EventSpecifications", "[", 
       RowBox[{"True", ",", "events_", ",", "evopts___Rule"}], "]"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "evbackg", ",", "detbackg", ",", "period", ",", "Nspace", ",", 
       "Nsubdiv", ",", "Nperiods", ",", "carav"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"detbackg", "=", 
         RowBox[{"First", "@", "evbackg"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"period", ",", "carav"}], "}"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"SignalGeneratorPeriod", ",", "CarouselAverage"}], "}"}], 
           "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Nspace", "=", 
         RowBox[{"BasisDimension", "[", 
          RowBox[{"Basis", "[", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"NumericQ", "[", "period", "]"}], ",", 
          RowBox[{"(", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Nsubdiv", "=", 
             RowBox[{"Max", "[", 
              RowBox[{
               RowBox[{"Round", "[", 
                RowBox[{"period", "/", "\[Delta]t"}], "]"}], ",", "1"}], 
              "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"Nperiods", "=", 
             RowBox[{"Max", "[", 
              RowBox[{
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{"Abs", "[", 
                  RowBox[{"tmax", "-", "tmin"}], "]"}], "/", "period"}], 
                "]"}], ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
           ")"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"prefix", ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"True", ",", "True", ",", "False", ",", "False"}], 
                 "}"}], ",", "sgenperst", ",", "moresubcatst"}], "}"}], ",", 
              "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
          "\[IndentingNewLine]", "timing", ",", "\[IndentingNewLine]", 
          RowBox[{"EventSpecifications", "[", 
           RowBox[{"events", ",", "evopts"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Evaluate", "@", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Sequence", "@@", "\[IndentingNewLine]", 
              RowBox[{"Which", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"MatchQ", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"detbackg", ",", "period", ",", "events"}], "}"}], 
                  ",", "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"None", "|", 
                    RowBox[{"_", "?", "OperatorQ"}], "|", 
                    RowBox[{"_", "?", "SuperoperatorQ"}], "|", 
                    RowBox[{"ShapeFunction", "[", 
                    RowBox[{"_", ",", "_", ",", "All", ",", "___"}], "]"}]}], 
                    ",", 
                    RowBox[{"Except", "[", 
                    RowBox[{"_", "?", "NumericQ"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    "SingleTimeIndependentEventPattern"}], 
                   "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
                 "]"}], ",", "\[IndentingNewLine]", "\t", 
                RowBox[{"{", 
                 RowBox[{
                 "SignalCalculationMethod", "\[Rule]", 
                  "\"\<Diagonalization\>\""}], "}"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"(", 
                 RowBox[{"MatchQ", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"detbackg", ",", "period", ",", "events"}], "}"}],
                    ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Except", "[", 
                    RowBox[{"_Function", "|", 
                    RowBox[{"ShapeFunction", "[", 
                    RowBox[{"_", ",", "_", ",", "None", ",", "___"}], "]"}]}],
                     "]"}], ",", "_", ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    "SingleTimeIndependentEventPattern", "|", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"_PeriodicFunction", ",", 
                    RowBox[{"_", "?", "NumericQ"}]}], "}"}], "|", 
                    RowBox[{"{", 
                    RowBox[{"{", "_Repeat", "}"}], "}"}]}], "}"}]}], 
                    "\[IndentingNewLine]", "}"}], "|", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Except", "[", 
                    RowBox[{"_Function", "|", 
                    RowBox[{"ShapeFunction", "[", 
                    RowBox[{"_", ",", "_", ",", "None", ",", "___"}], "]"}]}],
                     "]"}], ",", 
                    RowBox[{"_", "?", "NumericQ"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    "SingleTimeIndependentEventPattern", "|", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Except", "[", "_Function", "]"}], ",", 
                    RowBox[{"_", "?", "NumericQ"}]}], "}"}], "|", 
                    RowBox[{"{", "_Repeat", "}"}]}], "}"}]}], 
                    "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
                  "]"}], "\[IndentingNewLine]", ")"}], ",", 
                "\[IndentingNewLine]", "\t", 
                RowBox[{"{", "\[IndentingNewLine]", "\t", 
                 RowBox[{
                  RowBox[{
                  "SignalCalculationMethod", "\[Rule]", "\"\<COMPUTE\>\""}], 
                  ",", "\[IndentingNewLine]", "\t", 
                  RowBox[{"MatchSamplingToPeriod", "\[Rule]", "True"}]}], 
                 "\[IndentingNewLine]", "\t", "}"}], ",", 
                "\[IndentingNewLine]", "True", ",", "\[IndentingNewLine]", 
                "\t", 
                RowBox[{"{", 
                 RowBox[{
                 "SignalCalculationMethod", "\[Rule]", "\"\<Direct\>\""}], 
                 "}"}]}], "\[IndentingNewLine]", "]"}]}], ",", 
             "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
            "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"SignalCalculationMethod", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", "Automatic"}], 
         "]"}], "&&", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"evbackg", "=", 
           RowBox[{"ReleaseHold", "[", 
            RowBox[{
             RowBox[{"BackgroundGenerator", "/.", 
              RowBox[{"{", "opts", "}"}]}], "/.", 
             RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"evbackg", ",", 
            RowBox[{"{", 
             RowBox[{"_", ",", "_"}], "}"}]}], "]"}]}], "\[IndentingNewLine]",
          ")"}]}], "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700326749441185*^9, 3.700326955462449*^9}, {
   3.700326988664522*^9, 3.700326992566722*^9}, 3.7004813936165867`*^9, {
   3.700574107755525*^9, 3.700574134729697*^9}, {3.700574381074074*^9, 
   3.700574408255446*^9}, {3.700574801557692*^9, 3.7005748159737463`*^9}, {
   3.700575011451049*^9, 3.700575037553998*^9}, {3.700575536441061*^9, 
   3.700575538088134*^9}, {3.70057572330427*^9, 3.700575725070202*^9}, {
   3.700576135676961*^9, 3.7005761449968987`*^9}, {3.70109917272434*^9, 
   3.701099178442254*^9}, 3.7093755548446198`*^9},
 CellLabel->
  "In[2160]:=",ExpressionUUID->"bf6742a5-c2b9-4aae-9590-bd15c5cc2bde"]
}, Open  ]],

Cell[CellGroupData[{

Cell["implement explicit SignalCalculationMethod", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470137070872547*^9, 3.470137108041605*^9}, 
   3.470139104995274*^9, 3.499315841453224*^9, {3.701098925556041*^9, 
   3.701098930580357*^9}},ExpressionUUID->"35462ea8-f0ae-41aa-9d85-\
01aff97cc81b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"prefix", ":", 
         RowBox[{"Repeated", "[", 
          RowBox[{"_", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StatusPosition", "[", 
              RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}], 
             "-", "1"}], "}"}]}], "]"}]}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"True", ",", "False", ",", "False", ",", "False"}], 
              "}"}], ",", "moresubcatst__"}], "}"}], ",", "morelocst___"}], 
          "}"}]}], ",", "morest___"}], "}"}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SignalCalculationMethod", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", "Automatic"}], 
      "]"}]}]}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "False", ",", "False"}], "}"}], 
           ",", "moresubcatst"}], "}"}], ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.70109894476499*^9, 3.70109896601365*^9}, {
  3.7010990087983627`*^9, 3.701099045160355*^9}, {3.70109918320151*^9, 
  3.701099187527697*^9}},
 CellLabel->
  "In[2161]:=",ExpressionUUID->"b09c7d5c-349a-4a8b-9778-ec9db60f3bf9"]
}, Closed]],

Cell[CellGroupData[{

Cell["check", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470137070872547*^9, 3.470137076535653*^9}, 
   3.4701390970280933`*^9, {3.701098001665907*^9, 3.7010980046136513`*^9}, {
   3.7010988402760563`*^9, 
   3.701098840827217*^9}},ExpressionUUID->"358b8cbe-366f-45d2-9c1e-\
29ae4a381872"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImplementedSignalCalculationSignalCalculationMethods", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Direct\>\"", ",", "\"\<Diagonalization\>\"", ",", 
     "\"\<COMPUTE\>\""}], "}"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469878320659041*^9, 3.469878339682229*^9}, {
   3.4701370284799643`*^9, 3.470137056887949*^9}, 3.470139097954458*^9, {
   3.470824844379533*^9, 3.47082484887362*^9}, 3.701098815872774*^9},
 CellLabel->
  "In[2162]:=",ExpressionUUID->"5d5701b0-5aca-43bd-8728-c0676def1eb8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"Repeated", "[", 
         RowBox[{"_", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"StatusPosition", "[", 
             RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}], 
            "-", "1"}], "}"}]}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"True", ",", "True", ",", "False", ",", "False"}], "}"}],
             ",", "moresubcatst__"}], "}"}], ",", "morelocst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"MemberQ", "[", 
      RowBox[{"ImplementedSignalCalculationSignalCalculationMethods", ",", 
       RowBox[{
        RowBox[{"SignalCalculationMethod", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Signal1D", "]"}]}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Signal1D", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"prefix", ",", 
         RowBox[{"{", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"True", ",", "True", ",", "True", ",", "False"}], "}"}],
              ",", "moresubcatst"}], "}"}], ",", "morelocst"}], "}"}], ",", 
         "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Message", "[", 
        RowBox[{"Signal1D", "::", "unrecogmethod"}], "]"}], ";", "$Failed"}], 
      ")"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.4698783534473543`*^9, 3.469878391959339*^9}, 
   3.470137034129311*^9, {3.4701391000108223`*^9, 3.470139101602394*^9}, 
   3.499326545108363*^9, {3.51435248519176*^9, 3.514352485965055*^9}, 
   3.514352627918438*^9, 3.683957723872407*^9, {3.699959566254277*^9, 
   3.699959567221973*^9}, {3.700326647174519*^9, 3.7003266848039417`*^9}, {
   3.700574092813087*^9, 3.700574096195272*^9}, {3.7005747954442797`*^9, 
   3.7005748129805717`*^9}, {3.70057612828424*^9, 3.700576129339366*^9}, {
   3.701098009801235*^9, 3.701098135747582*^9}, {3.701099067414452*^9, 
   3.701099075174713*^9}, {3.7010991920281677`*^9, 3.70109919960215*^9}},
 CellLabel->
  "In[2163]:=",ExpressionUUID->"14bac3b6-ddd6-4878-8669-cfcdbed68fc4"]
}, Closed]],

Cell[CellGroupData[{

Cell["ReportSignalCalculationMethod", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{
  3.499658845992846*^9},ExpressionUUID->"c18557a4-dc03-40c6-ae0f-\
89d3484b825a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"Repeated", "[", 
         RowBox[{"_", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"StatusPosition", "[", 
             RowBox[{"Signal1D", ",", "\"\<SignalCalculation\>\""}], "]"}], 
            "-", "1"}], "}"}]}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"True", ",", "True", ",", "True", ",", "False"}], "}"}], 
            ",", "moresubcatst__"}], "}"}], ",", "morelocst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", "timing_List", ",", 
     RowBox[{"evs", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "repscm", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"repscm", "=", 
        RowBox[{
         RowBox[{"ReportSignalCalculationMethod", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"repscm", ",", "\[IndentingNewLine]", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"Signal1D", "::", "reportscm"}], ",", 
           RowBox[{
            RowBox[{"SignalCalculationMethod", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Signal1D", "]"}]}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"True", ",", "True", ",", "True", ",", "True"}], 
                "}"}], ",", "moresubcatst"}], "}"}], ",", "morelocst"}], 
            "}"}], ",", "morest"}], "}"}], ",", "timing", ",", "evs", ",", 
         "opts"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.499658639363443*^9, 3.4996587549638243`*^9}, {
   3.51435281041085*^9, 3.514352816054686*^9}, 3.5150665733511457`*^9, 
   3.515066677710226*^9, {3.5930027244808826`*^9, 3.5930027275275173`*^9}, 
   3.593002943001554*^9, {3.6839577239638863`*^9, 3.6839577239661007`*^9}, {
   3.699959585728663*^9, 3.69995958757365*^9}, {3.700576219142378*^9, 
   3.7005764048015738`*^9}, {3.7010990820662327`*^9, 3.701099101222742*^9}},
 CellLabel->
  "In[2164]:=",ExpressionUUID->"f2a77a59-051d-45e1-966f-28ad8fbd112d"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["subcategory 2: SignalGeneratorPeriod", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700323603223743*^9, 3.700323619442904*^9}, {3.7003236919388866`*^9, 
   3.7003236933443213`*^9}, {3.700571517662788*^9, 3.7005715363528843`*^9}, {
   3.7005735219986467`*^9, 
   3.7005735223264513`*^9}},ExpressionUUID->"af45229d-cacf-42e9-ac1a-\
d323e7dcd1c5"],

Cell[CellGroupData[{

Cell["request set up", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812330624641*^9, 3.470812336603714*^9}, {3.499557113585561*^9, 
   3.499557172623969*^9}, {3.505725943541356*^9, 3.50572594617164*^9}, 
   3.7003253426838512`*^9, 3.700481393463455*^9, {3.7005715514318523`*^9, 
   3.700571555237199*^9}},ExpressionUUID->"ea452b47-90eb-4a3b-9b14-\
9cab4ea6f66e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", "True"}], ",", 
       RowBox[{"sampst", ":", 
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
       RowBox[{"acqevst", ":", "True"}], ",", 
       RowBox[{"prepst", ":", "True"}], ",", 
       RowBox[{"ensavst", ":", "True"}], ",", 
       RowBox[{"normfacst", ":", "True"}], ",", 
       RowBox[{"obsst", ":", "True"}], ",", 
       RowBox[{"evbackgst", ":", "True"}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{"subcat1st_", ",", 
            RowBox[{"{", 
             RowBox[{"False", ",", "False"}], "}"}], ",", "moresubcatst___"}],
            "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}], 
     ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{"subcat1st", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "False"}], "}"}], ",", "moresubcatst"}], 
          "}"}], ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
     "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.7003234224719067`*^9, 3.700323423407679*^9}, 
   3.700323487606675*^9, {3.7003235334507027`*^9, 3.700323562646338*^9}, 
   3.700325340855411*^9, 3.700481393447546*^9, {3.700488780586094*^9, 
   3.7004887825675898`*^9}, 3.700571495162578*^9, {3.7005715826727*^9, 
   3.700571630261539*^9}, {3.7005735309437723`*^9, 3.700573551160348*^9}, {
   3.701088386889241*^9, 3.7010883998695908`*^9}, {3.7030884593524923`*^9, 
   3.703088483603899*^9}},
 CellLabel->
  "In[2165]:=",ExpressionUUID->"be663e90-764d-4dba-b7f6-718417aa2eb3"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
if a Repeat is specified, and the BackgroundGenerator during detection is \
time-independent, set SignalGeneratorPeriod to the repeat duration of the \
event\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812330624641*^9, 3.470812336603714*^9}, {3.499557113585561*^9, 
   3.499557172623969*^9}, {3.505725943541356*^9, 3.50572594617164*^9}, 
   3.7003253426838512`*^9, 3.700481393463455*^9, 3.700573826506358*^9, 
   3.709375554863351*^9},ExpressionUUID->"2e9efe26-ab36-4b3d-a228-\
8ee14faa42be"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"chronst", ":", "True"}], ",", 
        RowBox[{"sampst", ":", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
        RowBox[{"acqevst", ":", "True"}], ",", 
        RowBox[{"prepst", ":", "True"}], ",", 
        RowBox[{"ensavst", ":", "True"}], ",", 
        RowBox[{"normfacst", ":", "True"}], ",", 
        RowBox[{"obsst", ":", "True"}], ",", 
        RowBox[{"evbackgst", ":", "True"}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{"subcat1st_", ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "False"}], "}"}], ",", "moresubcatst___"}],
             "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}],
       ",", "\[IndentingNewLine]", 
      RowBox[{"timing", ":", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "_"}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"evspecs", ":", 
       RowBox[{"HoldPattern", "@", 
        RowBox[{"EventSpecifications", "[", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Repeat", "[", 
               RowBox[{"repev_", ",", "nrep_", ",", "___Rule"}], "]"}], ",", 
              "___Rule"}], "}"}], ",", "___Rule"}], "}"}], ",", "___Rule"}], 
         "]"}]}]}], ",", "\[IndentingNewLine]", "opts___Rule"}], 
     "\[IndentingNewLine]", "]"}], "/;", "\[IndentingNewLine]", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"First", "[", 
       RowBox[{"ReleaseHold", "[", 
        RowBox[{
         RowBox[{"BackgroundGenerator", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], "]"}], ",", 
      RowBox[{"(", 
       RowBox[{"None", "|", 
        RowBox[{"_", "?", "OperatorQ"}], "|", 
        RowBox[{"_", "?", "SuperoperatorQ"}]}], ")"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{"subcat1st", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}], ",", "moresubcatst"}], 
          "}"}], ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
     "timing", ",", "evspecs", ",", "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SignalGeneratorPeriod", "\[Rule]", 
         RowBox[{"EventDuration", "[", 
          RowBox[{"Evaluate", "@", "repev"}], "]"}]}], ",", 
        "\[IndentingNewLine]", "opts"}], "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700324264390958*^9, 3.700324384181057*^9}, {
   3.70032534373773*^9, 3.700325345184697*^9}, {3.7003259456277933`*^9, 
   3.700325954494207*^9}, {3.700326256841934*^9, 3.700326305165822*^9}, {
   3.7004813934846687`*^9, 3.700481393488036*^9}, {3.700571641384111*^9, 
   3.700571669668004*^9}, 3.700571871963758*^9, {3.700573563823166*^9, 
   3.700573580903213*^9}, {3.701088418312374*^9, 3.701088458012884*^9}, {
   3.7030884891522083`*^9, 3.703088493994485*^9}, 3.709375554874733*^9},
 CellLabel->
  "In[2166]:=",ExpressionUUID->"faa4c451-247f-4de1-924d-7ae6d882dc5d"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
if the events are time-independent, and the BackgroundGenerator during \
detection is a PeriodicFunction, set the SignalGeneratorPeriod to its period\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812330624641*^9, 3.470812336603714*^9}, {3.499557113585561*^9, 
   3.499557172623969*^9}, {3.504271807825529*^9, 3.5042718512157393`*^9}, {
   3.5043631553563957`*^9, 3.504363160369092*^9}, {3.504363363175894*^9, 
   3.5043633882222013`*^9}, 3.505725952207465*^9, 3.700325345952129*^9, 
   3.7004813935092487`*^9, 
   3.709375554893167*^9},ExpressionUUID->"ae7bd755-d0e6-49d2-901c-\
85e78b33b663"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", "True"}], ",", 
       RowBox[{"sampst", ":", 
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
       RowBox[{"acqevst", ":", "True"}], ",", 
       RowBox[{"prepst", ":", "True"}], ",", 
       RowBox[{"ensavst", ":", "True"}], ",", 
       RowBox[{"normfacst", ":", "True"}], ",", 
       RowBox[{"obsst", ":", "True"}], ",", 
       RowBox[{"evbackgst", ":", "True"}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{"subcat1st_", ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", "False"}], "}"}], ",", "moresubcatst___"}], 
           "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"timing", ":", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", "_"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"evspecs", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "detbackg", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", 
           "ensavst", ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", 
             RowBox[{"{", 
              RowBox[{"subcat1st", ",", 
               RowBox[{"{", 
                RowBox[{"True", ",", "True"}], "}"}], ",", "moresubcatst"}], 
              "}"}], ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
         "timing", ",", "evspecs", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"SignalGeneratorPeriod", "\[Rule]", 
             RowBox[{
             "detbackg", "\[LeftDoubleBracket]", "2", 
              "\[RightDoubleBracket]"}]}], ",", "opts"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"detbackg", "=", 
         RowBox[{"First", "[", 
          RowBox[{"ReleaseHold", "[", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"detbackg", ",", 
           RowBox[{"PeriodicFunction", "[", 
            RowBox[{"_", ",", 
             RowBox[{"_", "?", "NumericQ"}], ",", "___"}], "]"}]}], "]"}], "&&",
          "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"evspecs", ",", 
           RowBox[{"EventSpecifications", "[", 
            RowBox[{
            "True", ",", "SingleTimeIndependentEventPattern", ",", 
             "___Rule"}], "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700324665257514*^9, 3.700324753839406*^9}, {
   3.700325346662778*^9, 3.700325347328794*^9}, {3.700325933798705*^9, 
   3.700325939830002*^9}, {3.700326320030384*^9, 3.7003263299726667`*^9}, {
   3.700327273949061*^9, 3.700327275050378*^9}, 3.7003283707470083`*^9, {
   3.7003285411730347`*^9, 3.700328566211557*^9}, {3.7004813935231113`*^9, 
   3.700481393526552*^9}, {3.7005716872397537`*^9, 3.700571695340687*^9}, 
   3.700571875146553*^9, 3.700573593096418*^9, 3.700573633830998*^9, {
   3.701088470909809*^9, 3.701088479358362*^9}, {3.70308850377742*^9, 
   3.703088508385306*^9}, 3.70937555490602*^9},
 CellLabel->
  "In[2167]:=",ExpressionUUID->"0f7120f1-7963-4b92-a777-70d028dcac47"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", "True"}], ",", 
       RowBox[{"sampst", ":", 
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
       RowBox[{"acqevst", ":", "True"}], ",", 
       RowBox[{"prepst", ":", "True"}], ",", 
       RowBox[{"ensavst", ":", "True"}], ",", 
       RowBox[{"normfacst", ":", "True"}], ",", 
       RowBox[{"obsst", ":", "True"}], ",", 
       RowBox[{"evbackgst", ":", "True"}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{"subcat1st_", ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", "False"}], "}"}], ",", "moresubcatst___"}], 
           "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"timing", ":", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", "_"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"evspecs", ":", 
      RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "\[IndentingNewLine]", 
     "opts___Rule"}], "\[IndentingNewLine]", "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "detbackg", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", 
           "ensavst", ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", 
             RowBox[{"{", 
              RowBox[{"subcat1st", ",", 
               RowBox[{"{", 
                RowBox[{"True", ",", "True"}], "}"}], ",", "moresubcatst"}], 
              "}"}], ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
         "timing", ",", "evspecs", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"SignalGeneratorPeriod", "\[Rule]", 
             RowBox[{
             "detbackg", "\[LeftDoubleBracket]", "3", 
              "\[RightDoubleBracket]"}]}], ",", "opts"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"detbackg", "=", 
         RowBox[{"First", "[", 
          RowBox[{"ReleaseHold", "[", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"detbackg", ",", 
           RowBox[{"ShapeFunction", "[", 
            RowBox[{"_", ",", "_", ",", 
             RowBox[{"_", "?", "NumericQ"}], ",", "___"}], "]"}]}], "]"}], "&&",
          "\[IndentingNewLine]", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"evspecs", ",", 
           RowBox[{"EventSpecifications", "[", 
            RowBox[{
            "True", ",", "SingleTimeIndependentEventPattern", ",", 
             "___Rule"}], "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700324665257514*^9, 3.700324753839406*^9}, {
   3.700324818791588*^9, 3.700324825548211*^9}, {3.700325348214953*^9, 
   3.700325348840213*^9}, {3.700325917667912*^9, 3.700325926251625*^9}, {
   3.7003263365495863`*^9, 3.7003263392268353`*^9}, {3.7003272810910378`*^9, 
   3.700327281922243*^9}, {3.700327429917809*^9, 3.700327472113057*^9}, {
   3.7003284148235683`*^9, 3.700328421069187*^9}, {3.700328572429936*^9, 
   3.700328583376583*^9}, {3.7003286635846033`*^9, 3.7003286638779697`*^9}, {
   3.700481393536673*^9, 3.700481393540491*^9}, {3.700571702702807*^9, 
   3.700571711000016*^9}, 3.70057187809196*^9, 3.7005735972305403`*^9, 
   3.700573642036908*^9, {3.701088486461375*^9, 3.701088494174636*^9}, {
   3.7030885196312437`*^9, 3.7030885243551893`*^9}, 3.709375554915433*^9},
 CellLabel->
  "In[2168]:=",ExpressionUUID->"de2467ea-0f8c-47c4-9a5d-ee27a3165f98"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
if a Repeat is specified, and the BackgroundGenerator during detection is a \
PeriodicFunction, combine the two periods\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812330624641*^9, 3.470812336603714*^9}, {3.499557113585561*^9, 
   3.499557172623969*^9}, {3.5042720085229683`*^9, 3.504272015592711*^9}, 
   3.5057259558305473`*^9, 3.700573821220106*^9, 
   3.7093755549321632`*^9},ExpressionUUID->"3444f258-1418-4793-8463-\
6eb3ee5ad359"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", "True"}], ",", 
       RowBox[{"sampst", ":", 
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
       RowBox[{"acqevst", ":", "True"}], ",", 
       RowBox[{"prepst", ":", "True"}], ",", 
       RowBox[{"ensavst", ":", "True"}], ",", 
       RowBox[{"normfacst", ":", "True"}], ",", 
       RowBox[{"obsst", ":", "True"}], ",", 
       RowBox[{"evbackgst", ":", "True"}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{"subcat1st_", ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", "False"}], "}"}], ",", "moresubcatst___"}], 
           "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"timing", ":", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", "_"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"evspecs", ":", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"EventSpecifications", "[", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Repeat", "[", 
              RowBox[{"repev_", ",", "nrep_", ",", "___Rule"}], "]"}], ",", 
             "___Rule"}], "}"}], ",", "___Rule"}], "}"}], ",", "___Rule"}], 
        "]"}]}]}], ",", "\[IndentingNewLine]", "opts___Rule"}], 
    "\[IndentingNewLine]", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "detbackg", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", 
           "ensavst", ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", 
             RowBox[{"{", 
              RowBox[{"subcat1st", ",", 
               RowBox[{"{", 
                RowBox[{"True", ",", "True"}], "}"}], ",", "moresubcatst"}], 
              "}"}], ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
         "timing", ",", "evspecs", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"SignalGeneratorPeriod", "\[Rule]", 
             RowBox[{"CommonPeriod", "[", 
              RowBox[{
               RowBox[{"EventDuration", "[", 
                RowBox[{"Evaluate", "@", "repev"}], "]"}], ",", 
               RowBox[{
               "detbackg", "\[LeftDoubleBracket]", "2", 
                "\[RightDoubleBracket]"}]}], "]"}]}], ",", "opts"}], 
           "]"}]}]}], "\[IndentingNewLine]", "]"}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"detbackg", "=", 
         RowBox[{"First", "[", 
          RowBox[{"ReleaseHold", "[", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"detbackg", ",", 
          RowBox[{"PeriodicFunction", "[", 
           RowBox[{"_", ",", 
            RowBox[{"_", "?", "NumericQ"}], ",", "___"}], "]"}]}], "]"}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700324665257514*^9, 3.700324753839406*^9}, {
   3.700324891666608*^9, 3.700324909306254*^9}, {3.700325349747031*^9, 
   3.7003253503325644`*^9}, {3.700325980082103*^9, 3.700325987880232*^9}, {
   3.70032634592418*^9, 3.700326350019375*^9}, {3.7003287105088453`*^9, 
   3.700328738344062*^9}, {3.7004813935506887`*^9, 3.7004813935541363`*^9}, {
   3.700571723558832*^9, 3.700571730861034*^9}, 3.70057188089242*^9, 
   3.700573603110304*^9, 3.700573645740779*^9, 3.700573924857492*^9, {
   3.7010885061086073`*^9, 3.701088514508712*^9}, {3.703088533239998*^9, 
   3.703088537294585*^9}, 3.709375554942335*^9},
 CellLabel->
  "In[2169]:=",ExpressionUUID->"f8ab0981-7878-45b7-9042-44d279afec5a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", "True"}], ",", 
       RowBox[{"sampst", ":", 
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
       RowBox[{"acqevst", ":", "True"}], ",", 
       RowBox[{"prepst", ":", "True"}], ",", 
       RowBox[{"ensavst", ":", "True"}], ",", 
       RowBox[{"normfacst", ":", "True"}], ",", 
       RowBox[{"obsst", ":", "True"}], ",", 
       RowBox[{"evbackgst", ":", "True"}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{"subcat1st_", ",", 
            RowBox[{"{", 
             RowBox[{"True", ",", "False"}], "}"}], ",", "moresubcatst___"}], 
           "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"timing", ":", 
      RowBox[{"{", 
       RowBox[{"_", ",", "_", ",", "_"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"evspecs", ":", 
      RowBox[{"HoldPattern", "@", 
       RowBox[{"EventSpecifications", "[", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Repeat", "[", 
              RowBox[{"repev_", ",", "nrep_", ",", "___Rule"}], "]"}], ",", 
             "___Rule"}], "}"}], ",", "___Rule"}], "}"}], ",", "___Rule"}], 
        "]"}]}]}], ",", "\[IndentingNewLine]", "opts___Rule"}], 
    "\[IndentingNewLine]", "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "detbackg", "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", 
           "ensavst", ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", 
             RowBox[{"{", 
              RowBox[{"subcat1st", ",", 
               RowBox[{"{", 
                RowBox[{"True", ",", "True"}], "}"}], ",", "moresubcatst"}], 
              "}"}], ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
         "timing", ",", "evspecs", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"SignalGeneratorPeriod", "\[Rule]", 
             RowBox[{"CommonPeriod", "[", 
              RowBox[{
               RowBox[{"EventDuration", "[", 
                RowBox[{"Evaluate", "@", "repev"}], "]"}], ",", 
               RowBox[{
               "detbackg", "\[LeftDoubleBracket]", "3", 
                "\[RightDoubleBracket]"}]}], "]"}]}], ",", "opts"}], 
           "]"}]}]}], "\[IndentingNewLine]", "]"}], ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"detbackg", "=", 
         RowBox[{"First", "[", 
          RowBox[{"ReleaseHold", "[", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"detbackg", ",", 
          RowBox[{"ShapeFunction", "[", 
           RowBox[{"_", ",", "_", ",", 
            RowBox[{"_", "?", "NumericQ"}], ",", "___"}], "]"}]}], "]"}]}], 
       "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700324665257514*^9, 3.700324753839406*^9}, {
   3.700324891666608*^9, 3.700324909306254*^9}, {3.700324964142363*^9, 
   3.700324968684554*^9}, {3.700325351672752*^9, 3.700325352281323*^9}, {
   3.700325990802813*^9, 3.700325999698202*^9}, {3.700326352841305*^9, 
   3.700326356290661*^9}, {3.700481393564398*^9, 3.700481393567769*^9}, {
   3.7005717413252077`*^9, 3.7005717487709827`*^9}, 3.7005718836122713`*^9, 
   3.700573605997939*^9, 3.7005736505420113`*^9, 3.700573930241921*^9, {
   3.701088522283204*^9, 3.701088529492776*^9}, {3.7030885467674217`*^9, 
   3.703088551005035*^9}, 3.709375554951004*^9},
 CellLabel->
  "In[2170]:=",ExpressionUUID->"98f8d6f3-ef26-4a07-8192-cf1926186f3b"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
set complete flag if there is no RepeatEvent and the BackgroundGenerator \
during detection is not periodic\
\>", "Subsubsection",
 CellChangeTimes->{{3.700323497078107*^9, 3.7003235103773193`*^9}, {
   3.7003236246260653`*^9, 3.700323688916321*^9}, {3.700325622525321*^9, 
   3.7003256278509073`*^9}, {3.700328226828381*^9, 3.700328227289135*^9}, 
   3.709375554965008*^9},ExpressionUUID->"2afecd70-9702-4791-900f-\
35de5532f183"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"chronst", ":", "True"}], ",", 
        RowBox[{"sampst", ":", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
        RowBox[{"acqevst", ":", "True"}], ",", 
        RowBox[{"prepst", ":", "True"}], ",", 
        RowBox[{"ensavst", ":", "True"}], ",", 
        RowBox[{"normfacst", ":", "True"}], ",", 
        RowBox[{"obsst", ":", "True"}], ",", 
        RowBox[{"evbackgst", ":", "True"}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{"subcat1st_", ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "False"}], "}"}], ",", "moresubcatst___"}],
             "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}],
       ",", "\[IndentingNewLine]", 
      RowBox[{"timing", ":", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "_"}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"evspecs", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "\[IndentingNewLine]", 
      "opts___Rule"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"First", "[", 
         RowBox[{"ReleaseHold", "[", 
          RowBox[{
           RowBox[{"BackgroundGenerator", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{"PeriodicFunction", "[", 
          RowBox[{"_", ",", 
           RowBox[{"_", "?", "NumericQ"}], ",", "___"}], "]"}], "|", 
         RowBox[{"ShapeFunction", "[", 
          RowBox[{"_", ",", "_", ",", 
           RowBox[{"_", "?", "NumericQ"}], ",", "___"}], "]"}]}]}], "]"}]}], "&&", 
     RowBox[{"!", 
      RowBox[{"MatchQ", "[", 
       RowBox[{"evspecs", ",", 
        RowBox[{"HoldPattern", "@", 
         RowBox[{"EventSpecifications", "[", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Repeat", "[", 
                RowBox[{"repev_", ",", "nrep_", ",", "___Rule"}], "]"}], ",", 
               "___Rule"}], "}"}], ",", "___Rule"}], "}"}], ",", "___Rule"}], 
          "]"}]}]}], "]"}]}]}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{"subcat1st", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}], ",", "moresubcatst"}], 
          "}"}], ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
     "timing", ",", "evspecs", ",", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.7003234224719067`*^9, 3.700323423407679*^9}, 
   3.700323487606675*^9, {3.7003235334507027`*^9, 3.700323562646338*^9}, {
   3.700323708138833*^9, 3.700323934589793*^9}, {3.700324029791738*^9, 
   3.700324052676941*^9}, {3.700324148836472*^9, 3.700324149627701*^9}, 
   3.700325341585267*^9, {3.7003256555399103`*^9, 3.7003257233261747`*^9}, {
   3.70032603056733*^9, 3.700326078748678*^9}, {3.700326403265223*^9, 
   3.700326415129526*^9}, {3.700328237008072*^9, 3.700328239684762*^9}, 
   3.700481393574594*^9, {3.700571763804696*^9, 3.700571771308169*^9}, 
   3.700571834646338*^9, 3.700571886530919*^9, 3.700573611469884*^9, 
   3.7005736552767143`*^9, {3.701088539491206*^9, 3.70108854765042*^9}, {
   3.703088563676498*^9, 3.7030885671245813`*^9}, 3.709375554974578*^9},
 CellLabel->
  "In[2171]:=",ExpressionUUID->"c617c572-5ede-4456-8834-cd3bf67abb7b"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
otherwise, set complete flag if the SignalGeneratorPeriod option has been set\
\
\>", "Subsubsection",
 CellChangeTimes->{{3.700323497078107*^9, 3.7003235103773193`*^9}, {
   3.7003236246260653`*^9, 3.700323688916321*^9}, {3.700325622525321*^9, 
   3.7003256278509073`*^9}, {3.7003258244812813`*^9, 
   3.7003258459103127`*^9}, {3.7003282532183228`*^9, 3.700328255003819*^9}, 
   3.700481393592998*^9},ExpressionUUID->"b44588d9-1e56-4f4f-89b2-\
43f1efebbe14"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"chronst", ":", "True"}], ",", 
        RowBox[{"sampst", ":", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
        RowBox[{"acqevst", ":", "True"}], ",", 
        RowBox[{"prepst", ":", "True"}], ",", 
        RowBox[{"ensavst", ":", "True"}], ",", 
        RowBox[{"normfacst", ":", "True"}], ",", 
        RowBox[{"obsst", ":", "True"}], ",", 
        RowBox[{"evbackgst", ":", "True"}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{"subcat1st_", ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "False"}], "}"}], ",", "moresubcatst___"}],
             "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}],
       ",", "\[IndentingNewLine]", 
      RowBox[{"timing", ":", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", "_"}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"evspecs", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "\[IndentingNewLine]", 
      "opts___Rule"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SignalGeneratorPeriod", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
       RowBox[{"None", "|", "False"}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{"subcat1st", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}], ",", "moresubcatst"}], 
          "}"}], ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
     "timing", ",", "evspecs", ",", "opts"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.7003234224719067`*^9, 3.700323423407679*^9}, 
   3.700323487606675*^9, {3.7003235334507027`*^9, 3.700323562646338*^9}, {
   3.700323708138833*^9, 3.700323934589793*^9}, {3.700324029791738*^9, 
   3.700324052676941*^9}, {3.700324148836472*^9, 3.700324149627701*^9}, 
   3.700325341585267*^9, {3.7003256555399103`*^9, 3.7003257233261747`*^9}, {
   3.700325860754139*^9, 3.700325908650865*^9}, {3.700326369923193*^9, 
   3.7003263845840893`*^9}, {3.700481393606162*^9, 3.700481393609928*^9}, 
   3.70057180097985*^9, 3.700571838156835*^9, 3.7005718891065607`*^9, 
   3.700573618709593*^9, 3.700573659250839*^9, {3.701088562099402*^9, 
   3.7010885719619513`*^9}, {3.7030885764774942`*^9, 3.7030885799403963`*^9}},
 
 CellLabel->
  "In[2172]:=",ExpressionUUID->"ae1bc811-58fb-4755-a8c4-d8835b9f89c8"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["subcategory 3: PeriodicDetectionEvents", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700323603223743*^9, 3.700323619442904*^9}, {3.7003236919388866`*^9, 
   3.7003236933443213`*^9}, {3.700571517662788*^9, 3.7005715363528843`*^9}, {
   3.7005735219986467`*^9, 3.7005735223264513`*^9}, {3.7005764893130713`*^9, 
   3.700576494920969*^9}, {3.700577046650675*^9, 
   3.7005770537513027`*^9}},ExpressionUUID->"ea46e5b3-8d34-44e3-b1ad-\
549ecfac03ae"],

Cell["\<\
this is needed for implementation of periodic algorithms such as COMPUTE\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.534820073679936*^9, 
  3.53482008886935*^9}},ExpressionUUID->"8c8bd788-acd6-4b32-b04f-\
187c3b9a1e4c"],

Cell[CellGroupData[{

Cell["request set up", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812330624641*^9, 3.470812336603714*^9}, {3.499557113585561*^9, 
   3.499557172623969*^9}, {3.505725943541356*^9, 3.50572594617164*^9}, 
   3.7003253426838512`*^9, 3.700481393463455*^9, {3.7005715514318523`*^9, 
   3.700571555237199*^9}},ExpressionUUID->"f21c3071-462d-404d-9469-\
e77e8cd6139f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", "True"}], ",", 
       RowBox[{"sampst", ":", 
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
       RowBox[{"acqevst", ":", "True"}], ",", 
       RowBox[{"prepst", ":", "True"}], ",", 
       RowBox[{"ensavst", ":", "True"}], ",", 
       RowBox[{"normfacst", ":", "True"}], ",", 
       RowBox[{"obsst", ":", "True"}], ",", 
       RowBox[{"evbackgst", ":", "True"}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"subcat1st", ":", "True"}], ",", 
            RowBox[{"subcat2st", ":", "True"}], ",", 
            RowBox[{"{", 
             RowBox[{"False", ",", "False"}], "}"}], ",", "moresubcatst___"}],
            "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}], 
     ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{"subcat1st", ",", "subcat2st", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "False"}], "}"}], ",", "moresubcatst"}], 
          "}"}], ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
     "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.7003234224719067`*^9, 3.700323423407679*^9}, 
   3.700323487606675*^9, {3.7003235334507027`*^9, 3.700323562646338*^9}, 
   3.700325340855411*^9, 3.700481393447546*^9, {3.700488780586094*^9, 
   3.7004887825675898`*^9}, 3.700571495162578*^9, {3.7005715826727*^9, 
   3.700571630261539*^9}, {3.7005735309437723`*^9, 3.700573551160348*^9}, {
   3.7005765065510597`*^9, 3.700576540950471*^9}, 3.7005773671111403`*^9, {
   3.701088593337123*^9, 3.701088600969604*^9}, {3.703088597130391*^9, 
   3.7030886026493883`*^9}},
 CellLabel->
  "In[2173]:=",ExpressionUUID->"3fc5fe5b-e22d-4b5f-9700-b4c114132809"]
}, Closed]],

Cell[CellGroupData[{

Cell["finish up unless COMPUTE is used", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812330624641*^9, 3.470812336603714*^9}, {3.499557113585561*^9, 
   3.499557172623969*^9}, {3.505725943541356*^9, 3.50572594617164*^9}, 
   3.7003253426838512`*^9, 3.700481393463455*^9, {3.7005715514318523`*^9, 
   3.700571555237199*^9}, {3.700576710730658*^9, 
   3.7005767315022573`*^9}},ExpressionUUID->"af19aa12-8716-4cf9-ac01-\
93226f30d4ae"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"chronst", ":", "True"}], ",", 
        RowBox[{"sampst", ":", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
        RowBox[{"acqevst", ":", "True"}], ",", 
        RowBox[{"prepst", ":", "True"}], ",", 
        RowBox[{"ensavst", ":", "True"}], ",", 
        RowBox[{"normfacst", ":", "True"}], ",", 
        RowBox[{"obsst", ":", "True"}], ",", 
        RowBox[{"evbackgst", ":", "True"}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"subcat1st", ":", "True"}], ",", 
             RowBox[{"subcat2st", ":", "True"}], ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "False"}], "}"}], ",", "moresubcatst___"}],
             "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}],
       ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SignalCalculationMethod", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", "\"\<COMPUTE\>\""}],
       "]"}]}]}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{"subcat1st", ",", "subcat2st", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}], ",", "moresubcatst"}], 
          "}"}], ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
     "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.7003234224719067`*^9, 3.700323423407679*^9}, 
   3.700323487606675*^9, {3.7003235334507027`*^9, 3.700323562646338*^9}, 
   3.700325340855411*^9, 3.700481393447546*^9, {3.700488780586094*^9, 
   3.7004887825675898`*^9}, 3.700571495162578*^9, {3.7005715826727*^9, 
   3.700571630261539*^9}, {3.7005735309437723`*^9, 3.700573551160348*^9}, {
   3.7005765065510597`*^9, 3.700576540950471*^9}, {3.700576740281185*^9, 
   3.700576771546064*^9}, 3.700577360647586*^9, {3.701088611784379*^9, 
   3.701088632408863*^9}, {3.7030886154662457`*^9, 3.7030886214798098`*^9}},
 CellLabel->
  "In[2174]:=",ExpressionUUID->"a191f595-33b4-4ff1-907d-e7dd44d295e1"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
if the detection events are time-independent, set up a single event lasting \
one period\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.534819595658876*^9, 3.534819622945457*^9}, 
   3.534819653181642*^9},ExpressionUUID->"ddf0dc10-1b5b-4937-a6aa-\
06bdd2b7e2f6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"chronst", ":", "True"}], ",", 
        RowBox[{"sampst", ":", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
        RowBox[{"acqevst", ":", "True"}], ",", 
        RowBox[{"prepst", ":", "True"}], ",", 
        RowBox[{"ensavst", ":", "True"}], ",", 
        RowBox[{"normfacst", ":", "True"}], ",", 
        RowBox[{"obsst", ":", "True"}], ",", 
        RowBox[{"evbackgst", ":", "True"}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"subcat1st", ":", "True"}], ",", 
             RowBox[{"subcat2st", ":", "True"}], ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "False"}], "}"}], ",", "moresubcatst___"}],
             "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}],
       ",", "\[IndentingNewLine]", "timing_List", ",", 
      "evspecs_EventSpecifications", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"evspecs", ",", 
      RowBox[{"EventSpecifications", "[", 
       RowBox[{"True", ",", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
           "NullGeneratorPattern", "|", "NonStandardNullGeneratorPattern", 
            "|", 
            RowBox[{"_", "?", "OperatorQ"}], "|", 
            RowBox[{"_", "?", "SuperoperatorQ"}]}], ",", "\[Tau]_"}], "}"}], 
         "}"}], ",", "evopts___Rule"}], "]"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"period", ",", "evgen"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"period", "=", 
        RowBox[{
         RowBox[{"SignalGeneratorPeriod", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"evgen", "=", 
        RowBox[{"evspecs", "\[LeftDoubleBracket]", 
         RowBox[{"2", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", 
           "ensavst", ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", 
             RowBox[{"{", 
              RowBox[{"subcat1st", ",", "subcat2st", ",", 
               RowBox[{"{", 
                RowBox[{"True", ",", "True"}], "}"}], ",", "moresubcatst"}], 
              "}"}], ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
         "\[IndentingNewLine]", "timing", ",", "evspecs", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PeriodicDetectionEvents", "\[Rule]", 
             RowBox[{"EventSpecifications", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"evgen", ",", "period"}], "}"}], "}"}], "]"}]}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.534819090178753*^9, 3.534819190621499*^9}, {
   3.5348193451961317`*^9, 3.534819379304345*^9}, {3.534819443180255*^9, 
   3.534819540477182*^9}, 3.534821090532414*^9, {3.534821313650243*^9, 
   3.534821314569572*^9}, 3.543894312988209*^9, {3.626084083262925*^9, 
   3.626084084994341*^9}, {3.683957724030876*^9, 3.683957724033955*^9}, {
   3.699959598981575*^9, 3.69995960047782*^9}, {3.7005768332292624`*^9, 
   3.700576979516238*^9}, {3.700577033328496*^9, 3.700577067728314*^9}, {
   3.7005771961494417`*^9, 3.7005772079707823`*^9}, {3.7005772610240717`*^9, 
   3.7005772661612988`*^9}, {3.700577351576542*^9, 3.70057735379885*^9}, {
   3.700577539772181*^9, 3.700577541121806*^9}, {3.700577598077014*^9, 
   3.70057762609138*^9}, 3.700577694944516*^9, {3.700577732366897*^9, 
   3.700577755396488*^9}, {3.700577889672365*^9, 3.700577890398726*^9}, {
   3.700577936675159*^9, 3.70057796895188*^9}, {3.70057814865412*^9, 
   3.700578150652553*^9}, 3.700578455900551*^9, {3.701088643057008*^9, 
   3.701088651431415*^9}, {3.703088631521635*^9, 3.703088637759959*^9}, {
   3.709374479479697*^9, 3.709374480716164*^9}},
 CellLabel->
  "In[2175]:=",ExpressionUUID->"5096280d-2e5d-4237-a365-4d4237334bec"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
if the detection events are repetitions, expand the appropriate number of \
repetitions\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.534819595658876*^9, 3.534819622945457*^9}, {
  3.534819653181642*^9, 
  3.5348196821364*^9}},ExpressionUUID->"68f6b5c0-d8fb-473c-a210-bc75c7cfbe7a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"chronst", ":", "True"}], ",", 
        RowBox[{"sampst", ":", 
         RowBox[{"True", "|", 
          RowBox[{"{", 
           RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
        RowBox[{"acqevst", ":", "True"}], ",", 
        RowBox[{"prepst", ":", "True"}], ",", 
        RowBox[{"ensavst", ":", "True"}], ",", 
        RowBox[{"normfacst", ":", "True"}], ",", 
        RowBox[{"obsst", ":", "True"}], ",", 
        RowBox[{"evbackgst", ":", "True"}], ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"subcat1st", ":", "True"}], ",", 
             RowBox[{"subcat2st", ":", "True"}], ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "False"}], "}"}], ",", "moresubcatst___"}],
             "}"}], ",", "morelocst___"}], "}"}]}], ",", "morest___"}], "}"}],
       ",", "timing_List", ",", "evspecs_EventSpecifications", ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"evspecs", ",", 
      RowBox[{"EventSpecifications", "[", 
       RowBox[{"True", ",", 
        RowBox[{"{", 
         RowBox[{"{", "_Repeat", "}"}], "}"}], ",", "evopts___Rule"}], 
       "]"}]}], "]"}]}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "period", ",", "repev", ",", "nrepdet", ",", "evopts", ",", 
       "repevopts"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"period", "=", 
        RowBox[{
         RowBox[{"SignalGeneratorPeriod", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"repev", "=", 
        RowBox[{"evspecs", "\[LeftDoubleBracket]", 
         RowBox[{"2", ",", "1", ",", "1", ",", "1"}], 
         "\[RightDoubleBracket]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"evopts", "=", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"Cases", "[", 
          RowBox[{"evspecs", ",", "_Rule"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"repevopts", "=", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"evspecs", "\[LeftDoubleBracket]", 
            RowBox[{"2", ",", "1", ",", "1"}], "\[RightDoubleBracket]"}], ",",
            "_Rule"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"nrepdet", "=", 
        RowBox[{"Max", "[", 
         RowBox[{
          RowBox[{"Ceiling", "[", 
           RowBox[{"period", "/", 
            RowBox[{"EventDuration", "[", "repev", "]"}]}], "]"}], ",", "1"}],
          "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", 
           "ensavst", ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", 
             RowBox[{"{", 
              RowBox[{"subcat1st", ",", "subcat2st", ",", 
               RowBox[{"{", 
                RowBox[{"True", ",", "True"}], "}"}], ",", "moresubcatst"}], 
              "}"}], ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
         "\[IndentingNewLine]", "timing", ",", "evspecs", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
           "PeriodicDetectionEvents", "\[Rule]", "\[IndentingNewLine]", 
            RowBox[{"EventSpecifications", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"Repeat", "[", 
                RowBox[{"repev", ",", "nrepdet", ",", "repevopts"}], "]"}], 
               "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"ExpandRepeatedEvents", "\[Rule]", "True"}], ",", 
              "\[IndentingNewLine]", "evopts"}], "\[IndentingNewLine]", 
             "]"}]}], "\[IndentingNewLine]", "]"}]}], ",", 
         "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.534819090178753*^9, 3.534819190621499*^9}, {
   3.5348193451961317`*^9, 3.534819379304345*^9}, {3.534819443180255*^9, 
   3.534819540477182*^9}, 3.5348197084257174`*^9, {3.534819872251301*^9, 
   3.534819947115484*^9}, {3.534819981295965*^9, 3.5348200628037033`*^9}, 
   3.5348210859520273`*^9, {3.61501549575073*^9, 3.6150154959321527`*^9}, {
   3.626084087142034*^9, 3.626084088321899*^9}, 3.6615821610931997`*^9, 
   3.6615845893118467`*^9, 3.680955515955592*^9, {3.6839577240429897`*^9, 
   3.6839577240456953`*^9}, 3.684946895446436*^9, 3.692848562629785*^9, {
   3.69995960093891*^9, 3.699959602323016*^9}, {3.70057822007649*^9, 
   3.700578333663739*^9}, {3.700578417982992*^9, 3.7005784699020576`*^9}, {
   3.700578512309986*^9, 3.700578530811812*^9}, {3.70057858186959*^9, 
   3.700578591036742*^9}, 3.7005786420608253`*^9, {3.700578888348781*^9, 
   3.700578892930513*^9}, {3.700579192259987*^9, 3.7005792017214622`*^9}, {
   3.701088662360268*^9, 3.70108867222276*^9}, {3.703088653473085*^9, 
   3.7030886599034348`*^9}},
 CellLabel->
  "In[2176]:=",ExpressionUUID->"9811cfc1-fd91-4881-8901-009293595cb6"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["subcategory 4: CarouselAverage", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700323603223743*^9, 3.700323619442904*^9}, {3.7003236919388866`*^9, 
   3.7003236933443213`*^9}, {3.700571517662788*^9, 3.7005715363528843`*^9}, {
   3.7005735219986467`*^9, 3.7005735223264513`*^9}, {3.7005764893130713`*^9, 
   3.700576494920969*^9}, {3.700577046650675*^9, 3.7005770537513027`*^9}, {
   3.703085127631392*^9, 
   3.703085132485495*^9}},ExpressionUUID->"fc9ee684-e36b-4c96-b3c3-\
0974def18462"],

Cell["\<\
CarouselAverage\[Rule]True is only compatible with the COMPUTE algorithm\
\>", "Text",
 CellChangeTimes->{{3.7030851394311857`*^9, 
  3.703085159602068*^9}},ExpressionUUID->"c9d94149-90fc-499e-9373-\
1c1bb65a2259"],

Cell[CellGroupData[{

Cell["request checks", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812330624641*^9, 3.470812336603714*^9}, {3.499557113585561*^9, 
   3.499557172623969*^9}, {3.505725943541356*^9, 3.50572594617164*^9}, 
   3.7003253426838512`*^9, 3.700481393463455*^9, {3.7005715514318523`*^9, 
   3.700571555237199*^9}, {3.703089815028017*^9, 
   3.703089815905758*^9}},ExpressionUUID->"c10eec8f-55b1-4cc6-8b63-\
66557e837b5e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chronst_", ",", "sampst_", ",", "acqevst_", ",", "prepst_", ",", 
       "ensavst_", ",", "normfacst_", ",", "obsst_", ",", "evbackgst_", ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"subcat1st", ":", "True"}], ",", 
            RowBox[{"subcat2st", ":", "True"}], ",", 
            RowBox[{"subcat3st", ":", "True"}], ",", 
            RowBox[{"{", 
             RowBox[{"False", ",", "False", ",", "False"}], "}"}], ",", 
            "moresubcatst___"}], "}"}], ",", "morelocst___"}], "}"}]}], ",", 
       "morest___"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{"subcat1st", ",", "subcat2st", ",", "subcat3st", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "False", ",", "False"}], "}"}], ",", 
           "moresubcatst"}], "}"}], ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.7003234224719067`*^9, 3.700323423407679*^9}, 
   3.700323487606675*^9, {3.7003235334507027`*^9, 3.700323562646338*^9}, 
   3.700325340855411*^9, 3.700481393447546*^9, {3.700488780586094*^9, 
   3.7004887825675898`*^9}, 3.700571495162578*^9, {3.7005715826727*^9, 
   3.700571630261539*^9}, {3.7005735309437723`*^9, 3.700573551160348*^9}, {
   3.7005765065510597`*^9, 3.700576540950471*^9}, 3.7005773671111403`*^9, {
   3.701088593337123*^9, 3.701088600969604*^9}, {3.7030852218661623`*^9, 
   3.7030852697361593`*^9}, {3.703088677900679*^9, 3.7030886829143248`*^9}, {
   3.703089858994809*^9, 3.703089866512179*^9}},
 CellLabel->
  "In[2177]:=",ExpressionUUID->"a4101cd9-2a4a-4971-997d-6c0b9dcca8b4"]
}, Closed]],

Cell[CellGroupData[{

Cell["finish up if CarouselAverage\[Rule]False", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812330624641*^9, 3.470812336603714*^9}, {3.499557113585561*^9, 
   3.499557172623969*^9}, {3.505725943541356*^9, 3.50572594617164*^9}, 
   3.7003253426838512`*^9, 3.700481393463455*^9, {3.7005715514318523`*^9, 
   3.700571555237199*^9}, {3.700576710730658*^9, 3.7005767315022573`*^9}, {
   3.703085362889539*^9, 3.7030853659506493`*^9}, {3.703088882308528*^9, 
   3.7030888911704407`*^9}},ExpressionUUID->"3c173c64-dfbf-4f29-a7b3-\
b2a97a3fd103"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "chronst_", ",", "sampst_", ",", "acqevst_", ",", "prepst_", ",", 
        "ensavst_", ",", "normfacst_", ",", "obsst_", ",", "evbackgst_", ",", 
        
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"subcat1st", ":", "True"}], ",", 
             RowBox[{"subcat2st", ":", "True"}], ",", 
             RowBox[{"subcat3st", ":", "True"}], ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "False", ",", "False"}], "}"}], ",", 
             "moresubcatst___"}], "}"}], ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"CarouselAverage", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Signal1D", "]"}]}], ")"}]}]}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{"subcat1st", ",", "subcat2st", ",", "subcat3st", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "True"}], "}"}], ",", 
           "moresubcatst"}], "}"}], ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "\[IndentingNewLine]", "opts"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.703088920258642*^9, 3.703088971713937*^9}, {
  3.703089875706985*^9, 3.703089882183721*^9}},
 CellLabel->
  "In[2178]:=",ExpressionUUID->"107e7766-5346-47bf-8b2c-04a9a7488aa2"]
}, Closed]],

Cell[CellGroupData[{

Cell["CarouselAverage\[Rule]True: check validity", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812330624641*^9, 3.470812336603714*^9}, {3.499557113585561*^9, 
   3.499557172623969*^9}, {3.505725943541356*^9, 3.50572594617164*^9}, 
   3.7003253426838512`*^9, 3.700481393463455*^9, {3.7005715514318523`*^9, 
   3.700571555237199*^9}, {3.700576710730658*^9, 3.7005767315022573`*^9}, {
   3.703085362889539*^9, 3.7030853659506493`*^9}, {3.703088896916092*^9, 
   3.7030888998814583`*^9}, {3.703088983184133*^9, 3.70308898571068*^9}, {
   3.70308988751394*^9, 3.703089892966383*^9}, {3.703089932063023*^9, 
   3.703089935821005*^9}},ExpressionUUID->"3f92bfcd-c68c-4ad9-a820-\
dd5ade6e074f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "chronst_", ",", "sampst_", ",", "acqevst_", ",", "prepst_", ",", 
        "ensavst_", ",", "normfacst_", ",", "obsst_", ",", "evbackgst_", ",", 
        
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"subcat1st", ":", "True"}], ",", 
             RowBox[{"subcat2st", ":", "True"}], ",", 
             RowBox[{"subcat3st", ":", "True"}], ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "False", ",", "False"}], "}"}], ",", 
             "moresubcatst___"}], "}"}], ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"CarouselAverage", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "Signal1D", "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "scm", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"scm", "=", 
        RowBox[{
         RowBox[{"SignalCalculationMethod", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"scm", ",", "\"\<COMPUTE\>\""}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Signal1D", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", 
             "ensavst", ",", "normfacst", ",", "obsst", ",", "evbackgst", ",",
              
             RowBox[{"{", 
              RowBox[{"True", ",", 
               RowBox[{"{", 
                RowBox[{
                "subcat1st", ",", "subcat2st", ",", "subcat3st", ",", 
                 RowBox[{"{", 
                  RowBox[{"True", ",", "True", ",", "False"}], "}"}]}], "}"}],
                ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", 
           "more", ",", "opts"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{"Signal1D", "::", "nocarav"}], "]"}], ";", "$Failed"}], 
          ")"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.7003234224719067`*^9, 3.700323423407679*^9}, 
   3.700323487606675*^9, {3.7003235334507027`*^9, 3.700323562646338*^9}, 
   3.700325340855411*^9, 3.700481393447546*^9, {3.700488780586094*^9, 
   3.7004887825675898`*^9}, 3.700571495162578*^9, {3.7005715826727*^9, 
   3.700571630261539*^9}, {3.7005735309437723`*^9, 3.700573551160348*^9}, {
   3.7005765065510597`*^9, 3.700576540950471*^9}, {3.700576740281185*^9, 
   3.700576771546064*^9}, 3.700577360647586*^9, {3.701088611784379*^9, 
   3.701088632408863*^9}, 3.703085307680797*^9, {3.703085348732211*^9, 
   3.7030854711106*^9}, {3.703085503595573*^9, 3.703085616931966*^9}, {
   3.703085970018515*^9, 3.7030859724319077`*^9}, {3.7030886903112926`*^9, 
   3.703088697917645*^9}, 3.7030888485911217`*^9, {3.7030892063595943`*^9, 
   3.70308920658946*^9}, {3.703089245005842*^9, 3.7030892483235283`*^9}, {
   3.703089907928485*^9, 3.703089916078101*^9}, {3.70309008201016*^9, 
   3.703090084257455*^9}},
 CellLabel->
  "In[2179]:=",ExpressionUUID->"508855b0-a389-4f78-a649-250d315ec704"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
CarouselAverage\[Rule]True: Issue warning if Preparation has a finite \
duration.\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.470811122794271*^9, 3.470811128920431*^9}, {
   3.470812330624641*^9, 3.470812336603714*^9}, {3.499557113585561*^9, 
   3.499557172623969*^9}, {3.505725943541356*^9, 3.50572594617164*^9}, 
   3.7003253426838512`*^9, 3.700481393463455*^9, {3.7005715514318523`*^9, 
   3.700571555237199*^9}, {3.700576710730658*^9, 3.7005767315022573`*^9}, {
   3.703085362889539*^9, 3.7030853659506493`*^9}, {3.703088896916092*^9, 
   3.7030888998814583`*^9}, {3.703088983184133*^9, 3.70308898571068*^9}, {
   3.70308988751394*^9, 3.703089892966383*^9}, {3.703089943152822*^9, 
   3.703089971138261*^9}, {3.703090360015155*^9, 
   3.703090372956205*^9}},ExpressionUUID->"571f50c9-fc78-4a75-bdb4-\
1554c44cd323"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"chronst_", ",", "sampst_", ",", "acqevst_", ",", 
        RowBox[{"prepst", ":", "True"}], ",", "ensavst_", ",", "normfacst_", 
        ",", "obsst_", ",", "evbackgst_", ",", 
        RowBox[{"locst", ":", 
         RowBox[{"{", 
          RowBox[{"True", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"subcat1st", ":", "True"}], ",", 
             RowBox[{"subcat2st", ":", "True"}], ",", 
             RowBox[{"subcat3st", ":", "True"}], ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True", ",", "False"}], "}"}], ",", 
             "moresubcatst___"}], "}"}], ",", "morelocst___"}], "}"}]}], ",", 
        "morest___"}], "}"}], ",", 
      RowBox[{"more", ":", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
      "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"CarouselAverage", "/.", 
       RowBox[{"{", "opts", "}"}]}], "/.", 
      RowBox[{"Options", "[", "Signal1D", "]"}]}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "prep", "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"prep", "=", 
        RowBox[{
         RowBox[{"Preparation", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"TrueQ", "[", 
           RowBox[{
            RowBox[{"Chop", "@", 
             RowBox[{"EventDuration", "[", "prep", "]"}]}], "\[Equal]", "0"}],
            "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"Message", "[", 
          RowBox[{"Signal1D", "::", "caravwarn"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", 
           "ensavst", ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", 
             RowBox[{"{", 
              RowBox[{"subcat1st", ",", "subcat2st", ",", "subcat3st", ",", 
               RowBox[{"{", 
                RowBox[{"True", ",", "True", ",", "True"}], "}"}]}], "}"}], 
             ",", "morelocst"}], "}"}], ",", "morest"}], "}"}], ",", "more", 
         ",", "opts"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.7003234224719067`*^9, 3.700323423407679*^9}, 
   3.700323487606675*^9, {3.7003235334507027`*^9, 3.700323562646338*^9}, 
   3.700325340855411*^9, 3.700481393447546*^9, {3.700488780586094*^9, 
   3.7004887825675898`*^9}, 3.700571495162578*^9, {3.7005715826727*^9, 
   3.700571630261539*^9}, {3.7005735309437723`*^9, 3.700573551160348*^9}, {
   3.7005765065510597`*^9, 3.700576540950471*^9}, {3.700576740281185*^9, 
   3.700576771546064*^9}, 3.700577360647586*^9, {3.701088611784379*^9, 
   3.701088632408863*^9}, 3.703085307680797*^9, {3.703085348732211*^9, 
   3.7030854711106*^9}, {3.703085503595573*^9, 3.703085616931966*^9}, {
   3.703085970018515*^9, 3.7030859724319077`*^9}, {3.7030886903112926`*^9, 
   3.703088697917645*^9}, 3.7030888485911217`*^9, {3.7030892063595943`*^9, 
   3.70308920658946*^9}, {3.703089245005842*^9, 3.7030892483235283`*^9}, {
   3.703089907928485*^9, 3.703089916078101*^9}, {3.703089984102045*^9, 
   3.703090050011207*^9}, {3.703090092907178*^9, 3.7030901502515583`*^9}, {
   3.703090196431508*^9, 3.70309022750041*^9}},
 CellLabel->
  "In[2180]:=",ExpressionUUID->"533679c2-3131-4913-a14b-74acfddab31a"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["consolidate when all subcategories done", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.7005794559273853`*^9, 
   3.700579464023025*^9}},ExpressionUUID->"3dfd04d9-4d42-41ce-b632-\
f8a955a47c25"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"chronst", ":", "True"}], ",", 
       RowBox[{"sampst", ":", 
        RowBox[{"True", "|", 
         RowBox[{"{", 
          RowBox[{"True", ",", "True", ",", "___"}], "}"}]}]}], ",", 
       RowBox[{"acqevst", ":", "True"}], ",", "prepst_", ",", 
       RowBox[{"ensavst", ":", "True"}], ",", "normfacst_", ",", "obsst_", 
       ",", 
       RowBox[{"evbackgst", ":", "True"}], ",", "\[IndentingNewLine]", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"subcats", ":", 
           RowBox[{"True", ".."}]}], ",", "False"}], "}"}]}], ",", 
       "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "chronst", ",", "sampst", ",", "acqevst", ",", "prepst", ",", "ensavst",
        ",", "normfacst", ",", "obsst", ",", "evbackgst", ",", 
       RowBox[{"{", 
        RowBox[{"subcats", ",", "True"}], "}"}], ",", "morest"}], "}"}], ",", 
     "more", ",", "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.700309586887883*^9, {3.7003234224719067`*^9, 3.700323423407679*^9}, 
   3.700323487606675*^9, {3.7003235334507027`*^9, 3.700323562646338*^9}, 
   3.700325340855411*^9, 3.700481393447546*^9, {3.700488780586094*^9, 
   3.7004887825675898`*^9}, 3.700571495162578*^9, {3.70057260555066*^9, 
   3.7005726078283253`*^9}, {3.700573315814458*^9, 3.700573316074943*^9}, {
   3.700574265444388*^9, 3.700574343231988*^9}, {3.700579483506549*^9, 
   3.7005795157072353`*^9}, 3.701088684375414*^9},
 CellLabel->
  "In[2181]:=",ExpressionUUID->"2a5beab7-5a43-4e70-bbe7-06ef276e4e99"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["10. InitialDensityOperator", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469882637143063*^9, 
   3.469882639820516*^9}, 3.4698965783855743`*^9, {3.497350131321055*^9, 
   3.497350134039557*^9}, 3.497572555273549*^9, {3.49962571930704*^9, 
   3.499625720633676*^9}, 3.700309573483725*^9, {3.700323416023525*^9, 
   3.700323416886857*^9}, 3.700325339948*^9, 3.700481393433628*^9, 
   3.7005714895228167`*^9, {3.700579885774226*^9, 3.7005799122948*^9}, {
   3.701097914092905*^9, 
   3.701097914970427*^9}},ExpressionUUID->"491d18ba-c677-44e7-8482-\
d94986fc0a2e"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"0ccbbf18-58d9-44bf-a25a-\
4d161d301327"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<InitialDensityOperator\>\""}], "]"}]}],
        ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "nextlocst_", ",", "morelocst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.70057991472042*^9, {3.7191694174399195`*^9, 3.7191694245003796`*^9}, {
   3.719169513569521*^9, 3.7191695151382275`*^9}},
 CellLabel->
  "In[2182]:=",ExpressionUUID->"8def08fb-2b7d-439a-966d-c879c5ebe03a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 
   3.7010863549023314`*^9},ExpressionUUID->"fb318766-9f3b-44cc-9046-\
1c9ee7183bf3"],

Cell[CellGroupData[{

Cell["convert to Operator in ZeemanBasis", "Subsubsection",
 CellChangeTimes->{{3.7010864603545218`*^9, 3.7010864659691887`*^9}, {
  3.7010867609612627`*^9, 
  3.7010867637837343`*^9}},ExpressionUUID->"cd84a898-49bc-43c8-b786-\
ef3e1ef3ca09"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"Repeated", "[", 
         RowBox[{"_", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"StatusPosition", "[", 
             RowBox[{"Signal1D", ",", "\"\<InitialDensityOperator\>\""}], 
             "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "False", ",", "morelocst___"}], "}"}]}], ",", 
       "morest___"}], "}"}], ",", "\[IndentingNewLine]", "timing_List", ",", 
     "events_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]0", ",", "\[Rho]0vec", ",", "opbasis", ",", "basis"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]0", ",", "opbasis", ",", "basis"}], "}"}], "=", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "InitialDensityOperator", ",", "OperatorBasis", ",", "Basis"}], 
           "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True", ",", "morelocst"}], "}"}], ",", 
           "morest"}], "}"}], ",", "\[IndentingNewLine]", "timing", ",", 
         "events", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
            "InitialDensityOperator", "\[Rule]", "\[IndentingNewLine]", 
             RowBox[{"Operator", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"InitialDensityOperator", "/.", 
                 RowBox[{"{", "opts", "}"}]}], "/.", 
                RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
               RowBox[{"ZeemanBasis", "[", "]"}], ",", "\[IndentingNewLine]", 
               
               RowBox[{"Sequence", "@@", 
                RowBox[{"FilterRules", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
                    "opts"}], "}"}], ",", 
                  RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], 
              "]"}]}], ",", "\[IndentingNewLine]", "opts"}], 
           "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505831667958248*^9, 3.505831748490183*^9}, {
   3.505832309441513*^9, 3.505832312941794*^9}, {3.505832599922316*^9, 
   3.505832740073543*^9}, {3.506250210416719*^9, 3.506250237611433*^9}, {
   3.513186469192401*^9, 3.513186469829424*^9}, 3.51318681605831*^9, 
   3.513187651452241*^9, {3.532147304855291*^9, 3.532147439537492*^9}, {
   3.532149329896896*^9, 3.532149338319561*^9}, 3.532149372569627*^9, {
   3.533181425525577*^9, 3.533181430442663*^9}, {3.533182504670869*^9, 
   3.5331825131288147`*^9}, {3.5659827691398582`*^9, 3.565982782116868*^9}, {
   3.5659830268451757`*^9, 3.5659830434887037`*^9}, {3.5659830820186157`*^9, 
   3.56598308349586*^9}, 3.5659838988626003`*^9, 3.6184039837849693`*^9, 
   3.618404028231964*^9, {3.618480923911574*^9, 3.6184809991430187`*^9}, 
   3.618485751950809*^9, 3.618485814320808*^9, {3.699543683122245*^9, 
   3.6995437105638285`*^9}, {3.699543897851222*^9, 3.6995439024443913`*^9}, {
   3.6995439475325623`*^9, 3.699543947873602*^9}, {3.6995440913626137`*^9, 
   3.6995440975835285`*^9}, {3.6995441636725135`*^9, 3.699544163910169*^9}, {
   3.699544238338408*^9, 3.699544244690833*^9}, {3.699544291911933*^9, 
   3.6995443148411703`*^9}, {3.6995446345330815`*^9, 3.699544636765685*^9}, {
   3.6995448209907894`*^9, 3.699544822105002*^9}, {3.699544856660718*^9, 
   3.6995448878803053`*^9}, {3.699544938301976*^9, 3.6995449433501616`*^9}, {
   3.6999596180955772`*^9, 3.6999596194796953`*^9}, {3.70108647947666*^9, 
   3.701086681379079*^9}, {3.701086775234342*^9, 3.7010868771727133`*^9}, {
   3.7027831377703085`*^9, 3.7027831434043283`*^9}, {3.7027831936710367`*^9, 
   3.7027831939812574`*^9}, {3.709549793846383*^9, 3.70954982461693*^9}, {
   3.7095499072778535`*^9, 3.7095499404445014`*^9}},
 CellLabel->
  "In[2183]:=",ExpressionUUID->"64a9d1ef-3502-4189-ab73-31845d2b0a0d"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["done", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 3.7010863549023314`*^9, {3.7010868925951853`*^9, 
   3.701086901481483*^9}, {3.7010869484497347`*^9, 
   3.701086949006496*^9}},ExpressionUUID->"a4c02ede-08b5-4ab4-81a5-\
8dc1aa83e93e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"Repeated", "[", 
         RowBox[{"_", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"StatusPosition", "[", 
             RowBox[{"Signal1D", ",", "\"\<InitialDensityOperator\>\""}], 
             "]"}], "-", "1"}], "}"}]}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"True", ",", "True", ",", "False"}], "}"}]}], ",", 
       "morest___"}], "}"}], ",", "\[IndentingNewLine]", "timing_List", ",", 
     "events_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "True", ",", "True"}], "}"}], ",", "morest"}], 
      "}"}], ",", "\[IndentingNewLine]", "timing", ",", "events", ",", 
     "opts"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.701086909747253*^9, 3.701086939705097*^9}},
 CellLabel->
  "In[2184]:=",ExpressionUUID->"fd916b1d-80ce-428b-bba6-3eb2f903df29"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["11. LineBroadening", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469882637143063*^9, 
   3.469882639820516*^9}, 3.4698965783855743`*^9, {3.497350131321055*^9, 
   3.497350134039557*^9}, 3.497572555273549*^9, {3.49962571930704*^9, 
   3.499625720633676*^9}, 3.700309573483725*^9, {3.700323416023525*^9, 
   3.700323416886857*^9}, 3.700325339948*^9, 3.700481393433628*^9, 
   3.7005714895228167`*^9, {3.700579885774226*^9, 3.7005799122948*^9}, 
   3.701092012391735*^9, {3.701097916964213*^9, 
   3.7010979182049437`*^9}},ExpressionUUID->"7a28927c-da51-4258-8157-\
649853ee05ac"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"8c3026a8-5258-4488-9605-\
34af7c52b319"],

Cell["only request when everything else is done", "Text",
 CellChangeTimes->{{3.7010920581339617`*^9, 3.701092065349743*^9}, {
  3.701092546206051*^9, 
  3.70109254684184*^9}},ExpressionUUID->"69123495-2eba-4ae2-b347-\
d95d41dbcfe5"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"Repeated", "[", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"StatusPosition", "[", 
             RowBox[{"Signal1D", ",", "\"\<LineBroadening\>\""}], "]"}], "-", 
            "1"}], "}"}]}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "nextlocst_", ",", "morelocst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.70057991472042*^9, {3.701092025435781*^9, 3.701092055203823*^9}, {
   3.7191693692819448`*^9, 3.7191694109296365`*^9}, {3.7191695176491*^9, 
   3.719169519458014*^9}},
 CellLabel->
  "In[2185]:=",ExpressionUUID->"e5c8d1b8-8bf5-4257-a2e0-7dda4f2d35eb"]
}, Open  ]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 
   3.7010863549023314`*^9},ExpressionUUID->"ed0afdf6-db32-498b-812a-\
f5222114554d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<LineBroadening\>\""}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}], ",", "morest___"}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"timing", ":", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}]}], ",", 
     "events_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"lb", ",", "fwhh"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"lb", "=", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"LineBroadening", "/.", 
              RowBox[{"{", "opts", "}"}]}], "/.", 
             RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", "Automatic"}], 
           "]"}], ",", "\[IndentingNewLine]", "\t", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"fwhh", "=", 
             RowBox[{"N", "[", 
              RowBox[{"4", " ", 
               RowBox[{
                RowBox[{"Log", "[", "10", "]"}], "/", 
                RowBox[{"(", 
                 RowBox[{"Abs", "[", 
                  RowBox[{"tmax", "-", "tmin"}], "]"}], ")"}]}]}], "]"}]}], 
            ";", "\[IndentingNewLine]", "\t", 
            RowBox[{"Message", "[", 
             RowBox[{
              RowBox[{"Signal1D", "::", "autolb"}], ",", 
              RowBox[{"EngineeringForm", "@", 
               RowBox[{"N", "[", 
                RowBox[{"fwhh", "/", 
                 RowBox[{"(", 
                  RowBox[{"2", "\[Pi]"}], ")"}]}], "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", "\t", 
            RowBox[{"{", 
             RowBox[{"\"\<Lorentzian\>\"", ",", "fwhh"}], "}"}]}], ")"}], ",",
           "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"LineBroadening", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Signal1D", "]"}]}]}], 
         "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}], ",", "morest"}], "}"}], ",",
          "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "}"}], ",", 
         "\[IndentingNewLine]", "events", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", 
           RowBox[{
            RowBox[{"LineBroadening", "\[Rule]", "lb"}], ",", "opts"}], 
           "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.701092169605324*^9, 3.701092526598296*^9}},
 CellLabel->
  "In[2186]:=",ExpressionUUID->"0639ddd4-b671-484c-9fd8-dc600ef83551"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["12. UserLevel", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469882637143063*^9, 
   3.469882639820516*^9}, 3.4698965783855743`*^9, {3.497350131321055*^9, 
   3.497350134039557*^9}, 3.497572555273549*^9, {3.49962571930704*^9, 
   3.499625720633676*^9}, 3.700309573483725*^9, {3.700323416023525*^9, 
   3.700323416886857*^9}, 3.700325339948*^9, 3.700481393433628*^9, 
   3.7005714895228167`*^9, {3.700579885774226*^9, 3.7005799122948*^9}, 
   3.701092012391735*^9, {3.701092960495016*^9, 3.7010929611494503`*^9}, {
   3.7010937617650757`*^9, 3.701093778079844*^9}, {3.7010979198596363`*^9, 
   3.701097920532009*^9}, {3.7455060654117517`*^9, 3.745506067218445*^9}},
 Background->RGBColor[
  1, 0.9, 0.8],ExpressionUUID->"4d46eb71-d526-4a61-be99-43644ac37f48"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"9b2a1005-848f-4818-b295-\
32cc0af424ff"],

Cell["only request when everything else is done", "Text",
 CellChangeTimes->{{3.7010920581339617`*^9, 3.701092065349743*^9}, {
  3.701092546206051*^9, 
  3.70109254684184*^9}},ExpressionUUID->"a9773308-5efc-4b46-8eb0-\
8658d12ef43b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"Repeated", "[", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"StatusPosition", "[", 
             RowBox[{"Signal1D", ",", "\"\<UserLevel\>\""}], "]"}], "-", 
            "1"}], "}"}]}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "nextlocst_", ",", "morelocst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.70057991472042*^9, {3.701092025435781*^9, 3.701092055203823*^9}, {
   3.7010929675372458`*^9, 3.701092968310589*^9}, {3.745506078964069*^9, 
   3.745506080711481*^9}},ExpressionUUID->"489cdf66-9606-48ce-a90d-\
6f74dd99735a"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 
   3.7010863549023314`*^9},ExpressionUUID->"5c89f3ed-6b5a-4689-bddf-\
60d73d96645d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<UserLevel\>\""}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}], ",", "morest___"}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"timing", ":", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}]}], ",", 
     "events_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"scm", ",", "minrul", ",", "ul"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"scm", ",", "minrul"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "SignalCalculationMethod", ",", "MinimumRecommendedUserLevel"}], 
           "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"minrul", "=", 
        RowBox[{"Switch", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"minrul", ",", "scm"}], "}"}], ",", "\[IndentingNewLine]", 
          "\t", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", 
            RowBox[{"\"\<Diagonalization\>\"", "|", "\"\<COMPUTE\>\""}]}], 
           "}"}], ",", "1", ",", "\[IndentingNewLine]", "\t", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "\"\<Direct\>\""}], "}"}], ",", "2", ",",
           "\[IndentingNewLine]", "\t", "_", ",", "1"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ul", "=", 
        RowBox[{"UserLevel", "[", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"ul", "<", "minrul"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Message", "[", 
          RowBox[{
           RowBox[{"UserLevel", "::", "toolow"}], ",", "ul", ",", "minrul"}], 
          "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prefix", ",", 
           RowBox[{"{", 
            RowBox[{"True", ",", "True"}], "}"}], ",", "morest"}], "}"}], ",",
          "\[IndentingNewLine]", "timing", ",", "events", ",", "opts"}], 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.701092169605324*^9, 3.701092526598296*^9}, {
   3.7010929944817467`*^9, 3.701093013403054*^9}, {3.7010934705429573`*^9, 
   3.701093752204941*^9}, 3.7455061338733883`*^9, {3.745506272210012*^9, 
   3.74550651378727*^9}, {3.7455065885460043`*^9, 3.745506748988186*^9}, {
   3.7455068904135313`*^9, 3.745506890606183*^9}, 
   3.745507394572627*^9},ExpressionUUID->"afd9bcaf-5d28-4168-91d4-\
2fd86ec7e0cf"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["13. Check for suspect symbols & determine readiness", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469882637143063*^9, 
   3.469882639820516*^9}, 3.4698965783855743`*^9, {3.497350131321055*^9, 
   3.497350134039557*^9}, 3.497572555273549*^9, {3.49962571930704*^9, 
   3.499625720633676*^9}, 3.700309573483725*^9, {3.700323416023525*^9, 
   3.700323416886857*^9}, 3.700325339948*^9, 3.700481393433628*^9, 
   3.7005714895228167`*^9, {3.700579885774226*^9, 3.7005799122948*^9}, 
   3.701092012391735*^9, {3.701092960495016*^9, 3.7010929611494503`*^9}, {
   3.7010937617650757`*^9, 3.701093778079844*^9}, {3.7010979198596363`*^9, 
   3.701097920532009*^9}, 3.745506074066016*^9, {3.74550695640584*^9, 
   3.745506962467461*^9}},ExpressionUUID->"02b1d110-5046-44d0-a803-\
f221dc2c6915"],

Cell[CellGroupData[{

Cell["request setup", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 
   3.6999627884003057`*^9}},ExpressionUUID->"9dd6df6e-141c-41c2-9eb4-\
6003757b7457"],

Cell["only request when everything else is done", "Text",
 CellChangeTimes->{{3.7010920581339617`*^9, 3.701092065349743*^9}, {
  3.701092546206051*^9, 
  3.70109254684184*^9}},ExpressionUUID->"ef898462-00e3-479a-87de-\
3835c0ae135c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"Repeated", "[", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"StatusPosition", "[", 
             RowBox[{"Signal1D", ",", "\"\<Ready\>\""}], "]"}], "-", "1"}], 
           "}"}]}], "]"}]}], ",", 
       RowBox[{"locst", ":", 
        RowBox[{"{", 
         RowBox[{"False", ",", "nextlocst_", ",", "morelocst___"}], "}"}]}], 
       ",", "morest___"}], "}"}], ",", 
     RowBox[{"more", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Except", "[", "_Rule", "]"}], "..."}], ")"}]}], ",", 
     "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Signal1D", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"prefix", ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False", ",", "morelocst"}], "}"}], ",", 
       "morest"}], "}"}], ",", "more", ",", "opts"}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.6999612655554667`*^9, 3.699961371047697*^9}, {
   3.699961581259591*^9, 3.6999616644332952`*^9}, {3.6999619016309958`*^9, 
   3.699961902462171*^9}, {3.6999628208271723`*^9, 3.699962851572974*^9}, 
   3.699963538565003*^9, 3.6999651545718327`*^9, {3.699965238914163*^9, 
   3.699965240711988*^9}, {3.699965970973316*^9, 3.6999659755522346`*^9}, 
   3.69996662616116*^9, {3.700297655445187*^9, 3.7002976571938257`*^9}, 
   3.70057991472042*^9, {3.701092025435781*^9, 3.701092055203823*^9}, {
   3.7010929675372458`*^9, 3.701092968310589*^9}},
 CellLabel->
  "In[2187]:=",ExpressionUUID->"a82bb1bf-5641-4caf-a979-8ff22d000aca"]
}, Closed]],

Cell[CellGroupData[{

Cell["implementation", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, 3.4657360035980377`*^9, {
   3.47081822609048*^9, 3.470818231239852*^9}, {3.470818398251335*^9, 
   3.470818401375496*^9}, {3.4975727274869204`*^9, 3.497572737117094*^9}, {
   3.499326167332705*^9, 3.499326190834632*^9}, {3.699962741286421*^9, 
   3.6999627422294188`*^9}, {3.699962785071239*^9, 3.6999627884003057`*^9}, {
   3.700298701257303*^9, 3.700298704750389*^9}, {3.700580112900766*^9, 
   3.700580117226997*^9}, 
   3.7010863549023314`*^9},ExpressionUUID->"70d24e1d-ccce-49a0-b4cf-\
f0859b7cb273"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"prefix", ":", 
        RowBox[{"StatusPatternPrefix", "[", 
         RowBox[{"Signal1D", ",", "\"\<Ready\>\""}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"True", ",", "False"}], "}"}], ",", "morest___"}], "}"}], ",",
      "\[IndentingNewLine]", 
     RowBox[{"timing", ":", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}]}], ",", 
     "events_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ensavvars", ",", "suspectsymbols"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ensavvars", "=", 
        RowBox[{"UnassignedSymbols", "[", 
         RowBox[{
          RowBox[{"EnsembleAverage", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"suspectsymbols", "=", 
        RowBox[{"UnassignedSymbols", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"timing", ",", "events", ",", "opts"}], "}"}], ",", 
          RowBox[{"PermittedSymbols", "\[Rule]", "ensavvars"}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "suspectsymbols", "]"}], "\[Equal]", "0"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"prefix", ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True"}], "}"}], ",", "morest"}], "}"}], 
           ",", "\[IndentingNewLine]", "timing", ",", "events", ",", "opts"}],
           "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Message", "[", 
            RowBox[{
             RowBox[{"Signal1D", "::", "suspsymbs"}], ",", "suspectsymbols"}],
             "]"}], ";", "$Failed"}], ")"}]}], "\[IndentingNewLine]", "]"}]}],
       "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.701092169605324*^9, 3.701092526598296*^9}, {
  3.7010929944817467`*^9, 3.701093013403054*^9}, {3.7010934705429573`*^9, 
  3.701093752204941*^9}},
 CellLabel->
  "In[2188]:=",ExpressionUUID->"e57d8451-583b-408f-8ef4-80ebf7feec68"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["EnsembleAverage", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, {
   3.699957885713748*^9, 
   3.699957898650996*^9}},ExpressionUUID->"14893274-9c55-4681-aa4b-\
f3d4c7b6d8ba"],

Cell[CellGroupData[{

Cell["Implement Preparation before the EnsembleAverage if possible", \
"Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506767146878869*^9, 3.5067671531811543`*^9}, {
   3.507554915952759*^9, 3.507554918310874*^9}, {3.507556747116287*^9, 
   3.507556755028116*^9}, {3.565419601881979*^9, 3.565419618207242*^9}, {
   3.565970228271748*^9, 3.565970284235326*^9}, 3.565970334627747*^9, {
   3.5659707861449127`*^9, 3.56597079822922*^9}, {3.5662382108694563`*^9, 
   3.56623823117078*^9}},ExpressionUUID->"9c8fcce2-d010-4f45-8659-\
56246695659e"],

Cell[CellGroupData[{

Cell["\<\
remove Preparation background if the preparation has zero duration\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.587648667436393*^9, 
  3.587648679992875*^9}},ExpressionUUID->"82d7394a-e344-4a78-822c-\
9307e3ea7247"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{"True", ",", "timing_", ",", "acqevents_", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ensav", ",", "prep", ",", "backg", ",", "prepbackg", ",", "detbackg", 
       ",", "\[Rho]ini", ",", "var", ",", "vals", ",", "weights"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", 
        RowBox[{
        "True", ",", "timing", ",", "acqevents", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"detbackg", ",", 
               RowBox[{"NullOperator", "[", "]"}]}], "}"}]}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"prep", ",", "backg"}], "}"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Preparation", ",", "BackgroundGenerator"}], "}"}], "/.", 
           
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"detbackg", ",", "prepbackg"}], "}"}], "=", 
         RowBox[{"ReleaseHold", "[", "backg", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{
            RowBox[{"ReleaseHold", "@", "prepbackg"}], ",", 
            "NullGeneratorPattern"}], "]"}]}], "&&", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Chop", "[", 
            RowBox[{"EventDuration", "[", "prep", "]"}], "]"}], "\[Equal]", 
           "0"}], ")"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5876487143706017`*^9, 3.587648977157609*^9}, {
   3.587649061749064*^9, 3.587649105632389*^9}, {3.587817664000142*^9, 
   3.587817669870483*^9}, {3.58781798043719*^9, 3.587818015676833*^9}, {
   3.587819734193678*^9, 3.587819738828768*^9}, {3.593000546608993*^9, 
   3.593000552417733*^9}, {3.59300285690172*^9, 3.593002860484715*^9}, {
   3.6334328032390614`*^9, 3.633432803821804*^9}, {3.6334328578158827`*^9, 
   3.633432881419784*^9}, 3.680955517103447*^9, 3.68095680455027*^9, 
   3.6839577240549088`*^9, {3.69995960277287*^9, 3.6999596042130203`*^9}, {
   3.7010943118845987`*^9, 3.7010943860636063`*^9}, {3.7010945900271807`*^9, 
   3.701094590295767*^9}, 3.7010965527016993`*^9, 3.709374481638205*^9, {
   3.7093755549822817`*^9, 3.709375554985426*^9}, {3.7095500630585966`*^9, 
   3.709550065003179*^9}, {3.709550160180255*^9, 3.7095501603641734`*^9}, 
   3.7136374563122697`*^9, {3.7136376524281816`*^9, 3.7136376541555414`*^9}, {
   3.713637713511294*^9, 3.713637717723494*^9}, {3.7136377942334404`*^9, 
   3.713637820132653*^9}, {3.713637864310922*^9, 3.7136378656939974`*^9}, {
   3.713637921459983*^9, 3.7136379553604994`*^9}, {3.713637999125249*^9, 
   3.7136380006278467`*^9}, {3.7136380534342203`*^9, 
   3.7136380626562448`*^9}, {3.713638121989996*^9, 3.7136381704441566`*^9}, {
   3.7136383433022985`*^9, 3.7136383455426064`*^9}, {3.7185280749673862`*^9, 
   3.7185280937967434`*^9}},
 CellLabel->
  "In[2189]:=",ExpressionUUID->"8a50d3a2-0130-4965-90df-328ea10e0687"]
}, Closed]],

Cell[CellGroupData[{

Cell["implement Preparation if possible", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.587648667436393*^9, 3.587648708202773*^9}, {
  3.7010960584427023`*^9, 
  3.701096060573463*^9}},ExpressionUUID->"ff6513cf-8312-4480-b591-\
ce0674a914db"],

Cell["\<\
implement in the case that Preparation contains no EnsembleAverage variables\
\>", "Text",
 CellChangeTimes->{{3.7010960016317596`*^9, 3.7010960059802094`*^9}, {
  3.701096043055482*^9, 
  3.701096055667478*^9}},ExpressionUUID->"1cd51ccc-cc13-4013-b0a2-\
4ac2bec4661f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{"True", ",", 
     RowBox[{"timing", ":", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}]}], ",", 
     "acqevents_", ",", "opts___Rule"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ensav", ",", "prep", ",", "backg", ",", "prepbackg", ",", "detbackg", 
       ",", "\[Rho]ini", ",", "var", ",", "vals", ",", "weights", ",", 
       "\[Rho]afterprep", ",", "temp"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"temp", "=", 
          RowBox[{
          "PrintTemporary", "[", "\"\<implementing preparation..\>\"", 
           "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\[Rho]afterprep", "=", 
         RowBox[{
          RowBox[{"NPropagate", "[", "\[IndentingNewLine]", 
           RowBox[{"prep", ",", "\[IndentingNewLine]", 
            RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"InitialTimePoint", "\[Rule]", "Automatic"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"FinalTimePoint", "\[Rule]", "tmin"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"BackgroundGenerator", "\[Rule]", "prepbackg"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Continuous", "\[Rule]", "False"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Sequence", "@@", 
               RowBox[{"FilterRules", "[", 
                RowBox[{
                 RowBox[{"{", "opts", "}"}], ",", 
                 RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Sequence", "@@", 
               RowBox[{"CurrentOptionsToPassDown", "[", 
                RowBox[{"Signal1D", ",", "NPropagate"}], "]"}]}]}], 
             "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
          "[", 
          RowBox[{"Operator", "@", "\[Rho]ini"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"NotebookDelete", "[", "temp", "]"}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Signal1D", "[", 
         RowBox[{
         "True", ",", "timing", ",", "acqevents", ",", "\[IndentingNewLine]", 
          
          RowBox[{"Evaluate", "@", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"InitialDensityOperator", "\[Rule]", "\[Rho]afterprep"}],
              ",", "\[IndentingNewLine]", 
             RowBox[{"Preparation", "\[Rule]", "None"}], ",", 
             "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
            "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"ensav", ",", "prep", ",", "backg", ",", "\[Rho]ini"}], 
           "}"}], "=", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "EnsembleAverage", ",", "Preparation", ",", 
              "BackgroundGenerator", ",", "InitialDensityOperator"}], "}"}], "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"detbackg", ",", "prepbackg"}], "}"}], "=", 
          RowBox[{"ReleaseHold", "[", "backg", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"!", 
            RowBox[{"MatchQ", "[", 
             RowBox[{"prep", ",", 
              RowBox[{"None", "|", 
               RowBox[{"EventSpecifications", "@", 
                RowBox[{"UnitySuperoperator", "[", "]"}]}]}]}], "]"}]}], 
           ")"}], "&&", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"MatchQ", "[", 
               RowBox[{"ensav", ",", 
                RowBox[{"{", 
                 RowBox[{"_", ",", "_"}], "}"}]}], "]"}], "&&", 
              "\[IndentingNewLine]", 
              RowBox[{"EnsembleVariablesFreeQ", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"prep", ",", "\[Rho]ini"}], "}"}], ",", "ensav"}], 
               "]"}], "&&", "\[IndentingNewLine]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Chop", "[", 
                   RowBox[{"EventDuration", "[", "prep", "]"}], "]"}], 
                  "\[Equal]", "0"}], ")"}], "||", 
                RowBox[{"EnsembleVariablesFreeQ", "[", 
                 RowBox[{"prepbackg", ",", "ensav"}], "]"}]}], ")"}]}], ")"}],
             "||", 
            RowBox[{"MatchQ", "[", 
             RowBox[{"ensav", ",", 
              RowBox[{"False", "|", "None"}]}], "]"}]}], ")"}]}]}], 
        "\[IndentingNewLine]", ")"}], "\[IndentingNewLine]", ")"}]}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.5659694809930143`*^9, {3.565969538493561*^9, 3.56596955481822*^9}, {
   3.565969586077976*^9, 3.565969774347459*^9}, {3.5659698096456127`*^9, 
   3.56596997895259*^9}, {3.56597001255625*^9, 3.5659700444435167`*^9}, {
   3.565970123705276*^9, 3.565970164966851*^9}, 3.565970215360155*^9, {
   3.565970296722459*^9, 3.565970326752845*^9}, {3.565970385782839*^9, 
   3.565970395040709*^9}, {3.5659704530735617`*^9, 3.5659705164898043`*^9}, {
   3.5659705500286293`*^9, 3.565970593665462*^9}, {3.5659706685275593`*^9, 
   3.5659706904719553`*^9}, {3.5659707429246693`*^9, 
   3.5659707447297297`*^9}, {3.5659719523308992`*^9, 3.565971971936439*^9}, {
   3.5659723706055403`*^9, 3.565972374822139*^9}, {3.565973381831758*^9, 
   3.565973405833807*^9}, {3.565978944898698*^9, 3.5659790323132563`*^9}, {
   3.565979123821411*^9, 3.5659791283997087`*^9}, {3.5659805847924147`*^9, 
   3.565980612186614*^9}, 3.566236461730055*^9, 3.587648573737261*^9, {
   3.587649004834676*^9, 3.587649005825801*^9}, {3.587814834762928*^9, 
   3.587814849564591*^9}, {3.5878149146013393`*^9, 3.587814941974708*^9}, 
   3.587815635268095*^9, 3.587817694425083*^9, {3.587818045330318*^9, 
   3.587818054479807*^9}, {3.657218650347041*^9, 3.657218777707869*^9}, {
   3.6572188121008873`*^9, 3.65721882049043*^9}, {3.6572196622226458`*^9, 
   3.657219674838647*^9}, {3.657220615581979*^9, 3.657220621835104*^9}, {
   3.657221060957816*^9, 3.65722106397911*^9}, 3.6572224249256907`*^9, 
   3.680281472507402*^9, 3.68034479553915*^9, {3.68035034496574*^9, 
   3.680350383417244*^9}, {3.6839577240886087`*^9, 3.683957724094481*^9}, {
   3.699959605147025*^9, 3.699959607037032*^9}, {3.70109440749759*^9, 
   3.701094525704381*^9}, {3.701094663928021*^9, 3.701094684869507*^9}, {
   3.701094913815991*^9, 3.701094914102126*^9}, {3.701095950601769*^9, 
   3.70109599553631*^9}, {3.701096090943309*^9, 3.7010960962111073`*^9}, {
   3.701096403236446*^9, 3.7010964112321653`*^9}, {3.701097502022727*^9, 
   3.7010975129519577`*^9}, {3.709375554993396*^9, 3.709375554997064*^9}, {
   3.709550173951375*^9, 3.7095502466088457`*^9}, {3.709550289068795*^9, 
   3.7095502912145753`*^9}, {3.7095503621426306`*^9, 
   3.7095503646782084`*^9}, {3.711713508652747*^9, 3.7117135527635107`*^9}, {
   3.7117135838743906`*^9, 3.7117135840937386`*^9}, {3.711713704002673*^9, 
   3.711713704194438*^9}, 3.7136374563322268`*^9, {3.713637657308694*^9, 
   3.713637660338563*^9}, {3.713637721404148*^9, 3.7136377215803275`*^9}, {
   3.7136377637975655`*^9, 3.7136377639368925`*^9}, {3.713637827439451*^9, 
   3.7136378294061303`*^9}, {3.713637891573968*^9, 3.713637893325801*^9}, 
   3.713638068309805*^9, {3.713638162234545*^9, 3.7136381759788055`*^9}, {
   3.713638238475834*^9, 3.713638262706666*^9}, {3.71363834047672*^9, 
   3.7136383407558737`*^9}, {3.7185316812666793`*^9, 
   3.7185317278245444`*^9}, {3.7185318656641836`*^9, 3.71853186638818*^9}, {
   3.7185322262672825`*^9, 3.7185322263973265`*^9}, {3.7191689742367525`*^9, 
   3.7191689956763935`*^9}},
 CellLabel->
  "In[2190]:=",ExpressionUUID->"e4258c2b-1eea-4f1a-8cee-f7dd39f5aa69"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["PrepareParallel", "Subsection",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469877652562336*^9, 
   3.469877654440535*^9}, {3.4698786125145903`*^9, 3.4698786191211853`*^9}, {
   3.469883247163637*^9, 3.469883260409108*^9}, {3.469905506864237*^9, 
   3.4699055103160048`*^9}, {3.469906283820899*^9, 3.4699063030097322`*^9}, {
   3.469906546731975*^9, 3.4699065510413637`*^9}, 3.469960282710096*^9, {
   3.4701369772984257`*^9, 3.4701369799061337`*^9}, 3.4701379835572653`*^9, 
   3.470138023065645*^9, 
   3.61530540932759*^9},ExpressionUUID->"a75eae9e-db95-4dff-a8c8-\
7b486da1f80d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{"True", ",", "timing_", ",", "acqevents_", ",", "opts___Rule"}], 
     "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Parallel", ",", "ParallelSetUp", ",", "EnsembleAverage"}], 
         "}"}], "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"True", "|", "All", "|", 
         RowBox[{"_", "?", "NumericQ"}]}], ",", "False", ",", 
        RowBox[{"Except", "[", 
         RowBox[{"None", "|", "False"}], "]"}]}], "}"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"opbasis", ",", "basis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"PrepareParallel", "[", 
        RowBox[{"opbasis", ",", "basis", ",", "opts"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", 
        RowBox[{
        "True", ",", "timing", ",", "acqevents", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ParallelSetUp", "\[Rule]", "True"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Parallel", "\[Rule]", "True"}], ",", 
            "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}],
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQAWIQvTRS6XzwpFeOYdvkH4Nop9bLSiFA+s+bs6ogesm9
g24gWqlTwx1EX9DyjgHRqQWTwLTO7s1Xn8585ch9xOc6iA44+rTHZdYrRyPZ
P2D6jJmt/EEgvUtoMpgu3HV7zTEgzVRyfi2ItpsfFXYCxNcMDgfRRhXHKkC0
ymGRShCde2LBZRAd03b/CoherXRf/CSQ3ugkKQmiH3y8cIxj3ivHF7pBJ0E0
U0hz9fSi144nMiD03aUfnslMfO0410v2OYjekv6F02Pya0eHwy95QfQqS98O
k1VAuvxQF4gO33zvWcDq1477fCWfg+g3EdfegmgtNvtPIHqa9ZPYQCB95ulL
MA0A0cKtmw==
  "],
 CellLabel->
  "In[2191]:=",ExpressionUUID->"1d3eea0a-63f2-4cdd-88d6-79c087c9c96c"]
}, Closed]],

Cell[CellGroupData[{

Cell["divide into batches, calculate and combine", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506767146878869*^9, 3.5067671531811543`*^9}, {
   3.507554915952759*^9, 3.507554918310874*^9}, {3.507556747116287*^9, 
   3.507556755028116*^9}, {3.565419601881979*^9, 3.565419618207242*^9}, 
   3.565971500181367*^9, {3.565973348279451*^9, 3.56597335195018*^9}, {
   3.565973877245042*^9, 
   3.565973918345532*^9}},ExpressionUUID->"53baca82-64cc-45d8-b332-\
9b64952a5f64"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{"True", ",", "timing_", ",", "acqevents_", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ensav", ",", "prep", ",", "backg", ",", "prepbackg", ",", "detbackg", 
       ",", "\[Rho]ini", ",", "var", ",", "vals", ",", "weights", ",", "nens",
        ",", "maxbatchsize", ",", "valwbatches", ",", "nbatch", ",", "lb", 
       ",", "opbasis", ",", "basis", ",", "ib", ",", "temp", ",", "sig"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nens", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"maxbatchsize", "=", 
         RowBox[{"Min", "[", 
          RowBox[{
           RowBox[{"Max", "[", 
            RowBox[{"maxbatchsize", ",", "1"}], "]"}], ",", "nens"}], "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"var", "=", 
         RowBox[{"First", "[", "ensav", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"valwbatches", "=", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Last", "[", "ensav", "]"}], ",", "maxbatchsize", ",", 
           "maxbatchsize", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"nbatch", "=", 
         RowBox[{"Length", "[", "valwbatches", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"nbatch", "==", "1"}], ",", "\[IndentingNewLine]", 
          RowBox[{
          "PrintTemporary", "[", 
           "\"\<ensemble averaging using 1 batch ..\>\"", "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"PrintTemporary", "[", 
           RowBox[{"\"\<ensemble averaging using \>\"", "<>", 
            RowBox[{"ToString", "[", "nbatch", "]"}], "<>", 
            "\"\< batches..\>\""}], "]"}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"CombineData", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Monitor", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"(", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"temp", "=", 
                 RowBox[{"PrintTemporary", "[", 
                  RowBox[{"\"\<computing batch \>\"", "<>", 
                   RowBox[{"ToString", "[", "ib", "]"}], "<>", "\"\< of \>\"",
                    "<>", 
                   RowBox[{"ToString", "[", "nbatch", "]"}], "<>", 
                   "\"\<..\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"sig", "=", 
                 RowBox[{"Signal1D", "[", 
                  RowBox[{
                  "True", ",", "timing", ",", "acqevents", ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Evaluate", "@", 
                    RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"EnsembleAverage", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"var", ",", 
                    RowBox[{
                    "valwbatches", "\[LeftDoubleBracket]", "ib", 
                    "\[RightDoubleBracket]"}]}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"OperatorBasis", "\[Rule]", "opbasis"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Basis", "\[Rule]", "basis"}], ",", 
                    "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", 
                    "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"NotebookDelete", "[", "temp", "]"}], ";", 
                "\[IndentingNewLine]", "sig"}], "\[IndentingNewLine]", ")"}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"ib", ",", "1", ",", "nbatch"}], "}"}]}], 
             "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"ProgressIndicator", "[", 
             RowBox[{"ib", ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"nbatch", "+", "1"}]}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Table", "[", 
           RowBox[{"1", ",", 
            RowBox[{"{", "nbatch", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", 
             RowBox[{"Options", "[", "Signal", "]"}]}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "ensav", ",", "prep", ",", "backg", ",", "\[Rho]ini", ",", 
            "maxbatchsize"}], "}"}], "=", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "EnsembleAverage", ",", "Preparation", ",", 
              "BackgroundGenerator", ",", "InitialDensityOperator", ",", 
              "MaxBatchSize"}], "}"}], "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"detbackg", ",", "prepbackg"}], "}"}], "=", 
          RowBox[{"ReleaseHold", "[", "backg", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"EnsembleAverage", "/.", 
              RowBox[{"{", "opts", "}"}]}], "/.", 
             RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"_", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"_", ",", "_"}], "}"}], "..."}], "}"}]}], "}"}]}], 
           "]"}], "&&", "\[IndentingNewLine]", 
          RowBox[{"(", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"nens", "=", 
             RowBox[{"Length", "[", 
              RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"maxbatchsize", "=", 
             RowBox[{"Min", "[", 
              RowBox[{
               RowBox[{"Max", "[", 
                RowBox[{"maxbatchsize", ",", "1"}], "]"}], ",", "nens"}], 
              "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"maxbatchsize", "<", "nens"}], "&&", 
             "\[IndentingNewLine]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"MatchQ", "[", 
                RowBox[{"prep", ",", 
                 RowBox[{"None", "|", 
                  RowBox[{"UnitySuperoperator", "[", "]"}]}]}], "]"}], "||", 
               "\[IndentingNewLine]", 
               RowBox[{"!", 
                RowBox[{"EnsembleVariablesFreeQ", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"prep", ",", "\[Rho]ini"}], "}"}], ",", "ensav"}], 
                 "]"}]}], "||", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Chop", "[", 
                    RowBox[{"EventDuration", "[", "prep", "]"}], "]"}], "!=", 
                   "0"}], ")"}], "&&", "\[IndentingNewLine]", 
                 RowBox[{"!", 
                  RowBox[{"EnsembleVariablesFreeQ", "[", 
                   RowBox[{"prepbackg", ",", "ensav"}], "]"}]}]}], ")"}]}], 
              "\[IndentingNewLine]", ")"}]}]}], "\[IndentingNewLine]", 
           ")"}]}]}], "\[IndentingNewLine]", ")"}], "\[IndentingNewLine]", 
       ")"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.565973616626845*^9, 3.565973646938964*^9}, {
   3.565973704450218*^9, 3.565973792473486*^9}, {3.565973833957481*^9, 
   3.5659738417145357`*^9}, {3.565974054462031*^9, 3.565974486123555*^9}, {
   3.565974518256566*^9, 3.565974565209744*^9}, {3.5659798951711817`*^9, 
   3.565979896529059*^9}, {3.5661487167383833`*^9, 3.566148809409091*^9}, {
   3.566148841085351*^9, 3.566148910373026*^9}, 3.566148957582659*^9, {
   3.566148997323354*^9, 3.566148997527849*^9}, {3.566236134850613*^9, 
   3.5662361806023083`*^9}, {3.566463016717122*^9, 3.566463039597144*^9}, {
   3.566464270741766*^9, 3.566464284139461*^9}, {3.5664643242018433`*^9, 
   3.566464388867107*^9}, 3.5664645533377542`*^9, 3.566464680822782*^9, {
   3.566465258046586*^9, 3.5664652708622026`*^9}, {3.566465307380603*^9, 
   3.566465313920671*^9}, {3.5664688939931173`*^9, 3.5664688989712343`*^9}, {
   3.566903936029044*^9, 3.566903941372896*^9}, {3.5669039983988333`*^9, 
   3.5669040096094723`*^9}, {3.566904080790515*^9, 3.566904143473688*^9}, {
   3.566904551154718*^9, 3.56690457016008*^9}, {3.566904647204361*^9, 
   3.566904647327443*^9}, {3.566904824406974*^9, 3.566904825010825*^9}, {
   3.5669048800746717`*^9, 3.5669048997208843`*^9}, {3.5669053345885553`*^9, 
   3.5669053671167107`*^9}, {3.567698791691313*^9, 3.567698793381279*^9}, 
   3.5878177102123833`*^9, {3.5878180686155148`*^9, 3.587818074734044*^9}, {
   3.5926788732290287`*^9, 3.59267891202717*^9}, {3.657221287931819*^9, 
   3.657221389520824*^9}, 3.680955518656767*^9, 3.680956805890163*^9, {
   3.683957724120804*^9, 3.683957724124276*^9}, {3.699959609344165*^9, 
   3.6999596117068377`*^9}, {3.7010965795664253`*^9, 3.701096625642161*^9}, {
   3.703004469666016*^9, 3.703004471048457*^9}, 3.7093755550063763`*^9, 
   3.7136374563582478`*^9},
 CellLabel->
  "In[2192]:=",ExpressionUUID->"45c3be2b-990b-4e6d-a1c6-42da5801464d"]
}, Open  ]],

Cell[CellGroupData[{

Cell["ensemble average of a batch (Parallel\[Rule]False)", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506767146878869*^9, 3.5067671531811543`*^9}, {
   3.507554915952759*^9, 3.507554918310874*^9}, {3.507556747116287*^9, 
   3.507556755028116*^9}, {3.565419601881979*^9, 3.565419618207242*^9}, 
   3.565971500181367*^9, {3.566148650763178*^9, 
   3.566148655746417*^9}},ExpressionUUID->"2b75d89c-2ea1-4745-b067-\
cd6598a76a10"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{"True", ",", "timing_", ",", "acqevents_", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ensav", ",", "prep", ",", "backg", ",", "prepbackg", ",", "detbackg", 
       ",", "\[Rho]ini", ",", "var", ",", "vals", ",", "weights", ",", "nens",
        ",", "maxbatchsize", ",", "valwbatches", ",", "nbatch", ",", 
       "opbasis", ",", "basis", ",", "i", ",", "vardim", ",", "varsubrules", 
       ",", "temp", ",", "sig"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"temp", "=", 
         RowBox[{"PrintTemporary", "[", "\"\<setting up batch..\>\"", "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nens", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"varsubrules", "=", 
         RowBox[{"EnsembleVariablesSubstitutionRules", "[", "ensav", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"weights", "=", 
         RowBox[{"EnsembleWeights", "[", "ensav", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"NotebookDelete", "[", "temp", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"CombineData", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Monitor", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
               RowBox[{"True", ",", "timing", ",", "\[IndentingNewLine]", 
                RowBox[{"Evaluate", "@", 
                 RowBox[{"ReleaseHold", "[", 
                  RowBox[{
                   RowBox[{"Hold", "[", "acqevents", "]"}], "/.", 
                   RowBox[{
                   "varsubrules", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}]}], "]"}]}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Evaluate", "@", 
                 RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"EnsembleAverage", "\[Rule]", "False"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"OperatorBasis", "\[Rule]", "opbasis"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Basis", "\[Rule]", "basis"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"ReleaseHold", "[", 
                    RowBox[{
                    RowBox[{"Hold", "[", "opts", "]"}], "/.", 
                    RowBox[{
                    "varsubrules", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}]}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                   "WarnAboutMissingPreparationBackground", "\[Rule]", 
                    "False"}]}], "\[IndentingNewLine]", "]"}]}]}], 
               "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", "nens"}], "}"}]}], 
             "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"ProgressIndicator", "[", 
             RowBox[{"i", ",", 
              RowBox[{"{", 
               RowBox[{"1", ",", 
                RowBox[{"nens", "+", "1"}]}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          "weights", ",", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", 
             RowBox[{"Options", "[", "Signal", "]"}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Parallel", "\[Rule]", "False"}]}], "\[IndentingNewLine]", 
         "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"TrueQ", "[", 
          RowBox[{
           RowBox[{"Parallel", "/.", 
            RowBox[{"{", "opts", "}"}]}], "/.", 
           RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], "&&", 
        "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "ensav", ",", "prep", ",", "backg", ",", "\[Rho]ini", ",", 
             "maxbatchsize"}], "}"}], "=", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "EnsembleAverage", ",", "Preparation", ",", 
               "BackgroundGenerator", ",", "InitialDensityOperator", ",", 
               "MaxBatchSize"}], "}"}], "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"detbackg", ",", "prepbackg"}], "}"}], "=", 
           RowBox[{"ReleaseHold", "[", "backg", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{"ensav", ",", 
             RowBox[{"{", 
              RowBox[{"_", ",", "_"}], "}"}]}], "]"}], "&&", 
           "\[IndentingNewLine]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"nens", "=", 
              RowBox[{"Length", "[", 
               RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"maxbatchsize", "=", 
              RowBox[{"Min", "[", 
               RowBox[{
                RowBox[{"Max", "[", 
                 RowBox[{"maxbatchsize", ",", "1"}], "]"}], ",", "nens"}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"maxbatchsize", ">=", "nens"}], "&&", 
              "\[IndentingNewLine]", 
              RowBox[{"(", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"MatchQ", "[", 
                 RowBox[{"prep", ",", 
                  RowBox[{"None", "|", 
                   RowBox[{"EventSpecifications", "@", 
                    RowBox[{"UnitySuperoperator", "[", "]"}]}]}]}], "]"}], "||",
                 "\[IndentingNewLine]", 
                RowBox[{"(", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"!", 
                   RowBox[{"EnsembleVariablesFreeQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"prep", ",", "\[Rho]ini"}], "}"}], ",", "ensav"}],
                     "]"}]}], "||", "\[IndentingNewLine]", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Chop", "[", 
                    RowBox[{"EventDuration", "[", "prep", "]"}], "]"}], 
                    "\[NotEqual]", "0"}], ")"}], "&&", 
                    RowBox[{"!", 
                    RowBox[{"EnsembleVariablesFreeQ", "[", 
                    RowBox[{"prepbackg", ",", "ensav"}], "]"}]}]}], ")"}]}], 
                 "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
               ")"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
         "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.565973616626845*^9, 3.565973646938964*^9}, {
   3.565973704450218*^9, 3.565973792473486*^9}, {3.565973833957481*^9, 
   3.5659738417145357`*^9}, {3.565974054462031*^9, 3.565974486123555*^9}, {
   3.565974518256566*^9, 3.565974565209744*^9}, {3.5659783584475822`*^9, 
   3.565978359069312*^9}, {3.565978420403222*^9, 3.565978456688849*^9}, {
   3.5659784934805737`*^9, 3.565978701913156*^9}, {3.56597882283484*^9, 
   3.565978835914706*^9}, {3.56597930120035*^9, 3.5659793136804*^9}, {
   3.565979374883979*^9, 3.565979417503574*^9}, {3.5659797653630257`*^9, 
   3.565979816442376*^9}, {3.566148318765524*^9, 3.5661483287387247`*^9}, {
   3.5662398938218193`*^9, 3.566240101430765*^9}, {3.566240140156839*^9, 
   3.566240198227624*^9}, {3.5662404107506037`*^9, 3.5662404350283537`*^9}, {
   3.5664644230823307`*^9, 3.566464442214588*^9}, 3.566464689673236*^9, {
   3.5669039464406137`*^9, 3.566903946626964*^9}, {3.566904223936995*^9, 
   3.566904251583747*^9}, 3.566904688931509*^9, {3.566905054396121*^9, 
   3.566905058516095*^9}, 3.5669051361083803`*^9, {3.570561407668545*^9, 
   3.570561415454359*^9}, {3.570884287221319*^9, 3.570884290706141*^9}, 
   3.5708844148769007`*^9, 3.582607929495708*^9, 3.587817722882839*^9, {
   3.587818095068046*^9, 3.587818095380129*^9}, {3.592678946804638*^9, 
   3.592678950018751*^9}, 3.6393080920209093`*^9, {3.657214902312935*^9, 
   3.657214929695773*^9}, {3.65721892143541*^9, 3.657219023620442*^9}, {
   3.657222275986828*^9, 3.657222279551108*^9}, 3.661581665006077*^9, 
   3.680955519365437*^9, 3.680956806621008*^9, {3.683957724137703*^9, 
   3.683957724141232*^9}, {3.6999596121676607`*^9, 3.699959614473936*^9}, {
   3.701096648798113*^9, 3.7010968166625967`*^9}, 3.7093755550158052`*^9, 
   3.713637456376758*^9},
 CellLabel->
  "In[2193]:=",ExpressionUUID->"269a3d3d-52c7-4e6a-a36e-830dea0692fc"]
}, Open  ]],

Cell[CellGroupData[{

Cell["ensemble average of a batch (Parallel\[Rule]True)", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.506767146878869*^9, 3.5067671531811543`*^9}, {
   3.507554915952759*^9, 3.507554918310874*^9}, {3.507556747116287*^9, 
   3.507556755028116*^9}, {3.565419601881979*^9, 3.565419627726918*^9}, 
   3.566148665315995*^9},ExpressionUUID->"5c93048d-ad81-4417-8ac0-\
fc4acd8012f9"],

Cell["\<\
ensures that all basis transformation matrices are set up before distributing \
definitions to the parallel kernels. \
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.56541985860445*^9, 
  3.565419907904767*^9}},ExpressionUUID->"ef7b5f16-81d6-4c4d-a4cd-\
0ac1e32601dd"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "[", 
    RowBox[{"True", ",", "timing_", ",", "acqevents_", ",", "opts___Rule"}], 
    "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "ensav", ",", "prep", ",", "backg", ",", "prepbackg", ",", "detbackg", 
       ",", "\[Rho]ini", ",", "var", ",", "vals", ",", "weights", ",", "nens",
        ",", "maxbatchsize", ",", "valwbatches", ",", "nbatch", ",", 
       "opbasis", ",", "basis", ",", "i", ",", "vardim", ",", "varsubrules", 
       ",", "pvar", ",", "pvardim", ",", "pvarsubrules", ",", "temp", ",", 
       "sig", ",", "acqeventlists"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"temp", "=", 
         RowBox[{"PrintTemporary", "[", "\"\<setting up batch..\>\"", "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"opbasis", ",", "basis"}], "}"}], "=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"OperatorBasis", ",", "Basis"}], "}"}], "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"nens", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"varsubrules", "=", 
         RowBox[{"EnsembleVariablesSubstitutionRules", "[", "ensav", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"weights", "=", 
         RowBox[{"EnsembleWeights", "[", "ensav", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SetSharedVariable", "[", 
         RowBox[{"opbasis", ",", "basis"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"acqeventlists", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"ReleaseHold", "[", 
            RowBox[{
             RowBox[{"Hold", "[", "acqevents", "]"}], "/.", "#"}], "]"}], 
           "&"}], "/@", "varsubrules"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"DistributeDefinitions", "[", 
         RowBox[{"varsubrules", ",", "acqeventlists"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"NotebookDelete", "[", "temp", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"CombineData", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Parallelize", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
               RowBox[{"True", ",", "timing", ",", "\[IndentingNewLine]", 
                RowBox[{"Evaluate", "[", 
                 RowBox[{
                 "acqeventlists", "\[LeftDoubleBracket]", "i", 
                  "\[RightDoubleBracket]"}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Evaluate", "@", 
                 RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"EnsembleAverage", "\[Rule]", "False"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"OperatorBasis", "\[Rule]", "opbasis"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Basis", "\[Rule]", "basis"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"ReleaseHold", "[", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Hold", "[", "opts", "]"}], "/.", 
                    RowBox[{
                    "varsubrules", "\[LeftDoubleBracket]", "i", 
                    "\[RightDoubleBracket]"}]}], ")"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{
                   "WarnAboutMissingPreparationBackground", "\[Rule]", 
                    "False"}]}], "\[IndentingNewLine]", "]"}]}]}], 
               "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", "nens"}], "}"}]}], 
             "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Method", "\[Rule]", "\"\<CoarsestGrained\>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"DistributedContexts", "\[Rule]", "\"\<Global`\>\""}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          "weights", ",", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", 
            RowBox[{
             RowBox[{"{", "opts", "}"}], ",", 
             RowBox[{"Options", "[", "Signal", "]"}]}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Parallel", "\[Rule]", "True"}]}], "\[IndentingNewLine]", 
         "]"}]}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"Parallel", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], "&&", 
        "\[IndentingNewLine]", 
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"ParallelSetUp", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], "&&", 
        "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "ensav", ",", "prep", ",", "backg", ",", "\[Rho]ini", ",", 
             "maxbatchsize"}], "}"}], "=", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "EnsembleAverage", ",", "Preparation", ",", 
               "BackgroundGenerator", ",", "InitialDensityOperator", ",", 
               "MaxBatchSize"}], "}"}], "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"detbackg", ",", "prepbackg"}], "}"}], "=", 
           RowBox[{"ReleaseHold", "[", "backg", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{"ensav", ",", 
             RowBox[{"{", 
              RowBox[{"_", ",", "_"}], "}"}]}], "]"}], "&&", 
           "\[IndentingNewLine]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"nens", "=", 
              RowBox[{"Length", "[", 
               RowBox[{"Last", "[", "ensav", "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"maxbatchsize", "=", 
              RowBox[{"Min", "[", 
               RowBox[{
                RowBox[{"Max", "[", 
                 RowBox[{"maxbatchsize", ",", "1"}], "]"}], ",", "nens"}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"maxbatchsize", ">=", "nens"}], "&&", 
              "\[IndentingNewLine]", 
              RowBox[{"(", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"MatchQ", "[", 
                 RowBox[{"prep", ",", 
                  RowBox[{"None", "|", 
                   RowBox[{"EventSpecifications", "@", 
                    RowBox[{"UnitySuperoperator", "[", "]"}]}]}]}], "]"}], "||",
                 "\[IndentingNewLine]", 
                RowBox[{"(", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"!", 
                   RowBox[{"EnsembleVariablesFreeQ", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"prep", ",", "\[Rho]ini"}], "}"}], ",", "ensav"}],
                     "]"}]}], "||", "\[IndentingNewLine]", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Chop", "[", 
                    RowBox[{"EventDuration", "[", "prep", "]"}], "]"}], 
                    "\[NotEqual]", "0"}], ")"}], "&&", 
                    RowBox[{"!", 
                    RowBox[{"EnsembleVariablesFreeQ", "[", 
                    RowBox[{"prepbackg", ",", "ensav"}], "]"}]}]}], ")"}]}], 
                 "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
               ")"}]}]}], "\[IndentingNewLine]", ")"}]}]}], 
         "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", ")"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.565973616626845*^9, 3.565973646938964*^9}, {
   3.565973704450218*^9, 3.565973792473486*^9}, {3.565973833957481*^9, 
   3.5659738417145357`*^9}, {3.565974054462031*^9, 3.565974486123555*^9}, {
   3.565974518256566*^9, 3.565974565209744*^9}, {3.5659783584475822`*^9, 
   3.565978359069312*^9}, {3.565978420403222*^9, 3.565978456688849*^9}, {
   3.5659784934805737`*^9, 3.565978701913156*^9}, {3.56597882283484*^9, 
   3.565978835914706*^9}, {3.56597930120035*^9, 3.5659793136804*^9}, {
   3.565979374883979*^9, 3.565979417503574*^9}, {3.5659797653630257`*^9, 
   3.565979816442376*^9}, {3.566148318765524*^9, 3.5661483287387247`*^9}, {
   3.5662398938218193`*^9, 3.566240101430765*^9}, {3.566240140156839*^9, 
   3.566240198227624*^9}, {3.5662404107506037`*^9, 3.5662404350283537`*^9}, {
   3.56624048381085*^9, 3.56624053772714*^9}, {3.5662407555506496`*^9, 
   3.566240796437571*^9}, {3.566240873366365*^9, 3.566240883387638*^9}, {
   3.566240933520528*^9, 3.566240935584161*^9}, {3.5662416210583057`*^9, 
   3.5662416885803537`*^9}, {3.566306825919901*^9, 3.5663068278357697`*^9}, {
   3.566306955208445*^9, 3.566307083873686*^9}, {3.5663071312542152`*^9, 
   3.566307178596663*^9}, 3.566307209915374*^9, {3.566307258004628*^9, 
   3.566307260507393*^9}, {3.566307378953197*^9, 3.5663073916863413`*^9}, {
   3.5663074465661783`*^9, 3.566307449858664*^9}, {3.5663075869207706`*^9, 
   3.566307610796382*^9}, {3.566307705101838*^9, 3.5663077059198627`*^9}, {
   3.5663078624669*^9, 3.56630797411709*^9}, {3.5663080420163097`*^9, 
   3.566308044656402*^9}, {3.566308133517496*^9, 3.5663081478373528`*^9}, {
   3.566308196588539*^9, 3.566308197305032*^9}, {3.566308396608077*^9, 
   3.566308434759433*^9}, {3.566308733546071*^9, 3.566308755165876*^9}, {
   3.566308889136335*^9, 3.5663089193570147`*^9}, {3.5663090288901978`*^9, 
   3.566309037949785*^9}, 3.566309082002984*^9, {3.566309133166436*^9, 
   3.5663091358829327`*^9}, {3.566309186526877*^9, 3.5663092090070457`*^9}, 
   3.566309516261615*^9, {3.566309629898693*^9, 3.5663096321855288`*^9}, {
   3.5663774770455503`*^9, 3.5663774801674423`*^9}, {3.566377517067107*^9, 
   3.566377587426165*^9}, {3.566377657492201*^9, 3.566377658921473*^9}, {
   3.566377749486884*^9, 3.5663777868913803`*^9}, {3.566377852443668*^9, 
   3.56637785481588*^9}, {3.566377899147768*^9, 3.566377917818173*^9}, {
   3.566377976832615*^9, 3.566377990498824*^9}, {3.566378080423018*^9, 
   3.56637814758615*^9}, {3.566378802852352*^9, 3.566378817362453*^9}, {
   3.5663794652049313`*^9, 3.5663794655266113`*^9}, {3.566379753677494*^9, 
   3.566379756487061*^9}, 3.566379902668301*^9, {3.566469406524246*^9, 
   3.566469433908721*^9}, {3.566903950818812*^9, 3.566903951229341*^9}, {
   3.566904028397936*^9, 3.566904028946813*^9}, {3.566905071140037*^9, 
   3.566905098518236*^9}, {3.5705613704722137`*^9, 3.570561375991653*^9}, {
   3.570884306578054*^9, 3.5708843260115767`*^9}, {3.572544284650556*^9, 
   3.572544287487486*^9}, 3.5776217018775053`*^9, {3.5826079798795347`*^9, 
   3.582607981047279*^9}, {3.582608026568942*^9, 3.582608037112817*^9}, {
   3.582608405824305*^9, 3.582608406675667*^9}, 3.58781773787671*^9, 
   3.5878181081729593`*^9, {3.592678964845249*^9, 3.592678966221348*^9}, 
   3.639308099862793*^9, {3.6394770105476017`*^9, 3.639477012838336*^9}, 
   3.63958663685343*^9, 3.6572150780913143`*^9, {3.65721511890431*^9, 
   3.657215181193636*^9}, 3.657219070222581*^9, {3.657222289321924*^9, 
   3.657222290202064*^9}, 3.661581672121952*^9, 3.680281472529955*^9, 
   3.680344797598826*^9, 3.6839577241557617`*^9, {3.699959614946802*^9, 
   3.6999596176468573`*^9}, {3.70109683106301*^9, 3.701096948044991*^9}, {
   3.7027819355428257`*^9, 3.7027819373981466`*^9}, {3.7027819761777177`*^9, 
   3.7027819797272415`*^9}, {3.702782017258924*^9, 3.702782019034217*^9}, {
   3.7027821651440673`*^9, 3.7027821749040365`*^9}, {3.7027823785678062`*^9, 
   3.702782378948077*^9}, 3.702782433711011*^9, {3.7027825751846175`*^9, 
   3.7027825861483912`*^9}, {3.702782649994813*^9, 3.7027826601009693`*^9}, {
   3.7027827601973147`*^9, 3.7027827664477806`*^9}, {3.702782845120716*^9, 
   3.702782854544416*^9}, {3.7027828890689316`*^9, 3.7027829173930783`*^9}, 
   3.7027829674286423`*^9, {3.7028103411808405`*^9, 3.7028103428868413`*^9}, 
   3.702810375820898*^9, {3.702810413211437*^9, 3.702810421470719*^9}, {
   3.702810481322624*^9, 3.702810481603901*^9}, {3.702814634753796*^9, 
   3.7028146700532565`*^9}, 3.7028155838911924`*^9, {3.7028157031305466`*^9, 
   3.7028157047969675`*^9}, {3.702815779873423*^9, 3.70281578237808*^9}, 
   3.709375555025486*^9, 3.7136374564014397`*^9},
 CellLabel->
  "In[2194]:=",ExpressionUUID->"ca64fdf5-9245-4603-83b6-9639dc08c402"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["initial density operator", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, {
   3.699957885713748*^9, 
   3.6999579106103067`*^9}},ExpressionUUID->"4e335592-c4fc-4462-ac5f-\
91722b3cc044"],

Cell[CellGroupData[{

Cell["convert initial density operator to an Operator", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.505831864582645*^9, 3.505831871221332*^9}, {
   3.505831912842533*^9, 3.505831920120267*^9}, {3.513186793384747*^9, 
   3.513186798389885*^9}, 3.51318764447775*^9, {3.5321471983041477`*^9, 
   3.532147200003888*^9}},ExpressionUUID->"c81d1b3e-d510-4ebb-816c-\
4fe6f0b6071a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{"True", ",", "timing_", ",", "acqevents_", ",", "opts___Rule"}], 
     "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"InitialDensityOperator", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
      RowBox[{"Except", "[", "_Operator", "]"}]}], "]"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]0", ",", "\[Rho]0vec", ",", "opbasis", ",", "basis"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
       RowBox[{
       "True", ",", "timing", ",", "acqevents", ",", "\[IndentingNewLine]", 
        RowBox[{"Evaluate", "@", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"InitialDensityOperator", "\[Rule]", 
            RowBox[{"Operator", "[", 
             RowBox[{"\[Rho]0", ",", 
              RowBox[{"ZeemanBasis", "[", "]"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Sequence", "@@", 
               RowBox[{"FilterRules", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"CheckOperatorType", "\[Rule]", "False"}], ",", 
                   "opts"}], "}"}], ",", 
                 RowBox[{"Options", "[", "Operator", "]"}]}], "]"}]}]}], 
             "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
           "opts"}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
       "]"}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505831667958248*^9, 3.505831748490183*^9}, {
   3.505832309441513*^9, 3.505832312941794*^9}, {3.505832599922316*^9, 
   3.505832740073543*^9}, {3.506250210416719*^9, 3.506250237611433*^9}, {
   3.513186469192401*^9, 3.513186469829424*^9}, 3.51318681605831*^9, 
   3.513187651452241*^9, {3.532147304855291*^9, 3.532147439537492*^9}, {
   3.532149329896896*^9, 3.532149338319561*^9}, 3.532149372569627*^9, {
   3.533181425525577*^9, 3.533181430442663*^9}, {3.533182504670869*^9, 
   3.5331825131288147`*^9}, {3.5659827691398582`*^9, 3.565982782116868*^9}, {
   3.5659830268451757`*^9, 3.5659830434887037`*^9}, {3.5659830820186157`*^9, 
   3.56598308349586*^9}, 3.5659838988626003`*^9, 3.6184039837849693`*^9, 
   3.618404028231964*^9, {3.618480923911574*^9, 3.6184809991430187`*^9}, 
   3.618485751950809*^9, 3.618485814320808*^9, {3.699543683122245*^9, 
   3.6995437105638285`*^9}, {3.699543897851222*^9, 3.6995439024443913`*^9}, {
   3.6995439475325623`*^9, 3.699543947873602*^9}, {3.6995440913626137`*^9, 
   3.6995440975835285`*^9}, {3.6995441636725135`*^9, 3.699544163910169*^9}, {
   3.699544238338408*^9, 3.699544244690833*^9}, {3.699544291911933*^9, 
   3.6995443148411703`*^9}, {3.6995446345330815`*^9, 3.699544636765685*^9}, {
   3.6995448209907894`*^9, 3.699544822105002*^9}, {3.699544856660718*^9, 
   3.6995448878803053`*^9}, {3.699544938301976*^9, 3.6995449433501616`*^9}, {
   3.6999596180955772`*^9, 3.6999596194796953`*^9}, {3.701097110388341*^9, 
   3.701097192211336*^9}, 3.701097412697047*^9, {3.709549443696224*^9, 
   3.7095494472504706`*^9}, {3.709549533174879*^9, 3.7095495333152256`*^9}},
 CellLabel->
  "In[2195]:=",ExpressionUUID->"92213e89-fef5-4cc1-a324-6251833ae81e"]
}, Closed]],

Cell[CellGroupData[{

Cell["implement Preparation if not already done", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.513231134227606*^9, 3.513231139299225*^9}, {
  3.565971566329623*^9, 
  3.565971569207515*^9}},ExpressionUUID->"1ba9e7a4-c579-4bdc-89a2-\
0a35a478a93c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{"True", ",", 
      RowBox[{"timing", ":", 
       RowBox[{"{", 
        RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}]}], ",", 
      "acqevents_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"!", 
     RowBox[{"MatchQ", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Preparation", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
       RowBox[{"None", "|", 
        RowBox[{"EventSpecifications", "@", 
         RowBox[{"UnitySuperoperator", "[", "]"}]}]}]}], "]"}]}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\[Rho]ini", ",", "prepseq", ",", "Qobs", ",", "tvals", ",", 
       "prepbackg", ",", "detbackg", ",", "traj", ",", "norm", ",", 
       "\[Rho]afterprep", ",", "opbasis", ",", "basis"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]ini", ",", "opbasis", ",", "basis"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "InitialDensityOperator", ",", "OperatorBasis", ",", "Basis"}], 
           "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"prepseq", "=", 
        RowBox[{
         RowBox[{"Preparation", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"detbackg", ",", "prepbackg"}], "}"}], "=", 
        RowBox[{"ReleaseHold", "[", 
         RowBox[{
          RowBox[{"BackgroundGenerator", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Rho]afterprep", "=", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"NPropagate", "[", "\[IndentingNewLine]", 
          RowBox[{"prepseq", ",", "\[IndentingNewLine]", 
           RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"InitialTimePoint", "\[Rule]", "Automatic"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"FinalTimePoint", "\[Rule]", "tmin"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"BackgroundGenerator", "\[Rule]", "prepbackg"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Continuous", "\[Rule]", "False"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"OperatorBasis", "\[Rule]", "opbasis"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Basis", "\[Rule]", "basis"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Sequence", "@@", 
              RowBox[{"FilterRules", "[", 
               RowBox[{
                RowBox[{"{", "opts", "}"}], ",", 
                RowBox[{"Options", "[", "NPropagate", "]"}]}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Sequence", "@@", 
              RowBox[{"CurrentOptionsToPassDown", "[", 
               RowBox[{"Signal1D", ",", "NPropagate"}], "]"}]}]}], 
            "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], "[",
          "\[Rho]ini", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Signal1D", "[", "\[IndentingNewLine]", 
        RowBox[{
        "True", ",", "timing", ",", "acqevents", ",", "\[IndentingNewLine]", 
         RowBox[{"Evaluate", "@", 
          RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"InitialDensityOperator", "\[Rule]", "\[Rho]afterprep"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"Preparation", "\[Rule]", "None"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"OperatorBasis", "\[Rule]", "opbasis"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Basis", "\[Rule]", "basis"}], ",", "\[IndentingNewLine]",
             "opts"}], "\[IndentingNewLine]", "]"}]}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.46987864414359*^9, 3.469878827111032*^9}, {
   3.469878858496944*^9, 3.469878952701845*^9}, {3.4698791736757936`*^9, 
   3.469879262476729*^9}, {3.469879398093581*^9, 3.469879414211699*^9}, {
   3.469879475026143*^9, 3.4698794796182117`*^9}, {3.469881934633746*^9, 
   3.469881993596458*^9}, {3.469883211956971*^9, 3.469883241469263*^9}, {
   3.469883781032305*^9, 3.469883794862007*^9}, {3.469884303383265*^9, 
   3.469884343812602*^9}, {3.469894812375486*^9, 3.469894875600522*^9}, {
   3.469894994885296*^9, 3.4698950754070473`*^9}, 3.469895605038212*^9, {
   3.469896201444419*^9, 3.469896221003875*^9}, 3.4699620444991703`*^9, 
   3.470139110046466*^9, 3.470141281091852*^9, {3.470817972968492*^9, 
   3.470817985856023*^9}, {3.497362024261635*^9, 3.497362101049741*^9}, {
   3.497364515291769*^9, 3.497364516073038*^9}, {3.497572564667365*^9, 
   3.4975725667166224`*^9}, 3.499326824220335*^9, {3.499327484958603*^9, 
   3.499327496381454*^9}, {3.499327547053383*^9, 3.499327563379311*^9}, {
   3.49955893159127*^9, 3.499558937067727*^9}, 3.499561109525261*^9, {
   3.502002385614365*^9, 3.5020024503256187`*^9}, {3.502622535479453*^9, 
   3.502622537862336*^9}, {3.502622600551457*^9, 3.5026226499919043`*^9}, {
   3.502622683447212*^9, 3.5026227072500896`*^9}, {3.5057263119325457`*^9, 
   3.505726342822915*^9}, {3.505830873691154*^9, 3.505830896575211*^9}, {
   3.505830929382745*^9, 3.505831086193581*^9}, {3.5058311229199343`*^9, 
   3.505831140943446*^9}, {3.5058314465147247`*^9, 3.5058314570156717`*^9}, {
   3.5058317860344477`*^9, 3.5058318072772923`*^9}, {3.505831838032158*^9, 
   3.505831850303075*^9}, 3.505832319765359*^9, {3.508355611996072*^9, 
   3.508355621443553*^9}, 3.513186823676083*^9, 3.5144533582147703`*^9, {
   3.514453448179607*^9, 3.514453478385446*^9}, {3.533248810455819*^9, 
   3.53324881622932*^9}, {3.542732033379133*^9, 3.5427320342953043`*^9}, 
   3.5427323263787413`*^9, {3.5427331530669537`*^9, 3.542733167889331*^9}, {
   3.545060820848333*^9, 3.545060836949592*^9}, 3.545060869955489*^9, {
   3.554960898503819*^9, 3.554960916117958*^9}, {3.554961055101056*^9, 
   3.554961076004197*^9}, 3.555070294072214*^9, {3.555070337525429*^9, 
   3.555070339741012*^9}, {3.5557328971728897`*^9, 3.555732971991981*^9}, {
   3.555733080785727*^9, 3.5557332054468203`*^9}, {3.5557332423818007`*^9, 
   3.555733244226872*^9}, {3.555733424384098*^9, 3.5557334292751513`*^9}, {
   3.555734013035139*^9, 3.555734013281097*^9}, {3.555734913081609*^9, 
   3.5557349133025637`*^9}, 3.555734957564869*^9, {3.555735223835086*^9, 
   3.555735226921788*^9}, 3.5627593723992367`*^9, {3.565958430588999*^9, 
   3.5659584709708548`*^9}, 3.565958549896799*^9, {3.569521213369174*^9, 
   3.569521223046611*^9}, {3.569521281105363*^9, 3.56952128645551*^9}, {
   3.56952140404388*^9, 3.5695214106488037`*^9}, {3.569521810781901*^9, 
   3.569521813698875*^9}, {3.587814483371922*^9, 3.587814534798786*^9}, {
   3.5878147372731867`*^9, 3.5878147442137947`*^9}, 3.587815629153205*^9, {
   3.587817751316066*^9, 3.5878177614000397`*^9}, {3.587818123317914*^9, 
   3.587818145171337*^9}, {3.587819659053692*^9, 3.5878196626226807`*^9}, 
   3.587819796610908*^9, {3.593002550927794*^9, 3.5930025529580727`*^9}, 
   3.593002950220263*^9, 3.6809568080163383`*^9, {3.683957724168416*^9, 
   3.6839577241712*^9}, {3.6995431150657597`*^9, 3.6995431169737916`*^9}, {
   3.6995432197530107`*^9, 3.6995432199226613`*^9}, {3.6995437642650676`*^9, 
   3.6995437948548403`*^9}, {3.699543957790526*^9, 3.699543960645002*^9}, {
   3.699544234730753*^9, 3.6995442349244213`*^9}, {3.6999596199409122`*^9, 
   3.6999596230800257`*^9}, {3.7010972193299437`*^9, 3.701097310737091*^9}, {
   3.709375555034523*^9, 3.7093755550380383`*^9}, {3.7095493603053665`*^9, 
   3.709549364068597*^9}, {3.709549402080973*^9, 3.7095494022470183`*^9}, 
   3.71363745642646*^9, {3.718527810919695*^9, 3.718527818344984*^9}, {
   3.7185280181557956`*^9, 3.7185280204971247`*^9}, {3.7191689358968153`*^9, 
   3.719168960339259*^9}},
 CellLabel->
  "In[2196]:=",ExpressionUUID->"684a2dbc-b90c-4378-bd5d-690662e2a01d"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["main Signal calculation", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, {
   3.699957885713748*^9, 
   3.699957927360552*^9}},ExpressionUUID->"39bee82a-ab5c-45e4-a162-\
13632ad786a3"],

Cell[CellGroupData[{

Cell["\<\
SignalCalculationMethod\[Rule]\"Direct\"(fully general; uses a Trajectory \
function running through the whole evolution)\
\>", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469877652562336*^9, 
   3.469877654440535*^9}, {3.4698786125145903`*^9, 3.4698786191211853`*^9}, {
   3.469883247163637*^9, 3.469883260409108*^9}, {3.469905503943878*^9, 
   3.4699055057551394`*^9}, {3.4699621499651947`*^9, 3.469962157017393*^9}, {
   3.470137455408881*^9, 3.4701374577903767`*^9}, 
   3.470139107379881*^9},ExpressionUUID->"9d66feb9-0d2b-4607-9c08-\
2f56558c0c8e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{"True", ",", "timing_", ",", "acqevents_", ",", "opts___Rule"}], 
     "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"SignalCalculationMethod", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", "\"\<Direct\>\""}],
        "]"}], "&&", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"EnsembleAverage", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
        RowBox[{"False", "|", "None"}]}], "]"}], "&&", "\[IndentingNewLine]", 
      
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Preparation", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
        RowBox[{"None", "|", 
         RowBox[{"EventSpecifications", "@", 
          RowBox[{"UnitySuperoperator", "[", "]"}]}]}]}], "]"}], "&&", 
      "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"InitialDensityOperator", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", "_Operator"}], 
       "]"}]}], "\[IndentingNewLine]", ")"}]}], ":=", 
   RowBox[{"Signal1DCore", "[", 
    RowBox[{"\"\<Direct\>\"", ",", "timing", ",", "acqevents", ",", "opts"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.506249453091873*^9, 3.5062503151897573`*^9, 3.5131867841668463`*^9, {
   3.513190418064509*^9, 3.513190433568109*^9}, {3.514453501713839*^9, 
   3.514453511013501*^9}, 3.5150662444971533`*^9, 3.515066311104985*^9, 
   3.515066691359253*^9, 3.5150667246961527`*^9, {3.53214746544799*^9, 
   3.532147468364221*^9}, 3.533177376470624*^9, 3.5331810667863503`*^9, 
   3.5331815185546217`*^9, 3.562153197637459*^9, {3.562153958961903*^9, 
   3.56215395953554*^9}, {3.587818163144045*^9, 3.587818164183806*^9}, 
   3.680956808678896*^9, 3.683957724180523*^9, {3.699544407561489*^9, 
   3.6995444132707944`*^9}, {3.6995446126772923`*^9, 
   3.6995446149783025`*^9}, {3.699959623529208*^9, 3.699959626634782*^9}, {
   3.701097580172915*^9, 3.7010976588700743`*^9}, {3.7011014798592443`*^9, 
   3.701101480264221*^9}},
 CellLabel->
  "In[2197]:=",ExpressionUUID->"bcd77bbb-0873-47d5-83b4-76d9ad8d8528"],

Cell[CellGroupData[{

Cell["Signal1DCore", "Subsubsection",
 CellChangeTimes->{{3.7011037702229156`*^9, 
  3.701103781922637*^9}},ExpressionUUID->"94280f7d-fa4c-4342-9221-\
8cd90a7e071c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1DCore", "[", 
    RowBox[{"\"\<Direct\>\"", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"tmin_", "?", "NumericQ"}], ",", 
       RowBox[{"tmax_", "?", "NumericQ"}], ",", 
       RowBox[{"\[Delta]t_", "?", "NumericQ"}]}], "}"}], ",", 
     "events_EventSpecifications", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\[Rho]ini", ",", "Qobs", ",", "tvals", ",", "prepbackg", ",", 
       "detbackg", ",", "traj", ",", "norm", ",", "opbasis", ",", "basis"}], 
      "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]ini", ",", "opbasis", ",", "basis", ",", "Qobs"}], 
         "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "InitialDensityOperator", ",", "OperatorBasis", ",", "Basis", ",", 
            "Observable"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"detbackg", ",", "prepbackg"}], "}"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Which", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"MatchQ", "[", 
             RowBox[{"#", ",", 
              RowBox[{"_", "?", "OperatorQ"}]}], "]"}], ",", 
            RowBox[{"NDiagonalize", "[", 
             RowBox[{"#", ",", "basis"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"MatchQ", "[", 
             RowBox[{"#", ",", 
              RowBox[{"_", "?", "SuperoperatorQ"}]}], "]"}], ",", 
            RowBox[{"NDiagonalize", "[", 
             RowBox[{"#", ",", "opbasis", ",", "basis"}], "]"}], ",", 
            "\[IndentingNewLine]", "True", ",", "#"}], "\[IndentingNewLine]", 
           "]"}], "&"}], "@", "\[IndentingNewLine]", 
         RowBox[{"(", 
          RowBox[{"ReleaseHold", "[", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}], ")"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"tvals", "=", 
        RowBox[{"Range", "[", 
         RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"traj", "=", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Trajectory", "[", "\[IndentingNewLine]", 
          RowBox[{
          "Qobs", ",", "\[IndentingNewLine]", "events", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Evaluate", "@", 
            RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"BackgroundGenerator", "\[Rule]", "detbackg"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"InitialTimePoint", "\[Rule]", "tmin"}], ",", 
              "\[IndentingNewLine]", "opts", ",", "\[IndentingNewLine]", 
              RowBox[{"NormalizationFactor", "\[Rule]", 
               RowBox[{"norm", "\[Times]", 
                RowBox[{
                 RowBox[{"OperatorNorm", "[", "Qobs", "]"}], "^", "2"}]}]}], 
              ",", "\[IndentingNewLine]", 
              RowBox[{"Sequence", "@@", 
               RowBox[{"CurrentOptionsToPassDown", "[", 
                RowBox[{"Signal1D", ",", "Trajectory"}], "]"}]}]}], 
             "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}], 
         "[", "\[Rho]ini", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Signal", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "}"}], ",", 
         RowBox[{"traj", "/@", "tvals"}], ",", "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", "opts", "}"}], ",", 
               RowBox[{"Options", "@", "Signal1D"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Options", "[", "Signal", "]"}]}], "\[IndentingNewLine]",
             "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.46987864414359*^9, 3.469878827111032*^9}, {
   3.469878858496944*^9, 3.469878952701845*^9}, {3.4698791736757936`*^9, 
   3.469879262476729*^9}, {3.469879398093581*^9, 3.469879414211699*^9}, {
   3.469879475026143*^9, 3.4698794796182117`*^9}, {3.469881934633746*^9, 
   3.469881993596458*^9}, {3.469883211956971*^9, 3.469883241469263*^9}, {
   3.469883781032305*^9, 3.469883794862007*^9}, {3.469884303383265*^9, 
   3.469884343812602*^9}, {3.469894812375486*^9, 3.469894875600522*^9}, {
   3.469894994885296*^9, 3.4698950754070473`*^9}, 3.469895605038212*^9, {
   3.469896201444419*^9, 3.469896221003875*^9}, 3.4699620444991703`*^9, 
   3.470139110046466*^9, 3.470141281091852*^9, {3.470817972968492*^9, 
   3.470817985856023*^9}, {3.497362024261635*^9, 3.497362101049741*^9}, {
   3.497364515291769*^9, 3.497364516073038*^9}, {3.497572564667365*^9, 
   3.4975725667166224`*^9}, 3.499326824220335*^9, {3.499327484958603*^9, 
   3.499327496381454*^9}, {3.499327547053383*^9, 3.499327563379311*^9}, {
   3.49955893159127*^9, 3.499558937067727*^9}, 3.499561109525261*^9, {
   3.502002385614365*^9, 3.5020024503256187`*^9}, {3.502622535479453*^9, 
   3.502622537862336*^9}, {3.502622600551457*^9, 3.5026226499919043`*^9}, {
   3.502622683447212*^9, 3.5026227072500896`*^9}, {3.5057263119325457`*^9, 
   3.505726342822915*^9}, {3.505831170813334*^9, 3.5058311973670607`*^9}, 
   3.5058318339270267`*^9, {3.505835554365243*^9, 3.505835557906418*^9}, {
   3.505932259178569*^9, 3.5059322927923822`*^9}, {3.505932336076049*^9, 
   3.5059323429860897`*^9}, {3.505994838558855*^9, 3.505994887151846*^9}, {
   3.506249464019321*^9, 3.506249467806459*^9}, {3.5131867446784143`*^9, 
   3.5131867475151787`*^9}, {3.5131871025076857`*^9, 3.5131871043847*^9}, 
   3.5144535208789797`*^9, 3.515066757704598*^9, 3.515066830517846*^9, 
   3.515068055151009*^9, {3.5331773797939043`*^9, 3.533177400717168*^9}, {
   3.533248854511065*^9, 3.5332488610117817`*^9}, {3.542732057817855*^9, 
   3.5427320588765383`*^9}, {3.5427332991346483`*^9, 3.542733303803334*^9}, 
   3.544622212600161*^9, {3.544964944735547*^9, 3.544964952476472*^9}, {
   3.5450596898304167`*^9, 3.5450598310247307`*^9}, 3.5450607045363693`*^9, {
   3.562206890191905*^9, 3.562206898062989*^9}, {3.5737436767217913`*^9, 
   3.5737436806693583`*^9}, {3.573743753719308*^9, 3.573743760713028*^9}, 
   3.57374452457743*^9, {3.587647062570912*^9, 3.587647133505166*^9}, {
   3.587647163553349*^9, 3.587647197027473*^9}, {3.587648241298697*^9, 
   3.587648252012389*^9}, 3.587814173872335*^9, {3.587817795975718*^9, 
   3.5878178157347393`*^9}, {3.5878183063036623`*^9, 
   3.5878183071254883`*^9}, {3.626027765808894*^9, 3.62602776679255*^9}, {
   3.629103231136282*^9, 3.629103280772077*^9}, 3.683957724191834*^9, {
   3.699543815432638*^9, 3.6995438448648744`*^9}, {3.699959627040037*^9, 
   3.6999596297402782`*^9}, {3.701097668273036*^9, 3.701097713567376*^9}, {
   3.701101485290544*^9, 3.701101489978023*^9}, {3.701101561276627*^9, 
   3.701101561543195*^9}, {3.7027697674292097`*^9, 3.702769792477189*^9}, {
   3.7027698659937506`*^9, 3.702769873243931*^9}, {3.702770504601003*^9, 
   3.7027705212948933`*^9}, {3.702770570261792*^9, 3.702770578045684*^9}, {
   3.7027706172045236`*^9, 3.7027706207880774`*^9}, {3.702810144515803*^9, 
   3.702810147226771*^9}, 3.702810220014891*^9, {3.702810259032714*^9, 
   3.7028102591828976`*^9}, {3.7093755550457153`*^9, 3.709375555049148*^9}, 
   3.7136374564494934`*^9},
 CellLabel->
  "In[2198]:=",ExpressionUUID->"ef7579ce-8ad9-4163-b1ed-7cff978019b3"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SignalCalculationMethod\[Rule]\"Diagonalization\"", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469877652562336*^9, 
   3.469877654440535*^9}, {3.4698786125145903`*^9, 3.4698786191211853`*^9}, {
   3.469883247163637*^9, 3.469883260409108*^9}, {3.469905503943878*^9, 
   3.4699055057551394`*^9}, {3.4699621499651947`*^9, 3.469962157017393*^9}, {
   3.470137445264617*^9, 3.470137477023409*^9}, 3.470139111492014*^9, {
   3.4701432784148397`*^9, 3.47014328556489*^9}, {3.470385972092572*^9, 
   3.4703859723964*^9}, 
   3.701101849076969*^9},ExpressionUUID->"5ffb0068-5b78-4179-ae7e-\
b5d5b6f93f87"],

Cell["propagation over a single time-independent generator", "Text",
 CellChangeTimes->{{3.70110185289501*^9, 
  3.70110188199165*^9}},ExpressionUUID->"2ddfda02-8d3d-4f5e-a090-\
9d526ddf17f9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{"True", ",", "timing_", ",", "acqevents_", ",", "opts___Rule"}], 
     "]"}], "/;", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"MatchQ", "[", 
       RowBox[{"acqevents", ",", 
        RowBox[{"EventSpecifications", "[", 
         RowBox[{"True", ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"evgen_", ",", "T_"}], "}"}], "}"}], ",", "___Rule"}], 
         "]"}]}], "]"}], "&&", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"SignalCalculationMethod", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
        "\"\<Diagonalization\>\""}], "]"}], "&&", "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"EnsembleAverage", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
        RowBox[{"False", "|", "None"}]}], "]"}], "&&", "\[IndentingNewLine]", 
      
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Preparation", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
        RowBox[{"None", "|", 
         RowBox[{"EventSpecifications", "@", 
          RowBox[{"UnitySuperoperator", "[", "]"}]}]}]}], "]"}], "&&", 
      "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"InitialDensityOperator", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", "_Operator"}], 
       "]"}]}], "\[IndentingNewLine]", ")"}]}], ":=", 
   RowBox[{"Signal1DCore", "[", 
    RowBox[{
    "\"\<Diagonalization\>\"", ",", "timing", ",", "acqevents", ",", "opts"}],
     "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.506261007346991*^9, 3.506261023717424*^9}, 
   3.50626148665802*^9, 3.51318676177748*^9, 3.5131904563883457`*^9, {
   3.5144536511114492`*^9, 3.51445373934597*^9}, {3.53214752211334*^9, 
   3.532147525990506*^9}, 3.5331774057237787`*^9, 3.533181625668559*^9, {
   3.5331824811759157`*^9, 3.5331824814938087`*^9}, {3.533248891170396*^9, 
   3.533248894625785*^9}, {3.587818197611106*^9, 3.587818198651884*^9}, {
   3.587818943438046*^9, 3.5878189473751097`*^9}, 3.6184039305565777`*^9, 
   3.618403967289312*^9, 3.6184782178805437`*^9, 3.618478947119698*^9, 
   3.680956811052957*^9, 3.683957724212028*^9, {3.699959632620041*^9, 
   3.699959635702359*^9}, {3.70110137241394*^9, 3.7011014629454412`*^9}, {
   3.7011015032951937`*^9, 3.7011015037235813`*^9}, 3.701101831503269*^9, {
   3.701102965209649*^9, 3.701103004754841*^9}},
 CellLabel->
  "In[2199]:=",ExpressionUUID->"ab7a0dad-adaa-4904-9fdb-79336bfe7d31"],

Cell[CellGroupData[{

Cell["Signal1DCore", "Subsubsection",
 CellChangeTimes->{{3.7011037702229156`*^9, 
  3.701103781922637*^9}},ExpressionUUID->"27b34cab-b069-432c-8a7d-\
c09ca682fede"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"HoldPattern", "@", 
    RowBox[{"Signal1DCore", "[", 
     RowBox[{"\"\<Diagonalization\>\"", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"tmin_", "?", "NumericQ"}], ",", 
        RowBox[{"tmax_", "?", "NumericQ"}], ",", 
        RowBox[{"\[Delta]t_", "?", "NumericQ"}]}], "}"}], ",", 
      RowBox[{"acqevents", ":", 
       RowBox[{"EventSpecifications", "[", 
        RowBox[{"True", ",", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"evgen_", ",", "T_"}], "}"}], "}"}], ",", "___Rule"}], 
        "]"}]}], ",", "opts___Rule"}], "]"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\[Rho]0", ",", "Qobs", ",", "prepbackg", ",", "detbackg", ",", 
       "opbasis", ",", "basis", ",", "norm", ",", "tvals", ",", "X", ",", 
       "evals", ",", "Xinv", ",", "Qobsvec", ",", "QobsadjX", ",", 
       "Xinv\[Rho]", ",", "\[Rho]0vec", ",", "avals", ",", "\[Omega]vals", 
       ",", "\[Lambda]vals", ",", "blub"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Rho]0", ",", "Qobs", ",", 
          RowBox[{"{", 
           RowBox[{"detbackg", ",", "prepbackg"}], "}"}], ",", "opbasis", ",",
           "basis", ",", "norm"}], "}"}], "=", 
        RowBox[{"ReleaseHold", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "InitialDensityOperator", ",", "Observable", ",", 
             "BackgroundGenerator", ",", "OperatorBasis", ",", "Basis", ",", 
             "NormalizationFactor"}], "}"}], "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"opbasis", "=", 
        RowBox[{
         RowBox[{"OperatorBasis", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"basis", "=", 
        RowBox[{
         RowBox[{"Basis", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"norm", "=", 
        RowBox[{
         RowBox[{"NormalizationFactor", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"tvals", "=", 
        RowBox[{"Range", "[", 
         RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], "=", 
        RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
         RowBox[{
         "SuperoperatorMatrixRepresentation", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Liouvillian", "[", 
            RowBox[{"evgen", ",", "detbackg"}], "]"}], ",", 
           "\[IndentingNewLine]", "opbasis", ",", "basis", ",", "opts"}], 
          "\[IndentingNewLine]", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Rho]0vec", "=", 
        RowBox[{"OperatorVectorRepresentation", "[", 
         RowBox[{"\[Rho]0", ",", "opbasis", ",", "basis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Qobsvec", "=", 
        RowBox[{"OperatorVectorRepresentation", "[", 
         RowBox[{"Qobs", ",", "opbasis", ",", "basis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"QobsadjX", "=", 
        RowBox[{
         RowBox[{"Conjugate", "[", "Qobsvec", "]"}], ".", "X"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Xinv\[Rho]", "=", 
        RowBox[{"Xinv", ".", "\[Rho]0vec"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"avals", "=", 
        RowBox[{
         RowBox[{"Chop", "@", 
          RowBox[{"MapThread", "[", 
           RowBox[{"Times", ",", 
            RowBox[{"{", 
             RowBox[{"QobsadjX", ",", "Xinv\[Rho]"}], "}"}]}], "]"}]}], "/", 
         RowBox[{"(", 
          RowBox[{"norm", "\[Times]", 
           RowBox[{
            RowBox[{"Norm", "[", "Qobsvec", "]"}], "^", "2"}]}], ")"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"\[Omega]vals", "=", 
        RowBox[{"Im", "[", "evals", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Lambda]vals", "=", 
        RowBox[{"-", 
         RowBox[{"Re", "[", "evals", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Signal", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"\"\<Lorentzian\>\"", ",", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"avals", ",", "\[Omega]vals", ",", "\[Lambda]vals"}], 
             "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", "opts", "}"}], ",", 
               RowBox[{"Options", "@", "Signal1D"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Options", "[", "Signal", "]"}]}], "\[IndentingNewLine]",
             "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.470137520994417*^9, 3.470137644665415*^9}, {
   3.470137717035119*^9, 3.4701377959254723`*^9}, {3.4701378684334717`*^9, 
   3.4701378704871607`*^9}, 3.470137959340438*^9, {3.470138075766912*^9, 
   3.470138097663471*^9}, {3.470138362810503*^9, 3.47013837352169*^9}, {
   3.470138433165674*^9, 3.470138710638435*^9}, 3.470139114342375*^9, {
   3.470139615957039*^9, 3.470139640635371*^9}, 3.4701406458684483`*^9, {
   3.4701411697001143`*^9, 3.470141184956568*^9}, {3.470142659329577*^9, 
   3.4701426614324207`*^9}, {3.470143363595736*^9, 3.4701433640408916`*^9}, {
   3.470143420710148*^9, 3.4701434238208237`*^9}, {3.470385760817987*^9, 
   3.4703857684396687`*^9}, 3.470386811979693*^9, {3.470386902736025*^9, 
   3.470386936367881*^9}, {3.470387030253839*^9, 3.4703870776609173`*^9}, {
   3.470812973995502*^9, 3.4708130100010147`*^9}, {3.4973621292680883`*^9, 
   3.4973622006518917`*^9}, {3.497572571731102*^9, 3.497572573832383*^9}, 
   3.499326862106921*^9, {3.499328192148817*^9, 3.499328205947485*^9}, {
   3.4993727654112253`*^9, 3.4993727707678537`*^9}, {3.500258371448064*^9, 
   3.500258382854746*^9}, {3.500258721693925*^9, 3.500258748152707*^9}, {
   3.500258891913836*^9, 3.500259031960477*^9}, 3.502002520823659*^9, {
   3.5020029650901117`*^9, 3.502003011257348*^9}, {3.5025169763621397`*^9, 
   3.502517017001236*^9}, {3.502617237508003*^9, 3.5026172378490973`*^9}, {
   3.502621148677164*^9, 3.502621150144964*^9}, {3.5026218113806963`*^9, 
   3.5026218192579393`*^9}, {3.502621863294573*^9, 3.5026219171249437`*^9}, {
   3.502622357434853*^9, 3.502622361882657*^9}, 3.5027105598420563`*^9, 
   3.504458715045247*^9, {3.5044606851831703`*^9, 3.5044606942208242`*^9}, {
   3.5046342213457117`*^9, 3.504634229752417*^9}, 3.504635175450129*^9, {
   3.5050231362160463`*^9, 3.505023140155604*^9}, 3.505026448926552*^9, {
   3.50572643202527*^9, 3.50572648074986*^9}, {3.505831233663561*^9, 
   3.5058312706084023`*^9}, {3.505831962214993*^9, 3.505831984711574*^9}, {
   3.505835572551667*^9, 3.505835576341373*^9}, {3.505895049120326*^9, 
   3.5058951632244473`*^9}, {3.505895196993277*^9, 3.50589519731133*^9}, {
   3.505932389484767*^9, 3.5059323969379997`*^9}, {3.505994907343341*^9, 
   3.505994916960463*^9}, 3.506261057724935*^9, 3.5131867598932962`*^9, 
   3.514453755272152*^9, {3.5144537907749567`*^9, 3.514453790916299*^9}, {
   3.5321475561589813`*^9, 3.532147597189444*^9}, {3.5321494655353727`*^9, 
   3.5321494792148857`*^9}, {3.532149509518746*^9, 3.532149660910762*^9}, {
   3.532149706768818*^9, 3.5321498985299683`*^9}, 3.532149940019533*^9, {
   3.5321499739598427`*^9, 3.532149975654749*^9}, {3.533177408140164*^9, 
   3.533177410288877*^9}, {3.533182341654181*^9, 3.533182341867138*^9}, {
   3.533252405026581*^9, 3.533252409791782*^9}, {3.533253758804571*^9, 
   3.5332537617788057`*^9}, {3.533343875391088*^9, 3.5333439023222113`*^9}, {
   3.534468680151836*^9, 3.53446869365874*^9}, 3.534468811643619*^9, {
   3.534468915607868*^9, 3.5344689243800097`*^9}, 3.534469378852303*^9, 
   3.534469745694181*^9, {3.534470430211906*^9, 3.534470446731703*^9}, 
   3.5446222138362827`*^9, {3.565972740045476*^9, 3.5659727448219624`*^9}, 
   3.565972877944803*^9, {3.565981321825156*^9, 3.565981333550353*^9}, {
   3.565982897440455*^9, 3.565982909104506*^9}, {3.5659838007352037`*^9, 
   3.565983803741824*^9}, 3.565983875782818*^9, {3.5834270124898577`*^9, 
   3.583427012807064*^9}, {3.586107026779842*^9, 3.5861070982873793`*^9}, {
   3.5861071908114634`*^9, 3.586107197853835*^9}, {3.5861072371614637`*^9, 
   3.5861073070527143`*^9}, 3.58619258403307*^9, {3.586351616692194*^9, 
   3.586351622070024*^9}, 3.587817843552651*^9, {3.587819037540539*^9, 
   3.5878190405380497`*^9}, 3.587819807332481*^9, {3.6183997336207743`*^9, 
   3.618399758665677*^9}, 3.618399831025362*^9, {3.618488623007895*^9, 
   3.6184886311772223`*^9}, {3.618488837288422*^9, 3.618488847174714*^9}, {
   3.61848971032753*^9, 3.6184897170062733`*^9}, 3.62910331998777*^9, {
   3.629116360514668*^9, 3.629116379619409*^9}, 3.629118368254341*^9, 
   3.683957724224749*^9, {3.699959636107973*^9, 3.699959639854238*^9}, {
   3.701101614173943*^9, 3.701101639099422*^9}, {3.701101755231647*^9, 
   3.701101823340398*^9}, {3.701102108618692*^9, 3.7011021687819033`*^9}, 
   3.7011024019783*^9, {3.7027723028342295`*^9, 3.7027723058193817`*^9}, {
   3.7027724367844954`*^9, 3.7027724485648494`*^9}, {3.702772481445217*^9, 
   3.702772489213772*^9}, {3.702772565857247*^9, 3.7027725854421597`*^9}, {
   3.702772617449913*^9, 3.7027727045578737`*^9}, {3.7027729041720705`*^9, 
   3.702772904521291*^9}, {3.7027731244656687`*^9, 3.7027731332959776`*^9}, {
   3.702773278292035*^9, 3.7027733607556834`*^9}, {3.702773509660041*^9, 
   3.7027735351121407`*^9}, {3.702773635444072*^9, 3.7027736715517683`*^9}, {
   3.702773786176524*^9, 3.7027738173610992`*^9}, {3.7027740233335934`*^9, 
   3.702774044727775*^9}, {3.7027741480304556`*^9, 3.7027741482086124`*^9}, {
   3.7027742467106133`*^9, 3.7027742554648685`*^9}, {3.702774405937886*^9, 
   3.7027744061360226`*^9}, {3.7027744790196133`*^9, 
   3.7027745461824408`*^9}, {3.7027746007222195`*^9, 3.702774630733552*^9}, {
   3.702774716033199*^9, 3.702774722988145*^9}, {3.7027747592269087`*^9, 
   3.702774761207346*^9}, {3.7027748174753513`*^9, 3.7027749303911314`*^9}, {
   3.7027750282993402`*^9, 3.702775119675332*^9}, {3.7027751875659394`*^9, 
   3.7027751919730444`*^9}, {3.7027752232052493`*^9, 
   3.7027752964103804`*^9}, {3.7027753818025312`*^9, 
   3.7027753873584523`*^9}, {3.702775665020539*^9, 3.7027756938810596`*^9}, {
   3.7027757386048546`*^9, 3.7027757678390055`*^9}, {3.7027758141180983`*^9, 
   3.7027758218486214`*^9}, {3.702775862791358*^9, 3.7027758648958673`*^9}, {
   3.702775898435711*^9, 3.702775898855009*^9}, {3.702775996217205*^9, 
   3.7027760000038953`*^9}, {3.7027760929609876`*^9, 
   3.7027760931301055`*^9}, {3.7027761436470222`*^9, 3.7027762003763547`*^9},
    {3.702776610560364*^9, 3.702776614276008*^9}, {3.7027793146082673`*^9, 
   3.7027793147783885`*^9}, {3.7028099282606163`*^9, 
   3.7028099670167565`*^9}, {3.702815787417449*^9, 3.7028157875527973`*^9}, 
   3.7093755550585527`*^9, 3.7136374564754925`*^9, {3.7185276669387617`*^9, 
   3.718527743652008*^9}, {3.719168810780783*^9, 3.719168812683588*^9}, {
   3.7191688443715787`*^9, 3.7191688445208993`*^9}},
 CellLabel->
  "In[2200]:=",ExpressionUUID->"fe5652ca-c4f3-4785-b679-6b9b3666ff40"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
SignalCalculationMethod\[Rule]\"COMPUTE\"(for time-dependent periodic \
calculations)\
\>", "Section",
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.4483607649589663`*^9, 3.448360776920339*^9}, {
   3.455107952027554*^9, 3.455107958728705*^9}, {3.46279631431157*^9, 
   3.462796315357738*^9}, {3.469877097913712*^9, 3.4698771006083603`*^9}, {
   3.4698774379827433`*^9, 3.469877440612029*^9}, {3.469877652562336*^9, 
   3.469877654440535*^9}, {3.4698786125145903`*^9, 3.4698786191211853`*^9}, {
   3.469883247163637*^9, 3.469883260409108*^9}, {3.469905503943878*^9, 
   3.4699055057551394`*^9}, {3.4699621499651947`*^9, 3.469962157017393*^9}, {
   3.470137445264617*^9, 3.470137477023409*^9}, 3.470139111492014*^9, {
   3.4701432784148397`*^9, 3.47014328556489*^9}, {3.470385972092572*^9, 
   3.4703859723964*^9}, {3.470652899881089*^9, 3.470652916709353*^9}, {
   3.470825607803694*^9, 3.470825609434436*^9}, {3.703005199409359*^9, 
   3.70300520082965*^9}},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"45c5f7d7-0776-4893-9d8f-19aeb01ca7f7"],

Cell[CellGroupData[{

Cell["pass to COMPUTE routines", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.504592770970264*^9, 3.5045927997448263`*^9}, {
  3.5045931322902403`*^9, 3.5045931397301617`*^9}, {3.5045932820463247`*^9, 
  3.504593300963689*^9}, {3.544028377121984*^9, 
  3.544028383624703*^9}},ExpressionUUID->"a5e471ed-d541-461c-a590-\
d19a8998eb7d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1D", "[", 
     RowBox[{"True", ",", "timing_", ",", "acqevents_", ",", "opts___Rule"}], 
     "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"SignalCalculationMethod", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
        "\"\<COMPUTE\>\""}], "]"}], "&&", "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"SignalGeneratorPeriod", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "]"}], "&&", "\[IndentingNewLine]", 
      
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"EnsembleAverage", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
        RowBox[{"False", "|", "None"}]}], "]"}], "&&", "\[IndentingNewLine]", 
      
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Preparation", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
        RowBox[{"None", "|", 
         RowBox[{"EventSpecifications", "@", 
          RowBox[{"UnitySuperoperator", "[", "]"}]}]}]}], "]"}], "&&", 
      "\[IndentingNewLine]", 
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"InitialDensityOperator", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", "_Operator"}], 
       "]"}]}], "\[IndentingNewLine]", ")"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Signal1DCore", "[", 
    RowBox[{
    "\"\<COMPUTE\>\"", ",", "timing", ",", "acqevents", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Evaluate", "@", 
      RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"BackgroundGenerator", "\[Rule]", 
         RowBox[{"HeldGeneratorSymbol", "[", 
          RowBox[{"First", "@", 
           RowBox[{"ReleaseHold", "[", 
            RowBox[{
             RowBox[{"BackgroundGenerator", "/.", 
              RowBox[{"{", "opts", "}"}]}], "/.", 
             RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], 
          "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
        "opts"}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.534762950197673*^9, 3.534763037295219*^9}, {
   3.53476307844836*^9, 3.534763326423648*^9}, {3.5347633983147697`*^9, 
   3.534763402928219*^9}, 3.534763437169344*^9, 3.534763523828374*^9, {
   3.5347635603230677`*^9, 3.5347635945185747`*^9}, {3.534820168589388*^9, 
   3.5348202411111813`*^9}, 3.5348203512535467`*^9, {3.5348204601038437`*^9, 
   3.5348205020442467`*^9}, 3.534822059991316*^9, {3.534823446642243*^9, 
   3.534823446991023*^9}, 3.5438530169987907`*^9, {3.5438533965537033`*^9, 
   3.5438534129538317`*^9}, 3.543894983141611*^9, {3.544028389918495*^9, 
   3.544028392010642*^9}, {3.544029382738974*^9, 3.5440294616999197`*^9}, 
   3.564586529117249*^9, 3.564589509310704*^9, {3.564590326233901*^9, 
   3.564590332126583*^9}, 3.564590432030417*^9, {3.587820215962639*^9, 
   3.5878202166359873`*^9}, {3.621573865069723*^9, 3.6215738694761887`*^9}, 
   3.6615005061573133`*^9, {3.661584599255319*^9, 3.661584599531911*^9}, {
   3.699959641282735*^9, 3.699959644567607*^9}, {3.701103822633453*^9, 
   3.701103932744137*^9}, 3.709374482504733*^9, {3.709375555066427*^9, 
   3.709375555069724*^9}},
 CellLabel->
  "In[2201]:=",ExpressionUUID->"5a2e8d5b-9528-41e5-930f-2713084b4d10"]
}, Closed]],

Cell[CellGroupData[{

Cell["COMPUTE and \[Gamma]-COMPUTE (for unitary propagators)", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.504592770970264*^9, 3.5045927997448263`*^9}, {
   3.5045931322902403`*^9, 3.5045931397301617`*^9}, {3.5045932820463247`*^9, 
   3.504593300963689*^9}, 3.5476458407065268`*^9},
 Background->RGBColor[
  1, 1, 0],ExpressionUUID->"a8f09e65-bfd0-4f78-90a7-f61e8d1a3107"],

Cell["\<\
see M. Ed\[EAcute]n, Y. K. Lee and M. H. Levitt, J. Magn. Reson. A 120, 56 \
(1996); M. H. Levitt and M. Ed\[EAcute]n, Mol. Phys. 95, 879-890 (1998); M. \
Hohwy, H. Bilds\[OSlash]e, H. J. Jakobsen and N. C. Nielsen, J. Magn. Reson. \
136, 6-14 (1999).\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.4708300918503313`*^9, 3.470830119064274*^9}, {
   3.470842480879712*^9, 3.470842489584428*^9}, 3.5045928049628773`*^9, {
   3.504593164977955*^9, 3.504593166234065*^9}, {3.504593317163864*^9, 
   3.504593337987323*^9}},ExpressionUUID->"87e40599-e79f-4888-ad71-\
9d1a8ecc7926"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1DCore", "[", 
    RowBox[{"\"\<COMPUTE\>\"", ",", 
     RowBox[{"{", 
      RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}], ",", 
     "acqevents_", ",", "opts___Rule"}], "]"}], "/;", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"UseHilbertSpaceWhenPossible", "/.", 
        RowBox[{"{", "opts", "}"}]}], "/.", 
       RowBox[{"Options", "[", "Signal1D", "]"}]}], ")"}], "&&", 
     "\[IndentingNewLine]", 
     RowBox[{"HilbertSpaceCompatibility", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"PeriodicDetectionEvents", "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
       "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "\[Rho]0", ",", "\[Rho]0mat", ",", "Qobs", ",", "Qadjmat", ",", 
      "opbasis", ",", "basis", ",", "T", ",", "n", ",", "nH", ",", 
      "dividedevents", ",", "Ajset", ",", "An", ",", "evals", ",", "evecs", 
      ",", "X", ",", "Xinv", ",", "norm", ",", "carav", ",", "perdetevents", 
      ",", "prepbackg", ",", "detbackg", ",", "\[Omega]rvec", ",", "AjXset", 
      ",", "QadjTjset", ",", "rspairs", ",", "\[Delta]rsk", ",", 
      "\[Epsilon]rsk", ",", "Ers", ",", "arsk", ",", "\[Rho]0Tjset", ",", 
      "\[Omega]rs", ",", "\[Omega]rsk", ",", "expmi\[Omega]j\[Tau]rs", ",", 
      "normCOMPUTE"}], "}"}], ",", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "\[Rho]0", ",", "Qobs", ",", "opbasis", ",", "basis", ",", "T", ",", 
         "norm", ",", "carav", ",", "perdetevents"}], "}"}], "=", 
       RowBox[{"ReleaseHold", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "InitialDensityOperator", ",", "Observable", ",", "OperatorBasis", 
            ",", "Basis", ",", "SignalGeneratorPeriod", ",", 
            "NormalizationFactor", ",", "CarouselAverage", ",", 
            "PeriodicDetectionEvents"}], "}"}], "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"nH", "=", 
       RowBox[{"BasisDimension", "[", "basis", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"normCOMPUTE", "=", 
       RowBox[{"norm", "\[Times]", 
        RowBox[{"Log", "[", 
         RowBox[{"2", ",", "nH"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"detbackg", "=", 
       RowBox[{"ReleaseHold", "[", 
        RowBox[{
         RowBox[{"BackgroundGenerator", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"n", "=", 
       RowBox[{"Max", "[", 
        RowBox[{"1", ",", 
         RowBox[{"Round", "[", 
          RowBox[{"T", "/", "\[Delta]t"}], "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Qadjmat", "=", 
       RowBox[{"ConjugateTranspose", "@", 
        RowBox[{"MatrixRepresentation", "[", 
         RowBox[{"Qobs", ",", "basis"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Rho]0mat", "=", 
       RowBox[{"MatrixRepresentation", "[", 
        RowBox[{"\[Rho]0", ",", "basis"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dividedevents", "=", 
       RowBox[{"DivideEventSpecifications", "[", 
        RowBox[{"perdetevents", ",", "n", ",", 
         RowBox[{"IncludeRepetitionNumbers", "\[Rule]", "True"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"Ajset", "=", 
       RowBox[{"DividedEventPropagators", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Operator", ",", "T", ",", "n"}], "}"}], ",", 
         "\[IndentingNewLine]", "dividedevents", ",", "\[IndentingNewLine]", 
         "opbasis", ",", "basis", ",", "\[IndentingNewLine]", 
         RowBox[{"InitialTimePoint", "\[Rule]", "tmin"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"BackgroundGenerator", "\[Rule]", "detbackg"}], ",", 
         "opts"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"An", "=", 
       RowBox[{"Last", "@", "Ajset"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], "=", 
       RowBox[{"NDiagonalize", "[", 
        RowBox[{"An", ",", 
         RowBox[{"Assumptions", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"OrthogonalEigenvectors", "\[Rule]", "True"}], "}"}]}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Omega]rvec", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "I"}], " ", "T"}], ")"}], "^", 
         RowBox[{"-", "1"}]}], " ", 
        RowBox[{"Log", "/@", "evals"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"AjXset", "=", 
       RowBox[{"Chop", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"#", ".", "X"}], ")"}], "&"}], "/@", 
         RowBox[{"Most", "[", "Ajset", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"QadjTjset", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Chop", "[", 
          RowBox[{
           RowBox[{"ConjugateTranspose", "[", "#", "]"}], ".", "Qadjmat", ".",
            "#"}], "]"}], "&"}], "/@", "AjXset"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"rspairs", "=", 
       RowBox[{"Union", "[", 
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"First", "/@", 
              RowBox[{"Most", "@", 
               RowBox[{"ArrayRules", "[", "#", "]"}]}]}], ")"}], "&"}], "/@", 
           "QadjTjset"}], ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", "rspairs", "]"}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"\[Omega]rs", "=", 
       RowBox[{"Chop", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Omega]rvec", "\[LeftDoubleBracket]", 
             RowBox[{"First", "[", "#", "]"}], "\[RightDoubleBracket]"}], "-", 
            RowBox[{"\[Omega]rvec", "\[LeftDoubleBracket]", 
             RowBox[{"Last", "[", "#", "]"}], "\[RightDoubleBracket]"}]}], 
           ")"}], "&"}], "/@", "rspairs"}], "]"}]}], ";", " ", 
      "\[IndentingNewLine]", 
      RowBox[{"expmi\[Omega]j\[Tau]rs", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Exp", "[", 
            RowBox[{
             RowBox[{"-", "I"}], " ", "#", " ", "j", " ", "\[Delta]t"}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "0", ",", 
             RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], "&"}], "/@", 
        "\[Omega]rs"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Delta]rsk", "=", 
       RowBox[{
        SuperscriptBox["n", 
         RowBox[{"-", "1"}]], "\[Times]", 
        RowBox[{"(", 
         RowBox[{"Chop", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"RotateRight", "[", 
             RowBox[{
              RowBox[{"Fourier", "[", 
               RowBox[{"#", ",", 
                RowBox[{"FourierParameters", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", 
                   RowBox[{"-", "1"}]}], "}"}]}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"Floor", "[", 
                RowBox[{"n", "/", "2"}], "]"}], "-", "1"}]}], "]"}], "&"}], "/@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Outer", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Extract", "[", 
                 RowBox[{"#2", ",", "#1"}], "]"}], "&"}], ",", "rspairs", ",",
                "QadjTjset", ",", "1"}], "]"}], "*", 
             "expmi\[Omega]j\[Tau]rs"}], ")"}]}], "]"}], ")"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{"carav", ",", "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Rho]0Tjset", "=", 
           RowBox[{"Chop", "@", 
            RowBox[{"Transpose", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"ConjugateTranspose", "[", "#", "]"}], ".", 
                  "\[Rho]0mat", ".", "#"}], ")"}], "&"}], "/@", "AjXset"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{"3", ",", "1", ",", "2"}], "}"}]}], "]"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"\[Epsilon]rsk", "=", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"RotateRight", "[", 
               RowBox[{
                RowBox[{"Fourier", "[", 
                 RowBox[{"#", ",", 
                  RowBox[{"FourierParameters", "\[Rule]", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "1"}]}], "}"}]}]}], "]"}], ",", 
                RowBox[{
                 RowBox[{"Floor", "[", 
                  RowBox[{"n", "/", "2"}], "]"}], "-", "1"}]}], "]"}], "&"}], 
             "/@", 
             RowBox[{"Chop", "[", 
              RowBox[{
               RowBox[{"Extract", "[", 
                RowBox[{"\[Rho]0Tjset", ",", "rspairs"}], "]"}], "*", 
               "expmi\[Omega]j\[Tau]rs"}], "]"}]}], ")"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"arsk", "=", 
           RowBox[{"Chop", "[", 
            RowBox[{"\[Delta]rsk", "*", 
             RowBox[{
              RowBox[{"Conjugate", "[", "\[Epsilon]rsk", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"normCOMPUTE", "\[Times]", 
                RowBox[{
                 RowBox[{"Norm", "[", 
                  RowBox[{"N", "@", "Qadjmat"}], "]"}], "^", "2"}]}], 
               ")"}]}]}], "]"}]}]}], "\[IndentingNewLine]", ")"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Ers", "=", 
           RowBox[{"Chop", "@", 
            RowBox[{"Extract", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"ConjugateTranspose", "[", "X", "]"}], ".", 
               "\[Rho]0mat", ".", "X"}], ",", "rspairs"}], "]"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"arsk", "=", 
           RowBox[{"Chop", "[", 
            RowBox[{"\[Delta]rsk", "\[Times]", 
             RowBox[{
              RowBox[{"Conjugate", "[", "Ers", "]"}], "/", 
              RowBox[{"(", 
               RowBox[{"normCOMPUTE", "\[Times]", 
                RowBox[{
                 RowBox[{"Norm", "[", 
                  RowBox[{"N", "@", "Qadjmat"}], "]"}], "^", "2"}]}], 
               ")"}]}]}], "]"}]}]}], "\[IndentingNewLine]", ")"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Omega]rsk", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Plus", "[", 
          RowBox[{"#", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"EvenQ", "[", "n", "]"}], ",", 
              RowBox[{"Range", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"-", "n"}], "/", "2"}], "+", "1"}], ",", 
                RowBox[{"n", "/", "2"}]}], "]"}], ",", 
              RowBox[{"Range", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"-", 
                  RowBox[{"(", 
                   RowBox[{"n", "-", "1"}], ")"}]}], "/", "2"}], ",", 
                RowBox[{
                 RowBox[{"+", 
                  RowBox[{"(", 
                   RowBox[{"n", "-", "1"}], ")"}]}], "/", "2"}]}], "]"}]}], 
             "]"}], "\[Times]", "2", 
            RowBox[{"\[Pi]", "/", "T"}]}]}], "\[IndentingNewLine]", "]"}], 
         "&"}], "/@", "\[Omega]rs"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Signal", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"\"\<Lorentzian\>\"", ",", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Flatten", "[", "arsk", "]"}], ",", 
             RowBox[{"Flatten", "[", "\[Omega]rsk", "]"}], ",", 
             RowBox[{"Table", "[", 
              RowBox[{"0", ",", 
               RowBox[{"{", 
                RowBox[{"Length", "@", 
                 RowBox[{"Flatten", "[", "\[Omega]rsk", "]"}]}], "}"}]}], 
              "]"}]}], "}"}], "]"}]}], "\[IndentingNewLine]", "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
         RowBox[{"Sequence", "@@", 
          RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "opts", "}"}], ",", 
              RowBox[{"Options", "@", "Signal1D"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Options", "[", "Signal", "]"}]}], "\[IndentingNewLine]", 
           "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.544032860758041*^9, 3.544032873291316*^9}, {
   3.547613946933979*^9, 3.54761395320372*^9}, {3.5476139895366096`*^9, 
   3.5476140703889427`*^9}, {3.547614119139723*^9, 3.547614277151492*^9}, {
   3.547614313688985*^9, 3.5476143456075773`*^9}, {3.547614377126581*^9, 
   3.5476143983564787`*^9}, {3.547614471287806*^9, 3.547614496798925*^9}, {
   3.547614536879713*^9, 3.547614596690401*^9}, {3.5476146269796247`*^9, 
   3.547614680649415*^9}, {3.547614715740073*^9, 3.547614805634756*^9}, {
   3.5476152019146023`*^9, 3.547615213315205*^9}, {3.54761526575163*^9, 
   3.547615271700265*^9}, {3.5476153611300898`*^9, 3.547615375992992*^9}, {
   3.5476154163527727`*^9, 3.54761549349776*^9}, {3.547615527400128*^9, 
   3.547615547374447*^9}, 3.547616198336555*^9, {3.547616660489154*^9, 
   3.547616708106813*^9}, {3.54761675765849*^9, 3.547616875688995*^9}, {
   3.547616914832225*^9, 3.547617117402185*^9}, {3.5476171777784557`*^9, 
   3.547617208838613*^9}, {3.547617277899241*^9, 3.547617292101532*^9}, {
   3.547617488471547*^9, 3.547617539299038*^9}, {3.5476175804242887`*^9, 
   3.547617584982424*^9}, {3.5476176499881477`*^9, 3.547617657238391*^9}, {
   3.5476179159977417`*^9, 3.547617930114555*^9}, {3.547618006572904*^9, 
   3.547618146262414*^9}, {3.5476183023940887`*^9, 3.547618342940501*^9}, {
   3.547618425056088*^9, 3.547618427044731*^9}, {3.5476218034529133`*^9, 
   3.547621807004546*^9}, {3.5476218373991756`*^9, 3.5476218383601713`*^9}, {
   3.547634040846137*^9, 3.547634092516068*^9}, 3.547634133557378*^9, {
   3.5476342301323833`*^9, 3.547634291882268*^9}, 3.547634353636037*^9, {
   3.54763444497644*^9, 3.54763451210406*^9}, {3.547635015831386*^9, 
   3.547635020268466*^9}, {3.547635407590149*^9, 3.547635410849917*^9}, {
   3.547635507340515*^9, 3.547635513617535*^9}, {3.5476356162879257`*^9, 
   3.547635637220886*^9}, {3.5476357705660763`*^9, 3.5476357844191093`*^9}, {
   3.547642144878875*^9, 3.5476421573113823`*^9}, {3.547642375812353*^9, 
   3.547642382626197*^9}, {3.547643084402823*^9, 3.5476431012353077`*^9}, {
   3.5476431724771852`*^9, 3.547643179746931*^9}, {3.547643525124076*^9, 
   3.547643541558454*^9}, {3.547643578824926*^9, 3.547643579296455*^9}, {
   3.547644046718878*^9, 3.547644047564704*^9}, {3.5476448947121964`*^9, 
   3.547644896636854*^9}, {3.547644970620884*^9, 3.547644995945313*^9}, {
   3.547645199998761*^9, 3.547645212994705*^9}, {3.547645316280919*^9, 
   3.547645320302443*^9}, {3.547645365385805*^9, 3.547645377069097*^9}, {
   3.547645608107676*^9, 3.547645609048737*^9}, 3.547645738116515*^9, {
   3.547646660399712*^9, 3.547646677716659*^9}, {3.547661076576213*^9, 
   3.547661079284886*^9}, {3.564589520591168*^9, 3.5645895436360273`*^9}, {
   3.56458965678438*^9, 3.564589676884445*^9}, 3.5645903642916813`*^9, {
   3.564590490520774*^9, 3.56459049873282*^9}, {3.564591871127877*^9, 
   3.564591874639246*^9}, {3.564592386145513*^9, 3.564592420729363*^9}, {
   3.564594081017015*^9, 3.564594084236932*^9}, {3.5645953811396303`*^9, 
   3.564595459632039*^9}, {3.564595634806538*^9, 3.564595639544827*^9}, {
   3.586106600090382*^9, 3.58610661125636*^9}, {3.5863511969223022`*^9, 
   3.586351293974772*^9}, {3.586351338737265*^9, 3.586351343748095*^9}, {
   3.6150127323024473`*^9, 3.6150127584411983`*^9}, 3.615030495151609*^9, {
   3.6152767038809566`*^9, 3.615276719247394*^9}, {3.615276762352497*^9, 
   3.61527676664209*^9}, {3.615276892409787*^9, 3.6152769006200867`*^9}, {
   3.615279027153873*^9, 3.6152790914338083`*^9}, {3.615279331010787*^9, 
   3.615279350323201*^9}, {3.615289401722975*^9, 3.6152894234390163`*^9}, {
   3.626027794273334*^9, 3.626027797123542*^9}, {3.6260840905397778`*^9, 
   3.62608409154113*^9}, {3.626084126439501*^9, 3.626084217489552*^9}, {
   3.6260843589342327`*^9, 3.6260844562960787`*^9}, {3.6260844867092133`*^9, 
   3.6260844973039227`*^9}, {3.6260846672238817`*^9, 3.626084686955307*^9}, 
   3.629103334357378*^9, {3.633854213942471*^9, 3.633854228572749*^9}, {
   3.633854399146199*^9, 3.6338544384759607`*^9}, {3.633854552764874*^9, 
   3.633854560804933*^9}, {3.6338546202408657`*^9, 3.6338546320429792`*^9}, {
   3.633854841600902*^9, 3.6338548932046824`*^9}, {3.633854971183899*^9, 
   3.6338549898054123`*^9}, {3.634046844907956*^9, 3.634046890428046*^9}, 
   3.634048989176094*^9, {3.634049053809475*^9, 3.634049085322112*^9}, {
   3.634049140879553*^9, 3.634049141057159*^9}, {3.683807450086793*^9, 
   3.683807450377405*^9}, {3.699959645176942*^9, 3.69995964807997*^9}, {
   3.70110401683785*^9, 3.701104030366589*^9}, {3.7011040895625753`*^9, 
   3.701104141868966*^9}, {3.70110427361033*^9, 3.701104287026361*^9}, 
   3.7011050377845*^9, 3.701105377405699*^9, {3.702779793763526*^9, 
   3.7027797941127763`*^9}, {3.702779828636322*^9, 3.702779877538083*^9}, {
   3.702779941729721*^9, 3.702779972395525*^9}, {3.7027800042962112`*^9, 
   3.702780022794363*^9}, {3.7027800582345576`*^9, 3.7027800768348083`*^9}, {
   3.702780146622425*^9, 3.7027801833925447`*^9}, {3.702780369495882*^9, 
   3.702780369895166*^9}, {3.702780741516415*^9, 3.702780771762909*^9}, {
   3.7027809217615633`*^9, 3.702780923880061*^9}, {3.7027809571097145`*^9, 
   3.7027809860882893`*^9}, {3.7027812201241813`*^9, 
   3.7027812247454967`*^9}, {3.7027812569343567`*^9, 
   3.7027812642525573`*^9}, {3.7027813244824076`*^9, 
   3.7027813248106413`*^9}, {3.702781387106901*^9, 3.7027813906614304`*^9}, {
   3.7027814412483964`*^9, 3.7027814480992966`*^9}, {3.702781650633274*^9, 
   3.7027816562382493`*^9}, {3.7027957143635435`*^9, 3.702795714528465*^9}, {
   3.702795766368483*^9, 3.7027957665331535`*^9}, {3.703005725312922*^9, 
   3.703005733776781*^9}, {3.703007638292851*^9, 3.703007670867176*^9}, {
   3.703007805966112*^9, 3.703007806139984*^9}, {3.703008356130267*^9, 
   3.703008526250411*^9}, {3.703008660515266*^9, 3.703008701030765*^9}, 
   3.7030089004245787`*^9, 3.70313894777529*^9, {3.7038388670279255`*^9, 
   3.703838869372283*^9}, {3.703838916392907*^9, 3.703838919770754*^9}, {
   3.7038390229846687`*^9, 3.7038390231285505`*^9}, {3.709375555081641*^9, 
   3.709375555087968*^9}, {3.7099790266422095`*^9, 3.7099790285121756`*^9}, {
   3.709979063781767*^9, 3.7099791413857193`*^9}, {3.709979422888708*^9, 
   3.7099794490241036`*^9}, {3.7099796705990887`*^9, 3.709979673059622*^9}, {
   3.709979703620718*^9, 3.7099797383749547`*^9}, {3.7099802886908083`*^9, 
   3.7099802900364046`*^9}, {3.7099803529633975`*^9, 
   3.7099803535740175`*^9}, {3.7099805927497234`*^9, 3.709980593050528*^9}, {
   3.709980702408868*^9, 3.7099807046327777`*^9}, {3.7099807456335826`*^9, 
   3.7099807457839823`*^9}, {3.710677751941677*^9, 3.710677753918147*^9}, {
   3.7106778998954206`*^9, 3.710677902242998*^9}, {3.710678000527226*^9, 
   3.71067801719575*^9}, {3.7106785991338577`*^9, 3.71067862011586*^9}, {
   3.7106787295969753`*^9, 3.7106787298001127`*^9}, {3.7106787629707975`*^9, 
   3.710678767531679*^9}, {3.7106789542667894`*^9, 3.710678964524132*^9}, {
   3.7114372577950425`*^9, 3.711437257951358*^9}, {3.711437707854211*^9, 
   3.7114377102329836`*^9}, {3.711446866773737*^9, 3.7114470266827197`*^9}, {
   3.7114471751419787`*^9, 3.7114471820959053`*^9}, 3.7114472477173896`*^9, {
   3.711447297721135*^9, 3.711447300104267*^9}, {3.7114473317509193`*^9, 
   3.7114473341986837`*^9}, {3.711447440511159*^9, 3.711447451800436*^9}, {
   3.7114475043525424`*^9, 3.7114475081675243`*^9}, {3.71145131726972*^9, 
   3.7114513200582757`*^9}, {3.7119556431241236`*^9, 3.7119556500586147`*^9}, 
   3.712935078377747*^9, {3.7129421686640615`*^9, 3.712942181696879*^9}, {
   3.712942430851007*^9, 3.7129424565751486`*^9}, {3.712943445391548*^9, 
   3.712943445720939*^9}, {3.712949558205784*^9, 3.7129495635776052`*^9}, {
   3.7129501496121387`*^9, 3.7129501522317266`*^9}, {3.7129505928386884`*^9, 
   3.712950592923937*^9}, {3.7130232954194207`*^9, 3.7130233078583097`*^9}, {
   3.713023364925344*^9, 3.7130233732863827`*^9}, {3.7130239018183804`*^9, 
   3.713023913122192*^9}, {3.7130256189210367`*^9, 3.7130256190508056`*^9}, {
   3.713026345435897*^9, 3.7130263468510985`*^9}, {3.7130273100250473`*^9, 
   3.7130273133017597`*^9}, {3.7130273515191703`*^9, 
   3.7130273713919725`*^9}, {3.7130274570918407`*^9, 3.713027468476809*^9}, {
   3.7130275511602287`*^9, 3.713027579758879*^9}, {3.7130276279061136`*^9, 
   3.713027644158581*^9}, {3.7130369380939684`*^9, 3.713036941383416*^9}, {
   3.713037312088396*^9, 3.7130373122374926`*^9}, {3.7130729968458014`*^9, 
   3.713073004661561*^9}, {3.713084027925162*^9, 3.7130840527426205`*^9}, {
   3.7130865169122477`*^9, 3.713086521547587*^9}, {3.7130888724425116`*^9, 
   3.713088872583166*^9}, {3.7130889712884483`*^9, 3.7130890010815363`*^9}, {
   3.7130894120355234`*^9, 3.713089452082955*^9}, {3.713089501911685*^9, 
   3.713089511425832*^9}, {3.7130895871011796`*^9, 3.713089616272726*^9}, {
   3.713089680890814*^9, 3.713089681039857*^9}, {3.713089933858368*^9, 
   3.713089942768329*^9}, {3.713090005174624*^9, 3.7130900053259954`*^9}, {
   3.7130902187322087`*^9, 3.7130902343710127`*^9}, {3.7130902713835855`*^9, 
   3.71309028251937*^9}, 3.7131027818794355`*^9, {3.7131028581341443`*^9, 
   3.7131028821188807`*^9}, {3.7131030265945296`*^9, 
   3.7131030297812867`*^9}, {3.713103073410197*^9, 3.7131031040736485`*^9}, {
   3.713103170493147*^9, 3.71310317075878*^9}, {3.713103370039824*^9, 
   3.71310337154139*^9}, {3.7131034026004343`*^9, 3.7131034027441854`*^9}, {
   3.713116461639271*^9, 3.713116463517684*^9}, {3.713552081219458*^9, 
   3.7135521009865136`*^9}, {3.713592253239221*^9, 3.7135922582387733`*^9}, {
   3.713601427832023*^9, 3.7136014356615725`*^9}, {3.713601467063099*^9, 
   3.7136014672024927`*^9}, {3.713601863027034*^9, 3.7136018885955515`*^9}, {
   3.7136021105141935`*^9, 3.713602112298929*^9}, {3.71360217868209*^9, 
   3.7136021802883615`*^9}, {3.7136027815832233`*^9, 3.713602787344513*^9}, {
   3.7136031595933247`*^9, 3.713603160873721*^9}, {3.71360477913264*^9, 
   3.7136047944712796`*^9}, {3.713605074785329*^9, 3.7136050816475005`*^9}, {
   3.713605146865775*^9, 3.713605150867396*^9}, {3.713605211953848*^9, 
   3.7136052120892057`*^9}, {3.713606001657447*^9, 3.7136060017827525`*^9}, {
   3.713610630080185*^9, 3.713610664716958*^9}, {3.713610824840173*^9, 
   3.713610831738454*^9}, {3.713611805660342*^9, 3.713611805828579*^9}, {
   3.7136161763690753`*^9, 3.7136161802672963`*^9}, {3.7136163747091856`*^9, 
   3.713616375478963*^9}, {3.713616992015283*^9, 3.7136169922184334`*^9}, {
   3.7284661947462883`*^9, 3.7284662039729495`*^9}, {3.7284662824648933`*^9, 
   3.728466375787877*^9}, {3.728466414720524*^9, 3.728466415048292*^9}, {
   3.7284680968864737`*^9, 3.7284681014815865`*^9}, {3.7284692163313184`*^9, 
   3.7284692165540576`*^9}, {3.744373835005123*^9, 3.7443738566471233`*^9}, {
   3.7443741743357487`*^9, 3.744374182199395*^9}, {3.744374221141911*^9, 
   3.744374221372209*^9}, {3.7443743378600397`*^9, 3.744374345072674*^9}, {
   3.744375774029909*^9, 3.7443757948514643`*^9}, {3.744376355082714*^9, 
   3.7443763640306463`*^9}, {3.744376444371653*^9, 3.744376486128523*^9}, {
   3.7443766008366127`*^9, 3.7443766039307117`*^9}, {3.744376680013332*^9, 
   3.744376692915822*^9}, {3.744377395001914*^9, 3.744377421493803*^9}, {
   3.744377555593916*^9, 3.744377563447321*^9}, {3.744377967832838*^9, 
   3.744377972556847*^9}, {3.74453995950333*^9, 3.744539964719796*^9}, 
   3.744541929625701*^9, 3.744542162638125*^9, {3.7445426706436653`*^9, 
   3.74454268047324*^9}, {3.7445427308173847`*^9, 3.744542736226385*^9}, 
   3.744542827660469*^9, {3.744544186590981*^9, 
   3.7445441892790403`*^9}},ExpressionUUID->"aa00bf35-76d9-47ab-aab5-\
80443bf5c085"]
}, Open  ]],

Cell[CellGroupData[{

Cell["L-COMPUTE (general case of non-unitary propagators)", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.504592770970264*^9, 3.5045927997448263`*^9}, {
   3.505047956226206*^9, 3.5050479576795397`*^9}, {3.534648661927877*^9, 
   3.53464867910023*^9}, 
   3.534649164439288*^9},ExpressionUUID->"2d58218f-f844-400a-9ebf-\
6742bea79619"],

Cell["see M. Helmle et al, J. Magn. Reson. 140, 379-403 (1999).", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.4708300918503313`*^9, 3.470830119064274*^9}, {
   3.470842480879712*^9, 3.470842489584428*^9}, 
   3.5045928049628773`*^9},ExpressionUUID->"e646d9d7-5607-4cef-b495-\
711ca3e3f7df"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Signal1DCore", "[", 
     RowBox[{"\"\<COMPUTE\>\"", ",", 
      RowBox[{"{", 
       RowBox[{"tmin_", ",", "tmax_", ",", "\[Delta]t_"}], "}"}], ",", 
      "acqevents_", ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"!", "UseHilbertSpaceWhenPossible"}], "/.", 
         RowBox[{"{", "opts", "}"}]}], "/.", 
        RowBox[{"Options", "[", "Signal1D", "]"}]}], ")"}], "||", 
      "\[IndentingNewLine]", 
      RowBox[{"!", 
       RowBox[{"HilbertSpaceCompatibility", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"PeriodicDetectionEvents", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}], ",", 
         "\[IndentingNewLine]", "opts"}], "\[IndentingNewLine]", "]"}]}]}], 
     "\[IndentingNewLine]", ")"}]}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\[Rho]0", ",", "\[Rho]0vec", ",", "Qobs", ",", "Qobsvec", ",", 
       "opbasis", ",", "basis", ",", "T", ",", "n", ",", "ns", ",", "Ajset", 
       ",", "Ajinvset", ",", "An", ",", "evals", ",", "rekets", ",", "lebras",
        ",", "X", ",", "Xinv", ",", "zsset", ",", "Excs0", ",", "Excsj", ",", 
       "Detsj", ",", "\[Epsilon]sk", ",", "\[Epsilon]smk", ",", "\[Delta]sk", 
       ",", "ask", ",", "kvals", ",", "zsk", ",", "zvals", ",", "avals", ",", 
       "\[Omega]vals", ",", "\[Lambda]vals", ",", "norm", ",", "carav", ",", 
       "perdetevents", ",", "assumeorthogevecs", ",", "prepbackg", ",", 
       "detbackg", ",", "divpereventlists", ",", "normCOMPUTE", ",", 
       "dividedevents"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "\[Rho]0", ",", "Qobs", ",", "opbasis", ",", "basis", ",", "T", ",", 
          "norm", ",", "carav", ",", "perdetevents"}], "}"}], "=", 
        RowBox[{"ReleaseHold", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "InitialDensityOperator", ",", "Observable", ",", "OperatorBasis",
              ",", "Basis", ",", "SignalGeneratorPeriod", ",", 
             "NormalizationFactor", ",", "CarouselAverage", ",", 
             "PeriodicDetectionEvents"}], "}"}], "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"normCOMPUTE", "=", 
        RowBox[{"norm", "\[Times]", 
         RowBox[{"Log", "[", 
          RowBox[{"2", ",", 
           RowBox[{"BasisDimension", "[", "basis", "]"}]}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"detbackg", "=", 
        RowBox[{"ReleaseHold", "[", 
         RowBox[{
          RowBox[{"BackgroundGenerator", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "Signal1D", "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ns", "=", 
        RowBox[{"OperatorBasisDimension", "[", "opbasis", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"n", "=", 
        RowBox[{"Max", "[", 
         RowBox[{"1", ",", 
          RowBox[{"Round", "[", 
           RowBox[{"T", "/", "\[Delta]t"}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Qobsvec", "=", 
        RowBox[{"OperatorVectorRepresentation", "[", 
         RowBox[{"Qobs", ",", "opbasis", ",", "basis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Rho]0vec", "=", 
        RowBox[{"OperatorVectorRepresentation", "[", 
         RowBox[{"\[Rho]0", ",", "opbasis", ",", "basis"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"dividedevents", "=", 
        RowBox[{"DivideEventSpecifications", "[", 
         RowBox[{"perdetevents", ",", "n", ",", 
          RowBox[{"IncludeRepetitionNumbers", "\[Rule]", "True"}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"Ajset", "=", 
        RowBox[{"DividedEventPropagators", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Superoperator", ",", "T", ",", "n"}], "}"}], ",", 
          "\[IndentingNewLine]", "dividedevents", ",", "\[IndentingNewLine]", 
          "opbasis", ",", "basis", ",", "\[IndentingNewLine]", 
          RowBox[{"InitialTimePoint", "\[Rule]", "tmin"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"BackgroundGenerator", "\[Rule]", "detbackg"}], ",", 
          "opts"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"An", "=", 
        RowBox[{"Last", "@", "Ajset"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"X", ",", "evals", ",", "Xinv"}], "}"}], "=", 
        RowBox[{"First", "@", 
         RowBox[{"NDiagonalize", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Superoperator", "[", 
            RowBox[{"An", ",", "opbasis", ",", "basis"}], "]"}], ",", 
           "\[IndentingNewLine]", "opbasis", ",", "basis", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Sequence", "@@", 
            RowBox[{"FilterRules", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Assumptions", "\[Rule]", "None"}], ",", "opts"}], 
               "}"}], ",", 
              RowBox[{"Options", "[", "NDiagonalize", "]"}]}], "]"}]}]}], 
          "\[IndentingNewLine]", "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"rekets", "=", 
        RowBox[{"Transpose", "[", "X", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"lebras", "=", "Xinv"}], ";", "\[IndentingNewLine]", 
       RowBox[{"zsset", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Log", "/@", "evals"}], ")"}], "/", "T"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Detsj", "=", 
        RowBox[{"MapThread", "[", "\[IndentingNewLine]", 
         RowBox[{"Times", ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Outer", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"Dot", "[", 
                 RowBox[{
                  RowBox[{"Conjugate", "@", "Qobsvec"}], ",", "#2", ",", 
                  "#1"}], "]"}], ")"}], "&"}], ",", "rekets", ",", 
              RowBox[{"Most", "@", "Ajset"}], ",", "1"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Outer", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Exp", "[", 
                RowBox[{
                 RowBox[{"-", "#1"}], "\[Times]", "#2", " ", "\[Delta]t"}], 
                "]"}], "&"}], ",", "zsset", ",", 
              RowBox[{"Range", "[", 
               RowBox[{"0", ",", 
                RowBox[{"n", "-", "1"}]}], "]"}]}], "]"}]}], "}"}]}], 
         "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Delta]sk", "=", 
        RowBox[{
         SuperscriptBox["n", 
          RowBox[{"-", "1"}]], "\[Times]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"RotateRight", "[", 
             RowBox[{
              RowBox[{"Fourier", "[", 
               RowBox[{"#", ",", 
                RowBox[{"FourierParameters", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", 
                   RowBox[{"-", "1"}]}], "}"}]}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"Floor", "[", 
                RowBox[{"n", "/", "2"}], "]"}], "-", "1"}]}], "]"}], "&"}], "/@",
            "Detsj"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{"carav", ",", "\[IndentingNewLine]", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Ajinvset", "=", 
            RowBox[{"Inverse", "/@", "Ajset"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"Excsj", "=", 
            RowBox[{"Chop", "@", 
             RowBox[{"MapThread", "[", "\[IndentingNewLine]", 
              RowBox[{"Times", ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Outer", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"Dot", "[", 
                    RowBox[{"#1", ",", "#2", ",", "\[Rho]0vec"}], "]"}], 
                    ")"}], "&"}], ",", "lebras", ",", "Ajinvset", ",", "1"}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Outer", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Exp", "[", 
                    RowBox[{
                    RowBox[{"+", "#1"}], "\[Times]", "#2", " ", "\[Delta]t"}],
                     "]"}], "&"}], ",", "zsset", ",", 
                   RowBox[{"Range", "[", 
                    RowBox[{"0", ",", 
                    RowBox[{"n", "-", "1"}]}], "]"}]}], "]"}]}], "}"}]}], 
              "\[IndentingNewLine]", "]"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"\[Epsilon]sk", "=", 
            RowBox[{
             SuperscriptBox["n", 
              RowBox[{"-", "1"}]], "\[Times]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"RotateRight", "[", 
                 RowBox[{
                  RowBox[{"Fourier", "[", 
                   RowBox[{"#", ",", 
                    RowBox[{"FourierParameters", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", 
                    RowBox[{"-", "1"}]}], "}"}]}]}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"Floor", "[", 
                    RowBox[{"n", "/", "2"}], "]"}], "-", "1"}]}], "]"}], 
                "&"}], "/@", "Excsj"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"\[Epsilon]smk", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"RotateLeft", "[", 
               RowBox[{
                RowBox[{"Reverse", "[", "#", "]"}], ",", "1"}], "]"}], "&"}], 
             "/@", "\[Epsilon]sk"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"ask", "=", 
            RowBox[{"Chop", "@", 
             RowBox[{"MapThread", "[", 
              RowBox[{"Times", ",", 
               RowBox[{"{", 
                RowBox[{"\[Epsilon]smk", ",", "\[Delta]sk"}], "}"}]}], 
              "]"}]}]}], ";"}], "\[IndentingNewLine]", ")"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Excs0", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"Dot", "[", 
               RowBox[{"#1", ",", "\[Rho]0vec"}], "]"}], "&"}], "/@", 
             "lebras"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"ask", "=", 
            RowBox[{"Chop", "@", 
             RowBox[{"MapThread", "[", 
              RowBox[{"Times", ",", 
               RowBox[{"{", 
                RowBox[{"Excs0", ",", "\[Delta]sk"}], "}"}]}], "]"}]}]}], 
           ";"}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"zsk", "=", 
        RowBox[{"Outer", "[", 
         RowBox[{"Plus", ",", "zsset", ",", 
          RowBox[{"I", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"EvenQ", "[", "n", "]"}], ",", 
             RowBox[{"Range", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"-", "n"}], "/", "2"}], "+", "1"}], ",", 
               RowBox[{"n", "/", "2"}]}], "]"}], ",", 
             RowBox[{"Range", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 RowBox[{"(", 
                  RowBox[{"n", "-", "1"}], ")"}]}], "/", "2"}], ",", 
               RowBox[{
                RowBox[{"+", 
                 RowBox[{"(", 
                  RowBox[{"n", "-", "1"}], ")"}]}], "/", "2"}]}], "]"}]}], 
            "]"}], "\[Times]", "2", 
           RowBox[{"\[Pi]", "/", "T"}]}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"avals", "=", 
        RowBox[{
         RowBox[{"Chop", "@", 
          RowBox[{"N", "@", 
           RowBox[{"Flatten", "@", "ask"}]}]}], "/", 
         RowBox[{"(", 
          RowBox[{"normCOMPUTE", "\[Times]", 
           RowBox[{
            RowBox[{"Norm", "[", "Qobsvec", "]"}], "^", "2"}]}], ")"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"zvals", "=", 
        RowBox[{"Flatten", "@", "zsk"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Omega]vals", "=", 
        RowBox[{"Im", "/@", "zvals"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Lambda]vals", "=", 
        RowBox[{"-", 
         RowBox[{"Re", "/@", "zvals"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Signal", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"tmin", ",", "tmax", ",", "\[Delta]t"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"\"\<Lorentzian\>\"", ",", 
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{"avals", ",", "\[Omega]vals", ",", "\[Lambda]vals"}], 
             "}"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"SimplifyRules", "[", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"FilterRules", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", "opts", "}"}], ",", 
               RowBox[{"Options", "@", "Signal1D"}]}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Options", "[", "Signal", "]"}]}], "\[IndentingNewLine]",
             "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.470137520994417*^9, 3.470137644665415*^9}, {
   3.470137717035119*^9, 3.4701377959254723`*^9}, {3.4701378684334717`*^9, 
   3.4701378704871607`*^9}, 3.470137959340438*^9, {3.470138075766912*^9, 
   3.470138097663471*^9}, {3.470138362810503*^9, 3.47013837352169*^9}, {
   3.470138433165674*^9, 3.470138710638435*^9}, 3.470139114342375*^9, {
   3.470139615957039*^9, 3.470139640635371*^9}, 3.4701406458684483`*^9, {
   3.4701411697001143`*^9, 3.470141184956568*^9}, {3.470142659329577*^9, 
   3.4701426614324207`*^9}, {3.470143363595736*^9, 3.4701433640408916`*^9}, {
   3.470143420710148*^9, 3.4701434238208237`*^9}, {3.470385760817987*^9, 
   3.4703857684396687`*^9}, 3.470386811979693*^9, {3.470386902736025*^9, 
   3.470386936367881*^9}, {3.470387030253839*^9, 3.4703870776609173`*^9}, {
   3.470653274837183*^9, 3.470653300914125*^9}, {3.470653836443573*^9, 
   3.470653856944706*^9}, {3.470653913710114*^9, 3.4706539368867893`*^9}, 
   3.470812079368765*^9, {3.470825570365651*^9, 3.4708255789208317`*^9}, {
   3.470825640268902*^9, 3.470825876740882*^9}, {3.470826110542151*^9, 
   3.470826181428112*^9}, {3.470826288610529*^9, 3.470826297755519*^9}, {
   3.4708263424917507`*^9, 3.470826392228142*^9}, {3.470826752021058*^9, 
   3.470826809315834*^9}, {3.470826875498164*^9, 3.470826877838354*^9}, {
   3.470826917254923*^9, 3.470827132145159*^9}, {3.47082730426849*^9, 
   3.470827311515287*^9}, {3.4708273679336233`*^9, 3.470827412853204*^9}, {
   3.470827449198216*^9, 3.470827487952927*^9}, {3.470827539907276*^9, 
   3.470827590137908*^9}, {3.4708276727660017`*^9, 3.470827689342993*^9}, {
   3.470827760924115*^9, 3.470827781588152*^9}, {3.470827889449196*^9, 
   3.470827983171822*^9}, {3.470828078646009*^9, 3.4708282159737673`*^9}, {
   3.4708283346966467`*^9, 3.470828343054369*^9}, {3.470828485322448*^9, 
   3.470828551255259*^9}, {3.470828775053027*^9, 3.470829015215823*^9}, {
   3.470829250121274*^9, 3.4708292553224163`*^9}, 3.470829526517795*^9, {
   3.470829649159946*^9, 3.470829698535163*^9}, {3.470830022589822*^9, 
   3.47083004744693*^9}, {3.4708301772318277`*^9, 3.470830204710726*^9}, {
   3.470830245129081*^9, 3.470830316823291*^9}, 3.47083035028874*^9, {
   3.4708314370756063`*^9, 3.470831443033218*^9}, {3.470831579095169*^9, 
   3.470831620662941*^9}, {3.4708316564829082`*^9, 3.4708316575272512`*^9}, {
   3.470831739797195*^9, 3.470831747701764*^9}, {3.470831806109497*^9, 
   3.470831819918272*^9}, {3.470831873550167*^9, 3.470831875179698*^9}, {
   3.470831943774794*^9, 3.470832018779505*^9}, {3.470832080268238*^9, 
   3.470832082690296*^9}, {3.470832133026431*^9, 3.4708322811810837`*^9}, 
   3.470832420185305*^9, 3.470832642165433*^9, 3.470832870246295*^9, {
   3.4708338221123247`*^9, 3.4708338273086567`*^9}, {3.470833869042948*^9, 
   3.470833881567574*^9}, {3.4708339241115627`*^9, 3.470833925434802*^9}, {
   3.470834018279605*^9, 3.4708340268170033`*^9}, {3.4708340598418837`*^9, 
   3.470834071562405*^9}, {3.4708342175379953`*^9, 3.470834257272251*^9}, 
   3.470834338378552*^9, {3.470834374931724*^9, 3.470834377027721*^9}, {
   3.4708344758247023`*^9, 3.470834484477839*^9}, {3.470839854393835*^9, 
   3.470839874128125*^9}, {3.4708400588570757`*^9, 3.470840059113409*^9}, {
   3.470840809130525*^9, 3.470840858130522*^9}, {3.4708412986335087`*^9, 
   3.4708413459563103`*^9}, {3.470841424338646*^9, 3.4708414283825407`*^9}, {
   3.470842308147214*^9, 3.47084231029837*^9}, {3.4708423747708063`*^9, 
   3.47084238296201*^9}, {3.4708432627158213`*^9, 3.470843270537835*^9}, {
   3.470843432104847*^9, 3.470843458578806*^9}, {3.470876487685856*^9, 
   3.4708764892708607`*^9}, {3.4973622241032887`*^9, 3.497362274794814*^9}, {
   3.497572575926502*^9, 3.497572578998639*^9}, 3.4993268864342337`*^9, {
   3.499628185122727*^9, 3.499628251810655*^9}, 3.499628780415124*^9, 
   3.499660960291071*^9, {3.4997101451596727`*^9, 3.4997101525429277`*^9}, 
   3.4997105662245617`*^9, 3.499710649343855*^9, {3.499711074032387*^9, 
   3.49971108101233*^9}, {3.499823202029277*^9, 3.499823236844366*^9}, {
   3.499823280474203*^9, 3.499823358622974*^9}, {3.4998233975202208`*^9, 
   3.499823473398377*^9}, {3.499823508024404*^9, 3.49982355643859*^9}, {
   3.499823616929305*^9, 3.499823678293866*^9}, {3.499823977508367*^9, 
   3.4998239825244713`*^9}, {3.499914791927268*^9, 3.4999148758041067`*^9}, {
   3.499915226073861*^9, 3.4999153081992073`*^9}, {3.500067855531077*^9, 
   3.500067856561964*^9}, {3.50006929545214*^9, 3.5000692974139767`*^9}, {
   3.500069856525249*^9, 3.500069864778194*^9}, 3.50007003563538*^9, 
   3.500070110826254*^9, {3.500070842875526*^9, 3.500070844712056*^9}, 
   3.500152066887352*^9, {3.500152121812292*^9, 3.500152128018261*^9}, {
   3.500159745255374*^9, 3.500159751333025*^9}, {3.500159849027317*^9, 
   3.5001599303155947`*^9}, {3.500160237465906*^9, 3.5001602410438843`*^9}, {
   3.5001607193909693`*^9, 3.500160735863278*^9}, {3.500162582413743*^9, 
   3.500162587924551*^9}, {3.500163297267729*^9, 3.5001633130170107`*^9}, {
   3.500163926473832*^9, 3.500163929208192*^9}, {3.5001647231065493`*^9, 
   3.5001647255597353`*^9}, 3.500172447942995*^9, 3.502002562606245*^9, {
   3.502002605209475*^9, 3.502002619630165*^9}, {3.5020026798503447`*^9, 
   3.5020026830872803`*^9}, {3.5020027196767387`*^9, 3.502002754522504*^9}, {
   3.502002921883857*^9, 3.502002928744391*^9}, {3.50244837955968*^9, 
   3.502448386484435*^9}, {3.5024484274073267`*^9, 3.502448435092207*^9}, {
   3.502448589179962*^9, 3.502448594265156*^9}, {3.5024491425466757`*^9, 
   3.502449152505756*^9}, {3.502617248867882*^9, 3.502617249129027*^9}, {
   3.50271059287563*^9, 3.502710601907014*^9}, {3.502710802275712*^9, 
   3.5027108508484287`*^9}, {3.5043413384019623`*^9, 3.504341343216494*^9}, {
   3.50434145238487*^9, 3.504341468550612*^9}, {3.504342731299797*^9, 
   3.504342738010407*^9}, {3.504458507305241*^9, 3.504458525433455*^9}, {
   3.5044585596382523`*^9, 3.504458625935773*^9}, {3.5044609550948143`*^9, 
   3.5044610337393503`*^9}, {3.504634240377836*^9, 3.5046342451686487`*^9}, 
   3.504635176528018*^9, {3.505726498466008*^9, 3.505726556918934*^9}, {
   3.505831289545541*^9, 3.505831311682917*^9}, {3.5058313650852823`*^9, 
   3.505831393489818*^9}, {3.505832000982279*^9, 3.505832026279419*^9}, {
   3.505832067658229*^9, 3.505832073686378*^9}, {3.5058356193965607`*^9, 
   3.505835634259921*^9}, {3.505895183471855*^9, 3.505895280720715*^9}, {
   3.5059324219180403`*^9, 3.505932422754764*^9}, {3.505994926955846*^9, 
   3.505994929980315*^9}, {3.5062473041498613`*^9, 3.506247323859659*^9}, {
   3.506247363954225*^9, 3.506247384289279*^9}, {3.506249273145874*^9, 
   3.506249282994821*^9}, {3.506249857539628*^9, 3.506249867081687*^9}, 
   3.5062499086173162`*^9, 3.506250453020863*^9, 3.513186776386734*^9, {
   3.5131884112355824`*^9, 3.513188457107885*^9}, {3.5131889972881937`*^9, 
   3.513189015557356*^9}, {3.513189175736771*^9, 3.513189178582741*^9}, {
   3.5131893397924013`*^9, 3.513189362220656*^9}, {3.513189457808361*^9, 
   3.513189465044306*^9}, {3.513190265979438*^9, 3.513190285626446*^9}, {
   3.513231283561399*^9, 3.513231331302869*^9}, {3.5132314221695557`*^9, 
   3.513231427199284*^9}, {3.529506477481063*^9, 3.529506489028516*^9}, {
   3.529773881727559*^9, 3.5297738856789417`*^9}, {3.530611305567067*^9, 
   3.5306113087708693`*^9}, {3.530611357105781*^9, 3.5306113675810957`*^9}, {
   3.5306116100105753`*^9, 3.5306116457478533`*^9}, {3.53214764534623*^9, 
   3.532147670666737*^9}, 3.533177415204667*^9, {3.533182712255921*^9, 
   3.533182712628207*^9}, {3.533252426578452*^9, 3.533252432114358*^9}, {
   3.534397321692052*^9, 3.534397387303742*^9}, 3.534398179376155*^9, {
   3.5344781053971157`*^9, 3.534478111030727*^9}, {3.534648693990899*^9, 
   3.53464869934791*^9}, {3.5346491751655893`*^9, 3.5346491822442427`*^9}, {
   3.534763582539819*^9, 3.534763648774611*^9}, {3.534763709456626*^9, 
   3.534763775024521*^9}, {3.534763905375435*^9, 3.534763906075288*^9}, 
   3.534820263774349*^9, {3.5348205271096582`*^9, 3.53482053405816*^9}, {
   3.534820564401329*^9, 3.5348205884472227`*^9}, {3.534820636624351*^9, 
   3.5348207058911333`*^9}, {3.5435134069493237`*^9, 3.543513427043666*^9}, {
   3.543895360557424*^9, 3.543895464625641*^9}, 3.543895495972926*^9, {
   3.544028108637536*^9, 3.544028129355584*^9}, {3.544028401940151*^9, 
   3.544028482761108*^9}, 3.544028581796664*^9, {3.544029084052827*^9, 
   3.5440291289315557`*^9}, {3.544029550304509*^9, 3.544029582287345*^9}, {
   3.544029677953499*^9, 3.5440297169694242`*^9}, {3.544032845698503*^9, 
   3.544032881437994*^9}, 3.544622214813779*^9, {3.5476139561883307`*^9, 
   3.547613959996398*^9}, {3.564595496623886*^9, 3.5645955123709593`*^9}, 
   3.564595704038747*^9, {3.5861084011653233`*^9, 3.586108505435728*^9}, {
   3.586180359564211*^9, 3.586180369145135*^9}, 3.5861804044586897`*^9, 
   3.586192599207737*^9, {3.615012872424522*^9, 3.615012876800406*^9}, 
   3.615030510141616*^9, {3.615276743500949*^9, 3.615276749926201*^9}, {
   3.6152769568497887`*^9, 3.6152769612103767`*^9}, {3.615279125828763*^9, 
   3.615279154342567*^9}, {3.615279341328315*^9, 3.6152793428497543`*^9}, 
   3.615289436527334*^9, {3.626027807703203*^9, 3.626027808612673*^9}, {
   3.6260840923624477`*^9, 3.626084093195444*^9}, {3.6260845234564753`*^9, 
   3.626084637881014*^9}, {3.629103342805026*^9, 3.629103346890581*^9}, {
   3.6338553004714108`*^9, 3.6338553215393333`*^9}, {3.633855387840859*^9, 
   3.6338554142887278`*^9}, {3.633855486713443*^9, 3.633855511935677*^9}, {
   3.634049438087188*^9, 3.63404944304722*^9}, {3.634049477632791*^9, 
   3.63404948002766*^9}, 3.634049521229637*^9, {3.68380746776154*^9, 
   3.6838074680566597`*^9}, {3.699959649193451*^9, 3.6999596513875637`*^9}, 
   3.701105061017202*^9, {3.701105465421447*^9, 3.7011055095488367`*^9}, {
   3.701163940047944*^9, 3.7011639447150097`*^9}, {3.701164042667142*^9, 
   3.701164056110237*^9}, 3.7011645510935097`*^9, {3.7011651103593273`*^9, 
   3.701165110700696*^9}, {3.7027797340130405`*^9, 3.702779742490075*^9}, {
   3.7027797808093405`*^9, 3.7027797811815834`*^9}, {3.703008728183853*^9, 
   3.703008742467286*^9}, 3.7031389529890614`*^9, {3.703139077343042*^9, 
   3.703139077989636*^9}, {3.703139440335474*^9, 3.7031394459267683`*^9}, {
   3.709375555100183*^9, 3.70937555510609*^9}, {3.713022713348236*^9, 
   3.7130227134370084`*^9}, {3.71361802416879*^9, 3.7136181040887775`*^9}, {
   3.744374251670672*^9, 
   3.74437425508572*^9}},ExpressionUUID->"4b2e8e1a-819f-4437-8303-\
b7cd9a8fee11"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
local routine: DividedEventPropagators (for COMPUTE algorithm)\
\>", "Section",
 InitializationCell->True,
 CellChangeTimes->{
  3.605545643975979*^9, 3.626009314771649*^9, {3.6260163330982227`*^9, 
   3.626016333513719*^9}, {3.626028212004506*^9, 3.626028222012779*^9}, {
   3.6260284142021313`*^9, 3.626028420922085*^9}, {3.626084732193687*^9, 
   3.626084733102336*^9}, {3.629385767728001*^9, 3.629385773846023*^9}, {
   3.701163866709197*^9, 
   3.701163873954282*^9}},ExpressionUUID->"cf303cc7-6f82-407c-bc37-\
2b43692fc72f"],

Cell["\<\
DividedEventPropagators converts the output of DivideEventSpecifications \
(format {..{nrep2,EventSpecifications[..]},{nrep1, EventSpecifications[..]}}) \
into a set of propagators, taking into account specified repetitions, for the \
sake of efficiency. The type Operator or Superoperator is defined in the \
first argument to DividedEventPropagators. The output propagators are in \
RightToLeft chronological order.\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.626008606702052*^9, 3.626008638276084*^9}, 
   3.6260087119370537`*^9, {3.626016337746071*^9, 3.6260163603125763`*^9}, 
   3.626028401311865*^9, {3.626084753501992*^9, 3.626084764559318*^9}, {
   3.629386002444181*^9, 3.629386034619576*^9}, {3.6340489269883537`*^9, 
   3.634048969167013*^9}, {3.683957724284972*^9, 
   3.6839577243226557`*^9}},ExpressionUUID->"ce8c11db-c164-4f5b-afe0-\
27a6f38c1835"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DividedEventPropagators", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"BackgroundGenerator", "\[Rule]", "None"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"InitialTimePoint", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Method", "\[Rule]", "Automatic"}], ",", "\[IndentingNewLine]", 
     RowBox[{"AccuracyGoal", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PrecisionGoal", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"MaxStepSize", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"MaxSteps", "\[Rule]", "Automatic"}]}], "}"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.626001285649837*^9, 3.62600130004208*^9}, {
   3.6260025410093937`*^9, 3.626002549401597*^9}, 3.6260087164040194`*^9, {
   3.626015165925542*^9, 3.626015170763397*^9}, 3.626016369250193*^9, {
   3.626028160612364*^9, 3.6260281608736763`*^9}, 3.626028402079693*^9, 
   3.709375555112513*^9, {3.7130260297092113`*^9, 3.713026034276363*^9}},
 CellLabel->
  "In[2204]:=",ExpressionUUID->"1e98aaed-6d3b-4646-a80c-b013796c3d5e"],

Cell[CellGroupData[{

Cell["BackgroundGenerator is compatible with repetitions", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.626008750478898*^9, 3.6260088005439568`*^9}, {
   3.62600959867705*^9, 3.626009614920927*^9}, {3.626010373304895*^9, 
   3.6260103920352573`*^9}, 3.6260153231180983`*^9, 3.626016984398726*^9, 
   3.709375555147832*^9},ExpressionUUID->"9b3d362a-2e6a-4bba-a77b-\
5dafdb6ac99e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DividedEventPropagators", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"type_", ",", "T_", ",", "n_"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"divevent", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_Integer", ",", "_EventSpecifications"}], "}"}], ".."}], 
       "}"}]}], ",", "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=",
    "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "dim", ",", "evbackg", ",", "standevbackg", ",", "nreps", ",", 
       "evspeclists", ",", "evlists", ",", "props", ",", "Sjset"}], "}"}], 
     ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"nreps", ",", "evspeclists"}], "}"}], "=", 
         RowBox[{"Transpose", "[", "divevent", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"evlists", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"EventList", "[", 
            RowBox[{"#", ",", "opts"}], "]"}], "&"}], "/@", "evspeclists"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"props", "=", 
         RowBox[{"Switch", "[", 
          RowBox[{
          "type", ",", "\[IndentingNewLine]", "Superoperator", ",", 
           "\[IndentingNewLine]", "\t", 
           RowBox[{
            RowBox[{
             RowBox[{"NPropagationSuperoperator", "[", 
              RowBox[{"#", ",", "opbasis", ",", "basis", ",", "opts"}], "]"}],
              "&"}], "/@", "evlists"}], ",", "\[IndentingNewLine]", 
           "Operator", ",", "\[IndentingNewLine]", "\t", 
           RowBox[{
            RowBox[{
             RowBox[{"NPropagationOperator", "[", 
              RowBox[{"#", ",", "basis", ",", "opts"}], "]"}], "&"}], "/@", 
            "evlists"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Sjset", "=", 
         RowBox[{"Switch", "[", 
          RowBox[{"type", ",", "\[IndentingNewLine]", "Superoperator", ",", 
           RowBox[{
            RowBox[{"dim", "=", 
             RowBox[{
              RowBox[{"BasisDimension", "[", "basis", "]"}], "^", "2"}]}], 
            ";", 
            RowBox[{
             RowBox[{
              RowBox[{"SuperoperatorMatrixRepresentation", "[", 
               RowBox[{"#", ",", "opbasis"}], "]"}], "&"}], "/@", 
             RowBox[{"Flatten", "@", 
              RowBox[{"MapThread", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Table", "[", 
                  RowBox[{"#2", ",", 
                   RowBox[{"{", "#1", "}"}]}], "]"}], "&"}], ",", 
                RowBox[{"{", 
                 RowBox[{"nreps", ",", "props"}], "}"}]}], "]"}]}]}]}], ",", 
           "\[IndentingNewLine]", "Operator", ",", 
           RowBox[{
            RowBox[{"dim", "=", 
             RowBox[{"BasisDimension", "[", "basis", "]"}]}], ";", 
            RowBox[{
             RowBox[{
              RowBox[{"MatrixRepresentation", "[", 
               RowBox[{"#", ",", "basis"}], "]"}], "&"}], "/@", 
             RowBox[{"Flatten", "@", 
              RowBox[{"MapThread", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Table", "[", 
                  RowBox[{"#2", ",", 
                   RowBox[{"{", "#1", "}"}]}], "]"}], "&"}], ",", 
                RowBox[{"{", 
                 RowBox[{"nreps", ",", "props"}], "}"}]}], "]"}]}]}]}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"FoldList", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Dot", "[", 
            RowBox[{"#2", ",", "#1"}], "]"}], "&"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"SparseArray", "@", 
           RowBox[{"DiagonalMatrix", "[", 
            RowBox[{"Table", "[", 
             RowBox[{"1", ",", 
              RowBox[{"{", "dim", "}"}]}], "]"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Reverse", "@", "Sjset"}]}], "]"}]}], "\[IndentingNewLine]",
        ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"evbackg", "=", 
         RowBox[{
          RowBox[{"BackgroundGenerator", "/.", 
           RowBox[{"{", "opts", "}"}]}], "/.", 
          RowBox[{"Options", "[", "DividedEventPropagators", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"standevbackg", "=", 
         RowBox[{"StandardizeGenerator", "[", "evbackg", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"MatchQ", "[", 
         RowBox[{"standevbackg", ",", 
          RowBox[{
           RowBox[{"_", "?", "OperatorQ"}], "|", 
           RowBox[{"_", "?", "SuperoperatorQ"}], "|", 
           "NullGeneratorPattern"}]}], "]"}]}], "\[IndentingNewLine]", 
       ")"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.62601534244963*^9, 3.626015363971154*^9}, {
   3.626015394718357*^9, 3.626015415769844*^9}, {3.626015490966639*^9, 
   3.626015510711598*^9}, {3.6260155438344*^9, 3.626015661120654*^9}, {
   3.626015697855654*^9, 3.62601573488072*^9}, {3.626015796961543*^9, 
   3.626015895472124*^9}, {3.6260161682065973`*^9, 3.626016187876658*^9}, {
   3.626016460677352*^9, 3.626016554532009*^9}, 3.626027977270195*^9, {
   3.626028254015094*^9, 3.626028256494728*^9}, {3.626028409352051*^9, 
   3.6260284100535517`*^9}, 3.6268703073681498`*^9, {3.626870804263228*^9, 
   3.6268708319427233`*^9}, {3.626870941697949*^9, 3.626871003142892*^9}, {
   3.6268711841028357`*^9, 3.62687120610783*^9}, {3.62687130883377*^9, 
   3.626871316895631*^9}, {3.6268713898280573`*^9, 3.626871408537595*^9}, {
   3.6268715396894827`*^9, 3.62687158121776*^9}, {3.626871621154216*^9, 
   3.626871621356989*^9}, 3.626871651959853*^9, 3.627031024912582*^9, {
   3.62938588393219*^9, 3.6293858992100983`*^9}, 3.683957724349854*^9, 
   3.709374051953114*^9, 3.7093744845645733`*^9, 3.709375026506132*^9, {
   3.7099793189348745`*^9, 3.70997934598466*^9}, {3.7099795841496487`*^9, 
   3.709979585527332*^9}, {3.709979648070302*^9, 3.7099796482327375`*^9}, {
   3.713025832280981*^9, 3.7130258356942883`*^9}, {3.713025882921945*^9, 
   3.713025883213953*^9}, {3.7130267464304*^9, 3.7130267489939814`*^9}, {
   3.713026793364073*^9, 3.713026793504141*^9}, {3.713027474242775*^9, 
   3.713027475925692*^9}, {3.713027653298363*^9, 3.7130276534485197`*^9}, {
   3.7130367504623766`*^9, 3.7130367510721684`*^9}, {3.7130371783288994`*^9, 
   3.7130372547710247`*^9}, {3.7130372969803605`*^9, 
   3.7130372971799774`*^9}, {3.7135984881593013`*^9, 3.713598491211776*^9}, {
   3.7135987042769175`*^9, 3.7135987069922347`*^9}, {3.7135989368267355`*^9, 
   3.713598951972021*^9}, {3.713599054285553*^9, 3.713599090725443*^9}, {
   3.7135992951085186`*^9, 3.713599295671077*^9}, {3.713601014402549*^9, 
   3.7136010186047363`*^9}, {3.713602451310252*^9, 3.713602452872423*^9}, {
   3.7136033218680553`*^9, 3.71360332202046*^9}, {3.7136038557206135`*^9, 
   3.713603855872012*^9}, {3.7136048058182845`*^9, 3.71360481036131*^9}, {
   3.713605015516439*^9, 3.7136050653162713`*^9}, {3.713605179307658*^9, 
   3.713605196188372*^9}, {3.7136182152827663`*^9, 3.7136182578293133`*^9}, {
   3.7136371128337703`*^9, 3.7136371384922156`*^9}, {3.728466467385908*^9, 
   3.7284666407158985`*^9}, {3.7284666838713727`*^9, 3.728466702653036*^9}, {
   3.7284667477969956`*^9, 3.728466748063444*^9}, {3.728468066121185*^9, 
   3.728468086845508*^9}},
 CellLabel->
  "In[2205]:=",ExpressionUUID->"2bfaa727-85f3-4da8-b2eb-00fd989c05f3"]
}, Open  ]],

Cell[CellGroupData[{

Cell["BackgroundGenerator is incompatible with repetitions", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.626008750478898*^9, 3.6260088005439568`*^9}, {
   3.62600959867705*^9, 3.626009614920927*^9}, {3.626010373304895*^9, 
   3.6260103920352573`*^9}, {3.626016972000054*^9, 3.626016978523122*^9}, 
   3.709375555123426*^9},ExpressionUUID->"44ba871c-c79d-4e00-adbd-\
69f5505511fd"],

Cell["\<\
expand out the repetitions, determine the initial time points for each \
segment, and calculate the propagators individually\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.626011297846334*^9, 
  3.626011319694233*^9}},ExpressionUUID->"666a8051-8c0d-4c52-beea-\
109099a3c48e"],

Cell[CellGroupData[{

Cell["Expand out any repeated events", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.626008750478898*^9, 3.6260088005439568`*^9}, {
  3.62600959867705*^9, 3.626009614920927*^9}, {3.626010373304895*^9, 
  3.626010397581667*^9}},ExpressionUUID->"e7135fd1-6282-4a98-878f-\
b0556854ecd4"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DividedEventPropagators", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"type_", ",", "T_", ",", "n_"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"divevent", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_Integer", ",", "_EventSpecifications"}], "}"}], ".."}], 
       "}"}]}], ",", 
     RowBox[{"more", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", "opts___Rule"}],
     "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"evbackg", ",", "standevbackg"}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{"DividedEventPropagators", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"type", ",", "T", ",", "n"}], "}"}], ",", 
         RowBox[{"divevent", "/.", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"nrep", ":", 
              RowBox[{"Except", "[", "1", "]"}]}], ",", 
             "evspeclist_EventSpecifications"}], "}"}], "\[RuleDelayed]", 
           RowBox[{"Sequence", "@@", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "evspeclist"}], "}"}], ",", 
              RowBox[{"{", "nrep", "}"}]}], "]"}]}]}]}], ",", 
         "\[IndentingNewLine]", "more", ",", "\[IndentingNewLine]", "opts"}], 
        "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", ")"}], "/;", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"First", "/@", "divevent"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ".."}], "}"}]}], "]"}]}], "&&", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"evbackg", "=", 
           RowBox[{
            RowBox[{"BackgroundGenerator", "/.", 
             RowBox[{"{", "opts", "}"}]}], "/.", 
            RowBox[{"Options", "[", "DividedEventPropagators", "]"}]}]}], ";",
           "\[IndentingNewLine]", 
          RowBox[{"standevbackg", "=", 
           RowBox[{"StandardizeGenerator", "[", "evbackg", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"!", 
           RowBox[{"MatchQ", "[", 
            RowBox[{"standevbackg", ",", 
             RowBox[{
              RowBox[{"_", "?", "OperatorQ"}], "|", 
              RowBox[{"_", "?", "SuperoperatorQ"}], "|", 
              "NullGeneratorPattern"}]}], "]"}]}]}], "\[IndentingNewLine]", 
         ")"}]}], "\[IndentingNewLine]", ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6260096234163313`*^9, 3.6260096602727413`*^9}, {
   3.6260097153135*^9, 3.626009725605927*^9}, {3.62600982922584*^9, 
   3.626009996813767*^9}, {3.626010208179379*^9, 3.6260102136689568`*^9}, {
   3.626010251876795*^9, 3.626010346348837*^9}, {3.626012177984151*^9, 
   3.6260121817089167`*^9}, 3.6260153991162643`*^9, {3.6260161200024157`*^9, 
   3.626016134525066*^9}, {3.6260163797345867`*^9, 3.6260164165146503`*^9}, {
   3.626028249903551*^9, 3.626028259268066*^9}, {3.626028402795882*^9, 
   3.626028406150115*^9}, 3.6268703568092823`*^9, {3.683957724332251*^9, 
   3.6839577243348293`*^9}, 3.709374051946508*^9, 3.709374483843359*^9, 
   3.709375555135366*^9, {3.709979545478026*^9, 3.7099795479045043`*^9}, {
   3.709979654310868*^9, 3.7099796544462233`*^9}, {3.713026600651578*^9, 
   3.713026602513232*^9}, {3.7130266769271884`*^9, 3.713026677042774*^9}, {
   3.713603546569248*^9, 3.7136035504204955`*^9}, {3.7136035840328965`*^9, 
   3.7136035841882877`*^9}, {3.7136043262299275`*^9, 3.713604328992258*^9}, 
   3.713604818745533*^9, {3.713604879284767*^9, 3.7136048829715242`*^9}, {
   3.7136056740240383`*^9, 3.713605674160372*^9}, {3.7284680071338453`*^9, 
   3.7284680395602036`*^9}},
 CellLabel->
  "In[2206]:=",ExpressionUUID->"f4b10839-adca-46cb-9ef0-8c1a0a072814"]
}, Open  ]],

Cell[CellGroupData[{

Cell["BackgroundGenerator is a None event", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.626008750478898*^9, 3.6260088005439568`*^9}, {
   3.62600959867705*^9, 3.626009614920927*^9}, {3.626010373304895*^9, 
   3.6260103920352573`*^9}, 3.6260153231180983`*^9, 3.626016984398726*^9, 
   3.709375555147832*^9, {3.7136042226690803`*^9, 
   3.7136042244217615`*^9}},ExpressionUUID->"9b3d362a-2e6a-4bba-a77b-\
5dafdb6ac99e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DividedEventPropagators", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Operator", ",", "T_", ",", "n_"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"divevent", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", 
          RowBox[{"EventSpecifications", "[", 
           RowBox[{"True", ",", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"None", ",", "_"}], "}"}], "}"}], ",", 
            "evopts___Rule"}], "]"}]}], "}"}], ".."}], "}"}]}], ",", 
     "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "tinivals", ",", "tini", ",", "evspeclist", ",", "UonePeriod", ",", 
       "\[Tau]list"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tini", "=", 
        RowBox[{
         RowBox[{"InitialTimePoint", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "DividedEventPropagators", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"evspeclist", "=", 
        RowBox[{
         RowBox[{"Last", "[", 
          RowBox[{
          "divevent", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
          "]"}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"EventSpecifications", "[", 
            RowBox[{"bool_", ",", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"a_", ",", "\[Delta]t_"}], "}"}], "}"}], ",", 
             "opts$___Rule"}], "]"}], "\[RuleDelayed]", 
           RowBox[{"EventSpecifications", "[", 
            RowBox[{"bool", ",", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"a", ",", 
                RowBox[{
                 RowBox[{"Length", "[", "divevent", "]"}], "*", 
                 "\[Delta]t"}]}], "}"}], "}"}], ",", "opts$"}], "]"}]}], 
          "}"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"UonePeriod", "=", 
        RowBox[{"DividedEventPropagators", "[", "\[IndentingNewLine]", 
         RowBox[{
         "Operator", ",", "\[IndentingNewLine]", "evspeclist", ",", 
          "\[IndentingNewLine]", "opbasis", ",", "basis", ",", 
          RowBox[{"InitialTimePoint", "\[Rule]", "tini"}], ",", "opts"}], 
         "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Tau]list", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "\[Times]", 
           RowBox[{"(", 
            RowBox[{"T", "/", "n"}], ")"}]}], "&"}], "/@", 
         RowBox[{"Range", "[", 
          RowBox[{"0", ",", "n"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"MatrixRepresentation", "[", 
          RowBox[{
           RowBox[{"UonePeriod", "[", "#", "]"}], ",", "basis"}], "]"}], 
         "&"}], "/@", "\[Tau]list"}]}], "\[IndentingNewLine]", ")"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.62601534244963*^9, 3.626015363971154*^9}, {
   3.626015394718357*^9, 3.626015415769844*^9}, {3.626015490966639*^9, 
   3.626015510711598*^9}, {3.6260155438344*^9, 3.626015661120654*^9}, {
   3.626015697855654*^9, 3.62601573488072*^9}, {3.626015796961543*^9, 
   3.626015895472124*^9}, {3.6260161682065973`*^9, 3.626016187876658*^9}, {
   3.626016460677352*^9, 3.626016554532009*^9}, 3.626027977270195*^9, {
   3.626028254015094*^9, 3.626028256494728*^9}, {3.626028409352051*^9, 
   3.6260284100535517`*^9}, 3.6268703073681498`*^9, {3.626870804263228*^9, 
   3.6268708319427233`*^9}, {3.626870941697949*^9, 3.626871003142892*^9}, {
   3.6268711841028357`*^9, 3.62687120610783*^9}, {3.62687130883377*^9, 
   3.626871316895631*^9}, {3.6268713898280573`*^9, 3.626871408537595*^9}, {
   3.6268715396894827`*^9, 3.62687158121776*^9}, {3.626871621154216*^9, 
   3.626871621356989*^9}, 3.626871651959853*^9, 3.627031024912582*^9, {
   3.62938588393219*^9, 3.6293858992100983`*^9}, 3.683957724349854*^9, 
   3.709374051953114*^9, 3.7093744845645733`*^9, 3.709375026506132*^9, {
   3.7099793189348745`*^9, 3.70997934598466*^9}, {3.7099795841496487`*^9, 
   3.709979585527332*^9}, {3.709979648070302*^9, 3.7099796482327375`*^9}, {
   3.713025832280981*^9, 3.7130258356942883`*^9}, {3.713025882921945*^9, 
   3.713025883213953*^9}, {3.7130267464304*^9, 3.7130267489939814`*^9}, {
   3.713026793364073*^9, 3.713026793504141*^9}, {3.713027474242775*^9, 
   3.713027475925692*^9}, {3.713027653298363*^9, 3.7130276534485197`*^9}, {
   3.7130367504623766`*^9, 3.7130367510721684`*^9}, {3.7130371783288994`*^9, 
   3.7130372547710247`*^9}, {3.7130372969803605`*^9, 
   3.7130372971799774`*^9}, {3.71308998843419*^9, 3.713089990106753*^9}, {
   3.7130900334672165`*^9, 3.7130900335991964`*^9}, {3.7136013119842453`*^9, 
   3.7136013241605587`*^9}, {3.713601364866765*^9, 3.713601380123613*^9}, {
   3.7136014758873196`*^9, 3.7136014806137414`*^9}, {3.713601577228628*^9, 
   3.7136016603043013`*^9}, {3.7136019853066216`*^9, 3.713602000877953*^9}, {
   3.713602101645666*^9, 3.7136021017659864`*^9}, {3.71360285256559*^9, 
   3.713602857606969*^9}, {3.7136029410885077`*^9, 3.713602971165351*^9}, {
   3.7136030298306503`*^9, 3.7136030668376245`*^9}, {3.7136031213869324`*^9, 
   3.713603151339418*^9}, {3.7136034526584606`*^9, 3.7136034558489428`*^9}, {
   3.713604172163077*^9, 3.713604207857777*^9}, {3.71360425875083*^9, 
   3.7136042604583635`*^9}, {3.7136043317575693`*^9, 3.713604333250535*^9}, {
   3.713604384294016*^9, 3.713604384526632*^9}, 3.713604513587136*^9, {
   3.713604544518631*^9, 3.7136045483798103`*^9}, {3.7136045878538275`*^9, 
   3.7136046097274313`*^9}, {3.7136047212103405`*^9, 3.713604730171026*^9}, 
   3.713604820773902*^9, 3.7136048548089733`*^9, {3.7136048905917273`*^9, 
   3.7136049302366486`*^9}, {3.713605235972432*^9, 3.7136052754519773`*^9}, {
   3.7136053068009615`*^9, 3.7136053242090855`*^9}, {3.7136053644729342`*^9, 
   3.7136053694361415`*^9}, {3.713605669421796*^9, 3.7136056695691624`*^9}, {
   3.713618275893836*^9, 3.7136182978047743`*^9}, {3.7136183370701556`*^9, 
   3.713618353456401*^9}, {3.7136371542585754`*^9, 3.7136371720998983`*^9}},
 CellLabel->
  "In[2207]:=",ExpressionUUID->"2bfaa727-85f3-4da8-b2eb-00fd989c05f3"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Determine starting time points and construct non-repeated EventLists\
\>", "Subsubsection",
 InitializationCell->True,
 CellChangeTimes->{{3.626008750478898*^9, 3.6260088005439568`*^9}, {
  3.62600959867705*^9, 3.626009614920927*^9}, {3.626010373304895*^9, 
  3.626010428026243*^9}, {3.626010491592904*^9, 3.626010503101426*^9}, {
  3.626017027588846*^9, 
  3.626017030096447*^9}},ExpressionUUID->"c43260af-3ce4-488c-bf5a-\
ae22bf6c941a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DividedEventPropagators", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"type_", ",", "T_", ",", "n_"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"divevent", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "_EventSpecifications"}], "}"}], ".."}], "}"}]}], 
     ",", 
     RowBox[{"more", ":", 
      RowBox[{
       RowBox[{"Except", "[", "_Rule", "]"}], "..."}]}], ",", "opbasis_", ",",
      "basis_", ",", "opts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "dim", ",", "tinivals", ",", "tini", ",", "evspeclists", ",", "props", 
       ",", "Sjset"}], "}"}], ",", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tini", "=", 
        RowBox[{
         RowBox[{"InitialTimePoint", "/.", 
          RowBox[{"{", "opts", "}"}]}], "/.", 
         RowBox[{"Options", "[", "DividedEventPropagators", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"evspeclists", "=", 
        RowBox[{"Last", "/@", "divevent"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"tinivals", "=", 
        RowBox[{"Reverse", "@", 
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"FoldList", "[", 
            RowBox[{"Plus", ",", "tini", ",", 
             RowBox[{"EventDuration", "/@", 
              RowBox[{"Reverse", "[", "evspeclists", "]"}]}]}], "]"}], ",", 
           RowBox[{"-", "1"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"props", "=", 
        RowBox[{"DividedEventPropagators", "[", "\[IndentingNewLine]", 
         RowBox[{"type", ",", "\[IndentingNewLine]", 
          RowBox[{"MapThread", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"EventList", "[", 
                RowBox[{"#1", ",", 
                 RowBox[{"InitialTimePoint", "\[Rule]", "#2"}], ",", "opts"}],
                 "]"}]}], "}"}], "&"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"evspeclists", ",", "tinivals"}], "}"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "more", 
          ",", "opts"}], "\[IndentingNewLine]", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Sjset", "=", 
        RowBox[{"Switch", "[", 
         RowBox[{"type", ",", "\[IndentingNewLine]", "Superoperator", ",", 
          RowBox[{
           RowBox[{"dim", "=", 
            RowBox[{
             RowBox[{"BasisDimension", "[", "basis", "]"}], "^", "2"}]}], ";", 
           RowBox[{
            RowBox[{
             RowBox[{"SuperoperatorMatrixRepresentation", "[", 
              RowBox[{"#", ",", "opbasis"}], "]"}], "&"}], "/@", "props"}]}], 
          ",", "\[IndentingNewLine]", "Operator", ",", 
          RowBox[{
           RowBox[{"dim", "=", 
            RowBox[{"BasisDimension", "[", "basis", "]"}]}], ";", 
           RowBox[{
            RowBox[{
             RowBox[{"MatrixRepresentation", "[", 
              RowBox[{"#", ",", "basis"}], "]"}], "&"}], "/@", "props"}]}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"FoldList", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"Dot", "[", 
           RowBox[{"#2", ",", "#1"}], "]"}], "&"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"SparseArray", "@", 
          RowBox[{"DiagonalMatrix", "[", 
           RowBox[{"Table", "[", 
            RowBox[{"1", ",", 
             RowBox[{"{", "dim", "}"}]}], "]"}], "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Reverse", "@", "Sjset"}]}], "]"}]}], "\[IndentingNewLine]", 
      ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6260096234163313`*^9, 3.6260096602727413`*^9}, {
   3.6260097153135*^9, 3.626009725605927*^9}, {3.62600982922584*^9, 
   3.626009996813767*^9}, {3.626010208179379*^9, 3.6260102136689568`*^9}, {
   3.626010251876795*^9, 3.626010346348837*^9}, {3.626010431492934*^9, 
   3.6260104355252132`*^9}, {3.626010522860512*^9, 3.626010555226533*^9}, {
   3.626010595047414*^9, 3.626010597562366*^9}, {3.626010703217861*^9, 
   3.626010771647237*^9}, 3.626010808782571*^9, {3.626010975775634*^9, 
   3.626011159814077*^9}, {3.62601124644454*^9, 3.626011271825569*^9}, {
   3.6260114431383944`*^9, 3.626011457472618*^9}, {3.6260115611917877`*^9, 
   3.626011565274667*^9}, {3.626015520265149*^9, 3.6260155318967867`*^9}, {
   3.626016142103771*^9, 3.6260161525601463`*^9}, {3.6260164274492903`*^9, 
   3.6260164508134317`*^9}, {3.626028252476869*^9, 3.626028253251789*^9}, {
   3.626028407109284*^9, 3.626028408598549*^9}, 3.680955522255494*^9, 
   3.683957724341941*^9, {3.7099795786691327`*^9, 3.7099795798853345`*^9}, {
   3.7099796515836296`*^9, 3.7099796520147743`*^9}, {3.7130258965501127`*^9, 
   3.7130258968133793`*^9}, {3.713025940841383*^9, 3.7130259410110884`*^9}, {
   3.713026101427782*^9, 3.7130261041387815`*^9}, {3.713026326147853*^9, 
   3.7130263534186726`*^9}, {3.713037623615405*^9, 3.7130376458941813`*^9}, {
   3.7130377163111744`*^9, 3.713037716454159*^9}, {3.713598421336172*^9, 
   3.713598436034969*^9}, {3.7135984805391626`*^9, 3.7135984826730785`*^9}, {
   3.7135993221353407`*^9, 3.7135993222787695`*^9}, {3.713599398559916*^9, 
   3.713599398750471*^9}, {3.7136038695836983`*^9, 3.7136038795391207`*^9}, {
   3.713603914513968*^9, 3.7136039146643305`*^9}, {3.713605405630186*^9, 
   3.7136054621683955`*^9}, {3.7136055150070515`*^9, 3.71360553320747*^9}, {
   3.7136055697095604`*^9, 3.713605579608898*^9}, {3.713605667173823*^9, 
   3.713605671574524*^9}, {3.713616385717291*^9, 3.71361639827262*^9}, {
   3.713616882778471*^9, 3.7136168958994937`*^9}, {3.7136169471484256`*^9, 
   3.7136169683412724`*^9}, {3.7136170243646083`*^9, 
   3.7136170441979914`*^9}, {3.713617077732044*^9, 3.7136170931984553`*^9}, {
   3.7136171281051826`*^9, 3.713617130886713*^9}, {3.7136371914947796`*^9, 
   3.7136372352678957`*^9}},
 CellLabel->
  "In[2208]:=",ExpressionUUID->"86e5ff0d-97b5-4a4b-8492-523284930e50"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Determine propagators for a set of EventLists with no repetitions\
\>", "Subsection",
 InitializationCell->True,
 CellChangeTimes->{{3.626008750478898*^9, 3.6260088005439568`*^9}, {
  3.62600959867705*^9, 3.626009614920927*^9}, {3.626010373304895*^9, 
  3.626010428026243*^9}, {3.626010491592904*^9, 3.626010503101426*^9}, {
  3.6260114039063807`*^9, 3.626011413682197*^9}, {3.626011529542666*^9, 
  3.626011530891011*^9}, {3.626016840885181*^9, 
  3.62601684434818*^9}},ExpressionUUID->"50cb6e1d-dc41-4cb8-8c0d-\
e62d1d4c8c9b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DividedEventPropagators", "[", 
   RowBox[{"Superoperator", ",", 
    RowBox[{"diveventlists", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "_EventList"}], "}"}], ".."}], "}"}]}], ",", 
    "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationSuperoperator", "[", 
     RowBox[{
      RowBox[{"Last", "[", "#", "]"}], ",", "opbasis", ",", "basis", ",", 
      "opts"}], "]"}], "&"}], "/@", "diveventlists"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6260114638411694`*^9, 3.6260114969597692`*^9}, {
   3.626011579968739*^9, 3.626011630268159*^9}, {3.6260118414670563`*^9, 
   3.626011844256219*^9}, {3.6260150950587063`*^9, 3.6260151220463963`*^9}, {
   3.626015185490965*^9, 3.626015229221496*^9}, {3.6260162322708178`*^9, 
   3.626016245860651*^9}, {3.62601656318887*^9, 3.626016592237377*^9}, {
   3.626027994109995*^9, 3.626027995535852*^9}, 3.62602825733954*^9, 
   3.6260284109003983`*^9, {3.626084877426062*^9, 3.626084892684494*^9}},
 CellLabel->
  "In[2209]:=",ExpressionUUID->"8fa1ae1a-ca21-4a5d-a3db-2d2a31812c29"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DividedEventPropagators", "[", 
   RowBox[{"Operator", ",", 
    RowBox[{"diveventlists", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1", ",", "_EventList"}], "}"}], ".."}], "}"}]}], ",", 
    "opbasis_", ",", "basis_", ",", "opts___Rule"}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"NPropagationOperator", "[", 
     RowBox[{
      RowBox[{"Last", "[", "#", "]"}], ",", "basis", ",", "opts"}], "]"}], 
    "&"}], "/@", "diveventlists"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6260114638411694`*^9, 3.6260114969597692`*^9}, {
   3.626011579968739*^9, 3.626011630268159*^9}, {3.6260118414670563`*^9, 
   3.626011844256219*^9}, {3.6260150950587063`*^9, 3.6260151220463963`*^9}, {
   3.626015185490965*^9, 3.626015229221496*^9}, {3.6260162322708178`*^9, 
   3.626016245860651*^9}, {3.62601656318887*^9, 3.6260166060175457`*^9}, {
   3.626028002717533*^9, 3.626028004290333*^9}, 3.626028257995625*^9, 
   3.626028411541922*^9, {3.6260849059261637`*^9, 3.626084909073969*^9}, {
   3.709979379223836*^9, 3.70997941049485*^9}, {3.713026263629098*^9, 
   3.7130262706884823`*^9}, {3.713026313238999*^9, 3.7130263155880947`*^9}},
 CellLabel->
  "In[2210]:=",ExpressionUUID->"7237f907-a8fd-4aca-b10d-cf8134a284c1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"DividedEventPropagators", "[", 
   RowBox[{"Operator", ",", 
    RowBox[{"evspec", ":", "_EventSpecifications"}], ",", "opbasis_", ",", 
    "basis_", ",", "sigopts___Rule"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"NPropagationOperator", "[", 
   RowBox[{"evspec", ",", "basis", ",", 
    RowBox[{"Continuous", "\[Rule]", " ", "True"}], ",", 
    RowBox[{"Sequence", "@@", 
     RowBox[{"FilterRules", "[", 
      RowBox[{
       RowBox[{"{", "sigopts", "}"}], ",", 
       RowBox[{"Options", "[", "NPropagationOperator", "]"}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6260114638411694`*^9, 3.6260114969597692`*^9}, {
   3.626011579968739*^9, 3.626011630268159*^9}, {3.6260118414670563`*^9, 
   3.626011844256219*^9}, {3.6260150950587063`*^9, 3.6260151220463963`*^9}, {
   3.626015185490965*^9, 3.626015229221496*^9}, {3.6260162322708178`*^9, 
   3.626016245860651*^9}, {3.62601656318887*^9, 3.6260166060175457`*^9}, {
   3.626028002717533*^9, 3.626028004290333*^9}, 3.626028257995625*^9, 
   3.626028411541922*^9, {3.6260849059261637`*^9, 3.626084909073969*^9}, {
   3.709979379223836*^9, 3.70997941049485*^9}, {3.713026263629098*^9, 
   3.7130262706884823`*^9}, {3.713026313238999*^9, 3.7130263155880947`*^9}, {
   3.713086346861253*^9, 3.7130863636838255`*^9}, {3.7130868309713097`*^9, 
   3.713086839469737*^9}, {3.7130874896669226`*^9, 3.713087493009687*^9}, {
   3.71308882784138*^9, 3.7130888322795663`*^9}, {3.7130888660160637`*^9, 
   3.713088866156665*^9}, {3.713088924820603*^9, 3.7130889354561415`*^9}, {
   3.713089045842827*^9, 3.7130890725030727`*^9}, {3.7130892135507545`*^9, 
   3.713089271926586*^9}, {3.713089359724956*^9, 3.7130893600049834`*^9}, {
   3.713089400385624*^9, 3.7130894028443413`*^9}, {3.7131040716508455`*^9, 
   3.7131040900420666`*^9}, {3.7131041361540575`*^9, 3.713104142095561*^9}, {
   3.7131041727455044`*^9, 3.7131042105926313`*^9}, {3.713602982382118*^9, 
   3.713602984539813*^9}, {3.713603017612223*^9, 3.713603018123579*^9}, 
   3.7136031260192556`*^9},
 CellLabel->
  "In[2211]:=",ExpressionUUID->"7237f907-a8fd-4aca-b10d-cf8134a284c1"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["closure", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, {
   3.699957885713748*^9, 
   3.699957943233548*^9}},ExpressionUUID->"5c5a1564-4236-4d72-a102-\
3ef063b8352e"],

Cell[CellGroupData[{

Cell["release held options", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.470843247451812*^9, 3.4708432532973423`*^9}, {
  3.470843285339106*^9, 3.4708432863528547`*^9}, {3.4708443288879833`*^9, 
  3.470844330101821*^9}, {3.5028839670721397`*^9, 3.502883969062737*^9}, {
  3.502884110778058*^9, 
  3.502884118871526*^9}},ExpressionUUID->"6a645b51-6a1d-4fd0-b12a-\
ea7ae4cb22a0"],

Cell["\<\
if no evaluation is yet made, release the held options and try again\
\>", "Text",
 InitializationCell->True,
 CellChangeTimes->{{3.502883971470879*^9, 3.502883993678935*^9}, {
  3.50288412379401*^9, 
  3.502884136287917*^9}},ExpressionUUID->"4f56895d-3136-4901-8c14-\
0730a3e07063"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"signal1D", "[", 
     RowBox[{"args___", ",", 
      RowBox[{"rule", ":", 
       RowBox[{"Except", "[", "_Rule", "]"}]}], ",", "opts___Rule"}], "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{
      RowBox[{"Evaluate", "[", "rule", "]"}], ",", "_Rule"}], "]"}]}], ":=", 
   RowBox[{"signal1D", "[", 
    RowBox[{"args", ",", 
     RowBox[{"Evaluate", "[", "rule", "]"}], ",", "opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.502884020059135*^9, 3.502884087194989*^9}, 
   3.502884167406979*^9, {3.502884821355733*^9, 3.502884845983889*^9}, {
   3.502884881651362*^9, 3.502884952644002*^9}, {3.6999596520708523`*^9, 
   3.699959654287269*^9}},
 CellLabel->
  "In[2212]:=",ExpressionUUID->"4037a83f-66aa-4612-b203-c4e9845b2b64"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["messages", "Subsubtitle",
 InitializationCell->True,
 CellChangeTimes->{{3.455119111984703*^9, 3.455119113726385*^9}, {
   3.456338125870762*^9, 3.456338128092794*^9}, {3.464426854630291*^9, 
   3.464426855428462*^9}, {3.541442774600806*^9, 3.5414427905242567`*^9}, 
   3.541488256748209*^9, 3.6833678572992487`*^9, {3.683957788670847*^9, 
   3.683957789873822*^9}, {3.683959370434451*^9, 3.683959372582471*^9}, {
   3.683963462002846*^9, 3.683963467650033*^9}, 3.683963828516594*^9, {
   3.683973033466785*^9, 3.683973044514587*^9}, 3.6840002435345*^9, {
   3.699957885713748*^9, 
   3.699957972149035*^9}},ExpressionUUID->"42956da5-9d9d-41dd-8bc3-\
28af341b4514"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "unreck"}], "=", 
   "\"\<Unrecognized number of points: `1`. Proceeding using 1k \
points.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469877762355247*^9, 3.4698778001257544`*^9}, {
   3.469877852201559*^9, 3.469877869418755*^9}, {3.4698785077518044`*^9, 
   3.4698785207951736`*^9}, 3.4701391034177513`*^9, {3.62695998220651*^9, 
   3.626960046459655*^9}},
 CellLabel->
  "In[2213]:=",ExpressionUUID->"e2a66b13-2737-4a4f-bc04-4fd47a5682f6"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "unrecogmethod"}], "=", 
   "\"\<Unrecognized SignalCalculationMethod for Signal1D.\>\""}], 
  ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.469877762355247*^9, 3.4698778001257544`*^9}, {
   3.469877852201559*^9, 3.469877869418755*^9}, {3.4698785077518044`*^9, 
   3.4698785207951736`*^9}, 3.4701391034177513`*^9},
 CellLabel->
  "In[2214]:=",ExpressionUUID->"e660b383-18a0-4cf6-b323-57755766875c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "noadj\[Delta]t"}], "=", 
   "\"\<Period must have a numeric value. Evaluation will proceed without \
adjusting the sampling interval \[Delta]t\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.500068671197753*^9, 3.500068696188752*^9}},
 CellLabel->
  "In[2215]:=",ExpressionUUID->"88404507-2d08-4046-b79f-76f00cadd132"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "nonumperiod"}], "=", 
   "\"\<Period must have a numeric value. Evaluation will proceed using \
SignalCalculationMethod\[Rule]\\\"Direct\\\"\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.470810560453443*^9, 3.47081057008339*^9}, {
  3.470811022775778*^9, 3.4708110719084063`*^9}},
 CellLabel->
  "In[2216]:=",ExpressionUUID->"cbaff171-97f2-4e22-872a-d0dd6fdf431f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "new\[Delta]t"}], "=", 
   "\"\<Sampling interval has been adjusted to `1` s for compatibility with \
the periodicity of the specified events and/or the \
BackgroundGenerator.\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.470811815976449*^9, 3.470811859582847*^9}, 
   3.470831194663021*^9, {3.4708313645882263`*^9, 3.470831365207724*^9}, {
   3.470844444392531*^9, 3.470844445570483*^9}, {3.4992968902013483`*^9, 
   3.499296910381939*^9}, {3.5044453303051147`*^9, 3.504445391441854*^9}, {
   3.5319920275298347`*^9, 3.5319920278221273`*^9}, 3.709375026511273*^9},
 CellLabel->
  "In[2217]:=",ExpressionUUID->"cfa45168-b28b-4e19-b608-236526396e40"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "badtimes"}], "=", 
   "\"\<The timing specification `1` is inappropriate.\>\""}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.7004819578756247`*^9, 3.7004819824244013`*^9}},
 CellLabel->
  "In[2218]:=",ExpressionUUID->"a8a8200d-5b92-49b8-bb03-2d11bed9fb4f"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "zerorepeldur"}], "=", 
   "\"\<The repeating element may not have zero duration.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.499314654821986*^9, 3.499314674348922*^9}},
 CellLabel->
  "In[2219]:=",ExpressionUUID->"43dd2298-6fc5-4d65-8472-e94265928a21"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "nocarav"}], "=", 
   "\"\<CarouselAverage\[Rule]True requires \
SignalCalculationMethod\[Rule]\\\"COMPUTE\\\".\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.499316326025031*^9, 3.49931637136831*^9}, {
  3.7030856363385897`*^9, 3.703085648912985*^9}, {3.703085712328294*^9, 
  3.70308572652325*^9}, {3.7030890465731688`*^9, 3.703089080720986*^9}, {
  3.703089218982833*^9, 3.703089227514702*^9}, {3.703089526431448*^9, 
  3.703089535944475*^9}},
 CellLabel->
  "In[2220]:=",ExpressionUUID->"25dbca94-0ae5-46c0-bcaf-87d730d4ebf3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "caravwarn"}], "=", "\[IndentingNewLine]", 
   "\"\<The preparation sequence has finite duration. \
CarouselAverage\[Rule]True may not be appropriate in this case. Evaluation is \
proceeding anyway.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5028899206501923`*^9, 3.50288997266656*^9}, {
  3.502890227475865*^9, 3.502890245728855*^9}, {3.7030901661231413`*^9, 
  3.703090182611629*^9}, {3.7030906433557262`*^9, 3.7030906582491693`*^9}},
 CellLabel->
  "In[2221]:=",ExpressionUUID->"e55314fa-994c-41fe-a939-732d4814d25a"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "paderr"}], "=", 
   "\"\<Error in padding of events to fill acquisition time.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.499373783913425*^9, 3.4993738029893427`*^9}},
 CellLabel->
  "In[2222]:=",ExpressionUUID->"fabb5373-f288-4696-9d57-64c13e33e4e2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "reportscm"}], "=", 
   "\"\<Using SignalCalculationMethod \[Rule] `1`\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.499658775272642*^9, 3.499658803663351*^9}, {
  3.499659064361495*^9, 3.499659065886632*^9}},
 CellLabel->
  "In[2223]:=",ExpressionUUID->"fd561484-bd6f-41e6-80aa-e4939ad9fb50"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "diverr"}], "=", 
   "\"\<Incorrect construction of repeated elements: `1` should be equal to \
Round[`2` divided by `3`] = `4`.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.500167555180295*^9, 3.500167612931366*^9}, {
  3.500168546135903*^9, 3.5001685740930853`*^9}, {3.500168657653714*^9, 
  3.500168660556611*^9}, {3.502436771759652*^9, 3.5024367798699017`*^9}},
 CellLabel->
  "In[2224]:=",ExpressionUUID->"7c9cc369-14fc-4e01-b696-5245eab18038"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "nullprepbackg"}], "=", 
   "\"\<A value for BackgroundGenerator is probably intended when the \
preparation sequence has a finite duration. Calculation will proceed anyway \
using BackgroundGenerator\[Rule]None.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.505046778066638*^9, 3.505046934350897*^9}, {
  3.505047185747328*^9, 3.505047323370784*^9}, {3.505047468165696*^9, 
  3.505047506308681*^9}, {3.505725845290413*^9, 3.5057258655307417`*^9}, {
  3.709375026515881*^9, 3.709375026518456*^9}},
 CellLabel->
  "In[2225]:=",ExpressionUUID->"d6861e3b-9391-41b5-b65b-9b6491e5fc84"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "badnorm"}], "=", 
   "\"\<invalid normalization factor.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5330828862991247`*^9, 3.533082893537858*^9}, 
   3.533104706037471*^9},
 CellLabel->
  "In[2226]:=",ExpressionUUID->"d661fd92-a7a0-4ecc-a3a5-4f21c82b9220"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "zeronorm"}], "=", 
   "\"\<The normalization factor cannot be zero. Proceeding without \
normalization.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533083042469365*^9, 3.533083069891502*^9}, 
   3.5331047069732122`*^9},
 CellLabel->
  "In[2227]:=",ExpressionUUID->"946fb2b7-65da-4fe4-b964-fc915196289c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Signal1D", "::", "badensvar"}], "=", 
  "\"\<The variable used in the EnsembleAverage may not have an assigned \
value.\>\""}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53321393226892*^9, 3.533213932525598*^9}},
 CellLabel->
  "In[2228]:=",ExpressionUUID->"c029645c-0d86-429a-a799-036dc54da5d4"],

Cell[BoxData["\<\"The variable used in the EnsembleAverage may not have an \
assigned value.\"\>"], "Output",
 InitializationCell->True,
 CellChangeTimes->{{3.534388252264607*^9, 3.534388271259637*^9}, {
   3.534406243461494*^9, 3.5344062726565123`*^9}, {3.5344063578551693`*^9, 
   3.534406377340727*^9}, 3.534406586054036*^9, 3.5344066396330433`*^9, 
   3.534821248397716*^9, 3.534821293854287*^9, {3.54029432705634*^9, 
   3.540294353619578*^9}, {3.541444460395179*^9, 3.54144448068968*^9}, {
   3.541444889746983*^9, 3.541444909292778*^9}, 3.543845364227393*^9, 
   3.543845414503018*^9, 3.564569745695175*^9, 3.5645697786220007`*^9, 
   3.566374395937821*^9, {3.566374529184437*^9, 3.5663745507724943`*^9}, {
   3.566375001055208*^9, 3.5663750184223537`*^9}, 3.5725032247123623`*^9, {
   3.572503257991145*^9, 3.572503276229622*^9}, 3.572503710923156*^9, 
   3.586363626916134*^9, 3.586363663419964*^9, 3.586363813096661*^9, {
   3.621574063615218*^9, 3.621574092648368*^9}, 3.6666140987772202`*^9, {
   3.709381410456922*^9, 3.709381414434725*^9}, {3.70938145002871*^9, 
   3.709381458848336*^9}, 3.7093815392388353`*^9, {3.709381601833617*^9, 
   3.709381636426588*^9}, {3.7093817379347677`*^9, 3.709381742871516*^9}, 
   3.721773734418899*^9, 3.744272995229986*^9, 3.744273438929496*^9, 
   3.7442739499088583`*^9, 3.744274909449533*^9},
 CellLabel->
  "Out[2228]=",ExpressionUUID->"7bce68e2-93de-4c48-baa8-2bea6107f954"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "obsopobsol"}], "=", "\[IndentingNewLine]", 
   "\"\<ObservableOperator has been superseded by Observable.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.544622546516881*^9, 3.544622592802321*^9}, {
  3.6233425177910547`*^9, 3.623342518540553*^9}},
 CellLabel->
  "In[2229]:=",ExpressionUUID->"12248356-69bf-4c26-b3fe-0d41e9fc58f0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "invalobs"}], "=", 
   "\"\<The observable `1` is invalid.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.544623007752776*^9, 3.544623022034522*^9}, {
  3.681045222003874*^9, 3.681045233928088*^9}},
 CellLabel->
  "In[2230]:=",ExpressionUUID->"8370173e-f29b-4704-8de3-a2bda4cd55ac"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "invalchron"}], "=", 
   "\"\<Invalid setting for Chronology.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.544623007752776*^9, 3.544623022034522*^9}, {
  3.545060536247017*^9, 3.545060546597498*^9}},
 CellLabel->
  "In[2231]:=",ExpressionUUID->"884220fd-86a5-4df4-a7ce-6bfdeb6d4e49"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "autolb"}], "=", 
   "\"\<Using LineBroadening \[Rule] 2\[Pi] \[Times] `1` rad \
\!\(\*SuperscriptBox[\(s\), \(-1\)]\).\>\""}], ";"}]], "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 CellChangeTimes->{{3.497350419163645*^9, 3.497350449324395*^9}, {
   3.497434668733426*^9, 3.49743468603356*^9}, {3.4993159104943867`*^9, 
   3.499315915941661*^9}, {3.505928905016253*^9, 3.505928905174798*^9}, 
   3.505993359036067*^9, {3.531844845805813*^9, 3.531844846365452*^9}, {
   3.531845247528193*^9, 3.531845271703198*^9}, 3.566469330146323*^9},
 CellLabel->
  "In[2232]:=",ExpressionUUID->"0757a926-408a-4aed-999a-128eb00a6e63"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "parallel"}], "=", 
   "\"\<Parallel computation invoked by Signal1D\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5705432489840384`*^9, 3.570543280928747*^9}, {
  3.570543314455514*^9, 3.5705433364277554`*^9}, {3.570561321675194*^9, 
  3.5705613506353197`*^9}, {3.570884345374517*^9, 3.570884347052197*^9}},
 CellLabel->
  "In[2233]:=",ExpressionUUID->"ffdb4d26-0cf2-4a82-b711-8b5db8e28a9d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "badchron"}], "=", 
   "\"\<unknown setting for Chronology\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.587817378622898*^9, 3.587817395801531*^9}},
 CellLabel->
  "In[2234]:=",ExpressionUUID->"4cfd9fee-1428-4019-953d-26e8d8e56044"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "droplast"}], "=", 
   "\"\<the last sampling point has been dropped in order to get an even \
number of points.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.587819425614945*^9, 3.5878194429876413`*^9}, {
  3.587819552507732*^9, 3.587819569546755*^9}},
 CellLabel->
  "In[2235]:=",ExpressionUUID->"d82db7ae-a13f-41a3-aeab-52072f38a052"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "invalprep"}], "=", 
   "\"\<The Preparation sequence `1` is invalid.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.699964479526135*^9, 3.6999644956476393`*^9}},
 CellLabel->
  "In[2236]:=",ExpressionUUID->"63cf311f-715b-4643-91d6-51830af3c60e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "obspollevel"}], "=", 
   "\"\<PolarizationLevel is not a valid observable for Signal1D. Proceeding \
using PolarizationLevelOperator.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700569100885468*^9, 3.700569146650996*^9}},
 CellLabel->
  "In[2237]:=",ExpressionUUID->"83612025-a6da-4108-b0b9-958626dd8d40"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "obssingpollevel"}], "=", 
   "\"\<SingletPolarizationLevel is not a valid observable for Signal1D. \
Proceeding using SingletPolarizationLevelOperator.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.700569100885468*^9, 3.7005691502434053`*^9}},
 CellLabel->
  "In[2238]:=",ExpressionUUID->"3ec9a759-3213-4964-a387-10d088400c4e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "suspsymbs"}], "=", 
   "\"\<The following symbols do not have numerical values: `1`.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.701093796050228*^9, 3.701093848737091*^9}, {
  3.701093978300651*^9, 3.701093979196167*^9}},
 CellLabel->
  "In[2239]:=",ExpressionUUID->"1ac9b7ee-f89c-4de1-a64c-2976f1a4af8e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Signal1D", "::", "oddnCOMPUTE"}], "=", 
   "\"\<The COMPUTE algorithm cannot be performed with an odd number of \
subdivisions of the period.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.703007684640023*^9, 3.703007724893621*^9}},
 CellLabel->
  "In[2240]:=",ExpressionUUID->"48281e0d-283f-4399-b64d-1d46ff46879e"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["end", "Chapter",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True,
 AspectRatioFixed->
  True,ExpressionUUID->"e363ded0-e5b9-403e-ade2-d276411c9d85"],

Cell["\<\
End[];
EndPackage[];\
\>", "Input",
 PageWidth->WindowWidth,
 InitializationCell->True,
 InitializationGroup->True,
 CellChangeTimes->{{3.51238794480797*^9, 3.512387952205147*^9}, 
   3.513231730353488*^9},
 AspectRatioFixed->True,
 CellLabel->
  "In[2241]:=",ExpressionUUID->"fd0ecbf8-c225-4562-b051-e36f0ca73b62"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["history", "Title",
 PageWidth->WindowWidth,
 Evaluatable->False,
 CellChangeTimes->{
  3.682593334636269*^9, {3.69926171587668*^9, 3.69926172886936*^9}, {
   3.69926187929764*^9, 3.6992618809832497`*^9}},
 AspectRatioFixed->
  True,ExpressionUUID->"e419645f-11e1-4100-beb2-148e592e1e6f"],

Cell[CellGroupData[{

Cell["170325 changes incorporated into v3.0.0b10_CB", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699542530452357*^9, 3.6995425326806383`*^9}, {3.699545410099059*^9, 
   3.6995454103978543`*^9}, {3.699684558842494*^9, 
   3.699684559329362*^9}},ExpressionUUID->"82f0a69c-884f-4599-9470-\
fddb7c7b370a"],

Cell["\<\
CB: minor changes in TransformationAmplitude/Trajectory to harmonize with the \
new NPropagate structure:

1) The the implementation of the Events is now done in NPropagate. 

2) NPropagate[Qini_, opbasis_, basis_,more___] \[Rule] NPropagate[Qini_, \
OperatorBasis \[Rule] opbasis_, Basis \[Rule] basis_,more___] \
\>", "Text",
 CellChangeTimes->{{3.6992793268113956`*^9, 3.699279350177552*^9}, {
  3.6995424688031*^9, 3.6995424844515934`*^9}, {3.6995425465206327`*^9, 
  3.699542682270033*^9}, {3.699543154054568*^9, 
  3.699543189960311*^9}},ExpressionUUID->"52b30e8a-2d68-460a-8e0f-\
285ed91c579f"]
}, Closed]],

Cell["170328 packaged transferred from v3.0.0b10_CB to v3.0.0b11", \
"Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}},ExpressionUUID->"60a34cb3-36d2-424e-9bf2-\
404072c7ebdd"],

Cell["170331 development of Signal1D in v3.0.0b12", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 
   3.6999571579260406`*^9}},ExpressionUUID->"e33f6898-a881-44ce-9fca-\
95855ff594c7"],

Cell[CellGroupData[{

Cell["\<\
170502 fixed parallel problem in TransformationAmplitude/etc. [CB]\
\>", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.702729114382555*^9, 3.7027291389422092`*^9}, {3.702729256100906*^9, 
   3.7027292598717737`*^9}},ExpressionUUID->"a8c383cf-fb2e-469a-81f4-\
a0bda14f31fb"],

Cell["\<\
-Problem has been fixed by forcing \[OpenCurlyDoubleQuote]SetSpinSystem\
\[CloseCurlyDoubleQuote], the problem only occurs when the ensemble average \
variable is contained in the evolution background and the evolution \
background is given by a time-dependent function. I don\[CloseCurlyQuote]t \
fully understand why the SpinSystem is not recognized in this case, checking \
the the SpinSystem with SpinSystem[basis] \[Equal] SpinSystem[] gives True.

-I updated the default options for all the high-end routines to use \
MaxStepSize \[Rule] Automatic, etc...  Because of this I had to introduce a \
new option into Trajectory, called \
\[OpenCurlyDoubleQuote]InterpolationStepSize\[CloseCurlyDoubleQuote]. \
CombineTrajectory would always use the MaxStepSize option for the time \
increment, but Automatic is obviously not a numerical value. \
\>", "Text",
 CellChangeTimes->{{3.7027291445902243`*^9, 3.7027292521494417`*^9}, {
  3.702797182562234*^9, 3.7027971877454195`*^9}, {3.702816098877943*^9, 
  3.7028162436299977`*^9}},ExpressionUUID->"7f0949b2-2bac-42e1-ae93-\
35803f0e73e3"]
}, Closed]],

Cell[CellGroupData[{

Cell["170505 changes incorporated into v3.0.0b14 [MHL]", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.702729114382555*^9, 3.7027291389422092`*^9}, {3.702729256100906*^9, 
   3.7027292598717737`*^9}, {3.7030044842472773`*^9, 3.703004502797503*^9}, {
   3.7030047058446217`*^9, 3.703004721506567*^9}, 
   3.7030496146444893`*^9},ExpressionUUID->"511a3cc2-485c-4e48-bdf5-\
58a7439abc6b"],

Cell[CellGroupData[{

Cell["Signal1D", "Subsubsection",
 CellChangeTimes->{{3.703082962952669*^9, 
  3.7030829665916348`*^9}},ExpressionUUID->"9a0f3d40-fc44-4437-a24c-\
0927f6f228b0"],

Cell["debugged EnsembleAverage with >1 batches in Signal1D [MHL]", "Text",
 CellChangeTimes->{3.703004702229426*^9, 
  3.703076980486948*^9},ExpressionUUID->"b01096ac-5b6b-42b5-85d1-\
cb1a32f1a94a"],

Cell["\<\
debugged single period subdivision in COMPUTE algorithm [MHL]\
\>", "Text",
 CellChangeTimes->{{3.703049562961969*^9, 3.703049588495924*^9}, {
  3.703076974543386*^9, 
  3.703076975341515*^9}},ExpressionUUID->"bb2f238d-c8f0-4c42-8ba4-\
2111401e148e"],

Cell["introduced checks for COMPUTE and CarouselAverage [MHL]", "Text",
 CellChangeTimes->{{3.703091040356035*^9, 
  3.703091065951112*^9}},ExpressionUUID->"83fe27de-612c-4a40-a868-\
06d1dc5f6de7"]
}, Closed]],

Cell[CellGroupData[{

Cell["TransformationAmplitudeTable", "Subsubsection",
 CellChangeTimes->{{3.703082962952669*^9, 
  3.703082977077339*^9}},ExpressionUUID->"595ede08-520f-46a3-98a1-\
1e944acf5499"],

Cell["debugged TransformationAmplitudeTable [MHL]", "Text",
 CellChangeTimes->{{3.703076932919956*^9, 3.703076949877249*^9}, {
  3.7030829403789263`*^9, 
  3.703082952782745*^9}},ExpressionUUID->"3a88a0de-48c2-4825-8051-\
05ab1d818157"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["170516 changes to prepareparallel [CB]", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.702729114382555*^9, 3.7027291389422092`*^9}, {3.702729256100906*^9, 
   3.7027292598717737`*^9}, {3.703920360244886*^9, 3.7039203651541505`*^9}, {
   3.709226228068713*^9, 
   3.7092262291583996`*^9}},ExpressionUUID->"021e6cf4-502b-464c-b38e-\
e4c67ab52c9b"],

Cell["\<\
The Syntax:

If[basis\[NotEqual]Basis[],SetBasis[basis],Nothing];

is not getting evaluated in parallel. Everything has to wrapped into \
ParallelEvaluate[ ___ ]. The SpinSystem bug reported on the 170502 has now \
been fixed by:

EvaluateParallel[SetSpinSystem[SpinSystem[basis]]].\
\>", "Text",
 CellChangeTimes->{{3.7039203781627707`*^9, 
  3.7039204723873386`*^9}},ExpressionUUID->"35b88b28-46c4-4631-9b3a-\
7ac87de231fc"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
170717 changes to v3.0.0b16  to resolve \[OpenCurlyDoubleQuote]bug\
\[CloseCurlyDoubleQuote] \[Rule] 160916-JE-2143-TransformationAmplitudeTable \
[CB] \
\>", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.702729114382555*^9, 3.7027291389422092`*^9}, {3.702729256100906*^9, 
   3.7027292598717737`*^9}, {3.703920360244886*^9, 3.7039203651541505`*^9}, {
   3.709226228068713*^9, 3.7092262291583996`*^9}, {3.709291530570922*^9, 
   3.7092915466068344`*^9}, {3.7092915798914127`*^9, 
   3.709291611424614*^9}},ExpressionUUID->"6c501e2e-fcc6-4c76-836d-\
cd7f022c3a08"],

Cell["\<\
TransformationAmplitudeTable is now able to handle \[OpenCurlyDoubleQuote]no \
event\[CloseCurlyDoubleQuote] in case someone forgot to specify an event. \
\>", "Text",
 CellChangeTimes->{{3.7039203781627707`*^9, 3.7039204723873386`*^9}, {
  3.7092915505230913`*^9, 
  3.7092915698729267`*^9}},ExpressionUUID->"5809c330-c914-4869-80b2-\
4e8d322cf702"]
}, Closed]],

Cell[CellGroupData[{

Cell["170718 changes in v3.0.0b18", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.700565864488969*^9, 3.700565866479809*^9}, {3.7093869109392977`*^9, 
   3.7093869141048*^9}},ExpressionUUID->"cfa4754e-e894-4483-9526-\
69be69c652c3"],

Cell["\<\
Numerous name changes from EvolutionGenerator (and similar) to Generator (and \
similar)\
\>", "Text",
 CellChangeTimes->{{3.709386922996626*^9, 
  3.709386992335451*^9}},ExpressionUUID->"ba97d145-2366-499f-a153-\
f26304bf535c"],

Cell["\<\
trapping of PolarizationLevelOperator and SingletPolarizationLevelOperator \
with non-rigorous density operators implemented in TransformationAmplitude, \
TransformationAmplitudeTable, and Trajectory\
\>", "Text",
 CellChangeTimes->{{3.709387059277862*^9, 3.709387092171773*^9}, {
  3.7093877478106947`*^9, 
  3.709387762016667*^9}},ExpressionUUID->"820c8650-d3ab-4355-97ed-\
2a51ccacdd38"]
}, Closed]],

Cell[CellGroupData[{

Cell["170905 changes in v3.0.1b1", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.700565864488969*^9, 3.700565866479809*^9}, {3.7093869109392977`*^9, 
   3.7093869141048*^9}, {3.71363857604142*^9, 
   3.7136385830911565`*^9}},ExpressionUUID->"cfa4754e-e894-4483-9526-\
69be69c652c3"],

Cell["\<\
-Added special case for COMPUTE when all detection events are of the type \
{None,T}. The calculation of the Sjsets has been pushed into \
DividedEventPropagators.

-the order of {prepbackg,detbackg} was reversed for some reason. \
\>", "Text",
 CellChangeTimes->{{3.709386922996626*^9, 3.709386992335451*^9}, {
  3.713638591591776*^9, 
  3.7136386456610622`*^9}},ExpressionUUID->"ba97d145-2366-499f-a153-\
f26304bf535c"]
}, Closed]],

Cell[CellGroupData[{

Cell["170907 changes in v3.0.1b2m", "Subsection",
 CellChangeTimes->{{3.6992617377127457`*^9, 3.699261750424902*^9}, 
   3.699261872727805*^9, {3.699261961052656*^9, 3.699261967080655*^9}, {
   3.699267263610918*^9, 3.699267264970158*^9}, 3.6995424563123937`*^9, {
   3.699545398748596*^9, 3.6995453990235744`*^9}, {3.699598420679057*^9, 
   3.6995984207889843`*^9}, {3.699623620808276*^9, 3.699623620919536*^9}, {
   3.699684596084985*^9, 3.699684596623074*^9}, {3.699685713789143*^9, 
   3.699685784922206*^9}, {3.6999571421771107`*^9, 3.6999571579260406`*^9}, {
   3.700565864488969*^9, 3.700565866479809*^9}, {3.7093869109392977`*^9, 
   3.7093869141048*^9}, {3.71363857604142*^9, 3.7136385830911565`*^9}, {
   3.7137835629191413`*^9, 
   3.7137835776325903`*^9}},ExpressionUUID->"cfa4754e-e894-4483-9526-\
69be69c652c3"],

Cell["\<\
The syntax : 

ParallelEvaluate[{...}=stufftodistribute] caused the DownValues of SpinSystem \
to be rewritten, leading to a loop in successive EnsembleAverage calculations.

The syntax has been changed to: ParallelEvaluate[stufftodistribute], which no \
longer rewrites the DownValues.\
\>", "Text",
 CellChangeTimes->{{3.7137836084005113`*^9, 
  3.713783682485275*^9}},ExpressionUUID->"757e98e5-ccdb-4efd-8ce2-\
433f30f39d2b"]
}, Closed]]
}, Closed]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->{},
CellGrouping->Automatic,
WindowSize->{789, 746},
WindowMargins->{{Automatic, 39}, {Automatic, 46}},
ShowCellLabel->True,
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"MHL-StyleSheet.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, 128}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False},
CharacterEncoding -> "MacintoshAutomaticEncoding"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 388, 8, 98, "Title",ExpressionUUID->"5e4a1278-e3ba-46d0-8447-3e4dc783ee47",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[980, 34, 355, 8, 69, "Chapter",ExpressionUUID->"b000a75b-363b-4f47-b8df-9c3061e578d7",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1338, 44, 2537, 43, 509, "Input",ExpressionUUID->"8818fe29-4224-42d7-b79f-8d82f42a4d3b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[3912, 92, 412, 10, 74, "Chapter",ExpressionUUID->"3e5a7c9e-efee-4064-9d77-c13378b614db",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[4349, 106, 1065, 18, 36, "Section",ExpressionUUID->"8d1251b0-f032-406d-a10f-e12dc7c79a67",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[5417, 126, 3838, 57, 3765, "Input",ExpressionUUID->"7b9dbbf7-8267-4f62-9d53-6384c9b59a12",
 InitializationCell->True],
Cell[9258, 185, 444, 9, 835, "Input",ExpressionUUID->"cdf2acb5-3e38-40c6-9d2a-6443d77b3f86",
 InitializationCell->True],
Cell[9705, 196, 2518, 39, 1616, "Input",ExpressionUUID->"222025e4-1caf-4874-bbcd-89761313eb5f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[12260, 240, 1192, 19, 36, "Section",ExpressionUUID->"603a34d1-9d34-4ca2-8cb7-c5f856050763",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[13455, 261, 3187, 48, 217, "Input",ExpressionUUID->"d32a8115-27dc-469a-82df-15d0ab33b5e3",
 InitializationCell->True],
Cell[16645, 311, 409, 9, 91, "Input",ExpressionUUID->"bf4068f2-5d89-4f76-bbdf-3a5663a6243d",
 InitializationCell->True],
Cell[17057, 322, 3225, 48, 154, "Input",ExpressionUUID->"264a82aa-c391-4c8c-baf8-611ec3cc2f91",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20319, 375, 1162, 19, 36, "Section",ExpressionUUID->"ed6250c0-dd24-4f47-aaee-a2be80ebae51",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[21484, 396, 5526, 79, 551, "Input",ExpressionUUID->"ed59407f-2898-4147-be34-3cec13b7511b",
 InitializationCell->True],
Cell[27013, 477, 990, 18, 110, "Input",ExpressionUUID->"296219b8-4fb6-4ed7-895f-6d6c3dbbcd7d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[28040, 500, 1249, 21, 44, "Section",ExpressionUUID->"5e412516-8bd0-4a34-b909-578df9024b26",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[29292, 523, 12397, 173, 761, "Input",ExpressionUUID->"4d4bc8ef-9d77-4a92-b2e9-7d483c5224bd",
 InitializationCell->True],
Cell[41692, 698, 2313, 41, 215, "Input",ExpressionUUID->"68d3f213-08c3-493c-b2ed-271322d31942",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[44042, 744, 1104, 18, 36, "Section",ExpressionUUID->"55fc7164-9445-4ec7-aae1-2dcd84238999",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[45171, 766, 156, 3, 44, "Subsection",ExpressionUUID->"5677fffe-1f6e-448a-85a0-4b219fee311d",
 InitializationCell->True],
Cell[45330, 771, 4931, 71, 847, "Input",ExpressionUUID->"0a341e1b-05d9-41a8-90ea-5aa0e88a11bc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[50298, 847, 176, 4, 36, "Subsection",ExpressionUUID->"66935e0a-6249-4019-8b51-4d5cff5ff9a7",
 InitializationCell->True],
Cell[50477, 853, 1429, 24, 3378, "Input",ExpressionUUID->"b429a310-eeda-4eec-9597-4451d81a15c3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[51943, 882, 208, 4, 36, "Subsection",ExpressionUUID->"dacfcf00-56db-41d3-9e76-4824fd09e2f3",
 InitializationCell->True],
Cell[52154, 888, 454, 10, 835, "Input",ExpressionUUID->"0b902bae-142e-4488-87bf-8babd1a30365",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[52645, 903, 172, 4, 36, "Subsection",ExpressionUUID->"d2bae161-2678-4d17-a4df-24c5a85ae35a",
 InitializationCell->True],
Cell[52820, 909, 809, 16, 1222, "Input",ExpressionUUID->"47990f77-77c4-4acb-9c36-61d6fd617292",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[53666, 930, 197, 4, 36, "Subsection",ExpressionUUID->"037dcca6-c9d0-4e0c-84f8-bba2da66f27a",
 InitializationCell->True],
Cell[53866, 936, 797, 15, 1035, "Input",ExpressionUUID->"b9f42749-05be-4d08-bef3-b50edd49a07d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[54700, 956, 208, 4, 36, "Subsection",ExpressionUUID->"a419f03e-a450-41ec-83ab-dff0b28abfa4",
 InitializationCell->True],
Cell[54911, 962, 882, 16, 1222, "Input",ExpressionUUID->"6095f033-135d-4707-8ffa-9c57dbaac0d0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[55830, 983, 232, 5, 36, "Subsection",ExpressionUUID->"039b1b50-d963-48b4-89e1-bc4ae58fa212",
 InitializationCell->True],
Cell[56065, 990, 1102, 19, 2393, "Input",ExpressionUUID->"be29b6f8-89e8-40cc-a9ab-6aea1b4a08dd",
 InitializationCell->True],
Cell[57170, 1011, 588, 13, 637, "Input",ExpressionUUID->"e730eafc-1a92-47d5-8a5d-99617b32e281",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[57795, 1029, 256, 4, 36, "Subsection",ExpressionUUID->"0f6e9eb4-ce94-45a2-ac34-d25b1fead152",
 InitializationCell->True],
Cell[58054, 1035, 1656, 27, 2393, "Input",ExpressionUUID->"09f771b5-6841-4d79-8fcf-d945627d467c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[59747, 1067, 174, 4, 36, "Subsection",ExpressionUUID->"71d51f4c-20f7-40cf-be0f-837155802212",
 InitializationCell->True],
Cell[59924, 1073, 1101, 20, 1426, "Input",ExpressionUUID->"72ab65c8-c7f4-47fd-b153-a65b0f7cb648",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[61062, 1098, 272, 6, 36, "Subsection",ExpressionUUID->"7337d809-ba4a-4840-9b45-498fde5c6661",
 InitializationCell->True],
Cell[61337, 1106, 1099, 20, 835, "Input",ExpressionUUID->"7845e95e-be00-4d44-868e-e0d2c7652613",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[62485, 1132, 258, 5, 36, "Section",ExpressionUUID->"14f09ae6-816f-4d44-ab0a-871ba4e2f0e1",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[62768, 1141, 163, 3, 401, "Subsection",ExpressionUUID->"fb7776b0-d09b-4859-8d26-01495a3aef15",
 InitializationCell->True],
Cell[62934, 1146, 2157, 34, 3178, "Input",ExpressionUUID->"6e7a7fee-8f63-4557-954a-5ea4d73b5e3a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[65128, 1185, 209, 4, 401, "Subsection",ExpressionUUID->"b1c0f228-75d5-4ee5-8f27-b87e1be636b5",
 InitializationCell->True],
Cell[65340, 1191, 1603, 26, 1426, "Input",ExpressionUUID->"c505df3e-a278-49a5-8920-a1500f73b3f4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[66980, 1222, 182, 4, 401, "Subsection",ExpressionUUID->"2efc791b-c6ae-4d78-9086-2bf9be0d769b",
 InitializationCell->True],
Cell[67165, 1228, 727, 15, 1616, "Input",ExpressionUUID->"a24878fb-79a4-43fc-b61e-b3db9c19365c",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[67941, 1249, 1225, 20, 36, "Section",ExpressionUUID->"c88f47b0-2625-4dd0-828d-bfca5eb5e835",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[69169, 1271, 358, 9, 440, "Input",ExpressionUUID->"e79b523f-54b6-48f8-9f4c-6ee1d2a743f1",
 InitializationCell->True],
Cell[69530, 1282, 2139, 34, 1426, "Input",ExpressionUUID->"becd273a-ded8-43a4-aedf-f8da79731344",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[71718, 1322, 379, 8, 58, "Chapter",ExpressionUUID->"67084a09-f1b0-4584-ad10-7e0e86f67b14",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[72100, 1332, 323, 7, 48, "Input",ExpressionUUID->"224b0594-7343-40b1-abd4-71c795c2fe9b",
 InitializationCell->True],
Cell[72426, 1341, 227, 6, 48, "Input",ExpressionUUID->"8ad7b403-e355-4090-8e0a-f7a48a4db6da",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]],
Cell[CellGroupData[{
Cell[72690, 1352, 374, 6, 74, "Chapter",ExpressionUUID->"fb0155e4-e338-4f38-9d51-ccc28f32a792",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[73089, 1362, 533, 9, 65, "Subchapter",ExpressionUUID->"2fe36fb9-1423-44b3-aff9-139a4c402934",
 InitializationCell->True],
Cell[73625, 1373, 431, 9, 49, "Text",ExpressionUUID->"802cad79-7910-4b21-8a85-0df4aaf77ca4",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[74081, 1386, 301, 6, 34, "Section",ExpressionUUID->"ec95bce6-30c7-45a2-9cfb-028ef003aa0c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[74385, 1394, 371, 8, 445, "Text",ExpressionUUID->"71aeb8cf-dede-4e3d-b323-0ecfd19b4faf",
 InitializationCell->True],
Cell[74759, 1404, 338, 8, 453, "Input",ExpressionUUID->"b54a0b4e-3b97-4620-8028-e5ad3e7c4ae9",
 InitializationCell->True],
Cell[75100, 1414, 457, 13, 440, "Input",ExpressionUUID->"92bcadf0-240a-4f54-be4e-2c09096ffd3c",
 InitializationCell->True],
Cell[75560, 1429, 622, 18, 637, "Input",ExpressionUUID->"36ed0780-5ca3-4777-ab07-def4b24921cd",
 InitializationCell->True],
Cell[76185, 1449, 661, 19, 637, "Input",ExpressionUUID->"520e6eed-9f19-4e1f-9fe2-1a9150f041c6",
 InitializationCell->True],
Cell[76849, 1470, 1378, 32, 1035, "Input",ExpressionUUID->"226cd92c-162b-488c-b22d-173d7f6fd69e",
 InitializationCell->True],
Cell[78230, 1504, 1035, 27, 1035, "Input",ExpressionUUID->"19180164-8384-4354-94fd-0684bdefcac0",
 InitializationCell->True],
Cell[79268, 1533, 1887, 48, 1616, "Input",ExpressionUUID->"7077ff63-a7b9-4e76-9e6b-ccc33345573b",
 InitializationCell->True],
Cell[81158, 1583, 842, 24, 835, "Input",ExpressionUUID->"cf2fe04a-d314-46f1-81f7-13f55d0baa24",
 InitializationCell->True],
Cell[82003, 1609, 1658, 41, 1035, "Input",ExpressionUUID->"274258e3-0592-48e6-b991-33bbb7a91ea1",
 InitializationCell->True],
Cell[83664, 1652, 1784, 44, 1035, "Input",ExpressionUUID->"d802c8ce-58a0-4b02-93e2-1f73366fc133",
 InitializationCell->True],
Cell[85451, 1698, 3356, 76, 2597, "Input",ExpressionUUID->"61ba7679-2e50-460f-bcae-c039e9c9b77b",
 InitializationCell->True],
Cell[88810, 1776, 3409, 76, 2597, "Input",ExpressionUUID->"84d37266-8437-414c-9f9f-ebbe77166d53",
 InitializationCell->True],
Cell[92222, 1854, 2756, 67, 1426, "Input",ExpressionUUID->"0c2908e1-d651-4998-bd79-fc6f50f02db6",
 InitializationCell->True],
Cell[94981, 1923, 2006, 54, 1616, "Input",ExpressionUUID->"282e999f-ff9a-4c44-bb64-e877c63e1d6b",
 InitializationCell->True],
Cell[96990, 1979, 1009, 26, 637, "Input",ExpressionUUID->"070faa8a-98b3-488e-8f5d-8f40fe25e1d2",
 InitializationCell->True],
Cell[98002, 2007, 501, 13, 637, "Input",ExpressionUUID->"9d5bf624-656b-44fc-ae15-01ccb1406465",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[98540, 2025, 388, 7, 34, "Section",ExpressionUUID->"05544b1c-eae9-46db-9a57-ddafac990e53",
 InitializationCell->True,
 InitializationGroup->True],
Cell[98931, 2034, 249, 6, 266, "Text",ExpressionUUID->"b31582a0-b286-4181-9093-ac2cb05eee63",
 InitializationCell->True],
Cell[99183, 2042, 468, 13, 440, "Input",ExpressionUUID->"13b2765a-4d44-49e8-a56d-41a71972a118",
 InitializationCell->True],
Cell[99654, 2057, 1199, 33, 1035, "Input",ExpressionUUID->"cc8111e2-c7c0-4c4d-b911-71f4e01c03b0",
 InitializationCell->True],
Cell[100856, 2092, 382, 10, 440, "Input",ExpressionUUID->"c81f1fa8-7116-48a8-ab06-17238a408be7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[101275, 2107, 556, 9, 34, "Section",ExpressionUUID->"af383bd0-f0b2-4d83-ae46-5bf53544af34",
 InitializationCell->True,
 InitializationGroup->True],
Cell[101834, 2118, 379, 8, 266, "Text",ExpressionUUID->"65326144-b31c-4bf4-9e21-46ed7db84c24",
 InitializationCell->True],
Cell[102216, 2128, 510, 13, 440, "Input",ExpressionUUID->"f81f8622-28cf-47c6-8e13-4e161cd269f4",
 InitializationCell->True],
Cell[102729, 2143, 1339, 35, 1035, "Input",ExpressionUUID->"ea347197-2306-4331-b604-434808211bed",
 InitializationCell->True],
Cell[104071, 2180, 1133, 31, 835, "Input",ExpressionUUID->"c35b2c3f-8cb1-422b-949a-15c15ab2e3ce",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[105241, 2216, 589, 10, 34, "Section",ExpressionUUID->"394ba4d9-aac6-4ec8-bc12-e8884d284efc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[105833, 2228, 546, 11, 626, "Text",ExpressionUUID->"7d3442ae-31a4-4ad4-ab23-d7d5be6cca4e",
 InitializationCell->True],
Cell[106382, 2241, 337, 8, 440, "Input",ExpressionUUID->"aa357a57-bfc3-441a-8269-cd7fb36b330e",
 InitializationCell->True],
Cell[106722, 2251, 637, 17, 637, "Input",ExpressionUUID->"14711fe4-9eed-4bb3-86a9-d60423287874",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[107384, 2272, 261, 6, 307, "Subsubsection",ExpressionUUID->"9a6ae8bc-7fca-4c95-b726-13ef4ae14c85",
 InitializationCell->True],
Cell[107648, 2280, 1943, 46, 1616, "Input",ExpressionUUID->"c13b68e8-adc9-4f6c-9233-9b96eb57badd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[109628, 2331, 248, 6, 307, "Subsubsection",ExpressionUUID->"35b8d093-5e24-4d83-b608-26c1ed862816",
 InitializationCell->True],
Cell[109879, 2339, 379, 10, 453, "Input",ExpressionUUID->"1e863dd7-3c6a-40e7-a98e-f15371ec4e07",
 InitializationCell->True],
Cell[110261, 2351, 1323, 36, 1222, "Input",ExpressionUUID->"24f1b5c9-ef52-4d70-bb49-bacfa74127f8",
 InitializationCell->True],
Cell[111587, 2389, 443, 9, 445, "Text",ExpressionUUID->"2aa71410-ea3f-43dd-9d6f-4301070c97fb",
 InitializationCell->True],
Cell[112033, 2400, 2218, 51, 1816, "Input",ExpressionUUID->"db9bd7a7-ef37-4351-bb59-e29e3431a28d",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[114300, 2457, 509, 9, 34, "Section",ExpressionUUID->"d484d08e-71c2-48ea-bcdb-db005ffef9ca",
 InitializationCell->True,
 InitializationGroup->True],
Cell[114812, 2468, 366, 8, 445, "Text",ExpressionUUID->"37d7a533-ae8b-4878-93b9-48aa9a48ee6d",
 InitializationCell->True],
Cell[115181, 2478, 439, 12, 440, "Input",ExpressionUUID->"9804cbec-9ff1-4f76-830f-b6a588400d04",
 InitializationCell->True],
Cell[115623, 2492, 1291, 34, 1035, "Input",ExpressionUUID->"96f18df0-f3df-428d-9c54-2e7dd71be8e5",
 InitializationCell->True],
Cell[116917, 2528, 1539, 35, 2003, "Input",ExpressionUUID->"bba1fce1-109f-4ec2-a881-2a41e906f306",
 InitializationCell->True],
Cell[118459, 2565, 2407, 60, 2200, "Input",ExpressionUUID->"a53b9d16-d8dd-44d7-8ae7-870f68e0adf5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[120903, 2630, 543, 9, 34, "Section",ExpressionUUID->"e2698725-58dc-4a1b-9959-a866bdd9bbec",
 InitializationCell->True,
 InitializationGroup->True],
Cell[121449, 2641, 242, 6, 30, "Text",ExpressionUUID->"2d2701f2-b164-458d-994f-5c66e1271e5a",
 InitializationCell->True],
Cell[121694, 2649, 441, 12, 50, "Input",ExpressionUUID->"8692ab79-0fbf-448f-b04d-3d4784e9664a",
 InitializationCell->True],
Cell[122138, 2663, 1285, 36, 112, "Input",ExpressionUUID->"50fb5ffb-6085-4525-9287-98e4c2d11976",
 InitializationCell->True],
Cell[123426, 2701, 589, 18, 70, "Input",ExpressionUUID->"c5a86212-677a-4ea0-88f3-213f13f73b1d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[124052, 2724, 281, 6, 34, "Section",ExpressionUUID->"a609b5a9-9e86-4b8d-a6b1-078a71fc4420",
 InitializationCell->True,
 InitializationGroup->True],
Cell[124336, 2732, 421, 10, 637, "Input",ExpressionUUID->"5659473a-2346-43e4-b002-c906ea591433",
 InitializationCell->True],
Cell[124760, 2744, 402, 9, 835, "Input",ExpressionUUID->"f3d53d8e-de6e-418b-bfb2-1b0019e019fe",
 InitializationCell->True],
Cell[125165, 2755, 367, 9, 637, "Input",ExpressionUUID->"c1474105-36ac-4bdf-9315-d43dbc64c894",
 InitializationCell->True],
Cell[125535, 2766, 526, 12, 835, "Input",ExpressionUUID->"4a003365-3f35-411d-9db4-a2bc609d1c1e",
 InitializationCell->True],
Cell[126064, 2780, 403, 10, 440, "Input",ExpressionUUID->"fe8e1158-b456-4335-b4b4-565e0e77e69f",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[126516, 2796, 462, 8, 65, "Subchapter",ExpressionUUID->"1cdba7bf-5669-43b1-af21-2c12cae3310f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[127003, 2808, 205, 4, 36, "Section",ExpressionUUID->"f120f95b-e11a-44c9-a1bf-9a2d11341128",
 InitializationCell->True],
Cell[127211, 2814, 435, 10, 91, "Input",ExpressionUUID->"afc120b5-9fa8-4f19-b40e-8d8d202dfd1a",
 InitializationCell->True],
Cell[127649, 2826, 350, 9, 48, "Input",ExpressionUUID->"be765ace-b974-48d6-a22c-5058f79ac0ba",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[128036, 2840, 274, 5, 44, "Section",ExpressionUUID->"43b0a01a-e605-458c-a5f1-a5fd12b6ec63",
 InitializationCell->True],
Cell[128313, 2847, 362, 9, 46, "Input",ExpressionUUID->"2578657e-6d5b-4d2b-9a89-f2f9f299da57",
 InitializationCell->True],
Cell[128678, 2858, 589, 14, 46, "Input",ExpressionUUID->"3f26689f-4cca-407d-abd6-56c337858665",
 InitializationCell->True],
Cell[129270, 2874, 511, 13, 68, "Input",ExpressionUUID->"60a9a46a-eb5c-4c4f-bd4b-bb9f2ef708fa",
 InitializationCell->True],
Cell[129784, 2889, 1437, 37, 152, "Input",ExpressionUUID->"7ed53c72-332b-4ecb-80a2-2745a32b3a6c",
 InitializationCell->True],
Cell[131224, 2928, 10012, 194, 929, "Input",ExpressionUUID->"56b75acc-b6c6-40b2-8eab-52b1112c0c5f",
 InitializationCell->True],
Cell[141239, 3124, 517, 11, 89, "Input",ExpressionUUID->"c69f66df-4865-4a79-893a-c2c3f0151e4a",
 InitializationCell->True],
Cell[141759, 3137, 548, 12, 89, "Input",ExpressionUUID->"9428deca-9c31-4fb3-bc84-5f292beefa34",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[142356, 3155, 415, 7, 49, "Subchapter",ExpressionUUID->"8404bbee-00d8-474d-a3b1-84c2d0ff8960",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[142796, 3166, 348, 6, 35, "Subsubsection",ExpressionUUID->"f8376509-45d6-40bc-88d3-cc4b0c30d57f",
 InitializationCell->True],
Cell[143147, 3174, 470, 12, 440, "Input",ExpressionUUID->"cf30830c-e446-42d7-891f-fc13d96eb62f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[143654, 3191, 294, 5, 29, "Subsubsection",ExpressionUUID->"f86874a2-cf61-4b34-8d7b-5eb1269d9265",
 InitializationCell->True],
Cell[143951, 3198, 394, 10, 70, "Input",ExpressionUUID->"cecf3270-e196-4935-afb6-416624080dfa",
 InitializationCell->True],
Cell[144348, 3210, 418, 11, 48, "Input",ExpressionUUID->"f82737d2-ce03-4aed-b183-aad569396d01",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[144815, 3227, 584, 10, 49, "Subchapter",ExpressionUUID->"63aef8ef-6f9e-4994-aa74-25ea81cb2a7c",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[145424, 3241, 187, 4, 42, "Section",ExpressionUUID->"8d4d7a88-0f95-4712-9d76-3c8f0097c90d"],
Cell[CellGroupData[{
Cell[145636, 3249, 214, 4, 51, "Subsubsection",ExpressionUUID->"aa5ff608-1973-431e-9c0f-79e04a9bbd94"],
Cell[145853, 3255, 1225, 33, 133, "Input",ExpressionUUID->"3ddf605c-5468-4580-b9b3-42d030fb36df",
 InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[147151, 3296, 543, 9, 58, "Chapter",ExpressionUUID->"5c11b280-3f12-423b-a38c-d477f63d79ed",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[147719, 3309, 308, 5, 33, "Section",ExpressionUUID->"a48065c8-d5b3-4316-a898-3f4639b6c666",
 InitializationCell->True],
Cell[148030, 3316, 495, 13, 91, "Input",ExpressionUUID->"3e5c3c97-2c31-4b1d-b06d-475ce1f29826",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[148562, 3334, 230, 5, 33, "Section",ExpressionUUID->"48a5f51e-2a40-494f-838a-fba4750a1adb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[148817, 3343, 355, 7, 44, "Subsection",ExpressionUUID->"93540379-e57d-4d8c-b6c7-3851dea1d58e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[149175, 3352, 1071, 20, 48, "Input",ExpressionUUID->"ba8a32c6-23cc-4370-899d-fd19d6aafe11",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[150283, 3377, 253, 5, 36, "Subsection",ExpressionUUID->"054cab53-b3c6-45c2-b6d9-fa17856b3bb4",
 InitializationCell->True],
Cell[150539, 3384, 846, 21, 91, "Input",ExpressionUUID->"a482bbcb-954d-4d25-80c7-9df15366703a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[151422, 3410, 321, 6, 36, "Subsection",ExpressionUUID->"4d7f56ab-e667-4deb-af0f-be62c7f6b374",
 InitializationCell->True,
 InitializationGroup->True],
Cell[151746, 3418, 1564, 38, 217, "Input",ExpressionUUID->"a9e2bad5-e9b2-45ee-9464-012423609a8d",
 InitializationCell->True],
Cell[153313, 3458, 1843, 43, 238, "Input",ExpressionUUID->"08c55c91-c7a9-4734-bd53-6b0f600611e1",
 InitializationCell->True],
Cell[155159, 3503, 1557, 37, 154, "Input",ExpressionUUID->"ffae2cb2-6547-4ef4-9d9f-ddf1dd66f27f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[156753, 3545, 313, 6, 36, "Subsection",ExpressionUUID->"318e7a16-d4bd-4b6c-a122-3ca812e1bcda",
 InitializationCell->True,
 InitializationGroup->True],
Cell[157069, 3553, 1418, 31, 70, "Input",ExpressionUUID->"d09a04c9-a6b3-4e47-b9e3-7f5b2127f6ae",
 InitializationCell->True,
 InitializationGroup->True],
Cell[158490, 3586, 1369, 31, 91, "Input",ExpressionUUID->"b3f86c99-3aba-4642-9ca5-5cdf0b06c5af",
 InitializationCell->True,
 InitializationGroup->True],
Cell[159862, 3619, 1660, 37, 112, "Input",ExpressionUUID->"0f06fa5a-dea8-426c-bc73-0dfd540c7843",
 InitializationCell->True],
Cell[161525, 3658, 2173, 45, 196, "Input",ExpressionUUID->"af7b37d9-0bd4-470e-9c58-5281265b4385",
 InitializationCell->True],
Cell[163701, 3705, 2161, 45, 196, "Input",ExpressionUUID->"3d57cf64-3d7a-4397-ba64-417cea2b28ba",
 InitializationCell->True],
Cell[165865, 3752, 2911, 60, 196, "Input",ExpressionUUID->"46af663d-6f73-4a09-a75a-702769a26ef8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[168813, 3817, 432, 8, 36, "Subsection",ExpressionUUID->"256cdb7a-4adb-40de-a7f4-75caa5ed460b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[169248, 3827, 874, 23, 112, "Input",ExpressionUUID->"99339a62-3158-4cbb-be77-b606e6cf0833",
 InitializationCell->True],
Cell[170125, 3852, 879, 23, 112, "Input",ExpressionUUID->"1f92b46e-c92b-4d57-9819-7b1e9d888b8a",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[171053, 3881, 390, 7, 33, "Section",ExpressionUUID->"dc180867-5177-46d2-9e14-7167bf3325df",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[171468, 3892, 473, 8, 44, "Subsection",ExpressionUUID->"a859b841-a9b4-4ecc-9a6c-baa358bff382",
 InitializationCell->True,
 InitializationGroup->True],
Cell[171944, 3902, 3440, 78, 238, "Input",ExpressionUUID->"679341ed-5ff2-4f9c-9ff2-df2a8cf8ad7a",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[175421, 3985, 527, 9, 44, "Subsection",ExpressionUUID->"29bc45bb-18a5-4d44-b425-ef571ce9f1f3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[175951, 3996, 1518, 36, 133, "Input",ExpressionUUID->"15810de7-6aa1-43f9-8ec3-ecbcb0635bde",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[177518, 4038, 431, 8, 33, "Section",ExpressionUUID->"3b8aa9e2-0e66-4572-9973-8142c689feb5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[177952, 4048, 446, 10, 70, "Input",ExpressionUUID->"778477ce-fc5c-4707-b905-701f202aa4b5",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[178447, 4064, 455, 8, 74, "Chapter",ExpressionUUID->"f1bc8b7b-d128-4429-9b5b-4c5347fdfd88",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[178927, 4076, 232, 5, 36, "Section",ExpressionUUID->"1364129d-c7e4-4992-b052-b535ff9cfd57",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[179184, 4085, 389, 7, 70, "Subsection",ExpressionUUID->"d6943771-d4bb-4eed-820c-0b9d0688bf2a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[179576, 4094, 4934, 86, 576, "Input",ExpressionUUID->"d74001eb-cbc9-4255-af93-d0e523fe17bd",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[184547, 4185, 360, 7, 54, "Subsection",ExpressionUUID->"564fce24-1da3-459d-950b-897567f65b61",
 InitializationCell->True,
 InitializationGroup->True],
Cell[184910, 4194, 480, 10, 266, "Text",ExpressionUUID->"cbbda62c-fa86-43f5-aa8c-f0afdd23f031",
 InitializationCell->True],
Cell[185393, 4206, 426, 9, 440, "Input",ExpressionUUID->"590a76a1-de16-4664-9400-a5e801b932dc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[185856, 4220, 336, 6, 54, "Subsection",ExpressionUUID->"62c3fe94-8ad5-47ba-a5fa-c66c5370922c",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[186217, 4230, 1600, 23, 61, "Subsubsection",ExpressionUUID->"6c90bf09-240f-4823-82b0-dc5caac0ccf8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[187820, 4255, 1679, 42, 215, "Input",ExpressionUUID->"0900dccf-2abe-4e9e-81ab-0fb89a89d90c",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[189536, 4302, 1427, 21, 45, "Subsubsection",ExpressionUUID->"b414d5e4-0d54-4eb5-a6e9-734f587021c9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[190966, 4325, 1232, 26, 68, "Input",ExpressionUUID->"a64ab7db-3209-4088-ac23-aaf2225c40db",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[192235, 4356, 1584, 24, 37, "Subsubsection",ExpressionUUID->"aaf19751-4cc0-415a-9eb8-9a0eb82f2a79",
 InitializationCell->True,
 InitializationGroup->True],
Cell[193822, 4382, 181, 3, 35, "Text",ExpressionUUID->"95bfdcda-7f95-4865-a8d2-0599c67a0c29"],
Cell[194006, 4387, 2668, 61, 257, "Input",ExpressionUUID->"3918c957-fcc2-4259-aa51-089be77c4637",
 InitializationCell->True],
Cell[196677, 4450, 2677, 61, 257, "Input",ExpressionUUID->"73cbccc5-eba9-4268-870c-4b15273826b5",
 InitializationCell->True],
Cell[199357, 4513, 2695, 62, 257, "Input",ExpressionUUID->"d7eedcce-c7f7-4e0a-92e8-a7081d4358bd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[202089, 4580, 380, 6, 37, "Subsubsection",ExpressionUUID->"f646733e-d6bc-4853-bb35-669f668ef6f4",
 InitializationCell->True],
Cell[202472, 4588, 1077, 28, 110, "Input",ExpressionUUID->"709c9164-a7a4-4bb5-b347-fb7bf8c9674b",
 InitializationCell->True],
Cell[203552, 4618, 4635, 97, 446, "Input",ExpressionUUID->"b8dd260b-9fa5-497e-8b30-2e05dea52334",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[208236, 4721, 323, 6, 54, "Subsection",ExpressionUUID->"fc8562c6-6c75-4eca-8d19-8210d45102be",
 InitializationCell->True,
 InitializationGroup->True],
Cell[208562, 4729, 1443, 35, 1816, "Input",ExpressionUUID->"4f72dbc4-df1d-4897-b496-8c2088978fcc",
 InitializationCell->True],
Cell[210008, 4766, 1677, 41, 2003, "Input",ExpressionUUID->"d2b5db67-1dcd-4060-84f4-f733046b6dee",
 InitializationCell->True],
Cell[211688, 4809, 1572, 39, 1426, "Input",ExpressionUUID->"838ea7aa-7307-41e7-859a-ebd9fc51cdad",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[213297, 4853, 289, 6, 38, "Subsection",ExpressionUUID->"59fae4d9-ee62-44e7-bdf5-3969ecd605c9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[213589, 4861, 1382, 30, 307, "Input",ExpressionUUID->"7b4e948d-3ec7-41ac-9544-e74868d89969",
 InitializationCell->True,
 InitializationGroup->True],
Cell[214974, 4893, 1407, 32, 307, "Input",ExpressionUUID->"e6943a37-2fc1-4cd4-b1ef-2e57208cb81a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[216384, 4927, 1499, 32, 401, "Input",ExpressionUUID->"862cc783-746f-408f-ba8d-228bc05b6ea7",
 InitializationCell->True],
Cell[217886, 4961, 1961, 40, 766, "Input",ExpressionUUID->"7cc2baef-3746-47bb-87f5-d6cd73c84d01",
 InitializationCell->True],
Cell[219850, 5003, 2083, 44, 766, "Input",ExpressionUUID->"ae8bfd8f-50ee-4ca2-8f8c-20a30477b95b",
 InitializationCell->True],
Cell[221936, 5049, 2887, 59, 1187, "Input",ExpressionUUID->"05501b81-3f0e-4d79-8836-a76c6a7f08de",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[224860, 5113, 346, 6, 38, "Subsection",ExpressionUUID->"5e1e8d2a-3c8a-4050-9e60-cce43e61a754",
 InitializationCell->True],
Cell[225209, 5121, 320, 7, 58, "Text",ExpressionUUID->"23adc2a5-5bb5-4735-8aa8-bbacc4ec1893",
 InitializationCell->True],
Cell[225532, 5130, 4223, 89, 635, "Input",ExpressionUUID->"8e59f6cf-3ab9-42ac-ac42-e51d6adf5d1b",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[229804, 5225, 841, 13, 36, "Section",ExpressionUUID->"0e9c0dd5-5dc0-4f88-b1c6-79a7831ffd1f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[230670, 5242, 314, 6, 54, "Subsection",ExpressionUUID->"767aeda5-a248-44f2-9c6e-fcd50564a695",
 InitializationCell->True],
Cell[230987, 5250, 4814, 103, 404, "Input",ExpressionUUID->"8c9fb110-e818-4a7d-8cfc-35d41e520bdc",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[235838, 5358, 487, 8, 54, "Subsection",ExpressionUUID->"06d7a93e-dea4-423c-9578-060504ddb7f2",
 InitializationCell->True],
Cell[236328, 5368, 9680, 206, 1017, "Input",ExpressionUUID->"f3f112cf-c68d-456c-b74d-63053a3e7944",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[246045, 5579, 352, 6, 38, "Subsection",ExpressionUUID->"080f299e-d3c3-49f6-973f-e371d56a2300",
 InitializationCell->True],
Cell[246400, 5587, 10381, 220, 884, "Input",ExpressionUUID->"3d5381dd-bc2e-40f8-9efc-93a1498b7d60",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[256818, 5812, 399, 6, 38, "Subsection",ExpressionUUID->"4e0c6e45-7b43-4fee-ba14-4497ba46802c",
 InitializationCell->True],
Cell[257220, 5820, 13079, 261, 1328, "Input",ExpressionUUID->"83ce7f18-23e0-4f49-80dd-297695ca6b42",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[270348, 6087, 390, 7, 36, "Section",ExpressionUUID->"d363df82-f11f-48b1-aacd-24b213048e7e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[270763, 6098, 526, 8, 54, "Subsection",ExpressionUUID->"9497a42b-b066-4571-8973-8811e266a83f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[271292, 6108, 2648, 59, 2003, "Input",ExpressionUUID->"9da56580-0c05-4092-89cd-497e6f8958b9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[273977, 6172, 380, 7, 38, "Subsection",ExpressionUUID->"a0e6522f-91eb-4f7e-adc9-db574d1f1e15",
 InitializationCell->True,
 InitializationGroup->True],
Cell[274360, 6181, 2337, 50, 1222, "Input",ExpressionUUID->"49d06feb-3156-4bd0-8627-15828010dc39",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[276734, 6236, 405, 7, 38, "Subsection",ExpressionUUID->"cfd785a2-b139-470f-bdf1-0dd3da305f74",
 InitializationCell->True,
 InitializationGroup->True],
Cell[277142, 6245, 532, 10, 49, "Text",ExpressionUUID->"ed257b41-4472-4a40-b147-ee05c2824661",
 InitializationCell->True],
Cell[277677, 6257, 15488, 271, 596, "Input",ExpressionUUID->"c1ae2ed7-38d3-4d7b-93fc-6137702b0522",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[293190, 6532, 305, 7, 39, "Subsubsection",ExpressionUUID->"78c48384-f621-4126-a26a-0544e1c62670",
 InitializationCell->True],
Cell[293498, 6541, 534, 10, 796, "Text",ExpressionUUID->"8e99f6a6-efed-4804-9957-bd86172b02e5",
 InitializationCell->True],
Cell[294035, 6553, 2921, 65, 3575, "Input",ExpressionUUID->"aca8163d-9c6b-4f1e-94fb-91eb0edcc20f",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[297017, 6625, 442, 8, 36, "Section",ExpressionUUID->"1d8f8726-823e-4737-8a74-9bb6924e1cc7",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[297484, 6637, 389, 7, 401, "Subsection",ExpressionUUID->"2cc38c04-692a-495f-bd9a-285508927056",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[297898, 6648, 187, 4, 307, "Subsubsection",ExpressionUUID->"9ee87d77-b1f2-49ab-8698-c18c2e6b5586",
 InitializationCell->True],
Cell[298088, 6654, 389, 9, 440, "Input",ExpressionUUID->"cb3d5fc7-1069-424e-9a84-97d34c427dbd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[298514, 6668, 193, 4, 307, "Subsubsection",ExpressionUUID->"1e50219f-83a1-44f4-bf44-cf3a7e20a632",
 InitializationCell->True],
Cell[298710, 6674, 1992, 42, 2200, "Input",ExpressionUUID->"381a2416-4372-479d-81b9-db55db232219",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[300739, 6721, 188, 4, 307, "Subsubsection",ExpressionUUID->"5fc72ea3-2833-49d4-9292-b50995691557",
 InitializationCell->True],
Cell[300930, 6727, 452, 13, 440, "Input",ExpressionUUID->"b015c233-2335-457c-bd92-b6e685d504dc",
 InitializationCell->True],
Cell[301385, 6742, 1830, 48, 1222, "Input",ExpressionUUID->"fd431ccb-61ca-4307-b54f-2f7333452c5d",
 InitializationCell->True],
Cell[303218, 6792, 1083, 27, 637, "Input",ExpressionUUID->"2df73172-1b4c-4cc9-a0ab-a43f059b9b4d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[304338, 6824, 186, 4, 307, "Subsubsection",ExpressionUUID->"aab59d81-ee45-4751-9e85-b2488ba4696a",
 InitializationCell->True],
Cell[304527, 6830, 444, 11, 637, "Input",ExpressionUUID->"ce3cf860-c347-47c9-a6ae-bbc6936a0c80",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[305020, 6847, 349, 6, 401, "Subsection",ExpressionUUID->"d4346af4-75df-4e97-ba86-604464a8a816",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[305394, 6857, 307, 6, 307, "Subsubsection",ExpressionUUID->"87c9f8b8-2979-402f-b7c1-98e85e75be99",
 InitializationCell->True],
Cell[305704, 6865, 738, 17, 835, "Input",ExpressionUUID->"68ec5f11-3e05-4504-be03-d7fdd2244742",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[306479, 6887, 285, 5, 307, "Subsubsection",ExpressionUUID->"f08f350b-a78e-4f71-bd8e-91806ff0c07b",
 InitializationCell->True],
Cell[306767, 6894, 1032, 23, 835, "Input",ExpressionUUID->"43f878be-d998-4e83-8011-8c5714e4bf61",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[307836, 6922, 283, 5, 307, "Subsubsection",ExpressionUUID->"bda564c0-9b79-4aa7-b997-5e78dc25c84a",
 InitializationCell->True],
Cell[308122, 6929, 907, 25, 835, "Input",ExpressionUUID->"5f856395-8204-4ac3-8ee2-90ea931a77dd",
 InitializationCell->True],
Cell[309032, 6956, 397, 8, 445, "Text",ExpressionUUID->"830fcdb6-ec6a-4073-935c-f5e3764d344d",
 InitializationCell->True],
Cell[309432, 6966, 9753, 230, 12376, "Input",ExpressionUUID->"7fb3d5f9-5e59-4ed4-9819-63ea907d1fb4",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[319246, 7203, 377, 7, 36, "Section",ExpressionUUID->"3139e8ef-c308-485a-9e9d-b50678a59e02",
 InitializationCell->True,
 InitializationGroup->True],
Cell[319626, 7212, 419, 10, 637, "Input",ExpressionUUID->"25142868-06df-4c35-9eb1-cf56ea4e6919",
 InitializationCell->True],
Cell[320048, 7224, 478, 11, 440, "Input",ExpressionUUID->"7217c9ef-b7a0-4c1e-802e-6df637a88172",
 InitializationCell->True],
Cell[320529, 7237, 375, 9, 637, "Input",ExpressionUUID->"ca024741-50cb-4a9b-856d-7f933c10ce67",
 InitializationCell->True],
Cell[320907, 7248, 344, 9, 440, "Input",ExpressionUUID->"d1b23e08-e0a3-4337-ad68-8061fe76f1c8",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[321300, 7263, 619, 10, 74, "Chapter",ExpressionUUID->"aa7199cf-eb49-41eb-824f-f4af87623ab3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[321944, 7277, 738, 11, 57, "Subsubtitle",ExpressionUUID->"c569203d-30c4-4e2b-a4ab-8c3db0215628",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[322707, 7292, 488, 9, 44, "Section",ExpressionUUID->"29f70a24-3d17-44ac-9860-32f8704366fb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[323198, 7303, 4233, 69, 320, "Input",ExpressionUUID->"66dc5bec-78b3-49fc-8e48-dd1493da3364",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[327468, 7377, 380, 7, 36, "Section",ExpressionUUID->"6f751c2e-8708-4f8d-80aa-8d44a04c6016",
 InitializationCell->True,
 InitializationGroup->True],
Cell[327851, 7386, 499, 10, 49, "Text",ExpressionUUID->"3411b3ad-e6ab-4527-a992-42b42889608f",
 InitializationCell->True],
Cell[328353, 7398, 583, 11, 48, "Input",ExpressionUUID->"e0a41ad3-d61c-4d3f-8b3c-7e4cd03c37cd",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[328985, 7415, 814, 13, 41, "Subsubtitle",ExpressionUUID->"af59bf71-4ca4-4a1a-87b2-8f3abe6119d7",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[329824, 7432, 420, 7, 36, "Section",ExpressionUUID->"ddd6a019-cb91-424d-abd0-60467a58abce"],
Cell[CellGroupData[{
Cell[330269, 7443, 760, 12, 34, "Subsubsection",ExpressionUUID->"a0a63208-6ee7-47b9-93bc-d1c40f6eef5e",
 InitializationCell->True],
Cell[331032, 7457, 969, 23, 70, "Input",ExpressionUUID->"76b77afc-1f41-4974-a1f5-4766c17eb426",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[332038, 7485, 272, 4, 28, "Subsubsection",ExpressionUUID->"04c5e39c-41a0-49ab-a83d-b87271b2d530"],
Cell[332313, 7491, 175, 3, 30, "Text",ExpressionUUID->"aaec75c3-0646-4af0-ae4a-6990763bd78f"],
Cell[332491, 7496, 913, 23, 133, "Input",ExpressionUUID->"3f9b94dd-9345-4291-9fdf-0b179b488128",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[333453, 7525, 437, 7, 36, "Section",ExpressionUUID->"0d866ba3-a315-482e-b1d5-5a1a447d4171"],
Cell[333893, 7534, 300, 7, 35, "Text",ExpressionUUID->"08fc9845-9c38-44c7-a1b4-b5154ad40812"],
Cell[334196, 7543, 1696, 32, 89, "Input",ExpressionUUID->"d31f9819-71ca-4235-b263-238c5dfdf27d",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[335941, 7581, 832, 13, 57, "Subsubtitle",ExpressionUUID->"d5d7bf4e-912f-4e86-9321-1c870aa80e35",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[336798, 7598, 187, 3, 44, "Section",ExpressionUUID->"b36e66ce-5ce9-49d6-b196-4175fe8ada95"],
Cell[336988, 7603, 1732, 33, 311, "Text",ExpressionUUID->"dcc463ae-6ecc-4ae7-a434-6aa0c4eb6307"],
Cell[338723, 7638, 299, 4, 35, "Text",ExpressionUUID->"4aab0f8c-fa55-4666-922d-49380ed5ea69"]
}, Closed]],
Cell[CellGroupData[{
Cell[339059, 7647, 490, 8, 44, "Section",ExpressionUUID->"16f52e92-882f-4750-8982-9216ed5bc97d"],
Cell[CellGroupData[{
Cell[339574, 7659, 256, 4, 70, "Subsection",ExpressionUUID->"1c29be00-aa29-4d06-86c1-6774d39fbf7b"],
Cell[339833, 7665, 635, 13, 46, "Input",ExpressionUUID->"ef2bd440-824c-477f-bce7-7e0197dd16da",
 InitializationCell->True],
Cell[340471, 7680, 1353, 25, 68, "Input",ExpressionUUID->"e49cb92e-8c19-418a-8e50-38adcf52dd66",
 InitializationCell->True],
Cell[341827, 7707, 1074, 23, 110, "Input",ExpressionUUID->"85ac0c4a-5007-49b2-8bd2-0a6dd1c2fd5d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[342938, 7735, 360, 5, 54, "Subsection",ExpressionUUID->"ea17cff1-a7c3-406c-b5ad-ae14ac958940"],
Cell[CellGroupData[{
Cell[343323, 7744, 337, 6, 45, "Subsubsection",ExpressionUUID->"bd0287b9-4f9e-4269-a0ff-3fc6b54d69b1",
 InitializationCell->True],
Cell[343663, 7752, 311, 4, 30, "Text",ExpressionUUID->"c613c57d-32ba-46c4-9624-f335b9dbe503"],
Cell[343977, 7758, 921, 19, 70, "Input",ExpressionUUID->"fb437609-38a8-426f-ae41-7116352b65fd",
 InitializationCell->True],
Cell[344901, 7779, 1345, 31, 133, "Input",ExpressionUUID->"b4ef34cb-cad2-45dc-889b-3a7ac1196da0",
 InitializationCell->True],
Cell[346249, 7812, 874, 23, 70, "Input",ExpressionUUID->"5ab6d05a-98b0-491f-b0ef-8b8fbaccb1c8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[347160, 7840, 481, 8, 37, "Subsubsection",ExpressionUUID->"053532e7-1a33-4a8a-a1ee-b714ebe85157",
 InitializationCell->True],
Cell[347644, 7850, 625, 9, 30, "Text",ExpressionUUID->"a6a0b35d-14aa-4698-9ee0-bf50e04b215e"],
Cell[348272, 7861, 1573, 33, 112, "Input",ExpressionUUID->"9677dfb4-aa76-4ca4-8ed9-1f412c892657",
 InitializationCell->True],
Cell[349848, 7896, 1676, 36, 217, "Input",ExpressionUUID->"52d9abf5-0127-4a25-a607-0c292f16b1c6",
 InitializationCell->True],
Cell[351527, 7934, 1126, 27, 112, "Input",ExpressionUUID->"ee211a11-7fdd-4533-9f70-fedc87cea32d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[352690, 7966, 581, 9, 37, "Subsubsection",ExpressionUUID->"3971af6f-405f-4c3a-bf8e-223cae7e150c",
 InitializationCell->True],
Cell[353274, 7977, 748, 13, 30, "Text",ExpressionUUID->"923eb4f7-99f9-429c-bb3c-d58701afbe71"],
Cell[354025, 7992, 1652, 34, 112, "Input",ExpressionUUID->"4b6ef65d-21e6-4d78-aaa4-010615f6e0c6",
 InitializationCell->True],
Cell[355680, 8028, 1827, 39, 217, "Input",ExpressionUUID->"bcd44ba5-ba13-47fa-a423-1eb50cca07b3",
 InitializationCell->True],
Cell[357510, 8069, 1206, 28, 133, "Input",ExpressionUUID->"130b5ccc-3931-4e8a-9131-82de9028735d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[358753, 8102, 637, 10, 37, "Subsubsection",ExpressionUUID->"c49f952c-bd32-4434-b24e-107c12506a3b",
 InitializationCell->True],
Cell[359393, 8114, 699, 10, 30, "Text",ExpressionUUID->"27fb84ce-709d-4fee-b875-fbd2df764dc8"],
Cell[360095, 8126, 1703, 36, 112, "Input",ExpressionUUID->"fc0bd939-241f-44d3-bcf2-68ebc41d00ee",
 InitializationCell->True],
Cell[361801, 8164, 1892, 40, 217, "Input",ExpressionUUID->"601fc651-cfd1-4a59-9c4f-bc6cb21a6d83",
 InitializationCell->True],
Cell[363696, 8206, 1242, 29, 154, "Input",ExpressionUUID->"5e519a54-236f-46e2-9f58-1ec18018b492",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[364975, 8240, 687, 11, 37, "Subsubsection",ExpressionUUID->"5caf1cd9-096f-4965-afcf-9dcf25e53825",
 InitializationCell->True],
Cell[365665, 8253, 805, 13, 30, "Text",ExpressionUUID->"bdb2169d-baa0-42f1-908c-b8f5ee698f36"],
Cell[366473, 8268, 1803, 37, 112, "Input",ExpressionUUID->"55030dc8-748b-494b-b7a3-90edf438ee47",
 InitializationCell->True],
Cell[368279, 8307, 1947, 41, 217, "Input",ExpressionUUID->"0d550c8b-f3fe-468e-9f8e-a84dfa688e72",
 InitializationCell->True],
Cell[370229, 8350, 1265, 29, 154, "Input",ExpressionUUID->"44b0fffd-8489-40ad-b567-f78d4be6f430",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[371531, 8384, 742, 11, 37, "Subsubsection",ExpressionUUID->"ec597d98-674c-4e48-a200-b594a7bc5803",
 InitializationCell->True],
Cell[372276, 8397, 693, 10, 30, "Text",ExpressionUUID->"1706437b-8695-4d6d-bc47-75e8012cfbec"],
Cell[372972, 8409, 1826, 40, 133, "Input",ExpressionUUID->"1ea53dc5-9714-4aae-98e9-50d362e6e05f",
 InitializationCell->True],
Cell[374801, 8451, 2005, 42, 238, "Input",ExpressionUUID->"bffc305f-aeb0-41a3-8520-b9f8be7d103a",
 InitializationCell->True],
Cell[376809, 8495, 1298, 30, 154, "Input",ExpressionUUID->"5bf42c3d-731e-4058-babb-6696df2ea851",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[378144, 8530, 902, 14, 37, "Subsubsection",ExpressionUUID->"1c3a6595-8edc-49e3-96ba-ad06e2e30fc9",
 InitializationCell->True],
Cell[379049, 8546, 949, 16, 30, "Text",ExpressionUUID->"da30d7d7-5ff6-4e2b-aac3-c06cac2fa265"],
Cell[380001, 8564, 1926, 39, 112, "Input",ExpressionUUID->"57895b8a-fccc-4c6b-99f7-2c8e30c4d478",
 InitializationCell->True],
Cell[381930, 8605, 2052, 41, 217, "Input",ExpressionUUID->"7ec0bbf4-7190-4324-8172-594a4cef9bbd",
 InitializationCell->True],
Cell[383985, 8648, 1318, 29, 133, "Input",ExpressionUUID->"7d8a0b0f-1161-4a7d-b929-ff14f40dac91",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[385340, 8682, 921, 14, 37, "Subsubsection",ExpressionUUID->"f89d1a29-a59c-4e77-8b60-7c7a75aa08b3",
 InitializationCell->True],
Cell[386264, 8698, 866, 12, 35, "Text",ExpressionUUID->"c535834e-8058-42f0-b9e0-8a8122c25f3a"],
Cell[387133, 8712, 1983, 39, 110, "Input",ExpressionUUID->"35138b9e-9ce1-44a6-90c0-74181eef62a0",
 InitializationCell->True],
Cell[389119, 8753, 2086, 42, 215, "Input",ExpressionUUID->"0471017a-9ec2-41f9-86be-ed210cbea08f",
 InitializationCell->True],
Cell[391208, 8797, 1363, 30, 110, "Input",ExpressionUUID->"71b5f4e1-fcf9-42e2-8d60-f04f5d38b24e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[392608, 8832, 855, 13, 37, "Subsubsection",ExpressionUUID->"56f4c657-8773-45ad-b159-200c3cd37897",
 InitializationCell->True],
Cell[393466, 8847, 644, 9, 30, "Text",ExpressionUUID->"3ec2ff47-3639-4972-907b-671c8447401a"],
Cell[394113, 8858, 1872, 38, 112, "Input",ExpressionUUID->"601c4cec-da77-45c3-b91e-0eb9d1a0388b",
 InitializationCell->True],
Cell[395988, 8898, 2019, 41, 217, "Input",ExpressionUUID->"42bba432-e506-404f-a362-5d8a756bc77b",
 InitializationCell->True],
Cell[398010, 8941, 1409, 31, 154, "Input",ExpressionUUID->"e61583f6-5f9b-4e38-8d51-e1aebf9686c5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[399456, 8977, 1011, 15, 53, "Subsubsection",ExpressionUUID->"1f43e0d0-2b8b-4a76-b826-d12c19e501fe",
 InitializationCell->True],
Cell[400470, 8994, 765, 11, 35, "Text",ExpressionUUID->"b7541ad5-bf85-4c73-a021-0e60548bd6ce"],
Cell[401238, 9007, 1924, 38, 110, "Input",ExpressionUUID->"1d1bc823-1d21-40c8-a957-253ab13917cb",
 InitializationCell->True],
Cell[403165, 9047, 2072, 41, 215, "Input",ExpressionUUID->"c223093c-1b76-4899-a14e-a83e2b897f1b",
 InitializationCell->True],
Cell[405240, 9090, 1319, 29, 131, "Input",ExpressionUUID->"b854a65f-34d5-4b36-98ea-63724ebfd6d8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[406596, 9124, 981, 15, 53, "Subsubsection",ExpressionUUID->"1bd9cbc6-034f-4dfe-95a4-ea2ca8ec2b8a",
 InitializationCell->True],
Cell[407580, 9141, 739, 11, 35, "Text",ExpressionUUID->"85b1c05d-550a-4700-aac4-756eb2e7b08e"],
Cell[408322, 9154, 1907, 38, 110, "Input",ExpressionUUID->"79ce8a3b-a80e-458e-b77d-dc9354492426",
 InitializationCell->True],
Cell[410232, 9194, 2034, 41, 194, "Input",ExpressionUUID->"3b4b4f4b-7517-48de-88e0-6c418dfc55f5",
 InitializationCell->True],
Cell[412269, 9237, 1314, 29, 110, "Input",ExpressionUUID->"7caedabd-0fe8-43ef-92e2-11a9e57562a1",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[413644, 9273, 429, 7, 36, "Section",ExpressionUUID->"e26d2aa6-e1ae-4d3a-a6e6-073e3553bc7b"],
Cell[414076, 9282, 558, 14, 48, "Input",ExpressionUUID->"add71dd1-7792-4850-b1f0-5814308cccb0",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[414683, 9302, 754, 12, 57, "Subsubtitle",ExpressionUUID->"3c84d945-3890-4454-807c-4623c395707f",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[415462, 9318, 481, 8, 36, "Section",ExpressionUUID->"d9e57147-30ab-48bf-a18d-316617657e4b",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[415968, 9330, 590, 10, 44, "Subsection",ExpressionUUID->"063e66fc-af65-4616-84ab-509ab562f9d7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[416561, 9342, 1111, 28, 91, "Input",ExpressionUUID->"9e177b79-8155-4a18-bb0b-0dc0af6478b3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[417709, 9375, 689, 11, 36, "Subsection",ExpressionUUID->"95558766-9f51-4687-825f-3e9019300aac",
 InitializationCell->True,
 InitializationGroup->True],
Cell[418401, 9388, 1962, 48, 196, "Input",ExpressionUUID->"5518d783-e285-4f2b-928c-c978fbd31710",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[420400, 9441, 726, 11, 36, "Subsection",ExpressionUUID->"9603f23c-5e49-428d-9a16-59c95f98fb50",
 InitializationCell->True,
 InitializationGroup->True],
Cell[421129, 9454, 451, 8, 30, "Text",ExpressionUUID->"ce2f40ec-1d6f-4d61-89e4-270e6f9f9644"],
Cell[421583, 9464, 2045, 47, 217, "Input",ExpressionUUID->"9bbd7dc0-2661-442f-b0f8-0b08f0a2f111",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[423677, 9517, 500, 8, 36, "Section",ExpressionUUID->"5c32426c-70e0-4ab0-bb35-cbca39e428a6",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[424202, 9529, 590, 10, 54, "Subsection",ExpressionUUID->"8c3564d4-1d49-4f9a-b438-07d36ddff4c5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[424795, 9541, 1578, 35, 199, "Input",ExpressionUUID->"994644ea-d66c-4fdd-a300-045d02c863ce",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[426410, 9581, 734, 12, 38, "Subsection",ExpressionUUID->"d582f298-b624-4041-9e91-7ae5eebe3d23",
 InitializationCell->True,
 InitializationGroup->True],
Cell[427147, 9595, 2069, 45, 199, "Input",ExpressionUUID->"f47d0d22-1146-4191-9aeb-ded17d886bda",
 InitializationCell->True],
Cell[429219, 9642, 1897, 42, 180, "Input",ExpressionUUID->"584f165a-5b5c-4584-bd09-e8ed5e7d1f22",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[431153, 9689, 782, 13, 38, "Subsection",ExpressionUUID->"249ae056-8a8e-4f97-aade-07fb89d018d4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[431938, 9704, 1957, 43, 180, "Input",ExpressionUUID->"948a6fdb-1a1f-4f3d-9d2e-75e1cf9f3ad9",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[433944, 9753, 680, 11, 36, "Section",ExpressionUUID->"5dc4721e-130b-41d0-ad32-ba1fdfc84e1a",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[434649, 9768, 686, 11, 54, "Subsection",ExpressionUUID->"7ab506a8-a5ca-4d26-aa49-ee4a03ca3720",
 InitializationCell->True,
 InitializationGroup->True],
Cell[435338, 9781, 1892, 38, 259, "Input",ExpressionUUID->"8374ee3a-acd6-47d5-ae84-d48b0150ca09",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[437267, 9824, 641, 11, 38, "Subsection",ExpressionUUID->"8068e201-4d49-436b-8e7f-867599c44af5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[437933, 9839, 704, 11, 34, "Subsubsection",ExpressionUUID->"4f447303-af9b-4b82-b691-33c3a8bf8124",
 InitializationCell->True,
 InitializationGroup->True],
Cell[438640, 9852, 2348, 55, 238, "Input",ExpressionUUID->"a6ab4882-b257-4a62-a000-2d2cc21ea6f0",
 InitializationCell->True],
Cell[440991, 9909, 2410, 56, 259, "Input",ExpressionUUID->"05f3bc1e-c640-4551-b116-1b17f04586c5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[443438, 9970, 659, 11, 28, "Subsubsection",ExpressionUUID->"ed7a0ef1-f6da-4b7e-b077-c86aeebd1457",
 InitializationCell->True,
 InitializationGroup->True],
Cell[444100, 9983, 2110, 48, 238, "Input",ExpressionUUID->"4f4d4377-3640-432b-bd47-a3e70c2ab6e1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[446247, 10036, 711, 11, 28, "Subsubsection",ExpressionUUID->"fbd66220-9e9a-4e86-bfa4-1cec683f26cc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[446961, 10049, 3410, 78, 448, "Input",ExpressionUUID->"1f29ad8b-6a41-417e-b1da-a4d7bff9752d",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[450432, 10134, 732, 11, 36, "Section",ExpressionUUID->"c45a4023-a673-4062-b2dc-cd310832fa15",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[451189, 10149, 686, 11, 44, "Subsection",ExpressionUUID->"1a7da3aa-ecc2-4995-a555-5a8f1390fd4e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[451878, 10162, 1981, 40, 322, "Input",ExpressionUUID->"a62805a2-27f4-4afc-8b40-8863221032d5",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[453896, 10207, 641, 11, 44, "Subsection",ExpressionUUID->"1c1527b4-7d36-4faf-aa1c-e4eea49c6511",
 InitializationCell->True,
 InitializationGroup->True],
Cell[454540, 10220, 2967, 71, 364, "Input",ExpressionUUID->"0b1e69d6-a39d-4f4f-ac84-ef4759100d5e",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[457556, 10297, 786, 12, 36, "Section",ExpressionUUID->"420b1c28-4961-4ac4-8d09-500632291cf4",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[458367, 10313, 590, 10, 43, "Subsection",ExpressionUUID->"a9df87a5-25ea-4e1d-be77-67b2620fcab9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[458960, 10325, 395, 6, 30, "Text",ExpressionUUID->"58a811fb-7a82-4907-8cf9-c7fee1f91527"],
Cell[459358, 10333, 2817, 60, 199, "Input",ExpressionUUID->"64917ccf-f190-46b7-872f-0c4a741c5f01",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[462212, 10398, 644, 11, 35, "Subsection",ExpressionUUID->"9804369d-d243-41ca-af2b-2099b6118145",
 InitializationCell->True,
 InitializationGroup->True],
Cell[462859, 10411, 3701, 74, 256, "Input",ExpressionUUID->"a64e44b0-df57-41b3-a1bf-84e8c3f4cd44",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[466597, 10490, 690, 11, 51, "Subsection",ExpressionUUID->"d5edf83f-05bd-437f-85b2-09b237602a27",
 InitializationCell->True,
 InitializationGroup->True],
Cell[467290, 10503, 704, 12, 65, "Text",ExpressionUUID->"87fe2c72-34a5-4149-911c-27c4790ba493"],
Cell[467997, 10517, 7187, 141, 579, "Input",ExpressionUUID->"ae3e64c3-95e0-41cf-b2d9-866bba90a3a5",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[475233, 10664, 837, 13, 36, "Section",ExpressionUUID->"780cde09-94e1-49c7-8462-b9f60fadb90e",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[476095, 10681, 590, 10, 44, "Subsection",ExpressionUUID->"fe2f3114-51c0-4b9a-8156-fd6082f6f36c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[476688, 10693, 373, 6, 30, "Text",ExpressionUUID->"9530959d-f476-4d0b-b090-2db99e064f1c"],
Cell[477064, 10701, 2743, 58, 280, "Input",ExpressionUUID->"76b6e196-005f-4a9a-928c-aea1cdcf32fa",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[479844, 10764, 715, 12, 36, "Subsection",ExpressionUUID->"de88987c-ee92-44bc-84c6-d6c7be6f5630",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[480584, 10780, 242, 4, 35, "Subsubsection",ExpressionUUID->"a9ea8160-bb79-4ef3-b072-415b5eb0a469"],
Cell[480829, 10786, 4648, 92, 427, "Input",ExpressionUUID->"17c7f2cc-56b8-45fb-a111-cd713e91a633",
 InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[485538, 10885, 876, 13, 36, "Section",ExpressionUUID->"56b8c1c9-569d-4123-944d-8304c4d8a670",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[486439, 10902, 590, 10, 43, "Subsection",ExpressionUUID->"c5d29309-1aad-4434-a108-9a7fffb84b92",
 InitializationCell->True,
 InitializationGroup->True],
Cell[487032, 10914, 373, 6, 30, "Text",ExpressionUUID->"d11f0218-e806-4fa0-984b-df7576d5c520"],
Cell[487408, 10922, 2740, 57, 259, "Input",ExpressionUUID->"b1c0b0ec-d01c-4295-87e9-49ac2fde69ee",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[490185, 10984, 974, 17, 35, "Subsection",ExpressionUUID->"c1cb459b-2098-4c44-960f-8903ebe44217",
 InitializationCell->True,
 InitializationGroup->True],
Cell[491162, 11003, 5293, 102, 427, "Input",ExpressionUUID->"ba0ffe6d-e66f-491a-8777-734ec3efa4fd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[496492, 11110, 758, 12, 35, "Subsection",ExpressionUUID->"854be039-116c-47a1-aace-ef3f5470b138",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[497275, 11126, 287, 4, 35, "Subsubsection",ExpressionUUID->"78e44fdf-dd67-431f-bc82-3533693fdfde"],
Cell[497565, 11132, 3837, 67, 259, "Input",ExpressionUUID->"c1a1a38b-d109-410e-8bf3-28d242d4747d",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[501451, 11205, 328, 5, 35, "Subsection",ExpressionUUID->"da3f721a-f685-4f45-9032-e4ab8f217138"],
Cell[501782, 11212, 4444, 82, 294, "Input",ExpressionUUID->"0edebc02-9e44-4043-858f-72b3c3975ddb",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[506275, 11300, 721, 11, 44, "Section",ExpressionUUID->"c48ce61b-4c11-4c0e-8c8f-c910db137842",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[507021, 11315, 686, 11, 54, "Subsection",ExpressionUUID->"ee9266b2-436e-46cc-8b2a-02d2bcdc6f4f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[507710, 11328, 277, 4, 35, "Text",ExpressionUUID->"dfd93f83-a343-4c10-940a-d01a81faa665"],
Cell[507990, 11334, 2631, 53, 404, "Input",ExpressionUUID->"f941aa35-8f4f-48b0-8779-998e562f0453",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[510658, 11392, 847, 13, 38, "Subsection",ExpressionUUID->"119c9f6a-0542-4ab8-9ee8-9597d4203b16",
 InitializationCell->True,
 InitializationGroup->True],
Cell[511508, 11407, 3501, 66, 467, "Input",ExpressionUUID->"5d350bfd-e49e-4496-83bb-c4d84c687ff2",
 InitializationCell->True],
Cell[515012, 11475, 3263, 62, 425, "Input",ExpressionUUID->"f57db6f3-7f6c-4ba1-a708-d1df36309dbd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[518312, 11542, 932, 14, 54, "Subsection",ExpressionUUID->"5faefe59-f454-4640-aa83-7d2d1c4a187f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[519247, 11558, 3353, 60, 425, "Input",ExpressionUUID->"a3e78e0d-55c9-4b8e-be8c-de4caf04d270",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[522637, 11623, 779, 13, 38, "Subsection",ExpressionUUID->"61f50a0c-670c-46e2-81de-32aab0048796",
 InitializationCell->True,
 InitializationGroup->True],
Cell[523419, 11638, 3148, 64, 467, "Input",ExpressionUUID->"56b9408d-35c3-43b1-966b-be7e8f3af576",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[526616, 11708, 876, 13, 36, "Section",ExpressionUUID->"55d544a5-9f04-4a38-ae03-e5b9798727c7",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[527517, 11725, 727, 12, 44, "Subsection",ExpressionUUID->"b1cf6b61-02e3-41fd-ae01-e26c8e106dd6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[528247, 11739, 1220, 28, 238, "Input",ExpressionUUID->"6ea7ea16-b59f-4aa0-9889-0349fcd0bc9a",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[529516, 11773, 1153, 18, 44, "Section",ExpressionUUID->"aa5b8947-0f62-4d68-93d9-ee5af893b77a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[530694, 11795, 623, 10, 70, "Subsection",ExpressionUUID->"63c0b62b-ed9b-4dd2-8cc4-c56d03b6b837",
 InitializationCell->True,
 InitializationGroup->True],
Cell[531320, 11807, 233, 4, 35, "Text",ExpressionUUID->"d4f959b1-26de-4aa8-af8f-283fdcd8b122"],
Cell[531556, 11813, 1856, 42, 152, "Input",ExpressionUUID->"04d60c76-131c-443d-a821-8ff7c0545707",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[533449, 11860, 748, 12, 54, "Subsection",ExpressionUUID->"40865630-390b-4560-845c-38efa1fbf0b7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[534200, 11874, 2630, 58, 341, "Input",ExpressionUUID->"3428c6e0-b6b7-452e-8db7-d3cfde69c6f9",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[536879, 11938, 1089, 17, 36, "Section",ExpressionUUID->"db26b614-6e2d-4da1-927a-0852006d8d05",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[537993, 11959, 590, 10, 54, "Subsection",ExpressionUUID->"eaa682f6-7887-426b-9b57-3642cc5809c9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[538586, 11971, 233, 4, 35, "Text",ExpressionUUID->"ca459b8d-966b-462c-9585-ca27715d2a47"],
Cell[538822, 11977, 1851, 42, 173, "Input",ExpressionUUID->"af3bde47-8f99-4af4-a81b-30309cf5e141",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[540710, 12024, 715, 12, 38, "Subsection",ExpressionUUID->"97adf75a-5d3c-4d0a-bcdd-5251ccb3c3dc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[541428, 12038, 3108, 68, 467, "Input",ExpressionUUID->"e91bc926-2980-45a4-ae31-b397782f4d5b",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[544597, 12113, 1020, 15, 41, "Subsubtitle",ExpressionUUID->"64adbeda-31b7-4bca-8b49-0be3b20a7e58",
 InitializationCell->True],
Cell[545620, 12130, 357, 7, 35, "Text",ExpressionUUID->"91bb777b-604f-4089-b547-d60803b15258"],
Cell[CellGroupData[{
Cell[546002, 12141, 870, 13, 54, "Subsection",ExpressionUUID->"202920a3-4275-41d0-9b55-af8d9a00270c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[546875, 12156, 1405, 35, 110, "Input",ExpressionUUID->"cbf95a8c-1b13-4529-963d-3d1300fb8799",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[548317, 12196, 699, 11, 54, "Subsection",ExpressionUUID->"5d62efb8-382a-4dd0-b1e9-a47bdef113ae",
 InitializationCell->True,
 InitializationGroup->True],
Cell[549019, 12209, 1694, 32, 91, "Input",ExpressionUUID->"b005ea25-bd80-4df1-9e75-5293feb8029e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[550750, 12246, 643, 11, 38, "Subsection",ExpressionUUID->"298acd5b-6ab2-49fe-9961-8174c1b1ada5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[551396, 12259, 169, 3, 30, "Text",ExpressionUUID->"12cb8e0e-21e2-44d5-85ec-3eaa960eb2aa"],
Cell[551568, 12264, 4141, 79, 238, "Input",ExpressionUUID->"ddb938ef-68cf-4f9a-b6fa-cb97439302e7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[555746, 12348, 694, 11, 38, "Subsection",ExpressionUUID->"abffdf4c-ddf3-49a2-a660-d4d2769740aa",
 InitializationCell->True,
 InitializationGroup->True],
Cell[556443, 12361, 12006, 235, 1181, "Input",ExpressionUUID->"36048c11-c377-4d0d-9e39-6c73ee655584",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[568498, 12602, 1023, 15, 41, "Subsubtitle",ExpressionUUID->"9e495e95-7e96-477c-9a2c-783570154db2",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[569546, 12621, 395, 7, 43, "Subsection",ExpressionUUID->"20ab9076-3720-429d-97ce-063ae770ce7d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[569944, 12630, 759, 11, 30, "Text",ExpressionUUID->"e0e9f34d-3763-4ec8-8639-d2bf516ae1f1"],
Cell[570706, 12643, 673, 16, 70, "Input",ExpressionUUID->"6a87aed3-160c-4715-8480-845d652c0d7f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[571416, 12664, 384, 7, 35, "Subsection",ExpressionUUID->"b2c6cd32-4d5e-4e99-af0e-2c5b5275b822",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[571825, 12675, 363, 7, 34, "Subsubsection",ExpressionUUID->"52f60dad-aee4-457e-a5d6-e1db0d92339d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[572191, 12684, 4795, 78, 112, "Input",ExpressionUUID->"39896965-4793-4407-b570-6dfd47e8bb2f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[577023, 12767, 436, 8, 28, "Subsubsection",ExpressionUUID->"2be8c773-612d-4c34-8273-af6b7b6b31ab",
 InitializationCell->True,
 InitializationGroup->True],
Cell[577462, 12777, 4539, 70, 91, "Input",ExpressionUUID->"d80c00b5-17d7-4999-be4e-0dd5be1ffdf4",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[582050, 12853, 389, 7, 51, "Subsection",ExpressionUUID->"d5975089-8cc7-4976-93ef-c07f871492a4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[582442, 12862, 7151, 136, 446, "Input",ExpressionUUID->"394a6c77-599c-4c23-9537-37f5e6384682",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[589642, 13004, 435, 8, 41, "Subsubtitle",ExpressionUUID->"1d8e64ad-06f8-44f4-913a-138054873e27",
 InitializationCell->True,
 InitializationGroup->True],
Cell[590080, 13014, 366, 9, 48, "Input",ExpressionUUID->"205beac4-1629-4ae1-b7fa-41d932cc1fd3",
 InitializationCell->True],
Cell[590449, 13025, 379, 9, 48, "Input",ExpressionUUID->"f2ae8859-6418-40ce-956e-51c0f2995435",
 InitializationCell->True],
Cell[590831, 13036, 396, 10, 70, "Input",ExpressionUUID->"c2d14941-c1fe-4faa-9c75-6f32b3bcd398",
 InitializationCell->True],
Cell[591230, 13048, 468, 11, 70, "Input",ExpressionUUID->"48d16248-a33e-48fc-8b60-0db240bbe4ae",
 InitializationCell->True],
Cell[591701, 13061, 525, 11, 112, "Input",ExpressionUUID->"a7417a8d-52f9-43dc-8a23-598af91351d7",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[592251, 13076, 154, 3, 44, "Subsection",ExpressionUUID->"5c452fe0-bc57-4dbb-9059-d07dd9db95c4"],
Cell[592408, 13081, 454, 10, 70, "Input",ExpressionUUID->"5473aff5-c779-488e-b6d7-e255447d641e",
 InitializationCell->True],
Cell[592865, 13093, 389, 9, 70, "Input",ExpressionUUID->"11eadf55-2e61-4fc7-a626-29e4a3b0ba6a",
 InitializationCell->True],
Cell[593257, 13104, 526, 11, 112, "Input",ExpressionUUID->"b04303e0-5e60-441e-8b66-948eaedf70dd",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[593844, 13122, 655, 11, 74, "Chapter",ExpressionUUID->"d58ce204-100e-431e-8c48-785a95c4c586",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[594524, 13137, 738, 11, 57, "Subsubtitle",ExpressionUUID->"3020c932-2ab6-473c-b9af-82f9ee78e42d",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[595287, 13152, 488, 9, 44, "Section",ExpressionUUID->"be15ae92-7aec-4bbc-ac24-d4a6109ce71b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[595778, 13163, 4352, 72, 362, "Input",ExpressionUUID->"5f421a6e-8bc7-4cc9-a938-ba3346754f8f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[600167, 13240, 380, 7, 36, "Section",ExpressionUUID->"0b268c22-7e01-4437-b293-83d38fc1e48b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[600550, 13249, 499, 10, 49, "Text",ExpressionUUID->"28129bbc-48c2-4ccd-87ab-d0646d51cc60",
 InitializationCell->True],
Cell[601052, 13261, 566, 11, 48, "Input",ExpressionUUID->"1475746e-0da8-417b-b230-a2c27e3606e1",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[601667, 13278, 814, 13, 41, "Subsubtitle",ExpressionUUID->"9b801f42-aa3e-47f0-9cf1-921162f33a0b",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[602506, 13295, 420, 7, 36, "Section",ExpressionUUID->"59106b80-f0d1-44f0-963a-40175e994866"],
Cell[CellGroupData[{
Cell[602951, 13306, 760, 12, 35, "Subsubsection",ExpressionUUID->"32b20361-c342-47b1-939f-6a7c455e6403",
 InitializationCell->True],
Cell[603714, 13320, 948, 22, 70, "Input",ExpressionUUID->"62655dc5-e99f-4f9b-9029-515de8138e19",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[604699, 13347, 272, 4, 45, "Subsubsection",ExpressionUUID->"3d344252-1d94-4a7b-8429-4bbe0a86e811"],
Cell[604974, 13353, 175, 3, 30, "Text",ExpressionUUID->"885007e5-24e7-4345-aa2b-ff660f0c81c6"],
Cell[605152, 13358, 875, 22, 133, "Input",ExpressionUUID->"502e2bbe-155d-4a64-bb35-f069e751d2b7",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[606076, 13386, 437, 7, 36, "Section",ExpressionUUID->"2d81471c-48ba-4ec3-a532-f5123d4a423a"],
Cell[606516, 13395, 300, 7, 30, "Text",ExpressionUUID->"767b92ed-d00e-48d9-8bc9-294a5b3cbd0b"],
Cell[606819, 13404, 1554, 30, 112, "Input",ExpressionUUID->"5fa857f0-9766-4ff4-8d41-4f201a3cfb97",
 InitializationCell->True],
Cell[608376, 13436, 1579, 30, 112, "Input",ExpressionUUID->"a32e5461-8638-4fd6-baa3-dace1f081853",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[610004, 13472, 832, 13, 57, "Subsubtitle",ExpressionUUID->"6b24c118-724a-4b00-8ef7-f6faef115fc7",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[610861, 13489, 187, 3, 44, "Section",ExpressionUUID->"5f507f57-9d95-4588-aefc-3587f8f8b6b9"],
Cell[611051, 13494, 1751, 33, 357, "Text",ExpressionUUID->"d9256be1-6958-4814-b498-2212d102e58a"],
Cell[612805, 13529, 299, 4, 35, "Text",ExpressionUUID->"0de8b211-135f-4645-99c4-107b56867727"]
}, Closed]],
Cell[CellGroupData[{
Cell[613141, 13538, 490, 8, 44, "Section",ExpressionUUID->"164c8f06-6259-448e-b0b4-bd3d153ab48e"],
Cell[CellGroupData[{
Cell[613656, 13550, 256, 4, 70, "Subsection",ExpressionUUID->"5ac3c095-b9d1-4197-8c0a-8f1fe0577000"],
Cell[613915, 13556, 562, 12, 46, "Input",ExpressionUUID->"c07bff71-a55b-4d52-a311-885cb3e88428",
 InitializationCell->True],
Cell[614480, 13570, 1309, 24, 68, "Input",ExpressionUUID->"e5d9f848-1cb4-4735-9700-b750314128b0",
 InitializationCell->True],
Cell[615792, 13596, 1049, 23, 110, "Input",ExpressionUUID->"42357887-9181-4378-aba4-8c0cefea8ae1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[616878, 13624, 360, 5, 54, "Subsection",ExpressionUUID->"c4f3970c-601b-4cac-b98e-10b23a83d46c"],
Cell[CellGroupData[{
Cell[617263, 13633, 337, 6, 45, "Subsubsection",ExpressionUUID->"25df8f39-4008-4d36-910a-af2de43b297a",
 InitializationCell->True],
Cell[617603, 13641, 311, 4, 30, "Text",ExpressionUUID->"27919a99-261b-4ae8-9455-a9bacf75e294"],
Cell[617917, 13647, 884, 18, 70, "Input",ExpressionUUID->"a2f8f222-41ec-4907-a870-13f580984a14",
 InitializationCell->True],
Cell[618804, 13667, 1323, 31, 133, "Input",ExpressionUUID->"dce7785f-dffc-4686-ba94-34f56ac8d305",
 InitializationCell->True],
Cell[620130, 13700, 836, 22, 70, "Input",ExpressionUUID->"c37ab526-a3ba-463c-857f-ed163a625b0c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[621003, 13727, 481, 8, 37, "Subsubsection",ExpressionUUID->"a7c0d1e7-97e5-4cc9-ab21-d4bc0b980dde",
 InitializationCell->True],
Cell[621487, 13737, 625, 9, 30, "Text",ExpressionUUID->"7baa1f42-dcd2-4e82-a438-96128845b098"],
Cell[622115, 13748, 1550, 33, 112, "Input",ExpressionUUID->"6d0d85c2-aea4-496c-a8b4-4af206416dd2",
 InitializationCell->True],
Cell[623668, 13783, 1656, 36, 217, "Input",ExpressionUUID->"5840597c-c4df-4727-acef-c99fb297e599",
 InitializationCell->True],
Cell[625327, 13821, 1090, 26, 133, "Input",ExpressionUUID->"602542f8-eb54-43a7-b209-8e057c8fabb3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[626454, 13852, 483, 8, 37, "Subsubsection",ExpressionUUID->"acd379c3-35f4-43d5-a06a-f2a8c5e6b0a8",
 InitializationCell->True],
Cell[626940, 13862, 750, 13, 30, "Text",ExpressionUUID->"7e091a8a-87c3-48de-a85d-49174a1f244c"],
Cell[627693, 13877, 1666, 35, 112, "Input",ExpressionUUID->"17c70e7c-4794-413b-a440-964e236712bd",
 InitializationCell->True],
Cell[629362, 13914, 1733, 37, 217, "Input",ExpressionUUID->"38640821-920d-4ba2-a65c-08f00b2da5d1",
 InitializationCell->True],
Cell[631098, 13953, 1139, 27, 133, "Input",ExpressionUUID->"52d5ac40-4b17-4bcf-b3c1-dc1f4357a42a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[632274, 13985, 511, 8, 37, "Subsubsection",ExpressionUUID->"4294ce17-76a1-47c2-95aa-216bda6a9584",
 InitializationCell->True],
Cell[632788, 13995, 890, 14, 30, "Text",ExpressionUUID->"a9e2c2da-6387-4dc4-a653-671ec330bb60"],
Cell[633681, 14011, 1610, 34, 112, "Input",ExpressionUUID->"b612f91a-75d7-42d5-9304-8789cd2f9f3d",
 InitializationCell->True],
Cell[635294, 14047, 1761, 38, 238, "Input",ExpressionUUID->"ae6d947b-3bb0-4581-a20d-1e5390f5f1d1",
 InitializationCell->True],
Cell[637058, 14087, 1159, 28, 154, "Input",ExpressionUUID->"6db3e8b3-8f8c-419d-9044-57ce94847f35",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[638254, 14120, 559, 9, 37, "Subsubsection",ExpressionUUID->"4c18639e-9c66-4008-910c-25e79c4daf25",
 InitializationCell->True],
Cell[638816, 14131, 748, 13, 30, "Text",ExpressionUUID->"0da3f960-5409-45e3-bb55-70b35ba0bd81"],
Cell[639567, 14146, 1631, 35, 112, "Input",ExpressionUUID->"2ce7ff4c-feff-460d-aa08-331592699985",
 InitializationCell->True],
Cell[641201, 14183, 1808, 39, 217, "Input",ExpressionUUID->"27c051ec-e2e0-4050-bf89-1a5f668c8fdb",
 InitializationCell->True],
Cell[643012, 14224, 1180, 28, 154, "Input",ExpressionUUID->"12d2674e-f213-4581-8517-97e7692d9d1c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[644229, 14257, 615, 10, 37, "Subsubsection",ExpressionUUID->"6054158c-63c2-4017-ba35-68700799d8e6",
 InitializationCell->True],
Cell[644847, 14269, 699, 10, 30, "Text",ExpressionUUID->"b193157c-6eb1-4fb7-8f1a-6fca9ae61883"],
Cell[645549, 14281, 1684, 38, 133, "Input",ExpressionUUID->"8739a29f-7dbb-44a8-b396-dce94d2d65f7",
 InitializationCell->True],
Cell[647236, 14321, 1880, 41, 238, "Input",ExpressionUUID->"021c0af4-259b-41d4-a7bc-9e111ab9a5f1",
 InitializationCell->True],
Cell[649119, 14364, 1218, 29, 154, "Input",ExpressionUUID->"1a237d54-d786-46fb-85d6-3304613e2fea",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[650374, 14398, 661, 10, 37, "Subsubsection",ExpressionUUID->"1cd67d3b-650a-4dee-b280-dd9e72f85c62",
 InitializationCell->True],
Cell[651038, 14410, 724, 10, 30, "Text",ExpressionUUID->"071e8690-def6-49c4-b52e-823cddee467a"],
Cell[651765, 14422, 1786, 39, 133, "Input",ExpressionUUID->"2b8645bc-4b2b-4f2c-8bde-9fe9e08a5d85",
 InitializationCell->True],
Cell[653554, 14463, 1928, 41, 238, "Input",ExpressionUUID->"170df02c-3cf9-4c61-9103-de4da054d4b8",
 InitializationCell->True],
Cell[655485, 14506, 1244, 30, 154, "Input",ExpressionUUID->"f632503b-245b-49e0-b80c-bf5881a02cb9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[656766, 14541, 718, 11, 37, "Subsubsection",ExpressionUUID->"81fd063a-8424-4986-a2d2-6932e1dcb647",
 InitializationCell->True],
Cell[657487, 14554, 693, 10, 30, "Text",ExpressionUUID->"a6c75492-0aea-4ccc-afd5-ce7d4845521f"],
Cell[658183, 14566, 1808, 41, 154, "Input",ExpressionUUID->"79394b3b-38f0-4b99-ab0a-e49cf376b180",
 InitializationCell->True],
Cell[659994, 14609, 1984, 42, 238, "Input",ExpressionUUID->"f6801917-901d-4032-877e-80fd3cd0dde7",
 InitializationCell->True],
Cell[661981, 14653, 1271, 30, 154, "Input",ExpressionUUID->"6c01a436-9d01-42a6-a783-22a28b7d288b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[663289, 14688, 876, 13, 37, "Subsubsection",ExpressionUUID->"22a50a5d-d9ab-40e1-a03d-48ab056ae14c",
 InitializationCell->True],
Cell[664168, 14703, 949, 16, 30, "Text",ExpressionUUID->"7a034127-cd55-4e6c-b7cd-494a1f85ccb0"],
Cell[665120, 14721, 1899, 38, 112, "Input",ExpressionUUID->"60b18bb9-0895-4e80-beb0-06adc6f9572b",
 InitializationCell->True],
Cell[667022, 14761, 2045, 42, 217, "Input",ExpressionUUID->"09fa74c7-339d-45c3-b159-e795f87d89e5",
 InitializationCell->True],
Cell[669070, 14805, 1298, 30, 133, "Input",ExpressionUUID->"bcdd7841-6e18-44c7-8d88-3850c36e2059",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[670405, 14840, 927, 14, 53, "Subsubsection",ExpressionUUID->"41d7a5ee-d1fb-473b-b417-d6561ff62512",
 InitializationCell->True],
Cell[671335, 14856, 840, 12, 35, "Text",ExpressionUUID->"a1ef7e8e-7dca-4ac4-b869-9d92c5c89bdd"],
Cell[672178, 14870, 1936, 39, 131, "Input",ExpressionUUID->"1904edfe-d5ea-4f69-b60d-318a0dd1981d",
 InitializationCell->True],
Cell[674117, 14911, 2063, 41, 236, "Input",ExpressionUUID->"c293a912-ad00-4423-a81f-5925425031af",
 InitializationCell->True],
Cell[676183, 14954, 1328, 29, 152, "Input",ExpressionUUID->"cd743acd-2220-4ddf-864a-6ec596f2f7f2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[677548, 14988, 832, 13, 37, "Subsubsection",ExpressionUUID->"1234dd93-7b5b-451d-93be-1bc031c40571",
 InitializationCell->True],
Cell[678383, 15003, 644, 9, 30, "Text",ExpressionUUID->"77e0d30c-038c-4d03-beaf-d8cecf913c42"],
Cell[679030, 15014, 1853, 38, 112, "Input",ExpressionUUID->"abe99f14-8078-45da-96f6-b83d5e6cb86b",
 InitializationCell->True],
Cell[680886, 15054, 2005, 42, 217, "Input",ExpressionUUID->"f70056c8-7bea-4ef4-acb3-8578f290d3a8",
 InitializationCell->True],
Cell[682894, 15098, 1386, 31, 154, "Input",ExpressionUUID->"3ce4752b-3210-4fab-b5b8-22af796c977b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[684317, 15134, 957, 14, 53, "Subsubsection",ExpressionUUID->"9308974c-f49d-44a1-81ad-3535c3a51c70",
 InitializationCell->True],
Cell[685277, 15150, 789, 11, 35, "Text",ExpressionUUID->"e30aadf4-d647-458e-8d76-027be4113d8d"],
Cell[686069, 15163, 1898, 38, 110, "Input",ExpressionUUID->"f7c62c7d-c0f2-48d0-b70e-6be24b403ac2",
 InitializationCell->True],
Cell[687970, 15203, 2056, 42, 215, "Input",ExpressionUUID->"489eb424-c8b6-4ca0-8492-63c0a3298e64",
 InitializationCell->True],
Cell[690029, 15247, 1286, 29, 131, "Input",ExpressionUUID->"d5e2e0b3-53b0-40f8-88da-c32954149012",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[691352, 15281, 931, 14, 53, "Subsubsection",ExpressionUUID->"b580df28-b1cf-4955-8155-850f226e9e64",
 InitializationCell->True],
Cell[692286, 15297, 739, 11, 35, "Text",ExpressionUUID->"d36ff8c9-ba2c-4372-80b4-ffbfa8222ca1"],
Cell[693028, 15310, 1855, 38, 110, "Input",ExpressionUUID->"d68b73f4-6c1f-4ef1-9f7e-281d62468aaa",
 InitializationCell->True],
Cell[694886, 15350, 2009, 40, 215, "Input",ExpressionUUID->"223e31f6-7672-422b-9286-08f0d5ba6748",
 InitializationCell->True],
Cell[696898, 15392, 1283, 29, 131, "Input",ExpressionUUID->"ba9003d1-ba9e-40ff-8f1d-e39f45c3c8ce",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[698242, 15428, 429, 7, 36, "Section",ExpressionUUID->"8d660882-28f4-45c8-9ae8-865cb455c9ad"],
Cell[698674, 15437, 520, 13, 70, "Input",ExpressionUUID->"b7931865-9166-4ac4-8889-d6ec12575c23",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[699243, 15456, 750, 12, 57, "Subsubtitle",ExpressionUUID->"7f42e3ed-e23b-4e2f-992a-773e0604c3a9",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[700018, 15472, 481, 8, 36, "Section",ExpressionUUID->"5a6f3844-d293-4874-a9b0-b027fb683a13",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[700524, 15484, 590, 10, 44, "Subsection",ExpressionUUID->"f25efe23-e8df-441c-be9c-a4745d985f37",
 InitializationCell->True,
 InitializationGroup->True],
Cell[701117, 15496, 1071, 27, 91, "Input",ExpressionUUID->"6133b61c-7934-4f3f-987f-bafa6ed7611d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[702225, 15528, 689, 11, 36, "Subsection",ExpressionUUID->"1a2415ba-fb7b-43cd-a34a-ff3bbc09b913",
 InitializationCell->True,
 InitializationGroup->True],
Cell[702917, 15541, 1944, 49, 196, "Input",ExpressionUUID->"eb9b998b-b199-4e5c-a08e-0dcd5a59626f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[704898, 15595, 726, 11, 36, "Subsection",ExpressionUUID->"9e2efbc9-4f08-49dc-8e28-7a029ef56bdd",
 InitializationCell->True,
 InitializationGroup->True],
Cell[705627, 15608, 451, 8, 30, "Text",ExpressionUUID->"35c1bcc6-6828-455a-a66f-7e728ab33a1c"],
Cell[706081, 15618, 2032, 48, 238, "Input",ExpressionUUID->"d6eade72-9b97-4d16-be13-5ba92a182741",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[708162, 15672, 500, 8, 36, "Section",ExpressionUUID->"bab5d08f-dc42-4046-93c5-b85554a3f615",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[708687, 15684, 590, 10, 44, "Subsection",ExpressionUUID->"1d6f4df0-1193-4279-b4bc-cdeb40ae0f31",
 InitializationCell->True,
 InitializationGroup->True],
Cell[709280, 15696, 1543, 34, 238, "Input",ExpressionUUID->"11a55fd7-6250-4f34-a7e8-de82d4d7bd31",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[710860, 15735, 734, 12, 36, "Subsection",ExpressionUUID->"fbd92a9c-788e-4a21-bdfe-be4929995787",
 InitializationCell->True,
 InitializationGroup->True],
Cell[711597, 15749, 2032, 44, 259, "Input",ExpressionUUID->"757d46d2-9742-4e96-b7a9-e2f5d31a6f2c",
 InitializationCell->True],
Cell[713632, 15795, 1866, 42, 238, "Input",ExpressionUUID->"b7554135-8fd5-4646-8569-de2f1782ae31",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[715535, 15842, 782, 13, 36, "Subsection",ExpressionUUID->"d1ec9f22-54c4-473e-8205-15fbd77ba3c2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[716320, 15857, 1920, 42, 238, "Input",ExpressionUUID->"84bcd681-a5d1-416a-8bea-3a8d333b867e",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[718289, 15905, 550, 9, 36, "Section",ExpressionUUID->"9ec94b5b-de6e-4608-a26e-823e94db251d",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[718864, 15918, 640, 11, 44, "Subsection",ExpressionUUID->"90a47ec8-1aa5-4b28-81e0-d493875426b7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[719507, 15931, 189, 3, 30, "Text",ExpressionUUID->"0a7167f2-4dd5-44d0-9667-4f91cd8c8dc7"],
Cell[719699, 15936, 2930, 64, 469, "Input",ExpressionUUID->"9ce08f70-9d81-406b-b119-aac8602d935e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[722666, 16005, 941, 15, 36, "Subsection",ExpressionUUID->"a00875ab-4cb7-44e2-9d49-69eb97ee0f28",
 InitializationCell->True,
 InitializationGroup->True],
Cell[723610, 16022, 2489, 52, 343, "Input",ExpressionUUID->"53f289d9-c6c1-4ed1-9043-2a663fd29845",
 InitializationCell->True],
Cell[726102, 16076, 2556, 54, 343, "Input",ExpressionUUID->"ad3496ce-65ee-4342-b6c5-86163e8f6a13",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[728695, 16135, 893, 14, 36, "Subsection",ExpressionUUID->"ad32d919-6ddf-4c74-965b-ca5bc69c8961",
 InitializationCell->True,
 InitializationGroup->True],
Cell[729591, 16151, 3099, 66, 469, "Input",ExpressionUUID->"1aadbaef-962d-465b-a17f-a7b70a2befa2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[732727, 16222, 991, 15, 36, "Subsection",ExpressionUUID->"bd0c10ed-b1d2-47f7-9a1c-28867ad69edb",
 InitializationCell->True,
 InitializationGroup->True],
Cell[733721, 16239, 3195, 69, 406, "Input",ExpressionUUID->"59e064cd-0c12-436a-ba51-6106cea45272",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[736953, 16313, 996, 15, 36, "Subsection",ExpressionUUID->"03a4f826-1338-499c-9771-9e8295e0a53e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[737952, 16330, 7056, 153, 658, "Input",ExpressionUUID->"2931bf28-7eda-4e52-bb11-95bf13762ec5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[745045, 16488, 865, 14, 36, "Subsection",ExpressionUUID->"db0ede5b-e92b-4724-8d1e-81c85ec9e0f1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[745913, 16504, 3040, 69, 343, "Input",ExpressionUUID->"a4992eac-4932-4358-904c-f3d1fb44bfc5",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[749002, 16579, 638, 10, 44, "Section",ExpressionUUID->"9e396be7-acd2-49f5-b0a4-a705f3223a54",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[749665, 16593, 710, 11, 54, "Subsection",ExpressionUUID->"783e1125-5795-4255-a748-0f351a9ca340",
 InitializationCell->True,
 InitializationGroup->True],
Cell[750378, 16606, 2106, 44, 343, "Input",ExpressionUUID->"826665b7-5055-454d-bc17-55c4b1171e44",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[752521, 16655, 686, 11, 38, "Subsection",ExpressionUUID->"f5f1c064-4fa8-409d-b7a0-5463018a44cd",
 InitializationCell->True,
 InitializationGroup->True],
Cell[753210, 16668, 226, 4, 30, "Text",ExpressionUUID->"366acab5-3481-4a61-8d4d-e0912ce56665"],
Cell[753439, 16674, 1841, 38, 343, "Input",ExpressionUUID->"003bf918-fedd-444c-8e7b-89648199d32e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[755317, 16717, 784, 13, 38, "Subsection",ExpressionUUID->"42582f7a-2342-4609-9fcd-4c36786fcea5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[756104, 16732, 281, 8, 68, "Text",ExpressionUUID->"3ee26c33-826f-4eb8-897d-549c281a4707"],
Cell[756388, 16742, 4297, 85, 616, "Input",ExpressionUUID->"cafd4329-3b6b-40a7-9e79-25e362c02581",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[760722, 16832, 736, 12, 54, "Subsection",ExpressionUUID->"67a247ce-927d-4075-aada-149268e9fbf9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[761461, 16846, 369, 8, 58, "Text",ExpressionUUID->"11ea0d57-2e1a-4f9d-95f9-5bba604a7c02"],
Cell[761833, 16856, 4359, 90, 635, "Input",ExpressionUUID->"1880b41a-3365-4792-8578-6c5da48e21a0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[766229, 16951, 704, 12, 38, "Subsection",ExpressionUUID->"8d37e96a-5fac-4460-9340-c77a508ffcb6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[766936, 16965, 4783, 100, 574, "Input",ExpressionUUID->"a65179a0-5e0f-4feb-896b-6e073933edc0",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[771768, 17071, 654, 10, 36, "Section",ExpressionUUID->"0b9153c9-2679-465b-aa0e-a6d424a4f15e",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[772447, 17085, 686, 11, 44, "Subsection",ExpressionUUID->"788849d1-f964-4fc5-92ef-90662a6a5c7f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[773136, 17098, 1872, 39, 259, "Input",ExpressionUUID->"b6bf78ba-2c72-416e-8b40-c83f08ce7db4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[775045, 17142, 641, 11, 36, "Subsection",ExpressionUUID->"8aba1763-3ba5-4734-8e83-0cf45f47104b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[775711, 17157, 706, 11, 35, "Subsubsection",ExpressionUUID->"3aeaebaa-7f87-4c81-813b-71205ba26641",
 InitializationCell->True,
 InitializationGroup->True],
Cell[776420, 17170, 296, 7, 30, "Text",ExpressionUUID->"a948d6f7-b43e-4821-9ed9-6310648417ff"],
Cell[776719, 17179, 2489, 62, 364, "Input",ExpressionUUID->"10f81bd7-ca3d-4e8a-b736-7a1ec9e19ebb",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[779245, 17246, 659, 11, 29, "Subsubsection",ExpressionUUID->"2f750348-3ee8-439b-82d0-5060c5454e2e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[779907, 17259, 2008, 47, 238, "Input",ExpressionUUID->"09a560f8-5aa2-4cbe-b9b3-335df763af9a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[781952, 17311, 711, 11, 29, "Subsubsection",ExpressionUUID->"a287f759-3fbf-4232-9f93-c421fec1e28e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[782666, 17324, 3382, 78, 448, "Input",ExpressionUUID->"4cd39090-5523-4805-a976-9eb0db1cc5ca",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[786109, 17409, 710, 11, 36, "Section",ExpressionUUID->"95fd919a-c13f-4593-972b-b7dd8b3a49af",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[786844, 17424, 686, 11, 44, "Subsection",ExpressionUUID->"993a490a-61bf-43d8-bb19-779b1683fe5e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[787533, 17437, 1960, 41, 343, "Input",ExpressionUUID->"a09eb37f-33c6-4017-ad88-898c20ff63cc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[789530, 17483, 641, 11, 44, "Subsection",ExpressionUUID->"13f5e7d4-7e29-4885-9a15-79d927ca51f4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[790174, 17496, 2953, 71, 364, "Input",ExpressionUUID->"67667958-c7ad-4bef-8d66-44a973c2a045",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[793176, 17573, 762, 12, 36, "Section",ExpressionUUID->"9335be0d-dfe0-4052-a358-1ff69e7d0ec7",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[793963, 17589, 590, 10, 43, "Subsection",ExpressionUUID->"e67149aa-1ed2-42c2-8e67-3885f9537859",
 InitializationCell->True,
 InitializationGroup->True],
Cell[794556, 17601, 380, 8, 30, "Text",ExpressionUUID->"a4454d83-bc0b-4b32-a9bb-289b2c70f1e9"],
Cell[794939, 17611, 3350, 74, 385, "Input",ExpressionUUID->"f8774926-e215-46d4-95cb-8b33f22d20f4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[798326, 17690, 644, 11, 35, "Subsection",ExpressionUUID->"37ddcf78-30af-42bc-9f82-a9c3bef41e30",
 InitializationCell->True,
 InitializationGroup->True],
Cell[798973, 17703, 3428, 71, 332, "Input",ExpressionUUID->"e60ce49f-9045-4579-9aa9-173f9a1634af",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[802438, 17779, 690, 11, 51, "Subsection",ExpressionUUID->"f9c8c1de-8d0e-408e-aa59-a08c7e2ba574",
 InitializationCell->True,
 InitializationGroup->True],
Cell[803131, 17792, 704, 12, 84, "Text",ExpressionUUID->"646ffe82-8dd6-48de-aa27-c55390338cad"],
Cell[803838, 17806, 7006, 142, 674, "Input",ExpressionUUID->"cb19113c-b58a-4987-bb51-681e5dcac760",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[810893, 17954, 811, 12, 36, "Section",ExpressionUUID->"59c24145-5bda-4a5f-9068-28f6fcb0eaf8",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[811729, 17970, 590, 10, 44, "Subsection",ExpressionUUID->"cdf21de4-bb59-432f-a1db-e35fac802ba0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[812322, 17982, 373, 6, 30, "Text",ExpressionUUID->"a9a05aba-6586-4021-9b9b-cfe807b92737"],
Cell[812698, 17990, 2733, 58, 301, "Input",ExpressionUUID->"ace1721e-617b-45b1-8406-577a09b52ce1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[815468, 18053, 715, 12, 36, "Subsection",ExpressionUUID->"7206a89c-db06-44eb-8164-fb141173a1b6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[816208, 18069, 242, 4, 35, "Subsubsection",ExpressionUUID->"b0119d5a-7039-4ed9-8a34-ea4cde80b0a8"],
Cell[816453, 18075, 4616, 91, 448, "Input",ExpressionUUID->"a7df5fe0-7fc3-4b62-93e8-bd407c0cec09",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[821130, 18173, 852, 13, 36, "Section",ExpressionUUID->"de654e4c-0043-45b4-a583-625044a7878b",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[822007, 18190, 590, 10, 44, "Subsection",ExpressionUUID->"273a9540-c130-4323-9efc-8d76d424b611",
 InitializationCell->True,
 InitializationGroup->True],
Cell[822600, 18202, 373, 6, 30, "Text",ExpressionUUID->"6388bf50-f2aa-44d6-a0a0-34aafaeba49c"],
Cell[822976, 18210, 2743, 58, 280, "Input",ExpressionUUID->"6c093549-5bdb-483f-b4ec-897c70fad11b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[825756, 18273, 974, 17, 61, "Subsection",ExpressionUUID->"d6d2d919-aa34-4dd4-a496-5cccc41376a9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[826733, 18292, 5267, 102, 448, "Input",ExpressionUUID->"358b729a-67eb-49bf-9c19-15b90103cd77",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[832037, 18399, 758, 12, 44, "Subsection",ExpressionUUID->"05fd98e0-e106-4ae9-8ae5-350a7c6e8c85",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[832820, 18415, 287, 4, 35, "Subsubsection",ExpressionUUID->"54c8feb5-5832-4c7c-8868-b32e657d0857"],
Cell[833110, 18421, 3817, 68, 280, "Input",ExpressionUUID->"42a973c6-fdce-47fb-b1a1-855ea56ce2b7",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[836976, 18495, 328, 5, 44, "Subsection",ExpressionUUID->"5d91c211-ba3d-48d2-a185-6afe989cd5f3"],
Cell[837307, 18502, 4424, 83, 364, "Input",ExpressionUUID->"e913e85e-bff2-4830-a82c-6ec82556b37f",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[841780, 18591, 704, 11, 44, "Section",ExpressionUUID->"72a411cd-d2a3-48a0-9667-db2f19119268",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[842509, 18606, 686, 11, 54, "Subsection",ExpressionUUID->"7229ba80-98c1-4082-9b67-ab6cbeabb1e8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[843198, 18619, 277, 4, 35, "Text",ExpressionUUID->"87b70449-4f12-4cb0-ab35-3138449dc153"],
Cell[843478, 18625, 2546, 53, 446, "Input",ExpressionUUID->"788bd88d-c90a-4d91-8a50-b37c3751f913",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[846061, 18683, 880, 14, 54, "Subsection",ExpressionUUID->"4dd47fb8-d58e-4c0a-8899-5296656e2fa3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[846944, 18699, 2854, 56, 446, "Input",ExpressionUUID->"9c3876eb-d2de-455c-ab4d-293af53e7f59",
 InitializationCell->True],
Cell[849801, 18757, 2771, 55, 446, "Input",ExpressionUUID->"4065f96c-fc92-4404-87fe-caaa79465c97",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[852609, 18817, 936, 14, 54, "Subsection",ExpressionUUID->"4821143a-8045-446d-8f7c-04478204e2b5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[853548, 18833, 3472, 62, 425, "Input",ExpressionUUID->"7fabbfa7-aff2-4985-b5b8-60c41acf30f9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[857057, 18900, 808, 13, 54, "Subsection",ExpressionUUID->"e4af1e57-bf04-4fbc-a7c6-94d7819e1b24",
 InitializationCell->True,
 InitializationGroup->True],
Cell[857868, 18915, 3129, 65, 488, "Input",ExpressionUUID->"015de6b3-23f1-43c5-92cd-a43c5fa8329a",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[861046, 18986, 853, 13, 36, "Section",ExpressionUUID->"369030bf-526b-4900-9286-7ddaa80fdb34",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[861924, 19003, 727, 12, 44, "Subsection",ExpressionUUID->"341362fe-6be5-4a77-945f-ea98da032a64",
 InitializationCell->True,
 InitializationGroup->True],
Cell[862654, 19017, 1197, 28, 238, "Input",ExpressionUUID->"9c806ab3-7289-4cfa-aa78-b81cda9fa3e1",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[863900, 19051, 1177, 18, 44, "Section",ExpressionUUID->"38c9a9a2-0151-4a62-b036-c0f208431cd7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[865102, 19073, 623, 10, 70, "Subsection",ExpressionUUID->"bc63e5bb-4856-4daa-8c1f-1a46a90f7f88",
 InitializationCell->True,
 InitializationGroup->True],
Cell[865728, 19085, 233, 4, 35, "Text",ExpressionUUID->"95626dc4-c212-4e69-a1de-ed251b01e45c"],
Cell[865964, 19091, 1945, 43, 173, "Input",ExpressionUUID->"7d775cda-662d-400f-be12-9d8e7da1f7d6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[867946, 19139, 748, 12, 54, "Subsection",ExpressionUUID->"66ae6b2f-b950-49b7-b927-66b892880724",
 InitializationCell->True,
 InitializationGroup->True],
Cell[868697, 19153, 2700, 59, 362, "Input",ExpressionUUID->"2b71ffc1-29ef-4f45-a810-ba8e4eedd3a7",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[871446, 19218, 1037, 16, 36, "Section",ExpressionUUID->"ee653d38-6fd7-47c6-840b-253b2fb0b95e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[872508, 19238, 590, 10, 54, "Subsection",ExpressionUUID->"333c688e-f6c7-4038-ac72-fd8e96a37698",
 InitializationCell->True,
 InitializationGroup->True],
Cell[873101, 19250, 233, 4, 35, "Text",ExpressionUUID->"c20fe1c3-e1ea-4013-9b0a-1b308f3d23ce"],
Cell[873337, 19256, 1816, 41, 152, "Input",ExpressionUUID->"6c4b7e16-b0a1-485c-ae28-b9c2b8bbb13d",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[875190, 19302, 715, 12, 54, "Subsection",ExpressionUUID->"e81412e5-93fd-410a-a6f4-a836ad583880",
 InitializationCell->True,
 InitializationGroup->True],
Cell[875908, 19316, 3244, 75, 488, "Input",ExpressionUUID->"94373a0b-4aab-4752-8c53-734a22816c64",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[879213, 19398, 877, 13, 57, "Subsubtitle",ExpressionUUID->"71c89072-29ed-4b14-a02c-2666c1b789b7",
 InitializationCell->True],
Cell[880093, 19413, 293, 4, 35, "Text",ExpressionUUID->"7a418f6f-e1ba-404c-a99d-48de30fde2e4"],
Cell[CellGroupData[{
Cell[880411, 19421, 699, 11, 54, "Subsection",ExpressionUUID->"6b742096-c077-471f-8b6e-ae07577d35cd",
 InitializationCell->True,
 InitializationGroup->True],
Cell[881113, 19434, 1652, 31, 85, "Input",ExpressionUUID->"2f6a3e85-8c70-49f1-b42b-9f93259aae0c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[882802, 19470, 643, 11, 38, "Subsection",ExpressionUUID->"86035964-b07f-4df8-a169-248eb7bf9a3c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[883448, 19483, 169, 3, 35, "Text",ExpressionUUID->"b7c85dc1-10d7-46b8-865d-7c20e5003278"],
Cell[883620, 19488, 4123, 79, 299, "Input",ExpressionUUID->"3a784959-6a9f-4756-858a-3b923eb19081",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[887780, 19572, 727, 12, 54, "Subsection",ExpressionUUID->"fde03888-fe7e-42ec-b6a2-abd6fe667c43",
 InitializationCell->True,
 InitializationGroup->True],
Cell[888510, 19586, 15435, 298, 1874, "Input",ExpressionUUID->"2217621f-69c3-45b4-8962-f4176cc6e3e9",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[903970, 19888, 212, 3, 61, "Subsubsection",ExpressionUUID->"38bef4c2-0114-4fb9-9d6e-e16d20a3b010"],
Cell[904185, 19893, 448, 13, 46, "Input",ExpressionUUID->"a6fbfcaa-15af-49c8-8009-ceba10839880",
 InitializationCell->True],
Cell[904636, 19908, 742, 20, 68, "Input",ExpressionUUID->"9b096558-8029-4570-8eff-da1911f617ed",
 InitializationCell->True],
Cell[905381, 19930, 356, 7, 81, "Text",ExpressionUUID->"a4b9acc0-0115-42b6-a782-526ab9a1802c"],
Cell[905740, 19939, 3094, 80, 404, "Input",ExpressionUUID->"86e71367-b066-4507-abd0-9e6d09850064",
 InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[908895, 20026, 435, 8, 41, "Subsubtitle",ExpressionUUID->"ac28a40c-2a9b-4bf7-82dc-b1c05f62775e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[909333, 20036, 345, 8, 48, "Input",ExpressionUUID->"84df0f20-83bd-4560-90ad-011841b86966",
 InitializationCell->True],
Cell[909681, 20046, 551, 11, 70, "Input",ExpressionUUID->"9106962a-ae80-484a-9952-2ce64f596741",
 InitializationCell->True],
Cell[910235, 20059, 599, 12, 70, "Input",ExpressionUUID->"43299e34-0b26-4d26-b22f-37d6881a9b1c",
 InitializationCell->True],
Cell[910837, 20073, 358, 8, 70, "Input",ExpressionUUID->"8eaba2d9-1e56-485f-ab73-b70dc1e1ad76",
 InitializationCell->True],
Cell[911198, 20083, 585, 12, 91, "Input",ExpressionUUID->"5af2f121-b47d-4f67-b6c4-37ce390188ed",
 InitializationCell->True],
Cell[911786, 20097, 368, 9, 70, "Input",ExpressionUUID->"a12891fb-f86b-40cc-827a-b4926f178400",
 InitializationCell->True],
Cell[912157, 20108, 376, 9, 70, "Input",ExpressionUUID->"2c81efb8-1fe7-4cf0-8c9f-66607ed3b210",
 InitializationCell->True],
Cell[912536, 20119, 448, 10, 70, "Input",ExpressionUUID->"90eef6ec-4723-43c3-bfcc-c08ebbd41095",
 InitializationCell->True],
Cell[912987, 20131, 400, 9, 91, "Input",ExpressionUUID->"8ccebce6-f4aa-4fe3-8e17-b89e8801e2dd",
 InitializationCell->True],
Cell[913390, 20142, 528, 11, 112, "Input",ExpressionUUID->"64580b45-f91c-47b0-8ae7-48350e732855",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[913943, 20157, 154, 3, 44, "Subsection",ExpressionUUID->"f402d643-c2cc-4748-88f6-cd627dca9e98"],
Cell[914100, 20162, 454, 10, 70, "Input",ExpressionUUID->"05e9f7bd-355a-4f57-9307-55ef954d3f22",
 InitializationCell->True],
Cell[914557, 20174, 389, 9, 70, "Input",ExpressionUUID->"7179383c-e7b8-47d0-a879-c3b16973c711",
 InitializationCell->True],
Cell[914949, 20185, 526, 11, 112, "Input",ExpressionUUID->"2af50f9e-5232-431e-94af-11e7b0ee8431",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[915536, 20203, 675, 11, 74, "Chapter",ExpressionUUID->"5f831a4f-365c-496f-bdb8-0779de81b648",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[916236, 20218, 705, 11, 41, "Subsubtitle",ExpressionUUID->"36e266ae-ca0f-4997-b485-94686c7b9c5b",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[916966, 20233, 451, 8, 36, "Section",ExpressionUUID->"818b90a0-e06d-417f-a50e-5b6b97980d00",
 InitializationCell->True,
 InitializationGroup->True],
Cell[917420, 20243, 3265, 51, 68, "Input",ExpressionUUID->"854297ca-d8f1-4578-aa0a-2608e324903a",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[920734, 20300, 751, 12, 41, "Subsubtitle",ExpressionUUID->"09fc7921-368e-432c-884b-b8724d1822ec",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[921510, 20316, 152, 3, 36, "Section",ExpressionUUID->"d8e341d3-b30b-46a0-9987-e4a8c549677d"],
Cell[CellGroupData[{
Cell[921687, 20323, 334, 5, 54, "Subsection",ExpressionUUID->"256ca297-0212-446d-9a25-1b9529d53d1a"],
Cell[922024, 20330, 585, 15, 89, "Input",ExpressionUUID->"03e5ac0c-8249-4694-87fd-b85d8f488bfc",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[922658, 20351, 171, 3, 36, "Section",ExpressionUUID->"6954f715-65cb-4fb6-a6fe-0fbaec0837cd"],
Cell[CellGroupData[{
Cell[922854, 20358, 239, 4, 54, "Subsection",ExpressionUUID->"7accf3a5-44c0-4fd8-80d5-44ac69f31390"],
Cell[923096, 20364, 1001, 25, 173, "Input",ExpressionUUID->"85900b34-27db-43d9-a75a-c0a5aa4ab4ca",
 InitializationCell->True],
Cell[924100, 20391, 1087, 26, 173, "Input",ExpressionUUID->"b303d3ba-3648-4dfb-bcef-b86d471905f1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[925224, 20422, 189, 3, 38, "Subsection",ExpressionUUID->"3e1d0f88-2da8-4aba-a82a-23195a7f2adc"],
Cell[CellGroupData[{
Cell[925438, 20429, 170, 3, 45, "Subsubsection",ExpressionUUID->"0e691400-39c9-4e35-8c8b-3bbe9c62c3f3"],
Cell[925611, 20434, 1864, 45, 299, "Input",ExpressionUUID->"05864145-e876-4b84-b431-60cd946b107a",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[927512, 20484, 164, 3, 45, "Subsubsection",ExpressionUUID->"5b01612c-b2ec-43bd-a453-1ebe8a5da7d7"],
Cell[927679, 20489, 2452, 59, 341, "Input",ExpressionUUID->"800e0cec-631f-4b42-9da8-e0a167fe9f0e",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[930168, 20553, 276, 4, 45, "Subsubsection",ExpressionUUID->"e6047448-3570-4ebc-bdf0-dae751417f50"],
Cell[930447, 20559, 2721, 63, 320, "Input",ExpressionUUID->"c95d6142-e814-4e93-9534-6b06c99ccc2c",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[933205, 20627, 224, 5, 45, "Subsubsection",ExpressionUUID->"3cca8c74-5fd7-4c0a-acd7-904e99de8152"],
Cell[933432, 20634, 215, 5, 35, "Text",ExpressionUUID->"9be3b350-efa5-4426-a7eb-4de1b30f2ac8"],
Cell[933650, 20641, 3931, 92, 572, "Input",ExpressionUUID->"bb723d82-a872-4ba5-a475-1f5366899c63",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[937618, 20738, 224, 4, 45, "Subsubsection",ExpressionUUID->"50ce487a-5fec-4b5b-973d-3201ec2af692"],
Cell[937845, 20744, 2854, 64, 425, "Input",ExpressionUUID->"e8e0a762-0817-4514-b477-651bd789fdad",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[940736, 20813, 375, 7, 45, "Subsubsection",ExpressionUUID->"6e53c7d7-4191-44e3-b5f2-8b35c6db0c76"],
Cell[941114, 20822, 2873, 64, 362, "Input",ExpressionUUID->"6c410d11-a24f-43d1-908b-32967f54c087",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[944024, 20891, 273, 4, 45, "Subsubsection",ExpressionUUID->"d1b34d77-90cc-48ce-b7ee-8a8dc1e0e063"],
Cell[944300, 20897, 1365, 33, 194, "Input",ExpressionUUID->"e61b2eda-61d2-4c2f-ab27-27b6f8db289e",
 InitializationCell->True],
Cell[945668, 20932, 1483, 35, 194, "Input",ExpressionUUID->"47742de6-f5ba-4b02-b34d-f912964fc738",
 InitializationCell->True],
Cell[947154, 20969, 1836, 44, 215, "Input",ExpressionUUID->"7ce0dacb-68f8-42a1-99ce-de73b5ba1511",
 InitializationCell->True],
Cell[948993, 21015, 1843, 45, 194, "Input",ExpressionUUID->"2a4d9745-982e-49d7-b1d5-ac6769458564",
 InitializationCell->True]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[950909, 21068, 763, 12, 41, "Subsubtitle",ExpressionUUID->"a734e686-40b5-4c40-924c-53ad72839c88",
 InitializationCell->True],
Cell[951675, 21082, 258, 4, 35, "Text",ExpressionUUID->"1835c82d-d627-4a6c-9553-424efe101afe"],
Cell[951936, 21088, 6602, 151, 1013, "Input",ExpressionUUID->"1b21da4a-5bcb-4ac8-812e-0853373cc8b7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[958575, 21244, 763, 12, 41, "Subsubtitle",ExpressionUUID->"1dbe24cf-b36c-4596-8e3d-199f42a01b1d",
 InitializationCell->True],
Cell[959341, 21258, 233, 4, 35, "Text",ExpressionUUID->"f4eb047e-14e9-4c82-a8c6-e26d2e254279"],
Cell[959577, 21264, 333, 7, 58, "Text",ExpressionUUID->"cb1cad72-8c46-487d-9735-4d82c8b863fc"],
Cell[959913, 21273, 323, 9, 35, "Text",ExpressionUUID->"58ba8414-b4d3-4646-a10c-70b50f89c9b2"],
Cell[960239, 21284, 9724, 214, 1181, "Input",ExpressionUUID->"c22acc24-c06d-4824-803d-f7049d3b3850",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[970000, 21503, 435, 8, 41, "Subsubtitle",ExpressionUUID->"f61f8e15-ac26-4490-83a6-25f20441ed21",
 InitializationCell->True,
 InitializationGroup->True],
Cell[970438, 21513, 766, 15, 173, "Input",ExpressionUUID->"48f6d1ca-0590-43c0-b0a1-b4652eed8afa",
 InitializationCell->True],
Cell[971207, 21530, 370, 9, 68, "Input",ExpressionUUID->"be020dda-cf87-4ade-a0e0-a3a04fe30f45",
 InitializationCell->True],
Cell[971580, 21541, 605, 12, 68, "Input",ExpressionUUID->"37a1f92d-cff4-41d9-9eb6-0861de0c66f3",
 InitializationCell->True],
Cell[972188, 21555, 655, 13, 68, "Input",ExpressionUUID->"8e219093-8f0e-42a9-88e5-59cde04d0a66",
 InitializationCell->True],
Cell[972846, 21570, 732, 15, 89, "Input",ExpressionUUID->"2a048743-336b-4c9f-9be9-7a523d94b4d7",
 InitializationCell->True],
Cell[973581, 21587, 496, 11, 89, "Input",ExpressionUUID->"776d1797-c25d-45e4-b03a-736860428edb",
 InitializationCell->True],
Cell[974080, 21600, 413, 10, 68, "Input",ExpressionUUID->"c9b8b685-3976-42f6-ae89-ba433ed44f20",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[974542, 21616, 487, 9, 74, "Chapter",ExpressionUUID->"4a6f9def-6717-45ac-85a1-8a09cce47dc9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[975054, 21629, 714, 11, 57, "Subsubtitle",ExpressionUUID->"b896718e-4d1b-4b5c-8072-d05aa03125ae",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[975793, 21644, 414, 8, 44, "Section",ExpressionUUID->"38fc809e-ac94-439a-b013-5bbbe328bab8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[976210, 21654, 7250, 121, 656, "Input",ExpressionUUID->"9e8389ca-4716-4e52-a428-3aba9b8c6b94",
 InitializationCell->True],
Cell[983463, 21777, 556, 10, 81, "Text",ExpressionUUID->"9435917c-7410-481c-b116-a774e4e01528",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[984056, 21792, 380, 7, 36, "Section",ExpressionUUID->"3f005276-b5f2-46ef-97b8-34784e92c153",
 InitializationCell->True,
 InitializationGroup->True],
Cell[984439, 21801, 337, 7, 266, "Text",ExpressionUUID->"a1f6bec6-e2e2-4b30-988d-040b39512cdf",
 InitializationCell->True],
Cell[984779, 21810, 457, 9, 440, "Input",ExpressionUUID->"bb6e07a0-068f-41ac-914f-630e70fa13bf",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[985285, 21825, 732, 11, 57, "Subsubtitle",ExpressionUUID->"b5818fab-49c8-4ed9-b41e-7464252c41c1",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[986042, 21840, 187, 3, 44, "Section",ExpressionUUID->"6e1a064a-f683-4c48-932f-4720e521b63d"],
Cell[986232, 21845, 1068, 20, 357, "Text",ExpressionUUID->"a782c495-5a1a-41ce-a87e-bbb62f58d06d"],
Cell[987303, 21867, 299, 4, 35, "Text",ExpressionUUID->"a801e04e-52c2-4b8c-840f-f17db0c49023"]
}, Closed]],
Cell[CellGroupData[{
Cell[987639, 21876, 287, 5, 36, "Section",ExpressionUUID->"324d8b45-ea15-441a-b658-f383d52b3e34"],
Cell[987929, 21883, 1225, 33, 131, "Input",ExpressionUUID->"f4544a54-bd44-4cdc-9a75-7d23fa034254",
 InitializationCell->True],
Cell[989157, 21918, 1631, 36, 173, "Input",ExpressionUUID->"6724df13-b0bb-4380-98a3-0f8da7ed225f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[990825, 21959, 754, 12, 36, "Section",ExpressionUUID->"4c15d8ad-a034-4ae4-9b3b-8d8cca48d595",
 InitializationCell->True],
Cell[991582, 21973, 814, 19, 637, "Input",ExpressionUUID->"ab9c8097-3953-4eac-808f-d742a19a81aa",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[992433, 21997, 382, 6, 44, "Section",ExpressionUUID->"f8b47124-839b-4aed-9c8c-951802bc78fd"],
Cell[CellGroupData[{
Cell[992840, 22007, 275, 4, 70, "Subsection",ExpressionUUID->"091e9ba4-2904-4fcc-9c42-ef22e4b5459c"],
Cell[993118, 22013, 370, 9, 46, "Input",ExpressionUUID->"9e0181d8-8c0c-4231-8c0c-feba9e9d4ed4",
 InitializationCell->True],
Cell[993491, 22024, 336, 7, 58, "Text",ExpressionUUID->"c941c9f3-c542-4027-8b74-744f6dbd9d37"],
Cell[993830, 22033, 828, 20, 68, "Input",ExpressionUUID->"2aac6d99-39dd-4146-b6d3-41f2e446edc3",
 InitializationCell->True],
Cell[994661, 22055, 1314, 29, 68, "Input",ExpressionUUID->"93e500a7-980a-4990-89ba-3fd73bfde2a8",
 InitializationCell->True],
Cell[995978, 22086, 1416, 33, 110, "Input",ExpressionUUID->"30e74a7b-34d1-4a63-a411-2ce2590dd2c9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[997431, 22124, 312, 6, 38, "Subsection",ExpressionUUID->"8ccd2ffa-d52d-47c1-bb40-e4a9e29bdd40",
 InitializationCell->True],
Cell[997746, 22132, 282, 4, 266, "Text",ExpressionUUID->"bd7d882a-1aa0-469a-bce5-303218f25343"],
Cell[998031, 22138, 791, 17, 637, "Input",ExpressionUUID->"03e14fa5-5295-48ae-8179-626a1dd177b9",
 InitializationCell->True],
Cell[998825, 22157, 1195, 30, 835, "Input",ExpressionUUID->"ae01d601-dccc-4f0b-80e4-53418c654e03",
 InitializationCell->True],
Cell[1000023, 22189, 746, 21, 440, "Input",ExpressionUUID->"cc5c1db3-43f4-4efa-8b6c-a25e948c441c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1000806, 22215, 405, 7, 38, "Subsection",ExpressionUUID->"355c83d1-b64f-4c06-b993-febe2cb679e9",
 InitializationCell->True],
Cell[1001214, 22224, 511, 9, 445, "Text",ExpressionUUID->"0ebac51c-aeb6-4ff0-8d3f-4444c39c7eee"],
Cell[1001728, 22235, 1355, 30, 1035, "Input",ExpressionUUID->"2382f784-dbf4-4330-a4ec-9cd6792f4ade",
 InitializationCell->True],
Cell[1003086, 22267, 1483, 34, 1616, "Input",ExpressionUUID->"1a36f5ab-73b8-4d2d-8341-102af0c0adcb",
 InitializationCell->True],
Cell[1004572, 22303, 974, 25, 835, "Input",ExpressionUUID->"eb71ad0c-53d0-4af7-be53-d569aa6828d0",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1005583, 22333, 439, 7, 38, "Subsection",ExpressionUUID->"71238257-ba1d-4461-8c85-b0431e0bf6e7",
 InitializationCell->True],
Cell[1006025, 22342, 490, 7, 35, "Text",ExpressionUUID->"4b1a6cea-d1ec-489c-94fc-4a5fcfabec3c"],
Cell[1006518, 22351, 1513, 32, 110, "Input",ExpressionUUID->"30083fd0-544d-4210-93d3-d511e16cbb6f",
 InitializationCell->True],
Cell[1008034, 22385, 1606, 36, 215, "Input",ExpressionUUID->"04424905-bf3f-4e39-b9c8-8c4759b4da56",
 InitializationCell->True],
Cell[1009643, 22423, 1035, 26, 131, "Input",ExpressionUUID->"1ef202ff-09e6-4bfd-b231-ca0b302efc90",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1010715, 22454, 458, 8, 38, "Subsection",ExpressionUUID->"1c2ff8c3-98b1-4f28-b36e-42f7cbfd8da8",
 InitializationCell->True],
Cell[1011176, 22464, 615, 9, 266, "Text",ExpressionUUID->"77d331ea-c984-4b3b-911e-bd58bb21f922"],
Cell[1011794, 22475, 1392, 31, 957, "Input",ExpressionUUID->"dc94ca58-bccf-4f0e-b6c0-4c6bb6353797",
 InitializationCell->True],
Cell[1013189, 22508, 1592, 36, 1312, "Input",ExpressionUUID->"db6ab517-e8cf-4bb0-ae7c-98d4c545a80b",
 InitializationCell->True],
Cell[1014784, 22546, 1029, 26, 782, "Input",ExpressionUUID->"77f70236-88fb-4ccb-9fa3-09781e07d072",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1015850, 22577, 511, 8, 38, "Subsection",ExpressionUUID->"396161b5-3486-4ddd-afe7-ffba40b13f6e",
 InitializationCell->True],
Cell[1016364, 22587, 609, 10, 266, "Text",ExpressionUUID->"d7f758fb-91fc-4aaf-8e0d-84ee967d4315"],
Cell[1016976, 22599, 1459, 32, 1035, "Input",ExpressionUUID->"67016bf9-56ba-4a5b-8e88-07991c63f17e",
 InitializationCell->True],
Cell[1018438, 22633, 1648, 36, 1616, "Input",ExpressionUUID->"75e0c211-5ccd-4577-9897-7642fe31488a",
 InitializationCell->True],
Cell[1020089, 22671, 1055, 26, 835, "Input",ExpressionUUID->"9df3349f-54e4-4c55-b74c-4924074d5b9d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1021181, 22702, 564, 9, 38, "Subsection",ExpressionUUID->"57463dea-0b14-4dde-b9a8-0aee88f08e4f",
 InitializationCell->True],
Cell[1021748, 22713, 623, 9, 266, "Text",ExpressionUUID->"e3c4c3ed-9d5d-4ac0-b953-e226767f92ec"],
Cell[1022374, 22724, 1525, 32, 1035, "Input",ExpressionUUID->"f25092d0-2cde-41ab-a69b-e488f7995079",
 InitializationCell->True],
Cell[1023902, 22758, 1708, 37, 1816, "Input",ExpressionUUID->"13d93685-0cb5-42bc-8a74-3d5f7f5a4b6d",
 InitializationCell->True],
Cell[1025613, 22797, 1085, 27, 835, "Input",ExpressionUUID->"e7d43783-15c9-4b54-9e32-e3d5d26e4b3e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1026735, 22829, 626, 10, 38, "Subsection",ExpressionUUID->"a454d891-96b1-42b6-b266-eb43749ecd7d",
 InitializationCell->True],
Cell[1027364, 22841, 728, 10, 266, "Text",ExpressionUUID->"cdc84025-9db6-4db1-88b5-cd7c47d8319e"],
Cell[1028095, 22853, 1559, 32, 1035, "Input",ExpressionUUID->"6612ddec-777f-4c91-9fff-2e1c1dcf2f0d",
 InitializationCell->True],
Cell[1029657, 22887, 1740, 38, 1616, "Input",ExpressionUUID->"03544665-fb23-40ab-a96e-8547789df309",
 InitializationCell->True],
Cell[1031400, 22927, 1097, 27, 835, "Input",ExpressionUUID->"f0ce31a8-8007-4289-aa6d-da1bd0a96ac7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1032534, 22959, 685, 11, 38, "Subsection",ExpressionUUID->"40148378-7db2-4598-a274-f08e8e72308e",
 InitializationCell->True],
Cell[1033222, 22972, 1068, 17, 266, "Text",ExpressionUUID->"4b6f846d-ef85-4c7d-a7dc-5097ecde2c8b"],
Cell[1034293, 22991, 1794, 36, 835, "Input",ExpressionUUID->"373f7fe4-2ba6-4d35-af05-0504077fbea8",
 InitializationCell->True],
Cell[1036090, 23029, 1856, 39, 1222, "Input",ExpressionUUID->"e775c46b-a369-4b20-a5ae-1b338af364c4",
 InitializationCell->True],
Cell[1037949, 23070, 1156, 28, 835, "Input",ExpressionUUID->"32b5ce03-1c4d-4ac5-9da2-fdb84b341602",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1039142, 23103, 828, 13, 38, "Subsection",ExpressionUUID->"a0510a52-7c19-4c6c-8108-d430224a3ae5",
 InitializationCell->True],
Cell[1039973, 23118, 1208, 18, 35, "Text",ExpressionUUID->"49543b5d-0a00-4a2d-9692-c46679dac08c"],
Cell[1041184, 23138, 590, 10, 104, "Text",ExpressionUUID->"8807da94-1169-41a6-b6fc-f5956787881d"],
Cell[1041777, 23150, 2034, 39, 110, "Input",ExpressionUUID->"7fb1706b-93d6-4850-8022-8423fc807677",
 InitializationCell->True],
Cell[1043814, 23191, 2001, 41, 194, "Input",ExpressionUUID->"381c89b8-7a8b-4fc0-9256-0f3f1b9a7296",
 InitializationCell->True],
Cell[1045818, 23234, 1226, 29, 89, "Input",ExpressionUUID->"de7a40b6-4d03-45a3-84ba-b3a882e5dfcd",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1047069, 23267, 192, 4, 45, "Subsubsection",ExpressionUUID->"5de63327-bc67-4c07-ab40-e9182a6ea97d",
 InitializationCell->True],
Cell[1047264, 23273, 1694, 42, 1222, "Input",ExpressionUUID->"4050e830-31e6-42cf-bdb6-d284eaa825fe",
 InitializationCell->True],
Cell[1048961, 23317, 1213, 34, 835, "Input",ExpressionUUID->"84a3e81f-3928-4aef-bda9-091b39b77e10",
 InitializationCell->True],
Cell[1050177, 23353, 969, 27, 835, "Input",ExpressionUUID->"81b802a3-1e61-4e74-8e02-0e74ed9c4b91",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1051195, 23386, 933, 14, 38, "Subsection",ExpressionUUID->"f2f19b6d-6ef1-4020-a438-d1f112445b3b",
 InitializationCell->True],
Cell[1052131, 23402, 1239, 17, 266, "Text",ExpressionUUID->"b4482553-6760-4d14-bc04-48a3c8f762f5"],
Cell[1053373, 23421, 2087, 40, 1035, "Input",ExpressionUUID->"c5425620-214d-4757-bcf4-22edc4ff4e5b",
 InitializationCell->True],
Cell[1055463, 23463, 2068, 42, 1816, "Input",ExpressionUUID->"6d7abf6b-58a8-4808-a9d7-64f6ab6fc3b5",
 InitializationCell->True],
Cell[1057534, 23507, 1255, 29, 1035, "Input",ExpressionUUID->"a4aad218-70a4-4d4f-9b7d-900e5c8d633a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1058826, 23541, 975, 15, 38, "Subsection",ExpressionUUID->"2e7ab0a8-2853-4837-b7f1-6463e118204e",
 InitializationCell->True],
Cell[1059804, 23558, 1265, 18, 266, "Text",ExpressionUUID->"22f9a1c7-55b9-4a47-ac00-bd47bb411af7"],
Cell[1061072, 23578, 2122, 41, 1035, "Input",ExpressionUUID->"d53c6ea7-a6a9-420f-a758-b44e25ce9218",
 InitializationCell->True],
Cell[1063197, 23621, 2091, 42, 1616, "Input",ExpressionUUID->"41837b7b-9cdb-4011-8601-2865be834bea",
 InitializationCell->True],
Cell[1065291, 23665, 1267, 29, 835, "Input",ExpressionUUID->"2bf9cd77-c8b9-46b3-bb27-4c207285709e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1066595, 23699, 1101, 16, 54, "Subsection",ExpressionUUID->"b6071dd6-0380-4e41-8177-d670d8bfc76a",
 InitializationCell->True],
Cell[1067699, 23717, 1367, 19, 35, "Text",ExpressionUUID->"f74c06ca-a21d-4511-ba8b-556645908375"],
Cell[1069069, 23738, 2173, 41, 110, "Input",ExpressionUUID->"96f3c145-2681-4f07-83ec-f44b72195473",
 InitializationCell->True],
Cell[1071245, 23781, 2154, 43, 173, "Input",ExpressionUUID->"a75fb807-52dd-432a-9ba2-c91ecd08eefa",
 InitializationCell->True],
Cell[1073402, 23826, 1287, 30, 89, "Input",ExpressionUUID->"32ec1ee2-1def-4e60-ae58-42f090805aff",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1074726, 23861, 1075, 16, 70, "Subsection",ExpressionUUID->"65cde813-3eaa-4983-b2c4-c75ac83682d6",
 InitializationCell->True],
Cell[1075804, 23879, 1313, 18, 35, "Text",ExpressionUUID->"fa2f49ed-f596-496a-b886-f7035d8b2827"],
Cell[1077120, 23899, 2128, 40, 110, "Input",ExpressionUUID->"04e4ea8b-1a0d-47b2-83dd-3d691838726f",
 InitializationCell->True],
Cell[1079251, 23941, 2119, 42, 152, "Input",ExpressionUUID->"beef0269-fdc1-4550-8af2-81c182e605ef",
 InitializationCell->True],
Cell[1081373, 23985, 1284, 30, 89, "Input",ExpressionUUID->"c8d7e423-315e-4c49-ad3b-f2e251e1b3a9",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1082694, 24020, 416, 7, 54, "Subsection",ExpressionUUID->"8169b104-ef9b-4160-a8e2-1caa435ec593"],
Cell[1083113, 24029, 431, 12, 440, "Input",ExpressionUUID->"f0f7da72-7c56-44ef-9795-0ebf144892ec",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1083605, 24048, 647, 10, 41, "Subsubtitle",ExpressionUUID->"94eba405-d2fd-4e76-9b9b-a6a931c99e77",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1084277, 24062, 457, 8, 36, "Section",ExpressionUUID->"f98b69ee-5adb-4bfc-999e-64559203008f",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1084759, 24074, 590, 10, 73, "Subsection",ExpressionUUID->"b28540b9-4dd1-4fd6-9f4f-ad768473fcaa",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1085352, 24086, 960, 28, 637, "Input",ExpressionUUID->"d755d2c5-7459-4980-b291-c2d2ff276119",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1086349, 24119, 689, 11, 60, "Subsection",ExpressionUUID->"974cafb3-4381-4920-b0cc-bc57b97de724",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1087041, 24132, 1759, 46, 1616, "Input",ExpressionUUID->"c05a8657-0669-4edc-9547-392caaf86077",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1088837, 24183, 726, 11, 60, "Subsection",ExpressionUUID->"bde4fbba-cf4c-42da-8e08-6af83929b35b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1089566, 24196, 449, 7, 78, "Text",ExpressionUUID->"71b78e28-3729-494b-8a6b-8343d26d5309"],
Cell[1090018, 24205, 1301, 34, 162, "Input",ExpressionUUID->"65f4a525-e3bc-494b-9017-2778e888e522",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1091368, 24245, 659, 11, 36, "Section",ExpressionUUID->"82dc1d0a-4f0b-46d0-8bd7-7d8b73a29f30",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1092052, 24260, 590, 10, 383, "Subsection",ExpressionUUID->"226b5d1a-8d26-492c-a9b5-eeffc2d54b5b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1092645, 24272, 1168, 32, 1035, "Input",ExpressionUUID->"a976bbc8-65c5-44a0-8710-547bac432974",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1093850, 24309, 819, 13, 307, "Subsection",ExpressionUUID->"789ccad4-ea39-403f-9aec-9a8df94639e3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1094694, 24326, 269, 5, 307, "Subsubsection",ExpressionUUID->"dc67ad47-b0c4-41b4-9c44-8231c87d847a",
 InitializationCell->True],
Cell[1094966, 24333, 1709, 41, 1035, "Input",ExpressionUUID->"b925ad50-0f95-4947-9151-2ea59dac9873",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1096712, 24379, 428, 7, 307, "Subsubsection",ExpressionUUID->"9c3466d9-0961-4350-a101-d904cfbd152f",
 InitializationCell->True],
Cell[1097143, 24388, 1330, 33, 1035, "Input",ExpressionUUID->"45b39a2c-5fe1-476b-a105-17032a5b05cf",
 InitializationCell->True],
Cell[1098476, 24423, 1762, 45, 1616, "Input",ExpressionUUID->"6cd7e960-333c-4406-a9d6-f1d10d9e21d5",
 InitializationCell->True],
Cell[1100241, 24470, 1718, 35, 2793, "Input",ExpressionUUID->"fcc0ede8-512b-4d19-b408-06801cd0d814",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1101996, 24510, 313, 5, 307, "Subsubsection",ExpressionUUID->"b70c6718-ec0e-403e-9061-f99b9cdf7c10",
 InitializationCell->True],
Cell[1102312, 24517, 1979, 51, 1616, "Input",ExpressionUUID->"ab3b9042-f65d-498a-b190-ed10faacde6c",
 InitializationCell->True],
Cell[1104294, 24570, 1948, 50, 1616, "Input",ExpressionUUID->"fa8f905a-ec97-4c6b-be21-db1dff871622",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1106279, 24625, 257, 5, 307, "Subsubsection",ExpressionUUID->"62469fd1-d238-4cd9-b177-3e7fd2ff0ef7",
 InitializationCell->True],
Cell[1106539, 24632, 1407, 37, 1035, "Input",ExpressionUUID->"573227c0-8e34-4b74-8c97-701c2ecc3b22",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1107983, 24674, 797, 13, 307, "Subsubsection",ExpressionUUID->"7b38d0d9-af2d-43d4-b7a6-be750d3b7e0c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1108783, 24689, 1313, 35, 1035, "Input",ExpressionUUID->"aa6038fc-ed11-489a-aa47-75f2b903bf0f",
 InitializationCell->True],
Cell[1110099, 24726, 1359, 35, 1222, "Input",ExpressionUUID->"166ae690-3627-452b-a690-2f8a205b3b41",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1111507, 24767, 832, 13, 307, "Subsection",ExpressionUUID->"5565f777-0948-46f4-b799-6508f53cda41",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1112364, 24784, 170, 3, 352, "Subsubsection",ExpressionUUID->"9a9a48dd-6d18-48ec-aa1b-c66d44e26631"],
Cell[1112537, 24789, 1283, 33, 1616, "Input",ExpressionUUID->"006a3872-2870-459f-8cd3-5c8f11d1fa81",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1113857, 24827, 340, 7, 293, "Subsubsection",ExpressionUUID->"0e1b235b-2ec1-4ecb-a8aa-a35e1d70b390"],
Cell[1114200, 24836, 2001, 48, 2793, "Input",ExpressionUUID->"ed64bc25-8fe8-4ef9-8db3-5160e8520d4b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1116238, 24889, 585, 9, 293, "Subsubsection",ExpressionUUID->"6ff01a39-ec73-4b42-96d0-a040b40ee365",
 InitializationCell->True],
Cell[1116826, 24900, 194, 3, 266, "Text",ExpressionUUID->"c220e427-2853-4b71-9ba6-e5a7bffe12d5"],
Cell[1117023, 24905, 2978, 63, 2597, "Input",ExpressionUUID->"6eeece3e-4a46-4d29-8df2-d3e4539eff29",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1120038, 24973, 586, 9, 293, "Subsubsection",ExpressionUUID->"87301361-f549-4411-b0ac-e13de77b9e17",
 InitializationCell->True],
Cell[1120627, 24984, 194, 3, 266, "Text",ExpressionUUID->"c681c4fc-aa88-431a-9912-6c0759cc9d4c"],
Cell[1120824, 24989, 3077, 65, 1675, "Input",ExpressionUUID->"4f2f6821-de62-4f0b-a512-599e3a52a37b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1123938, 25059, 432, 9, 293, "Subsubsection",ExpressionUUID->"af2ee08b-33d6-44a2-b27b-2601434204c7",
 InitializationCell->True],
Cell[1124373, 25070, 316, 7, 445, "Text",ExpressionUUID->"7db17c61-1c13-4458-bdad-c31bcebaa2b2",
 InitializationCell->True],
Cell[1124692, 25079, 4285, 100, 3078, "Input",ExpressionUUID->"9f4626a2-02f8-4506-8c18-aded52fc045c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1129014, 25184, 365, 6, 293, "Subsubsection",ExpressionUUID->"56af88f1-f48f-4c43-8ee7-49c20686cd70",
 InitializationCell->True],
Cell[1129382, 25192, 316, 7, 445, "Text",ExpressionUUID->"9b2be7e5-5f5e-4294-a16b-9e0c90907dd8",
 InitializationCell->True],
Cell[1129701, 25201, 5037, 118, 6702, "Input",ExpressionUUID->"ca609cb9-424d-4ec9-9b73-5d48248b498b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1134775, 25324, 218, 4, 293, "Subsubsection",ExpressionUUID->"0404567b-6148-45a7-a3d7-10174118da91"],
Cell[1134996, 25330, 1273, 33, 1616, "Input",ExpressionUUID->"67b94bf5-6f75-47fd-b848-9ac834102296",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1136318, 25369, 652, 11, 307, "Subsection",ExpressionUUID->"12dbcc4c-0e27-44cc-b06e-6529d7465045",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1136995, 25384, 170, 3, 307, "Subsubsection",ExpressionUUID->"a94bdb22-0f53-4cf0-9bec-5941376c02bc"],
Cell[1137168, 25389, 1375, 36, 1616, "Input",ExpressionUUID->"48fbe7a2-2dc4-4810-98db-4527a068686e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1138580, 25430, 325, 6, 307, "Subsubsection",ExpressionUUID->"9c355a77-c1ac-4eec-a761-b6f80a321274"],
Cell[1138908, 25438, 2088, 50, 2981, "Input",ExpressionUUID->"32f49843-79a1-425b-b30d-dc4d43e3b72b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1141033, 25493, 256, 4, 307, "Subsubsection",ExpressionUUID->"75cb3a0b-31e7-4fc1-a2d3-4a09727bbf49"],
Cell[1141292, 25499, 247, 6, 266, "Text",ExpressionUUID->"8e82ca5c-5bee-44e8-8cfc-b2ad719b5243",
 InitializationCell->True],
Cell[1141542, 25507, 3252, 75, 3178, "Input",ExpressionUUID->"8351a5e5-3a1d-4b51-8905-80d1d82d4fdd",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1144831, 25587, 218, 4, 307, "Subsubsection",ExpressionUUID->"faa989eb-214c-4f28-b544-91eabfc89e95"],
Cell[1145052, 25593, 1360, 35, 1616, "Input",ExpressionUUID->"5b858378-c6eb-4671-833e-f88cc444cc7f",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1146473, 25635, 547, 9, 36, "Section",ExpressionUUID->"d6fb69fb-f9de-4534-a6bd-991d2839fd8b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1147045, 25648, 590, 10, 54, "Subsection",ExpressionUUID->"9aa928ef-1411-485c-8e68-1081292a44b1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1147638, 25660, 652, 12, 35, "Text",ExpressionUUID->"bdb5cd65-e81a-4434-9fa7-0761feab53f7"],
Cell[1148293, 25674, 1777, 40, 131, "Input",ExpressionUUID->"783e9c04-3c10-49ef-99c0-27745de906b9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1150107, 25719, 715, 12, 38, "Subsection",ExpressionUUID->"69707e92-3c1f-436d-83ff-40680122179e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1150847, 25735, 681, 11, 45, "Subsubsection",ExpressionUUID->"ee993b5f-29eb-4b13-a5ab-e29d98ea3f2c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1151531, 25748, 1177, 28, 835, "Input",ExpressionUUID->"e02029d9-eb44-40cc-aa85-f6eca704e44d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1152745, 25781, 1047, 16, 37, "Subsubsection",ExpressionUUID->"fe04d5ed-c808-4b44-a43d-b910b3fbb7c7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1153795, 25799, 555, 11, 453, "Text",ExpressionUUID->"d6b4ee56-1b3d-48f8-a1b4-f3af46b278b4",
 InitializationCell->True],
Cell[1154353, 25812, 4004, 83, 4897, "Input",ExpressionUUID->"ab754d0d-aa8a-4188-80da-56165edafcc6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1158394, 25900, 929, 15, 37, "Subsubsection",ExpressionUUID->"c1ece637-a37d-4e1b-88dc-6220959735fe",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1159326, 25917, 2029, 49, 1426, "Input",ExpressionUUID->"ef3fb483-2efb-47e9-a1d7-a0599ae92c04",
 InitializationCell->True],
Cell[1161358, 25968, 4438, 102, 3575, "Input",ExpressionUUID->"49f28f4e-30c5-482c-944a-ff15d73c8af8",
 InitializationCell->True],
Cell[1165799, 26072, 4386, 100, 3575, "Input",ExpressionUUID->"c0952dd5-14ad-4e5e-86fa-548c227e4d7d",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1170234, 26178, 920, 14, 38, "Subsection",ExpressionUUID->"82d327c0-1cb5-4552-b4ec-3a7f7770a905",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1171157, 26194, 245, 4, 35, "Text",ExpressionUUID->"983a5d9c-9f03-48df-8a7c-e85aa053d222"],
Cell[1171405, 26200, 3084, 71, 467, "Input",ExpressionUUID->"be220460-4306-4a0e-a8e2-8a399ca79d04",
 InitializationCell->True],
Cell[1174492, 26273, 4673, 99, 509, "Input",ExpressionUUID->"51824d5f-5999-462b-b847-5aa056150d04",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1179202, 26377, 947, 15, 38, "Subsection",ExpressionUUID->"53d0bfd5-4c8c-44fd-9979-a053890330b3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1180152, 26394, 1950, 46, 163, "Input",ExpressionUUID->"7e2b64d9-129b-4be1-8f90-94a1fefd0fe5",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1182139, 26445, 988, 15, 38, "Subsection",ExpressionUUID->"e2e96121-c164-48bd-8e84-828a0e9d6bb8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1183130, 26462, 1935, 44, 163, "Input",ExpressionUUID->"a266473c-d8aa-47ba-9ad1-d343d480b89f",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1185114, 26512, 586, 10, 36, "Section",ExpressionUUID->"df35ab80-1d97-4388-b870-8893f95479a2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1185725, 26526, 590, 10, 44, "Subsection",ExpressionUUID->"da1a5e19-1409-4348-994b-25a5ad05e721",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1186318, 26538, 1220, 33, 106, "Input",ExpressionUUID->"81d991ce-a913-40e5-aaee-996dc2a45a56",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1187575, 26576, 641, 11, 36, "Subsection",ExpressionUUID->"2cc309d3-1d3a-4a30-9d43-4e0097a92dd2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1188241, 26591, 744, 12, 42, "Subsubsection",ExpressionUUID->"c4da0cd4-c6b1-4d12-ab28-ae7d9eb8e200",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1188988, 26605, 193, 3, 38, "Text",ExpressionUUID->"49c8147e-9d0e-4fc7-88a9-06f0b33335d2"],
Cell[1189184, 26610, 5789, 118, 732, "Input",ExpressionUUID->"96c9e1a6-4bd5-49ac-b8f1-b6a9c00e6916",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1195010, 26733, 620, 10, 33, "Subsubsection",ExpressionUUID->"08655e3d-503d-4d3b-b54d-e5b45350db08",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1195633, 26745, 2602, 60, 342, "Input",ExpressionUUID->"07bd2859-0e04-4f62-902c-5a73c2dbb821",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1198296, 26812, 413, 7, 36, "Section",ExpressionUUID->"cdd24cde-3b89-4b72-afa7-b763bdbf0211",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1198734, 26823, 590, 10, 73, "Subsection",ExpressionUUID->"2ae63c9c-ed02-439d-96d7-1350872015c6",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1199327, 26835, 1348, 34, 835, "Input",ExpressionUUID->"32b04aa2-ea6f-46af-91aa-f18036976a59",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1200712, 26874, 641, 11, 60, "Subsection",ExpressionUUID->"20863d0b-3f9e-4948-a5fa-66fa9985d60f",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1201378, 26889, 706, 11, 61, "Subsubsection",ExpressionUUID->"0fe331bb-4334-41e8-b112-40ad6a3aca8a",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1202087, 26902, 188, 3, 47, "Text",ExpressionUUID->"819adeda-7e6f-460c-920d-69fbf79a7791"],
Cell[1202278, 26907, 1513, 42, 163, "Input",ExpressionUUID->"e3d66090-a4d6-44c2-8f58-9776206fc0f2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1203828, 26954, 659, 11, 50, "Subsubsection",ExpressionUUID->"4108dd6a-98fd-407a-8fb8-a3e906a5ae77",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1204490, 26967, 1810, 43, 1816, "Input",ExpressionUUID->"93c09dea-48fc-4daf-a823-89fcd8507ed8",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1206337, 27015, 711, 11, 50, "Subsubsection",ExpressionUUID->"2597a2d8-5db9-4fb9-8c48-abb679df0858",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1207051, 27028, 3164, 74, 3575, "Input",ExpressionUUID->"866085e5-867c-4da2-a39a-1c409021b43f",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1210276, 27109, 665, 11, 36, "Section",ExpressionUUID->"bf8ce338-7452-4e04-9a97-6b7f52f148f1",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1210966, 27124, 590, 10, 401, "Subsection",ExpressionUUID->"86d7ff89-107f-462e-8cd5-ee298c8ebe32",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1211559, 27136, 1409, 36, 835, "Input",ExpressionUUID->"325589ce-f8db-483c-886a-6462ecb599c6",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1213005, 27177, 641, 11, 401, "Subsection",ExpressionUUID->"ef1fab06-7d3b-4b08-a9ce-b1ab055acfc9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1213671, 27192, 680, 11, 307, "Subsubsection",ExpressionUUID->"b51e8f02-dbb9-489a-ab87-0dfe98f0ee7e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1214354, 27205, 1373, 39, 1616, "Input",ExpressionUUID->"e49ad345-36e1-4b0c-b516-13cf1e0e89d7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1215764, 27249, 639, 11, 307, "Subsubsection",ExpressionUUID->"b5f03970-1b15-414a-a4ad-128a796dcdd0",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1216406, 27262, 1994, 50, 1816, "Input",ExpressionUUID->"8ade1e14-3c34-420b-8348-51ed85a740f9",
 InitializationCell->True],
Cell[1218403, 27314, 2033, 51, 1816, "Input",ExpressionUUID->"e696bcdb-dd82-414e-8aee-0d4f60383253",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1220485, 27371, 680, 11, 401, "Subsection",ExpressionUUID->"0a5ca307-e092-4278-8aae-06bd228027c9",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1221168, 27384, 2334, 53, 1035, "Input",ExpressionUUID->"2270350e-79c8-48f1-ad2d-78968f450199",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1223551, 27443, 711, 12, 36, "Section",ExpressionUUID->"ac4fbb13-f9ee-4c33-b232-93e84158f61b",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1224287, 27459, 590, 10, 53, "Subsection",ExpressionUUID->"6ff3e332-b92a-4179-8134-606f94352168",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1224880, 27471, 1466, 36, 106, "Input",ExpressionUUID->"222618be-c6e7-4edc-bc89-990556f87702",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1226383, 27512, 641, 11, 42, "Subsection",ExpressionUUID->"d73fd50f-47df-4761-9197-c83f1a1ba595",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1227049, 27527, 219, 4, 42, "Subsubsection",ExpressionUUID->"6efcebe4-5e31-42b1-ac9d-c064622fd7ba",
 InitializationCell->True],
Cell[1227271, 27533, 1375, 36, 154, "Input",ExpressionUUID->"d1e03f15-f6d2-421f-83f4-a95c2af88e56",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1228683, 27574, 350, 6, 33, "Subsubsection",ExpressionUUID->"ea553ec4-62fc-413c-a646-b46f83afc60d",
 InitializationCell->True],
Cell[1229036, 27582, 1923, 46, 2003, "Input",ExpressionUUID->"d889d418-a3d1-40bd-a745-4b6d0c0964ea",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1230996, 27633, 365, 6, 33, "Subsubsection",ExpressionUUID->"86be7e17-5ff1-416a-9e77-80728cb57974",
 InitializationCell->True],
Cell[1231364, 27641, 2403, 57, 2981, "Input",ExpressionUUID->"764ee131-2f8c-48ee-8842-9e67e50e247a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1233804, 27703, 416, 7, 33, "Subsubsection",ExpressionUUID->"e1fd42cb-8b87-4a5a-8760-17658c4d47c2",
 InitializationCell->True],
Cell[1234223, 27712, 3361, 76, 3378, "Input",ExpressionUUID->"17aac3bc-7a1c-4653-b6d1-72434e15c99c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1237621, 27793, 496, 9, 33, "Subsubsection",ExpressionUUID->"c5e4502e-6d39-40cc-9a30-a2709ff7bace",
 InitializationCell->True],
Cell[1238120, 27804, 3459, 76, 3575, "Input",ExpressionUUID->"df6d0f46-bc68-4e96-a284-e48566e17db5",
 InitializationCell->True],
Cell[1241582, 27882, 3362, 75, 3765, "Input",ExpressionUUID->"82668630-acd2-4122-b0cc-8268322004b7",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1244981, 27962, 545, 9, 33, "Subsubsection",ExpressionUUID->"777e7bb8-cf4e-476b-8c5b-a2e257c7387c",
 InitializationCell->True],
Cell[1245529, 27973, 2108, 44, 1426, "Input",ExpressionUUID->"724ee90b-9abe-4fd5-97cf-6d70a67a3c30",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1247686, 28023, 623, 10, 42, "Subsection",ExpressionUUID->"e5036602-91e7-4ee0-94ad-f75e52fdf0c4",
 InitializationCell->True],
Cell[1248312, 28035, 2272, 56, 2200, "Input",ExpressionUUID->"8c2a9306-4a63-4ac6-9180-25da75d1fc13",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1250633, 28097, 715, 12, 36, "Section",ExpressionUUID->"123c0f57-f224-46b8-8adf-1e87b7c8fdc2",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1251373, 28113, 590, 10, 54, "Subsection",ExpressionUUID->"9887f721-4f57-4e3e-8769-1ca6b4acfffd",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1251966, 28125, 311, 7, 38, "Text",ExpressionUUID->"d46e50a5-d15e-4c3d-bb76-0c938ad42a1e"],
Cell[1252280, 28134, 1721, 38, 154, "Input",ExpressionUUID->"a1a35657-e691-4b02-bba7-003c26cfebcc",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1254038, 28177, 644, 11, 38, "Subsection",ExpressionUUID->"0a06bc43-2fe9-4635-821c-db9ccaffa2bc",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1254685, 28190, 3530, 73, 418, "Input",ExpressionUUID->"bb68f620-a288-4538-b588-51543cdd446f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1258252, 28268, 690, 11, 38, "Subsection",ExpressionUUID->"560e30e3-2547-41a4-9f05-73f4ad0d0ae4",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1258945, 28281, 181, 3, 35, "Text",ExpressionUUID->"6b2c5d41-aee9-419f-8459-0e23cb281634"],
Cell[1259129, 28286, 6510, 133, 803, "Input",ExpressionUUID->"be39bd53-a674-47c2-8782-0051c336dfd7",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1265676, 28424, 704, 11, 54, "Subsection",ExpressionUUID->"d52b0459-2c0c-4dff-b28d-1bf11ed84014",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1266383, 28437, 5367, 100, 4125, "Input",ExpressionUUID->"287f8b1d-3962-4cab-8a3b-7551be075432",
 InitializationCell->True],
Cell[1271753, 28539, 1689, 44, 1797, "Input",ExpressionUUID->"c5a2bc4a-bef7-4299-8441-796deca0c583",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1273479, 28588, 767, 12, 38, "Subsection",ExpressionUUID->"61e0557d-4d3f-4b17-8c1f-0180890ec350",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1274249, 28602, 3524, 84, 2445, "Input",ExpressionUUID->"862d660d-2358-402c-bbc6-d97d76c3d647",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1277822, 28692, 804, 13, 36, "Section",ExpressionUUID->"46272f31-6c16-466b-9bc1-9a0fd11c6360",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1278651, 28709, 590, 10, 54, "Subsection",ExpressionUUID->"02dc70ae-6360-4302-84ba-e7d4a849b20c",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1279244, 28721, 297, 4, 35, "Text",ExpressionUUID->"6e1d62b4-3be3-433e-b7f4-72156e072a68"],
Cell[1279544, 28727, 2411, 51, 173, "Input",ExpressionUUID->"d14ec1c6-fd12-451b-b2f5-2cebc5887cac",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1281992, 28783, 869, 13, 54, "Subsection",ExpressionUUID->"2e163770-bbb1-4d7d-9328-6654816a20a8",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1282886, 28800, 436, 7, 45, "Subsubsection",ExpressionUUID->"4c344f21-c091-42e7-a2c1-deca21d3e90c",
 InitializationCell->True],
Cell[1283325, 28809, 248, 4, 266, "Text",ExpressionUUID->"5220afbe-0734-4e22-a3c7-137075e210fc"],
Cell[1283576, 28815, 2956, 64, 1495, "Input",ExpressionUUID->"6be78b5e-b932-455b-ac97-6901a0797795",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1286569, 28884, 322, 5, 37, "Subsubsection",ExpressionUUID->"69d8c413-178a-470c-9789-212fa761d2c8",
 InitializationCell->True],
Cell[1286894, 28891, 262, 6, 35, "Text",ExpressionUUID->"4c5a8acb-9c4e-4c4c-897b-766d2d49ae19"],
Cell[1287159, 28899, 9854, 220, 1307, "Input",ExpressionUUID->"bf6742a5-c2b9-4aae-9590-bd15c5cc2bde",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1297050, 29124, 315, 5, 45, "Subsubsection",ExpressionUUID->"35462ea8-f0ae-41aa-9d85-01aff97cc81b",
 InitializationCell->True],
Cell[1297368, 29131, 1968, 56, 173, "Input",ExpressionUUID->"b09c7d5c-349a-4a8b-9778-ec9db60f3bf9",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1299373, 29192, 312, 6, 37, "Subsubsection",ExpressionUUID->"358b8cbe-366f-45d2-9c1e-29ae4a381872",
 InitializationCell->True],
Cell[1299688, 29200, 584, 13, 637, "Input",ExpressionUUID->"5d5701b0-5aca-43bd-8728-c0676def1eb8",
 InitializationCell->True],
Cell[1300275, 29215, 2814, 68, 2200, "Input",ExpressionUUID->"14bac3b6-ddd6-4878-8669-cfcdbed68fc4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1303126, 29288, 183, 4, 37, "Subsubsection",ExpressionUUID->"c18557a4-dc03-40c6-ae0f-89d3484b825a",
 InitializationCell->True],
Cell[1303312, 29294, 2895, 70, 2793, "Input",ExpressionUUID->"f2a77a59-051d-45e1-966f-28ad8fbd112d",
 InitializationCell->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1306256, 29370, 819, 13, 54, "Subsection",ExpressionUUID->"af45229d-cacf-42e9-ac1a-d323e7dcd1c5",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1307100, 29387, 436, 7, 352, "Subsubsection",ExpressionUUID->"ea452b47-90eb-4a3b-9b14-9cab4ea6f66e",
 InitializationCell->True],
Cell[1307539, 29396, 2708, 61, 1495, "Input",ExpressionUUID->"be663e90-764d-4dba-b7f6-718417aa2eb3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1310284, 29462, 583, 11, 556, "Subsubsection",ExpressionUUID->"2e9efe26-ab36-4b3d-a228-8ee14faa42be",
 InitializationCell->True],
Cell[1310870, 29475, 3774, 89, 3627, "Input",ExpressionUUID->"faa4c451-247f-4de1-924d-7ae6d882dc5d",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1314681, 29569, 682, 12, 608, "Subsubsection",ExpressionUUID->"ae7bd755-d0e6-49d2-901c-85e78b33b663",
 InitializationCell->True],
Cell[1315366, 29583, 4167, 96, 3618, "Input",ExpressionUUID->"0f7120f1-7963-4b92-a777-70d028dcac47",
 InitializationCell->True],
Cell[1319536, 29681, 4353, 98, 3618, "Input",ExpressionUUID->"de2467ea-0f8c-47c4-9a5d-ee27a3165f98",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1323926, 29784, 528, 10, 608, "Subsubsection",ExpressionUUID->"3444f258-1418-4793-8463-6eb3ee5ad359",
 InitializationCell->True],
Cell[1324457, 29796, 4406, 101, 3797, "Input",ExpressionUUID->"f8ab0981-7878-45b7-9042-44d279afec5a",
 InitializationCell->True],
Cell[1328866, 29899, 4415, 101, 3797, "Input",ExpressionUUID->"98f8d6f3-ef26-4a07-8192-cf1926186f3b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1333318, 30005, 441, 8, 608, "Subsubsection",ExpressionUUID->"2afecd70-9702-4791-900f-35de5532f183"],
Cell[1333762, 30015, 4518, 100, 3627, "Input",ExpressionUUID->"c617c572-5ede-4456-8834-cd3bf67abb7b",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1338317, 30120, 469, 9, 352, "Subsubsection",ExpressionUUID->"b44588d9-1e56-4f4f-89b2-43f1efebbe14"],
Cell[1338789, 30131, 3557, 78, 2746, "Input",ExpressionUUID->"ae1bc811-58fb-4755-a8c4-d8835b9f89c8",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1342395, 30215, 921, 14, 38, "Subsection",ExpressionUUID->"ea46e5b3-8d34-44e3-b1ad-549ecfac03ae",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1343319, 30231, 248, 6, 266, "Text",ExpressionUUID->"8c8bd788-acd6-4b32-b04f-187c3b9a1e4c",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1343592, 30241, 436, 7, 352, "Subsubsection",ExpressionUUID->"f21c3071-462d-404d-9469-e77e8cd6139f",
 InitializationCell->True],
Cell[1344031, 30250, 2889, 64, 1675, "Input",ExpressionUUID->"3fc5fe5b-e22d-4b5f-9700-b4c114132809",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1346957, 30319, 506, 8, 293, "Subsubsection",ExpressionUUID->"af19aa12-8716-4cf9-ac01-93226f30d4ae",
 InitializationCell->True],
Cell[1347466, 30329, 3254, 73, 1853, "Input",ExpressionUUID->"a191f595-33b4-4ff1-907d-e7dd44d295e1",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1350757, 30407, 297, 7, 293, "Subsubsection",ExpressionUUID->"ddf0dc10-1b5b-4937-a6aa-06bdd2b7e2f6",
 InitializationCell->True],
Cell[1351057, 30416, 4819, 105, 4165, "Input",ExpressionUUID->"5096280d-2e5d-4237-a365-4d4237334bec",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1355913, 30526, 318, 7, 293, "Subsubsection",ExpressionUUID->"68f6b5c0-d8fb-473c-a210-bc75c7cfbe7a",
 InitializationCell->True],
Cell[1356234, 30535, 5576, 122, 5215, "Input",ExpressionUUID->"9811cfc1-fd91-4881-8901-009293595cb6",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1361859, 30663, 963, 15, 38, "Subsection",ExpressionUUID->"fc9ee684-e36b-4c96-b3c3-0974def18462",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1362825, 30680, 224, 5, 47, "Text",ExpressionUUID->"c9d94149-90fc-499e-9373-1c1bb65a2259"],
Cell[CellGroupData[{
Cell[1363074, 30689, 486, 8, 61, "Subsubsection",ExpressionUUID->"c10eec8f-55b1-4cc6-8b63-66557e837b5e",
 InitializationCell->True],
Cell[1363563, 30699, 2787, 58, 1665, "Input",ExpressionUUID->"a4101cd9-2a4a-4971-997d-6c0b9dcca8b4",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1366387, 30762, 614, 9, 50, "Subsubsection",ExpressionUUID->"3c173c64-dfbf-4f29-a7b3-b2a97a3fd103",
 InitializationCell->True],
Cell[1367004, 30773, 2092, 53, 1665, "Input",ExpressionUUID->"107e7766-5346-47bf-8b2c-04a9a7488aa2",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1369133, 30831, 760, 11, 50, "Subsubsection",ExpressionUUID->"3f92bfcd-c68c-4ad9-a820-dd5ade6e074f",
 InitializationCell->True],
Cell[1369896, 30844, 4291, 94, 2543, "Input",ExpressionUUID->"508855b0-a389-4f78-a649-250d315ec704",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1374224, 30943, 857, 15, 50, "Subsubsection",ExpressionUUID->"571f50c9-fc78-4a75-bdb4-1554c44cd323",
 InitializationCell->True],
Cell[1375084, 30960, 4366, 93, 462, "Input",ExpressionUUID->"533679c2-3131-4913-a14b-74acfddab31a",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1379499, 31059, 668, 11, 38, "Subsection",ExpressionUUID->"3dfd04d9-4d42-41ce-b632-f8a955a47c25",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1380170, 31072, 2375, 51, 1316, "Input",ExpressionUUID->"2a5beab7-5a43-4e70-bbe7-06ef276e4e99",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1382594, 31129, 858, 14, 36, "Section",ExpressionUUID->"491d18ba-c677-44e7-8482-d94986fc0a2e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1383477, 31147, 590, 10, 53, "Subsection",ExpressionUUID->"0ccbbf18-58d9-44bf-a25a-4d161d301327",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1384070, 31159, 1563, 38, 106, "Input",ExpressionUUID->"8def08fb-2b7d-439a-966d-c879c5ebe03a",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1385670, 31202, 715, 12, 53, "Subsection",ExpressionUUID->"fb318766-9f3b-44cc-9046-1c9ee7183bf3",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1386410, 31218, 242, 4, 61, "Subsubsection",ExpressionUUID->"cd84a898-49bc-43c8-b786-ef3e1ef3ca09"],
Cell[1386655, 31224, 4751, 98, 552, "Input",ExpressionUUID->"64a9d1ef-3502-4189-ab73-31845d2b0a0d",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1391455, 31328, 805, 13, 42, "Subsection",ExpressionUUID->"a4c02ede-08b5-4ab4-81a5-8dc1aa83e93e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1392263, 31343, 1198, 31, 222, "Input",ExpressionUUID->"fd916b1d-80ce-428b-bba6-3eb2f903df29",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1393510, 31380, 874, 14, 36, "Section",ExpressionUUID->"7a28927c-da51-4258-8157-649853ee05ac",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1394409, 31398, 590, 10, 53, "Subsection",ExpressionUUID->"8c3026a8-5258-4488-9605-34af7c52b319",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1395002, 31410, 233, 4, 38, "Text",ExpressionUUID->"69123495-2eba-4ae2-b347-d95d41dbcfe5"],
Cell[1395238, 31416, 1746, 43, 106, "Input",ExpressionUUID->"e5c8d1b8-8bf5-4257-a2e0-7dda4f2d35eb",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1397021, 31464, 715, 12, 53, "Subsection",ExpressionUUID->"ed0afdf6-db32-498b-812a-f5222114554d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1397739, 31478, 3256, 80, 3965, "Input",ExpressionUUID->"0639ddd4-b671-484c-9fd8-dc600ef83551",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1401044, 31564, 1054, 16, 44, "Section",ExpressionUUID->"4d46eb71-d526-4a61-be99-43644ac37f48",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1402123, 31584, 590, 10, 54, "Subsection",ExpressionUUID->"9b2a1005-848f-4818-b295-32cc0af424ff",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1402716, 31596, 233, 4, 35, "Text",ExpressionUUID->"a9773308-5efc-4b46-8eb0-8658d12ef43b"],
Cell[1402952, 31602, 1714, 42, 110, "Input",ExpressionUUID->"489cdf66-9606-48ce-a90d-6f74dd99735a",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1404703, 31649, 715, 12, 38, "Subsection",ExpressionUUID->"5c89f3ed-6b5a-4689-bddf-60d73d96645d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1405421, 31663, 3066, 73, 425, "Input",ExpressionUUID->"afd9bcaf-5d28-4168-91d4-2fd86ec7e0cf",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1408536, 31742, 1078, 16, 36, "Section",ExpressionUUID->"02b1d110-5046-44d0-a803-f221dc2c6915",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1409639, 31762, 590, 10, 54, "Subsection",ExpressionUUID->"9dd6df6e-141c-41c2-9eb4-6003757b7457",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1410232, 31774, 233, 4, 35, "Text",ExpressionUUID->"ef898462-00e3-479a-87de-3835c0ae135c"],
Cell[1410468, 31780, 1686, 42, 110, "Input",ExpressionUUID->"a82bb1bf-5641-4caf-a979-8ff22d000aca",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1412191, 31827, 715, 12, 38, "Subsection",ExpressionUUID->"70d24e1d-ccce-49a0-b4cf-f0859b7cb273",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1412909, 31841, 2552, 62, 341, "Input",ExpressionUUID->"e57d8451-583b-408f-8ef4-80ebf7feec68",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1415522, 31910, 678, 11, 41, "Subsubtitle",ExpressionUUID->"14893274-9c55-4681-aa4b-f3d4c7b6d8ba",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1416225, 31925, 556, 9, 54, "Subsection",ExpressionUUID->"9c8fcce2-d010-4f45-8659-56246695659e",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1416806, 31938, 252, 6, 45, "Subsubsection",ExpressionUUID->"82d7394a-e344-4a78-822c-9307e3ea7247",
 InitializationCell->True],
Cell[1417061, 31946, 3731, 79, 492, "Input",ExpressionUUID->"8a50d3a2-0130-4965-90df-328ea10e0687",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1420829, 32030, 262, 5, 37, "Subsubsection",ExpressionUUID->"ff6513cf-8312-4480-b591-ce0674a914db",
 InitializationCell->True],
Cell[1421094, 32037, 279, 6, 35, "Text",ExpressionUUID->"1cd51ccc-cc13-4013-b0a2-4ac2bec4661f"],
Cell[1421376, 32045, 8459, 173, 824, "Input",ExpressionUUID->"e4258c2b-1eea-4f1a-8cee-f7dd39f5aa69",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1429884, 32224, 869, 14, 54, "Subsection",ExpressionUUID->"a75eae9e-db95-4dff-a8c8-7b486da1f80d",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1430756, 32240, 2540, 65, 1408, "Input",ExpressionUUID->"1d3eea0a-63f2-4cdd-88d6-79c087c9c96c",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1433333, 32310, 487, 8, 38, "Subsection",ExpressionUUID->"53baca82-64cc-45d8-b332-9b64952a5f64",
 InitializationCell->True],
Cell[1433823, 32320, 10582, 225, 1391, "Input",ExpressionUUID->"45c3be2b-990b-4e6d-a1c6-42da5801464d",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1444442, 32550, 446, 7, 54, "Subsection",ExpressionUUID->"2b75d89c-2ea1-4745-b067-cd6598a76a10",
 InitializationCell->True],
Cell[1444891, 32559, 9829, 206, 1286, "Input",ExpressionUUID->"269a3d3d-52c7-4e6a-a36e-830dea0692fc",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1454757, 32770, 395, 6, 54, "Subsection",ExpressionUUID->"5c93048d-ad81-4417-8ac0-fc4acd8012f9",
 InitializationCell->True],
Cell[1455155, 32778, 293, 7, 58, "Text",ExpressionUUID->"ef7b5f16-81d6-4c4d-a4cd-0ac1e32601dd",
 InitializationCell->True],
Cell[1455451, 32787, 13397, 258, 1412, "Input",ExpressionUUID->"ca64fdf5-9245-4603-83b6-9639dc08c402",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1468897, 33051, 689, 11, 41, "Subsubtitle",ExpressionUUID->"4e335592-c4fc-4462-ac5f-91722b3cc044",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1469611, 33066, 392, 6, 44, "Subsection",ExpressionUUID->"c81d1b3e-d510-4ebb-816c-4fe6f0b6071a",
 InitializationCell->True],
Cell[1470006, 33074, 3478, 66, 432, "Input",ExpressionUUID->"92213e89-fef5-4cc1-a324-6251833ae81e",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1473521, 33145, 265, 5, 36, "Subsection",ExpressionUUID->"1ba9e7a4-c579-4bdc-89a2-0a35a478a93c",
 InitializationCell->True],
Cell[1473789, 33152, 8517, 160, 763, "Input",ExpressionUUID->"684a2dbc-b90c-4378-bd5d-690662e2a01d",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1482355, 33318, 686, 11, 41, "Subsubtitle",ExpressionUUID->"39bee82a-ab5c-45e4-a162-13632ad786a3",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1483066, 33333, 855, 15, 64, "Section",ExpressionUUID->"9d66feb9-0d2b-4607-9c08-2f56558c0c8e",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1483924, 33350, 2530, 59, 1616, "Input",ExpressionUUID->"bcd77bbb-0873-47d5-83b4-76d9ad8d8528",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1486479, 33413, 165, 3, 307, "Subsubsection",ExpressionUUID->"94280f7d-fa4c-4342-9221-8cd90a7e071c"],
Cell[1486647, 33418, 8138, 155, 7093, "Input",ExpressionUUID->"ef7579ce-8ad9-4163-b1ed-7cff978019b3",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1494834, 33579, 894, 14, 36, "Section",ExpressionUUID->"5ffb0068-5b78-4179-ae7e-b5d5b6f93f87",
 InitializationCell->True,
 InitializationGroup->True],
Cell[1495731, 33595, 192, 3, 30, "Text",ExpressionUUID->"2ddfda02-8d3d-4f5e-a090-9d526ddf17f9"],
Cell[1495926, 33600, 2938, 67, 163, "Input",ExpressionUUID->"ab7a0dad-adaa-4904-9fdb-79336bfe7d31",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1498889, 33671, 165, 3, 34, "Subsubsection",ExpressionUUID->"27b34cab-b069-432c-8a7d-c09ca682fede"],
Cell[1499057, 33676, 12164, 223, 617, "Input",ExpressionUUID->"fe5652ca-c4f3-4785-b679-6b9b3666ff40",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1511270, 33905, 1090, 19, 44, "Section",ExpressionUUID->"45c5f7d7-0776-4893-9d8f-19aeb01ca7f7",
 InitializationCell->True,
 InitializationGroup->True],
Cell[CellGroupData[{
Cell[1512385, 33928, 354, 6, 45, "Subsubsection",ExpressionUUID->"a5e471ed-d541-461c-a590-d19a8998eb7d",
 InitializationCell->True],
Cell[1512742, 33936, 3821, 85, 467, "Input",ExpressionUUID->"5a2e8d5b-9528-41e5-930f-2713084b4d10",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1516600, 34026, 394, 6, 53, "Subsubsection",ExpressionUUID->"a8f09e65-bfd0-4f78-90a7-f61e8d1a3107",
 InitializationCell->True],
Cell[1516997, 34034, 601, 11, 81, "Text",ExpressionUUID->"87e40599-e79f-4888-ad71-9d1a8ecc7926",
 InitializationCell->True],
Cell[1517601, 34047, 25415, 497, 1565, "Input",ExpressionUUID->"aa00bf35-76d9-47ab-aab5-80443bf5c085",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1543053, 34549, 355, 6, 45, "Subsubsection",ExpressionUUID->"2d58218f-f844-400a-9ebf-6742bea79619",
 InitializationCell->True],
Cell[1543411, 34557, 303, 5, 35, "Text",ExpressionUUID->"e646d9d7-5607-4cef-b495-711ca3e3f7df",
 InitializationCell->True],
Cell[1543717, 34564, 24649, 472, 1972, "Input",ExpressionUUID->"4b2e8e1a-819f-4437-8303-b7cd9a8fee11",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1568415, 35042, 540, 11, 36, "Section",ExpressionUUID->"cf303cc7-6f82-407c-bc37-2b43692fc72f",
 InitializationCell->True],
Cell[1568958, 35055, 893, 15, 127, "Text",ExpressionUUID->"ce8c11db-c164-4f5b-afe0-27a6f38c1835",
 InitializationCell->True],
Cell[1569854, 35072, 1227, 25, 194, "Input",ExpressionUUID->"1e98aaed-6d3b-4646-a80c-b013796c3d5e",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1571106, 35101, 397, 6, 54, "Subsection",ExpressionUUID->"9b3d362a-2e6a-4bba-a77b-5dafdb6ac99e",
 InitializationCell->True],
Cell[1571506, 35109, 7688, 162, 740, "Input",ExpressionUUID->"2bfaa727-85f3-4da8-b2eb-00fd989c05f3",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1579231, 35276, 399, 6, 54, "Subsection",ExpressionUUID->"44ba871c-c79d-4e00-adbd-69f5505511fd",
 InitializationCell->True],
Cell[1579633, 35284, 301, 7, 35, "Text",ExpressionUUID->"666a8051-8c0d-4c52-beea-109099a3c48e",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1579959, 35295, 304, 5, 45, "Subsubsection",ExpressionUUID->"e7135fd1-6282-4a98-878f-b0556854ecd4",
 InitializationCell->True],
Cell[1580266, 35302, 4062, 89, 383, "Input",ExpressionUUID->"f4b10839-adca-46cb-9ef0-8c1a0a072814",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1584365, 35396, 439, 7, 45, "Subsubsection",ExpressionUUID->"9b3d362a-2e6a-4bba-a77b-5dafdb6ac99e",
 InitializationCell->True],
Cell[1584807, 35405, 6368, 125, 2722, "Input",ExpressionUUID->"2bfaa727-85f3-4da8-b2eb-00fd989c05f3",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[1591212, 35535, 448, 9, 37, "Subsubsection",ExpressionUUID->"c43260af-3ce4-488c-bf5a-ae22bf6c941a",
 InitializationCell->True],
Cell[1591663, 35546, 6208, 127, 656, "Input",ExpressionUUID->"86e5ff0d-97b5-4a4b-8492-523284930e50",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1597920, 35679, 538, 10, 54, "Subsection",ExpressionUUID->"50cb6e1d-dc41-4cb8-8c0d-e62d1d4c8c9b",
 InitializationCell->True],
Cell[1598461, 35691, 1206, 26, 478, "Input",ExpressionUUID->"8fa1ae1a-ca21-4a5d-a3db-2d2a31812c29",
 InitializationCell->True],
Cell[1599670, 35719, 1330, 28, 478, "Input",ExpressionUUID->"7237f907-a8fd-4aca-b10d-cf8134a284c1",
 InitializationCell->True],
Cell[1601003, 35749, 2172, 37, 626, "Input",ExpressionUUID->"7237f907-a8fd-4aca-b10d-cf8134a284c1",
 InitializationCell->True]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1603236, 35793, 670, 11, 41, "Subsubtitle",ExpressionUUID->"5c5a1564-4236-4d72-a102-3ef063b8352e",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1603931, 35808, 393, 7, 213, "Section",ExpressionUUID->"6a645b51-6a1d-4fd0-b12a-ea7ae4cb22a0",
 InitializationCell->True],
Cell[1604327, 35817, 293, 7, 175, "Text",ExpressionUUID->"4f56895d-3136-4901-8c14-0730a3e07063",
 InitializationCell->True],
Cell[1604623, 35826, 833, 21, 383, "Input",ExpressionUUID->"4037a83f-66aa-4612-b203-c4e9845b2b64",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1605505, 35853, 671, 11, 41, "Subsubtitle",ExpressionUUID->"42956da5-9d9d-41dd-8bc3-28af341b4514",
 InitializationCell->True],
Cell[1606179, 35866, 561, 13, 68, "Input",ExpressionUUID->"e2a66b13-2737-4a4f-bc04-4fd47a5682f6",
 InitializationCell->True],
Cell[1606743, 35881, 507, 12, 46, "Input",ExpressionUUID->"e660b383-18a0-4cf6-b323-57755766875c",
 InitializationCell->True],
Cell[1607253, 35895, 409, 9, 89, "Input",ExpressionUUID->"88404507-2d08-4046-b79f-76f00cadd132",
 InitializationCell->True],
Cell[1607665, 35906, 482, 11, 89, "Input",ExpressionUUID->"cbaff171-97f2-4e22-872a-d0dd6fdf431f",
 InitializationCell->True],
Cell[1608150, 35919, 766, 15, 89, "Input",ExpressionUUID->"cfa45168-b28b-4e19-b608-236526396e40",
 InitializationCell->True],
Cell[1608919, 35936, 346, 9, 46, "Input",ExpressionUUID->"a8a8200d-5b92-49b8-bb03-2d11bed9fb4f",
 InitializationCell->True],
Cell[1609268, 35947, 350, 9, 46, "Input",ExpressionUUID->"43dd2298-6fc5-4d65-8472-e94265928a21",
 InitializationCell->True],
Cell[1609621, 35958, 621, 13, 68, "Input",ExpressionUUID->"25dbca94-0ae5-46c0-bcaf-87d730d4ebf3",
 InitializationCell->True],
Cell[1610245, 35973, 615, 12, 89, "Input",ExpressionUUID->"e55314fa-994c-41fe-a939-732d4814d25a",
 InitializationCell->True],
Cell[1610863, 35987, 349, 9, 46, "Input",ExpressionUUID->"fabb5373-f288-4696-9d57-64c13e33e4e2",
 InitializationCell->True],
Cell[1611215, 35998, 385, 9, 46, "Input",ExpressionUUID->"fd561484-bd6f-41e6-80aa-e4939ad9fb50",
 InitializationCell->True],
Cell[1611603, 36009, 542, 11, 89, "Input",ExpressionUUID->"7c9cc369-14fc-4e01-b696-5245eab18038",
 InitializationCell->True],
Cell[1612148, 36022, 673, 13, 110, "Input",ExpressionUUID->"d6861e3b-9391-41b5-b65b-9b6491e5fc84",
 InitializationCell->True],
Cell[1612824, 36037, 350, 9, 46, "Input",ExpressionUUID->"d661fd92-a7a0-4ecc-a3a5-4f21c82b9220",
 InitializationCell->True],
Cell[1613177, 36048, 398, 10, 68, "Input",ExpressionUUID->"946fb2b7-65da-4fe4-b964-fc915196289c",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1613600, 36062, 348, 8, 68, "Input",ExpressionUUID->"c029645c-0d86-429a-a799-036dc54da5d4",
 InitializationCell->True],
Cell[1613951, 36072, 1429, 21, 34, "Output",ExpressionUUID->"7bce68e2-93de-4c48-baa8-2bea6107f954",
 InitializationCell->True]
}, Open  ]],
Cell[1615395, 36096, 426, 10, 68, "Input",ExpressionUUID->"12248356-69bf-4c26-b3fe-0d41e9fc58f0",
 InitializationCell->True],
Cell[1615824, 36108, 373, 9, 46, "Input",ExpressionUUID->"8370173e-f29b-4704-8de3-a2bda4cd55ac",
 InitializationCell->True],
Cell[1616200, 36119, 376, 9, 46, "Input",ExpressionUUID->"884220fd-86a5-4df4-a7ce-6bfdeb6d4e49",
 InitializationCell->True],
Cell[1616579, 36130, 701, 14, 46, "Input",ExpressionUUID->"0757a926-408a-4aed-999a-128eb00a6e63",
 InitializationCell->True],
Cell[1617283, 36146, 484, 10, 46, "Input",ExpressionUUID->"ffdb4d26-0cf2-4a82-b711-8b5db8e28a9d",
 InitializationCell->True],
Cell[1617770, 36158, 324, 8, 46, "Input",ExpressionUUID->"4cfd9fee-1428-4019-953d-26e8d8e56044",
 InitializationCell->True],
Cell[1618097, 36168, 429, 10, 89, "Input",ExpressionUUID->"d82db7ae-a13f-41a3-aeab-52072f38a052",
 InitializationCell->True],
Cell[1618529, 36180, 337, 8, 46, "Input",ExpressionUUID->"63cf311f-715b-4643-91d6-51830af3c60e",
 InitializationCell->True],
Cell[1618869, 36190, 400, 9, 89, "Input",ExpressionUUID->"83612025-a6da-4108-b0b9-958626dd8d40",
 InitializationCell->True],
Cell[1619272, 36201, 420, 9, 89, "Input",ExpressionUUID->"3ec9a759-3213-4964-a387-10d088400c4e",
 InitializationCell->True],
Cell[1619695, 36212, 403, 10, 46, "Input",ExpressionUUID->"1ac9b7ee-f89c-4de1-a64c-2976f1a4af8e",
 InitializationCell->True],
Cell[1620101, 36224, 390, 9, 89, "Input",ExpressionUUID->"48281e0d-283f-4399-b64d-1d46ff46879e",
 InitializationCell->True]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1620540, 36239, 181, 5, 58, "Chapter",ExpressionUUID->"e363ded0-e5b9-403e-ade2-d276411c9d85",
 Evaluatable->False,
 InitializationCell->True,
 InitializationGroup->True],
Cell[1620724, 36246, 325, 11, 597, "Input",ExpressionUUID->"fd0ecbf8-c225-4562-b051-e36f0ca73b62",
 InitializationCell->True,
 InitializationGroup->True]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1621098, 36263, 293, 7, 98, "Title",ExpressionUUID->"e419645f-11e1-4100-beb2-148e592e1e6f",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[1621416, 36274, 492, 7, 44, "Subsection",ExpressionUUID->"82f0a69c-884f-4599-9470-fddb7c7b370a"],
Cell[1621911, 36283, 611, 13, 1151, "Text",ExpressionUUID->"52b30e8a-2d68-460a-8e0f-285ed91c579f"]
}, Closed]],
Cell[1622537, 36299, 603, 9, 36, "Subsection",ExpressionUUID->"60a34cb3-36d2-424e-9bf2-404072c7ebdd"],
Cell[1623143, 36310, 640, 9, 36, "Subsection",ExpressionUUID->"e33f6898-a881-44ce-9fca-95855ff594c7"],
Cell[CellGroupData[{
Cell[1623808, 36323, 771, 12, 36, "Subsection",ExpressionUUID->"a8c383cf-fb2e-469a-81f4-a0bda14f31fb"],
Cell[1624582, 36337, 1098, 18, 233, "Text",ExpressionUUID->"7f0949b2-2bac-42e1-ae93-35803f0e73e3"]
}, Closed]],
Cell[CellGroupData[{
Cell[1625717, 36360, 873, 12, 36, "Subsection",ExpressionUUID->"511a3cc2-485c-4e48-bdf5-58a7439abc6b"],
Cell[CellGroupData[{
Cell[1626615, 36376, 161, 3, 306, "Subsubsection",ExpressionUUID->"9a0f3d40-fc44-4437-a24c-0927f6f228b0"],
Cell[1626779, 36381, 198, 3, 266, "Text",ExpressionUUID->"b01096ac-5b6b-42b5-85d1-cb1a32f1a94a"],
Cell[1626980, 36386, 260, 6, 266, "Text",ExpressionUUID->"bb2f238d-c8f0-4c42-8ba4-2111401e148e"],
Cell[1627243, 36394, 197, 3, 266, "Text",ExpressionUUID->"83fe27de-612c-4a40-a868-06d1dc5f6de7"]
}, Closed]],
Cell[CellGroupData[{
Cell[1627477, 36402, 179, 3, 246, "Subsubsection",ExpressionUUID->"595ede08-520f-46a3-98a1-1e944acf5499"],
Cell[1627659, 36407, 236, 4, 266, "Text",ExpressionUUID->"3a88a0de-48c2-4825-8051-05ab1d818157"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[1627944, 36417, 839, 12, 36, "Subsection",ExpressionUUID->"021e6cf4-502b-464c-b38e-e4c67ab52c9b"],
Cell[1628786, 36431, 436, 13, 1502, "Text",ExpressionUUID->"35b88b28-46c4-4631-9b3a-7ac87de231fc"]
}, Closed]],
Cell[CellGroupData[{
Cell[1629259, 36449, 1061, 17, 61, "Subsection",ExpressionUUID->"6c501e2e-fcc6-4c76-836d-cd7f022c3a08"],
Cell[1630323, 36468, 360, 7, 266, "Text",ExpressionUUID->"5809c330-c914-4869-80b2-4e8d322cf702"]
}, Closed]],
Cell[CellGroupData[{
Cell[1630720, 36480, 720, 10, 36, "Subsection",ExpressionUUID->"cfa4754e-e894-4483-9526-69be69c652c3"],
Cell[1631443, 36492, 238, 6, 266, "Text",ExpressionUUID->"ba97d145-2366-499f-a153-f26304bf535c"],
Cell[1631684, 36500, 400, 8, 445, "Text",ExpressionUUID->"820c8650-d3ab-4355-97ed-2a51ccacdd38"]
}, Closed]],
Cell[CellGroupData[{
Cell[1632121, 36513, 770, 11, 36, "Subsection",ExpressionUUID->"cfa4754e-e894-4483-9526-69be69c652c3"],
Cell[1632894, 36526, 431, 10, 141, "Text",ExpressionUUID->"ba97d145-2366-499f-a153-f26304bf535c"]
}, Closed]],
Cell[CellGroupData[{
Cell[1633362, 36541, 825, 12, 36, "Subsection",ExpressionUUID->"cfa4754e-e894-4483-9526-69be69c652c3"],
Cell[1634190, 36555, 438, 11, 202, "Text",ExpressionUUID->"757e98e5-ccdb-4efd-8ce2-433f30f39d2b"]
}, Closed]]
}, Closed]]
}
]
*)

